  ! number of tests
  integer, parameter :: NUM_TEST = 8
  ! number of atoms
  integer, parameter :: NUM_ATOMS(NUM_TEST) = (/6, 6, 6, 6, 12, 12, 12, 12/)
  ! order of geometric derivatives
  integer, parameter :: ORDER_GEO(NUM_TEST) = (/4, 3, 3, 3, 4, 4, 4, 4/)
  ! maximum number of differentiated centers
  integer, parameter :: MAX_NCENT(NUM_TEST) = (/4, 1, 2, 3, 1, 2, 3, 4/)
  ! number of different paths from subroutine \fn{geom_total_tree_search}
  integer, parameter :: REF_NUM_PATHS = 126
  ! total number of geometric derivatives
  integer, parameter :: REF_TOT_NGEO(NUM_TEST) = &
    (/5985, 60, 600, 1140, 180, 6516, 42156, 82251/)
  ! number of centers of each path
  integer, parameter :: REF_NUM_CENTS(REF_NUM_PATHS) = (/ &
    1, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 2, 3, 3, 3, 2, 3, 3, &
    2, 3, 2, 2, 3, 3, 3, 3, 3, 4, 4, 4, 3, 4, 4, 3, 4, 3, &
    2, 3, 3, 3, 3, 4, 4, 3, 4, 3, 2, 3, 3, 3, 4, 3, 2, 3, &
    3, 2, 1, 2, 2, 2, 2, 2, 3, 3, 3, 2, 3, 3, 2, 3, 2, 2, &
    3, 3, 3, 3, 4, 4, 3, 4, 3, 2, 3, 3, 3, 4, 3, 2, 3, 3, &
    2, 1, 2, 2, 2, 2, 3, 3, 2, 3, 2, 2, 3, 3, 3, 4, 3, 2, &
    3, 3, 2, 1, 2, 2, 2, 3, 2, 2, 3, 3, 2, 1, 2, 2, 2, 1/)
  ! generated centers of each path
  integer, parameter :: REF_IDX_CENT(MAX_NCENT(1)*REF_NUM_PATHS) = (/            &
    1, 0, 0, 0,  1, 2, 0, 0,  1, 3, 0, 0,  1, 4, 0, 0,  1, 5, 0, 0,  1, 6, 0, 0, &
    1, 2, 0, 0,  1, 2, 3, 0,  1, 2, 4, 0,  1, 2, 5, 0,  1, 2, 6, 0,  1, 3, 0, 0, &
    1, 3, 4, 0,  1, 3, 5, 0,  1, 3, 6, 0,  1, 4, 0, 0,  1, 4, 5, 0,  1, 4, 6, 0, &
    1, 5, 0, 0,  1, 5, 6, 0,  1, 6, 0, 0,  1, 2, 0, 0,  1, 2, 3, 0,  1, 2, 4, 0, &
    1, 2, 5, 0,  1, 2, 6, 0,  1, 2, 3, 0,  1, 2, 3, 4,  1, 2, 3, 5,  1, 2, 3, 6, &
    1, 2, 4, 0,  1, 2, 4, 5,  1, 2, 4, 6,  1, 2, 5, 0,  1, 2, 5, 6,  1, 2, 6, 0, &
    1, 3, 0, 0,  1, 3, 4, 0,  1, 3, 5, 0,  1, 3, 6, 0,  1, 3, 4, 0,  1, 3, 4, 5, &
    1, 3, 4, 6,  1, 3, 5, 0,  1, 3, 5, 6,  1, 3, 6, 0,  1, 4, 0, 0,  1, 4, 5, 0, &
    1, 4, 6, 0,  1, 4, 5, 0,  1, 4, 5, 6,  1, 4, 6, 0,  1, 5, 0, 0,  1, 5, 6, 0, &
    1, 5, 6, 0,  1, 6, 0, 0,  2, 0, 0, 0,  2, 3, 0, 0,  2, 4, 0, 0,  2, 5, 0, 0, &
    2, 6, 0, 0,  2, 3, 0, 0,  2, 3, 4, 0,  2, 3, 5, 0,  2, 3, 6, 0,  2, 4, 0, 0, &
    2, 4, 5, 0,  2, 4, 6, 0,  2, 5, 0, 0,  2, 5, 6, 0,  2, 6, 0, 0,  2, 3, 0, 0, &
    2, 3, 4, 0,  2, 3, 5, 0,  2, 3, 6, 0,  2, 3, 4, 0,  2, 3, 4, 5,  2, 3, 4, 6, &
    2, 3, 5, 0,  2, 3, 5, 6,  2, 3, 6, 0,  2, 4, 0, 0,  2, 4, 5, 0,  2, 4, 6, 0, &
    2, 4, 5, 0,  2, 4, 5, 6,  2, 4, 6, 0,  2, 5, 0, 0,  2, 5, 6, 0,  2, 5, 6, 0, &
    2, 6, 0, 0,  3, 0, 0, 0,  3, 4, 0, 0,  3, 5, 0, 0,  3, 6, 0, 0,  3, 4, 0, 0, &
    3, 4, 5, 0,  3, 4, 6, 0,  3, 5, 0, 0,  3, 5, 6, 0,  3, 6, 0, 0,  3, 4, 0, 0, &
    3, 4, 5, 0,  3, 4, 6, 0,  3, 4, 5, 0,  3, 4, 5, 6,  3, 4, 6, 0,  3, 5, 0, 0, &
    3, 5, 6, 0,  3, 5, 6, 0,  3, 6, 0, 0,  4, 0, 0, 0,  4, 5, 0, 0,  4, 6, 0, 0, &
    4, 5, 0, 0,  4, 5, 6, 0,  4, 6, 0, 0,  4, 5, 0, 0,  4, 5, 6, 0,  4, 5, 6, 0, &
    4, 6, 0, 0,  5, 0, 0, 0,  5, 6, 0, 0,  5, 6, 0, 0,  5, 6, 0, 0,  6, 0, 0, 0/) 
  ! orders of generated centers of each path
  integer, parameter :: REF_ORDER_CENT(MAX_NCENT(1)*REF_NUM_PATHS) = (/          &
    4, 0, 0, 0,  3, 1, 0, 0,  3, 1, 0, 0,  3, 1, 0, 0,  3, 1, 0, 0,  3, 1, 0, 0, &
    2, 2, 0, 0,  2, 1, 1, 0,  2, 1, 1, 0,  2, 1, 1, 0,  2, 1, 1, 0,  2, 2, 0, 0, &
    2, 1, 1, 0,  2, 1, 1, 0,  2, 1, 1, 0,  2, 2, 0, 0,  2, 1, 1, 0,  2, 1, 1, 0, &
    2, 2, 0, 0,  2, 1, 1, 0,  2, 2, 0, 0,  1, 3, 0, 0,  1, 2, 1, 0,  1, 2, 1, 0, &
    1, 2, 1, 0,  1, 2, 1, 0,  1, 1, 2, 0,  1, 1, 1, 1,  1, 1, 1, 1,  1, 1, 1, 1, &
    1, 1, 2, 0,  1, 1, 1, 1,  1, 1, 1, 1,  1, 1, 2, 0,  1, 1, 1, 1,  1, 1, 2, 0, &
    1, 3, 0, 0,  1, 2, 1, 0,  1, 2, 1, 0,  1, 2, 1, 0,  1, 1, 2, 0,  1, 1, 1, 1, &
    1, 1, 1, 1,  1, 1, 2, 0,  1, 1, 1, 1,  1, 1, 2, 0,  1, 3, 0, 0,  1, 2, 1, 0, &
    1, 2, 1, 0,  1, 1, 2, 0,  1, 1, 1, 1,  1, 1, 2, 0,  1, 3, 0, 0,  1, 2, 1, 0, &
    1, 1, 2, 0,  1, 3, 0, 0,  4, 0, 0, 0,  3, 1, 0, 0,  3, 1, 0, 0,  3, 1, 0, 0, &
    3, 1, 0, 0,  2, 2, 0, 0,  2, 1, 1, 0,  2, 1, 1, 0,  2, 1, 1, 0,  2, 2, 0, 0, &
    2, 1, 1, 0,  2, 1, 1, 0,  2, 2, 0, 0,  2, 1, 1, 0,  2, 2, 0, 0,  1, 3, 0, 0, &
    1, 2, 1, 0,  1, 2, 1, 0,  1, 2, 1, 0,  1, 1, 2, 0,  1, 1, 1, 1,  1, 1, 1, 1, &
    1, 1, 2, 0,  1, 1, 1, 1,  1, 1, 2, 0,  1, 3, 0, 0,  1, 2, 1, 0,  1, 2, 1, 0, &
    1, 1, 2, 0,  1, 1, 1, 1,  1, 1, 2, 0,  1, 3, 0, 0,  1, 2, 1, 0,  1, 1, 2, 0, &
    1, 3, 0, 0,  4, 0, 0, 0,  3, 1, 0, 0,  3, 1, 0, 0,  3, 1, 0, 0,  2, 2, 0, 0, &
    2, 1, 1, 0,  2, 1, 1, 0,  2, 2, 0, 0,  2, 1, 1, 0,  2, 2, 0, 0,  1, 3, 0, 0, &
    1, 2, 1, 0,  1, 2, 1, 0,  1, 1, 2, 0,  1, 1, 1, 1,  1, 1, 2, 0,  1, 3, 0, 0, &
    1, 2, 1, 0,  1, 1, 2, 0,  1, 3, 0, 0,  4, 0, 0, 0,  3, 1, 0, 0,  3, 1, 0, 0, &
    2, 2, 0, 0,  2, 1, 1, 0,  2, 2, 0, 0,  1, 3, 0, 0,  1, 2, 1, 0,  1, 1, 2, 0, &
    1, 3, 0, 0,  4, 0, 0, 0,  3, 1, 0, 0,  2, 2, 0, 0,  1, 3, 0, 0,  4, 0, 0, 0/)
  ! number of geometric derivatives of each path
  integer, parameter :: REF_NGEO_CENT(REF_NUM_PATHS) = (/      &
    15,  30,  30,  30,  30,  30,  36,  54,  54,  54,  54,  36, &
    54,  54,  54,  36,  54,  54,  36,  54,  36,  30,  54,  54, &
    54,  54,  54,  81,  81,  81,  54,  81,  81,  54,  81,  54, &
    30,  54,  54,  54,  54,  81,  81,  54,  81,  54,  30,  54, &
    54,  54,  81,  54,  30,  54,  54,  30,  15,  30,  30,  30, &
    30,  36,  54,  54,  54,  36,  54,  54,  36,  54,  36,  30, &
    54,  54,  54,  54,  81,  81,  54,  81,  54,  30,  54,  54, &
    54,  81,  54,  30,  54,  54,  30,  15,  30,  30,  30,  36, &
    54,  54,  36,  54,  36,  30,  54,  54,  54,  81,  54,  30, &
    54,  54,  30,  15,  30,  30,  36,  54,  36,  30,  54,  54, &
    30,  15,  30,  36,  30,  15/)
