  ! number of test cases
  integer, parameter :: NUM_TESTS = 8
  ! ID of block of sub-shells on bra center
  integer, parameter :: BRA_BLOCK(NUM_TESTS) = &
    (/12,    12,    12,    12,    12,    12,    12,    12/)
  ! ID of block of sub-shells on ket center
  integer, parameter :: KET_BLOCK(NUM_TESTS) = &
    (/6,    6,    6,    6,    6,    6,    6,    6/)
  ! orders of electronic derivatives
  integer, parameter :: ORDER_ELEC(NUM_TESTS) = &
    (/0,    0,    0,    0,    1,    2,    0,    0/)
  ! indices of dipole origin
  integer, parameter :: IDX_DIPORG(NUM_TESTS) = &
    (/-1,    -1,    -1,    -1,    -1,    -1,    -1,    -1/)
  ! coordinates of dipole origin
  real(REALK), parameter :: DIP_ORIGIN(3*NUM_TESTS) =                      &
    (/0.0_REALK, 0.0_REALK, 0.0_REALK,    0.0_REALK, 0.0_REALK, 0.0_REALK, &
      0.0_REALK, 0.0_REALK, 0.0_REALK,    0.0_REALK, 0.0_REALK, 0.0_REALK, &
      0.0_REALK, 0.0_REALK, 0.0_REALK,    0.0_REALK, 0.0_REALK, 0.0_REALK, &
      0.0_REALK, 0.0_REALK, 0.0_REALK,    0.0_REALK, 0.0_REALK, 0.0_REALK/)
  ! scale constants
  real(REALK), parameter :: SCAL_CONST(NUM_TESTS) =                      &
    (/1.0_REALK,    1.0_REALK,    1.0_REALK,   -1.0_REALK,    1.0_REALK, &
     -0.25_REALK,  -1.0_REALK,   -1.0_REALK/)
  ! orders of Cartesian multipole moments
  integer, parameter :: ORDER_MOM(NUM_TESTS) = &
    (/0,    3,    0,    1,    0,    0,    3,    0/)
  ! orders of partial geometric derivatives on bra center
  integer, parameter :: ORDER_GEO_BRA(NUM_TESTS) = &
    (/0,    0,    1,    0,    0,    0,    0,    0/)
  ! orders of partial geometric derivatives on ket center
  integer, parameter :: ORDER_GEO_KET(NUM_TESTS) = &
    (/0,    0,    0,    0,    0,    0,    0,    1/)
  ! orders of geometric derivatives on dipole origin
  integer, parameter :: ORDER_GEO_MOM(NUM_TESTS) = &
    (/0,    0,    0,    0,    0,    0,    0,    0/)
  ! numbers of differentiated centers of total geometric derivatives
  integer, parameter :: NUM_CENTS(NUM_TESTS) = &
    (/0,    0,    0,    1,    0,    0,    1,    0/)
  ! indices of differentiated centers
  integer, parameter :: IDX_CENT(3*NUM_TESTS) =                            &
    (/0, 0, 0,    0, 0, 0,    0, 0, 0,    1, 0, 0,    0, 0, 0,    0, 0, 0, &
      1, 0, 0,    0, 0, 0/)
  ! orders of geometric derivatives of differentiated centers
  integer, parameter :: ORDER_CENT(3*NUM_TESTS) =                          &
    (/0, 0, 0,    0, 0, 0,    0, 0, 0,    1, 0, 0,    0, 0, 0,    0, 0, 0, &
      1, 0, 0,    0, 0, 0/)
  ! referenced results from Dalton
  real(REALK) REF_CONTR_INTS(81900)
    ! results of test 1, ket-major order, OVERLAP
  data REF_CONTR_INTS(1:1260)                                                              &
    /14.861017618986345_REALK,     13.730033534525871_REALK,      0.000000000000000_REALK, &
     16.458460609878731_REALK,      0.000000000000000_REALK,      2.586822640005127_REALK, &
     24.277491051392065_REALK,      0.000000000000000_REALK,      2.903164574634262_REALK, &
      0.000000000000000_REALK,     49.549842407664904_REALK,      0.000000000000000_REALK, &
      4.931275824220198_REALK,      0.000000000000000_REALK,      2.325187558284665_REALK, &
      9.382279279395854_REALK,     14.057994662807792_REALK,      0.000000000000000_REALK, &
     21.057471857098466_REALK,      0.000000000000000_REALK,      2.538675035037558_REALK, &
     35.592917412157625_REALK,      0.000000000000000_REALK,      3.457412149590654_REALK, &
      0.000000000000000_REALK,     76.631752467376430_REALK,      0.000000000000000_REALK, &
      6.357607811798670_REALK,      0.000000000000000_REALK,      2.299407119321252_REALK, &
     10.875840787063188_REALK,      7.294368807303750_REALK,      0.000000000000000_REALK, &
      6.507758257062164_REALK,      0.000000000000000_REALK,      1.651016836935933_REALK, &
      6.960856039128613_REALK,      0.000000000000000_REALK,      1.329426786477019_REALK, &
      0.000000000000000_REALK,      9.547415806702920_REALK,      0.000000000000000_REALK, &
      1.605263074215828_REALK,      0.000000000000000_REALK,      1.221764665443327_REALK, &
      9.383546344734343_REALK,      4.910819750452618_REALK,      0.000000000000000_REALK, &
      2.820017351718780_REALK,      0.000000000000000_REALK,      1.148894103505634_REALK, &
      0.448856009188451_REALK,      0.000000000000000_REALK,      0.806920893759341_REALK, &
      0.000000000000000_REALK,     -5.223628504280318_REALK,      0.000000000000000_REALK, &
      0.632730705708349_REALK,      0.000000000000000_REALK,      0.773336280841197_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.126408842959509_REALK, &
      0.000000000000000_REALK,     -1.998354858585787_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.465732935530024_REALK,      0.000000000000000_REALK, &
     -1.162638584438493_REALK,      0.000000000000000_REALK,     -4.122109853875349_REALK, &
      0.000000000000000_REALK,     -1.478797369364352_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.277981528424028_REALK, &
      0.000000000000000_REALK,     -3.354840097114491_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -4.467685418647517_REALK,      0.000000000000000_REALK, &
     -1.615863696319991_REALK,      0.000000000000000_REALK,     -7.749102194649033_REALK, &
      0.000000000000000_REALK,     -2.258188596845486_REALK,      0.000000000000000_REALK, &
     10.858894100394007_REALK,      5.683498541090964_REALK,      0.000000000000000_REALK, &
      4.281895923811618_REALK,      0.000000000000000_REALK,      1.432577299672486_REALK, &
      3.957781664868499_REALK,      0.000000000000000_REALK,      0.886286079776608_REALK, &
      0.000000000000000_REALK,      4.850610798980714_REALK,      0.000000000000000_REALK, &
      0.867404473933112_REALK,      0.000000000000000_REALK,      0.870612444417928_REALK, &
      4.812797077273400_REALK,      3.964345243586067_REALK,      0.000000000000000_REALK, &
      3.943478021814958_REALK,      0.000000000000000_REALK,      0.989029689348303_REALK, &
      4.980738767970413_REALK,      0.000000000000000_REALK,      0.723524625919795_REALK, &
      0.000000000000000_REALK,      8.596174205955235_REALK,      0.000000000000000_REALK, &
      0.801870307001414_REALK,      0.000000000000000_REALK,      0.603330514011256_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.561079860028817_REALK, &
      0.000000000000000_REALK,     -1.054492306721790_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.959540269847395_REALK,      0.000000000000000_REALK, &
     -0.730305465565006_REALK,      0.000000000000000_REALK,     -1.118477348810795_REALK, &
      0.000000000000000_REALK,     -0.640840899115770_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.159781315882660_REALK, &
      0.000000000000000_REALK,     -0.798536815737268_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.519552855967174_REALK,      0.000000000000000_REALK, &
     -0.635008021120563_REALK,      0.000000000000000_REALK,     -0.090322455096615_REALK, &
      0.000000000000000_REALK,     -0.487125546062360_REALK,      0.000000000000000_REALK, &
      2.330075536306309_REALK,      1.889497098478143_REALK,      0.000000000000000_REALK, &
      1.955802634184317_REALK,      0.000000000000000_REALK,      0.922197036541731_REALK, &
      2.463976444147849_REALK,      0.000000000000000_REALK,      0.883945846410661_REALK, &
      0.000000000000000_REALK,      3.981012673510611_REALK,      0.000000000000000_REALK, &
      1.188589343510825_REALK,      0.000000000000000_REALK,      0.934069684991423_REALK, &
      2.593795150231284_REALK,      3.386631414100798_REALK,      0.000000000000000_REALK, &
      4.421265226262227_REALK,      0.000000000000000_REALK,      1.599074532217590_REALK, &
      6.363004260879309_REALK,      0.000000000000000_REALK,      1.854261732864872_REALK, &
      0.000000000000000_REALK,     10.836431736615738_REALK,      0.000000000000000_REALK, &
      2.697071938556826_REALK,      0.000000000000000_REALK,      1.625786144837337_REALK, &
     13.553819778609764_REALK,      5.343479805231405_REALK,      0.000000000000000_REALK, &
      3.316514204470399_REALK,      0.000000000000000_REALK,      1.520103231189125_REALK, &
      2.421429350274113_REALK,      0.000000000000000_REALK,      0.700857830313399_REALK, &
      0.000000000000000_REALK,      2.248073732627181_REALK,      0.000000000000000_REALK, &
      0.546741169107122_REALK,      0.000000000000000_REALK,      0.751786031849580_REALK, &
     14.338348317939641_REALK,      4.578797683765997_REALK,      0.000000000000000_REALK, &
      1.793211253384380_REALK,      0.000000000000000_REALK,      1.263698006298025_REALK, &
     -0.049514460064658_REALK,      0.000000000000000_REALK,      0.506272906030351_REALK, &
      0.000000000000000_REALK,     -2.546075735300223_REALK,      0.000000000000000_REALK, &
      0.251710238473685_REALK,      0.000000000000000_REALK,      0.532149894649049_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.603836457546004_REALK, &
      0.000000000000000_REALK,     -0.830938185201470_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.628758516798892_REALK,      0.000000000000000_REALK, &
     -0.631083889591612_REALK,      0.000000000000000_REALK,     -0.611711346963680_REALK, &
      0.000000000000000_REALK,     -0.410950853960249_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.090025331863612_REALK, &
      0.000000000000000_REALK,     -1.120359785893613_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.921414150420564_REALK,      0.000000000000000_REALK, &
     -0.693275793026096_REALK,      0.000000000000000_REALK,     -1.082598408359959_REALK, &
      0.000000000000000_REALK,     -0.471789414132946_REALK,      0.000000000000000_REALK, &
      2.035010758559748_REALK,      1.180552844240125_REALK,      0.000000000000000_REALK, &
      0.899617706571326_REALK,      0.000000000000000_REALK,      0.684698442236909_REALK, &
      0.810754590326983_REALK,      0.000000000000000_REALK,      0.464528585384229_REALK, &
      0.000000000000000_REALK,      0.882058788925636_REALK,      0.000000000000000_REALK, &
      0.444917168734531_REALK,      0.000000000000000_REALK,      0.564376938729578_REALK, &
      3.718929769880425_REALK,      1.687474290500135_REALK,      0.000000000000000_REALK, &
      0.804514602017602_REALK,      0.000000000000000_REALK,      0.983294037406028_REALK, &
      0.103787841375451_REALK,      0.000000000000000_REALK,      0.559746840922009_REALK, &
      0.000000000000000_REALK,     -0.932302242276278_REALK,      0.000000000000000_REALK, &
      0.338785341571807_REALK,      0.000000000000000_REALK,      0.690117174365541_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.032442178571901_REALK, &
      0.000000000000000_REALK,     -0.828744097637172_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.861576917306129_REALK,      0.000000000000000_REALK, &
     -0.677082361656465_REALK,      0.000000000000000_REALK,     -1.142490271443414_REALK, &
      0.000000000000000_REALK,     -0.683109567602665_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.379176900215118_REALK, &
      0.000000000000000_REALK,     -2.871277913149427_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -3.099154847348775_REALK,      0.000000000000000_REALK, &
     -1.868160407401365_REALK,      0.000000000000000_REALK,     -4.149130443969812_REALK, &
      0.000000000000000_REALK,     -2.015183785175997_REALK,      0.000000000000000_REALK, &
     20.683834690751045_REALK,      6.123263880219523_REALK,      0.000000000000000_REALK, &
      3.289199928140536_REALK,      0.000000000000000_REALK,      1.973800551269796_REALK, &
      1.990393021408364_REALK,      0.000000000000000_REALK,      0.669572394406592_REALK, &
      0.000000000000000_REALK,      1.626350331494557_REALK,      0.000000000000000_REALK, &
      0.437168360355164_REALK,      0.000000000000000_REALK,      0.787014930242819_REALK, &
     10.178235112033907_REALK,      4.701110620120084_REALK,      0.000000000000000_REALK, &
      3.362907070790971_REALK,      0.000000000000000_REALK,      1.590359241639932_REALK, &
      3.228738925175942_REALK,      0.000000000000000_REALK,      0.628202127460413_REALK, &
      0.000000000000000_REALK,      4.705108970360358_REALK,      0.000000000000000_REALK, &
      0.458940964328295_REALK,      0.000000000000000_REALK,      0.651116122410402_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.060923743807084_REALK, &
      0.000000000000000_REALK,     -0.798925237965323_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.491683083619789_REALK,      0.000000000000000_REALK, &
     -0.676079459986054_REALK,      0.000000000000000_REALK,     -0.366865154557458_REALK, &
      0.000000000000000_REALK,     -0.318556041552428_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.732134012460053_REALK, &
      0.000000000000000_REALK,     -0.729260453108563_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.328449478982286_REALK,      0.000000000000000_REALK, &
     -0.694387152059497_REALK,      0.000000000000000_REALK,      0.009733566088232_REALK, &
      0.000000000000000_REALK,     -0.298569798585674_REALK,      0.000000000000000_REALK, &
      2.512868960795084_REALK,      1.126568380607972_REALK,      0.000000000000000_REALK, &
      0.716737440789744_REALK,      0.000000000000000_REALK,      0.719388190958221_REALK, &
      0.550110616055306_REALK,      0.000000000000000_REALK,      0.369567163602001_REALK, &
      0.000000000000000_REALK,      0.532713022835614_REALK,      0.000000000000000_REALK, &
      0.285785241372371_REALK,      0.000000000000000_REALK,      0.478070294860222_REALK, &
      2.130394342692141_REALK,      1.535662224413704_REALK,      0.000000000000000_REALK, &
      1.327250367998279_REALK,      0.000000000000000_REALK,      0.998628630782582_REALK, &
      1.412651647898920_REALK,      0.000000000000000_REALK,      0.615624490290746_REALK, &
      0.000000000000000_REALK,      1.941761509437277_REALK,      0.000000000000000_REALK, &
      0.543395536336612_REALK,      0.000000000000000_REALK,      0.681421724076078_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.928299636498967_REALK, &
      0.000000000000000_REALK,     -0.529527665338113_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.400112992837236_REALK,      0.000000000000000_REALK, &
     -0.507542890928864_REALK,      0.000000000000000_REALK,     -0.368506652553963_REALK, &
      0.000000000000000_REALK,     -0.351898252274117_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.347788030013298_REALK, &
      0.000000000000000_REALK,     -0.806286945192360_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.442071286415826_REALK,      0.000000000000000_REALK, &
     -0.900514129784938_REALK,      0.000000000000000_REALK,     -0.061207926645896_REALK, &
      0.000000000000000_REALK,     -0.550175934633933_REALK,      0.000000000000000_REALK, &
      1.617616242692606_REALK,      1.123593683189747_REALK,      0.000000000000000_REALK, &
      0.982132914711717_REALK,      0.000000000000000_REALK,      0.771822991071707_REALK, &
      1.027438889568688_REALK,      0.000000000000000_REALK,      0.614318872671636_REALK, &
      0.000000000000000_REALK,      1.311631080996048_REALK,      0.000000000000000_REALK, &
      0.652677619718431_REALK,      0.000000000000000_REALK,      0.718082266824657_REALK, &
      3.444445979396402_REALK,      3.935622362150446_REALK,      0.000000000000000_REALK, &
      4.464175430505207_REALK,      0.000000000000000_REALK,      2.690990351159186_REALK, &
      5.414081448633246_REALK,      0.000000000000000_REALK,      2.629555588632940_REALK, &
      0.000000000000000_REALK,      7.343417737356136_REALK,      0.000000000000000_REALK, &
      3.046163533333759_REALK,      0.000000000000000_REALK,      2.570704383240833_REALK, &
     47.042633529543146_REALK,      9.509605675334916_REALK,      0.000000000000000_REALK, &
      4.342885533788503_REALK,      0.000000000000000_REALK,      3.422896164538098_REALK, &
      1.971071057749334_REALK,      0.000000000000000_REALK,      0.796140592044431_REALK, &
      0.000000000000000_REALK,      1.278844132797252_REALK,      0.000000000000000_REALK, &
      0.436706549526230_REALK,      0.000000000000000_REALK,      1.032586165423071_REALK, &
    103.156093382457669_REALK,     17.726213958957704_REALK,      0.000000000000000_REALK, &
      4.917761162733340_REALK,      0.000000000000000_REALK,      6.062381477221383_REALK, &
     -0.844744501616983_REALK,      0.000000000000000_REALK,      1.168684968326301_REALK, &
      0.000000000000000_REALK,     -4.631253416566044_REALK,      0.000000000000000_REALK, &
      0.373472727410518_REALK,      0.000000000000000_REALK,      1.381198112298592_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.792761786060281_REALK, &
      0.000000000000000_REALK,     -1.042050963642632_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.529139071989745_REALK,      0.000000000000000_REALK, &
     -0.952585748640261_REALK,      0.000000000000000_REALK,     -0.311488188100715_REALK, &
      0.000000000000000_REALK,     -0.314355842830062_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -9.612747789405738_REALK, &
      0.000000000000000_REALK,     -2.611985960229853_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.340135304584584_REALK,      0.000000000000000_REALK, &
     -1.901298360462349_REALK,      0.000000000000000_REALK,     -1.019520177263403_REALK, &
      0.000000000000000_REALK,     -0.595091234554482_REALK,      0.000000000000000_REALK, &
      4.820208322388273_REALK,      1.535176951148703_REALK,      0.000000000000000_REALK, &
      0.765203039093121_REALK,      0.000000000000000_REALK,      1.052177865549293_REALK, &
      0.444045601264919_REALK,      0.000000000000000_REALK,      0.385573301935292_REALK, &
      0.000000000000000_REALK,      0.316385653994324_REALK,      0.000000000000000_REALK, &
      0.230839042122644_REALK,      0.000000000000000_REALK,      0.529018047536551_REALK, &
     16.375836100035919_REALK,      4.407932890239096_REALK,      0.000000000000000_REALK, &
      1.365651898083716_REALK,      0.000000000000000_REALK,      2.887175023547962_REALK, &
     -0.028422600221444_REALK,      0.000000000000000_REALK,      0.871841825131018_REALK, &
      0.000000000000000_REALK,     -1.049063821330841_REALK,      0.000000000000000_REALK, &
      0.311137765047862_REALK,      0.000000000000000_REALK,      1.096313032368436_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.382342323419701_REALK, &
      0.000000000000000_REALK,     -0.575154863281723_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.345908238385064_REALK,      0.000000000000000_REALK, &
     -0.578645883619499_REALK,      0.000000000000000_REALK,     -0.258270035928064_REALK, &
      0.000000000000000_REALK,     -0.289178581651311_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -6.036098581785682_REALK, &
      0.000000000000000_REALK,     -2.559689716291860_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.586747750147331_REALK,      0.000000000000000_REALK, &
     -1.989792545718381_REALK,      0.000000000000000_REALK,     -1.338194470213040_REALK, &
      0.000000000000000_REALK,     -0.971960886299768_REALK,      0.000000000000000_REALK, &
      2.171161182924961_REALK,      1.017515317068929_REALK,      0.000000000000000_REALK, &
      0.622693129577857_REALK,      0.000000000000000_REALK,      0.789885549345437_REALK, &
      0.446032434726147_REALK,      0.000000000000000_REALK,      0.425929988373048_REALK, &
      0.000000000000000_REALK,      0.372413158979728_REALK,      0.000000000000000_REALK, &
      0.313080054627199_REALK,      0.000000000000000_REALK,      0.555998386473827_REALK, &
     12.742175673660286_REALK,      4.873510869174648_REALK,      0.000000000000000_REALK, &
      1.838077177813521_REALK,      0.000000000000000_REALK,      3.744225244024000_REALK, &
      0.178730838591938_REALK,      0.000000000000000_REALK,      1.606546922249312_REALK, &
      0.000000000000000_REALK,     -1.152414132098475_REALK,      0.000000000000000_REALK, &
      0.697951439763999_REALK,      0.000000000000000_REALK,      1.990450892908776_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.483098555351139_REALK, &
      0.000000000000000_REALK,     -0.956060283546587_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.789986790731405_REALK,      0.000000000000000_REALK, &
     -0.869151152593021_REALK,      0.000000000000000_REALK,     -0.803949457855089_REALK, &
      0.000000000000000_REALK,     -0.672968350242781_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,    -16.265388895872043_REALK, &
      0.000000000000000_REALK,    -10.933363608492401_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -8.894981297939905_REALK,      0.000000000000000_REALK, &
     -7.506611894350304_REALK,      0.000000000000000_REALK,     -8.547865600388061_REALK, &
      0.000000000000000_REALK,     -5.812236694828642_REALK,      0.000000000000000_REALK, &
     18.493261608736802_REALK,      4.259029748003720_REALK,      0.000000000000000_REALK, &
     17.773651145745877_REALK,      0.000000000000000_REALK,      8.014081434880085_REALK, &
      9.106296619621670_REALK,      0.000000000000000_REALK,      2.159014384445270_REALK, &
      0.000000000000000_REALK,    117.870625920888102_REALK,      0.000000000000000_REALK, &
     22.172765707681808_REALK,      0.000000000000000_REALK,     29.992883605191555_REALK, &
      7.211510901217586_REALK,      2.380542571589090_REALK,      0.000000000000000_REALK, &
     14.949251052353748_REALK,      0.000000000000000_REALK,      4.944344124656303_REALK, &
     10.141601224974886_REALK,      0.000000000000000_REALK,      2.018829574478735_REALK, &
      0.000000000000000_REALK,    141.495253110973948_REALK,      0.000000000000000_REALK, &
     22.240612146046264_REALK,      0.000000000000000_REALK,     22.067708865404903_REALK, &
     14.039144287235580_REALK,      3.510543058213750_REALK,      0.000000000000000_REALK, &
      6.874141483659812_REALK,      0.000000000000000_REALK,      5.383530140197364_REALK, &
      4.070034972321750_REALK,      0.000000000000000_REALK,      1.516086610631551_REALK, &
      0.000000000000000_REALK,     22.217674259210654_REALK,      0.000000000000000_REALK, &
      7.363626418299619_REALK,      0.000000000000000_REALK,     17.300620677491739_REALK, &
      7.168079772235083_REALK,      1.674648420178619_REALK,      0.000000000000000_REALK, &
      1.935749185049040_REALK,      0.000000000000000_REALK,      2.568940440171968_REALK, &
     -0.114862946761856_REALK,      0.000000000000000_REALK,      0.785797406335896_REALK, &
      0.000000000000000_REALK,    -10.826236650860800_REALK,      0.000000000000000_REALK, &
      2.284483336297360_REALK,      0.000000000000000_REALK,      9.095240756665365_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.209919780658525_REALK, &
      0.000000000000000_REALK,     -2.532732998123486_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.116650326302171_REALK,      0.000000000000000_REALK, &
     -2.863172222474592_REALK,      0.000000000000000_REALK,    -11.443238403755984_REALK, &
      0.000000000000000_REALK,     -8.139241675406398_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.139207304222840_REALK, &
      0.000000000000000_REALK,     -2.915728025987037_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -3.034943183670996_REALK,      0.000000000000000_REALK, &
     -3.011348885565755_REALK,      0.000000000000000_REALK,    -17.285931684109016_REALK, &
      0.000000000000000_REALK,    -10.323029667255936_REALK,      0.000000000000000_REALK, &
     14.956772190856501_REALK,      2.514996398571509_REALK,      0.000000000000000_REALK, &
      4.504149282177697_REALK,      0.000000000000000_REALK,      4.827738058796714_REALK, &
      2.160661054348503_REALK,      0.000000000000000_REALK,      0.946217781617092_REALK, &
      0.000000000000000_REALK,     10.153475755808756_REALK,      0.000000000000000_REALK, &
      3.866683829564757_REALK,      0.000000000000000_REALK,     12.433426724456737_REALK, &
      4.184368352804180_REALK,      1.253847069014752_REALK,      0.000000000000000_REALK, &
      2.399813293220593_REALK,      0.000000000000000_REALK,      2.335612263719227_REALK, &
      2.307100166264818_REALK,      0.000000000000000_REALK,      0.636533021786422_REALK, &
      0.000000000000000_REALK,     12.113542022019992_REALK,      0.000000000000000_REALK, &
      2.271880762998839_REALK,      0.000000000000000_REALK,      6.633306749434855_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.374882596059869_REALK, &
      0.000000000000000_REALK,     -1.179463570108471_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.140899002060071_REALK,      0.000000000000000_REALK, &
     -2.680508182343128_REALK,      0.000000000000000_REALK,     -2.718219641669754_REALK, &
      0.000000000000000_REALK,     -3.037607611371717_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.366101804161420_REALK, &
      0.000000000000000_REALK,     -0.711221281175916_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.522582045151969_REALK,      0.000000000000000_REALK, &
     -2.080562129847400_REALK,      0.000000000000000_REALK,      0.098419733646523_REALK, &
      0.000000000000000_REALK,     -2.019919572289525_REALK,      0.000000000000000_REALK, &
      2.300281131486351_REALK,      1.117286122872805_REALK,      0.000000000000000_REALK, &
      1.646681616356769_REALK,      0.000000000000000_REALK,      2.227450138846975_REALK, &
      1.772982296159916_REALK,      0.000000000000000_REALK,      1.261070589067336_REALK, &
      0.000000000000000_REALK,      7.514866069983849_REALK,      0.000000000000000_REALK, &
      4.240887754499437_REALK,      0.000000000000000_REALK,      9.561012405962229_REALK, &
      1.627657912089535_REALK,      1.550515245296332_REALK,      0.000000000000000_REALK, &
      2.746911814651526_REALK,      0.000000000000000_REALK,      2.725556734077892_REALK, &
      3.954205919698200_REALK,      0.000000000000000_REALK,      2.361422326862999_REALK, &
      0.000000000000000_REALK,     16.544282250792527_REALK,      0.000000000000000_REALK, &
      7.801427044750587_REALK,      0.000000000000000_REALK,     12.901295134305094_REALK, &
     20.384132956877604_REALK,      1.142577853558069_REALK,      0.000000000000000_REALK, &
      4.105758421082951_REALK,      0.000000000000000_REALK,      5.368691260624994_REALK, &
      0.530536594627093_REALK,      0.000000000000000_REALK,      0.365094065621853_REALK, &
      0.000000000000000_REALK,      5.758961146528913_REALK,      0.000000000000000_REALK, &
      2.681945928801506_REALK,      0.000000000000000_REALK,     10.520740525421083_REALK, &
     14.215842443962501_REALK,      0.451211668017702_REALK,      0.000000000000000_REALK, &
      1.628906119889113_REALK,      0.000000000000000_REALK,      3.219153617287557_REALK, &
     -0.944860486319781_REALK,      0.000000000000000_REALK,      0.140900861278540_REALK, &
      0.000000000000000_REALK,     -2.730087471205866_REALK,      0.000000000000000_REALK, &
      0.992119783836786_REALK,      0.000000000000000_REALK,      5.882081143764418_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.969672274562980_REALK, &
      0.000000000000000_REALK,     -0.668705517314028_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.885312454588096_REALK,      0.000000000000000_REALK, &
     -2.846746208781455_REALK,      0.000000000000000_REALK,     -0.997440665999004_REALK, &
      0.000000000000000_REALK,     -1.310426860858330_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.656842364695720_REALK, &
      0.000000000000000_REALK,     -0.646415616467520_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.852463556356026_REALK,      0.000000000000000_REALK, &
     -2.488974049218867_REALK,      0.000000000000000_REALK,     -1.427004710117815_REALK, &
      0.000000000000000_REALK,     -1.181139380313954_REALK,      0.000000000000000_REALK, &
      2.397526949958869_REALK,      0.725519947509580_REALK,      0.000000000000000_REALK, &
      0.806289495079867_REALK,      0.000000000000000_REALK,      1.894353124155944_REALK, &
      0.622361126264390_REALK,      0.000000000000000_REALK,      0.695487908770055_REALK, &
      0.000000000000000_REALK,      1.589111881900656_REALK,      0.000000000000000_REALK, &
      1.580042910703818_REALK,      0.000000000000000_REALK,      6.187106166492842_REALK, &
      3.110149285976322_REALK,      0.809039608095026_REALK,      0.000000000000000_REALK, &
      0.530695475819497_REALK,      0.000000000000000_REALK,      2.112864228142975_REALK, &
     -0.036929418799771_REALK,      0.000000000000000_REALK,      0.757921740520478_REALK, &
      0.000000000000000_REALK,     -1.531803162673274_REALK,      0.000000000000000_REALK, &
      0.969693970065706_REALK,      0.000000000000000_REALK,      6.434423616274413_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.370164834906975_REALK, &
      0.000000000000000_REALK,     -0.891216458847982_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.970989848940174_REALK,      0.000000000000000_REALK, &
     -2.189080807887632_REALK,      0.000000000000000_REALK,     -2.455421648009605_REALK, &
      0.000000000000000_REALK,     -2.910782988612606_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.100418126315492_REALK, &
      0.000000000000000_REALK,     -2.398084964822909_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.927280494440090_REALK,      0.000000000000000_REALK, &
     -4.840871981886684_REALK,      0.000000000000000_REALK,     -7.337354339478718_REALK, &
      0.000000000000000_REALK,     -7.303022279406477_REALK,      0.000000000000000_REALK, &
     34.161332748598731_REALK,     -1.445206963281875_REALK,      0.000000000000000_REALK, &
      5.358177774711502_REALK,      0.000000000000000_REALK,      7.252744256260846_REALK, &
     -1.158547343247654_REALK,      0.000000000000000_REALK,     -0.379638493241694_REALK, &
      0.000000000000000_REALK,      5.761151297573705_REALK,      0.000000000000000_REALK, &
      2.563230153700857_REALK,      0.000000000000000_REALK,     10.408642764225633_REALK, &
     12.991396178668937_REALK,     -0.954313670155388_REALK,      0.000000000000000_REALK, &
      3.442263250178515_REALK,      0.000000000000000_REALK,      4.798001345312882_REALK, &
      0.026584830632186_REALK,      0.000000000000000_REALK,     -0.322925964206781_REALK, &
      0.000000000000000_REALK,      6.728462593180709_REALK,      0.000000000000000_REALK, &
      1.635075007402170_REALK,      0.000000000000000_REALK,      6.837151764725930_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.351881237632861_REALK, &
      0.000000000000000_REALK,     -0.273722938831349_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.874263190351438_REALK,      0.000000000000000_REALK, &
     -3.429560632762126_REALK,      0.000000000000000_REALK,     -0.190279609123231_REALK, &
      0.000000000000000_REALK,     -0.392828450308318_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.159225400848544_REALK, &
      0.000000000000000_REALK,     -0.140664607383792_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.540937121835368_REALK,      0.000000000000000_REALK, &
     -3.207108754554845_REALK,      0.000000000000000_REALK,      0.448056186152806_REALK, &
      0.000000000000000_REALK,     -0.200447061055557_REALK,      0.000000000000000_REALK, &
      3.350937737181727_REALK,      0.542055196141361_REALK,      0.000000000000000_REALK, &
      0.663747646626618_REALK,      0.000000000000000_REALK,      2.134298559598445_REALK, &
      0.325146621890412_REALK,      0.000000000000000_REALK,      0.427174148364799_REALK, &
      0.000000000000000_REALK,      0.833776313172467_REALK,      0.000000000000000_REALK, &
      0.952565249128711_REALK,      0.000000000000000_REALK,      5.104998989378992_REALK, &
      2.242672026283245_REALK,      0.634381852447937_REALK,      0.000000000000000_REALK, &
      0.851034197915688_REALK,      0.000000000000000_REALK,      2.484800690676432_REALK, &
      0.778051031047309_REALK,      0.000000000000000_REALK,      0.643996972223014_REALK, &
      0.000000000000000_REALK,      2.155391808844106_REALK,      0.000000000000000_REALK, &
      1.212723705008033_REALK,      0.000000000000000_REALK,      5.901401508861919_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.535569735389426_REALK, &
      0.000000000000000_REALK,     -0.521429988148275_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.515063835243462_REALK,      0.000000000000000_REALK, &
     -2.016878535123303_REALK,      0.000000000000000_REALK,     -0.669638813071810_REALK, &
      0.000000000000000_REALK,     -1.247201124021592_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.073530850546323_REALK, &
      0.000000000000000_REALK,     -0.756650903979900_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.528709812841257_REALK,      0.000000000000000_REALK, &
     -3.508264474070403_REALK,      0.000000000000000_REALK,      0.052536183226521_REALK, &
      0.000000000000000_REALK,     -1.797045856910615_REALK,      0.000000000000000_REALK, &
      1.546075333220000_REALK,      0.722423398487367_REALK,      0.000000000000000_REALK, &
      0.727982785955761_REALK,      0.000000000000000_REALK,      1.641225340252260_REALK, &
      0.800420597818004_REALK,      0.000000000000000_REALK,      0.948859704707900_REALK, &
      0.000000000000000_REALK,      1.851302197347961_REALK,      0.000000000000000_REALK, &
      1.741251883376932_REALK,      0.000000000000000_REALK,      5.495873635818912_REALK, &
      2.617099566788035_REALK,      2.353441877882515_REALK,      0.000000000000000_REALK, &
      2.922372210618726_REALK,      0.000000000000000_REALK,      4.832755105599933_REALK, &
      4.000572716063102_REALK,      0.000000000000000_REALK,      3.981853720570102_REALK, &
      0.000000000000000_REALK,      8.831292378828953_REALK,      0.000000000000000_REALK, &
      6.940633845568767_REALK,      0.000000000000000_REALK,     16.068910368073464_REALK, &
     78.506008625060034_REALK,     -8.897459439187598_REALK,      0.000000000000000_REALK, &
      9.905036674529054_REALK,      0.000000000000000_REALK,     12.321353550156310_REALK, &
     -4.427033386316184_REALK,      0.000000000000000_REALK,     -1.768414677175050_REALK, &
      0.000000000000000_REALK,      8.120915511050548_REALK,      0.000000000000000_REALK, &
      3.267565930866747_REALK,      0.000000000000000_REALK,     12.194049271776889_REALK, &
    136.187305715220447_REALK,    -16.958650002512837_REALK,      0.000000000000000_REALK, &
     11.767020701369532_REALK,      0.000000000000000_REALK,     17.199425275615148_REALK, &
     -7.570542150304189_REALK,      0.000000000000000_REALK,     -2.660076859502300_REALK, &
      0.000000000000000_REALK,      2.139275789930224_REALK,      0.000000000000000_REALK, &
      2.689452203318691_REALK,      0.000000000000000_REALK,     11.793222781855381_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -8.212530861766741_REALK, &
      0.000000000000000_REALK,      0.346864819192007_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.205896024169987_REALK,      0.000000000000000_REALK, &
     -4.896845064132408_REALK,      0.000000000000000_REALK,      0.349198258901710_REALK, &
      0.000000000000000_REALK,      0.343281010374031_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,    -16.490887660889971_REALK, &
      0.000000000000000_REALK,      0.715815410675456_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.855797802519054_REALK,      0.000000000000000_REALK, &
     -7.760115690733425_REALK,      0.000000000000000_REALK,     -0.013468811963103_REALK, &
      0.000000000000000_REALK,      0.490817017051695_REALK,      0.000000000000000_REALK, &
      6.655056111229388_REALK,      0.309945863703304_REALK,      0.000000000000000_REALK, &
      0.798789239884629_REALK,      0.000000000000000_REALK,      3.133491334435663_REALK, &
      0.089518853307428_REALK,      0.000000000000000_REALK,      0.184809883624263_REALK, &
      0.000000000000000_REALK,      0.565841254887699_REALK,      0.000000000000000_REALK, &
      0.790536145989806_REALK,      0.000000000000000_REALK,      5.168526813937803_REALK, &
     18.763472046790643_REALK,      0.483468859485709_REALK,      0.000000000000000_REALK, &
      1.199070904587401_REALK,      0.000000000000000_REALK,      7.109053234110681_REALK, &
     -0.508540392277506_REALK,      0.000000000000000_REALK,      0.227505902630930_REALK, &
      0.000000000000000_REALK,     -0.754144607322233_REALK,      0.000000000000000_REALK, &
      0.822173420474035_REALK,      0.000000000000000_REALK,      8.124171516823957_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.416739398165832_REALK, &
      0.000000000000000_REALK,     -0.390296785952428_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.448143388539765_REALK,      0.000000000000000_REALK, &
     -2.401695366994492_REALK,      0.000000000000000_REALK,     -0.294007754401195_REALK, &
      0.000000000000000_REALK,     -0.643773729775504_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -8.540341300586844_REALK, &
      0.000000000000000_REALK,     -1.427519023680558_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.376432259454818_REALK,      0.000000000000000_REALK, &
     -6.698046207267862_REALK,      0.000000000000000_REALK,     -1.182564205113294_REALK, &
      0.000000000000000_REALK,     -1.631357792661223_REALK,      0.000000000000000_REALK, &
      2.348249456660478_REALK,      0.590433044184864_REALK,      0.000000000000000_REALK, &
      0.470599075869591_REALK,      0.000000000000000_REALK,      1.842764158197202_REALK, &
      0.315037953633346_REALK,      0.000000000000000_REALK,      0.586757640404031_REALK, &
      0.000000000000000_REALK,      0.468410033615308_REALK,      0.000000000000000_REALK, &
      0.776228073623949_REALK,      0.000000000000000_REALK,      4.255357658798035_REALK, &
     12.315246054280877_REALK,      2.600633921921021_REALK,      0.000000000000000_REALK, &
      1.171967180578787_REALK,      0.000000000000000_REALK,      7.776611525906176_REALK, &
     -0.059628171761624_REALK,      0.000000000000000_REALK,      2.039633495211520_REALK, &
      0.000000000000000_REALK,     -1.269411079454107_REALK,      0.000000000000000_REALK, &
      1.339315106184001_REALK,      0.000000000000000_REALK,     12.441872818484436_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.858415695038474_REALK, &
      0.000000000000000_REALK,     -0.866945938757983_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.819188522814092_REALK,      0.000000000000000_REALK, &
     -2.585586064991391_REALK,      0.000000000000000_REALK,     -1.206275603565753_REALK, &
      0.000000000000000_REALK,     -2.001973515627084_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,    -16.610337472476026_REALK, &
      0.000000000000000_REALK,     -8.826395434757762_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -7.877567072082195_REALK,      0.000000000000000_REALK, &
    -18.238092084427265_REALK,      0.000000000000000_REALK,    -10.134155527050151_REALK, &
      0.000000000000000_REALK,    -14.121431818868079_REALK,      0.000000000000000_REALK/
    ! results of test 2, ket-major order, CM030000
  data REF_CONTR_INTS(1261:2520)                                                           &
     /7.013127527083945_REALK,      7.619013231716389_REALK,      0.000000000000000_REALK, &
     11.318877867400632_REALK,      0.000000000000000_REALK,      1.779019935149369_REALK, &
     20.044020341067124_REALK,      0.000000000000000_REALK,      2.396915301678094_REALK, &
      0.000000000000000_REALK,     60.751486447825805_REALK,      0.000000000000000_REALK, &
      6.046080509012108_REALK,      0.000000000000000_REALK,      2.850838540990649_REALK, &
      6.733865527697717_REALK,      7.314577889626193_REALK,      0.000000000000000_REALK, &
     11.694317957558205_REALK,      0.000000000000000_REALK,      1.409859324619569_REALK, &
     23.376724469153107_REALK,      0.000000000000000_REALK,      2.270759945338901_REALK, &
      0.000000000000000_REALK,     74.426329062159951_REALK,      0.000000000000000_REALK, &
      6.174639047312996_REALK,      0.000000000000000_REALK,      2.233231335578979_REALK, &
      4.368786122961311_REALK,      3.500705181005103_REALK,      0.000000000000000_REALK, &
      3.865420827386808_REALK,      0.000000000000000_REALK,      0.980656412818176_REALK, &
      5.089620979160317_REALK,      0.000000000000000_REALK,      0.972046889732567_REALK, &
      0.000000000000000_REALK,     10.130766575531815_REALK,      0.000000000000000_REALK, &
      1.703345263938726_REALK,      0.000000000000000_REALK,      1.296414955254102_REALK, &
      1.253859241974520_REALK,      1.300113514884639_REALK,      0.000000000000000_REALK, &
      1.104262972839217_REALK,      0.000000000000000_REALK,      0.449884188634984_REALK, &
      0.236177607408798_REALK,      0.000000000000000_REALK,      0.424583033656650_REALK, &
      0.000000000000000_REALK,     -4.113854957977169_REALK,      0.000000000000000_REALK, &
      0.498305411384018_REALK,      0.000000000000000_REALK,      0.609038964106139_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.020503713224634_REALK, &
      0.000000000000000_REALK,     -1.186965186130659_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.802888323955508_REALK,      0.000000000000000_REALK, &
     -0.850095117220694_REALK,      0.000000000000000_REALK,     -4.373972347469389_REALK, &
      0.000000000000000_REALK,     -1.569152455999963_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.867828245223924_REALK, &
      0.000000000000000_REALK,     -1.313688973148308_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.350792305842416_REALK,      0.000000000000000_REALK, &
     -0.850229948765964_REALK,      0.000000000000000_REALK,     -6.102785153501406_REALK, &
      0.000000000000000_REALK,     -1.778430519622148_REALK,      0.000000000000000_REALK, &
      3.630237488062240_REALK,      2.294924020085265_REALK,      0.000000000000000_REALK, &
      2.147549436087988_REALK,      0.000000000000000_REALK,      0.718497279430711_REALK, &
      2.491824833675227_REALK,      0.000000000000000_REALK,      0.558006946904534_REALK, &
      0.000000000000000_REALK,      4.363942447625375_REALK,      0.000000000000000_REALK, &
      0.780376608210309_REALK,      0.000000000000000_REALK,      0.783262718671358_REALK, &
      2.275854011265156_REALK,      1.414019688019895_REALK,      0.000000000000000_REALK, &
      1.475057832659921_REALK,      0.000000000000000_REALK,      0.369946524853455_REALK, &
      2.243875576738350_REALK,      0.000000000000000_REALK,      0.325955508389719_REALK, &
      0.000000000000000_REALK,      5.463564537638595_REALK,      0.000000000000000_REALK, &
      0.509653488651171_REALK,      0.000000000000000_REALK,      0.383465379115228_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.630344081581095_REALK, &
      0.000000000000000_REALK,     -0.528871882678467_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.604127886725306_REALK,      0.000000000000000_REALK, &
     -0.459801335535293_REALK,      0.000000000000000_REALK,     -1.006259001486696_REALK, &
      0.000000000000000_REALK,     -0.576544463722668_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.413675780914639_REALK, &
      0.000000000000000_REALK,     -0.298692671343571_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.234064065320264_REALK,      0.000000000000000_REALK, &
     -0.286077840257019_REALK,      0.000000000000000_REALK,     -0.057407231495663_REALK, &
      0.000000000000000_REALK,     -0.309607715604502_REALK,      0.000000000000000_REALK, &
      0.778967681580850_REALK,      0.762954762076273_REALK,      0.000000000000000_REALK, &
      0.980916612378344_REALK,      0.000000000000000_REALK,      0.462520285645863_REALK, &
      1.551322991770541_REALK,      0.000000000000000_REALK,      0.556533532726681_REALK, &
      0.000000000000000_REALK,      3.581592279907964_REALK,      0.000000000000000_REALK, &
      1.069336564795516_REALK,      0.000000000000000_REALK,      0.840353208348667_REALK, &
      1.226542279318011_REALK,      1.207958238085582_REALK,      0.000000000000000_REALK, &
      1.653774121774744_REALK,      0.000000000000000_REALK,      0.598133779548483_REALK, &
      2.866600823854721_REALK,      0.000000000000000_REALK,      0.835364553148701_REALK, &
      0.000000000000000_REALK,      6.887429539259326_REALK,      0.000000000000000_REALK, &
      1.714207535341797_REALK,      0.000000000000000_REALK,      1.033318696655051_REALK, &
      3.560711068048706_REALK,      1.731029586691009_REALK,      0.000000000000000_REALK, &
      1.352270637954572_REALK,      0.000000000000000_REALK,      0.619804662204115_REALK, &
      1.264580326615202_REALK,      0.000000000000000_REALK,      0.366019774175203_REALK, &
      0.000000000000000_REALK,      1.665951963887718_REALK,      0.000000000000000_REALK, &
      0.405166659435067_REALK,      0.000000000000000_REALK,      0.557116698623366_REALK, &
      0.998162160730069_REALK,      0.631223155554352_REALK,      0.000000000000000_REALK, &
      0.383255162396655_REALK,      0.000000000000000_REALK,      0.270084622606517_REALK, &
     -0.015183016473144_REALK,      0.000000000000000_REALK,      0.155242526367603_REALK, &
      0.000000000000000_REALK,     -1.170431374754741_REALK,      0.000000000000000_REALK, &
      0.115711232141278_REALK,      0.000000000000000_REALK,      0.244629381653580_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.519565612937804_REALK, &
      0.000000000000000_REALK,     -0.338805517036113_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.328366239735891_REALK,      0.000000000000000_REALK, &
     -0.329580654967699_REALK,      0.000000000000000_REALK,     -0.453313298855020_REALK, &
      0.000000000000000_REALK,     -0.304538224116135_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.288126376460119_REALK, &
      0.000000000000000_REALK,     -0.239449574541176_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.282540619571635_REALK,      0.000000000000000_REALK, &
     -0.212584723173834_REALK,      0.000000000000000_REALK,     -0.497670641071732_REALK, &
      0.000000000000000_REALK,     -0.216881660243797_REALK,      0.000000000000000_REALK, &
      0.534615735634721_REALK,      0.382442149408176_REALK,      0.000000000000000_REALK, &
      0.366808804358701_REALK,      0.000000000000000_REALK,      0.279177938705093_REALK, &
      0.423412850977629_REALK,      0.000000000000000_REALK,      0.242597914393326_REALK, &
      0.000000000000000_REALK,      0.653656305995717_REALK,      0.000000000000000_REALK, &
      0.329709217390503_REALK,      0.000000000000000_REALK,      0.418235779282336_REALK, &
      0.258892788234387_REALK,      0.232631559665298_REALK,      0.000000000000000_REALK, &
      0.171945371112750_REALK,      0.000000000000000_REALK,      0.210155114339410_REALK, &
      0.031825299180437_REALK,      0.000000000000000_REALK,      0.171639668400126_REALK, &
      0.000000000000000_REALK,     -0.428579472317104_REALK,      0.000000000000000_REALK, &
      0.155739669321301_REALK,      0.000000000000000_REALK,      0.317246962427562_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.334461441382445_REALK, &
      0.000000000000000_REALK,     -0.337910902990347_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.449954577187133_REALK,      0.000000000000000_REALK, &
     -0.353603145163826_REALK,      0.000000000000000_REALK,     -0.846651016739323_REALK, &
      0.000000000000000_REALK,     -0.506223487771555_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.465846026281682_REALK, &
      0.000000000000000_REALK,     -0.613665612912665_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.950318735954605_REALK,      0.000000000000000_REALK, &
     -0.572849026385647_REALK,      0.000000000000000_REALK,     -1.907355850512320_REALK, &
      0.000000000000000_REALK,     -0.926380270376712_REALK,      0.000000000000000_REALK, &
      4.100284278113774_REALK,      1.513756454671704_REALK,      0.000000000000000_REALK, &
      1.037264787752418_REALK,      0.000000000000000_REALK,      0.622447359420894_REALK, &
      0.820113603462510_REALK,      0.000000000000000_REALK,      0.275887939341377_REALK, &
      0.000000000000000_REALK,      0.951852859037254_REALK,      0.000000000000000_REALK, &
      0.255861203841790_REALK,      0.000000000000000_REALK,      0.460615647778800_REALK, &
      2.683063490695676_REALK,      0.946494792205342_REALK,      0.000000000000000_REALK, &
      0.694646059390850_REALK,      0.000000000000000_REALK,      0.328506484706745_REALK, &
      0.799334802862877_REALK,      0.000000000000000_REALK,      0.155523204368172_REALK, &
      0.000000000000000_REALK,      1.597877821880888_REALK,      0.000000000000000_REALK, &
      0.155858576936773_REALK,      0.000000000000000_REALK,      0.221122192498122_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.509489167999453_REALK, &
      0.000000000000000_REALK,     -0.251944860602205_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.202591137092946_REALK,      0.000000000000000_REALK, &
     -0.278569084694551_REALK,      0.000000000000000_REALK,     -0.214714898435048_REALK, &
      0.000000000000000_REALK,     -0.186441059495848_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.348737980165484_REALK, &
      0.000000000000000_REALK,     -0.150636901156564_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.081313821159577_REALK,      0.000000000000000_REALK, &
     -0.171908547010114_REALK,      0.000000000000000_REALK,      0.003305566242604_REALK, &
      0.000000000000000_REALK,     -0.101395751394670_REALK,      0.000000000000000_REALK, &
      0.498141531633661_REALK,      0.278503456838321_REALK,      0.000000000000000_REALK, &
      0.226026549202582_REALK,      0.000000000000000_REALK,      0.226862475832449_REALK, &
      0.226665384566547_REALK,      0.000000000000000_REALK,      0.152274980369755_REALK, &
      0.000000000000000_REALK,      0.311780557984997_REALK,      0.000000000000000_REALK, &
      0.167261317443801_REALK,      0.000000000000000_REALK,      0.279799848883302_REALK, &
      0.561588843128981_REALK,      0.309181471240708_REALK,      0.000000000000000_REALK, &
      0.274158404781078_REALK,      0.000000000000000_REALK,      0.206277910321453_REALK, &
      0.349728377752212_REALK,      0.000000000000000_REALK,      0.152409374677854_REALK, &
      0.000000000000000_REALK,      0.659431624401708_REALK,      0.000000000000000_REALK, &
      0.184539759119509_REALK,      0.000000000000000_REALK,      0.231414121778695_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.229488650841768_REALK, &
      0.000000000000000_REALK,     -0.166989059162020_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.164860962040417_REALK,      0.000000000000000_REALK, &
     -0.209125948852516_REALK,      0.000000000000000_REALK,     -0.215675616756814_REALK, &
      0.000000000000000_REALK,     -0.205955230574165_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.271355952770943_REALK, &
      0.000000000000000_REALK,     -0.166547584404235_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.109443027995606_REALK,      0.000000000000000_REALK, &
     -0.222939141593077_REALK,      0.000000000000000_REALK,     -0.020786508692337_REALK, &
      0.000000000000000_REALK,     -0.186842415260112_REALK,      0.000000000000000_REALK, &
      0.320670056935807_REALK,      0.277768070040427_REALK,      0.000000000000000_REALK, &
      0.309720269846603_REALK,      0.000000000000000_REALK,      0.243398038582903_REALK, &
      0.423341822945841_REALK,      0.000000000000000_REALK,      0.253121498579851_REALK, &
      0.000000000000000_REALK,      0.767657355411798_REALK,      0.000000000000000_REALK, &
      0.381992149125526_REALK,      0.000000000000000_REALK,      0.420271478699723_REALK, &
      0.907983275220810_REALK,      0.792375753491019_REALK,      0.000000000000000_REALK, &
      0.922125353437292_REALK,      0.000000000000000_REALK,      0.555854147599703_REALK, &
      1.340357281191755_REALK,      0.000000000000000_REALK,      0.650995743777069_REALK, &
      0.000000000000000_REALK,      2.493860272577155_REALK,      0.000000000000000_REALK, &
      1.034491907073419_REALK,      0.000000000000000_REALK,      0.873023674152633_REALK, &
      5.448588428703844_REALK,      1.475649414286650_REALK,      0.000000000000000_REALK, &
      0.912013210398870_REALK,      0.000000000000000_REALK,      0.718813907388238_REALK, &
      0.569710047410256_REALK,      0.000000000000000_REALK,      0.230113111678871_REALK, &
      0.000000000000000_REALK,      0.541021581819082_REALK,      0.000000000000000_REALK, &
      0.184750949827356_REALK,      0.000000000000000_REALK,      0.436840883305877_REALK, &
      1.738280360528735_REALK,      0.611516941966486_REALK,      0.000000000000000_REALK, &
      0.289771569574122_REALK,      0.000000000000000_REALK,      0.357216574347651_REALK, &
     -0.080671151764411_REALK,      0.000000000000000_REALK,      0.111606719267389_REALK, &
      0.000000000000000_REALK,     -0.730668076249314_REALK,      0.000000000000000_REALK, &
      0.058922407116077_REALK,      0.000000000000000_REALK,      0.217910202024896_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.588540355847250_REALK, &
      0.000000000000000_REALK,     -0.218832441554568_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.152940120856989_REALK,      0.000000000000000_REALK, &
     -0.275331358494937_REALK,      0.000000000000000_REALK,     -0.131776678582085_REALK, &
      0.000000000000000_REALK,     -0.132989854651000_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.331619495605938_REALK, &
      0.000000000000000_REALK,     -0.153907285521913_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.127979830983270_REALK,      0.000000000000000_REALK, &
     -0.181569608671840_REALK,      0.000000000000000_REALK,     -0.160848647140272_REALK, &
      0.000000000000000_REALK,     -0.093886930477485_REALK,      0.000000000000000_REALK, &
      0.558287861856482_REALK,      0.238220494742981_REALK,      0.000000000000000_REALK, &
      0.160693915338243_REALK,      0.000000000000000_REALK,      0.220959107856830_REALK, &
      0.128345063743067_REALK,      0.000000000000000_REALK,      0.111444477489568_REALK, &
      0.000000000000000_REALK,      0.133848576694382_REALK,      0.000000000000000_REALK, &
      0.097657642954205_REALK,      0.000000000000000_REALK,      0.223803803410374_REALK, &
      0.275948742789155_REALK,      0.152064374698036_REALK,      0.000000000000000_REALK, &
      0.080468953433202_REALK,      0.000000000000000_REALK,      0.170122381003085_REALK, &
     -0.002714292773276_REALK,      0.000000000000000_REALK,      0.083258883668467_REALK, &
      0.000000000000000_REALK,     -0.165509717402360_REALK,      0.000000000000000_REALK, &
      0.049087884377659_REALK,      0.000000000000000_REALK,      0.172964176709131_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.214504439988369_REALK, &
      0.000000000000000_REALK,     -0.120783481226248_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.099979855173245_REALK,      0.000000000000000_REALK, &
     -0.167249360440124_REALK,      0.000000000000000_REALK,     -0.109262465839866_REALK, &
      0.000000000000000_REALK,     -0.122338484934031_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.208232652200192_REALK, &
      0.000000000000000_REALK,     -0.150825809177844_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.151530750799740_REALK,      0.000000000000000_REALK, &
     -0.190020599279523_REALK,      0.000000000000000_REALK,     -0.211125561754085_REALK, &
      0.000000000000000_REALK,     -0.153345266843292_REALK,      0.000000000000000_REALK, &
      0.251468993348485_REALK,      0.157892549167932_REALK,      0.000000000000000_REALK, &
      0.130766596490102_REALK,      0.000000000000000_REALK,      0.165877283686494_REALK, &
      0.128919329688956_REALK,      0.000000000000000_REALK,      0.123109003562021_REALK, &
      0.000000000000000_REALK,      0.157551300580113_REALK,      0.000000000000000_REALK, &
      0.132450125896043_REALK,      0.000000000000000_REALK,      0.235217974438341_REALK, &
      0.214718035529032_REALK,      0.168125831621935_REALK,      0.000000000000000_REALK, &
      0.108305891886250_REALK,      0.000000000000000_REALK,      0.220622756961391_REALK, &
      0.017068382898535_REALK,      0.000000000000000_REALK,      0.153421526074857_REALK, &
      0.000000000000000_REALK,     -0.181815189367733_REALK,      0.000000000000000_REALK, &
      0.110115078994302_REALK,      0.000000000000000_REALK,      0.314031385021629_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.230139249644145_REALK, &
      0.000000000000000_REALK,     -0.200774255215413_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.228334442957611_REALK,      0.000000000000000_REALK, &
     -0.251215775506263_REALK,      0.000000000000000_REALK,     -0.340114949301887_REALK, &
      0.000000000000000_REALK,     -0.284702718669977_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.561121562705326_REALK, &
      0.000000000000000_REALK,     -0.644231760900834_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.849450200450151_REALK,      0.000000000000000_REALK, &
     -0.716864124248823_REALK,      0.000000000000000_REALK,     -1.348587942074701_REALK, &
      0.000000000000000_REALK,     -0.916990590349733_REALK,      0.000000000000000_REALK, &
     62.303562399123912_REALK,    -25.610925055313754_REALK,      0.000000000000000_REALK, &
     54.872746972354328_REALK,      0.000000000000000_REALK,     24.741942957357551_REALK, &
    -43.722845405317273_REALK,      0.000000000000000_REALK,    -10.366261511353958_REALK, &
      0.000000000000000_REALK,    355.687227286053940_REALK,      0.000000000000000_REALK, &
     66.908693274623957_REALK,      0.000000000000000_REALK,     90.506735876706799_REALK, &
     41.293262004080553_REALK,    -24.962030887493949_REALK,      0.000000000000000_REALK, &
     51.061478039039116_REALK,      0.000000000000000_REALK,     16.888171725421618_REALK, &
    -57.514777276591886_REALK,      0.000000000000000_REALK,    -11.449132218845330_REALK, &
      0.000000000000000_REALK,    431.665661228058468_REALK,      0.000000000000000_REALK, &
     67.850393119620932_REALK,      0.000000000000000_REALK,     67.322909636425791_REALK, &
     26.806670934527911_REALK,     -4.200636385240346_REALK,      0.000000000000000_REALK, &
     14.857397408270078_REALK,      0.000000000000000_REALK,     11.635670715018192_REALK, &
     -4.243881394660786_REALK,      0.000000000000000_REALK,     -1.580844342446337_REALK, &
      0.000000000000000_REALK,     59.182970955202293_REALK,      0.000000000000000_REALK, &
     19.615072367825316_REALK,      0.000000000000000_REALK,     46.085027582870993_REALK, &
      9.612361021266313_REALK,     -2.237704754527885_REALK,      0.000000000000000_REALK, &
      3.833953160534612_REALK,      0.000000000000000_REALK,      5.088054483449505_REALK, &
      0.132080459440986_REALK,      0.000000000000000_REALK,     -0.903585406628681_REALK, &
      0.000000000000000_REALK,    -27.567436244812271_REALK,      0.000000000000000_REALK, &
      5.817104387858189_REALK,      0.000000000000000_REALK,     23.159707087194946_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.644340002432563_REALK, &
      0.000000000000000_REALK,     -5.474112043170483_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.207060381516138_REALK,      0.000000000000000_REALK, &
      2.985469021102288_REALK,      0.000000000000000_REALK,    -30.482256521615192_REALK, &
      0.000000000000000_REALK,    -21.681139891285039_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.858459302800795_REALK, &
      0.000000000000000_REALK,     -5.774903467263577_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.489869460755214_REALK,      0.000000000000000_REALK, &
      3.462738468370098_REALK,      0.000000000000000_REALK,    -44.016109660411566_REALK, &
      0.000000000000000_REALK,    -26.286092885541770_REALK,      0.000000000000000_REALK, &
     15.888362959125210_REALK,     -0.111962316050346_REALK,      0.000000000000000_REALK, &
      6.693714246025866_REALK,      0.000000000000000_REALK,      7.174606567352650_REALK, &
      0.137855008239085_REALK,      0.000000000000000_REALK,      0.060370810969296_REALK, &
      0.000000000000000_REALK,     23.505162572940641_REALK,      0.000000000000000_REALK, &
      8.951322110567336_REALK,      0.000000000000000_REALK,     28.783219020334563_REALK, &
      6.406735002992360_REALK,     -0.121938531306970_REALK,      0.000000000000000_REALK, &
      3.021963098048022_REALK,      0.000000000000000_REALK,      2.941117999573944_REALK, &
     -0.012299047122467_REALK,      0.000000000000000_REALK,     -0.003393328882912_REALK, &
      0.000000000000000_REALK,     25.090969474969260_REALK,      0.000000000000000_REALK, &
      4.705782237065959_REALK,      0.000000000000000_REALK,     13.739672249919140_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.105724746148165_REALK, &
      0.000000000000000_REALK,     -1.752826473390437_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.072791908296963_REALK,      0.000000000000000_REALK, &
     -0.171022417800402_REALK,      0.000000000000000_REALK,     -6.292642649966994_REALK, &
      0.000000000000000_REALK,     -7.032021590955866_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.132855474747922_REALK, &
      0.000000000000000_REALK,     -0.895604867400195_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.002785861356460_REALK,      0.000000000000000_REALK, &
      0.011091383048895_REALK,      0.000000000000000_REALK,      0.203858337071895_REALK, &
      0.000000000000000_REALK,     -4.183891073154340_REALK,      0.000000000000000_REALK, &
      2.443555404783461_REALK,     -0.049739213176926_REALK,      0.000000000000000_REALK, &
      2.447169377287383_REALK,      0.000000000000000_REALK,      3.310262114470490_REALK, &
      0.113120236305909_REALK,      0.000000000000000_REALK,      0.080459124348110_REALK, &
      0.000000000000000_REALK,     17.396815921660327_REALK,      0.000000000000000_REALK, &
      9.817599265559325_REALK,      0.000000000000000_REALK,     22.133617725484374_REALK, &
      2.492125940894548_REALK,     -0.150789961912235_REALK,      0.000000000000000_REALK, &
      3.459046652053860_REALK,      0.000000000000000_REALK,      3.432155282782895_REALK, &
     -0.021079693742575_REALK,      0.000000000000000_REALK,     -0.012588636115074_REALK, &
      0.000000000000000_REALK,     34.268431164503369_REALK,      0.000000000000000_REALK, &
     16.159218128373247_REALK,      0.000000000000000_REALK,     26.722654844799806_REALK, &
     12.780931161898202_REALK,      0.334588099571270_REALK,      0.000000000000000_REALK, &
      4.235724416341450_REALK,      0.000000000000000_REALK,      5.538634845064798_REALK, &
      0.246471055046588_REALK,      0.000000000000000_REALK,      0.169611522478135_REALK, &
      0.000000000000000_REALK,     11.346581669950277_REALK,      0.000000000000000_REALK, &
      5.284098597171210_REALK,      0.000000000000000_REALK,     20.728467958495646_REALK, &
      3.066352215249809_REALK,      0.054231333375614_REALK,      0.000000000000000_REALK, &
      1.063797137383087_REALK,      0.000000000000000_REALK,      2.102347312133639_REALK, &
     -0.308409699246821_REALK,      0.000000000000000_REALK,      0.045991120255002_REALK, &
      0.000000000000000_REALK,     -4.355104401311574_REALK,      0.000000000000000_REALK, &
      1.582654505684174_REALK,      0.000000000000000_REALK,      9.383244217726586_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.869627395281052_REALK, &
      0.000000000000000_REALK,     -0.689873099324283_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.411289055152897_REALK,      0.000000000000000_REALK, &
     -1.322511111644265_REALK,      0.000000000000000_REALK,     -1.965205475384862_REALK, &
      0.000000000000000_REALK,     -2.581865899232102_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.319327079105178_REALK, &
      0.000000000000000_REALK,     -0.422157590275787_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.278250633655621_REALK,      0.000000000000000_REALK, &
     -0.812420192257818_REALK,      0.000000000000000_REALK,     -2.276393910185383_REALK, &
      0.000000000000000_REALK,     -1.884183334058398_REALK,      0.000000000000000_REALK, &
      1.503258783243034_REALK,      0.212458468088049_REALK,      0.000000000000000_REALK, &
      0.831812238005129_REALK,      0.000000000000000_REALK,      1.954318047539585_REALK, &
      0.289129920468890_REALK,      0.000000000000000_REALK,      0.323102384232680_REALK, &
      0.000000000000000_REALK,      3.130944504034718_REALK,      0.000000000000000_REALK, &
      3.113076381689531_REALK,      0.000000000000000_REALK,     12.190133538420730_REALK, &
      0.670858107101589_REALK,      0.097238834477472_REALK,      0.000000000000000_REALK, &
      0.346583711059645_REALK,      0.000000000000000_REALK,      1.379857862975326_REALK, &
     -0.012054045131847_REALK,      0.000000000000000_REALK,      0.247391460888583_REALK, &
      0.000000000000000_REALK,     -2.443571045273046_REALK,      0.000000000000000_REALK, &
      1.546880281858926_REALK,      0.000000000000000_REALK,     10.264354862872727_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.401233794951732_REALK, &
      0.000000000000000_REALK,     -0.919427527835910_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.451092148838530_REALK,      0.000000000000000_REALK, &
     -1.016979906318320_REALK,      0.000000000000000_REALK,     -4.837789586425196_REALK, &
      0.000000000000000_REALK,     -5.734964356149796_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.372640649455491_REALK, &
      0.000000000000000_REALK,     -1.566128268309099_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.955486772886178_REALK,      0.000000000000000_REALK, &
     -1.580097690232702_REALK,      0.000000000000000_REALK,    -11.704732729216186_REALK, &
      0.000000000000000_REALK,    -11.649965360952828_REALK,      0.000000000000000_REALK, &
     13.748454593446121_REALK,     -0.507199132505874_REALK,      0.000000000000000_REALK, &
      3.894889578857044_REALK,      0.000000000000000_REALK,      5.272060616418543_REALK, &
     -0.668454351409719_REALK,      0.000000000000000_REALK,     -0.219042410523048_REALK, &
      0.000000000000000_REALK,      9.377565530082277_REALK,      0.000000000000000_REALK, &
      4.172231815042892_REALK,      0.000000000000000_REALK,     16.942399975131682_REALK, &
      6.321871482645241_REALK,     -0.274763588197084_REALK,      0.000000000000000_REALK, &
      1.625476081426160_REALK,      0.000000000000000_REALK,      2.265671117702045_REALK, &
      0.010613950528600_REALK,      0.000000000000000_REALK,     -0.128927667658018_REALK, &
      0.000000000000000_REALK,      7.894009682979136_REALK,      0.000000000000000_REALK, &
      1.918313100813171_REALK,      0.000000000000000_REALK,      8.021526684185702_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.527304008751492_REALK, &
      0.000000000000000_REALK,     -0.198970744677420_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.504429134703767_REALK,      0.000000000000000_REALK, &
     -1.978775180621393_REALK,      0.000000000000000_REALK,     -0.309722729264726_REALK, &
      0.000000000000000_REALK,     -0.639416384776829_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.909596219992507_REALK, &
      0.000000000000000_REALK,     -0.066423436613600_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.215968268885362_REALK,      0.000000000000000_REALK, &
     -1.280432970653287_REALK,      0.000000000000000_REALK,      0.525671328780762_REALK, &
      0.000000000000000_REALK,     -0.235169776005141_REALK,      0.000000000000000_REALK, &
      1.348607083457475_REALK,      0.190235677130195_REALK,      0.000000000000000_REALK, &
      0.482481899730566_REALK,      0.000000000000000_REALK,      1.551433634244651_REALK, &
      0.187601892590380_REALK,      0.000000000000000_REALK,      0.246469356602850_REALK, &
      0.000000000000000_REALK,      1.357157903056300_REALK,      0.000000000000000_REALK, &
      1.550513531756342_REALK,      0.000000000000000_REALK,      8.309530522843007_REALK, &
      1.091328763506225_REALK,      0.182649625083257_REALK,      0.000000000000000_REALK, &
      0.401868082900374_REALK,      0.000000000000000_REALK,      1.173351308792633_REALK, &
      0.310635612711562_REALK,      0.000000000000000_REALK,      0.257114747064351_REALK, &
      0.000000000000000_REALK,      2.528762488309537_REALK,      0.000000000000000_REALK, &
      1.422799419263210_REALK,      0.000000000000000_REALK,      6.923679816741236_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.538912181770249_REALK, &
      0.000000000000000_REALK,     -0.379030392856202_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.297179622333891_REALK,      0.000000000000000_REALK, &
     -1.163691100692325_REALK,      0.000000000000000_REALK,     -1.089987317936268_REALK, &
      0.000000000000000_REALK,     -2.030099482829131_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.597005779704164_REALK, &
      0.000000000000000_REALK,     -0.357299211890615_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.211086535593284_REALK,      0.000000000000000_REALK, &
     -1.400668903413870_REALK,      0.000000000000000_REALK,      0.061636835065003_REALK, &
      0.000000000000000_REALK,     -2.108341571161788_REALK,      0.000000000000000_REALK, &
      0.622228256527672_REALK,      0.253536365603071_REALK,      0.000000000000000_REALK, &
      0.529174784007438_REALK,      0.000000000000000_REALK,      1.193015936215147_REALK, &
      0.461823709395914_REALK,      0.000000000000000_REALK,      0.547469555030306_REALK, &
      0.000000000000000_REALK,      3.013409434139880_REALK,      0.000000000000000_REALK, &
      2.834277872136973_REALK,      0.000000000000000_REALK,      8.945766653732640_REALK, &
      1.273532643526513_REALK,      0.677597057658194_REALK,      0.000000000000000_REALK, &
      1.379977585717445_REALK,      0.000000000000000_REALK,      2.282082240844149_REALK, &
      1.597222170862796_REALK,      0.000000000000000_REALK,      1.589748642260840_REALK, &
      0.000000000000000_REALK,     10.361105020090472_REALK,      0.000000000000000_REALK, &
      8.142934589316377_REALK,      0.000000000000000_REALK,     18.852469235551112_REALK, &
     18.753445713973839_REALK,     -2.519674224293877_REALK,      0.000000000000000_REALK, &
      4.866139596553249_REALK,      0.000000000000000_REALK,      6.053226087262147_REALK, &
     -2.373158895192499_REALK,      0.000000000000000_REALK,     -0.947977721265643_REALK, &
      0.000000000000000_REALK,     10.382240445437988_REALK,      0.000000000000000_REALK, &
      4.177442200872172_REALK,      0.000000000000000_REALK,     15.589566394433287_REALK, &
      5.023221526694780_REALK,     -1.239005236378358_REALK,      0.000000000000000_REALK, &
      1.918252406944977_REALK,      0.000000000000000_REALK,      2.803839626897154_REALK, &
     -1.790120673336685_REALK,      0.000000000000000_REALK,     -0.628998357623338_REALK, &
      0.000000000000000_REALK,      1.444497442274111_REALK,      0.000000000000000_REALK, &
      1.815991583272689_REALK,      0.000000000000000_REALK,      7.963106124392918_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.325709093707433_REALK, &
      0.000000000000000_REALK,      0.170407509510990_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.646433542896232_REALK,      0.000000000000000_REALK, &
     -2.625006501700532_REALK,      0.000000000000000_REALK,      0.446434922529671_REALK, &
      0.000000000000000_REALK,      0.438869975337920_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.204830346834352_REALK, &
      0.000000000000000_REALK,      0.116691783698204_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.438819564816592_REALK,      0.000000000000000_REALK, &
     -1.834946989220332_REALK,      0.000000000000000_REALK,     -0.009094509704056_REALK, &
      0.000000000000000_REALK,      0.331413055340053_REALK,      0.000000000000000_REALK, &
      1.589753901531951_REALK,      0.087773662699723_REALK,      0.000000000000000_REALK, &
      0.392428627699966_REALK,      0.000000000000000_REALK,      1.539419464964156_REALK, &
      0.047987544812878_REALK,      0.000000000000000_REALK,      0.099069327237978_REALK, &
      0.000000000000000_REALK,      0.723403654944870_REALK,      0.000000000000000_REALK, &
      1.010666388205568_REALK,      0.000000000000000_REALK,      6.607738752850792_REALK, &
      0.692084157227297_REALK,      0.035322413543525_REALK,      0.000000000000000_REALK, &
      0.195471794194665_REALK,      0.000000000000000_REALK,      1.158913443217247_REALK, &
     -0.120248807994040_REALK,      0.000000000000000_REALK,      0.053795753529935_REALK, &
      0.000000000000000_REALK,     -0.509219036418539_REALK,      0.000000000000000_REALK, &
      0.555153949093789_REALK,      0.000000000000000_REALK,      5.485662499378424_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.684397159662685_REALK, &
      0.000000000000000_REALK,     -0.191744736232476_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.240232086824135_REALK,      0.000000000000000_REALK, &
     -1.287454651085958_REALK,      0.000000000000000_REALK,     -0.375876241399488_REALK, &
      0.000000000000000_REALK,     -0.823036964969121_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.623960491567285_REALK, &
      0.000000000000000_REALK,     -0.232713264693778_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.325469404195655_REALK,      0.000000000000000_REALK, &
     -1.583811403270873_REALK,      0.000000000000000_REALK,     -0.798499650045956_REALK, &
      0.000000000000000_REALK,     -1.101537338021264_REALK,      0.000000000000000_REALK, &
      0.560947747562515_REALK,      0.167204912005736_REALK,      0.000000000000000_REALK, &
      0.231195589924382_REALK,      0.000000000000000_REALK,      0.905311906655699_REALK, &
      0.168879485819812_REALK,      0.000000000000000_REALK,      0.314537748450478_REALK, &
      0.000000000000000_REALK,      0.598842038121476_REALK,      0.000000000000000_REALK, &
      0.992374134405991_REALK,      0.000000000000000_REALK,      5.440291348291835_REALK, &
      0.454243578441635_REALK,      0.190003275419086_REALK,      0.000000000000000_REALK, &
      0.191053361939282_REALK,      0.000000000000000_REALK,      1.267738381365247_REALK, &
     -0.014099600908961_REALK,      0.000000000000000_REALK,      0.482289116594033_REALK, &
      0.000000000000000_REALK,     -0.857141031603822_REALK,      0.000000000000000_REALK, &
      0.904342139703721_REALK,      0.000000000000000_REALK,      8.401092345361764_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.526285301643273_REALK, &
      0.000000000000000_REALK,     -0.425912603787692_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.439134824635592_REALK,      0.000000000000000_REALK, &
     -1.386031238975131_REALK,      0.000000000000000_REALK,     -1.542171365118088_REALK, &
      0.000000000000000_REALK,     -2.559436848758740_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.213557394212392_REALK, &
      0.000000000000000_REALK,     -1.438873502228278_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.862719392000751_REALK,      0.000000000000000_REALK, &
     -4.312555829471152_REALK,      0.000000000000000_REALK,     -6.842858600718072_REALK, &
      0.000000000000000_REALK,     -9.535176455331412_REALK,      0.000000000000000_REALK/
    ! results of test 2, ket-major order, CM020100
  data REF_CONTR_INTS(2521:3780)                                                           &
     /2.437451181495476_REALK,      1.501987809788685_REALK,      0.000000000000000_REALK, &
      1.107154195696193_REALK,      0.000000000000000_REALK,      0.547131872513034_REALK, &
      0.448582047051994_REALK,      0.000000000000000_REALK,      0.417059564696657_REALK, &
      0.000000000000000_REALK,     -2.082311492406181_REALK,      0.000000000000000_REALK, &
      0.487881123402526_REALK,      0.000000000000000_REALK,      0.723301181484846_REALK, &
      0.270817966712200_REALK,     -0.399579848778321_REALK,      0.000000000000000_REALK, &
     -1.821390023259121_REALK,      0.000000000000000_REALK,      0.097169376867400_REALK, &
     -5.478139993129083_REALK,      0.000000000000000_REALK,     -0.130492316586232_REALK, &
      0.000000000000000_REALK,    -20.027179921188058_REALK,      0.000000000000000_REALK, &
     -0.821913373131847_REALK,      0.000000000000000_REALK,      0.131544824479653_REALK, &
      2.369759897762771_REALK,      1.339017461693874_REALK,      0.000000000000000_REALK, &
      1.164206212471702_REALK,      0.000000000000000_REALK,      0.469023320112152_REALK, &
      1.274840570682943_REALK,      0.000000000000000_REALK,      0.325579861952858_REALK, &
      0.000000000000000_REALK,      2.238713005625605_REALK,      0.000000000000000_REALK, &
      0.423049304513805_REALK,      0.000000000000000_REALK,      0.511301143857342_REALK, &
      1.453180533581448_REALK,      0.928137973911452_REALK,      0.000000000000000_REALK, &
      1.146816075883075_REALK,      0.000000000000000_REALK,      0.236218617592388_REALK, &
      2.181572498276204_REALK,      0.000000000000000_REALK,      0.213951536676096_REALK, &
      0.000000000000000_REALK,      6.399860507280921_REALK,      0.000000000000000_REALK, &
      0.396241286933872_REALK,      0.000000000000000_REALK,      0.244850689663923_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.351684171107253_REALK, &
      0.000000000000000_REALK,     -0.226914030074071_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.173037491748907_REALK,      0.000000000000000_REALK, &
     -0.256534258489637_REALK,      0.000000000000000_REALK,     -0.088688278478817_REALK, &
      0.000000000000000_REALK,     -0.247368090581101_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.089348812143350_REALK, &
      0.000000000000000_REALK,      0.091800885907449_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.386069227949993_REALK,      0.000000000000000_REALK, &
     -0.061789247489869_REALK,      0.000000000000000_REALK,      1.331560829163928_REALK, &
      0.000000000000000_REALK,      0.095155540470499_REALK,      0.000000000000000_REALK, &
      2.459288048981949_REALK,      1.074232642438035_REALK,      0.000000000000000_REALK, &
      0.779223569873577_REALK,      0.000000000000000_REALK,      0.428082528835227_REALK, &
      0.644412709225132_REALK,      0.000000000000000_REALK,      0.227142500752060_REALK, &
      0.000000000000000_REALK,      0.705810668873246_REALK,      0.000000000000000_REALK, &
      0.233470580442604_REALK,      0.000000000000000_REALK,      0.384785626418027_REALK, &
      0.621540930698909_REALK,      0.275213747751048_REALK,      0.000000000000000_REALK, &
     -0.023069936135675_REALK,      0.000000000000000_REALK,      0.168177731341305_REALK, &
     -0.617922582743138_REALK,      0.000000000000000_REALK,      0.067685852643424_REALK, &
      0.000000000000000_REALK,     -2.485541829124530_REALK,      0.000000000000000_REALK, &
     -0.006965204901576_REALK,      0.000000000000000_REALK,      0.152327126323899_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.339163968706014_REALK, &
      0.000000000000000_REALK,     -0.197682580973954_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.178010345113580_REALK,      0.000000000000000_REALK, &
     -0.215144882886916_REALK,      0.000000000000000_REALK,     -0.231919265271205_REALK, &
      0.000000000000000_REALK,     -0.177688671291870_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.183974736257554_REALK, &
      0.000000000000000_REALK,     -0.157170543558570_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.219667403840307_REALK,      0.000000000000000_REALK, &
     -0.135739805771322_REALK,      0.000000000000000_REALK,     -0.483852400292059_REALK, &
      0.000000000000000_REALK,     -0.142357356423454_REALK,      0.000000000000000_REALK, &
      0.298275017314338_REALK,      0.164087924192330_REALK,      0.000000000000000_REALK, &
      0.105063310024795_REALK,      0.000000000000000_REALK,      0.155760107588638_REALK, &
      0.037318182280638_REALK,      0.000000000000000_REALK,      0.104087345622837_REALK, &
      0.000000000000000_REALK,     -0.134354693488454_REALK,      0.000000000000000_REALK, &
      0.094437050891658_REALK,      0.000000000000000_REALK,      0.233343831824939_REALK, &
      0.055917615118965_REALK,     -0.071497513384724_REALK,      0.000000000000000_REALK, &
     -0.283609603141107_REALK,      0.000000000000000_REALK,      0.045390885080484_REALK, &
     -0.738187866946589_REALK,      0.000000000000000_REALK,     -0.052752126609321_REALK, &
      0.000000000000000_REALK,     -2.086422173435828_REALK,      0.000000000000000_REALK, &
     -0.256879644527205_REALK,      0.000000000000000_REALK,      0.068521389350656_REALK, &
      2.948296582425308_REALK,      0.988687355581749_REALK,      0.000000000000000_REALK, &
      0.655720214521080_REALK,      0.000000000000000_REALK,      0.447568826463051_REALK, &
      0.489489097780887_REALK,      0.000000000000000_REALK,      0.180192075378123_REALK, &
      0.000000000000000_REALK,      0.564872557348326_REALK,      0.000000000000000_REALK, &
      0.161745935514014_REALK,      0.000000000000000_REALK,      0.331204240497828_REALK, &
      1.900386229099689_REALK,      0.658222535731058_REALK,      0.000000000000000_REALK, &
      0.558663293844992_REALK,      0.000000000000000_REALK,      0.232677758790113_REALK, &
      0.803967428179222_REALK,      0.000000000000000_REALK,      0.108155775168839_REALK, &
      0.000000000000000_REALK,      1.906495952632401_REALK,      0.000000000000000_REALK, &
      0.125347959278494_REALK,      0.000000000000000_REALK,      0.156618570909332_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.351890562868235_REALK, &
      0.000000000000000_REALK,     -0.156350530016504_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.116739789092141_REALK,      0.000000000000000_REALK, &
     -0.192400227851281_REALK,      0.000000000000000_REALK,     -0.109415753589872_REALK, &
      0.000000000000000_REALK,     -0.115700548125248_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.217154022953119_REALK, &
      0.000000000000000_REALK,     -0.065677796753976_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.004894662473346_REALK,      0.000000000000000_REALK, &
     -0.107044929679175_REALK,      0.000000000000000_REALK,      0.134530844623107_REALK, &
      0.000000000000000_REALK,     -0.044208620203189_REALK,      0.000000000000000_REALK, &
      0.325178677416417_REALK,      0.162498186687140_REALK,      0.000000000000000_REALK, &
      0.122531061843461_REALK,      0.000000000000000_REALK,      0.148092128766452_REALK, &
      0.115964101613311_REALK,      0.000000000000000_REALK,      0.088847759625008_REALK, &
      0.000000000000000_REALK,      0.159944178558548_REALK,      0.000000000000000_REALK, &
      0.090673891646933_REALK,      0.000000000000000_REALK,      0.182648783575221_REALK, &
      0.358586258464748_REALK,      0.202941349911583_REALK,      0.000000000000000_REALK, &
      0.213150467039273_REALK,      0.000000000000000_REALK,      0.131712773448222_REALK, &
      0.340017877408335_REALK,      0.000000000000000_REALK,      0.100038867504527_REALK, &
      0.000000000000000_REALK,      0.772439015076527_REALK,      0.000000000000000_REALK, &
      0.143474484668993_REALK,      0.000000000000000_REALK,      0.147762771821073_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.128037255061347_REALK, &
      0.000000000000000_REALK,     -0.071647144863945_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.047220345204420_REALK,      0.000000000000000_REALK, &
     -0.116676412340921_REALK,      0.000000000000000_REALK,     -0.019008922287163_REALK, &
      0.000000000000000_REALK,     -0.088365694821464_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.058609503303539_REALK, &
      0.000000000000000_REALK,      0.051187113916390_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.180517181332212_REALK,      0.000000000000000_REALK, &
     -0.048152075612350_REALK,      0.000000000000000_REALK,      0.482143103380326_REALK, &
      0.000000000000000_REALK,      0.057424573454754_REALK,      0.000000000000000_REALK, &
      4.027121316504255_REALK,      0.984367051775506_REALK,      0.000000000000000_REALK, &
      0.599508700220931_REALK,      0.000000000000000_REALK,      0.531284542211517_REALK, &
      0.341974592648295_REALK,      0.000000000000000_REALK,      0.153502426203122_REALK, &
      0.000000000000000_REALK,      0.305512738122438_REALK,      0.000000000000000_REALK, &
      0.121445391944641_REALK,      0.000000000000000_REALK,      0.322874677744771_REALK, &
      1.240835906300001_REALK,      0.348967679643669_REALK,      0.000000000000000_REALK, &
      0.073611236523223_REALK,      0.000000000000000_REALK,      0.254991750376347_REALK, &
     -0.326949469015083_REALK,      0.000000000000000_REALK,      0.063689384843760_REALK, &
      0.000000000000000_REALK,     -1.181291300217180_REALK,      0.000000000000000_REALK, &
      0.014968173907170_REALK,      0.000000000000000_REALK,      0.155550743804833_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.423188101621591_REALK, &
      0.000000000000000_REALK,     -0.142927131566224_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.096683055321417_REALK,      0.000000000000000_REALK, &
     -0.197976151950754_REALK,      0.000000000000000_REALK,     -0.078651600504338_REALK, &
      0.000000000000000_REALK,     -0.086860331665845_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.234882672339263_REALK, &
      0.000000000000000_REALK,     -0.107032013887446_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.102926710597821_REALK,      0.000000000000000_REALK, &
     -0.128603883262382_REALK,      0.000000000000000_REALK,     -0.161780861666867_REALK, &
      0.000000000000000_REALK,     -0.065291952961415_REALK,      0.000000000000000_REALK, &
      0.385594517588236_REALK,      0.147833539945339_REALK,      0.000000000000000_REALK, &
      0.092597208615155_REALK,      0.000000000000000_REALK,      0.152610555274232_REALK, &
      0.065402875959424_REALK,      0.000000000000000_REALK,      0.069159589448493_REALK, &
      0.000000000000000_REALK,      0.056707369415341_REALK,      0.000000000000000_REALK, &
      0.056273600145100_REALK,      0.000000000000000_REALK,      0.154575310527922_REALK, &
      0.171829232930367_REALK,      0.066300176240069_REALK,      0.000000000000000_REALK, &
     -0.004843805899442_REALK,      0.000000000000000_REALK,      0.105932710316362_REALK, &
     -0.110467034251739_REALK,      0.000000000000000_REALK,      0.036300932889326_REALK, &
      0.000000000000000_REALK,     -0.351478381905431_REALK,      0.000000000000000_REALK, &
     -0.002954831320591_REALK,      0.000000000000000_REALK,      0.107702254802700_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.140025004272608_REALK, &
      0.000000000000000_REALK,     -0.070473440092414_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.054199994914549_REALK,      0.000000000000000_REALK, &
     -0.109177658101106_REALK,      0.000000000000000_REALK,     -0.055899685412508_REALK, &
      0.000000000000000_REALK,     -0.071380736847991_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.132960917148257_REALK, &
      0.000000000000000_REALK,     -0.098999442603171_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.117810906908244_REALK,      0.000000000000000_REALK, &
     -0.121332139269768_REALK,      0.000000000000000_REALK,     -0.205263484295027_REALK, &
      0.000000000000000_REALK,     -0.100653170873560_REALK,      0.000000000000000_REALK, &
      0.140300618454462_REALK,      0.067744260611687_REALK,      0.000000000000000_REALK, &
      0.037454857420739_REALK,      0.000000000000000_REALK,      0.092546938606105_REALK, &
      0.011362515411901_REALK,      0.000000000000000_REALK,      0.052820278505229_REALK, &
      0.000000000000000_REALK,     -0.032383618889599_REALK,      0.000000000000000_REALK, &
      0.037937062781707_REALK,      0.000000000000000_REALK,      0.131233782924371_REALK, &
      0.046376419179907_REALK,     -0.051672176010864_REALK,      0.000000000000000_REALK, &
     -0.178641569801616_REALK,      0.000000000000000_REALK,      0.047651765406007_REALK, &
     -0.395901169464643_REALK,      0.000000000000000_REALK,     -0.047152921253780_REALK, &
      0.000000000000000_REALK,     -0.885117620107567_REALK,      0.000000000000000_REALK, &
     -0.181625673615531_REALK,      0.000000000000000_REALK,      0.067826864713656_REALK, &
      6.491028630539452_REALK,      1.084569195232545_REALK,      0.000000000000000_REALK, &
      0.663251430915509_REALK,      0.000000000000000_REALK,      0.727989139312299_REALK, &
      0.291576043187979_REALK,      0.000000000000000_REALK,      0.142253520309227_REALK, &
      0.000000000000000_REALK,      0.269860451886634_REALK,      0.000000000000000_REALK, &
      0.109339758672502_REALK,      0.000000000000000_REALK,      0.360036117971447_REALK, &
      5.855127610265785_REALK,      0.981059532428710_REALK,      0.000000000000000_REALK, &
      0.683713088966150_REALK,      0.000000000000000_REALK,      0.516036639900558_REALK, &
      0.712250242431175_REALK,      0.000000000000000_REALK,      0.108474733931233_REALK, &
      0.000000000000000_REALK,      1.429077409791635_REALK,      0.000000000000000_REALK, &
      0.095971729123629_REALK,      0.000000000000000_REALK,      0.217305750416266_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.594797584970999_REALK, &
      0.000000000000000_REALK,     -0.143916315920696_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.088032546298649_REALK,      0.000000000000000_REALK, &
     -0.234043297667355_REALK,      0.000000000000000_REALK,     -0.052855300370187_REALK, &
      0.000000000000000_REALK,     -0.071175610869397_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.538850575915445_REALK, &
      0.000000000000000_REALK,     -0.098621419383673_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.017199648276786_REALK,      0.000000000000000_REALK, &
     -0.178740446177868_REALK,      0.000000000000000_REALK,      0.071064753896759_REALK, &
      0.000000000000000_REALK,     -0.041529999789194_REALK,      0.000000000000000_REALK, &
      0.551664499520554_REALK,      0.160013525574356_REALK,      0.000000000000000_REALK, &
      0.090645271726214_REALK,      0.000000000000000_REALK,      0.185612691171449_REALK, &
      0.057012460925790_REALK,      0.000000000000000_REALK,      0.062962752612097_REALK, &
      0.000000000000000_REALK,      0.052186980636392_REALK,      0.000000000000000_REALK, &
      0.044829750860847_REALK,      0.000000000000000_REALK,      0.152995123065367_REALK, &
      0.753169714522225_REALK,      0.226180895027066_REALK,      0.000000000000000_REALK, &
      0.159379436880276_REALK,      0.000000000000000_REALK,      0.199139896494554_REALK, &
      0.185899357920508_REALK,      0.000000000000000_REALK,      0.075025760203309_REALK, &
      0.000000000000000_REALK,      0.340267392689466_REALK,      0.000000000000000_REALK, &
      0.067115521368530_REALK,      0.000000000000000_REALK,      0.139764767652628_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.170854565691576_REALK, &
      0.000000000000000_REALK,     -0.064840625455941_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.040791241485913_REALK,      0.000000000000000_REALK, &
     -0.112047546331608_REALK,      0.000000000000000_REALK,     -0.030325837605117_REALK, &
      0.000000000000000_REALK,     -0.053446234784149_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.223857838059496_REALK, &
      0.000000000000000_REALK,     -0.056211086592832_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.003395341325307_REALK,      0.000000000000000_REALK, &
     -0.123758643687045_REALK,      0.000000000000000_REALK,      0.072032347626561_REALK, &
      0.000000000000000_REALK,     -0.039451308328684_REALK,      0.000000000000000_REALK, &
      0.182535434258227_REALK,      0.078898271342662_REALK,      0.000000000000000_REALK, &
      0.050815246273050_REALK,      0.000000000000000_REALK,      0.102359596023381_REALK, &
      0.040520200605056_REALK,      0.000000000000000_REALK,      0.051742004540336_REALK, &
      0.000000000000000_REALK,      0.044330373147468_REALK,      0.000000000000000_REALK, &
      0.041885524142102_REALK,      0.000000000000000_REALK,      0.118120837795914_REALK, &
      0.426349611122108_REALK,      0.209206402102393_REALK,      0.000000000000000_REALK, &
      0.182427242572230_REALK,      0.000000000000000_REALK,      0.187879782808333_REALK, &
      0.235864425135440_REALK,      0.000000000000000_REALK,      0.115658673376259_REALK, &
      0.000000000000000_REALK,      0.413589878292892_REALK,      0.000000000000000_REALK, &
      0.128035123149291_REALK,      0.000000000000000_REALK,      0.184606723787121_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.103610572500819_REALK, &
      0.000000000000000_REALK,     -0.049521692108753_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.027499571472319_REALK,      0.000000000000000_REALK, &
     -0.095127891525953_REALK,      0.000000000000000_REALK,     -0.008780903288838_REALK, &
      0.000000000000000_REALK,     -0.057146999286917_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.100698086093049_REALK, &
      0.000000000000000_REALK,      0.073015119137078_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.208702659629373_REALK,      0.000000000000000_REALK, &
     -0.077938579817888_REALK,      0.000000000000000_REALK,      0.430259441316693_REALK, &
      0.000000000000000_REALK,      0.071743120677189_REALK,      0.000000000000000_REALK, &
     18.923042036934813_REALK,     -2.187583224517802_REALK,      0.000000000000000_REALK, &
      7.268169195928910_REALK,      0.000000000000000_REALK,      8.213712422776760_REALK, &
     -1.048552843141997_REALK,      0.000000000000000_REALK,     -0.823263012304650_REALK, &
      0.000000000000000_REALK,      5.919371865791701_REALK,      0.000000000000000_REALK, &
      9.595601493461293_REALK,      0.000000000000000_REALK,     32.531787194086590_REALK, &
      5.507895275701661_REALK,     -0.061649281704229_REALK,      0.000000000000000_REALK, &
     -2.734892538089308_REALK,      0.000000000000000_REALK,      2.915461788201989_REALK, &
      4.546191535708308_REALK,      0.000000000000000_REALK,     -0.024893986199191_REALK, &
      0.000000000000000_REALK,    -90.975464543830839_REALK,      0.000000000000000_REALK, &
     -4.149543491402888_REALK,      0.000000000000000_REALK,     13.270542062452693_REALK, &
     11.934351899084822_REALK,     -0.062570188282263_REALK,      0.000000000000000_REALK, &
      4.413854472779361_REALK,      0.000000000000000_REALK,      5.389119051002966_REALK, &
      0.066358143046408_REALK,      0.000000000000000_REALK,      0.033738253569202_REALK, &
      0.000000000000000_REALK,     14.306281573175852_REALK,      0.000000000000000_REALK, &
      5.902527607669219_REALK,      0.000000000000000_REALK,     21.620167254538682_REALK, &
      4.735201987627029_REALK,     -0.077528938737641_REALK,      0.000000000000000_REALK, &
      2.443752967160602_REALK,      0.000000000000000_REALK,      2.173773035863581_REALK, &
     -0.012479694285412_REALK,      0.000000000000000_REALK,     -0.002157490206419_REALK, &
      0.000000000000000_REALK,     29.357922754295711_REALK,      0.000000000000000_REALK, &
      3.805396999079719_REALK,      0.000000000000000_REALK,     10.154957761913638_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.074631938467566_REALK, &
      0.000000000000000_REALK,     -0.912826875983037_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.035609460463269_REALK,      0.000000000000000_REALK, &
     -0.120726083787107_REALK,      0.000000000000000_REALK,     -1.554748525677607_REALK, &
      0.000000000000000_REALK,     -3.662095705515789_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.076126358560218_REALK, &
      0.000000000000000_REALK,     -0.024674120504196_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.001987252091226_REALK,      0.000000000000000_REALK, &
      0.006355376807098_REALK,      0.000000000000000_REALK,      7.016776367997944_REALK, &
      0.000000000000000_REALK,     -0.115267163314010_REALK,      0.000000000000000_REALK, &
      9.906353797703202_REALK,      0.105402586307136_REALK,      0.000000000000000_REALK, &
      3.073517870955990_REALK,      0.000000000000000_REALK,      4.292932622551587_REALK, &
     -0.018823027848735_REALK,      0.000000000000000_REALK,      0.053431347856047_REALK, &
      0.000000000000000_REALK,      7.539408710814247_REALK,      0.000000000000000_REALK, &
      3.834237045177490_REALK,      0.000000000000000_REALK,     16.066398815555093_REALK, &
      2.329934869479855_REALK,     -0.022235912898836_REALK,      0.000000000000000_REALK, &
      0.545017235484868_REALK,      0.000000000000000_REALK,      1.597446074830109_REALK, &
     -0.543451263237690_REALK,      0.000000000000000_REALK,     -0.018857263512720_REALK, &
      0.000000000000000_REALK,     -8.470352850092041_REALK,      0.000000000000000_REALK, &
      0.810844429923517_REALK,      0.000000000000000_REALK,      7.129757561117395_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.653210112525025_REALK, &
      0.000000000000000_REALK,     -0.385535877055083_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.271205188773874_REALK,      0.000000000000000_REALK, &
     -0.993388245058163_REALK,      0.000000000000000_REALK,     -0.945974961062015_REALK, &
      0.000000000000000_REALK,     -1.442876863692811_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.236013854010777_REALK, &
      0.000000000000000_REALK,     -0.268409251803503_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.225011288870291_REALK,      0.000000000000000_REALK, &
     -0.600457753812319_REALK,      0.000000000000000_REALK,     -2.309829354210094_REALK, &
      0.000000000000000_REALK,     -1.197970261827719_REALK,      0.000000000000000_REALK, &
      1.061162321019866_REALK,      0.110642897426023_REALK,      0.000000000000000_REALK, &
      0.406918649271663_REALK,      0.000000000000000_REALK,      1.379568640114066_REALK, &
      0.071436492199449_REALK,      0.000000000000000_REALK,      0.168263398858474_REALK, &
      0.000000000000000_REALK,      0.313151308753437_REALK,      0.000000000000000_REALK, &
      1.522902379213142_REALK,      0.000000000000000_REALK,      8.605112135959704_REALK, &
      0.384402561513886_REALK,      0.002678952300192_REALK,      0.000000000000000_REALK, &
     -0.247230251782250_REALK,      0.000000000000000_REALK,      0.790660337018882_REALK, &
     -0.414898601817271_REALK,      0.000000000000000_REALK,      0.006815691763035_REALK, &
      0.000000000000000_REALK,     -8.064043715033666_REALK,      0.000000000000000_REALK, &
     -1.103443668462435_REALK,      0.000000000000000_REALK,      5.881488588731164_REALK, &
     10.894987231048578_REALK,     -0.639363467453256_REALK,      0.000000000000000_REALK, &
      3.058084353218117_REALK,      0.000000000000000_REALK,      4.177853787623176_REALK, &
     -0.751396361193191_REALK,      0.000000000000000_REALK,     -0.276119784392009_REALK, &
      0.000000000000000_REALK,      7.452738117780738_REALK,      0.000000000000000_REALK, &
      3.275840450225454_REALK,      0.000000000000000_REALK,     13.426034914525600_REALK, &
      5.020428440730737_REALK,     -0.311862840066489_REALK,      0.000000000000000_REALK, &
      1.389465907599489_REALK,      0.000000000000000_REALK,      1.799251969591462_REALK, &
      0.127350308122991_REALK,      0.000000000000000_REALK,     -0.146335796758257_REALK, &
      0.000000000000000_REALK,      8.660456607952852_REALK,      0.000000000000000_REALK, &
      1.639784604731166_REALK,      0.000000000000000_REALK,      6.370186552181498_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.183795896847283_REALK, &
      0.000000000000000_REALK,     -0.062680146470629_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.366022858843590_REALK,      0.000000000000000_REALK, &
     -1.533726046799101_REALK,      0.000000000000000_REALK,      0.023653566773730_REALK, &
      0.000000000000000_REALK,     -0.201430178685361_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.691146939861557_REALK, &
      0.000000000000000_REALK,      0.027234914929189_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.110647438993780_REALK,      0.000000000000000_REALK, &
     -0.972923270692739_REALK,      0.000000000000000_REALK,      0.926289764463966_REALK, &
      0.000000000000000_REALK,      0.096424231716206_REALK,      0.000000000000000_REALK, &
      1.012989919036071_REALK,      0.106313289649060_REALK,      0.000000000000000_REALK, &
      0.318149955747695_REALK,      0.000000000000000_REALK,      1.165340632435498_REALK, &
      0.090304395780085_REALK,      0.000000000000000_REALK,      0.137739505509281_REALK, &
      0.000000000000000_REALK,      0.826026326775381_REALK,      0.000000000000000_REALK, &
      1.022413093195733_REALK,      0.000000000000000_REALK,      6.241603469842611_REALK, &
      0.806598388679349_REALK,      0.116129261536575_REALK,      0.000000000000000_REALK, &
      0.324976278045644_REALK,      0.000000000000000_REALK,      0.867221048940625_REALK, &
      0.315198197242485_REALK,      0.000000000000000_REALK,      0.163474442902010_REALK, &
      0.000000000000000_REALK,      2.958802124796852_REALK,      0.000000000000000_REALK, &
      1.150566763950471_REALK,      0.000000000000000_REALK,      5.117274620319637_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.380422391678614_REALK, &
      0.000000000000000_REALK,     -0.197389265090408_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.145378878773390_REALK,      0.000000000000000_REALK, &
     -0.821458795468875_REALK,      0.000000000000000_REALK,     -0.269307550076372_REALK, &
      0.000000000000000_REALK,     -1.057223516975553_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.342085082564446_REALK, &
      0.000000000000000_REALK,     -0.009843675633245_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.150575389659871_REALK,      0.000000000000000_REALK, &
     -0.802585090059295_REALK,      0.000000000000000_REALK,      2.121531519850343_REALK, &
      0.000000000000000_REALK,     -0.058085296188555_REALK,      0.000000000000000_REALK, &
     15.108342313925929_REALK,     -2.359376474008500_REALK,      0.000000000000000_REALK, &
      3.996918163238737_REALK,      0.000000000000000_REALK,      4.876661773244014_REALK, &
     -2.189113604400357_REALK,      0.000000000000000_REALK,     -0.887668854915222_REALK, &
      0.000000000000000_REALK,      8.705066952032828_REALK,      0.000000000000000_REALK, &
      3.431240365642742_REALK,      0.000000000000000_REALK,     12.559425569311291_REALK, &
      4.060388586621453_REALK,     -1.164082102752939_REALK,      0.000000000000000_REALK, &
      1.532680402781545_REALK,      0.000000000000000_REALK,      2.266409784889808_REALK, &
     -1.793251962937833_REALK,      0.000000000000000_REALK,     -0.590962579714817_REALK, &
      0.000000000000000_REALK,     -0.057577960586397_REALK,      0.000000000000000_REALK, &
      1.450974179008612_REALK,      0.000000000000000_REALK,      6.436766734198837_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.843012296898804_REALK, &
      0.000000000000000_REALK,      0.214811755735324_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.507549254709918_REALK,      0.000000000000000_REALK, &
     -2.080191058788536_REALK,      0.000000000000000_REALK,      0.501828697189153_REALK, &
      0.000000000000000_REALK,      0.553229316081151_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.956799668596188_REALK, &
      0.000000000000000_REALK,      0.132447793811904_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.375105381043403_REALK,      0.000000000000000_REALK, &
     -1.457198248525664_REALK,      0.000000000000000_REALK,     -0.109119465925366_REALK, &
      0.000000000000000_REALK,      0.376161256852295_REALK,      0.000000000000000_REALK, &
      1.232200095623984_REALK,      0.027650627951370_REALK,      0.000000000000000_REALK, &
      0.284753275179400_REALK,      0.000000000000000_REALK,      1.193186448610915_REALK, &
     -0.003664815295388_REALK,      0.000000000000000_REALK,      0.031209009907917_REALK, &
      0.000000000000000_REALK,      0.480676557590064_REALK,      0.000000000000000_REALK, &
      0.733357721229508_REALK,      0.000000000000000_REALK,      5.121582853342923_REALK, &
      0.525872729988093_REALK,     -0.014482884008964_REALK,      0.000000000000000_REALK, &
      0.100146440654388_REALK,      0.000000000000000_REALK,      0.880587960062783_REALK, &
     -0.211891411867978_REALK,      0.000000000000000_REALK,     -0.022057316598392_REALK, &
      0.000000000000000_REALK,     -0.990393000716567_REALK,      0.000000000000000_REALK, &
      0.284423091556643_REALK,      0.000000000000000_REALK,      4.168221861772831_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.514076658694253_REALK, &
      0.000000000000000_REALK,     -0.107156627974755_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.158409730675815_REALK,      0.000000000000000_REALK, &
     -0.967056008205597_REALK,      0.000000000000000_REALK,     -0.180932486335752_REALK, &
      0.000000000000000_REALK,     -0.459954560409622_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.461167655364264_REALK, &
      0.000000000000000_REALK,     -0.147959896256756_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.263195411862202_REALK,      0.000000000000000_REALK, &
     -1.170591089110407_REALK,      0.000000000000000_REALK,     -0.810227932323204_REALK, &
      0.000000000000000_REALK,     -0.700361238415159_REALK,      0.000000000000000_REALK, &
      0.395977472681141_REALK,      0.087076011112491_REALK,      0.000000000000000_REALK, &
      0.113099799295108_REALK,      0.000000000000000_REALK,      0.639066869139567_REALK, &
      0.041725733718078_REALK,      0.000000000000000_REALK,      0.163803157161030_REALK, &
      0.000000000000000_REALK,      0.059895078859640_REALK,      0.000000000000000_REALK, &
      0.485464776658085_REALK,      0.000000000000000_REALK,      3.840344895057449_REALK, &
      0.260282156920787_REALK,      0.005234634027271_REALK,      0.000000000000000_REALK, &
     -0.136285028028814_REALK,      0.000000000000000_REALK,      0.726415729298882_REALK, &
     -0.485306354781590_REALK,      0.000000000000000_REALK,      0.013287176313866_REALK, &
      0.000000000000000_REALK,     -2.828656347918840_REALK,      0.000000000000000_REALK, &
     -0.645098796514913_REALK,      0.000000000000000_REALK,      4.813836760539776_REALK, &
     25.537282688686165_REALK,     -6.129677995338668_REALK,      0.000000000000000_REALK, &
      6.545480703225678_REALK,      0.000000000000000_REALK,      6.725907188738252_REALK, &
     -4.885971019778482_REALK,      0.000000000000000_REALK,     -1.958649078749424_REALK, &
      0.000000000000000_REALK,     12.478455761996061_REALK,      0.000000000000000_REALK, &
      4.275610867391134_REALK,      0.000000000000000_REALK,     13.180404850202141_REALK, &
     19.214860786202085_REALK,     -4.696824605877476_REALK,      0.000000000000000_REALK, &
      4.357765372089804_REALK,      0.000000000000000_REALK,      4.351172914964987_REALK, &
     -2.776918996172474_REALK,      0.000000000000000_REALK,     -1.466687763527454_REALK, &
      0.000000000000000_REALK,     10.426376739180260_REALK,      0.000000000000000_REALK, &
      2.654189327536864_REALK,      0.000000000000000_REALK,      7.950522155553218_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.999766574749389_REALK, &
      0.000000000000000_REALK,      0.627328160981277_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.785613710426090_REALK,      0.000000000000000_REALK, &
     -2.875594791062879_REALK,      0.000000000000000_REALK,      1.010575410301437_REALK, &
      0.000000000000000_REALK,      1.229341842467074_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.578122073510410_REALK, &
      0.000000000000000_REALK,      0.600137663248782_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.544439932307785_REALK,      0.000000000000000_REALK, &
     -2.415227573134793_REALK,      0.000000000000000_REALK,      1.109175507400391_REALK, &
      0.000000000000000_REALK,      1.096579676627209_REALK,      0.000000000000000_REALK, &
      1.860585301459293_REALK,     -0.132136521801347_REALK,      0.000000000000000_REALK, &
      0.358692251960332_REALK,      0.000000000000000_REALK,      1.470100504454604_REALK, &
     -0.114898247509749_REALK,      0.000000000000000_REALK,     -0.126666887016989_REALK, &
      0.000000000000000_REALK,      0.533054655383181_REALK,      0.000000000000000_REALK, &
      0.702910249101250_REALK,      0.000000000000000_REALK,      4.801463771717863_REALK, &
      2.178307500247758_REALK,     -0.150664095738903_REALK,      0.000000000000000_REALK, &
      0.380929139303654_REALK,      0.000000000000000_REALK,      1.479822211725200_REALK, &
      0.040944212172307_REALK,      0.000000000000000_REALK,     -0.141144626954977_REALK, &
      0.000000000000000_REALK,      1.225367156665843_REALK,      0.000000000000000_REALK, &
      0.696038889034564_REALK,      0.000000000000000_REALK,      4.506585354696882_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.733961261292471_REALK, &
      0.000000000000000_REALK,     -0.022055849637137_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.167908924776482_REALK,      0.000000000000000_REALK, &
     -1.172633007281516_REALK,      0.000000000000000_REALK,      0.005075440872559_REALK, &
      0.000000000000000_REALK,     -0.072036138118638_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.001700254138173_REALK, &
      0.000000000000000_REALK,      0.022399770975830_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.106722291102156_REALK,      0.000000000000000_REALK, &
     -1.564015722056458_REALK,      0.000000000000000_REALK,      0.393181943970798_REALK, &
      0.000000000000000_REALK,      0.068215275475934_REALK,      0.000000000000000_REALK, &
      0.518978346807174_REALK,      0.065914940549116_REALK,      0.000000000000000_REALK, &
      0.111950401860038_REALK,      0.000000000000000_REALK,      0.683432187390930_REALK, &
      0.041426139465523_REALK,      0.000000000000000_REALK,      0.105310782785431_REALK, &
      0.000000000000000_REALK,      0.177243788255290_REALK,      0.000000000000000_REALK, &
      0.365638809817051_REALK,      0.000000000000000_REALK,      3.125000521757650_REALK, &
      1.049921938231377_REALK,      0.168309666273523_REALK,      0.000000000000000_REALK, &
      0.267281694094754_REALK,      0.000000000000000_REALK,      1.188765287266720_REALK, &
      0.304016740621339_REALK,      0.000000000000000_REALK,      0.262792150784016_REALK, &
      0.000000000000000_REALK,      1.255921867954324_REALK,      0.000000000000000_REALK, &
      0.813967893333439_REALK,      0.000000000000000_REALK,      5.068298791468806_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.393107318533467_REALK, &
      0.000000000000000_REALK,     -0.115762012799886_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.111151578971382_REALK,      0.000000000000000_REALK, &
     -0.879281915814378_REALK,      0.000000000000000_REALK,     -0.096310672017010_REALK, &
      0.000000000000000_REALK,     -0.529322962941504_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.826323835493705_REALK, &
      0.000000000000000_REALK,     -0.013493468483278_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.242056371634666_REALK,      0.000000000000000_REALK, &
     -1.806265747499183_REALK,      0.000000000000000_REALK,      1.500876434083585_REALK, &
      0.000000000000000_REALK,     -0.057529380054294_REALK,      0.000000000000000_REALK/
    ! results of test 2, ket-major order, CM010200
  data REF_CONTR_INTS(3781:5040)                                                           &
     /1.666509039228760_REALK,      0.928882953426401_REALK,      0.000000000000000_REALK, &
      0.882551866294805_REALK,      0.000000000000000_REALK,      0.329835779276164_REALK, &
      1.167579677551918_REALK,      0.000000000000000_REALK,      0.225856340487418_REALK, &
      0.000000000000000_REALK,      2.675539741103298_REALK,      0.000000000000000_REALK, &
      0.320701735855454_REALK,      0.000000000000000_REALK,      0.359567219789101_REALK, &
      1.275493317157132_REALK,      1.077469966560440_REALK,      0.000000000000000_REALK, &
      1.688223580902664_REALK,      0.000000000000000_REALK,      0.207335056563569_REALK, &
      3.626692505897314_REALK,      0.000000000000000_REALK,      0.248375092440665_REALK, &
      0.000000000000000_REALK,     10.957961858702989_REALK,      0.000000000000000_REALK, &
      0.583305290531335_REALK,      0.000000000000000_REALK,      0.214911644596528_REALK, &
      1.740297043671596_REALK,      0.691011860640982_REALK,      0.000000000000000_REALK, &
      0.468569507393008_REALK,      0.000000000000000_REALK,      0.302929443213374_REALK, &
      0.327129235447985_REALK,      0.000000000000000_REALK,      0.146111890362129_REALK, &
      0.000000000000000_REALK,      0.213255867753734_REALK,      0.000000000000000_REALK, &
      0.140392563955040_REALK,      0.000000000000000_REALK,      0.272290709654699_REALK, &
      0.381060373815326_REALK,      0.041535353276440_REALK,      0.000000000000000_REALK, &
     -0.338976299068825_REALK,      0.000000000000000_REALK,      0.103108043263165_REALK, &
     -1.203926581819097_REALK,      0.000000000000000_REALK,      0.010215172113803_REALK, &
      0.000000000000000_REALK,     -4.026023945085988_REALK,      0.000000000000000_REALK, &
     -0.102342692494118_REALK,      0.000000000000000_REALK,      0.093390199795736_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.238513538929780_REALK, &
      0.000000000000000_REALK,     -0.137133371975413_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.134944617729044_REALK,      0.000000000000000_REALK, &
     -0.151298404708995_REALK,      0.000000000000000_REALK,     -0.212406340989265_REALK, &
      0.000000000000000_REALK,     -0.123263499171409_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.161479280240513_REALK, &
      0.000000000000000_REALK,     -0.182458368337911_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.323371549211423_REALK,      0.000000000000000_REALK, &
     -0.119142261496462_REALK,      0.000000000000000_REALK,     -0.804366517952623_REALK, &
      0.000000000000000_REALK,     -0.165261825694727_REALK,      0.000000000000000_REALK, &
      2.152649443851538_REALK,      0.662842915882612_REALK,      0.000000000000000_REALK, &
      0.435861470217559_REALK,      0.000000000000000_REALK,      0.326784893729524_REALK, &
      0.321007405508486_REALK,      0.000000000000000_REALK,      0.120805672276749_REALK, &
      0.000000000000000_REALK,      0.400921356175373_REALK,      0.000000000000000_REALK, &
      0.107513570107554_REALK,      0.000000000000000_REALK,      0.241823237308922_REALK, &
      1.413024583118805_REALK,      0.532535625517404_REALK,      0.000000000000000_REALK, &
      0.566848737968112_REALK,      0.000000000000000_REALK,      0.173006617329140_REALK, &
      0.992507288187986_REALK,      0.000000000000000_REALK,      0.087503542124833_REALK, &
      0.000000000000000_REALK,      2.561881043765872_REALK,      0.000000000000000_REALK, &
      0.127184537281605_REALK,      0.000000000000000_REALK,      0.116453112256379_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.249012760627626_REALK, &
      0.000000000000000_REALK,     -0.100574183273471_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.070198987277737_REALK,      0.000000000000000_REALK, &
     -0.136150601744246_REALK,      0.000000000000000_REALK,     -0.055543739757800_REALK, &
      0.000000000000000_REALK,     -0.074425639176033_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.133134905643251_REALK, &
      0.000000000000000_REALK,     -0.009912115629711_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.071919339552928_REALK,      0.000000000000000_REALK, &
     -0.065628149175491_REALK,      0.000000000000000_REALK,      0.262112543609140_REALK, &
      0.000000000000000_REALK,     -0.006671980135471_REALK,      0.000000000000000_REALK, &
      0.228678528061226_REALK,      0.112725785805244_REALK,      0.000000000000000_REALK, &
      0.092887339159135_REALK,      0.000000000000000_REALK,      0.104144251685969_REALK, &
      0.106207263467254_REALK,      0.000000000000000_REALK,      0.061634124816712_REALK, &
      0.000000000000000_REALK,      0.191153133526345_REALK,      0.000000000000000_REALK, &
      0.068737317701918_REALK,      0.000000000000000_REALK,      0.128445860325177_REALK, &
      0.314740230636685_REALK,      0.235593430771344_REALK,      0.000000000000000_REALK, &
      0.313777991347938_REALK,      0.000000000000000_REALK,      0.115607633349861_REALK, &
      0.565252948889986_REALK,      0.000000000000000_REALK,      0.116134538457243_REALK, &
      0.000000000000000_REALK,      1.322584649423696_REALK,      0.000000000000000_REALK, &
      0.211208242864523_REALK,      0.000000000000000_REALK,      0.129695122957570_REALK, &
      3.005019836541519_REALK,      0.663493335045135_REALK,      0.000000000000000_REALK, &
      0.401954973465489_REALK,      0.000000000000000_REALK,      0.396442138867410_REALK, &
      0.206049494206433_REALK,      0.000000000000000_REALK,      0.103465304446473_REALK, &
      0.000000000000000_REALK,      0.165751133632827_REALK,      0.000000000000000_REALK, &
      0.081425973098680_REALK,      0.000000000000000_REALK,      0.240927634179695_REALK, &
      0.888501124124126_REALK,      0.166382585014905_REALK,      0.000000000000000_REALK, &
     -0.100233906666308_REALK,      0.000000000000000_REALK,      0.182586960694371_REALK, &
     -0.574655117045394_REALK,      0.000000000000000_REALK,      0.030366148805340_REALK, &
      0.000000000000000_REALK,     -1.718949024038409_REALK,      0.000000000000000_REALK, &
     -0.020381651188580_REALK,      0.000000000000000_REALK,      0.111382181984926_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.308983715217322_REALK, &
      0.000000000000000_REALK,     -0.095822239569706_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.064265852576005_REALK,      0.000000000000000_REALK, &
     -0.144548976494788_REALK,      0.000000000000000_REALK,     -0.051579792750133_REALK, &
      0.000000000000000_REALK,     -0.058233530742428_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.174646071983616_REALK, &
      0.000000000000000_REALK,     -0.086594361894087_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.104434776095693_REALK,      0.000000000000000_REALK, &
     -0.095622903256027_REALK,      0.000000000000000_REALK,     -0.199720385012791_REALK, &
      0.000000000000000_REALK,     -0.052824522291602_REALK,      0.000000000000000_REALK, &
      0.272863115523442_REALK,      0.095095536541252_REALK,      0.000000000000000_REALK, &
      0.055681360400597_REALK,      0.000000000000000_REALK,      0.107993733506235_REALK, &
      0.033201072080705_REALK,      0.000000000000000_REALK,      0.044487660026330_REALK, &
      0.000000000000000_REALK,      0.017133743942984_REALK,      0.000000000000000_REALK, &
      0.033838931622023_REALK,      0.000000000000000_REALK,      0.109384078065894_REALK, &
      0.105346741459518_REALK,      0.010006045355382_REALK,      0.000000000000000_REALK, &
     -0.071172082468905_REALK,      0.000000000000000_REALK,      0.064946258884402_REALK, &
     -0.215227930916506_REALK,      0.000000000000000_REALK,      0.005478549251785_REALK, &
      0.000000000000000_REALK,     -0.569316663735151_REALK,      0.000000000000000_REALK, &
     -0.043416582496639_REALK,      0.000000000000000_REALK,      0.066031148471140_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.098471130159072_REALK, &
      0.000000000000000_REALK,     -0.048887769610077_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.041087486179488_REALK,      0.000000000000000_REALK, &
     -0.076778054299547_REALK,      0.000000000000000_REALK,     -0.051196469715602_REALK, &
      0.000000000000000_REALK,     -0.049517165800989_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.116703160651154_REALK, &
      0.000000000000000_REALK,     -0.114927876144973_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.173428987710060_REALK,      0.000000000000000_REALK, &
     -0.106496288120208_REALK,      0.000000000000000_REALK,     -0.341234380620109_REALK, &
      0.000000000000000_REALK,     -0.116847679659407_REALK,      0.000000000000000_REALK, &
      4.936179568597047_REALK,      0.733419641345752_REALK,      0.000000000000000_REALK, &
      0.466477336984879_REALK,      0.000000000000000_REALK,      0.553607959565459_REALK, &
      0.188969164812805_REALK,      0.000000000000000_REALK,      0.096196283560307_REALK, &
      0.000000000000000_REALK,      0.188255574155285_REALK,      0.000000000000000_REALK, &
      0.076900730363619_REALK,      0.000000000000000_REALK,      0.273793728335466_REALK, &
      4.460302930727911_REALK,      0.753736341316086_REALK,      0.000000000000000_REALK, &
      0.648225068094353_REALK,      0.000000000000000_REALK,      0.393104965513632_REALK, &
      0.841280200980223_REALK,      0.000000000000000_REALK,      0.083339844704587_REALK, &
      0.000000000000000_REALK,      1.822210310285953_REALK,      0.000000000000000_REALK, &
      0.090990331544431_REALK,      0.000000000000000_REALK,      0.165538574043427_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.443835286073869_REALK, &
      0.000000000000000_REALK,     -0.097003974529014_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.059023530098117_REALK,      0.000000000000000_REALK, &
     -0.174642057396596_REALK,      0.000000000000000_REALK,     -0.031846833482764_REALK, &
      0.000000000000000_REALK,     -0.047974526721950_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.385844203899152_REALK, &
      0.000000000000000_REALK,     -0.047021221884072_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.023420173624237_REALK,      0.000000000000000_REALK, &
     -0.127987179085618_REALK,      0.000000000000000_REALK,      0.124905309041686_REALK, &
      0.000000000000000_REALK,     -0.019800884504978_REALK,      0.000000000000000_REALK, &
      0.402788608569587_REALK,      0.107277423215304_REALK,      0.000000000000000_REALK, &
      0.060252498745542_REALK,      0.000000000000000_REALK,      0.135522002366982_REALK, &
      0.037388824891937_REALK,      0.000000000000000_REALK,      0.042211943237447_REALK, &
      0.000000000000000_REALK,      0.037039992081857_REALK,      0.000000000000000_REALK, &
      0.029798625521964_REALK,      0.000000000000000_REALK,      0.111706830493877_REALK, &
      0.560016330146038_REALK,      0.182991887811236_REALK,      0.000000000000000_REALK, &
      0.161714638582860_REALK,      0.000000000000000_REALK,      0.148069673899841_REALK, &
      0.229494953574712_REALK,      0.000000000000000_REALK,      0.060699669140640_REALK, &
      0.000000000000000_REALK,      0.457239147001148_REALK,      0.000000000000000_REALK, &
      0.068098887120332_REALK,      0.000000000000000_REALK,      0.103921534224447_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.120903972877000_REALK, &
      0.000000000000000_REALK,     -0.041709439344299_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.024528944795785_REALK,      0.000000000000000_REALK, &
     -0.079289619494664_REALK,      0.000000000000000_REALK,     -0.015394587859713_REALK, &
      0.000000000000000_REALK,     -0.034379873300657_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.137244945970848_REALK, &
      0.000000000000000_REALK,     -0.008483396482787_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.049889181736760_REALK,      0.000000000000000_REALK, &
     -0.075875155918104_REALK,      0.000000000000000_REALK,      0.140343888506984_REALK, &
      0.000000000000000_REALK,     -0.005954004994445_REALK,      0.000000000000000_REALK, &
      0.128366148595082_REALK,      0.054732116198320_REALK,      0.000000000000000_REALK, &
      0.038521603779537_REALK,      0.000000000000000_REALK,      0.071983322945844_REALK, &
      0.037110964182326_REALK,      0.000000000000000_REALK,      0.035893681276442_REALK, &
      0.000000000000000_REALK,      0.052980294837232_REALK,      0.000000000000000_REALK, &
      0.031752233501543_REALK,      0.000000000000000_REALK,      0.083067252549089_REALK, &
      0.374217839554008_REALK,      0.242866493359316_REALK,      0.000000000000000_REALK, &
      0.268550449532492_REALK,      0.000000000000000_REALK,      0.164906838388729_REALK, &
      0.392106035312779_REALK,      0.000000000000000_REALK,      0.134267480092385_REALK, &
      0.000000000000000_REALK,      0.708156389709290_REALK,      0.000000000000000_REALK, &
      0.188480017528502_REALK,      0.000000000000000_REALK,      0.162033991683352_REALK, &
      9.432795583767088_REALK,      0.825170705999673_REALK,      0.000000000000000_REALK, &
      0.635461664744910_REALK,      0.000000000000000_REALK,      0.900145326126600_REALK, &
      0.143806317635740_REALK,      0.000000000000000_REALK,      0.090231539293154_REALK, &
      0.000000000000000_REALK,      0.150646643131715_REALK,      0.000000000000000_REALK, &
      0.084459364013833_REALK,      0.000000000000000_REALK,      0.358915600967978_REALK, &
      3.849761854783698_REALK,      0.289968322904153_REALK,      0.000000000000000_REALK, &
     -0.021952040181656_REALK,      0.000000000000000_REALK,      0.601529074193756_REALK, &
     -0.788069748286838_REALK,      0.000000000000000_REALK,      0.038748017663082_REALK, &
      0.000000000000000_REALK,     -1.918775762796830_REALK,      0.000000000000000_REALK, &
     -0.002995827799539_REALK,      0.000000000000000_REALK,      0.246274720862617_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.750569938422225_REALK, &
      0.000000000000000_REALK,     -0.109656531482900_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.069156651033882_REALK,      0.000000000000000_REALK, &
     -0.246222074045726_REALK,      0.000000000000000_REALK,     -0.028630280643041_REALK, &
      0.000000000000000_REALK,     -0.043723428600810_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.538823736240440_REALK, &
      0.000000000000000_REALK,     -0.120046820968177_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.118730676866441_REALK,      0.000000000000000_REALK, &
     -0.216006542783990_REALK,      0.000000000000000_REALK,     -0.165379091769741_REALK, &
      0.000000000000000_REALK,     -0.049148908328344_REALK,      0.000000000000000_REALK, &
      0.695395037837666_REALK,      0.131515932766035_REALK,      0.000000000000000_REALK, &
      0.067282387082848_REALK,      0.000000000000000_REALK,      0.199078816315626_REALK, &
      0.028639784554551_REALK,      0.000000000000000_REALK,      0.043143382219360_REALK, &
      0.000000000000000_REALK,      0.018203436865008_REALK,      0.000000000000000_REALK, &
      0.026827555166358_REALK,      0.000000000000000_REALK,      0.132298068848843_REALK, &
      0.393296816366504_REALK,      0.064451362055582_REALK,      0.000000000000000_REALK, &
     -0.033735572703289_REALK,      0.000000000000000_REALK,      0.184359042524921_REALK, &
     -0.162985359378427_REALK,      0.000000000000000_REALK,      0.025837606918514_REALK, &
      0.000000000000000_REALK,     -0.388287739591202_REALK,      0.000000000000000_REALK, &
     -0.013811832390278_REALK,      0.000000000000000_REALK,      0.125798773171463_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.183737858558399_REALK, &
      0.000000000000000_REALK,     -0.048118441911215_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.026797835817262_REALK,      0.000000000000000_REALK, &
     -0.100457697320139_REALK,      0.000000000000000_REALK,     -0.016994082880613_REALK, &
      0.000000000000000_REALK,     -0.031977168935826_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.202957128283462_REALK, &
      0.000000000000000_REALK,     -0.087434795924846_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.088860286850370_REALK,      0.000000000000000_REALK, &
     -0.135604232779859_REALK,      0.000000000000000_REALK,     -0.135342542034281_REALK, &
      0.000000000000000_REALK,     -0.059661787722488_REALK,      0.000000000000000_REALK, &
      0.189430686183731_REALK,      0.056548773873932_REALK,      0.000000000000000_REALK, &
      0.027961153047613_REALK,      0.000000000000000_REALK,      0.090384205445244_REALK, &
      0.013844317672804_REALK,      0.000000000000000_REALK,      0.030917741472680_REALK, &
      0.000000000000000_REALK,      0.005645084035773_REALK,      0.000000000000000_REALK, &
      0.018581618172379_REALK,      0.000000000000000_REALK,      0.084090906700183_REALK, &
      0.139895843366966_REALK,      0.011628078477441_REALK,      0.000000000000000_REALK, &
     -0.071862836911095_REALK,      0.000000000000000_REALK,      0.109294315230849_REALK, &
     -0.183130719425567_REALK,      0.000000000000000_REALK,      0.007769210542017_REALK, &
      0.000000000000000_REALK,     -0.385803204252066_REALK,      0.000000000000000_REALK, &
     -0.049036144884592_REALK,      0.000000000000000_REALK,      0.104408912171023_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.097593463636791_REALK, &
      0.000000000000000_REALK,     -0.040916098265478_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.028554711007679_REALK,      0.000000000000000_REALK, &
     -0.074702190339645_REALK,      0.000000000000000_REALK,     -0.028112981303758_REALK, &
      0.000000000000000_REALK,     -0.038067179822277_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.226035605213265_REALK, &
      0.000000000000000_REALK,     -0.193405497714009_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.245942175142314_REALK,      0.000000000000000_REALK, &
     -0.211433513664487_REALK,      0.000000000000000_REALK,     -0.385401557780068_REALK, &
      0.000000000000000_REALK,     -0.184760365455085_REALK,      0.000000000000000_REALK, &
      9.143184070509873_REALK,     -0.036848040440962_REALK,      0.000000000000000_REALK, &
      3.298557754275748_REALK,      0.000000000000000_REALK,      4.128729224499416_REALK, &
      0.048693125035339_REALK,      0.000000000000000_REALK,      0.019868703707862_REALK, &
      0.000000000000000_REALK,     13.386226420351745_REALK,      0.000000000000000_REALK, &
      4.411071622360041_REALK,      0.000000000000000_REALK,     16.563712090525502_REALK, &
      3.777411411706986_REALK,     -0.076305444227413_REALK,      0.000000000000000_REALK, &
      2.856210424567605_REALK,      0.000000000000000_REALK,      1.734083380938721_REALK, &
     -0.018697545181803_REALK,      0.000000000000000_REALK,     -0.002123442566062_REALK, &
      0.000000000000000_REALK,     43.439321304608754_REALK,      0.000000000000000_REALK, &
      4.447673199561774_REALK,      0.000000000000000_REALK,      8.100911732062825_REALK, &
      7.747149736611206_REALK,     -0.022677835949006_REALK,      0.000000000000000_REALK, &
      2.307155524118628_REALK,      0.000000000000000_REALK,      3.357238446682681_REALK, &
     -0.146525480788287_REALK,      0.000000000000000_REALK,     -0.011495992495695_REALK, &
      0.000000000000000_REALK,      5.222194856957159_REALK,      0.000000000000000_REALK, &
      2.878194157631499_REALK,      0.000000000000000_REALK,     12.564541898460810_REALK, &
      1.785650631442194_REALK,     -0.070854051794765_REALK,      0.000000000000000_REALK, &
      0.125498570486625_REALK,      0.000000000000000_REALK,      1.224274819687144_REALK, &
     -0.781945094000639_REALK,      0.000000000000000_REALK,     -0.060088089556590_REALK, &
      0.000000000000000_REALK,    -13.285437663556795_REALK,      0.000000000000000_REALK, &
      0.186709355626000_REALK,      0.000000000000000_REALK,      5.464211149336211_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.500439432826910_REALK, &
      0.000000000000000_REALK,     -0.227044891172154_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.202676817721760_REALK,      0.000000000000000_REALK, &
     -0.761057798098283_REALK,      0.000000000000000_REALK,     -0.694149579006133_REALK, &
      0.000000000000000_REALK,     -0.849720713398479_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.188275268466008_REALK, &
      0.000000000000000_REALK,     -0.264173449644681_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.262988770777206_REALK,      0.000000000000000_REALK, &
     -0.479003002918416_REALK,      0.000000000000000_REALK,     -3.460672811759610_REALK, &
      0.000000000000000_REALK,     -1.179064933538331_REALK,      0.000000000000000_REALK, &
      8.683297262294319_REALK,     -0.680998130308470_REALK,      0.000000000000000_REALK, &
      2.450883420695674_REALK,      0.000000000000000_REALK,      3.329746569408579_REALK, &
     -0.745062068674789_REALK,      0.000000000000000_REALK,     -0.294100408428299_REALK, &
      0.000000000000000_REALK,      6.173757277449480_REALK,      0.000000000000000_REALK, &
      2.625402742685291_REALK,      0.000000000000000_REALK,     10.700540509541080_REALK, &
      4.031540892549486_REALK,     -0.296651417410394_REALK,      0.000000000000000_REALK, &
      1.268550360861187_REALK,      0.000000000000000_REALK,      1.444848378389072_REALK, &
      0.333052402302808_REALK,      0.000000000000000_REALK,     -0.139198121574731_REALK, &
      0.000000000000000_REALK,     10.151138643827872_REALK,      0.000000000000000_REALK, &
      1.497085564092833_REALK,      0.000000000000000_REALK,      5.115433449849251_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.925773928303284_REALK, &
      0.000000000000000_REALK,      0.013485912715449_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.274757361496003_REALK,      0.000000000000000_REALK, &
     -1.199432766296744_REALK,      0.000000000000000_REALK,      0.184128200400637_REALK, &
      0.000000000000000_REALK,      0.043338600194257_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.529691617456520_REALK, &
      0.000000000000000_REALK,      0.086783217842153_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.025478268424616_REALK,      0.000000000000000_REALK, &
     -0.745643612366356_REALK,      0.000000000000000_REALK,      1.332792443301055_REALK, &
      0.000000000000000_REALK,      0.307252845402549_REALK,      0.000000000000000_REALK, &
      0.776075095626092_REALK,      0.062608672020103_REALK,      0.000000000000000_REALK, &
      0.237759538749184_REALK,      0.000000000000000_REALK,      0.892794514297774_REALK, &
      0.066264711956831_REALK,      0.000000000000000_REALK,      0.081115799850692_REALK, &
      0.000000000000000_REALK,      0.772903523730386_REALK,      0.000000000000000_REALK, &
      0.764068833132647_REALK,      0.000000000000000_REALK,      4.781837329958432_REALK, &
      0.643447516288259_REALK,      0.114296610190119_REALK,      0.000000000000000_REALK, &
      0.379825884843682_REALK,      0.000000000000000_REALK,      0.691808014800750_REALK, &
      0.472241739210964_REALK,      0.000000000000000_REALK,      0.160894630941343_REALK, &
      0.000000000000000_REALK,      4.377978552893460_REALK,      0.000000000000000_REALK, &
      1.344759813908137_REALK,      0.000000000000000_REALK,      4.082202110520922_REALK, &
     12.219773658485561_REALK,     -2.157308846366753_REALK,      0.000000000000000_REALK, &
      3.314446321384632_REALK,      0.000000000000000_REALK,      3.944291295485328_REALK, &
     -1.982231920551172_REALK,      0.000000000000000_REALK,     -0.811644896204028_REALK, &
      0.000000000000000_REALK,      7.372147999418220_REALK,      0.000000000000000_REALK, &
      2.845357733938610_REALK,      0.000000000000000_REALK,     10.158185097257027_REALK, &
      3.295767874339293_REALK,     -1.079042664330901_REALK,      0.000000000000000_REALK, &
      1.203091329874456_REALK,      0.000000000000000_REALK,      1.839617169583094_REALK, &
     -1.830822393896037_REALK,      0.000000000000000_REALK,     -0.547791118021060_REALK, &
      0.000000000000000_REALK,     -1.705493198946906_REALK,      0.000000000000000_REALK, &
      1.138955291311165_REALK,      0.000000000000000_REALK,      5.224645022175103_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.468879521623443_REALK, &
      0.000000000000000_REALK,      0.228800066739394_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.406772315566097_REALK,      0.000000000000000_REALK, &
     -1.657910830253371_REALK,      0.000000000000000_REALK,      0.497598267117497_REALK, &
      0.000000000000000_REALK,      0.589255015435553_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.768336215815453_REALK, &
      0.000000000000000_REALK,      0.125987519894336_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.342462570604318_REALK,      0.000000000000000_REALK, &
     -1.170169916141184_REALK,      0.000000000000000_REALK,     -0.285374262536875_REALK, &
      0.000000000000000_REALK,      0.357813614460504_REALK,      0.000000000000000_REALK, &
      0.963627873706561_REALK,     -0.005949155770628_REALK,      0.000000000000000_REALK, &
      0.213751837283666_REALK,      0.000000000000000_REALK,      0.933117701007943_REALK, &
     -0.028528291381831_REALK,      0.000000000000000_REALK,     -0.006714757499027_REALK, &
      0.000000000000000_REALK,      0.332942110341649_REALK,      0.000000000000000_REALK, &
      0.550499586704351_REALK,      0.000000000000000_REALK,      4.005274802774296_REALK, &
      0.403026275395887_REALK,     -0.046149263957697_REALK,      0.000000000000000_REALK, &
      0.023060252636356_REALK,      0.000000000000000_REALK,      0.674878284163169_REALK, &
     -0.304880053059269_REALK,      0.000000000000000_REALK,     -0.070284960182492_REALK, &
      0.000000000000000_REALK,     -1.553395083570803_REALK,      0.000000000000000_REALK, &
      0.065492775420193_REALK,      0.000000000000000_REALK,      3.194504746447019_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.393846063576748_REALK, &
      0.000000000000000_REALK,     -0.063105320113768_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.118382617436958_REALK,      0.000000000000000_REALK, &
     -0.740884060088284_REALK,      0.000000000000000_REALK,     -0.132766948796927_REALK, &
      0.000000000000000_REALK,     -0.270870596817163_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.367887150038157_REALK, &
      0.000000000000000_REALK,     -0.145624921423465_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.307617623041757_REALK,      0.000000000000000_REALK, &
     -0.933815315587852_REALK,      0.000000000000000_REALK,     -1.213913820780062_REALK, &
      0.000000000000000_REALK,     -0.689308744413179_REALK,      0.000000000000000_REALK, &
     20.906198390919386_REALK,     -5.395464519285986_REALK,      0.000000000000000_REALK, &
      5.545799576332011_REALK,      0.000000000000000_REALK,      5.506190762769324_REALK, &
     -4.307397382727754_REALK,      0.000000000000000_REALK,     -1.724041885750122_REALK, &
      0.000000000000000_REALK,     10.821773997782548_REALK,      0.000000000000000_REALK, &
      3.622603443816272_REALK,      0.000000000000000_REALK,     10.790191032855679_REALK, &
     15.901930767733974_REALK,     -4.106155123602535_REALK,      0.000000000000000_REALK, &
      3.850430715919522_REALK,      0.000000000000000_REALK,      3.600965483023340_REALK, &
     -2.217213988902071_REALK,      0.000000000000000_REALK,     -1.282238103461874_REALK, &
      0.000000000000000_REALK,     10.438638678969093_REALK,      0.000000000000000_REALK, &
      2.345186406333011_REALK,      0.000000000000000_REALK,      6.579732962506235_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.426240272431503_REALK, &
      0.000000000000000_REALK,      0.573600951848357_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.651470549609939_REALK,      0.000000000000000_REALK, &
     -2.325808930601169_REALK,      0.000000000000000_REALK,      0.915071210738888_REALK, &
      0.000000000000000_REALK,      1.124055470239239_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.092630231007191_REALK, &
      0.000000000000000_REALK,      0.556295936159346_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.427363043859765_REALK,      0.000000000000000_REALK, &
     -1.960410752552983_REALK,      0.000000000000000_REALK,      1.132413849073831_REALK, &
      0.000000000000000_REALK,      1.016471478361069_REALK,      0.000000000000000_REALK, &
      1.482885194062922_REALK,     -0.140741110296172_REALK,      0.000000000000000_REALK, &
      0.287471760723819_REALK,      0.000000000000000_REALK,      1.171669081836966_REALK, &
     -0.113929652042474_REALK,      0.000000000000000_REALK,     -0.134915298764502_REALK, &
      0.000000000000000_REALK,      0.441575969253326_REALK,      0.000000000000000_REALK, &
      0.563343216463737_REALK,      0.000000000000000_REALK,      3.826763293962155_REALK, &
      1.749240302390975_REALK,     -0.143315303433625_REALK,      0.000000000000000_REALK, &
      0.347779527718705_REALK,      0.000000000000000_REALK,      1.188337575309570_REALK, &
      0.107079193017837_REALK,      0.000000000000000_REALK,     -0.134260156282577_REALK, &
      0.000000000000000_REALK,      1.436283611823142_REALK,      0.000000000000000_REALK, &
      0.635467469211723_REALK,      0.000000000000000_REALK,      3.618910887330691_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.573985939551556_REALK, &
      0.000000000000000_REALK,      0.004745414294953_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.126041890632113_REALK,      0.000000000000000_REALK, &
     -0.917044119261001_REALK,      0.000000000000000_REALK,      0.039509127864048_REALK, &
      0.000000000000000_REALK,      0.015498895993825_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.767698151028981_REALK, &
      0.000000000000000_REALK,      0.071376180511818_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.024574442972363_REALK,      0.000000000000000_REALK, &
     -1.198653961644476_REALK,      0.000000000000000_REALK,      0.565730016535322_REALK, &
      0.000000000000000_REALK,      0.217365874913960_REALK,      0.000000000000000_REALK, &
      0.397601360642866_REALK,      0.038817789456868_REALK,      0.000000000000000_REALK, &
      0.083662673617145_REALK,      0.000000000000000_REALK,      0.523593266049550_REALK, &
      0.030398201277504_REALK,      0.000000000000000_REALK,      0.062018288413030_REALK, &
      0.000000000000000_REALK,      0.165845014936295_REALK,      0.000000000000000_REALK, &
      0.273248866455430_REALK,      0.000000000000000_REALK,      2.394135453058046_REALK, &
      0.837553946218082_REALK,      0.165653549008706_REALK,      0.000000000000000_REALK, &
      0.312393589380082_REALK,      0.000000000000000_REALK,      0.948313413809146_REALK, &
      0.455489262300001_REALK,      0.000000000000000_REALK,      0.258644992844665_REALK, &
      0.000000000000000_REALK,      1.858319269116868_REALK,      0.000000000000000_REALK, &
      0.951349671363698_REALK,      0.000000000000000_REALK,      4.043132635706048_REALK, &
     42.446708937556231_REALK,    -13.387019767814650_REALK,      0.000000000000000_REALK, &
     11.004155031077776_REALK,      0.000000000000000_REALK,      9.011800760515261_REALK, &
     -9.363297815847758_REALK,      0.000000000000000_REALK,     -3.516609138187972_REALK, &
      0.000000000000000_REALK,     17.586503501150958_REALK,      0.000000000000000_REALK, &
      5.264137021503776_REALK,      0.000000000000000_REALK,     12.933120411299202_REALK, &
     18.424358565972668_REALK,     -9.641778061011568_REALK,      0.000000000000000_REALK, &
      8.120636295038247_REALK,      0.000000000000000_REALK,      6.804510921713805_REALK, &
     -9.122117929965661_REALK,      0.000000000000000_REALK,     -3.262638453573626_REALK, &
      0.000000000000000_REALK,      8.821102758483642_REALK,      0.000000000000000_REALK, &
      3.857302154195036_REALK,      0.000000000000000_REALK,      9.696427847387056_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.463338848904796_REALK, &
      0.000000000000000_REALK,      1.292570479972265_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.180899588674490_REALK,      0.000000000000000_REALK, &
     -3.517396355974060_REALK,      0.000000000000000_REALK,      1.544869663326354_REALK, &
      0.000000000000000_REALK,      1.855008793671588_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.533929403198772_REALK, &
      0.000000000000000_REALK,      1.280088125504411_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.278674617195122_REALK,      0.000000000000000_REALK, &
     -3.587492023814892_REALK,      0.000000000000000_REALK,      1.051410719503716_REALK, &
      0.000000000000000_REALK,      1.824125538198750_REALK,      0.000000000000000_REALK, &
      2.737736469441647_REALK,     -0.464963079278769_REALK,      0.000000000000000_REALK, &
      0.488428737118955_REALK,      0.000000000000000_REALK,      1.743734877092572_REALK, &
     -0.298295751419880_REALK,      0.000000000000000_REALK,     -0.366420631747224_REALK, &
      0.000000000000000_REALK,      0.605381105637662_REALK,      0.000000000000000_REALK, &
      0.700959534877364_REALK,      0.000000000000000_REALK,      4.170815158577106_REALK, &
      1.766413898993951_REALK,     -0.545939852781632_REALK,      0.000000000000000_REALK, &
      0.426646467802907_REALK,      0.000000000000000_REALK,      1.957123656424594_REALK, &
     -0.617430171461315_REALK,      0.000000000000000_REALK,     -0.554214485881913_REALK, &
      0.000000000000000_REALK,     -0.303462526845348_REALK,      0.000000000000000_REALK, &
      0.607971203072371_REALK,      0.000000000000000_REALK,      4.648168580438250_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.949759344769478_REALK, &
      0.000000000000000_REALK,      0.101150403549365_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.183639137687059_REALK,      0.000000000000000_REALK, &
     -1.247451803621632_REALK,      0.000000000000000_REALK,      0.122584322426007_REALK, &
      0.000000000000000_REALK,      0.241940241009177_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.166215315895380_REALK, &
      0.000000000000000_REALK,      0.134035037113373_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.346478267458826_REALK,      0.000000000000000_REALK, &
     -1.973152104679116_REALK,      0.000000000000000_REALK,     -0.152331996737732_REALK, &
      0.000000000000000_REALK,      0.318333206051184_REALK,      0.000000000000000_REALK, &
      0.647677914472251_REALK,     -0.003846650595549_REALK,      0.000000000000000_REALK, &
      0.094497719816173_REALK,      0.000000000000000_REALK,      0.687537911454627_REALK, &
     -0.012879221688806_REALK,      0.000000000000000_REALK,     -0.005052344312005_REALK, &
      0.000000000000000_REALK,      0.082020950835986_REALK,      0.000000000000000_REALK, &
      0.226027779473809_REALK,      0.000000000000000_REALK,      2.302317292157272_REALK, &
      0.648023078380582_REALK,     -0.070047431497999_REALK,      0.000000000000000_REALK, &
      0.024533238058421_REALK,      0.000000000000000_REALK,      1.196644132433190_REALK, &
     -0.308455059425402_REALK,      0.000000000000000_REALK,     -0.118515196125277_REALK, &
      0.000000000000000_REALK,     -0.829198024724949_REALK,      0.000000000000000_REALK, &
      0.058266439090460_REALK,      0.000000000000000_REALK,      3.978841651684090_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.424426661928532_REALK, &
      0.000000000000000_REALK,     -0.046497135297968_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.089073915764585_REALK,      0.000000000000000_REALK, &
     -0.780442467853693_REALK,      0.000000000000000_REALK,     -0.054512336337500_REALK, &
      0.000000000000000_REALK,     -0.155702190161122_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.930659477939301_REALK, &
      0.000000000000000_REALK,     -0.258211312834749_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.518707883332727_REALK,      0.000000000000000_REALK, &
     -2.204452090149303_REALK,      0.000000000000000_REALK,     -1.079973100021364_REALK, &
      0.000000000000000_REALK,     -0.858552596045331_REALK,      0.000000000000000_REALK/
    ! results of test 2, ket-major order, CM000300
  data REF_CONTR_INTS(5041:6300)                                                           &
     /1.234674085579904_REALK,      0.425169732518382_REALK,      0.000000000000000_REALK, &
      0.233071431813933_REALK,      0.000000000000000_REALK,      0.214916835407371_REALK, &
      0.036540949724682_REALK,      0.000000000000000_REALK,      0.089900560151597_REALK, &
      0.000000000000000_REALK,     -0.375408218154059_REALK,      0.000000000000000_REALK, &
      0.069832747075421_REALK,      0.000000000000000_REALK,      0.193179827649158_REALK, &
      0.169984505316538_REALK,     -0.229740533453385_REALK,      0.000000000000000_REALK, &
     -0.804020853706996_REALK,      0.000000000000000_REALK,      0.045994731891853_REALK, &
     -2.178112089545260_REALK,      0.000000000000000_REALK,     -0.056502206087517_REALK, &
      0.000000000000000_REALK,     -6.663666476749802_REALK,      0.000000000000000_REALK, &
     -0.242747529003749_REALK,      0.000000000000000_REALK,      0.041659768384588_REALK, &
      1.589615616383101_REALK,      0.453239927050510_REALK,      0.000000000000000_REALK, &
      0.303654094186749_REALK,      0.000000000000000_REALK,      0.241313034853049_REALK, &
      0.235479472258495_REALK,      0.000000000000000_REALK,      0.082604720934663_REALK, &
      0.000000000000000_REALK,      0.351384621726146_REALK,      0.000000000000000_REALK, &
      0.074902091546420_REALK,      0.000000000000000_REALK,      0.178573429839462_REALK, &
      1.114228153426078_REALK,      0.513566913886506_REALK,      0.000000000000000_REALK, &
      0.687120919857660_REALK,      0.000000000000000_REALK,      0.136422852128774_REALK, &
      1.359848045001461_REALK,      0.000000000000000_REALK,      0.084386700025048_REALK, &
      0.000000000000000_REALK,      3.623458861221109_REALK,      0.000000000000000_REALK, &
      0.154170152273539_REALK,      0.000000000000000_REALK,      0.091828081252310_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.176665014540850_REALK, &
      0.000000000000000_REALK,     -0.061881859105821_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.034917719182668_REALK,      0.000000000000000_REALK, &
     -0.096593636311120_REALK,      0.000000000000000_REALK,     -0.006204340004131_REALK, &
      0.000000000000000_REALK,     -0.045793033236262_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.059389200849049_REALK, &
      0.000000000000000_REALK,      0.054825938695295_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.170586111607903_REALK,      0.000000000000000_REALK, &
     -0.029275593157955_REALK,      0.000000000000000_REALK,      0.474207072655458_REALK, &
      0.000000000000000_REALK,      0.036904086629808_REALK,      0.000000000000000_REALK, &
      2.258749534049874_REALK,      0.448370860961806_REALK,      0.000000000000000_REALK, &
      0.270639732782426_REALK,      0.000000000000000_REALK,      0.297989213101198_REALK, &
      0.116909688249325_REALK,      0.000000000000000_REALK,      0.069919055978437_REALK, &
      0.000000000000000_REALK,      0.066554578083629_REALK,      0.000000000000000_REALK, &
      0.054824806398042_REALK,      0.000000000000000_REALK,      0.181095370761159_REALK, &
      0.626524005431690_REALK,      0.018661924751746_REALK,      0.000000000000000_REALK, &
     -0.276626200744991_REALK,      0.000000000000000_REALK,      0.128750668792462_REALK, &
     -0.880450665942439_REALK,      0.000000000000000_REALK,      0.003405950111635_REALK, &
      0.000000000000000_REALK,     -2.441434235082284_REALK,      0.000000000000000_REALK, &
     -0.056249416197819_REALK,      0.000000000000000_REALK,      0.078540824424628_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.228167823758023_REALK, &
      0.000000000000000_REALK,     -0.065521504162959_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.044772457729208_REALK,      0.000000000000000_REALK, &
     -0.106741629959585_REALK,      0.000000000000000_REALK,     -0.037837078421179_REALK, &
      0.000000000000000_REALK,     -0.039819028902869_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.137715629730882_REALK, &
      0.000000000000000_REALK,     -0.083509904440119_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.126593418331009_REALK,      0.000000000000000_REALK, &
     -0.075402602469263_REALK,      0.000000000000000_REALK,     -0.273639678356844_REALK, &
      0.000000000000000_REALK,     -0.050942933375526_REALK,      0.000000000000000_REALK, &
      0.193585927685437_REALK,      0.058510925988205_REALK,      0.000000000000000_REALK, &
      0.027696497935001_REALK,      0.000000000000000_REALK,      0.076617416923184_REALK, &
      0.003708622080338_REALK,      0.000000000000000_REALK,      0.027372622079479_REALK, &
      0.000000000000000_REALK,     -0.030161647375495_REALK,      0.000000000000000_REALK, &
      0.016831842703720_REALK,      0.000000000000000_REALK,      0.077603813127257_REALK, &
      0.046993376809062_REALK,     -0.055345483217740_REALK,      0.000000000000000_REALK, &
     -0.168813685983206_REALK,      0.000000000000000_REALK,      0.028971413579663_REALK, &
     -0.389384672966292_REALK,      0.000000000000000_REALK,     -0.030302976341114_REALK, &
      0.000000000000000_REALK,     -0.942303478203963_REALK,      0.000000000000000_REALK, &
     -0.102980172418782_REALK,      0.000000000000000_REALK,      0.029455364240495_REALK, &
      3.775958182959544_REALK,      0.496734160876121_REALK,      0.000000000000000_REALK, &
      0.334545430616491_REALK,      0.000000000000000_REALK,      0.423485506558843_REALK, &
      0.127145579535376_REALK,      0.000000000000000_REALK,      0.065152305037879_REALK, &
      0.000000000000000_REALK,      0.143982130510790_REALK,      0.000000000000000_REALK, &
      0.055151206531291_REALK,      0.000000000000000_REALK,      0.209440044590019_REALK, &
      3.461538074365152_REALK,      0.645352034179745_REALK,      0.000000000000000_REALK, &
      0.696547894062825_REALK,      0.000000000000000_REALK,      0.305079683259398_REALK, &
      1.068066701523355_REALK,      0.000000000000000_REALK,      0.071355904392799_REALK, &
      0.000000000000000_REALK,      2.394275317027182_REALK,      0.000000000000000_REALK, &
      0.097773330494103_REALK,      0.000000000000000_REALK,      0.128470663478887_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.333612688150517_REALK, &
      0.000000000000000_REALK,     -0.065552663876167_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.039741049291934_REALK,      0.000000000000000_REALK, &
     -0.131271235208907_REALK,      0.000000000000000_REALK,     -0.018069461361880_REALK, &
      0.000000000000000_REALK,     -0.032419888361188_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.272076927688531_REALK, &
      0.000000000000000_REALK,     -0.005274028555675_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.064635150578627_REALK,      0.000000000000000_REALK, &
     -0.090249790244972_REALK,      0.000000000000000_REALK,      0.191372110442395_REALK, &
      0.000000000000000_REALK,     -0.002220921237741_REALK,      0.000000000000000_REALK, &
      0.297437682718019_REALK,      0.073354350340348_REALK,      0.000000000000000_REALK, &
      0.041976451646284_REALK,      0.000000000000000_REALK,      0.100075695994707_REALK, &
      0.027427095458973_REALK,      0.000000000000000_REALK,      0.028863758841150_REALK, &
      0.000000000000000_REALK,      0.032463433054760_REALK,      0.000000000000000_REALK, &
      0.020759978248056_REALK,      0.000000000000000_REALK,      0.082489474873352_REALK, &
      0.441595970007696_REALK,      0.176473788017795_REALK,      0.000000000000000_REALK, &
      0.196026741835587_REALK,      0.000000000000000_REALK,      0.116759043896938_REALK, &
      0.314434229018138_REALK,      0.000000000000000_REALK,      0.058537570560097_REALK, &
      0.000000000000000_REALK,      0.646707325826133_REALK,      0.000000000000000_REALK, &
      0.082547894747254_REALK,      0.000000000000000_REALK,      0.081946415202866_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.085776737194215_REALK, &
      0.000000000000000_REALK,     -0.025663222557508_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.012200956729443_REALK,      0.000000000000000_REALK, &
     -0.056252947622674_REALK,      0.000000000000000_REALK,     -0.001719604364445_REALK, &
      0.000000000000000_REALK,     -0.021153445212499_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.061222619435512_REALK, &
      0.000000000000000_REALK,      0.046923400903335_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.118332587266194_REALK,      0.000000000000000_REALK, &
     -0.033846607337882_REALK,      0.000000000000000_REALK,      0.253906446511857_REALK, &
      0.000000000000000_REALK,      0.032932819290207_REALK,      0.000000000000000_REALK, &
      7.316413023849051_REALK,      0.533648399120372_REALK,      0.000000000000000_REALK, &
      0.465287116896020_REALK,      0.000000000000000_REALK,      0.698184851876052_REALK, &
      0.081185460752582_REALK,      0.000000000000000_REALK,      0.058353885012949_REALK, &
      0.000000000000000_REALK,      0.095277164286916_REALK,      0.000000000000000_REALK, &
      0.061841423577680_REALK,      0.000000000000000_REALK,      0.278387754093152_REALK, &
      2.926150049902525_REALK,      0.054271846402249_REALK,      0.000000000000000_REALK, &
     -0.259926048516398_REALK,      0.000000000000000_REALK,      0.457213821754379_REALK, &
     -1.106005966292377_REALK,      0.000000000000000_REALK,      0.007252262736635_REALK, &
      0.000000000000000_REALK,     -2.569167080889426_REALK,      0.000000000000000_REALK, &
     -0.035472497113071_REALK,      0.000000000000000_REALK,      0.187189964970539_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.574152674448663_REALK, &
      0.000000000000000_REALK,     -0.074268729769490_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.049597353967218_REALK,      0.000000000000000_REALK, &
     -0.188348953355130_REALK,      0.000000000000000_REALK,     -0.019263532376967_REALK, &
      0.000000000000000_REALK,     -0.029613224670119_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.418168655209161_REALK, &
      0.000000000000000_REALK,     -0.102784562534627_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.127581617870933_REALK,      0.000000000000000_REALK, &
     -0.167637688240324_REALK,      0.000000000000000_REALK,     -0.209960844010862_REALK, &
      0.000000000000000_REALK,     -0.042081489545837_REALK,      0.000000000000000_REALK, &
      0.522699783407810_REALK,      0.088874912361389_REALK,      0.000000000000000_REALK, &
      0.045301808568440_REALK,      0.000000000000000_REALK,      0.149639339522512_REALK, &
      0.016249825298993_REALK,      0.000000000000000_REALK,      0.029155131496811_REALK, &
      0.000000000000000_REALK,      0.007309283705452_REALK,      0.000000000000000_REALK, &
      0.018063223098923_REALK,      0.000000000000000_REALK,      0.099443004579944_REALK, &
      0.277332115878167_REALK,      0.007229040639806_REALK,      0.000000000000000_REALK, &
     -0.093103657407421_REALK,      0.000000000000000_REALK,      0.130000247184975_REALK, &
     -0.249715984330595_REALK,      0.000000000000000_REALK,      0.002898016496350_REALK, &
      0.000000000000000_REALK,     -0.551487546892777_REALK,      0.000000000000000_REALK, &
     -0.038117986682579_REALK,      0.000000000000000_REALK,      0.088706642125493_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.135680507627216_REALK, &
      0.000000000000000_REALK,     -0.032902515179759_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.018669400984662_REALK,      0.000000000000000_REALK, &
     -0.074182596196556_REALK,      0.000000000000000_REALK,     -0.012466247194219_REALK, &
      0.000000000000000_REALK,     -0.021865406370764_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.160040065101208_REALK, &
      0.000000000000000_REALK,     -0.084320402537938_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.107714382955681_REALK,      0.000000000000000_REALK, &
     -0.106929529529890_REALK,      0.000000000000000_REALK,     -0.185434699957574_REALK, &
      0.000000000000000_REALK,     -0.057536658073946_REALK,      0.000000000000000_REALK, &
      0.134393815179523_REALK,      0.034793653237616_REALK,      0.000000000000000_REALK, &
      0.013908173436710_REALK,      0.000000000000000_REALK,      0.064124131345724_REALK, &
      0.001546436274220_REALK,      0.000000000000000_REALK,      0.019023244926387_REALK, &
      0.000000000000000_REALK,     -0.009937409748775_REALK,      0.000000000000000_REALK, &
      0.009242693526840_REALK,      0.000000000000000_REALK,      0.059659276968366_REALK, &
      0.062405139354894_REALK,     -0.064317280141215_REALK,      0.000000000000000_REALK, &
     -0.170452092496690_REALK,      0.000000000000000_REALK,      0.048754321847774_REALK, &
     -0.331315247932522_REALK,      0.000000000000000_REALK,     -0.042973092405286_REALK, &
      0.000000000000000_REALK,     -0.638561497363930_REALK,      0.000000000000000_REALK, &
     -0.116309261682642_REALK,      0.000000000000000_REALK,      0.046575027228180_REALK, &
     20.457951024715527_REALK,      0.485524138186440_REALK,      0.000000000000000_REALK, &
      0.926180647914053_REALK,      0.000000000000000_REALK,      1.488552762524031_REALK, &
      0.045368372376199_REALK,      0.000000000000000_REALK,      0.040647897297172_REALK, &
      0.000000000000000_REALK,      0.183487946583758_REALK,      0.000000000000000_REALK, &
      0.093133736047534_REALK,      0.000000000000000_REALK,      0.449052181310334_REALK, &
     41.920865562491691_REALK,      2.010394816637743_REALK,      0.000000000000000_REALK, &
      3.180908371893899_REALK,      0.000000000000000_REALK,      2.463647764877023_REALK, &
      3.085120660975134_REALK,      0.000000000000000_REALK,      0.132544840542125_REALK, &
      0.000000000000000_REALK,      5.606181795645064_REALK,      0.000000000000000_REALK, &
      0.241569788768243_REALK,      0.000000000000000_REALK,      0.561295203048887_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.341598989876708_REALK, &
      0.000000000000000_REALK,     -0.090815754379966_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.074851513627002_REALK,      0.000000000000000_REALK, &
     -0.336954480727941_REALK,      0.000000000000000_REALK,     -0.012705185256352_REALK, &
      0.000000000000000_REALK,     -0.027396417264053_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.763577586296209_REALK, &
      0.000000000000000_REALK,     -0.030154002382272_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.103581831690657_REALK,      0.000000000000000_REALK, &
     -0.546605991226189_REALK,      0.000000000000000_REALK,      0.349237093781852_REALK, &
      0.000000000000000_REALK,     -0.006870014914952_REALK,      0.000000000000000_REALK, &
      1.342861669683392_REALK,      0.142711278496577_REALK,      0.000000000000000_REALK, &
      0.077188024666801_REALK,      0.000000000000000_REALK,      0.293126195142405_REALK, &
      0.023316160476279_REALK,      0.000000000000000_REALK,      0.035843202851736_REALK, &
      0.000000000000000_REALK,      0.020263517100890_REALK,      0.000000000000000_REALK, &
      0.023285335743753_REALK,      0.000000000000000_REALK,      0.147379119551331_REALK, &
      3.953424683435445_REALK,      0.621269742345091_REALK,      0.000000000000000_REALK, &
      0.530468427430290_REALK,      0.000000000000000_REALK,      0.697016563537039_REALK, &
      0.613098331832623_REALK,      0.000000000000000_REALK,      0.122880488326909_REALK, &
      0.000000000000000_REALK,      0.986517242426991_REALK,      0.000000000000000_REALK, &
      0.120857124110991_REALK,      0.000000000000000_REALK,      0.264669906101944_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.287539877454775_REALK, &
      0.000000000000000_REALK,     -0.045373932863981_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.021863332241023_REALK,      0.000000000000000_REALK, &
     -0.120363649182102_REALK,      0.000000000000000_REALK,     -0.007629089207349_REALK, &
      0.000000000000000_REALK,     -0.022813281060828_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.785771891048312_REALK, &
      0.000000000000000_REALK,     -0.012049590522052_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.111306820840833_REALK,      0.000000000000000_REALK, &
     -0.259028746840053_REALK,      0.000000000000000_REALK,      0.236554107201183_REALK, &
      0.000000000000000_REALK,     -0.004575449363577_REALK,      0.000000000000000_REALK, &
      0.317337462880815_REALK,      0.063223917005585_REALK,      0.000000000000000_REALK, &
      0.029055061781541_REALK,      0.000000000000000_REALK,      0.115449869943702_REALK, &
      0.015088874378249_REALK,      0.000000000000000_REALK,      0.026465412149921_REALK, &
      0.000000000000000_REALK,      0.013706353598013_REALK,      0.000000000000000_REALK, &
      0.014608416084386_REALK,      0.000000000000000_REALK,      0.081264863574861_REALK, &
      1.513041056109916_REALK,      0.509665201343154_REALK,      0.000000000000000_REALK, &
      0.447862946807338_REALK,      0.000000000000000_REALK,      0.444599624320210_REALK, &
      0.541480511489990_REALK,      0.000000000000000_REALK,      0.168010512867510_REALK, &
      0.000000000000000_REALK,      0.799391686320534_REALK,      0.000000000000000_REALK, &
      0.170061732072081_REALK,      0.000000000000000_REALK,      0.236351624579078_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.123217897966394_REALK, &
      0.000000000000000_REALK,     -0.029605746701549_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.011187155153462_REALK,      0.000000000000000_REALK, &
     -0.072210290847613_REALK,      0.000000000000000_REALK,     -0.001210054064420_REALK, &
      0.000000000000000_REALK,     -0.020839408202941_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.294690021785831_REALK, &
      0.000000000000000_REALK,      0.178676749287739_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.339630061263340_REALK,      0.000000000000000_REALK, &
     -0.136001889462679_REALK,      0.000000000000000_REALK,      0.523087478006335_REALK, &
      0.000000000000000_REALK,      0.094985550276242_REALK,      0.000000000000000_REALK, &
      6.092933375028094_REALK,     -0.098105331191620_REALK,      0.000000000000000_REALK, &
      1.734438304433414_REALK,      0.000000000000000_REALK,      2.640381414477229_REALK, &
     -0.240232616383634_REALK,      0.000000000000000_REALK,     -0.049732176990019_REALK, &
      0.000000000000000_REALK,      3.054003971474601_REALK,      0.000000000000000_REALK, &
      2.163725046884120_REALK,      0.000000000000000_REALK,      9.881688011436026_REALK, &
      1.351458912198127_REALK,     -0.118704941364118_REALK,      0.000000000000000_REALK, &
     -0.364826597552309_REALK,      0.000000000000000_REALK,      0.926585014398718_REALK, &
     -1.139265479763935_REALK,      0.000000000000000_REALK,     -0.100668246442102_REALK, &
      0.000000000000000_REALK,    -20.410056733904078_REALK,      0.000000000000000_REALK, &
     -0.542767448904745_REALK,      0.000000000000000_REALK,      4.135555256930927_REALK, &
      6.953670629852341_REALK,     -0.672040247137829_REALK,      0.000000000000000_REALK, &
      1.995084221036752_REALK,      0.000000000000000_REALK,      2.666494100701815_REALK, &
     -0.695753569310541_REALK,      0.000000000000000_REALK,     -0.290231797074043_REALK, &
      0.000000000000000_REALK,      5.287867226556706_REALK,      0.000000000000000_REALK, &
      2.137147585873863_REALK,      0.000000000000000_REALK,      8.569099043498683_REALK, &
      3.273662336386505_REALK,     -0.248180687485766_REALK,      0.000000000000000_REALK, &
      1.240707703276670_REALK,      0.000000000000000_REALK,      1.173235208121695_REALK, &
      0.629026952828814_REALK,      0.000000000000000_REALK,     -0.116454139375818_REALK, &
      0.000000000000000_REALK,     12.489218723170294_REALK,      0.000000000000000_REALK, &
      1.464226923220694_REALK,      0.000000000000000_REALK,      4.153796839816533_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.728097307688972_REALK, &
      0.000000000000000_REALK,      0.058340660737886_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.206552912112752_REALK,      0.000000000000000_REALK, &
     -0.943322922795143_REALK,      0.000000000000000_REALK,      0.301883324963578_REALK, &
      0.000000000000000_REALK,      0.187484720102896_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.400893906413310_REALK, &
      0.000000000000000_REALK,      0.145391781054126_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.074065783736298_REALK,      0.000000000000000_REALK, &
     -0.564335871481330_REALK,      0.000000000000000_REALK,      1.941829975010857_REALK, &
      0.000000000000000_REALK,      0.514754344650797_REALK,      0.000000000000000_REALK, &
      9.917586444694720_REALK,     -1.942082791665780_REALK,      0.000000000000000_REALK, &
      2.767483344208519_REALK,      0.000000000000000_REALK,      3.201192671753681_REALK, &
     -1.777094255132045_REALK,      0.000000000000000_REALK,     -0.730670338888151_REALK, &
      0.000000000000000_REALK,      6.267974210683882_REALK,      0.000000000000000_REALK, &
      2.375805601733318_REALK,      0.000000000000000_REALK,      8.244398107431216_REALK, &
      2.681756599156738_REALK,     -0.998151109767032_REALK,      0.000000000000000_REALK, &
      0.902184099919802_REALK,      0.000000000000000_REALK,      1.496891065315245_REALK, &
     -1.929078318601748_REALK,      0.000000000000000_REALK,     -0.506725387649332_REALK, &
      0.000000000000000_REALK,     -3.637056026998345_REALK,      0.000000000000000_REALK, &
      0.854089235642389_REALK,      0.000000000000000_REALK,      4.251278245522172_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.176293299626794_REALK, &
      0.000000000000000_REALK,      0.225790419317370_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.331123472249916_REALK,      0.000000000000000_REALK, &
     -1.327671447723865_REALK,      0.000000000000000_REALK,      0.464667019011611_REALK, &
      0.000000000000000_REALK,      0.581503925746665_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.623898751974747_REALK, &
      0.000000000000000_REALK,      0.105402055971796_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.334946063271983_REALK,      0.000000000000000_REALK, &
     -0.950192813056510_REALK,      0.000000000000000_REALK,     -0.538978555741308_REALK, &
      0.000000000000000_REALK,      0.299349416914207_REALK,      0.000000000000000_REALK, &
      0.757868459036952_REALK,     -0.025736313575085_REALK,      0.000000000000000_REALK, &
      0.160691106582178_REALK,      0.000000000000000_REALK,      0.733872995436348_REALK, &
     -0.046772930160280_REALK,      0.000000000000000_REALK,     -0.029048340846751_REALK, &
      0.000000000000000_REALK,      0.194708653182466_REALK,      0.000000000000000_REALK, &
      0.413846210094373_REALK,      0.000000000000000_REALK,      3.150045287837360_REALK, &
      0.305028006118912_REALK,     -0.077315912546025_REALK,      0.000000000000000_REALK, &
     -0.067036568427806_REALK,      0.000000000000000_REALK,      0.510777559574828_REALK, &
     -0.444199116515895_REALK,      0.000000000000000_REALK,     -0.117751516898550_REALK, &
      0.000000000000000_REALK,     -2.386438639715816_REALK,      0.000000000000000_REALK, &
     -0.190388673975797_REALK,      0.000000000000000_REALK,      2.417741653168846_REALK, &
     17.160532537166869_REALK,     -4.724132392150252_REALK,      0.000000000000000_REALK, &
      4.716813518007143_REALK,      0.000000000000000_REALK,      4.519672298785419_REALK, &
     -3.783501715803018_REALK,      0.000000000000000_REALK,     -1.509527509407805_REALK, &
      0.000000000000000_REALK,      9.418763174199256_REALK,      0.000000000000000_REALK, &
      3.081096721759506_REALK,      0.000000000000000_REALK,      8.856962936982017_REALK, &
     13.212865893308587_REALK,     -3.558635691437382_REALK,      0.000000000000000_REALK, &
      3.452193793808696_REALK,      0.000000000000000_REALK,      2.992031263911771_REALK, &
     -1.645782599189480_REALK,      0.000000000000000_REALK,     -1.111263004573738_REALK, &
      0.000000000000000_REALK,     10.801844577593684_REALK,      0.000000000000000_REALK, &
      2.102631771504015_REALK,      0.000000000000000_REALK,      5.467080099718321_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.969140207497202_REALK, &
      0.000000000000000_REALK,      0.516375084515101_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.543962315411609_REALK,      0.000000000000000_REALK, &
     -1.887629981350962_REALK,      0.000000000000000_REALK,      0.820372114272399_REALK, &
      0.000000000000000_REALK,      1.011912962442045_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.702767047185766_REALK, &
      0.000000000000000_REALK,      0.514592633258533_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.320474542114640_REALK,      0.000000000000000_REALK, &
     -1.595180447521880_REALK,      0.000000000000000_REALK,      1.193187832536818_REALK, &
      0.000000000000000_REALK,      0.940270637771094_REALK,      0.000000000000000_REALK, &
      1.187509181123405_REALK,     -0.138889794753253_REALK,      0.000000000000000_REALK, &
      0.234009650957184_REALK,      0.000000000000000_REALK,      0.938284229615680_REALK, &
     -0.106389743071806_REALK,      0.000000000000000_REALK,     -0.133140616235319_REALK, &
      0.000000000000000_REALK,      0.378212973221117_REALK,      0.000000000000000_REALK, &
      0.458576345453377_REALK,      0.000000000000000_REALK,      3.064510026642882_REALK, &
      1.420405310984052_REALK,     -0.119898603026671_REALK,      0.000000000000000_REALK, &
      0.340146321656153_REALK,      0.000000000000000_REALK,      0.964945182719872_REALK, &
      0.202237539887610_REALK,      0.000000000000000_REALK,     -0.112323002462044_REALK, &
      0.000000000000000_REALK,      1.767098333098918_REALK,      0.000000000000000_REALK, &
      0.621519971581948_REALK,      0.000000000000000_REALK,      2.938601538803101_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.451425131408434_REALK, &
      0.000000000000000_REALK,      0.020528874187762_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.094753856335306_REALK,      0.000000000000000_REALK, &
     -0.721231538124717_REALK,      0.000000000000000_REALK,      0.064776318130835_REALK, &
      0.000000000000000_REALK,      0.067048916307434_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.581027716070184_REALK, &
      0.000000000000000_REALK,      0.119579686804531_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.071438346919706_REALK,      0.000000000000000_REALK, &
     -0.907194022493453_REALK,      0.000000000000000_REALK,      0.824247998548662_REALK, &
      0.000000000000000_REALK,      0.364162708873173_REALK,      0.000000000000000_REALK, &
     35.174997182888674_REALK,    -11.608704089995534_REALK,      0.000000000000000_REALK, &
      9.449202518928152_REALK,      0.000000000000000_REALK,      7.467953919117862_REALK, &
     -8.196176018975068_REALK,      0.000000000000000_REALK,     -3.049466990670063_REALK, &
      0.000000000000000_REALK,     15.364394905233834_REALK,      0.000000000000000_REALK, &
      4.520283171501681_REALK,      0.000000000000000_REALK,     10.717496960780878_REALK, &
     15.432696140514393_REALK,     -8.469171963602296_REALK,      0.000000000000000_REALK, &
      6.939207695269991_REALK,      0.000000000000000_REALK,      5.699625800464163_REALK, &
     -8.435993473495824_REALK,      0.000000000000000_REALK,     -2.865845484466327_REALK, &
      0.000000000000000_REALK,      6.323245728570832_REALK,      0.000000000000000_REALK, &
      3.296123581809255_REALK,      0.000000000000000_REALK,      8.121966584688350_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.663663288218865_REALK, &
      0.000000000000000_REALK,      1.131742049595066_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.004378731434964_REALK,      0.000000000000000_REALK, &
     -2.887200890575238_REALK,      0.000000000000000_REALK,      1.356971856213045_REALK, &
      0.000000000000000_REALK,      1.624198824509593_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.936331189142715_REALK, &
      0.000000000000000_REALK,      1.109399707142218_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.146425660778978_REALK,      0.000000000000000_REALK, &
     -2.980836207648452_REALK,      0.000000000000000_REALK,      0.780435932400630_REALK, &
      0.000000000000000_REALK,      1.580894547452281_REALK,      0.000000000000000_REALK, &
      2.221950983488663_REALK,     -0.418575576949966_REALK,      0.000000000000000_REALK, &
      0.407826304528842_REALK,      0.000000000000000_REALK,      1.415217815281364_REALK, &
     -0.267425653215779_REALK,      0.000000000000000_REALK,     -0.329864314340557_REALK, &
      0.000000000000000_REALK,      0.514709302915732_REALK,      0.000000000000000_REALK, &
      0.585284433548120_REALK,      0.000000000000000_REALK,      3.385039775373221_REALK, &
      1.437325779934930_REALK,     -0.505012904432227_REALK,      0.000000000000000_REALK, &
      0.319937190120798_REALK,      0.000000000000000_REALK,      1.592505747096828_REALK, &
     -0.650566194180066_REALK,      0.000000000000000_REALK,     -0.512667221063980_REALK, &
      0.000000000000000_REALK,     -0.647150169178353_REALK,      0.000000000000000_REALK, &
      0.455910485763573_REALK,      0.000000000000000_REALK,      3.782201065080232_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.760576709705584_REALK, &
      0.000000000000000_REALK,      0.099819866125939_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.149487137115748_REALK,      0.000000000000000_REALK, &
     -0.998971785368558_REALK,      0.000000000000000_REALK,      0.114471643981430_REALK, &
      0.000000000000000_REALK,      0.238757747083305_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.946981627501111_REALK, &
      0.000000000000000_REALK,      0.112134666162602_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.338873621983984_REALK,      0.000000000000000_REALK, &
     -1.602224534293371_REALK,      0.000000000000000_REALK,     -0.287705271193765_REALK, &
      0.000000000000000_REALK,      0.266319826202060_REALK,      0.000000000000000_REALK, &
      0.509381968275053_REALK,     -0.016640782282021_REALK,      0.000000000000000_REALK, &
      0.071040059162635_REALK,      0.000000000000000_REALK,      0.540730827429629_REALK, &
     -0.021115843515007_REALK,      0.000000000000000_REALK,     -0.021856667150161_REALK, &
      0.000000000000000_REALK,      0.047966863829968_REALK,      0.000000000000000_REALK, &
      0.169919727771783_REALK,      0.000000000000000_REALK,      1.810713145635608_REALK, &
      0.490452359026231_REALK,     -0.117353574538857_REALK,      0.000000000000000_REALK, &
     -0.071318563495098_REALK,      0.000000000000000_REALK,      0.905672895374990_REALK, &
     -0.449407770389574_REALK,      0.000000000000000_REALK,     -0.198553774278966_REALK, &
      0.000000000000000_REALK,     -1.273874384635552_REALK,      0.000000000000000_REALK, &
     -0.169381584526709_REALK,      0.000000000000000_REALK,      3.011362310022881_REALK, &
     96.312319396971617_REALK,    -33.433481727817174_REALK,      0.000000000000000_REALK, &
     23.089515610015411_REALK,      0.000000000000000_REALK,     15.116016713997823_REALK, &
    -19.372778977728924_REALK,      0.000000000000000_REALK,     -6.645072135550438_REALK, &
      0.000000000000000_REALK,     28.669606753756462_REALK,      0.000000000000000_REALK, &
      7.616984878159422_REALK,      0.000000000000000_REALK,     14.959837963675188_REALK, &
    205.346797938833902_REALK,    -69.354711825477182_REALK,      0.000000000000000_REALK, &
     42.539444307659807_REALK,      0.000000000000000_REALK,     25.933745353045001_REALK, &
    -28.187512430973445_REALK,      0.000000000000000_REALK,    -10.878747069906266_REALK, &
      0.000000000000000_REALK,     42.577775470589017_REALK,      0.000000000000000_REALK, &
      9.722750144212188_REALK,      0.000000000000000_REALK,     17.782131182602999_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -8.456220137924239_REALK, &
      0.000000000000000_REALK,      2.786210658773621_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.126610244798384_REALK,      0.000000000000000_REALK, &
     -5.042148460761243_REALK,      0.000000000000000_REALK,      2.470412980668528_REALK, &
      0.000000000000000_REALK,      2.757423518149470_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,    -19.589800423124988_REALK, &
      0.000000000000000_REALK,      6.352590345080058_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -3.741075407709598_REALK,      0.000000000000000_REALK, &
     -9.218370821987905_REALK,      0.000000000000000_REALK,      4.273971551239176_REALK, &
      0.000000000000000_REALK,      4.355814917118688_REALK,      0.000000000000000_REALK, &
      5.602608027283821_REALK,     -1.281510305817730_REALK,      0.000000000000000_REALK, &
      0.917672083525235_REALK,      0.000000000000000_REALK,      2.637952770091740_REALK, &
     -0.638400326227143_REALK,      0.000000000000000_REALK,     -0.764119797088758_REALK, &
      0.000000000000000_REALK,      0.925431625318606_REALK,      0.000000000000000_REALK, &
      0.908190691573728_REALK,      0.000000000000000_REALK,      4.351162384361976_REALK, &
     17.439644595412705_REALK,     -3.813043103745424_REALK,      0.000000000000000_REALK, &
      2.541230022166651_REALK,      0.000000000000000_REALK,      6.607485091436759_REALK, &
     -0.885788897634199_REALK,      0.000000000000000_REALK,     -1.794303389076684_REALK, &
      0.000000000000000_REALK,      2.983843163723638_REALK,      0.000000000000000_REALK, &
      1.742458908428772_REALK,      0.000000000000000_REALK,      7.550983289887361_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.602499629583285_REALK, &
      0.000000000000000_REALK,      0.301387577362418_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.275352632850866_REALK,      0.000000000000000_REALK, &
     -1.592524183162456_REALK,      0.000000000000000_REALK,      0.241814647539976_REALK, &
      0.000000000000000_REALK,      0.497122732674145_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -5.473494374975603_REALK, &
      0.000000000000000_REALK,      1.136406291414743_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.517454963102698_REALK,      0.000000000000000_REALK, &
     -4.292769685479447_REALK,      0.000000000000000_REALK,      0.988799273562496_REALK, &
      0.000000000000000_REALK,      1.298676394762732_REALK,      0.000000000000000_REALK, &
      1.163101749242153_REALK,     -0.113029455087851_REALK,      0.000000000000000_REALK, &
      0.136582116171696_REALK,      0.000000000000000_REALK,      0.912731911748421_REALK, &
     -0.053854274520804_REALK,      0.000000000000000_REALK,     -0.112325854754728_REALK, &
      0.000000000000000_REALK,      0.111482868838888_REALK,      0.000000000000000_REALK, &
      0.225284915257286_REALK,      0.000000000000000_REALK,      2.107703643904047_REALK, &
      5.624373395981457_REALK,     -0.385410517732624_REALK,      0.000000000000000_REALK, &
      0.751165863926067_REALK,      0.000000000000000_REALK,      3.551578814130603_REALK, &
      0.326543313081912_REALK,      0.000000000000000_REALK,     -0.302270994294193_REALK, &
      0.000000000000000_REALK,      1.464401077881250_REALK,      0.000000000000000_REALK, &
      0.858426588626048_REALK,      0.000000000000000_REALK,      5.682203844570680_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.612288045913248_REALK, &
      0.000000000000000_REALK,      0.019969810844112_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.079940353328082_REALK,      0.000000000000000_REALK, &
     -0.851867234817627_REALK,      0.000000000000000_REALK,      0.031822677914964_REALK, &
      0.000000000000000_REALK,      0.046114792900779_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.112827383788064_REALK, &
      0.000000000000000_REALK,      0.440125190384661_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.192246821050300_REALK,      0.000000000000000_REALK, &
     -3.417873511752967_REALK,      0.000000000000000_REALK,      1.138429060895728_REALK, &
      0.000000000000000_REALK,      0.704160369170441_REALK,      0.000000000000000_REALK/
    ! results of test 2, ket-major order, CM020001
  data REF_CONTR_INTS(6301:7560)                                                           &
     /0.000000000000000_REALK,      0.000000000000000_REALK,     -1.020503713224634_REALK, &
      0.000000000000000_REALK,     -1.186965186130659_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.802888323955508_REALK,      0.000000000000000_REALK, &
     -0.850095117220694_REALK,      0.000000000000000_REALK,     -4.373972347469388_REALK, &
      0.000000000000000_REALK,     -1.569152455999963_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.867828245223924_REALK, &
      0.000000000000000_REALK,     -1.313688973148308_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.350792305842416_REALK,      0.000000000000000_REALK, &
     -0.850229948765964_REALK,      0.000000000000000_REALK,     -6.102785153501406_REALK, &
      0.000000000000000_REALK,     -1.778430519622148_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.630344081581095_REALK, &
      0.000000000000000_REALK,     -0.528871882678467_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.604127886725306_REALK,      0.000000000000000_REALK, &
     -0.459801335535293_REALK,      0.000000000000000_REALK,     -1.006259001486697_REALK, &
      0.000000000000000_REALK,     -0.576544463722668_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.413675780914639_REALK, &
      0.000000000000000_REALK,     -0.298692671343571_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.234064065320264_REALK,      0.000000000000000_REALK, &
     -0.286077840257019_REALK,      0.000000000000000_REALK,     -0.057407231495663_REALK, &
      0.000000000000000_REALK,     -0.309607715604502_REALK,      0.000000000000000_REALK, &
      0.778967681580850_REALK,      0.762954762076273_REALK,      0.000000000000000_REALK, &
      0.980916612378344_REALK,      0.000000000000000_REALK,      0.462520285645863_REALK, &
      1.551322991770541_REALK,      0.000000000000000_REALK,      0.556533532726681_REALK, &
      0.000000000000000_REALK,      3.581592279907965_REALK,      0.000000000000000_REALK, &
      1.069336564795516_REALK,      0.000000000000000_REALK,      0.840353208348667_REALK, &
      1.226542279318010_REALK,      1.207958238085582_REALK,      0.000000000000000_REALK, &
      1.653774121774744_REALK,      0.000000000000000_REALK,      0.598133779548483_REALK, &
      2.866600823854721_REALK,      0.000000000000000_REALK,      0.835364553148701_REALK, &
      0.000000000000000_REALK,      6.887429539259326_REALK,      0.000000000000000_REALK, &
      1.714207535341797_REALK,      0.000000000000000_REALK,      1.033318696655051_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.519565612937804_REALK, &
      0.000000000000000_REALK,     -0.338805517036113_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.328366239735891_REALK,      0.000000000000000_REALK, &
     -0.329580654967699_REALK,      0.000000000000000_REALK,     -0.453313298855020_REALK, &
      0.000000000000000_REALK,     -0.304538224116135_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.288126376460119_REALK, &
      0.000000000000000_REALK,     -0.239449574541176_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.282540619571635_REALK,      0.000000000000000_REALK, &
     -0.212584723173834_REALK,      0.000000000000000_REALK,     -0.497670641071732_REALK, &
      0.000000000000000_REALK,     -0.216881660243797_REALK,      0.000000000000000_REALK, &
      0.534615735634721_REALK,      0.382442149408176_REALK,      0.000000000000000_REALK, &
      0.366808804358701_REALK,      0.000000000000000_REALK,      0.279177938705093_REALK, &
      0.423412850977629_REALK,      0.000000000000000_REALK,      0.242597914393326_REALK, &
      0.000000000000000_REALK,      0.653656305995717_REALK,      0.000000000000000_REALK, &
      0.329709217390503_REALK,      0.000000000000000_REALK,      0.418235779282336_REALK, &
      0.258892788234387_REALK,      0.232631559665298_REALK,      0.000000000000000_REALK, &
      0.171945371112750_REALK,      0.000000000000000_REALK,      0.210155114339410_REALK, &
      0.031825299180437_REALK,      0.000000000000000_REALK,      0.171639668400126_REALK, &
      0.000000000000000_REALK,     -0.428579472317104_REALK,      0.000000000000000_REALK, &
      0.155739669321301_REALK,      0.000000000000000_REALK,      0.317246962427562_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.334461441382445_REALK, &
      0.000000000000000_REALK,     -0.337910902990347_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.449954577187133_REALK,      0.000000000000000_REALK, &
     -0.353603145163826_REALK,      0.000000000000000_REALK,     -0.846651016739323_REALK, &
      0.000000000000000_REALK,     -0.506223487771555_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.465846026281682_REALK, &
      0.000000000000000_REALK,     -0.613665612912665_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.950318735954605_REALK,      0.000000000000000_REALK, &
     -0.572849026385647_REALK,      0.000000000000000_REALK,     -1.907355850512320_REALK, &
      0.000000000000000_REALK,     -0.926380270376712_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.509489167999453_REALK, &
      0.000000000000000_REALK,     -0.251944860602205_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.202591137092946_REALK,      0.000000000000000_REALK, &
     -0.278569084694551_REALK,      0.000000000000000_REALK,     -0.214714898435048_REALK, &
      0.000000000000000_REALK,     -0.186441059495848_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.348737980165484_REALK, &
      0.000000000000000_REALK,     -0.150636901156564_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.081313821159577_REALK,      0.000000000000000_REALK, &
     -0.171908547010114_REALK,      0.000000000000000_REALK,      0.003305566242604_REALK, &
      0.000000000000000_REALK,     -0.101395751394670_REALK,      0.000000000000000_REALK, &
      0.498141531633661_REALK,      0.278503456838321_REALK,      0.000000000000000_REALK, &
      0.226026549202582_REALK,      0.000000000000000_REALK,      0.226862475832449_REALK, &
      0.226665384566547_REALK,      0.000000000000000_REALK,      0.152274980369755_REALK, &
      0.000000000000000_REALK,      0.311780557984997_REALK,      0.000000000000000_REALK, &
      0.167261317443801_REALK,      0.000000000000000_REALK,      0.279799848883302_REALK, &
      0.561588843128981_REALK,      0.309181471240708_REALK,      0.000000000000000_REALK, &
      0.274158404781078_REALK,      0.000000000000000_REALK,      0.206277910321453_REALK, &
      0.349728377752212_REALK,      0.000000000000000_REALK,      0.152409374677854_REALK, &
      0.000000000000000_REALK,      0.659431624401708_REALK,      0.000000000000000_REALK, &
      0.184539759119509_REALK,      0.000000000000000_REALK,      0.231414121778695_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.229488650841768_REALK, &
      0.000000000000000_REALK,     -0.166989059162020_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.164860962040417_REALK,      0.000000000000000_REALK, &
     -0.209125948852516_REALK,      0.000000000000000_REALK,     -0.215675616756814_REALK, &
      0.000000000000000_REALK,     -0.205955230574165_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.271355952770943_REALK, &
      0.000000000000000_REALK,     -0.166547584404235_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.109443027995606_REALK,      0.000000000000000_REALK, &
     -0.222939141593077_REALK,      0.000000000000000_REALK,     -0.020786508692337_REALK, &
      0.000000000000000_REALK,     -0.186842415260112_REALK,      0.000000000000000_REALK, &
      0.320670056935807_REALK,      0.277768070040427_REALK,      0.000000000000000_REALK, &
      0.309720269846603_REALK,      0.000000000000000_REALK,      0.243398038582903_REALK, &
      0.423341822945841_REALK,      0.000000000000000_REALK,      0.253121498579851_REALK, &
      0.000000000000000_REALK,      0.767657355411798_REALK,      0.000000000000000_REALK, &
      0.381992149125526_REALK,      0.000000000000000_REALK,      0.420271478699723_REALK, &
      0.907983275220810_REALK,      0.792375753491019_REALK,      0.000000000000000_REALK, &
      0.922125353437292_REALK,      0.000000000000000_REALK,      0.555854147599702_REALK, &
      1.340357281191755_REALK,      0.000000000000000_REALK,      0.650995743777069_REALK, &
      0.000000000000000_REALK,      2.493860272577155_REALK,      0.000000000000000_REALK, &
      1.034491907073419_REALK,      0.000000000000000_REALK,      0.873023674152633_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.588540355847251_REALK, &
      0.000000000000000_REALK,     -0.218832441554568_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.152940120856989_REALK,      0.000000000000000_REALK, &
     -0.275331358494937_REALK,      0.000000000000000_REALK,     -0.131776678582085_REALK, &
      0.000000000000000_REALK,     -0.132989854651000_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.331619495605939_REALK, &
      0.000000000000000_REALK,     -0.153907285521913_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.127979830983270_REALK,      0.000000000000000_REALK, &
     -0.181569608671840_REALK,      0.000000000000000_REALK,     -0.160848647140272_REALK, &
      0.000000000000000_REALK,     -0.093886930477485_REALK,      0.000000000000000_REALK, &
      0.558287861856483_REALK,      0.238220494742982_REALK,      0.000000000000000_REALK, &
      0.160693915338243_REALK,      0.000000000000000_REALK,      0.220959107856830_REALK, &
      0.128345063743067_REALK,      0.000000000000000_REALK,      0.111444477489568_REALK, &
      0.000000000000000_REALK,      0.133848576694382_REALK,      0.000000000000000_REALK, &
      0.097657642954205_REALK,      0.000000000000000_REALK,      0.223803803410374_REALK, &
      0.275948742789156_REALK,      0.152064374698037_REALK,      0.000000000000000_REALK, &
      0.080468953433202_REALK,      0.000000000000000_REALK,      0.170122381003085_REALK, &
     -0.002714292773276_REALK,      0.000000000000000_REALK,      0.083258883668467_REALK, &
      0.000000000000000_REALK,     -0.165509717402360_REALK,      0.000000000000000_REALK, &
      0.049087884377659_REALK,      0.000000000000000_REALK,      0.172964176709131_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.214504439988369_REALK, &
      0.000000000000000_REALK,     -0.120783481226248_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.099979855173245_REALK,      0.000000000000000_REALK, &
     -0.167249360440124_REALK,      0.000000000000000_REALK,     -0.109262465839866_REALK, &
      0.000000000000000_REALK,     -0.122338484934031_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.208232652200192_REALK, &
      0.000000000000000_REALK,     -0.150825809177844_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.151530750799740_REALK,      0.000000000000000_REALK, &
     -0.190020599279523_REALK,      0.000000000000000_REALK,     -0.211125561754085_REALK, &
      0.000000000000000_REALK,     -0.153345266843292_REALK,      0.000000000000000_REALK, &
      0.251468993348485_REALK,      0.157892549167932_REALK,      0.000000000000000_REALK, &
      0.130766596490102_REALK,      0.000000000000000_REALK,      0.165877283686494_REALK, &
      0.128919329688956_REALK,      0.000000000000000_REALK,      0.123109003562021_REALK, &
      0.000000000000000_REALK,      0.157551300580113_REALK,      0.000000000000000_REALK, &
      0.132450125896043_REALK,      0.000000000000000_REALK,      0.235217974438341_REALK, &
      0.214718035529032_REALK,      0.168125831621935_REALK,      0.000000000000000_REALK, &
      0.108305891886250_REALK,      0.000000000000000_REALK,      0.220622756961391_REALK, &
      0.017068382898535_REALK,      0.000000000000000_REALK,      0.153421526074857_REALK, &
      0.000000000000000_REALK,     -0.181815189367733_REALK,      0.000000000000000_REALK, &
      0.110115078994302_REALK,      0.000000000000000_REALK,      0.314031385021629_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.230139249644146_REALK, &
      0.000000000000000_REALK,     -0.200774255215413_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.228334442957612_REALK,      0.000000000000000_REALK, &
     -0.251215775506263_REALK,      0.000000000000000_REALK,     -0.340114949301887_REALK, &
      0.000000000000000_REALK,     -0.284702718669977_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.561121562705327_REALK, &
      0.000000000000000_REALK,     -0.644231760900834_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.849450200450151_REALK,      0.000000000000000_REALK, &
     -0.716864124248824_REALK,      0.000000000000000_REALK,     -1.348587942074701_REALK, &
      0.000000000000000_REALK,     -0.916990590349733_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.804745371243785_REALK, &
      0.000000000000000_REALK,     -0.215742722099053_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.133921067600572_REALK,      0.000000000000000_REALK, &
     -0.316654379956197_REALK,      0.000000000000000_REALK,     -0.088053897357081_REALK, &
      0.000000000000000_REALK,     -0.106698256815359_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.754872879337001_REALK, &
      0.000000000000000_REALK,     -0.172820213194183_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.067706634376598_REALK,      0.000000000000000_REALK, &
     -0.250396531600700_REALK,      0.000000000000000_REALK,      0.017534439080069_REALK, &
      0.000000000000000_REALK,     -0.072775503155160_REALK,      0.000000000000000_REALK, &
      0.767216326763468_REALK,      0.244993026162889_REALK,      0.000000000000000_REALK, &
      0.143389126117644_REALK,      0.000000000000000_REALK,      0.258137123641279_REALK, &
      0.095521422201409_REALK,      0.000000000000000_REALK,      0.096400821384409_REALK, &
      0.000000000000000_REALK,      0.087938998057292_REALK,      0.000000000000000_REALK, &
      0.070914882570203_REALK,      0.000000000000000_REALK,      0.212774895671101_REALK, &
      1.063363926968480_REALK,      0.325238088364285_REALK,      0.000000000000000_REALK, &
      0.198173567149616_REALK,      0.000000000000000_REALK,      0.281155997472462_REALK, &
      0.184828167668752_REALK,      0.000000000000000_REALK,      0.107883713271546_REALK, &
      0.000000000000000_REALK,      0.285185877020619_REALK,      0.000000000000000_REALK, &
      0.083451934208420_REALK,      0.000000000000000_REALK,      0.197327122051387_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.247373927318716_REALK, &
      0.000000000000000_REALK,     -0.104484854257497_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.070789437434579_REALK,      0.000000000000000_REALK, &
     -0.162229446256129_REALK,      0.000000000000000_REALK,     -0.059510709634625_REALK, &
      0.000000000000000_REALK,     -0.086123815320510_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.359503955890029_REALK, &
      0.000000000000000_REALK,     -0.128924298826679_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.056405968502465_REALK,      0.000000000000000_REALK, &
     -0.198749895767565_REALK,      0.000000000000000_REALK,      0.001769911557137_REALK, &
      0.000000000000000_REALK,     -0.090484503544881_REALK,      0.000000000000000_REALK, &
      0.279626208954554_REALK,      0.135222686206369_REALK,      0.000000000000000_REALK, &
      0.093736188923673_REALK,      0.000000000000000_REALK,      0.156804764523947_REALK, &
      0.079201466014759_REALK,      0.000000000000000_REALK,      0.088679925739554_REALK, &
      0.000000000000000_REALK,      0.086413576287438_REALK,      0.000000000000000_REALK, &
      0.077264004252861_REALK,      0.000000000000000_REALK,      0.180949426097079_REALK, &
      0.667714334351977_REALK,      0.318726288275769_REALK,      0.000000000000000_REALK, &
      0.234641577412065_REALK,      0.000000000000000_REALK,      0.294242145045914_REALK, &
      0.242600428544565_REALK,      0.000000000000000_REALK,      0.176206173910836_REALK, &
      0.000000000000000_REALK,      0.353081913206787_REALK,      0.000000000000000_REALK, &
      0.164681342744095_REALK,      0.000000000000000_REALK,      0.289116144297628_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.185707280937596_REALK, &
      0.000000000000000_REALK,     -0.115420939509251_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.096009586312837_REALK,      0.000000000000000_REALK, &
     -0.170503276356972_REALK,      0.000000000000000_REALK,     -0.099628306323343_REALK, &
      0.000000000000000_REALK,     -0.133193355617680_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.466221748245730_REALK, &
      0.000000000000000_REALK,     -0.237569395632088_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.126531174772442_REALK,      0.000000000000000_REALK, &
     -0.360847582593661_REALK,      0.000000000000000_REALK,     -0.018549662028111_REALK, &
      0.000000000000000_REALK,     -0.233430692457565_REALK,      0.000000000000000_REALK, &
      0.300007617152949_REALK,      0.224776052450882_REALK,      0.000000000000000_REALK, &
      0.214075129892606_REALK,      0.000000000000000_REALK,      0.235527540549626_REALK, &
      0.246540313649196_REALK,      0.000000000000000_REALK,      0.206373456096966_REALK, &
      0.000000000000000_REALK,      0.354608477798257_REALK,      0.000000000000000_REALK, &
      0.247038232628505_REALK,      0.000000000000000_REALK,      0.349449257395331_REALK, &
      1.799280308700708_REALK,      1.361395632886474_REALK,      0.000000000000000_REALK, &
      1.315352388308503_REALK,      0.000000000000000_REALK,      1.110046165653601_REALK, &
      1.549637144641131_REALK,      0.000000000000000_REALK,      1.053696711766708_REALK, &
      0.000000000000000_REALK,      2.225494713246019_REALK,      0.000000000000000_REALK, &
      1.292437597071928_REALK,      0.000000000000000_REALK,      1.402338882780909_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.644340002432563_REALK, &
      0.000000000000000_REALK,     -5.474112043170483_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.207060381516138_REALK,      0.000000000000000_REALK, &
      2.985469021102288_REALK,      0.000000000000000_REALK,    -30.482256521615192_REALK, &
      0.000000000000000_REALK,    -21.681139891285039_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.858459302800795_REALK, &
      0.000000000000000_REALK,     -5.774903467263577_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.489869460755213_REALK,      0.000000000000000_REALK, &
      3.462738468370098_REALK,      0.000000000000000_REALK,    -44.016109660411573_REALK, &
      0.000000000000000_REALK,    -26.286092885541773_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.105724746148165_REALK, &
      0.000000000000000_REALK,     -1.752826473390437_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.072791908296963_REALK,      0.000000000000000_REALK, &
     -0.171022417800402_REALK,      0.000000000000000_REALK,     -6.292642649966994_REALK, &
      0.000000000000000_REALK,     -7.032021590955866_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.132855474747922_REALK, &
      0.000000000000000_REALK,     -0.895604867400195_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.002785861356460_REALK,      0.000000000000000_REALK, &
      0.011091383048895_REALK,      0.000000000000000_REALK,      0.203858337071895_REALK, &
      0.000000000000000_REALK,     -4.183891073154340_REALK,      0.000000000000000_REALK, &
      2.443555404783461_REALK,     -0.049739213176926_REALK,      0.000000000000000_REALK, &
      2.447169377287383_REALK,      0.000000000000000_REALK,      3.310262114470490_REALK, &
      0.113120236305909_REALK,      0.000000000000000_REALK,      0.080459124348110_REALK, &
      0.000000000000000_REALK,     17.396815921660327_REALK,      0.000000000000000_REALK, &
      9.817599265559325_REALK,      0.000000000000000_REALK,     22.133617725484374_REALK, &
      2.492125940894548_REALK,     -0.150789961912235_REALK,      0.000000000000000_REALK, &
      3.459046652053860_REALK,      0.000000000000000_REALK,      3.432155282782895_REALK, &
     -0.021079693742575_REALK,      0.000000000000000_REALK,     -0.012588636115074_REALK, &
      0.000000000000000_REALK,     34.268431164503369_REALK,      0.000000000000000_REALK, &
     16.159218128373247_REALK,      0.000000000000000_REALK,     26.722654844799806_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.869627395281052_REALK, &
      0.000000000000000_REALK,     -0.689873099324283_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.411289055152897_REALK,      0.000000000000000_REALK, &
     -1.322511111644265_REALK,      0.000000000000000_REALK,     -1.965205475384862_REALK, &
      0.000000000000000_REALK,     -2.581865899232102_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.319327079105178_REALK, &
      0.000000000000000_REALK,     -0.422157590275787_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.278250633655621_REALK,      0.000000000000000_REALK, &
     -0.812420192257818_REALK,      0.000000000000000_REALK,     -2.276393910185383_REALK, &
      0.000000000000000_REALK,     -1.884183334058398_REALK,      0.000000000000000_REALK, &
      1.503258783243034_REALK,      0.212458468088049_REALK,      0.000000000000000_REALK, &
      0.831812238005129_REALK,      0.000000000000000_REALK,      1.954318047539585_REALK, &
      0.289129920468890_REALK,      0.000000000000000_REALK,      0.323102384232680_REALK, &
      0.000000000000000_REALK,      3.130944504034718_REALK,      0.000000000000000_REALK, &
      3.113076381689531_REALK,      0.000000000000000_REALK,     12.190133538420730_REALK, &
      0.670858107101589_REALK,      0.097238834477472_REALK,      0.000000000000000_REALK, &
      0.346583711059645_REALK,      0.000000000000000_REALK,      1.379857862975326_REALK, &
     -0.012054045131847_REALK,      0.000000000000000_REALK,      0.247391460888583_REALK, &
      0.000000000000000_REALK,     -2.443571045273046_REALK,      0.000000000000000_REALK, &
      1.546880281858926_REALK,      0.000000000000000_REALK,     10.264354862872727_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.401233794951732_REALK, &
      0.000000000000000_REALK,     -0.919427527835910_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.451092148838530_REALK,      0.000000000000000_REALK, &
     -1.016979906318320_REALK,      0.000000000000000_REALK,     -4.837789586425196_REALK, &
      0.000000000000000_REALK,     -5.734964356149796_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.372640649455491_REALK, &
      0.000000000000000_REALK,     -1.566128268309099_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.955486772886178_REALK,      0.000000000000000_REALK, &
     -1.580097690232702_REALK,      0.000000000000000_REALK,    -11.704732729216186_REALK, &
      0.000000000000000_REALK,    -11.649965360952828_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.527304008751492_REALK, &
      0.000000000000000_REALK,     -0.198970744677420_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.504429134703767_REALK,      0.000000000000000_REALK, &
     -1.978775180621393_REALK,      0.000000000000000_REALK,     -0.309722729264726_REALK, &
      0.000000000000000_REALK,     -0.639416384776829_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.909596219992508_REALK, &
      0.000000000000000_REALK,     -0.066423436613600_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.215968268885362_REALK,      0.000000000000000_REALK, &
     -1.280432970653287_REALK,      0.000000000000000_REALK,      0.525671328780762_REALK, &
      0.000000000000000_REALK,     -0.235169776005141_REALK,      0.000000000000000_REALK, &
      1.348607083457475_REALK,      0.190235677130195_REALK,      0.000000000000000_REALK, &
      0.482481899730566_REALK,      0.000000000000000_REALK,      1.551433634244651_REALK, &
      0.187601892590380_REALK,      0.000000000000000_REALK,      0.246469356602850_REALK, &
      0.000000000000000_REALK,      1.357157903056300_REALK,      0.000000000000000_REALK, &
      1.550513531756342_REALK,      0.000000000000000_REALK,      8.309530522843007_REALK, &
      1.091328763506225_REALK,      0.182649625083257_REALK,      0.000000000000000_REALK, &
      0.401868082900374_REALK,      0.000000000000000_REALK,      1.173351308792633_REALK, &
      0.310635612711562_REALK,      0.000000000000000_REALK,      0.257114747064351_REALK, &
      0.000000000000000_REALK,      2.528762488309537_REALK,      0.000000000000000_REALK, &
      1.422799419263210_REALK,      0.000000000000000_REALK,      6.923679816741236_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.538912181770249_REALK, &
      0.000000000000000_REALK,     -0.379030392856202_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.297179622333891_REALK,      0.000000000000000_REALK, &
     -1.163691100692325_REALK,      0.000000000000000_REALK,     -1.089987317936268_REALK, &
      0.000000000000000_REALK,     -2.030099482829131_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.597005779704164_REALK, &
      0.000000000000000_REALK,     -0.357299211890615_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.211086535593284_REALK,      0.000000000000000_REALK, &
     -1.400668903413871_REALK,      0.000000000000000_REALK,      0.061636835065003_REALK, &
      0.000000000000000_REALK,     -2.108341571161788_REALK,      0.000000000000000_REALK, &
      0.622228256527672_REALK,      0.253536365603071_REALK,      0.000000000000000_REALK, &
      0.529174784007438_REALK,      0.000000000000000_REALK,      1.193015936215147_REALK, &
      0.461823709395914_REALK,      0.000000000000000_REALK,      0.547469555030306_REALK, &
      0.000000000000000_REALK,      3.013409434139880_REALK,      0.000000000000000_REALK, &
      2.834277872136973_REALK,      0.000000000000000_REALK,      8.945766653732640_REALK, &
      1.273532643526513_REALK,      0.677597057658195_REALK,      0.000000000000000_REALK, &
      1.379977585717445_REALK,      0.000000000000000_REALK,      2.282082240844149_REALK, &
      1.597222170862796_REALK,      0.000000000000000_REALK,      1.589748642260841_REALK, &
      0.000000000000000_REALK,     10.361105020090472_REALK,      0.000000000000000_REALK, &
      8.142934589316377_REALK,      0.000000000000000_REALK,     18.852469235551112_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.325709093707433_REALK, &
      0.000000000000000_REALK,      0.170407509510990_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.646433542896232_REALK,      0.000000000000000_REALK, &
     -2.625006501700532_REALK,      0.000000000000000_REALK,      0.446434922529671_REALK, &
      0.000000000000000_REALK,      0.438869975337920_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.204830346834352_REALK, &
      0.000000000000000_REALK,      0.116691783698204_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.438819564816591_REALK,      0.000000000000000_REALK, &
     -1.834946989220331_REALK,      0.000000000000000_REALK,     -0.009094509704056_REALK, &
      0.000000000000000_REALK,      0.331413055340053_REALK,      0.000000000000000_REALK, &
      1.589753901531950_REALK,      0.087773662699723_REALK,      0.000000000000000_REALK, &
      0.392428627699965_REALK,      0.000000000000000_REALK,      1.539419464964155_REALK, &
      0.047987544812878_REALK,      0.000000000000000_REALK,      0.099069327237978_REALK, &
      0.000000000000000_REALK,      0.723403654944870_REALK,      0.000000000000000_REALK, &
      1.010666388205568_REALK,      0.000000000000000_REALK,      6.607738752850792_REALK, &
      0.692084157227295_REALK,      0.035322413543525_REALK,      0.000000000000000_REALK, &
      0.195471794194665_REALK,      0.000000000000000_REALK,      1.158913443217246_REALK, &
     -0.120248807994039_REALK,      0.000000000000000_REALK,      0.053795753529935_REALK, &
      0.000000000000000_REALK,     -0.509219036418539_REALK,      0.000000000000000_REALK, &
      0.555153949093789_REALK,      0.000000000000000_REALK,      5.485662499378424_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.684397159662685_REALK, &
      0.000000000000000_REALK,     -0.191744736232476_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.240232086824135_REALK,      0.000000000000000_REALK, &
     -1.287454651085958_REALK,      0.000000000000000_REALK,     -0.375876241399488_REALK, &
      0.000000000000000_REALK,     -0.823036964969121_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.623960491567285_REALK, &
      0.000000000000000_REALK,     -0.232713264693778_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.325469404195654_REALK,      0.000000000000000_REALK, &
     -1.583811403270873_REALK,      0.000000000000000_REALK,     -0.798499650045956_REALK, &
      0.000000000000000_REALK,     -1.101537338021264_REALK,      0.000000000000000_REALK, &
      0.560947747562515_REALK,      0.167204912005736_REALK,      0.000000000000000_REALK, &
      0.231195589924382_REALK,      0.000000000000000_REALK,      0.905311906655699_REALK, &
      0.168879485819812_REALK,      0.000000000000000_REALK,      0.314537748450478_REALK, &
      0.000000000000000_REALK,      0.598842038121476_REALK,      0.000000000000000_REALK, &
      0.992374134405991_REALK,      0.000000000000000_REALK,      5.440291348291835_REALK, &
      0.454243578441634_REALK,      0.190003275419086_REALK,      0.000000000000000_REALK, &
      0.191053361939282_REALK,      0.000000000000000_REALK,      1.267738381365247_REALK, &
     -0.014099600908961_REALK,      0.000000000000000_REALK,      0.482289116594033_REALK, &
      0.000000000000000_REALK,     -0.857141031603822_REALK,      0.000000000000000_REALK, &
      0.904342139703721_REALK,      0.000000000000000_REALK,      8.401092345361764_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.526285301643273_REALK, &
      0.000000000000000_REALK,     -0.425912603787692_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.439134824635592_REALK,      0.000000000000000_REALK, &
     -1.386031238975131_REALK,      0.000000000000000_REALK,     -1.542171365118088_REALK, &
      0.000000000000000_REALK,     -2.559436848758740_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.213557394212391_REALK, &
      0.000000000000000_REALK,     -1.438873502228278_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.862719392000750_REALK,      0.000000000000000_REALK, &
     -4.312555829471150_REALK,      0.000000000000000_REALK,     -6.842858600718072_REALK, &
      0.000000000000000_REALK,     -9.535176455331412_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.723503111410353_REALK, &
      0.000000000000000_REALK,      0.669949291607843_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.956463412000856_REALK,      0.000000000000000_REALK, &
     -3.569373111163676_REALK,      0.000000000000000_REALK,      1.095537490333488_REALK, &
      0.000000000000000_REALK,      1.312864219607824_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.189467712714712_REALK, &
      0.000000000000000_REALK,      0.638763971677457_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.681403121414625_REALK,      0.000000000000000_REALK, &
     -2.987946320510269_REALK,      0.000000000000000_REALK,      1.107238718926739_REALK, &
      0.000000000000000_REALK,      1.167158191191225_REALK,      0.000000000000000_REALK, &
      2.347884581401607_REALK,     -0.104822268774508_REALK,      0.000000000000000_REALK, &
      0.456843746872740_REALK,      0.000000000000000_REALK,      1.855129299802869_REALK, &
     -0.102215338646677_REALK,      0.000000000000000_REALK,     -0.100483275136350_REALK, &
      0.000000000000000_REALK,      0.670727306256096_REALK,      0.000000000000000_REALK, &
      0.895252546325363_REALK,      0.000000000000000_REALK,      6.058998073849622_REALK, &
      2.742989015543888_REALK,     -0.132741071519980_REALK,      0.000000000000000_REALK, &
      0.445632527771832_REALK,      0.000000000000000_REALK,      1.863435750580855_REALK, &
      0.003412475783016_REALK,      0.000000000000000_REALK,     -0.124354040220439_REALK, &
      0.000000000000000_REALK,      1.116922656369187_REALK,      0.000000000000000_REALK, &
      0.814265797872491_REALK,      0.000000000000000_REALK,      5.674825121861133_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.946938555561580_REALK, &
      0.000000000000000_REALK,     -0.070013697700128_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.231401267947132_REALK,      0.000000000000000_REALK, &
     -1.512901926409044_REALK,      0.000000000000000_REALK,     -0.066458450613736_REALK, &
      0.000000000000000_REALK,     -0.228670238539837_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.318305431421176_REALK, &
      0.000000000000000_REALK,     -0.054630968058490_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.208306931189868_REALK,      0.000000000000000_REALK, &
     -2.058350701916397_REALK,      0.000000000000000_REALK,      0.223131554367697_REALK, &
      0.000000000000000_REALK,     -0.166370742792325_REALK,      0.000000000000000_REALK, &
      0.690922842876072_REALK,      0.117947374121806_REALK,      0.000000000000000_REALK, &
      0.169775420644303_REALK,      0.000000000000000_REALK,      0.909862449426236_REALK, &
      0.086060286426932_REALK,      0.000000000000000_REALK,      0.188441803827433_REALK, &
      0.000000000000000_REALK,      0.291210824886596_REALK,      0.000000000000000_REALK, &
      0.554499865200853_REALK,      0.000000000000000_REALK,      4.160355162725566_REALK, &
      1.420545871042655_REALK,      0.264719649776340_REALK,      0.000000000000000_REALK, &
      0.330522531201913_REALK,      0.000000000000000_REALK,      1.608401119144371_REALK, &
      0.299616010889902_REALK,      0.000000000000000_REALK,      0.413322940148086_REALK, &
      0.000000000000000_REALK,      1.073383069896434_REALK,      0.000000000000000_REALK, &
      1.006558751929644_REALK,      0.000000000000000_REALK,      6.857415450866440_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.556881843274087_REALK, &
      0.000000000000000_REALK,     -0.222288284873389_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.227213089956620_REALK,      0.000000000000000_REALK, &
     -1.245604217858373_REALK,      0.000000000000000_REALK,     -0.389804931390485_REALK, &
      0.000000000000000_REALK,     -1.016415408911092_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.442097685169061_REALK, &
      0.000000000000000_REALK,     -0.489776972989963_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.339330623829419_REALK,      0.000000000000000_REALK, &
     -3.152289140627818_REALK,      0.000000000000000_REALK,      0.043604948762244_REALK, &
      0.000000000000000_REALK,     -2.088163295886450_REALK,      0.000000000000000_REALK, &
      0.531303398387097_REALK,      0.261990363903564_REALK,      0.000000000000000_REALK, &
      0.310342804567354_REALK,      0.000000000000000_REALK,      0.979527921244812_REALK, &
      0.353094169791961_REALK,      0.000000000000000_REALK,      0.586006360699235_REALK, &
      0.000000000000000_REALK,      1.077665619037063_REALK,      0.000000000000000_REALK, &
      1.419045582121471_REALK,      0.000000000000000_REALK,      5.758587296164655_REALK, &
      2.762857534924223_REALK,      1.636769997118730_REALK,      0.000000000000000_REALK, &
      1.891639338218311_REALK,      0.000000000000000_REALK,      4.379511100986618_REALK, &
      2.567602874857624_REALK,      0.000000000000000_REALK,      3.577824401692960_REALK, &
      0.000000000000000_REALK,      7.329958669110840_REALK,      0.000000000000000_REALK, &
      8.065001118791599_REALK,      0.000000000000000_REALK,     24.006906220020142_REALK/
    ! results of test 2, ket-major order, CM010101
  data REF_CONTR_INTS(7561:8820)                                                           &
     /0.000000000000000_REALK,      0.000000000000000_REALK,     -0.351684171107253_REALK, &
      0.000000000000000_REALK,     -0.226914030074071_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.173037491748907_REALK,      0.000000000000000_REALK, &
     -0.256534258489637_REALK,      0.000000000000000_REALK,     -0.088688278478817_REALK, &
      0.000000000000000_REALK,     -0.247368090581101_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.089348812143350_REALK, &
      0.000000000000000_REALK,      0.091800885907449_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.386069227949993_REALK,      0.000000000000000_REALK, &
     -0.061789247489869_REALK,      0.000000000000000_REALK,      1.331560829163928_REALK, &
      0.000000000000000_REALK,      0.095155540470499_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.339163968706014_REALK, &
      0.000000000000000_REALK,     -0.197682580973954_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.178010345113580_REALK,      0.000000000000000_REALK, &
     -0.215144882886916_REALK,      0.000000000000000_REALK,     -0.231919265271205_REALK, &
      0.000000000000000_REALK,     -0.177688671291870_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.183974736257554_REALK, &
      0.000000000000000_REALK,     -0.157170543558570_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.219667403840307_REALK,      0.000000000000000_REALK, &
     -0.135739805771322_REALK,      0.000000000000000_REALK,     -0.483852400292059_REALK, &
      0.000000000000000_REALK,     -0.142357356423454_REALK,      0.000000000000000_REALK, &
      0.298275017314338_REALK,      0.164087924192330_REALK,      0.000000000000000_REALK, &
      0.105063310024795_REALK,      0.000000000000000_REALK,      0.155760107588638_REALK, &
      0.037318182280638_REALK,      0.000000000000000_REALK,      0.104087345622837_REALK, &
      0.000000000000000_REALK,     -0.134354693488454_REALK,      0.000000000000000_REALK, &
      0.094437050891658_REALK,      0.000000000000000_REALK,      0.233343831824939_REALK, &
      0.055917615118965_REALK,     -0.071497513384724_REALK,      0.000000000000000_REALK, &
     -0.283609603141107_REALK,      0.000000000000000_REALK,      0.045390885080484_REALK, &
     -0.738187866946589_REALK,      0.000000000000000_REALK,     -0.052752126609321_REALK, &
      0.000000000000000_REALK,     -2.086422173435828_REALK,      0.000000000000000_REALK, &
     -0.256879644527205_REALK,      0.000000000000000_REALK,      0.068521389350656_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.351890562868235_REALK, &
      0.000000000000000_REALK,     -0.156350530016504_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.116739789092141_REALK,      0.000000000000000_REALK, &
     -0.192400227851281_REALK,      0.000000000000000_REALK,     -0.109415753589872_REALK, &
      0.000000000000000_REALK,     -0.115700548125248_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.217154022953119_REALK, &
      0.000000000000000_REALK,     -0.065677796753976_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.004894662473346_REALK,      0.000000000000000_REALK, &
     -0.107044929679175_REALK,      0.000000000000000_REALK,      0.134530844623107_REALK, &
      0.000000000000000_REALK,     -0.044208620203189_REALK,      0.000000000000000_REALK, &
      0.325178677416417_REALK,      0.162498186687140_REALK,      0.000000000000000_REALK, &
      0.122531061843461_REALK,      0.000000000000000_REALK,      0.148092128766452_REALK, &
      0.115964101613311_REALK,      0.000000000000000_REALK,      0.088847759625008_REALK, &
      0.000000000000000_REALK,      0.159944178558548_REALK,      0.000000000000000_REALK, &
      0.090673891646933_REALK,      0.000000000000000_REALK,      0.182648783575221_REALK, &
      0.358586258464748_REALK,      0.202941349911583_REALK,      0.000000000000000_REALK, &
      0.213150467039273_REALK,      0.000000000000000_REALK,      0.131712773448222_REALK, &
      0.340017877408335_REALK,      0.000000000000000_REALK,      0.100038867504527_REALK, &
      0.000000000000000_REALK,      0.772439015076527_REALK,      0.000000000000000_REALK, &
      0.143474484668993_REALK,      0.000000000000000_REALK,      0.147762771821073_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.128037255061347_REALK, &
      0.000000000000000_REALK,     -0.071647144863945_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.047220345204420_REALK,      0.000000000000000_REALK, &
     -0.116676412340921_REALK,      0.000000000000000_REALK,     -0.019008922287163_REALK, &
      0.000000000000000_REALK,     -0.088365694821464_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.058609503303539_REALK, &
      0.000000000000000_REALK,      0.051187113916390_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.180517181332212_REALK,      0.000000000000000_REALK, &
     -0.048152075612350_REALK,      0.000000000000000_REALK,      0.482143103380326_REALK, &
      0.000000000000000_REALK,      0.057424573454754_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.423188101621591_REALK, &
      0.000000000000000_REALK,     -0.142927131566224_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.096683055321417_REALK,      0.000000000000000_REALK, &
     -0.197976151950754_REALK,      0.000000000000000_REALK,     -0.078651600504338_REALK, &
      0.000000000000000_REALK,     -0.086860331665845_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.234882672339263_REALK, &
      0.000000000000000_REALK,     -0.107032013887446_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.102926710597821_REALK,      0.000000000000000_REALK, &
     -0.128603883262382_REALK,      0.000000000000000_REALK,     -0.161780861666867_REALK, &
      0.000000000000000_REALK,     -0.065291952961415_REALK,      0.000000000000000_REALK, &
      0.385594517588236_REALK,      0.147833539945339_REALK,      0.000000000000000_REALK, &
      0.092597208615155_REALK,      0.000000000000000_REALK,      0.152610555274232_REALK, &
      0.065402875959424_REALK,      0.000000000000000_REALK,      0.069159589448493_REALK, &
      0.000000000000000_REALK,      0.056707369415341_REALK,      0.000000000000000_REALK, &
      0.056273600145100_REALK,      0.000000000000000_REALK,      0.154575310527922_REALK, &
      0.171829232930367_REALK,      0.066300176240069_REALK,      0.000000000000000_REALK, &
     -0.004843805899442_REALK,      0.000000000000000_REALK,      0.105932710316362_REALK, &
     -0.110467034251739_REALK,      0.000000000000000_REALK,      0.036300932889326_REALK, &
      0.000000000000000_REALK,     -0.351478381905431_REALK,      0.000000000000000_REALK, &
     -0.002954831320591_REALK,      0.000000000000000_REALK,      0.107702254802700_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.140025004272608_REALK, &
      0.000000000000000_REALK,     -0.070473440092414_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.054199994914549_REALK,      0.000000000000000_REALK, &
     -0.109177658101106_REALK,      0.000000000000000_REALK,     -0.055899685412508_REALK, &
      0.000000000000000_REALK,     -0.071380736847991_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.132960917148257_REALK, &
      0.000000000000000_REALK,     -0.098999442603171_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.117810906908244_REALK,      0.000000000000000_REALK, &
     -0.121332139269768_REALK,      0.000000000000000_REALK,     -0.205263484295027_REALK, &
      0.000000000000000_REALK,     -0.100653170873560_REALK,      0.000000000000000_REALK, &
      0.140300618454462_REALK,      0.067744260611687_REALK,      0.000000000000000_REALK, &
      0.037454857420739_REALK,      0.000000000000000_REALK,      0.092546938606105_REALK, &
      0.011362515411901_REALK,      0.000000000000000_REALK,      0.052820278505229_REALK, &
      0.000000000000000_REALK,     -0.032383618889599_REALK,      0.000000000000000_REALK, &
      0.037937062781707_REALK,      0.000000000000000_REALK,      0.131233782924371_REALK, &
      0.046376419179907_REALK,     -0.051672176010864_REALK,      0.000000000000000_REALK, &
     -0.178641569801616_REALK,      0.000000000000000_REALK,      0.047651765406007_REALK, &
     -0.395901169464643_REALK,      0.000000000000000_REALK,     -0.047152921253780_REALK, &
      0.000000000000000_REALK,     -0.885117620107567_REALK,      0.000000000000000_REALK, &
     -0.181625673615531_REALK,      0.000000000000000_REALK,      0.067826864713656_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.594797584970999_REALK, &
      0.000000000000000_REALK,     -0.143916315920696_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.088032546298649_REALK,      0.000000000000000_REALK, &
     -0.234043297667355_REALK,      0.000000000000000_REALK,     -0.052855300370187_REALK, &
      0.000000000000000_REALK,     -0.071175610869397_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.538850575915445_REALK, &
      0.000000000000000_REALK,     -0.098621419383673_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.017199648276786_REALK,      0.000000000000000_REALK, &
     -0.178740446177868_REALK,      0.000000000000000_REALK,      0.071064753896759_REALK, &
      0.000000000000000_REALK,     -0.041529999789194_REALK,      0.000000000000000_REALK, &
      0.551664499520554_REALK,      0.160013525574356_REALK,      0.000000000000000_REALK, &
      0.090645271726214_REALK,      0.000000000000000_REALK,      0.185612691171449_REALK, &
      0.057012460925790_REALK,      0.000000000000000_REALK,      0.062962752612097_REALK, &
      0.000000000000000_REALK,      0.052186980636392_REALK,      0.000000000000000_REALK, &
      0.044829750860847_REALK,      0.000000000000000_REALK,      0.152995123065367_REALK, &
      0.753169714522225_REALK,      0.226180895027066_REALK,      0.000000000000000_REALK, &
      0.159379436880276_REALK,      0.000000000000000_REALK,      0.199139896494554_REALK, &
      0.185899357920508_REALK,      0.000000000000000_REALK,      0.075025760203309_REALK, &
      0.000000000000000_REALK,      0.340267392689466_REALK,      0.000000000000000_REALK, &
      0.067115521368530_REALK,      0.000000000000000_REALK,      0.139764767652628_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.170854565691576_REALK, &
      0.000000000000000_REALK,     -0.064840625455941_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.040791241485913_REALK,      0.000000000000000_REALK, &
     -0.112047546331608_REALK,      0.000000000000000_REALK,     -0.030325837605117_REALK, &
      0.000000000000000_REALK,     -0.053446234784149_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.223857838059496_REALK, &
      0.000000000000000_REALK,     -0.056211086592832_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.003395341325307_REALK,      0.000000000000000_REALK, &
     -0.123758643687045_REALK,      0.000000000000000_REALK,      0.072032347626561_REALK, &
      0.000000000000000_REALK,     -0.039451308328684_REALK,      0.000000000000000_REALK, &
      0.182535434258227_REALK,      0.078898271342662_REALK,      0.000000000000000_REALK, &
      0.050815246273050_REALK,      0.000000000000000_REALK,      0.102359596023381_REALK, &
      0.040520200605056_REALK,      0.000000000000000_REALK,      0.051742004540336_REALK, &
      0.000000000000000_REALK,      0.044330373147468_REALK,      0.000000000000000_REALK, &
      0.041885524142102_REALK,      0.000000000000000_REALK,      0.118120837795914_REALK, &
      0.426349611122108_REALK,      0.209206402102393_REALK,      0.000000000000000_REALK, &
      0.182427242572230_REALK,      0.000000000000000_REALK,      0.187879782808333_REALK, &
      0.235864425135440_REALK,      0.000000000000000_REALK,      0.115658673376259_REALK, &
      0.000000000000000_REALK,      0.413589878292892_REALK,      0.000000000000000_REALK, &
      0.128035123149291_REALK,      0.000000000000000_REALK,      0.184606723787121_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.103610572500819_REALK, &
      0.000000000000000_REALK,     -0.049521692108753_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.027499571472319_REALK,      0.000000000000000_REALK, &
     -0.095127891525953_REALK,      0.000000000000000_REALK,     -0.008780903288838_REALK, &
      0.000000000000000_REALK,     -0.057146999286917_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.100698086093049_REALK, &
      0.000000000000000_REALK,      0.073015119137078_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.208702659629373_REALK,      0.000000000000000_REALK, &
     -0.077938579817888_REALK,      0.000000000000000_REALK,      0.430259441316693_REALK, &
      0.000000000000000_REALK,      0.071743120677189_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.986992246091565_REALK, &
      0.000000000000000_REALK,     -0.162158318918452_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.098328995041904_REALK,      0.000000000000000_REALK, &
     -0.323779657909783_REALK,      0.000000000000000_REALK,     -0.044176011221348_REALK, &
      0.000000000000000_REALK,     -0.064657504513207_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.707324543674683_REALK, &
      0.000000000000000_REALK,     -0.156252354560682_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.125230759856360_REALK,      0.000000000000000_REALK, &
     -0.283556048164243_REALK,      0.000000000000000_REALK,     -0.140014347263611_REALK, &
      0.000000000000000_REALK,     -0.063971978503509_REALK,      0.000000000000000_REALK, &
      0.931920696899751_REALK,      0.195118690965601_REALK,      0.000000000000000_REALK, &
      0.100350484732249_REALK,      0.000000000000000_REALK,      0.266791764600059_REALK, &
      0.047532650804593_REALK,      0.000000000000000_REALK,      0.064008064159388_REALK, &
      0.000000000000000_REALK,      0.033552602132950_REALK,      0.000000000000000_REALK, &
      0.040012821807439_REALK,      0.000000000000000_REALK,      0.177296790761521_REALK, &
      0.549258519016639_REALK,      0.135179064950792_REALK,      0.000000000000000_REALK, &
      0.024775221320820_REALK,      0.000000000000000_REALK,      0.257466550581485_REALK, &
     -0.092730361438337_REALK,      0.000000000000000_REALK,      0.054191306939313_REALK, &
      0.000000000000000_REALK,     -0.266838005284462_REALK,      0.000000000000000_REALK, &
      0.010143334673012_REALK,      0.000000000000000_REALK,      0.175684228732425_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.251649752818385_REALK, &
      0.000000000000000_REALK,     -0.071772804608715_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.040315292475898_REALK,      0.000000000000000_REALK, &
     -0.137588164451597_REALK,      0.000000000000000_REALK,     -0.025913477864064_REALK, &
      0.000000000000000_REALK,     -0.047696704357253_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.272958401640972_REALK, &
      0.000000000000000_REALK,     -0.108070803768037_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.087577121053114_REALK,      0.000000000000000_REALK, &
     -0.182375041213849_REALK,      0.000000000000000_REALK,     -0.109632439718598_REALK, &
      0.000000000000000_REALK,     -0.073742922199410_REALK,      0.000000000000000_REALK, &
      0.267692589800210_REALK,      0.087909545762175_REALK,      0.000000000000000_REALK, &
      0.046498948718974_REALK,      0.000000000000000_REALK,      0.127725779387214_REALK, &
      0.027271956438524_REALK,      0.000000000000000_REALK,      0.048064076772293_REALK, &
      0.000000000000000_REALK,      0.018683474368620_REALK,      0.000000000000000_REALK, &
      0.030900932770609_REALK,      0.000000000000000_REALK,      0.118832450257750_REALK, &
      0.228181670575256_REALK,      0.077047787113324_REALK,      0.000000000000000_REALK, &
     -0.004890817035355_REALK,      0.000000000000000_REALK,      0.178268051669952_REALK, &
     -0.093992946775935_REALK,      0.000000000000000_REALK,      0.051478882004558_REALK, &
      0.000000000000000_REALK,     -0.238182885908867_REALK,      0.000000000000000_REALK, &
     -0.003337285627151_REALK,      0.000000000000000_REALK,      0.170299555932016_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.138776970881158_REALK, &
      0.000000000000000_REALK,     -0.058981995352333_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.037667556117737_REALK,      0.000000000000000_REALK, &
     -0.106225799425521_REALK,      0.000000000000000_REALK,     -0.030695608889003_REALK, &
      0.000000000000000_REALK,     -0.054875179172409_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.257524313905717_REALK, &
      0.000000000000000_REALK,     -0.166600455105629_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.167069364141951_REALK,      0.000000000000000_REALK, &
     -0.240888025104493_REALK,      0.000000000000000_REALK,     -0.231831465689087_REALK, &
      0.000000000000000_REALK,     -0.159153495294203_REALK,      0.000000000000000_REALK, &
      0.162335623699369_REALK,      0.067140460599242_REALK,      0.000000000000000_REALK, &
      0.031347444135200_REALK,      0.000000000000000_REALK,      0.108438644882553_REALK, &
      0.007896646255986_REALK,      0.000000000000000_REALK,      0.051392165830307_REALK, &
      0.000000000000000_REALK,     -0.017782477531139_REALK,      0.000000000000000_REALK, &
      0.029164774830700_REALK,      0.000000000000000_REALK,      0.129713459371006_REALK, &
      0.102643077890961_REALK,     -0.100080850528246_REALK,      0.000000000000000_REALK, &
     -0.300625599974640_REALK,      0.000000000000000_REALK,      0.112266572742930_REALK, &
     -0.561433218547651_REALK,      0.000000000000000_REALK,     -0.093615542815710_REALK, &
      0.000000000000000_REALK,     -0.999681535571331_REALK,      0.000000000000000_REALK, &
     -0.287187780973019_REALK,      0.000000000000000_REALK,      0.137890685840209_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.074631938467566_REALK, &
      0.000000000000000_REALK,     -0.912826875983037_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.035609460463269_REALK,      0.000000000000000_REALK, &
     -0.120726083787108_REALK,      0.000000000000000_REALK,     -1.554748525677607_REALK, &
      0.000000000000000_REALK,     -3.662095705515789_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.076126358560218_REALK, &
      0.000000000000000_REALK,     -0.024674120504196_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.001987252091226_REALK,      0.000000000000000_REALK, &
      0.006355376807098_REALK,      0.000000000000000_REALK,      7.016776367997946_REALK, &
      0.000000000000000_REALK,     -0.115267163314010_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.653210112525025_REALK, &
      0.000000000000000_REALK,     -0.385535877055083_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.271205188773874_REALK,      0.000000000000000_REALK, &
     -0.993388245058163_REALK,      0.000000000000000_REALK,     -0.945974961062015_REALK, &
      0.000000000000000_REALK,     -1.442876863692811_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.236013854010777_REALK, &
      0.000000000000000_REALK,     -0.268409251803503_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.225011288870291_REALK,      0.000000000000000_REALK, &
     -0.600457753812319_REALK,      0.000000000000000_REALK,     -2.309829354210094_REALK, &
      0.000000000000000_REALK,     -1.197970261827719_REALK,      0.000000000000000_REALK, &
      1.061162321019866_REALK,      0.110642897426023_REALK,      0.000000000000000_REALK, &
      0.406918649271663_REALK,      0.000000000000000_REALK,      1.379568640114066_REALK, &
      0.071436492199449_REALK,      0.000000000000000_REALK,      0.168263398858474_REALK, &
      0.000000000000000_REALK,      0.313151308753437_REALK,      0.000000000000000_REALK, &
      1.522902379213142_REALK,      0.000000000000000_REALK,      8.605112135959704_REALK, &
      0.384402561513886_REALK,      0.002678952300192_REALK,      0.000000000000000_REALK, &
     -0.247230251782250_REALK,      0.000000000000000_REALK,      0.790660337018882_REALK, &
     -0.414898601817271_REALK,      0.000000000000000_REALK,      0.006815691763035_REALK, &
      0.000000000000000_REALK,     -8.064043715033666_REALK,      0.000000000000000_REALK, &
     -1.103443668462435_REALK,      0.000000000000000_REALK,      5.881488588731164_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.183795896847283_REALK, &
      0.000000000000000_REALK,     -0.062680146470629_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.366022858843590_REALK,      0.000000000000000_REALK, &
     -1.533726046799101_REALK,      0.000000000000000_REALK,      0.023653566773730_REALK, &
      0.000000000000000_REALK,     -0.201430178685361_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.691146939861557_REALK, &
      0.000000000000000_REALK,      0.027234914929189_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.110647438993780_REALK,      0.000000000000000_REALK, &
     -0.972923270692739_REALK,      0.000000000000000_REALK,      0.926289764463966_REALK, &
      0.000000000000000_REALK,      0.096424231716206_REALK,      0.000000000000000_REALK, &
      1.012989919036071_REALK,      0.106313289649060_REALK,      0.000000000000000_REALK, &
      0.318149955747695_REALK,      0.000000000000000_REALK,      1.165340632435498_REALK, &
      0.090304395780085_REALK,      0.000000000000000_REALK,      0.137739505509281_REALK, &
      0.000000000000000_REALK,      0.826026326775381_REALK,      0.000000000000000_REALK, &
      1.022413093195733_REALK,      0.000000000000000_REALK,      6.241603469842611_REALK, &
      0.806598388679349_REALK,      0.116129261536575_REALK,      0.000000000000000_REALK, &
      0.324976278045644_REALK,      0.000000000000000_REALK,      0.867221048940625_REALK, &
      0.315198197242485_REALK,      0.000000000000000_REALK,      0.163474442902010_REALK, &
      0.000000000000000_REALK,      2.958802124796852_REALK,      0.000000000000000_REALK, &
      1.150566763950471_REALK,      0.000000000000000_REALK,      5.117274620319637_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.380422391678614_REALK, &
      0.000000000000000_REALK,     -0.197389265090408_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.145378878773390_REALK,      0.000000000000000_REALK, &
     -0.821458795468875_REALK,      0.000000000000000_REALK,     -0.269307550076372_REALK, &
      0.000000000000000_REALK,     -1.057223516975553_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.342085082564446_REALK, &
      0.000000000000000_REALK,     -0.009843675633245_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.150575389659871_REALK,      0.000000000000000_REALK, &
     -0.802585090059295_REALK,      0.000000000000000_REALK,      2.121531519850343_REALK, &
      0.000000000000000_REALK,     -0.058085296188555_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.843012296898804_REALK, &
      0.000000000000000_REALK,      0.214811755735324_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.507549254709918_REALK,      0.000000000000000_REALK, &
     -2.080191058788536_REALK,      0.000000000000000_REALK,      0.501828697189153_REALK, &
      0.000000000000000_REALK,      0.553229316081151_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.956799668596188_REALK, &
      0.000000000000000_REALK,      0.132447793811904_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.375105381043403_REALK,      0.000000000000000_REALK, &
     -1.457198248525664_REALK,      0.000000000000000_REALK,     -0.109119465925366_REALK, &
      0.000000000000000_REALK,      0.376161256852295_REALK,      0.000000000000000_REALK, &
      1.232200095623984_REALK,      0.027650627951370_REALK,      0.000000000000000_REALK, &
      0.284753275179400_REALK,      0.000000000000000_REALK,      1.193186448610916_REALK, &
     -0.003664815295388_REALK,      0.000000000000000_REALK,      0.031209009907917_REALK, &
      0.000000000000000_REALK,      0.480676557590064_REALK,      0.000000000000000_REALK, &
      0.733357721229508_REALK,      0.000000000000000_REALK,      5.121582853342923_REALK, &
      0.525872729988093_REALK,     -0.014482884008964_REALK,      0.000000000000000_REALK, &
      0.100146440654388_REALK,      0.000000000000000_REALK,      0.880587960062783_REALK, &
     -0.211891411867978_REALK,      0.000000000000000_REALK,     -0.022057316598392_REALK, &
      0.000000000000000_REALK,     -0.990393000716567_REALK,      0.000000000000000_REALK, &
      0.284423091556643_REALK,      0.000000000000000_REALK,      4.168221861772831_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.514076658694253_REALK, &
      0.000000000000000_REALK,     -0.107156627974755_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.158409730675815_REALK,      0.000000000000000_REALK, &
     -0.967056008205597_REALK,      0.000000000000000_REALK,     -0.180932486335752_REALK, &
      0.000000000000000_REALK,     -0.459954560409622_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.461167655364264_REALK, &
      0.000000000000000_REALK,     -0.147959896256756_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.263195411862202_REALK,      0.000000000000000_REALK, &
     -1.170591089110407_REALK,      0.000000000000000_REALK,     -0.810227932323204_REALK, &
      0.000000000000000_REALK,     -0.700361238415159_REALK,      0.000000000000000_REALK, &
      0.395977472681141_REALK,      0.087076011112491_REALK,      0.000000000000000_REALK, &
      0.113099799295108_REALK,      0.000000000000000_REALK,      0.639066869139567_REALK, &
      0.041725733718078_REALK,      0.000000000000000_REALK,      0.163803157161030_REALK, &
      0.000000000000000_REALK,      0.059895078859640_REALK,      0.000000000000000_REALK, &
      0.485464776658085_REALK,      0.000000000000000_REALK,      3.840344895057449_REALK, &
      0.260282156920787_REALK,      0.005234634027271_REALK,      0.000000000000000_REALK, &
     -0.136285028028814_REALK,      0.000000000000000_REALK,      0.726415729298882_REALK, &
     -0.485306354781590_REALK,      0.000000000000000_REALK,      0.013287176313866_REALK, &
      0.000000000000000_REALK,     -2.828656347918840_REALK,      0.000000000000000_REALK, &
     -0.645098796514913_REALK,      0.000000000000000_REALK,      4.813836760539776_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.999766574749390_REALK, &
      0.000000000000000_REALK,      0.627328160981277_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.785613710426090_REALK,      0.000000000000000_REALK, &
     -2.875594791062879_REALK,      0.000000000000000_REALK,      1.010575410301437_REALK, &
      0.000000000000000_REALK,      1.229341842467074_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.578122073510410_REALK, &
      0.000000000000000_REALK,      0.600137663248782_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.544439932307785_REALK,      0.000000000000000_REALK, &
     -2.415227573134792_REALK,      0.000000000000000_REALK,      1.109175507400391_REALK, &
      0.000000000000000_REALK,      1.096579676627209_REALK,      0.000000000000000_REALK, &
      1.860585301459293_REALK,     -0.132136521801347_REALK,      0.000000000000000_REALK, &
      0.358692251960332_REALK,      0.000000000000000_REALK,      1.470100504454604_REALK, &
     -0.114898247509749_REALK,      0.000000000000000_REALK,     -0.126666887016989_REALK, &
      0.000000000000000_REALK,      0.533054655383181_REALK,      0.000000000000000_REALK, &
      0.702910249101250_REALK,      0.000000000000000_REALK,      4.801463771717863_REALK, &
      2.178307500247759_REALK,     -0.150664095738903_REALK,      0.000000000000000_REALK, &
      0.380929139303654_REALK,      0.000000000000000_REALK,      1.479822211725200_REALK, &
      0.040944212172307_REALK,      0.000000000000000_REALK,     -0.141144626954977_REALK, &
      0.000000000000000_REALK,      1.225367156665843_REALK,      0.000000000000000_REALK, &
      0.696038889034564_REALK,      0.000000000000000_REALK,      4.506585354696882_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.733961261292471_REALK, &
      0.000000000000000_REALK,     -0.022055849637137_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.167908924776482_REALK,      0.000000000000000_REALK, &
     -1.172633007281516_REALK,      0.000000000000000_REALK,      0.005075440872559_REALK, &
      0.000000000000000_REALK,     -0.072036138118638_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.001700254138173_REALK, &
      0.000000000000000_REALK,      0.022399770975830_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.106722291102156_REALK,      0.000000000000000_REALK, &
     -1.564015722056457_REALK,      0.000000000000000_REALK,      0.393181943970798_REALK, &
      0.000000000000000_REALK,      0.068215275475934_REALK,      0.000000000000000_REALK, &
      0.518978346807174_REALK,      0.065914940549116_REALK,      0.000000000000000_REALK, &
      0.111950401860038_REALK,      0.000000000000000_REALK,      0.683432187390930_REALK, &
      0.041426139465523_REALK,      0.000000000000000_REALK,      0.105310782785431_REALK, &
      0.000000000000000_REALK,      0.177243788255290_REALK,      0.000000000000000_REALK, &
      0.365638809817051_REALK,      0.000000000000000_REALK,      3.125000521757650_REALK, &
      1.049921938231378_REALK,      0.168309666273523_REALK,      0.000000000000000_REALK, &
      0.267281694094754_REALK,      0.000000000000000_REALK,      1.188765287266720_REALK, &
      0.304016740621339_REALK,      0.000000000000000_REALK,      0.262792150784016_REALK, &
      0.000000000000000_REALK,      1.255921867954324_REALK,      0.000000000000000_REALK, &
      0.813967893333439_REALK,      0.000000000000000_REALK,      5.068298791468806_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.393107318533467_REALK, &
      0.000000000000000_REALK,     -0.115762012799886_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.111151578971382_REALK,      0.000000000000000_REALK, &
     -0.879281915814378_REALK,      0.000000000000000_REALK,     -0.096310672017010_REALK, &
      0.000000000000000_REALK,     -0.529322962941504_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.826323835493705_REALK, &
      0.000000000000000_REALK,     -0.013493468483278_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.242056371634666_REALK,      0.000000000000000_REALK, &
     -1.806265747499183_REALK,      0.000000000000000_REALK,      1.500876434083585_REALK, &
      0.000000000000000_REALK,     -0.057529380054294_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -5.452045550729339_REALK, &
      0.000000000000000_REALK,      1.468463150890822_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.393767546721971_REALK,      0.000000000000000_REALK, &
     -4.296560445426539_REALK,      0.000000000000000_REALK,      1.752377998513675_REALK, &
      0.000000000000000_REALK,      2.107437931077934_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.270170868088049_REALK, &
      0.000000000000000_REALK,      1.464228511728938_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.447153417394344_REALK,      0.000000000000000_REALK, &
     -4.334892461554625_REALK,      0.000000000000000_REALK,      1.316824814557037_REALK, &
      0.000000000000000_REALK,      2.086525582721921_REALK,      0.000000000000000_REALK, &
      3.384895735521310_REALK,     -0.508514556170498_REALK,      0.000000000000000_REALK, &
      0.589000243643397_REALK,      0.000000000000000_REALK,      2.155927283444557_REALK, &
     -0.329428297868654_REALK,      0.000000000000000_REALK,     -0.400741979801235_REALK, &
      0.000000000000000_REALK,      0.714836850330105_REALK,      0.000000000000000_REALK, &
      0.845292886045683_REALK,      0.000000000000000_REALK,      5.156732432612318_REALK, &
      2.176223298542342_REALK,     -0.588965416114245_REALK,      0.000000000000000_REALK, &
      0.543527048927964_REALK,      0.000000000000000_REALK,      2.411177868145932_REALK, &
     -0.604759844888001_REALK,      0.000000000000000_REALK,     -0.597892173709002_REALK, &
      0.000000000000000_REALK,     -0.010244985685630_REALK,      0.000000000000000_REALK, &
      0.774526027464414_REALK,      0.000000000000000_REALK,      5.726547309248070_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.191668973347856_REALK, &
      0.000000000000000_REALK,      0.094966300007790_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.229135326820180_REALK,      0.000000000000000_REALK, &
     -1.565185558120022_REALK,      0.000000000000000_REALK,      0.123626497285073_REALK, &
      0.000000000000000_REALK,      0.227148569905816_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.452273633328917_REALK, &
      0.000000000000000_REALK,      0.140907964328942_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.379503845658404_REALK,      0.000000000000000_REALK, &
     -2.457142122141367_REALK,      0.000000000000000_REALK,     -0.058247670899256_REALK, &
      0.000000000000000_REALK,      0.334656407824447_REALK,      0.000000000000000_REALK, &
      0.828191888095253_REALK,      0.017878554298676_REALK,      0.000000000000000_REALK, &
      0.125886801987722_REALK,      0.000000000000000_REALK,      0.879161244040026_REALK, &
     -0.001654496864397_REALK,      0.000000000000000_REALK,      0.023482406284134_REALK, &
      0.000000000000000_REALK,      0.118415625640292_REALK,      0.000000000000000_REALK, &
      0.301106887803169_REALK,      0.000000000000000_REALK,      2.943994943443101_REALK, &
      0.845547017966865_REALK,     -0.021982773689334_REALK,      0.000000000000000_REALK, &
      0.106543345730918_REALK,      0.000000000000000_REALK,      1.561393276725541_REALK, &
     -0.214376038654006_REALK,      0.000000000000000_REALK,     -0.037193265755125_REALK, &
      0.000000000000000_REALK,     -0.528669060808290_REALK,      0.000000000000000_REALK, &
      0.253040440472702_REALK,      0.000000000000000_REALK,      5.191632529432837_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.553992690046164_REALK, &
      0.000000000000000_REALK,     -0.078954931534041_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.119191274124534_REALK,      0.000000000000000_REALK, &
     -1.018690532371265_REALK,      0.000000000000000_REALK,     -0.074288462895992_REALK, &
      0.000000000000000_REALK,     -0.264391681016286_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.166635065506588_REALK, &
      0.000000000000000_REALK,     -0.262351517074837_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.443802710780963_REALK,      0.000000000000000_REALK, &
     -2.763407206996932_REALK,      0.000000000000000_REALK,     -0.720829071072524_REALK, &
      0.000000000000000_REALK,     -0.872318774836887_REALK,      0.000000000000000_REALK, &
      0.443576942721723_REALK,      0.093837121018539_REALK,      0.000000000000000_REALK, &
      0.083333967096863_REALK,      0.000000000000000_REALK,      0.659226354851944_REALK, &
      0.031395441078154_REALK,      0.000000000000000_REALK,      0.172549184283635_REALK, &
      0.000000000000000_REALK,      0.024592119600126_REALK,      0.000000000000000_REALK, &
      0.279055496831077_REALK,      0.000000000000000_REALK,      2.838229800737817_REALK, &
      0.697509711203754_REALK,      0.013242272176448_REALK,      0.000000000000000_REALK, &
     -0.241650506404119_REALK,      0.000000000000000_REALK,      1.803237112230929_REALK, &
     -0.818328383034511_REALK,      0.000000000000000_REALK,      0.031366955658514_REALK, &
      0.000000000000000_REALK,     -2.516548302410755_REALK,      0.000000000000000_REALK, &
     -0.803487915890434_REALK,      0.000000000000000_REALK,      7.708838483019431_REALK/
    ! results of test 2, ket-major order, CM000201
  data REF_CONTR_INTS(8821:10080)                                                          &
     /0.000000000000000_REALK,      0.000000000000000_REALK,     -0.238513538929780_REALK, &
      0.000000000000000_REALK,     -0.137133371975413_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.134944617729044_REALK,      0.000000000000000_REALK, &
     -0.151298404708995_REALK,      0.000000000000000_REALK,     -0.212406340989265_REALK, &
      0.000000000000000_REALK,     -0.123263499171409_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.161479280240513_REALK, &
      0.000000000000000_REALK,     -0.182458368337911_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.323371549211423_REALK,      0.000000000000000_REALK, &
     -0.119142261496462_REALK,      0.000000000000000_REALK,     -0.804366517952623_REALK, &
      0.000000000000000_REALK,     -0.165261825694727_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.249012760627626_REALK, &
      0.000000000000000_REALK,     -0.100574183273471_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.070198987277737_REALK,      0.000000000000000_REALK, &
     -0.136150601744246_REALK,      0.000000000000000_REALK,     -0.055543739757800_REALK, &
      0.000000000000000_REALK,     -0.074425639176033_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.133134905643251_REALK, &
      0.000000000000000_REALK,     -0.009912115629711_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.071919339552928_REALK,      0.000000000000000_REALK, &
     -0.065628149175491_REALK,      0.000000000000000_REALK,      0.262112543609140_REALK, &
      0.000000000000000_REALK,     -0.006671980135471_REALK,      0.000000000000000_REALK, &
      0.228678528061226_REALK,      0.112725785805244_REALK,      0.000000000000000_REALK, &
      0.092887339159135_REALK,      0.000000000000000_REALK,      0.104144251685969_REALK, &
      0.106207263467254_REALK,      0.000000000000000_REALK,      0.061634124816712_REALK, &
      0.000000000000000_REALK,      0.191153133526345_REALK,      0.000000000000000_REALK, &
      0.068737317701918_REALK,      0.000000000000000_REALK,      0.128445860325177_REALK, &
      0.314740230636685_REALK,      0.235593430771344_REALK,      0.000000000000000_REALK, &
      0.313777991347938_REALK,      0.000000000000000_REALK,      0.115607633349861_REALK, &
      0.565252948889986_REALK,      0.000000000000000_REALK,      0.116134538457243_REALK, &
      0.000000000000000_REALK,      1.322584649423696_REALK,      0.000000000000000_REALK, &
      0.211208242864523_REALK,      0.000000000000000_REALK,      0.129695122957570_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.308983715217322_REALK, &
      0.000000000000000_REALK,     -0.095822239569706_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.064265852576005_REALK,      0.000000000000000_REALK, &
     -0.144548976494788_REALK,      0.000000000000000_REALK,     -0.051579792750133_REALK, &
      0.000000000000000_REALK,     -0.058233530742428_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.174646071983616_REALK, &
      0.000000000000000_REALK,     -0.086594361894087_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.104434776095693_REALK,      0.000000000000000_REALK, &
     -0.095622903256027_REALK,      0.000000000000000_REALK,     -0.199720385012791_REALK, &
      0.000000000000000_REALK,     -0.052824522291602_REALK,      0.000000000000000_REALK, &
      0.272863115523442_REALK,      0.095095536541252_REALK,      0.000000000000000_REALK, &
      0.055681360400597_REALK,      0.000000000000000_REALK,      0.107993733506235_REALK, &
      0.033201072080705_REALK,      0.000000000000000_REALK,      0.044487660026330_REALK, &
      0.000000000000000_REALK,      0.017133743942984_REALK,      0.000000000000000_REALK, &
      0.033838931622023_REALK,      0.000000000000000_REALK,      0.109384078065894_REALK, &
      0.105346741459518_REALK,      0.010006045355382_REALK,      0.000000000000000_REALK, &
     -0.071172082468905_REALK,      0.000000000000000_REALK,      0.064946258884402_REALK, &
     -0.215227930916506_REALK,      0.000000000000000_REALK,      0.005478549251785_REALK, &
      0.000000000000000_REALK,     -0.569316663735151_REALK,      0.000000000000000_REALK, &
     -0.043416582496639_REALK,      0.000000000000000_REALK,      0.066031148471140_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.098471130159072_REALK, &
      0.000000000000000_REALK,     -0.048887769610077_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.041087486179488_REALK,      0.000000000000000_REALK, &
     -0.076778054299547_REALK,      0.000000000000000_REALK,     -0.051196469715602_REALK, &
      0.000000000000000_REALK,     -0.049517165800989_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.116703160651154_REALK, &
      0.000000000000000_REALK,     -0.114927876144973_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.173428987710060_REALK,      0.000000000000000_REALK, &
     -0.106496288120208_REALK,      0.000000000000000_REALK,     -0.341234380620109_REALK, &
      0.000000000000000_REALK,     -0.116847679659407_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.443835286073869_REALK, &
      0.000000000000000_REALK,     -0.097003974529014_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.059023530098117_REALK,      0.000000000000000_REALK, &
     -0.174642057396596_REALK,      0.000000000000000_REALK,     -0.031846833482764_REALK, &
      0.000000000000000_REALK,     -0.047974526721950_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.385844203899152_REALK, &
      0.000000000000000_REALK,     -0.047021221884072_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.023420173624237_REALK,      0.000000000000000_REALK, &
     -0.127987179085618_REALK,      0.000000000000000_REALK,      0.124905309041686_REALK, &
      0.000000000000000_REALK,     -0.019800884504978_REALK,      0.000000000000000_REALK, &
      0.402788608569587_REALK,      0.107277423215304_REALK,      0.000000000000000_REALK, &
      0.060252498745542_REALK,      0.000000000000000_REALK,      0.135522002366982_REALK, &
      0.037388824891937_REALK,      0.000000000000000_REALK,      0.042211943237447_REALK, &
      0.000000000000000_REALK,      0.037039992081857_REALK,      0.000000000000000_REALK, &
      0.029798625521964_REALK,      0.000000000000000_REALK,      0.111706830493877_REALK, &
      0.560016330146038_REALK,      0.182991887811236_REALK,      0.000000000000000_REALK, &
      0.161714638582860_REALK,      0.000000000000000_REALK,      0.148069673899841_REALK, &
      0.229494953574712_REALK,      0.000000000000000_REALK,      0.060699669140640_REALK, &
      0.000000000000000_REALK,      0.457239147001148_REALK,      0.000000000000000_REALK, &
      0.068098887120332_REALK,      0.000000000000000_REALK,      0.103921534224447_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.120903972877000_REALK, &
      0.000000000000000_REALK,     -0.041709439344299_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.024528944795785_REALK,      0.000000000000000_REALK, &
     -0.079289619494664_REALK,      0.000000000000000_REALK,     -0.015394587859713_REALK, &
      0.000000000000000_REALK,     -0.034379873300657_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.137244945970847_REALK, &
      0.000000000000000_REALK,     -0.008483396482787_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.049889181736760_REALK,      0.000000000000000_REALK, &
     -0.075875155918104_REALK,      0.000000000000000_REALK,      0.140343888506984_REALK, &
      0.000000000000000_REALK,     -0.005954004994445_REALK,      0.000000000000000_REALK, &
      0.128366148595082_REALK,      0.054732116198320_REALK,      0.000000000000000_REALK, &
      0.038521603779537_REALK,      0.000000000000000_REALK,      0.071983322945844_REALK, &
      0.037110964182326_REALK,      0.000000000000000_REALK,      0.035893681276442_REALK, &
      0.000000000000000_REALK,      0.052980294837232_REALK,      0.000000000000000_REALK, &
      0.031752233501543_REALK,      0.000000000000000_REALK,      0.083067252549089_REALK, &
      0.374217839554008_REALK,      0.242866493359316_REALK,      0.000000000000000_REALK, &
      0.268550449532492_REALK,      0.000000000000000_REALK,      0.164906838388729_REALK, &
      0.392106035312779_REALK,      0.000000000000000_REALK,      0.134267480092385_REALK, &
      0.000000000000000_REALK,      0.708156389709290_REALK,      0.000000000000000_REALK, &
      0.188480017528502_REALK,      0.000000000000000_REALK,      0.162033991683352_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.750569938422225_REALK, &
      0.000000000000000_REALK,     -0.109656531482900_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.069156651033882_REALK,      0.000000000000000_REALK, &
     -0.246222074045726_REALK,      0.000000000000000_REALK,     -0.028630280643041_REALK, &
      0.000000000000000_REALK,     -0.043723428600810_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.538823736240440_REALK, &
      0.000000000000000_REALK,     -0.120046820968177_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.118730676866441_REALK,      0.000000000000000_REALK, &
     -0.216006542783990_REALK,      0.000000000000000_REALK,     -0.165379091769741_REALK, &
      0.000000000000000_REALK,     -0.049148908328344_REALK,      0.000000000000000_REALK, &
      0.695395037837666_REALK,      0.131515932766036_REALK,      0.000000000000000_REALK, &
      0.067282387082848_REALK,      0.000000000000000_REALK,      0.199078816315626_REALK, &
      0.028639784554551_REALK,      0.000000000000000_REALK,      0.043143382219360_REALK, &
      0.000000000000000_REALK,      0.018203436865008_REALK,      0.000000000000000_REALK, &
      0.026827555166358_REALK,      0.000000000000000_REALK,      0.132298068848843_REALK, &
      0.393296816366504_REALK,      0.064451362055582_REALK,      0.000000000000000_REALK, &
     -0.033735572703289_REALK,      0.000000000000000_REALK,      0.184359042524921_REALK, &
     -0.162985359378427_REALK,      0.000000000000000_REALK,      0.025837606918514_REALK, &
      0.000000000000000_REALK,     -0.388287739591202_REALK,      0.000000000000000_REALK, &
     -0.013811832390278_REALK,      0.000000000000000_REALK,      0.125798773171463_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.183737858558399_REALK, &
      0.000000000000000_REALK,     -0.048118441911215_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.026797835817262_REALK,      0.000000000000000_REALK, &
     -0.100457697320139_REALK,      0.000000000000000_REALK,     -0.016994082880613_REALK, &
      0.000000000000000_REALK,     -0.031977168935826_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.202957128283462_REALK, &
      0.000000000000000_REALK,     -0.087434795924846_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.088860286850370_REALK,      0.000000000000000_REALK, &
     -0.135604232779859_REALK,      0.000000000000000_REALK,     -0.135342542034281_REALK, &
      0.000000000000000_REALK,     -0.059661787722488_REALK,      0.000000000000000_REALK, &
      0.189430686183731_REALK,      0.056548773873932_REALK,      0.000000000000000_REALK, &
      0.027961153047613_REALK,      0.000000000000000_REALK,      0.090384205445244_REALK, &
      0.013844317672804_REALK,      0.000000000000000_REALK,      0.030917741472680_REALK, &
      0.000000000000000_REALK,      0.005645084035773_REALK,      0.000000000000000_REALK, &
      0.018581618172379_REALK,      0.000000000000000_REALK,      0.084090906700183_REALK, &
      0.139895843366966_REALK,      0.011628078477441_REALK,      0.000000000000000_REALK, &
     -0.071862836911095_REALK,      0.000000000000000_REALK,      0.109294315230849_REALK, &
     -0.183130719425567_REALK,      0.000000000000000_REALK,      0.007769210542017_REALK, &
      0.000000000000000_REALK,     -0.385803204252066_REALK,      0.000000000000000_REALK, &
     -0.049036144884592_REALK,      0.000000000000000_REALK,      0.104408912171023_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.097593463636791_REALK, &
      0.000000000000000_REALK,     -0.040916098265478_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.028554711007679_REALK,      0.000000000000000_REALK, &
     -0.074702190339645_REALK,      0.000000000000000_REALK,     -0.028112981303758_REALK, &
      0.000000000000000_REALK,     -0.038067179822277_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.226035605213265_REALK, &
      0.000000000000000_REALK,     -0.193405497714009_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.245942175142314_REALK,      0.000000000000000_REALK, &
     -0.211433513664487_REALK,      0.000000000000000_REALK,     -0.385401557780068_REALK, &
      0.000000000000000_REALK,     -0.184760365455085_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.729676685234179_REALK, &
      0.000000000000000_REALK,     -0.140426730935823_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.102227776636937_REALK,      0.000000000000000_REALK, &
     -0.434423634557052_REALK,      0.000000000000000_REALK,     -0.022505087606315_REALK, &
      0.000000000000000_REALK,     -0.042362576207300_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.635874918585516_REALK, &
      0.000000000000000_REALK,     -0.161109416378230_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.008747997918413_REALK,      0.000000000000000_REALK, &
     -0.719137043122212_REALK,      0.000000000000000_REALK,      0.248844216918387_REALK, &
      0.000000000000000_REALK,     -0.036705710884616_REALK,      0.000000000000000_REALK, &
      1.755476627696090_REALK,      0.210710804560622_REALK,      0.000000000000000_REALK, &
      0.107628025668563_REALK,      0.000000000000000_REALK,      0.383193739277180_REALK, &
      0.034653468787075_REALK,      0.000000000000000_REALK,      0.052921886696572_REALK, &
      0.000000000000000_REALK,      0.026494399219545_REALK,      0.000000000000000_REALK, &
      0.032468180445712_REALK,      0.000000000000000_REALK,      0.192663626957040_REALK, &
      5.094114617003936_REALK,      0.725609524359463_REALK,      0.000000000000000_REALK, &
      0.493667320544493_REALK,      0.000000000000000_REALK,      0.898128217665301_REALK, &
      0.482916925590073_REALK,      0.000000000000000_REALK,      0.143517777562101_REALK, &
      0.000000000000000_REALK,      0.750808345907916_REALK,      0.000000000000000_REALK, &
      0.112472693082996_REALK,      0.000000000000000_REALK,      0.341035670416102_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.382540437761187_REALK, &
      0.000000000000000_REALK,     -0.067143752329171_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.032471489091634_REALK,      0.000000000000000_REALK, &
     -0.160130704152147_REALK,      0.000000000000000_REALK,     -0.013446019709484_REALK, &
      0.000000000000000_REALK,     -0.033758794900055_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.114337523301309_REALK, &
      0.000000000000000_REALK,     -0.107429541491563_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.040331383872666_REALK,      0.000000000000000_REALK, &
     -0.367340007330244_REALK,      0.000000000000000_REALK,      0.154394826898968_REALK, &
      0.000000000000000_REALK,     -0.040792956934711_REALK,      0.000000000000000_REALK, &
      0.429736790418529_REALK,      0.092462122157282_REALK,      0.000000000000000_REALK, &
      0.041705289629904_REALK,      0.000000000000000_REALK,      0.156341631124959_REALK, &
      0.020569268181848_REALK,      0.000000000000000_REALK,      0.038704469559087_REALK, &
      0.000000000000000_REALK,      0.015638618007072_REALK,      0.000000000000000_REALK, &
      0.020968746458509_REALK,      0.000000000000000_REALK,      0.110048468054894_REALK, &
      1.918784946312336_REALK,      0.528489802327317_REALK,      0.000000000000000_REALK, &
      0.369469970777501_REALK,      0.000000000000000_REALK,      0.563825457899382_REALK, &
      0.395208388202666_REALK,      0.000000000000000_REALK,      0.174216019654202_REALK, &
      0.000000000000000_REALK,      0.565191019455497_REALK,      0.000000000000000_REALK, &
      0.140294488809480_REALK,      0.000000000000000_REALK,      0.299732738544971_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.173678014354393_REALK, &
      0.000000000000000_REALK,     -0.048117070781888_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.022490786359316_REALK,      0.000000000000000_REALK, &
     -0.101781803920946_REALK,      0.000000000000000_REALK,     -0.010832889235969_REALK, &
      0.000000000000000_REALK,     -0.033869481140332_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.660617211270198_REALK, &
      0.000000000000000_REALK,     -0.032303406771091_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.143188501503121_REALK,      0.000000000000000_REALK, &
     -0.304880322719608_REALK,      0.000000000000000_REALK,      0.289130629415871_REALK, &
      0.000000000000000_REALK,     -0.017172670088194_REALK,      0.000000000000000_REALK, &
      0.228257269123291_REALK,      0.078622439251097_REALK,      0.000000000000000_REALK, &
      0.044439502540213_REALK,      0.000000000000000_REALK,      0.116258510774822_REALK, &
      0.034027340921585_REALK,      0.000000000000000_REALK,      0.046075686236905_REALK, &
      0.000000000000000_REALK,      0.037281262148152_REALK,      0.000000000000000_REALK, &
      0.031280850407421_REALK,      0.000000000000000_REALK,      0.105215224828448_REALK, &
      2.136972080172817_REALK,      1.169017805494152_REALK,      0.000000000000000_REALK, &
      1.022596836940188_REALK,      0.000000000000000_REALK,      0.879114133927393_REALK, &
      1.125395800697151_REALK,      0.000000000000000_REALK,      0.539511414058890_REALK, &
      0.000000000000000_REALK,      1.458914277349022_REALK,      0.000000000000000_REALK, &
      0.543618146483562_REALK,      0.000000000000000_REALK,      0.600868216642837_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.500439432826911_REALK, &
      0.000000000000000_REALK,     -0.227044891172154_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.202676817721760_REALK,      0.000000000000000_REALK, &
     -0.761057798098283_REALK,      0.000000000000000_REALK,     -0.694149579006133_REALK, &
      0.000000000000000_REALK,     -0.849720713398479_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.188275268466008_REALK, &
      0.000000000000000_REALK,     -0.264173449644681_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.262988770777206_REALK,      0.000000000000000_REALK, &
     -0.479003002918416_REALK,      0.000000000000000_REALK,     -3.460672811759610_REALK, &
      0.000000000000000_REALK,     -1.179064933538331_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.925773928303285_REALK, &
      0.000000000000000_REALK,      0.013485912715449_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.274757361496003_REALK,      0.000000000000000_REALK, &
     -1.199432766296744_REALK,      0.000000000000000_REALK,      0.184128200400637_REALK, &
      0.000000000000000_REALK,      0.043338600194257_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.529691617456520_REALK, &
      0.000000000000000_REALK,      0.086783217842153_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.025478268424616_REALK,      0.000000000000000_REALK, &
     -0.745643612366356_REALK,      0.000000000000000_REALK,      1.332792443301055_REALK, &
      0.000000000000000_REALK,      0.307252845402549_REALK,      0.000000000000000_REALK, &
      0.776075095626093_REALK,      0.062608672020103_REALK,      0.000000000000000_REALK, &
      0.237759538749184_REALK,      0.000000000000000_REALK,      0.892794514297774_REALK, &
      0.066264711956831_REALK,      0.000000000000000_REALK,      0.081115799850692_REALK, &
      0.000000000000000_REALK,      0.772903523730386_REALK,      0.000000000000000_REALK, &
      0.764068833132647_REALK,      0.000000000000000_REALK,      4.781837329958432_REALK, &
      0.643447516288259_REALK,      0.114296610190119_REALK,      0.000000000000000_REALK, &
      0.379825884843682_REALK,      0.000000000000000_REALK,      0.691808014800749_REALK, &
      0.472241739210964_REALK,      0.000000000000000_REALK,      0.160894630941343_REALK, &
      0.000000000000000_REALK,      4.377978552893460_REALK,      0.000000000000000_REALK, &
      1.344759813908137_REALK,      0.000000000000000_REALK,      4.082202110520922_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.468879521623443_REALK, &
      0.000000000000000_REALK,      0.228800066739394_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.406772315566097_REALK,      0.000000000000000_REALK, &
     -1.657910830253371_REALK,      0.000000000000000_REALK,      0.497598267117497_REALK, &
      0.000000000000000_REALK,      0.589255015435553_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.768336215815453_REALK, &
      0.000000000000000_REALK,      0.125987519894336_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.342462570604318_REALK,      0.000000000000000_REALK, &
     -1.170169916141184_REALK,      0.000000000000000_REALK,     -0.285374262536875_REALK, &
      0.000000000000000_REALK,      0.357813614460504_REALK,      0.000000000000000_REALK, &
      0.963627873706561_REALK,     -0.005949155770628_REALK,      0.000000000000000_REALK, &
      0.213751837283666_REALK,      0.000000000000000_REALK,      0.933117701007943_REALK, &
     -0.028528291381831_REALK,      0.000000000000000_REALK,     -0.006714757499027_REALK, &
      0.000000000000000_REALK,      0.332942110341649_REALK,      0.000000000000000_REALK, &
      0.550499586704351_REALK,      0.000000000000000_REALK,      4.005274802774296_REALK, &
      0.403026275395887_REALK,     -0.046149263957697_REALK,      0.000000000000000_REALK, &
      0.023060252636356_REALK,      0.000000000000000_REALK,      0.674878284163169_REALK, &
     -0.304880053059269_REALK,      0.000000000000000_REALK,     -0.070284960182492_REALK, &
      0.000000000000000_REALK,     -1.553395083570803_REALK,      0.000000000000000_REALK, &
      0.065492775420193_REALK,      0.000000000000000_REALK,      3.194504746447019_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.393846063576748_REALK, &
      0.000000000000000_REALK,     -0.063105320113768_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.118382617436958_REALK,      0.000000000000000_REALK, &
     -0.740884060088284_REALK,      0.000000000000000_REALK,     -0.132766948796927_REALK, &
      0.000000000000000_REALK,     -0.270870596817163_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.367887150038157_REALK, &
      0.000000000000000_REALK,     -0.145624921423465_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.307617623041757_REALK,      0.000000000000000_REALK, &
     -0.933815315587852_REALK,      0.000000000000000_REALK,     -1.213913820780062_REALK, &
      0.000000000000000_REALK,     -0.689308744413179_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.426240272431503_REALK, &
      0.000000000000000_REALK,      0.573600951848357_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.651470549609939_REALK,      0.000000000000000_REALK, &
     -2.325808930601169_REALK,      0.000000000000000_REALK,      0.915071210738888_REALK, &
      0.000000000000000_REALK,      1.124055470239239_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.092630231007191_REALK, &
      0.000000000000000_REALK,      0.556295936159346_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.427363043859765_REALK,      0.000000000000000_REALK, &
     -1.960410752552983_REALK,      0.000000000000000_REALK,      1.132413849073831_REALK, &
      0.000000000000000_REALK,      1.016471478361069_REALK,      0.000000000000000_REALK, &
      1.482885194062922_REALK,     -0.140741110296172_REALK,      0.000000000000000_REALK, &
      0.287471760723819_REALK,      0.000000000000000_REALK,      1.171669081836966_REALK, &
     -0.113929652042474_REALK,      0.000000000000000_REALK,     -0.134915298764502_REALK, &
      0.000000000000000_REALK,      0.441575969253326_REALK,      0.000000000000000_REALK, &
      0.563343216463737_REALK,      0.000000000000000_REALK,      3.826763293962155_REALK, &
      1.749240302390975_REALK,     -0.143315303433625_REALK,      0.000000000000000_REALK, &
      0.347779527718705_REALK,      0.000000000000000_REALK,      1.188337575309570_REALK, &
      0.107079193017837_REALK,      0.000000000000000_REALK,     -0.134260156282577_REALK, &
      0.000000000000000_REALK,      1.436283611823142_REALK,      0.000000000000000_REALK, &
      0.635467469211723_REALK,      0.000000000000000_REALK,      3.618910887330691_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.573985939551556_REALK, &
      0.000000000000000_REALK,      0.004745414294953_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.126041890632113_REALK,      0.000000000000000_REALK, &
     -0.917044119261001_REALK,      0.000000000000000_REALK,      0.039509127864048_REALK, &
      0.000000000000000_REALK,      0.015498895993825_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.767698151028981_REALK, &
      0.000000000000000_REALK,      0.071376180511818_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.024574442972363_REALK,      0.000000000000000_REALK, &
     -1.198653961644476_REALK,      0.000000000000000_REALK,      0.565730016535322_REALK, &
      0.000000000000000_REALK,      0.217365874913960_REALK,      0.000000000000000_REALK, &
      0.397601360642866_REALK,      0.038817789456868_REALK,      0.000000000000000_REALK, &
      0.083662673617145_REALK,      0.000000000000000_REALK,      0.523593266049550_REALK, &
      0.030398201277504_REALK,      0.000000000000000_REALK,      0.062018288413030_REALK, &
      0.000000000000000_REALK,      0.165845014936295_REALK,      0.000000000000000_REALK, &
      0.273248866455430_REALK,      0.000000000000000_REALK,      2.394135453058046_REALK, &
      0.837553946218082_REALK,      0.165653549008706_REALK,      0.000000000000000_REALK, &
      0.312393589380082_REALK,      0.000000000000000_REALK,      0.948313413809146_REALK, &
      0.455489262300001_REALK,      0.000000000000000_REALK,      0.258644992844665_REALK, &
      0.000000000000000_REALK,      1.858319269116868_REALK,      0.000000000000000_REALK, &
      0.951349671363698_REALK,      0.000000000000000_REALK,      4.043132635706048_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.463338848904796_REALK, &
      0.000000000000000_REALK,      1.292570479972265_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.180899588674490_REALK,      0.000000000000000_REALK, &
     -3.517396355974061_REALK,      0.000000000000000_REALK,      1.544869663326354_REALK, &
      0.000000000000000_REALK,      1.855008793671588_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.533929403198772_REALK, &
      0.000000000000000_REALK,      1.280088125504411_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.278674617195122_REALK,      0.000000000000000_REALK, &
     -3.587492023814892_REALK,      0.000000000000000_REALK,      1.051410719503716_REALK, &
      0.000000000000000_REALK,      1.824125538198750_REALK,      0.000000000000000_REALK, &
      2.737736469441647_REALK,     -0.464963079278769_REALK,      0.000000000000000_REALK, &
      0.488428737118955_REALK,      0.000000000000000_REALK,      1.743734877092572_REALK, &
     -0.298295751419880_REALK,      0.000000000000000_REALK,     -0.366420631747224_REALK, &
      0.000000000000000_REALK,      0.605381105637662_REALK,      0.000000000000000_REALK, &
      0.700959534877364_REALK,      0.000000000000000_REALK,      4.170815158577106_REALK, &
      1.766413898993950_REALK,     -0.545939852781632_REALK,      0.000000000000000_REALK, &
      0.426646467802907_REALK,      0.000000000000000_REALK,      1.957123656424594_REALK, &
     -0.617430171461315_REALK,      0.000000000000000_REALK,     -0.554214485881913_REALK, &
      0.000000000000000_REALK,     -0.303462526845348_REALK,      0.000000000000000_REALK, &
      0.607971203072371_REALK,      0.000000000000000_REALK,      4.648168580438250_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.949759344769478_REALK, &
      0.000000000000000_REALK,      0.101150403549365_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.183639137687059_REALK,      0.000000000000000_REALK, &
     -1.247451803621632_REALK,      0.000000000000000_REALK,      0.122584322426007_REALK, &
      0.000000000000000_REALK,      0.241940241009177_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.166215315895380_REALK, &
      0.000000000000000_REALK,      0.134035037113373_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.346478267458826_REALK,      0.000000000000000_REALK, &
     -1.973152104679115_REALK,      0.000000000000000_REALK,     -0.152331996737732_REALK, &
      0.000000000000000_REALK,      0.318333206051184_REALK,      0.000000000000000_REALK, &
      0.647677914472251_REALK,     -0.003846650595549_REALK,      0.000000000000000_REALK, &
      0.094497719816173_REALK,      0.000000000000000_REALK,      0.687537911454627_REALK, &
     -0.012879221688806_REALK,      0.000000000000000_REALK,     -0.005052344312005_REALK, &
      0.000000000000000_REALK,      0.082020950835986_REALK,      0.000000000000000_REALK, &
      0.226027779473809_REALK,      0.000000000000000_REALK,      2.302317292157273_REALK, &
      0.648023078380582_REALK,     -0.070047431497999_REALK,      0.000000000000000_REALK, &
      0.024533238058421_REALK,      0.000000000000000_REALK,      1.196644132433190_REALK, &
     -0.308455059425402_REALK,      0.000000000000000_REALK,     -0.118515196125277_REALK, &
      0.000000000000000_REALK,     -0.829198024724949_REALK,      0.000000000000000_REALK, &
      0.058266439090460_REALK,      0.000000000000000_REALK,      3.978841651684090_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.424426661928532_REALK, &
      0.000000000000000_REALK,     -0.046497135297968_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.089073915764585_REALK,      0.000000000000000_REALK, &
     -0.780442467853693_REALK,      0.000000000000000_REALK,     -0.054512336337500_REALK, &
      0.000000000000000_REALK,     -0.155702190161122_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.930659477939301_REALK, &
      0.000000000000000_REALK,     -0.258211312834748_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.518707883332727_REALK,      0.000000000000000_REALK, &
     -2.204452090149302_REALK,      0.000000000000000_REALK,     -1.079973100021364_REALK, &
      0.000000000000000_REALK,     -0.858552596045331_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,    -10.204370821697809_REALK, &
      0.000000000000000_REALK,      3.213025060949132_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.476563368978800_REALK,      0.000000000000000_REALK, &
     -6.084509602689995_REALK,      0.000000000000000_REALK,      2.822195669368768_REALK, &
      0.000000000000000_REALK,      3.179828072068480_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,    -23.387326747396678_REALK, &
      0.000000000000000_REALK,      7.232143411778651_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -4.378008855251529_REALK,      0.000000000000000_REALK, &
    -11.005372481385759_REALK,      0.000000000000000_REALK,      4.621586377729353_REALK, &
      0.000000000000000_REALK,      4.958902816732800_REALK,      0.000000000000000_REALK, &
      6.825501170856471_REALK,     -1.463621848877046_REALK,      0.000000000000000_REALK, &
      1.078954135582652_REALK,      0.000000000000000_REALK,      3.213744319295947_REALK, &
     -0.726798638107584_REALK,      0.000000000000000_REALK,     -0.872706544068690_REALK, &
      0.000000000000000_REALK,      1.063283120551542_REALK,      0.000000000000000_REALK, &
      1.067806376769002_REALK,      0.000000000000000_REALK,      5.300899831724887_REALK, &
     20.988937843574458_REALK,     -4.399704784233625_REALK,      0.000000000000000_REALK, &
      2.834380315240653_REALK,      0.000000000000000_REALK,      7.952231659754710_REALK, &
     -1.193343237445771_REALK,      0.000000000000000_REALK,     -2.070368729252729_REALK, &
      0.000000000000000_REALK,      2.883513129362367_REALK,      0.000000000000000_REALK, &
      1.943464852487228_REALK,      0.000000000000000_REALK,      9.087749355339694_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.974490756447092_REALK, &
      0.000000000000000_REALK,      0.334788037677479_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.329773085336178_REALK,      0.000000000000000_REALK, &
     -1.962199691671942_REALK,      0.000000000000000_REALK,      0.269728356740963_REALK, &
      0.000000000000000_REALK,      0.552215010364248_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -6.726698063162699_REALK, &
      0.000000000000000_REALK,      1.228502238240023_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.690042730485609_REALK,      0.000000000000000_REALK, &
     -5.275636284735720_REALK,      0.000000000000000_REALK,      0.938435643410539_REALK, &
      0.000000000000000_REALK,      1.403922936513586_REALK,      0.000000000000000_REALK, &
      1.452406760769827_REALK,     -0.114536068207869_REALK,      0.000000000000000_REALK, &
      0.167785821049092_REALK,      0.000000000000000_REALK,      1.139760988458267_REALK, &
     -0.057670961316393_REALK,      0.000000000000000_REALK,     -0.113823089315039_REALK, &
      0.000000000000000_REALK,      0.130159881728575_REALK,      0.000000000000000_REALK, &
      0.276753762029147_REALK,      0.000000000000000_REALK,      2.631964936945598_REALK, &
      6.926460034939154_REALK,     -0.460682809482564_REALK,      0.000000000000000_REALK, &
      0.768022738339949_REALK,      0.000000000000000_REALK,      4.373797218831259_REALK, &
      0.172895667488904_REALK,      0.000000000000000_REALK,     -0.361305788165182_REALK, &
      0.000000000000000_REALK,      1.190253666081211_REALK,      0.000000000000000_REALK, &
      0.877690495431365_REALK,      0.000000000000000_REALK,      6.997678686823479_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.778522738007970_REALK, &
      0.000000000000000_REALK,      0.004616182308899_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.106336920321376_REALK,      0.000000000000000_REALK, &
     -1.083147084931758_REALK,      0.000000000000000_REALK,      0.019409659069836_REALK, &
      0.000000000000000_REALK,      0.010659805084228_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.112905048952631_REALK, &
      0.000000000000000_REALK,      0.262707286464506_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.066131968952596_REALK,      0.000000000000000_REALK, &
     -4.515955268314143_REALK,      0.000000000000000_REALK,      0.781371010398405_REALK, &
      0.000000000000000_REALK,      0.420307821188183_REALK,      0.000000000000000_REALK, &
      0.649048789707449_REALK,      0.052650299683278_REALK,      0.000000000000000_REALK, &
      0.081384285936297_REALK,      0.000000000000000_REALK,      0.713067932575243_REALK, &
      0.025645847511078_REALK,      0.000000000000000_REALK,      0.073251577428099_REALK, &
      0.000000000000000_REALK,      0.081474721725622_REALK,      0.000000000000000_REALK, &
      0.187934653994811_REALK,      0.000000000000000_REALK,      2.117101534799223_REALK, &
      5.527431849181949_REALK,      0.887480733386722_REALK,      0.000000000000000_REALK, &
      1.149796354840816_REALK,      0.000000000000000_REALK,      4.886509457672944_REALK, &
      1.225761323930733_REALK,      0.000000000000000_REALK,      0.974450721755824_REALK, &
      0.000000000000000_REALK,      2.566660354784291_REALK,      0.000000000000000_REALK, &
      1.839569839181270_REALK,      0.000000000000000_REALK,     10.051677960719404_REALK/
    ! results of test 2, ket-major order, CM010002
  data REF_CONTR_INTS(10081:11340)                                                         &
     /0.778967681580850_REALK,      0.762954762076273_REALK,      0.000000000000000_REALK, &
      0.980916612378344_REALK,      0.000000000000000_REALK,      0.462520285645863_REALK, &
      1.551322991770541_REALK,      0.000000000000000_REALK,      0.556533532726681_REALK, &
      0.000000000000000_REALK,      3.581592279907964_REALK,      0.000000000000000_REALK, &
      1.069336564795516_REALK,      0.000000000000000_REALK,      0.840353208348667_REALK, &
      1.226542279318010_REALK,      1.207958238085582_REALK,      0.000000000000000_REALK, &
      1.653774121774744_REALK,      0.000000000000000_REALK,      0.598133779548483_REALK, &
      2.866600823854720_REALK,      0.000000000000000_REALK,      0.835364553148701_REALK, &
      0.000000000000000_REALK,      6.887429539259326_REALK,      0.000000000000000_REALK, &
      1.714207535341797_REALK,      0.000000000000000_REALK,      1.033318696655052_REALK, &
      0.534615735634721_REALK,      0.382442149408176_REALK,      0.000000000000000_REALK, &
      0.366808804358701_REALK,      0.000000000000000_REALK,      0.279177938705093_REALK, &
      0.423412850977629_REALK,      0.000000000000000_REALK,      0.242597914393326_REALK, &
      0.000000000000000_REALK,      0.653656305995717_REALK,      0.000000000000000_REALK, &
      0.329709217390503_REALK,      0.000000000000000_REALK,      0.418235779282336_REALK, &
      0.258892788234387_REALK,      0.232631559665298_REALK,      0.000000000000000_REALK, &
      0.171945371112750_REALK,      0.000000000000000_REALK,      0.210155114339410_REALK, &
      0.031825299180437_REALK,      0.000000000000000_REALK,      0.171639668400126_REALK, &
      0.000000000000000_REALK,     -0.428579472317104_REALK,      0.000000000000000_REALK, &
      0.155739669321301_REALK,      0.000000000000000_REALK,      0.317246962427562_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.334461441382445_REALK, &
      0.000000000000000_REALK,     -0.337910902990347_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.449954577187133_REALK,      0.000000000000000_REALK, &
     -0.353603145163826_REALK,      0.000000000000000_REALK,     -0.846651016739323_REALK, &
      0.000000000000000_REALK,     -0.506223487771555_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.465846026281682_REALK, &
      0.000000000000000_REALK,     -0.613665612912665_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.950318735954605_REALK,      0.000000000000000_REALK, &
     -0.572849026385648_REALK,      0.000000000000000_REALK,     -1.907355850512320_REALK, &
      0.000000000000000_REALK,     -0.926380270376712_REALK,      0.000000000000000_REALK, &
      0.498141531633661_REALK,      0.278503456838321_REALK,      0.000000000000000_REALK, &
      0.226026549202582_REALK,      0.000000000000000_REALK,      0.226862475832449_REALK, &
      0.226665384566547_REALK,      0.000000000000000_REALK,      0.152274980369755_REALK, &
      0.000000000000000_REALK,      0.311780557984997_REALK,      0.000000000000000_REALK, &
      0.167261317443801_REALK,      0.000000000000000_REALK,      0.279799848883302_REALK, &
      0.561588843128981_REALK,      0.309181471240707_REALK,      0.000000000000000_REALK, &
      0.274158404781078_REALK,      0.000000000000000_REALK,      0.206277910321453_REALK, &
      0.349728377752212_REALK,      0.000000000000000_REALK,      0.152409374677854_REALK, &
      0.000000000000000_REALK,      0.659431624401708_REALK,      0.000000000000000_REALK, &
      0.184539759119509_REALK,      0.000000000000000_REALK,      0.231414121778695_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.229488650841768_REALK, &
      0.000000000000000_REALK,     -0.166989059162020_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.164860962040417_REALK,      0.000000000000000_REALK, &
     -0.209125948852516_REALK,      0.000000000000000_REALK,     -0.215675616756814_REALK, &
      0.000000000000000_REALK,     -0.205955230574165_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.271355952770943_REALK, &
      0.000000000000000_REALK,     -0.166547584404235_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.109443027995606_REALK,      0.000000000000000_REALK, &
     -0.222939141593077_REALK,      0.000000000000000_REALK,     -0.020786508692337_REALK, &
      0.000000000000000_REALK,     -0.186842415260112_REALK,      0.000000000000000_REALK, &
      0.320670056935807_REALK,      0.277768070040427_REALK,      0.000000000000000_REALK, &
      0.309720269846603_REALK,      0.000000000000000_REALK,      0.243398038582903_REALK, &
      0.423341822945841_REALK,      0.000000000000000_REALK,      0.253121498579851_REALK, &
      0.000000000000000_REALK,      0.767657355411798_REALK,      0.000000000000000_REALK, &
      0.381992149125526_REALK,      0.000000000000000_REALK,      0.420271478699723_REALK, &
      0.907983275220810_REALK,      0.792375753491019_REALK,      0.000000000000000_REALK, &
      0.922125353437292_REALK,      0.000000000000000_REALK,      0.555854147599703_REALK, &
      1.340357281191755_REALK,      0.000000000000000_REALK,      0.650995743777069_REALK, &
      0.000000000000000_REALK,      2.493860272577155_REALK,      0.000000000000000_REALK, &
      1.034491907073419_REALK,      0.000000000000000_REALK,      0.873023674152633_REALK, &
      0.558287861856482_REALK,      0.238220494742982_REALK,      0.000000000000000_REALK, &
      0.160693915338243_REALK,      0.000000000000000_REALK,      0.220959107856830_REALK, &
      0.128345063743067_REALK,      0.000000000000000_REALK,      0.111444477489568_REALK, &
      0.000000000000000_REALK,      0.133848576694382_REALK,      0.000000000000000_REALK, &
      0.097657642954205_REALK,      0.000000000000000_REALK,      0.223803803410374_REALK, &
      0.275948742789156_REALK,      0.152064374698037_REALK,      0.000000000000000_REALK, &
      0.080468953433202_REALK,      0.000000000000000_REALK,      0.170122381003085_REALK, &
     -0.002714292773276_REALK,      0.000000000000000_REALK,      0.083258883668467_REALK, &
      0.000000000000000_REALK,     -0.165509717402360_REALK,      0.000000000000000_REALK, &
      0.049087884377659_REALK,      0.000000000000000_REALK,      0.172964176709131_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.214504439988369_REALK, &
      0.000000000000000_REALK,     -0.120783481226248_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.099979855173245_REALK,      0.000000000000000_REALK, &
     -0.167249360440124_REALK,      0.000000000000000_REALK,     -0.109262465839866_REALK, &
      0.000000000000000_REALK,     -0.122338484934031_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.208232652200192_REALK, &
      0.000000000000000_REALK,     -0.150825809177844_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.151530750799740_REALK,      0.000000000000000_REALK, &
     -0.190020599279524_REALK,      0.000000000000000_REALK,     -0.211125561754085_REALK, &
      0.000000000000000_REALK,     -0.153345266843292_REALK,      0.000000000000000_REALK, &
      0.251468993348485_REALK,      0.157892549167932_REALK,      0.000000000000000_REALK, &
      0.130766596490102_REALK,      0.000000000000000_REALK,      0.165877283686494_REALK, &
      0.128919329688956_REALK,      0.000000000000000_REALK,      0.123109003562021_REALK, &
      0.000000000000000_REALK,      0.157551300580113_REALK,      0.000000000000000_REALK, &
      0.132450125896043_REALK,      0.000000000000000_REALK,      0.235217974438341_REALK, &
      0.214718035529032_REALK,      0.168125831621935_REALK,      0.000000000000000_REALK, &
      0.108305891886250_REALK,      0.000000000000000_REALK,      0.220622756961391_REALK, &
      0.017068382898535_REALK,      0.000000000000000_REALK,      0.153421526074857_REALK, &
      0.000000000000000_REALK,     -0.181815189367733_REALK,      0.000000000000000_REALK, &
      0.110115078994302_REALK,      0.000000000000000_REALK,      0.314031385021629_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.230139249644146_REALK, &
      0.000000000000000_REALK,     -0.200774255215413_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.228334442957612_REALK,      0.000000000000000_REALK, &
     -0.251215775506263_REALK,      0.000000000000000_REALK,     -0.340114949301887_REALK, &
      0.000000000000000_REALK,     -0.284702718669977_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.561121562705327_REALK, &
      0.000000000000000_REALK,     -0.644231760900834_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.849450200450151_REALK,      0.000000000000000_REALK, &
     -0.716864124248824_REALK,      0.000000000000000_REALK,     -1.348587942074701_REALK, &
      0.000000000000000_REALK,     -0.916990590349733_REALK,      0.000000000000000_REALK, &
      0.767216326763468_REALK,      0.244993026162889_REALK,      0.000000000000000_REALK, &
      0.143389126117644_REALK,      0.000000000000000_REALK,      0.258137123641279_REALK, &
      0.095521422201409_REALK,      0.000000000000000_REALK,      0.096400821384409_REALK, &
      0.000000000000000_REALK,      0.087938998057292_REALK,      0.000000000000000_REALK, &
      0.070914882570203_REALK,      0.000000000000000_REALK,      0.212774895671101_REALK, &
      1.063363926968480_REALK,      0.325238088364285_REALK,      0.000000000000000_REALK, &
      0.198173567149616_REALK,      0.000000000000000_REALK,      0.281155997472462_REALK, &
      0.184828167668752_REALK,      0.000000000000000_REALK,      0.107883713271546_REALK, &
      0.000000000000000_REALK,      0.285185877020619_REALK,      0.000000000000000_REALK, &
      0.083451934208420_REALK,      0.000000000000000_REALK,      0.197327122051387_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.247373927318716_REALK, &
      0.000000000000000_REALK,     -0.104484854257497_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.070789437434579_REALK,      0.000000000000000_REALK, &
     -0.162229446256129_REALK,      0.000000000000000_REALK,     -0.059510709634625_REALK, &
      0.000000000000000_REALK,     -0.086123815320510_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.359503955890029_REALK, &
      0.000000000000000_REALK,     -0.128924298826679_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.056405968502465_REALK,      0.000000000000000_REALK, &
     -0.198749895767565_REALK,      0.000000000000000_REALK,      0.001769911557137_REALK, &
      0.000000000000000_REALK,     -0.090484503544881_REALK,      0.000000000000000_REALK, &
      0.279626208954554_REALK,      0.135222686206369_REALK,      0.000000000000000_REALK, &
      0.093736188923673_REALK,      0.000000000000000_REALK,      0.156804764523947_REALK, &
      0.079201466014759_REALK,      0.000000000000000_REALK,      0.088679925739554_REALK, &
      0.000000000000000_REALK,      0.086413576287438_REALK,      0.000000000000000_REALK, &
      0.077264004252861_REALK,      0.000000000000000_REALK,      0.180949426097079_REALK, &
      0.667714334351977_REALK,      0.318726288275769_REALK,      0.000000000000000_REALK, &
      0.234641577412065_REALK,      0.000000000000000_REALK,      0.294242145045914_REALK, &
      0.242600428544565_REALK,      0.000000000000000_REALK,      0.176206173910836_REALK, &
      0.000000000000000_REALK,      0.353081913206787_REALK,      0.000000000000000_REALK, &
      0.164681342744095_REALK,      0.000000000000000_REALK,      0.289116144297628_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.185707280937596_REALK, &
      0.000000000000000_REALK,     -0.115420939509251_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.096009586312837_REALK,      0.000000000000000_REALK, &
     -0.170503276356972_REALK,      0.000000000000000_REALK,     -0.099628306323343_REALK, &
      0.000000000000000_REALK,     -0.133193355617680_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.466221748245730_REALK, &
      0.000000000000000_REALK,     -0.237569395632088_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.126531174772442_REALK,      0.000000000000000_REALK, &
     -0.360847582593661_REALK,      0.000000000000000_REALK,     -0.018549662028111_REALK, &
      0.000000000000000_REALK,     -0.233430692457565_REALK,      0.000000000000000_REALK, &
      0.300007617152948_REALK,      0.224776052450882_REALK,      0.000000000000000_REALK, &
      0.214075129892606_REALK,      0.000000000000000_REALK,      0.235527540549626_REALK, &
      0.246540313649196_REALK,      0.000000000000000_REALK,      0.206373456096966_REALK, &
      0.000000000000000_REALK,      0.354608477798257_REALK,      0.000000000000000_REALK, &
      0.247038232628505_REALK,      0.000000000000000_REALK,      0.349449257395331_REALK, &
      1.799280308700708_REALK,      1.361395632886474_REALK,      0.000000000000000_REALK, &
      1.315352388308503_REALK,      0.000000000000000_REALK,      1.110046165653601_REALK, &
      1.549637144641131_REALK,      0.000000000000000_REALK,      1.053696711766708_REALK, &
      0.000000000000000_REALK,      2.225494713246019_REALK,      0.000000000000000_REALK, &
      1.292437597071928_REALK,      0.000000000000000_REALK,      1.402338882780909_REALK, &
      1.260864008438978_REALK,      0.292499410174724_REALK,      0.000000000000000_REALK, &
      0.152659949241794_REALK,      0.000000000000000_REALK,      0.360962187932097_REALK, &
      0.079186668616842_REALK,      0.000000000000000_REALK,      0.095953498459804_REALK, &
      0.000000000000000_REALK,      0.059417103167855_REALK,      0.000000000000000_REALK, &
      0.060870212659587_REALK,      0.000000000000000_REALK,      0.239877859807835_REALK, &
      0.769453310959304_REALK,      0.236882362575830_REALK,      0.000000000000000_REALK, &
      0.097527974094219_REALK,      0.000000000000000_REALK,      0.360683508670701_REALK, &
     -0.022880187214544_REALK,      0.000000000000000_REALK,      0.094962669134672_REALK, &
      0.000000000000000_REALK,     -0.165048207800698_REALK,      0.000000000000000_REALK, &
      0.039929366055237_REALK,      0.000000000000000_REALK,      0.246115092986662_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.349976841279529_REALK, &
      0.000000000000000_REALK,     -0.109889689225777_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.063773591795903_REALK,      0.000000000000000_REALK, &
     -0.191347977309439_REALK,      0.000000000000000_REALK,     -0.043416688554842_REALK, &
      0.000000000000000_REALK,     -0.073027326262180_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.385376777997648_REALK, &
      0.000000000000000_REALK,     -0.155401019265141_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.108894038148890_REALK,      0.000000000000000_REALK, &
     -0.257486508375097_REALK,      0.000000000000000_REALK,     -0.109000715101491_REALK, &
      0.000000000000000_REALK,     -0.106039049158693_REALK,      0.000000000000000_REALK, &
      0.387582075930800_REALK,      0.141658350952290_REALK,      0.000000000000000_REALK, &
      0.080694636917394_REALK,      0.000000000000000_REALK,      0.184929372761954_REALK, &
      0.053517845142957_REALK,      0.000000000000000_REALK,      0.077450950253195_REALK, &
      0.000000000000000_REALK,      0.044099320383379_REALK,      0.000000000000000_REALK, &
      0.053625718839437_REALK,      0.000000000000000_REALK,      0.172053054562388_REALK, &
      0.366447804305149_REALK,      0.176714817873654_REALK,      0.000000000000000_REALK, &
      0.081249937846109_REALK,      0.000000000000000_REALK,      0.286289148236672_REALK, &
     -0.002309506885026_REALK,      0.000000000000000_REALK,      0.118070636401205_REALK, &
      0.000000000000000_REALK,     -0.112159336580370_REALK,      0.000000000000000_REALK, &
      0.055441503499436_REALK,      0.000000000000000_REALK,      0.273492161697744_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.212592576424353_REALK, &
      0.000000000000000_REALK,     -0.101088448626648_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.069483342412095_REALK,      0.000000000000000_REALK, &
     -0.162727405269185_REALK,      0.000000000000000_REALK,     -0.059998153709074_REALK, &
      0.000000000000000_REALK,     -0.094049831605583_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.403313786041563_REALK, &
      0.000000000000000_REALK,     -0.253816059868389_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.214887966220159_REALK,      0.000000000000000_REALK, &
     -0.377259373856781_REALK,      0.000000000000000_REALK,     -0.238452292642230_REALK, &
      0.000000000000000_REALK,     -0.242470604682591_REALK,      0.000000000000000_REALK, &
      0.290963620303132_REALK,      0.156485263557433_REALK,      0.000000000000000_REALK, &
      0.109443710656177_REALK,      0.000000000000000_REALK,      0.194360917072794_REALK, &
      0.089595508143051_REALK,      0.000000000000000_REALK,      0.119780480249397_REALK, &
      0.000000000000000_REALK,      0.086514495866532_REALK,      0.000000000000000_REALK, &
      0.101823330927943_REALK,      0.000000000000000_REALK,      0.232493009732269_REALK, &
      0.475226859579306_REALK,      0.325633203853351_REALK,      0.000000000000000_REALK, &
      0.182261742131186_REALK,      0.000000000000000_REALK,      0.519782647759560_REALK, &
      0.024204922554501_REALK,      0.000000000000000_REALK,      0.304597023073326_REALK, &
      0.000000000000000_REALK,     -0.205348174715174_REALK,      0.000000000000000_REALK, &
      0.174114730360114_REALK,      0.000000000000000_REALK,      0.638419647418330_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.319323247710943_REALK, &
      0.000000000000000_REALK,     -0.235250225353504_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.222160917915014_REALK,      0.000000000000000_REALK, &
     -0.314258918393463_REALK,      0.000000000000000_REALK,     -0.261469264766788_REALK, &
      0.000000000000000_REALK,     -0.281404480676257_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.521525482628652_REALK, &
      0.000000000000000_REALK,     -1.517796690893676_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.686464793603429_REALK,      0.000000000000000_REALK, &
     -1.829871832782617_REALK,      0.000000000000000_REALK,     -2.132396653081351_REALK, &
      0.000000000000000_REALK,     -1.864223887483993_REALK,      0.000000000000000_REALK, &
      2.443555404783461_REALK,     -0.049739213176926_REALK,      0.000000000000000_REALK, &
      2.447169377287383_REALK,      0.000000000000000_REALK,      3.310262114470492_REALK, &
      0.113120236305909_REALK,      0.000000000000000_REALK,      0.080459124348110_REALK, &
      0.000000000000000_REALK,     17.396815921660327_REALK,      0.000000000000000_REALK, &
      9.817599265559327_REALK,      0.000000000000000_REALK,     22.133617725484378_REALK, &
      2.492125940894548_REALK,     -0.150789961912235_REALK,      0.000000000000000_REALK, &
      3.459046652053860_REALK,      0.000000000000000_REALK,      3.432155282782896_REALK, &
     -0.021079693742575_REALK,      0.000000000000000_REALK,     -0.012588636115074_REALK, &
      0.000000000000000_REALK,     34.268431164503376_REALK,      0.000000000000000_REALK, &
     16.159218128373254_REALK,      0.000000000000000_REALK,     26.722654844799813_REALK, &
      1.503258783243034_REALK,      0.212458468088049_REALK,      0.000000000000000_REALK, &
      0.831812238005129_REALK,      0.000000000000000_REALK,      1.954318047539585_REALK, &
      0.289129920468890_REALK,      0.000000000000000_REALK,      0.323102384232680_REALK, &
      0.000000000000000_REALK,      3.130944504034718_REALK,      0.000000000000000_REALK, &
      3.113076381689531_REALK,      0.000000000000000_REALK,     12.190133538420731_REALK, &
      0.670858107101589_REALK,      0.097238834477472_REALK,      0.000000000000000_REALK, &
      0.346583711059645_REALK,      0.000000000000000_REALK,      1.379857862975326_REALK, &
     -0.012054045131847_REALK,      0.000000000000000_REALK,      0.247391460888583_REALK, &
      0.000000000000000_REALK,     -2.443571045273046_REALK,      0.000000000000000_REALK, &
      1.546880281858926_REALK,      0.000000000000000_REALK,     10.264354862872727_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.401233794951732_REALK, &
      0.000000000000000_REALK,     -0.919427527835910_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.451092148838531_REALK,      0.000000000000000_REALK, &
     -1.016979906318321_REALK,      0.000000000000000_REALK,     -4.837789586425197_REALK, &
      0.000000000000000_REALK,     -5.734964356149797_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.372640649455491_REALK, &
      0.000000000000000_REALK,     -1.566128268309100_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.955486772886179_REALK,      0.000000000000000_REALK, &
     -1.580097690232702_REALK,      0.000000000000000_REALK,    -11.704732729216188_REALK, &
      0.000000000000000_REALK,    -11.649965360952828_REALK,      0.000000000000000_REALK, &
      1.348607083457475_REALK,      0.190235677130195_REALK,      0.000000000000000_REALK, &
      0.482481899730566_REALK,      0.000000000000000_REALK,      1.551433634244652_REALK, &
      0.187601892590380_REALK,      0.000000000000000_REALK,      0.246469356602850_REALK, &
      0.000000000000000_REALK,      1.357157903056300_REALK,      0.000000000000000_REALK, &
      1.550513531756342_REALK,      0.000000000000000_REALK,      8.309530522843009_REALK, &
      1.091328763506225_REALK,      0.182649625083257_REALK,      0.000000000000000_REALK, &
      0.401868082900374_REALK,      0.000000000000000_REALK,      1.173351308792633_REALK, &
      0.310635612711562_REALK,      0.000000000000000_REALK,      0.257114747064351_REALK, &
      0.000000000000000_REALK,      2.528762488309537_REALK,      0.000000000000000_REALK, &
      1.422799419263211_REALK,      0.000000000000000_REALK,      6.923679816741236_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.538912181770249_REALK, &
      0.000000000000000_REALK,     -0.379030392856202_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.297179622333891_REALK,      0.000000000000000_REALK, &
     -1.163691100692325_REALK,      0.000000000000000_REALK,     -1.089987317936269_REALK, &
      0.000000000000000_REALK,     -2.030099482829131_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.597005779704164_REALK, &
      0.000000000000000_REALK,     -0.357299211890615_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.211086535593284_REALK,      0.000000000000000_REALK, &
     -1.400668903413871_REALK,      0.000000000000000_REALK,      0.061636835065003_REALK, &
      0.000000000000000_REALK,     -2.108341571161788_REALK,      0.000000000000000_REALK, &
      0.622228256527672_REALK,      0.253536365603071_REALK,      0.000000000000000_REALK, &
      0.529174784007438_REALK,      0.000000000000000_REALK,      1.193015936215147_REALK, &
      0.461823709395914_REALK,      0.000000000000000_REALK,      0.547469555030306_REALK, &
      0.000000000000000_REALK,      3.013409434139881_REALK,      0.000000000000000_REALK, &
      2.834277872136973_REALK,      0.000000000000000_REALK,      8.945766653732640_REALK, &
      1.273532643526513_REALK,      0.677597057658195_REALK,      0.000000000000000_REALK, &
      1.379977585717445_REALK,      0.000000000000000_REALK,      2.282082240844149_REALK, &
      1.597222170862796_REALK,      0.000000000000000_REALK,      1.589748642260841_REALK, &
      0.000000000000000_REALK,     10.361105020090474_REALK,      0.000000000000000_REALK, &
      8.142934589316377_REALK,      0.000000000000000_REALK,     18.852469235551112_REALK, &
      1.589753901531950_REALK,      0.087773662699723_REALK,      0.000000000000000_REALK, &
      0.392428627699966_REALK,      0.000000000000000_REALK,      1.539419464964156_REALK, &
      0.047987544812878_REALK,      0.000000000000000_REALK,      0.099069327237978_REALK, &
      0.000000000000000_REALK,      0.723403654944870_REALK,      0.000000000000000_REALK, &
      1.010666388205568_REALK,      0.000000000000000_REALK,      6.607738752850794_REALK, &
      0.692084157227295_REALK,      0.035322413543525_REALK,      0.000000000000000_REALK, &
      0.195471794194665_REALK,      0.000000000000000_REALK,      1.158913443217246_REALK, &
     -0.120248807994039_REALK,      0.000000000000000_REALK,      0.053795753529935_REALK, &
      0.000000000000000_REALK,     -0.509219036418539_REALK,      0.000000000000000_REALK, &
      0.555153949093790_REALK,      0.000000000000000_REALK,      5.485662499378424_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.684397159662685_REALK, &
      0.000000000000000_REALK,     -0.191744736232476_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.240232086824135_REALK,      0.000000000000000_REALK, &
     -1.287454651085959_REALK,      0.000000000000000_REALK,     -0.375876241399488_REALK, &
      0.000000000000000_REALK,     -0.823036964969121_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.623960491567285_REALK, &
      0.000000000000000_REALK,     -0.232713264693778_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.325469404195654_REALK,      0.000000000000000_REALK, &
     -1.583811403270873_REALK,      0.000000000000000_REALK,     -0.798499650045956_REALK, &
      0.000000000000000_REALK,     -1.101537338021264_REALK,      0.000000000000000_REALK, &
      0.560947747562515_REALK,      0.167204912005736_REALK,      0.000000000000000_REALK, &
      0.231195589924382_REALK,      0.000000000000000_REALK,      0.905311906655699_REALK, &
      0.168879485819812_REALK,      0.000000000000000_REALK,      0.314537748450478_REALK, &
      0.000000000000000_REALK,      0.598842038121476_REALK,      0.000000000000000_REALK, &
      0.992374134405991_REALK,      0.000000000000000_REALK,      5.440291348291835_REALK, &
      0.454243578441634_REALK,      0.190003275419086_REALK,      0.000000000000000_REALK, &
      0.191053361939282_REALK,      0.000000000000000_REALK,      1.267738381365247_REALK, &
     -0.014099600908961_REALK,      0.000000000000000_REALK,      0.482289116594033_REALK, &
      0.000000000000000_REALK,     -0.857141031603823_REALK,      0.000000000000000_REALK, &
      0.904342139703721_REALK,      0.000000000000000_REALK,      8.401092345361764_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.526285301643273_REALK, &
      0.000000000000000_REALK,     -0.425912603787692_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.439134824635592_REALK,      0.000000000000000_REALK, &
     -1.386031238975131_REALK,      0.000000000000000_REALK,     -1.542171365118088_REALK, &
      0.000000000000000_REALK,     -2.559436848758740_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.213557394212391_REALK, &
      0.000000000000000_REALK,     -1.438873502228278_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.862719392000750_REALK,      0.000000000000000_REALK, &
     -4.312555829471150_REALK,      0.000000000000000_REALK,     -6.842858600718072_REALK, &
      0.000000000000000_REALK,     -9.535176455331412_REALK,      0.000000000000000_REALK, &
      2.347884581401607_REALK,     -0.104822268774508_REALK,      0.000000000000000_REALK, &
      0.456843746872740_REALK,      0.000000000000000_REALK,      1.855129299802870_REALK, &
     -0.102215338646677_REALK,      0.000000000000000_REALK,     -0.100483275136350_REALK, &
      0.000000000000000_REALK,      0.670727306256096_REALK,      0.000000000000000_REALK, &
      0.895252546325363_REALK,      0.000000000000000_REALK,      6.058998073849623_REALK, &
      2.742989015543889_REALK,     -0.132741071519980_REALK,      0.000000000000000_REALK, &
      0.445632527771832_REALK,      0.000000000000000_REALK,      1.863435750580855_REALK, &
      0.003412475783016_REALK,      0.000000000000000_REALK,     -0.124354040220439_REALK, &
      0.000000000000000_REALK,      1.116922656369187_REALK,      0.000000000000000_REALK, &
      0.814265797872491_REALK,      0.000000000000000_REALK,      5.674825121861133_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.946938555561581_REALK, &
      0.000000000000000_REALK,     -0.070013697700128_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.231401267947132_REALK,      0.000000000000000_REALK, &
     -1.512901926409045_REALK,      0.000000000000000_REALK,     -0.066458450613736_REALK, &
      0.000000000000000_REALK,     -0.228670238539837_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.318305431421177_REALK, &
      0.000000000000000_REALK,     -0.054630968058490_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.208306931189868_REALK,      0.000000000000000_REALK, &
     -2.058350701916397_REALK,      0.000000000000000_REALK,      0.223131554367697_REALK, &
      0.000000000000000_REALK,     -0.166370742792325_REALK,      0.000000000000000_REALK, &
      0.690922842876072_REALK,      0.117947374121806_REALK,      0.000000000000000_REALK, &
      0.169775420644303_REALK,      0.000000000000000_REALK,      0.909862449426236_REALK, &
      0.086060286426932_REALK,      0.000000000000000_REALK,      0.188441803827433_REALK, &
      0.000000000000000_REALK,      0.291210824886597_REALK,      0.000000000000000_REALK, &
      0.554499865200853_REALK,      0.000000000000000_REALK,      4.160355162725566_REALK, &
      1.420545871042655_REALK,      0.264719649776340_REALK,      0.000000000000000_REALK, &
      0.330522531201913_REALK,      0.000000000000000_REALK,      1.608401119144371_REALK, &
      0.299616010889902_REALK,      0.000000000000000_REALK,      0.413322940148086_REALK, &
      0.000000000000000_REALK,      1.073383069896435_REALK,      0.000000000000000_REALK, &
      1.006558751929644_REALK,      0.000000000000000_REALK,      6.857415450866440_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.556881843274087_REALK, &
      0.000000000000000_REALK,     -0.222288284873389_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.227213089956620_REALK,      0.000000000000000_REALK, &
     -1.245604217858373_REALK,      0.000000000000000_REALK,     -0.389804931390485_REALK, &
      0.000000000000000_REALK,     -1.016415408911092_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.442097685169061_REALK, &
      0.000000000000000_REALK,     -0.489776972989963_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.339330623829419_REALK,      0.000000000000000_REALK, &
     -3.152289140627818_REALK,      0.000000000000000_REALK,      0.043604948762244_REALK, &
      0.000000000000000_REALK,     -2.088163295886450_REALK,      0.000000000000000_REALK, &
      0.531303398387097_REALK,      0.261990363903564_REALK,      0.000000000000000_REALK, &
      0.310342804567354_REALK,      0.000000000000000_REALK,      0.979527921244812_REALK, &
      0.353094169791962_REALK,      0.000000000000000_REALK,      0.586006360699235_REALK, &
      0.000000000000000_REALK,      1.077665619037064_REALK,      0.000000000000000_REALK, &
      1.419045582121471_REALK,      0.000000000000000_REALK,      5.758587296164656_REALK, &
      2.762857534924224_REALK,      1.636769997118730_REALK,      0.000000000000000_REALK, &
      1.891639338218311_REALK,      0.000000000000000_REALK,      4.379511100986617_REALK, &
      2.567602874857624_REALK,      0.000000000000000_REALK,      3.577824401692959_REALK, &
      0.000000000000000_REALK,      7.329958669110840_REALK,      0.000000000000000_REALK, &
      8.065001118791599_REALK,      0.000000000000000_REALK,     24.006906220020142_REALK, &
      4.201550183639268_REALK,     -0.543063404240941_REALK,      0.000000000000000_REALK, &
      0.717091841993126_REALK,      0.000000000000000_REALK,      2.676075537161065_REALK, &
     -0.357124314537010_REALK,      0.000000000000000_REALK,     -0.427968680802415_REALK, &
      0.000000000000000_REALK,      0.852561858545339_REALK,      0.000000000000000_REALK, &
      1.029121191748049_REALK,      0.000000000000000_REALK,      6.400867793903856_REALK, &
      2.692267374642717_REALK,     -0.626872651753313_REALK,      0.000000000000000_REALK, &
      0.680260586586473_REALK,      0.000000000000000_REALK,      2.982936315964440_REALK, &
     -0.603703842578996_REALK,      0.000000000000000_REALK,     -0.636373957011446_REALK, &
      0.000000000000000_REALK,      0.257022921067532_REALK,      0.000000000000000_REALK, &
      0.969371314286262_REALK,      0.000000000000000_REALK,      7.084473592559807_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.503774756504669_REALK, &
      0.000000000000000_REALK,      0.075335591464280_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.291835245041806_REALK,      0.000000000000000_REALK, &
     -1.975117741745135_REALK,      0.000000000000000_REALK,      0.109980130764170_REALK, &
      0.000000000000000_REALK,      0.180194151638173_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.828745768598852_REALK, &
      0.000000000000000_REALK,      0.124145531017137_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.443965138369407_REALK,      0.000000000000000_REALK, &
     -3.094105790801978_REALK,      0.000000000000000_REALK,     -0.004854624275693_REALK, &
      0.000000000000000_REALK,      0.294845629595972_REALK,      0.000000000000000_REALK, &
      1.068512565444824_REALK,      0.056753365505137_REALK,      0.000000000000000_REALK, &
      0.173489084255327_REALK,      0.000000000000000_REALK,      1.134271960172628_REALK, &
      0.021664186602503_REALK,      0.000000000000000_REALK,      0.074542133805658_REALK, &
      0.000000000000000_REALK,      0.178211928662072_REALK,      0.000000000000000_REALK, &
      0.414966123557878_REALK,      0.000000000000000_REALK,      3.798269018197848_REALK, &
      1.112797188283371_REALK,      0.053613950274529_REALK,      0.000000000000000_REALK, &
      0.207957654944500_REALK,      0.000000000000000_REALK,      2.054899386107031_REALK, &
     -0.121658838757892_REALK,      0.000000000000000_REALK,      0.090710932520319_REALK, &
      0.000000000000000_REALK,     -0.271819721599723_REALK,      0.000000000000000_REALK, &
      0.493899419488156_REALK,      0.000000000000000_REALK,      6.832540306563702_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.737537908265516_REALK, &
      0.000000000000000_REALK,     -0.141280971670875_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.180756373942474_REALK,      0.000000000000000_REALK, &
     -1.356196386548674_REALK,      0.000000000000000_REALK,     -0.154329765639070_REALK, &
      0.000000000000000_REALK,     -0.473099182912625_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.578458897725919_REALK, &
      0.000000000000000_REALK,     -0.412629905673262_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.548809733559951_REALK,      0.000000000000000_REALK, &
     -3.738893869121067_REALK,      0.000000000000000_REALK,     -0.710394863015855_REALK, &
      0.000000000000000_REALK,     -1.371994405792914_REALK,      0.000000000000000_REALK, &
      0.628377885251016_REALK,      0.180187716023267_REALK,      0.000000000000000_REALK, &
      0.170349070500354_REALK,      0.000000000000000_REALK,      0.933870142622527_REALK, &
      0.127068968569572_REALK,      0.000000000000000_REALK,      0.331332025964473_REALK, &
      0.000000000000000_REALK,      0.245876544508398_REALK,      0.000000000000000_REALK, &
      0.570437795766212_REALK,      0.000000000000000_REALK,      4.020679770009829_REALK, &
      1.217291692074804_REALK,      0.480659215984965_REALK,      0.000000000000000_REALK, &
      0.338761655117948_REALK,      0.000000000000000_REALK,      3.147003576153012_REALK, &
     -0.023774886727899_REALK,      0.000000000000000_REALK,      1.138536960558080_REALK, &
      0.000000000000000_REALK,     -0.762565876762027_REALK,      0.000000000000000_REALK, &
      1.126382478169204_REALK,      0.000000000000000_REALK,     13.453439988285536_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.794009000567219_REALK, &
      0.000000000000000_REALK,     -0.439348097732698_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.462581778609546_REALK,      0.000000000000000_REALK, &
     -1.877189561279475_REALK,      0.000000000000000_REALK,     -0.886472957840951_REALK, &
      0.000000000000000_REALK,     -1.891567069041823_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.297981506453589_REALK, &
      0.000000000000000_REALK,     -3.571825325875024_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -4.397310248089819_REALK,      0.000000000000000_REALK, &
    -13.089373850210078_REALK,      0.000000000000000_REALK,     -8.522964583916711_REALK, &
      0.000000000000000_REALK,    -15.269552927880639_REALK,      0.000000000000000_REALK/
    ! results of test 2, ket-major order, CM000102
  data REF_CONTR_INTS(11341:12600)                                                         &
     /0.298275017314338_REALK,      0.164087924192330_REALK,      0.000000000000000_REALK, &
      0.105063310024795_REALK,      0.000000000000000_REALK,      0.155760107588638_REALK, &
      0.037318182280638_REALK,      0.000000000000000_REALK,      0.104087345622837_REALK, &
      0.000000000000000_REALK,     -0.134354693488454_REALK,      0.000000000000000_REALK, &
      0.094437050891658_REALK,      0.000000000000000_REALK,      0.233343831824939_REALK, &
      0.055917615118965_REALK,     -0.071497513384724_REALK,      0.000000000000000_REALK, &
     -0.283609603141107_REALK,      0.000000000000000_REALK,      0.045390885080484_REALK, &
     -0.738187866946589_REALK,      0.000000000000000_REALK,     -0.052752126609321_REALK, &
      0.000000000000000_REALK,     -2.086422173435828_REALK,      0.000000000000000_REALK, &
     -0.256879644527205_REALK,      0.000000000000000_REALK,      0.068521389350656_REALK, &
      0.325178677416417_REALK,      0.162498186687140_REALK,      0.000000000000000_REALK, &
      0.122531061843461_REALK,      0.000000000000000_REALK,      0.148092128766452_REALK, &
      0.115964101613311_REALK,      0.000000000000000_REALK,      0.088847759625008_REALK, &
      0.000000000000000_REALK,      0.159944178558548_REALK,      0.000000000000000_REALK, &
      0.090673891646933_REALK,      0.000000000000000_REALK,      0.182648783575221_REALK, &
      0.358586258464748_REALK,      0.202941349911583_REALK,      0.000000000000000_REALK, &
      0.213150467039273_REALK,      0.000000000000000_REALK,      0.131712773448222_REALK, &
      0.340017877408335_REALK,      0.000000000000000_REALK,      0.100038867504527_REALK, &
      0.000000000000000_REALK,      0.772439015076527_REALK,      0.000000000000000_REALK, &
      0.143474484668993_REALK,      0.000000000000000_REALK,      0.147762771821073_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.128037255061347_REALK, &
      0.000000000000000_REALK,     -0.071647144863945_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.047220345204420_REALK,      0.000000000000000_REALK, &
     -0.116676412340921_REALK,      0.000000000000000_REALK,     -0.019008922287163_REALK, &
      0.000000000000000_REALK,     -0.088365694821464_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.058609503303539_REALK, &
      0.000000000000000_REALK,      0.051187113916390_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.180517181332212_REALK,      0.000000000000000_REALK, &
     -0.048152075612350_REALK,      0.000000000000000_REALK,      0.482143103380326_REALK, &
      0.000000000000000_REALK,      0.057424573454754_REALK,      0.000000000000000_REALK, &
      0.385594517588236_REALK,      0.147833539945339_REALK,      0.000000000000000_REALK, &
      0.092597208615155_REALK,      0.000000000000000_REALK,      0.152610555274232_REALK, &
      0.065402875959424_REALK,      0.000000000000000_REALK,      0.069159589448493_REALK, &
      0.000000000000000_REALK,      0.056707369415341_REALK,      0.000000000000000_REALK, &
      0.056273600145100_REALK,      0.000000000000000_REALK,      0.154575310527922_REALK, &
      0.171829232930367_REALK,      0.066300176240069_REALK,      0.000000000000000_REALK, &
     -0.004843805899442_REALK,      0.000000000000000_REALK,      0.105932710316362_REALK, &
     -0.110467034251739_REALK,      0.000000000000000_REALK,      0.036300932889326_REALK, &
      0.000000000000000_REALK,     -0.351478381905431_REALK,      0.000000000000000_REALK, &
     -0.002954831320591_REALK,      0.000000000000000_REALK,      0.107702254802701_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.140025004272608_REALK, &
      0.000000000000000_REALK,     -0.070473440092414_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.054199994914549_REALK,      0.000000000000000_REALK, &
     -0.109177658101106_REALK,      0.000000000000000_REALK,     -0.055899685412508_REALK, &
      0.000000000000000_REALK,     -0.071380736847991_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.132960917148257_REALK, &
      0.000000000000000_REALK,     -0.098999442603171_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.117810906908244_REALK,      0.000000000000000_REALK, &
     -0.121332139269768_REALK,      0.000000000000000_REALK,     -0.205263484295027_REALK, &
      0.000000000000000_REALK,     -0.100653170873560_REALK,      0.000000000000000_REALK, &
      0.140300618454462_REALK,      0.067744260611687_REALK,      0.000000000000000_REALK, &
      0.037454857420739_REALK,      0.000000000000000_REALK,      0.092546938606105_REALK, &
      0.011362515411901_REALK,      0.000000000000000_REALK,      0.052820278505229_REALK, &
      0.000000000000000_REALK,     -0.032383618889599_REALK,      0.000000000000000_REALK, &
      0.037937062781707_REALK,      0.000000000000000_REALK,      0.131233782924371_REALK, &
      0.046376419179907_REALK,     -0.051672176010864_REALK,      0.000000000000000_REALK, &
     -0.178641569801616_REALK,      0.000000000000000_REALK,      0.047651765406007_REALK, &
     -0.395901169464643_REALK,      0.000000000000000_REALK,     -0.047152921253780_REALK, &
      0.000000000000000_REALK,     -0.885117620107567_REALK,      0.000000000000000_REALK, &
     -0.181625673615531_REALK,      0.000000000000000_REALK,      0.067826864713656_REALK, &
      0.551664499520554_REALK,      0.160013525574356_REALK,      0.000000000000000_REALK, &
      0.090645271726214_REALK,      0.000000000000000_REALK,      0.185612691171449_REALK, &
      0.057012460925790_REALK,      0.000000000000000_REALK,      0.062962752612097_REALK, &
      0.000000000000000_REALK,      0.052186980636392_REALK,      0.000000000000000_REALK, &
      0.044829750860847_REALK,      0.000000000000000_REALK,      0.152995123065367_REALK, &
      0.753169714522225_REALK,      0.226180895027066_REALK,      0.000000000000000_REALK, &
      0.159379436880276_REALK,      0.000000000000000_REALK,      0.199139896494554_REALK, &
      0.185899357920508_REALK,      0.000000000000000_REALK,      0.075025760203309_REALK, &
      0.000000000000000_REALK,      0.340267392689466_REALK,      0.000000000000000_REALK, &
      0.067115521368530_REALK,      0.000000000000000_REALK,      0.139764767652628_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.170854565691576_REALK, &
      0.000000000000000_REALK,     -0.064840625455941_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.040791241485913_REALK,      0.000000000000000_REALK, &
     -0.112047546331608_REALK,      0.000000000000000_REALK,     -0.030325837605117_REALK, &
      0.000000000000000_REALK,     -0.053446234784149_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.223857838059496_REALK, &
      0.000000000000000_REALK,     -0.056211086592832_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.003395341325307_REALK,      0.000000000000000_REALK, &
     -0.123758643687045_REALK,      0.000000000000000_REALK,      0.072032347626561_REALK, &
      0.000000000000000_REALK,     -0.039451308328684_REALK,      0.000000000000000_REALK, &
      0.182535434258227_REALK,      0.078898271342662_REALK,      0.000000000000000_REALK, &
      0.050815246273050_REALK,      0.000000000000000_REALK,      0.102359596023381_REALK, &
      0.040520200605056_REALK,      0.000000000000000_REALK,      0.051742004540336_REALK, &
      0.000000000000000_REALK,      0.044330373147468_REALK,      0.000000000000000_REALK, &
      0.041885524142102_REALK,      0.000000000000000_REALK,      0.118120837795914_REALK, &
      0.426349611122108_REALK,      0.209206402102393_REALK,      0.000000000000000_REALK, &
      0.182427242572230_REALK,      0.000000000000000_REALK,      0.187879782808333_REALK, &
      0.235864425135440_REALK,      0.000000000000000_REALK,      0.115658673376259_REALK, &
      0.000000000000000_REALK,      0.413589878292892_REALK,      0.000000000000000_REALK, &
      0.128035123149291_REALK,      0.000000000000000_REALK,      0.184606723787121_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.103610572500819_REALK, &
      0.000000000000000_REALK,     -0.049521692108753_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.027499571472319_REALK,      0.000000000000000_REALK, &
     -0.095127891525953_REALK,      0.000000000000000_REALK,     -0.008780903288838_REALK, &
      0.000000000000000_REALK,     -0.057146999286917_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.100698086093049_REALK, &
      0.000000000000000_REALK,      0.073015119137078_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.208702659629373_REALK,      0.000000000000000_REALK, &
     -0.077938579817888_REALK,      0.000000000000000_REALK,      0.430259441316693_REALK, &
      0.000000000000000_REALK,      0.071743120677189_REALK,      0.000000000000000_REALK, &
      0.931920696899751_REALK,      0.195118690965601_REALK,      0.000000000000000_REALK, &
      0.100350484732249_REALK,      0.000000000000000_REALK,      0.266791764600059_REALK, &
      0.047532650804593_REALK,      0.000000000000000_REALK,      0.064008064159388_REALK, &
      0.000000000000000_REALK,      0.033552602132950_REALK,      0.000000000000000_REALK, &
      0.040012821807439_REALK,      0.000000000000000_REALK,      0.177296790761521_REALK, &
      0.549258519016639_REALK,      0.135179064950792_REALK,      0.000000000000000_REALK, &
      0.024775221320820_REALK,      0.000000000000000_REALK,      0.257466550581485_REALK, &
     -0.092730361438337_REALK,      0.000000000000000_REALK,      0.054191306939313_REALK, &
      0.000000000000000_REALK,     -0.266838005284462_REALK,      0.000000000000000_REALK, &
      0.010143334673012_REALK,      0.000000000000000_REALK,      0.175684228732425_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.251649752818385_REALK, &
      0.000000000000000_REALK,     -0.071772804608715_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.040315292475898_REALK,      0.000000000000000_REALK, &
     -0.137588164451597_REALK,      0.000000000000000_REALK,     -0.025913477864064_REALK, &
      0.000000000000000_REALK,     -0.047696704357253_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.272958401640972_REALK, &
      0.000000000000000_REALK,     -0.108070803768037_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.087577121053114_REALK,      0.000000000000000_REALK, &
     -0.182375041213849_REALK,      0.000000000000000_REALK,     -0.109632439718598_REALK, &
      0.000000000000000_REALK,     -0.073742922199410_REALK,      0.000000000000000_REALK, &
      0.267692589800210_REALK,      0.087909545762175_REALK,      0.000000000000000_REALK, &
      0.046498948718974_REALK,      0.000000000000000_REALK,      0.127725779387214_REALK, &
      0.027271956438524_REALK,      0.000000000000000_REALK,      0.048064076772293_REALK, &
      0.000000000000000_REALK,      0.018683474368620_REALK,      0.000000000000000_REALK, &
      0.030900932770609_REALK,      0.000000000000000_REALK,      0.118832450257750_REALK, &
      0.228181670575256_REALK,      0.077047787113324_REALK,      0.000000000000000_REALK, &
     -0.004890817035355_REALK,      0.000000000000000_REALK,      0.178268051669952_REALK, &
     -0.093992946775935_REALK,      0.000000000000000_REALK,      0.051478882004558_REALK, &
      0.000000000000000_REALK,     -0.238182885908867_REALK,      0.000000000000000_REALK, &
     -0.003337285627151_REALK,      0.000000000000000_REALK,      0.170299555932016_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.138776970881158_REALK, &
      0.000000000000000_REALK,     -0.058981995352333_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.037667556117737_REALK,      0.000000000000000_REALK, &
     -0.106225799425521_REALK,      0.000000000000000_REALK,     -0.030695608889003_REALK, &
      0.000000000000000_REALK,     -0.054875179172409_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.257524313905717_REALK, &
      0.000000000000000_REALK,     -0.166600455105629_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.167069364141951_REALK,      0.000000000000000_REALK, &
     -0.240888025104493_REALK,      0.000000000000000_REALK,     -0.231831465689087_REALK, &
      0.000000000000000_REALK,     -0.159153495294203_REALK,      0.000000000000000_REALK, &
      0.162335623699369_REALK,      0.067140460599242_REALK,      0.000000000000000_REALK, &
      0.031347444135200_REALK,      0.000000000000000_REALK,      0.108438644882553_REALK, &
      0.007896646255986_REALK,      0.000000000000000_REALK,      0.051392165830307_REALK, &
      0.000000000000000_REALK,     -0.017782477531139_REALK,      0.000000000000000_REALK, &
      0.029164774830700_REALK,      0.000000000000000_REALK,      0.129713459371006_REALK, &
      0.102643077890961_REALK,     -0.100080850528246_REALK,      0.000000000000000_REALK, &
     -0.300625599974640_REALK,      0.000000000000000_REALK,      0.112266572742930_REALK, &
     -0.561433218547651_REALK,      0.000000000000000_REALK,     -0.093615542815710_REALK, &
      0.000000000000000_REALK,     -0.999681535571331_REALK,      0.000000000000000_REALK, &
     -0.287187780973019_REALK,      0.000000000000000_REALK,      0.137890685840209_REALK, &
      2.308434872003004_REALK,      0.311595756161896_REALK,      0.000000000000000_REALK, &
      0.153028746246680_REALK,      0.000000000000000_REALK,      0.503896079574469_REALK, &
      0.053469682853723_REALK,      0.000000000000000_REALK,      0.078260036722457_REALK, &
      0.000000000000000_REALK,      0.037979170486361_REALK,      0.000000000000000_REALK, &
      0.046164230140379_REALK,      0.000000000000000_REALK,      0.253350815395308_REALK, &
      6.687144709027781_REALK,      0.944449805154593_REALK,      0.000000000000000_REALK, &
      0.520693853515071_REALK,      0.000000000000000_REALK,      1.178990621597243_REALK, &
      0.408850341330846_REALK,      0.000000000000000_REALK,      0.186802036776461_REALK, &
      0.000000000000000_REALK,      0.588825142829781_REALK,      0.000000000000000_REALK, &
      0.118630173680546_REALK,      0.000000000000000_REALK,      0.447684249467098_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.512654436619610_REALK, &
      0.000000000000000_REALK,     -0.099615314931408_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.048430648964803_REALK,      0.000000000000000_REALK, &
     -0.214596178127105_REALK,      0.000000000000000_REALK,     -0.022315983499988_REALK, &
      0.000000000000000_REALK,     -0.050084972451156_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.556227643507752_REALK, &
      0.000000000000000_REALK,     -0.225320683749056_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.029619149211089_REALK,      0.000000000000000_REALK, &
     -0.513008547248832_REALK,      0.000000000000000_REALK,      0.087842786353029_REALK, &
      0.000000000000000_REALK,     -0.085558374550047_REALK,      0.000000000000000_REALK, &
      0.588573078701778_REALK,      0.137915226755399_REALK,      0.000000000000000_REALK, &
      0.062742415495305_REALK,      0.000000000000000_REALK,      0.214127524596757_REALK, &
      0.031365109812334_REALK,      0.000000000000000_REALK,      0.057731053226410_REALK, &
      0.000000000000000_REALK,      0.022033812893679_REALK,      0.000000000000000_REALK, &
      0.031545873782210_REALK,      0.000000000000000_REALK,      0.150723808372099_REALK, &
      2.580586730152566_REALK,      0.653221833671527_REALK,      0.000000000000000_REALK, &
      0.364134727707523_REALK,      0.000000000000000_REALK,      0.758292635958850_REALK, &
      0.320133338303479_REALK,      0.000000000000000_REALK,      0.215333781867356_REALK, &
      0.000000000000000_REALK,      0.420602819821856_REALK,      0.000000000000000_REALK, &
      0.138268599675373_REALK,      0.000000000000000_REALK,      0.403112568278162_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.245431816726843_REALK, &
      0.000000000000000_REALK,     -0.074801795796180_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.037401816720162_REALK,      0.000000000000000_REALK, &
     -0.143832212378246_REALK,      0.000000000000000_REALK,     -0.021339735935636_REALK, &
      0.000000000000000_REALK,     -0.052652789764904_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.077521213285711_REALK, &
      0.000000000000000_REALK,     -0.214042759752843_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.009745075375814_REALK,      0.000000000000000_REALK, &
     -0.497284977804500_REALK,      0.000000000000000_REALK,      0.148398040193492_REALK, &
      0.000000000000000_REALK,     -0.113786317463323_REALK,      0.000000000000000_REALK, &
      0.324579651240025_REALK,      0.113337012644970_REALK,      0.000000000000000_REALK, &
      0.058621761408395_REALK,      0.000000000000000_REALK,      0.165318489202611_REALK, &
      0.037153297161056_REALK,      0.000000000000000_REALK,      0.066419722962041_REALK, &
      0.000000000000000_REALK,      0.031194470840784_REALK,      0.000000000000000_REALK, &
      0.041263705586627_REALK,      0.000000000000000_REALK,      0.149615042321007_REALK, &
      2.434670715982770_REALK,      1.006997736485763_REALK,      0.000000000000000_REALK, &
      0.694653542940771_REALK,      0.000000000000000_REALK,      1.001582312533764_REALK, &
      0.676961866627561_REALK,      0.000000000000000_REALK,      0.464737808279904_REALK, &
      0.000000000000000_REALK,      0.852060628382167_REALK,      0.000000000000000_REALK, &
      0.369281673696189_REALK,      0.000000000000000_REALK,      0.684574339926238_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.208370571270800_REALK, &
      0.000000000000000_REALK,     -0.079981278162781_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.035300408922935_REALK,      0.000000000000000_REALK, &
     -0.157002349073003_REALK,      0.000000000000000_REALK,     -0.008650544920150_REALK, &
      0.000000000000000_REALK,     -0.072383932220352_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.678582687925232_REALK, &
      0.000000000000000_REALK,      0.389241730973508_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.838605647004170_REALK,      0.000000000000000_REALK, &
     -0.402649121850144_REALK,      0.000000000000000_REALK,      1.240963594245549_REALK, &
      0.000000000000000_REALK,      0.266043936397841_REALK,      0.000000000000000_REALK, &
      1.061162321019866_REALK,      0.110642897426023_REALK,      0.000000000000000_REALK, &
      0.406918649271663_REALK,      0.000000000000000_REALK,      1.379568640114067_REALK, &
      0.071436492199449_REALK,      0.000000000000000_REALK,      0.168263398858474_REALK, &
      0.000000000000000_REALK,      0.313151308753437_REALK,      0.000000000000000_REALK, &
      1.522902379213143_REALK,      0.000000000000000_REALK,      8.605112135959706_REALK, &
      0.384402561513886_REALK,      0.002678952300192_REALK,      0.000000000000000_REALK, &
     -0.247230251782250_REALK,      0.000000000000000_REALK,      0.790660337018882_REALK, &
     -0.414898601817271_REALK,      0.000000000000000_REALK,      0.006815691763035_REALK, &
      0.000000000000000_REALK,     -8.064043715033666_REALK,      0.000000000000000_REALK, &
     -1.103443668462436_REALK,      0.000000000000000_REALK,      5.881488588731164_REALK, &
      1.012989919036071_REALK,      0.106313289649060_REALK,      0.000000000000000_REALK, &
      0.318149955747695_REALK,      0.000000000000000_REALK,      1.165340632435499_REALK, &
      0.090304395780085_REALK,      0.000000000000000_REALK,      0.137739505509281_REALK, &
      0.000000000000000_REALK,      0.826026326775381_REALK,      0.000000000000000_REALK, &
      1.022413093195734_REALK,      0.000000000000000_REALK,      6.241603469842612_REALK, &
      0.806598388679349_REALK,      0.116129261536575_REALK,      0.000000000000000_REALK, &
      0.324976278045644_REALK,      0.000000000000000_REALK,      0.867221048940625_REALK, &
      0.315198197242485_REALK,      0.000000000000000_REALK,      0.163474442902010_REALK, &
      0.000000000000000_REALK,      2.958802124796852_REALK,      0.000000000000000_REALK, &
      1.150566763950471_REALK,      0.000000000000000_REALK,      5.117274620319637_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.380422391678614_REALK, &
      0.000000000000000_REALK,     -0.197389265090408_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.145378878773390_REALK,      0.000000000000000_REALK, &
     -0.821458795468875_REALK,      0.000000000000000_REALK,     -0.269307550076372_REALK, &
      0.000000000000000_REALK,     -1.057223516975554_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.342085082564446_REALK, &
      0.000000000000000_REALK,     -0.009843675633245_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.150575389659871_REALK,      0.000000000000000_REALK, &
     -0.802585090059295_REALK,      0.000000000000000_REALK,      2.121531519850343_REALK, &
      0.000000000000000_REALK,     -0.058085296188555_REALK,      0.000000000000000_REALK, &
      1.232200095623984_REALK,      0.027650627951370_REALK,      0.000000000000000_REALK, &
      0.284753275179400_REALK,      0.000000000000000_REALK,      1.193186448610916_REALK, &
     -0.003664815295388_REALK,      0.000000000000000_REALK,      0.031209009907917_REALK, &
      0.000000000000000_REALK,      0.480676557590064_REALK,      0.000000000000000_REALK, &
      0.733357721229509_REALK,      0.000000000000000_REALK,      5.121582853342924_REALK, &
      0.525872729988093_REALK,     -0.014482884008964_REALK,      0.000000000000000_REALK, &
      0.100146440654388_REALK,      0.000000000000000_REALK,      0.880587960062783_REALK, &
     -0.211891411867978_REALK,      0.000000000000000_REALK,     -0.022057316598392_REALK, &
      0.000000000000000_REALK,     -0.990393000716567_REALK,      0.000000000000000_REALK, &
      0.284423091556643_REALK,      0.000000000000000_REALK,      4.168221861772831_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.514076658694253_REALK, &
      0.000000000000000_REALK,     -0.107156627974755_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.158409730675815_REALK,      0.000000000000000_REALK, &
     -0.967056008205597_REALK,      0.000000000000000_REALK,     -0.180932486335752_REALK, &
      0.000000000000000_REALK,     -0.459954560409622_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.461167655364264_REALK, &
      0.000000000000000_REALK,     -0.147959896256756_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.263195411862202_REALK,      0.000000000000000_REALK, &
     -1.170591089110407_REALK,      0.000000000000000_REALK,     -0.810227932323204_REALK, &
      0.000000000000000_REALK,     -0.700361238415159_REALK,      0.000000000000000_REALK, &
      0.395977472681142_REALK,      0.087076011112491_REALK,      0.000000000000000_REALK, &
      0.113099799295108_REALK,      0.000000000000000_REALK,      0.639066869139567_REALK, &
      0.041725733718078_REALK,      0.000000000000000_REALK,      0.163803157161030_REALK, &
      0.000000000000000_REALK,      0.059895078859640_REALK,      0.000000000000000_REALK, &
      0.485464776658085_REALK,      0.000000000000000_REALK,      3.840344895057449_REALK, &
      0.260282156920787_REALK,      0.005234634027271_REALK,      0.000000000000000_REALK, &
     -0.136285028028814_REALK,      0.000000000000000_REALK,      0.726415729298882_REALK, &
     -0.485306354781591_REALK,      0.000000000000000_REALK,      0.013287176313866_REALK, &
      0.000000000000000_REALK,     -2.828656347918840_REALK,      0.000000000000000_REALK, &
     -0.645098796514913_REALK,      0.000000000000000_REALK,      4.813836760539776_REALK, &
      1.860585301459293_REALK,     -0.132136521801347_REALK,      0.000000000000000_REALK, &
      0.358692251960332_REALK,      0.000000000000000_REALK,      1.470100504454604_REALK, &
     -0.114898247509749_REALK,      0.000000000000000_REALK,     -0.126666887016989_REALK, &
      0.000000000000000_REALK,      0.533054655383181_REALK,      0.000000000000000_REALK, &
      0.702910249101250_REALK,      0.000000000000000_REALK,      4.801463771717864_REALK, &
      2.178307500247759_REALK,     -0.150664095738903_REALK,      0.000000000000000_REALK, &
      0.380929139303654_REALK,      0.000000000000000_REALK,      1.479822211725200_REALK, &
      0.040944212172307_REALK,      0.000000000000000_REALK,     -0.141144626954977_REALK, &
      0.000000000000000_REALK,      1.225367156665843_REALK,      0.000000000000000_REALK, &
      0.696038889034565_REALK,      0.000000000000000_REALK,      4.506585354696882_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.733961261292471_REALK, &
      0.000000000000000_REALK,     -0.022055849637137_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.167908924776482_REALK,      0.000000000000000_REALK, &
     -1.172633007281516_REALK,      0.000000000000000_REALK,      0.005075440872559_REALK, &
      0.000000000000000_REALK,     -0.072036138118638_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.001700254138173_REALK, &
      0.000000000000000_REALK,      0.022399770975830_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.106722291102156_REALK,      0.000000000000000_REALK, &
     -1.564015722056457_REALK,      0.000000000000000_REALK,      0.393181943970799_REALK, &
      0.000000000000000_REALK,      0.068215275475934_REALK,      0.000000000000000_REALK, &
      0.518978346807174_REALK,      0.065914940549116_REALK,      0.000000000000000_REALK, &
      0.111950401860038_REALK,      0.000000000000000_REALK,      0.683432187390930_REALK, &
      0.041426139465523_REALK,      0.000000000000000_REALK,      0.105310782785431_REALK, &
      0.000000000000000_REALK,      0.177243788255290_REALK,      0.000000000000000_REALK, &
      0.365638809817051_REALK,      0.000000000000000_REALK,      3.125000521757650_REALK, &
      1.049921938231378_REALK,      0.168309666273524_REALK,      0.000000000000000_REALK, &
      0.267281694094754_REALK,      0.000000000000000_REALK,      1.188765287266720_REALK, &
      0.304016740621339_REALK,      0.000000000000000_REALK,      0.262792150784016_REALK, &
      0.000000000000000_REALK,      1.255921867954324_REALK,      0.000000000000000_REALK, &
      0.813967893333439_REALK,      0.000000000000000_REALK,      5.068298791468806_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.393107318533467_REALK, &
      0.000000000000000_REALK,     -0.115762012799886_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.111151578971382_REALK,      0.000000000000000_REALK, &
     -0.879281915814378_REALK,      0.000000000000000_REALK,     -0.096310672017010_REALK, &
      0.000000000000000_REALK,     -0.529322962941504_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.826323835493705_REALK, &
      0.000000000000000_REALK,     -0.013493468483278_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.242056371634666_REALK,      0.000000000000000_REALK, &
     -1.806265747499183_REALK,      0.000000000000000_REALK,      1.500876434083585_REALK, &
      0.000000000000000_REALK,     -0.057529380054294_REALK,      0.000000000000000_REALK, &
      3.384895735521311_REALK,     -0.508514556170498_REALK,      0.000000000000000_REALK, &
      0.589000243643397_REALK,      0.000000000000000_REALK,      2.155927283444557_REALK, &
     -0.329428297868654_REALK,      0.000000000000000_REALK,     -0.400741979801236_REALK, &
      0.000000000000000_REALK,      0.714836850330105_REALK,      0.000000000000000_REALK, &
      0.845292886045683_REALK,      0.000000000000000_REALK,      5.156732432612320_REALK, &
      2.176223298542341_REALK,     -0.588965416114245_REALK,      0.000000000000000_REALK, &
      0.543527048927963_REALK,      0.000000000000000_REALK,      2.411177868145932_REALK, &
     -0.604759844888001_REALK,      0.000000000000000_REALK,     -0.597892173709002_REALK, &
      0.000000000000000_REALK,     -0.010244985685630_REALK,      0.000000000000000_REALK, &
      0.774526027464414_REALK,      0.000000000000000_REALK,      5.726547309248070_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.191668973347856_REALK, &
      0.000000000000000_REALK,      0.094966300007790_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.229135326820180_REALK,      0.000000000000000_REALK, &
     -1.565185558120023_REALK,      0.000000000000000_REALK,      0.123626497285073_REALK, &
      0.000000000000000_REALK,      0.227148569905816_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.452273633328917_REALK, &
      0.000000000000000_REALK,      0.140907964328942_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.379503845658404_REALK,      0.000000000000000_REALK, &
     -2.457142122141367_REALK,      0.000000000000000_REALK,     -0.058247670899256_REALK, &
      0.000000000000000_REALK,      0.334656407824447_REALK,      0.000000000000000_REALK, &
      0.828191888095253_REALK,      0.017878554298676_REALK,      0.000000000000000_REALK, &
      0.125886801987722_REALK,      0.000000000000000_REALK,      0.879161244040026_REALK, &
     -0.001654496864397_REALK,      0.000000000000000_REALK,      0.023482406284134_REALK, &
      0.000000000000000_REALK,      0.118415625640292_REALK,      0.000000000000000_REALK, &
      0.301106887803169_REALK,      0.000000000000000_REALK,      2.943994943443102_REALK, &
      0.845547017966864_REALK,     -0.021982773689334_REALK,      0.000000000000000_REALK, &
      0.106543345730918_REALK,      0.000000000000000_REALK,      1.561393276725541_REALK, &
     -0.214376038654006_REALK,      0.000000000000000_REALK,     -0.037193265755125_REALK, &
      0.000000000000000_REALK,     -0.528669060808291_REALK,      0.000000000000000_REALK, &
      0.253040440472702_REALK,      0.000000000000000_REALK,      5.191632529432837_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.553992690046164_REALK, &
      0.000000000000000_REALK,     -0.078954931534041_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.119191274124534_REALK,      0.000000000000000_REALK, &
     -1.018690532371265_REALK,      0.000000000000000_REALK,     -0.074288462895992_REALK, &
      0.000000000000000_REALK,     -0.264391681016286_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.166635065506588_REALK, &
      0.000000000000000_REALK,     -0.262351517074837_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.443802710780963_REALK,      0.000000000000000_REALK, &
     -2.763407206996931_REALK,      0.000000000000000_REALK,     -0.720829071072524_REALK, &
      0.000000000000000_REALK,     -0.872318774836887_REALK,      0.000000000000000_REALK, &
      0.443576942721723_REALK,      0.093837121018539_REALK,      0.000000000000000_REALK, &
      0.083333967096863_REALK,      0.000000000000000_REALK,      0.659226354851944_REALK, &
      0.031395441078154_REALK,      0.000000000000000_REALK,      0.172549184283635_REALK, &
      0.000000000000000_REALK,      0.024592119600126_REALK,      0.000000000000000_REALK, &
      0.279055496831077_REALK,      0.000000000000000_REALK,      2.838229800737817_REALK, &
      0.697509711203754_REALK,      0.013242272176448_REALK,      0.000000000000000_REALK, &
     -0.241650506404119_REALK,      0.000000000000000_REALK,      1.803237112230929_REALK, &
     -0.818328383034511_REALK,      0.000000000000000_REALK,      0.031366955658514_REALK, &
      0.000000000000000_REALK,     -2.516548302410755_REALK,      0.000000000000000_REALK, &
     -0.803487915890434_REALK,      0.000000000000000_REALK,      7.708838483019431_REALK, &
      8.337467655900054_REALK,     -1.662791147729720_REALK,      0.000000000000000_REALK, &
      1.273445492740430_REALK,      0.000000000000000_REALK,      3.925644234136187_REALK, &
     -0.824422909585208_REALK,      0.000000000000000_REALK,     -0.991464234533383_REALK, &
      0.000000000000000_REALK,      1.226058813000370_REALK,      0.000000000000000_REALK, &
      1.260288248380147_REALK,      0.000000000000000_REALK,      6.475140768106633_REALK, &
     25.361669888090081_REALK,     -5.032601318543276_REALK,      0.000000000000000_REALK, &
      3.207839667915962_REALK,      0.000000000000000_REALK,      9.608960478677126_REALK, &
     -1.494586233716697_REALK,      0.000000000000000_REALK,     -2.368190800902332_REALK, &
      0.000000000000000_REALK,      2.880125957389092_REALK,      0.000000000000000_REALK, &
      2.199536743000436_REALK,      0.000000000000000_REALK,     10.981046344200211_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.441230343359921_REALK, &
      0.000000000000000_REALK,      0.366146470500048_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.397676084244687_REALK,      0.000000000000000_REALK, &
     -2.426033857793542_REALK,      0.000000000000000_REALK,      0.297879379860865_REALK, &
      0.000000000000000_REALK,      0.603939072628394_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -8.287297249898080_REALK, &
      0.000000000000000_REALK,      1.325320597600197_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.879081200101013_REALK,      0.000000000000000_REALK, &
     -6.499588009365266_REALK,      0.000000000000000_REALK,      0.919177941698444_REALK, &
      0.000000000000000_REALK,      1.514566215093275_REALK,      0.000000000000000_REALK, &
      1.822343821118346_REALK,     -0.107533595848016_REALK,      0.000000000000000_REALK, &
      0.209354386140668_REALK,      0.000000000000000_REALK,      1.430065220687735_REALK, &
     -0.058161262398885_REALK,      0.000000000000000_REALK,     -0.106864206848469_REALK, &
      0.000000000000000_REALK,      0.157124335857456_REALK,      0.000000000000000_REALK, &
      0.345318892856746_REALK,      0.000000000000000_REALK,      3.302342821442604_REALK, &
      8.625435752681385_REALK,     -0.484305285271183_REALK,      0.000000000000000_REALK, &
      0.841229047036104_REALK,      0.000000000000000_REALK,      5.446636047271576_REALK, &
      0.066110667197119_REALK,      0.000000000000000_REALK,     -0.379832499076767_REALK, &
      0.000000000000000_REALK,      1.015466401281074_REALK,      0.000000000000000_REALK, &
      0.961350103592327_REALK,      0.000000000000000_REALK,      8.714123466625036_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.995504404131617_REALK, &
      0.000000000000000_REALK,     -0.021455202132925_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.141658601482891_REALK,      0.000000000000000_REALK, &
     -1.385030443851787_REALK,      0.000000000000000_REALK,      0.002493413099486_REALK, &
      0.000000000000000_REALK,     -0.049544896079768_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -5.366559796008285_REALK, &
      0.000000000000000_REALK,      0.082444633605919_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.287198991637569_REALK,      0.000000000000000_REALK, &
     -5.892463768323091_REALK,      0.000000000000000_REALK,      0.543052275557824_REALK, &
      0.000000000000000_REALK,      0.131903933027163_REALK,      0.000000000000000_REALK, &
      0.847185903325234_REALK,      0.089403374640192_REALK,      0.000000000000000_REALK, &
      0.108901653769210_REALK,      0.000000000000000_REALK,      0.930748366179537_REALK, &
      0.034949714491550_REALK,      0.000000000000000_REALK,      0.124385582972651_REALK, &
      0.000000000000000_REALK,      0.087074599928384_REALK,      0.000000000000000_REALK, &
      0.251478456622438_REALK,      0.000000000000000_REALK,      2.763395610056609_REALK, &
      6.928953038475544_REALK,      0.901710750867465_REALK,      0.000000000000000_REALK, &
      0.983757439439379_REALK,      0.000000000000000_REALK,      6.125520038622172_REALK, &
      0.818135559550640_REALK,      0.000000000000000_REALK,      0.990075230866904_REALK, &
      0.000000000000000_REALK,      1.734645343648035_REALK,      0.000000000000000_REALK, &
      1.573922640338706_REALK,      0.000000000000000_REALK,     12.600355182671699_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.746464592273205_REALK, &
      0.000000000000000_REALK,     -0.157653248218345_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.131284314701710_REALK,      0.000000000000000_REALK, &
     -1.335272225730045_REALK,      0.000000000000000_REALK,     -0.066240394905634_REALK, &
      0.000000000000000_REALK,     -0.468073122519672_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -6.197784974111695_REALK, &
      0.000000000000000_REALK,     -0.069529714965751_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.911952725049098_REALK,      0.000000000000000_REALK, &
     -8.749473542190227_REALK,      0.000000000000000_REALK,      2.902157958934735_REALK, &
      0.000000000000000_REALK,     -0.143024445074782_REALK,      0.000000000000000_REALK/
    ! results of test 2, ket-major order, CM000003
  data REF_CONTR_INTS(12601:13860)                                                         &
     /0.000000000000000_REALK,      0.000000000000000_REALK,     -0.334461441382445_REALK, &
      0.000000000000000_REALK,     -0.337910902990347_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.449954577187133_REALK,      0.000000000000000_REALK, &
     -0.353603145163826_REALK,      0.000000000000000_REALK,     -0.846651016739323_REALK, &
      0.000000000000000_REALK,     -0.506223487771555_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.465846026281682_REALK, &
      0.000000000000000_REALK,     -0.613665612912665_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.950318735954605_REALK,      0.000000000000000_REALK, &
     -0.572849026385647_REALK,      0.000000000000000_REALK,     -1.907355850512320_REALK, &
      0.000000000000000_REALK,     -0.926380270376712_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.229488650841768_REALK, &
      0.000000000000000_REALK,     -0.166989059162020_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.164860962040417_REALK,      0.000000000000000_REALK, &
     -0.209125948852516_REALK,      0.000000000000000_REALK,     -0.215675616756814_REALK, &
      0.000000000000000_REALK,     -0.205955230574165_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.271355952770943_REALK, &
      0.000000000000000_REALK,     -0.166547584404235_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.109443027995606_REALK,      0.000000000000000_REALK, &
     -0.222939141593077_REALK,      0.000000000000000_REALK,     -0.020786508692337_REALK, &
      0.000000000000000_REALK,     -0.186842415260112_REALK,      0.000000000000000_REALK, &
      0.320670056935807_REALK,      0.277768070040427_REALK,      0.000000000000000_REALK, &
      0.309720269846603_REALK,      0.000000000000000_REALK,      0.243398038582903_REALK, &
      0.423341822945841_REALK,      0.000000000000000_REALK,      0.253121498579851_REALK, &
      0.000000000000000_REALK,      0.767657355411798_REALK,      0.000000000000000_REALK, &
      0.381992149125526_REALK,      0.000000000000000_REALK,      0.420271478699723_REALK, &
      0.907983275220810_REALK,      0.792375753491019_REALK,      0.000000000000000_REALK, &
      0.922125353437292_REALK,      0.000000000000000_REALK,      0.555854147599702_REALK, &
      1.340357281191755_REALK,      0.000000000000000_REALK,      0.650995743777069_REALK, &
      0.000000000000000_REALK,      2.493860272577155_REALK,      0.000000000000000_REALK, &
      1.034491907073419_REALK,      0.000000000000000_REALK,      0.873023674152633_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.214504439988369_REALK, &
      0.000000000000000_REALK,     -0.120783481226248_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.099979855173245_REALK,      0.000000000000000_REALK, &
     -0.167249360440124_REALK,      0.000000000000000_REALK,     -0.109262465839866_REALK, &
      0.000000000000000_REALK,     -0.122338484934031_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.208232652200192_REALK, &
      0.000000000000000_REALK,     -0.150825809177844_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.151530750799740_REALK,      0.000000000000000_REALK, &
     -0.190020599279523_REALK,      0.000000000000000_REALK,     -0.211125561754085_REALK, &
      0.000000000000000_REALK,     -0.153345266843292_REALK,      0.000000000000000_REALK, &
      0.251468993348485_REALK,      0.157892549167932_REALK,      0.000000000000000_REALK, &
      0.130766596490102_REALK,      0.000000000000000_REALK,      0.165877283686494_REALK, &
      0.128919329688956_REALK,      0.000000000000000_REALK,      0.123109003562021_REALK, &
      0.000000000000000_REALK,      0.157551300580113_REALK,      0.000000000000000_REALK, &
      0.132450125896043_REALK,      0.000000000000000_REALK,      0.235217974438341_REALK, &
      0.214718035529032_REALK,      0.168125831621935_REALK,      0.000000000000000_REALK, &
      0.108305891886250_REALK,      0.000000000000000_REALK,      0.220622756961391_REALK, &
      0.017068382898535_REALK,      0.000000000000000_REALK,      0.153421526074857_REALK, &
      0.000000000000000_REALK,     -0.181815189367733_REALK,      0.000000000000000_REALK, &
      0.110115078994302_REALK,      0.000000000000000_REALK,      0.314031385021629_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.230139249644146_REALK, &
      0.000000000000000_REALK,     -0.200774255215413_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.228334442957612_REALK,      0.000000000000000_REALK, &
     -0.251215775506263_REALK,      0.000000000000000_REALK,     -0.340114949301887_REALK, &
      0.000000000000000_REALK,     -0.284702718669978_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.561121562705327_REALK, &
      0.000000000000000_REALK,     -0.644231760900834_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.849450200450151_REALK,      0.000000000000000_REALK, &
     -0.716864124248824_REALK,      0.000000000000000_REALK,     -1.348587942074701_REALK, &
      0.000000000000000_REALK,     -0.916990590349733_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.247373927318716_REALK, &
      0.000000000000000_REALK,     -0.104484854257497_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.070789437434579_REALK,      0.000000000000000_REALK, &
     -0.162229446256129_REALK,      0.000000000000000_REALK,     -0.059510709634625_REALK, &
      0.000000000000000_REALK,     -0.086123815320510_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.359503955890029_REALK, &
      0.000000000000000_REALK,     -0.128924298826679_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.056405968502465_REALK,      0.000000000000000_REALK, &
     -0.198749895767565_REALK,      0.000000000000000_REALK,      0.001769911557137_REALK, &
      0.000000000000000_REALK,     -0.090484503544881_REALK,      0.000000000000000_REALK, &
      0.279626208954554_REALK,      0.135222686206369_REALK,      0.000000000000000_REALK, &
      0.093736188923673_REALK,      0.000000000000000_REALK,      0.156804764523947_REALK, &
      0.079201466014759_REALK,      0.000000000000000_REALK,      0.088679925739554_REALK, &
      0.000000000000000_REALK,      0.086413576287438_REALK,      0.000000000000000_REALK, &
      0.077264004252861_REALK,      0.000000000000000_REALK,      0.180949426097079_REALK, &
      0.667714334351977_REALK,      0.318726288275769_REALK,      0.000000000000000_REALK, &
      0.234641577412065_REALK,      0.000000000000000_REALK,      0.294242145045914_REALK, &
      0.242600428544565_REALK,      0.000000000000000_REALK,      0.176206173910836_REALK, &
      0.000000000000000_REALK,      0.353081913206787_REALK,      0.000000000000000_REALK, &
      0.164681342744095_REALK,      0.000000000000000_REALK,      0.289116144297628_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.185707280937596_REALK, &
      0.000000000000000_REALK,     -0.115420939509251_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.096009586312837_REALK,      0.000000000000000_REALK, &
     -0.170503276356972_REALK,      0.000000000000000_REALK,     -0.099628306323343_REALK, &
      0.000000000000000_REALK,     -0.133193355617680_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.466221748245730_REALK, &
      0.000000000000000_REALK,     -0.237569395632088_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.126531174772442_REALK,      0.000000000000000_REALK, &
     -0.360847582593661_REALK,      0.000000000000000_REALK,     -0.018549662028111_REALK, &
      0.000000000000000_REALK,     -0.233430692457565_REALK,      0.000000000000000_REALK, &
      0.300007617152948_REALK,      0.224776052450882_REALK,      0.000000000000000_REALK, &
      0.214075129892606_REALK,      0.000000000000000_REALK,      0.235527540549626_REALK, &
      0.246540313649196_REALK,      0.000000000000000_REALK,      0.206373456096966_REALK, &
      0.000000000000000_REALK,      0.354608477798257_REALK,      0.000000000000000_REALK, &
      0.247038232628505_REALK,      0.000000000000000_REALK,      0.349449257395331_REALK, &
      1.799280308700708_REALK,      1.361395632886474_REALK,      0.000000000000000_REALK, &
      1.315352388308503_REALK,      0.000000000000000_REALK,      1.110046165653601_REALK, &
      1.549637144641131_REALK,      0.000000000000000_REALK,      1.053696711766708_REALK, &
      0.000000000000000_REALK,      2.225494713246019_REALK,      0.000000000000000_REALK, &
      1.292437597071928_REALK,      0.000000000000000_REALK,      1.402338882780909_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.349976841279529_REALK, &
      0.000000000000000_REALK,     -0.109889689225777_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.063773591795903_REALK,      0.000000000000000_REALK, &
     -0.191347977309439_REALK,      0.000000000000000_REALK,     -0.043416688554842_REALK, &
      0.000000000000000_REALK,     -0.073027326262180_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.385376777997648_REALK, &
      0.000000000000000_REALK,     -0.155401019265141_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.108894038148890_REALK,      0.000000000000000_REALK, &
     -0.257486508375097_REALK,      0.000000000000000_REALK,     -0.109000715101491_REALK, &
      0.000000000000000_REALK,     -0.106039049158693_REALK,      0.000000000000000_REALK, &
      0.387582075930800_REALK,      0.141658350952290_REALK,      0.000000000000000_REALK, &
      0.080694636917394_REALK,      0.000000000000000_REALK,      0.184929372761954_REALK, &
      0.053517845142957_REALK,      0.000000000000000_REALK,      0.077450950253195_REALK, &
      0.000000000000000_REALK,      0.044099320383379_REALK,      0.000000000000000_REALK, &
      0.053625718839437_REALK,      0.000000000000000_REALK,      0.172053054562388_REALK, &
      0.366447804305149_REALK,      0.176714817873654_REALK,      0.000000000000000_REALK, &
      0.081249937846109_REALK,      0.000000000000000_REALK,      0.286289148236672_REALK, &
     -0.002309506885026_REALK,      0.000000000000000_REALK,      0.118070636401205_REALK, &
      0.000000000000000_REALK,     -0.112159336580370_REALK,      0.000000000000000_REALK, &
      0.055441503499436_REALK,      0.000000000000000_REALK,      0.273492161697744_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.212592576424354_REALK, &
      0.000000000000000_REALK,     -0.101088448626648_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.069483342412095_REALK,      0.000000000000000_REALK, &
     -0.162727405269185_REALK,      0.000000000000000_REALK,     -0.059998153709074_REALK, &
      0.000000000000000_REALK,     -0.094049831605583_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.403313786041563_REALK, &
      0.000000000000000_REALK,     -0.253816059868389_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.214887966220159_REALK,      0.000000000000000_REALK, &
     -0.377259373856781_REALK,      0.000000000000000_REALK,     -0.238452292642230_REALK, &
      0.000000000000000_REALK,     -0.242470604682591_REALK,      0.000000000000000_REALK, &
      0.290963620303132_REALK,      0.156485263557433_REALK,      0.000000000000000_REALK, &
      0.109443710656177_REALK,      0.000000000000000_REALK,      0.194360917072794_REALK, &
      0.089595508143051_REALK,      0.000000000000000_REALK,      0.119780480249397_REALK, &
      0.000000000000000_REALK,      0.086514495866532_REALK,      0.000000000000000_REALK, &
      0.101823330927943_REALK,      0.000000000000000_REALK,      0.232493009732269_REALK, &
      0.475226859579306_REALK,      0.325633203853351_REALK,      0.000000000000000_REALK, &
      0.182261742131186_REALK,      0.000000000000000_REALK,      0.519782647759560_REALK, &
      0.024204922554501_REALK,      0.000000000000000_REALK,      0.304597023073326_REALK, &
      0.000000000000000_REALK,     -0.205348174715174_REALK,      0.000000000000000_REALK, &
      0.174114730360114_REALK,      0.000000000000000_REALK,      0.638419647418330_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.319323247710943_REALK, &
      0.000000000000000_REALK,     -0.235250225353504_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.222160917915014_REALK,      0.000000000000000_REALK, &
     -0.314258918393463_REALK,      0.000000000000000_REALK,     -0.261469264766788_REALK, &
      0.000000000000000_REALK,     -0.281404480676257_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.521525482628652_REALK, &
      0.000000000000000_REALK,     -1.517796690893676_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.686464793603429_REALK,      0.000000000000000_REALK, &
     -1.829871832782617_REALK,      0.000000000000000_REALK,     -2.132396653081351_REALK, &
      0.000000000000000_REALK,     -1.864223887483993_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.693607868191558_REALK, &
      0.000000000000000_REALK,     -0.149331777071747_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.073675981062182_REALK,      0.000000000000000_REALK, &
     -0.290342942537023_REALK,      0.000000000000000_REALK,     -0.037177147925899_REALK, &
      0.000000000000000_REALK,     -0.075081607139128_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.180110952211121_REALK, &
      0.000000000000000_REALK,     -0.394842913901699_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.116596157892819_REALK,      0.000000000000000_REALK, &
     -0.718670920093782_REALK,      0.000000000000000_REALK,      0.021674232322937_REALK, &
      0.000000000000000_REALK,     -0.149929058237979_REALK,      0.000000000000000_REALK, &
      0.818546192234397_REALK,      0.211158829451860_REALK,      0.000000000000000_REALK, &
      0.099250407186767_REALK,      0.000000000000000_REALK,      0.297793555726087_REALK, &
      0.052550615218615_REALK,      0.000000000000000_REALK,      0.088390686866883_REALK, &
      0.000000000000000_REALK,      0.037128636407464_REALK,      0.000000000000000_REALK, &
      0.049901502727146_REALK,      0.000000000000000_REALK,      0.209616110363350_REALK, &
      3.643405711020269_REALK,      0.939304004592062_REALK,      0.000000000000000_REALK, &
      0.452767805718007_REALK,      0.000000000000000_REALK,      1.070596732206613_REALK, &
      0.318288664308427_REALK,      0.000000000000000_REALK,      0.309640421072744_REALK, &
      0.000000000000000_REALK,      0.352516834187841_REALK,      0.000000000000000_REALK, &
      0.171924196488625_REALK,      0.000000000000000_REALK,      0.569135156857089_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.355351536243320_REALK, &
      0.000000000000000_REALK,     -0.120536387133922_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.064907403359269_REALK,      0.000000000000000_REALK, &
     -0.208249273918589_REALK,      0.000000000000000_REALK,     -0.041876595313922_REALK, &
      0.000000000000000_REALK,     -0.084845249812940_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.730442597362540_REALK, &
      0.000000000000000_REALK,     -0.490922954753582_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.161892535105442_REALK,      0.000000000000000_REALK, &
     -0.798613612438662_REALK,      0.000000000000000_REALK,      0.003646298018172_REALK, &
      0.000000000000000_REALK,     -0.260977363794628_REALK,      0.000000000000000_REALK, &
      0.497223882852483_REALK,      0.194246781781784_REALK,      0.000000000000000_REALK, &
      0.108136453238643_REALK,      0.000000000000000_REALK,      0.253251554108800_REALK, &
      0.072620459881692_REALK,      0.000000000000000_REALK,      0.113835869952116_REALK, &
      0.000000000000000_REALK,      0.060807649346401_REALK,      0.000000000000000_REALK, &
      0.076116968552610_REALK,      0.000000000000000_REALK,      0.229195428585191_REALK, &
      3.812984682242601_REALK,      1.534162662455814_REALK,      0.000000000000000_REALK, &
      0.893477316064602_REALK,      0.000000000000000_REALK,      1.568597342805265_REALK, &
      0.696295080777311_REALK,      0.000000000000000_REALK,      0.708028794367263_REALK, &
      0.000000000000000_REALK,      0.727404640749699_REALK,      0.000000000000000_REALK, &
      0.474977493512975_REALK,      0.000000000000000_REALK,      1.072125053650811_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.373474745714854_REALK, &
      0.000000000000000_REALK,     -0.186413546783213_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.123244744405438_REALK,      0.000000000000000_REALK, &
     -0.281404480676257_REALK,      0.000000000000000_REALK,     -0.098149257635491_REALK, &
      0.000000000000000_REALK,     -0.168706300340052_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.141767826664046_REALK, &
      0.000000000000000_REALK,     -1.266476366470874_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.508425517310982_REALK,      0.000000000000000_REALK, &
     -1.864223887483993_REALK,      0.000000000000000_REALK,     -0.053501336756260_REALK, &
      0.000000000000000_REALK,     -0.865627529319765_REALK,      0.000000000000000_REALK, &
      0.746851784678365_REALK,      0.452045706598285_REALK,      0.000000000000000_REALK, &
      0.345747525631252_REALK,      0.000000000000000_REALK,      0.489079017415918_REALK, &
      0.316476709339482_REALK,      0.000000000000000_REALK,      0.340605860949817_REALK, &
      0.000000000000000_REALK,      0.349344078320395_REALK,      0.000000000000000_REALK, &
      0.312905295283124_REALK,      0.000000000000000_REALK,      0.540982278551034_REALK, &
     14.384713738267688_REALK,      9.174151602445839_REALK,      0.000000000000000_REALK, &
      7.012109909786449_REALK,      0.000000000000000_REALK,      7.608378461834253_REALK, &
      6.226726878379328_REALK,      0.000000000000000_REALK,      5.443646223482668_REALK, &
      0.000000000000000_REALK,      6.418820026058301_REALK,      0.000000000000000_REALK, &
      4.792726921104118_REALK,      0.000000000000000_REALK,      6.355888253643176_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.401233794951732_REALK, &
      0.000000000000000_REALK,     -0.919427527835910_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.451092148838531_REALK,      0.000000000000000_REALK, &
     -1.016979906318321_REALK,      0.000000000000000_REALK,     -4.837789586425197_REALK, &
      0.000000000000000_REALK,     -5.734964356149797_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.372640649455491_REALK, &
      0.000000000000000_REALK,     -1.566128268309100_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.955486772886178_REALK,      0.000000000000000_REALK, &
     -1.580097690232702_REALK,      0.000000000000000_REALK,    -11.704732729216188_REALK, &
      0.000000000000000_REALK,    -11.649965360952828_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.538912181770250_REALK, &
      0.000000000000000_REALK,     -0.379030392856202_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.297179622333891_REALK,      0.000000000000000_REALK, &
     -1.163691100692325_REALK,      0.000000000000000_REALK,     -1.089987317936269_REALK, &
      0.000000000000000_REALK,     -2.030099482829131_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.597005779704164_REALK, &
      0.000000000000000_REALK,     -0.357299211890615_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.211086535593284_REALK,      0.000000000000000_REALK, &
     -1.400668903413870_REALK,      0.000000000000000_REALK,      0.061636835065003_REALK, &
      0.000000000000000_REALK,     -2.108341571161788_REALK,      0.000000000000000_REALK, &
      0.622228256527672_REALK,      0.253536365603071_REALK,      0.000000000000000_REALK, &
      0.529174784007438_REALK,      0.000000000000000_REALK,      1.193015936215147_REALK, &
      0.461823709395914_REALK,      0.000000000000000_REALK,      0.547469555030306_REALK, &
      0.000000000000000_REALK,      3.013409434139881_REALK,      0.000000000000000_REALK, &
      2.834277872136973_REALK,      0.000000000000000_REALK,      8.945766653732640_REALK, &
      1.273532643526513_REALK,      0.677597057658195_REALK,      0.000000000000000_REALK, &
      1.379977585717445_REALK,      0.000000000000000_REALK,      2.282082240844149_REALK, &
      1.597222170862796_REALK,      0.000000000000000_REALK,      1.589748642260840_REALK, &
      0.000000000000000_REALK,     10.361105020090474_REALK,      0.000000000000000_REALK, &
      8.142934589316377_REALK,      0.000000000000000_REALK,     18.852469235551116_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.684397159662685_REALK, &
      0.000000000000000_REALK,     -0.191744736232476_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.240232086824135_REALK,      0.000000000000000_REALK, &
     -1.287454651085959_REALK,      0.000000000000000_REALK,     -0.375876241399488_REALK, &
      0.000000000000000_REALK,     -0.823036964969121_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.623960491567285_REALK, &
      0.000000000000000_REALK,     -0.232713264693778_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.325469404195654_REALK,      0.000000000000000_REALK, &
     -1.583811403270873_REALK,      0.000000000000000_REALK,     -0.798499650045956_REALK, &
      0.000000000000000_REALK,     -1.101537338021264_REALK,      0.000000000000000_REALK, &
      0.560947747562515_REALK,      0.167204912005736_REALK,      0.000000000000000_REALK, &
      0.231195589924382_REALK,      0.000000000000000_REALK,      0.905311906655699_REALK, &
      0.168879485819812_REALK,      0.000000000000000_REALK,      0.314537748450478_REALK, &
      0.000000000000000_REALK,      0.598842038121476_REALK,      0.000000000000000_REALK, &
      0.992374134405991_REALK,      0.000000000000000_REALK,      5.440291348291835_REALK, &
      0.454243578441634_REALK,      0.190003275419086_REALK,      0.000000000000000_REALK, &
      0.191053361939282_REALK,      0.000000000000000_REALK,      1.267738381365247_REALK, &
     -0.014099600908961_REALK,      0.000000000000000_REALK,      0.482289116594033_REALK, &
      0.000000000000000_REALK,     -0.857141031603823_REALK,      0.000000000000000_REALK, &
      0.904342139703721_REALK,      0.000000000000000_REALK,      8.401092345361766_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.526285301643273_REALK, &
      0.000000000000000_REALK,     -0.425912603787692_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.439134824635592_REALK,      0.000000000000000_REALK, &
     -1.386031238975131_REALK,      0.000000000000000_REALK,     -1.542171365118088_REALK, &
      0.000000000000000_REALK,     -2.559436848758740_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.213557394212391_REALK, &
      0.000000000000000_REALK,     -1.438873502228277_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.862719392000750_REALK,      0.000000000000000_REALK, &
     -4.312555829471151_REALK,      0.000000000000000_REALK,     -6.842858600718072_REALK, &
      0.000000000000000_REALK,     -9.535176455331413_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.946938555561581_REALK, &
      0.000000000000000_REALK,     -0.070013697700128_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.231401267947132_REALK,      0.000000000000000_REALK, &
     -1.512901926409045_REALK,      0.000000000000000_REALK,     -0.066458450613736_REALK, &
      0.000000000000000_REALK,     -0.228670238539837_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.318305431421177_REALK, &
      0.000000000000000_REALK,     -0.054630968058490_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.208306931189868_REALK,      0.000000000000000_REALK, &
     -2.058350701916397_REALK,      0.000000000000000_REALK,      0.223131554367697_REALK, &
      0.000000000000000_REALK,     -0.166370742792325_REALK,      0.000000000000000_REALK, &
      0.690922842876072_REALK,      0.117947374121806_REALK,      0.000000000000000_REALK, &
      0.169775420644303_REALK,      0.000000000000000_REALK,      0.909862449426236_REALK, &
      0.086060286426932_REALK,      0.000000000000000_REALK,      0.188441803827433_REALK, &
      0.000000000000000_REALK,      0.291210824886597_REALK,      0.000000000000000_REALK, &
      0.554499865200853_REALK,      0.000000000000000_REALK,      4.160355162725566_REALK, &
      1.420545871042655_REALK,      0.264719649776340_REALK,      0.000000000000000_REALK, &
      0.330522531201913_REALK,      0.000000000000000_REALK,      1.608401119144371_REALK, &
      0.299616010889902_REALK,      0.000000000000000_REALK,      0.413322940148086_REALK, &
      0.000000000000000_REALK,      1.073383069896435_REALK,      0.000000000000000_REALK, &
      1.006558751929644_REALK,      0.000000000000000_REALK,      6.857415450866441_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.556881843274087_REALK, &
      0.000000000000000_REALK,     -0.222288284873389_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.227213089956620_REALK,      0.000000000000000_REALK, &
     -1.245604217858373_REALK,      0.000000000000000_REALK,     -0.389804931390485_REALK, &
      0.000000000000000_REALK,     -1.016415408911092_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.442097685169061_REALK, &
      0.000000000000000_REALK,     -0.489776972989963_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.339330623829419_REALK,      0.000000000000000_REALK, &
     -3.152289140627818_REALK,      0.000000000000000_REALK,      0.043604948762244_REALK, &
      0.000000000000000_REALK,     -2.088163295886450_REALK,      0.000000000000000_REALK, &
      0.531303398387097_REALK,      0.261990363903564_REALK,      0.000000000000000_REALK, &
      0.310342804567354_REALK,      0.000000000000000_REALK,      0.979527921244812_REALK, &
      0.353094169791962_REALK,      0.000000000000000_REALK,      0.586006360699235_REALK, &
      0.000000000000000_REALK,      1.077665619037064_REALK,      0.000000000000000_REALK, &
      1.419045582121471_REALK,      0.000000000000000_REALK,      5.758587296164656_REALK, &
      2.762857534924224_REALK,      1.636769997118730_REALK,      0.000000000000000_REALK, &
      1.891639338218311_REALK,      0.000000000000000_REALK,      4.379511100986618_REALK, &
      2.567602874857624_REALK,      0.000000000000000_REALK,      3.577824401692960_REALK, &
      0.000000000000000_REALK,      7.329958669110840_REALK,      0.000000000000000_REALK, &
      8.065001118791601_REALK,      0.000000000000000_REALK,     24.006906220020142_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.503774756504669_REALK, &
      0.000000000000000_REALK,      0.075335591464280_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.291835245041806_REALK,      0.000000000000000_REALK, &
     -1.975117741745136_REALK,      0.000000000000000_REALK,      0.109980130764170_REALK, &
      0.000000000000000_REALK,      0.180194151638173_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.828745768598852_REALK, &
      0.000000000000000_REALK,      0.124145531017137_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.443965138369407_REALK,      0.000000000000000_REALK, &
     -3.094105790801977_REALK,      0.000000000000000_REALK,     -0.004854624275693_REALK, &
      0.000000000000000_REALK,      0.294845629595972_REALK,      0.000000000000000_REALK, &
      1.068512565444825_REALK,      0.056753365505137_REALK,      0.000000000000000_REALK, &
      0.173489084255327_REALK,      0.000000000000000_REALK,      1.134271960172628_REALK, &
      0.021664186602503_REALK,      0.000000000000000_REALK,      0.074542133805658_REALK, &
      0.000000000000000_REALK,      0.178211928662072_REALK,      0.000000000000000_REALK, &
      0.414966123557878_REALK,      0.000000000000000_REALK,      3.798269018197849_REALK, &
      1.112797188283371_REALK,      0.053613950274529_REALK,      0.000000000000000_REALK, &
      0.207957654944500_REALK,      0.000000000000000_REALK,      2.054899386107031_REALK, &
     -0.121658838757892_REALK,      0.000000000000000_REALK,      0.090710932520319_REALK, &
      0.000000000000000_REALK,     -0.271819721599723_REALK,      0.000000000000000_REALK, &
      0.493899419488156_REALK,      0.000000000000000_REALK,      6.832540306563704_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.737537908265516_REALK, &
      0.000000000000000_REALK,     -0.141280971670875_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.180756373942474_REALK,      0.000000000000000_REALK, &
     -1.356196386548674_REALK,      0.000000000000000_REALK,     -0.154329765639070_REALK, &
      0.000000000000000_REALK,     -0.473099182912625_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.578458897725919_REALK, &
      0.000000000000000_REALK,     -0.412629905673262_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.548809733559951_REALK,      0.000000000000000_REALK, &
     -3.738893869121067_REALK,      0.000000000000000_REALK,     -0.710394863015855_REALK, &
      0.000000000000000_REALK,     -1.371994405792914_REALK,      0.000000000000000_REALK, &
      0.628377885251016_REALK,      0.180187716023267_REALK,      0.000000000000000_REALK, &
      0.170349070500354_REALK,      0.000000000000000_REALK,      0.933870142622527_REALK, &
      0.127068968569572_REALK,      0.000000000000000_REALK,      0.331332025964473_REALK, &
      0.000000000000000_REALK,      0.245876544508398_REALK,      0.000000000000000_REALK, &
      0.570437795766212_REALK,      0.000000000000000_REALK,      4.020679770009830_REALK, &
      1.217291692074803_REALK,      0.480659215984965_REALK,      0.000000000000000_REALK, &
      0.338761655117948_REALK,      0.000000000000000_REALK,      3.147003576153013_REALK, &
     -0.023774886727899_REALK,      0.000000000000000_REALK,      1.138536960558080_REALK, &
      0.000000000000000_REALK,     -0.762565876762027_REALK,      0.000000000000000_REALK, &
      1.126382478169205_REALK,      0.000000000000000_REALK,     13.453439988285536_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.794009000567219_REALK, &
      0.000000000000000_REALK,     -0.439348097732698_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.462581778609546_REALK,      0.000000000000000_REALK, &
     -1.877189561279475_REALK,      0.000000000000000_REALK,     -0.886472957840951_REALK, &
      0.000000000000000_REALK,     -1.891567069041823_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.297981506453590_REALK, &
      0.000000000000000_REALK,     -3.571825325875025_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -4.397310248089819_REALK,      0.000000000000000_REALK, &
    -13.089373850210077_REALK,      0.000000000000000_REALK,     -8.522964583916712_REALK, &
      0.000000000000000_REALK,    -15.269552927880639_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.030212035724624_REALK, &
      0.000000000000000_REALK,      0.391022727486866_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.484159860450395_REALK,      0.000000000000000_REALK, &
     -3.011349180939451_REALK,      0.000000000000000_REALK,      0.322922985170921_REALK, &
      0.000000000000000_REALK,      0.644971131614424_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,    -10.252449748521432_REALK, &
      0.000000000000000_REALK,      1.410621429900334_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.100229131222340_REALK,      0.000000000000000_REALK, &
     -8.040824100152721_REALK,      0.000000000000000_REALK,      0.917572917758735_REALK, &
      0.000000000000000_REALK,      1.612047352076327_REALK,      0.000000000000000_REALK, &
      2.299627410933764_REALK,     -0.085305071849978_REALK,      0.000000000000000_REALK, &
      0.266641505820210_REALK,      0.000000000000000_REALK,      1.804608517232704_REALK, &
     -0.051741199374828_REALK,      0.000000000000000_REALK,     -0.084774053834151_REALK, &
      0.000000000000000_REALK,      0.197705022313693_REALK,      0.000000000000000_REALK, &
      0.439810941040534_REALK,      0.000000000000000_REALK,      4.167247686459812_REALK, &
     10.861402956742134_REALK,     -0.426692253349428_REALK,      0.000000000000000_REALK, &
      0.984117485344059_REALK,      0.000000000000000_REALK,      6.858564664369952_REALK, &
      0.005509961941869_REALK,      0.000000000000000_REALK,     -0.334647566019561_REALK, &
      0.000000000000000_REALK,      0.925598033375242_REALK,      0.000000000000000_REALK, &
      1.124641915083476_REALK,      0.000000000000000_REALK,     10.973081140439096_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.284375010260852_REALK, &
      0.000000000000000_REALK,     -0.068107012921435_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.195224762724166_REALK,      0.000000000000000_REALK, &
     -1.786931813812992_REALK,      0.000000000000000_REALK,     -0.032649059558106_REALK, &
      0.000000000000000_REALK,     -0.157274438925825_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -7.062756446249599_REALK, &
      0.000000000000000_REALK,     -0.201074830183700_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.560572116387387_REALK,      0.000000000000000_REALK, &
     -7.754881720496510_REALK,      0.000000000000000_REALK,      0.308183272925502_REALK, &
      0.000000000000000_REALK,     -0.321701483455859_REALK,      0.000000000000000_REALK, &
      1.127869970628056_REALK,      0.159977285704767_REALK,      0.000000000000000_REALK, &
      0.165151922372220_REALK,      0.000000000000000_REALK,      1.239117799652554_REALK, &
      0.072605907248140_REALK,      0.000000000000000_REALK,      0.222574013842920_REALK, &
      0.000000000000000_REALK,      0.143063214352497_REALK,      0.000000000000000_REALK, &
      0.381373001317426_REALK,      0.000000000000000_REALK,      3.678945687498919_REALK, &
      9.374883285166437_REALK,      1.418222491043851_REALK,      0.000000000000000_REALK, &
      1.216521767693322_REALK,      0.000000000000000_REALK,      8.287837297229759_REALK, &
      0.806292812095672_REALK,      0.000000000000000_REALK,      1.557203303709152_REALK, &
      0.000000000000000_REALK,      1.482527688748071_REALK,      0.000000000000000_REALK, &
      1.946324445310964_REALK,      0.000000000000000_REALK,     17.048298427373751_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.057453164786481_REALK, &
      0.000000000000000_REALK,     -0.302728583440880_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.268367890787167_REALK,      0.000000000000000_REALK, &
     -1.891567069041823_REALK,      0.000000000000000_REALK,     -0.268099391798543_REALK, &
      0.000000000000000_REALK,     -0.898802371206974_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,    -10.816354291658515_REALK, &
      0.000000000000000_REALK,     -2.523743496417046_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.278435618133222_REALK,      0.000000000000000_REALK, &
    -15.269552927880639_REALK,      0.000000000000000_REALK,      0.084316367573961_REALK, &
      0.000000000000000_REALK,     -5.191406483744910_REALK,      0.000000000000000_REALK, &
      1.214227632386002_REALK,      0.497488906847032_REALK,      0.000000000000000_REALK, &
      0.422647723703733_REALK,      0.000000000000000_REALK,      1.715134343207369_REALK, &
      0.417049640997384_REALK,      0.000000000000000_REALK,      0.889905732700201_REALK, &
      0.000000000000000_REALK,      0.741195079280849_REALK,      0.000000000000000_REALK, &
      1.254842776761882_REALK,      0.000000000000000_REALK,      6.223849748329593_REALK, &
     25.526844596876316_REALK,     12.276480549733076_REALK,      0.000000000000000_REALK, &
      9.747319169071972_REALK,      0.000000000000000_REALK,     29.014624268716368_REALK, &
      9.673500526994456_REALK,      0.000000000000000_REALK,     17.330827418145066_REALK, &
      0.000000000000000_REALK,     14.173517157800873_REALK,      0.000000000000000_REALK, &
     20.050490870126566_REALK,      0.000000000000000_REALK,     72.946918224397464_REALK/
    ! results of test 3, ket-major order, 1DOVL001
  data REF_CONTR_INTS(13861:15120)                                                         &
    /21.578818408654001_REALK,      9.032095652812361_REALK,      0.000000000000000_REALK, &
     -4.187608634636775_REALK,      0.000000000000000_REALK,     -0.658178251315764_REALK, &
    -28.782908284490571_REALK,      0.000000000000000_REALK,     -3.441933909463378_REALK, &
      0.000000000000000_REALK,   -136.359522158011004_REALK,      0.000000000000000_REALK, &
    -13.570707440151212_REALK,      0.000000000000000_REALK,     -6.398839006729168_REALK, &
     64.808457510703192_REALK,     45.480441173591899_REALK,      0.000000000000000_REALK, &
     32.960848851312441_REALK,      0.000000000000000_REALK,      3.973738380387094_REALK, &
     10.655557405207052_REALK,      0.000000000000000_REALK,      1.035055744568994_REALK, &
      0.000000000000000_REALK,   -105.269570561925377_REALK,      0.000000000000000_REALK, &
     -8.733490003821924_REALK,      0.000000000000000_REALK,     -3.158711528893073_REALK, &
      8.508323327151508_REALK,      0.220472395407811_REALK,      0.000000000000000_REALK, &
     -5.300880331640139_REALK,      0.000000000000000_REALK,     -1.344832172987215_REALK, &
    -11.992504208685881_REALK,      0.000000000000000_REALK,     -2.290401675073462_REALK, &
      0.000000000000000_REALK,    -29.572719588095826_REALK,      0.000000000000000_REALK, &
     -4.972234971224447_REALK,      0.000000000000000_REALK,     -3.784364752233052_REALK, &
     10.098804464972780_REALK,      5.498957920893442_REALK,      0.000000000000000_REALK, &
      1.764399924760265_REALK,      0.000000000000000_REALK,      0.718828438607779_REALK, &
     -0.102552090883603_REALK,      0.000000000000000_REALK,     -0.184360737382806_REALK, &
      0.000000000000000_REALK,      8.303477408882667_REALK,      0.000000000000000_REALK, &
     -1.005788431633407_REALK,      0.000000000000000_REALK,     -1.229294987607263_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.064270735907159_REALK, &
      0.000000000000000_REALK,      1.627755602940450_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      4.248085643578535_REALK,      0.000000000000000_REALK, &
      2.003050779772291_REALK,      0.000000000000000_REALK,     12.768062194840100_REALK, &
      0.000000000000000_REALK,      4.580512760439631_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.670564876385116_REALK, &
      0.000000000000000_REALK,     -2.099022408966304_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.020751581160469_REALK,      0.000000000000000_REALK, &
      0.369183429091510_REALK,      0.000000000000000_REALK,     12.317969197018224_REALK, &
      0.000000000000000_REALK,      3.589615529423321_REALK,      0.000000000000000_REALK, &
      1.369876512200395_REALK,     -3.456468018839264_REALK,      0.000000000000000_REALK, &
     -6.006565788410715_REALK,      0.000000000000000_REALK,     -2.009593402215801_REALK, &
     -8.983417083846371_REALK,      0.000000000000000_REALK,     -2.011702055450537_REALK, &
      0.000000000000000_REALK,    -16.862466066519488_REALK,      0.000000000000000_REALK, &
     -3.015409628560151_REALK,      0.000000000000000_REALK,     -3.026561686658477_REALK, &
     26.952817417941258_REALK,      9.555765959400826_REALK,      0.000000000000000_REALK, &
      3.287746977763454_REALK,      0.000000000000000_REALK,      0.824571445329534_REALK, &
     -1.935969132495210_REALK,      0.000000000000000_REALK,     -0.281227626589949_REALK, &
      0.000000000000000_REALK,    -14.928644872839630_REALK,      0.000000000000000_REALK, &
     -1.392577297817659_REALK,      0.000000000000000_REALK,     -1.047780881218305_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.949384005649439_REALK, &
      0.000000000000000_REALK,      1.479222644921078_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.177975235294354_REALK,      0.000000000000000_REALK, &
      1.657655512940236_REALK,      0.000000000000000_REALK,      3.888229157543608_REALK, &
      0.000000000000000_REALK,      2.227793233307496_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.795568533439717_REALK, &
      0.000000000000000_REALK,     -0.665754186545394_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.201945602592212_REALK,      0.000000000000000_REALK, &
      0.246822004735901_REALK,      0.000000000000000_REALK,      0.156859531214041_REALK, &
      0.000000000000000_REALK,      0.845972186163362_REALK,      0.000000000000000_REALK, &
      0.293944827100113_REALK,     -1.149113744881096_REALK,      0.000000000000000_REALK, &
     -2.743564393063916_REALK,      0.000000000000000_REALK,     -1.293641244071724_REALK, &
     -5.592761288232476_REALK,      0.000000000000000_REALK,     -2.006390167585056_REALK, &
      0.000000000000000_REALK,    -13.839430516990362_REALK,      0.000000000000000_REALK, &
     -4.131963643875451_REALK,      0.000000000000000_REALK,     -3.247161856449543_REALK, &
     14.525874659010467_REALK,      8.163228779395611_REALK,      0.000000000000000_REALK, &
      3.686086572594665_REALK,      0.000000000000000_REALK,      1.333176559228605_REALK, &
     -2.473243511226650_REALK,      0.000000000000000_REALK,     -0.720735145050835_REALK, &
      0.000000000000000_REALK,    -18.819213897809604_REALK,      0.000000000000000_REALK, &
     -4.683901024169830_REALK,      0.000000000000000_REALK,     -2.823440220493131_REALK, &
     -9.464638014202675_REALK,     -7.201453989309058_REALK,      0.000000000000000_REALK, &
     -6.839419708690412_REALK,      0.000000000000000_REALK,     -3.134804604371979_REALK, &
     -6.920217000664946_REALK,      0.000000000000000_REALK,     -2.002985662924623_REALK, &
      0.000000000000000_REALK,     -8.778717002774494_REALK,      0.000000000000000_REALK, &
     -2.135021608810140_REALK,      0.000000000000000_REALK,     -2.935720801529766_REALK, &
      4.187306267328455_REALK,      0.490327132926316_REALK,      0.000000000000000_REALK, &
     -0.624127389316744_REALK,      0.000000000000000_REALK,     -0.439830240897166_REALK, &
      0.052115780614889_REALK,      0.000000000000000_REALK,     -0.532870754674208_REALK, &
      0.000000000000000_REALK,      5.243412599072212_REALK,      0.000000000000000_REALK, &
     -0.518374460519636_REALK,      0.000000000000000_REALK,     -1.095914557258352_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.161504277434768_REALK, &
      0.000000000000000_REALK,      1.713586811390694_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.796932616172347_REALK,      0.000000000000000_REALK, &
      1.803578312579406_REALK,      0.000000000000000_REALK,      2.388729837657292_REALK, &
      0.000000000000000_REALK,      1.604761087951301_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.223813367502444_REALK, &
      0.000000000000000_REALK,      0.389941356293375_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.969822101585396_REALK,      0.000000000000000_REALK, &
      0.729698134399135_REALK,      0.000000000000000_REALK,      2.229513464751976_REALK, &
      0.000000000000000_REALK,      0.971607609261430_REALK,      0.000000000000000_REALK, &
     -1.421048862931805_REALK,     -1.591041287630547_REALK,      0.000000000000000_REALK, &
     -1.855219876434487_REALK,      0.000000000000000_REALK,     -1.412006622505192_REALK, &
     -2.317060251505085_REALK,      0.000000000000000_REALK,     -1.327578941548252_REALK, &
      0.000000000000000_REALK,     -3.444435284931249_REALK,      0.000000000000000_REALK, &
     -1.737399382106410_REALK,      0.000000000000000_REALK,     -2.203889203495630_REALK, &
      1.086059397349913_REALK,      0.180705610488399_REALK,      0.000000000000000_REALK, &
     -0.280011402603447_REALK,      0.000000000000000_REALK,     -0.342235606283805_REALK, &
     -0.109240499937850_REALK,      0.000000000000000_REALK,     -0.589154027394729_REALK, &
      0.000000000000000_REALK,      1.919992110021930_REALK,      0.000000000000000_REALK, &
     -0.697697756492359_REALK,      0.000000000000000_REALK,     -1.421233876406156_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.391431261390454_REALK, &
      0.000000000000000_REALK,      1.709062095136012_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.462305674888850_REALK,      0.000000000000000_REALK, &
      1.935037612992931_REALK,      0.000000000000000_REALK,      4.461418958756212_REALK, &
      0.000000000000000_REALK,      2.667539542336693_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.361864016618995_REALK, &
      0.000000000000000_REALK,      0.999348618047431_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.261973853801230_REALK,      0.000000000000000_REALK, &
      1.966307172054675_REALK,      0.000000000000000_REALK,      8.544758721617551_REALK, &
      0.000000000000000_REALK,      4.150088664739545_REALK,      0.000000000000000_REALK, &
    -29.453493680452237_REALK,    -12.753584720675677_REALK,      0.000000000000000_REALK, &
     -9.086786158663662_REALK,      0.000000000000000_REALK,     -5.452846868867733_REALK, &
     -6.957783297081264_REALK,      0.000000000000000_REALK,     -2.340612920101810_REALK, &
      0.000000000000000_REALK,     -7.155501404700518_REALK,      0.000000000000000_REALK, &
     -1.923422497622227_REALK,      0.000000000000000_REALK,     -3.462652744502863_REALK, &
     45.648056370814068_REALK,      7.655174867030909_REALK,      0.000000000000000_REALK, &
      0.356949419183347_REALK,      0.000000000000000_REALK,      0.168805677839537_REALK, &
     -3.413349996667938_REALK,      0.000000000000000_REALK,     -0.664121125729280_REALK, &
      0.000000000000000_REALK,    -10.259719829601947_REALK,      0.000000000000000_REALK, &
     -1.000743179806741_REALK,      0.000000000000000_REALK,     -1.419790494662208_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.292509041526632_REALK, &
      0.000000000000000_REALK,      2.207121170118241_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.718768258264154_REALK,      0.000000000000000_REALK, &
      2.363359559441288_REALK,      0.000000000000000_REALK,      1.614107414580956_REALK, &
      0.000000000000000_REALK,      1.401560388719890_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.820565145130512_REALK, &
      0.000000000000000_REALK,     -0.077405973370909_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.347229383970300_REALK,      0.000000000000000_REALK, &
      0.734090441530322_REALK,      0.000000000000000_REALK,     -0.021224516081830_REALK, &
      0.000000000000000_REALK,      0.651046023028685_REALK,      0.000000000000000_REALK, &
     -3.578290542501679_REALK,     -2.346425953016919_REALK,      0.000000000000000_REALK, &
     -1.980068101255898_REALK,      0.000000000000000_REALK,     -1.987391097871250_REALK, &
     -1.923012397435151_REALK,      0.000000000000000_REALK,     -1.291889697362508_REALK, &
      0.000000000000000_REALK,     -2.343793160296257_REALK,      0.000000000000000_REALK, &
     -1.257377734970209_REALK,      0.000000000000000_REALK,     -2.103379942299570_REALK, &
      9.554540642541825_REALK,      2.500635235909484_REALK,      0.000000000000000_REALK, &
      0.140878483405858_REALK,      0.000000000000000_REALK,      0.105997549808554_REALK, &
     -1.493423472567074_REALK,      0.000000000000000_REALK,     -0.650824331288449_REALK, &
      0.000000000000000_REALK,     -4.234105774856399_REALK,      0.000000000000000_REALK, &
     -1.184900497435862_REALK,      0.000000000000000_REALK,     -1.485873338718749_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.933470170787017_REALK, &
      0.000000000000000_REALK,      1.462879960216960_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.398668237159656_REALK,      0.000000000000000_REALK, &
      1.774209119040448_REALK,      0.000000000000000_REALK,      1.621329561613085_REALK, &
      0.000000000000000_REALK,      1.548257094241892_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.194705440302818_REALK, &
      0.000000000000000_REALK,     -0.085581804885805_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.467347797075982_REALK,      0.000000000000000_REALK, &
      0.952003235050462_REALK,      0.000000000000000_REALK,      0.133466872434545_REALK, &
      0.000000000000000_REALK,      1.199685486965720_REALK,      0.000000000000000_REALK, &
     -2.303463090567446_REALK,     -2.340230228598728_REALK,      0.000000000000000_REALK, &
     -2.713253061639104_REALK,      0.000000000000000_REALK,     -2.132248153177364_REALK, &
     -3.591600788247569_REALK,      0.000000000000000_REALK,     -2.147464116575372_REALK, &
      0.000000000000000_REALK,     -5.770821858468377_REALK,      0.000000000000000_REALK, &
     -2.871604926854870_REALK,      0.000000000000000_REALK,     -3.159367677093602_REALK, &
     15.447890769177887_REALK,      6.408672296268860_REALK,      0.000000000000000_REALK, &
      0.473841469153831_REALK,      0.000000000000000_REALK,      0.285630088091711_REALK, &
     -5.723644841815511_REALK,      0.000000000000000_REALK,     -2.779906882439962_REALK, &
      0.000000000000000_REALK,    -16.012680907416499_REALK,      0.000000000000000_REALK, &
     -6.642308308698128_REALK,      0.000000000000000_REALK,     -5.605546418356514_REALK, &
   -138.084338924072114_REALK,    -32.033262444902739_REALK,      0.000000000000000_REALK, &
    -16.718653264862141_REALK,      0.000000000000000_REALK,    -13.177002638293777_REALK, &
     -8.672179326534662_REALK,      0.000000000000000_REALK,     -3.502803187230817_REALK, &
      0.000000000000000_REALK,     -6.507102555710486_REALK,      0.000000000000000_REALK, &
     -2.222080261104156_REALK,      0.000000000000000_REALK,     -5.254075851541640_REALK, &
    -61.946088390955737_REALK,    -19.070599296124005_REALK,      0.000000000000000_REALK, &
     -7.851647939885066_REALK,      0.000000000000000_REALK,     -9.679137205184293_REALK, &
      1.842006629130886_REALK,      0.000000000000000_REALK,     -2.548374632687145_REALK, &
      0.000000000000000_REALK,     13.287474007284651_REALK,      0.000000000000000_REALK, &
     -1.071526153189115_REALK,      0.000000000000000_REALK,     -3.962779050360447_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     12.775980185906937_REALK, &
      0.000000000000000_REALK,      4.011546841359845_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.328068743605272_REALK,      0.000000000000000_REALK, &
      4.191119545706496_REALK,      0.000000000000000_REALK,      1.584935593699231_REALK, &
      0.000000000000000_REALK,      1.599526991462002_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     10.341794454862704_REALK, &
      0.000000000000000_REALK,      4.170270475731821_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.922230461698117_REALK,      0.000000000000000_REALK, &
      4.145873902965362_REALK,      0.000000000000000_REALK,      2.925093195468961_REALK, &
      0.000000000000000_REALK,      1.707369171987277_REALK,      0.000000000000000_REALK, &
    -14.148767399582258_REALK,     -5.171268699717150_REALK,      0.000000000000000_REALK, &
     -2.945775150711046_REALK,      0.000000000000000_REALK,     -4.050532018451777_REALK, &
     -1.953680496798206_REALK,      0.000000000000000_REALK,     -1.696418201038892_REALK, &
      0.000000000000000_REALK,     -1.609855216048441_REALK,      0.000000000000000_REALK, &
     -1.174571069633361_REALK,      0.000000000000000_REALK,     -2.691785965825606_REALK, &
     -9.833825198940085_REALK,     -4.742237799260907_REALK,      0.000000000000000_REALK, &
     -2.180386065400012_REALK,      0.000000000000000_REALK,     -4.609634562474008_REALK, &
      0.061976867472734_REALK,      0.000000000000000_REALK,     -1.901093666038511_REALK, &
      0.000000000000000_REALK,      3.009856512721772_REALK,      0.000000000000000_REALK, &
     -0.892681655244755_REALK,      0.000000000000000_REALK,     -3.145418661249644_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.656442753420520_REALK, &
      0.000000000000000_REALK,      2.214153391332418_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.521902653893294_REALK,      0.000000000000000_REALK, &
      2.545885319344774_REALK,      0.000000000000000_REALK,      1.314147336450567_REALK, &
      0.000000000000000_REALK,      1.471418321796615_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.493886265372918_REALK, &
      0.000000000000000_REALK,      4.086774819397171_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.459980939722214_REALK,      0.000000000000000_REALK, &
      4.338839794509047_REALK,      0.000000000000000_REALK,      3.839397813137192_REALK, &
      0.000000000000000_REALK,      2.788641400319136_REALK,      0.000000000000000_REALK, &
     -6.373013884384700_REALK,     -3.427517008188618_REALK,      0.000000000000000_REALK, &
     -2.397159778407148_REALK,      0.000000000000000_REALK,     -3.040794539871617_REALK, &
     -1.962422026435094_REALK,      0.000000000000000_REALK,     -1.873976701751987_REALK, &
      0.000000000000000_REALK,     -1.894938215243311_REALK,      0.000000000000000_REALK, &
     -1.593035438298881_REALK,      0.000000000000000_REALK,     -2.829069179588857_REALK, &
     -7.651782019770401_REALK,     -5.243125980907410_REALK,      0.000000000000000_REALK, &
     -2.934655508668070_REALK,      0.000000000000000_REALK,     -5.977992312129044_REALK, &
     -0.389731319808868_REALK,      0.000000000000000_REALK,     -3.503154001154802_REALK, &
      0.000000000000000_REALK,      3.306377658176163_REALK,      0.000000000000000_REALK, &
     -2.002484161423298_REALK,      0.000000000000000_REALK,     -5.710778945435564_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.995841770646915_REALK, &
      0.000000000000000_REALK,      3.680511553105002_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.475728126533934_REALK,      0.000000000000000_REALK, &
      3.824029898626579_REALK,      0.000000000000000_REALK,      4.090710851859765_REALK, &
      0.000000000000000_REALK,      3.424243783484856_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     17.498982848057629_REALK, &
      0.000000000000000_REALK,     17.456098214603056_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     19.395941003981260_REALK,      0.000000000000000_REALK, &
     16.368533734446775_REALK,      0.000000000000000_REALK,     24.524579366925529_REALK, &
      0.000000000000000_REALK,     16.675819062388008_REALK,      0.000000000000000_REALK, &
     22.592722061535262_REALK,     38.809554618550386_REALK,      0.000000000000000_REALK, &
      8.763371249755906_REALK,      0.000000000000000_REALK,      3.951375565084180_REALK, &
     64.923703440059583_REALK,      0.000000000000000_REALK,     15.392778807195397_REALK, &
      0.000000000000000_REALK,    -48.113979618687054_REALK,      0.000000000000000_REALK, &
     -9.050770614091331_REALK,      0.000000000000000_REALK,    -12.242889008279279_REALK, &
     25.573011644088101_REALK,     38.774142367498897_REALK,      0.000000000000000_REALK, &
     14.781545942541815_REALK,      0.000000000000000_REALK,      4.888877013195698_REALK, &
     85.699483336386422_REALK,      0.000000000000000_REALK,     17.059697737964736_REALK, &
      0.000000000000000_REALK,    -30.425795593312781_REALK,      0.000000000000000_REALK, &
     -4.782410039544084_REALK,      0.000000000000000_REALK,     -4.745230559960544_REALK, &
     23.630258070772019_REALK,     13.716096563614354_REALK,      0.000000000000000_REALK, &
      3.728979751139395_REALK,      0.000000000000000_REALK,      2.920375574195569_REALK, &
     11.742531315092291_REALK,      0.000000000000000_REALK,      4.374088827933973_REALK, &
      0.000000000000000_REALK,    -17.990621398365384_REALK,      0.000000000000000_REALK, &
     -5.962649981498847_REALK,      0.000000000000000_REALK,    -14.009068318051016_REALK, &
      7.983155504234931_REALK,      6.464357313669902_REALK,      0.000000000000000_REALK, &
      2.259752572980420_REALK,      0.000000000000000_REALK,      2.998926624559054_REALK, &
     -0.397245417677865_REALK,      0.000000000000000_REALK,      2.717625027827931_REALK, &
      0.000000000000000_REALK,      5.006937656168573_REALK,      0.000000000000000_REALK, &
     -1.056532016643789_REALK,      0.000000000000000_REALK,     -4.206383520430999_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -8.634411430571372_REALK, &
      0.000000000000000_REALK,     -1.373918486765968_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -6.106786037154156_REALK,      0.000000000000000_REALK, &
     -8.260589825775199_REALK,      0.000000000000000_REALK,      9.266090018754426_REALK, &
      0.000000000000000_REALK,      6.590699536938661_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -8.257614085369646_REALK, &
      0.000000000000000_REALK,     -3.403759102534973_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,    -10.496137410835974_REALK,      0.000000000000000_REALK, &
    -10.414538191332534_REALK,      0.000000000000000_REALK,      7.994429187379834_REALK, &
      0.000000000000000_REALK,      4.774213573339858_REALK,      0.000000000000000_REALK, &
     22.963938133244866_REALK,      5.052467687275590_REALK,      0.000000000000000_REALK, &
      1.363940221900322_REALK,      0.000000000000000_REALK,      1.461928925234951_REALK, &
      2.304710481094863_REALK,      0.000000000000000_REALK,      1.009301312809935_REALK, &
      0.000000000000000_REALK,    -12.656900838845139_REALK,      0.000000000000000_REALK, &
     -4.820047339746552_REALK,      0.000000000000000_REALK,    -15.498992948150407_REALK, &
     26.941104735571443_REALK,      5.373618970688037_REALK,      0.000000000000000_REALK, &
      3.747086925768969_REALK,      0.000000000000000_REALK,      3.646842944728830_REALK, &
      4.311118477504801_REALK,      0.000000000000000_REALK,      1.189445223008329_REALK, &
      0.000000000000000_REALK,     -8.685961798304916_REALK,      0.000000000000000_REALK, &
     -1.629042065635323_REALK,      0.000000000000000_REALK,     -4.756383303685560_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.770987976158125_REALK, &
      0.000000000000000_REALK,     -0.357163518070453_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.216961763913202_REALK,      0.000000000000000_REALK, &
     -2.859215373032915_REALK,      0.000000000000000_REALK,      3.388419620062888_REALK, &
      0.000000000000000_REALK,      3.786555387445317_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -5.854709678829733_REALK, &
      0.000000000000000_REALK,     -1.110506376288316_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.976512916001543_REALK,      0.000000000000000_REALK, &
     -3.887802520557017_REALK,      0.000000000000000_REALK,     -0.070571435266337_REALK, &
      0.000000000000000_REALK,      1.448374406813633_REALK,      0.000000000000000_REALK, &
      3.531745547666734_REALK,      2.244556706507651_REALK,      0.000000000000000_REALK, &
      0.498645837095109_REALK,      0.000000000000000_REALK,      0.674513353425524_REALK, &
      1.891185511272843_REALK,      0.000000000000000_REALK,      1.345145087969533_REALK, &
      0.000000000000000_REALK,     -9.367719680679068_REALK,      0.000000000000000_REALK, &
     -5.286514398447639_REALK,      0.000000000000000_REALK,    -11.918360653198119_REALK, &
     10.479694564628556_REALK,      6.645051332306746_REALK,      0.000000000000000_REALK, &
      4.289049225620284_REALK,      0.000000000000000_REALK,      4.255705238635021_REALK, &
      7.388951053594198_REALK,      0.000000000000000_REALK,      4.412626541054531_REALK, &
      0.000000000000000_REALK,    -11.863004507643980_REALK,      0.000000000000000_REALK, &
     -5.593978801558374_REALK,      0.000000000000000_REALK,     -9.250816687763846_REALK, &
     18.030917141007329_REALK,      0.863262874057076_REALK,      0.000000000000000_REALK, &
     -0.875759042581793_REALK,      0.000000000000000_REALK,     -1.145142854528215_REALK, &
     -0.080576994101268_REALK,      0.000000000000000_REALK,     -0.055449864665222_REALK, &
      0.000000000000000_REALK,     -9.969655575544655_REALK,      0.000000000000000_REALK, &
     -4.642864659453556_REALK,      0.000000000000000_REALK,    -18.213034741750590_REALK, &
     11.987955223356387_REALK,      0.543859594964662_REALK,      0.000000000000000_REALK, &
      1.113153320074508_REALK,      0.000000000000000_REALK,      2.199888313488222_REALK, &
     -0.550757751676060_REALK,      0.000000000000000_REALK,      0.082130899419076_REALK, &
      0.000000000000000_REALK,      2.869051228409991_REALK,      0.000000000000000_REALK, &
     -1.042619518446977_REALK,      0.000000000000000_REALK,     -6.181484040022538_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.243705157389139_REALK, &
      0.000000000000000_REALK,      0.142635012475388_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.134459747270149_REALK,      0.000000000000000_REALK, &
      0.432358964105050_REALK,      0.000000000000000_REALK,      1.726724602586625_REALK, &
      0.000000000000000_REALK,      2.268552283526704_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.202375547370996_REALK, &
      0.000000000000000_REALK,     -0.441744113324230_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.496899720627670_REALK,      0.000000000000000_REALK, &
     -1.450819217413965_REALK,      0.000000000000000_REALK,      1.499640454634223_REALK, &
      0.000000000000000_REALK,      1.241260371967633_REALK,      0.000000000000000_REALK, &
      2.120748028355787_REALK,      0.548159088785479_REALK,      0.000000000000000_REALK, &
     -0.171981700781278_REALK,      0.000000000000000_REALK,     -0.404065877281951_REALK, &
     -0.094523147522204_REALK,      0.000000000000000_REALK,     -0.105629518660929_REALK, &
      0.000000000000000_REALK,     -2.750999308808342_REALK,      0.000000000000000_REALK, &
     -2.735299512099085_REALK,      0.000000000000000_REALK,    -10.710841056192979_REALK, &
      2.622730979553922_REALK,      0.975160849678354_REALK,      0.000000000000000_REALK, &
      0.362663890597457_REALK,      0.000000000000000_REALK,      1.443878073577452_REALK, &
     -0.021526102491688_REALK,      0.000000000000000_REALK,      0.441791438841256_REALK, &
      0.000000000000000_REALK,      1.609773236902514_REALK,      0.000000000000000_REALK, &
     -1.019052211821600_REALK,      0.000000000000000_REALK,     -6.761941210707204_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.035213862784380_REALK, &
      0.000000000000000_REALK,      0.190096638108576_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.147472283953263_REALK,      0.000000000000000_REALK, &
      0.332473863501052_REALK,      0.000000000000000_REALK,      4.250715971255789_REALK, &
      0.000000000000000_REALK,      5.039017127092977_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.737031344528276_REALK, &
      0.000000000000000_REALK,     -1.638790724535493_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.706307382926547_REALK,      0.000000000000000_REALK, &
     -2.821736973338946_REALK,      0.000000000000000_REALK,      7.710831870036225_REALK, &
      0.000000000000000_REALK,      7.674752279120920_REALK,      0.000000000000000_REALK, &
      1.359446316058182_REALK,      0.451568229273068_REALK,      0.000000000000000_REALK, &
     -5.070083304173500_REALK,      0.000000000000000_REALK,     -6.862784160812630_REALK, &
      1.367996282162825_REALK,      0.000000000000000_REALK,      0.448271751989611_REALK, &
      0.000000000000000_REALK,    -13.160721763372875_REALK,      0.000000000000000_REALK, &
     -5.855419711430151_REALK,      0.000000000000000_REALK,    -23.777409111267200_REALK, &
     69.318115933764943_REALK,     -2.297412483287417_REALK,      0.000000000000000_REALK, &
      2.921613659487305_REALK,      0.000000000000000_REALK,      4.072293502821906_REALK, &
      0.000722373425234_REALK,      0.000000000000000_REALK,     -0.008774670716862_REALK, &
      0.000000000000000_REALK,     -9.144272535269410_REALK,      0.000000000000000_REALK, &
     -2.222137862287664_REALK,      0.000000000000000_REALK,     -9.291985834181029_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.359785383279578_REALK, &
      0.000000000000000_REALK,      0.259005609833998_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.032317583742385_REALK,      0.000000000000000_REALK, &
      4.049576586071097_REALK,      0.000000000000000_REALK,      0.434673013008501_REALK, &
      0.000000000000000_REALK,      0.897373748441914_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -7.605511793880448_REALK, &
      0.000000000000000_REALK,     -0.119388788268182_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.014698555237859_REALK,      0.000000000000000_REALK, &
     -0.087144814581598_REALK,      0.000000000000000_REALK,     -0.608927793021711_REALK, &
      0.000000000000000_REALK,      0.272416251082898_REALK,      0.000000000000000_REALK, &
      0.133350182666363_REALK,     -0.169370139577773_REALK,      0.000000000000000_REALK, &
     -0.628059762635864_REALK,      0.000000000000000_REALK,     -2.019543200715146_REALK, &
     -0.383928522642000_REALK,      0.000000000000000_REALK,     -0.504401179809360_REALK, &
      0.000000000000000_REALK,     -1.904671046423478_REALK,      0.000000000000000_REALK, &
     -2.176031414158594_REALK,      0.000000000000000_REALK,    -11.661813382650031_REALK, &
     11.966211897576148_REALK,      1.527209378387692_REALK,      0.000000000000000_REALK, &
      0.722313477097475_REALK,      0.000000000000000_REALK,      2.108969335395040_REALK, &
      0.021141507203129_REALK,      0.000000000000000_REALK,      0.017498937837945_REALK, &
      0.000000000000000_REALK,     -2.929270966050010_REALK,      0.000000000000000_REALK, &
     -1.648144121335280_REALK,      0.000000000000000_REALK,     -8.020260644946735_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.479802909861757_REALK, &
      0.000000000000000_REALK,      0.493394132923912_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.608180076365652_REALK,      0.000000000000000_REALK, &
      2.381501587918186_REALK,      0.000000000000000_REALK,      1.529716830124717_REALK, &
      0.000000000000000_REALK,      2.849094934050218_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.991813288969264_REALK, &
      0.000000000000000_REALK,     -0.642205855817811_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.014366310011186_REALK,      0.000000000000000_REALK, &
     -0.095327935687204_REALK,      0.000000000000000_REALK,     -0.071398951949744_REALK, &
      0.000000000000000_REALK,      2.442263272834707_REALK,      0.000000000000000_REALK, &
      0.061525890443504_REALK,     -0.225727845996231_REALK,      0.000000000000000_REALK, &
     -0.688841155330787_REALK,      0.000000000000000_REALK,     -1.552981171186969_REALK, &
     -0.945125297091559_REALK,      0.000000000000000_REALK,     -1.120400090596083_REALK, &
      0.000000000000000_REALK,     -4.229097946009224_REALK,      0.000000000000000_REALK, &
     -3.977700007066967_REALK,      0.000000000000000_REALK,    -12.554723879258407_REALK, &
     13.964042716108288_REALK,      5.665670437329368_REALK,      0.000000000000000_REALK, &
      2.480357238281239_REALK,      0.000000000000000_REALK,      4.101790683424793_REALK, &
      0.108705127964989_REALK,      0.000000000000000_REALK,      0.108196488091435_REALK, &
      0.000000000000000_REALK,    -12.002109431730441_REALK,      0.000000000000000_REALK, &
     -9.432622470951920_REALK,      0.000000000000000_REALK,    -21.838346236687421_REALK, &
   -118.979834224311460_REALK,     15.378512926367295_REALK,      0.000000000000000_REALK, &
    -20.306664148908684_REALK,      0.000000000000000_REALK,    -25.260440382456654_REALK, &
     10.113074909004215_REALK,      0.000000000000000_REALK,      4.039750446819079_REALK, &
      0.000000000000000_REALK,    -24.142914915235593_REALK,      0.000000000000000_REALK, &
     -9.714245412538858_REALK,      0.000000000000000_REALK,    -36.252057251438565_REALK, &
    -45.883289804433495_REALK,     10.683552392224041_REALK,      0.000000000000000_REALK, &
    -11.593422678170354_REALK,      0.000000000000000_REALK,    -16.945683372393951_REALK, &
     10.288695181613646_REALK,      0.000000000000000_REALK,      3.615159842414137_REALK, &
      0.000000000000000_REALK,     -4.380343975043946_REALK,      0.000000000000000_REALK, &
     -5.506875649427108_REALK,      0.000000000000000_REALK,    -24.147598267606316_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     14.194671285559910_REALK, &
      0.000000000000000_REALK,     -0.711119768644262_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.754737938637816_REALK,      0.000000000000000_REALK, &
     11.186308444031612_REALK,      0.000000000000000_REALK,     -1.038142047130074_REALK, &
      0.000000000000000_REALK,     -1.020550480324381_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     10.388873070279383_REALK, &
      0.000000000000000_REALK,     -0.705255036607761_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.522109715492407_REALK,      0.000000000000000_REALK, &
     10.546333846487514_REALK,      0.000000000000000_REALK,      0.027578505591138_REALK, &
      0.000000000000000_REALK,     -1.004988404772980_REALK,      0.000000000000000_REALK, &
    -10.086074769757257_REALK,     -0.535715448214570_REALK,      0.000000000000000_REALK, &
     -1.637625922356361_REALK,      0.000000000000000_REALK,     -6.424080821985053_REALK, &
     -0.204496056448200_REALK,      0.000000000000000_REALK,     -0.422178021695868_REALK, &
      0.000000000000000_REALK,     -1.682206550935612_REALK,      0.000000000000000_REALK, &
     -2.350208776840375_REALK,      0.000000000000000_REALK,    -15.365669416978298_REALK, &
     -6.321659872327319_REALK,     -0.304574060409232_REALK,      0.000000000000000_REALK, &
     -1.181381096436745_REALK,      0.000000000000000_REALK,     -7.004173875131080_REALK, &
      0.691128452864008_REALK,      0.000000000000000_REALK,     -0.309190390557889_REALK, &
      0.000000000000000_REALK,      1.544173407909959_REALK,      0.000000000000000_REALK, &
     -1.683468024911447_REALK,      0.000000000000000_REALK,    -16.634912582778380_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.177131497859110_REALK, &
      0.000000000000000_REALK,      0.800161171650713_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.023734691562577_REALK,      0.000000000000000_REALK, &
      5.486411109999466_REALK,      0.000000000000000_REALK,      0.874064529949689_REALK, &
      0.000000000000000_REALK,      1.913894358522050_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.380215035912338_REALK, &
      0.000000000000000_REALK,      1.406458936605049_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.870631148272696_REALK,      0.000000000000000_REALK, &
      9.102935347394293_REALK,      0.000000000000000_REALK,      2.421397940066253_REALK, &
      0.000000000000000_REALK,      3.340339900007775_REALK,      0.000000000000000_REALK, &
     -3.558891044953816_REALK,     -1.020514031472830_REALK,      0.000000000000000_REALK, &
     -0.964791721270930_REALK,      0.000000000000000_REALK,     -3.777915629770872_REALK, &
     -0.719669843494123_REALK,      0.000000000000000_REALK,     -1.340383831117717_REALK, &
      0.000000000000000_REALK,     -1.392550331502475_REALK,      0.000000000000000_REALK, &
     -2.307671876504463_REALK,      0.000000000000000_REALK,    -12.650881264613320_REALK, &
     -4.149167947437581_REALK,     -1.638338473505936_REALK,      0.000000000000000_REALK, &
     -1.154677231749250_REALK,      0.000000000000000_REALK,     -7.661883726716690_REALK, &
      0.081037272009324_REALK,      0.000000000000000_REALK,     -2.771950396392333_REALK, &
      0.000000000000000_REALK,      2.599224092524410_REALK,      0.000000000000000_REALK, &
     -2.742358364299434_REALK,      0.000000000000000_REALK,    -25.475762823683862_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.212115771254651_REALK, &
      0.000000000000000_REALK,      1.777356368491767_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.871346830458201_REALK,      0.000000000000000_REALK, &
      5.906489352386338_REALK,      0.000000000000000_REALK,      3.586173162568094_REALK, &
      0.000000000000000_REALK,      5.951727509610205_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     10.464123654502290_REALK, &
      0.000000000000000_REALK,      8.696180247894883_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     10.705955368614354_REALK,      0.000000000000000_REALK, &
     24.786358285229682_REALK,      0.000000000000000_REALK,     20.750520953878652_REALK, &
      0.000000000000000_REALK,     28.914798679973003_REALK,      0.000000000000000_REALK/
    ! results of test 3, ket-major order, 1DOVL002
  data REF_CONTR_INTS(15121:16380)                                                         &
   /-58.548788719033148_REALK,    -41.883399814949165_REALK,      0.000000000000000_REALK, &
    -40.171303901448383_REALK,      0.000000000000000_REALK,    -10.191450954864177_REALK, &
    -46.370332746342470_REALK,      0.000000000000000_REALK,     -8.856089266077861_REALK, &
      0.000000000000000_REALK,    -71.585593920407220_REALK,      0.000000000000000_REALK, &
    -12.036106198031272_REALK,      0.000000000000000_REALK,     -9.160672476978005_REALK, &
    -20.842584358697390_REALK,    -18.728381504507681_REALK,      0.000000000000000_REALK, &
    -13.842741340714607_REALK,      0.000000000000000_REALK,     -5.639626257266616_REALK, &
     -2.562147394806922_REALK,      0.000000000000000_REALK,     -4.606043415791206_REALK, &
      0.000000000000000_REALK,     34.503486431951522_REALK,      0.000000000000000_REALK, &
     -4.179358333311439_REALK,      0.000000000000000_REALK,     -5.108096383859572_REALK, &
    -33.176698866965225_REALK,    -11.982970382632484_REALK,      0.000000000000000_REALK, &
     -4.105822040336164_REALK,      0.000000000000000_REALK,     -5.036418746444697_REALK, &
      3.398840413337183_REALK,      0.000000000000000_REALK,     -2.183942467000220_REALK, &
      0.000000000000000_REALK,     17.031325608052938_REALK,      0.000000000000000_REALK, &
     -1.012779554849125_REALK,      0.000000000000000_REALK,     -3.726987107049885_REALK, &
    -12.500974714007551_REALK,      3.654659718027620_REALK,      0.000000000000000_REALK, &
     11.148556440642349_REALK,      0.000000000000000_REALK,     -1.530582959720323_REALK, &
     20.131731408046583_REALK,      0.000000000000000_REALK,      0.600515074043454_REALK, &
      0.000000000000000_REALK,     36.754212096926111_REALK,      0.000000000000000_REALK, &
      2.501415099455899_REALK,      0.000000000000000_REALK,     -1.030256252493006_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.377532768527326_REALK, &
      0.000000000000000_REALK,      6.095971674346316_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      6.018285029253223_REALK,      0.000000000000000_REALK, &
      4.580512760439631_REALK,      0.000000000000000_REALK,      7.873284975640717_REALK, &
      0.000000000000000_REALK,      4.511064107063818_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      7.281983886630688_REALK, &
      0.000000000000000_REALK,      4.469394585246675_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.936962901421231_REALK,      0.000000000000000_REALK, &
      3.589615529423321_REALK,      0.000000000000000_REALK,      0.557817213188905_REALK, &
      0.000000000000000_REALK,      3.008410414519546_REALK,      0.000000000000000_REALK, &
    -27.612700938654850_REALK,     -5.036935743479729_REALK,      0.000000000000000_REALK, &
     -0.163286483020697_REALK,      0.000000000000000_REALK,     -3.642850568542406_REALK, &
      3.133121445405015_REALK,      0.000000000000000_REALK,     -0.785460927261611_REALK, &
      0.000000000000000_REALK,      6.347923555592708_REALK,      0.000000000000000_REALK, &
     -0.033077736690731_REALK,      0.000000000000000_REALK,     -2.213849848697874_REALK, &
     -6.745007267164154_REALK,     -0.128519724909376_REALK,      0.000000000000000_REALK, &
      1.325286855017152_REALK,      0.000000000000000_REALK,     -1.386098839196176_REALK, &
      1.448316199685685_REALK,      0.000000000000000_REALK,     -0.023455874848139_REALK, &
      0.000000000000000_REALK,      0.224624075723633_REALK,      0.000000000000000_REALK, &
      0.269485000656461_REALK,      0.000000000000000_REALK,     -0.845551689832161_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.762066440423277_REALK, &
      0.000000000000000_REALK,      1.732288346526820_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.605385362041409_REALK,      0.000000000000000_REALK, &
      2.227793233307496_REALK,      0.000000000000000_REALK,     -0.546129095785215_REALK, &
      0.000000000000000_REALK,      1.052754215881542_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.545087152658806_REALK, &
      0.000000000000000_REALK,     -0.594275595956878_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.053981807990159_REALK,      0.000000000000000_REALK, &
      0.845972186163362_REALK,      0.000000000000000_REALK,     -4.051070652720109_REALK, &
      0.000000000000000_REALK,     -0.362521575069464_REALK,      0.000000000000000_REALK, &
     -9.179929919489004_REALK,     -5.763901612165967_REALK,      0.000000000000000_REALK, &
     -4.773662850456000_REALK,      0.000000000000000_REALK,     -3.633231642281247_REALK, &
     -4.706227976870538_REALK,      0.000000000000000_REALK,     -2.696472459945803_REALK, &
      0.000000000000000_REALK,     -5.751444258757945_REALK,      0.000000000000000_REALK, &
     -2.901072273037338_REALK,      0.000000000000000_REALK,     -3.680006984551770_REALK, &
     -5.762074717451477_REALK,     -4.511747703691475_REALK,      0.000000000000000_REALK, &
     -2.906447238356998_REALK,      0.000000000000000_REALK,     -3.552318668106818_REALK, &
     -0.458039294766790_REALK,      0.000000000000000_REALK,     -2.470289822642938_REALK, &
      0.000000000000000_REALK,      4.879109029305625_REALK,      0.000000000000000_REALK, &
     -1.772998652264910_REALK,      0.000000000000000_REALK,     -3.611658091162211_REALK, &
    -28.098024036907596_REALK,      0.213448511339736_REALK,      0.000000000000000_REALK, &
      3.043525149786454_REALK,      0.000000000000000_REALK,     -3.151281175801052_REALK, &
      5.378898935859294_REALK,      0.000000000000000_REALK,      0.027996187127859_REALK, &
      0.000000000000000_REALK,      7.651687418293939_REALK,      0.000000000000000_REALK, &
      0.501737787330507_REALK,      0.000000000000000_REALK,     -1.558505450017691_REALK, &
    -13.443400589293722_REALK,      8.263101921921045_REALK,      0.000000000000000_REALK, &
      9.405029730660587_REALK,      0.000000000000000_REALK,     -1.184822557372308_REALK, &
     11.339590078214901_REALK,      0.000000000000000_REALK,      0.913642600473051_REALK, &
      0.000000000000000_REALK,     15.200616795168724_REALK,      0.000000000000000_REALK, &
      1.320169205880632_REALK,      0.000000000000000_REALK,     -0.498935027151412_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.078339474286109_REALK, &
      0.000000000000000_REALK,      0.736409487114967_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.023977174761877_REALK,      0.000000000000000_REALK, &
      1.604761087951301_REALK,      0.000000000000000_REALK,     -0.484252569206132_REALK, &
      0.000000000000000_REALK,      0.364200506107382_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.929114987736770_REALK, &
      0.000000000000000_REALK,      0.036320835506326_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.309660166691420_REALK,      0.000000000000000_REALK, &
      0.971607609261430_REALK,      0.000000000000000_REALK,     -0.314801656064485_REALK, &
      0.000000000000000_REALK,      0.015294895372098_REALK,      0.000000000000000_REALK, &
     -6.207790317055785_REALK,     -1.939376818114438_REALK,      0.000000000000000_REALK, &
     -0.567579504587295_REALK,      0.000000000000000_REALK,     -2.088669232800359_REALK, &
      0.395874509027620_REALK,      0.000000000000000_REALK,     -0.763113632939945_REALK, &
      0.000000000000000_REALK,      1.573476084396624_REALK,      0.000000000000000_REALK, &
     -0.280703530364212_REALK,      0.000000000000000_REALK,     -1.721629077722735_REALK, &
     -4.954443161303669_REALK,      1.255827871534009_REALK,      0.000000000000000_REALK, &
      3.180539453931907_REALK,      0.000000000000000_REALK,     -1.309966770180124_REALK, &
      4.655009408850949_REALK,      0.000000000000000_REALK,      0.416566751736781_REALK, &
      0.000000000000000_REALK,      6.559814566251032_REALK,      0.000000000000000_REALK, &
      1.339341936840764_REALK,      0.000000000000000_REALK,     -0.919389858535430_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.067570642039764_REALK, &
      0.000000000000000_REALK,      2.528079796624879_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.102910411852460_REALK,      0.000000000000000_REALK, &
      2.667539542336693_REALK,      0.000000000000000_REALK,      2.182171705228681_REALK, &
      0.000000000000000_REALK,      2.083822378537802_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      7.506787797328321_REALK, &
      0.000000000000000_REALK,      3.825182001611945_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.037319542336661_REALK,      0.000000000000000_REALK, &
      4.150088664739545_REALK,      0.000000000000000_REALK,      0.298674133244840_REALK, &
      0.000000000000000_REALK,      2.684673855391543_REALK,      0.000000000000000_REALK, &
    -34.731101028983112_REALK,      5.741573273795580_REALK,      0.000000000000000_REALK, &
      4.799503853606666_REALK,      0.000000000000000_REALK,     -3.314291928075967_REALK, &
      5.598972318981981_REALK,      0.000000000000000_REALK,      0.627834932447559_REALK, &
      0.000000000000000_REALK,      5.252490659866498_REALK,      0.000000000000000_REALK, &
      0.637903221463852_REALK,      0.000000000000000_REALK,     -1.321510032460471_REALK, &
     -9.140072498300192_REALK,      6.394433844948511_REALK,      0.000000000000000_REALK, &
      3.856664836922030_REALK,      0.000000000000000_REALK,     -1.428145312711879_REALK, &
      1.509201094912626_REALK,      0.000000000000000_REALK,      0.854478286069115_REALK, &
      0.000000000000000_REALK,     -2.874957969086986_REALK,      0.000000000000000_REALK, &
      0.526324826136726_REALK,      0.000000000000000_REALK,     -0.584703388960519_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.272440229957429_REALK, &
      0.000000000000000_REALK,     -0.031913548648297_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.451211645258232_REALK,      0.000000000000000_REALK, &
      1.401560388719890_REALK,      0.000000000000000_REALK,     -0.814944524080200_REALK, &
      0.000000000000000_REALK,     -0.012724912477647_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.624020486007222_REALK, &
      0.000000000000000_REALK,     -1.316055844316343_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.722650975459961_REALK,      0.000000000000000_REALK, &
      0.651046023028685_REALK,      0.000000000000000_REALK,     -2.229139715865524_REALK, &
      0.000000000000000_REALK,     -0.538812336100358_REALK,      0.000000000000000_REALK, &
     -6.389886343025060_REALK,     -0.998408375181731_REALK,      0.000000000000000_REALK, &
     -0.027332176689534_REALK,      0.000000000000000_REALK,     -1.829306998675724_REALK, &
      0.435487228567246_REALK,      0.000000000000000_REALK,     -0.327524682641340_REALK, &
      0.000000000000000_REALK,      0.697153757778255_REALK,      0.000000000000000_REALK, &
     -0.010898178702432_REALK,      0.000000000000000_REALK,     -1.215668184769466_REALK, &
     -2.985691084138680_REALK,     -0.049784485081032_REALK,      0.000000000000000_REALK, &
      0.446049770353541_REALK,      0.000000000000000_REALK,     -1.399551500650994_REALK, &
      0.410775662301677_REALK,      0.000000000000000_REALK,     -0.019957870790303_REALK, &
      0.000000000000000_REALK,      0.050739593438079_REALK,      0.000000000000000_REALK, &
      0.182619240527797_REALK,      0.000000000000000_REALK,     -0.954994446493589_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.831773478614511_REALK, &
      0.000000000000000_REALK,      0.869892172737093_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.252436043215534_REALK,      0.000000000000000_REALK, &
      1.548257094241892_REALK,      0.000000000000000_REALK,     -0.179934090899660_REALK, &
      0.000000000000000_REALK,      0.578087898500370_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.795553990362403_REALK, &
      0.000000000000000_REALK,     -0.600043285949249_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.747668922813663_REALK,      0.000000000000000_REALK, &
      1.199685486965720_REALK,      0.000000000000000_REALK,     -2.745249064408206_REALK, &
      0.000000000000000_REALK,     -0.409444029369946_REALK,      0.000000000000000_REALK, &
     -6.373013884384699_REALK,     -3.427517008188617_REALK,      0.000000000000000_REALK, &
     -2.397159778407148_REALK,      0.000000000000000_REALK,     -3.040794539871617_REALK, &
     -1.962422026435094_REALK,      0.000000000000000_REALK,     -1.873976701751987_REALK, &
      0.000000000000000_REALK,     -1.894938215243311_REALK,      0.000000000000000_REALK, &
     -1.593035438298881_REALK,      0.000000000000000_REALK,     -2.829069179588857_REALK, &
     -7.651782019770399_REALK,     -5.243125980907410_REALK,      0.000000000000000_REALK, &
     -2.934655508668070_REALK,      0.000000000000000_REALK,     -5.977992312129043_REALK, &
     -0.389731319808866_REALK,      0.000000000000000_REALK,     -3.503154001154802_REALK, &
      0.000000000000000_REALK,      3.306377658176164_REALK,      0.000000000000000_REALK, &
     -2.002484161423297_REALK,      0.000000000000000_REALK,     -5.710778945435564_REALK, &
    -61.899045022555185_REALK,     19.697708660398874_REALK,      0.000000000000000_REALK, &
      8.759913400686875_REALK,      0.000000000000000_REALK,     -4.503872081549531_REALK, &
      8.227811035662587_REALK,      0.000000000000000_REALK,      1.649084722354313_REALK, &
      0.000000000000000_REALK,      5.989335253113601_REALK,      0.000000000000000_REALK, &
      0.880868612722881_REALK,      0.000000000000000_REALK,     -1.358684511211526_REALK, &
    -61.743964250781730_REALK,     62.287274472090864_REALK,      0.000000000000000_REALK, &
     31.071743938471826_REALK,      0.000000000000000_REALK,     -3.628631648703101_REALK, &
     25.888815510173831_REALK,      0.000000000000000_REALK,      4.106584833179312_REALK, &
      0.000000000000000_REALK,     24.159958192936951_REALK,      0.000000000000000_REALK, &
      2.359701614230574_REALK,      0.000000000000000_REALK,     -0.826714584400052_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.368586615586751_REALK, &
      0.000000000000000_REALK,     -0.977095235452922_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.772104180527676_REALK,      0.000000000000000_REALK, &
      1.599526991462002_REALK,      0.000000000000000_REALK,     -0.876215764478377_REALK, &
      0.000000000000000_REALK,     -0.294760627822210_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.632263917657344_REALK, &
      0.000000000000000_REALK,     -3.552813957438310_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.536900246456562_REALK,      0.000000000000000_REALK, &
      1.707369171987277_REALK,      0.000000000000000_REALK,     -0.476551682706151_REALK, &
      0.000000000000000_REALK,     -0.809440968008996_REALK,      0.000000000000000_REALK, &
     -9.992631709557807_REALK,      0.061323565693082_REALK,      0.000000000000000_REALK, &
      0.702217614817916_REALK,      0.000000000000000_REALK,     -2.181238900930599_REALK, &
      0.986391121362467_REALK,      0.000000000000000_REALK,      0.015401957209581_REALK, &
      0.000000000000000_REALK,      1.076870430387502_REALK,      0.000000000000000_REALK, &
      0.211838209318048_REALK,      0.000000000000000_REALK,     -1.096691711889103_REALK, &
    -15.353715769476747_REALK,      7.954751717065624_REALK,      0.000000000000000_REALK, &
      7.162567532949371_REALK,      0.000000000000000_REALK,     -2.706968023952713_REALK, &
      6.509222458394651_REALK,      0.000000000000000_REALK,      1.573364528944634_REALK, &
      0.000000000000000_REALK,      6.263135428626649_REALK,      0.000000000000000_REALK, &
      1.631854543118450_REALK,      0.000000000000000_REALK,     -1.027885146781678_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.515109809391044_REALK, &
      0.000000000000000_REALK,      0.509724436094218_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.013190918391941_REALK,      0.000000000000000_REALK, &
      1.471418321796615_REALK,      0.000000000000000_REALK,     -0.204455792863608_REALK, &
      0.000000000000000_REALK,      0.256281218977610_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.459431832627599_REALK, &
      0.000000000000000_REALK,      0.082982333267626_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.533259200093235_REALK,      0.000000000000000_REALK, &
      2.788641400319136_REALK,      0.000000000000000_REALK,     -0.389124750328777_REALK, &
      0.000000000000000_REALK,      0.031509905937688_REALK,      0.000000000000000_REALK, &
     -6.623116517412377_REALK,     -1.671543656540007_REALK,      0.000000000000000_REALK, &
     -0.392864497234849_REALK,      0.000000000000000_REALK,     -2.409541986047897_REALK, &
      0.217788308835099_REALK,      0.000000000000000_REALK,     -0.699705015002636_REALK, &
      0.000000000000000_REALK,      0.664335763699989_REALK,      0.000000000000000_REALK, &
     -0.197525927961913_REALK,      0.000000000000000_REALK,     -1.696070345246544_REALK, &
    -16.975417400400662_REALK,      3.626894238441711_REALK,      0.000000000000000_REALK, &
      7.266589032376336_REALK,      0.000000000000000_REALK,     -4.988142369580625_REALK, &
      8.016292893958200_REALK,      0.000000000000000_REALK,      1.195601268265784_REALK, &
      0.000000000000000_REALK,      8.108553929502298_REALK,      0.000000000000000_REALK, &
      2.759256433047825_REALK,      0.000000000000000_REALK,     -2.651724131536839_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.843046969799631_REALK, &
      0.000000000000000_REALK,      2.916457195991702_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.928175435165135_REALK,      0.000000000000000_REALK, &
      3.424243783484856_REALK,      0.000000000000000_REALK,      1.535554221524243_REALK, &
      0.000000000000000_REALK,      2.052886644824826_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     36.133303016648490_REALK, &
      0.000000000000000_REALK,     14.565676662908128_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      5.847374564880096_REALK,      0.000000000000000_REALK, &
     16.675819062388008_REALK,      0.000000000000000_REALK,      0.615316000247656_REALK, &
      0.000000000000000_REALK,      7.743194447443924_REALK,      0.000000000000000_REALK, &
    -42.569402484578895_REALK,     -6.016415895994814_REALK,      0.000000000000000_REALK, &
    -23.555325500808287_REALK,      0.000000000000000_REALK,    -18.447511605223255_REALK, &
     -8.187604218231648_REALK,      0.000000000000000_REALK,     -3.049879721630588_REALK, &
      0.000000000000000_REALK,    -88.662336940815507_REALK,      0.000000000000000_REALK, &
    -29.385448674264893_REALK,      0.000000000000000_REALK,    -69.040235350336260_REALK, &
    -11.433179793251675_REALK,     -1.657204505242454_REALK,      0.000000000000000_REALK, &
     -5.906694485779328_REALK,      0.000000000000000_REALK,     -7.838797737566850_REALK, &
      0.205432510644916_REALK,      0.000000000000000_REALK,     -1.405399553056327_REALK, &
      0.000000000000000_REALK,     41.644852767591260_REALK,      0.000000000000000_REALK, &
     -8.787630943071514_REALK,      0.000000000000000_REALK,    -34.986299894618391_REALK, &
    -19.832059378190362_REALK,      2.093097996306802_REALK,      0.000000000000000_REALK, &
      1.949540854743892_REALK,      0.000000000000000_REALK,     -7.604914318157121_REALK, &
      8.312884865752062_REALK,      0.000000000000000_REALK,      0.903939303497713_REALK, &
      0.000000000000000_REALK,     50.473983007852176_REALK,      0.000000000000000_REALK, &
      2.088361226732205_REALK,      0.000000000000000_REALK,    -24.439305525730489_REALK, &
     -4.990028002127127_REALK,      4.128029115926409_REALK,      0.000000000000000_REALK, &
      7.897667692154029_REALK,      0.000000000000000_REALK,     -1.788356873748600_REALK, &
     11.774001319332749_REALK,      0.000000000000000_REALK,      1.937000347946496_REALK, &
      0.000000000000000_REALK,     67.622872789381191_REALK,      0.000000000000000_REALK, &
      9.320468983115095_REALK,      0.000000000000000_REALK,     -6.331612859226931_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.086986092114821_REALK, &
      0.000000000000000_REALK,      3.577804329111118_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.805185439873636_REALK,      0.000000000000000_REALK, &
      6.590699536938661_REALK,      0.000000000000000_REALK,     10.288782689434889_REALK, &
      0.000000000000000_REALK,     11.497703912542791_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.391514213767257_REALK, &
      0.000000000000000_REALK,      2.029771564850409_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.199155871077603_REALK,      0.000000000000000_REALK, &
      4.774213573339858_REALK,      0.000000000000000_REALK,     -0.350151052671843_REALK, &
      0.000000000000000_REALK,      7.186332845502661_REALK,      0.000000000000000_REALK, &
    -11.918947886218486_REALK,      7.380674627580811_REALK,      0.000000000000000_REALK, &
      2.529327352476006_REALK,      0.000000000000000_REALK,     -3.847190931094640_REALK, &
      8.606152633647305_REALK,      0.000000000000000_REALK,      2.776833230025202_REALK, &
      0.000000000000000_REALK,     14.850455198203784_REALK,      0.000000000000000_REALK, &
      2.171355468210914_REALK,      0.000000000000000_REALK,     -9.908111408323172_REALK, &
     -2.086759650901681_REALK,      3.458794437951016_REALK,      0.000000000000000_REALK, &
      0.751872020201991_REALK,      0.000000000000000_REALK,     -1.164778294151415_REALK, &
      1.748015775933997_REALK,      0.000000000000000_REALK,      1.755905428767346_REALK, &
      0.000000000000000_REALK,     -9.640531021264060_REALK,      0.000000000000000_REALK, &
      0.711790197912268_REALK,      0.000000000000000_REALK,     -3.308054097937641_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.354820756711827_REALK, &
      0.000000000000000_REALK,     -0.703233885576398_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.323564654719393_REALK,      0.000000000000000_REALK, &
      3.786555387445317_REALK,      0.000000000000000_REALK,     -5.551855714924355_REALK, &
      0.000000000000000_REALK,     -1.811118764104703_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.951005914153812_REALK, &
      0.000000000000000_REALK,     -1.753169274926086_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.132083725708466_REALK,      0.000000000000000_REALK, &
      1.448374406813633_REALK,      0.000000000000000_REALK,    -10.088493343332502_REALK, &
      0.000000000000000_REALK,     -4.979126786117536_REALK,      0.000000000000000_REALK, &
     -5.294987730431703_REALK,     -1.578307358190466_REALK,      0.000000000000000_REALK, &
     -2.182338403708613_REALK,      0.000000000000000_REALK,     -5.127338999525722_REALK, &
     -1.594114263268097_REALK,      0.000000000000000_REALK,     -1.781421024728103_REALK, &
      0.000000000000000_REALK,     -5.652685580962340_REALK,      0.000000000000000_REALK, &
     -5.620426025607922_REALK,      0.000000000000000_REALK,    -22.008372232033715_REALK, &
     -2.580500231606986_REALK,     -1.079384540574274_REALK,      0.000000000000000_REALK, &
     -1.085349949084547_REALK,      0.000000000000000_REALK,     -4.321116698604595_REALK, &
      0.080098046814358_REALK,      0.000000000000000_REALK,     -1.643894028849560_REALK, &
      0.000000000000000_REALK,      4.869309629343972_REALK,      0.000000000000000_REALK, &
     -3.082471887391485_REALK,      0.000000000000000_REALK,    -20.453803489558467_REALK, &
     -5.333681995736963_REALK,     13.407942204040642_REALK,      0.000000000000000_REALK, &
      2.089963485580469_REALK,      0.000000000000000_REALK,     -1.404763792408669_REALK, &
     10.511778020644332_REALK,      0.000000000000000_REALK,      4.284312106743671_REALK, &
      0.000000000000000_REALK,      6.781495715790758_REALK,      0.000000000000000_REALK, &
      1.365196995691213_REALK,      0.000000000000000_REALK,     -2.752841361512299_REALK, &
     -1.207513309010606_REALK,     10.748702764432291_REALK,      0.000000000000000_REALK, &
      3.001226122313751_REALK,      0.000000000000000_REALK,     -0.273439358374097_REALK, &
      9.547005655385993_REALK,      0.000000000000000_REALK,      3.356521084193496_REALK, &
      0.000000000000000_REALK,     15.375487958318324_REALK,      0.000000000000000_REALK, &
      1.827960356559978_REALK,      0.000000000000000_REALK,     -0.499632103674052_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.366511211643798_REALK, &
      0.000000000000000_REALK,     -1.962427400598369_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.497151596581785_REALK,      0.000000000000000_REALK, &
      2.268552283526704_REALK,      0.000000000000000_REALK,     -3.972916805862730_REALK, &
      0.000000000000000_REALK,     -3.845665261680273_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.324976908817734_REALK, &
      0.000000000000000_REALK,     -1.783167017808158_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.267080567507742_REALK,      0.000000000000000_REALK, &
      1.241260371967633_REALK,      0.000000000000000_REALK,     -1.081195685429005_REALK, &
      0.000000000000000_REALK,     -3.258226956087218_REALK,      0.000000000000000_REALK, &
     -3.386808758396092_REALK,      0.432578186118478_REALK,      0.000000000000000_REALK, &
      0.228667727474842_REALK,      0.000000000000000_REALK,     -2.676012360360086_REALK, &
      1.271147894978496_REALK,      0.000000000000000_REALK,      0.414672124558107_REALK, &
      0.000000000000000_REALK,      3.610135119852971_REALK,      0.000000000000000_REALK, &
      0.448108060328365_REALK,      0.000000000000000_REALK,     -8.740066656670496_REALK, &
     -2.165117091460371_REALK,      1.994292663410354_REALK,      0.000000000000000_REALK, &
      2.165185730735963_REALK,      0.000000000000000_REALK,     -1.470861374055087_REALK, &
      3.785442023981660_REALK,      0.000000000000000_REALK,      1.868286486144025_REALK, &
      0.000000000000000_REALK,      9.567953643391906_REALK,      0.000000000000000_REALK, &
      3.956256728823309_REALK,      0.000000000000000_REALK,     -4.479296414518811_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.153964917676612_REALK, &
      0.000000000000000_REALK,      1.258955486821485_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.286847691687753_REALK,      0.000000000000000_REALK, &
      5.039017127092976_REALK,      0.000000000000000_REALK,      2.207705446302054_REALK, &
      0.000000000000000_REALK,      4.111847551825289_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.915424570243186_REALK, &
      0.000000000000000_REALK,      1.669416567083639_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.156616575257546_REALK,      0.000000000000000_REALK, &
      7.674752279120920_REALK,      0.000000000000000_REALK,     -0.148628514374880_REALK, &
      0.000000000000000_REALK,      5.083967649962902_REALK,      0.000000000000000_REALK, &
      7.119556385490888_REALK,     22.076201878928984_REALK,      0.000000000000000_REALK, &
      0.167468312923395_REALK,      0.000000000000000_REALK,      1.511542950095012_REALK, &
     12.669751186831029_REALK,      0.000000000000000_REALK,      5.799152807002788_REALK, &
      0.000000000000000_REALK,     -3.111420920282463_REALK,      0.000000000000000_REALK, &
      0.080113024898240_REALK,      0.000000000000000_REALK,      2.169263113991823_REALK, &
      1.682475241569538_REALK,     12.975244525163671_REALK,      0.000000000000000_REALK, &
     -2.704413019665567_REALK,      0.000000000000000_REALK,      0.621374205011224_REALK, &
      5.088470198070804_REALK,      0.000000000000000_REALK,      4.390635364601851_REALK, &
      0.000000000000000_REALK,    -15.999094587118623_REALK,      0.000000000000000_REALK, &
     -1.284596155717864_REALK,      0.000000000000000_REALK,      0.885458222411277_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.138706789925853_REALK, &
      0.000000000000000_REALK,     -3.212088640036258_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.445028167083354_REALK,      0.000000000000000_REALK, &
      0.897373748441914_REALK,      0.000000000000000_REALK,     -3.770101880275153_REALK, &
      0.000000000000000_REALK,     -4.609770040120150_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.268348972825676_REALK, &
      0.000000000000000_REALK,     -3.350893076161842_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.996665554115568_REALK,      0.000000000000000_REALK, &
      0.272416251082898_REALK,      0.000000000000000_REALK,     -4.527223865390640_REALK, &
      0.000000000000000_REALK,     -4.775022527133914_REALK,      0.000000000000000_REALK, &
     -2.670339010969770_REALK,      1.590750998761374_REALK,      0.000000000000000_REALK, &
      0.372730780570974_REALK,      0.000000000000000_REALK,     -1.700807699741284_REALK, &
      1.295095059297694_REALK,      0.000000000000000_REALK,      1.253613484371306_REALK, &
      0.000000000000000_REALK,      1.219479721218381_REALK,      0.000000000000000_REALK, &
      0.534917736668461_REALK,      0.000000000000000_REALK,     -4.068138241137567_REALK, &
     -1.118428661166390_REALK,      1.749971329843395_REALK,      0.000000000000000_REALK, &
      0.266632743245261_REALK,      0.000000000000000_REALK,     -1.239179102949033_REALK, &
      0.589504303557966_REALK,      0.000000000000000_REALK,      1.776495077132926_REALK, &
      0.000000000000000_REALK,     -1.715362984531509_REALK,      0.000000000000000_REALK, &
      0.379951650658441_REALK,      0.000000000000000_REALK,     -2.943050303927117_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.169185638991086_REALK, &
      0.000000000000000_REALK,     -0.310893228001815_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.146074675942457_REALK,      0.000000000000000_REALK, &
      2.849094934050218_REALK,      0.000000000000000_REALK,     -1.367710693534740_REALK, &
      0.000000000000000_REALK,     -0.743621180652739_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.443479611873005_REALK, &
      0.000000000000000_REALK,     -1.865153858317266_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.157084419640559_REALK,      0.000000000000000_REALK, &
      2.442263272834707_REALK,      0.000000000000000_REALK,     -5.385210009492616_REALK, &
      0.000000000000000_REALK,     -4.429740314800348_REALK,      0.000000000000000_REALK, &
     -3.558891044953816_REALK,     -1.020514031472830_REALK,      0.000000000000000_REALK, &
     -0.964791721270930_REALK,      0.000000000000000_REALK,     -3.777915629770872_REALK, &
     -0.719669843494123_REALK,      0.000000000000000_REALK,     -1.340383831117717_REALK, &
      0.000000000000000_REALK,     -1.392550331502476_REALK,      0.000000000000000_REALK, &
     -2.307671876504464_REALK,      0.000000000000000_REALK,    -12.650881264613322_REALK, &
     -4.149167947437576_REALK,     -1.638338473505936_REALK,      0.000000000000000_REALK, &
     -1.154677231749249_REALK,      0.000000000000000_REALK,     -7.661883726716689_REALK, &
      0.081037272009325_REALK,      0.000000000000000_REALK,     -2.771950396392332_REALK, &
      0.000000000000000_REALK,      2.599224092524407_REALK,      0.000000000000000_REALK, &
     -2.742358364299433_REALK,      0.000000000000000_REALK,    -25.475762823683858_REALK, &
     49.988115970775347_REALK,     40.526351018788510_REALK,      0.000000000000000_REALK, &
     -3.432639369353385_REALK,      0.000000000000000_REALK,      7.845530055205596_REALK, &
     18.710298983404098_REALK,      0.000000000000000_REALK,      8.054815472192519_REALK, &
      0.000000000000000_REALK,    -11.052282466911771_REALK,      0.000000000000000_REALK, &
     -1.132391108161579_REALK,      0.000000000000000_REALK,      7.764470004609991_REALK, &
     55.905598383597834_REALK,     74.450813237353330_REALK,      0.000000000000000_REALK, &
    -10.054076650868398_REALK,      0.000000000000000_REALK,      7.060453665908589_REALK, &
     30.891069969589850_REALK,      0.000000000000000_REALK,     11.678104414824647_REALK, &
      0.000000000000000_REALK,     -1.078031463854113_REALK,      0.000000000000000_REALK, &
     -2.297944338439543_REALK,      0.000000000000000_REALK,      4.841179381794748_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.711571880647155_REALK, &
      0.000000000000000_REALK,     -5.298519843685138_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.037689935127181_REALK,      0.000000000000000_REALK, &
     -1.020550480324381_REALK,      0.000000000000000_REALK,     -3.818795218810084_REALK, &
      0.000000000000000_REALK,     -5.243775513654058_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.135683480002585_REALK, &
      0.000000000000000_REALK,     -9.732523256092700_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.458006948985962_REALK,      0.000000000000000_REALK, &
     -1.004988404772980_REALK,      0.000000000000000_REALK,     -2.577998303840646_REALK, &
      0.000000000000000_REALK,     -6.673351763178879_REALK,      0.000000000000000_REALK, &
     -1.741352111280608_REALK,      3.637158040455713_REALK,      0.000000000000000_REALK, &
      0.406609491552383_REALK,      0.000000000000000_REALK,     -0.819904694971993_REALK, &
      1.773680315665553_REALK,      0.000000000000000_REALK,      2.168710193929611_REALK, &
      0.000000000000000_REALK,      0.666309417307220_REALK,      0.000000000000000_REALK, &
      0.402408400520169_REALK,      0.000000000000000_REALK,     -1.352389060172539_REALK, &
     -1.593795254066755_REALK,     11.517129176426995_REALK,      0.000000000000000_REALK, &
      2.209263552646646_REALK,      0.000000000000000_REALK,     -0.603852809180458_REALK, &
      5.138364945258606_REALK,      0.000000000000000_REALK,      5.419614557569034_REALK, &
      0.000000000000000_REALK,      4.247241691341152_REALK,      0.000000000000000_REALK, &
      1.514837667112881_REALK,      0.000000000000000_REALK,     -0.690078359402200_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.925882842483814_REALK, &
      0.000000000000000_REALK,     -1.145390739701100_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.251657140883412_REALK,      0.000000000000000_REALK, &
      1.913894358522050_REALK,      0.000000000000000_REALK,     -1.171065496256432_REALK, &
      0.000000000000000_REALK,     -1.889260929342053_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.259099134771568_REALK, &
      0.000000000000000_REALK,     -3.937876461325834_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.431242258100266_REALK,      0.000000000000000_REALK, &
      3.340339900007776_REALK,      0.000000000000000_REALK,     -0.895990957314859_REALK, &
      0.000000000000000_REALK,     -4.500175020545748_REALK,      0.000000000000000_REALK, &
     -3.317198093165548_REALK,      0.352035055899724_REALK,      0.000000000000000_REALK, &
      0.133464248123685_REALK,      0.000000000000000_REALK,     -2.603136448892787_REALK, &
      0.643452514463827_REALK,      0.000000000000000_REALK,      0.349843662670326_REALK, &
      0.000000000000000_REALK,      1.064131186800760_REALK,      0.000000000000000_REALK, &
      0.220142158220950_REALK,      0.000000000000000_REALK,     -6.011228607533408_REALK, &
     -8.573205742210286_REALK,      6.410594856925734_REALK,      0.000000000000000_REALK, &
      4.781511680237360_REALK,      0.000000000000000_REALK,     -5.413654773520528_REALK, &
      6.112172748330607_REALK,      0.000000000000000_REALK,      5.027721850508690_REALK, &
      0.000000000000000_REALK,      7.928999403179576_REALK,      0.000000000000000_REALK, &
      5.464274878904447_REALK,      0.000000000000000_REALK,     -8.661356421230629_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.277863330953822_REALK, &
      0.000000000000000_REALK,      1.224670320595075_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.085666200106039_REALK,      0.000000000000000_REALK, &
      5.951727509610205_REALK,      0.000000000000000_REALK,      1.084580003557496_REALK, &
      0.000000000000000_REALK,      2.828039716892085_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     26.334145139729305_REALK, &
      0.000000000000000_REALK,      6.144457340986721_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.112556062044227_REALK,      0.000000000000000_REALK, &
     28.914798679973000_REALK,      0.000000000000000_REALK,     -0.205281687477622_REALK, &
      0.000000000000000_REALK,      9.830574218666737_REALK,      0.000000000000000_REALK/
    ! results of test 3, ket-major order, 1DOVL003
  data REF_CONTR_INTS(16381:17640)                                                         &
     /0.000000000000000_REALK,      0.000000000000000_REALK,     12.209587161337501_REALK, &
      0.000000000000000_REALK,     12.335510502417661_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     16.425689030404968_REALK,      0.000000000000000_REALK, &
      7.745015515490882_REALK,      0.000000000000000_REALK,     30.907178242688616_REALK, &
      0.000000000000000_REALK,     11.087878659224391_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     12.501230293251162_REALK, &
      0.000000000000000_REALK,     16.468048920163149_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     25.502317718550895_REALK,      0.000000000000000_REALK, &
      9.223628235199078_REALK,      0.000000000000000_REALK,     51.184926763798529_REALK, &
      0.000000000000000_REALK,     14.915949621647256_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.377532768527326_REALK, &
      0.000000000000000_REALK,      6.095971674346316_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      6.018285029253223_REALK,      0.000000000000000_REALK, &
      4.580512760439629_REALK,      0.000000000000000_REALK,      7.873284975640716_REALK, &
      0.000000000000000_REALK,      4.511064107063818_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      7.281983886630690_REALK, &
      0.000000000000000_REALK,      4.469394585246675_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.936962901421232_REALK,      0.000000000000000_REALK, &
      3.589615529423321_REALK,      0.000000000000000_REALK,      0.557817213188908_REALK, &
      0.000000000000000_REALK,      3.008410414519546_REALK,      0.000000000000000_REALK, &
      9.671464072433743_REALK,      8.377532768527326_REALK,      0.000000000000000_REALK, &
      9.341216610459950_REALK,      0.000000000000000_REALK,     -2.085933847353481_REALK, &
     12.768062194840098_REALK,      0.000000000000000_REALK,     -2.169264405147246_REALK, &
      0.000000000000000_REALK,     23.152677876284958_REALK,      0.000000000000000_REALK, &
     -3.273692581597515_REALK,      0.000000000000000_REALK,     -4.173680944286847_REALK, &
      8.344424410208857_REALK,      7.281983886630689_REALK,      0.000000000000000_REALK, &
      8.474391014111333_REALK,      0.000000000000000_REALK,     -4.944991743065289_REALK, &
     12.317969197018224_REALK,      0.000000000000000_REALK,     -5.791390766173672_REALK, &
      0.000000000000000_REALK,     22.918735512041497_REALK,      0.000000000000000_REALK, &
     -9.203050765809666_REALK,      0.000000000000000_REALK,     -7.344780697013846_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      7.830530914734441_REALK, &
      0.000000000000000_REALK,      4.409227071396122_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.649786208748017_REALK,      0.000000000000000_REALK, &
      3.663284417237143_REALK,      0.000000000000000_REALK,      3.988649916176913_REALK, &
      0.000000000000000_REALK,      2.679595690577732_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.588035945067877_REALK, &
      0.000000000000000_REALK,      4.047492236325485_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      4.066409726357447_REALK,      0.000000000000000_REALK, &
      3.059583387690254_REALK,      0.000000000000000_REALK,      5.665668738974966_REALK, &
      0.000000000000000_REALK,      2.469061947986520_REALK,      0.000000000000000_REALK, &
      7.584348092057158_REALK,      4.762066440423276_REALK,      0.000000000000000_REALK, &
      3.943943041996059_REALK,      0.000000000000000_REALK,     -1.421576946812006_REALK, &
      3.888229157543608_REALK,      0.000000000000000_REALK,     -1.055050562194703_REALK, &
      0.000000000000000_REALK,      4.751774324319903_REALK,      0.000000000000000_REALK, &
     -1.135104466335632_REALK,      0.000000000000000_REALK,     -2.335930053365533_REALK, &
      1.973272488466079_REALK,      1.545087152658806_REALK,      0.000000000000000_REALK, &
      0.995338078011720_REALK,      0.000000000000000_REALK,     -1.962704994138220_REALK, &
      0.156859531214041_REALK,      0.000000000000000_REALK,     -1.364869153040838_REALK, &
      0.000000000000000_REALK,     -1.670893226461585_REALK,      0.000000000000000_REALK, &
     -0.979606176845403_REALK,      0.000000000000000_REALK,     -2.641957742099134_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.096159137619856_REALK, &
      0.000000000000000_REALK,     -0.956292917411945_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.087562797168844_REALK,      0.000000000000000_REALK, &
      1.059311695339401_REALK,      0.000000000000000_REALK,     -1.619976210467592_REALK, &
      0.000000000000000_REALK,      1.200517439536802_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.948902948583890_REALK, &
      0.000000000000000_REALK,      1.089449164175544_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.436490510177775_REALK,      0.000000000000000_REALK, &
      3.817393384087544_REALK,      0.000000000000000_REALK,      2.280573693318197_REALK, &
      0.000000000000000_REALK,      4.883092478005739_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      9.030438649538032_REALK, &
      0.000000000000000_REALK,      3.814242173398460_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.584183704067790_REALK,      0.000000000000000_REALK, &
      3.553332586284229_REALK,      0.000000000000000_REALK,      2.172451309525271_REALK, &
      0.000000000000000_REALK,      1.886381088611596_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      9.647483267783709_REALK, &
      0.000000000000000_REALK,      3.459753350034372_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.513684699194594_REALK,      0.000000000000000_REALK, &
      3.200136625719711_REALK,      0.000000000000000_REALK,     -0.047496534747906_REALK, &
      0.000000000000000_REALK,      1.456920380942887_REALK,      0.000000000000000_REALK, &
      8.433574557777296_REALK,      4.078339474286109_REALK,      0.000000000000000_REALK, &
      2.827099580562477_REALK,      0.000000000000000_REALK,     -1.343824985817979_REALK, &
      2.388729837657292_REALK,      0.000000000000000_REALK,     -0.759991574944114_REALK, &
      0.000000000000000_REALK,      2.606248323964255_REALK,      0.000000000000000_REALK, &
     -0.662156534175242_REALK,      0.000000000000000_REALK,     -1.796993633538033_REALK, &
      6.136337466412071_REALK,      2.929114987736770_REALK,      0.000000000000000_REALK, &
      2.156371113477831_REALK,      0.000000000000000_REALK,     -2.617638069261469_REALK, &
      2.229513464751975_REALK,      0.000000000000000_REALK,     -1.567566022181965_REALK, &
      0.000000000000000_REALK,      3.244845379612821_REALK,      0.000000000000000_REALK, &
     -1.465038776130367_REALK,      0.000000000000000_REALK,     -2.432344893617435_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.884528533212160_REALK, &
      0.000000000000000_REALK,     -0.549752889658613_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.457296117453453_REALK,      0.000000000000000_REALK, &
      0.718968044003764_REALK,      0.000000000000000_REALK,     -0.474532173502725_REALK, &
      0.000000000000000_REALK,      0.561641796033587_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.788419517281383_REALK, &
      0.000000000000000_REALK,      0.401749487083899_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.213974676450648_REALK,      0.000000000000000_REALK, &
      1.921559648281264_REALK,      0.000000000000000_REALK,      0.031369011928263_REALK, &
      0.000000000000000_REALK,      1.243048369820754_REALK,      0.000000000000000_REALK, &
      5.428968800785847_REALK,      4.067570642039765_REALK,      0.000000000000000_REALK, &
      3.873925643090010_REALK,      0.000000000000000_REALK,      0.352687364375603_REALK, &
      4.461418958756212_REALK,      0.000000000000000_REALK,      0.309030995432941_REALK, &
      0.000000000000000_REALK,      6.417031609832160_REALK,      0.000000000000000_REALK, &
      0.369923886448416_REALK,      0.000000000000000_REALK,     -0.924215874479916_REALK, &
      9.921300714539557_REALK,      7.506787797328321_REALK,      0.000000000000000_REALK, &
      7.252903578664796_REALK,      0.000000000000000_REALK,     -2.483416594686616_REALK, &
      8.544758721617551_REALK,      0.000000000000000_REALK,     -2.357350514541345_REALK, &
      0.000000000000000_REALK,     12.271463307835539_REALK,      0.000000000000000_REALK, &
     -2.891466206971178_REALK,      0.000000000000000_REALK,     -5.327016188642624_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     12.775980185906935_REALK, &
      0.000000000000000_REALK,      4.011546841359845_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.328068743605272_REALK,      0.000000000000000_REALK, &
      4.191119545706496_REALK,      0.000000000000000_REALK,      1.584935593699231_REALK, &
      0.000000000000000_REALK,      1.599526991462001_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     10.341794454862704_REALK, &
      0.000000000000000_REALK,      4.170270475731821_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.922230461698117_REALK,      0.000000000000000_REALK, &
      4.145873902965362_REALK,      0.000000000000000_REALK,      2.925093195468961_REALK, &
      0.000000000000000_REALK,      1.707369171987277_REALK,      0.000000000000000_REALK, &
     11.689542074189989_REALK,      4.272440229957429_REALK,      0.000000000000000_REALK, &
      2.433764128906156_REALK,      0.000000000000000_REALK,     -1.584854340897325_REALK, &
      1.614107414580956_REALK,      0.000000000000000_REALK,     -0.663758671119298_REALK, &
      0.000000000000000_REALK,      1.330043087845806_REALK,      0.000000000000000_REALK, &
     -0.459575198991359_REALK,      0.000000000000000_REALK,     -1.708644511055314_REALK, &
      3.367678774223799_REALK,      1.624020486007222_REALK,      0.000000000000000_REALK, &
      0.746692128801760_REALK,      0.000000000000000_REALK,     -2.546886589355904_REALK, &
     -0.021224516081830_REALK,      0.000000000000000_REALK,     -1.050380436349446_REALK, &
      0.000000000000000_REALK,     -1.030751481371144_REALK,      0.000000000000000_REALK, &
     -0.493218910413295_REALK,      0.000000000000000_REALK,     -2.300899745899662_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.012583883879153_REALK, &
      0.000000000000000_REALK,     -0.481486868673010_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.330950938682375_REALK,      0.000000000000000_REALK, &
      0.686179214687037_REALK,      0.000000000000000_REALK,     -0.285772742069054_REALK, &
      0.000000000000000_REALK,      0.396583719170183_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.682036952802596_REALK, &
      0.000000000000000_REALK,      0.429223939365061_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.363393314950164_REALK,      0.000000000000000_REALK, &
      2.008954541217928_REALK,      0.000000000000000_REALK,      0.403242538914202_REALK, &
      0.000000000000000_REALK,      1.291187061594046_REALK,      0.000000000000000_REALK, &
      5.265307700451099_REALK,      2.831773478614512_REALK,      0.000000000000000_REALK, &
      1.980504682625121_REALK,      0.000000000000000_REALK,      0.291042989792464_REALK, &
      1.621329561613086_REALK,      0.000000000000000_REALK,      0.179363575844340_REALK, &
      0.000000000000000_REALK,      1.565575245496733_REALK,      0.000000000000000_REALK, &
      0.152473898097512_REALK,      0.000000000000000_REALK,     -0.614892508004647_REALK, &
      2.620419152431702_REALK,      1.795553990362404_REALK,      0.000000000000000_REALK, &
      1.004998244962258_REALK,      0.000000000000000_REALK,     -1.162867719394523_REALK, &
      0.133466872434545_REALK,      0.000000000000000_REALK,     -0.681450308282489_REALK, &
      0.000000000000000_REALK,     -1.132297720749378_REALK,      0.000000000000000_REALK, &
     -0.389532817764470_REALK,      0.000000000000000_REALK,     -2.425142623301481_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.302835328577121_REALK, &
      0.000000000000000_REALK,     -1.696533321276293_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.602138316177109_REALK,      0.000000000000000_REALK, &
     -0.166483001784953_REALK,      0.000000000000000_REALK,     -1.885614857541143_REALK, &
      0.000000000000000_REALK,     -0.149077909700123_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.294346251984429_REALK, &
      0.000000000000000_REALK,     -1.291174206782624_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.434658446162251_REALK,      0.000000000000000_REALK, &
      3.811916504273466_REALK,      0.000000000000000_REALK,     -1.814008143256063_REALK, &
      0.000000000000000_REALK,      3.883477343631681_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     25.320305047632353_REALK, &
      0.000000000000000_REALK,      5.451388777667954_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.689557602686869_REALK,      0.000000000000000_REALK, &
      6.359419098833769_REALK,      0.000000000000000_REALK,      1.357159815298884_REALK, &
      0.000000000000000_REALK,      1.644522171744616_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     58.504457569314233_REALK, &
      0.000000000000000_REALK,     10.595823336182809_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.128921014440612_REALK,      0.000000000000000_REALK, &
     11.571553908744832_REALK,      0.000000000000000_REALK,     -0.581639757370457_REALK, &
      0.000000000000000_REALK,      2.414056463647814_REALK,      0.000000000000000_REALK, &
     24.687493947734477_REALK,      6.368586615586751_REALK,      0.000000000000000_REALK, &
      2.993409351822925_REALK,      0.000000000000000_REALK,     -2.552106257837466_REALK, &
      1.584935593699231_REALK,      0.000000000000000_REALK,     -0.757512782764905_REALK, &
      0.000000000000000_REALK,      1.119806060174584_REALK,      0.000000000000000_REALK, &
     -0.427658473249786_REALK,      0.000000000000000_REALK,     -2.081680080089664_REALK, &
     33.483131662241782_REALK,      8.632263917657346_REALK,      0.000000000000000_REALK, &
      4.160965111688049_REALK,      0.000000000000000_REALK,     -9.524246645950937_REALK, &
      2.925093195468961_REALK,      0.000000000000000_REALK,     -2.754624269938246_REALK, &
      0.000000000000000_REALK,      3.239652267263648_REALK,      0.000000000000000_REALK, &
     -1.529472678652441_REALK,      0.000000000000000_REALK,     -4.788155278988532_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.692548464126262_REALK, &
      0.000000000000000_REALK,     -0.574117897650380_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.309155623829725_REALK,      0.000000000000000_REALK, &
      0.878133114703221_REALK,      0.000000000000000_REALK,     -0.199459295521050_REALK, &
      0.000000000000000_REALK,      0.357770387786017_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.926321482061436_REALK, &
      0.000000000000000_REALK,      0.830191299452566_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.273773659979538_REALK,      0.000000000000000_REALK, &
      4.252719891318522_REALK,      0.000000000000000_REALK,     -0.006166191376032_REALK, &
      0.000000000000000_REALK,      1.389737926960929_REALK,      0.000000000000000_REALK, &
      8.997814697603237_REALK,      3.515109809391045_REALK,      0.000000000000000_REALK, &
      1.956848417488458_REALK,      0.000000000000000_REALK,      0.379227936292395_REALK, &
      1.314147336450567_REALK,      0.000000000000000_REALK,      0.170461903737989_REALK, &
      0.000000000000000_REALK,      1.100381497921880_REALK,      0.000000000000000_REALK, &
      0.113980271523382_REALK,      0.000000000000000_REALK,     -0.606171136363364_REALK, &
     21.024943956497506_REALK,      8.459431832627599_REALK,      0.000000000000000_REALK, &
      4.926668230309155_REALK,      0.000000000000000_REALK,     -3.509296092392919_REALK, &
      3.839397813137192_REALK,      0.000000000000000_REALK,     -1.584015612911291_REALK, &
      0.000000000000000_REALK,      4.010937121432045_REALK,      0.000000000000000_REALK, &
     -1.062628768055101_REALK,      0.000000000000000_REALK,     -4.072644342372906_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.693354915211359_REALK, &
      0.000000000000000_REALK,     -1.344342149639977_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.888793263606078_REALK,      0.000000000000000_REALK, &
     -0.149077909700123_REALK,      0.000000000000000_REALK,     -0.707814352938137_REALK, &
      0.000000000000000_REALK,     -0.089374492358814_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.672669933876068_REALK, &
      0.000000000000000_REALK,     -1.077378563082875_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.432512416162619_REALK,      0.000000000000000_REALK, &
      3.883477343631681_REALK,      0.000000000000000_REALK,     -0.045513042993525_REALK, &
      0.000000000000000_REALK,      1.803240973740630_REALK,      0.000000000000000_REALK, &
      9.653647836174189_REALK,      5.843046969799631_REALK,      0.000000000000000_REALK, &
      4.469059217834127_REALK,      0.000000000000000_REALK,      1.811698385266843_REALK, &
      4.090710851859765_REALK,      0.000000000000000_REALK,      1.261708366790227_REALK, &
      0.000000000000000_REALK,      4.515547495424822_REALK,      0.000000000000000_REALK, &
      1.159096992549553_REALK,      0.000000000000000_REALK,      0.078360397804389_REALK, &
     56.655617089868265_REALK,     36.133303016648490_REALK,      0.000000000000000_REALK, &
     27.617888076845006_REALK,      0.000000000000000_REALK,     -2.797261161047646_REALK, &
     24.524579366925529_REALK,      0.000000000000000_REALK,     -2.001385739657424_REALK, &
      0.000000000000000_REALK,     25.281157218838903_REALK,      0.000000000000000_REALK, &
     -1.762071765904233_REALK,      0.000000000000000_REALK,    -11.824233594654904_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.787390234715579_REALK, &
      0.000000000000000_REALK,      8.678807429153172_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      4.258021186060472_REALK,      0.000000000000000_REALK, &
      5.759783669102944_REALK,      0.000000000000000_REALK,     45.665637510518536_REALK, &
      0.000000000000000_REALK,     32.480635886919693_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.116924328407710_REALK, &
      0.000000000000000_REALK,      8.896976316016673_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      5.427999328441814_REALK,      0.000000000000000_REALK, &
      5.385800899502727_REALK,      0.000000000000000_REALK,     66.493104035198101_REALK, &
      0.000000000000000_REALK,     39.709186531976371_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.086986092114821_REALK, &
      0.000000000000000_REALK,      3.577804329111118_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.805185439873636_REALK,      0.000000000000000_REALK, &
      6.590699536938663_REALK,      0.000000000000000_REALK,     10.288782689434893_REALK, &
      0.000000000000000_REALK,     11.497703912542793_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.391514213767257_REALK, &
      0.000000000000000_REALK,      2.029771564850410_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.199155871077604_REALK,      0.000000000000000_REALK, &
      4.774213573339858_REALK,      0.000000000000000_REALK,     -0.350151052671840_REALK, &
      0.000000000000000_REALK,      7.186332845502661_REALK,      0.000000000000000_REALK, &
     12.484467384188038_REALK,      5.086986092114821_REALK,      0.000000000000000_REALK, &
     10.617430600697588_REALK,      0.000000000000000_REALK,      0.282842126983384_REALK, &
      9.266090018754426_REALK,      0.000000000000000_REALK,      0.129794958057873_REALK, &
      0.000000000000000_REALK,     60.461432602990122_REALK,      0.000000000000000_REALK, &
      0.671955132770827_REALK,      0.000000000000000_REALK,    -13.566877755744658_REALK, &
      6.374295775640051_REALK,      3.391514213767257_REALK,      0.000000000000000_REALK, &
      6.907074851853642_REALK,      0.000000000000000_REALK,     -2.901228800887828_REALK, &
      7.994429187379834_REALK,      0.000000000000000_REALK,     -2.021059742962373_REALK, &
      0.000000000000000_REALK,     51.859485735397001_REALK,      0.000000000000000_REALK, &
    -10.352175715425400_REALK,      0.000000000000000_REALK,    -28.631436784575691_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.460271173033565_REALK, &
      0.000000000000000_REALK,      1.809947593403386_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.267637151084263_REALK,      0.000000000000000_REALK, &
      7.291648761164853_REALK,      0.000000000000000_REALK,      3.548031158016674_REALK, &
      0.000000000000000_REALK,      4.661365323390552_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.544640517598148_REALK, &
      0.000000000000000_REALK,      1.322014579711824_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.848950459110981_REALK,      0.000000000000000_REALK, &
      5.398459179522447_REALK,      0.000000000000000_REALK,      4.536175368622069_REALK, &
      0.000000000000000_REALK,      3.754616453541590_REALK,      0.000000000000000_REALK, &
     11.254927408405994_REALK,      3.354820756711827_REALK,      0.000000000000000_REALK, &
      4.638737909278308_REALK,      0.000000000000000_REALK,      0.214632795328983_REALK, &
      3.388419620062888_REALK,      0.000000000000000_REALK,      0.074571112663037_REALK, &
      0.000000000000000_REALK,     12.015243304650177_REALK,      0.000000000000000_REALK, &
      0.235273647583587_REALK,      0.000000000000000_REALK,     -8.250580473962414_REALK, &
      2.273583592764694_REALK,      0.951005914153812_REALK,      0.000000000000000_REALK, &
      0.956261815605389_REALK,      0.000000000000000_REALK,     -1.611685608073120_REALK, &
     -0.070571435266337_REALK,      0.000000000000000_REALK,     -0.613137883628496_REALK, &
      0.000000000000000_REALK,     -4.290169148511706_REALK,      0.000000000000000_REALK, &
     -1.149697155784554_REALK,      0.000000000000000_REALK,    -12.758824396011621_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.230222977691807_REALK, &
      0.000000000000000_REALK,     -2.614157520545937_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.695312592643981_REALK,      0.000000000000000_REALK, &
     -1.403080532039515_REALK,      0.000000000000000_REALK,     -9.465507327657406_REALK, &
      0.000000000000000_REALK,     -2.590919969547949_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.050829703338274_REALK, &
      0.000000000000000_REALK,     -1.245932843966685_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.612944616738928_REALK,      0.000000000000000_REALK, &
      2.599437630362599_REALK,      0.000000000000000_REALK,     -5.925289654755172_REALK, &
      0.000000000000000_REALK,      5.747426229418915_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.938493923825760_REALK, &
      0.000000000000000_REALK,      0.660884497522678_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.184279872609440_REALK,      0.000000000000000_REALK, &
      8.568495556841087_REALK,      0.000000000000000_REALK,      0.627325240385276_REALK, &
      0.000000000000000_REALK,      1.295100421718040_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      7.489126170549058_REALK, &
      0.000000000000000_REALK,      0.310351609617659_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.183365290545023_REALK,      0.000000000000000_REALK, &
      7.015937767898882_REALK,      0.000000000000000_REALK,     -1.267582097032667_REALK, &
      0.000000000000000_REALK,      0.567078669705466_REALK,      0.000000000000000_REALK, &
     13.862764357589402_REALK,      2.366511211643798_REALK,      0.000000000000000_REALK, &
      3.406395771061145_REALK,      0.000000000000000_REALK,      0.215711645289891_REALK, &
      1.726724602586625_REALK,      0.000000000000000_REALK,      0.044676084358294_REALK, &
      0.000000000000000_REALK,      5.842891265510258_REALK,      0.000000000000000_REALK, &
      0.131461715241602_REALK,      0.000000000000000_REALK,     -6.309468164992651_REALK, &
      7.110127558109665_REALK,      1.324976908817734_REALK,      0.000000000000000_REALK, &
      1.654334017352063_REALK,      0.000000000000000_REALK,     -2.044772781070226_REALK, &
      1.499640454634223_REALK,      0.000000000000000_REALK,     -0.525460650174332_REALK, &
      0.000000000000000_REALK,      5.372505528510194_REALK,      0.000000000000000_REALK, &
     -1.279645925382504_REALK,      0.000000000000000_REALK,    -10.414426594942300_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.418017794505351_REALK, &
      0.000000000000000_REALK,     -1.364356411299562_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.394583777503472_REALK,      0.000000000000000_REALK, &
     -1.260926146221404_REALK,      0.000000000000000_REALK,     -2.392536599945948_REALK, &
      0.000000000000000_REALK,     -1.028918131573025_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.248724691488137_REALK, &
      0.000000000000000_REALK,     -0.424102060342178_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.293829282795217_REALK,      0.000000000000000_REALK, &
      1.900074883189670_REALK,      0.000000000000000_REALK,      0.037757897228790_REALK, &
      0.000000000000000_REALK,      1.258662024170217_REALK,      0.000000000000000_REALK, &
      6.396083635244228_REALK,      3.153964917676612_REALK,      0.000000000000000_REALK, &
      3.736054652831021_REALK,      0.000000000000000_REALK,      3.468676064307995_REALK, &
      4.250715971255789_REALK,      0.000000000000000_REALK,      2.075148847524941_REALK, &
      0.000000000000000_REALK,     12.973452552935328_REALK,      0.000000000000000_REALK, &
      5.025083346895787_REALK,      0.000000000000000_REALK,      6.152075405169786_REALK, &
      8.297205981997802_REALK,      4.915424570243187_REALK,      0.000000000000000_REALK, &
      5.680829009258998_REALK,      0.000000000000000_REALK,      1.371616829398005_REALK, &
      7.710831870036226_REALK,      0.000000000000000_REALK,      1.120536984342241_REALK, &
      0.000000000000000_REALK,     22.012780662181758_REALK,      0.000000000000000_REALK, &
      2.525873552679482_REALK,      0.000000000000000_REALK,     -8.811528392452498_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     14.194671285559910_REALK, &
      0.000000000000000_REALK,     -0.711119768644262_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.754737938637817_REALK,      0.000000000000000_REALK, &
     11.186308444031617_REALK,      0.000000000000000_REALK,     -1.038142047130075_REALK, &
      0.000000000000000_REALK,     -1.020550480324381_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     10.388873070279386_REALK, &
      0.000000000000000_REALK,     -0.705255036607761_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.522109715492408_REALK,      0.000000000000000_REALK, &
     10.546333846487514_REALK,      0.000000000000000_REALK,      0.027578505591138_REALK, &
      0.000000000000000_REALK,     -1.004988404772980_REALK,      0.000000000000000_REALK, &
     21.438772882693332_REALK,      1.138706789925853_REALK,      0.000000000000000_REALK, &
      3.480907193101661_REALK,      0.000000000000000_REALK,      0.268915011152862_REALK, &
      0.434673013008501_REALK,      0.000000000000000_REALK,      0.017672568350060_REALK, &
      0.000000000000000_REALK,      3.575666947802675_REALK,      0.000000000000000_REALK, &
      0.098380832518899_REALK,      0.000000000000000_REALK,     -5.760339325620707_REALK, &
      5.569781389173433_REALK,      0.268348972825676_REALK,      0.000000000000000_REALK, &
      1.040871318189451_REALK,      0.000000000000000_REALK,     -2.612409480779787_REALK, &
     -0.608927793021711_REALK,      0.000000000000000_REALK,     -0.115321510010960_REALK, &
      0.000000000000000_REALK,     -1.360514245108708_REALK,      0.000000000000000_REALK, &
     -0.627898151484137_REALK,      0.000000000000000_REALK,    -10.376648460273982_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.526844832563594_REALK, &
      0.000000000000000_REALK,     -0.867151409277285_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.109442712251537_REALK,      0.000000000000000_REALK, &
     -1.372878687060331_REALK,      0.000000000000000_REALK,     -0.947242025480361_REALK, &
      0.000000000000000_REALK,     -0.478918681341796_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.366801029056801_REALK, &
      0.000000000000000_REALK,     -0.357299756431006_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.475219031465954_REALK,      0.000000000000000_REALK, &
      2.253656950457882_REALK,      0.000000000000000_REALK,     -0.615136973921593_REALK, &
      0.000000000000000_REALK,      0.826983818433818_REALK,      0.000000000000000_REALK, &
      7.564712593227414_REALK,      2.169185638991086_REALK,      0.000000000000000_REALK, &
      2.050743333120071_REALK,      0.000000000000000_REALK,      3.306994053594782_REALK, &
      1.529716830124717_REALK,      0.000000000000000_REALK,      1.173303427983043_REALK, &
      0.000000000000000_REALK,      2.959979076728517_REALK,      0.000000000000000_REALK, &
      2.020017893758791_REALK,      0.000000000000000_REALK,      4.295415499147782_REALK, &
      3.655678869303805_REALK,      1.443479611873005_REALK,      0.000000000000000_REALK, &
      1.017343527773758_REALK,      0.000000000000000_REALK,      0.985608431556380_REALK, &
     -0.071398951949744_REALK,      0.000000000000000_REALK,      0.356577805143891_REALK, &
      0.000000000000000_REALK,     -2.290080496137787_REALK,      0.000000000000000_REALK, &
      0.352771149055396_REALK,      0.000000000000000_REALK,     -4.937969405406972_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.819667664217444_REALK, &
      0.000000000000000_REALK,     -2.666861230118344_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.807890639561933_REALK,      0.000000000000000_REALK, &
     -4.642775351410659_REALK,      0.000000000000000_REALK,     -5.380927731369615_REALK, &
      0.000000000000000_REALK,     -4.678334647088954_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -5.282818041655046_REALK, &
      0.000000000000000_REALK,     -4.390270931794375_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -5.404906903038664_REALK,      0.000000000000000_REALK, &
     -1.856330013008660_REALK,      0.000000000000000_REALK,    -10.475910844356815_REALK, &
      0.000000000000000_REALK,     -2.165522179259488_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     28.603262281537578_REALK, &
      0.000000000000000_REALK,     -3.691004292930422_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      4.570159220341038_REALK,      0.000000000000000_REALK, &
     17.055125402755568_REALK,      0.000000000000000_REALK,     -3.048186309302981_REALK, &
      0.000000000000000_REALK,     -3.652868820549558_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     58.242868377715425_REALK, &
      0.000000000000000_REALK,     -8.013561664549341_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      6.250262332117493_REALK,      0.000000000000000_REALK, &
     27.407341925148941_REALK,      0.000000000000000_REALK,     -5.212615519884456_REALK, &
      0.000000000000000_REALK,     -5.494702088688609_REALK,      0.000000000000000_REALK, &
     46.140018725283639_REALK,     -1.711571880647155_REALK,      0.000000000000000_REALK, &
      5.349929302889438_REALK,      0.000000000000000_REALK,      0.427839474639156_REALK, &
     -1.038142047130074_REALK,      0.000000000000000_REALK,     -0.020098368321487_REALK, &
      0.000000000000000_REALK,      3.966778873944783_REALK,      0.000000000000000_REALK, &
      0.104271081599395_REALK,      0.000000000000000_REALK,     -6.319921156955286_REALK, &
     54.363580970309378_REALK,     -2.135683480002585_REALK,      0.000000000000000_REALK, &
      4.925712710583966_REALK,      0.000000000000000_REALK,     -8.719346297380254_REALK, &
      0.027578505591138_REALK,      0.000000000000000_REALK,      0.425440038621845_REALK, &
      0.000000000000000_REALK,      4.632810681434027_REALK,      0.000000000000000_REALK, &
     -1.429765963876433_REALK,      0.000000000000000_REALK,    -16.664929939895874_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -7.883210222978841_REALK, &
      0.000000000000000_REALK,     -0.418025807283314_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.198246487973320_REALK,      0.000000000000000_REALK, &
     -1.808912504668341_REALK,      0.000000000000000_REALK,     -0.200392718655306_REALK, &
      0.000000000000000_REALK,     -0.159209040344163_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -6.115701075662538_REALK, &
      0.000000000000000_REALK,     -0.174112411294617_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.485404179128565_REALK,      0.000000000000000_REALK, &
      4.674335164663063_REALK,      0.000000000000000_REALK,      0.266858525856788_REALK, &
      0.000000000000000_REALK,      0.193908896465505_REALK,      0.000000000000000_REALK, &
     13.577836474822535_REALK,      1.925882842483814_REALK,      0.000000000000000_REALK, &
      1.988177585953375_REALK,      0.000000000000000_REALK,      4.387928265536995_REALK, &
      0.874064529949689_REALK,      0.000000000000000_REALK,      0.788172687688949_REALK, &
      0.000000000000000_REALK,      1.722263186915964_REALK,      0.000000000000000_REALK, &
      1.350507088722829_REALK,      0.000000000000000_REALK,      3.930330498956179_REALK, &
     28.153944490788799_REALK,      4.259099134771568_REALK,      0.000000000000000_REALK, &
      3.653366690299654_REALK,      0.000000000000000_REALK,      2.595663500803065_REALK, &
      2.421397940066253_REALK,      0.000000000000000_REALK,      0.487699701841256_REALK, &
      0.000000000000000_REALK,      4.452215668766012_REALK,      0.000000000000000_REALK, &
      0.609568352060083_REALK,      0.000000000000000_REALK,     -6.257431268279476_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -6.418784700305595_REALK, &
      0.000000000000000_REALK,     -1.837575094995215_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.629004261182363_REALK,      0.000000000000000_REALK, &
     -4.678334647088953_REALK,      0.000000000000000_REALK,     -1.627374461151853_REALK, &
      0.000000000000000_REALK,     -2.222970754208198_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,    -13.294806297120488_REALK, &
      0.000000000000000_REALK,     -3.102032350619078_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.571375479030702_REALK,      0.000000000000000_REALK, &
     -2.165522179259488_REALK,      0.000000000000000_REALK,      0.103636562222921_REALK, &
      0.000000000000000_REALK,     -0.736243289846043_REALK,      0.000000000000000_REALK, &
     10.441036558855576_REALK,      4.277863330953822_REALK,      0.000000000000000_REALK, &
      3.634310583128717_REALK,      0.000000000000000_REALK,      6.651611141368908_REALK, &
      3.586173162568094_REALK,      0.000000000000000_REALK,      3.451220547148150_REALK, &
      0.000000000000000_REALK,      6.373471261569045_REALK,      0.000000000000000_REALK, &
      4.866514525600905_REALK,      0.000000000000000_REALK,     11.799513835596789_REALK, &
     54.757357196160896_REALK,     26.334145139729308_REALK,      0.000000000000000_REALK, &
     20.908868521539588_REALK,      0.000000000000000_REALK,     18.879254141152025_REALK, &
     20.750520953878652_REALK,      0.000000000000000_REALK,     11.276833788138577_REALK, &
      0.000000000000000_REALK,     30.403457771298079_REALK,      0.000000000000000_REALK, &
     13.046466129844347_REALK,      0.000000000000000_REALK,      5.089808587914938_REALK/
    ! results of test 4, ket-major order, 01 DPG X
  data REF_CONTR_INTS(17641:18900)                                                         &
     /7.805017388863392_REALK,     -0.170026926273168_REALK,      0.000000000000000_REALK, &
    -12.680827760531944_REALK,      0.000000000000000_REALK,     -1.993081438324823_REALK, &
    -38.413628702395279_REALK,      0.000000000000000_REALK,     -4.593600129266789_REALK, &
      0.000000000000000_REALK,   -172.773679987949890_REALK,      0.000000000000000_REALK, &
    -17.194699918043305_REALK,      0.000000000000000_REALK,     -8.107618341181508_REALK, &
     13.063143093845929_REALK,     11.765826913811200_REALK,      0.000000000000000_REALK, &
      4.550751188764806_REALK,      0.000000000000000_REALK,      0.548635587025146_REALK, &
    -18.791820289397837_REALK,      0.000000000000000_REALK,     -1.825393154181168_REALK, &
      0.000000000000000_REALK,   -164.771693692143003_REALK,      0.000000000000000_REALK, &
    -13.669970648608476_REALK,      0.000000000000000_REALK,     -4.944128162795565_REALK, &
      0.102372942633275_REALK,     -3.736470641393762_REALK,      0.000000000000000_REALK, &
     -7.827617014702936_REALK,      0.000000000000000_REALK,     -1.985864713142384_REALK, &
    -14.059996011369925_REALK,      0.000000000000000_REALK,     -2.685263882804727_REALK, &
      0.000000000000000_REALK,    -34.986617658128104_REALK,      0.000000000000000_REALK, &
     -5.882505439730667_REALK,      0.000000000000000_REALK,     -4.477171004542021_REALK, &
      9.207744812159429_REALK,      2.913312775199504_REALK,      0.000000000000000_REALK, &
     -0.022009567462359_REALK,      0.000000000000000_REALK,     -0.008966846343268_REALK, &
     -0.349806722543611_REALK,      0.000000000000000_REALK,     -0.628857244683579_REALK, &
      0.000000000000000_REALK,     11.344196548413695_REALK,      0.000000000000000_REALK, &
     -1.374106424660636_REALK,      0.000000000000000_REALK,     -1.679460696849549_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.089232587933147_REALK, &
      0.000000000000000_REALK,      2.403647442728137_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      4.980449968190334_REALK,      0.000000000000000_REALK, &
      2.348374074680093_REALK,      0.000000000000000_REALK,     15.105520103260616_REALK, &
      0.000000000000000_REALK,      5.419070374988030_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.944641821306012_REALK, &
      0.000000000000000_REALK,      0.026183732308549_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.481798977089821_REALK,      0.000000000000000_REALK, &
      1.259290222512285_REALK,      0.000000000000000_REALK,     16.828788321721191_REALK, &
      0.000000000000000_REALK,      4.904126559729603_REALK,      0.000000000000000_REALK, &
     -5.347712412890575_REALK,     -5.564454427391341_REALK,      0.000000000000000_REALK, &
     -6.885571538961359_REALK,      0.000000000000000_REALK,     -2.303678944444368_REALK, &
     -9.480377511317009_REALK,      0.000000000000000_REALK,     -2.122988919245155_REALK, &
      0.000000000000000_REALK,    -18.507924683731936_REALK,      0.000000000000000_REALK, &
     -3.309656729676116_REALK,      0.000000000000000_REALK,     -3.321897018287415_REALK, &
      1.470501567135901_REALK,     -0.365143978338122_REALK,      0.000000000000000_REALK, &
     -2.160224520963822_REALK,      0.000000000000000_REALK,     -0.541787268769439_REALK, &
     -5.811420423583645_REALK,      0.000000000000000_REALK,     -0.844193197819402_REALK, &
      0.000000000000000_REALK,    -19.493596150981521_REALK,      0.000000000000000_REALK, &
     -1.818406136920783_REALK,      0.000000000000000_REALK,     -1.368176249563639_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.528382153324420_REALK, &
      0.000000000000000_REALK,      1.695693296710009_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.298460290574556_REALK,      0.000000000000000_REALK, &
      1.749356608928659_REALK,      0.000000000000000_REALK,      4.267646980994707_REALK, &
      0.000000000000000_REALK,      2.445183830783138_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.106823986727387_REALK, &
      0.000000000000000_REALK,      0.437435887991608_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.606203259989318_REALK,      0.000000000000000_REALK, &
      0.740913899522424_REALK,      0.000000000000000_REALK,      0.204824776794169_REALK, &
      0.000000000000000_REALK,      1.104657542094423_REALK,      0.000000000000000_REALK, &
     -1.147499345078408_REALK,     -1.849920505680573_REALK,      0.000000000000000_REALK, &
     -3.145059850445273_REALK,      0.000000000000000_REALK,     -1.482953761863926_REALK, &
     -5.902151469563254_REALK,      0.000000000000000_REALK,     -2.117383179047130_REALK, &
      0.000000000000000_REALK,    -15.189897887045388_REALK,      0.000000000000000_REALK, &
     -4.535165355713010_REALK,      0.000000000000000_REALK,     -3.564023603545193_REALK, &
      0.792507926680643_REALK,     -0.311932486130046_REALK,      0.000000000000000_REALK, &
     -2.421954808070815_REALK,      0.000000000000000_REALK,     -0.875967862946361_REALK, &
     -7.424218502447553_REALK,      0.000000000000000_REALK,     -2.163513287293233_REALK, &
      0.000000000000000_REALK,    -24.573841680049199_REALK,      0.000000000000000_REALK, &
     -6.116166320122782_REALK,      0.000000000000000_REALK,     -3.686805057227016_REALK, &
    -12.557807161028492_REALK,     -7.392313676309692_REALK,      0.000000000000000_REALK, &
     -6.504382690836303_REALK,      0.000000000000000_REALK,     -2.981242514174532_REALK, &
     -6.541263510951516_REALK,      0.000000000000000_REALK,     -1.893301471411796_REALK, &
      0.000000000000000_REALK,     -8.828427610593288_REALK,      0.000000000000000_REALK, &
     -2.147111441737510_REALK,      0.000000000000000_REALK,     -2.952344696044670_REALK, &
      1.727412946815125_REALK,     -0.768246611792477_REALK,      0.000000000000000_REALK, &
     -1.095760438020173_REALK,      0.000000000000000_REALK,     -0.772195846023685_REALK, &
      0.060482464704774_REALK,      0.000000000000000_REALK,     -0.618417996075869_REALK, &
      0.000000000000000_REALK,      5.534243296831104_REALK,      0.000000000000000_REALK, &
     -0.547126576284852_REALK,      0.000000000000000_REALK,     -1.156700465166489_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.218790490809758_REALK, &
      0.000000000000000_REALK,      1.629644746189903_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.698531961162112_REALK,      0.000000000000000_REALK, &
      1.704813736922637_REALK,      0.000000000000000_REALK,      2.402256325879580_REALK, &
      0.000000000000000_REALK,      1.613848252859430_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.350671724469826_REALK, &
      0.000000000000000_REALK,      0.684607531552125_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.125517651985260_REALK,      0.000000000000000_REALK, &
      0.846844106299863_REALK,      0.000000000000000_REALK,      2.353175477680615_REALK, &
      0.000000000000000_REALK,      1.025498718078492_REALK,      0.000000000000000_REALK, &
     -1.885466465840294_REALK,     -1.633208555881245_REALK,      0.000000000000000_REALK, &
     -1.764339748976526_REALK,      0.000000000000000_REALK,     -1.342837817527003_REALK, &
     -2.190177226290737_REALK,      0.000000000000000_REALK,     -1.254880256995234_REALK, &
      0.000000000000000_REALK,     -3.463939840272572_REALK,      0.000000000000000_REALK, &
     -1.747237628319519_REALK,      0.000000000000000_REALK,     -2.216369007986015_REALK, &
      0.448038176388141_REALK,     -0.283130309679325_REALK,      0.000000000000000_REALK, &
     -0.491607037953084_REALK,      0.000000000000000_REALK,     -0.600852076461790_REALK, &
     -0.126778004739995_REALK,      0.000000000000000_REALK,     -0.683737003401945_REALK, &
      0.000000000000000_REALK,      2.026486236604310_REALK,      0.000000000000000_REALK, &
     -0.736396203641338_REALK,      0.000000000000000_REALK,     -1.500063919273070_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.428308277535546_REALK, &
      0.000000000000000_REALK,      1.625341678482199_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.327468959775632_REALK,      0.000000000000000_REALK, &
      1.829074280325767_REALK,      0.000000000000000_REALK,      4.486682314221933_REALK, &
      0.000000000000000_REALK,      2.682644826171257_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.566970061473095_REALK, &
      0.000000000000000_REALK,      1.754524313770778_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.785652179679051_REALK,      0.000000000000000_REALK, &
      2.281978754407551_REALK,      0.000000000000000_REALK,      9.018701615531549_REALK, &
      0.000000000000000_REALK,      4.380277145871286_REALK,      0.000000000000000_REALK, &
    -28.260375574444783_REALK,    -10.792658439727459_REALK,      0.000000000000000_REALK, &
     -7.471011351952328_REALK,      0.000000000000000_REALK,     -4.483244146658742_REALK, &
     -5.851034956099647_REALK,      0.000000000000000_REALK,     -1.968300452812192_REALK, &
      0.000000000000000_REALK,     -6.482732366426599_REALK,      0.000000000000000_REALK, &
     -1.742579949946998_REALK,      0.000000000000000_REALK,     -3.137089876851768_REALK, &
     -6.949861453881020_REALK,     -4.339032616268588_REALK,      0.000000000000000_REALK, &
     -4.079964242261570_REALK,      0.000000000000000_REALK,     -1.929464211068729_REALK, &
     -5.251160215524677_REALK,      0.000000000000000_REALK,     -1.021696115875434_REALK, &
      0.000000000000000_REALK,    -10.810830607119524_REALK,      0.000000000000000_REALK, &
     -1.054499067986790_REALK,      0.000000000000000_REALK,     -1.496055914812157_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.632514696792199_REALK, &
      0.000000000000000_REALK,      1.814659994102104_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.445370275437685_REALK,      0.000000000000000_REALK, &
      1.987428870043138_REALK,      0.000000000000000_REALK,      1.462347051251969_REALK, &
      0.000000000000000_REALK,      1.269783958044818_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.598725616803369_REALK, &
      0.000000000000000_REALK,      0.884757297583780_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.534184050433128_REALK,      0.000000000000000_REALK, &
      1.129338194127175_REALK,      0.000000000000000_REALK,     -0.022364611499109_REALK, &
      0.000000000000000_REALK,      0.686017590080237_REALK,      0.000000000000000_REALK, &
     -3.433339207317715_REALK,     -1.985651439941345_REALK,      0.000000000000000_REALK, &
     -1.627980564725542_REALK,      0.000000000000000_REALK,     -1.634001416310284_REALK, &
     -1.617126069897293_REALK,      0.000000000000000_REALK,     -1.086393676828642_REALK, &
      0.000000000000000_REALK,     -2.123426846157927_REALK,      0.000000000000000_REALK, &
     -1.139157534643332_REALK,      0.000000000000000_REALK,     -1.905617574455446_REALK, &
     -1.454667273930131_REALK,     -1.417386021674263_REALK,      0.000000000000000_REALK, &
     -1.610253845250570_REALK,      0.000000000000000_REALK,     -1.211561609977304_REALK, &
     -2.297510050750838_REALK,      0.000000000000000_REALK,     -1.001240083523093_REALK, &
      0.000000000000000_REALK,     -4.461544863294285_REALK,      0.000000000000000_REALK, &
     -1.248548574115181_REALK,      0.000000000000000_REALK,     -1.565688462776157_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.636189637167381_REALK, &
      0.000000000000000_REALK,      1.202756684100484_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.176187357119961_REALK,      0.000000000000000_REALK, &
      1.491992367639728_REALK,      0.000000000000000_REALK,      1.468890163142006_REALK, &
      0.000000000000000_REALK,      1.402688058980486_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.243981836337794_REALK, &
      0.000000000000000_REALK,      0.978207793477150_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.718976419416166_REALK,      0.000000000000000_REALK, &
      1.464579230910350_REALK,      0.000000000000000_REALK,      0.140636174624262_REALK, &
      0.000000000000000_REALK,      1.264127753662966_REALK,      0.000000000000000_REALK, &
     -2.210153157637489_REALK,     -1.980408338578337_REALK,      0.000000000000000_REALK, &
     -2.230793601860908_REALK,      0.000000000000000_REALK,     -1.753100587976223_REALK, &
     -3.020298400096340_REALK,      0.000000000000000_REALK,     -1.805875100813074_REALK, &
      0.000000000000000_REALK,     -5.228242093307339_REALK,      0.000000000000000_REALK, &
     -2.601613101589670_REALK,      0.000000000000000_REALK,     -2.862320044306375_REALK, &
     -2.351922713386695_REALK,     -3.632502013800858_REALK,      0.000000000000000_REALK, &
     -5.416050977394376_REALK,      0.000000000000000_REALK,     -3.264777818085244_REALK, &
     -8.805360162442952_REALK,      0.000000000000000_REALK,     -4.276659714996135_REALK, &
      0.000000000000000_REALK,    -16.872817555550441_REALK,      0.000000000000000_REALK, &
     -6.999106326316131_REALK,      0.000000000000000_REALK,     -5.906653767907908_REALK, &
    -72.433927843658736_REALK,    -18.125197657475209_REALK,      0.000000000000000_REALK, &
    -10.307137498301945_REALK,      0.000000000000000_REALK,     -8.123691295986774_REALK, &
     -5.885739307859820_REALK,      0.000000000000000_REALK,     -2.377324733553372_REALK, &
      0.000000000000000_REALK,     -4.975834133999402_REALK,      0.000000000000000_REALK, &
     -1.699174512315816_REALK,      0.000000000000000_REALK,     -4.017672956726339_REALK, &
    -67.280560918585394_REALK,    -13.716128371226516_REALK,      0.000000000000000_REALK, &
     -4.810142575386091_REALK,      0.000000000000000_REALK,     -5.929714414110885_REALK, &
      1.096207295845293_REALK,      0.000000000000000_REALK,     -1.516578073455032_REALK, &
      0.000000000000000_REALK,      8.372728857349754_REALK,      0.000000000000000_REALK, &
     -0.675192135035819_REALK,      0.000000000000000_REALK,     -2.497034010532321_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      7.228959789401594_REALK, &
      0.000000000000000_REALK,      2.473139685340303_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.580041786464390_REALK,      0.000000000000000_REALK, &
      2.844479585267226_REALK,      0.000000000000000_REALK,      1.211964397333547_REALK, &
      0.000000000000000_REALK,      1.223122109146009_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      7.438118652126758_REALK, &
      0.000000000000000_REALK,      2.554826161307339_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.739065593790115_REALK,      0.000000000000000_REALK, &
      2.467275170572850_REALK,      0.000000000000000_REALK,      1.843165389803476_REALK, &
      0.000000000000000_REALK,      1.075850769575168_REALK,      0.000000000000000_REALK, &
     -7.421919132057278_REALK,     -2.926029388467827_REALK,      0.000000000000000_REALK, &
     -1.816085843545380_REALK,      0.000000000000000_REALK,     -2.497174251660709_REALK, &
     -1.325947453579602_REALK,      0.000000000000000_REALK,     -1.151345574447807_REALK, &
      0.000000000000000_REALK,     -1.231019868863307_REALK,      0.000000000000000_REALK, &
     -0.898167928206524_REALK,      0.000000000000000_REALK,     -2.058347839995457_REALK, &
    -10.680662694702242_REALK,     -3.410755027230078_REALK,      0.000000000000000_REALK, &
     -1.335766443459853_REALK,      0.000000000000000_REALK,     -2.823993082177349_REALK, &
      0.036883414653781_REALK,      0.000000000000000_REALK,     -1.131370926596491_REALK, &
      0.000000000000000_REALK,      1.896576615444875_REALK,      0.000000000000000_REALK, &
     -0.562498293595675_REALK,      0.000000000000000_REALK,     -1.981997299039168_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.634728368102729_REALK, &
      0.000000000000000_REALK,      1.365037188417518_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.032903257125715_REALK,      0.000000000000000_REALK, &
      1.727872168362834_REALK,      0.000000000000000_REALK,      1.004898742233080_REALK, &
      0.000000000000000_REALK,      1.125160307264944_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.670591430343926_REALK, &
      0.000000000000000_REALK,      2.503674350315546_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.059089413483124_REALK,      0.000000000000000_REALK, &
      2.582112226430399_REALK,      0.000000000000000_REALK,      2.419288786361925_REALK, &
      0.000000000000000_REALK,      1.757184120356645_REALK,      0.000000000000000_REALK, &
     -3.343046948300104_REALK,     -1.939372343189548_REALK,      0.000000000000000_REALK, &
     -1.477861586696722_REALK,      0.000000000000000_REALK,     -1.874665795744104_REALK, &
     -1.331880260392905_REALK,      0.000000000000000_REALK,     -1.271853120214774_REALK, &
      0.000000000000000_REALK,     -1.449016389783650_REALK,      0.000000000000000_REALK, &
     -1.218158165280797_REALK,      0.000000000000000_REALK,     -2.163325208220405_REALK, &
     -8.310713391098689_REALK,     -3.771008341371600_REALK,      0.000000000000000_REALK, &
     -1.797853331480658_REALK,      0.000000000000000_REALK,     -3.662287911539189_REALK, &
     -0.231935276147988_REALK,      0.000000000000000_REALK,     -2.084782385581009_REALK, &
      0.000000000000000_REALK,      2.083421093936369_REALK,      0.000000000000000_REALK, &
     -1.261809198312849_REALK,      0.000000000000000_REALK,     -3.598487090035324_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.826768572642061_REALK, &
      0.000000000000000_REALK,      2.269054692441754_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.358949104659406_REALK,      0.000000000000000_REALK, &
      2.595338754113539_REALK,      0.000000000000000_REALK,      3.128074056730943_REALK, &
      0.000000000000000_REALK,      2.618441764998253_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     12.585776219346805_REALK, &
      0.000000000000000_REALK,     10.694101654207946_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     11.542831443761504_REALK,      0.000000000000000_REALK, &
      9.741173467142479_REALK,      0.000000000000000_REALK,     15.453475451184220_REALK, &
      0.000000000000000_REALK,     10.507799406196661_REALK,      0.000000000000000_REALK, &
    -13.043257158127945_REALK,     48.236594928691190_REALK,      0.000000000000000_REALK, &
    -12.701234578698482_REALK,      0.000000000000000_REALK,     -5.726945319367743_REALK, &
     88.295764690638904_REALK,      0.000000000000000_REALK,     20.934067274057689_REALK, &
      0.000000000000000_REALK,   -123.493613184668604_REALK,      0.000000000000000_REALK, &
    -23.230511674524848_REALK,      0.000000000000000_REALK,    -31.423686243240127_REALK, &
    -18.874051461878516_REALK,     41.025680183657933_REALK,      0.000000000000000_REALK, &
    -13.167072793436986_REALK,      0.000000000000000_REALK,     -4.354903050136526_REALK, &
    109.783711800423987_REALK,      0.000000000000000_REALK,     21.854005029594813_REALK, &
      0.000000000000000_REALK,   -141.137181759495746_REALK,      0.000000000000000_REALK, &
    -22.184329508475439_REALK,      0.000000000000000_REALK,    -22.011863781108925_REALK, &
      3.238562720918497_REALK,     14.703205621526282_REALK,      0.000000000000000_REALK, &
     -3.015653313755370_REALK,      0.000000000000000_REALK,     -2.361729176738534_REALK, &
     15.323270501120458_REALK,      0.000000000000000_REALK,      5.707912928468475_REALK, &
      0.000000000000000_REALK,    -34.241380819169891_REALK,      0.000000000000000_REALK, &
    -11.348655734952489_REALK,      0.000000000000000_REALK,    -26.663328218542631_REALK, &
      6.301565218788764_REALK,      7.292943930281645_REALK,      0.000000000000000_REALK, &
      0.004593487369285_REALK,      0.000000000000000_REALK,      0.006096035351851_REALK, &
     -0.461869455847524_REALK,      0.000000000000000_REALK,      3.159729318308602_REALK, &
      0.000000000000000_REALK,     13.801291029790452_REALK,      0.000000000000000_REALK, &
     -2.912260316648412_REALK,      0.000000000000000_REALK,    -11.594616736811270_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -9.255805840659233_REALK, &
      0.000000000000000_REALK,      1.111097971550952_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -7.968974646847097_REALK,      0.000000000000000_REALK, &
    -10.779554169591075_REALK,      0.000000000000000_REALK,     17.636062146564182_REALK, &
      0.000000000000000_REALK,     12.544016557957692_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -9.316056276028430_REALK, &
      0.000000000000000_REALK,     -0.006918954151233_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,    -12.203653103872592_REALK,      0.000000000000000_REALK, &
    -12.108779291784472_REALK,      0.000000000000000_REALK,     22.036112971398577_REALK, &
      0.000000000000000_REALK,     13.159802555732247_REALK,      0.000000000000000_REALK, &
      6.398768536133870_REALK,      4.477713431068178_REALK,      0.000000000000000_REALK, &
     -2.041798664963326_REALK,      0.000000000000000_REALK,     -2.188486327983763_REALK, &
      2.931452855176155_REALK,      0.000000000000000_REALK,      1.283770451620532_REALK, &
      0.000000000000000_REALK,    -20.492397730358267_REALK,      0.000000000000000_REALK, &
     -7.803989967440889_REALK,      0.000000000000000_REALK,    -25.093941396675760_REALK, &
      2.697355254793298_REALK,      2.738151342884074_REALK,      0.000000000000000_REALK, &
      0.256413692643900_REALK,      0.000000000000000_REALK,      0.249553982727096_REALK, &
      3.775651008798580_REALK,      0.000000000000000_REALK,      1.041708800070212_REALK, &
      0.000000000000000_REALK,    -18.735288867076989_REALK,      0.000000000000000_REALK, &
     -3.513781707197207_REALK,      0.000000000000000_REALK,    -10.259337679159650_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.228254045861600_REALK, &
      0.000000000000000_REALK,      0.534668589327041_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.547902032262563_REALK,      0.000000000000000_REALK, &
     -3.636749664478096_REALK,      0.000000000000000_REALK,      5.486085686834993_REALK, &
      0.000000000000000_REALK,      6.130695026811981_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.983293243665060_REALK, &
      0.000000000000000_REALK,     -0.075992109681376_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.855223997123833_REALK,      0.000000000000000_REALK, &
     -3.404913501065899_REALK,      0.000000000000000_REALK,     -0.152219898749392_REALK, &
      0.000000000000000_REALK,      3.124088446328452_REALK,      0.000000000000000_REALK, &
      0.984100469044745_REALK,      1.989222362932700_REALK,      0.000000000000000_REALK, &
     -0.746465562143031_REALK,      0.000000000000000_REALK,     -1.009736674973443_REALK, &
      2.405474011666267_REALK,      0.000000000000000_REALK,      1.710943496417485_REALK, &
      0.000000000000000_REALK,    -15.166985976046877_REALK,      0.000000000000000_REALK, &
     -8.559232393428422_REALK,      0.000000000000000_REALK,    -19.296650096965866_REALK, &
      1.049231628768620_REALK,      3.386015333119091_REALK,      0.000000000000000_REALK, &
      0.293500250103503_REALK,      0.000000000000000_REALK,      0.291218516319436_REALK, &
      6.471197821409257_REALK,      0.000000000000000_REALK,      3.864551145629093_REALK, &
      0.000000000000000_REALK,    -25.588049020146546_REALK,      0.000000000000000_REALK, &
    -12.065999275285114_REALK,      0.000000000000000_REALK,    -19.953659355887929_REALK, &
      2.579240956474114_REALK,      0.516350795491966_REALK,      0.000000000000000_REALK, &
     -2.987761645273176_REALK,      0.000000000000000_REALK,     -3.906798254724833_REALK, &
     -0.048970865697515_REALK,      0.000000000000000_REALK,     -0.033699791184234_REALK, &
      0.000000000000000_REALK,    -14.242765582860272_REALK,      0.000000000000000_REALK, &
     -6.632850300240263_REALK,      0.000000000000000_REALK,    -26.019352666059596_REALK, &
     11.013984071332118_REALK,      0.405910120497252_REALK,      0.000000000000000_REALK, &
      0.099199480715119_REALK,      0.000000000000000_REALK,      0.196044672727278_REALK, &
     -0.327394473888738_REALK,      0.000000000000000_REALK,      0.048822195463411_REALK, &
      0.000000000000000_REALK,      4.797471993370802_REALK,      0.000000000000000_REALK, &
     -1.743411860325397_REALK,      0.000000000000000_REALK,    -10.336342643805494_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.342046527985763_REALK, &
      0.000000000000000_REALK,      0.486617207275051_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.081718241028114_REALK,      0.000000000000000_REALK, &
      0.262767220351945_REALK,      0.000000000000000_REALK,      2.466818793733032_REALK, &
      0.000000000000000_REALK,      3.240880102818201_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.390096003354095_REALK, &
      0.000000000000000_REALK,     -0.039366353098413_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.295378906815717_REALK,      0.000000000000000_REALK, &
     -0.862430338833053_REALK,      0.000000000000000_REALK,      2.507617504348528_REALK, &
      0.000000000000000_REALK,      2.075568331450085_REALK,      0.000000000000000_REALK, &
      0.303363391352781_REALK,      0.327875077287083_REALK,      0.000000000000000_REALK, &
     -0.586737109523092_REALK,      0.000000000000000_REALK,     -1.378521341609689_REALK, &
     -0.057446674627733_REALK,      0.000000000000000_REALK,     -0.064196598914281_REALK, &
      0.000000000000000_REALK,     -3.930109518535428_REALK,      0.000000000000000_REALK, &
     -3.907680606871016_REALK,      0.000000000000000_REALK,    -15.301631756751840_REALK, &
      2.409645072406975_REALK,      0.727812217825932_REALK,      0.000000000000000_REALK, &
      0.032319060611511_REALK,      0.000000000000000_REALK,      0.128672261522107_REALK, &
     -0.012796055940555_REALK,      0.000000000000000_REALK,      0.262620136072192_REALK, &
      0.000000000000000_REALK,      2.691775574881464_REALK,      0.000000000000000_REALK, &
     -1.704003887273242_REALK,      0.000000000000000_REALK,    -11.306951670279455_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.619201308914027_REALK, &
      0.000000000000000_REALK,      0.648538486752917_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.089626642097182_REALK,      0.000000000000000_REALK, &
      0.202061805594059_REALK,      0.000000000000000_REALK,      6.072622136157291_REALK, &
      0.000000000000000_REALK,      7.198798310069246_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.789136860696636_REALK, &
      0.000000000000000_REALK,     -0.146042046448546_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.014303668401709_REALK,      0.000000000000000_REALK, &
     -1.677363757527407_REALK,      0.000000000000000_REALK,     12.893635211453091_REALK, &
      0.000000000000000_REALK,     12.833304874638443_REALK,      0.000000000000000_REALK, &
    -14.622454495891928_REALK,      0.700118007633770_REALK,      0.000000000000000_REALK, &
     -6.274938989715285_REALK,      0.000000000000000_REALK,     -8.493657663028021_REALK, &
      1.304599877551695_REALK,      0.000000000000000_REALK,      0.427497706229820_REALK, &
      0.000000000000000_REALK,    -16.685091207728430_REALK,      0.000000000000000_REALK, &
     -7.423469145639359_REALK,      0.000000000000000_REALK,    -30.144869471299526_REALK, &
      0.105441475736005_REALK,      0.048410754733337_REALK,      0.000000000000000_REALK, &
     -1.717991632657868_REALK,      0.000000000000000_REALK,     -2.394623991730223_REALK, &
     -0.015322393646088_REALK,      0.000000000000000_REALK,      0.186121130902680_REALK, &
      0.000000000000000_REALK,    -13.374376431184595_REALK,      0.000000000000000_REALK, &
     -3.250089948390568_REALK,      0.000000000000000_REALK,    -13.590421311290291_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.108231207682084_REALK, &
      0.000000000000000_REALK,      0.320555758593651_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.984477378268546_REALK,      0.000000000000000_REALK, &
      3.861908973884001_REALK,      0.000000000000000_REALK,      0.551076073028859_REALK, &
      0.000000000000000_REALK,      1.137685539545760_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.160262281481209_REALK, &
      0.000000000000000_REALK,      0.070203991075908_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.311773719126440_REALK,      0.000000000000000_REALK, &
      1.848444456276087_REALK,      0.000000000000000_REALK,     -0.890615354241832_REALK, &
      0.000000000000000_REALK,      0.398434919114911_REALK,      0.000000000000000_REALK, &
     -1.434339079833376_REALK,     -0.262593949234940_REALK,      0.000000000000000_REALK, &
     -0.777312019546306_REALK,      0.000000000000000_REALK,     -2.499467880764473_REALK, &
     -0.366136304724065_REALK,      0.000000000000000_REALK,     -0.481025954526606_REALK, &
      0.000000000000000_REALK,     -2.414731555129442_REALK,      0.000000000000000_REALK, &
     -2.758760747998176_REALK,      0.000000000000000_REALK,    -14.784783345131411_REALK, &
      0.018202096586927_REALK,     -0.032181142559906_REALK,      0.000000000000000_REALK, &
     -0.424740795477810_REALK,      0.000000000000000_REALK,     -1.240133739098315_REALK, &
     -0.448436340986795_REALK,      0.000000000000000_REALK,     -0.371173142000121_REALK, &
      0.000000000000000_REALK,     -4.284339997280969_REALK,      0.000000000000000_REALK, &
     -2.410568998962209_REALK,      0.000000000000000_REALK,    -11.730401136668736_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.743893470650180_REALK, &
      0.000000000000000_REALK,      0.610644420661194_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.579995474769552_REALK,      0.000000000000000_REALK, &
      2.271136786333337_REALK,      0.000000000000000_REALK,      1.939366646566570_REALK, &
      0.000000000000000_REALK,      3.612067004288817_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.105186791908222_REALK, &
      0.000000000000000_REALK,      0.377635243850994_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.304726405407115_REALK,      0.000000000000000_REALK, &
      2.022018121161560_REALK,      0.000000000000000_REALK,     -0.104427821511752_REALK, &
      0.000000000000000_REALK,      3.572044493311453_REALK,      0.000000000000000_REALK, &
     -0.661783788519133_REALK,     -0.349971764091441_REALK,      0.000000000000000_REALK, &
     -0.852537515458102_REALK,      0.000000000000000_REALK,     -1.922031950313956_REALK, &
     -0.901325802514058_REALK,      0.000000000000000_REALK,     -1.068477919172139_REALK, &
      0.000000000000000_REALK,     -5.361627289466894_REALK,      0.000000000000000_REALK, &
     -5.042906354847614_REALK,      0.000000000000000_REALK,    -15.916810398367334_REALK, &
      0.021241045740971_REALK,     -0.119386215551941_REALK,      0.000000000000000_REALK, &
     -1.458520351427068_REALK,      0.000000000000000_REALK,     -2.411969169898526_REALK, &
     -2.305764171057128_REALK,      0.000000000000000_REALK,     -2.294975318512932_REALK, &
      0.000000000000000_REALK,    -17.554237244035143_REALK,      0.000000000000000_REALK, &
    -13.796115893657007_REALK,      0.000000000000000_REALK,    -31.940677848070713_REALK, &
    -76.932989074321185_REALK,     10.493857457267113_REALK,      0.000000000000000_REALK, &
    -16.288701362836548_REALK,      0.000000000000000_REALK,    -20.262302398185163_REALK, &
      8.394267776431033_REALK,      0.000000000000000_REALK,      3.353158886459320_REALK, &
      0.000000000000000_REALK,    -26.443791200788624_REALK,      0.000000000000000_REALK, &
    -10.640035731571464_REALK,      0.000000000000000_REALK,    -39.706963136879445_REALK, &
    -54.852023764542167_REALK,      8.413946054903008_REALK,      0.000000000000000_REALK, &
     -8.497953259782818_REALK,      0.000000000000000_REALK,    -12.421148546997424_REALK, &
      7.477662265506336_REALK,      0.000000000000000_REALK,      2.627441464657549_REALK, &
      0.000000000000000_REALK,     -4.117042392978672_REALK,      0.000000000000000_REALK, &
     -5.175858478403149_REALK,      0.000000000000000_REALK,    -22.696091065623708_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      9.686037774694951_REALK, &
      0.000000000000000_REALK,     -0.570414591964298_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.286545696426210_REALK,      0.000000000000000_REALK, &
      9.285095715581809_REALK,      0.000000000000000_REALK,     -1.137079413461499_REALK, &
      0.000000000000000_REALK,     -1.117811329175167_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.181868200336359_REALK, &
      0.000000000000000_REALK,     -0.516950386757141_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.833029778421974_REALK,      0.000000000000000_REALK, &
      7.664910005715956_REALK,      0.000000000000000_REALK,      0.025920767250379_REALK, &
      0.000000000000000_REALK,     -0.944578756936744_REALK,      0.000000000000000_REALK, &
     -6.521709204953400_REALK,     -0.365556902552061_REALK,      0.000000000000000_REALK, &
     -1.313598304364336_REALK,      0.000000000000000_REALK,     -5.152984915332024_REALK, &
     -0.169740130721466_REALK,      0.000000000000000_REALK,     -0.350425107628118_REALK, &
      0.000000000000000_REALK,     -1.842524771582911_REALK,      0.000000000000000_REALK, &
     -2.574189172733588_REALK,      0.000000000000000_REALK,    -16.830053667898309_REALK, &
     -7.557344711467164_REALK,     -0.239870561768506_REALK,      0.000000000000000_REALK, &
     -0.865949738761256_REALK,      0.000000000000000_REALK,     -5.134044006377011_REALK, &
      0.502301318230756_REALK,      0.000000000000000_REALK,     -0.224714725776265_REALK, &
      0.000000000000000_REALK,      1.451353459613150_REALK,      0.000000000000000_REALK, &
     -1.582275105624546_REALK,      0.000000000000000_REALK,    -15.634991383549012_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.850355084960003_REALK, &
      0.000000000000000_REALK,      0.641837884921946_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.849741864894825_REALK,      0.000000000000000_REALK, &
      4.553946688154857_REALK,      0.000000000000000_REALK,      0.957364924954402_REALK, &
      0.000000000000000_REALK,      2.096292969379025_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.237245947227545_REALK, &
      0.000000000000000_REALK,      1.030931299311498_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.359545375113903_REALK,      0.000000000000000_REALK, &
      6.615870618287523_REALK,      0.000000000000000_REALK,      2.275848204232404_REALK, &
      0.000000000000000_REALK,      3.139552750569590_REALK,      0.000000000000000_REALK, &
     -2.301197742148021_REALK,     -0.696369592475714_REALK,      0.000000000000000_REALK, &
     -0.773893935009694_REALK,      0.000000000000000_REALK,     -3.030401203076844_REALK, &
     -0.597355545298410_REALK,      0.000000000000000_REALK,     -1.112573663583049_REALK, &
      0.000000000000000_REALK,     -1.525263636645719_REALK,      0.000000000000000_REALK, &
     -2.527598406259827_REALK,      0.000000000000000_REALK,    -13.856539852041262_REALK, &
     -4.960199232138142_REALK,     -1.290291003373029_REALK,      0.000000000000000_REALK, &
     -0.846375864826927_REALK,      0.000000000000000_REALK,     -5.616143877349305_REALK, &
      0.058896618114082_REALK,      0.000000000000000_REALK,     -2.014610066201554_REALK, &
      0.000000000000000_REALK,      2.442985262970622_REALK,      0.000000000000000_REALK, &
     -2.577515762891006_REALK,      0.000000000000000_REALK,    -23.944419921388533_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.191855948697914_REALK, &
      0.000000000000000_REALK,      1.425681091163067_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.553294773230189_REALK,      0.000000000000000_REALK, &
      4.902628892665012_REALK,      0.000000000000000_REALK,      3.927943856562984_REALK, &
      0.000000000000000_REALK,      6.518941068246983_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.241132603505505_REALK, &
      0.000000000000000_REALK,      6.374280946765237_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      7.780920424112214_REALK,      0.000000000000000_REALK, &
     18.014336393209540_REALK,      0.000000000000000_REALK,     19.503211375689638_REALK, &
      0.000000000000000_REALK,     27.176736034456813_REALK,      0.000000000000000_REALK/
    ! results of test 4, ket-major order, 01 DPG Y
  data REF_CONTR_INTS(18901:20160)                                                         &
     /6.125010305613347_REALK,      1.526526627452819_REALK,      0.000000000000000_REALK, &
     -0.378040898133266_REALK,      0.000000000000000_REALK,     -0.186819708841098_REALK, &
     -0.625694281380857_REALK,      0.000000000000000_REALK,     -0.581725876772864_REALK, &
      0.000000000000000_REALK,      5.228858248575579_REALK,      0.000000000000000_REALK, &
     -1.225110290045886_REALK,      0.000000000000000_REALK,     -1.816269738127037_REALK, &
      4.015487146496454_REALK,     -2.404686710528524_REALK,      0.000000000000000_REALK, &
     -4.615081360686021_REALK,      0.000000000000000_REALK,      0.246210078173034_REALK, &
     -2.297448366986007_REALK,      0.000000000000000_REALK,     -0.054726487461306_REALK, &
      0.000000000000000_REALK,     29.796314817089719_REALK,      0.000000000000000_REALK, &
      1.222837649363857_REALK,      0.000000000000000_REALK,     -0.195711578873260_REALK, &
      3.597609631677719_REALK,      0.069458572728587_REALK,      0.000000000000000_REALK, &
     -1.411476390476078_REALK,      0.000000000000000_REALK,     -0.568640963971061_REALK, &
     -2.825410978087749_REALK,      0.000000000000000_REALK,     -0.721578005407454_REALK, &
      0.000000000000000_REALK,     -7.006234977351935_REALK,      0.000000000000000_REALK, &
     -1.323967309333940_REALK,      0.000000000000000_REALK,     -1.600158639830787_REALK, &
      4.012018007982169_REALK,      2.362453223479992_REALK,      0.000000000000000_REALK, &
      1.386429560163795_REALK,      0.000000000000000_REALK,      0.285573668679986_REALK, &
     -0.807617086034034_REALK,      0.000000000000000_REALK,     -0.079204755624388_REALK, &
      0.000000000000000_REALK,    -12.764922946676371_REALK,      0.000000000000000_REALK, &
     -0.790328084533787_REALK,      0.000000000000000_REALK,     -0.488370048604147_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.018242839451433_REALK, &
      0.000000000000000_REALK,      0.275109162523143_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.383500525517650_REALK,      0.000000000000000_REALK, &
      0.568553219014619_REALK,      0.000000000000000_REALK,      0.277557202373859_REALK, &
      0.000000000000000_REALK,      0.774158618882797_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.227425657817447_REALK, &
      0.000000000000000_REALK,      0.110981581569918_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.142922641869913_REALK,      0.000000000000000_REALK, &
      0.022874349601232_REALK,      0.000000000000000_REALK,     -2.655881540504323_REALK, &
      0.000000000000000_REALK,     -0.189793690139558_REALK,      0.000000000000000_REALK, &
      0.687919317305123_REALK,     -1.271453844675295_REALK,      0.000000000000000_REALK, &
     -1.836956443860142_REALK,      0.000000000000000_REALK,     -1.009169884293153_REALK, &
     -2.099410719243478_REALK,      0.000000000000000_REALK,     -0.739999993867358_REALK, &
      0.000000000000000_REALK,     -2.787885889093345_REALK,      0.000000000000000_REALK, &
     -0.922186877358269_REALK,      0.000000000000000_REALK,     -1.519867105337579_REALK, &
     10.003913794506699_REALK,      1.661402995575476_REALK,      0.000000000000000_REALK, &
     -0.041982854627732_REALK,      0.000000000000000_REALK,      0.306051183020202_REALK, &
      0.446378871204387_REALK,      0.000000000000000_REALK,     -0.048895339551035_REALK, &
      0.000000000000000_REALK,      6.345707767936749_REALK,      0.000000000000000_REALK, &
      0.017782502926040_REALK,      0.000000000000000_REALK,     -0.388898475758710_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.401431975673247_REALK, &
      0.000000000000000_REALK,      0.466020671086636_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.579933979137458_REALK,      0.000000000000000_REALK, &
      0.700913353906829_REALK,      0.000000000000000_REALK,      0.916059328049917_REALK, &
      0.000000000000000_REALK,      0.701853572342801_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.110613769937827_REALK, &
      0.000000000000000_REALK,     -0.286020214498008_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.158684745476271_REALK,      0.000000000000000_REALK, &
      0.098056589886589_REALK,      0.000000000000000_REALK,      1.235298436377402_REALK, &
      0.000000000000000_REALK,      0.363445173963312_REALK,      0.000000000000000_REALK, &
      0.083434368887774_REALK,     -0.194213258690062_REALK,      0.000000000000000_REALK, &
     -0.247678242580156_REALK,      0.000000000000000_REALK,     -0.367191836070511_REALK, &
     -0.121577664097999_REALK,      0.000000000000000_REALK,     -0.339102699263868_REALK, &
      0.000000000000000_REALK,      0.530688427688233_REALK,      0.000000000000000_REALK, &
     -0.373017486415646_REALK,      0.000000000000000_REALK,     -0.921686232216115_REALK, &
      0.900013134477735_REALK,     -0.431614277572459_REALK,      0.000000000000000_REALK, &
     -0.516115028220194_REALK,      0.000000000000000_REALK,      0.082602696364262_REALK, &
      0.533256877134342_REALK,      0.000000000000000_REALK,      0.038107418934206_REALK, &
      0.000000000000000_REALK,      5.326736101572913_REALK,      0.000000000000000_REALK, &
      0.655826080495000_REALK,      0.000000000000000_REALK,     -0.174938400785405_REALK, &
     -5.447888019187728_REALK,     -3.049745119143967_REALK,      0.000000000000000_REALK, &
     -2.643585626626974_REALK,      0.000000000000000_REALK,     -1.804407566462153_REALK, &
     -2.304244350402952_REALK,      0.000000000000000_REALK,     -0.848244779219342_REALK, &
      0.000000000000000_REALK,     -2.881996848028763_REALK,      0.000000000000000_REALK, &
     -0.825232648088093_REALK,      0.000000000000000_REALK,     -1.689814038142222_REALK, &
      2.286623802834840_REALK,      0.251800542158575_REALK,      0.000000000000000_REALK, &
     -0.576687243630558_REALK,      0.000000000000000_REALK,     -0.240184556331414_REALK, &
     -2.034142436527317_REALK,      0.000000000000000_REALK,     -0.273648215481434_REALK, &
      0.000000000000000_REALK,     -7.284996029720961_REALK,      0.000000000000000_REALK, &
     -0.478972632706933_REALK,      0.000000000000000_REALK,     -0.598462150249867_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.085455903245327_REALK, &
      0.000000000000000_REALK,      0.630338984087934_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.549546457116828_REALK,      0.000000000000000_REALK, &
      0.905714019070981_REALK,      0.000000000000000_REALK,      0.558242479420452_REALK, &
      0.000000000000000_REALK,      0.590307690955052_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.083071450373210_REALK, &
      0.000000000000000_REALK,      0.067796735520425_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.012384134357358_REALK,      0.000000000000000_REALK, &
      0.270837631530206_REALK,      0.000000000000000_REALK,     -0.514061762156444_REALK, &
      0.000000000000000_REALK,      0.168927514488026_REALK,      0.000000000000000_REALK, &
     -0.600867983008317_REALK,     -0.501248497738955_REALK,      0.000000000000000_REALK, &
     -0.493993240914949_REALK,      0.000000000000000_REALK,     -0.597044614995619_REALK, &
     -0.545894948842432_REALK,      0.000000000000000_REALK,     -0.418246185849738_REALK, &
      0.000000000000000_REALK,     -0.816040029684141_REALK,      0.000000000000000_REALK, &
     -0.462620933740671_REALK,      0.000000000000000_REALK,     -0.931879610209980_REALK, &
      0.431465910149976_REALK,      0.077634446042438_REALK,      0.000000000000000_REALK, &
     -0.220027262699579_REALK,      0.000000000000000_REALK,     -0.135962174547066_REALK, &
     -0.860289570661629_REALK,      0.000000000000000_REALK,     -0.253111380586589_REALK, &
      0.000000000000000_REALK,     -2.951600893914448_REALK,      0.000000000000000_REALK, &
     -0.548236700810560_REALK,      0.000000000000000_REALK,     -0.564622864565102_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.394948910277277_REALK, &
      0.000000000000000_REALK,      0.288850882063354_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.222287307632880_REALK,      0.000000000000000_REALK, &
      0.549248114372100_REALK,      0.000000000000000_REALK,      0.096984095621847_REALK, &
      0.000000000000000_REALK,      0.450844443824324_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.022420843873243_REALK, &
      0.000000000000000_REALK,     -0.052838545075483_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.456732009531477_REALK,      0.000000000000000_REALK, &
      0.121831030682150_REALK,      0.000000000000000_REALK,     -1.842338342776567_REALK, &
      0.000000000000000_REALK,     -0.219427578143391_REALK,      0.000000000000000_REALK, &
    -18.767030015943615_REALK,     -5.747235621585571_REALK,      0.000000000000000_REALK, &
     -3.920580208999155_REALK,      0.000000000000000_REALK,     -3.474417737013725_REALK, &
     -2.349821784379939_REALK,      0.000000000000000_REALK,     -1.054766502546106_REALK, &
      0.000000000000000_REALK,     -2.087675567915229_REALK,      0.000000000000000_REALK, &
     -0.829878908345569_REALK,      0.000000000000000_REALK,     -2.206315783651951_REALK, &
     25.609015582079945_REALK,      2.288391648190445_REALK,      0.000000000000000_REALK, &
      0.027338559469986_REALK,      0.000000000000000_REALK,      0.094701671392524_REALK, &
      1.019145323350461_REALK,      0.000000000000000_REALK,     -0.198528350286422_REALK, &
      0.000000000000000_REALK,      6.048946890990139_REALK,      0.000000000000000_REALK, &
     -0.076646369107207_REALK,      0.000000000000000_REALK,     -0.796516649158814_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.470787424146189_REALK, &
      0.000000000000000_REALK,      0.934694163973023_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.664341604489690_REALK,      0.000000000000000_REALK, &
      1.360360344430735_REALK,      0.000000000000000_REALK,      0.537453939758580_REALK, &
      0.000000000000000_REALK,      0.593547075497473_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.540267414548728_REALK, &
      0.000000000000000_REALK,     -0.039750739357995_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.320836354527851_REALK,      0.000000000000000_REALK, &
      0.400875543815360_REALK,      0.000000000000000_REALK,      0.828418731282950_REALK, &
      0.000000000000000_REALK,      0.334335447827321_REALK,      0.000000000000000_REALK, &
     -1.796932179794210_REALK,     -0.863127412997478_REALK,      0.000000000000000_REALK, &
     -0.605553819938487_REALK,      0.000000000000000_REALK,     -0.998020416504432_REALK, &
     -0.449405031819459_REALK,      0.000000000000000_REALK,     -0.475218666469700_REALK, &
      0.000000000000000_REALK,     -0.387501321145261_REALK,      0.000000000000000_REALK, &
     -0.384537223762088_REALK,      0.000000000000000_REALK,     -1.056267248217733_REALK, &
      3.546300909918005_REALK,      0.434770262209531_REALK,      0.000000000000000_REALK, &
     -0.001798946491018_REALK,      0.000000000000000_REALK,      0.039342467775107_REALK, &
      0.344340554157196_REALK,      0.000000000000000_REALK,     -0.113154874050917_REALK, &
      0.000000000000000_REALK,      1.799788134464568_REALK,      0.000000000000000_REALK, &
      0.015130575944143_REALK,      0.000000000000000_REALK,     -0.551502596541300_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.817537209333310_REALK, &
      0.000000000000000_REALK,      0.460872001331396_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.372426289851523_REALK,      0.000000000000000_REALK, &
      0.750196198456799_REALK,      0.000000000000000_REALK,      0.381982133403127_REALK, &
      0.000000000000000_REALK,      0.487769581239575_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.871904964518493_REALK, &
      0.000000000000000_REALK,     -0.036767513723920_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.367232389692836_REALK,      0.000000000000000_REALK, &
      0.378208542994105_REALK,      0.000000000000000_REALK,      1.051076830018077_REALK, &
      0.000000000000000_REALK,      0.515406898291712_REALK,      0.000000000000000_REALK, &
     -0.653823341998532_REALK,     -0.395525456732027_REALK,      0.000000000000000_REALK, &
     -0.244941854355939_REALK,      0.000000000000000_REALK,     -0.605225071410712_REALK, &
     -0.078075643086435_REALK,      0.000000000000000_REALK,     -0.362945797017886_REALK, &
      0.000000000000000_REALK,      0.221288612618828_REALK,      0.000000000000000_REALK, &
     -0.259237240236104_REALK,      0.000000000000000_REALK,     -0.896766413014506_REALK, &
      0.957140614153183_REALK,     -0.338845637933660_REALK,      0.000000000000000_REALK, &
     -0.066345892427611_REALK,      0.000000000000000_REALK,      0.017697442454875_REALK, &
      1.234077016807311_REALK,      0.000000000000000_REALK,      0.146981976520309_REALK, &
      0.000000000000000_REALK,      4.532353260644451_REALK,      0.000000000000000_REALK, &
      0.930036523200221_REALK,      0.000000000000000_REALK,     -0.347315774153125_REALK, &
    -95.825536181511211_REALK,    -14.843661089550148_REALK,      0.000000000000000_REALK, &
     -8.331184669062278_REALK,      0.000000000000000_REALK,     -9.144363169048457_REALK, &
     -3.326935719488370_REALK,      0.000000000000000_REALK,     -1.623138556807344_REALK, &
      0.000000000000000_REALK,     -2.732916382698531_REALK,      0.000000000000000_REALK, &
     -1.107299775373952_REALK,      0.000000000000000_REALK,     -3.646138581212685_REALK, &
    -41.747069360037564_REALK,    -10.563151440470984_REALK,      0.000000000000000_REALK, &
     -8.642554106596172_REALK,      0.000000000000000_REALK,     -6.523020625611365_REALK, &
     -9.268222487411494_REALK,      0.000000000000000_REALK,     -1.411537558633516_REALK, &
      0.000000000000000_REALK,    -17.562910944987326_REALK,      0.000000000000000_REALK, &
     -1.179462302241909_REALK,      0.000000000000000_REALK,     -2.670619181469660_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.140535253077488_REALK, &
      0.000000000000000_REALK,      1.807750950753940_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.004467375152874_REALK,      0.000000000000000_REALK, &
      2.670476622163287_REALK,      0.000000000000000_REALK,      0.535273380312941_REALK, &
      0.000000000000000_REALK,      0.720805852186395_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.801849988745179_REALK, &
      0.000000000000000_REALK,      1.246635418932144_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.223812022008376_REALK,      0.000000000000000_REALK, &
      2.325876670846853_REALK,      0.000000000000000_REALK,     -0.873363426966630_REALK, &
      0.000000000000000_REALK,      0.510390607846286_REALK,      0.000000000000000_REALK, &
     -8.144093866748010_REALK,     -2.189981564855834_REALK,      0.000000000000000_REALK, &
     -1.138606662462850_REALK,      0.000000000000000_REALK,     -2.331504366204616_REALK, &
     -0.650522555406447_REALK,      0.000000000000000_REALK,     -0.718416466497723_REALK, &
      0.000000000000000_REALK,     -0.528505208331461_REALK,      0.000000000000000_REALK, &
     -0.453997463145769_REALK,      0.000000000000000_REALK,     -1.549404054485053_REALK, &
     -5.370101286419571_REALK,     -2.435308937060642_REALK,      0.000000000000000_REALK, &
     -2.014654142133599_REALK,      0.000000000000000_REALK,     -2.517250814722013_REALK, &
     -2.419032675360167_REALK,      0.000000000000000_REALK,     -0.976279678723519_REALK, &
      0.000000000000000_REALK,     -4.181779009549561_REALK,      0.000000000000000_REALK, &
     -0.824828603926884_REALK,      0.000000000000000_REALK,     -1.717664942928355_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.338354509676310_REALK, &
      0.000000000000000_REALK,      0.814471254114432_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.465435489342546_REALK,      0.000000000000000_REALK, &
      1.278482896248534_REALK,      0.000000000000000_REALK,      0.307114205993017_REALK, &
      0.000000000000000_REALK,      0.541257859808647_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.410296385077646_REALK, &
      0.000000000000000_REALK,      0.710542719028107_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.044182194612159_REALK,      0.000000000000000_REALK, &
      1.610420855058760_REALK,      0.000000000000000_REALK,     -0.885254848936499_REALK, &
      0.000000000000000_REALK,      0.484844144965487_REALK,      0.000000000000000_REALK, &
     -2.694727886058624_REALK,     -1.079819715984769_REALK,      0.000000000000000_REALK, &
     -0.638296701629870_REALK,      0.000000000000000_REALK,     -1.285751763768199_REALK, &
     -0.462342863562646_REALK,      0.000000000000000_REALK,     -0.590385688827645_REALK, &
      0.000000000000000_REALK,     -0.448940191787528_REALK,      0.000000000000000_REALK, &
     -0.424180847269733_REALK,      0.000000000000000_REALK,     -1.196227051773186_REALK, &
     -3.039873418972627_REALK,     -2.252543127788453_REALK,      0.000000000000000_REALK, &
     -2.305992586498073_REALK,      0.000000000000000_REALK,     -2.374916049818298_REALK, &
     -3.069207757036195_REALK,      0.000000000000000_REALK,     -1.505019238450609_REALK, &
      0.000000000000000_REALK,     -5.082889247591779_REALK,      0.000000000000000_REALK, &
     -1.573511308970552_REALK,      0.000000000000000_REALK,     -2.268758450385001_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.418037899524393_REALK, &
      0.000000000000000_REALK,      0.622048205026827_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.313775115409251_REALK,      0.000000000000000_REALK, &
      1.085426555546161_REALK,      0.000000000000000_REALK,      0.088925495696710_REALK, &
      0.000000000000000_REALK,      0.578736044801720_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.084224858947345_REALK, &
      0.000000000000000_REALK,     -0.922956029254839_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.715762758545443_REALK,      0.000000000000000_REALK, &
      1.014183014721643_REALK,      0.000000000000000_REALK,     -5.287752923186198_REALK, &
      0.000000000000000_REALK,     -0.881700340888221_REALK,      0.000000000000000_REALK, &
     12.196470677603802_REALK,      9.485251141322676_REALK,      0.000000000000000_REALK, &
      1.887554333287562_REALK,      0.000000000000000_REALK,      2.133113313415193_REALK, &
      4.791581974388441_REALK,      0.000000000000000_REALK,      3.762072875716271_REALK, &
      0.000000000000000_REALK,     -1.202589008034607_REALK,      0.000000000000000_REALK, &
     -1.949457669352500_REALK,      0.000000000000000_REALK,     -6.609209655743959_REALK, &
      7.718123970510762_REALK,      0.247059235988823_REALK,      0.000000000000000_REALK, &
     -1.384114117709561_REALK,      0.000000000000000_REALK,      1.475499225103872_REALK, &
    -19.851051232017987_REALK,      0.000000000000000_REALK,      0.108700170577459_REALK, &
      0.000000000000000_REALK,      9.817995107079120_REALK,      0.000000000000000_REALK, &
      0.447815220284777_REALK,      0.000000000000000_REALK,     -1.432145663567083_REALK, &
     16.040956433762993_REALK,      3.907878883525767_REALK,      0.000000000000000_REALK, &
      1.623681096305448_REALK,      0.000000000000000_REALK,      1.982442054403109_REALK, &
      2.451149418023364_REALK,      0.000000000000000_REALK,      1.246229879329810_REALK, &
      0.000000000000000_REALK,     -6.292725203325231_REALK,      0.000000000000000_REALK, &
     -2.596271019140700_REALK,      0.000000000000000_REALK,     -9.509792652049752_REALK, &
      5.086264889959623_REALK,      2.538126357596823_REALK,      0.000000000000000_REALK, &
      2.147995315479286_REALK,      0.000000000000000_REALK,      1.910689975908394_REALK, &
      6.172094010466399_REALK,      0.000000000000000_REALK,      1.067031938133843_REALK, &
      0.000000000000000_REALK,     -7.747836629812920_REALK,      0.000000000000000_REALK, &
     -1.004280667512006_REALK,      0.000000000000000_REALK,     -2.679990487761776_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.661206628599405_REALK, &
      0.000000000000000_REALK,     -0.335792616606121_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.315348867276547_REALK,      0.000000000000000_REALK, &
     -4.459402515348538_REALK,      0.000000000000000_REALK,      0.683867794878888_REALK, &
      0.000000000000000_REALK,      1.610800250590388_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.492208977907052_REALK, &
      0.000000000000000_REALK,     -0.021687910344786_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.982837115158970_REALK,      0.000000000000000_REALK, &
     -3.143184618809053_REALK,      0.000000000000000_REALK,     -1.851794400515797_REALK, &
      0.000000000000000_REALK,      0.030420106954203_REALK,      0.000000000000000_REALK, &
     17.798648900697565_REALK,      0.522598891989673_REALK,      0.000000000000000_REALK, &
      0.811238582204664_REALK,      0.000000000000000_REALK,      1.133096575467665_REALK, &
     -0.036777239927522_REALK,      0.000000000000000_REALK,      0.104396461374029_REALK, &
      0.000000000000000_REALK,     -5.637192850558444_REALK,      0.000000000000000_REALK, &
     -2.866847320190786_REALK,      0.000000000000000_REALK,    -12.012797291034046_REALK, &
     19.170613296334363_REALK,     -0.351436784729379_REALK,      0.000000000000000_REALK, &
      0.885363669415538_REALK,      0.000000000000000_REALK,      2.595001820899849_REALK, &
     -2.241850911220531_REALK,      0.000000000000000_REALK,     -0.077790183313322_REALK, &
      0.000000000000000_REALK,      4.020908516976587_REALK,      0.000000000000000_REALK, &
     -0.384910915982334_REALK,      0.000000000000000_REALK,     -3.384522865675387_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.238695491278637_REALK, &
      0.000000000000000_REALK,     -0.101760130060319_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.529892341300229_REALK,      0.000000000000000_REALK, &
     -1.940924601678215_REALK,      0.000000000000000_REALK,      0.707302587225063_REALK, &
      0.000000000000000_REALK,      1.078834621152521_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.730179659476875_REALK, &
      0.000000000000000_REALK,     -0.436022541324615_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.928218953772382_REALK,      0.000000000000000_REALK, &
     -2.477014690358394_REALK,      0.000000000000000_REALK,      1.096484725899582_REALK, &
      0.000000000000000_REALK,      0.568681011773365_REALK,      0.000000000000000_REALK, &
      1.906579955064894_REALK,      0.548580994330421_REALK,      0.000000000000000_REALK, &
      0.107403998274168_REALK,      0.000000000000000_REALK,      0.364129754453664_REALK, &
      0.139575685395177_REALK,      0.000000000000000_REALK,      0.328760252631422_REALK, &
      0.000000000000000_REALK,     -0.234142276477971_REALK,      0.000000000000000_REALK, &
     -1.138669454526974_REALK,      0.000000000000000_REALK,     -6.434016044455413_REALK, &
      3.162849293958256_REALK,      0.042340621997673_REALK,      0.000000000000000_REALK, &
     -0.401617909778080_REALK,      0.000000000000000_REALK,      1.284403302625096_REALK, &
     -1.711544109782220_REALK,      0.000000000000000_REALK,      0.028116163901300_REALK, &
      0.000000000000000_REALK,      3.828032034662888_REALK,      0.000000000000000_REALK, &
      0.523808880580021_REALK,      0.000000000000000_REALK,     -2.791964865864213_REALK, &
     15.483618731499572_REALK,     -0.939241863231658_REALK,      0.000000000000000_REALK, &
     -0.719797845479100_REALK,      0.000000000000000_REALK,     -0.983364030456936_REALK, &
      0.164174775117642_REALK,      0.000000000000000_REALK,      0.060330214317387_REALK, &
      0.000000000000000_REALK,     -8.681705620034421_REALK,      0.000000000000000_REALK, &
     -3.816031369625959_REALK,      0.000000000000000_REALK,    -15.640007864240447_REALK, &
     10.400675879651921_REALK,     -1.028220143294198_REALK,      0.000000000000000_REALK, &
      1.473916876023377_REALK,      0.000000000000000_REALK,      1.908609507937329_REALK, &
      0.135131100953478_REALK,      0.000000000000000_REALK,     -0.155276556580841_REALK, &
      0.000000000000000_REALK,     -7.291180366592196_REALK,      0.000000000000000_REALK, &
     -1.380523667132851_REALK,      0.000000000000000_REALK,     -5.363017358477843_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.739027517899468_REALK, &
      0.000000000000000_REALK,      0.014753364908458_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.079973398384761_REALK,      0.000000000000000_REALK, &
      0.335108262203272_REALK,      0.000000000000000_REALK,     -0.027554074804188_REALK, &
      0.000000000000000_REALK,      0.234646312093679_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.278729987164502_REALK, &
      0.000000000000000_REALK,      0.028890237976795_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.117407727309712_REALK,      0.000000000000000_REALK, &
     -1.032366506604709_REALK,      0.000000000000000_REALK,     -0.779837143717459_REALK, &
      0.000000000000000_REALK,     -0.081178914343539_REALK,      0.000000000000000_REALK, &
      1.439629928203007_REALK,      0.156177037537057_REALK,      0.000000000000000_REALK, &
     -0.074884674925816_REALK,      0.000000000000000_REALK,     -0.274292524205102_REALK, &
     -0.019730869931001_REALK,      0.000000000000000_REALK,     -0.030095104940211_REALK, &
      0.000000000000000_REALK,     -0.962239285767051_REALK,      0.000000000000000_REALK, &
     -1.191010519478355_REALK,      0.000000000000000_REALK,     -7.270853083228272_REALK, &
      1.671006469814825_REALK,      0.382881288172483_REALK,      0.000000000000000_REALK, &
      0.344728156264204_REALK,      0.000000000000000_REALK,      0.919930264057061_REALK, &
      0.334456037364217_REALK,      0.000000000000000_REALK,      0.173462332150546_REALK, &
      0.000000000000000_REALK,     -2.490995675809925_REALK,      0.000000000000000_REALK, &
     -0.968654446240815_REALK,      0.000000000000000_REALK,     -4.308199201399210_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.558850566483746_REALK, &
      0.000000000000000_REALK,      0.046460578362812_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.031764253810832_REALK,      0.000000000000000_REALK, &
      0.179482920040169_REALK,      0.000000000000000_REALK,      0.313716762090114_REALK, &
      0.000000000000000_REALK,      1.231561233456084_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.127863686927982_REALK, &
      0.000000000000000_REALK,     -0.010441968787134_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.159775178255446_REALK,      0.000000000000000_REALK, &
     -0.851621079108930_REALK,      0.000000000000000_REALK,     -1.786103165788589_REALK, &
      0.000000000000000_REALK,      0.048901621511362_REALK,      0.000000000000000_REALK, &
      1.267272063040218_REALK,      1.494837662224426_REALK,      0.000000000000000_REALK, &
     -5.243373075197963_REALK,      0.000000000000000_REALK,     -6.397468247875034_REALK, &
      3.659563964654336_REALK,      0.000000000000000_REALK,      1.483925250596372_REALK, &
      0.000000000000000_REALK,    -15.362951809022160_REALK,      0.000000000000000_REALK, &
     -6.055551401615715_REALK,      0.000000000000000_REALK,    -22.165234435706669_REALK, &
     65.745229185517289_REALK,     -8.028002341466729_REALK,      0.000000000000000_REALK, &
      2.611979312498721_REALK,      0.000000000000000_REALK,      3.862393921807465_REALK, &
     -0.093042350838135_REALK,      0.000000000000000_REALK,     -0.030661919691394_REALK, &
      0.000000000000000_REALK,      0.078834177331667_REALK,      0.000000000000000_REALK, &
     -1.986634374797539_REALK,      0.000000000000000_REALK,     -8.813045911988491_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.167683167013367_REALK, &
      0.000000000000000_REALK,     -0.281801660744016_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.848475364225039_REALK,      0.000000000000000_REALK, &
      3.477477013087186_REALK,      0.000000000000000_REALK,     -0.885641676713466_REALK, &
      0.000000000000000_REALK,     -0.976354963049222_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -6.598495038828905_REALK, &
      0.000000000000000_REALK,      0.225716265957958_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.019462232405499_REALK,      0.000000000000000_REALK, &
     -0.075606302673676_REALK,      0.000000000000000_REALK,      0.149403404349347_REALK, &
      0.000000000000000_REALK,     -0.515029760102561_REALK,      0.000000000000000_REALK, &
      0.103355664361697_REALK,     -0.017518696359483_REALK,      0.000000000000000_REALK, &
     -0.373554722706720_REALK,      0.000000000000000_REALK,     -1.565286413887444_REALK, &
      0.006126509818932_REALK,      0.000000000000000_REALK,     -0.052172426228577_REALK, &
      0.000000000000000_REALK,     -0.848311774128095_REALK,      0.000000000000000_REALK, &
     -1.294250738346391_REALK,      0.000000000000000_REALK,     -9.038716301136249_REALK, &
      8.514855762671884_REALK,     -0.099880091327057_REALK,      0.000000000000000_REALK, &
      0.170668608233602_REALK,      0.000000000000000_REALK,      1.500689596047032_REALK, &
     -0.010993923603636_REALK,      0.000000000000000_REALK,     -0.001144437386330_REALK, &
      0.000000000000000_REALK,      1.356019154749366_REALK,      0.000000000000000_REALK, &
     -0.389424359748899_REALK,      0.000000000000000_REALK,     -5.707015984280553_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.325705184887714_REALK, &
      0.000000000000000_REALK,      0.140573850903305_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.264815193175234_REALK,      0.000000000000000_REALK, &
      1.616637579848706_REALK,      0.000000000000000_REALK,      0.319314840836878_REALK, &
      0.000000000000000_REALK,      0.811740999219181_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.180407127914402_REALK, &
      0.000000000000000_REALK,     -0.252151842876526_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.013655816558735_REALK,      0.000000000000000_REALK, &
     -0.060735774476763_REALK,      0.000000000000000_REALK,      1.109342044166631_REALK, &
      0.000000000000000_REALK,      0.958915555590373_REALK,      0.000000000000000_REALK, &
      0.033214179179641_REALK,     -0.055169025512100_REALK,      0.000000000000000_REALK, &
     -0.148370423965281_REALK,      0.000000000000000_REALK,     -0.838362427761651_REALK, &
     -0.069753342725796_REALK,      0.000000000000000_REALK,     -0.273831440286224_REALK, &
      0.000000000000000_REALK,     -0.105704552898740_REALK,      0.000000000000000_REALK, &
     -0.856762160460376_REALK,      0.000000000000000_REALK,     -6.777550807810189_REALK, &
      4.214451325186249_REALK,      0.036100249396731_REALK,      0.000000000000000_REALK, &
     -0.232255643882795_REALK,      0.000000000000000_REALK,      1.237950752002137_REALK, &
     -0.025179977526187_REALK,      0.000000000000000_REALK,      0.000689401236298_REALK, &
      0.000000000000000_REALK,      3.872919323143573_REALK,      0.000000000000000_REALK, &
      0.883251723454303_REALK,      0.000000000000000_REALK,     -6.590974340898721_REALK, &
   -118.878121195720169_REALK,     27.038546248188307_REALK,      0.000000000000000_REALK, &
    -24.561798689294921_REALK,      0.000000000000000_REALK,    -25.238845833165175_REALK, &
     17.718126065216900_REALK,      0.000000000000000_REALK,      7.102701009548072_REALK, &
      0.000000000000000_REALK,    -34.292040172232078_REALK,      0.000000000000000_REALK, &
    -11.749804817351496_REALK,      0.000000000000000_REALK,    -36.221066230483238_REALK, &
    -48.379974085677411_REALK,     17.950923620607668_REALK,      0.000000000000000_REALK, &
    -17.894833871513892_REALK,      0.000000000000000_REALK,    -17.867762444995787_REALK, &
     11.500697004545216_REALK,      0.000000000000000_REALK,      6.074333313954447_REALK, &
      0.000000000000000_REALK,    -33.390489491382411_REALK,      0.000000000000000_REALK, &
     -8.500045899571683_REALK,      0.000000000000000_REALK,    -25.461560916786315_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     13.232232969955456_REALK, &
      0.000000000000000_REALK,     -2.354037648381481_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.848891797259034_REALK,      0.000000000000000_REALK, &
     10.427845522269001_REALK,      0.000000000000000_REALK,     -2.777161952416411_REALK, &
      0.000000000000000_REALK,     -3.378353912643379_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      9.853395923764094_REALK, &
      0.000000000000000_REALK,     -2.464419918671608_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.254815033235516_REALK,      0.000000000000000_REALK, &
     10.002740646713931_REALK,      0.000000000000000_REALK,     -3.552136475634689_REALK, &
      0.000000000000000_REALK,     -3.511798305857403_REALK,      0.000000000000000_REALK, &
     -8.661175413930961_REALK,      0.582865765300788_REALK,      0.000000000000000_REALK, &
     -1.345986228286918_REALK,      0.000000000000000_REALK,     -5.516525719134784_REALK, &
      0.416658556878326_REALK,      0.000000000000000_REALK,      0.459335485898430_REALK, &
      0.000000000000000_REALK,     -1.464887323002487_REALK,      0.000000000000000_REALK, &
     -1.931667424190797_REALK,      0.000000000000000_REALK,    -13.194901010646218_REALK, &
     -5.484633044455870_REALK,      0.575827266701116_REALK,      0.000000000000000_REALK, &
     -1.564256696405999_REALK,      0.000000000000000_REALK,     -6.076777976116563_REALK, &
     -0.169571737214002_REALK,      0.000000000000000_REALK,      0.584554893630735_REALK, &
      0.000000000000000_REALK,     -3.924240432822955_REALK,      0.000000000000000_REALK, &
     -2.229065742710666_REALK,      0.000000000000000_REALK,    -14.432347371696304_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.237567376773539_REALK, &
      0.000000000000000_REALK,      0.082764179327845_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.608892579309571_REALK,      0.000000000000000_REALK, &
      4.252350119790576_REALK,      0.000000000000000_REALK,     -0.013947817391287_REALK, &
      0.000000000000000_REALK,      0.197962487452986_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.828425853985722_REALK, &
      0.000000000000000_REALK,     -0.091982965154504_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.441993711479708_REALK,      0.000000000000000_REALK, &
      6.477420102822194_REALK,      0.000000000000000_REALK,     -1.259165853754713_REALK, &
      0.000000000000000_REALK,     -0.218459537374248_REALK,      0.000000000000000_REALK, &
     -2.415886277400635_REALK,     -0.290756573157540_REALK,      0.000000000000000_REALK, &
     -0.420091870764638_REALK,      0.000000000000000_REALK,     -2.564566999060593_REALK, &
     -0.150224706301813_REALK,      0.000000000000000_REALK,     -0.381891279720183_REALK, &
      0.000000000000000_REALK,     -0.487083596164206_REALK,      0.000000000000000_REALK, &
     -1.004811892907474_REALK,      0.000000000000000_REALK,     -8.587812905241874_REALK, &
     -2.643537037754317_REALK,     -0.643267359846735_REALK,      0.000000000000000_REALK, &
     -1.097572059146615_REALK,      0.000000000000000_REALK,     -4.881574731881197_REALK, &
     -1.259094854050361_REALK,      0.000000000000000_REALK,     -1.088361923954382_REALK, &
      0.000000000000000_REALK,     -4.022091948427254_REALK,      0.000000000000000_REALK, &
     -2.606733582390159_REALK,      0.000000000000000_REALK,    -16.231235621841748_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.734030795867471_REALK, &
      0.000000000000000_REALK,      0.434394872305890_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.403071913564509_REALK,      0.000000000000000_REALK, &
      3.188563290326456_REALK,      0.000000000000000_REALK,      0.264671326069089_REALK, &
      0.000000000000000_REALK,      1.454632260231808_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.158149878169418_REALK, &
      0.000000000000000_REALK,      0.055409907657091_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.002484045097078_REALK,      0.000000000000000_REALK, &
      7.480706171231200_REALK,      0.000000000000000_REALK,     -4.806559368971300_REALK, &
      0.000000000000000_REALK,      0.184237938854650_REALK,      0.000000000000000_REALK/
    ! results of test 4, ket-major order, 01 DPG Z
  data REF_CONTR_INTS(20161:21420)                                                         &
     /0.000000000000000_REALK,      0.000000000000000_REALK,     -1.037176255026364_REALK, &
      0.000000000000000_REALK,      0.405292584142349_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.514717032660308_REALK,      0.000000000000000_REALK, &
      1.185735490241599_REALK,      0.000000000000000_REALK,     10.983410249385265_REALK, &
      0.000000000000000_REALK,      3.940273005623677_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -5.222623349730048_REALK, &
      0.000000000000000_REALK,     -3.328656364805943_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.985886441557696_REALK,      0.000000000000000_REALK, &
     -0.356573473807706_REALK,      0.000000000000000_REALK,      9.079686127072153_REALK, &
      0.000000000000000_REALK,      2.645937962884116_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.032697706704399_REALK, &
      0.000000000000000_REALK,      0.641200989988218_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.338920020727160_REALK,      0.000000000000000_REALK, &
      1.019051143363653_REALK,      0.000000000000000_REALK,      3.149169632183911_REALK, &
      0.000000000000000_REALK,      1.804342931667368_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.052957329155276_REALK, &
      0.000000000000000_REALK,     -0.361100927745660_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.086650404022144_REALK,      0.000000000000000_REALK, &
      0.105905878401861_REALK,      0.000000000000000_REALK,      0.114502321697554_REALK, &
      0.000000000000000_REALK,      0.617531996032063_REALK,      0.000000000000000_REALK, &
      1.182576191227907_REALK,      0.039576592797572_REALK,      0.000000000000000_REALK, &
     -1.189257216260955_REALK,      0.000000000000000_REALK,     -0.560756725322195_REALK, &
     -3.438175025415405_REALK,      0.000000000000000_REALK,     -1.233437332636469_REALK, &
      0.000000000000000_REALK,    -11.208885213534776_REALK,      0.000000000000000_REALK, &
     -3.346576012202185_REALK,      0.000000000000000_REALK,     -2.629953918553770_REALK, &
      3.386303076911913_REALK,      3.074698927970761_REALK,      0.000000000000000_REALK, &
      1.999310418191411_REALK,      0.000000000000000_REALK,      0.723106669271229_REALK, &
     -1.061214241568240_REALK,      0.000000000000000_REALK,     -0.309251554428360_REALK, &
      0.000000000000000_REALK,    -13.737409943433455_REALK,      0.000000000000000_REALK, &
     -3.419094381565956_REALK,      0.000000000000000_REALK,     -2.061018912389679_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.614954033263752_REALK, &
      0.000000000000000_REALK,      0.798706560988433_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.069773444363220_REALK,      0.000000000000000_REALK, &
      1.073729847331026_REALK,      0.000000000000000_REALK,      1.790544978915900_REALK, &
      0.000000000000000_REALK,      1.202897398899181_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.739353607393787_REALK, &
      0.000000000000000_REALK,     -0.435752254341489_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.204103501564695_REALK,      0.000000000000000_REALK, &
      0.153568313273767_REALK,      0.000000000000000_REALK,      1.270577069320656_REALK, &
      0.000000000000000_REALK,      0.553709303945545_REALK,      0.000000000000000_REALK, &
      0.149544292719455_REALK,     -0.452655711641119_REALK,      0.000000000000000_REALK, &
     -0.864722042405199_REALK,      0.000000000000000_REALK,     -0.658139375290093_REALK, &
     -1.379422635963754_REALK,      0.000000000000000_REALK,     -0.790351671611005_REALK, &
      0.000000000000000_REALK,     -2.581881051346937_REALK,      0.000000000000000_REALK, &
     -1.302320459584989_REALK,      0.000000000000000_REALK,     -1.651992069256438_REALK, &
      4.166967946268559_REALK,      1.404343980820811_REALK,      0.000000000000000_REALK, &
      0.312907564064518_REALK,      0.000000000000000_REALK,      0.382441960944239_REALK, &
     -0.022990163364543_REALK,      0.000000000000000_REALK,     -0.123990162479936_REALK, &
      0.000000000000000_REALK,      1.094183994328032_REALK,      0.000000000000000_REALK, &
     -0.397610862069530_REALK,      0.000000000000000_REALK,     -0.809946744907529_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.395866098963643_REALK, &
      0.000000000000000_REALK,      0.796597580845027_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.465892042469503_REALK,      0.000000000000000_REALK, &
      1.151991918669302_REALK,      0.000000000000000_REALK,      3.344192042778519_REALK, &
      0.000000000000000_REALK,      1.999535258568593_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.812206838742024_REALK, &
      0.000000000000000_REALK,     -1.116753599378652_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.686497332330274_REALK,      0.000000000000000_REALK, &
      0.413818347006185_REALK,      0.000000000000000_REALK,      4.869571171561737_REALK, &
      0.000000000000000_REALK,      2.365093360695289_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.571590952985113_REALK, &
      0.000000000000000_REALK,      1.015734756136780_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.953687191817896_REALK,      0.000000000000000_REALK, &
      1.311349410057085_REALK,      0.000000000000000_REALK,      1.095481896694511_REALK, &
      0.000000000000000_REALK,      0.951227916492390_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.133408395656685_REALK, &
      0.000000000000000_REALK,      0.155496844475218_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.205734571450842_REALK,      0.000000000000000_REALK, &
      0.434951042067678_REALK,      0.000000000000000_REALK,     -0.012631045410876_REALK, &
      0.000000000000000_REALK,      0.387447791494563_REALK,      0.000000000000000_REALK, &
     -0.920470246522629_REALK,     -0.859083059333373_REALK,      0.000000000000000_REALK, &
     -0.911243123935797_REALK,      0.000000000000000_REALK,     -0.914613225352063_REALK, &
     -1.067015453841988_REALK,      0.000000000000000_REALK,     -0.716826513226642_REALK, &
      0.000000000000000_REALK,     -1.590713823322313_REALK,      0.000000000000000_REALK, &
     -0.853372293270961_REALK,      0.000000000000000_REALK,     -1.427547279595224_REALK, &
      0.675727068762002_REALK,      0.118276202739442_REALK,      0.000000000000000_REALK, &
     -0.283003477252290_REALK,      0.000000000000000_REALK,     -0.212932979194721_REALK, &
     -0.884858402851917_REALK,      0.000000000000000_REALK,     -0.385615593232347_REALK, &
      0.000000000000000_REALK,     -2.519783353857010_REALK,      0.000000000000000_REALK, &
     -0.705153037778570_REALK,      0.000000000000000_REALK,     -0.884266738700080_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.707890000668413_REALK, &
      0.000000000000000_REALK,      0.673229018762370_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.776074364282725_REALK,      0.000000000000000_REALK, &
      0.984449476710864_REALK,      0.000000000000000_REALK,      1.100383510588043_REALK, &
      0.000000000000000_REALK,      1.050789806706369_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.103806193675505_REALK, &
      0.000000000000000_REALK,      0.171920848284790_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.276905133000340_REALK,      0.000000000000000_REALK, &
      0.564065101125412_REALK,      0.000000000000000_REALK,      0.079428247978366_REALK, &
      0.000000000000000_REALK,      0.713951819029034_REALK,      0.000000000000000_REALK, &
     -0.592536914944883_REALK,     -0.856814655388589_REALK,      0.000000000000000_REALK, &
     -1.248660687149191_REALK,      0.000000000000000_REALK,     -0.981277596904516_REALK, &
     -1.992859510527652_REALK,      0.000000000000000_REALK,     -1.191556228141439_REALK, &
      0.000000000000000_REALK,     -3.916611012311292_REALK,      0.000000000000000_REALK, &
     -1.948935481871239_REALK,      0.000000000000000_REALK,     -2.144237777481718_REALK, &
      1.092523266009695_REALK,      0.303120348349589_REALK,      0.000000000000000_REALK, &
     -0.951875546889169_REALK,      0.000000000000000_REALK,     -0.573787466926058_REALK, &
     -3.391278713809702_REALK,      0.000000000000000_REALK,     -1.647104126363193_REALK, &
      0.000000000000000_REALK,     -9.529399818194314_REALK,      0.000000000000000_REALK, &
     -3.952942792982375_REALK,      0.000000000000000_REALK,     -3.335949384667079_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.436198003341311_REALK, &
      0.000000000000000_REALK,      1.431088721697671_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.050902714474644_REALK,      0.000000000000000_REALK, &
      1.891893836626964_REALK,      0.000000000000000_REALK,      0.900476209232832_REALK, &
      0.000000000000000_REALK,      0.908766266315947_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.174629137278980_REALK, &
      0.000000000000000_REALK,     -0.057159798922513_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.398930289205531_REALK,      0.000000000000000_REALK, &
      0.565976810110501_REALK,      0.000000000000000_REALK,      0.823645212540073_REALK, &
      0.000000000000000_REALK,      0.480759535020686_REALK,      0.000000000000000_REALK, &
     -2.601710809669004_REALK,     -1.390852437319123_REALK,      0.000000000000000_REALK, &
     -1.050882804452259_REALK,      0.000000000000000_REALK,     -1.444996386111416_REALK, &
     -0.881901852314683_REALK,      0.000000000000000_REALK,     -0.765772272512515_REALK, &
      0.000000000000000_REALK,     -0.914634214868983_REALK,      0.000000000000000_REALK, &
     -0.667328886083880_REALK,      0.000000000000000_REALK,     -1.529329792458906_REALK, &
      5.695173405333668_REALK,      0.997177863009019_REALK,      0.000000000000000_REALK, &
      0.029885454623862_REALK,      0.000000000000000_REALK,      0.063181941370612_REALK, &
      0.008460814432337_REALK,      0.000000000000000_REALK,     -0.259529101465473_REALK, &
      0.000000000000000_REALK,      0.847512794114034_REALK,      0.000000000000000_REALK, &
     -0.251360528547813_REALK,      0.000000000000000_REALK,     -0.885684266670732_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.252386044683027_REALK, &
      0.000000000000000_REALK,      0.789882325135796_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.686995018740651_REALK,      0.000000000000000_REALK, &
      1.149226284743335_REALK,      0.000000000000000_REALK,      0.746628706305016_REALK, &
      0.000000000000000_REALK,      0.835981725613633_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.365507151441756_REALK, &
      0.000000000000000_REALK,     -0.056015365976313_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.472341663335792_REALK,      0.000000000000000_REALK, &
      0.592319680712018_REALK,      0.000000000000000_REALK,      1.081094316148885_REALK, &
      0.000000000000000_REALK,      0.785223234056877_REALK,      0.000000000000000_REALK, &
     -1.171885765375143_REALK,     -0.921857026120618_REALK,      0.000000000000000_REALK, &
     -0.855168457118866_REALK,      0.000000000000000_REALK,     -1.084780246398668_REALK, &
     -0.885847825666758_REALK,      0.000000000000000_REALK,     -0.845923131841726_REALK, &
      0.000000000000000_REALK,     -1.076603230803922_REALK,      0.000000000000000_REALK, &
     -0.905078110653598_REALK,      0.000000000000000_REALK,     -1.607326821746578_REALK, &
      4.431462282561592_REALK,      1.102502527803049_REALK,      0.000000000000000_REALK, &
      0.040223846332863_REALK,      0.000000000000000_REALK,      0.081937332484810_REALK, &
     -0.053204437556050_REALK,      0.000000000000000_REALK,     -0.478235463331698_REALK, &
      0.000000000000000_REALK,      0.931006961837894_REALK,      0.000000000000000_REALK, &
     -0.563857758548850_REALK,      0.000000000000000_REALK,     -1.608036197126548_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.343670017290922_REALK, &
      0.000000000000000_REALK,      1.312994408895168_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.568962313928001_REALK,      0.000000000000000_REALK, &
      1.726187601520518_REALK,      0.000000000000000_REALK,      2.324124598875854_REALK, &
      0.000000000000000_REALK,      1.945473414755471_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.679612676525239_REALK, &
      0.000000000000000_REALK,     -0.239261954284453_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.647850145821596_REALK,      0.000000000000000_REALK, &
      2.234561572792175_REALK,      0.000000000000000_REALK,      6.905609850796157_REALK, &
      0.000000000000000_REALK,      4.695562711368018_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     11.013928485739193_REALK, &
      0.000000000000000_REALK,      2.709971475421305_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.528063754898805_REALK,      0.000000000000000_REALK, &
      3.613084106260162_REALK,      0.000000000000000_REALK,      0.891734735361352_REALK, &
      0.000000000000000_REALK,      1.080548898578759_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.127780505838524_REALK, &
      0.000000000000000_REALK,      2.184553824328145_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.881038873548392_REALK,      0.000000000000000_REALK, &
      3.258308143258674_REALK,      0.000000000000000_REALK,     -0.215492729731458_REALK, &
      0.000000000000000_REALK,      0.894387996152756_REALK,      0.000000000000000_REALK, &
    -11.326235033600346_REALK,     -3.353030369708668_REALK,      0.000000000000000_REALK, &
     -1.801128853310727_REALK,      0.000000000000000_REALK,     -3.242492886939606_REALK, &
     -1.089916812175532_REALK,      0.000000000000000_REALK,     -1.099950916903829_REALK, &
      0.000000000000000_REALK,     -0.890571133297543_REALK,      0.000000000000000_REALK, &
     -0.718165418453625_REALK,      0.000000000000000_REALK,     -2.154802580893928_REALK, &
     -7.581786524393091_REALK,     -3.501866164121771_REALK,      0.000000000000000_REALK, &
     -2.505035817257145_REALK,      0.000000000000000_REALK,     -3.553984792398893_REALK, &
     -2.405093712635869_REALK,      0.000000000000000_REALK,     -1.403846847360554_REALK, &
      0.000000000000000_REALK,     -3.504844542754003_REALK,      0.000000000000000_REALK, &
     -1.025597968764424_REALK,      0.000000000000000_REALK,     -2.425088135795570_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.385615925337731_REALK, &
      0.000000000000000_REALK,      1.312447399831028_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.807720364775488_REALK,      0.000000000000000_REALK, &
      1.851067507471361_REALK,      0.000000000000000_REALK,      0.602673686231004_REALK, &
      0.000000000000000_REALK,      0.872188511448876_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.870809674631776_REALK, &
      0.000000000000000_REALK,      1.629682459274541_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.733987908399045_REALK,      0.000000000000000_REALK, &
      2.586251493626753_REALK,      0.000000000000000_REALK,     -0.021751655190632_REALK, &
      0.000000000000000_REALK,      1.112026029361033_REALK,      0.000000000000000_REALK, &
     -4.128056264827563_REALK,     -1.850688489484118_REALK,      0.000000000000000_REALK, &
     -1.177432062256212_REALK,      0.000000000000000_REALK,     -1.969644375187550_REALK, &
     -0.903703141860901_REALK,      0.000000000000000_REALK,     -1.011854092396370_REALK, &
      0.000000000000000_REALK,     -0.875122963266651_REALK,      0.000000000000000_REALK, &
     -0.782463905100989_REALK,      0.000000000000000_REALK,     -1.832501381967395_REALK, &
     -4.760804287170432_REALK,     -3.431753058635935_REALK,      0.000000000000000_REALK, &
     -2.966013904322434_REALK,      0.000000000000000_REALK,     -3.719401749124815_REALK, &
     -3.156860627547876_REALK,      0.000000000000000_REALK,     -2.292899217396853_REALK, &
      0.000000000000000_REALK,     -4.339265427784419_REALK,      0.000000000000000_REALK, &
     -2.023881797513814_REALK,      0.000000000000000_REALK,     -3.553146288833785_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.541632154238439_REALK, &
      0.000000000000000_REALK,      1.449816942574724_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.095486853532583_REALK,      0.000000000000000_REALK, &
      1.945473414755471_REALK,      0.000000000000000_REALK,      1.008950472839021_REALK, &
      0.000000000000000_REALK,      1.348868650776080_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.019849222981428_REALK, &
      0.000000000000000_REALK,      3.003023327996168_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.646498673530278_REALK,      0.000000000000000_REALK, &
      4.695562711368019_REALK,      0.000000000000000_REALK,      0.227969499781560_REALK, &
      0.000000000000000_REALK,      2.868789636844578_REALK,      0.000000000000000_REALK, &
     -4.428942222956985_REALK,     -3.076336261710296_REALK,      0.000000000000000_REALK, &
     -2.689024639912154_REALK,      0.000000000000000_REALK,     -2.958491069156774_REALK, &
     -2.813069848967586_REALK,      0.000000000000000_REALK,     -2.354758693945978_REALK, &
      0.000000000000000_REALK,     -3.591172072985927_REALK,      0.000000000000000_REALK, &
     -2.501792420428276_REALK,      0.000000000000000_REALK,     -3.538923891147739_REALK, &
    -12.828871520029693_REALK,    -14.658262587770803_REALK,      0.000000000000000_REALK, &
    -16.626863473370683_REALK,      0.000000000000000_REALK,    -14.031666502081295_REALK, &
    -20.164797392370076_REALK,      0.000000000000000_REALK,    -13.711326409062568_REALK, &
      0.000000000000000_REALK,    -27.350628586997843_REALK,      0.000000000000000_REALK, &
    -15.883650713250910_REALK,      0.000000000000000_REALK,    -17.234302875563014_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,    -11.465725621317757_REALK, &
      0.000000000000000_REALK,     -1.421635026572535_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,    -10.085624973149267_REALK,      0.000000000000000_REALK, &
    -13.642726392065665_REALK,      0.000000000000000_REALK,      6.192823742808207_REALK, &
      0.000000000000000_REALK,      4.404774882551299_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,    -11.455263580251286_REALK, &
      0.000000000000000_REALK,     -2.922646980138273_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,    -15.238596287543590_REALK,      0.000000000000000_REALK, &
    -15.120128177350228_REALK,      0.000000000000000_REALK,      4.750181287289546_REALK, &
      0.000000000000000_REALK,      2.836772888476302_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -6.603136641921468_REALK, &
      0.000000000000000_REALK,     -0.644794980781430_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.688801034322633_REALK,      0.000000000000000_REALK, &
     -6.317257846821223_REALK,      0.000000000000000_REALK,      2.767866045165240_REALK, &
      0.000000000000000_REALK,      3.093087415440265_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.349395047826487_REALK, &
      0.000000000000000_REALK,     -0.787213390857292_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.377806042275802_REALK,      0.000000000000000_REALK, &
     -5.485475630913299_REALK,      0.000000000000000_REALK,     -0.053800165102869_REALK, &
      0.000000000000000_REALK,      1.104168874038926_REALK,      0.000000000000000_REALK, &
      3.284381600531101_REALK,      3.106508485805505_REALK,      0.000000000000000_REALK, &
      0.900216054213739_REALK,      0.000000000000000_REALK,      1.217713463873531_REALK, &
      4.178456307826183_REALK,      0.000000000000000_REALK,      2.972014085484820_REALK, &
      0.000000000000000_REALK,     -7.652119906063030_REALK,      0.000000000000000_REALK, &
     -4.318344638928985_REALK,      0.000000000000000_REALK,     -9.735637691003639_REALK, &
      2.676889540858153_REALK,      4.936530578415431_REALK,      0.000000000000000_REALK, &
      3.040412064755031_REALK,      0.000000000000000_REALK,      3.016775250397330_REALK, &
     10.425403741107457_REALK,      0.000000000000000_REALK,      6.225973472492091_REALK, &
      0.000000000000000_REALK,     -9.043766769354017_REALK,      0.000000000000000_REALK, &
     -4.264572230534526_REALK,      0.000000000000000_REALK,     -7.052364221582830_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.311718802548742_REALK, &
      0.000000000000000_REALK,     -0.182088310038976_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.803594213559983_REALK,      0.000000000000000_REALK, &
     -2.583978988429510_REALK,      0.000000000000000_REALK,      1.469378127734027_REALK, &
      0.000000000000000_REALK,      1.930453241959871_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -5.046938368049819_REALK, &
      0.000000000000000_REALK,     -0.685781969565933_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.147842463171743_REALK,      0.000000000000000_REALK, &
     -3.351404388051920_REALK,      0.000000000000000_REALK,      1.080612794230714_REALK, &
      0.000000000000000_REALK,      0.894428951136131_REALK,      0.000000000000000_REALK, &
      2.700890341311653_REALK,      1.053395024796663_REALK,      0.000000000000000_REALK, &
      0.219552385556776_REALK,      0.000000000000000_REALK,      0.515831782546256_REALK, &
      0.564914451636657_REALK,      0.000000000000000_REALK,      0.631291309855773_REALK, &
      0.000000000000000_REALK,     -2.340997636634773_REALK,      0.000000000000000_REALK, &
     -2.327637696167198_REALK,      0.000000000000000_REALK,     -9.114525590258999_REALK, &
      5.519794358383294_REALK,      1.536851825920960_REALK,      0.000000000000000_REALK, &
      0.563014536431008_REALK,      0.000000000000000_REALK,      2.241536489665083_REALK, &
     -0.049725474740326_REALK,      0.000000000000000_REALK,      1.020541876592670_REALK, &
      0.000000000000000_REALK,      1.159972412208191_REALK,      0.000000000000000_REALK, &
     -0.734309917207536_REALK,      0.000000000000000_REALK,     -4.872528054005045_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.989366143821001_REALK, &
      0.000000000000000_REALK,     -0.242677972095065_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.881363206842992_REALK,      0.000000000000000_REALK, &
     -1.987019002293573_REALK,      0.000000000000000_REALK,      3.617200488147687_REALK, &
      0.000000000000000_REALK,      4.288015321456641_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -5.889554987012132_REALK, &
      0.000000000000000_REALK,     -2.544127011271454_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -3.941584162841799_REALK,      0.000000000000000_REALK, &
     -6.518235739414092_REALK,      0.000000000000000_REALK,      5.556280871974375_REALK, &
      0.000000000000000_REALK,      5.530282595231969_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.243650029950778_REALK, &
      0.000000000000000_REALK,      0.046832819762302_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.110214187917108_REALK,      0.000000000000000_REALK, &
      0.432348341121874_REALK,      0.000000000000000_REALK,      0.360796463905627_REALK, &
      0.000000000000000_REALK,      0.744857089237442_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.998963119367339_REALK, &
      0.000000000000000_REALK,     -0.070460616307884_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.229163402708928_REALK,      0.000000000000000_REALK, &
     -1.358664298278757_REALK,      0.000000000000000_REALK,     -0.442559168089025_REALK, &
      0.000000000000000_REALK,      0.197987858059354_REALK,      0.000000000000000_REALK, &
      1.916598657348354_REALK,      0.279461246906421_REALK,      0.000000000000000_REALK, &
     -0.113564372919688_REALK,      0.000000000000000_REALK,     -0.365169321166027_REALK, &
     -0.040989682833653_REALK,      0.000000000000000_REALK,     -0.053851806161807_REALK, &
      0.000000000000000_REALK,     -1.580955241956975_REALK,      0.000000000000000_REALK, &
     -1.806195498869464_REALK,      0.000000000000000_REALK,     -9.679784355752416_REALK, &
      2.260874122870167_REALK,      0.602200709888033_REALK,      0.000000000000000_REALK, &
      0.426293402437879_REALK,      0.000000000000000_REALK,      1.244666951578117_REALK, &
      0.329614690060514_REALK,      0.000000000000000_REALK,      0.272823830222893_REALK, &
      0.000000000000000_REALK,     -2.128948188436863_REALK,      0.000000000000000_REALK, &
     -1.197845293954177_REALK,      0.000000000000000_REALK,     -5.828999627806816_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.791676264739247_REALK, &
      0.000000000000000_REALK,      0.089214432512919_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.064931639526090_REALK,      0.000000000000000_REALK, &
      0.254258251210034_REALK,      0.000000000000000_REALK,      1.269727833494759_REALK, &
      0.000000000000000_REALK,      2.364865880267224_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.968344058638103_REALK, &
      0.000000000000000_REALK,     -0.379015660128906_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.223983407434141_REALK,      0.000000000000000_REALK, &
     -1.486246352908843_REALK,      0.000000000000000_REALK,     -0.051891638285231_REALK, &
      0.000000000000000_REALK,      1.774998636400838_REALK,      0.000000000000000_REALK, &
      0.884291544700868_REALK,      0.372451634395926_REALK,      0.000000000000000_REALK, &
     -0.124554729502340_REALK,      0.000000000000000_REALK,     -0.280806610061696_REALK, &
     -0.100905204696054_REALK,      0.000000000000000_REALK,     -0.119618214464239_REALK, &
      0.000000000000000_REALK,     -3.510325092118932_REALK,      0.000000000000000_REALK, &
     -3.301654471470681_REALK,      0.000000000000000_REALK,    -10.420936762548418_REALK, &
      2.638340612529001_REALK,      2.234055662330577_REALK,      0.000000000000000_REALK, &
      1.463851859191659_REALK,      0.000000000000000_REALK,      2.420785935701408_REALK, &
      1.694808545005974_REALK,      0.000000000000000_REALK,      1.686878402057170_REALK, &
      0.000000000000000_REALK,     -8.722944865206189_REALK,      0.000000000000000_REALK, &
     -6.855482048088239_REALK,      0.000000000000000_REALK,    -15.871767479997251_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.473506912928208_REALK, &
      0.000000000000000_REALK,     -0.223549772772291_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.080649672256222_REALK,      0.000000000000000_REALK, &
      4.388250651449399_REALK,      0.000000000000000_REALK,     -0.787881154559789_REALK, &
      0.000000000000000_REALK,     -0.774530318801135_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -8.309019460553618_REALK, &
      0.000000000000000_REALK,      0.198865023918315_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.022768024097079_REALK,      0.000000000000000_REALK, &
     -0.095205685017469_REALK,      0.000000000000000_REALK,      0.012451955287276_REALK, &
      0.000000000000000_REALK,     -0.453761739885049_REALK,      0.000000000000000_REALK, &
      0.133346906275988_REALK,     -0.055611038848757_REALK,      0.000000000000000_REALK, &
     -0.514809064479707_REALK,      0.000000000000000_REALK,     -2.019493580896362_REALK, &
     -0.080221277414037_REALK,      0.000000000000000_REALK,     -0.165615224003855_REALK, &
      0.000000000000000_REALK,     -1.276683516695212_REALK,      0.000000000000000_REALK, &
     -1.783653026743782_REALK,      0.000000000000000_REALK,    -11.661526853960504_REALK, &
     11.206127335323474_REALK,      0.243598297717202_REALK,      0.000000000000000_REALK, &
      0.333121165826145_REALK,      0.000000000000000_REALK,      1.975009227733670_REALK, &
     -0.006239074046750_REALK,      0.000000000000000_REALK,      0.002791176854665_REALK, &
      0.000000000000000_REALK,      0.697208852290917_REALK,      0.000000000000000_REALK, &
     -0.760101685150511_REALK,      0.000000000000000_REALK,     -7.510819866725056_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.433615686794171_REALK, &
      0.000000000000000_REALK,      0.251541098969518_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.401598476355059_REALK,      0.000000000000000_REALK, &
      2.152251321160364_REALK,      0.000000000000000_REALK,      0.663357170553207_REALK, &
      0.000000000000000_REALK,      1.452519239603521_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.303095353359302_REALK, &
      0.000000000000000_REALK,     -0.396587724369060_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.016886884340915_REALK,      0.000000000000000_REALK, &
     -0.082175588980340_REALK,      0.000000000000000_REALK,      1.093283999119109_REALK, &
      0.000000000000000_REALK,      1.508194957908366_REALK,      0.000000000000000_REALK, &
      0.047051714512457_REALK,     -0.105936548290849_REALK,      0.000000000000000_REALK, &
     -0.303294859140103_REALK,      0.000000000000000_REALK,     -1.187637044879643_REALK, &
     -0.282317591665064_REALK,      0.000000000000000_REALK,     -0.525816023179017_REALK, &
      0.000000000000000_REALK,     -1.056853603030411_REALK,      0.000000000000000_REALK, &
     -1.751370332635879_REALK,      0.000000000000000_REALK,     -9.601182193243227_REALK, &
      7.355046822142731_REALK,      1.310342918547992_REALK,      0.000000000000000_REALK, &
      0.325591315751861_REALK,      0.000000000000000_REALK,      2.160467648556870_REALK, &
     -0.000731553647542_REALK,      0.000000000000000_REALK,      0.025023429009966_REALK, &
      0.000000000000000_REALK,      1.173574183516515_REALK,      0.000000000000000_REALK, &
     -1.238200656707005_REALK,      0.000000000000000_REALK,    -11.502547102904096_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.333440253659439_REALK, &
      0.000000000000000_REALK,      0.558735152405083_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.734106250416097_REALK,      0.000000000000000_REALK, &
      2.317042827673619_REALK,      0.000000000000000_REALK,      2.721668252997230_REALK, &
      0.000000000000000_REALK,      4.516967552619898_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -8.369204868970524_REALK, &
      0.000000000000000_REALK,     -2.452114487992525_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.096646647969982_REALK,      0.000000000000000_REALK, &
     -0.223755691217726_REALK,      0.000000000000000_REALK,      9.369055848639485_REALK, &
      0.000000000000000_REALK,     13.055304215588734_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     16.424698191275766_REALK, &
      0.000000000000000_REALK,     -2.513972674978371_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.468448593329352_REALK,      0.000000000000000_REALK, &
     12.943712212247371_REALK,      0.000000000000000_REALK,     -3.010646216587049_REALK, &
      0.000000000000000_REALK,     -3.607881729772312_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     12.189914698898932_REALK, &
      0.000000000000000_REALK,     -2.623035932472624_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.822052371042313_REALK,      0.000000000000000_REALK, &
     12.374673278334329_REALK,      0.000000000000000_REALK,     -3.545933907207120_REALK, &
      0.000000000000000_REALK,     -3.737826120487514_REALK,      0.000000000000000_REALK, &
    -10.929593066887987_REALK,      0.462380204026195_REALK,      0.000000000000000_REALK, &
     -1.714297948754424_REALK,      0.000000000000000_REALK,     -6.961339353107507_REALK, &
      0.370666188687865_REALK,      0.000000000000000_REALK,      0.364385160923948_REALK, &
      0.000000000000000_REALK,     -1.843225489551111_REALK,      0.000000000000000_REALK, &
     -2.460243227882518_REALK,      0.000000000000000_REALK,    -16.650730612414513_REALK, &
     -6.906411603283910_REALK,      0.507326765660141_REALK,      0.000000000000000_REALK, &
     -1.829956266873425_REALK,      0.000000000000000_REALK,     -7.652057956230188_REALK, &
     -0.014132875344910_REALK,      0.000000000000000_REALK,      0.515016152735293_REALK, &
      0.000000000000000_REALK,     -3.576946733570105_REALK,      0.000000000000000_REALK, &
     -2.607687622190320_REALK,      0.000000000000000_REALK,    -18.173637241103012_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.177028866477969_REALK, &
      0.000000000000000_REALK,      0.262725142181875_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.839136544310532_REALK,      0.000000000000000_REALK, &
      5.486276309850127_REALK,      0.000000000000000_REALK,      0.182634446256673_REALK, &
      0.000000000000000_REALK,      0.628408607264050_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.038467921169613_REALK, &
      0.000000000000000_REALK,      0.224337937950485_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.862709680355595_REALK,      0.000000000000000_REALK, &
      8.524723906049173_REALK,      0.000000000000000_REALK,     -0.714579187735754_REALK, &
      0.000000000000000_REALK,      0.532802590760532_REALK,      0.000000000000000_REALK, &
     -3.216301845955675_REALK,     -0.520276192724967_REALK,      0.000000000000000_REALK, &
     -0.637079214396084_REALK,      0.000000000000000_REALK,     -3.414242487452869_REALK, &
     -0.312082695118029_REALK,      0.000000000000000_REALK,     -0.683351502220475_REALK, &
      0.000000000000000_REALK,     -0.800276372018216_REALK,      0.000000000000000_REALK, &
     -1.523820897043697_REALK,      0.000000000000000_REALK,    -11.433070653296701_REALK, &
     -3.576709360179742_REALK,     -1.011739337266844_REALK,      0.000000000000000_REALK, &
     -1.357265773079948_REALK,      0.000000000000000_REALK,     -6.604777533500583_REALK, &
     -1.240869094022819_REALK,      0.000000000000000_REALK,     -1.711789903206704_REALK, &
      0.000000000000000_REALK,     -3.437511132790935_REALK,      0.000000000000000_REALK, &
     -3.223506139238943_REALK,      0.000000000000000_REALK,    -21.960884809558571_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.456454561820883_REALK, &
      0.000000000000000_REALK,      0.834132793540768_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.823948843581431_REALK,      0.000000000000000_REALK, &
      4.516967552619898_REALK,      0.000000000000000_REALK,      1.071222803649101_REALK, &
      0.000000000000000_REALK,      2.793210850673358_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.511592953147679_REALK, &
      0.000000000000000_REALK,      2.011232091998851_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.405348407499278_REALK,      0.000000000000000_REALK, &
     13.055304215588730_REALK,      0.000000000000000_REALK,     -0.139644923624009_REALK, &
      0.000000000000000_REALK,      6.687346556889201_REALK,      0.000000000000000_REALK, &
     -2.473260391683779_REALK,     -1.155662430615951_REALK,      0.000000000000000_REALK, &
     -1.164555795985779_REALK,      0.000000000000000_REALK,     -3.675660918273290_REALK, &
     -1.280434736092789_REALK,      0.000000000000000_REALK,     -2.125050380335400_REALK, &
      0.000000000000000_REALK,     -2.961532532959907_REALK,      0.000000000000000_REALK, &
     -3.899678697146254_REALK,      0.000000000000000_REALK,    -15.825171853139278_REALK, &
     -6.956437386110901_REALK,     -6.255616436264899_REALK,      0.000000000000000_REALK, &
     -7.767873855494848_REALK,      0.000000000000000_REALK,    -17.984131062343799_REALK, &
    -10.633807731676031_REALK,      0.000000000000000_REALK,    -14.817671828401988_REALK, &
      0.000000000000000_REALK,    -23.474205281062478_REALK,      0.000000000000000_REALK, &
    -25.828179994018708_REALK,      0.000000000000000_REALK,    -76.882158578436986_REALK/
    ! results of test 4, ket-major order, 02 DPG X
  data REF_CONTR_INTS(21421:22680)                                                         &
   /-43.400990205619493_REALK,    -32.913945870608764_REALK,      0.000000000000000_REALK, &
    -33.858650042951595_REALK,      0.000000000000000_REALK,     -8.589932060886118_REALK, &
    -41.903420167884370_REALK,      0.000000000000000_REALK,     -8.002971028712803_REALK, &
      0.000000000000000_REALK,    -73.176280884939786_REALK,      0.000000000000000_REALK, &
    -12.303557736593977_REALK,      0.000000000000000_REALK,     -9.364229666315330_REALK, &
    -28.326440566777880_REALK,    -16.729966226610969_REALK,      0.000000000000000_REALK, &
    -11.302078974337480_REALK,      0.000000000000000_REALK,     -4.604543260365808_REALK, &
     -2.145230759297416_REALK,      0.000000000000000_REALK,     -3.856540819720945_REALK, &
      0.000000000000000_REALK,     32.238710565534966_REALK,      0.000000000000000_REALK, &
     -3.905029247494032_REALK,      0.000000000000000_REALK,     -4.772805820214337_REALK, &
    -23.063377095086242_REALK,     -8.884916516138359_REALK,      0.000000000000000_REALK, &
     -3.272798700517482_REALK,      0.000000000000000_REALK,     -4.014588203456698_REALK, &
      2.923768545469562_REALK,      0.000000000000000_REALK,     -1.878682583940716_REALK, &
      0.000000000000000_REALK,     16.490085326990826_REALK,      0.000000000000000_REALK, &
     -0.980594327255255_REALK,      0.000000000000000_REALK,     -3.608546793256532_REALK, &
     -3.585610385288457_REALK,      1.799814953711481_REALK,      0.000000000000000_REALK, &
      7.066813270689772_REALK,      0.000000000000000_REALK,     -0.970201301776789_REALK, &
     14.839280684662747_REALK,      0.000000000000000_REALK,      0.442645074011869_REALK, &
      0.000000000000000_REALK,     31.349633698529210_REALK,      0.000000000000000_REALK, &
      2.133590753873646_REALK,      0.000000000000000_REALK,     -0.878760672276155_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.211621733410873_REALK, &
      0.000000000000000_REALK,      4.859170216875379_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      5.177081100116742_REALK,      0.000000000000000_REALK, &
      3.940273005623677_REALK,      0.000000000000000_REALK,      7.623079027427091_REALK, &
      0.000000000000000_REALK,      4.367706528130446_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.586167934375367_REALK, &
      0.000000000000000_REALK,      2.833046335203413_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.164861827890839_REALK,      0.000000000000000_REALK, &
      2.645937962884115_REALK,      0.000000000000000_REALK,      0.475792142084014_REALK, &
      0.000000000000000_REALK,      2.566034180281501_REALK,      0.000000000000000_REALK, &
    -17.913765144121637_REALK,     -3.490535672164998_REALK,      0.000000000000000_REALK, &
     -0.121894585652771_REALK,      0.000000000000000_REALK,     -2.719415302680915_REALK, &
      2.537589866757484_REALK,      0.000000000000000_REALK,     -0.636163559084555_REALK, &
      0.000000000000000_REALK,      5.770256537558190_REALK,      0.000000000000000_REALK, &
     -0.030067631520100_REALK,      0.000000000000000_REALK,     -2.012387428857176_REALK, &
     -8.182190999595482_REALK,     -0.104202478419234_REALK,      0.000000000000000_REALK, &
      0.957851758648629_REALK,      0.000000000000000_REALK,     -1.001803651608466_REALK, &
      1.057223403210992_REALK,      0.000000000000000_REALK,     -0.017122020617889_REALK, &
      0.000000000000000_REALK,      0.179137758870913_REALK,      0.000000000000000_REALK, &
      0.214914358184477_REALK,      0.000000000000000_REALK,     -0.674327692782194_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.300054562942257_REALK, &
      0.000000000000000_REALK,      1.293166258007055_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.490316059229872_REALK,      0.000000000000000_REALK, &
      1.804342931667367_REALK,      0.000000000000000_REALK,     -0.496430834068408_REALK, &
      0.000000000000000_REALK,      0.956952591415575_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.252740859773023_REALK, &
      0.000000000000000_REALK,     -0.429512993775141_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.499339465821129_REALK,      0.000000000000000_REALK, &
      0.617531996032063_REALK,      0.000000000000000_REALK,     -3.230729900248499_REALK, &
      0.000000000000000_REALK,     -0.289111050501102_REALK,      0.000000000000000_REALK, &
     -5.955487982959791_REALK,     -3.994314244361494_REALK,      0.000000000000000_REALK, &
     -3.563575162119178_REALK,      0.000000000000000_REALK,     -2.712234702000822_REALK, &
     -3.811686406944702_REALK,      0.000000000000000_REALK,     -2.183937427763691_REALK, &
      0.000000000000000_REALK,     -5.228057418123845_REALK,      0.000000000000000_REALK, &
     -2.637071965788580_REALK,      0.000000000000000_REALK,     -3.345122885445172_REALK, &
     -6.989821363372704_REALK,     -3.658078890679596_REALK,      0.000000000000000_REALK, &
     -2.100636241988287_REALK,      0.000000000000000_REALK,     -2.567440151273846_REALK, &
     -0.334353687490897_REALK,      0.000000000000000_REALK,     -1.803230685245962_REALK, &
      0.000000000000000_REALK,      3.891090721156866_REALK,      0.000000000000000_REALK, &
     -1.413966886784952_REALK,      0.000000000000000_REALK,     -2.880298268004151_REALK, &
    -16.367527964013799_REALK,      0.134573303325913_REALK,      0.000000000000000_REALK, &
      2.085476491341991_REALK,      0.000000000000000_REALK,     -2.159312798911079_REALK, &
      4.031917017097484_REALK,      0.000000000000000_REALK,      0.020985392111039_REALK, &
      0.000000000000000_REALK,      6.442749699020986_REALK,      0.000000000000000_REALK, &
      0.422465111497175_REALK,      0.000000000000000_REALK,     -1.312267473840803_REALK, &
     -2.689705334094755_REALK,      2.852892494369532_REALK,      0.000000000000000_REALK, &
      4.387562752392332_REALK,      0.000000000000000_REALK,     -0.552734384663752_REALK, &
      6.462317163210625_REALK,      0.000000000000000_REALK,      0.520675634423537_REALK, &
      0.000000000000000_REALK,     10.272583040385813_REALK,      0.000000000000000_REALK, &
      0.892170888689157_REALK,      0.000000000000000_REALK,     -0.337180495188791_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.571278720541649_REALK, &
      0.000000000000000_REALK,      0.504600618623847_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.017972819362684_REALK,      0.000000000000000_REALK, &
      1.202897398899180_REALK,      0.000000000000000_REALK,     -0.407742491812164_REALK, &
      0.000000000000000_REALK,      0.306658201365707_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.011296997498101_REALK, &
      0.000000000000000_REALK,      0.016944119217806_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.176472182518933_REALK,      0.000000000000000_REALK, &
      0.553709303945546_REALK,      0.000000000000000_REALK,     -0.212743087780571_REALK, &
      0.000000000000000_REALK,      0.010336296541192_REALK,      0.000000000000000_REALK, &
     -3.616132631806489_REALK,     -1.222722722071173_REALK,      0.000000000000000_REALK, &
     -0.388915371330968_REALK,      0.000000000000000_REALK,     -1.431192570726774_REALK, &
      0.296739758195250_REALK,      0.000000000000000_REALK,     -0.572014994019983_REALK, &
      0.000000000000000_REALK,      1.324872804517070_REALK,      0.000000000000000_REALK, &
     -0.236353432504877_REALK,      0.000000000000000_REALK,     -1.449618184324244_REALK, &
     -0.991266466390992_REALK,      0.433583168012831_REALK,      0.000000000000000_REALK, &
      1.483761013013378_REALK,      0.000000000000000_REALK,     -0.611115708542296_REALK, &
      2.652842562229553_REALK,      0.000000000000000_REALK,      0.237397159051033_REALK, &
      0.000000000000000_REALK,      4.433125363884174_REALK,      0.000000000000000_REALK, &
      0.905127828105032_REALK,      0.000000000000000_REALK,     -0.621324042014899_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.564489273666348_REALK, &
      0.000000000000000_REALK,      1.732284349438596_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.576300349957198_REALK,      0.000000000000000_REALK, &
      1.999535258568592_REALK,      0.000000000000000_REALK,      1.837396815695969_REALK, &
      0.000000000000000_REALK,      1.754586311254603_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.591769866351092_REALK, &
      0.000000000000000_REALK,      1.784494738669509_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.161047705831991_REALK,      0.000000000000000_REALK, &
      2.365093360695289_REALK,      0.000000000000000_REALK,      0.201844101270158_REALK, &
      0.000000000000000_REALK,      1.814303688296899_REALK,      0.000000000000000_REALK, &
    -18.218648729219677_REALK,      3.248721563450414_REALK,      0.000000000000000_REALK, &
      2.958919319579647_REALK,      0.000000000000000_REALK,     -2.043278371230276_REALK, &
      3.799978093236632_REALK,      0.000000000000000_REALK,      0.426106587700224_REALK, &
      0.000000000000000_REALK,      4.016460796509321_REALK,      0.000000000000000_REALK, &
      0.487790164112673_REALK,      0.000000000000000_REALK,     -1.010528829328018_REALK, &
     -9.927167646826872_REALK,      4.599062363837474_REALK,      0.000000000000000_REALK, &
      2.362702438151427_REALK,      0.000000000000000_REALK,     -0.874922388918785_REALK, &
      0.898149455586662_REALK,      0.000000000000000_REALK,      0.508513550666374_REALK, &
      0.000000000000000_REALK,     -1.811574083851136_REALK,      0.000000000000000_REALK, &
      0.331648818858919_REALK,      0.000000000000000_REALK,     -0.368434431936124_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.417450416763578_REALK, &
      0.000000000000000_REALK,     -0.019674870264106_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.306233763932287_REALK,      0.000000000000000_REALK, &
      0.951227916492390_REALK,      0.000000000000000_REALK,     -0.623169643557494_REALK, &
      0.000000000000000_REALK,     -0.009730452734738_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.168042656535920_REALK, &
      0.000000000000000_REALK,     -0.806253196373499_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.025176857471578_REALK,      0.000000000000000_REALK, &
      0.387447791494563_REALK,      0.000000000000000_REALK,     -1.404629835276401_REALK, &
      0.000000000000000_REALK,     -0.339517472823671_REALK,      0.000000000000000_REALK, &
     -3.351897614937781_REALK,     -0.564923699987577_REALK,      0.000000000000000_REALK, &
     -0.016850430402729_REALK,      0.000000000000000_REALK,     -1.127777367186891_REALK, &
      0.295561727074364_REALK,      0.000000000000000_REALK,     -0.222288403679350_REALK, &
      0.000000000000000_REALK,      0.533097708987965_REALK,      0.000000000000000_REALK, &
     -0.008333590737463_REALK,      0.000000000000000_REALK,     -0.929593962536301_REALK, &
     -3.242803154941397_REALK,     -0.035806446229806_REALK,      0.000000000000000_REALK, &
      0.273262760575350_REALK,      0.000000000000000_REALK,     -0.857405007365293_REALK, &
      0.244459097404684_REALK,      0.000000000000000_REALK,     -0.011877244752474_REALK, &
      0.000000000000000_REALK,      0.031972130892319_REALK,      0.000000000000000_REALK, &
      0.115072389547939_REALK,      0.000000000000000_REALK,     -0.601762950308087_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.602286189530827_REALK, &
      0.000000000000000_REALK,      0.536293090780347_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.171326339819586_REALK,      0.000000000000000_REALK, &
      1.050789806706369_REALK,      0.000000000000000_REALK,     -0.137591529210334_REALK, &
      0.000000000000000_REALK,      0.442050739662279_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.291414530128808_REALK, &
      0.000000000000000_REALK,     -0.367603562833881_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.040065433865651_REALK,      0.000000000000000_REALK, &
      0.713951819029034_REALK,      0.000000000000000_REALK,     -1.729841657607887_REALK, &
      0.000000000000000_REALK,     -0.257999664819353_REALK,      0.000000000000000_REALK, &
     -3.343046948300105_REALK,     -1.939372343189547_REALK,      0.000000000000000_REALK, &
     -1.477861586696722_REALK,      0.000000000000000_REALK,     -1.874665795744104_REALK, &
     -1.331880260392905_REALK,      0.000000000000000_REALK,     -1.271853120214774_REALK, &
      0.000000000000000_REALK,     -1.449016389783650_REALK,      0.000000000000000_REALK, &
     -1.218158165280797_REALK,      0.000000000000000_REALK,     -2.163325208220406_REALK, &
     -8.310713391098689_REALK,     -3.771008341371600_REALK,      0.000000000000000_REALK, &
     -1.797853331480658_REALK,      0.000000000000000_REALK,     -3.662287911539190_REALK, &
     -0.231935276147988_REALK,      0.000000000000000_REALK,     -2.084782385581009_REALK, &
      0.000000000000000_REALK,      2.083421093936369_REALK,      0.000000000000000_REALK, &
     -1.261809198312849_REALK,      0.000000000000000_REALK,     -3.598487090035323_REALK, &
    -23.462344282789100_REALK,      8.568188815673256_REALK,      0.000000000000000_REALK, &
      4.354691329349216_REALK,      0.000000000000000_REALK,     -2.238945958128296_REALK, &
      4.674605151863030_REALK,      0.000000000000000_REALK,      0.936922336398223_REALK, &
      0.000000000000000_REALK,      3.935349563639610_REALK,      0.000000000000000_REALK, &
      0.578783080960565_REALK,      0.000000000000000_REALK,     -0.892736551279301_REALK, &
     -4.787934127292849_REALK,      8.653311495389495_REALK,      0.000000000000000_REALK, &
      6.406099355917224_REALK,      0.000000000000000_REALK,     -0.748119414013203_REALK, &
      7.289750284304796_REALK,      0.000000000000000_REALK,      1.156328606205500_REALK, &
      0.000000000000000_REALK,      8.951065114137123_REALK,      0.000000000000000_REALK, &
      0.874249973043714_REALK,      0.000000000000000_REALK,     -0.306290930500660_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.770233510510855_REALK, &
      0.000000000000000_REALK,     -0.485729476439988_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.438668579580352_REALK,      0.000000000000000_REALK, &
      0.908766266315947_REALK,      0.000000000000000_REALK,     -0.575725882868478_REALK, &
      0.000000000000000_REALK,     -0.193675267630952_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.199244455998314_REALK, &
      0.000000000000000_REALK,     -0.732487988106106_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.432759042380753_REALK,      0.000000000000000_REALK, &
      0.480759535020686_REALK,      0.000000000000000_REALK,     -0.176558465378530_REALK, &
      0.000000000000000_REALK,     -0.299891198189940_REALK,      0.000000000000000_REALK, &
     -3.787628151215093_REALK,      0.026674772115247_REALK,      0.000000000000000_REALK, &
      0.349083469058506_REALK,      0.000000000000000_REALK,     -1.084328314064942_REALK, &
      0.560415035990386_REALK,      0.000000000000000_REALK,      0.008750573902173_REALK, &
      0.000000000000000_REALK,      0.707567935209299_REALK,      0.000000000000000_REALK, &
      0.139190305663486_REALK,      0.000000000000000_REALK,     -0.720591696313263_REALK, &
     -1.190603496316667_REALK,      1.105120509119342_REALK,      0.000000000000000_REALK, &
      1.476715286737693_REALK,      0.000000000000000_REALK,     -0.558098900051147_REALK, &
      1.832861231060892_REALK,      0.000000000000000_REALK,      0.443026623511683_REALK, &
      0.000000000000000_REALK,      2.320439985557828_REALK,      0.000000000000000_REALK, &
      0.604588640245412_REALK,      0.000000000000000_REALK,     -0.380822963567337_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.529016652339797_REALK, &
      0.000000000000000_REALK,      0.253392069154801_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.007494379101015_REALK,      0.000000000000000_REALK, &
      0.835981725613633_REALK,      0.000000000000000_REALK,     -0.134339618876922_REALK, &
      0.000000000000000_REALK,      0.168392006900642_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.175233614605179_REALK, &
      0.000000000000000_REALK,      0.017108568889822_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.150154664432606_REALK,      0.000000000000000_REALK, &
      0.785223234056877_REALK,      0.000000000000000_REALK,     -0.144167508482424_REALK, &
      0.000000000000000_REALK,      0.011674160093168_REALK,      0.000000000000000_REALK, &
     -2.510440022134958_REALK,     -0.727094806294371_REALK,      0.000000000000000_REALK, &
     -0.195299147544494_REALK,      0.000000000000000_REALK,     -1.197821384115842_REALK, &
      0.123735747707787_REALK,      0.000000000000000_REALK,     -0.397535219724734_REALK, &
      0.000000000000000_REALK,      0.436508117729397_REALK,      0.000000000000000_REALK, &
     -0.129786285382559_REALK,      0.000000000000000_REALK,     -1.114419115142738_REALK, &
     -1.316358307774028_REALK,      0.503869303514510_REALK,      0.000000000000000_REALK, &
      1.498161526182772_REALK,      0.000000000000000_REALK,     -1.028411397965630_REALK, &
      2.257220821085371_REALK,      0.000000000000000_REALK,      0.336656371236088_REALK, &
      0.000000000000000_REALK,      3.004152309571718_REALK,      0.000000000000000_REALK, &
      1.022281735819945_REALK,      0.000000000000000_REALK,     -0.982441905592952_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.541632154238439_REALK, &
      0.000000000000000_REALK,      1.449816942574724_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.095486853532583_REALK,      0.000000000000000_REALK, &
      1.945473414755471_REALK,      0.000000000000000_REALK,      1.008950472839021_REALK, &
      0.000000000000000_REALK,      1.348868650776080_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.019849222981428_REALK, &
      0.000000000000000_REALK,      3.003023327996167_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.646498673530278_REALK,      0.000000000000000_REALK, &
      4.695562711368019_REALK,      0.000000000000000_REALK,      0.227969499781560_REALK, &
      0.000000000000000_REALK,      2.868789636844578_REALK,      0.000000000000000_REALK, &
    -52.918014428023859_REALK,      0.661033388671281_REALK,      0.000000000000000_REALK, &
    -30.512219248394615_REALK,      0.000000000000000_REALK,    -23.895849737527989_REALK, &
     -0.956869388166543_REALK,      0.000000000000000_REALK,     -0.356433514057731_REALK, &
      0.000000000000000_REALK,   -123.112077856012490_REALK,      0.000000000000000_REALK, &
    -40.803161408150963_REALK,      0.000000000000000_REALK,    -95.865810928509575_REALK, &
    -22.370753870151503_REALK,      0.594350249567152_REALK,      0.000000000000000_REALK, &
     -7.738403252826878_REALK,      0.000000000000000_REALK,    -10.269665725336024_REALK, &
     -0.002417668800100_REALK,      0.000000000000000_REALK,      0.016539692965016_REALK, &
      0.000000000000000_REALK,     57.106237633233640_REALK,      0.000000000000000_REALK, &
    -12.050193661837849_REALK,      0.000000000000000_REALK,    -47.975579763472723_REALK, &
    -19.978286427698830_REALK,      1.191753983357370_REALK,      0.000000000000000_REALK, &
      2.219404634249460_REALK,      0.000000000000000_REALK,     -8.657619069493823_REALK, &
      5.555766311752316_REALK,      0.000000000000000_REALK,      0.604131491214526_REALK, &
      0.000000000000000_REALK,     66.917800923103556_REALK,      0.000000000000000_REALK, &
      2.768724251546650_REALK,      0.000000000000000_REALK,    -32.401337964854413_REALK, &
     -2.644238902401649_REALK,      1.357152707428928_REALK,      0.000000000000000_REALK, &
      8.006224865335875_REALK,      0.000000000000000_REALK,     -1.812938683774281_REALK, &
      6.995951734979013_REALK,      0.000000000000000_REALK,      1.150939309189683_REALK, &
      0.000000000000000_REALK,     86.419338177836991_REALK,      0.000000000000000_REALK, &
     11.911188149852542_REALK,      0.000000000000000_REALK,     -8.091549062059311_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.896393742318006_REALK, &
      0.000000000000000_REALK,      4.073059299652455_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.874794973917649_REALK,      0.000000000000000_REALK, &
      4.404774882551288_REALK,      0.000000000000000_REALK,     13.640744611844257_REALK, &
      0.000000000000000_REALK,     15.243517860927131_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.115012168819204_REALK, &
      0.000000000000000_REALK,      2.057671733846373_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.712522138332074_REALK,      0.000000000000000_REALK, &
      2.836772888476302_REALK,      0.000000000000000_REALK,     -0.447479099688960_REALK, &
      0.000000000000000_REALK,      9.183847163197026_REALK,      0.000000000000000_REALK, &
    -10.110736382809918_REALK,      5.252281204803329_REALK,      0.000000000000000_REALK, &
      2.549004479880547_REALK,      0.000000000000000_REALK,     -3.877120495580092_REALK, &
      7.030025889691800_REALK,      0.000000000000000_REALK,      2.268285298835162_REALK, &
      0.000000000000000_REALK,     18.674660642503202_REALK,      0.000000000000000_REALK, &
      2.730510678755963_REALK,      0.000000000000000_REALK,    -12.459592361918288_REALK, &
     -3.081541272122727_REALK,      2.852783624819095_REALK,      0.000000000000000_REALK, &
      0.712885611034973_REALK,      0.000000000000000_REALK,     -1.104381681503899_REALK, &
      1.332600605227113_REALK,      0.000000000000000_REALK,      1.338615285578124_REALK, &
      0.000000000000000_REALK,    -11.394826365939062_REALK,      0.000000000000000_REALK, &
      0.841315244595750_REALK,      0.000000000000000_REALK,     -3.910023418003605_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.387378240481672_REALK, &
      0.000000000000000_REALK,     -0.708704756220379_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.264307176097865_REALK,      0.000000000000000_REALK, &
      3.093087415440263_REALK,      0.000000000000000_REALK,     -6.981538278024942_REALK, &
      0.000000000000000_REALK,     -2.277507850871536_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.784381421814502_REALK, &
      0.000000000000000_REALK,     -1.662263146150412_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.625394977774661_REALK,      0.000000000000000_REALK, &
      1.104168874038925_REALK,      0.000000000000000_REALK,    -11.924304759524857_REALK, &
      0.000000000000000_REALK,     -5.885182575177940_REALK,      0.000000000000000_REALK, &
     -4.491690508564957_REALK,     -1.123164817732078_REALK,      0.000000000000000_REALK, &
     -2.199316099682826_REALK,      0.000000000000000_REALK,     -5.167227589921576_REALK, &
     -1.302168927156512_REALK,      0.000000000000000_REALK,     -1.455172416454391_REALK, &
      0.000000000000000_REALK,     -7.108333282336742_REALK,      0.000000000000000_REALK, &
     -7.067766428278651_REALK,      0.000000000000000_REALK,    -27.675844089737524_REALK, &
     -3.810653499545664_REALK,     -0.890266998364122_REALK,      0.000000000000000_REALK, &
     -1.029071891027484_REALK,      0.000000000000000_REALK,     -4.097056194763843_REALK, &
      0.061062781658987_REALK,      0.000000000000000_REALK,     -1.253223344968764_REALK, &
      0.000000000000000_REALK,      5.755381900228011_REALK,      0.000000000000000_REALK, &
     -3.643391827404654_REALK,      0.000000000000000_REALK,    -24.175798902828280_REALK, &
     -3.913470671921135_REALK,      9.690314166630172_REALK,      0.000000000000000_REALK, &
      1.879331082106304_REALK,      0.000000000000000_REALK,     -1.263187742898723_REALK, &
      8.945130383844859_REALK,      0.000000000000000_REALK,      3.645789544322791_REALK, &
      0.000000000000000_REALK,      8.014184762124136_REALK,      0.000000000000000_REALK, &
      1.613352189354055_REALK,      0.000000000000000_REALK,     -3.253232062154949_REALK, &
     -0.332849644520419_REALK,      4.764265631932986_REALK,      0.000000000000000_REALK, &
      2.039184996825397_REALK,      0.000000000000000_REALK,     -0.185788545885425_REALK, &
      6.879393274516179_REALK,      0.000000000000000_REALK,      2.418646160468726_REALK, &
      0.000000000000000_REALK,     16.237787041694673_REALK,      0.000000000000000_REALK, &
      1.930477333203778_REALK,      0.000000000000000_REALK,     -0.527652827711657_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.710347253195208_REALK, &
      0.000000000000000_REALK,     -1.764648442791942_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.423057435500157_REALK,      0.000000000000000_REALK, &
      1.930453241959871_REALK,      0.000000000000000_REALK,     -4.695083601187419_REALK, &
      0.000000000000000_REALK,     -4.544701232889357_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.587284074006911_REALK, &
      0.000000000000000_REALK,     -1.211573963892132_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.192453249342130_REALK,      0.000000000000000_REALK, &
      0.894428951136131_REALK,      0.000000000000000_REALK,     -1.141832073101592_REALK, &
      0.000000000000000_REALK,     -3.440957164408581_REALK,      0.000000000000000_REALK, &
     -2.484995685528751_REALK,      0.312636977496503_REALK,      0.000000000000000_REALK, &
      0.205621950183845_REALK,      0.000000000000000_REALK,     -2.406316301515943_REALK, &
      1.081699369545440_REALK,      0.000000000000000_REALK,      0.352870486175930_REALK, &
      0.000000000000000_REALK,      4.266358201681941_REALK,      0.000000000000000_REALK, &
      0.529561757372551_REALK,      0.000000000000000_REALK,    -10.328769928548173_REALK, &
     -0.596812017606786_REALK,      0.883952250288491_REALK,      0.000000000000000_REALK, &
      1.471136821258029_REALK,      0.000000000000000_REALK,     -0.999377695696855_REALK, &
      2.727718547664095_REALK,      0.000000000000000_REALK,      1.346252212639865_REALK, &
      0.000000000000000_REALK,     10.104550444667451_REALK,      0.000000000000000_REALK, &
      4.178134340780344_REALK,      0.000000000000000_REALK,     -4.730507511225559_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.279463206039606_REALK, &
      0.000000000000000_REALK,      1.132074408809470_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.095059310013014_REALK,      0.000000000000000_REALK, &
      4.288015321456640_REALK,      0.000000000000000_REALK,      2.609005459638380_REALK, &
      0.000000000000000_REALK,      4.859268128310410_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.178717642454545_REALK, &
      0.000000000000000_REALK,      1.134286147830894_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.833436218248372_REALK,      0.000000000000000_REALK, &
      5.530282595231964_REALK,      0.000000000000000_REALK,     -0.156964004738273_REALK, &
      0.000000000000000_REALK,      5.369090350222068_REALK,      0.000000000000000_REALK, &
      4.603542753189221_REALK,     15.064168871499389_REALK,      0.000000000000000_REALK, &
      0.134332321495251_REALK,      0.000000000000000_REALK,      1.212462644314810_REALK, &
     10.516414154939403_REALK,      0.000000000000000_REALK,      4.813535148946734_REALK, &
      0.000000000000000_REALK,     -3.407946614672972_REALK,      0.000000000000000_REALK, &
      0.087747983634560_REALK,      0.000000000000000_REALK,      2.375998964804888_REALK, &
      2.011346011307777_REALK,     10.218792726973815_REALK,      0.000000000000000_REALK, &
     -1.982328780226366_REALK,      0.000000000000000_REALK,      0.455465922152803_REALK, &
      3.698220320227209_REALK,      0.000000000000000_REALK,      3.191044909771708_REALK, &
      0.000000000000000_REALK,    -15.037392277802132_REALK,      0.000000000000000_REALK, &
     -1.207379343056004_REALK,      0.000000000000000_REALK,      0.832233509433967_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.777020951006009_REALK, &
      0.000000000000000_REALK,     -2.576531143906382_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.369391667338080_REALK,      0.000000000000000_REALK, &
      0.744857089237443_REALK,      0.000000000000000_REALK,     -4.129401411458513_REALK, &
      0.000000000000000_REALK,     -5.049091911750158_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.211341106249196_REALK, &
      0.000000000000000_REALK,     -2.456197236159700_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.724360890646104_REALK,      0.000000000000000_REALK, &
      0.197987858059355_REALK,      0.000000000000000_REALK,     -4.255093363103066_REALK, &
      0.000000000000000_REALK,     -4.487996897878607_REALK,      0.000000000000000_REALK, &
     -1.726655305035662_REALK,      1.085482992467100_REALK,      0.000000000000000_REALK, &
      0.298980685795398_REALK,      0.000000000000000_REALK,     -1.364278667020137_REALK, &
      1.074982121807314_REALK,      0.000000000000000_REALK,      1.040550709911991_REALK, &
      0.000000000000000_REALK,      1.335698992218401_REALK,      0.000000000000000_REALK, &
      0.585896648674048_REALK,      0.000000000000000_REALK,     -4.455841334912625_REALK, &
     -1.337046139514526_REALK,      1.378208654421547_REALK,      0.000000000000000_REALK, &
      0.195441212877738_REALK,      0.000000000000000_REALK,     -0.908315550091062_REALK, &
      0.428442480631214_REALK,      0.000000000000000_REALK,      1.291128755264691_REALK, &
      0.000000000000000_REALK,     -1.612252865733398_REALK,      0.000000000000000_REALK, &
      0.357112834506867_REALK,      0.000000000000000_REALK,     -2.766144151000186_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.480190250053028_REALK, &
      0.000000000000000_REALK,     -0.249378573926036_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.121247984045350_REALK,      0.000000000000000_REALK, &
      2.364865880267224_REALK,      0.000000000000000_REALK,     -1.498056723055204_REALK, &
      0.000000000000000_REALK,     -0.814490019233581_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.136827820912051_REALK, &
      0.000000000000000_REALK,     -1.367153665511410_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.567735119326187_REALK,      0.000000000000000_REALK, &
      1.774998636400838_REALK,      0.000000000000000_REALK,     -5.061506135246315_REALK, &
      0.000000000000000_REALK,     -4.163469528836888_REALK,      0.000000000000000_REALK, &
     -2.301197742148022_REALK,     -0.696369592475714_REALK,      0.000000000000000_REALK, &
     -0.773893935009694_REALK,      0.000000000000000_REALK,     -3.030401203076845_REALK, &
     -0.597355545298410_REALK,      0.000000000000000_REALK,     -1.112573663583049_REALK, &
      0.000000000000000_REALK,     -1.525263636645720_REALK,      0.000000000000000_REALK, &
     -2.527598406259828_REALK,      0.000000000000000_REALK,    -13.856539852041262_REALK, &
     -4.960199232138143_REALK,     -1.290291003373029_REALK,      0.000000000000000_REALK, &
     -0.846375864826927_REALK,      0.000000000000000_REALK,     -5.616143877349306_REALK, &
      0.058896618114082_REALK,      0.000000000000000_REALK,     -2.014610066201554_REALK, &
      0.000000000000000_REALK,      2.442985262970622_REALK,      0.000000000000000_REALK, &
     -2.577515762891006_REALK,      0.000000000000000_REALK,    -23.944419921388530_REALK, &
     25.169276682062744_REALK,     23.271229614495617_REALK,      0.000000000000000_REALK, &
     -2.337998249998805_REALK,      0.000000000000000_REALK,      5.343653546349374_REALK, &
     14.199879492364120_REALK,      0.000000000000000_REALK,      6.113072225078596_REALK, &
      0.000000000000000_REALK,    -10.916167522997645_REALK,      0.000000000000000_REALK, &
     -1.118445088175418_REALK,      0.000000000000000_REALK,      7.668846281423005_REALK, &
      6.257584540423371_REALK,     15.582149161016160_REALK,      0.000000000000000_REALK, &
     -3.290946700981673_REALK,      0.000000000000000_REALK,      2.311060230205114_REALK, &
     13.947609335331812_REALK,      0.000000000000000_REALK,      5.272774245616430_REALK, &
      0.000000000000000_REALK,     -0.733341698833200_REALK,      0.000000000000000_REALK, &
     -1.563199648135192_REALK,      0.000000000000000_REALK,      3.293260754662086_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.982826759255679_REALK, &
      0.000000000000000_REALK,     -3.608864430303769_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.028604168076400_REALK,      0.000000000000000_REALK, &
     -0.774530318801135_REALK,      0.000000000000000_REALK,     -3.771764653079974_REALK, &
      0.000000000000000_REALK,     -5.179195531005583_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.446986904495247_REALK, &
      0.000000000000000_REALK,     -3.185694362007794_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.658303883700838_REALK,      0.000000000000000_REALK, &
     -0.453761739885049_REALK,      0.000000000000000_REALK,     -1.753709162595895_REALK, &
      0.000000000000000_REALK,     -4.539614364709743_REALK,      0.000000000000000_REALK, &
     -0.876779855342805_REALK,      2.088545792450279_REALK,      0.000000000000000_REALK, &
      0.276944991125430_REALK,      0.000000000000000_REALK,     -0.558443674312173_REALK, &
      1.346106054359101_REALK,      0.000000000000000_REALK,      1.645907606018345_REALK, &
      0.000000000000000_REALK,      0.658103449966290_REALK,      0.000000000000000_REALK, &
      0.397452519503614_REALK,      0.000000000000000_REALK,     -1.335733644277539_REALK, &
     -0.178395524434175_REALK,      2.410472323003953_REALK,      0.000000000000000_REALK, &
      0.723146326873641_REALK,      0.000000000000000_REALK,     -0.197655884200893_REALK, &
      2.320020217797018_REALK,      0.000000000000000_REALK,      2.447007069404335_REALK, &
      0.000000000000000_REALK,      2.889228692962213_REALK,      0.000000000000000_REALK, &
      1.030483492833778_REALK,      0.000000000000000_REALK,     -0.469432714517254_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.105889395699117_REALK, &
      0.000000000000000_REALK,     -0.780134834114676_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.190991126176392_REALK,      0.000000000000000_REALK, &
      1.452519239603521_REALK,      0.000000000000000_REALK,     -1.156643179886947_REALK, &
      0.000000000000000_REALK,     -1.865993640779135_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.891406220076968_REALK, &
      0.000000000000000_REALK,     -1.288963870009315_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.194709945326918_REALK,      0.000000000000000_REALK, &
      1.508194957908367_REALK,      0.000000000000000_REALK,     -0.609506821282713_REALK, &
      0.000000000000000_REALK,     -3.061289123060698_REALK,      0.000000000000000_REALK, &
     -1.670226512735676_REALK,      0.202147205762400_REALK,      0.000000000000000_REALK, &
      0.090903571559677_REALK,      0.000000000000000_REALK,     -1.773017147200610_REALK, &
      0.488337902699975_REALK,      0.000000000000000_REALK,      0.265508202487425_REALK, &
      0.000000000000000_REALK,      1.051025825329745_REALK,      0.000000000000000_REALK, &
      0.217430986333235_REALK,      0.000000000000000_REALK,     -5.937197017477788_REALK, &
     -0.959609793391706_REALK,      1.341702540615671_REALK,      0.000000000000000_REALK, &
      1.565106437538778_REALK,      0.000000000000000_REALK,     -1.772022427900650_REALK, &
      2.759703622040283_REALK,      0.000000000000000_REALK,      2.270063817363398_REALK, &
      0.000000000000000_REALK,      5.393781246038017_REALK,      0.000000000000000_REALK, &
      3.717127706329824_REALK,      0.000000000000000_REALK,     -5.891974441485106_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.456454561820883_REALK, &
      0.000000000000000_REALK,      0.834132793540768_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.823948843581431_REALK,      0.000000000000000_REALK, &
      4.516967552619898_REALK,      0.000000000000000_REALK,      1.071222803649101_REALK, &
      0.000000000000000_REALK,      2.793210850673358_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.511592953147680_REALK, &
      0.000000000000000_REALK,      2.011232091998851_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.405348407499278_REALK,      0.000000000000000_REALK, &
     13.055304215588729_REALK,      0.000000000000000_REALK,     -0.139644923624009_REALK, &
      0.000000000000000_REALK,      6.687346556889200_REALK,      0.000000000000000_REALK/
    ! results of test 4, ket-major order, 02 DPG Y
  data REF_CONTR_INTS(22681:23940)                                                         &
   /-24.756427103150099_REALK,    -13.195126613407048_REALK,      0.000000000000000_REALK, &
    -10.696496333466582_REALK,      0.000000000000000_REALK,     -4.309293465492396_REALK, &
    -10.924761410899201_REALK,      0.000000000000000_REALK,     -2.790060493700022_REALK, &
      0.000000000000000_REALK,    -16.959735154069524_REALK,      0.000000000000000_REALK, &
     -3.204878938764395_REALK,      0.000000000000000_REALK,     -3.873445127625938_REALK, &
     -8.280269617063661_REALK,     -8.046056342380329_REALK,      0.000000000000000_REALK, &
    -10.877344483607262_REALK,      0.000000000000000_REALK,     -2.240491157237551_REALK, &
    -20.177394679668208_REALK,      0.000000000000000_REALK,     -1.978840767953494_REALK, &
      0.000000000000000_REALK,    -53.042156196438675_REALK,      0.000000000000000_REALK, &
     -3.284054739804624_REALK,      0.000000000000000_REALK,     -2.029326812855400_REALK, &
    -21.327970845717918_REALK,     -8.089863824770235_REALK,      0.000000000000000_REALK, &
     -5.706229270234047_REALK,      0.000000000000000_REALK,     -3.237711883925761_REALK, &
     -5.187685410697215_REALK,      0.000000000000000_REALK,     -1.474408814760267_REALK, &
      0.000000000000000_REALK,     -7.607604763997648_REALK,      0.000000000000000_REALK, &
     -1.407550615540442_REALK,      0.000000000000000_REALK,     -2.395930730789963_REALK, &
    -14.754194462905550_REALK,     -5.836976736365982_REALK,      0.000000000000000_REALK, &
     -4.369541635013720_REALK,      0.000000000000000_REALK,     -1.806460627747618_REALK, &
     -3.919377635940320_REALK,      0.000000000000000_REALK,     -0.959102293364935_REALK, &
      0.000000000000000_REALK,     -2.863472630019336_REALK,      0.000000000000000_REALK, &
     -0.980399344230685_REALK,      0.000000000000000_REALK,     -1.215953271137618_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.542306917459365_REALK, &
      0.000000000000000_REALK,      1.920501163471278_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.602501225927170_REALK,      0.000000000000000_REALK, &
      1.936797203321291_REALK,      0.000000000000000_REALK,      1.854930831516981_REALK, &
      0.000000000000000_REALK,      1.421185059400492_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.892961299362765_REALK, &
      0.000000000000000_REALK,      1.920133922975082_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.307805688774376_REALK,      0.000000000000000_REALK, &
      1.426070006180434_REALK,      0.000000000000000_REALK,      4.392915915937512_REALK, &
      0.000000000000000_REALK,      1.292468315556365_REALK,      0.000000000000000_REALK, &
    -21.016162901657694_REALK,     -4.416088706394125_REALK,      0.000000000000000_REALK, &
     -2.159695340191027_REALK,      0.000000000000000_REALK,     -2.772591538399977_REALK, &
     -0.630522124327280_REALK,      0.000000000000000_REALK,     -0.688645896403188_REALK, &
      0.000000000000000_REALK,      0.164453484073955_REALK,      0.000000000000000_REALK, &
     -0.437499984527090_REALK,      0.000000000000000_REALK,     -1.684972041069420_REALK, &
     -5.985510528655122_REALK,     -1.082547905717677_REALK,      0.000000000000000_REALK, &
      0.146019906968581_REALK,      0.000000000000000_REALK,     -1.230022276796376_REALK, &
      1.155843547003536_REALK,      0.000000000000000_REALK,     -0.197573627017441_REALK, &
      0.000000000000000_REALK,      1.625889556090659_REALK,      0.000000000000000_REALK, &
      0.029691816964996_REALK,      0.000000000000000_REALK,     -0.750341451320686_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.061341775261736_REALK, &
      0.000000000000000_REALK,      1.169491067836529_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.841358353751028_REALK,      0.000000000000000_REALK, &
      1.432159037907806_REALK,      0.000000000000000_REALK,      0.833562508979487_REALK, &
      0.000000000000000_REALK,      0.710728473449123_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.823579107549204_REALK, &
      0.000000000000000_REALK,      0.949137018551863_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.805033286180022_REALK,      0.000000000000000_REALK, &
      0.998453195083875_REALK,      0.000000000000000_REALK,      0.788689030072153_REALK, &
      0.000000000000000_REALK,      0.578995081176316_REALK,      0.000000000000000_REALK, &
     -3.881587831892706_REALK,     -1.815884381300989_REALK,      0.000000000000000_REALK, &
     -1.271093099252554_REALK,      0.000000000000000_REALK,     -1.536254400285385_REALK, &
     -1.108778280152947_REALK,      0.000000000000000_REALK,     -0.849508293876626_REALK, &
      0.000000000000000_REALK,     -1.362606161937862_REALK,      0.000000000000000_REALK, &
     -0.772474525790700_REALK,      0.000000000000000_REALK,     -1.556032612208814_REALK, &
     -2.289137056761132_REALK,     -1.938329599798536_REALK,      0.000000000000000_REALK, &
     -2.283827101648785_REALK,      0.000000000000000_REALK,     -1.411252838488751_REALK, &
     -3.607145962031143_REALK,      0.000000000000000_REALK,     -1.061281835283517_REALK, &
      0.000000000000000_REALK,     -7.500646746011911_REALK,      0.000000000000000_REALK, &
     -1.393186265276358_REALK,      0.000000000000000_REALK,     -1.434826998648723_REALK, &
    -25.453057320273263_REALK,     -2.142764069833376_REALK,      0.000000000000000_REALK, &
     -1.042101626571433_REALK,      0.000000000000000_REALK,     -2.854639895481775_REALK, &
      0.168802674436333_REALK,      0.000000000000000_REALK,     -0.281047750079761_REALK, &
      0.000000000000000_REALK,      0.047477472113872_REALK,      0.000000000000000_REALK, &
     -0.171794790105861_REALK,      0.000000000000000_REALK,     -1.411797801196002_REALK, &
    -21.242015950274681_REALK,     -1.838155636628188_REALK,      0.000000000000000_REALK, &
     -1.545755425498723_REALK,      0.000000000000000_REALK,     -1.872146819904447_REALK, &
     -1.602676717143531_REALK,      0.000000000000000_REALK,     -0.203242960306211_REALK, &
      0.000000000000000_REALK,     -2.684206643019134_REALK,      0.000000000000000_REALK, &
     -0.216975253774450_REALK,      0.000000000000000_REALK,     -0.788370898754706_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.104044292888115_REALK, &
      0.000000000000000_REALK,      0.645640481624100_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.317132144965168_REALK,      0.000000000000000_REALK, &
      1.221391580546663_REALK,      0.000000000000000_REALK,      0.097452959921036_REALK, &
      0.000000000000000_REALK,      0.319309561168379_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.599292766382912_REALK, &
      0.000000000000000_REALK,      0.305937819576057_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.034118310734751_REALK,      0.000000000000000_REALK, &
      0.862203307514122_REALK,      0.000000000000000_REALK,     -0.251230679341381_REALK, &
      0.000000000000000_REALK,      0.128832029207272_REALK,      0.000000000000000_REALK, &
     -3.990739748683344_REALK,     -1.309299269086175_REALK,      0.000000000000000_REALK, &
     -0.788816161646351_REALK,      0.000000000000000_REALK,     -1.342721790439210_REALK, &
     -0.604227373221412_REALK,      0.000000000000000_REALK,     -0.515188235986746_REALK, &
      0.000000000000000_REALK,     -0.702845123813037_REALK,      0.000000000000000_REALK, &
     -0.390118881307178_REALK,      0.000000000000000_REALK,     -1.106766376125881_REALK, &
     -5.847449461311079_REALK,     -2.005723825631587_REALK,      0.000000000000000_REALK, &
     -1.246573907550540_REALK,      0.000000000000000_REALK,     -1.546079798523635_REALK, &
     -0.906267791991792_REALK,      0.000000000000000_REALK,     -0.665312402967953_REALK, &
      0.000000000000000_REALK,     -0.511066579768498_REALK,      0.000000000000000_REALK, &
     -0.524938846361389_REALK,      0.000000000000000_REALK,     -1.085103927524573_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.719907760514192_REALK, &
      0.000000000000000_REALK,      0.796457144182342_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.559946313049040_REALK,      0.000000000000000_REALK, &
      1.127926805480789_REALK,      0.000000000000000_REALK,      0.514115466189291_REALK, &
      0.000000000000000_REALK,      0.656496374366516_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.982270617224297_REALK, &
      0.000000000000000_REALK,      1.643368376355484_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.600884242487546_REALK,      0.000000000000000_REALK, &
      1.648732829257974_REALK,      0.000000000000000_REALK,      2.352115213708494_REALK, &
      0.000000000000000_REALK,      1.153385149496057_REALK,      0.000000000000000_REALK, &
    -36.334949681743474_REALK,      1.153611271085809_REALK,      0.000000000000000_REALK, &
     -0.013945298943669_REALK,      0.000000000000000_REALK,     -3.467342723651474_REALK, &
      1.424970261171740_REALK,      0.000000000000000_REALK,      0.126146165852918_REALK, &
      0.000000000000000_REALK,      1.127683129813615_REALK,      0.000000000000000_REALK, &
     -0.001853473065504_REALK,      0.000000000000000_REALK,     -1.382536087563138_REALK, &
    -12.910513072011813_REALK,      2.514055021141844_REALK,      0.000000000000000_REALK, &
      2.175805635976604_REALK,      0.000000000000000_REALK,     -2.017280358763905_REALK, &
      3.721583139160972_REALK,      0.000000000000000_REALK,      0.335949276767603_REALK, &
      0.000000000000000_REALK,      4.892551133151737_REALK,      0.000000000000000_REALK, &
      0.296935453685069_REALK,      0.000000000000000_REALK,     -0.825903815076769_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.870260269110238_REALK, &
      0.000000000000000_REALK,      0.320373306682879_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.154494662048240_REALK,      0.000000000000000_REALK, &
      1.269626535483527_REALK,      0.000000000000000_REALK,     -0.025574902377303_REALK, &
      0.000000000000000_REALK,      0.127742681725608_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.566126690802617_REALK, &
      0.000000000000000_REALK,      0.292761179906292_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.283124792564677_REALK,      0.000000000000000_REALK, &
      1.028722599886817_REALK,      0.000000000000000_REALK,      0.315054626951738_REALK, &
      0.000000000000000_REALK,      0.119860670005800_REALK,      0.000000000000000_REALK, &
     -4.863374017863621_REALK,     -0.875345681293799_REALK,      0.000000000000000_REALK, &
     -0.361506804125245_REALK,      0.000000000000000_REALK,     -1.392294580914850_REALK, &
     -0.087639224095932_REALK,      0.000000000000000_REALK,     -0.287154358470835_REALK, &
      0.000000000000000_REALK,      0.018060923922260_REALK,      0.000000000000000_REALK, &
     -0.144143871095740_REALK,      0.000000000000000_REALK,     -0.925251052486219_REALK, &
     -2.649498319508463_REALK,     -0.419344891219667_REALK,      0.000000000000000_REALK, &
      0.049145696815606_REALK,      0.000000000000000_REALK,     -1.241960150780328_REALK, &
      0.327823716009347_REALK,      0.000000000000000_REALK,     -0.168109224026591_REALK, &
      0.000000000000000_REALK,      0.367266842547903_REALK,      0.000000000000000_REALK, &
      0.020120960538914_REALK,      0.000000000000000_REALK,     -0.847460808844734_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.820433745857250_REALK, &
      0.000000000000000_REALK,      0.587275858569768_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.350833018213475_REALK,      0.000000000000000_REALK, &
      0.995312472168439_REALK,      0.000000000000000_REALK,      0.274635271071972_REALK, &
      0.000000000000000_REALK,      0.390274884130040_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.119190970986307_REALK, &
      0.000000000000000_REALK,      0.958348785147252_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.684977661736974_REALK,      0.000000000000000_REALK, &
      1.415921028076650_REALK,      0.000000000000000_REALK,      0.534463110501614_REALK, &
      0.000000000000000_REALK,      0.653936469786066_REALK,      0.000000000000000_REALK, &
     -2.694727886058625_REALK,     -1.079819715984769_REALK,      0.000000000000000_REALK, &
     -0.638296701629870_REALK,      0.000000000000000_REALK,     -1.285751763768199_REALK, &
     -0.462342863562646_REALK,      0.000000000000000_REALK,     -0.590385688827645_REALK, &
      0.000000000000000_REALK,     -0.448940191787528_REALK,      0.000000000000000_REALK, &
     -0.424180847269733_REALK,      0.000000000000000_REALK,     -1.196227051773186_REALK, &
     -3.039873418972627_REALK,     -2.252543127788453_REALK,      0.000000000000000_REALK, &
     -2.305992586498073_REALK,      0.000000000000000_REALK,     -2.374916049818299_REALK, &
     -3.069207757036195_REALK,      0.000000000000000_REALK,     -1.505019238450609_REALK, &
      0.000000000000000_REALK,     -5.082889247591779_REALK,      0.000000000000000_REALK, &
     -1.573511308970552_REALK,      0.000000000000000_REALK,     -2.268758450385001_REALK, &
    -75.725582937583241_REALK,      9.352742860055645_REALK,      0.000000000000000_REALK, &
      0.605563367484582_REALK,      0.000000000000000_REALK,     -5.509912773732899_REALK, &
      2.638666556115957_REALK,      0.000000000000000_REALK,      0.783008096451043_REALK, &
      0.000000000000000_REALK,      0.899839211432804_REALK,      0.000000000000000_REALK, &
      0.060893497347829_REALK,      0.000000000000000_REALK,     -1.662177124094038_REALK, &
   -137.355901935332781_REALK,     17.314116769283530_REALK,      0.000000000000000_REALK, &
     -2.357015424736384_REALK,      0.000000000000000_REALK,     -8.072270365963707_REALK, &
     -2.847476291665630_REALK,      0.000000000000000_REALK,      1.141515500995216_REALK, &
      0.000000000000000_REALK,     -7.992734528422908_REALK,      0.000000000000000_REALK, &
     -0.179000352008898_REALK,      0.000000000000000_REALK,     -1.839113000942845_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.662681785644064_REALK, &
      0.000000000000000_REALK,     -0.196320419994846_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.002243403472845_REALK,      0.000000000000000_REALK, &
      1.673391600826655_REALK,      0.000000000000000_REALK,     -0.223001889564364_REALK, &
      0.000000000000000_REALK,     -0.059224043012734_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     12.193224525374081_REALK, &
      0.000000000000000_REALK,     -1.396835120272096_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.867069439418239_REALK,      0.000000000000000_REALK, &
      2.411688968308636_REALK,      0.000000000000000_REALK,     -1.175142738284772_REALK, &
      0.000000000000000_REALK,     -0.318242268085787_REALK,      0.000000000000000_REALK, &
     -9.051989824966622_REALK,     -0.615614193682787_REALK,      0.000000000000000_REALK, &
     -0.240438991825058_REALK,      0.000000000000000_REALK,     -1.975911142423049_REALK, &
      0.030955305409478_REALK,      0.000000000000000_REALK,     -0.154616962688826_REALK, &
      0.000000000000000_REALK,      0.006681805337048_REALK,      0.000000000000000_REALK, &
     -0.072533306490274_REALK,      0.000000000000000_REALK,     -0.993456229118314_REALK, &
    -24.260518988844893_REALK,     -1.769562065779593_REALK,      0.000000000000000_REALK, &
     -1.177197514694071_REALK,      0.000000000000000_REALK,     -4.277300044713466_REALK, &
     -0.919978518519704_REALK,      0.000000000000000_REALK,     -0.350000387829909_REALK, &
      0.000000000000000_REALK,     -1.105978129057989_REALK,      0.000000000000000_REALK, &
     -0.268202024436653_REALK,      0.000000000000000_REALK,     -1.624168865456233_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.675367416447161_REALK, &
      0.000000000000000_REALK,      0.446896375146869_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.174468605465053_REALK,      0.000000000000000_REALK, &
      1.119903743428146_REALK,      0.000000000000000_REALK,      0.041145516729472_REALK, &
      0.000000000000000_REALK,      0.224692284044520_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      7.506888620732526_REALK, &
      0.000000000000000_REALK,      0.698977150424025_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.058754418707900_REALK,      0.000000000000000_REALK, &
      2.474636690683869_REALK,      0.000000000000000_REALK,     -0.310544984406367_REALK, &
      0.000000000000000_REALK,      0.265414376713446_REALK,      0.000000000000000_REALK, &
     -4.257736327462565_REALK,     -1.128481513912952_REALK,      0.000000000000000_REALK, &
     -0.545999040224777_REALK,      0.000000000000000_REALK,     -1.548998031300022_REALK, &
     -0.332412556921124_REALK,      0.000000000000000_REALK,     -0.472380228618792_REALK, &
      0.000000000000000_REALK,     -0.296747536693701_REALK,      0.000000000000000_REALK, &
     -0.274519504424046_REALK,      0.000000000000000_REALK,     -1.090335690743602_REALK, &
    -20.035126471686958_REALK,     -5.792631579519353_REALK,      0.000000000000000_REALK, &
     -2.848051538381324_REALK,      0.000000000000000_REALK,     -5.887222733678955_REALK, &
     -1.560664527799584_REALK,      0.000000000000000_REALK,     -1.909533944955994_REALK, &
      0.000000000000000_REALK,     -0.631726839496239_REALK,      0.000000000000000_REALK, &
     -1.081457131250550_REALK,      0.000000000000000_REALK,     -3.129680236440660_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.470639778088229_REALK, &
      0.000000000000000_REALK,      0.918813232300142_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.513419268717851_REALK,      0.000000000000000_REALK, &
      1.447887197394741_REALK,      0.000000000000000_REALK,      0.361773627880093_REALK, &
      0.000000000000000_REALK,      0.646750247618809_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     14.354913286367914_REALK, &
      0.000000000000000_REALK,      6.257681960742066_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      4.594747955002999_REALK,      0.000000000000000_REALK, &
      6.624911553462084_REALK,      0.000000000000000_REALK,      4.845729724556842_REALK, &
      0.000000000000000_REALK,      3.326618414898532_REALK,      0.000000000000000_REALK, &
    -28.897438556164968_REALK,     -1.714148374898241_REALK,      0.000000000000000_REALK, &
    -10.256514994831456_REALK,      0.000000000000000_REALK,    -12.522746433173305_REALK, &
     -1.709089869637400_REALK,      0.000000000000000_REALK,     -0.868946970894826_REALK, &
      0.000000000000000_REALK,    -31.012142932643535_REALK,      0.000000000000000_REALK, &
    -12.795080880843946_REALK,      0.000000000000000_REALK,    -46.866665785648422_REALK, &
     -7.284360292388422_REALK,     -0.650674805024998_REALK,      0.000000000000000_REALK, &
     -5.614575789015500_REALK,      0.000000000000000_REALK,     -4.994291003216730_REALK, &
     -3.191852472253702_REALK,      0.000000000000000_REALK,     -0.551807623787118_REALK, &
      0.000000000000000_REALK,    -64.442087733685625_REALK,      0.000000000000000_REALK, &
     -8.353034011587791_REALK,      0.000000000000000_REALK,    -22.290632906899258_REALK, &
    -19.689533645564563_REALK,      1.270988072593687_REALK,      0.000000000000000_REALK, &
     -4.763600230655423_REALK,      0.000000000000000_REALK,     -7.550260589863843_REALK, &
      1.090374123231897_REALK,      0.000000000000000_REALK,      0.548897411932659_REALK, &
      0.000000000000000_REALK,    -14.894909838355272_REALK,      0.000000000000000_REALK, &
     -5.102800486148438_REALK,      0.000000000000000_REALK,    -24.263669205845776_REALK, &
     -9.127334340444406_REALK,      0.249717129993039_REALK,      0.000000000000000_REALK, &
     -2.999095578935218_REALK,      0.000000000000000_REALK,     -3.271110121982749_REALK, &
     -1.200578728918745_REALK,      0.000000000000000_REALK,      0.117175086246010_REALK, &
      0.000000000000000_REALK,    -15.777372306999474_REALK,      0.000000000000000_REALK, &
     -3.539396491527912_REALK,      0.000000000000000_REALK,    -11.581247130434253_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.453204871414533_REALK, &
      0.000000000000000_REALK,      1.019358964285105_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.221440413818928_REALK,      0.000000000000000_REALK, &
      4.473972473064978_REALK,      0.000000000000000_REALK,      2.147692267080746_REALK, &
      0.000000000000000_REALK,      3.275832458634831_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.160817193167822_REALK, &
      0.000000000000000_REALK,      0.796957293457936_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.139850983865434_REALK,      0.000000000000000_REALK, &
      3.041768992519959_REALK,      0.000000000000000_REALK,      5.440377959770213_REALK, &
      0.000000000000000_REALK,      2.821598486064986_REALK,      0.000000000000000_REALK, &
    -16.189601244807204_REALK,      5.515360550000157_REALK,      0.000000000000000_REALK, &
     -3.193678826969336_REALK,      0.000000000000000_REALK,     -5.225669889796095_REALK, &
      4.848894886131608_REALK,      0.000000000000000_REALK,      2.075045605394806_REALK, &
      0.000000000000000_REALK,     -5.479245881493140_REALK,      0.000000000000000_REALK, &
     -2.741682280809112_REALK,      0.000000000000000_REALK,    -13.458266142379273_REALK, &
     -4.047893454562189_REALK,      2.732515311147422_REALK,      0.000000000000000_REALK, &
     -0.529728744520439_REALK,      0.000000000000000_REALK,     -2.259435307211511_REALK, &
      4.179154059186831_REALK,      0.000000000000000_REALK,      1.387199660201836_REALK, &
      0.000000000000000_REALK,      6.292457258006236_REALK,      0.000000000000000_REALK, &
     -0.501489239885166_REALK,      0.000000000000000_REALK,     -6.416958716157538_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.330710891111867_REALK, &
      0.000000000000000_REALK,     -0.427023427660051_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.790613164172815_REALK,      0.000000000000000_REALK, &
      3.759342803495649_REALK,      0.000000000000000_REALK,     -0.728218892145450_REALK, &
      0.000000000000000_REALK,     -1.099762338547615_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.739499043797285_REALK, &
      0.000000000000000_REALK,     -0.106054581358802_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.809646990091069_REALK,      0.000000000000000_REALK, &
      2.649243141620766_REALK,      0.000000000000000_REALK,      1.028709797658640_REALK, &
      0.000000000000000_REALK,     -0.301202635927073_REALK,      0.000000000000000_REALK, &
     -3.594402873078315_REALK,     -0.449678519554004_REALK,      0.000000000000000_REALK, &
     -0.950238898658644_REALK,      0.000000000000000_REALK,     -3.480597683960858_REALK, &
     -0.332757234690128_REALK,      0.000000000000000_REALK,     -0.507548016515956_REALK, &
      0.000000000000000_REALK,     -1.977185569867350_REALK,      0.000000000000000_REALK, &
     -2.447259062797096_REALK,      0.000000000000000_REALK,    -14.939969724188455_REALK, &
     -1.644100220720047_REALK,     -0.423803051019590_REALK,      0.000000000000000_REALK, &
     -1.031673393877133_REALK,      0.000000000000000_REALK,     -2.753089819917868_REALK, &
     -1.244501894780444_REALK,      0.000000000000000_REALK,     -0.645448659667356_REALK, &
      0.000000000000000_REALK,     -7.534868236606183_REALK,      0.000000000000000_REALK, &
     -2.930026611489065_REALK,      0.000000000000000_REALK,    -13.031621706464991_REALK, &
    -14.581013691459143_REALK,     10.906065803249170_REALK,      0.000000000000000_REALK, &
     -4.441471203649567_REALK,      0.000000000000000_REALK,     -3.840288961124446_REALK, &
      7.621716737561525_REALK,      0.000000000000000_REALK,      3.484874043066983_REALK, &
      0.000000000000000_REALK,    -10.692106111037480_REALK,      0.000000000000000_REALK, &
     -2.901238794603795_REALK,      0.000000000000000_REALK,     -7.525611315917939_REALK, &
    -11.932919573582307_REALK,      7.350134465129896_REALK,      0.000000000000000_REALK, &
     -4.286228341249380_REALK,      0.000000000000000_REALK,     -2.702189572058281_REALK, &
      2.495902974146346_REALK,      0.000000000000000_REALK,      2.295242676679302_REALK, &
      0.000000000000000_REALK,    -15.765342656172635_REALK,      0.000000000000000_REALK, &
     -2.610618183253510_REALK,      0.000000000000000_REALK,     -4.937477429882170_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.214450908219729_REALK, &
      0.000000000000000_REALK,     -1.466464139613109_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.627733111035619_REALK,      0.000000000000000_REALK, &
      3.081392520875135_REALK,      0.000000000000000_REALK,     -2.238428343422243_REALK, &
      0.000000000000000_REALK,     -2.873752271034546_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.570188356062884_REALK, &
      0.000000000000000_REALK,     -1.408736849183890_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.188170659248197_REALK,      0.000000000000000_REALK, &
      2.407795134875330_REALK,      0.000000000000000_REALK,     -2.584921371846089_REALK, &
      0.000000000000000_REALK,     -2.574063074409185_REALK,      0.000000000000000_REALK, &
     -3.362469006767236_REALK,      0.262673661716223_REALK,      0.000000000000000_REALK, &
     -0.558737528732479_REALK,      0.000000000000000_REALK,     -2.656780841590258_REALK, &
      0.166732343087715_REALK,      0.000000000000000_REALK,      0.251800596665988_REALK, &
      0.000000000000000_REALK,     -1.065353552663450_REALK,      0.000000000000000_REALK, &
     -1.094928405498419_REALK,      0.000000000000000_REALK,     -8.677255005107464_REALK, &
     -3.960247832586391_REALK,      0.120640873958866_REALK,      0.000000000000000_REALK, &
     -0.822217293223788_REALK,      0.000000000000000_REALK,     -2.690374387422970_REALK, &
     -0.385996319372339_REALK,      0.000000000000000_REALK,      0.113018374198159_REALK, &
      0.000000000000000_REALK,     -2.232338861409789_REALK,      0.000000000000000_REALK, &
     -1.502366588092105_REALK,      0.000000000000000_REALK,     -8.193147607155545_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.141009788659273_REALK, &
      0.000000000000000_REALK,      0.358691376911110_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.560322235640802_REALK,      0.000000000000000_REALK, &
      3.420642041343716_REALK,      0.000000000000000_REALK,      0.460838960072875_REALK, &
      0.000000000000000_REALK,      1.171514223855894_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.131737994782858_REALK, &
      0.000000000000000_REALK,      0.655469675502558_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.099415491397002_REALK,      0.000000000000000_REALK, &
      4.889773603398046_REALK,      0.000000000000000_REALK,      2.309275632983151_REALK, &
      0.000000000000000_REALK,      1.996138466271570_REALK,      0.000000000000000_REALK, &
    -10.593286253178665_REALK,     19.751368680148687_REALK,      0.000000000000000_REALK, &
     -7.733840635177544_REALK,      0.000000000000000_REALK,     -2.249045626910445_REALK, &
     12.508925130849729_REALK,      0.000000000000000_REALK,      5.188447077617870_REALK, &
      0.000000000000000_REALK,    -15.977541919996339_REALK,      0.000000000000000_REALK, &
     -3.699693133281944_REALK,      0.000000000000000_REALK,     -3.227676540606918_REALK, &
     -7.112210234901145_REALK,     13.618253874346250_REALK,      0.000000000000000_REALK, &
     -6.124971525931477_REALK,      0.000000000000000_REALK,     -2.626691835572983_REALK, &
     12.776597570798613_REALK,      0.000000000000000_REALK,      4.608220442310052_REALK, &
      0.000000000000000_REALK,     -3.863513636706565_REALK,      0.000000000000000_REALK, &
     -2.909361409991268_REALK,      0.000000000000000_REALK,     -3.743035782289444_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.112952610923746_REALK, &
      0.000000000000000_REALK,     -2.612723827489909_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.945748479603073_REALK,      0.000000000000000_REALK, &
      2.453205669712907_REALK,      0.000000000000000_REALK,     -2.733566913872481_REALK, &
      0.000000000000000_REALK,     -3.749602633299397_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.651885230984307_REALK, &
      0.000000000000000_REALK,     -2.291394154982305_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.423396962006908_REALK,      0.000000000000000_REALK, &
      2.692078994452285_REALK,      0.000000000000000_REALK,     -1.183566022492103_REALK, &
      0.000000000000000_REALK,     -3.265236598094016_REALK,      0.000000000000000_REALK, &
     -3.627142612649640_REALK,      1.188721322391849_REALK,      0.000000000000000_REALK, &
     -0.470632004554090_REALK,      0.000000000000000_REALK,     -2.310220559379029_REALK, &
      0.729684921637454_REALK,      0.000000000000000_REALK,      0.936788397474176_REALK, &
      0.000000000000000_REALK,     -0.449941038902188_REALK,      0.000000000000000_REALK, &
     -0.675418880872056_REALK,      0.000000000000000_REALK,     -5.525784369686037_REALK, &
     -2.169526353920999_REALK,      1.382511605893189_REALK,      0.000000000000000_REALK, &
     -0.187855146264663_REALK,      0.000000000000000_REALK,     -2.403757892141634_REALK, &
      1.409386194930659_REALK,      0.000000000000000_REALK,      1.403465885448636_REALK, &
      0.000000000000000_REALK,      1.119632127973304_REALK,      0.000000000000000_REALK, &
     -0.267693577462415_REALK,      0.000000000000000_REALK,     -5.708924866630525_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.153596497868477_REALK, &
      0.000000000000000_REALK,     -0.188783126894999_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.356925764504594_REALK,      0.000000000000000_REALK, &
      2.828619534342484_REALK,      0.000000000000000_REALK,     -0.179398171920057_REALK, &
      0.000000000000000_REALK,     -0.451547731069124_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.640289999487699_REALK, &
      0.000000000000000_REALK,     -0.112828871942175_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.819140865189985_REALK,      0.000000000000000_REALK, &
      4.467180029660776_REALK,      0.000000000000000_REALK,      0.549122461668244_REALK, &
      0.000000000000000_REALK,     -0.267968564891810_REALK,      0.000000000000000_REALK, &
     -2.415886277400634_REALK,     -0.290756573157540_REALK,      0.000000000000000_REALK, &
     -0.420091870764638_REALK,      0.000000000000000_REALK,     -2.564566999060593_REALK, &
     -0.150224706301813_REALK,      0.000000000000000_REALK,     -0.381891279720183_REALK, &
      0.000000000000000_REALK,     -0.487083596164206_REALK,      0.000000000000000_REALK, &
     -1.004811892907474_REALK,      0.000000000000000_REALK,     -8.587812905241872_REALK, &
     -2.643537037754317_REALK,     -0.643267359846735_REALK,      0.000000000000000_REALK, &
     -1.097572059146615_REALK,      0.000000000000000_REALK,     -4.881574731881198_REALK, &
     -1.259094854050361_REALK,      0.000000000000000_REALK,     -1.088361923954382_REALK, &
      0.000000000000000_REALK,     -4.022091948427253_REALK,      0.000000000000000_REALK, &
     -2.606733582390159_REALK,      0.000000000000000_REALK,    -16.231235621841748_REALK, &
      9.383242566334909_REALK,     39.105833020657172_REALK,      0.000000000000000_REALK, &
    -16.062104563558613_REALK,      0.000000000000000_REALK,      1.472680258894006_REALK, &
     21.967830220168587_REALK,      0.000000000000000_REALK,      7.772480397303306_REALK, &
      0.000000000000000_REALK,    -27.358871583883907_REALK,      0.000000000000000_REALK, &
     -5.298716943155471_REALK,      0.000000000000000_REALK,      1.457464520064748_REALK, &
    -42.252527309606627_REALK,     78.288755479934593_REALK,      0.000000000000000_REALK, &
    -39.961914733886047_REALK,      0.000000000000000_REALK,     -5.336174192968477_REALK, &
     28.622654336947537_REALK,      0.000000000000000_REALK,     12.280111139775279_REALK, &
      0.000000000000000_REALK,    -50.497268678258642_REALK,      0.000000000000000_REALK, &
     -9.133633938229980_REALK,      0.000000000000000_REALK,     -3.658883366857956_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.546671434688909_REALK, &
      0.000000000000000_REALK,     -4.740535508129994_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.740555850449929_REALK,      0.000000000000000_REALK, &
      1.518491151489031_REALK,      0.000000000000000_REALK,     -3.770320567288922_REALK, &
      0.000000000000000_REALK,     -4.691556274676633_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      9.028025809648085_REALK, &
      0.000000000000000_REALK,    -10.214834277874813_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.302103259454644_REALK,      0.000000000000000_REALK, &
      4.248317384876027_REALK,      0.000000000000000_REALK,     -6.473074536009106_REALK, &
      0.000000000000000_REALK,     -7.004060565297113_REALK,      0.000000000000000_REALK, &
     -4.760441098012174_REALK,      2.958476723898217_REALK,      0.000000000000000_REALK, &
     -0.864103301478933_REALK,      0.000000000000000_REALK,     -2.241423765540116_REALK, &
      1.286032574360139_REALK,      0.000000000000000_REALK,      1.764036249801685_REALK, &
      0.000000000000000_REALK,     -1.050542725558829_REALK,      0.000000000000000_REALK, &
     -0.855175382416124_REALK,      0.000000000000000_REALK,     -3.697108942437189_REALK, &
    -15.750245104229098_REALK,      7.875596707272069_REALK,      0.000000000000000_REALK, &
     -3.155179805426672_REALK,      0.000000000000000_REALK,     -5.967410009034406_REALK, &
      1.343338509691263_REALK,      0.000000000000000_REALK,      3.706018914126314_REALK, &
      0.000000000000000_REALK,     -4.354933045968777_REALK,      0.000000000000000_REALK, &
     -2.163429170796931_REALK,      0.000000000000000_REALK,     -6.819510394434714_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.615941907094034_REALK, &
      0.000000000000000_REALK,     -0.855916731036492_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.317757241548123_REALK,      0.000000000000000_REALK, &
      2.599657854447478_REALK,      0.000000000000000_REALK,     -0.659803949319044_REALK, &
      0.000000000000000_REALK,     -1.411788992758400_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.261794549517866_REALK, &
      0.000000000000000_REALK,     -3.110999487542329_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.303830191614581_REALK,      0.000000000000000_REALK, &
      6.479586669893618_REALK,      0.000000000000000_REALK,     -2.142134125909901_REALK, &
      0.000000000000000_REALK,     -3.555226356200867_REALK,      0.000000000000000_REALK, &
     -3.293358607841434_REALK,      0.213765603890921_REALK,      0.000000000000000_REALK, &
     -0.326112849391790_REALK,      0.000000000000000_REALK,     -2.584428662554099_REALK, &
      0.084399577599152_REALK,      0.000000000000000_REALK,      0.212434928183505_REALK, &
      0.000000000000000_REALK,     -0.314025902832228_REALK,      0.000000000000000_REALK, &
     -0.537905750026492_REALK,      0.000000000000000_REALK,     -5.968028113579057_REALK, &
    -15.681377969264867_REALK,      0.387796525718151_REALK,      0.000000000000000_REALK, &
     -1.815752586687499_REALK,      0.000000000000000_REALK,     -9.902196360541758_REALK, &
     -0.623249852798421_REALK,      0.000000000000000_REALK,      0.304142300273132_REALK, &
      0.000000000000000_REALK,     -1.849947664831906_REALK,      0.000000000000000_REALK, &
     -2.075028131113912_REALK,      0.000000000000000_REALK,    -15.842615685649001_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.903947096807181_REALK, &
      0.000000000000000_REALK,      0.348923125682129_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.472723319420365_REALK,      0.000000000000000_REALK, &
      4.040218325223199_REALK,      0.000000000000000_REALK,      0.226396470504013_REALK, &
      0.000000000000000_REALK,      0.805742117675973_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     16.778132125855485_REALK, &
      0.000000000000000_REALK,      2.412522757259838_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.958622957388529_REALK,      0.000000000000000_REALK, &
     18.422330023281919_REALK,      0.000000000000000_REALK,      3.189509097790289_REALK, &
      0.000000000000000_REALK,      3.859817507603819_REALK,      0.000000000000000_REALK/
    ! results of test 4, ket-major order, 02 DPG Z
  data REF_CONTR_INTS(23941:25200)                                                         &
     /0.000000000000000_REALK,      0.000000000000000_REALK,      6.211621733410870_REALK, &
      0.000000000000000_REALK,      4.859170216875379_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      5.177081100116741_REALK,      0.000000000000000_REALK, &
      3.940273005623677_REALK,      0.000000000000000_REALK,      7.623079027427091_REALK, &
      0.000000000000000_REALK,      4.367706528130445_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.586167934375363_REALK, &
      0.000000000000000_REALK,      2.833046335203413_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.164861827890839_REALK,      0.000000000000000_REALK, &
      2.645937962884114_REALK,      0.000000000000000_REALK,      0.475792142084014_REALK, &
      0.000000000000000_REALK,      2.566034180281501_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.300054562942255_REALK, &
      0.000000000000000_REALK,      1.293166258007054_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.490316059229872_REALK,      0.000000000000000_REALK, &
      1.804342931667367_REALK,      0.000000000000000_REALK,     -0.496430834068408_REALK, &
      0.000000000000000_REALK,      0.956952591415576_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.252740859773023_REALK, &
      0.000000000000000_REALK,     -0.429512993775141_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.499339465821129_REALK,      0.000000000000000_REALK, &
      0.617531996032063_REALK,      0.000000000000000_REALK,     -3.230729900248499_REALK, &
      0.000000000000000_REALK,     -0.289111050501102_REALK,      0.000000000000000_REALK, &
     -5.955487982959789_REALK,     -3.994314244361493_REALK,      0.000000000000000_REALK, &
     -3.563575162119177_REALK,      0.000000000000000_REALK,     -2.712234702000821_REALK, &
     -3.811686406944702_REALK,      0.000000000000000_REALK,     -2.183937427763691_REALK, &
      0.000000000000000_REALK,     -5.228057418123846_REALK,      0.000000000000000_REALK, &
     -2.637071965788581_REALK,      0.000000000000000_REALK,     -3.345122885445173_REALK, &
     -6.989821363372716_REALK,     -3.658078890679596_REALK,      0.000000000000000_REALK, &
     -2.100636241988287_REALK,      0.000000000000000_REALK,     -2.567440151273846_REALK, &
     -0.334353687490897_REALK,      0.000000000000000_REALK,     -1.803230685245962_REALK, &
      0.000000000000000_REALK,      3.891090721156866_REALK,      0.000000000000000_REALK, &
     -1.413966886784952_REALK,      0.000000000000000_REALK,     -2.880298268004151_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.571278720541648_REALK, &
      0.000000000000000_REALK,      0.504600618623847_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.017972819362684_REALK,      0.000000000000000_REALK, &
      1.202897398899180_REALK,      0.000000000000000_REALK,     -0.407742491812164_REALK, &
      0.000000000000000_REALK,      0.306658201365707_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.011296997498101_REALK, &
      0.000000000000000_REALK,      0.016944119217806_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.176472182518933_REALK,      0.000000000000000_REALK, &
      0.553709303945545_REALK,      0.000000000000000_REALK,     -0.212743087780571_REALK, &
      0.000000000000000_REALK,      0.010336296541192_REALK,      0.000000000000000_REALK, &
     -3.616132631806488_REALK,     -1.222722722071173_REALK,      0.000000000000000_REALK, &
     -0.388915371330968_REALK,      0.000000000000000_REALK,     -1.431192570726774_REALK, &
      0.296739758195250_REALK,      0.000000000000000_REALK,     -0.572014994019983_REALK, &
      0.000000000000000_REALK,      1.324872804517070_REALK,      0.000000000000000_REALK, &
     -0.236353432504877_REALK,      0.000000000000000_REALK,     -1.449618184324244_REALK, &
     -0.991266466390994_REALK,      0.433583168012831_REALK,      0.000000000000000_REALK, &
      1.483761013013378_REALK,      0.000000000000000_REALK,     -0.611115708542296_REALK, &
      2.652842562229552_REALK,      0.000000000000000_REALK,      0.237397159051033_REALK, &
      0.000000000000000_REALK,      4.433125363884175_REALK,      0.000000000000000_REALK, &
      0.905127828105032_REALK,      0.000000000000000_REALK,     -0.621324042014899_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.564489273666347_REALK, &
      0.000000000000000_REALK,      1.732284349438596_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.576300349957197_REALK,      0.000000000000000_REALK, &
      1.999535258568592_REALK,      0.000000000000000_REALK,      1.837396815695969_REALK, &
      0.000000000000000_REALK,      1.754586311254603_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.591769866351092_REALK, &
      0.000000000000000_REALK,      1.784494738669509_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.161047705831991_REALK,      0.000000000000000_REALK, &
      2.365093360695287_REALK,      0.000000000000000_REALK,      0.201844101270158_REALK, &
      0.000000000000000_REALK,      1.814303688296899_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.417450416763578_REALK, &
      0.000000000000000_REALK,     -0.019674870264106_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.306233763932287_REALK,      0.000000000000000_REALK, &
      0.951227916492390_REALK,      0.000000000000000_REALK,     -0.623169643557493_REALK, &
      0.000000000000000_REALK,     -0.009730452734738_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.168042656535920_REALK, &
      0.000000000000000_REALK,     -0.806253196373499_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.025176857471578_REALK,      0.000000000000000_REALK, &
      0.387447791494563_REALK,      0.000000000000000_REALK,     -1.404629835276401_REALK, &
      0.000000000000000_REALK,     -0.339517472823671_REALK,      0.000000000000000_REALK, &
     -3.351897614937781_REALK,     -0.564923699987577_REALK,      0.000000000000000_REALK, &
     -0.016850430402729_REALK,      0.000000000000000_REALK,     -1.127777367186891_REALK, &
      0.295561727074364_REALK,      0.000000000000000_REALK,     -0.222288403679350_REALK, &
      0.000000000000000_REALK,      0.533097708987965_REALK,      0.000000000000000_REALK, &
     -0.008333590737463_REALK,      0.000000000000000_REALK,     -0.929593962536301_REALK, &
     -3.242803154941400_REALK,     -0.035806446229806_REALK,      0.000000000000000_REALK, &
      0.273262760575350_REALK,      0.000000000000000_REALK,     -0.857405007365293_REALK, &
      0.244459097404684_REALK,      0.000000000000000_REALK,     -0.011877244752474_REALK, &
      0.000000000000000_REALK,      0.031972130892319_REALK,      0.000000000000000_REALK, &
      0.115072389547939_REALK,      0.000000000000000_REALK,     -0.601762950308087_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.602286189530827_REALK, &
      0.000000000000000_REALK,      0.536293090780347_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.171326339819586_REALK,      0.000000000000000_REALK, &
      1.050789806706369_REALK,      0.000000000000000_REALK,     -0.137591529210334_REALK, &
      0.000000000000000_REALK,      0.442050739662279_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.291414530128808_REALK, &
      0.000000000000000_REALK,     -0.367603562833881_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.040065433865651_REALK,      0.000000000000000_REALK, &
      0.713951819029034_REALK,      0.000000000000000_REALK,     -1.729841657607887_REALK, &
      0.000000000000000_REALK,     -0.257999664819353_REALK,      0.000000000000000_REALK, &
     -3.343046948300104_REALK,     -1.939372343189547_REALK,      0.000000000000000_REALK, &
     -1.477861586696722_REALK,      0.000000000000000_REALK,     -1.874665795744105_REALK, &
     -1.331880260392905_REALK,      0.000000000000000_REALK,     -1.271853120214774_REALK, &
      0.000000000000000_REALK,     -1.449016389783650_REALK,      0.000000000000000_REALK, &
     -1.218158165280797_REALK,      0.000000000000000_REALK,     -2.163325208220405_REALK, &
     -8.310713391098695_REALK,     -3.771008341371599_REALK,      0.000000000000000_REALK, &
     -1.797853331480658_REALK,      0.000000000000000_REALK,     -3.662287911539190_REALK, &
     -0.231935276147988_REALK,      0.000000000000000_REALK,     -2.084782385581009_REALK, &
      0.000000000000000_REALK,      2.083421093936369_REALK,      0.000000000000000_REALK, &
     -1.261809198312849_REALK,      0.000000000000000_REALK,     -3.598487090035324_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.770233510510855_REALK, &
      0.000000000000000_REALK,     -0.485729476439988_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.438668579580352_REALK,      0.000000000000000_REALK, &
      0.908766266315947_REALK,      0.000000000000000_REALK,     -0.575725882868478_REALK, &
      0.000000000000000_REALK,     -0.193675267630952_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.199244455998314_REALK, &
      0.000000000000000_REALK,     -0.732487988106106_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.432759042380753_REALK,      0.000000000000000_REALK, &
      0.480759535020686_REALK,      0.000000000000000_REALK,     -0.176558465378530_REALK, &
      0.000000000000000_REALK,     -0.299891198189940_REALK,      0.000000000000000_REALK, &
     -3.787628151215093_REALK,      0.026674772115247_REALK,      0.000000000000000_REALK, &
      0.349083469058506_REALK,      0.000000000000000_REALK,     -1.084328314064942_REALK, &
      0.560415035990385_REALK,      0.000000000000000_REALK,      0.008750573902173_REALK, &
      0.000000000000000_REALK,      0.707567935209299_REALK,      0.000000000000000_REALK, &
      0.139190305663486_REALK,      0.000000000000000_REALK,     -0.720591696313263_REALK, &
     -1.190603496316669_REALK,      1.105120509119342_REALK,      0.000000000000000_REALK, &
      1.476715286737693_REALK,      0.000000000000000_REALK,     -0.558098900051147_REALK, &
      1.832861231060892_REALK,      0.000000000000000_REALK,      0.443026623511683_REALK, &
      0.000000000000000_REALK,      2.320439985557827_REALK,      0.000000000000000_REALK, &
      0.604588640245412_REALK,      0.000000000000000_REALK,     -0.380822963567337_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.529016652339797_REALK, &
      0.000000000000000_REALK,      0.253392069154801_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.007494379101015_REALK,      0.000000000000000_REALK, &
      0.835981725613633_REALK,      0.000000000000000_REALK,     -0.134339618876922_REALK, &
      0.000000000000000_REALK,      0.168392006900642_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.175233614605179_REALK, &
      0.000000000000000_REALK,      0.017108568889822_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.150154664432606_REALK,      0.000000000000000_REALK, &
      0.785223234056877_REALK,      0.000000000000000_REALK,     -0.144167508482424_REALK, &
      0.000000000000000_REALK,      0.011674160093168_REALK,      0.000000000000000_REALK, &
     -2.510440022134958_REALK,     -0.727094806294371_REALK,      0.000000000000000_REALK, &
     -0.195299147544494_REALK,      0.000000000000000_REALK,     -1.197821384115842_REALK, &
      0.123735747707787_REALK,      0.000000000000000_REALK,     -0.397535219724734_REALK, &
      0.000000000000000_REALK,      0.436508117729397_REALK,      0.000000000000000_REALK, &
     -0.129786285382559_REALK,      0.000000000000000_REALK,     -1.114419115142738_REALK, &
     -1.316358307774030_REALK,      0.503869303514510_REALK,      0.000000000000000_REALK, &
      1.498161526182773_REALK,      0.000000000000000_REALK,     -1.028411397965630_REALK, &
      2.257220821085371_REALK,      0.000000000000000_REALK,      0.336656371236088_REALK, &
      0.000000000000000_REALK,      3.004152309571717_REALK,      0.000000000000000_REALK, &
      1.022281735819945_REALK,      0.000000000000000_REALK,     -0.982441905592952_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.541632154238439_REALK, &
      0.000000000000000_REALK,      1.449816942574724_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.095486853532583_REALK,      0.000000000000000_REALK, &
      1.945473414755471_REALK,      0.000000000000000_REALK,      1.008950472839021_REALK, &
      0.000000000000000_REALK,      1.348868650776080_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.019849222981428_REALK, &
      0.000000000000000_REALK,      3.003023327996168_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.646498673530278_REALK,      0.000000000000000_REALK, &
      4.695562711368019_REALK,      0.000000000000000_REALK,      0.227969499781560_REALK, &
      0.000000000000000_REALK,      2.868789636844577_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.302252659510170_REALK, &
      0.000000000000000_REALK,     -1.458125860113063_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.700546448727510_REALK,      0.000000000000000_REALK, &
      1.080548898578760_REALK,      0.000000000000000_REALK,     -0.731556166635766_REALK, &
      0.000000000000000_REALK,     -0.439873288064390_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.521923760980751_REALK, &
      0.000000000000000_REALK,     -4.807869876262475_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.552862666384057_REALK,      0.000000000000000_REALK, &
      0.894387996152757_REALK,      0.000000000000000_REALK,     -2.301842197307848_REALK, &
      0.000000000000000_REALK,     -1.095381546381116_REALK,      0.000000000000000_REALK, &
     -6.479183260636566_REALK,      0.933354788770063_REALK,      0.000000000000000_REALK, &
      0.682696927009017_REALK,      0.000000000000000_REALK,     -1.414306759733891_REALK, &
      0.696846082671694_REALK,      0.000000000000000_REALK,      0.234420330186635_REALK, &
      0.000000000000000_REALK,      0.565261965122968_REALK,      0.000000000000000_REALK, &
      0.205949397270567_REALK,      0.000000000000000_REALK,     -0.711090610389881_REALK, &
    -11.337824044811335_REALK,      4.427441362979427_REALK,      0.000000000000000_REALK, &
      1.799358030560431_REALK,      0.000000000000000_REALK,     -1.998938081915037_REALK, &
      0.515561370999749_REALK,      0.000000000000000_REALK,      0.875700391697925_REALK, &
      0.000000000000000_REALK,     -0.746425883833616_REALK,      0.000000000000000_REALK, &
      0.409949443877371_REALK,      0.000000000000000_REALK,     -0.759033259926167_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.083594003701612_REALK, &
      0.000000000000000_REALK,     -0.013618458651162_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.168472917639581_REALK,      0.000000000000000_REALK, &
      0.872188511448876_REALK,      0.000000000000000_REALK,     -0.263107831871605_REALK, &
      0.000000000000000_REALK,     -0.006847141193503_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.373366109536577_REALK, &
      0.000000000000000_REALK,     -1.842049350101054_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.765435305452666_REALK,      0.000000000000000_REALK, &
      1.112026029361033_REALK,      0.000000000000000_REALK,     -1.736255904080501_REALK, &
      0.000000000000000_REALK,     -0.699459746053059_REALK,      0.000000000000000_REALK, &
     -3.576153079329286_REALK,     -0.486906215606638_REALK,      0.000000000000000_REALK, &
     -0.011663451225520_REALK,      0.000000000000000_REALK,     -1.301032674047681_REALK, &
      0.162601751888540_REALK,      0.000000000000000_REALK,     -0.203818021481490_REALK, &
      0.000000000000000_REALK,      0.225078650472811_REALK,      0.000000000000000_REALK, &
     -0.005864195015774_REALK,      0.000000000000000_REALK,     -0.915793519858268_REALK, &
    -11.110822207511520_REALK,     -0.103410822831416_REALK,      0.000000000000000_REALK, &
      0.624324334822803_REALK,      0.000000000000000_REALK,     -3.264860103696622_REALK, &
      0.420977822657575_REALK,      0.000000000000000_REALK,     -0.034089251795434_REALK, &
      0.000000000000000_REALK,      0.039520590858659_REALK,      0.000000000000000_REALK, &
      0.237067340604065_REALK,      0.000000000000000_REALK,     -1.735617727324827_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.301676919320820_REALK, &
      0.000000000000000_REALK,      0.618681358814345_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.157090496092925_REALK,      0.000000000000000_REALK, &
      1.348868650776080_REALK,      0.000000000000000_REALK,     -0.096820636533166_REALK, &
      0.000000000000000_REALK,      0.435488201458129_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.216117172494793_REALK, &
      0.000000000000000_REALK,     -1.399775130729723_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.985124344717063_REALK,      0.000000000000000_REALK, &
      2.868789636844578_REALK,      0.000000000000000_REALK,     -3.563747681318333_REALK, &
      0.000000000000000_REALK,     -0.744128218055093_REALK,      0.000000000000000_REALK, &
     -5.944517112350057_REALK,     -2.785899666023825_REALK,      0.000000000000000_REALK, &
     -1.704898739729501_REALK,      0.000000000000000_REALK,     -3.027727044188760_REALK, &
     -1.221211700791713_REALK,      0.000000000000000_REALK,     -1.632641267835256_REALK, &
      0.000000000000000_REALK,     -1.019646267550210_REALK,      0.000000000000000_REALK, &
     -1.200073794458435_REALK,      0.000000000000000_REALK,     -2.740126116792522_REALK, &
    -47.458353413248012_REALK,    -18.151437173378451_REALK,      0.000000000000000_REALK, &
     -6.845935775773332_REALK,      0.000000000000000_REALK,    -19.523563103891210_REALK, &
     -0.665684693178129_REALK,      0.000000000000000_REALK,     -8.377038818900605_REALK, &
      0.000000000000000_REALK,      4.292177298466041_REALK,      0.000000000000000_REALK, &
     -3.639337403494313_REALK,      0.000000000000000_REALK,    -13.344215605249142_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.896393742318006_REALK, &
      0.000000000000000_REALK,      4.073059299652455_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.874794973917649_REALK,      0.000000000000000_REALK, &
      4.404774882551287_REALK,      0.000000000000000_REALK,     13.640744611844257_REALK, &
      0.000000000000000_REALK,     15.243517860927131_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.115012168819193_REALK, &
      0.000000000000000_REALK,      2.057671733846373_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.712522138332074_REALK,      0.000000000000000_REALK, &
      2.836772888476302_REALK,      0.000000000000000_REALK,     -0.447479099688960_REALK, &
      0.000000000000000_REALK,      9.183847163197026_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.387378240481672_REALK, &
      0.000000000000000_REALK,     -0.708704756220379_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.264307176097865_REALK,      0.000000000000000_REALK, &
      3.093087415440262_REALK,      0.000000000000000_REALK,     -6.981538278024943_REALK, &
      0.000000000000000_REALK,     -2.277507850871536_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.784381421814500_REALK, &
      0.000000000000000_REALK,     -1.662263146150412_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.625394977774661_REALK,      0.000000000000000_REALK, &
      1.104168874038925_REALK,      0.000000000000000_REALK,    -11.924304759524860_REALK, &
      0.000000000000000_REALK,     -5.885182575177940_REALK,      0.000000000000000_REALK, &
     -4.491690508564955_REALK,     -1.123164817732078_REALK,      0.000000000000000_REALK, &
     -2.199316099682826_REALK,      0.000000000000000_REALK,     -5.167227589921576_REALK, &
     -1.302168927156512_REALK,      0.000000000000000_REALK,     -1.455172416454390_REALK, &
      0.000000000000000_REALK,     -7.108333282336742_REALK,      0.000000000000000_REALK, &
     -7.067766428278651_REALK,      0.000000000000000_REALK,    -27.675844089737524_REALK, &
     -3.810653499545673_REALK,     -0.890266998364119_REALK,      0.000000000000000_REALK, &
     -1.029071891027484_REALK,      0.000000000000000_REALK,     -4.097056194763842_REALK, &
      0.061062781658987_REALK,      0.000000000000000_REALK,     -1.253223344968764_REALK, &
      0.000000000000000_REALK,      5.755381900228013_REALK,      0.000000000000000_REALK, &
     -3.643391827404655_REALK,      0.000000000000000_REALK,    -24.175798902828284_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.710347253195208_REALK, &
      0.000000000000000_REALK,     -1.764648442791942_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.423057435500157_REALK,      0.000000000000000_REALK, &
      1.930453241959871_REALK,      0.000000000000000_REALK,     -4.695083601187418_REALK, &
      0.000000000000000_REALK,     -4.544701232889356_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.587284074006910_REALK, &
      0.000000000000000_REALK,     -1.211573963892132_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.192453249342130_REALK,      0.000000000000000_REALK, &
      0.894428951136131_REALK,      0.000000000000000_REALK,     -1.141832073101592_REALK, &
      0.000000000000000_REALK,     -3.440957164408581_REALK,      0.000000000000000_REALK, &
     -2.484995685528750_REALK,      0.312636977496503_REALK,      0.000000000000000_REALK, &
      0.205621950183845_REALK,      0.000000000000000_REALK,     -2.406316301515943_REALK, &
      1.081699369545440_REALK,      0.000000000000000_REALK,      0.352870486175930_REALK, &
      0.000000000000000_REALK,      4.266358201681940_REALK,      0.000000000000000_REALK, &
      0.529561757372551_REALK,      0.000000000000000_REALK,    -10.328769928548171_REALK, &
     -0.596812017606788_REALK,      0.883952250288490_REALK,      0.000000000000000_REALK, &
      1.471136821258029_REALK,      0.000000000000000_REALK,     -0.999377695696855_REALK, &
      2.727718547664096_REALK,      0.000000000000000_REALK,      1.346252212639865_REALK, &
      0.000000000000000_REALK,     10.104550444667453_REALK,      0.000000000000000_REALK, &
      4.178134340780344_REALK,      0.000000000000000_REALK,     -4.730507511225559_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.279463206039606_REALK, &
      0.000000000000000_REALK,      1.132074408809470_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.095059310013014_REALK,      0.000000000000000_REALK, &
      4.288015321456640_REALK,      0.000000000000000_REALK,      2.609005459638380_REALK, &
      0.000000000000000_REALK,      4.859268128310409_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.178717642454543_REALK, &
      0.000000000000000_REALK,      1.134286147830894_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.833436218248372_REALK,      0.000000000000000_REALK, &
      5.530282595231964_REALK,      0.000000000000000_REALK,     -0.156964004738273_REALK, &
      0.000000000000000_REALK,      5.369090350222068_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.777020951006009_REALK, &
      0.000000000000000_REALK,     -2.576531143906382_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.369391667338080_REALK,      0.000000000000000_REALK, &
      0.744857089237442_REALK,      0.000000000000000_REALK,     -4.129401411458512_REALK, &
      0.000000000000000_REALK,     -5.049091911750157_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.211341106249196_REALK, &
      0.000000000000000_REALK,     -2.456197236159701_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.724360890646105_REALK,      0.000000000000000_REALK, &
      0.197987858059355_REALK,      0.000000000000000_REALK,     -4.255093363103066_REALK, &
      0.000000000000000_REALK,     -4.487996897878607_REALK,      0.000000000000000_REALK, &
     -1.726655305035662_REALK,      1.085482992467100_REALK,      0.000000000000000_REALK, &
      0.298980685795398_REALK,      0.000000000000000_REALK,     -1.364278667020137_REALK, &
      1.074982121807314_REALK,      0.000000000000000_REALK,      1.040550709911991_REALK, &
      0.000000000000000_REALK,      1.335698992218401_REALK,      0.000000000000000_REALK, &
      0.585896648674048_REALK,      0.000000000000000_REALK,     -4.455841334912624_REALK, &
     -1.337046139514527_REALK,      1.378208654421547_REALK,      0.000000000000000_REALK, &
      0.195441212877738_REALK,      0.000000000000000_REALK,     -0.908315550091062_REALK, &
      0.428442480631214_REALK,      0.000000000000000_REALK,      1.291128755264691_REALK, &
      0.000000000000000_REALK,     -1.612252865733398_REALK,      0.000000000000000_REALK, &
      0.357112834506867_REALK,      0.000000000000000_REALK,     -2.766144151000186_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.480190250053028_REALK, &
      0.000000000000000_REALK,     -0.249378573926036_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.121247984045350_REALK,      0.000000000000000_REALK, &
      2.364865880267224_REALK,      0.000000000000000_REALK,     -1.498056723055203_REALK, &
      0.000000000000000_REALK,     -0.814490019233581_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.136827820912051_REALK, &
      0.000000000000000_REALK,     -1.367153665511410_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.567735119326187_REALK,      0.000000000000000_REALK, &
      1.774998636400839_REALK,      0.000000000000000_REALK,     -5.061506135246315_REALK, &
      0.000000000000000_REALK,     -4.163469528836888_REALK,      0.000000000000000_REALK, &
     -2.301197742148021_REALK,     -0.696369592475713_REALK,      0.000000000000000_REALK, &
     -0.773893935009694_REALK,      0.000000000000000_REALK,     -3.030401203076844_REALK, &
     -0.597355545298410_REALK,      0.000000000000000_REALK,     -1.112573663583049_REALK, &
      0.000000000000000_REALK,     -1.525263636645719_REALK,      0.000000000000000_REALK, &
     -2.527598406259827_REALK,      0.000000000000000_REALK,    -13.856539852041260_REALK, &
     -4.960199232138146_REALK,     -1.290291003373028_REALK,      0.000000000000000_REALK, &
     -0.846375864826927_REALK,      0.000000000000000_REALK,     -5.616143877349306_REALK, &
      0.058896618114082_REALK,      0.000000000000000_REALK,     -2.014610066201554_REALK, &
      0.000000000000000_REALK,      2.442985262970622_REALK,      0.000000000000000_REALK, &
     -2.577515762891006_REALK,      0.000000000000000_REALK,    -23.944419921388533_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.982826759255679_REALK, &
      0.000000000000000_REALK,     -3.608864430303769_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.028604168076400_REALK,      0.000000000000000_REALK, &
     -0.774530318801135_REALK,      0.000000000000000_REALK,     -3.771764653079974_REALK, &
      0.000000000000000_REALK,     -5.179195531005583_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.446986904495247_REALK, &
      0.000000000000000_REALK,     -3.185694362007794_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.658303883700839_REALK,      0.000000000000000_REALK, &
     -0.453761739885048_REALK,      0.000000000000000_REALK,     -1.753709162595895_REALK, &
      0.000000000000000_REALK,     -4.539614364709743_REALK,      0.000000000000000_REALK, &
     -0.876779855342805_REALK,      2.088545792450279_REALK,      0.000000000000000_REALK, &
      0.276944991125430_REALK,      0.000000000000000_REALK,     -0.558443674312173_REALK, &
      1.346106054359101_REALK,      0.000000000000000_REALK,      1.645907606018345_REALK, &
      0.000000000000000_REALK,      0.658103449966290_REALK,      0.000000000000000_REALK, &
      0.397452519503614_REALK,      0.000000000000000_REALK,     -1.335733644277539_REALK, &
     -0.178395524434175_REALK,      2.410472323003953_REALK,      0.000000000000000_REALK, &
      0.723146326873641_REALK,      0.000000000000000_REALK,     -0.197655884200893_REALK, &
      2.320020217797018_REALK,      0.000000000000000_REALK,      2.447007069404334_REALK, &
      0.000000000000000_REALK,      2.889228692962213_REALK,      0.000000000000000_REALK, &
      1.030483492833778_REALK,      0.000000000000000_REALK,     -0.469432714517254_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.105889395699117_REALK, &
      0.000000000000000_REALK,     -0.780134834114676_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.190991126176392_REALK,      0.000000000000000_REALK, &
      1.452519239603521_REALK,      0.000000000000000_REALK,     -1.156643179886947_REALK, &
      0.000000000000000_REALK,     -1.865993640779135_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.891406220076968_REALK, &
      0.000000000000000_REALK,     -1.288963870009315_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.194709945326918_REALK,      0.000000000000000_REALK, &
      1.508194957908367_REALK,      0.000000000000000_REALK,     -0.609506821282713_REALK, &
      0.000000000000000_REALK,     -3.061289123060698_REALK,      0.000000000000000_REALK, &
     -1.670226512735676_REALK,      0.202147205762400_REALK,      0.000000000000000_REALK, &
      0.090903571559677_REALK,      0.000000000000000_REALK,     -1.773017147200609_REALK, &
      0.488337902699975_REALK,      0.000000000000000_REALK,      0.265508202487425_REALK, &
      0.000000000000000_REALK,      1.051025825329745_REALK,      0.000000000000000_REALK, &
      0.217430986333235_REALK,      0.000000000000000_REALK,     -5.937197017477789_REALK, &
     -0.959609793391707_REALK,      1.341702540615671_REALK,      0.000000000000000_REALK, &
      1.565106437538778_REALK,      0.000000000000000_REALK,     -1.772022427900650_REALK, &
      2.759703622040282_REALK,      0.000000000000000_REALK,      2.270063817363398_REALK, &
      0.000000000000000_REALK,      5.393781246038017_REALK,      0.000000000000000_REALK, &
      3.717127706329824_REALK,      0.000000000000000_REALK,     -5.891974441485107_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.456454561820882_REALK, &
      0.000000000000000_REALK,      0.834132793540768_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.823948843581431_REALK,      0.000000000000000_REALK, &
      4.516967552619898_REALK,      0.000000000000000_REALK,      1.071222803649101_REALK, &
      0.000000000000000_REALK,      2.793210850673358_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.511592953147679_REALK, &
      0.000000000000000_REALK,      2.011232091998851_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.405348407499278_REALK,      0.000000000000000_REALK, &
     13.055304215588730_REALK,      0.000000000000000_REALK,     -0.139644923624009_REALK, &
      0.000000000000000_REALK,      6.687346556889201_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -6.050802029328469_REALK, &
      0.000000000000000_REALK,     -5.585339025960215_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.526183137763052_REALK,      0.000000000000000_REALK, &
     -3.607881729772310_REALK,      0.000000000000000_REALK,     -4.279991857257825_REALK, &
      0.000000000000000_REALK,     -5.527631278892502_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -7.943189651477216_REALK, &
      0.000000000000000_REALK,    -11.687920701254153_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.774219811797483_REALK,      0.000000000000000_REALK, &
     -3.737826120487509_REALK,      0.000000000000000_REALK,     -7.066350358649982_REALK, &
      0.000000000000000_REALK,     -8.014119685846287_REALK,      0.000000000000000_REALK, &
      1.502974661602216_REALK,      4.086440864672344_REALK,      0.000000000000000_REALK, &
      0.026134809205561_REALK,      0.000000000000000_REALK,      0.707666171297978_REALK, &
      1.774462582958849_REALK,      0.000000000000000_REALK,      2.436601836249890_REALK, &
      0.000000000000000_REALK,     -0.334844556157340_REALK,      0.000000000000000_REALK, &
      0.025864784243372_REALK,      0.000000000000000_REALK,      1.167257602239079_REALK, &
      2.654772997686504_REALK,     10.949335788978448_REALK,      0.000000000000000_REALK, &
     -1.459232508658926_REALK,      0.000000000000000_REALK,      1.005833169786986_REALK, &
      1.990446673987045_REALK,      0.000000000000000_REALK,      5.152428068543108_REALK, &
      0.000000000000000_REALK,     -4.153847967913087_REALK,      0.000000000000000_REALK, &
     -1.000559832050837_REALK,      0.000000000000000_REALK,      1.149458432727916_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.632344909430402_REALK, &
      0.000000000000000_REALK,     -1.503818644135326_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.186985320991853_REALK,      0.000000000000000_REALK, &
      0.628408607264050_REALK,      0.000000000000000_REALK,     -1.217191234917280_REALK, &
      0.000000000000000_REALK,     -2.480468638957587_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.679349743212347_REALK, &
      0.000000000000000_REALK,     -5.424170133281053_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.169590992997614_REALK,      0.000000000000000_REALK, &
      0.532802590760534_REALK,      0.000000000000000_REALK,     -3.526211977398022_REALK, &
      0.000000000000000_REALK,     -6.198700030514225_REALK,      0.000000000000000_REALK, &
     -1.691166550582250_REALK,      0.883373406690217_REALK,      0.000000000000000_REALK, &
      0.174503122385631_REALK,      0.000000000000000_REALK,     -1.327125231995978_REALK, &
      0.544153793601080_REALK,      0.000000000000000_REALK,      0.877874469950796_REALK, &
      0.000000000000000_REALK,      0.393713505619655_REALK,      0.000000000000000_REALK, &
      0.287833592279086_REALK,      0.000000000000000_REALK,     -3.064631192785470_REALK, &
     -5.294296408308523_REALK,      4.430211008597260_REALK,      0.000000000000000_REALK, &
      0.431604748225002_REALK,      0.000000000000000_REALK,     -3.343147695867930_REALK, &
      0.691785645573516_REALK,      0.000000000000000_REALK,      3.474540068028920_REALK, &
      0.000000000000000_REALK,     -1.336080052917440_REALK,      0.000000000000000_REALK, &
      0.493234596307560_REALK,      0.000000000000000_REALK,     -5.348732967672727_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.007648074348830_REALK, &
      0.000000000000000_REALK,     -0.242587240991823_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.102292477158962_REALK,      0.000000000000000_REALK, &
      2.793210850673357_REALK,      0.000000000000000_REALK,     -0.735950698831698_REALK, &
      0.000000000000000_REALK,     -0.560188599984029_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.090499082421893_REALK, &
      0.000000000000000_REALK,     -5.031948012222898_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -4.218911914047046_REALK,      0.000000000000000_REALK, &
      6.687346556889203_REALK,      0.000000000000000_REALK,     -6.990815490498566_REALK, &
      0.000000000000000_REALK,     -8.050660237912238_REALK,      0.000000000000000_REALK, &
     -3.756500246889901_REALK,     -0.944517146575489_REALK,      0.000000000000000_REALK, &
     -0.752818462142574_REALK,      0.000000000000000_REALK,     -4.127023895962484_REALK, &
     -0.503966964517629_REALK,      0.000000000000000_REALK,     -1.314092632154862_REALK, &
      0.000000000000000_REALK,     -0.749316646036393_REALK,      0.000000000000000_REALK, &
     -1.738427456553635_REALK,      0.000000000000000_REALK,    -12.253150401449696_REALK, &
    -32.734802740538186_REALK,     -6.912670527183215_REALK,      0.000000000000000_REALK, &
     -3.115172389210659_REALK,      0.000000000000000_REALK,    -28.939103647270070_REALK, &
      0.158495935184113_REALK,      0.000000000000000_REALK,     -7.590087909591436_REALK, &
      0.000000000000000_REALK,      3.374185225323969_REALK,      0.000000000000000_REALK, &
     -4.983993162715807_REALK,      0.000000000000000_REALK,    -59.528494286955748_REALK/
    ! results of test 4, ket-major order, 03 DPG X
  data REF_CONTR_INTS(25201:26460)                                                         &
     /0.000000000000000_REALK,      0.000000000000000_REALK,      9.594867959771186_REALK, &
      0.000000000000000_REALK,     10.397066877071287_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     14.843381710310430_REALK,      0.000000000000000_REALK, &
      6.998928412434067_REALK,      0.000000000000000_REALK,     31.593959518762009_REALK, &
      0.000000000000000_REALK,     11.334259852445440_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     11.167284292390100_REALK, &
      0.000000000000000_REALK,     13.445544120766519_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     21.352540651679895_REALK,      0.000000000000000_REALK, &
      7.722745007792253_REALK,      0.000000000000000_REALK,     47.825197100317318_REALK, &
      0.000000000000000_REALK,     13.936880947111547_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.211621733410872_REALK, &
      0.000000000000000_REALK,      4.859170216875379_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      5.177081100116741_REALK,      0.000000000000000_REALK, &
      3.940273005623677_REALK,      0.000000000000000_REALK,      7.623079027427091_REALK, &
      0.000000000000000_REALK,      4.367706528130446_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.586167934375367_REALK, &
      0.000000000000000_REALK,      2.833046335203413_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.164861827890839_REALK,      0.000000000000000_REALK, &
      2.645937962884115_REALK,      0.000000000000000_REALK,      0.475792142084014_REALK, &
      0.000000000000000_REALK,      2.566034180281501_REALK,      0.000000000000000_REALK, &
      6.723291664989020_REALK,      6.211621733410872_REALK,      0.000000000000000_REALK, &
      7.445992856880506_REALK,      0.000000000000000_REALK,     -1.662722231483992_REALK, &
     10.983410249385267_REALK,      0.000000000000000_REALK,     -1.866056143644849_REALK, &
      0.000000000000000_REALK,     22.416906500087688_REALK,      0.000000000000000_REALK, &
     -3.169657562025288_REALK,      0.000000000000000_REALK,     -4.041045100234797_REALK, &
      2.393401755382616_REALK,      3.586167934375366_REALK,      0.000000000000000_REALK, &
      5.371721370240970_REALK,      0.000000000000000_REALK,     -3.134516424561571_REALK, &
      9.079686127072147_REALK,      0.000000000000000_REALK,     -4.268886336297196_REALK, &
      0.000000000000000_REALK,     19.548615577480021_REALK,      0.000000000000000_REALK, &
     -7.849774323994588_REALK,      0.000000000000000_REALK,     -6.264756372417773_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.426463405901766_REALK, &
      0.000000000000000_REALK,      3.291521116592842_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.956048994759896_REALK,      0.000000000000000_REALK, &
      2.966981516105861_REALK,      0.000000000000000_REALK,      3.625679019806940_REALK, &
      0.000000000000000_REALK,      2.435749960779928_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.530722388197052_REALK, &
      0.000000000000000_REALK,      2.925327103339351_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.968345952826390_REALK,      0.000000000000000_REALK, &
      2.233395692352055_REALK,      0.000000000000000_REALK,      4.518372294400534_REALK, &
      0.000000000000000_REALK,      1.969077546344384_REALK,      0.000000000000000_REALK, &
      4.920352804103401_REALK,      3.300054562942257_REALK,      0.000000000000000_REALK, &
      2.944183094942988_REALK,      0.000000000000000_REALK,     -1.061217865064888_REALK, &
      3.149169632183911_REALK,      0.000000000000000_REALK,     -0.854510641286672_REALK, &
      0.000000000000000_REALK,      4.319358388579075_REALK,      0.000000000000000_REALK, &
     -1.031808891572753_REALK,      0.000000000000000_REALK,     -2.123358220001845_REALK, &
      2.393724981361623_REALK,      1.252740859773023_REALK,      0.000000000000000_REALK, &
      0.719381109730493_REALK,      0.000000000000000_REALK,     -1.418546047768211_REALK, &
      0.114502321697554_REALK,      0.000000000000000_REALK,     -0.996309791486621_REALK, &
      0.000000000000000_REALK,     -1.332537783123452_REALK,      0.000000000000000_REALK, &
     -0.781236181076603_REALK,      0.000000000000000_REALK,     -2.106961987162954_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.759625051239672_REALK, &
      0.000000000000000_REALK,     -0.713879843415033_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.880843076672159_REALK,      0.000000000000000_REALK, &
      0.857961834761711_REALK,      0.000000000000000_REALK,     -1.472556850641935_REALK, &
      0.000000000000000_REALK,      1.091269222647884_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.769360805055274_REALK, &
      0.000000000000000_REALK,      0.787399945840647_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.048591037081565_REALK,      0.000000000000000_REALK, &
      2.786572176570298_REALK,      0.000000000000000_REALK,      1.818758114173110_REALK, &
      0.000000000000000_REALK,      3.894267522532309_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.693438440599283_REALK, &
      0.000000000000000_REALK,      2.613585232067427_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.937053359057475_REALK,      0.000000000000000_REALK, &
      2.663508330029193_REALK,      0.000000000000000_REALK,      1.829212205809426_REALK, &
      0.000000000000000_REALK,      1.588339999597246_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.330859629263421_REALK, &
      0.000000000000000_REALK,      1.614017750692343_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.862633529415414_REALK,      0.000000000000000_REALK, &
      1.823725346186673_REALK,      0.000000000000000_REALK,     -0.032098177587341_REALK, &
      0.000000000000000_REALK,      0.984587388665911_REALK,      0.000000000000000_REALK, &
      4.912685932281209_REALK,      2.571278720541649_REALK,      0.000000000000000_REALK, &
      1.937177918296332_REALK,      0.000000000000000_REALK,     -0.920812307596019_REALK, &
      1.790544978915900_REALK,      0.000000000000000_REALK,     -0.569674760654035_REALK, &
      0.000000000000000_REALK,      2.194470929987174_REALK,      0.000000000000000_REALK, &
     -0.557538302082590_REALK,      0.000000000000000_REALK,     -1.513075424897739_REALK, &
      1.227735460651118_REALK,      1.011296997498101_REALK,      0.000000000000000_REALK, &
      1.005973808566109_REALK,      0.000000000000000_REALK,     -1.221160551411583_REALK, &
      1.270577069320656_REALK,      0.000000000000000_REALK,     -0.893339947894045_REALK, &
      0.000000000000000_REALK,      2.192867833223671_REALK,      0.000000000000000_REALK, &
     -0.990073803450380_REALK,      0.000000000000000_REALK,     -1.643779672840979_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.557670446391287_REALK, &
      0.000000000000000_REALK,     -0.376700264004984_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.342780189737593_REALK,      0.000000000000000_REALK, &
      0.538924327438580_REALK,      0.000000000000000_REALK,     -0.399557881925621_REALK, &
      0.000000000000000_REALK,      0.472904513023064_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.272207234585773_REALK, &
      0.000000000000000_REALK,      0.187421107194973_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.121941993897644_REALK,      0.000000000000000_REALK, &
      1.095077318454162_REALK,      0.000000000000000_REALK,      0.021199191076928_REALK, &
      0.000000000000000_REALK,      0.840052596172180_REALK,      0.000000000000000_REALK, &
      3.162457208588835_REALK,      2.564489273666347_REALK,      0.000000000000000_REALK, &
      2.654481385980327_REALK,      0.000000000000000_REALK,      0.241667530577263_REALK, &
      3.344192042778518_REALK,      0.000000000000000_REALK,      0.231643565747271_REALK, &
      0.000000000000000_REALK,      5.403164846228443_REALK,      0.000000000000000_REALK, &
      0.311477309224376_REALK,      0.000000000000000_REALK,     -0.778193256156763_REALK, &
      1.985016757910739_REALK,      2.591769866351092_REALK,      0.000000000000000_REALK, &
      3.383569270887098_REALK,      0.000000000000000_REALK,     -1.158544572591659_REALK, &
      4.869571171561735_REALK,      0.000000000000000_REALK,     -1.343430105034458_REALK, &
      0.000000000000000_REALK,      8.293059916940630_REALK,      0.000000000000000_REALK, &
     -1.954054043979416_REALK,      0.000000000000000_REALK,     -3.599999716636733_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      7.228959789401592_REALK, &
      0.000000000000000_REALK,      2.473139685340302_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.580041786464389_REALK,      0.000000000000000_REALK, &
      2.844479585267226_REALK,      0.000000000000000_REALK,      1.211964397333547_REALK, &
      0.000000000000000_REALK,      1.223122109146010_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      7.438118652126758_REALK, &
      0.000000000000000_REALK,      2.554826161307340_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.739065593790116_REALK,      0.000000000000000_REALK, &
      2.467275170572851_REALK,      0.000000000000000_REALK,      1.843165389803476_REALK, &
      0.000000000000000_REALK,      1.075850769575168_REALK,      0.000000000000000_REALK, &
      6.131900646552488_REALK,      2.417450416763578_REALK,      0.000000000000000_REALK, &
      1.500428360925018_REALK,      0.000000000000000_REALK,     -0.977071020471584_REALK, &
      1.095481896694511_REALK,      0.000000000000000_REALK,     -0.450487744134408_REALK, &
      0.000000000000000_REALK,      1.017053863763874_REALK,      0.000000000000000_REALK, &
     -0.351426759099402_REALK,      0.000000000000000_REALK,     -1.306561808145877_REALK, &
      3.657685623237390_REALK,      1.168042656535920_REALK,      0.000000000000000_REALK, &
      0.457444809924526_REALK,      0.000000000000000_REALK,     -1.560295075879324_REALK, &
     -0.012631045410876_REALK,      0.000000000000000_REALK,     -0.625098020566140_REALK, &
      0.000000000000000_REALK,     -0.649499119855347_REALK,      0.000000000000000_REALK, &
     -0.310788055121991_REALK,      0.000000000000000_REALK,     -1.449847404390119_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.572944546989281_REALK, &
      0.000000000000000_REALK,     -0.296839181985421_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.224613776472069_REALK,      0.000000000000000_REALK, &
      0.465704389179611_REALK,      0.000000000000000_REALK,     -0.218523951694280_REALK, &
      0.000000000000000_REALK,      0.303258599344446_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.490540766616700_REALK, &
      0.000000000000000_REALK,      0.262954778528320_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.216261112641995_REALK,      0.000000000000000_REALK, &
      1.195560640378208_REALK,      0.000000000000000_REALK,      0.254091969642007_REALK, &
      0.000000000000000_REALK,      0.813605292090752_REALK,      0.000000000000000_REALK, &
      2.761985327379140_REALK,      1.602286189530826_REALK,      0.000000000000000_REALK, &
      1.220991533017255_REALK,      0.000000000000000_REALK,      0.179429530966623_REALK, &
      1.100383510588043_REALK,      0.000000000000000_REALK,      0.121732635937912_REALK, &
      0.000000000000000_REALK,      1.197159976993258_REALK,      0.000000000000000_REALK, &
      0.116593340922795_REALK,      0.000000000000000_REALK,     -0.470194392031671_REALK, &
      2.846075918542577_REALK,      1.291414530128807_REALK,      0.000000000000000_REALK, &
      0.615690474572147_REALK,      0.000000000000000_REALK,     -0.712405799321105_REALK, &
      0.079428247978366_REALK,      0.000000000000000_REALK,     -0.405541862814984_REALK, &
      0.000000000000000_REALK,     -0.713485632892465_REALK,      0.000000000000000_REALK, &
     -0.245453173597427_REALK,      0.000000000000000_REALK,     -1.528135566938702_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.303000141645545_REALK, &
      0.000000000000000_REALK,     -1.045921698106933_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.087358564565110_REALK,      0.000000000000000_REALK, &
     -0.112990692512322_REALK,      0.000000000000000_REALK,     -1.441887029042714_REALK, &
      0.000000000000000_REALK,     -0.113996505412409_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.930931381513668_REALK, &
      0.000000000000000_REALK,     -0.791009998389761_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.853787945633598_REALK,      0.000000000000000_REALK, &
      2.268531837537019_REALK,      0.000000000000000_REALK,     -1.143046324695030_REALK, &
      0.000000000000000_REALK,      2.447064265492670_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     11.013928485739191_REALK, &
      0.000000000000000_REALK,      2.709971475421305_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.528063754898805_REALK,      0.000000000000000_REALK, &
      3.613084106260162_REALK,      0.000000000000000_REALK,      0.891734735361352_REALK, &
      0.000000000000000_REALK,      1.080548898578759_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.127780505838524_REALK, &
      0.000000000000000_REALK,      2.184553824328144_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.881038873548392_REALK,      0.000000000000000_REALK, &
      3.258308143258675_REALK,      0.000000000000000_REALK,     -0.215492729731458_REALK, &
      0.000000000000000_REALK,      0.894387996152756_REALK,      0.000000000000000_REALK, &
      9.357599657150699_REALK,      2.770233510510854_REALK,      0.000000000000000_REALK, &
      1.488071074829808_REALK,      0.000000000000000_REALK,     -1.268692335669810_REALK, &
      0.900476209232832_REALK,      0.000000000000000_REALK,     -0.430378522497237_REALK, &
      0.000000000000000_REALK,      0.735779198197014_REALK,      0.000000000000000_REALK, &
     -0.280997058098461_REALK,      0.000000000000000_REALK,     -1.367787650651110_REALK, &
      2.596448587640812_REALK,      1.199244455998313_REALK,      0.000000000000000_REALK, &
      0.857871253533826_REALK,      0.000000000000000_REALK,     -1.963625550758961_REALK, &
      0.823645212540073_REALK,      0.000000000000000_REALK,     -0.775644719900141_REALK, &
      0.000000000000000_REALK,      1.200264427606356_REALK,      0.000000000000000_REALK, &
     -0.566657004436129_REALK,      0.000000000000000_REALK,     -1.773972013385170_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.736231562276438_REALK, &
      0.000000000000000_REALK,     -0.285403076099619_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.175645802464091_REALK,      0.000000000000000_REALK, &
      0.498908587499254_REALK,      0.000000000000000_REALK,     -0.131056622883911_REALK, &
      0.000000000000000_REALK,      0.235076428344020_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.406541649711671_REALK, &
      0.000000000000000_REALK,      0.171161553057416_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.077088950434473_REALK,      0.000000000000000_REALK, &
      1.197477189507759_REALK,      0.000000000000000_REALK,     -0.002284523014168_REALK, &
      0.000000000000000_REALK,      0.514886432189685_REALK,      0.000000000000000_REALK, &
      3.410550617557689_REALK,      1.529016652339796_REALK,      0.000000000000000_REALK, &
      0.972780260113022_REALK,      0.000000000000000_REALK,      0.188520197687114_REALK, &
      0.746628706305016_REALK,      0.000000000000000_REALK,      0.096847398409632_REALK, &
      0.000000000000000_REALK,      0.723016105240190_REALK,      0.000000000000000_REALK, &
      0.074891819016123_REALK,      0.000000000000000_REALK,     -0.398290497386730_REALK, &
      1.630378740905987_REALK,      1.175233614605178_REALK,      0.000000000000000_REALK, &
      1.015737199672403_REALK,      0.000000000000000_REALK,     -0.723515856777069_REALK, &
      1.081094316148885_REALK,      0.000000000000000_REALK,     -0.446025746524615_REALK, &
      0.000000000000000_REALK,      1.486019100527412_REALK,      0.000000000000000_REALK, &
     -0.393695188503979_REALK,      0.000000000000000_REALK,     -1.508881116605552_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.171566391757429_REALK, &
      0.000000000000000_REALK,     -0.668293718777729_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.504965117816362_REALK,      0.000000000000000_REALK, &
     -0.084698148959986_REALK,      0.000000000000000_REALK,     -0.465076137376830_REALK, &
      0.000000000000000_REALK,     -0.058724358320387_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.371302897071766_REALK, &
      0.000000000000000_REALK,     -0.222124452773270_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.121786472133025_REALK,      0.000000000000000_REALK, &
      1.093506192228267_REALK,      0.000000000000000_REALK,     -0.016862206802024_REALK, &
      0.000000000000000_REALK,      0.668085898308847_REALK,      0.000000000000000_REALK, &
      3.659138990506043_REALK,      2.541632154238439_REALK,      0.000000000000000_REALK, &
      2.221639933646431_REALK,      0.000000000000000_REALK,      0.900623886201761_REALK, &
      2.324124598875855_REALK,      0.000000000000000_REALK,      0.716835669412200_REALK, &
      0.000000000000000_REALK,      2.966983331994313_REALK,      0.000000000000000_REALK, &
      0.761595678163876_REALK,      0.000000000000000_REALK,      0.051487442975548_REALK, &
      4.393358376952310_REALK,      5.019849222981426_REALK,      0.000000000000000_REALK, &
      5.694013679155350_REALK,      0.000000000000000_REALK,     -0.576714746285367_REALK, &
      6.905609850796157_REALK,      0.000000000000000_REALK,     -0.563548465897865_REALK, &
      0.000000000000000_REALK,      9.366460099782836_REALK,      0.000000000000000_REALK, &
     -0.652833046582112_REALK,      0.000000000000000_REALK,     -4.380780959358851_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.416126718025132_REALK, &
      0.000000000000000_REALK,     11.242029964044898_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.497626658361588_REALK,      0.000000000000000_REALK, &
      0.673134720307293_REALK,      0.000000000000000_REALK,     63.409015761588115_REALK, &
      0.000000000000000_REALK,     45.100983259583288_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.759227059137050_REALK, &
      0.000000000000000_REALK,     11.655993149796917_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.063880369188606_REALK,      0.000000000000000_REALK, &
     -0.063383749521451_REALK,      0.000000000000000_REALK,     91.179839707834631_REALK, &
      0.000000000000000_REALK,     54.451921224755985_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.896393742318006_REALK, &
      0.000000000000000_REALK,      4.073059299652456_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.874794973917649_REALK,      0.000000000000000_REALK, &
      4.404774882551289_REALK,      0.000000000000000_REALK,     13.640744611844257_REALK, &
      0.000000000000000_REALK,     15.243517860927133_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.115012168819204_REALK, &
      0.000000000000000_REALK,      2.057671733846373_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.712522138332074_REALK,      0.000000000000000_REALK, &
      2.836772888476302_REALK,      0.000000000000000_REALK,     -0.447479099688960_REALK, &
      0.000000000000000_REALK,      9.183847163197028_REALK,      0.000000000000000_REALK, &
     12.576518683322515_REALK,      2.896393742318006_REALK,      0.000000000000000_REALK, &
     12.087140734532541_REALK,      0.000000000000000_REALK,      0.321994343365718_REALK, &
      6.192823742808191_REALK,      0.000000000000000_REALK,      0.086746113660748_REALK, &
      0.000000000000000_REALK,     80.159041734889684_REALK,      0.000000000000000_REALK, &
      0.890870050755074_REALK,      0.000000000000000_REALK,    -17.986803709661000_REALK, &
      3.377768793717583_REALK,      1.115012168819204_REALK,      0.000000000000000_REALK, &
      7.002015858502677_REALK,      0.000000000000000_REALK,     -2.941107561257936_REALK, &
      4.750181287289545_REALK,      0.000000000000000_REALK,     -1.200886260481169_REALK, &
      0.000000000000000_REALK,     66.274357338449832_REALK,      0.000000000000000_REALK, &
    -13.229668263490607_REALK,      0.000000000000000_REALK,    -36.589835893398309_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.597298021140198_REALK, &
      0.000000000000000_REALK,      1.824028241903107_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.852343150204307_REALK,      0.000000000000000_REALK, &
      5.956259637914856_REALK,      0.000000000000000_REALK,      4.461700125731041_REALK, &
      0.000000000000000_REALK,      5.861733824534862_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.923588726037347_REALK, &
      0.000000000000000_REALK,      1.253464879836626_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.409548205896336_REALK,      0.000000000000000_REALK, &
      4.115517759604681_REALK,      0.000000000000000_REALK,      5.361626924584157_REALK, &
      0.000000000000000_REALK,      4.437847092077994_REALK,      0.000000000000000_REALK, &
      9.547453778670631_REALK,      2.387378240481672_REALK,      0.000000000000000_REALK, &
      4.674825383976986_REALK,      0.000000000000000_REALK,      0.216302550275787_REALK, &
      2.767866045165238_REALK,      0.000000000000000_REALK,      0.060914194177161_REALK, &
      0.000000000000000_REALK,     15.109340976873911_REALK,      0.000000000000000_REALK, &
      0.295859990020967_REALK,      0.000000000000000_REALK,    -10.375223412245786_REALK, &
      3.357426272689402_REALK,      0.784381421814502_REALK,      0.000000000000000_REALK, &
      0.906677294021557_REALK,      0.000000000000000_REALK,     -1.528115754591874_REALK, &
     -0.053800165102869_REALK,      0.000000000000000_REALK,     -0.467425938632868_REALK, &
      0.000000000000000_REALK,     -5.070854750632786_REALK,      0.000000000000000_REALK, &
     -1.358908491107295_REALK,      0.000000000000000_REALK,    -15.080558146162916_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.298711200417127_REALK, &
      0.000000000000000_REALK,     -2.634494591798091_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.201694312626812_REALK,      0.000000000000000_REALK, &
     -1.146121023579860_REALK,      0.000000000000000_REALK,    -11.903011375335465_REALK, &
      0.000000000000000_REALK,     -3.258119063518336_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.866715216511340_REALK, &
      0.000000000000000_REALK,     -1.181328168776804_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.229629046863523_REALK,      0.000000000000000_REALK, &
      1.981682435114448_REALK,      0.000000000000000_REALK,     -7.003519477807504_REALK, &
      0.000000000000000_REALK,      6.793290098939528_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.460112445314945_REALK, &
      0.000000000000000_REALK,      0.594278697425000_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.858740568619984_REALK,      0.000000000000000_REALK, &
      7.291469606646127_REALK,      0.000000000000000_REALK,      0.741355682152090_REALK, &
      0.000000000000000_REALK,      1.530513989854078_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.319487682329753_REALK, &
      0.000000000000000_REALK,      0.210868598459701_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.852710840961808_REALK,      0.000000000000000_REALK, &
      5.055553210830932_REALK,      0.000000000000000_REALK,     -1.338671540394638_REALK, &
      0.000000000000000_REALK,      0.598881980170469_REALK,      0.000000000000000_REALK, &
     10.171495373841406_REALK,      1.710347253195208_REALK,      0.000000000000000_REALK, &
      3.063089616004774_REALK,      0.000000000000000_REALK,      0.193971618433797_REALK, &
      1.469378127734027_REALK,      0.000000000000000_REALK,      0.038017678725687_REALK, &
      0.000000000000000_REALK,      6.904967887506849_REALK,      0.000000000000000_REALK, &
      0.155357832437870_REALK,      0.000000000000000_REALK,     -7.456355610053667_REALK, &
      1.959898423107851_REALK,      0.587284074006910_REALK,      0.000000000000000_REALK, &
      1.124038299827095_REALK,      0.000000000000000_REALK,     -1.389322166055520_REALK, &
      1.080612794230713_REALK,      0.000000000000000_REALK,     -0.378637092436713_REALK, &
      0.000000000000000_REALK,      5.673810215894918_REALK,      0.000000000000000_REALK, &
     -1.351411940971404_REALK,      0.000000000000000_REALK,    -10.998495896095800_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.470301986080131_REALK, &
      0.000000000000000_REALK,     -1.226852731407472_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.186738694107127_REALK,      0.000000000000000_REALK, &
     -1.073001043229616_REALK,      0.000000000000000_REALK,     -2.827433823701129_REALK, &
      0.000000000000000_REALK,     -1.215947094433024_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.553485965868298_REALK, &
      0.000000000000000_REALK,     -0.288156414520938_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.211727872055566_REALK,      0.000000000000000_REALK, &
      1.369158335537163_REALK,      0.000000000000000_REALK,      0.039875462554773_REALK, &
      0.000000000000000_REALK,      1.329251205643019_REALK,      0.000000000000000_REALK, &
      4.692984272719925_REALK,      2.279463206039606_REALK,      0.000000000000000_REALK, &
      3.359524547656445_REALK,      0.000000000000000_REALK,      3.119093125974708_REALK, &
      3.617200488147686_REALK,      0.000000000000000_REALK,      1.765874143321969_REALK, &
      0.000000000000000_REALK,     15.331668723136696_REALK,      0.000000000000000_REALK, &
      5.938505025273768_REALK,      0.000000000000000_REALK,      7.270353183700446_REALK, &
      2.287115215221530_REALK,      2.178717642454545_REALK,      0.000000000000000_REALK, &
      3.859842881908786_REALK,      0.000000000000000_REALK,      0.931945926735217_REALK, &
      5.556280871974369_REALK,      0.000000000000000_REALK,      0.807437941505964_REALK, &
      0.000000000000000_REALK,     23.247317129513483_REALK,      0.000000000000000_REALK, &
      2.667531395025986_REALK,      0.000000000000000_REALK,     -9.305702813228891_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      9.686037774694951_REALK, &
      0.000000000000000_REALK,     -0.570414591964298_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.286545696426210_REALK,      0.000000000000000_REALK, &
      9.285095715581809_REALK,      0.000000000000000_REALK,     -1.137079413461499_REALK, &
      0.000000000000000_REALK,     -1.117811329175167_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.181868200336357_REALK, &
      0.000000000000000_REALK,     -0.516950386757141_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.833029778421974_REALK,      0.000000000000000_REALK, &
      7.664910005715955_REALK,      0.000000000000000_REALK,      0.025920767250379_REALK, &
      0.000000000000000_REALK,     -0.944578756936744_REALK,      0.000000000000000_REALK, &
     13.862423751924206_REALK,      0.777020951006008_REALK,      0.000000000000000_REALK, &
      2.792160116718613_REALK,      0.000000000000000_REALK,      0.215706345292969_REALK, &
      0.360796463905627_REALK,      0.000000000000000_REALK,      0.014668957993735_REALK, &
      0.000000000000000_REALK,      3.916436374946003_REALK,      0.000000000000000_REALK, &
      0.107756756067918_REALK,      0.000000000000000_REALK,     -6.309313142477226_REALK, &
      6.658497732495324_REALK,      0.211341106249196_REALK,      0.000000000000000_REALK, &
      0.762956381127857_REALK,      0.000000000000000_REALK,     -1.914890389089455_REALK, &
     -0.442559168089025_REALK,      0.000000000000000_REALK,     -0.083813864497726_REALK, &
      0.000000000000000_REALK,     -1.278734011592715_REALK,      0.000000000000000_REALK, &
     -0.590155321787760_REALK,      0.000000000000000_REALK,     -9.752910239784592_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.088989464165957_REALK, &
      0.000000000000000_REALK,     -0.695573149706109_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.920883044281368_REALK,      0.000000000000000_REALK, &
     -1.139545729408053_REALK,      0.000000000000000_REALK,     -1.037516407043608_REALK, &
      0.000000000000000_REALK,     -0.524560752337635_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.076438782163897_REALK, &
      0.000000000000000_REALK,     -0.261899933623541_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.345381737598150_REALK,      0.000000000000000_REALK, &
      1.637922519849788_REALK,      0.000000000000000_REALK,     -0.578161216003226_REALK, &
      0.000000000000000_REALK,      0.777273989941680_REALK,      0.000000000000000_REALK, &
      4.891383107728587_REALK,      1.480190250053028_REALK,      0.000000000000000_REALK, &
      1.644974550229908_REALK,      0.000000000000000_REALK,      2.652658169390988_REALK, &
      1.269727833494760_REALK,      0.000000000000000_REALK,      0.973890062727116_REALK, &
      0.000000000000000_REALK,      3.242072009056251_REALK,      0.000000000000000_REALK, &
      2.212530325851627_REALK,      0.000000000000000_REALK,      4.704778647437266_REALK, &
      4.370248625790816_REALK,      1.136827820912051_REALK,      0.000000000000000_REALK, &
      0.745710562631565_REALK,      0.000000000000000_REALK,      0.722448807079618_REALK, &
     -0.051891638285231_REALK,      0.000000000000000_REALK,      0.259155155359881_REALK, &
      0.000000000000000_REALK,     -2.152424225049199_REALK,      0.000000000000000_REALK, &
      0.331566147306112_REALK,      0.000000000000000_REALK,     -4.641149072565292_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.288803390929987_REALK, &
      0.000000000000000_REALK,     -2.139184744228863_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.330664622530508_REALK,      0.000000000000000_REALK, &
     -3.853694338885520_REALK,      0.000000000000000_REALK,     -5.893742735475437_REALK, &
      0.000000000000000_REALK,     -5.124190886203442_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.160539901756467_REALK, &
      0.000000000000000_REALK,     -3.218058912526396_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -3.928201553648145_REALK,      0.000000000000000_REALK, &
     -1.349151534337195_REALK,      0.000000000000000_REALK,     -9.846205982225237_REALK, &
      0.000000000000000_REALK,     -2.035353083169099_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     16.424698191275770_REALK, &
      0.000000000000000_REALK,     -2.513972674978372_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.468448593329352_REALK,      0.000000000000000_REALK, &
     12.943712212247371_REALK,      0.000000000000000_REALK,     -3.010646216587049_REALK, &
      0.000000000000000_REALK,     -3.607881729772313_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     12.189914698898932_REALK, &
      0.000000000000000_REALK,     -2.623035932472624_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.822052371042312_REALK,      0.000000000000000_REALK, &
     12.374673278334331_REALK,      0.000000000000000_REALK,     -3.545933907207120_REALK, &
      0.000000000000000_REALK,     -3.737826120487514_REALK,      0.000000000000000_REALK, &
     23.231739681710746_REALK,     -0.982826759255680_REALK,      0.000000000000000_REALK, &
      3.643879825957079_REALK,      0.000000000000000_REALK,      0.291404903153338_REALK, &
     -0.787881154559788_REALK,      0.000000000000000_REALK,     -0.015253332317747_REALK, &
      0.000000000000000_REALK,      3.917925808022594_REALK,      0.000000000000000_REALK, &
      0.102986925818338_REALK,      0.000000000000000_REALK,     -6.242087848188882_REALK, &
      6.084984575385019_REALK,     -0.446986904495247_REALK,      0.000000000000000_REALK, &
      1.612306983305090_REALK,      0.000000000000000_REALK,     -2.854056610917306_REALK, &
      0.012451955287276_REALK,      0.000000000000000_REALK,      0.192090188528513_REALK, &
      0.000000000000000_REALK,      3.151515859610604_REALK,      0.000000000000000_REALK, &
     -0.972612614788151_REALK,      0.000000000000000_REALK,    -11.336485476377081_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.526733608787754_REALK, &
      0.000000000000000_REALK,     -0.284720735480823_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.909389836392344_REALK,      0.000000000000000_REALK, &
     -1.372844955674126_REALK,      0.000000000000000_REALK,     -0.197924771989790_REALK, &
      0.000000000000000_REALK,     -0.157248293352586_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.279982880527475_REALK, &
      0.000000000000000_REALK,     -0.056991276817100_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.219164563315142_REALK,      0.000000000000000_REALK, &
      2.110506396939483_REALK,      0.000000000000000_REALK,      0.181533184569858_REALK, &
      0.000000000000000_REALK,      0.131908468649418_REALK,      0.000000000000000_REALK, &
      6.836511365589507_REALK,      1.105889395699117_REALK,      0.000000000000000_REALK, &
      1.354163725483770_REALK,      0.000000000000000_REALK,      2.988653191342467_REALK, &
      0.663357170553207_REALK,      0.000000000000000_REALK,      0.598170942873923_REALK, &
      0.000000000000000_REALK,      1.701052567499185_REALK,      0.000000000000000_REALK, &
      1.333874850342436_REALK,      0.000000000000000_REALK,      3.881926314840275_REALK, &
      3.151306718669988_REALK,      0.891406220076968_REALK,      0.000000000000000_REALK, &
      1.195836820667117_REALK,      0.000000000000000_REALK,      0.849624538528713_REALK, &
      1.093283999119109_REALK,      0.000000000000000_REALK,      0.220201013462337_REALK, &
      0.000000000000000_REALK,      3.028664293741382_REALK,      0.000000000000000_REALK, &
      0.414664975785156_REALK,      0.000000000000000_REALK,     -4.256680282972812_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.685824379736823_REALK, &
      0.000000000000000_REALK,     -1.251587159052334_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.236306497392417_REALK,      0.000000000000000_REALK, &
     -3.550546587873315_REALK,      0.000000000000000_REALK,     -1.607332448638140_REALK, &
      0.000000000000000_REALK,     -2.195593645413011_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.782530449037613_REALK, &
      0.000000000000000_REALK,     -1.015371523920749_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.709490843865748_REALK,      0.000000000000000_REALK, &
     -0.977753680692883_REALK,      0.000000000000000_REALK,      0.070499809282074_REALK, &
      0.000000000000000_REALK,     -0.500836870753259_REALK,      0.000000000000000_REALK, &
      5.257116274416219_REALK,      2.456454561820883_REALK,      0.000000000000000_REALK, &
      2.475358133793029_REALK,      0.000000000000000_REALK,      4.530465782988010_REALK, &
      2.721668252997230_REALK,      0.000000000000000_REALK,      2.619248143204098_REALK, &
      0.000000000000000_REALK,      6.294978453779898_REALK,      0.000000000000000_REALK, &
      4.806580719738406_REALK,      0.000000000000000_REALK,     11.654196325955281_REALK, &
      6.129060447829265_REALK,      5.511592953147679_REALK,      0.000000000000000_REALK, &
      6.843987197598784_REALK,      0.000000000000000_REALK,      6.179644465655868_REALK, &
      9.369055848639480_REALK,      0.000000000000000_REALK,      5.091596774448525_REALK, &
      0.000000000000000_REALK,     20.682256613082288_REALK,      0.000000000000000_REALK, &
      8.874989233825129_REALK,      0.000000000000000_REALK,      3.462393261930339_REALK/
    ! results of test 4, ket-major order, 03 DPG Y
  data REF_CONTR_INTS(26461:27720)                                                         &
     /0.000000000000000_REALK,      0.000000000000000_REALK,      3.465613629728924_REALK, &
      0.000000000000000_REALK,      2.084841211718257_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.482846840593208_REALK,      0.000000000000000_REALK, &
      2.198373374813344_REALK,      0.000000000000000_REALK,      0.671872504645038_REALK, &
      0.000000000000000_REALK,      1.873977276801941_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.774567571673060_REALK, &
      0.000000000000000_REALK,     -0.870714913153566_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -3.570759712169571_REALK,      0.000000000000000_REALK, &
      0.571489617946652_REALK,      0.000000000000000_REALK,    -11.035999519867689_REALK, &
      0.000000000000000_REALK,     -0.788650789318088_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.542306917459364_REALK, &
      0.000000000000000_REALK,      1.920501163471279_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.602501225927169_REALK,      0.000000000000000_REALK, &
      1.936797203321290_REALK,      0.000000000000000_REALK,      1.854930831516981_REALK, &
      0.000000000000000_REALK,      1.421185059400493_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.892961299362765_REALK, &
      0.000000000000000_REALK,      1.920133922975082_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.307805688774376_REALK,      0.000000000000000_REALK, &
      1.426070006180434_REALK,      0.000000000000000_REALK,      4.392915915937513_REALK, &
      0.000000000000000_REALK,      1.292468315556365_REALK,      0.000000000000000_REALK, &
      2.745183540275272_REALK,      1.415898074499856_REALK,      0.000000000000000_REALK, &
      0.843288431461059_REALK,      0.000000000000000_REALK,     -0.592079050386927_REALK, &
      0.277557202373859_REALK,      0.000000000000000_REALK,     -0.366630293093916_REALK, &
      0.000000000000000_REALK,     -0.887815304528138_REALK,      0.000000000000000_REALK, &
     -0.295536138101089_REALK,      0.000000000000000_REALK,     -1.184672780129929_REALK, &
      0.517014757812607_REALK,     -0.385020229061263_REALK,      0.000000000000000_REALK, &
     -1.186559368929391_REALK,      0.000000000000000_REALK,     -0.306388263916486_REALK, &
     -2.655881540504321_REALK,      0.000000000000000_REALK,      0.306208120491624_REALK, &
      0.000000000000000_REALK,     -6.487096459889955_REALK,      0.000000000000000_REALK, &
      1.288584169732153_REALK,      0.000000000000000_REALK,     -0.455077525611893_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.932305892556825_REALK, &
      0.000000000000000_REALK,      1.621924080135308_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.116194932519918_REALK,      0.000000000000000_REALK, &
      1.839614076857488_REALK,      0.000000000000000_REALK,      0.932141334547282_REALK, &
      0.000000000000000_REALK,      0.985683137928909_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.074077414921831_REALK, &
      0.000000000000000_REALK,      0.703712894870993_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.051925981394893_REALK,      0.000000000000000_REALK, &
      1.135607012170230_REALK,      0.000000000000000_REALK,     -1.306340464768689_REALK, &
      0.000000000000000_REALK,      0.429280806381683_REALK,      0.000000000000000_REALK, &
      3.206921351814247_REALK,      1.500261915232920_REALK,      0.000000000000000_REALK, &
      1.050161886495072_REALK,      0.000000000000000_REALK,     -0.601091274905051_REALK, &
      0.916059328049917_REALK,      0.000000000000000_REALK,     -0.332387671803484_REALK, &
      0.000000000000000_REALK,      1.125768882241534_REALK,      0.000000000000000_REALK, &
     -0.302246618433087_REALK,      0.000000000000000_REALK,     -0.987710990260027_REALK, &
      0.783934849500326_REALK,      0.663797791666544_REALK,      0.000000000000000_REALK, &
      0.782116409293980_REALK,      0.000000000000000_REALK,     -0.779736632009367_REALK, &
      1.235298436377401_REALK,      0.000000000000000_REALK,     -0.586372832201241_REALK, &
      0.000000000000000_REALK,      2.568661566428666_REALK,      0.000000000000000_REALK, &
     -0.769754601458649_REALK,      0.000000000000000_REALK,     -1.049587807585910_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.311137796674783_REALK, &
      0.000000000000000_REALK,     -0.161624351444875_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.098180907646756_REALK,      0.000000000000000_REALK, &
      0.300678884632928_REALK,      0.000000000000000_REALK,     -0.035215685671652_REALK, &
      0.000000000000000_REALK,      0.202901066221966_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.058793369564179_REALK, &
      0.000000000000000_REALK,     -0.057602429952032_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.201133187079915_REALK,      0.000000000000000_REALK, &
      0.236523050473660_REALK,      0.000000000000000_REALK,     -0.491715271971110_REALK, &
      0.000000000000000_REALK,     -0.258183678195284_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.197960920745526_REALK, &
      0.000000000000000_REALK,      1.615294143213862_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.998843642824975_REALK,      0.000000000000000_REALK, &
      2.045314146822971_REALK,      0.000000000000000_REALK,      0.723367295565746_REALK, &
      0.000000000000000_REALK,      0.798863885873506_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.268342812583306_REALK, &
      0.000000000000000_REALK,      1.776707244558118_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.398628984797319_REALK,      0.000000000000000_REALK, &
      1.747545585043352_REALK,      0.000000000000000_REALK,      1.853847640365360_REALK, &
      0.000000000000000_REALK,      0.748180790269308_REALK,      0.000000000000000_REALK, &
      4.235140029453503_REALK,      1.500207835342111_REALK,      0.000000000000000_REALK, &
      0.864597005158689_REALK,      0.000000000000000_REALK,     -0.674836862000479_REALK, &
      0.558242479420452_REALK,      0.000000000000000_REALK,     -0.279561160299126_REALK, &
      0.000000000000000_REALK,      0.430893257082940_REALK,      0.000000000000000_REALK, &
     -0.202503852474934_REALK,      0.000000000000000_REALK,     -0.902407350279690_REALK, &
      2.277587165604628_REALK,      0.509267434519298_REALK,      0.000000000000000_REALK, &
     -0.027535760991609_REALK,      0.000000000000000_REALK,     -0.971572848361278_REALK, &
     -0.514061762156443_REALK,      0.000000000000000_REALK,     -0.272543184510847_REALK, &
      0.000000000000000_REALK,     -1.379283967604092_REALK,      0.000000000000000_REALK, &
      0.018707799103236_REALK,      0.000000000000000_REALK,     -0.902798704007100_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.374008867343220_REALK, &
      0.000000000000000_REALK,     -0.173196517407420_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.121765184810767_REALK,      0.000000000000000_REALK, &
      0.304004239204481_REALK,      0.000000000000000_REALK,     -0.111798869455419_REALK, &
      0.000000000000000_REALK,      0.176942049661388_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.313220571023902_REALK, &
      0.000000000000000_REALK,      0.172598951373424_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.168136946955476_REALK,      0.000000000000000_REALK, &
      0.763390551728744_REALK,      0.000000000000000_REALK,      0.247036894001753_REALK, &
      0.000000000000000_REALK,      0.534036388434021_REALK,      0.000000000000000_REALK, &
      1.540978251169260_REALK,      0.687465581942290_REALK,      0.000000000000000_REALK, &
      0.349722826842498_REALK,      0.000000000000000_REALK,      0.100108064331912_REALK, &
      0.096984095621847_REALK,      0.000000000000000_REALK,      0.052229743945387_REALK, &
      0.000000000000000_REALK,     -0.246068247625271_REALK,      0.000000000000000_REALK, &
      0.033395278899084_REALK,      0.000000000000000_REALK,     -0.262332795456989_REALK, &
      0.614716921617524_REALK,     -0.396906282990822_REALK,      0.000000000000000_REALK, &
     -1.015530281630354_REALK,      0.000000000000000_REALK,     -0.153870772402092_REALK, &
     -1.842338342776566_REALK,      0.000000000000000_REALK,      0.124640159771947_REALK, &
      0.000000000000000_REALK,     -3.473410046557948_REALK,      0.000000000000000_REALK, &
      0.404854615760748_REALK,      0.000000000000000_REALK,     -0.330058234006576_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.140535253077486_REALK, &
      0.000000000000000_REALK,      1.807750950753940_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.004467375152874_REALK,      0.000000000000000_REALK, &
      2.670476622163287_REALK,      0.000000000000000_REALK,      0.535273380312941_REALK, &
      0.000000000000000_REALK,      0.720805852186395_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.801849988745179_REALK, &
      0.000000000000000_REALK,      1.246635418932144_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.223812022008376_REALK,      0.000000000000000_REALK, &
      2.325876670846854_REALK,      0.000000000000000_REALK,     -0.873363426966630_REALK, &
      0.000000000000000_REALK,      0.510390607846286_REALK,      0.000000000000000_REALK, &
      6.728552758193926_REALK,      1.809336525303154_REALK,      0.000000000000000_REALK, &
      0.940703180066802_REALK,      0.000000000000000_REALK,     -0.912249254855370_REALK, &
      0.537453939758580_REALK,      0.000000000000000_REALK,     -0.281095285832658_REALK, &
      0.000000000000000_REALK,      0.436644669796576_REALK,      0.000000000000000_REALK, &
     -0.177635887568657_REALK,      0.000000000000000_REALK,     -0.983503431072666_REALK, &
      1.839037785586867_REALK,      0.833992678342565_REALK,      0.000000000000000_REALK, &
      0.689935793509595_REALK,      0.000000000000000_REALK,     -1.390815748010148_REALK, &
      0.828418731282950_REALK,      0.000000000000000_REALK,     -0.539407969873239_REALK, &
      0.000000000000000_REALK,      1.432086509985206_REALK,      0.000000000000000_REALK, &
     -0.455729164945140_REALK,      0.000000000000000_REALK,     -1.256486101330133_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.508495479635189_REALK, &
      0.000000000000000_REALK,     -0.177113841932942_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.101212986060543_REALK,      0.000000000000000_REALK, &
      0.344582838462027_REALK,      0.000000000000000_REALK,     -0.066784649133812_REALK, &
      0.000000000000000_REALK,      0.145882412834789_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.253147519782604_REALK, &
      0.000000000000000_REALK,      0.074626559677539_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.004640347574624_REALK,      0.000000000000000_REALK, &
      0.745651474418736_REALK,      0.000000000000000_REALK,     -0.092976146324254_REALK, &
      0.000000000000000_REALK,      0.224490853071830_REALK,      0.000000000000000_REALK, &
      2.226351887267958_REALK,      0.892134109358284_REALK,      0.000000000000000_REALK, &
      0.527353085876537_REALK,      0.000000000000000_REALK,      0.123062914166450_REALK, &
      0.381982133403126_REALK,      0.000000000000000_REALK,      0.056507473212687_REALK, &
      0.000000000000000_REALK,      0.370909006593053_REALK,      0.000000000000000_REALK, &
      0.040599540805311_REALK,      0.000000000000000_REALK,     -0.259997548774935_REALK, &
      1.041031031394035_REALK,      0.771402940973008_REALK,      0.000000000000000_REALK, &
      0.789707171925735_REALK,      0.000000000000000_REALK,     -0.461980053905770_REALK, &
      1.051076830018077_REALK,      0.000000000000000_REALK,     -0.292763556405217_REALK, &
      0.000000000000000_REALK,      1.740679530554416_REALK,      0.000000000000000_REALK, &
     -0.306086962271854_REALK,      0.000000000000000_REALK,     -0.963452249259569_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.653645155751843_REALK, &
      0.000000000000000_REALK,     -0.286733377151829_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.144634769107033_REALK,      0.000000000000000_REALK, &
     -0.047255140774220_REALK,      0.000000000000000_REALK,     -0.040990243987471_REALK, &
      0.000000000000000_REALK,     -0.025195857912708_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.080196797418006_REALK, &
      0.000000000000000_REALK,      0.068268235221742_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.200876666851088_REALK,      0.000000000000000_REALK, &
      0.236183706793204_REALK,      0.000000000000000_REALK,      0.391118914566252_REALK, &
      0.000000000000000_REALK,     -0.205331041605905_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     17.571375772041410_REALK, &
      0.000000000000000_REALK,      2.526079496968509_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.340251556813987_REALK,      0.000000000000000_REALK, &
      4.413206810395598_REALK,      0.000000000000000_REALK,      0.520651533664298_REALK, &
      0.000000000000000_REALK,      0.762043198491398_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     39.427665433902220_REALK, &
      0.000000000000000_REALK,      5.868996815392356_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.444101081659632_REALK,      0.000000000000000_REALK, &
      7.798369133220606_REALK,      0.000000000000000_REALK,      2.926572898044868_REALK, &
      0.000000000000000_REALK,      1.337139101682161_REALK,      0.000000000000000_REALK, &
     15.730254107106168_REALK,      2.869919999583782_REALK,      0.000000000000000_REALK, &
      1.291534901038749_REALK,      0.000000000000000_REALK,     -1.626138320443142_REALK, &
      0.535273380312941_REALK,      0.000000000000000_REALK,     -0.341363196643447_REALK, &
      0.000000000000000_REALK,      0.326712499992547_REALK,      0.000000000000000_REALK, &
     -0.184517310868520_REALK,      0.000000000000000_REALK,     -1.326394517760135_REALK, &
     18.784371310569604_REALK,      2.580476735968341_REALK,      0.000000000000000_REALK, &
      0.318686026772865_REALK,      0.000000000000000_REALK,     -5.343197501825649_REALK, &
     -0.873363426966630_REALK,      0.000000000000000_REALK,     -0.823450709189911_REALK, &
      0.000000000000000_REALK,     -1.910040901254697_REALK,      0.000000000000000_REALK, &
     -0.117141470292131_REALK,      0.000000000000000_REALK,     -2.686202938257739_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.974238474389750_REALK, &
      0.000000000000000_REALK,     -0.243133297632917_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.119495424810484_REALK,      0.000000000000000_REALK, &
      0.505457352691654_REALK,      0.000000000000000_REALK,     -0.066414529312530_REALK, &
      0.000000000000000_REALK,      0.151512249546336_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.598019329954037_REALK, &
      0.000000000000000_REALK,      0.426332962750608_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.252964026342584_REALK,      0.000000000000000_REALK, &
      2.322345180755623_REALK,      0.000000000000000_REALK,      0.240673964809646_REALK, &
      0.000000000000000_REALK,      0.713680194238163_REALK,      0.000000000000000_REALK, &
      4.518487972372628_REALK,      1.293025093027460_REALK,      0.000000000000000_REALK, &
      0.598452666097253_REALK,      0.000000000000000_REALK,      0.190439226246937_REALK, &
      0.307114205993017_REALK,      0.000000000000000_REALK,      0.062704020895619_REALK, &
      0.000000000000000_REALK,      0.181927011065529_REALK,      0.000000000000000_REALK, &
      0.034857987346411_REALK,      0.000000000000000_REALK,     -0.304404689461642_REALK, &
      7.803700949464636_REALK,      1.470790038946840_REALK,      0.000000000000000_REALK, &
     -0.062911044405503_REALK,      0.000000000000000_REALK,     -1.302524149639696_REALK, &
     -0.885254848936498_REALK,      0.000000000000000_REALK,     -0.275403174953247_REALK, &
      0.000000000000000_REALK,     -1.704926003999438_REALK,      0.000000000000000_REALK, &
      0.013569228226575_REALK,      0.000000000000000_REALK,     -1.511618703344296_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.138842426635297_REALK, &
      0.000000000000000_REALK,     -0.423527339103640_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.236660824072216_REALK,      0.000000000000000_REALK, &
     -0.063035230701217_REALK,      0.000000000000000_REALK,     -0.166759703264564_REALK, &
      0.000000000000000_REALK,     -0.028156924888953_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.061789040603246_REALK, &
      0.000000000000000_REALK,     -0.462861599575549_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.339859456175841_REALK,      0.000000000000000_REALK, &
      1.542814408406607_REALK,      0.000000000000000_REALK,     -0.358423810204824_REALK, &
      0.000000000000000_REALK,      0.774705410081152_REALK,      0.000000000000000_REALK, &
      2.740126514972476_REALK,      0.987541222737090_REALK,      0.000000000000000_REALK, &
      0.403449153902916_REALK,      0.000000000000000_REALK,      0.514239059353327_REALK, &
      0.088925495696710_REALK,      0.000000000000000_REALK,      0.213243027091457_REALK, &
      0.000000000000000_REALK,     -0.173153714494003_REALK,      0.000000000000000_REALK, &
      0.104638734494587_REALK,      0.000000000000000_REALK,      0.022242100332581_REALK, &
      3.510342799990548_REALK,     -1.910475609504132_REALK,      0.000000000000000_REALK, &
     -3.866975667402599_REALK,      0.000000000000000_REALK,     -0.173316364391569_REALK, &
     -5.287752923186196_REALK,      0.000000000000000_REALK,      0.105819239361073_REALK, &
      0.000000000000000_REALK,     -7.155774602402691_REALK,      0.000000000000000_REALK, &
      0.246720119366463_REALK,      0.000000000000000_REALK,     -0.732621325058799_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.044587359439820_REALK, &
      0.000000000000000_REALK,      2.121144364623726_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.917140916653799_REALK,      0.000000000000000_REALK, &
      3.109365592964874_REALK,      0.000000000000000_REALK,      3.370273628126790_REALK, &
      0.000000000000000_REALK,      7.938431441571613_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.638903412325231_REALK, &
      0.000000000000000_REALK,      0.056689330492793_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.508266897834532_REALK,      0.000000000000000_REALK, &
      1.625474527653438_REALK,      0.000000000000000_REALK,    -15.402170041067093_REALK, &
      0.000000000000000_REALK,      0.253017105919307_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.453204871414534_REALK, &
      0.000000000000000_REALK,      1.019358964285105_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.221440413818928_REALK,      0.000000000000000_REALK, &
      4.473972473064979_REALK,      0.000000000000000_REALK,      2.147692267080746_REALK, &
      0.000000000000000_REALK,      3.275832458634831_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.160817193167822_REALK, &
      0.000000000000000_REALK,      0.796957293457937_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.139850983865434_REALK,      0.000000000000000_REALK, &
      3.041768992519959_REALK,      0.000000000000000_REALK,      5.440377959770212_REALK, &
      0.000000000000000_REALK,      2.821598486064986_REALK,      0.000000000000000_REALK, &
      6.739623493000440_REALK,      1.243285090756008_REALK,      0.000000000000000_REALK, &
      2.286902673361567_REALK,      0.000000000000000_REALK,      0.152689689128570_REALK, &
      0.683867794878887_REALK,      0.000000000000000_REALK,      0.031722543228257_REALK, &
      0.000000000000000_REALK,      1.511208485239099_REALK,      0.000000000000000_REALK, &
      0.144733320829210_REALK,      0.000000000000000_REALK,     -7.323952655368202_REALK, &
      1.923809589022957_REALK,      0.021609888944982_REALK,      0.000000000000000_REALK, &
     -0.646764543552429_REALK,      0.000000000000000_REALK,     -0.875612300330878_REALK, &
     -1.851794400515794_REALK,      0.000000000000000_REALK,     -0.012877692335565_REALK, &
      0.000000000000000_REALK,    -16.734358700473010_REALK,      0.000000000000000_REALK, &
      0.969356832663368_REALK,      0.000000000000000_REALK,     -8.641179288254875_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.007159388121674_REALK, &
      0.000000000000000_REALK,      0.187210817647410_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.348735610155402_REALK,      0.000000000000000_REALK, &
      5.651534830574002_REALK,      0.000000000000000_REALK,     -0.056617433833474_REALK, &
      0.000000000000000_REALK,      0.482145459197691_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.522277141355356_REALK, &
      0.000000000000000_REALK,     -0.086460271149407_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.436870986842693_REALK,      0.000000000000000_REALK, &
      3.841407928236389_REALK,      0.000000000000000_REALK,     -2.358884112479183_REALK, &
      0.000000000000000_REALK,     -0.245553386185797_REALK,      0.000000000000000_REALK, &
      7.640195874403676_REALK,      0.955828295051998_REALK,      0.000000000000000_REALK, &
      2.019810124125582_REALK,      0.000000000000000_REALK,      0.145699437933246_REALK, &
      0.707302587225063_REALK,      0.000000000000000_REALK,      0.021246196040203_REALK, &
      0.000000000000000_REALK,      4.202668862462227_REALK,      0.000000000000000_REALK, &
      0.102443402628716_REALK,      0.000000000000000_REALK,     -5.600751440788788_REALK, &
      1.448556074866965_REALK,      0.373397239635865_REALK,      0.000000000000000_REALK, &
      0.908969382246564_REALK,      0.000000000000000_REALK,     -1.026844575136587_REALK, &
      1.096484725899581_REALK,      0.000000000000000_REALK,     -0.240738769187116_REALK, &
      0.000000000000000_REALK,      6.638694539361995_REALK,      0.000000000000000_REALK, &
     -1.092838275470118_REALK,      0.000000000000000_REALK,     -8.128961101680620_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.743805802693236_REALK, &
      0.000000000000000_REALK,     -0.638913299806422_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.580547008544387_REALK,      0.000000000000000_REALK, &
     -0.757439963220353_REALK,      0.000000000000000_REALK,     -0.698585445476296_REALK, &
      0.000000000000000_REALK,     -0.633233924990309_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.317148173048078_REALK, &
      0.000000000000000_REALK,     -0.007938775630581_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.151032877331645_REALK,      0.000000000000000_REALK, &
      0.784529493982658_REALK,      0.000000000000000_REALK,      1.372508023641146_REALK, &
      0.000000000000000_REALK,      0.036621177063934_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      7.675717816681842_REALK, &
      0.000000000000000_REALK,     -0.719051410049493_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.795288281115057_REALK,      0.000000000000000_REALK, &
      7.357990570703930_REALK,      0.000000000000000_REALK,     -1.278168556851788_REALK, &
      0.000000000000000_REALK,     -1.409087046046340_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.497519591159349_REALK, &
      0.000000000000000_REALK,     -0.586750292662189_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.566883951006742_REALK,      0.000000000000000_REALK, &
      6.086984256794231_REALK,      0.000000000000000_REALK,      0.311007450734331_REALK, &
      0.000000000000000_REALK,     -1.072118091548105_REALK,      0.000000000000000_REALK, &
     10.744606354631989_REALK,      0.244778633656748_REALK,      0.000000000000000_REALK, &
      2.026041633916683_REALK,      0.000000000000000_REALK,      0.167191525078547_REALK, &
     -0.027554074804188_REALK,      0.000000000000000_REALK,      0.004621043345390_REALK, &
      0.000000000000000_REALK,      2.602335697174517_REALK,      0.000000000000000_REALK, &
      0.078190241606193_REALK,      0.000000000000000_REALK,     -4.890276570474483_REALK, &
      5.059388144694766_REALK,     -0.086654008632837_REALK,      0.000000000000000_REALK, &
      0.390886911635014_REALK,      0.000000000000000_REALK,     -1.455008940780762_REALK, &
     -0.779837143717459_REALK,      0.000000000000000_REALK,      0.034365332266093_REALK, &
      0.000000000000000_REALK,     -2.487042165129734_REALK,      0.000000000000000_REALK, &
     -0.302355412215796_REALK,      0.000000000000000_REALK,     -7.410644326366144_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.320257119802841_REALK, &
      0.000000000000000_REALK,     -0.388721352652506_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.607232934438636_REALK,      0.000000000000000_REALK, &
     -0.855956008485079_REALK,      0.000000000000000_REALK,     -0.499420826497580_REALK, &
      0.000000000000000_REALK,     -0.293151001132312_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.795593240313608_REALK, &
      0.000000000000000_REALK,     -0.166516881019144_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.279297800361542_REALK,      0.000000000000000_REALK, &
      1.210584481479144_REALK,      0.000000000000000_REALK,     -0.586653189597270_REALK, &
      0.000000000000000_REALK,      0.494193483410490_REALK,      0.000000000000000_REALK, &
      3.452866206041297_REALK,      0.770844953752298_REALK,      0.000000000000000_REALK, &
      0.804713842238142_REALK,      0.000000000000000_REALK,      1.872532481620072_REALK, &
      0.313716762090114_REALK,      0.000000000000000_REALK,      0.507176858066597_REALK, &
      0.000000000000000_REALK,      0.324266077345199_REALK,      0.000000000000000_REALK, &
      1.082359468318600_REALK,      0.000000000000000_REALK,      3.321140634634218_REALK, &
      2.504158105004662_REALK,      0.031319868467366_REALK,      0.000000000000000_REALK, &
     -0.531941358676136_REALK,      0.000000000000000_REALK,      0.413964099210032_REALK, &
     -1.786103165788588_REALK,      0.000000000000000_REALK,      0.007139784256863_REALK, &
      0.000000000000000_REALK,     -7.103228317290317_REALK,      0.000000000000000_REALK, &
     -0.236517699664349_REALK,      0.000000000000000_REALK,     -2.659384410765910_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     13.232232969955458_REALK, &
      0.000000000000000_REALK,     -2.354037648381481_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.848891797259034_REALK,      0.000000000000000_REALK, &
     10.427845522269001_REALK,      0.000000000000000_REALK,     -2.777161952416411_REALK, &
      0.000000000000000_REALK,     -3.378353912643380_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      9.853395923764094_REALK, &
      0.000000000000000_REALK,     -2.464419918671608_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.254815033235516_REALK,      0.000000000000000_REALK, &
     10.002740646713931_REALK,      0.000000000000000_REALK,     -3.552136475634689_REALK, &
      0.000000000000000_REALK,     -3.511798305857403_REALK,      0.000000000000000_REALK, &
     18.410033321704415_REALK,     -1.238928626709118_REALK,      0.000000000000000_REALK, &
      2.861003285242426_REALK,      0.000000000000000_REALK,      0.230924332428898_REALK, &
     -0.885641676713466_REALK,      0.000000000000000_REALK,     -0.019227997084120_REALK, &
      0.000000000000000_REALK,      3.113737240056449_REALK,      0.000000000000000_REALK, &
      0.080860496826592_REALK,      0.000000000000000_REALK,     -4.946553588177140_REALK, &
      4.832307918238196_REALK,     -0.507340169864239_REALK,      0.000000000000000_REALK, &
      1.378208889989605_REALK,      0.000000000000000_REALK,     -2.266510323760862_REALK, &
      0.149403404349347_REALK,      0.000000000000000_REALK,      0.218026675719636_REALK, &
      0.000000000000000_REALK,      3.457503530846006_REALK,      0.000000000000000_REALK, &
     -0.831394620315562_REALK,      0.000000000000000_REALK,     -9.002716088072086_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.508619529247603_REALK, &
      0.000000000000000_REALK,     -0.089693273411107_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.659869632461070_REALK,      0.000000000000000_REALK, &
     -1.064076448580154_REALK,      0.000000000000000_REALK,      0.015115541637999_REALK, &
      0.000000000000000_REALK,     -0.049536659651026_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.972581274534136_REALK, &
      0.000000000000000_REALK,      0.023367543971698_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.112285002672697_REALK,      0.000000000000000_REALK, &
      1.603645667981096_REALK,      0.000000000000000_REALK,      0.319881115007011_REALK, &
      0.000000000000000_REALK,     -0.054085065531990_REALK,      0.000000000000000_REALK, &
      5.135162924521350_REALK,      0.618026762479051_REALK,      0.000000000000000_REALK, &
      0.892939464834604_REALK,      0.000000000000000_REALK,      2.244890740573041_REALK, &
      0.319314840836878_REALK,      0.000000000000000_REALK,      0.334288087643435_REALK, &
      0.000000000000000_REALK,      1.035335829986242_REALK,      0.000000000000000_REALK, &
      0.879560922070636_REALK,      0.000000000000000_REALK,      2.915862056198403_REALK, &
      2.329122998047990_REALK,      0.566759148941376_REALK,      0.000000000000000_REALK, &
      0.967030266065390_REALK,      0.000000000000000_REALK,      0.627955394081196_REALK, &
      1.109342044166631_REALK,      0.000000000000000_REALK,      0.140004563772471_REALK, &
      0.000000000000000_REALK,      3.543716892767136_REALK,      0.000000000000000_REALK, &
      0.335324665482216_REALK,      0.000000000000000_REALK,     -3.146101864243078_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.601852719752774_REALK, &
      0.000000000000000_REALK,     -0.651794352585489_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.604795345655399_REALK,      0.000000000000000_REALK, &
     -2.506359051465912_REALK,      0.000000000000000_REALK,     -0.397130092045992_REALK, &
      0.000000000000000_REALK,     -1.143408613856631_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.594393539822673_REALK, &
      0.000000000000000_REALK,     -0.027973719493593_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.506104569744027_REALK,      0.000000000000000_REALK, &
     -0.560254121414469_REALK,      0.000000000000000_REALK,      2.426593892720527_REALK, &
      0.000000000000000_REALK,     -0.013798171215597_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     28.578810033362807_REALK, &
      0.000000000000000_REALK,     -6.489534505351901_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      5.527807518010002_REALK,      0.000000000000000_REALK, &
     17.040545381956004_REALK,      0.000000000000000_REALK,     -5.340428087842213_REALK, &
      0.000000000000000_REALK,     -6.422484606665105_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     61.412084329601093_REALK, &
      0.000000000000000_REALK,    -13.464700512355400_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      9.647487993103605_REALK,      0.000000000000000_REALK, &
     28.898679622747657_REALK,      0.000000000000000_REALK,     -5.826658350469169_REALK, &
      0.000000000000000_REALK,     -9.232413891079290_REALK,      0.000000000000000_REALK, &
     43.011596727298055_REALK,     -5.665859427077834_REALK,      0.000000000000000_REALK, &
      5.532783896842880_REALK,      0.000000000000000_REALK,      0.398830764607268_REALK, &
     -2.777161952416410_REALK,      0.000000000000000_REALK,     -0.066532133947025_REALK, &
      0.000000000000000_REALK,      4.630553990364325_REALK,      0.000000000000000_REALK, &
      0.107834950429708_REALK,      0.000000000000000_REALK,     -5.891412870240624_REALK, &
     51.561500800939136_REALK,     -7.462861851241898_REALK,      0.000000000000000_REALK, &
      4.403682758525665_REALK,      0.000000000000000_REALK,     -8.269922125652041_REALK, &
     -3.552136475634689_REALK,      0.000000000000000_REALK,      1.486643626712887_REALK, &
      0.000000000000000_REALK,     -0.039940172101777_REALK,      0.000000000000000_REALK, &
     -1.278238519741650_REALK,      0.000000000000000_REALK,    -15.805963902797808_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -6.769518184699796_REALK, &
      0.000000000000000_REALK,      0.454817819590072_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.984854507300778_REALK,      0.000000000000000_REALK, &
     -1.553360337795989_REALK,      0.000000000000000_REALK,      0.408298049429594_REALK, &
      0.000000000000000_REALK,      0.173221622509263_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -5.305944465064122_REALK, &
      0.000000000000000_REALK,      0.329176666456132_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.642719559298425_REALK,      0.000000000000000_REALK, &
      4.055424306707422_REALK,      0.000000000000000_REALK,     -0.065475041046830_REALK, &
      0.000000000000000_REALK,     -0.366603871947385_REALK,      0.000000000000000_REALK, &
     10.523767432407023_REALK,      0.199202508928201_REALK,      0.000000000000000_REALK, &
      1.182519834888909_REALK,      0.000000000000000_REALK,      3.400949529936066_REALK, &
     -0.013947817391287_REALK,      0.000000000000000_REALK,      0.081524157852630_REALK, &
      0.000000000000000_REALK,      0.767070063017775_REALK,      0.000000000000000_REALK, &
      0.803248880208568_REALK,      0.000000000000000_REALK,      3.046279440778997_REALK, &
     20.033639596328371_REALK,     -0.278546751068983_REALK,      0.000000000000000_REALK, &
      0.863219402891331_REALK,      0.000000000000000_REALK,      1.847008937076143_REALK, &
     -1.259165853754712_REALK,      0.000000000000000_REALK,     -0.031895751459770_REALK, &
      0.000000000000000_REALK,     -2.061021256788333_REALK,      0.000000000000000_REALK, &
      0.144029130797051_REALK,      0.000000000000000_REALK,     -4.452630886891213_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.357271318279055_REALK, &
      0.000000000000000_REALK,     -0.523546978349092_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.709304850441906_REALK,      0.000000000000000_REALK, &
     -3.175799520756840_REALK,      0.000000000000000_REALK,     -0.339700006439974_REALK, &
      0.000000000000000_REALK,     -0.633350780870881_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -8.470448364933553_REALK, &
      0.000000000000000_REALK,     -1.217963316256495_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.493662274434421_REALK,      0.000000000000000_REALK, &
     -1.379707488217319_REALK,      0.000000000000000_REALK,     -1.610225257475788_REALK, &
      0.000000000000000_REALK,     -0.289074135120970_REALK,      0.000000000000000_REALK, &
      5.636496385297429_REALK,      1.045531401768707_REALK,      0.000000000000000_REALK, &
      0.782799050067465_REALK,      0.000000000000000_REALK,      3.590810351385203_REALK, &
      0.264671326069089_REALK,      0.000000000000000_REALK,      0.843495730768991_REALK, &
      0.000000000000000_REALK,      0.159302276447124_REALK,      0.000000000000000_REALK, &
      1.048205116388365_REALK,      0.000000000000000_REALK,      6.369857696379724_REALK, &
     16.526175212343666_REALK,      0.167794653379460_REALK,      0.000000000000000_REALK, &
     -1.957864232773173_REALK,      0.000000000000000_REALK,      5.697898470471070_REALK, &
     -4.806559368971299_REALK,      0.000000000000000_REALK,      0.071853193132281_REALK, &
      0.000000000000000_REALK,     -9.810786992288149_REALK,      0.000000000000000_REALK, &
     -1.221644747222700_REALK,      0.000000000000000_REALK,      1.536141859802369_REALK/
    ! results of test 4, ket-major order, 03 DPG Z
  data REF_CONTR_INTS(27721:28980)                                                         &
    /-8.137725953997332_REALK,     -7.518411801115001_REALK,      0.000000000000000_REALK, &
     -9.012467752998225_REALK,      0.000000000000000_REALK,     -4.249544871489119_REALK, &
    -13.294080802006800_REALK,      0.000000000000000_REALK,     -4.769220718279112_REALK, &
      0.000000000000000_REALK,    -27.132935907577220_REALK,      0.000000000000000_REALK, &
     -8.100933386245487_REALK,      0.000000000000000_REALK,     -6.366232658519462_REALK, &
     -6.988877524013226_REALK,    -10.471826728432431_REALK,      0.000000000000000_REALK, &
    -15.685750486857497_REALK,      0.000000000000000_REALK,     -5.673191459599130_REALK, &
    -26.513231285085478_REALK,      0.000000000000000_REALK,     -7.726298485887849_REALK, &
      0.000000000000000_REALK,    -57.083136889896409_REALK,      0.000000000000000_REALK, &
    -14.207382135793260_REALK,      0.000000000000000_REALK,     -8.564163491739025_REALK, &
     -5.955487982959789_REALK,     -3.994314244361493_REALK,      0.000000000000000_REALK, &
     -3.563575162119177_REALK,      0.000000000000000_REALK,     -2.712234702000821_REALK, &
     -3.811686406944702_REALK,      0.000000000000000_REALK,     -2.183937427763691_REALK, &
      0.000000000000000_REALK,     -5.228057418123846_REALK,      0.000000000000000_REALK, &
     -2.637071965788581_REALK,      0.000000000000000_REALK,     -3.345122885445173_REALK, &
     -6.989821363372716_REALK,     -3.658078890679596_REALK,      0.000000000000000_REALK, &
     -2.100636241988287_REALK,      0.000000000000000_REALK,     -2.567440151273846_REALK, &
     -0.334353687490897_REALK,      0.000000000000000_REALK,     -1.803230685245962_REALK, &
      0.000000000000000_REALK,      3.891090721156867_REALK,      0.000000000000000_REALK, &
     -1.413966886784952_REALK,      0.000000000000000_REALK,     -2.880298268004151_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.366783791719838_REALK, &
      0.000000000000000_REALK,      1.284475015170755_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.584889858857865_REALK,      0.000000000000000_REALK, &
      2.020600419200204_REALK,      0.000000000000000_REALK,      2.649553003233414_REALK, &
      0.000000000000000_REALK,      2.570066592012236_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.047342333479302_REALK, &
      0.000000000000000_REALK,      4.142240042955138_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      5.516276455729082_REALK,      0.000000000000000_REALK, &
      4.402435872890289_REALK,      0.000000000000000_REALK,      9.567860308822143_REALK, &
      0.000000000000000_REALK,      6.152456119377796_REALK,      0.000000000000000_REALK, &
     -5.946208168112799_REALK,     -3.112219820549316_REALK,      0.000000000000000_REALK, &
     -2.344718005515286_REALK,      0.000000000000000_REALK,     -2.353389607268505_REALK, &
     -2.167236685952599_REALK,      0.000000000000000_REALK,     -1.455960840430643_REALK, &
      0.000000000000000_REALK,     -2.656139868993541_REALK,      0.000000000000000_REALK, &
     -1.424942776015703_REALK,      0.000000000000000_REALK,     -2.383687869315668_REALK, &
     -3.585061616622279_REALK,     -2.953048246087967_REALK,      0.000000000000000_REALK, &
     -2.937504213248849_REALK,      0.000000000000000_REALK,     -2.210190240759886_REALK, &
     -3.710161698649758_REALK,      0.000000000000000_REALK,     -1.616864573813839_REALK, &
      0.000000000000000_REALK,     -6.403306372731564_REALK,      0.000000000000000_REALK, &
     -1.791944110451794_REALK,      0.000000000000000_REALK,     -2.247110186852236_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.003409413637530_REALK, &
      0.000000000000000_REALK,      0.677792042716806_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.616760080109802_REALK,      0.000000000000000_REALK, &
      1.269229793003586_REALK,      0.000000000000000_REALK,      0.718919466885174_REALK, &
      0.000000000000000_REALK,      1.113745412138833_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.431988550468432_REALK, &
      0.000000000000000_REALK,      0.985957922932241_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.641494849864817_REALK,      0.000000000000000_REALK, &
      1.730085339574724_REALK,      0.000000000000000_REALK,      0.111521646173543_REALK, &
      0.000000000000000_REALK,      1.327178142234540_REALK,      0.000000000000000_REALK, &
      0.832381672282525_REALK,      0.674992175188204_REALK,      0.000000000000000_REALK, &
      0.698678751796009_REALK,      0.000000000000000_REALK,     -0.680529505964468_REALK, &
      0.880215598630669_REALK,      0.000000000000000_REALK,     -0.652302280663389_REALK, &
      0.000000000000000_REALK,      1.422152172717833_REALK,      0.000000000000000_REALK, &
     -0.877112034286450_REALK,      0.000000000000000_REALK,     -1.712262941148186_REALK, &
     -0.608778392320540_REALK,     -0.794861547749707_REALK,      0.000000000000000_REALK, &
     -1.037695955375129_REALK,      0.000000000000000_REALK,     -2.757619104809249_REALK, &
     -1.493433089317576_REALK,      0.000000000000000_REALK,     -3.197691837899330_REALK, &
      0.000000000000000_REALK,     -2.543371819675107_REALK,      0.000000000000000_REALK, &
     -4.651125982536243_REALK,      0.000000000000000_REALK,     -5.225785861474071_REALK, &
     -7.421919132057277_REALK,     -2.926029388467826_REALK,      0.000000000000000_REALK, &
     -1.816085843545380_REALK,      0.000000000000000_REALK,     -2.497174251660709_REALK, &
     -1.325947453579602_REALK,      0.000000000000000_REALK,     -1.151345574447807_REALK, &
      0.000000000000000_REALK,     -1.231019868863307_REALK,      0.000000000000000_REALK, &
     -0.898167928206524_REALK,      0.000000000000000_REALK,     -2.058347839995457_REALK, &
    -10.680662694702249_REALK,     -3.410755027230077_REALK,      0.000000000000000_REALK, &
     -1.335766443459854_REALK,      0.000000000000000_REALK,     -2.823993082177350_REALK, &
      0.036883414653781_REALK,      0.000000000000000_REALK,     -1.131370926596491_REALK, &
      0.000000000000000_REALK,      1.896576615444876_REALK,      0.000000000000000_REALK, &
     -0.562498293595675_REALK,      0.000000000000000_REALK,     -1.981997299039168_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.030891910556724_REALK, &
      0.000000000000000_REALK,      0.534099003216049_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.404144740326823_REALK,      0.000000000000000_REALK, &
      1.096788278771223_REALK,      0.000000000000000_REALK,      0.393187395269400_REALK, &
      0.000000000000000_REALK,      0.714209453304695_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.580566098480313_REALK, &
      0.000000000000000_REALK,      1.383314564421933_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.137675263062559_REALK,      0.000000000000000_REALK, &
      1.888836433404303_REALK,      0.000000000000000_REALK,      1.336690378001966_REALK, &
      0.000000000000000_REALK,      1.285394706223699_REALK,      0.000000000000000_REALK, &
      0.726974568819392_REALK,      0.421733345290702_REALK,      0.000000000000000_REALK, &
      0.321373826445930_REALK,      0.000000000000000_REALK,     -0.505268911270286_REALK, &
      0.289628920261060_REALK,      0.000000000000000_REALK,     -0.342795949446317_REALK, &
      0.000000000000000_REALK,      0.315101188067622_REALK,      0.000000000000000_REALK, &
     -0.328323827811735_REALK,      0.000000000000000_REALK,     -1.034571330761249_REALK, &
     -0.872853851337845_REALK,     -0.396059760371329_REALK,      0.000000000000000_REALK, &
     -0.188824127445455_REALK,      0.000000000000000_REALK,     -1.695699836727133_REALK, &
     -0.024359593397086_REALK,      0.000000000000000_REALK,     -0.965288703736992_REALK, &
      0.000000000000000_REALK,      0.218816609383813_REALK,      0.000000000000000_REALK, &
     -0.584238515169235_REALK,      0.000000000000000_REALK,     -2.218252741304243_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.270557963073644_REALK, &
      0.000000000000000_REALK,     -0.217177600469761_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.225781647258981_REALK,      0.000000000000000_REALK, &
      0.564091669144143_REALK,      0.000000000000000_REALK,     -0.299396757599300_REALK, &
      0.000000000000000_REALK,      0.569113062190256_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.448245518701450_REALK, &
      0.000000000000000_REALK,      2.080267914759667_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.245366901715177_REALK,      0.000000000000000_REALK, &
      4.136692244938383_REALK,      0.000000000000000_REALK,      3.006084119274782_REALK, &
      0.000000000000000_REALK,      4.462248050668668_REALK,      0.000000000000000_REALK, &
    -11.326235033600346_REALK,     -3.353030369708668_REALK,      0.000000000000000_REALK, &
     -1.801128853310727_REALK,      0.000000000000000_REALK,     -3.242492886939606_REALK, &
     -1.089916812175532_REALK,      0.000000000000000_REALK,     -1.099950916903829_REALK, &
      0.000000000000000_REALK,     -0.890571133297543_REALK,      0.000000000000000_REALK, &
     -0.718165418453626_REALK,      0.000000000000000_REALK,     -2.154802580893928_REALK, &
     -7.581786524393091_REALK,     -3.501866164121771_REALK,      0.000000000000000_REALK, &
     -2.505035817257145_REALK,      0.000000000000000_REALK,     -3.553984792398894_REALK, &
     -2.405093712635869_REALK,      0.000000000000000_REALK,     -1.403846847360554_REALK, &
      0.000000000000000_REALK,     -3.504844542754003_REALK,      0.000000000000000_REALK, &
     -1.025597968764424_REALK,      0.000000000000000_REALK,     -2.425088135795570_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.324692181530647_REALK, &
      0.000000000000000_REALK,      0.513522161865704_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.316037281155698_REALK,      0.000000000000000_REALK, &
      1.174988047485308_REALK,      0.000000000000000_REALK,      0.235808531673546_REALK, &
      0.000000000000000_REALK,      0.553632469896448_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.138675662171723_REALK, &
      0.000000000000000_REALK,      0.900422006165978_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.405538429416759_REALK,      0.000000000000000_REALK, &
      1.891864341567256_REALK,      0.000000000000000_REALK,     -0.012018089102400_REALK, &
      0.000000000000000_REALK,      0.813456230775359_REALK,      0.000000000000000_REALK, &
      0.897681656762605_REALK,      0.402448271731825_REALK,      0.000000000000000_REALK, &
      0.256042819323277_REALK,      0.000000000000000_REALK,     -0.530867993271107_REALK, &
      0.196518090249710_REALK,      0.000000000000000_REALK,     -0.272719765192369_REALK, &
      0.000000000000000_REALK,      0.190303082404576_REALK,      0.000000000000000_REALK, &
     -0.210893422356248_REALK,      0.000000000000000_REALK,     -0.876360792246952_REALK, &
     -0.500015601786151_REALK,     -0.360428609808526_REALK,      0.000000000000000_REALK, &
     -0.311513168325876_REALK,      0.000000000000000_REALK,     -1.722144487559651_REALK, &
     -0.331557331750035_REALK,      0.000000000000000_REALK,     -1.061650236815361_REALK, &
      0.000000000000000_REALK,     -0.455742408909865_REALK,      0.000000000000000_REALK, &
     -0.937090724840591_REALK,      0.000000000000000_REALK,     -2.190302840681629_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.243266755258462_REALK, &
      0.000000000000000_REALK,     -0.138766053439616_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.104852124979126_REALK,      0.000000000000000_REALK, &
      0.422844741968878_REALK,      0.000000000000000_REALK,     -0.096569484822867_REALK, &
      0.000000000000000_REALK,      0.293173893953730_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.976485132941532_REALK, &
      0.000000000000000_REALK,      0.584162492419089_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.320284814282801_REALK,      0.000000000000000_REALK, &
      1.994020322013205_REALK,      0.000000000000000_REALK,      0.044345719843872_REALK, &
      0.000000000000000_REALK,      1.218261832942779_REALK,      0.000000000000000_REALK, &
      2.041522747813437_REALK,      1.418038471048692_REALK,      0.000000000000000_REALK, &
      1.239507018934714_REALK,      0.000000000000000_REALK,      0.128800895130054_REALK, &
      1.296685709307166_REALK,      0.000000000000000_REALK,      0.102516796740564_REALK, &
      0.000000000000000_REALK,      1.655352250998265_REALK,      0.000000000000000_REALK, &
      0.108918058445446_REALK,      0.000000000000000_REALK,     -0.666594823849110_REALK, &
      0.948912397555915_REALK,      1.084226860830980_REALK,      0.000000000000000_REALK, &
      1.229838248650144_REALK,      0.000000000000000_REALK,     -3.267705097444553_REALK, &
      1.491528402162909_REALK,      0.000000000000000_REALK,     -3.193104054530806_REALK, &
      0.000000000000000_REALK,      2.023042362426698_REALK,      0.000000000000000_REALK, &
     -3.698996579915871_REALK,      0.000000000000000_REALK,     -6.951485342599682_REALK, &
    -25.760016550189654_REALK,     -5.207353015824748_REALK,      0.000000000000000_REALK, &
     -2.378115229363468_REALK,      0.000000000000000_REALK,     -5.623018221931065_REALK, &
     -1.079336322387982_REALK,      0.000000000000000_REALK,     -1.307872877554535_REALK, &
      0.000000000000000_REALK,     -0.700280650854329_REALK,      0.000000000000000_REALK, &
     -0.717406771220009_REALK,      0.000000000000000_REALK,     -2.827162800536084_REALK, &
    -76.841168444955002_REALK,    -13.204290197976960_REALK,      0.000000000000000_REALK, &
     -3.663249561774432_REALK,      0.000000000000000_REALK,    -13.547638176106885_REALK, &
      0.629251771885525_REALK,      0.000000000000000_REALK,     -2.611666908826147_REALK, &
      0.000000000000000_REALK,      3.449829401489751_REALK,      0.000000000000000_REALK, &
     -0.834601616314077_REALK,      0.000000000000000_REALK,     -5.144285389399911_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.437859187900436_REALK, &
      0.000000000000000_REALK,      0.669795167551374_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.340112725525865_REALK,      0.000000000000000_REALK, &
      1.655540413667114_REALK,      0.000000000000000_REALK,      0.200214087811873_REALK, &
      0.000000000000000_REALK,      0.546332760930368_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     11.868914065487886_REALK, &
      0.000000000000000_REALK,      3.225033838544671_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.654672640404744_REALK,      0.000000000000000_REALK, &
      5.180105306053826_REALK,      0.000000000000000_REALK,      1.258807329295214_REALK, &
      0.000000000000000_REALK,      1.621331678291762_REALK,      0.000000000000000_REALK, &
      1.721941199597337_REALK,      0.548417052552909_REALK,      0.000000000000000_REALK, &
      0.273356367805010_REALK,      0.000000000000000_REALK,     -0.776448041639968_REALK, &
      0.158628084966085_REALK,      0.000000000000000_REALK,     -0.284531394357001_REALK, &
      0.000000000000000_REALK,      0.113023640502003_REALK,      0.000000000000000_REALK, &
     -0.170346220024884_REALK,      0.000000000000000_REALK,     -0.969754197732820_REALK, &
     -3.843501354760260_REALK,     -1.034566780702520_REALK,      0.000000000000000_REALK, &
     -0.320526224636809_REALK,      0.000000000000000_REALK,     -4.978960544648698_REALK, &
      0.006670945030812_REALK,      0.000000000000000_REALK,     -1.503499446032021_REALK, &
      0.000000000000000_REALK,      0.246221212393926_REALK,      0.000000000000000_REALK, &
     -0.536560008828210_REALK,      0.000000000000000_REALK,     -3.523893448405508_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.362251495587146_REALK, &
      0.000000000000000_REALK,     -0.150722947484236_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.090647428330862_REALK,      0.000000000000000_REALK, &
      0.482082152510603_REALK,      0.000000000000000_REALK,     -0.067681286462269_REALK, &
      0.000000000000000_REALK,      0.240920806746977_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.373210323009790_REALK, &
      0.000000000000000_REALK,      1.854519328887100_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.149613702780849_REALK,      0.000000000000000_REALK, &
      4.406023894039739_REALK,      0.000000000000000_REALK,      0.969534508430610_REALK, &
      0.000000000000000_REALK,      2.152225817874246_REALK,      0.000000000000000_REALK, &
      2.740127619349789_REALK,      1.284161602251891_REALK,      0.000000000000000_REALK, &
      0.785873778581925_REALK,      0.000000000000000_REALK,      0.131815153192988_REALK, &
      0.562918038112874_REALK,      0.000000000000000_REALK,      0.071078685656936_REALK, &
      0.000000000000000_REALK,      0.470006368368702_REALK,      0.000000000000000_REALK, &
      0.052246424050360_REALK,      0.000000000000000_REALK,     -0.516132570897214_REALK, &
      3.510349281393135_REALK,      1.342606303320141_REALK,      0.000000000000000_REALK, &
      0.506372935480754_REALK,      0.000000000000000_REALK,     -4.546662127795209_REALK, &
      0.049238661189622_REALK,      0.000000000000000_REALK,     -1.950851129903359_REALK, &
      0.000000000000000_REALK,     -0.317479229927860_REALK,      0.000000000000000_REALK, &
     -0.847531644438316_REALK,      0.000000000000000_REALK,     -5.382412033614036_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.730596263640538_REALK, &
      0.000000000000000_REALK,     -1.115606477095586_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.921818838965467_REALK,      0.000000000000000_REALK, &
     -0.062319280775655_REALK,      0.000000000000000_REALK,     -0.938111579233820_REALK, &
      0.000000000000000_REALK,     -0.048252715821395_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.485887500962196_REALK, &
      0.000000000000000_REALK,      2.343164113093605_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.906311882628910_REALK,      0.000000000000000_REALK, &
     12.792144701838209_REALK,      0.000000000000000_REALK,      1.831920407624533_REALK, &
      0.000000000000000_REALK,      9.904731174065434_REALK,      0.000000000000000_REALK, &
     -5.916742925414304_REALK,     -1.362636005685714_REALK,      0.000000000000000_REALK, &
     -5.686510411213339_REALK,      0.000000000000000_REALK,     -7.692087091514367_REALK, &
     -2.913472876813481_REALK,      0.000000000000000_REALK,     -2.072268270784523_REALK, &
      0.000000000000000_REALK,    -37.711584185998426_REALK,      0.000000000000000_REALK, &
    -21.281895656926736_REALK,      0.000000000000000_REALK,    -47.979687314852555_REALK, &
     -3.833742107499988_REALK,     -1.265530402769898_REALK,      0.000000000000000_REALK, &
     -7.947235193851074_REALK,      0.000000000000000_REALK,     -7.885451685914238_REALK, &
     -5.391419937685342_REALK,      0.000000000000000_REALK,     -3.219715834959905_REALK, &
      0.000000000000000_REALK,    -75.220895772524116_REALK,      0.000000000000000_REALK, &
    -35.470280409536869_REALK,      0.000000000000000_REALK,    -58.657544758803212_REALK, &
     -4.491690508564956_REALK,     -1.123164817732078_REALK,      0.000000000000000_REALK, &
     -2.199316099682827_REALK,      0.000000000000000_REALK,     -5.167227589921577_REALK, &
     -1.302168927156512_REALK,      0.000000000000000_REALK,     -1.455172416454391_REALK, &
      0.000000000000000_REALK,     -7.108333282336742_REALK,      0.000000000000000_REALK, &
     -7.067766428278652_REALK,      0.000000000000000_REALK,    -27.675844089737524_REALK, &
     -3.810653499545672_REALK,     -0.890266998364119_REALK,      0.000000000000000_REALK, &
     -1.029071891027483_REALK,      0.000000000000000_REALK,     -4.097056194763842_REALK, &
      0.061062781658987_REALK,      0.000000000000000_REALK,     -1.253223344968765_REALK, &
      0.000000000000000_REALK,      5.755381900228011_REALK,      0.000000000000000_REALK, &
     -3.643391827404655_REALK,      0.000000000000000_REALK,    -24.175798902828284_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.088791419758602_REALK, &
      0.000000000000000_REALK,     -0.101761593674605_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.085043986324641_REALK,      0.000000000000000_REALK, &
      1.717051198894732_REALK,      0.000000000000000_REALK,     -0.459772971579482_REALK, &
      0.000000000000000_REALK,      4.881122611888062_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.272492087711502_REALK, &
      0.000000000000000_REALK,      1.734399857210233_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.805314136807474_REALK,      0.000000000000000_REALK, &
      4.993031320680203_REALK,      0.000000000000000_REALK,     10.282412206301514_REALK, &
      0.000000000000000_REALK,     17.116319766195467_REALK,      0.000000000000000_REALK, &
     -4.785276817015101_REALK,     -0.804649145376301_REALK,      0.000000000000000_REALK, &
     -1.441059666172924_REALK,      0.000000000000000_REALK,     -4.633766440362917_REALK, &
     -0.691282926614477_REALK,      0.000000000000000_REALK,     -0.908200102891405_REALK, &
      0.000000000000000_REALK,     -3.248507868301909_REALK,      0.000000000000000_REALK, &
     -3.711325997126887_REALK,      0.000000000000000_REALK,    -19.889782334510400_REALK, &
     -2.224469929696323_REALK,     -0.666562995007842_REALK,      0.000000000000000_REALK, &
     -1.275774993393498_REALK,      0.000000000000000_REALK,     -3.724934429774747_REALK, &
     -1.226487372034105_REALK,      0.000000000000000_REALK,     -1.015170114223134_REALK, &
      0.000000000000000_REALK,     -6.439731806125075_REALK,      0.000000000000000_REALK, &
     -3.623292703970243_REALK,      0.000000000000000_REALK,    -17.631802645530655_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.095419390020263_REALK, &
      0.000000000000000_REALK,     -0.047389161299001_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.045839692047056_REALK,      0.000000000000000_REALK, &
      1.607507139113512_REALK,      0.000000000000000_REALK,     -0.109214182031374_REALK, &
      0.000000000000000_REALK,      1.821660516938693_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.812615838293123_REALK, &
      0.000000000000000_REALK,      0.423064866654978_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.310854173096403_REALK,      0.000000000000000_REALK, &
      3.449720465384563_REALK,      0.000000000000000_REALK,     -0.058544271091750_REALK, &
      0.000000000000000_REALK,      3.349170777932544_REALK,      0.000000000000000_REALK, &
      2.392703141233571_REALK,      1.162177083166801_REALK,      0.000000000000000_REALK, &
      1.712842931299675_REALK,      0.000000000000000_REALK,      0.891642987127733_REALK, &
      1.844218191987770_REALK,      0.000000000000000_REALK,      0.504803554254633_REALK, &
      0.000000000000000_REALK,      7.816802653152843_REALK,      0.000000000000000_REALK, &
      1.697617270774329_REALK,      0.000000000000000_REALK,     -2.290659222261785_REALK, &
      0.659457303132002_REALK,      0.628202397158210_REALK,      0.000000000000000_REALK, &
      1.112931067257259_REALK,      0.000000000000000_REALK,     -1.793610807342675_REALK, &
      1.602074952276169_REALK,      0.000000000000000_REALK,     -1.553984385357036_REALK, &
      0.000000000000000_REALK,      6.703034878720958_REALK,      0.000000000000000_REALK, &
     -5.133895649724600_REALK,      0.000000000000000_REALK,    -22.206997947533985_REALK, &
     -6.521709204953400_REALK,     -0.365556902552061_REALK,      0.000000000000000_REALK, &
     -1.313598304364337_REALK,      0.000000000000000_REALK,     -5.152984915332025_REALK, &
     -0.169740130721466_REALK,      0.000000000000000_REALK,     -0.350425107628118_REALK, &
      0.000000000000000_REALK,     -1.842524771582911_REALK,      0.000000000000000_REALK, &
     -2.574189172733588_REALK,      0.000000000000000_REALK,    -16.830053667898309_REALK, &
     -7.557344711467171_REALK,     -0.239870561768506_REALK,      0.000000000000000_REALK, &
     -0.865949738761256_REALK,      0.000000000000000_REALK,     -5.134044006377011_REALK, &
      0.502301318230756_REALK,      0.000000000000000_REALK,     -0.224714725776265_REALK, &
      0.000000000000000_REALK,      1.451353459613150_REALK,      0.000000000000000_REALK, &
     -1.582275105624546_REALK,      0.000000000000000_REALK,    -15.634991383549011_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.119317189602977_REALK, &
      0.000000000000000_REALK,     -0.026867632392082_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.035570589693272_REALK,      0.000000000000000_REALK, &
      1.707200479373402_REALK,      0.000000000000000_REALK,     -0.040075741044603_REALK, &
      0.000000000000000_REALK,      0.785866108520695_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.580403582531823_REALK, &
      0.000000000000000_REALK,      0.384515682843978_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.507081818757877_REALK,      0.000000000000000_REALK, &
      4.126896569068656_REALK,      0.000000000000000_REALK,      0.848843494114589_REALK, &
      0.000000000000000_REALK,      1.958413370255635_REALK,      0.000000000000000_REALK, &
      2.493856157769716_REALK,      0.754670302543448_REALK,      0.000000000000000_REALK, &
      0.838685055150041_REALK,      0.000000000000000_REALK,      0.758305045235043_REALK, &
      0.647366707230370_REALK,      0.000000000000000_REALK,      0.278402153957061_REALK, &
      0.000000000000000_REALK,      1.652960127155593_REALK,      0.000000000000000_REALK, &
      0.632487415147808_REALK,      0.000000000000000_REALK,     -1.482327519055578_REALK, &
      1.260099339814497_REALK,      0.327788212817024_REALK,      0.000000000000000_REALK, &
      0.215015086812068_REALK,      0.000000000000000_REALK,     -1.390415421063357_REALK, &
     -0.014962219485460_REALK,      0.000000000000000_REALK,     -0.498766585160597_REALK, &
      0.000000000000000_REALK,     -0.620621062375926_REALK,      0.000000000000000_REALK, &
     -0.638127822759594_REALK,      0.000000000000000_REALK,    -11.075572688839705_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.918638556023011_REALK, &
      0.000000000000000_REALK,     -1.247968285380880_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.359674773590333_REALK,      0.000000000000000_REALK, &
     -1.664613530997887_REALK,      0.000000000000000_REALK,     -3.438321087465831_REALK, &
      0.000000000000000_REALK,     -2.213407897590836_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.060121775440973_REALK, &
      0.000000000000000_REALK,     -0.819973947703488_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.000921059208056_REALK,      0.000000000000000_REALK, &
      3.491720447549489_REALK,      0.000000000000000_REALK,     -2.508851642746520_REALK, &
      0.000000000000000_REALK,      5.267669196237378_REALK,      0.000000000000000_REALK, &
    -10.929593066887989_REALK,      0.462380204026195_REALK,      0.000000000000000_REALK, &
     -1.714297948754424_REALK,      0.000000000000000_REALK,     -6.961339353107508_REALK, &
      0.370666188687865_REALK,      0.000000000000000_REALK,      0.364385160923948_REALK, &
      0.000000000000000_REALK,     -1.843225489551111_REALK,      0.000000000000000_REALK, &
     -2.460243227882519_REALK,      0.000000000000000_REALK,    -16.650730612414513_REALK, &
     -6.906411603283909_REALK,      0.507326765660141_REALK,      0.000000000000000_REALK, &
     -1.829956266873424_REALK,      0.000000000000000_REALK,     -7.652057956230188_REALK, &
     -0.014132875344910_REALK,      0.000000000000000_REALK,      0.515016152735293_REALK, &
      0.000000000000000_REALK,     -3.576946733570105_REALK,      0.000000000000000_REALK, &
     -2.607687622190320_REALK,      0.000000000000000_REALK,    -18.173637241103012_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.174852371154892_REALK, &
      0.000000000000000_REALK,     -0.010997796649474_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.035126646040906_REALK,      0.000000000000000_REALK, &
      2.056715677088001_REALK,      0.000000000000000_REALK,     -0.007645162866558_REALK, &
      0.000000000000000_REALK,      0.235580156955732_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.879242520321070_REALK, &
      0.000000000000000_REALK,      0.083673330566693_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.321772558520226_REALK,      0.000000000000000_REALK, &
      5.317615151494328_REALK,      0.000000000000000_REALK,     -0.266523001582948_REALK, &
      0.000000000000000_REALK,      0.332355529704975_REALK,      0.000000000000000_REALK, &
      3.485573628407779_REALK,      0.563834199557755_REALK,      0.000000000000000_REALK, &
      0.690416078857152_REALK,      0.000000000000000_REALK,      0.854354631744021_REALK, &
      0.338210548662795_REALK,      0.000000000000000_REALK,      0.170996794509124_REALK, &
      0.000000000000000_REALK,      0.867276254326718_REALK,      0.000000000000000_REALK, &
      0.381309601213725_REALK,      0.000000000000000_REALK,     -1.223072674538717_REALK, &
      0.908634692386748_REALK,      0.257024367629030_REALK,      0.000000000000000_REALK, &
      0.344802622751429_REALK,      0.000000000000000_REALK,     -1.635176152147719_REALK, &
      0.315232968071799_REALK,      0.000000000000000_REALK,     -0.423795958760676_REALK, &
      0.000000000000000_REALK,      0.873272484897276_REALK,      0.000000000000000_REALK, &
     -0.798058729222877_REALK,      0.000000000000000_REALK,    -10.158081791834730_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.150254644347397_REALK, &
      0.000000000000000_REALK,     -0.730157170904059_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.721242662148955_REALK,      0.000000000000000_REALK, &
     -1.533668052750012_REALK,      0.000000000000000_REALK,     -0.937693635566330_REALK, &
      0.000000000000000_REALK,     -0.948392521391419_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.708999598491289_REALK, &
      0.000000000000000_REALK,     -0.258720619940849_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.180781031024492_REALK,      0.000000000000000_REALK, &
      2.530510793377520_REALK,      0.000000000000000_REALK,      0.017963626055554_REALK, &
      0.000000000000000_REALK,      1.296208986157356_REALK,      0.000000000000000_REALK, &
      3.711040941196220_REALK,      1.734031163333516_REALK,      0.000000000000000_REALK, &
      1.747375347837267_REALK,      0.000000000000000_REALK,      2.889240442735749_REALK, &
      1.921247655179227_REALK,      0.000000000000000_REALK,      1.670388438496198_REALK, &
      0.000000000000000_REALK,      4.443676256431936_REALK,      0.000000000000000_REALK, &
      3.065328836361473_REALK,      0.000000000000000_REALK,      6.158322690136368_REALK, &
      3.511960881041237_REALK,      3.158151075265162_REALK,      0.000000000000000_REALK, &
      3.921614986980056_REALK,      0.000000000000000_REALK,      1.346889360055935_REALK, &
      5.368483132576377_REALK,      0.000000000000000_REALK,      1.109743053878423_REALK, &
      0.000000000000000_REALK,     11.850964234253334_REALK,      0.000000000000000_REALK, &
      1.934355388256364_REALK,      0.000000000000000_REALK,    -12.606517106143123_REALK, &
    -25.117249783315337_REALK,      2.846657409859128_REALK,      0.000000000000000_REALK, &
     -3.169022150332956_REALK,      0.000000000000000_REALK,    -11.826299166444672_REALK, &
      1.416387169729136_REALK,      0.000000000000000_REALK,      1.697362301752838_REALK, &
      0.000000000000000_REALK,     -2.598209575708137_REALK,      0.000000000000000_REALK, &
     -3.136279799715850_REALK,      0.000000000000000_REALK,    -19.506849653512134_REALK, &
    -72.399115189476063_REALK,      9.015460351035610_REALK,      0.000000000000000_REALK, &
     -6.255516127008528_REALK,      0.000000000000000_REALK,    -27.430379766655740_REALK, &
      4.024608243097069_REALK,      0.000000000000000_REALK,      4.242404458019387_REALK, &
      0.000000000000000_REALK,     -1.137269538624157_REALK,      0.000000000000000_REALK, &
     -4.289253513946976_REALK,      0.000000000000000_REALK,    -31.347227634567908_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.329967757838843_REALK, &
      0.000000000000000_REALK,      0.013936532913965_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.048451179542544_REALK,      0.000000000000000_REALK, &
      2.936649644115119_REALK,      0.000000000000000_REALK,      0.014030287188015_REALK, &
      0.000000000000000_REALK,     -0.205866439257046_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      9.809485984082908_REALK, &
      0.000000000000000_REALK,     -0.425797651563924_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.103907982847787_REALK,      0.000000000000000_REALK, &
     12.866825521830696_REALK,      0.000000000000000_REALK,      0.008011825978758_REALK, &
      0.000000000000000_REALK,     -0.813809635478861_REALK,      0.000000000000000_REALK, &
      6.922446758555569_REALK,      0.322399045727098_REALK,      0.000000000000000_REALK, &
      0.830883450415708_REALK,      0.000000000000000_REALK,      1.254329120480943_REALK, &
      0.093115592949245_REALK,      0.000000000000000_REALK,      0.073978956391260_REALK, &
      0.000000000000000_REALK,      0.588575948164437_REALK,      0.000000000000000_REALK, &
      0.316449737010800_REALK,      0.000000000000000_REALK,     -1.238292882505933_REALK, &
      7.602155576711011_REALK,      0.195880883726637_REALK,      0.000000000000000_REALK, &
      0.485812196242228_REALK,      0.000000000000000_REALK,     -4.678264279458920_REALK, &
     -0.206038795458248_REALK,      0.000000000000000_REALK,     -0.149715117132258_REALK, &
      0.000000000000000_REALK,     -0.305547108653692_REALK,      0.000000000000000_REALK, &
     -0.541048775112373_REALK,      0.000000000000000_REALK,    -13.984135570993686_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.384154425110191_REALK, &
      0.000000000000000_REALK,     -0.546531660091123_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.627534119964166_REALK,      0.000000000000000_REALK, &
     -1.826289185318728_REALK,      0.000000000000000_REALK,     -0.411698358469531_REALK, &
      0.000000000000000_REALK,     -0.489536273683456_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.920187346862615_REALK, &
      0.000000000000000_REALK,     -0.488109648506810_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.470641620329306_REALK,      0.000000000000000_REALK, &
      4.831300019512882_REALK,      0.000000000000000_REALK,     -0.404352578788297_REALK, &
      0.000000000000000_REALK,      1.176698202972171_REALK,      0.000000000000000_REALK, &
      5.636497579752011_REALK,      1.417215030163967_REALK,      0.000000000000000_REALK, &
      1.129577841335789_REALK,      0.000000000000000_REALK,      3.244032736826324_REALK, &
      0.756184850015755_REALK,      0.000000000000000_REALK,      1.032937929461263_REALK, &
      0.000000000000000_REALK,      1.124323488424839_REALK,      0.000000000000000_REALK, &
      1.366484837942159_REALK,      0.000000000000000_REALK,      4.768280233742439_REALK, &
     16.526181476585322_REALK,      3.489865160500868_REALK,      0.000000000000000_REALK, &
      1.572696333104491_REALK,      0.000000000000000_REALK,      2.167342456354639_REALK, &
     -0.080016751862385_REALK,      0.000000000000000_REALK,      0.568446071254642_REALK, &
      0.000000000000000_REALK,     -1.703459092492459_REALK,      0.000000000000000_REALK, &
      0.373267262020197_REALK,      0.000000000000000_REALK,     -9.761003013017996_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -5.130001658179122_REALK, &
      0.000000000000000_REALK,     -2.393132018446517_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.261301651518068_REALK,      0.000000000000000_REALK, &
     -5.482827593173709_REALK,      0.000000000000000_REALK,     -3.329823280676297_REALK, &
      0.000000000000000_REALK,     -4.245256338941361_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,    -21.239640286246281_REALK, &
      0.000000000000000_REALK,    -11.286312777754540_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,    -10.073045849854312_REALK,      0.000000000000000_REALK, &
     -3.929790240727872_REALK,      0.000000000000000_REALK,    -12.958545746351662_REALK, &
      0.000000000000000_REALK,     -3.042767011483401_REALK,      0.000000000000000_REALK/
    ! results of test 5, ket-major order, XDIPVEL
  data REF_CONTR_INTS(28981:30240)                                                         &
    /21.578818408654001_REALK,      9.032095652812361_REALK,      0.000000000000000_REALK, &
     -4.187608634636775_REALK,      0.000000000000000_REALK,     -0.658178251315764_REALK, &
    -28.782908284490571_REALK,      0.000000000000000_REALK,     -3.441933909463378_REALK, &
      0.000000000000000_REALK,   -136.359522158011004_REALK,      0.000000000000000_REALK, &
    -13.570707440151212_REALK,      0.000000000000000_REALK,     -6.398839006729168_REALK, &
     64.808457510703192_REALK,     45.480441173591899_REALK,      0.000000000000000_REALK, &
     32.960848851312441_REALK,      0.000000000000000_REALK,      3.973738380387094_REALK, &
     10.655557405207052_REALK,      0.000000000000000_REALK,      1.035055744568994_REALK, &
      0.000000000000000_REALK,   -105.269570561925377_REALK,      0.000000000000000_REALK, &
     -8.733490003821924_REALK,      0.000000000000000_REALK,     -3.158711528893073_REALK, &
      8.508323327151508_REALK,      0.220472395407811_REALK,      0.000000000000000_REALK, &
     -5.300880331640139_REALK,      0.000000000000000_REALK,     -1.344832172987215_REALK, &
    -11.992504208685881_REALK,      0.000000000000000_REALK,     -2.290401675073462_REALK, &
      0.000000000000000_REALK,    -29.572719588095826_REALK,      0.000000000000000_REALK, &
     -4.972234971224447_REALK,      0.000000000000000_REALK,     -3.784364752233052_REALK, &
     10.098804464972780_REALK,      5.498957920893442_REALK,      0.000000000000000_REALK, &
      1.764399924760265_REALK,      0.000000000000000_REALK,      0.718828438607779_REALK, &
     -0.102552090883603_REALK,      0.000000000000000_REALK,     -0.184360737382806_REALK, &
      0.000000000000000_REALK,      8.303477408882667_REALK,      0.000000000000000_REALK, &
     -1.005788431633407_REALK,      0.000000000000000_REALK,     -1.229294987607263_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.064270735907159_REALK, &
      0.000000000000000_REALK,      1.627755602940450_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      4.248085643578535_REALK,      0.000000000000000_REALK, &
      2.003050779772291_REALK,      0.000000000000000_REALK,     12.768062194840100_REALK, &
      0.000000000000000_REALK,      4.580512760439631_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.670564876385116_REALK, &
      0.000000000000000_REALK,     -2.099022408966304_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.020751581160469_REALK,      0.000000000000000_REALK, &
      0.369183429091510_REALK,      0.000000000000000_REALK,     12.317969197018224_REALK, &
      0.000000000000000_REALK,      3.589615529423321_REALK,      0.000000000000000_REALK, &
      1.369876512200395_REALK,     -3.456468018839264_REALK,      0.000000000000000_REALK, &
     -6.006565788410715_REALK,      0.000000000000000_REALK,     -2.009593402215801_REALK, &
     -8.983417083846371_REALK,      0.000000000000000_REALK,     -2.011702055450537_REALK, &
      0.000000000000000_REALK,    -16.862466066519488_REALK,      0.000000000000000_REALK, &
     -3.015409628560151_REALK,      0.000000000000000_REALK,     -3.026561686658477_REALK, &
     26.952817417941258_REALK,      9.555765959400826_REALK,      0.000000000000000_REALK, &
      3.287746977763454_REALK,      0.000000000000000_REALK,      0.824571445329534_REALK, &
     -1.935969132495210_REALK,      0.000000000000000_REALK,     -0.281227626589949_REALK, &
      0.000000000000000_REALK,    -14.928644872839630_REALK,      0.000000000000000_REALK, &
     -1.392577297817659_REALK,      0.000000000000000_REALK,     -1.047780881218305_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.949384005649439_REALK, &
      0.000000000000000_REALK,      1.479222644921078_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.177975235294354_REALK,      0.000000000000000_REALK, &
      1.657655512940236_REALK,      0.000000000000000_REALK,      3.888229157543608_REALK, &
      0.000000000000000_REALK,      2.227793233307496_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.795568533439717_REALK, &
      0.000000000000000_REALK,     -0.665754186545394_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.201945602592212_REALK,      0.000000000000000_REALK, &
      0.246822004735901_REALK,      0.000000000000000_REALK,      0.156859531214041_REALK, &
      0.000000000000000_REALK,      0.845972186163362_REALK,      0.000000000000000_REALK, &
      0.293944827100113_REALK,     -1.149113744881096_REALK,      0.000000000000000_REALK, &
     -2.743564393063916_REALK,      0.000000000000000_REALK,     -1.293641244071724_REALK, &
     -5.592761288232476_REALK,      0.000000000000000_REALK,     -2.006390167585056_REALK, &
      0.000000000000000_REALK,    -13.839430516990362_REALK,      0.000000000000000_REALK, &
     -4.131963643875451_REALK,      0.000000000000000_REALK,     -3.247161856449543_REALK, &
     14.525874659010467_REALK,      8.163228779395611_REALK,      0.000000000000000_REALK, &
      3.686086572594665_REALK,      0.000000000000000_REALK,      1.333176559228605_REALK, &
     -2.473243511226650_REALK,      0.000000000000000_REALK,     -0.720735145050835_REALK, &
      0.000000000000000_REALK,    -18.819213897809604_REALK,      0.000000000000000_REALK, &
     -4.683901024169830_REALK,      0.000000000000000_REALK,     -2.823440220493131_REALK, &
     -9.464638014202675_REALK,     -7.201453989309058_REALK,      0.000000000000000_REALK, &
     -6.839419708690412_REALK,      0.000000000000000_REALK,     -3.134804604371979_REALK, &
     -6.920217000664946_REALK,      0.000000000000000_REALK,     -2.002985662924623_REALK, &
      0.000000000000000_REALK,     -8.778717002774494_REALK,      0.000000000000000_REALK, &
     -2.135021608810140_REALK,      0.000000000000000_REALK,     -2.935720801529766_REALK, &
      4.187306267328455_REALK,      0.490327132926316_REALK,      0.000000000000000_REALK, &
     -0.624127389316744_REALK,      0.000000000000000_REALK,     -0.439830240897166_REALK, &
      0.052115780614889_REALK,      0.000000000000000_REALK,     -0.532870754674208_REALK, &
      0.000000000000000_REALK,      5.243412599072212_REALK,      0.000000000000000_REALK, &
     -0.518374460519636_REALK,      0.000000000000000_REALK,     -1.095914557258352_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.161504277434768_REALK, &
      0.000000000000000_REALK,      1.713586811390694_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.796932616172347_REALK,      0.000000000000000_REALK, &
      1.803578312579406_REALK,      0.000000000000000_REALK,      2.388729837657292_REALK, &
      0.000000000000000_REALK,      1.604761087951301_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.223813367502444_REALK, &
      0.000000000000000_REALK,      0.389941356293375_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.969822101585396_REALK,      0.000000000000000_REALK, &
      0.729698134399135_REALK,      0.000000000000000_REALK,      2.229513464751976_REALK, &
      0.000000000000000_REALK,      0.971607609261430_REALK,      0.000000000000000_REALK, &
     -1.421048862931805_REALK,     -1.591041287630547_REALK,      0.000000000000000_REALK, &
     -1.855219876434487_REALK,      0.000000000000000_REALK,     -1.412006622505192_REALK, &
     -2.317060251505085_REALK,      0.000000000000000_REALK,     -1.327578941548252_REALK, &
      0.000000000000000_REALK,     -3.444435284931249_REALK,      0.000000000000000_REALK, &
     -1.737399382106410_REALK,      0.000000000000000_REALK,     -2.203889203495630_REALK, &
      1.086059397349913_REALK,      0.180705610488399_REALK,      0.000000000000000_REALK, &
     -0.280011402603447_REALK,      0.000000000000000_REALK,     -0.342235606283805_REALK, &
     -0.109240499937850_REALK,      0.000000000000000_REALK,     -0.589154027394729_REALK, &
      0.000000000000000_REALK,      1.919992110021930_REALK,      0.000000000000000_REALK, &
     -0.697697756492359_REALK,      0.000000000000000_REALK,     -1.421233876406156_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.391431261390454_REALK, &
      0.000000000000000_REALK,      1.709062095136012_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.462305674888850_REALK,      0.000000000000000_REALK, &
      1.935037612992931_REALK,      0.000000000000000_REALK,      4.461418958756212_REALK, &
      0.000000000000000_REALK,      2.667539542336693_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.361864016618995_REALK, &
      0.000000000000000_REALK,      0.999348618047431_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.261973853801230_REALK,      0.000000000000000_REALK, &
      1.966307172054675_REALK,      0.000000000000000_REALK,      8.544758721617551_REALK, &
      0.000000000000000_REALK,      4.150088664739545_REALK,      0.000000000000000_REALK, &
    -29.453493680452237_REALK,    -12.753584720675677_REALK,      0.000000000000000_REALK, &
     -9.086786158663662_REALK,      0.000000000000000_REALK,     -5.452846868867733_REALK, &
     -6.957783297081264_REALK,      0.000000000000000_REALK,     -2.340612920101810_REALK, &
      0.000000000000000_REALK,     -7.155501404700518_REALK,      0.000000000000000_REALK, &
     -1.923422497622227_REALK,      0.000000000000000_REALK,     -3.462652744502863_REALK, &
     45.648056370814068_REALK,      7.655174867030909_REALK,      0.000000000000000_REALK, &
      0.356949419183347_REALK,      0.000000000000000_REALK,      0.168805677839537_REALK, &
     -3.413349996667938_REALK,      0.000000000000000_REALK,     -0.664121125729280_REALK, &
      0.000000000000000_REALK,    -10.259719829601947_REALK,      0.000000000000000_REALK, &
     -1.000743179806741_REALK,      0.000000000000000_REALK,     -1.419790494662208_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.292509041526632_REALK, &
      0.000000000000000_REALK,      2.207121170118241_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.718768258264154_REALK,      0.000000000000000_REALK, &
      2.363359559441288_REALK,      0.000000000000000_REALK,      1.614107414580956_REALK, &
      0.000000000000000_REALK,      1.401560388719890_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.820565145130512_REALK, &
      0.000000000000000_REALK,     -0.077405973370909_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.347229383970300_REALK,      0.000000000000000_REALK, &
      0.734090441530322_REALK,      0.000000000000000_REALK,     -0.021224516081830_REALK, &
      0.000000000000000_REALK,      0.651046023028685_REALK,      0.000000000000000_REALK, &
     -3.578290542501679_REALK,     -2.346425953016919_REALK,      0.000000000000000_REALK, &
     -1.980068101255898_REALK,      0.000000000000000_REALK,     -1.987391097871250_REALK, &
     -1.923012397435151_REALK,      0.000000000000000_REALK,     -1.291889697362508_REALK, &
      0.000000000000000_REALK,     -2.343793160296257_REALK,      0.000000000000000_REALK, &
     -1.257377734970209_REALK,      0.000000000000000_REALK,     -2.103379942299570_REALK, &
      9.554540642541825_REALK,      2.500635235909484_REALK,      0.000000000000000_REALK, &
      0.140878483405858_REALK,      0.000000000000000_REALK,      0.105997549808554_REALK, &
     -1.493423472567074_REALK,      0.000000000000000_REALK,     -0.650824331288449_REALK, &
      0.000000000000000_REALK,     -4.234105774856399_REALK,      0.000000000000000_REALK, &
     -1.184900497435862_REALK,      0.000000000000000_REALK,     -1.485873338718749_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.933470170787017_REALK, &
      0.000000000000000_REALK,      1.462879960216960_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.398668237159656_REALK,      0.000000000000000_REALK, &
      1.774209119040448_REALK,      0.000000000000000_REALK,      1.621329561613085_REALK, &
      0.000000000000000_REALK,      1.548257094241892_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.194705440302818_REALK, &
      0.000000000000000_REALK,     -0.085581804885805_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.467347797075982_REALK,      0.000000000000000_REALK, &
      0.952003235050462_REALK,      0.000000000000000_REALK,      0.133466872434545_REALK, &
      0.000000000000000_REALK,      1.199685486965720_REALK,      0.000000000000000_REALK, &
     -2.303463090567446_REALK,     -2.340230228598728_REALK,      0.000000000000000_REALK, &
     -2.713253061639104_REALK,      0.000000000000000_REALK,     -2.132248153177364_REALK, &
     -3.591600788247569_REALK,      0.000000000000000_REALK,     -2.147464116575372_REALK, &
      0.000000000000000_REALK,     -5.770821858468377_REALK,      0.000000000000000_REALK, &
     -2.871604926854870_REALK,      0.000000000000000_REALK,     -3.159367677093602_REALK, &
     15.447890769177887_REALK,      6.408672296268860_REALK,      0.000000000000000_REALK, &
      0.473841469153831_REALK,      0.000000000000000_REALK,      0.285630088091711_REALK, &
     -5.723644841815511_REALK,      0.000000000000000_REALK,     -2.779906882439962_REALK, &
      0.000000000000000_REALK,    -16.012680907416499_REALK,      0.000000000000000_REALK, &
     -6.642308308698128_REALK,      0.000000000000000_REALK,     -5.605546418356514_REALK, &
   -138.084338924072114_REALK,    -32.033262444902739_REALK,      0.000000000000000_REALK, &
    -16.718653264862141_REALK,      0.000000000000000_REALK,    -13.177002638293777_REALK, &
     -8.672179326534662_REALK,      0.000000000000000_REALK,     -3.502803187230817_REALK, &
      0.000000000000000_REALK,     -6.507102555710486_REALK,      0.000000000000000_REALK, &
     -2.222080261104156_REALK,      0.000000000000000_REALK,     -5.254075851541640_REALK, &
    -61.946088390955737_REALK,    -19.070599296124005_REALK,      0.000000000000000_REALK, &
     -7.851647939885066_REALK,      0.000000000000000_REALK,     -9.679137205184293_REALK, &
      1.842006629130886_REALK,      0.000000000000000_REALK,     -2.548374632687145_REALK, &
      0.000000000000000_REALK,     13.287474007284651_REALK,      0.000000000000000_REALK, &
     -1.071526153189115_REALK,      0.000000000000000_REALK,     -3.962779050360447_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     12.775980185906937_REALK, &
      0.000000000000000_REALK,      4.011546841359845_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.328068743605272_REALK,      0.000000000000000_REALK, &
      4.191119545706496_REALK,      0.000000000000000_REALK,      1.584935593699231_REALK, &
      0.000000000000000_REALK,      1.599526991462002_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     10.341794454862704_REALK, &
      0.000000000000000_REALK,      4.170270475731821_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.922230461698117_REALK,      0.000000000000000_REALK, &
      4.145873902965362_REALK,      0.000000000000000_REALK,      2.925093195468961_REALK, &
      0.000000000000000_REALK,      1.707369171987277_REALK,      0.000000000000000_REALK, &
    -14.148767399582258_REALK,     -5.171268699717150_REALK,      0.000000000000000_REALK, &
     -2.945775150711046_REALK,      0.000000000000000_REALK,     -4.050532018451777_REALK, &
     -1.953680496798206_REALK,      0.000000000000000_REALK,     -1.696418201038892_REALK, &
      0.000000000000000_REALK,     -1.609855216048441_REALK,      0.000000000000000_REALK, &
     -1.174571069633361_REALK,      0.000000000000000_REALK,     -2.691785965825606_REALK, &
     -9.833825198940085_REALK,     -4.742237799260907_REALK,      0.000000000000000_REALK, &
     -2.180386065400012_REALK,      0.000000000000000_REALK,     -4.609634562474008_REALK, &
      0.061976867472734_REALK,      0.000000000000000_REALK,     -1.901093666038511_REALK, &
      0.000000000000000_REALK,      3.009856512721772_REALK,      0.000000000000000_REALK, &
     -0.892681655244755_REALK,      0.000000000000000_REALK,     -3.145418661249644_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.656442753420520_REALK, &
      0.000000000000000_REALK,      2.214153391332418_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.521902653893294_REALK,      0.000000000000000_REALK, &
      2.545885319344774_REALK,      0.000000000000000_REALK,      1.314147336450567_REALK, &
      0.000000000000000_REALK,      1.471418321796615_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.493886265372918_REALK, &
      0.000000000000000_REALK,      4.086774819397171_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.459980939722214_REALK,      0.000000000000000_REALK, &
      4.338839794509047_REALK,      0.000000000000000_REALK,      3.839397813137192_REALK, &
      0.000000000000000_REALK,      2.788641400319136_REALK,      0.000000000000000_REALK, &
     -6.373013884384700_REALK,     -3.427517008188618_REALK,      0.000000000000000_REALK, &
     -2.397159778407148_REALK,      0.000000000000000_REALK,     -3.040794539871617_REALK, &
     -1.962422026435094_REALK,      0.000000000000000_REALK,     -1.873976701751987_REALK, &
      0.000000000000000_REALK,     -1.894938215243311_REALK,      0.000000000000000_REALK, &
     -1.593035438298881_REALK,      0.000000000000000_REALK,     -2.829069179588857_REALK, &
     -7.651782019770401_REALK,     -5.243125980907410_REALK,      0.000000000000000_REALK, &
     -2.934655508668070_REALK,      0.000000000000000_REALK,     -5.977992312129044_REALK, &
     -0.389731319808868_REALK,      0.000000000000000_REALK,     -3.503154001154802_REALK, &
      0.000000000000000_REALK,      3.306377658176163_REALK,      0.000000000000000_REALK, &
     -2.002484161423298_REALK,      0.000000000000000_REALK,     -5.710778945435564_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.995841770646915_REALK, &
      0.000000000000000_REALK,      3.680511553105002_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.475728126533934_REALK,      0.000000000000000_REALK, &
      3.824029898626579_REALK,      0.000000000000000_REALK,      4.090710851859765_REALK, &
      0.000000000000000_REALK,      3.424243783484856_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     17.498982848057629_REALK, &
      0.000000000000000_REALK,     17.456098214603056_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     19.395941003981260_REALK,      0.000000000000000_REALK, &
     16.368533734446775_REALK,      0.000000000000000_REALK,     24.524579366925529_REALK, &
      0.000000000000000_REALK,     16.675819062388008_REALK,      0.000000000000000_REALK, &
     22.592722061535262_REALK,     38.809554618550386_REALK,      0.000000000000000_REALK, &
      8.763371249755906_REALK,      0.000000000000000_REALK,      3.951375565084180_REALK, &
     64.923703440059583_REALK,      0.000000000000000_REALK,     15.392778807195397_REALK, &
      0.000000000000000_REALK,    -48.113979618687054_REALK,      0.000000000000000_REALK, &
     -9.050770614091331_REALK,      0.000000000000000_REALK,    -12.242889008279279_REALK, &
     25.573011644088101_REALK,     38.774142367498897_REALK,      0.000000000000000_REALK, &
     14.781545942541815_REALK,      0.000000000000000_REALK,      4.888877013195698_REALK, &
     85.699483336386422_REALK,      0.000000000000000_REALK,     17.059697737964736_REALK, &
      0.000000000000000_REALK,    -30.425795593312781_REALK,      0.000000000000000_REALK, &
     -4.782410039544084_REALK,      0.000000000000000_REALK,     -4.745230559960544_REALK, &
     23.630258070772019_REALK,     13.716096563614354_REALK,      0.000000000000000_REALK, &
      3.728979751139395_REALK,      0.000000000000000_REALK,      2.920375574195569_REALK, &
     11.742531315092291_REALK,      0.000000000000000_REALK,      4.374088827933973_REALK, &
      0.000000000000000_REALK,    -17.990621398365384_REALK,      0.000000000000000_REALK, &
     -5.962649981498847_REALK,      0.000000000000000_REALK,    -14.009068318051016_REALK, &
      7.983155504234931_REALK,      6.464357313669902_REALK,      0.000000000000000_REALK, &
      2.259752572980420_REALK,      0.000000000000000_REALK,      2.998926624559054_REALK, &
     -0.397245417677865_REALK,      0.000000000000000_REALK,      2.717625027827931_REALK, &
      0.000000000000000_REALK,      5.006937656168573_REALK,      0.000000000000000_REALK, &
     -1.056532016643789_REALK,      0.000000000000000_REALK,     -4.206383520430999_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -8.634411430571372_REALK, &
      0.000000000000000_REALK,     -1.373918486765968_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -6.106786037154156_REALK,      0.000000000000000_REALK, &
     -8.260589825775199_REALK,      0.000000000000000_REALK,      9.266090018754426_REALK, &
      0.000000000000000_REALK,      6.590699536938661_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -8.257614085369646_REALK, &
      0.000000000000000_REALK,     -3.403759102534973_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,    -10.496137410835974_REALK,      0.000000000000000_REALK, &
    -10.414538191332534_REALK,      0.000000000000000_REALK,      7.994429187379834_REALK, &
      0.000000000000000_REALK,      4.774213573339858_REALK,      0.000000000000000_REALK, &
     22.963938133244866_REALK,      5.052467687275590_REALK,      0.000000000000000_REALK, &
      1.363940221900322_REALK,      0.000000000000000_REALK,      1.461928925234951_REALK, &
      2.304710481094863_REALK,      0.000000000000000_REALK,      1.009301312809935_REALK, &
      0.000000000000000_REALK,    -12.656900838845139_REALK,      0.000000000000000_REALK, &
     -4.820047339746552_REALK,      0.000000000000000_REALK,    -15.498992948150407_REALK, &
     26.941104735571443_REALK,      5.373618970688037_REALK,      0.000000000000000_REALK, &
      3.747086925768969_REALK,      0.000000000000000_REALK,      3.646842944728830_REALK, &
      4.311118477504801_REALK,      0.000000000000000_REALK,      1.189445223008329_REALK, &
      0.000000000000000_REALK,     -8.685961798304916_REALK,      0.000000000000000_REALK, &
     -1.629042065635323_REALK,      0.000000000000000_REALK,     -4.756383303685560_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.770987976158125_REALK, &
      0.000000000000000_REALK,     -0.357163518070453_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.216961763913202_REALK,      0.000000000000000_REALK, &
     -2.859215373032915_REALK,      0.000000000000000_REALK,      3.388419620062888_REALK, &
      0.000000000000000_REALK,      3.786555387445317_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -5.854709678829733_REALK, &
      0.000000000000000_REALK,     -1.110506376288316_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.976512916001543_REALK,      0.000000000000000_REALK, &
     -3.887802520557017_REALK,      0.000000000000000_REALK,     -0.070571435266337_REALK, &
      0.000000000000000_REALK,      1.448374406813633_REALK,      0.000000000000000_REALK, &
      3.531745547666734_REALK,      2.244556706507651_REALK,      0.000000000000000_REALK, &
      0.498645837095109_REALK,      0.000000000000000_REALK,      0.674513353425524_REALK, &
      1.891185511272843_REALK,      0.000000000000000_REALK,      1.345145087969533_REALK, &
      0.000000000000000_REALK,     -9.367719680679068_REALK,      0.000000000000000_REALK, &
     -5.286514398447639_REALK,      0.000000000000000_REALK,    -11.918360653198119_REALK, &
     10.479694564628556_REALK,      6.645051332306746_REALK,      0.000000000000000_REALK, &
      4.289049225620284_REALK,      0.000000000000000_REALK,      4.255705238635021_REALK, &
      7.388951053594198_REALK,      0.000000000000000_REALK,      4.412626541054531_REALK, &
      0.000000000000000_REALK,    -11.863004507643980_REALK,      0.000000000000000_REALK, &
     -5.593978801558374_REALK,      0.000000000000000_REALK,     -9.250816687763846_REALK, &
     18.030917141007329_REALK,      0.863262874057076_REALK,      0.000000000000000_REALK, &
     -0.875759042581793_REALK,      0.000000000000000_REALK,     -1.145142854528215_REALK, &
     -0.080576994101268_REALK,      0.000000000000000_REALK,     -0.055449864665222_REALK, &
      0.000000000000000_REALK,     -9.969655575544655_REALK,      0.000000000000000_REALK, &
     -4.642864659453556_REALK,      0.000000000000000_REALK,    -18.213034741750590_REALK, &
     11.987955223356387_REALK,      0.543859594964662_REALK,      0.000000000000000_REALK, &
      1.113153320074508_REALK,      0.000000000000000_REALK,      2.199888313488222_REALK, &
     -0.550757751676060_REALK,      0.000000000000000_REALK,      0.082130899419076_REALK, &
      0.000000000000000_REALK,      2.869051228409991_REALK,      0.000000000000000_REALK, &
     -1.042619518446977_REALK,      0.000000000000000_REALK,     -6.181484040022538_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.243705157389139_REALK, &
      0.000000000000000_REALK,      0.142635012475388_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.134459747270149_REALK,      0.000000000000000_REALK, &
      0.432358964105050_REALK,      0.000000000000000_REALK,      1.726724602586625_REALK, &
      0.000000000000000_REALK,      2.268552283526704_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.202375547370996_REALK, &
      0.000000000000000_REALK,     -0.441744113324230_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.496899720627670_REALK,      0.000000000000000_REALK, &
     -1.450819217413965_REALK,      0.000000000000000_REALK,      1.499640454634223_REALK, &
      0.000000000000000_REALK,      1.241260371967633_REALK,      0.000000000000000_REALK, &
      2.120748028355787_REALK,      0.548159088785479_REALK,      0.000000000000000_REALK, &
     -0.171981700781278_REALK,      0.000000000000000_REALK,     -0.404065877281951_REALK, &
     -0.094523147522204_REALK,      0.000000000000000_REALK,     -0.105629518660929_REALK, &
      0.000000000000000_REALK,     -2.750999308808342_REALK,      0.000000000000000_REALK, &
     -2.735299512099085_REALK,      0.000000000000000_REALK,    -10.710841056192979_REALK, &
      2.622730979553922_REALK,      0.975160849678354_REALK,      0.000000000000000_REALK, &
      0.362663890597457_REALK,      0.000000000000000_REALK,      1.443878073577452_REALK, &
     -0.021526102491688_REALK,      0.000000000000000_REALK,      0.441791438841256_REALK, &
      0.000000000000000_REALK,      1.609773236902514_REALK,      0.000000000000000_REALK, &
     -1.019052211821600_REALK,      0.000000000000000_REALK,     -6.761941210707204_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.035213862784380_REALK, &
      0.000000000000000_REALK,      0.190096638108576_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.147472283953263_REALK,      0.000000000000000_REALK, &
      0.332473863501052_REALK,      0.000000000000000_REALK,      4.250715971255789_REALK, &
      0.000000000000000_REALK,      5.039017127092977_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.737031344528276_REALK, &
      0.000000000000000_REALK,     -1.638790724535493_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.706307382926547_REALK,      0.000000000000000_REALK, &
     -2.821736973338946_REALK,      0.000000000000000_REALK,      7.710831870036225_REALK, &
      0.000000000000000_REALK,      7.674752279120920_REALK,      0.000000000000000_REALK, &
      1.359446316058182_REALK,      0.451568229273068_REALK,      0.000000000000000_REALK, &
     -5.070083304173500_REALK,      0.000000000000000_REALK,     -6.862784160812630_REALK, &
      1.367996282162825_REALK,      0.000000000000000_REALK,      0.448271751989611_REALK, &
      0.000000000000000_REALK,    -13.160721763372875_REALK,      0.000000000000000_REALK, &
     -5.855419711430151_REALK,      0.000000000000000_REALK,    -23.777409111267200_REALK, &
     69.318115933764943_REALK,     -2.297412483287417_REALK,      0.000000000000000_REALK, &
      2.921613659487305_REALK,      0.000000000000000_REALK,      4.072293502821906_REALK, &
      0.000722373425234_REALK,      0.000000000000000_REALK,     -0.008774670716862_REALK, &
      0.000000000000000_REALK,     -9.144272535269410_REALK,      0.000000000000000_REALK, &
     -2.222137862287664_REALK,      0.000000000000000_REALK,     -9.291985834181029_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.359785383279578_REALK, &
      0.000000000000000_REALK,      0.259005609833998_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.032317583742385_REALK,      0.000000000000000_REALK, &
      4.049576586071097_REALK,      0.000000000000000_REALK,      0.434673013008501_REALK, &
      0.000000000000000_REALK,      0.897373748441914_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -7.605511793880448_REALK, &
      0.000000000000000_REALK,     -0.119388788268182_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.014698555237859_REALK,      0.000000000000000_REALK, &
     -0.087144814581598_REALK,      0.000000000000000_REALK,     -0.608927793021711_REALK, &
      0.000000000000000_REALK,      0.272416251082898_REALK,      0.000000000000000_REALK, &
      0.133350182666363_REALK,     -0.169370139577773_REALK,      0.000000000000000_REALK, &
     -0.628059762635864_REALK,      0.000000000000000_REALK,     -2.019543200715146_REALK, &
     -0.383928522642000_REALK,      0.000000000000000_REALK,     -0.504401179809360_REALK, &
      0.000000000000000_REALK,     -1.904671046423478_REALK,      0.000000000000000_REALK, &
     -2.176031414158594_REALK,      0.000000000000000_REALK,    -11.661813382650031_REALK, &
     11.966211897576148_REALK,      1.527209378387692_REALK,      0.000000000000000_REALK, &
      0.722313477097475_REALK,      0.000000000000000_REALK,      2.108969335395040_REALK, &
      0.021141507203129_REALK,      0.000000000000000_REALK,      0.017498937837945_REALK, &
      0.000000000000000_REALK,     -2.929270966050010_REALK,      0.000000000000000_REALK, &
     -1.648144121335280_REALK,      0.000000000000000_REALK,     -8.020260644946735_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.479802909861757_REALK, &
      0.000000000000000_REALK,      0.493394132923912_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.608180076365652_REALK,      0.000000000000000_REALK, &
      2.381501587918186_REALK,      0.000000000000000_REALK,      1.529716830124717_REALK, &
      0.000000000000000_REALK,      2.849094934050218_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.991813288969264_REALK, &
      0.000000000000000_REALK,     -0.642205855817811_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.014366310011186_REALK,      0.000000000000000_REALK, &
     -0.095327935687204_REALK,      0.000000000000000_REALK,     -0.071398951949744_REALK, &
      0.000000000000000_REALK,      2.442263272834707_REALK,      0.000000000000000_REALK, &
      0.061525890443504_REALK,     -0.225727845996231_REALK,      0.000000000000000_REALK, &
     -0.688841155330787_REALK,      0.000000000000000_REALK,     -1.552981171186969_REALK, &
     -0.945125297091559_REALK,      0.000000000000000_REALK,     -1.120400090596083_REALK, &
      0.000000000000000_REALK,     -4.229097946009224_REALK,      0.000000000000000_REALK, &
     -3.977700007066967_REALK,      0.000000000000000_REALK,    -12.554723879258407_REALK, &
     13.964042716108288_REALK,      5.665670437329368_REALK,      0.000000000000000_REALK, &
      2.480357238281239_REALK,      0.000000000000000_REALK,      4.101790683424793_REALK, &
      0.108705127964989_REALK,      0.000000000000000_REALK,      0.108196488091435_REALK, &
      0.000000000000000_REALK,    -12.002109431730441_REALK,      0.000000000000000_REALK, &
     -9.432622470951920_REALK,      0.000000000000000_REALK,    -21.838346236687421_REALK, &
   -118.979834224311460_REALK,     15.378512926367295_REALK,      0.000000000000000_REALK, &
    -20.306664148908684_REALK,      0.000000000000000_REALK,    -25.260440382456654_REALK, &
     10.113074909004215_REALK,      0.000000000000000_REALK,      4.039750446819079_REALK, &
      0.000000000000000_REALK,    -24.142914915235593_REALK,      0.000000000000000_REALK, &
     -9.714245412538858_REALK,      0.000000000000000_REALK,    -36.252057251438565_REALK, &
    -45.883289804433495_REALK,     10.683552392224041_REALK,      0.000000000000000_REALK, &
    -11.593422678170354_REALK,      0.000000000000000_REALK,    -16.945683372393951_REALK, &
     10.288695181613646_REALK,      0.000000000000000_REALK,      3.615159842414137_REALK, &
      0.000000000000000_REALK,     -4.380343975043946_REALK,      0.000000000000000_REALK, &
     -5.506875649427108_REALK,      0.000000000000000_REALK,    -24.147598267606316_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     14.194671285559910_REALK, &
      0.000000000000000_REALK,     -0.711119768644262_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.754737938637816_REALK,      0.000000000000000_REALK, &
     11.186308444031612_REALK,      0.000000000000000_REALK,     -1.038142047130074_REALK, &
      0.000000000000000_REALK,     -1.020550480324381_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     10.388873070279383_REALK, &
      0.000000000000000_REALK,     -0.705255036607761_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.522109715492407_REALK,      0.000000000000000_REALK, &
     10.546333846487514_REALK,      0.000000000000000_REALK,      0.027578505591138_REALK, &
      0.000000000000000_REALK,     -1.004988404772980_REALK,      0.000000000000000_REALK, &
    -10.086074769757257_REALK,     -0.535715448214570_REALK,      0.000000000000000_REALK, &
     -1.637625922356361_REALK,      0.000000000000000_REALK,     -6.424080821985053_REALK, &
     -0.204496056448200_REALK,      0.000000000000000_REALK,     -0.422178021695868_REALK, &
      0.000000000000000_REALK,     -1.682206550935612_REALK,      0.000000000000000_REALK, &
     -2.350208776840375_REALK,      0.000000000000000_REALK,    -15.365669416978298_REALK, &
     -6.321659872327319_REALK,     -0.304574060409232_REALK,      0.000000000000000_REALK, &
     -1.181381096436745_REALK,      0.000000000000000_REALK,     -7.004173875131080_REALK, &
      0.691128452864008_REALK,      0.000000000000000_REALK,     -0.309190390557889_REALK, &
      0.000000000000000_REALK,      1.544173407909959_REALK,      0.000000000000000_REALK, &
     -1.683468024911447_REALK,      0.000000000000000_REALK,    -16.634912582778380_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.177131497859110_REALK, &
      0.000000000000000_REALK,      0.800161171650713_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.023734691562577_REALK,      0.000000000000000_REALK, &
      5.486411109999466_REALK,      0.000000000000000_REALK,      0.874064529949689_REALK, &
      0.000000000000000_REALK,      1.913894358522050_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.380215035912338_REALK, &
      0.000000000000000_REALK,      1.406458936605049_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.870631148272696_REALK,      0.000000000000000_REALK, &
      9.102935347394293_REALK,      0.000000000000000_REALK,      2.421397940066253_REALK, &
      0.000000000000000_REALK,      3.340339900007775_REALK,      0.000000000000000_REALK, &
     -3.558891044953816_REALK,     -1.020514031472830_REALK,      0.000000000000000_REALK, &
     -0.964791721270930_REALK,      0.000000000000000_REALK,     -3.777915629770872_REALK, &
     -0.719669843494123_REALK,      0.000000000000000_REALK,     -1.340383831117717_REALK, &
      0.000000000000000_REALK,     -1.392550331502475_REALK,      0.000000000000000_REALK, &
     -2.307671876504463_REALK,      0.000000000000000_REALK,    -12.650881264613320_REALK, &
     -4.149167947437581_REALK,     -1.638338473505936_REALK,      0.000000000000000_REALK, &
     -1.154677231749250_REALK,      0.000000000000000_REALK,     -7.661883726716690_REALK, &
      0.081037272009324_REALK,      0.000000000000000_REALK,     -2.771950396392333_REALK, &
      0.000000000000000_REALK,      2.599224092524410_REALK,      0.000000000000000_REALK, &
     -2.742358364299434_REALK,      0.000000000000000_REALK,    -25.475762823683862_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.212115771254651_REALK, &
      0.000000000000000_REALK,      1.777356368491767_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.871346830458201_REALK,      0.000000000000000_REALK, &
      5.906489352386338_REALK,      0.000000000000000_REALK,      3.586173162568094_REALK, &
      0.000000000000000_REALK,      5.951727509610205_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     10.464123654502290_REALK, &
      0.000000000000000_REALK,      8.696180247894883_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     10.705955368614354_REALK,      0.000000000000000_REALK, &
     24.786358285229682_REALK,      0.000000000000000_REALK,     20.750520953878652_REALK, &
      0.000000000000000_REALK,     28.914798679973003_REALK,      0.000000000000000_REALK/
    ! results of test 5, ket-major order, YDIPVEL
  data REF_CONTR_INTS(30241:31500)                                                         &
   /-58.548788719033148_REALK,    -41.883399814949165_REALK,      0.000000000000000_REALK, &
    -40.171303901448383_REALK,      0.000000000000000_REALK,    -10.191450954864177_REALK, &
    -46.370332746342470_REALK,      0.000000000000000_REALK,     -8.856089266077861_REALK, &
      0.000000000000000_REALK,    -71.585593920407220_REALK,      0.000000000000000_REALK, &
    -12.036106198031272_REALK,      0.000000000000000_REALK,     -9.160672476978005_REALK, &
    -20.842584358697390_REALK,    -18.728381504507681_REALK,      0.000000000000000_REALK, &
    -13.842741340714607_REALK,      0.000000000000000_REALK,     -5.639626257266616_REALK, &
     -2.562147394806922_REALK,      0.000000000000000_REALK,     -4.606043415791206_REALK, &
      0.000000000000000_REALK,     34.503486431951522_REALK,      0.000000000000000_REALK, &
     -4.179358333311439_REALK,      0.000000000000000_REALK,     -5.108096383859572_REALK, &
    -33.176698866965225_REALK,    -11.982970382632484_REALK,      0.000000000000000_REALK, &
     -4.105822040336164_REALK,      0.000000000000000_REALK,     -5.036418746444697_REALK, &
      3.398840413337183_REALK,      0.000000000000000_REALK,     -2.183942467000220_REALK, &
      0.000000000000000_REALK,     17.031325608052938_REALK,      0.000000000000000_REALK, &
     -1.012779554849125_REALK,      0.000000000000000_REALK,     -3.726987107049885_REALK, &
    -12.500974714007551_REALK,      3.654659718027620_REALK,      0.000000000000000_REALK, &
     11.148556440642349_REALK,      0.000000000000000_REALK,     -1.530582959720323_REALK, &
     20.131731408046583_REALK,      0.000000000000000_REALK,      0.600515074043454_REALK, &
      0.000000000000000_REALK,     36.754212096926111_REALK,      0.000000000000000_REALK, &
      2.501415099455899_REALK,      0.000000000000000_REALK,     -1.030256252493006_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.377532768527326_REALK, &
      0.000000000000000_REALK,      6.095971674346316_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      6.018285029253223_REALK,      0.000000000000000_REALK, &
      4.580512760439631_REALK,      0.000000000000000_REALK,      7.873284975640717_REALK, &
      0.000000000000000_REALK,      4.511064107063818_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      7.281983886630688_REALK, &
      0.000000000000000_REALK,      4.469394585246675_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.936962901421231_REALK,      0.000000000000000_REALK, &
      3.589615529423321_REALK,      0.000000000000000_REALK,      0.557817213188905_REALK, &
      0.000000000000000_REALK,      3.008410414519546_REALK,      0.000000000000000_REALK, &
    -27.612700938654850_REALK,     -5.036935743479729_REALK,      0.000000000000000_REALK, &
     -0.163286483020697_REALK,      0.000000000000000_REALK,     -3.642850568542406_REALK, &
      3.133121445405015_REALK,      0.000000000000000_REALK,     -0.785460927261611_REALK, &
      0.000000000000000_REALK,      6.347923555592708_REALK,      0.000000000000000_REALK, &
     -0.033077736690731_REALK,      0.000000000000000_REALK,     -2.213849848697874_REALK, &
     -6.745007267164154_REALK,     -0.128519724909376_REALK,      0.000000000000000_REALK, &
      1.325286855017152_REALK,      0.000000000000000_REALK,     -1.386098839196176_REALK, &
      1.448316199685685_REALK,      0.000000000000000_REALK,     -0.023455874848139_REALK, &
      0.000000000000000_REALK,      0.224624075723633_REALK,      0.000000000000000_REALK, &
      0.269485000656461_REALK,      0.000000000000000_REALK,     -0.845551689832161_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.762066440423277_REALK, &
      0.000000000000000_REALK,      1.732288346526820_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.605385362041409_REALK,      0.000000000000000_REALK, &
      2.227793233307496_REALK,      0.000000000000000_REALK,     -0.546129095785215_REALK, &
      0.000000000000000_REALK,      1.052754215881542_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.545087152658806_REALK, &
      0.000000000000000_REALK,     -0.594275595956878_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.053981807990159_REALK,      0.000000000000000_REALK, &
      0.845972186163362_REALK,      0.000000000000000_REALK,     -4.051070652720109_REALK, &
      0.000000000000000_REALK,     -0.362521575069464_REALK,      0.000000000000000_REALK, &
     -9.179929919489004_REALK,     -5.763901612165967_REALK,      0.000000000000000_REALK, &
     -4.773662850456000_REALK,      0.000000000000000_REALK,     -3.633231642281247_REALK, &
     -4.706227976870538_REALK,      0.000000000000000_REALK,     -2.696472459945803_REALK, &
      0.000000000000000_REALK,     -5.751444258757945_REALK,      0.000000000000000_REALK, &
     -2.901072273037338_REALK,      0.000000000000000_REALK,     -3.680006984551770_REALK, &
     -5.762074717451477_REALK,     -4.511747703691475_REALK,      0.000000000000000_REALK, &
     -2.906447238356998_REALK,      0.000000000000000_REALK,     -3.552318668106818_REALK, &
     -0.458039294766790_REALK,      0.000000000000000_REALK,     -2.470289822642938_REALK, &
      0.000000000000000_REALK,      4.879109029305625_REALK,      0.000000000000000_REALK, &
     -1.772998652264910_REALK,      0.000000000000000_REALK,     -3.611658091162211_REALK, &
    -28.098024036907596_REALK,      0.213448511339736_REALK,      0.000000000000000_REALK, &
      3.043525149786454_REALK,      0.000000000000000_REALK,     -3.151281175801052_REALK, &
      5.378898935859294_REALK,      0.000000000000000_REALK,      0.027996187127859_REALK, &
      0.000000000000000_REALK,      7.651687418293939_REALK,      0.000000000000000_REALK, &
      0.501737787330507_REALK,      0.000000000000000_REALK,     -1.558505450017691_REALK, &
    -13.443400589293722_REALK,      8.263101921921045_REALK,      0.000000000000000_REALK, &
      9.405029730660587_REALK,      0.000000000000000_REALK,     -1.184822557372308_REALK, &
     11.339590078214901_REALK,      0.000000000000000_REALK,      0.913642600473051_REALK, &
      0.000000000000000_REALK,     15.200616795168724_REALK,      0.000000000000000_REALK, &
      1.320169205880632_REALK,      0.000000000000000_REALK,     -0.498935027151412_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.078339474286109_REALK, &
      0.000000000000000_REALK,      0.736409487114967_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.023977174761877_REALK,      0.000000000000000_REALK, &
      1.604761087951301_REALK,      0.000000000000000_REALK,     -0.484252569206132_REALK, &
      0.000000000000000_REALK,      0.364200506107382_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.929114987736770_REALK, &
      0.000000000000000_REALK,      0.036320835506326_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.309660166691420_REALK,      0.000000000000000_REALK, &
      0.971607609261430_REALK,      0.000000000000000_REALK,     -0.314801656064485_REALK, &
      0.000000000000000_REALK,      0.015294895372098_REALK,      0.000000000000000_REALK, &
     -6.207790317055785_REALK,     -1.939376818114438_REALK,      0.000000000000000_REALK, &
     -0.567579504587295_REALK,      0.000000000000000_REALK,     -2.088669232800359_REALK, &
      0.395874509027620_REALK,      0.000000000000000_REALK,     -0.763113632939945_REALK, &
      0.000000000000000_REALK,      1.573476084396624_REALK,      0.000000000000000_REALK, &
     -0.280703530364212_REALK,      0.000000000000000_REALK,     -1.721629077722735_REALK, &
     -4.954443161303669_REALK,      1.255827871534009_REALK,      0.000000000000000_REALK, &
      3.180539453931907_REALK,      0.000000000000000_REALK,     -1.309966770180124_REALK, &
      4.655009408850949_REALK,      0.000000000000000_REALK,      0.416566751736781_REALK, &
      0.000000000000000_REALK,      6.559814566251032_REALK,      0.000000000000000_REALK, &
      1.339341936840764_REALK,      0.000000000000000_REALK,     -0.919389858535430_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.067570642039764_REALK, &
      0.000000000000000_REALK,      2.528079796624879_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.102910411852460_REALK,      0.000000000000000_REALK, &
      2.667539542336693_REALK,      0.000000000000000_REALK,      2.182171705228681_REALK, &
      0.000000000000000_REALK,      2.083822378537802_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      7.506787797328321_REALK, &
      0.000000000000000_REALK,      3.825182001611945_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.037319542336661_REALK,      0.000000000000000_REALK, &
      4.150088664739545_REALK,      0.000000000000000_REALK,      0.298674133244840_REALK, &
      0.000000000000000_REALK,      2.684673855391543_REALK,      0.000000000000000_REALK, &
    -34.731101028983112_REALK,      5.741573273795580_REALK,      0.000000000000000_REALK, &
      4.799503853606666_REALK,      0.000000000000000_REALK,     -3.314291928075967_REALK, &
      5.598972318981981_REALK,      0.000000000000000_REALK,      0.627834932447559_REALK, &
      0.000000000000000_REALK,      5.252490659866498_REALK,      0.000000000000000_REALK, &
      0.637903221463852_REALK,      0.000000000000000_REALK,     -1.321510032460471_REALK, &
     -9.140072498300192_REALK,      6.394433844948511_REALK,      0.000000000000000_REALK, &
      3.856664836922030_REALK,      0.000000000000000_REALK,     -1.428145312711879_REALK, &
      1.509201094912626_REALK,      0.000000000000000_REALK,      0.854478286069115_REALK, &
      0.000000000000000_REALK,     -2.874957969086986_REALK,      0.000000000000000_REALK, &
      0.526324826136726_REALK,      0.000000000000000_REALK,     -0.584703388960519_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.272440229957429_REALK, &
      0.000000000000000_REALK,     -0.031913548648297_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.451211645258232_REALK,      0.000000000000000_REALK, &
      1.401560388719890_REALK,      0.000000000000000_REALK,     -0.814944524080200_REALK, &
      0.000000000000000_REALK,     -0.012724912477647_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.624020486007222_REALK, &
      0.000000000000000_REALK,     -1.316055844316343_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.722650975459961_REALK,      0.000000000000000_REALK, &
      0.651046023028685_REALK,      0.000000000000000_REALK,     -2.229139715865524_REALK, &
      0.000000000000000_REALK,     -0.538812336100358_REALK,      0.000000000000000_REALK, &
     -6.389886343025060_REALK,     -0.998408375181731_REALK,      0.000000000000000_REALK, &
     -0.027332176689534_REALK,      0.000000000000000_REALK,     -1.829306998675724_REALK, &
      0.435487228567246_REALK,      0.000000000000000_REALK,     -0.327524682641340_REALK, &
      0.000000000000000_REALK,      0.697153757778255_REALK,      0.000000000000000_REALK, &
     -0.010898178702432_REALK,      0.000000000000000_REALK,     -1.215668184769466_REALK, &
     -2.985691084138680_REALK,     -0.049784485081032_REALK,      0.000000000000000_REALK, &
      0.446049770353541_REALK,      0.000000000000000_REALK,     -1.399551500650994_REALK, &
      0.410775662301677_REALK,      0.000000000000000_REALK,     -0.019957870790303_REALK, &
      0.000000000000000_REALK,      0.050739593438079_REALK,      0.000000000000000_REALK, &
      0.182619240527797_REALK,      0.000000000000000_REALK,     -0.954994446493589_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.831773478614511_REALK, &
      0.000000000000000_REALK,      0.869892172737093_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.252436043215534_REALK,      0.000000000000000_REALK, &
      1.548257094241892_REALK,      0.000000000000000_REALK,     -0.179934090899660_REALK, &
      0.000000000000000_REALK,      0.578087898500370_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.795553990362403_REALK, &
      0.000000000000000_REALK,     -0.600043285949249_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.747668922813663_REALK,      0.000000000000000_REALK, &
      1.199685486965720_REALK,      0.000000000000000_REALK,     -2.745249064408206_REALK, &
      0.000000000000000_REALK,     -0.409444029369946_REALK,      0.000000000000000_REALK, &
     -6.373013884384699_REALK,     -3.427517008188617_REALK,      0.000000000000000_REALK, &
     -2.397159778407148_REALK,      0.000000000000000_REALK,     -3.040794539871617_REALK, &
     -1.962422026435094_REALK,      0.000000000000000_REALK,     -1.873976701751987_REALK, &
      0.000000000000000_REALK,     -1.894938215243311_REALK,      0.000000000000000_REALK, &
     -1.593035438298881_REALK,      0.000000000000000_REALK,     -2.829069179588857_REALK, &
     -7.651782019770399_REALK,     -5.243125980907410_REALK,      0.000000000000000_REALK, &
     -2.934655508668070_REALK,      0.000000000000000_REALK,     -5.977992312129043_REALK, &
     -0.389731319808866_REALK,      0.000000000000000_REALK,     -3.503154001154802_REALK, &
      0.000000000000000_REALK,      3.306377658176164_REALK,      0.000000000000000_REALK, &
     -2.002484161423297_REALK,      0.000000000000000_REALK,     -5.710778945435564_REALK, &
    -61.899045022555185_REALK,     19.697708660398874_REALK,      0.000000000000000_REALK, &
      8.759913400686875_REALK,      0.000000000000000_REALK,     -4.503872081549531_REALK, &
      8.227811035662587_REALK,      0.000000000000000_REALK,      1.649084722354313_REALK, &
      0.000000000000000_REALK,      5.989335253113601_REALK,      0.000000000000000_REALK, &
      0.880868612722881_REALK,      0.000000000000000_REALK,     -1.358684511211526_REALK, &
    -61.743964250781730_REALK,     62.287274472090864_REALK,      0.000000000000000_REALK, &
     31.071743938471826_REALK,      0.000000000000000_REALK,     -3.628631648703101_REALK, &
     25.888815510173831_REALK,      0.000000000000000_REALK,      4.106584833179312_REALK, &
      0.000000000000000_REALK,     24.159958192936951_REALK,      0.000000000000000_REALK, &
      2.359701614230574_REALK,      0.000000000000000_REALK,     -0.826714584400052_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.368586615586751_REALK, &
      0.000000000000000_REALK,     -0.977095235452922_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.772104180527676_REALK,      0.000000000000000_REALK, &
      1.599526991462002_REALK,      0.000000000000000_REALK,     -0.876215764478377_REALK, &
      0.000000000000000_REALK,     -0.294760627822210_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.632263917657344_REALK, &
      0.000000000000000_REALK,     -3.552813957438310_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.536900246456562_REALK,      0.000000000000000_REALK, &
      1.707369171987277_REALK,      0.000000000000000_REALK,     -0.476551682706151_REALK, &
      0.000000000000000_REALK,     -0.809440968008996_REALK,      0.000000000000000_REALK, &
     -9.992631709557807_REALK,      0.061323565693082_REALK,      0.000000000000000_REALK, &
      0.702217614817916_REALK,      0.000000000000000_REALK,     -2.181238900930599_REALK, &
      0.986391121362467_REALK,      0.000000000000000_REALK,      0.015401957209581_REALK, &
      0.000000000000000_REALK,      1.076870430387502_REALK,      0.000000000000000_REALK, &
      0.211838209318048_REALK,      0.000000000000000_REALK,     -1.096691711889103_REALK, &
    -15.353715769476747_REALK,      7.954751717065624_REALK,      0.000000000000000_REALK, &
      7.162567532949371_REALK,      0.000000000000000_REALK,     -2.706968023952713_REALK, &
      6.509222458394651_REALK,      0.000000000000000_REALK,      1.573364528944634_REALK, &
      0.000000000000000_REALK,      6.263135428626649_REALK,      0.000000000000000_REALK, &
      1.631854543118450_REALK,      0.000000000000000_REALK,     -1.027885146781678_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.515109809391044_REALK, &
      0.000000000000000_REALK,      0.509724436094218_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.013190918391941_REALK,      0.000000000000000_REALK, &
      1.471418321796615_REALK,      0.000000000000000_REALK,     -0.204455792863608_REALK, &
      0.000000000000000_REALK,      0.256281218977610_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.459431832627599_REALK, &
      0.000000000000000_REALK,      0.082982333267626_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.533259200093235_REALK,      0.000000000000000_REALK, &
      2.788641400319136_REALK,      0.000000000000000_REALK,     -0.389124750328777_REALK, &
      0.000000000000000_REALK,      0.031509905937688_REALK,      0.000000000000000_REALK, &
     -6.623116517412377_REALK,     -1.671543656540007_REALK,      0.000000000000000_REALK, &
     -0.392864497234849_REALK,      0.000000000000000_REALK,     -2.409541986047897_REALK, &
      0.217788308835099_REALK,      0.000000000000000_REALK,     -0.699705015002636_REALK, &
      0.000000000000000_REALK,      0.664335763699989_REALK,      0.000000000000000_REALK, &
     -0.197525927961913_REALK,      0.000000000000000_REALK,     -1.696070345246544_REALK, &
    -16.975417400400662_REALK,      3.626894238441711_REALK,      0.000000000000000_REALK, &
      7.266589032376336_REALK,      0.000000000000000_REALK,     -4.988142369580625_REALK, &
      8.016292893958200_REALK,      0.000000000000000_REALK,      1.195601268265784_REALK, &
      0.000000000000000_REALK,      8.108553929502298_REALK,      0.000000000000000_REALK, &
      2.759256433047825_REALK,      0.000000000000000_REALK,     -2.651724131536839_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.843046969799631_REALK, &
      0.000000000000000_REALK,      2.916457195991702_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.928175435165135_REALK,      0.000000000000000_REALK, &
      3.424243783484856_REALK,      0.000000000000000_REALK,      1.535554221524243_REALK, &
      0.000000000000000_REALK,      2.052886644824826_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     36.133303016648490_REALK, &
      0.000000000000000_REALK,     14.565676662908128_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      5.847374564880096_REALK,      0.000000000000000_REALK, &
     16.675819062388008_REALK,      0.000000000000000_REALK,      0.615316000247656_REALK, &
      0.000000000000000_REALK,      7.743194447443924_REALK,      0.000000000000000_REALK, &
    -42.569402484578895_REALK,     -6.016415895994814_REALK,      0.000000000000000_REALK, &
    -23.555325500808287_REALK,      0.000000000000000_REALK,    -18.447511605223255_REALK, &
     -8.187604218231648_REALK,      0.000000000000000_REALK,     -3.049879721630588_REALK, &
      0.000000000000000_REALK,    -88.662336940815507_REALK,      0.000000000000000_REALK, &
    -29.385448674264893_REALK,      0.000000000000000_REALK,    -69.040235350336260_REALK, &
    -11.433179793251675_REALK,     -1.657204505242454_REALK,      0.000000000000000_REALK, &
     -5.906694485779328_REALK,      0.000000000000000_REALK,     -7.838797737566850_REALK, &
      0.205432510644916_REALK,      0.000000000000000_REALK,     -1.405399553056327_REALK, &
      0.000000000000000_REALK,     41.644852767591260_REALK,      0.000000000000000_REALK, &
     -8.787630943071514_REALK,      0.000000000000000_REALK,    -34.986299894618391_REALK, &
    -19.832059378190362_REALK,      2.093097996306802_REALK,      0.000000000000000_REALK, &
      1.949540854743892_REALK,      0.000000000000000_REALK,     -7.604914318157121_REALK, &
      8.312884865752062_REALK,      0.000000000000000_REALK,      0.903939303497713_REALK, &
      0.000000000000000_REALK,     50.473983007852176_REALK,      0.000000000000000_REALK, &
      2.088361226732205_REALK,      0.000000000000000_REALK,    -24.439305525730489_REALK, &
     -4.990028002127127_REALK,      4.128029115926409_REALK,      0.000000000000000_REALK, &
      7.897667692154029_REALK,      0.000000000000000_REALK,     -1.788356873748600_REALK, &
     11.774001319332749_REALK,      0.000000000000000_REALK,      1.937000347946496_REALK, &
      0.000000000000000_REALK,     67.622872789381191_REALK,      0.000000000000000_REALK, &
      9.320468983115095_REALK,      0.000000000000000_REALK,     -6.331612859226931_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.086986092114821_REALK, &
      0.000000000000000_REALK,      3.577804329111118_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.805185439873636_REALK,      0.000000000000000_REALK, &
      6.590699536938661_REALK,      0.000000000000000_REALK,     10.288782689434889_REALK, &
      0.000000000000000_REALK,     11.497703912542791_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.391514213767257_REALK, &
      0.000000000000000_REALK,      2.029771564850409_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.199155871077603_REALK,      0.000000000000000_REALK, &
      4.774213573339858_REALK,      0.000000000000000_REALK,     -0.350151052671843_REALK, &
      0.000000000000000_REALK,      7.186332845502661_REALK,      0.000000000000000_REALK, &
    -11.918947886218486_REALK,      7.380674627580811_REALK,      0.000000000000000_REALK, &
      2.529327352476006_REALK,      0.000000000000000_REALK,     -3.847190931094640_REALK, &
      8.606152633647305_REALK,      0.000000000000000_REALK,      2.776833230025202_REALK, &
      0.000000000000000_REALK,     14.850455198203784_REALK,      0.000000000000000_REALK, &
      2.171355468210914_REALK,      0.000000000000000_REALK,     -9.908111408323172_REALK, &
     -2.086759650901681_REALK,      3.458794437951016_REALK,      0.000000000000000_REALK, &
      0.751872020201991_REALK,      0.000000000000000_REALK,     -1.164778294151415_REALK, &
      1.748015775933997_REALK,      0.000000000000000_REALK,      1.755905428767346_REALK, &
      0.000000000000000_REALK,     -9.640531021264060_REALK,      0.000000000000000_REALK, &
      0.711790197912268_REALK,      0.000000000000000_REALK,     -3.308054097937641_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.354820756711827_REALK, &
      0.000000000000000_REALK,     -0.703233885576398_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.323564654719393_REALK,      0.000000000000000_REALK, &
      3.786555387445317_REALK,      0.000000000000000_REALK,     -5.551855714924355_REALK, &
      0.000000000000000_REALK,     -1.811118764104703_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.951005914153812_REALK, &
      0.000000000000000_REALK,     -1.753169274926086_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.132083725708466_REALK,      0.000000000000000_REALK, &
      1.448374406813633_REALK,      0.000000000000000_REALK,    -10.088493343332502_REALK, &
      0.000000000000000_REALK,     -4.979126786117536_REALK,      0.000000000000000_REALK, &
     -5.294987730431703_REALK,     -1.578307358190466_REALK,      0.000000000000000_REALK, &
     -2.182338403708613_REALK,      0.000000000000000_REALK,     -5.127338999525722_REALK, &
     -1.594114263268097_REALK,      0.000000000000000_REALK,     -1.781421024728103_REALK, &
      0.000000000000000_REALK,     -5.652685580962340_REALK,      0.000000000000000_REALK, &
     -5.620426025607922_REALK,      0.000000000000000_REALK,    -22.008372232033715_REALK, &
     -2.580500231606986_REALK,     -1.079384540574274_REALK,      0.000000000000000_REALK, &
     -1.085349949084547_REALK,      0.000000000000000_REALK,     -4.321116698604595_REALK, &
      0.080098046814358_REALK,      0.000000000000000_REALK,     -1.643894028849560_REALK, &
      0.000000000000000_REALK,      4.869309629343972_REALK,      0.000000000000000_REALK, &
     -3.082471887391485_REALK,      0.000000000000000_REALK,    -20.453803489558467_REALK, &
     -5.333681995736963_REALK,     13.407942204040642_REALK,      0.000000000000000_REALK, &
      2.089963485580469_REALK,      0.000000000000000_REALK,     -1.404763792408669_REALK, &
     10.511778020644332_REALK,      0.000000000000000_REALK,      4.284312106743671_REALK, &
      0.000000000000000_REALK,      6.781495715790758_REALK,      0.000000000000000_REALK, &
      1.365196995691213_REALK,      0.000000000000000_REALK,     -2.752841361512299_REALK, &
     -1.207513309010606_REALK,     10.748702764432291_REALK,      0.000000000000000_REALK, &
      3.001226122313751_REALK,      0.000000000000000_REALK,     -0.273439358374097_REALK, &
      9.547005655385993_REALK,      0.000000000000000_REALK,      3.356521084193496_REALK, &
      0.000000000000000_REALK,     15.375487958318324_REALK,      0.000000000000000_REALK, &
      1.827960356559978_REALK,      0.000000000000000_REALK,     -0.499632103674052_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.366511211643798_REALK, &
      0.000000000000000_REALK,     -1.962427400598369_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.497151596581785_REALK,      0.000000000000000_REALK, &
      2.268552283526704_REALK,      0.000000000000000_REALK,     -3.972916805862730_REALK, &
      0.000000000000000_REALK,     -3.845665261680273_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.324976908817734_REALK, &
      0.000000000000000_REALK,     -1.783167017808158_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.267080567507742_REALK,      0.000000000000000_REALK, &
      1.241260371967633_REALK,      0.000000000000000_REALK,     -1.081195685429005_REALK, &
      0.000000000000000_REALK,     -3.258226956087218_REALK,      0.000000000000000_REALK, &
     -3.386808758396092_REALK,      0.432578186118478_REALK,      0.000000000000000_REALK, &
      0.228667727474842_REALK,      0.000000000000000_REALK,     -2.676012360360086_REALK, &
      1.271147894978496_REALK,      0.000000000000000_REALK,      0.414672124558107_REALK, &
      0.000000000000000_REALK,      3.610135119852971_REALK,      0.000000000000000_REALK, &
      0.448108060328365_REALK,      0.000000000000000_REALK,     -8.740066656670496_REALK, &
     -2.165117091460371_REALK,      1.994292663410354_REALK,      0.000000000000000_REALK, &
      2.165185730735963_REALK,      0.000000000000000_REALK,     -1.470861374055087_REALK, &
      3.785442023981660_REALK,      0.000000000000000_REALK,      1.868286486144025_REALK, &
      0.000000000000000_REALK,      9.567953643391906_REALK,      0.000000000000000_REALK, &
      3.956256728823309_REALK,      0.000000000000000_REALK,     -4.479296414518811_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.153964917676612_REALK, &
      0.000000000000000_REALK,      1.258955486821485_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.286847691687753_REALK,      0.000000000000000_REALK, &
      5.039017127092976_REALK,      0.000000000000000_REALK,      2.207705446302054_REALK, &
      0.000000000000000_REALK,      4.111847551825289_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.915424570243186_REALK, &
      0.000000000000000_REALK,      1.669416567083639_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.156616575257546_REALK,      0.000000000000000_REALK, &
      7.674752279120920_REALK,      0.000000000000000_REALK,     -0.148628514374880_REALK, &
      0.000000000000000_REALK,      5.083967649962902_REALK,      0.000000000000000_REALK, &
      7.119556385490888_REALK,     22.076201878928984_REALK,      0.000000000000000_REALK, &
      0.167468312923395_REALK,      0.000000000000000_REALK,      1.511542950095012_REALK, &
     12.669751186831029_REALK,      0.000000000000000_REALK,      5.799152807002788_REALK, &
      0.000000000000000_REALK,     -3.111420920282463_REALK,      0.000000000000000_REALK, &
      0.080113024898240_REALK,      0.000000000000000_REALK,      2.169263113991823_REALK, &
      1.682475241569538_REALK,     12.975244525163671_REALK,      0.000000000000000_REALK, &
     -2.704413019665567_REALK,      0.000000000000000_REALK,      0.621374205011224_REALK, &
      5.088470198070804_REALK,      0.000000000000000_REALK,      4.390635364601851_REALK, &
      0.000000000000000_REALK,    -15.999094587118623_REALK,      0.000000000000000_REALK, &
     -1.284596155717864_REALK,      0.000000000000000_REALK,      0.885458222411277_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.138706789925853_REALK, &
      0.000000000000000_REALK,     -3.212088640036258_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.445028167083354_REALK,      0.000000000000000_REALK, &
      0.897373748441914_REALK,      0.000000000000000_REALK,     -3.770101880275153_REALK, &
      0.000000000000000_REALK,     -4.609770040120150_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.268348972825676_REALK, &
      0.000000000000000_REALK,     -3.350893076161842_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.996665554115568_REALK,      0.000000000000000_REALK, &
      0.272416251082898_REALK,      0.000000000000000_REALK,     -4.527223865390640_REALK, &
      0.000000000000000_REALK,     -4.775022527133914_REALK,      0.000000000000000_REALK, &
     -2.670339010969770_REALK,      1.590750998761374_REALK,      0.000000000000000_REALK, &
      0.372730780570974_REALK,      0.000000000000000_REALK,     -1.700807699741284_REALK, &
      1.295095059297694_REALK,      0.000000000000000_REALK,      1.253613484371306_REALK, &
      0.000000000000000_REALK,      1.219479721218381_REALK,      0.000000000000000_REALK, &
      0.534917736668461_REALK,      0.000000000000000_REALK,     -4.068138241137567_REALK, &
     -1.118428661166390_REALK,      1.749971329843395_REALK,      0.000000000000000_REALK, &
      0.266632743245261_REALK,      0.000000000000000_REALK,     -1.239179102949033_REALK, &
      0.589504303557966_REALK,      0.000000000000000_REALK,      1.776495077132926_REALK, &
      0.000000000000000_REALK,     -1.715362984531509_REALK,      0.000000000000000_REALK, &
      0.379951650658441_REALK,      0.000000000000000_REALK,     -2.943050303927117_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.169185638991086_REALK, &
      0.000000000000000_REALK,     -0.310893228001815_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.146074675942457_REALK,      0.000000000000000_REALK, &
      2.849094934050218_REALK,      0.000000000000000_REALK,     -1.367710693534740_REALK, &
      0.000000000000000_REALK,     -0.743621180652739_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.443479611873005_REALK, &
      0.000000000000000_REALK,     -1.865153858317266_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.157084419640559_REALK,      0.000000000000000_REALK, &
      2.442263272834707_REALK,      0.000000000000000_REALK,     -5.385210009492616_REALK, &
      0.000000000000000_REALK,     -4.429740314800348_REALK,      0.000000000000000_REALK, &
     -3.558891044953816_REALK,     -1.020514031472830_REALK,      0.000000000000000_REALK, &
     -0.964791721270930_REALK,      0.000000000000000_REALK,     -3.777915629770872_REALK, &
     -0.719669843494123_REALK,      0.000000000000000_REALK,     -1.340383831117717_REALK, &
      0.000000000000000_REALK,     -1.392550331502476_REALK,      0.000000000000000_REALK, &
     -2.307671876504464_REALK,      0.000000000000000_REALK,    -12.650881264613322_REALK, &
     -4.149167947437576_REALK,     -1.638338473505936_REALK,      0.000000000000000_REALK, &
     -1.154677231749249_REALK,      0.000000000000000_REALK,     -7.661883726716689_REALK, &
      0.081037272009325_REALK,      0.000000000000000_REALK,     -2.771950396392332_REALK, &
      0.000000000000000_REALK,      2.599224092524407_REALK,      0.000000000000000_REALK, &
     -2.742358364299433_REALK,      0.000000000000000_REALK,    -25.475762823683858_REALK, &
     49.988115970775347_REALK,     40.526351018788510_REALK,      0.000000000000000_REALK, &
     -3.432639369353385_REALK,      0.000000000000000_REALK,      7.845530055205596_REALK, &
     18.710298983404098_REALK,      0.000000000000000_REALK,      8.054815472192519_REALK, &
      0.000000000000000_REALK,    -11.052282466911771_REALK,      0.000000000000000_REALK, &
     -1.132391108161579_REALK,      0.000000000000000_REALK,      7.764470004609991_REALK, &
     55.905598383597834_REALK,     74.450813237353330_REALK,      0.000000000000000_REALK, &
    -10.054076650868398_REALK,      0.000000000000000_REALK,      7.060453665908589_REALK, &
     30.891069969589850_REALK,      0.000000000000000_REALK,     11.678104414824647_REALK, &
      0.000000000000000_REALK,     -1.078031463854113_REALK,      0.000000000000000_REALK, &
     -2.297944338439543_REALK,      0.000000000000000_REALK,      4.841179381794748_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.711571880647155_REALK, &
      0.000000000000000_REALK,     -5.298519843685138_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.037689935127181_REALK,      0.000000000000000_REALK, &
     -1.020550480324381_REALK,      0.000000000000000_REALK,     -3.818795218810084_REALK, &
      0.000000000000000_REALK,     -5.243775513654058_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.135683480002585_REALK, &
      0.000000000000000_REALK,     -9.732523256092700_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.458006948985962_REALK,      0.000000000000000_REALK, &
     -1.004988404772980_REALK,      0.000000000000000_REALK,     -2.577998303840646_REALK, &
      0.000000000000000_REALK,     -6.673351763178879_REALK,      0.000000000000000_REALK, &
     -1.741352111280608_REALK,      3.637158040455713_REALK,      0.000000000000000_REALK, &
      0.406609491552383_REALK,      0.000000000000000_REALK,     -0.819904694971993_REALK, &
      1.773680315665553_REALK,      0.000000000000000_REALK,      2.168710193929611_REALK, &
      0.000000000000000_REALK,      0.666309417307220_REALK,      0.000000000000000_REALK, &
      0.402408400520169_REALK,      0.000000000000000_REALK,     -1.352389060172539_REALK, &
     -1.593795254066755_REALK,     11.517129176426995_REALK,      0.000000000000000_REALK, &
      2.209263552646646_REALK,      0.000000000000000_REALK,     -0.603852809180458_REALK, &
      5.138364945258606_REALK,      0.000000000000000_REALK,      5.419614557569034_REALK, &
      0.000000000000000_REALK,      4.247241691341152_REALK,      0.000000000000000_REALK, &
      1.514837667112881_REALK,      0.000000000000000_REALK,     -0.690078359402200_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.925882842483814_REALK, &
      0.000000000000000_REALK,     -1.145390739701100_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.251657140883412_REALK,      0.000000000000000_REALK, &
      1.913894358522050_REALK,      0.000000000000000_REALK,     -1.171065496256432_REALK, &
      0.000000000000000_REALK,     -1.889260929342053_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.259099134771568_REALK, &
      0.000000000000000_REALK,     -3.937876461325834_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.431242258100266_REALK,      0.000000000000000_REALK, &
      3.340339900007776_REALK,      0.000000000000000_REALK,     -0.895990957314859_REALK, &
      0.000000000000000_REALK,     -4.500175020545748_REALK,      0.000000000000000_REALK, &
     -3.317198093165548_REALK,      0.352035055899724_REALK,      0.000000000000000_REALK, &
      0.133464248123685_REALK,      0.000000000000000_REALK,     -2.603136448892787_REALK, &
      0.643452514463827_REALK,      0.000000000000000_REALK,      0.349843662670326_REALK, &
      0.000000000000000_REALK,      1.064131186800760_REALK,      0.000000000000000_REALK, &
      0.220142158220950_REALK,      0.000000000000000_REALK,     -6.011228607533408_REALK, &
     -8.573205742210286_REALK,      6.410594856925734_REALK,      0.000000000000000_REALK, &
      4.781511680237360_REALK,      0.000000000000000_REALK,     -5.413654773520528_REALK, &
      6.112172748330607_REALK,      0.000000000000000_REALK,      5.027721850508690_REALK, &
      0.000000000000000_REALK,      7.928999403179576_REALK,      0.000000000000000_REALK, &
      5.464274878904447_REALK,      0.000000000000000_REALK,     -8.661356421230629_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.277863330953822_REALK, &
      0.000000000000000_REALK,      1.224670320595075_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.085666200106039_REALK,      0.000000000000000_REALK, &
      5.951727509610205_REALK,      0.000000000000000_REALK,      1.084580003557496_REALK, &
      0.000000000000000_REALK,      2.828039716892085_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     26.334145139729305_REALK, &
      0.000000000000000_REALK,      6.144457340986721_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.112556062044227_REALK,      0.000000000000000_REALK, &
     28.914798679973000_REALK,      0.000000000000000_REALK,     -0.205281687477622_REALK, &
      0.000000000000000_REALK,      9.830574218666737_REALK,      0.000000000000000_REALK/
    ! results of test 5, ket-major order, ZDIPVEL
  data REF_CONTR_INTS(31501:32760)                                                         &
     /0.000000000000000_REALK,      0.000000000000000_REALK,     12.209587161337501_REALK, &
      0.000000000000000_REALK,     12.335510502417661_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     16.425689030404968_REALK,      0.000000000000000_REALK, &
      7.745015515490882_REALK,      0.000000000000000_REALK,     30.907178242688616_REALK, &
      0.000000000000000_REALK,     11.087878659224391_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     12.501230293251162_REALK, &
      0.000000000000000_REALK,     16.468048920163149_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     25.502317718550895_REALK,      0.000000000000000_REALK, &
      9.223628235199078_REALK,      0.000000000000000_REALK,     51.184926763798529_REALK, &
      0.000000000000000_REALK,     14.915949621647256_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.377532768527326_REALK, &
      0.000000000000000_REALK,      6.095971674346316_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      6.018285029253223_REALK,      0.000000000000000_REALK, &
      4.580512760439629_REALK,      0.000000000000000_REALK,      7.873284975640716_REALK, &
      0.000000000000000_REALK,      4.511064107063818_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      7.281983886630690_REALK, &
      0.000000000000000_REALK,      4.469394585246675_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.936962901421232_REALK,      0.000000000000000_REALK, &
      3.589615529423321_REALK,      0.000000000000000_REALK,      0.557817213188908_REALK, &
      0.000000000000000_REALK,      3.008410414519546_REALK,      0.000000000000000_REALK, &
      9.671464072433743_REALK,      8.377532768527326_REALK,      0.000000000000000_REALK, &
      9.341216610459950_REALK,      0.000000000000000_REALK,     -2.085933847353481_REALK, &
     12.768062194840098_REALK,      0.000000000000000_REALK,     -2.169264405147246_REALK, &
      0.000000000000000_REALK,     23.152677876284958_REALK,      0.000000000000000_REALK, &
     -3.273692581597515_REALK,      0.000000000000000_REALK,     -4.173680944286847_REALK, &
      8.344424410208857_REALK,      7.281983886630689_REALK,      0.000000000000000_REALK, &
      8.474391014111333_REALK,      0.000000000000000_REALK,     -4.944991743065289_REALK, &
     12.317969197018224_REALK,      0.000000000000000_REALK,     -5.791390766173672_REALK, &
      0.000000000000000_REALK,     22.918735512041497_REALK,      0.000000000000000_REALK, &
     -9.203050765809666_REALK,      0.000000000000000_REALK,     -7.344780697013846_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      7.830530914734441_REALK, &
      0.000000000000000_REALK,      4.409227071396122_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.649786208748017_REALK,      0.000000000000000_REALK, &
      3.663284417237143_REALK,      0.000000000000000_REALK,      3.988649916176913_REALK, &
      0.000000000000000_REALK,      2.679595690577732_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.588035945067877_REALK, &
      0.000000000000000_REALK,      4.047492236325485_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      4.066409726357447_REALK,      0.000000000000000_REALK, &
      3.059583387690254_REALK,      0.000000000000000_REALK,      5.665668738974966_REALK, &
      0.000000000000000_REALK,      2.469061947986520_REALK,      0.000000000000000_REALK, &
      7.584348092057158_REALK,      4.762066440423276_REALK,      0.000000000000000_REALK, &
      3.943943041996059_REALK,      0.000000000000000_REALK,     -1.421576946812006_REALK, &
      3.888229157543608_REALK,      0.000000000000000_REALK,     -1.055050562194703_REALK, &
      0.000000000000000_REALK,      4.751774324319903_REALK,      0.000000000000000_REALK, &
     -1.135104466335632_REALK,      0.000000000000000_REALK,     -2.335930053365533_REALK, &
      1.973272488466079_REALK,      1.545087152658806_REALK,      0.000000000000000_REALK, &
      0.995338078011720_REALK,      0.000000000000000_REALK,     -1.962704994138220_REALK, &
      0.156859531214041_REALK,      0.000000000000000_REALK,     -1.364869153040838_REALK, &
      0.000000000000000_REALK,     -1.670893226461585_REALK,      0.000000000000000_REALK, &
     -0.979606176845403_REALK,      0.000000000000000_REALK,     -2.641957742099134_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.096159137619856_REALK, &
      0.000000000000000_REALK,     -0.956292917411945_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.087562797168844_REALK,      0.000000000000000_REALK, &
      1.059311695339401_REALK,      0.000000000000000_REALK,     -1.619976210467592_REALK, &
      0.000000000000000_REALK,      1.200517439536802_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.948902948583890_REALK, &
      0.000000000000000_REALK,      1.089449164175544_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.436490510177775_REALK,      0.000000000000000_REALK, &
      3.817393384087544_REALK,      0.000000000000000_REALK,      2.280573693318197_REALK, &
      0.000000000000000_REALK,      4.883092478005739_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      9.030438649538032_REALK, &
      0.000000000000000_REALK,      3.814242173398460_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.584183704067790_REALK,      0.000000000000000_REALK, &
      3.553332586284229_REALK,      0.000000000000000_REALK,      2.172451309525271_REALK, &
      0.000000000000000_REALK,      1.886381088611596_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      9.647483267783709_REALK, &
      0.000000000000000_REALK,      3.459753350034372_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.513684699194594_REALK,      0.000000000000000_REALK, &
      3.200136625719711_REALK,      0.000000000000000_REALK,     -0.047496534747906_REALK, &
      0.000000000000000_REALK,      1.456920380942887_REALK,      0.000000000000000_REALK, &
      8.433574557777296_REALK,      4.078339474286109_REALK,      0.000000000000000_REALK, &
      2.827099580562477_REALK,      0.000000000000000_REALK,     -1.343824985817979_REALK, &
      2.388729837657292_REALK,      0.000000000000000_REALK,     -0.759991574944114_REALK, &
      0.000000000000000_REALK,      2.606248323964255_REALK,      0.000000000000000_REALK, &
     -0.662156534175242_REALK,      0.000000000000000_REALK,     -1.796993633538033_REALK, &
      6.136337466412071_REALK,      2.929114987736770_REALK,      0.000000000000000_REALK, &
      2.156371113477831_REALK,      0.000000000000000_REALK,     -2.617638069261469_REALK, &
      2.229513464751975_REALK,      0.000000000000000_REALK,     -1.567566022181965_REALK, &
      0.000000000000000_REALK,      3.244845379612821_REALK,      0.000000000000000_REALK, &
     -1.465038776130367_REALK,      0.000000000000000_REALK,     -2.432344893617435_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.884528533212160_REALK, &
      0.000000000000000_REALK,     -0.549752889658613_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.457296117453453_REALK,      0.000000000000000_REALK, &
      0.718968044003764_REALK,      0.000000000000000_REALK,     -0.474532173502725_REALK, &
      0.000000000000000_REALK,      0.561641796033587_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.788419517281383_REALK, &
      0.000000000000000_REALK,      0.401749487083899_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.213974676450648_REALK,      0.000000000000000_REALK, &
      1.921559648281264_REALK,      0.000000000000000_REALK,      0.031369011928263_REALK, &
      0.000000000000000_REALK,      1.243048369820754_REALK,      0.000000000000000_REALK, &
      5.428968800785847_REALK,      4.067570642039765_REALK,      0.000000000000000_REALK, &
      3.873925643090010_REALK,      0.000000000000000_REALK,      0.352687364375603_REALK, &
      4.461418958756212_REALK,      0.000000000000000_REALK,      0.309030995432941_REALK, &
      0.000000000000000_REALK,      6.417031609832160_REALK,      0.000000000000000_REALK, &
      0.369923886448416_REALK,      0.000000000000000_REALK,     -0.924215874479916_REALK, &
      9.921300714539557_REALK,      7.506787797328321_REALK,      0.000000000000000_REALK, &
      7.252903578664796_REALK,      0.000000000000000_REALK,     -2.483416594686616_REALK, &
      8.544758721617551_REALK,      0.000000000000000_REALK,     -2.357350514541345_REALK, &
      0.000000000000000_REALK,     12.271463307835539_REALK,      0.000000000000000_REALK, &
     -2.891466206971178_REALK,      0.000000000000000_REALK,     -5.327016188642624_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     12.775980185906935_REALK, &
      0.000000000000000_REALK,      4.011546841359845_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.328068743605272_REALK,      0.000000000000000_REALK, &
      4.191119545706496_REALK,      0.000000000000000_REALK,      1.584935593699231_REALK, &
      0.000000000000000_REALK,      1.599526991462001_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     10.341794454862704_REALK, &
      0.000000000000000_REALK,      4.170270475731821_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.922230461698117_REALK,      0.000000000000000_REALK, &
      4.145873902965362_REALK,      0.000000000000000_REALK,      2.925093195468961_REALK, &
      0.000000000000000_REALK,      1.707369171987277_REALK,      0.000000000000000_REALK, &
     11.689542074189989_REALK,      4.272440229957429_REALK,      0.000000000000000_REALK, &
      2.433764128906156_REALK,      0.000000000000000_REALK,     -1.584854340897325_REALK, &
      1.614107414580956_REALK,      0.000000000000000_REALK,     -0.663758671119298_REALK, &
      0.000000000000000_REALK,      1.330043087845806_REALK,      0.000000000000000_REALK, &
     -0.459575198991359_REALK,      0.000000000000000_REALK,     -1.708644511055314_REALK, &
      3.367678774223799_REALK,      1.624020486007222_REALK,      0.000000000000000_REALK, &
      0.746692128801760_REALK,      0.000000000000000_REALK,     -2.546886589355904_REALK, &
     -0.021224516081830_REALK,      0.000000000000000_REALK,     -1.050380436349446_REALK, &
      0.000000000000000_REALK,     -1.030751481371144_REALK,      0.000000000000000_REALK, &
     -0.493218910413295_REALK,      0.000000000000000_REALK,     -2.300899745899662_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.012583883879153_REALK, &
      0.000000000000000_REALK,     -0.481486868673010_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.330950938682375_REALK,      0.000000000000000_REALK, &
      0.686179214687037_REALK,      0.000000000000000_REALK,     -0.285772742069054_REALK, &
      0.000000000000000_REALK,      0.396583719170183_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.682036952802596_REALK, &
      0.000000000000000_REALK,      0.429223939365061_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.363393314950164_REALK,      0.000000000000000_REALK, &
      2.008954541217928_REALK,      0.000000000000000_REALK,      0.403242538914202_REALK, &
      0.000000000000000_REALK,      1.291187061594046_REALK,      0.000000000000000_REALK, &
      5.265307700451099_REALK,      2.831773478614512_REALK,      0.000000000000000_REALK, &
      1.980504682625121_REALK,      0.000000000000000_REALK,      0.291042989792464_REALK, &
      1.621329561613086_REALK,      0.000000000000000_REALK,      0.179363575844340_REALK, &
      0.000000000000000_REALK,      1.565575245496733_REALK,      0.000000000000000_REALK, &
      0.152473898097512_REALK,      0.000000000000000_REALK,     -0.614892508004647_REALK, &
      2.620419152431702_REALK,      1.795553990362404_REALK,      0.000000000000000_REALK, &
      1.004998244962258_REALK,      0.000000000000000_REALK,     -1.162867719394523_REALK, &
      0.133466872434545_REALK,      0.000000000000000_REALK,     -0.681450308282489_REALK, &
      0.000000000000000_REALK,     -1.132297720749378_REALK,      0.000000000000000_REALK, &
     -0.389532817764470_REALK,      0.000000000000000_REALK,     -2.425142623301481_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.302835328577121_REALK, &
      0.000000000000000_REALK,     -1.696533321276293_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.602138316177109_REALK,      0.000000000000000_REALK, &
     -0.166483001784953_REALK,      0.000000000000000_REALK,     -1.885614857541143_REALK, &
      0.000000000000000_REALK,     -0.149077909700123_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.294346251984429_REALK, &
      0.000000000000000_REALK,     -1.291174206782624_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.434658446162251_REALK,      0.000000000000000_REALK, &
      3.811916504273466_REALK,      0.000000000000000_REALK,     -1.814008143256063_REALK, &
      0.000000000000000_REALK,      3.883477343631681_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     25.320305047632353_REALK, &
      0.000000000000000_REALK,      5.451388777667954_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.689557602686869_REALK,      0.000000000000000_REALK, &
      6.359419098833769_REALK,      0.000000000000000_REALK,      1.357159815298884_REALK, &
      0.000000000000000_REALK,      1.644522171744616_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     58.504457569314233_REALK, &
      0.000000000000000_REALK,     10.595823336182809_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.128921014440612_REALK,      0.000000000000000_REALK, &
     11.571553908744832_REALK,      0.000000000000000_REALK,     -0.581639757370457_REALK, &
      0.000000000000000_REALK,      2.414056463647814_REALK,      0.000000000000000_REALK, &
     24.687493947734477_REALK,      6.368586615586751_REALK,      0.000000000000000_REALK, &
      2.993409351822925_REALK,      0.000000000000000_REALK,     -2.552106257837466_REALK, &
      1.584935593699231_REALK,      0.000000000000000_REALK,     -0.757512782764905_REALK, &
      0.000000000000000_REALK,      1.119806060174584_REALK,      0.000000000000000_REALK, &
     -0.427658473249786_REALK,      0.000000000000000_REALK,     -2.081680080089664_REALK, &
     33.483131662241782_REALK,      8.632263917657346_REALK,      0.000000000000000_REALK, &
      4.160965111688049_REALK,      0.000000000000000_REALK,     -9.524246645950937_REALK, &
      2.925093195468961_REALK,      0.000000000000000_REALK,     -2.754624269938246_REALK, &
      0.000000000000000_REALK,      3.239652267263648_REALK,      0.000000000000000_REALK, &
     -1.529472678652441_REALK,      0.000000000000000_REALK,     -4.788155278988532_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.692548464126262_REALK, &
      0.000000000000000_REALK,     -0.574117897650380_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.309155623829725_REALK,      0.000000000000000_REALK, &
      0.878133114703221_REALK,      0.000000000000000_REALK,     -0.199459295521050_REALK, &
      0.000000000000000_REALK,      0.357770387786017_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.926321482061436_REALK, &
      0.000000000000000_REALK,      0.830191299452566_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.273773659979538_REALK,      0.000000000000000_REALK, &
      4.252719891318522_REALK,      0.000000000000000_REALK,     -0.006166191376032_REALK, &
      0.000000000000000_REALK,      1.389737926960929_REALK,      0.000000000000000_REALK, &
      8.997814697603237_REALK,      3.515109809391045_REALK,      0.000000000000000_REALK, &
      1.956848417488458_REALK,      0.000000000000000_REALK,      0.379227936292395_REALK, &
      1.314147336450567_REALK,      0.000000000000000_REALK,      0.170461903737989_REALK, &
      0.000000000000000_REALK,      1.100381497921880_REALK,      0.000000000000000_REALK, &
      0.113980271523382_REALK,      0.000000000000000_REALK,     -0.606171136363364_REALK, &
     21.024943956497506_REALK,      8.459431832627599_REALK,      0.000000000000000_REALK, &
      4.926668230309155_REALK,      0.000000000000000_REALK,     -3.509296092392919_REALK, &
      3.839397813137192_REALK,      0.000000000000000_REALK,     -1.584015612911291_REALK, &
      0.000000000000000_REALK,      4.010937121432045_REALK,      0.000000000000000_REALK, &
     -1.062628768055101_REALK,      0.000000000000000_REALK,     -4.072644342372906_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.693354915211359_REALK, &
      0.000000000000000_REALK,     -1.344342149639977_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.888793263606078_REALK,      0.000000000000000_REALK, &
     -0.149077909700123_REALK,      0.000000000000000_REALK,     -0.707814352938137_REALK, &
      0.000000000000000_REALK,     -0.089374492358814_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.672669933876068_REALK, &
      0.000000000000000_REALK,     -1.077378563082875_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.432512416162619_REALK,      0.000000000000000_REALK, &
      3.883477343631681_REALK,      0.000000000000000_REALK,     -0.045513042993525_REALK, &
      0.000000000000000_REALK,      1.803240973740630_REALK,      0.000000000000000_REALK, &
      9.653647836174189_REALK,      5.843046969799631_REALK,      0.000000000000000_REALK, &
      4.469059217834127_REALK,      0.000000000000000_REALK,      1.811698385266843_REALK, &
      4.090710851859765_REALK,      0.000000000000000_REALK,      1.261708366790227_REALK, &
      0.000000000000000_REALK,      4.515547495424822_REALK,      0.000000000000000_REALK, &
      1.159096992549553_REALK,      0.000000000000000_REALK,      0.078360397804389_REALK, &
     56.655617089868265_REALK,     36.133303016648490_REALK,      0.000000000000000_REALK, &
     27.617888076845006_REALK,      0.000000000000000_REALK,     -2.797261161047646_REALK, &
     24.524579366925529_REALK,      0.000000000000000_REALK,     -2.001385739657424_REALK, &
      0.000000000000000_REALK,     25.281157218838903_REALK,      0.000000000000000_REALK, &
     -1.762071765904233_REALK,      0.000000000000000_REALK,    -11.824233594654904_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.787390234715579_REALK, &
      0.000000000000000_REALK,      8.678807429153172_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      4.258021186060472_REALK,      0.000000000000000_REALK, &
      5.759783669102944_REALK,      0.000000000000000_REALK,     45.665637510518536_REALK, &
      0.000000000000000_REALK,     32.480635886919693_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.116924328407710_REALK, &
      0.000000000000000_REALK,      8.896976316016673_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      5.427999328441814_REALK,      0.000000000000000_REALK, &
      5.385800899502727_REALK,      0.000000000000000_REALK,     66.493104035198101_REALK, &
      0.000000000000000_REALK,     39.709186531976371_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.086986092114821_REALK, &
      0.000000000000000_REALK,      3.577804329111118_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.805185439873636_REALK,      0.000000000000000_REALK, &
      6.590699536938663_REALK,      0.000000000000000_REALK,     10.288782689434893_REALK, &
      0.000000000000000_REALK,     11.497703912542793_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.391514213767257_REALK, &
      0.000000000000000_REALK,      2.029771564850410_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.199155871077604_REALK,      0.000000000000000_REALK, &
      4.774213573339858_REALK,      0.000000000000000_REALK,     -0.350151052671840_REALK, &
      0.000000000000000_REALK,      7.186332845502661_REALK,      0.000000000000000_REALK, &
     12.484467384188038_REALK,      5.086986092114821_REALK,      0.000000000000000_REALK, &
     10.617430600697588_REALK,      0.000000000000000_REALK,      0.282842126983384_REALK, &
      9.266090018754426_REALK,      0.000000000000000_REALK,      0.129794958057873_REALK, &
      0.000000000000000_REALK,     60.461432602990122_REALK,      0.000000000000000_REALK, &
      0.671955132770827_REALK,      0.000000000000000_REALK,    -13.566877755744658_REALK, &
      6.374295775640051_REALK,      3.391514213767257_REALK,      0.000000000000000_REALK, &
      6.907074851853642_REALK,      0.000000000000000_REALK,     -2.901228800887828_REALK, &
      7.994429187379834_REALK,      0.000000000000000_REALK,     -2.021059742962373_REALK, &
      0.000000000000000_REALK,     51.859485735397001_REALK,      0.000000000000000_REALK, &
    -10.352175715425400_REALK,      0.000000000000000_REALK,    -28.631436784575691_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.460271173033565_REALK, &
      0.000000000000000_REALK,      1.809947593403386_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.267637151084263_REALK,      0.000000000000000_REALK, &
      7.291648761164853_REALK,      0.000000000000000_REALK,      3.548031158016674_REALK, &
      0.000000000000000_REALK,      4.661365323390552_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.544640517598148_REALK, &
      0.000000000000000_REALK,      1.322014579711824_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.848950459110981_REALK,      0.000000000000000_REALK, &
      5.398459179522447_REALK,      0.000000000000000_REALK,      4.536175368622069_REALK, &
      0.000000000000000_REALK,      3.754616453541590_REALK,      0.000000000000000_REALK, &
     11.254927408405994_REALK,      3.354820756711827_REALK,      0.000000000000000_REALK, &
      4.638737909278308_REALK,      0.000000000000000_REALK,      0.214632795328983_REALK, &
      3.388419620062888_REALK,      0.000000000000000_REALK,      0.074571112663037_REALK, &
      0.000000000000000_REALK,     12.015243304650177_REALK,      0.000000000000000_REALK, &
      0.235273647583587_REALK,      0.000000000000000_REALK,     -8.250580473962414_REALK, &
      2.273583592764694_REALK,      0.951005914153812_REALK,      0.000000000000000_REALK, &
      0.956261815605389_REALK,      0.000000000000000_REALK,     -1.611685608073120_REALK, &
     -0.070571435266337_REALK,      0.000000000000000_REALK,     -0.613137883628496_REALK, &
      0.000000000000000_REALK,     -4.290169148511706_REALK,      0.000000000000000_REALK, &
     -1.149697155784554_REALK,      0.000000000000000_REALK,    -12.758824396011621_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.230222977691807_REALK, &
      0.000000000000000_REALK,     -2.614157520545937_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.695312592643981_REALK,      0.000000000000000_REALK, &
     -1.403080532039515_REALK,      0.000000000000000_REALK,     -9.465507327657406_REALK, &
      0.000000000000000_REALK,     -2.590919969547949_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.050829703338274_REALK, &
      0.000000000000000_REALK,     -1.245932843966685_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.612944616738928_REALK,      0.000000000000000_REALK, &
      2.599437630362599_REALK,      0.000000000000000_REALK,     -5.925289654755172_REALK, &
      0.000000000000000_REALK,      5.747426229418915_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.938493923825760_REALK, &
      0.000000000000000_REALK,      0.660884497522678_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.184279872609440_REALK,      0.000000000000000_REALK, &
      8.568495556841087_REALK,      0.000000000000000_REALK,      0.627325240385276_REALK, &
      0.000000000000000_REALK,      1.295100421718040_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      7.489126170549058_REALK, &
      0.000000000000000_REALK,      0.310351609617659_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.183365290545023_REALK,      0.000000000000000_REALK, &
      7.015937767898882_REALK,      0.000000000000000_REALK,     -1.267582097032667_REALK, &
      0.000000000000000_REALK,      0.567078669705466_REALK,      0.000000000000000_REALK, &
     13.862764357589402_REALK,      2.366511211643798_REALK,      0.000000000000000_REALK, &
      3.406395771061145_REALK,      0.000000000000000_REALK,      0.215711645289891_REALK, &
      1.726724602586625_REALK,      0.000000000000000_REALK,      0.044676084358294_REALK, &
      0.000000000000000_REALK,      5.842891265510258_REALK,      0.000000000000000_REALK, &
      0.131461715241602_REALK,      0.000000000000000_REALK,     -6.309468164992651_REALK, &
      7.110127558109665_REALK,      1.324976908817734_REALK,      0.000000000000000_REALK, &
      1.654334017352063_REALK,      0.000000000000000_REALK,     -2.044772781070226_REALK, &
      1.499640454634223_REALK,      0.000000000000000_REALK,     -0.525460650174332_REALK, &
      0.000000000000000_REALK,      5.372505528510194_REALK,      0.000000000000000_REALK, &
     -1.279645925382504_REALK,      0.000000000000000_REALK,    -10.414426594942300_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.418017794505351_REALK, &
      0.000000000000000_REALK,     -1.364356411299562_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.394583777503472_REALK,      0.000000000000000_REALK, &
     -1.260926146221404_REALK,      0.000000000000000_REALK,     -2.392536599945948_REALK, &
      0.000000000000000_REALK,     -1.028918131573025_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.248724691488137_REALK, &
      0.000000000000000_REALK,     -0.424102060342178_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.293829282795217_REALK,      0.000000000000000_REALK, &
      1.900074883189670_REALK,      0.000000000000000_REALK,      0.037757897228790_REALK, &
      0.000000000000000_REALK,      1.258662024170217_REALK,      0.000000000000000_REALK, &
      6.396083635244228_REALK,      3.153964917676612_REALK,      0.000000000000000_REALK, &
      3.736054652831021_REALK,      0.000000000000000_REALK,      3.468676064307995_REALK, &
      4.250715971255789_REALK,      0.000000000000000_REALK,      2.075148847524941_REALK, &
      0.000000000000000_REALK,     12.973452552935328_REALK,      0.000000000000000_REALK, &
      5.025083346895787_REALK,      0.000000000000000_REALK,      6.152075405169786_REALK, &
      8.297205981997802_REALK,      4.915424570243187_REALK,      0.000000000000000_REALK, &
      5.680829009258998_REALK,      0.000000000000000_REALK,      1.371616829398005_REALK, &
      7.710831870036226_REALK,      0.000000000000000_REALK,      1.120536984342241_REALK, &
      0.000000000000000_REALK,     22.012780662181758_REALK,      0.000000000000000_REALK, &
      2.525873552679482_REALK,      0.000000000000000_REALK,     -8.811528392452498_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     14.194671285559910_REALK, &
      0.000000000000000_REALK,     -0.711119768644262_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.754737938637817_REALK,      0.000000000000000_REALK, &
     11.186308444031617_REALK,      0.000000000000000_REALK,     -1.038142047130075_REALK, &
      0.000000000000000_REALK,     -1.020550480324381_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     10.388873070279386_REALK, &
      0.000000000000000_REALK,     -0.705255036607761_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.522109715492408_REALK,      0.000000000000000_REALK, &
     10.546333846487514_REALK,      0.000000000000000_REALK,      0.027578505591138_REALK, &
      0.000000000000000_REALK,     -1.004988404772980_REALK,      0.000000000000000_REALK, &
     21.438772882693332_REALK,      1.138706789925853_REALK,      0.000000000000000_REALK, &
      3.480907193101661_REALK,      0.000000000000000_REALK,      0.268915011152862_REALK, &
      0.434673013008501_REALK,      0.000000000000000_REALK,      0.017672568350060_REALK, &
      0.000000000000000_REALK,      3.575666947802675_REALK,      0.000000000000000_REALK, &
      0.098380832518899_REALK,      0.000000000000000_REALK,     -5.760339325620707_REALK, &
      5.569781389173433_REALK,      0.268348972825676_REALK,      0.000000000000000_REALK, &
      1.040871318189451_REALK,      0.000000000000000_REALK,     -2.612409480779787_REALK, &
     -0.608927793021711_REALK,      0.000000000000000_REALK,     -0.115321510010960_REALK, &
      0.000000000000000_REALK,     -1.360514245108708_REALK,      0.000000000000000_REALK, &
     -0.627898151484137_REALK,      0.000000000000000_REALK,    -10.376648460273982_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.526844832563594_REALK, &
      0.000000000000000_REALK,     -0.867151409277285_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.109442712251537_REALK,      0.000000000000000_REALK, &
     -1.372878687060331_REALK,      0.000000000000000_REALK,     -0.947242025480361_REALK, &
      0.000000000000000_REALK,     -0.478918681341796_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.366801029056801_REALK, &
      0.000000000000000_REALK,     -0.357299756431006_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.475219031465954_REALK,      0.000000000000000_REALK, &
      2.253656950457882_REALK,      0.000000000000000_REALK,     -0.615136973921593_REALK, &
      0.000000000000000_REALK,      0.826983818433818_REALK,      0.000000000000000_REALK, &
      7.564712593227414_REALK,      2.169185638991086_REALK,      0.000000000000000_REALK, &
      2.050743333120071_REALK,      0.000000000000000_REALK,      3.306994053594782_REALK, &
      1.529716830124717_REALK,      0.000000000000000_REALK,      1.173303427983043_REALK, &
      0.000000000000000_REALK,      2.959979076728517_REALK,      0.000000000000000_REALK, &
      2.020017893758791_REALK,      0.000000000000000_REALK,      4.295415499147782_REALK, &
      3.655678869303805_REALK,      1.443479611873005_REALK,      0.000000000000000_REALK, &
      1.017343527773758_REALK,      0.000000000000000_REALK,      0.985608431556380_REALK, &
     -0.071398951949744_REALK,      0.000000000000000_REALK,      0.356577805143891_REALK, &
      0.000000000000000_REALK,     -2.290080496137787_REALK,      0.000000000000000_REALK, &
      0.352771149055396_REALK,      0.000000000000000_REALK,     -4.937969405406972_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.819667664217444_REALK, &
      0.000000000000000_REALK,     -2.666861230118344_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.807890639561933_REALK,      0.000000000000000_REALK, &
     -4.642775351410659_REALK,      0.000000000000000_REALK,     -5.380927731369615_REALK, &
      0.000000000000000_REALK,     -4.678334647088954_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -5.282818041655046_REALK, &
      0.000000000000000_REALK,     -4.390270931794375_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -5.404906903038664_REALK,      0.000000000000000_REALK, &
     -1.856330013008660_REALK,      0.000000000000000_REALK,    -10.475910844356815_REALK, &
      0.000000000000000_REALK,     -2.165522179259488_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     28.603262281537578_REALK, &
      0.000000000000000_REALK,     -3.691004292930422_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      4.570159220341038_REALK,      0.000000000000000_REALK, &
     17.055125402755568_REALK,      0.000000000000000_REALK,     -3.048186309302981_REALK, &
      0.000000000000000_REALK,     -3.652868820549558_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     58.242868377715425_REALK, &
      0.000000000000000_REALK,     -8.013561664549341_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      6.250262332117493_REALK,      0.000000000000000_REALK, &
     27.407341925148941_REALK,      0.000000000000000_REALK,     -5.212615519884456_REALK, &
      0.000000000000000_REALK,     -5.494702088688609_REALK,      0.000000000000000_REALK, &
     46.140018725283639_REALK,     -1.711571880647155_REALK,      0.000000000000000_REALK, &
      5.349929302889438_REALK,      0.000000000000000_REALK,      0.427839474639156_REALK, &
     -1.038142047130074_REALK,      0.000000000000000_REALK,     -0.020098368321487_REALK, &
      0.000000000000000_REALK,      3.966778873944783_REALK,      0.000000000000000_REALK, &
      0.104271081599395_REALK,      0.000000000000000_REALK,     -6.319921156955286_REALK, &
     54.363580970309378_REALK,     -2.135683480002585_REALK,      0.000000000000000_REALK, &
      4.925712710583966_REALK,      0.000000000000000_REALK,     -8.719346297380254_REALK, &
      0.027578505591138_REALK,      0.000000000000000_REALK,      0.425440038621845_REALK, &
      0.000000000000000_REALK,      4.632810681434027_REALK,      0.000000000000000_REALK, &
     -1.429765963876433_REALK,      0.000000000000000_REALK,    -16.664929939895874_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -7.883210222978841_REALK, &
      0.000000000000000_REALK,     -0.418025807283314_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.198246487973320_REALK,      0.000000000000000_REALK, &
     -1.808912504668341_REALK,      0.000000000000000_REALK,     -0.200392718655306_REALK, &
      0.000000000000000_REALK,     -0.159209040344163_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -6.115701075662538_REALK, &
      0.000000000000000_REALK,     -0.174112411294617_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.485404179128565_REALK,      0.000000000000000_REALK, &
      4.674335164663063_REALK,      0.000000000000000_REALK,      0.266858525856788_REALK, &
      0.000000000000000_REALK,      0.193908896465505_REALK,      0.000000000000000_REALK, &
     13.577836474822535_REALK,      1.925882842483814_REALK,      0.000000000000000_REALK, &
      1.988177585953375_REALK,      0.000000000000000_REALK,      4.387928265536995_REALK, &
      0.874064529949689_REALK,      0.000000000000000_REALK,      0.788172687688949_REALK, &
      0.000000000000000_REALK,      1.722263186915964_REALK,      0.000000000000000_REALK, &
      1.350507088722829_REALK,      0.000000000000000_REALK,      3.930330498956179_REALK, &
     28.153944490788799_REALK,      4.259099134771568_REALK,      0.000000000000000_REALK, &
      3.653366690299654_REALK,      0.000000000000000_REALK,      2.595663500803065_REALK, &
      2.421397940066253_REALK,      0.000000000000000_REALK,      0.487699701841256_REALK, &
      0.000000000000000_REALK,      4.452215668766012_REALK,      0.000000000000000_REALK, &
      0.609568352060083_REALK,      0.000000000000000_REALK,     -6.257431268279476_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -6.418784700305595_REALK, &
      0.000000000000000_REALK,     -1.837575094995215_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.629004261182363_REALK,      0.000000000000000_REALK, &
     -4.678334647088953_REALK,      0.000000000000000_REALK,     -1.627374461151853_REALK, &
      0.000000000000000_REALK,     -2.222970754208198_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,    -13.294806297120488_REALK, &
      0.000000000000000_REALK,     -3.102032350619078_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.571375479030702_REALK,      0.000000000000000_REALK, &
     -2.165522179259488_REALK,      0.000000000000000_REALK,      0.103636562222921_REALK, &
      0.000000000000000_REALK,     -0.736243289846043_REALK,      0.000000000000000_REALK, &
     10.441036558855576_REALK,      4.277863330953822_REALK,      0.000000000000000_REALK, &
      3.634310583128717_REALK,      0.000000000000000_REALK,      6.651611141368908_REALK, &
      3.586173162568094_REALK,      0.000000000000000_REALK,      3.451220547148150_REALK, &
      0.000000000000000_REALK,      6.373471261569045_REALK,      0.000000000000000_REALK, &
      4.866514525600905_REALK,      0.000000000000000_REALK,     11.799513835596789_REALK, &
     54.757357196160896_REALK,     26.334145139729308_REALK,      0.000000000000000_REALK, &
     20.908868521539588_REALK,      0.000000000000000_REALK,     18.879254141152025_REALK, &
     20.750520953878652_REALK,      0.000000000000000_REALK,     11.276833788138577_REALK, &
      0.000000000000000_REALK,     30.403457771298079_REALK,      0.000000000000000_REALK, &
     13.046466129844347_REALK,      0.000000000000000_REALK,      5.089808587914938_REALK/
    ! results of test 6, ket-major order, dd/dxdx
  data REF_CONTR_INTS(32761:34020)                                                         &
    /22.976453154765636_REALK,     25.552557574398254_REALK,      0.000000000000000_REALK, &
     28.336591636788530_REALK,      0.000000000000000_REALK,      4.453741970414122_REALK, &
     33.410776519438578_REALK,      0.000000000000000_REALK,      3.995346248791821_REALK, &
      0.000000000000000_REALK,    -40.416281193170718_REALK,      0.000000000000000_REALK, &
     -4.022289893740162_REALK,      0.000000000000000_REALK,     -1.896583916641437_REALK, &
     -0.550670769874400_REALK,     10.039206003354245_REALK,      0.000000000000000_REALK, &
     23.596480932393998_REALK,      0.000000000000000_REALK,      2.844776308586867_REALK, &
     46.317403098842242_REALK,      0.000000000000000_REALK,      4.499163425044945_REALK, &
      0.000000000000000_REALK,      7.878716003769786_REALK,      0.000000000000000_REALK, &
      0.653642710752754_REALK,      0.000000000000000_REALK,      0.236408213134510_REALK, &
     19.138966393053778_REALK,     13.289547923230471_REALK,      0.000000000000000_REALK, &
      9.673652568901819_REALK,      0.000000000000000_REALK,      2.454203526781816_REALK, &
      5.763859931540241_REALK,      0.000000000000000_REALK,      1.100817161483838_REALK, &
      0.000000000000000_REALK,    -12.737332956210770_REALK,      0.000000000000000_REALK, &
     -2.141602573153092_REALK,      0.000000000000000_REALK,     -1.629972303810162_REALK, &
     -7.327059089661710_REALK,      0.547960545049359_REALK,      0.000000000000000_REALK, &
      2.163956034305702_REALK,      0.000000000000000_REALK,      0.881610294540905_REALK, &
      0.430765157282204_REALK,      0.000000000000000_REALK,      0.774398467657816_REALK, &
      0.000000000000000_REALK,      0.474282928407986_REALK,      0.000000000000000_REALK, &
     -0.057449217866681_REALK,      0.000000000000000_REALK,     -0.070215597380434_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.874086020245659_REALK, &
      0.000000000000000_REALK,     -2.970514553203873_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.041722912970878_REALK,      0.000000000000000_REALK, &
     -0.962710033656520_REALK,      0.000000000000000_REALK,      5.499360953151937_REALK, &
      0.000000000000000_REALK,      1.972883013552031_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.365764706556662_REALK, &
      0.000000000000000_REALK,     -2.574355249217485_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -4.287618239824210_REALK,      0.000000000000000_REALK, &
     -1.550737352386979_REALK,      0.000000000000000_REALK,      0.703585042159742_REALK, &
      0.000000000000000_REALK,      0.205033780586002_REALK,      0.000000000000000_REALK, &
     20.432615416748888_REALK,      9.342333872941900_REALK,      0.000000000000000_REALK, &
      4.624384203095141_REALK,      0.000000000000000_REALK,      1.547162273953858_REALK, &
      0.625553852450734_REALK,      0.000000000000000_REALK,      0.140083440301686_REALK, &
      0.000000000000000_REALK,     -9.568653513810245_REALK,      0.000000000000000_REALK, &
     -1.711102624258971_REALK,      0.000000000000000_REALK,     -1.717430890805976_REALK, &
      6.895822220438964_REALK,      6.045854096760598_REALK,      0.000000000000000_REALK, &
      5.658956889783899_REALK,      0.000000000000000_REALK,      1.419274139167761_REALK, &
      5.291041281769185_REALK,      0.000000000000000_REALK,      0.768600571613231_REALK, &
      0.000000000000000_REALK,     -1.450658075547764_REALK,      0.000000000000000_REALK, &
     -0.135320621537393_REALK,      0.000000000000000_REALK,     -0.101815791700507_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.566047857542892_REALK, &
      0.000000000000000_REALK,     -1.138836079217169_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.151661754793793_REALK,      0.000000000000000_REALK, &
     -0.115429661394724_REALK,      0.000000000000000_REALK,      2.206386506224024_REALK, &
      0.000000000000000_REALK,      1.264167498741802_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.768733091881972_REALK, &
      0.000000000000000_REALK,     -1.145913680807767_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.551921258481012_REALK,      0.000000000000000_REALK, &
     -0.674569338108964_REALK,      0.000000000000000_REALK,      0.015242478310692_REALK, &
      0.000000000000000_REALK,      0.082205477724198_REALK,      0.000000000000000_REALK, &
      4.384381769004844_REALK,      3.105888497782456_REALK,      0.000000000000000_REALK, &
      2.112237888734759_REALK,      0.000000000000000_REALK,      0.995959146089781_REALK, &
      0.389447950266292_REALK,      0.000000000000000_REALK,      0.139713550772232_REALK, &
      0.000000000000000_REALK,     -7.853223539376752_REALK,      0.000000000000000_REALK, &
     -2.344694321929969_REALK,      0.000000000000000_REALK,     -1.842611073911549_REALK, &
      3.716414788542235_REALK,      5.164807339190797_REALK,      0.000000000000000_REALK, &
      6.344589515983516_REALK,      0.000000000000000_REALK,      2.294698687633591_REALK, &
      6.759422605515302_REALK,      0.000000000000000_REALK,      1.969783165277457_REALK, &
      0.000000000000000_REALK,     -1.828715523000136_REALK,      0.000000000000000_REALK, &
     -0.455147731334971_REALK,      0.000000000000000_REALK,     -0.274361564065100_REALK, &
     20.324977562806836_REALK,      5.868175209875972_REALK,      0.000000000000000_REALK, &
      1.259078920677537_REALK,      0.000000000000000_REALK,      0.577090830204862_REALK, &
     -1.740070937354327_REALK,      0.000000000000000_REALK,     -0.503645642854498_REALK, &
      0.000000000000000_REALK,     -6.272186574403805_REALK,      0.000000000000000_REALK, &
     -1.525422663312725_REALK,      0.000000000000000_REALK,     -2.097503381386308_REALK, &
      1.499802447640728_REALK,      2.193896343419848_REALK,      0.000000000000000_REALK, &
      1.194920185410272_REALK,      0.000000000000000_REALK,      0.842074938542977_REALK, &
     -0.022745256436023_REALK,      0.000000000000000_REALK,      0.232564528811054_REALK, &
      0.000000000000000_REALK,      1.379720895319034_REALK,      0.000000000000000_REALK, &
     -0.136402020871908_REALK,      0.000000000000000_REALK,     -0.288372540890870_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.761322898919271_REALK, &
      0.000000000000000_REALK,     -0.315456738271466_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.451834129115479_REALK,      0.000000000000000_REALK, &
      0.453505172548841_REALK,      0.000000000000000_REALK,      1.706691218420259_REALK, &
      0.000000000000000_REALK,      1.146564007906014_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.001419859516284_REALK, &
      0.000000000000000_REALK,     -0.746560406956829_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.423266276310566_REALK,      0.000000000000000_REALK, &
     -0.318467285570201_REALK,      0.000000000000000_REALK,      0.586661121090821_REALK, &
      0.000000000000000_REALK,      0.255663138313046_REALK,      0.000000000000000_REALK, &
      3.051652499694069_REALK,      1.296475552829091_REALK,      0.000000000000000_REALK, &
      0.341530179332701_REALK,      0.000000000000000_REALK,      0.259938393895377_REALK, &
     -0.582618898129278_REALK,      0.000000000000000_REALK,     -0.333816343188337_REALK, &
      0.000000000000000_REALK,     -2.460967900402824_REALK,      0.000000000000000_REALK, &
     -1.241330945670218_REALK,      0.000000000000000_REALK,     -1.574626937999026_REALK, &
      0.389002962390867_REALK,      0.808540567029004_REALK,      0.000000000000000_REALK, &
      0.536094526282833_REALK,      0.000000000000000_REALK,      0.655225585536837_REALK, &
      0.047676599198360_REALK,      0.000000000000000_REALK,      0.257128633118476_REALK, &
      0.000000000000000_REALK,      0.505215483807944_REALK,      0.000000000000000_REALK, &
     -0.183588103179225_REALK,      0.000000000000000_REALK,     -0.373975162046148_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.133821370859210_REALK, &
      0.000000000000000_REALK,     -0.314623776543576_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.619140489863978_REALK,      0.000000000000000_REALK, &
      0.486560278779257_REALK,      0.000000000000000_REALK,      3.187578787088979_REALK, &
      0.000000000000000_REALK,      1.905894186912232_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.619107101288915_REALK, &
      0.000000000000000_REALK,     -1.913298240722951_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.423646176204720_REALK,      0.000000000000000_REALK, &
     -0.858169259535129_REALK,      0.000000000000000_REALK,      2.248417787255832_REALK, &
      0.000000000000000_REALK,      1.092030035778796_REALK,      0.000000000000000_REALK, &
     25.375720810462930_REALK,      2.814691004897637_REALK,      0.000000000000000_REALK, &
     -1.728095855619550_REALK,      0.000000000000000_REALK,     -1.037004933414672_REALK, &
     -3.620801896115735_REALK,      0.000000000000000_REALK,     -1.218045365502081_REALK, &
      0.000000000000000_REALK,     -6.253341377854972_REALK,      0.000000000000000_REALK, &
     -1.680918891802193_REALK,      0.000000000000000_REALK,     -3.026084191684830_REALK, &
     25.955194579081532_REALK,      9.802333176008977_REALK,      0.000000000000000_REALK, &
      5.122365405084239_REALK,      0.000000000000000_REALK,      2.422428271000757_REALK, &
      2.335430941025477_REALK,      0.000000000000000_REALK,      0.454394957191880_REALK, &
      0.000000000000000_REALK,     -2.711586122148097_REALK,      0.000000000000000_REALK, &
     -0.264490781743267_REALK,      0.000000000000000_REALK,     -0.375242625103262_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.947348283031336_REALK, &
      0.000000000000000_REALK,      0.419743227179941_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.894439953471535_REALK,      0.000000000000000_REALK, &
      1.229882623337517_REALK,      0.000000000000000_REALK,      1.410602012777336_REALK, &
      0.000000000000000_REALK,      1.224852749883767_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.611690102114000_REALK, &
      0.000000000000000_REALK,     -1.110806346314156_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.237576060980876_REALK,      0.000000000000000_REALK, &
     -0.502268308944162_REALK,      0.000000000000000_REALK,     -0.005609519968640_REALK, &
      0.000000000000000_REALK,      0.172067794271609_REALK,      0.000000000000000_REALK, &
      3.082883910831469_REALK,      0.517851581987624_REALK,      0.000000000000000_REALK, &
     -0.376563002570758_REALK,      0.000000000000000_REALK,     -0.377955666586477_REALK, &
     -1.000727765955016_REALK,      0.000000000000000_REALK,     -0.672294100873306_REALK, &
      0.000000000000000_REALK,     -2.048289549742250_REALK,      0.000000000000000_REALK, &
     -1.098848532475672_REALK,      0.000000000000000_REALK,     -1.838187442446964_REALK, &
      5.432651052575214_REALK,      3.202024794968489_REALK,      0.000000000000000_REALK, &
      2.021661980484235_REALK,      0.000000000000000_REALK,      1.521106781474098_REALK, &
      1.021807722410999_REALK,      0.000000000000000_REALK,      0.445297224705060_REALK, &
      0.000000000000000_REALK,     -1.119050290796602_REALK,      0.000000000000000_REALK, &
     -0.313162522791630_REALK,      0.000000000000000_REALK,     -0.392707948312068_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.426713054967952_REALK, &
      0.000000000000000_REALK,      0.278205820229360_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.727861215118466_REALK,      0.000000000000000_REALK, &
      0.923291150073950_REALK,      0.000000000000000_REALK,      1.416913597153980_REALK, &
      0.000000000000000_REALK,      1.353054049380841_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.810286417061521_REALK, &
      0.000000000000000_REALK,     -1.228132763613054_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.319761673012381_REALK,      0.000000000000000_REALK, &
     -0.651365319484843_REALK,      0.000000000000000_REALK,      0.035274542099661_REALK, &
      0.000000000000000_REALK,      0.317070112188915_REALK,      0.000000000000000_REALK, &
      1.984553578519589_REALK,      0.516484197823042_REALK,      0.000000000000000_REALK, &
     -0.515997767438949_REALK,      0.000000000000000_REALK,     -0.405504116892318_REALK, &
     -1.869054322176553_REALK,      0.000000000000000_REALK,     -1.117531520189539_REALK, &
      0.000000000000000_REALK,     -5.043241147026312_REALK,      0.000000000000000_REALK, &
     -2.509555221127837_REALK,      0.000000000000000_REALK,     -2.761037068632068_REALK, &
      8.783572459106194_REALK,      8.206205887528061_REALK,      0.000000000000000_REALK, &
      6.799812574680650_REALK,      0.000000000000000_REALK,      4.098904783875335_REALK, &
      3.916146094618383_REALK,      0.000000000000000_REALK,      1.902026030954232_REALK, &
      0.000000000000000_REALK,     -4.232061308502706_REALK,      0.000000000000000_REALK, &
     -1.755524646679717_REALK,      0.000000000000000_REALK,     -1.481514322761211_REALK, &
    -49.157545792127813_REALK,    -16.679786077423604_REALK,      0.000000000000000_REALK, &
    -11.546791803298028_REALK,      0.000000000000000_REALK,     -9.100739374484640_REALK, &
     -7.578797732213901_REALK,      0.000000000000000_REALK,     -3.061172497961310_REALK, &
      0.000000000000000_REALK,     -7.157372642327362_REALK,      0.000000000000000_REALK, &
     -2.444137975960639_REALK,      0.000000000000000_REALK,     -5.779128027963128_REALK, &
     69.455030850056644_REALK,      7.763525697847579_REALK,      0.000000000000000_REALK, &
      0.208349585104272_REALK,      0.000000000000000_REALK,      0.256843434181919_REALK, &
      0.486831969626006_REALK,      0.000000000000000_REALK,     -0.673521051529222_REALK, &
      0.000000000000000_REALK,      7.243496453357262_REALK,      0.000000000000000_REALK, &
     -0.584128773162584_REALK,      0.000000000000000_REALK,     -2.160258298980501_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.652479334468781_REALK, &
      0.000000000000000_REALK,      2.770587765206691_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.034547655222911_REALK,      0.000000000000000_REALK, &
      3.662706467709803_REALK,      0.000000000000000_REALK,      1.743321941074762_REALK, &
      0.000000000000000_REALK,      1.759371491587674_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.210082009772103_REALK, &
      0.000000000000000_REALK,     -0.110661370713985_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.772329039901908_REALK,      0.000000000000000_REALK, &
      1.095731104373929_REALK,      0.000000000000000_REALK,      1.594577131477581_REALK, &
      0.000000000000000_REALK,      0.930750459800047_REALK,      0.000000000000000_REALK, &
     -5.036912127519197_REALK,     -2.692690318649824_REALK,      0.000000000000000_REALK, &
     -2.034509109419573_REALK,      0.000000000000000_REALK,     -2.797513003511702_REALK, &
     -1.707361986081226_REALK,      0.000000000000000_REALK,     -1.482535119584228_REALK, &
      0.000000000000000_REALK,     -1.770731839986350_REALK,      0.000000000000000_REALK, &
     -1.291948723458392_REALK,      0.000000000000000_REALK,     -2.960782478200442_REALK, &
     11.025855712725983_REALK,      1.930536342785460_REALK,      0.000000000000000_REALK, &
      0.057858240151797_REALK,      0.000000000000000_REALK,      0.122320238493504_REALK, &
      0.016380136741005_REALK,      0.000000000000000_REALK,     -0.502448340437156_REALK, &
      0.000000000000000_REALK,      1.640784769404769_REALK,      0.000000000000000_REALK, &
     -0.486633983268567_REALK,      0.000000000000000_REALK,     -1.714684740274537_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.424619382506341_REALK, &
      0.000000000000000_REALK,      1.529212181462901_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.330022356281901_REALK,      0.000000000000000_REALK, &
      2.224902087263096_REALK,      0.000000000000000_REALK,      1.445473175406511_REALK, &
      0.000000000000000_REALK,      1.618460620787993_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.643621845191239_REALK, &
      0.000000000000000_REALK,     -0.108445748530142_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.914453460218093_REALK,      0.000000000000000_REALK, &
      1.146730901858466_REALK,      0.000000000000000_REALK,      2.092998596064242_REALK, &
      0.000000000000000_REALK,      1.520192181134113_REALK,      0.000000000000000_REALK, &
     -2.268770841766279_REALK,     -1.784715202569518_REALK,      0.000000000000000_REALK, &
     -1.655606132982124_REALK,      0.000000000000000_REALK,     -2.100134557027821_REALK, &
     -1.715001390490844_REALK,      0.000000000000000_REALK,     -1.637707183245581_REALK, &
      0.000000000000000_REALK,     -2.084303854836393_REALK,      0.000000000000000_REALK, &
     -1.752231222225366_REALK,      0.000000000000000_REALK,     -3.111784726901376_REALK, &
      8.579310979039244_REALK,      2.134444893826702_REALK,      0.000000000000000_REALK, &
      0.077873366500423_REALK,      0.000000000000000_REALK,      0.158630675690592_REALK, &
     -0.103003791108513_REALK,      0.000000000000000_REALK,     -0.925863857010166_REALK, &
      0.000000000000000_REALK,      1.802429478118163_REALK,      0.000000000000000_REALK, &
     -1.091628620550574_REALK,      0.000000000000000_REALK,     -3.113158077636996_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.601345153475226_REALK, &
      0.000000000000000_REALK,      2.541957175621045_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.037511039764609_REALK,      0.000000000000000_REALK, &
      3.341899196543723_REALK,      0.000000000000000_REALK,      4.499505223423653_REALK, &
      0.000000000000000_REALK,      3.766436530966592_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -7.123730141752858_REALK, &
      0.000000000000000_REALK,     -0.463211143494700_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      5.126237882310606_REALK,      0.000000000000000_REALK, &
      4.326111204925647_REALK,      0.000000000000000_REALK,     13.369260671141360_REALK, &
      0.000000000000000_REALK,      9.090609409208481_REALK,      0.000000000000000_REALK, &
    -34.523199273162163_REALK,      2.970417776140346_REALK,      0.000000000000000_REALK, &
     -6.769547330850443_REALK,      0.000000000000000_REALK,     -3.052366851461227_REALK, &
     24.156404955935148_REALK,      0.000000000000000_REALK,      5.727248732922977_REALK, &
      0.000000000000000_REALK,     85.757632179306512_REALK,      0.000000000000000_REALK, &
     16.131957144552256_REALK,      0.000000000000000_REALK,     21.821540864109039_REALK, &
    -27.721747497321051_REALK,     -2.275112545411857_REALK,      0.000000000000000_REALK, &
    -20.177427248468799_REALK,      0.000000000000000_REALK,     -6.673521202986212_REALK, &
     16.458003073924608_REALK,      0.000000000000000_REALK,      3.276198955711080_REALK, &
      0.000000000000000_REALK,     64.276708002090288_REALK,      0.000000000000000_REALK, &
     10.103189338641400_REALK,      0.000000000000000_REALK,     10.024644981583201_REALK, &
    -12.408501807423928_REALK,      3.795505488217402_REALK,      0.000000000000000_REALK, &
      0.837963504534937_REALK,      0.000000000000000_REALK,      0.656256754937705_REALK, &
      9.278747207767585_REALK,      0.000000000000000_REALK,      3.456330105465063_REALK, &
      0.000000000000000_REALK,     12.976266579090625_REALK,      0.000000000000000_REALK, &
      4.300737254399054_REALK,      0.000000000000000_REALK,     10.104453925990549_REALK, &
    -21.117167801420848_REALK,     -1.953541794643133_REALK,      0.000000000000000_REALK, &
     -1.727680444277572_REALK,      0.000000000000000_REALK,     -2.292811586996219_REALK, &
     -0.152445494983831_REALK,      0.000000000000000_REALK,      1.042906158539085_REALK, &
      0.000000000000000_REALK,     -4.329035377778212_REALK,      0.000000000000000_REALK, &
      0.913485406028857_REALK,      0.000000000000000_REALK,      3.636870343295519_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.389306303018977_REALK, &
      0.000000000000000_REALK,     -0.308742237005703_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -4.825477775635197_REALK,      0.000000000000000_REALK, &
     -6.527376655313823_REALK,      0.000000000000000_REALK,     -6.683440864367983_REALK, &
      0.000000000000000_REALK,     -4.753736529732972_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.495467601348495_REALK, &
      0.000000000000000_REALK,      2.602323860052269_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -4.027960529706458_REALK,      0.000000000000000_REALK, &
     -3.996646302143528_REALK,      0.000000000000000_REALK,     -6.912042680354246_REALK, &
      0.000000000000000_REALK,     -4.127820412262259_REALK,      0.000000000000000_REALK, &
      2.546524270810317_REALK,      3.290135588632164_REALK,      0.000000000000000_REALK, &
      2.654229054775127_REALK,      0.000000000000000_REALK,      2.844915170819238_REALK, &
      4.121038918991559_REALK,      0.000000000000000_REALK,      1.804725593603882_REALK, &
      0.000000000000000_REALK,      3.375181401399910_REALK,      0.000000000000000_REALK, &
      1.285348944589193_REALK,      0.000000000000000_REALK,      4.133074391993003_REALK, &
     -4.422304948051138_REALK,      0.446733490414333_REALK,      0.000000000000000_REALK, &
      0.188555873410582_REALK,      0.000000000000000_REALK,      0.183511530492037_REALK, &
      3.177561477893233_REALK,      0.000000000000000_REALK,      0.876694839266612_REALK, &
      0.000000000000000_REALK,      4.057713981291757_REALK,      0.000000000000000_REALK, &
      0.761019553082866_REALK,      0.000000000000000_REALK,      2.221981109278424_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.106837748379205_REALK, &
      0.000000000000000_REALK,     -0.695040568308410_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.176041994493146_REALK,      0.000000000000000_REALK, &
     -5.112545773840570_REALK,      0.000000000000000_REALK,     -0.903580665392834_REALK, &
      0.000000000000000_REALK,     -1.009750450114310_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.486728758487187_REALK, &
      0.000000000000000_REALK,     -0.055881409707647_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.719750533589514_REALK,      0.000000000000000_REALK, &
     -2.865551384736778_REALK,      0.000000000000000_REALK,      0.032967989752836_REALK, &
      0.000000000000000_REALK,     -0.676619264180941_REALK,      0.000000000000000_REALK, &
      0.391643441263216_REALK,      1.461641391469429_REALK,      0.000000000000000_REALK, &
      0.970365304585341_REALK,      0.000000000000000_REALK,      1.312603669683896_REALK, &
      3.381617413084323_REALK,      0.000000000000000_REALK,      2.405245823579262_REALK, &
      0.000000000000000_REALK,      2.498064387351304_REALK,      0.000000000000000_REALK, &
      1.409740449345367_REALK,      0.000000000000000_REALK,      3.178236894168572_REALK, &
     -1.720211757539069_REALK,      0.552433470228670_REALK,      0.000000000000000_REALK, &
      0.215827772042371_REALK,      0.000000000000000_REALK,      0.214149880732789_REALK, &
      5.446114819727405_REALK,      0.000000000000000_REALK,      3.252379211183144_REALK, &
      0.000000000000000_REALK,      5.541893962760473_REALK,      0.000000000000000_REALK, &
      2.613270299964114_REALK,      0.000000000000000_REALK,      4.321590295231544_REALK, &
     16.652675022674917_REALK,      1.509938135154704_REALK,      0.000000000000000_REALK, &
      3.262954413109396_REALK,      0.000000000000000_REALK,      4.266640421785365_REALK, &
      0.739739099975139_REALK,      0.000000000000000_REALK,      0.509058862752353_REALK, &
      0.000000000000000_REALK,     -0.378543575805070_REALK,      0.000000000000000_REALK, &
     -0.176287593573414_REALK,      0.000000000000000_REALK,     -0.691541171624435_REALK, &
    -12.739102033541631_REALK,     -0.044642634979898_REALK,      0.000000000000000_REALK, &
      0.357333444000870_REALK,      0.000000000000000_REALK,      0.706186338664826_REALK, &
     -0.939709038930561_REALK,      0.000000000000000_REALK,      0.140132659639799_REALK, &
      0.000000000000000_REALK,     -0.418091407906472_REALK,      0.000000000000000_REALK, &
      0.151935335996020_REALK,      0.000000000000000_REALK,      0.900794429758817_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.924477795811193_REALK, &
      0.000000000000000_REALK,     -0.531437896488534_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.234411056628620_REALK,      0.000000000000000_REALK, &
     -3.969282231740877_REALK,      0.000000000000000_REALK,      0.065562997692427_REALK, &
      0.000000000000000_REALK,      0.086135963955810_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.262866526495913_REALK, &
      0.000000000000000_REALK,     -0.141804316202095_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.847815863680360_REALK,      0.000000000000000_REALK, &
     -2.475403983528401_REALK,      0.000000000000000_REALK,     -0.218534539510121_REALK, &
      0.000000000000000_REALK,     -0.180882199437778_REALK,      0.000000000000000_REALK, &
      1.958642893481484_REALK,      0.958788263879542_REALK,      0.000000000000000_REALK, &
      0.640779509263155_REALK,      0.000000000000000_REALK,      1.505492348188824_REALK, &
      0.867772108587405_REALK,      0.000000000000000_REALK,      0.969734425273289_REALK, &
      0.000000000000000_REALK,     -0.104454272015981_REALK,      0.000000000000000_REALK, &
     -0.103858157421981_REALK,      0.000000000000000_REALK,     -0.406686072810448_REALK, &
     -2.787067263145276_REALK,     -0.080045935130935_REALK,      0.000000000000000_REALK, &
      0.116418767033161_REALK,      0.000000000000000_REALK,      0.463499425860076_REALK, &
     -0.036728076950032_REALK,      0.000000000000000_REALK,      0.753789496630542_REALK, &
      0.000000000000000_REALK,     -0.234583597658422_REALK,      0.000000000000000_REALK, &
      0.148500999128836_REALK,      0.000000000000000_REALK,      0.985381331978564_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.810698613868106_REALK, &
      0.000000000000000_REALK,     -0.708273205384239_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.353872973540816_REALK,      0.000000000000000_REALK, &
     -3.052284579422586_REALK,      0.000000000000000_REALK,      0.161397874911339_REALK, &
      0.000000000000000_REALK,      0.191329334035550_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.306753669084488_REALK, &
      0.000000000000000_REALK,     -0.526068352880403_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.911320750457850_REALK,      0.000000000000000_REALK, &
     -4.814479199360906_REALK,      0.000000000000000_REALK,     -1.123658065338962_REALK, &
      0.000000000000000_REALK,     -1.118400380563905_REALK,      0.000000000000000_REALK, &
     40.409408778482387_REALK,     -1.648197678994810_REALK,      0.000000000000000_REALK, &
      3.342165961180055_REALK,      0.000000000000000_REALK,      4.523902714243984_REALK, &
     -0.761902343730069_REALK,      0.000000000000000_REALK,     -0.249663908390810_REALK, &
      0.000000000000000_REALK,     -3.884998430967213_REALK,      0.000000000000000_REALK, &
     -1.728499150773826_REALK,      0.000000000000000_REALK,     -7.019006916993309_REALK, &
     19.631395959387998_REALK,     -1.399812980647022_REALK,      0.000000000000000_REALK, &
      3.887817487943621_REALK,      0.000000000000000_REALK,      5.419037470918898_REALK, &
      0.028480068882759_REALK,      0.000000000000000_REALK,     -0.345947425126938_REALK, &
      0.000000000000000_REALK,      0.062117938270561_REALK,      0.000000000000000_REALK, &
      0.015095199976364_REALK,      0.000000000000000_REALK,      0.063121369166583_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.963137278856689_REALK, &
      0.000000000000000_REALK,     -0.170734814599458_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.574946874331833_REALK,      0.000000000000000_REALK, &
     -2.255402249459291_REALK,      0.000000000000000_REALK,      0.128313933223753_REALK, &
      0.000000000000000_REALK,      0.264901550794166_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.634036861462448_REALK, &
      0.000000000000000_REALK,     -0.158871730827987_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.579500644719583_REALK,      0.000000000000000_REALK, &
     -3.435744222257286_REALK,      0.000000000000000_REALK,      0.004136506092995_REALK, &
      0.000000000000000_REALK,     -0.001850550254643_REALK,      0.000000000000000_REALK, &
      3.963821136883881_REALK,      0.618191123393457_REALK,      0.000000000000000_REALK, &
      0.414012913464465_REALK,      0.000000000000000_REALK,      1.331269751920393_REALK, &
      0.213828096640211_REALK,      0.000000000000000_REALK,      0.280925062507752_REALK, &
      0.000000000000000_REALK,     -0.562252143910342_REALK,      0.000000000000000_REALK, &
     -0.642356762929917_REALK,      0.000000000000000_REALK,     -3.442525988196000_REALK, &
      3.388918477237929_REALK,      0.930528378157816_REALK,      0.000000000000000_REALK, &
      0.961189019266060_REALK,      0.000000000000000_REALK,      2.806424400796549_REALK, &
      0.833518455133637_REALK,      0.000000000000000_REALK,      0.689907653840545_REALK, &
      0.000000000000000_REALK,      0.019898824356451_REALK,      0.000000000000000_REALK, &
      0.011196004318027_REALK,      0.000000000000000_REALK,      0.054482415493966_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.751252615096827_REALK, &
      0.000000000000000_REALK,     -0.325242205615606_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.338724477277322_REALK,      0.000000000000000_REALK, &
     -1.326371763644736_REALK,      0.000000000000000_REALK,      0.451566987868269_REALK, &
      0.000000000000000_REALK,      0.841042729074837_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.041510869161278_REALK, &
      0.000000000000000_REALK,     -0.854589089491877_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.566401648257237_REALK,      0.000000000000000_REALK, &
     -3.758369397301883_REALK,      0.000000000000000_REALK,      0.000485020068320_REALK, &
      0.000000000000000_REALK,     -0.016590533433607_REALK,      0.000000000000000_REALK, &
      1.828851075635451_REALK,      0.823893462244678_REALK,      0.000000000000000_REALK, &
      0.454079612481199_REALK,      0.000000000000000_REALK,      1.023715094468398_REALK, &
      0.526385333324267_REALK,      0.000000000000000_REALK,      0.624004221408355_REALK, &
      0.000000000000000_REALK,     -1.248414728315155_REALK,      0.000000000000000_REALK, &
     -1.174202947540546_REALK,      0.000000000000000_REALK,     -3.706110002863952_REALK, &
      3.954718734936054_REALK,      3.452091899010348_REALK,      0.000000000000000_REALK, &
      3.300633612532316_REALK,      0.000000000000000_REALK,      5.458289633579261_REALK, &
      4.285774398954480_REALK,      0.000000000000000_REALK,      4.265720922277023_REALK, &
      0.000000000000000_REALK,      0.081531504001131_REALK,      0.000000000000000_REALK, &
      0.064076727604099_REALK,      0.000000000000000_REALK,      0.148350023277354_REALK, &
      1.183697211930913_REALK,      1.201289508604837_REALK,      0.000000000000000_REALK, &
     -4.803707677951391_REALK,      0.000000000000000_REALK,     -5.975564008141713_REALK, &
      2.985343878561420_REALK,      0.000000000000000_REALK,      1.192520017486412_REALK, &
      0.000000000000000_REALK,    -13.787963956527895_REALK,      0.000000000000000_REALK, &
     -5.547783525030296_REALK,      0.000000000000000_REALK,    -20.703467683489663_REALK, &
     61.204799667885283_REALK,     -6.429889720576394_REALK,      0.000000000000000_REALK, &
      2.459973249794003_REALK,      0.000000000000000_REALK,      3.595653238284840_REALK, &
     -0.069892113310385_REALK,      0.000000000000000_REALK,     -0.024558134620675_REALK, &
      0.000000000000000_REALK,     -1.488269368793956_REALK,      0.000000000000000_REALK, &
     -1.871020722001053_REALK,      0.000000000000000_REALK,     -8.204408383535661_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.108813951978479_REALK, &
      0.000000000000000_REALK,     -0.168221204011149_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.813188878372806_REALK,      0.000000000000000_REALK, &
      3.302158615215670_REALK,      0.000000000000000_REALK,     -0.592880568806241_REALK, &
      0.000000000000000_REALK,     -0.582834064897854_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -6.252537144066594_REALK, &
      0.000000000000000_REALK,      0.149645930498532_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.017132938133052_REALK,      0.000000000000000_REALK, &
     -0.071642277975646_REALK,      0.000000000000000_REALK,      0.009370096353675_REALK, &
      0.000000000000000_REALK,     -0.341455709263499_REALK,      0.000000000000000_REALK, &
      0.100343546972676_REALK,     -0.041847306733689_REALK,      0.000000000000000_REALK, &
     -0.387393821020980_REALK,      0.000000000000000_REALK,     -1.519668919624513_REALK, &
     -0.060366511254063_REALK,      0.000000000000000_REALK,     -0.124625456062901_REALK, &
      0.000000000000000_REALK,     -0.960704346313146_REALK,      0.000000000000000_REALK, &
     -1.342198902624695_REALK,      0.000000000000000_REALK,     -8.775298957605274_REALK, &
      8.432610819830902_REALK,      0.183307719032195_REALK,      0.000000000000000_REALK, &
      0.250673677284174_REALK,      0.000000000000000_REALK,      1.486194443869588_REALK, &
     -0.004694903220179_REALK,      0.000000000000000_REALK,      0.002100360583135_REALK, &
      0.000000000000000_REALK,      0.524649661348915_REALK,      0.000000000000000_REALK, &
     -0.571976518075759_REALK,      0.000000000000000_REALK,     -5.651891949710602_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.326295804312615_REALK, &
      0.000000000000000_REALK,      0.189284676974563_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.302202853457182_REALK,      0.000000000000000_REALK, &
      1.619569119173173_REALK,      0.000000000000000_REALK,      0.499176270841288_REALK, &
      0.000000000000000_REALK,      1.093020727801649_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.238079253402872_REALK, &
      0.000000000000000_REALK,     -0.298432262587718_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.012707380466539_REALK,      0.000000000000000_REALK, &
     -0.061837130707706_REALK,      0.000000000000000_REALK,      0.822696209337129_REALK, &
      0.000000000000000_REALK,      1.134916705826045_REALK,      0.000000000000000_REALK, &
      0.035406415170622_REALK,     -0.079717252588864_REALK,      0.000000000000000_REALK, &
     -0.228229381502928_REALK,      0.000000000000000_REALK,     -0.893696876271931_REALK, &
     -0.212443987727960_REALK,      0.000000000000000_REALK,     -0.395676557442210_REALK, &
      0.000000000000000_REALK,     -0.795282336280384_REALK,      0.000000000000000_REALK, &
     -1.317906175308498_REALK,      0.000000000000000_REALK,     -7.224889600415524_REALK, &
      5.534672733662397_REALK,      0.986033046207364_REALK,      0.000000000000000_REALK, &
      0.245007465103275_REALK,      0.000000000000000_REALK,      1.625751905539046_REALK, &
     -0.000550494119775_REALK,      0.000000000000000_REALK,      0.018830130329999_REALK, &
      0.000000000000000_REALK,      0.883114573096177_REALK,      0.000000000000000_REALK, &
     -0.931745994172021_REALK,      0.000000000000000_REALK,     -8.655666694935327_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.250913790878728_REALK, &
      0.000000000000000_REALK,      0.420448202184825_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.552414953438112_REALK,      0.000000000000000_REALK, &
      1.743574727824397_REALK,      0.000000000000000_REALK,      2.048055360380415_REALK, &
      0.000000000000000_REALK,      3.399018083346471_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -6.297826663900315_REALK, &
      0.000000000000000_REALK,     -1.845216152214376_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.072726602597412_REALK,      0.000000000000000_REALK, &
     -0.168376157641340_REALK,      0.000000000000000_REALK,      7.050214526101208_REALK, &
      0.000000000000000_REALK,      9.824116422230516_REALK,      0.000000000000000_REALK/
    ! results of test 6, ket-major order, dd/dxdy
  data REF_CONTR_INTS(34021:35280)                                                         &
    /21.253821780692469_REALK,      6.888090849201771_REALK,      0.000000000000000_REALK, &
     -2.555246554792507_REALK,      0.000000000000000_REALK,     -0.648265488335681_REALK, &
    -13.743934986259168_REALK,      0.000000000000000_REALK,     -2.624900618490439_REALK, &
      0.000000000000000_REALK,    -49.250294784359156_REALK,      0.000000000000000_REALK, &
     -8.280741219636727_REALK,      0.000000000000000_REALK,     -6.302466672495071_REALK, &
     35.992739679746194_REALK,     15.147520569662527_REALK,      0.000000000000000_REALK, &
      5.416943070320434_REALK,      0.000000000000000_REALK,      2.206899169866341_REALK, &
      0.191759418944410_REALK,      0.000000000000000_REALK,      0.344731224610677_REALK, &
      0.000000000000000_REALK,     11.849419733442208_REALK,      0.000000000000000_REALK, &
     -1.435303391891626_REALK,      0.000000000000000_REALK,     -1.754256869392167_REALK, &
      6.488649622920441_REALK,      0.090546360286668_REALK,      0.000000000000000_REALK, &
     -0.836097102839290_REALK,      0.000000000000000_REALK,     -1.025600983486154_REALK, &
      1.463922243631848_REALK,      0.000000000000000_REALK,     -0.940650800699028_REALK, &
      0.000000000000000_REALK,     13.188453991573839_REALK,      0.000000000000000_REALK, &
     -0.784260536738180_REALK,      0.000000000000000_REALK,     -2.886046519201955_REALK, &
      3.363464478682270_REALK,     -1.023088864275964_REALK,      0.000000000000000_REALK, &
     -1.743828999231680_REALK,      0.000000000000000_REALK,      0.239409915095373_REALK, &
      1.149896128568643_REALK,      0.000000000000000_REALK,      0.034300574788797_REALK, &
      0.000000000000000_REALK,     14.606119557412661_REALK,      0.000000000000000_REALK, &
      0.994062065839408_REALK,      0.000000000000000_REALK,     -0.409423713369257_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.063302760179718_REALK, &
      0.000000000000000_REALK,      1.241365116617189_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.592149160127781_REALK,      0.000000000000000_REALK, &
      1.972883013552031_REALK,      0.000000000000000_REALK,      6.096792407908052_REALK, &
      0.000000000000000_REALK,      3.493207915708024_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.038525389244614_REALK, &
      0.000000000000000_REALK,     -0.699091396115598_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.167755182186871_REALK,      0.000000000000000_REALK, &
      0.205033780586002_REALK,      0.000000000000000_REALK,      0.221676494806463_REALK, &
      0.000000000000000_REALK,      1.195541944318073_REALK,      0.000000000000000_REALK, &
      0.870852733818092_REALK,     -0.765813837393198_REALK,      0.000000000000000_REALK, &
     -0.057263827757224_REALK,      0.000000000000000_REALK,     -1.277531144300998_REALK, &
      1.777898523828249_REALK,      0.000000000000000_REALK,     -0.445711999179357_REALK, &
      0.000000000000000_REALK,      5.516915806331804_REALK,      0.000000000000000_REALK, &
     -0.028747524570613_REALK,      0.000000000000000_REALK,     -1.924034389539240_REALK, &
      9.443414423861187_REALK,      0.077446863034162_REALK,      0.000000000000000_REALK, &
     -0.276228739462259_REALK,      0.000000000000000_REALK,      0.288903744628407_REALK, &
      0.140736926152162_REALK,      0.000000000000000_REALK,     -0.002279272804553_REALK, &
      0.000000000000000_REALK,      0.097523996606678_REALK,      0.000000000000000_REALK, &
      0.117001057010053_REALK,      0.000000000000000_REALK,     -0.367109268515896_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.724022810769969_REALK, &
      0.000000000000000_REALK,      0.607505653047742_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.343527616236886_REALK,      0.000000000000000_REALK, &
      1.264167498741802_REALK,      0.000000000000000_REALK,     -0.474635243233301_REALK, &
      0.000000000000000_REALK,      0.914937982934962_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.931080059284198_REALK, &
      0.000000000000000_REALK,      0.123864503856583_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.199591143212877_REALK,      0.000000000000000_REALK, &
      0.082205477724198_REALK,      0.000000000000000_REALK,     -1.758834618758193_REALK, &
      0.000000000000000_REALK,     -0.157394316450835_REALK,      0.000000000000000_REALK, &
      0.289517750704866_REALK,     -0.876341457737205_REALK,      0.000000000000000_REALK, &
     -1.674101874096465_REALK,      0.000000000000000_REALK,     -1.274157830561620_REALK, &
     -2.670562223225827_REALK,      0.000000000000000_REALK,     -1.530120836238905_REALK, &
      0.000000000000000_REALK,     -4.998521715407669_REALK,      0.000000000000000_REALK, &
     -2.521292409756537_REALK,      0.000000000000000_REALK,     -3.198256646080463_REALK, &
      8.067249943975915_REALK,      2.718809946869090_REALK,      0.000000000000000_REALK, &
      0.605789044028907_REALK,      0.000000000000000_REALK,      0.740407636388047_REALK, &
     -0.044508956273756_REALK,      0.000000000000000_REALK,     -0.240044954561157_REALK, &
      0.000000000000000_REALK,      2.118340213019070_REALK,      0.000000000000000_REALK, &
     -0.769774628966610_REALK,      0.000000000000000_REALK,     -1.568056898140975_REALK, &
     -4.905215481088789_REALK,      0.071916601612058_REALK,      0.000000000000000_REALK, &
      1.569113277525403_REALK,      0.000000000000000_REALK,     -1.624667742440780_REALK, &
      3.843096625612710_REALK,      0.000000000000000_REALK,      0.020002616439550_REALK, &
      0.000000000000000_REALK,      7.469950547439677_REALK,      0.000000000000000_REALK, &
      0.489820905409693_REALK,      0.000000000000000_REALK,     -1.521489052429578_REALK, &
      0.981487447046577_REALK,     -0.221216537302926_REALK,      0.000000000000000_REALK, &
      0.818355428169026_REALK,      0.000000000000000_REALK,     -0.103094407887069_REALK, &
      2.983833348921247_REALK,      0.000000000000000_REALK,      0.240410565239390_REALK, &
      0.000000000000000_REALK,      7.826073721257363_REALK,      0.000000000000000_REALK, &
      0.679692256503657_REALK,      0.000000000000000_REALK,     -0.256877885760895_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.374103353403729_REALK, &
      0.000000000000000_REALK,      0.379661690657901_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.017131126745064_REALK,      0.000000000000000_REALK, &
      1.146564007906014_REALK,      0.000000000000000_REALK,     -0.472750982455444_REALK, &
      0.000000000000000_REALK,      0.355550301685120_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.078417122416250_REALK, &
      0.000000000000000_REALK,      0.003160367775908_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.081482163449759_REALK,      0.000000000000000_REALK, &
      0.255663138313046_REALK,      0.000000000000000_REALK,     -0.162076381579305_REALK, &
      0.000000000000000_REALK,      0.007874613270890_REALK,      0.000000000000000_REALK, &
     -1.083725643005267_REALK,     -0.653428731493957_REALK,      0.000000000000000_REALK, &
     -0.292620068134381_REALK,      0.000000000000000_REALK,     -1.076829815510410_REALK, &
      0.282843014518749_REALK,      0.000000000000000_REALK,     -0.545226720687967_REALK, &
      0.000000000000000_REALK,      1.536104116056859_REALK,      0.000000000000000_REALK, &
     -0.274036480541428_REALK,      0.000000000000000_REALK,     -1.680738295826838_REALK, &
      0.361718282336834_REALK,     -0.033620533283301_REALK,      0.000000000000000_REALK, &
      0.276746783494549_REALK,      0.000000000000000_REALK,     -0.113983522412816_REALK, &
      1.224891924475827_REALK,      0.000000000000000_REALK,      0.109612936385764_REALK, &
      0.000000000000000_REALK,      3.377336136095169_REALK,      0.000000000000000_REALK, &
      0.689563382652927_REALK,      0.000000000000000_REALK,     -0.473350056016249_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.370475041294047_REALK, &
      0.000000000000000_REALK,      1.303371380323948_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.502479969251356_REALK,      0.000000000000000_REALK, &
      1.905894186912232_REALK,      0.000000000000000_REALK,      2.130342476498452_REALK, &
      0.000000000000000_REALK,      2.034329065783531_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.200968790955777_REALK, &
      0.000000000000000_REALK,      0.332838762279354_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.536088337488657_REALK,      0.000000000000000_REALK, &
      1.092030035778796_REALK,      0.000000000000000_REALK,      0.153773088086115_REALK, &
      0.000000000000000_REALK,      1.382210721640209_REALK,      0.000000000000000_REALK, &
    -12.364151521788706_REALK,      2.989649091143446_REALK,      0.000000000000000_REALK, &
      3.314792817265817_REALK,      0.000000000000000_REALK,     -2.289026410355424_REALK, &
      4.893058263220341_REALK,      0.000000000000000_REALK,      0.548677994662684_REALK, &
      0.000000000000000_REALK,      5.777384424349789_REALK,      0.000000000000000_REALK, &
      0.701650393038773_REALK,      0.000000000000000_REALK,     -1.453571642972358_REALK, &
     10.248008128207813_REALK,     -2.603135365994178_REALK,      0.000000000000000_REALK, &
     -0.102339601165396_REALK,      0.000000000000000_REALK,      0.037896946685626_REALK, &
      0.398873342787428_REALK,      0.000000000000000_REALK,      0.225833794749130_REALK, &
      0.000000000000000_REALK,     -1.567246554252218_REALK,      0.000000000000000_REALK, &
      0.286919245098440_REALK,      0.000000000000000_REALK,     -0.318743571718715_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.224668473491938_REALK, &
      0.000000000000000_REALK,     -0.022041195310916_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.394323233534661_REALK,      0.000000000000000_REALK, &
      1.224852749883767_REALK,      0.000000000000000_REALK,     -0.896383850066621_REALK, &
      0.000000000000000_REALK,     -0.013996542956526_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.661128923174980_REALK, &
      0.000000000000000_REALK,      0.034922565458453_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.455286943107816_REALK,      0.000000000000000_REALK, &
      0.172067794271609_REALK,      0.000000000000000_REALK,     -1.215186996193371_REALK, &
      0.000000000000000_REALK,     -0.293726651388246_REALK,      0.000000000000000_REALK, &
     -2.274777378529982_REALK,     -0.519873308083526_REALK,      0.000000000000000_REALK, &
     -0.018877055990407_REALK,      0.000000000000000_REALK,     -1.263416779054706_REALK, &
      0.380581339015322_REALK,      0.000000000000000_REALK,     -0.286230626533659_REALK, &
      0.000000000000000_REALK,      0.766821975018493_REALK,      0.000000000000000_REALK, &
     -0.011987259372073_REALK,      0.000000000000000_REALK,     -1.337152770119006_REALK, &
      3.347608731140927_REALK,      0.020266962945378_REALK,      0.000000000000000_REALK, &
     -0.011836277594277_REALK,      0.000000000000000_REALK,      0.037138187642296_REALK, &
      0.108565692213121_REALK,      0.000000000000000_REALK,     -0.005274752757523_REALK, &
      0.000000000000000_REALK,      0.027660040193646_REALK,      0.000000000000000_REALK, &
      0.099552542518818_REALK,      0.000000000000000_REALK,     -0.520603004179709_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.474510313279929_REALK, &
      0.000000000000000_REALK,      0.600793834933128_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.220609104103411_REALK,      0.000000000000000_REALK, &
      1.353054049380841_REALK,      0.000000000000000_REALK,     -0.197915328458605_REALK, &
      0.000000000000000_REALK,      0.635857583949712_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.730959175933421_REALK, &
      0.000000000000000_REALK,      0.015922615306916_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.461899045579971_REALK,      0.000000000000000_REALK, &
      0.317070112188915_REALK,      0.000000000000000_REALK,     -1.496537404379601_REALK, &
      0.000000000000000_REALK,     -0.223203174129526_REALK,      0.000000000000000_REALK, &
     -2.268770841766278_REALK,     -1.784715202569517_REALK,      0.000000000000000_REALK, &
     -1.655606132982124_REALK,      0.000000000000000_REALK,     -2.100134557027820_REALK, &
     -1.715001390490844_REALK,      0.000000000000000_REALK,     -1.637707183245581_REALK, &
      0.000000000000000_REALK,     -2.084303854836393_REALK,      0.000000000000000_REALK, &
     -1.752231222225366_REALK,      0.000000000000000_REALK,     -3.111784726901376_REALK, &
      8.579310979039239_REALK,      2.134444893826702_REALK,      0.000000000000000_REALK, &
      0.077873366500423_REALK,      0.000000000000000_REALK,      0.158630675690593_REALK, &
     -0.103003791108513_REALK,      0.000000000000000_REALK,     -0.925863857010166_REALK, &
      0.000000000000000_REALK,      1.802429478118163_REALK,      0.000000000000000_REALK, &
     -1.091628620550574_REALK,      0.000000000000000_REALK,     -3.113158077636996_REALK, &
    -45.423098531479667_REALK,     16.588013547143436_REALK,      0.000000000000000_REALK, &
      8.430682413620087_REALK,      0.000000000000000_REALK,     -4.334599374936377_REALK, &
      9.050035574006813_REALK,      0.000000000000000_REALK,      1.813881643266960_REALK, &
      0.000000000000000_REALK,      7.618836755206280_REALK,      0.000000000000000_REALK, &
      1.120524044739653_REALK,      0.000000000000000_REALK,     -1.728337963276726_REALK, &
     -9.269440470438964_REALK,     16.752811055074059_REALK,      0.000000000000000_REALK, &
     12.402208353055761_REALK,      0.000000000000000_REALK,     -1.448359185529560_REALK, &
     14.112956550414072_REALK,      0.000000000000000_REALK,      2.238652181613847_REALK, &
      0.000000000000000_REALK,     17.329262060969516_REALK,      0.000000000000000_REALK, &
      1.692547947812632_REALK,      0.000000000000000_REALK,     -0.592979241449277_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.363172076349015_REALK, &
      0.000000000000000_REALK,     -0.940372266387817_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.849262370067561_REALK,      0.000000000000000_REALK, &
      1.759371491587674_REALK,      0.000000000000000_REALK,     -1.114605309233373_REALK, &
      0.000000000000000_REALK,     -0.374955318133523_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.321737266812735_REALK, &
      0.000000000000000_REALK,     -1.418096744973421_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.837821506049139_REALK,      0.000000000000000_REALK, &
      0.930750459800047_REALK,      0.000000000000000_REALK,     -0.341817188972833_REALK, &
      0.000000000000000_REALK,     -0.580589359695724_REALK,      0.000000000000000_REALK, &
     -7.332848100752422_REALK,      0.051642358815118_REALK,      0.000000000000000_REALK, &
      0.675825596097267_REALK,      0.000000000000000_REALK,     -2.099259616029729_REALK, &
      1.084963509677385_REALK,      0.000000000000000_REALK,      0.016941111074607_REALK, &
      0.000000000000000_REALK,      1.369851522565202_REALK,      0.000000000000000_REALK, &
      0.269472431764510_REALK,      0.000000000000000_REALK,     -1.395065524062477_REALK, &
     -2.305008368869072_REALK,      2.139513305655047_REALK,      0.000000000000000_REALK, &
      2.858920795124177_REALK,      0.000000000000000_REALK,     -1.080479470499021_REALK, &
      3.548419343333887_REALK,      0.000000000000000_REALK,      0.857699543118619_REALK, &
      0.000000000000000_REALK,      4.492371812039959_REALK,      0.000000000000000_REALK, &
      1.170483607515119_REALK,      0.000000000000000_REALK,     -0.737273257466365_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.960176238929848_REALK, &
      0.000000000000000_REALK,      0.490567045883694_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.014509117939565_REALK,      0.000000000000000_REALK, &
      1.618460620787993_REALK,      0.000000000000000_REALK,     -0.260081502145720_REALK, &
      0.000000000000000_REALK,      0.326006925359643_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.275252277875625_REALK, &
      0.000000000000000_REALK,      0.033122189370695_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.290699430341526_REALK,      0.000000000000000_REALK, &
      1.520192181134113_REALK,      0.000000000000000_REALK,     -0.279108296421973_REALK, &
      0.000000000000000_REALK,      0.022601173940373_REALK,      0.000000000000000_REALK, &
     -4.860211882853280_REALK,     -1.407655544985903_REALK,      0.000000000000000_REALK, &
     -0.378099149646141_REALK,      0.000000000000000_REALK,     -2.318982199648271_REALK, &
      0.239552407562275_REALK,      0.000000000000000_REALK,     -0.769628185387085_REALK, &
      0.000000000000000_REALK,      0.845079715924112_REALK,      0.000000000000000_REALK, &
     -0.251266248500634_REALK,      0.000000000000000_REALK,     -2.157515406916340_REALK, &
     -2.548469683850522_REALK,      0.975490971604092_REALK,      0.000000000000000_REALK, &
      2.900440714689848_REALK,      0.000000000000000_REALK,     -1.991004466461459_REALK, &
      4.369979509621277_REALK,      0.000000000000000_REALK,      0.651766734713066_REALK, &
      0.000000000000000_REALK,      5.816038871330846_REALK,      0.000000000000000_REALK, &
      1.979137440547413_REALK,      0.000000000000000_REALK,     -1.902007529227955_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.920599850605618_REALK, &
      0.000000000000000_REALK,      2.806845600824666_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.120862548439080_REALK,      0.000000000000000_REALK, &
      3.766436530966592_REALK,      0.000000000000000_REALK,      1.953328115416345_REALK, &
      0.000000000000000_REALK,      2.611409707902491_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      9.718428095692044_REALK, &
      0.000000000000000_REALK,      5.813853163000581_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.187621431954616_REALK,      0.000000000000000_REALK, &
      9.090609409208481_REALK,      0.000000000000000_REALK,      0.441348951577097_REALK, &
      0.000000000000000_REALK,      5.553976736931101_REALK,      0.000000000000000_REALK, &
     13.001474523636144_REALK,     13.705845881504368_REALK,      0.000000000000000_REALK, &
      2.903512347853090_REALK,      0.000000000000000_REALK,      2.273905225002768_REALK, &
     14.593462368765259_REALK,      0.000000000000000_REALK,      5.436059653172771_REALK, &
      0.000000000000000_REALK,     -9.047839186369318_REALK,      0.000000000000000_REALK, &
     -2.998734560781279_REALK,      0.000000000000000_REALK,     -7.045437424640784_REALK, &
     10.135907855745339_REALK,      6.748113243721371_REALK,      0.000000000000000_REALK, &
      1.460107860994792_REALK,      0.000000000000000_REALK,      1.937714947831678_REALK, &
     -0.433991132963562_REALK,      0.000000000000000_REALK,      2.969008860294984_REALK, &
      0.000000000000000_REALK,      2.238728420144553_REALK,      0.000000000000000_REALK, &
     -0.472402177714165_REALK,      0.000000000000000_REALK,     -1.880780425059788_REALK, &
      8.345178872611172_REALK,     -2.044493811810681_REALK,      0.000000000000000_REALK, &
     -0.264389320056899_REALK,      0.000000000000000_REALK,      1.031349571759897_REALK, &
     -5.995913519089883_REALK,      0.000000000000000_REALK,     -0.651992897508787_REALK, &
      0.000000000000000_REALK,     10.217747233211727_REALK,      0.000000000000000_REALK, &
      0.422759328168535_REALK,      0.000000000000000_REALK,     -4.947393320996699_REALK, &
      1.389359869632362_REALK,     -3.983680228793178_REALK,      0.000000000000000_REALK, &
     -2.304892470797717_REALK,      0.000000000000000_REALK,      0.521922478138385_REALK, &
    -10.179888736302408_REALK,      0.000000000000000_REALK,     -1.674744845823735_REALK, &
      0.000000000000000_REALK,      7.818587361115205_REALK,      0.000000000000000_REALK, &
      1.077636870264601_REALK,      0.000000000000000_REALK,     -0.732063963487807_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.968860323045903_REALK, &
      0.000000000000000_REALK,     -0.485208223038026_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.023322778327782_REALK,      0.000000000000000_REALK, &
     -4.753736529732971_REALK,      0.000000000000000_REALK,      2.082819198986840_REALK, &
      0.000000000000000_REALK,      2.327548280118798_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.272919773489436_REALK, &
      0.000000000000000_REALK,     -0.592378076620113_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.036799046812541_REALK,      0.000000000000000_REALK, &
     -4.127820412262258_REALK,      0.000000000000000_REALK,     -0.040484624239909_REALK, &
      0.000000000000000_REALK,      0.830887077714291_REALK,      0.000000000000000_REALK, &
      4.574950704267182_REALK,     -3.706826388233352_REALK,      0.000000000000000_REALK, &
     -0.191481847862218_REALK,      0.000000000000000_REALK,      0.291250251907343_REALK, &
     -2.294979369479331_REALK,      0.000000000000000_REALK,     -0.740490582339544_REALK, &
      0.000000000000000_REALK,      4.627990044390616_REALK,      0.000000000000000_REALK, &
      0.676680368082502_REALK,      0.000000000000000_REALK,     -3.087759960514814_REALK, &
      3.358906624176071_REALK,     -3.705843373324736_REALK,      0.000000000000000_REALK, &
     -0.293494688181500_REALK,      0.000000000000000_REALK,      0.454673445822214_REALK, &
     -0.816599038567052_REALK,      0.000000000000000_REALK,     -0.820284750679632_REALK, &
      0.000000000000000_REALK,     -1.728175046032273_REALK,      0.000000000000000_REALK, &
      0.127596504313832_REALK,      0.000000000000000_REALK,     -0.593006394603255_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.684905342162263_REALK, &
      0.000000000000000_REALK,      0.053238076818202_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.086284108461019_REALK,      0.000000000000000_REALK, &
     -1.009750450114310_REALK,      0.000000000000000_REALK,     -1.730178141587932_REALK, &
      0.000000000000000_REALK,     -0.564416342638400_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.018932760585597_REALK, &
      0.000000000000000_REALK,      0.684352996053217_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.996019340630786_REALK,      0.000000000000000_REALK, &
     -0.676619264180941_REALK,      0.000000000000000_REALK,     -1.808477397101296_REALK, &
      0.000000000000000_REALK,     -0.892565216980230_REALK,      0.000000000000000_REALK, &
      2.032419981837024_REALK,      0.792679756159489_REALK,      0.000000000000000_REALK, &
      0.165213170131474_REALK,      0.000000000000000_REALK,      0.388163416366058_REALK, &
      0.425098124856585_REALK,      0.000000000000000_REALK,      0.475046710666470_REALK, &
      0.000000000000000_REALK,     -1.761600721567667_REALK,      0.000000000000000_REALK, &
     -1.751547366365816_REALK,      0.000000000000000_REALK,     -6.858680506669895_REALK, &
      4.153645254683417_REALK,      1.156480999005523_REALK,      0.000000000000000_REALK, &
      0.423668438664333_REALK,      0.000000000000000_REALK,      1.686756208472975_REALK, &
     -0.037418419742096_REALK,      0.000000000000000_REALK,      0.767957762135984_REALK, &
      0.000000000000000_REALK,      0.872879240186661_REALK,      0.000000000000000_REALK, &
     -0.552568212698670_REALK,      0.000000000000000_REALK,     -3.666577360638791_REALK, &
      1.179485758911905_REALK,     -2.532557997296907_REALK,      0.000000000000000_REALK, &
      0.111447401030970_REALK,      0.000000000000000_REALK,     -0.074909095209801_REALK, &
      0.399127734138043_REALK,      0.000000000000000_REALK,      0.162673505866134_REALK, &
      0.000000000000000_REALK,      2.934955404856979_REALK,      0.000000000000000_REALK, &
      0.590841971907258_REALK,      0.000000000000000_REALK,     -1.191398914235288_REALK, &
      0.254568372171532_REALK,     -3.238937258394626_REALK,      0.000000000000000_REALK, &
     -0.512740541268167_REALK,      0.000000000000000_REALK,      0.046715388612127_REALK, &
     -1.391233797509938_REALK,      0.000000000000000_REALK,     -0.489127768741841_REALK, &
      0.000000000000000_REALK,      4.039528319099214_REALK,      0.000000000000000_REALK, &
      0.480251270498368_REALK,      0.000000000000000_REALK,     -0.131265949893352_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.446998264426821_REALK, &
      0.000000000000000_REALK,     -0.104646533309125_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.018876634369286_REALK,      0.000000000000000_REALK, &
      0.086135963955810_REALK,      0.000000000000000_REALK,     -1.719433903830800_REALK, &
      0.000000000000000_REALK,     -1.664360860504229_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.399259070655766_REALK, &
      0.000000000000000_REALK,      0.304642830836628_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.038920214943549_REALK,      0.000000000000000_REALK, &
     -0.180882199437778_REALK,      0.000000000000000_REALK,     -0.284057364658496_REALK, &
      0.000000000000000_REALK,     -0.856018364740490_REALK,      0.000000000000000_REALK, &
      0.748955918609157_REALK,     -0.081707493069324_REALK,      0.000000000000000_REALK, &
      0.012193717307770_REALK,      0.000000000000000_REALK,     -0.142698484804414_REALK, &
      0.048264944149383_REALK,      0.000000000000000_REALK,      0.015744923947218_REALK, &
      0.000000000000000_REALK,      1.562426052648619_REALK,      0.000000000000000_REALK, &
      0.193936150480537_REALK,      0.000000000000000_REALK,     -3.782602975487425_REALK, &
      0.456450731781531_REALK,     -0.600945895818900_REALK,      0.000000000000000_REALK, &
     -0.369908316894094_REALK,      0.000000000000000_REALK,      0.251287382665465_REALK, &
     -0.551632110881449_REALK,      0.000000000000000_REALK,     -0.272255343379658_REALK, &
      0.000000000000000_REALK,      2.513742640434379_REALK,      0.000000000000000_REALK, &
      1.039408384113263_REALK,      0.000000000000000_REALK,     -1.176824095933755_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.595736389216283_REALK, &
      0.000000000000000_REALK,      0.067133860465971_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.048861058743383_REALK,      0.000000000000000_REALK, &
      0.191329334035550_REALK,      0.000000000000000_REALK,      0.955470194704806_REALK, &
      0.000000000000000_REALK,      1.779561574901086_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.481178904125174_REALK, &
      0.000000000000000_REALK,     -0.285209284247002_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.168547514094191_REALK,      0.000000000000000_REALK, &
     -1.118400380563905_REALK,      0.000000000000000_REALK,     -0.039048457809637_REALK, &
      0.000000000000000_REALK,      1.335686473891630_REALK,      0.000000000000000_REALK, &
     -0.070830482313524_REALK,      1.724478162093936_REALK,      0.000000000000000_REALK, &
      0.039616000673696_REALK,      0.000000000000000_REALK,      0.357567861549280_REALK, &
      3.740065656472685_REALK,      0.000000000000000_REALK,      1.711889359962500_REALK, &
      0.000000000000000_REALK,     -1.776925431459352_REALK,      0.000000000000000_REALK, &
      0.045752366838202_REALK,      0.000000000000000_REALK,      1.238861244922415_REALK, &
     -2.244293304716145_REALK,     -7.809143282251196_REALK,      0.000000000000000_REALK, &
      0.573841208886368_REALK,      0.000000000000000_REALK,     -0.131847510857843_REALK, &
     -0.034566476057687_REALK,      0.000000000000000_REALK,     -0.029826015737713_REALK, &
      0.000000000000000_REALK,     -5.435865890465131_REALK,      0.000000000000000_REALK, &
     -0.436455474893656_REALK,      0.000000000000000_REALK,      0.300844033543788_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.088949856638586_REALK, &
      0.000000000000000_REALK,     -0.759845868787456_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.131370738014292_REALK,      0.000000000000000_REALK, &
      0.264901550794166_REALK,      0.000000000000000_REALK,     -2.153096633947384_REALK, &
      0.000000000000000_REALK,     -2.632629215826342_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.161505671386505_REALK, &
      0.000000000000000_REALK,      0.711015854342936_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.006770446651514_REALK,      0.000000000000000_REALK, &
     -0.001850550254643_REALK,      0.000000000000000_REALK,     -1.538173404399426_REALK, &
      0.000000000000000_REALK,     -1.622365687015074_REALK,      0.000000000000000_REALK, &
      0.026566458617150_REALK,      0.124261200986362_REALK,      0.000000000000000_REALK, &
      0.088172518110702_REALK,      0.000000000000000_REALK,     -0.402339987801745_REALK, &
      0.382307472476757_REALK,      0.000000000000000_REALK,      0.370062258543918_REALK, &
      0.000000000000000_REALK,      0.696442103238537_REALK,      0.000000000000000_REALK, &
      0.305490306319139_REALK,      0.000000000000000_REALK,     -2.323304523745831_REALK, &
      1.491898302002221_REALK,     -1.053219215104261_REALK,      0.000000000000000_REALK, &
     -0.056575994346999_REALK,      0.000000000000000_REALK,      0.262937661256687_REALK, &
     -0.004004560428116_REALK,      0.000000000000000_REALK,     -0.012067904922307_REALK, &
      0.000000000000000_REALK,     -0.582813176496170_REALK,      0.000000000000000_REALK, &
      0.129092693751747_REALK,      0.000000000000000_REALK,     -0.999933257093246_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.169445508991214_REALK, &
      0.000000000000000_REALK,     -0.073544338716789_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.043120726738550_REALK,      0.000000000000000_REALK, &
      0.841042729074837_REALK,      0.000000000000000_REALK,     -0.781096475368610_REALK, &
      0.000000000000000_REALK,     -0.424680369878636_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.868757354997319_REALK, &
      0.000000000000000_REALK,      0.395761348962966_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.014653285573763_REALK,      0.000000000000000_REALK, &
     -0.016590533433607_REALK,      0.000000000000000_REALK,     -1.829683501412708_REALK, &
      0.000000000000000_REALK,     -1.505052310911933_REALK,      0.000000000000000_REALK, &
      0.035406415170624_REALK,     -0.079717252588864_REALK,      0.000000000000000_REALK, &
     -0.228229381502928_REALK,      0.000000000000000_REALK,     -0.893696876271931_REALK, &
     -0.212443987727960_REALK,      0.000000000000000_REALK,     -0.395676557442210_REALK, &
      0.000000000000000_REALK,     -0.795282336280385_REALK,      0.000000000000000_REALK, &
     -1.317906175308498_REALK,      0.000000000000000_REALK,     -7.224889600415525_REALK, &
      5.534672733662400_REALK,      0.986033046207364_REALK,      0.000000000000000_REALK, &
      0.245007465103275_REALK,      0.000000000000000_REALK,      1.625751905539044_REALK, &
     -0.000550494119775_REALK,      0.000000000000000_REALK,      0.018830130329999_REALK, &
      0.000000000000000_REALK,      0.883114573096176_REALK,      0.000000000000000_REALK, &
     -0.931745994172021_REALK,      0.000000000000000_REALK,     -8.655666694935327_REALK, &
     18.939880703252221_REALK,     17.511600284907942_REALK,      0.000000000000000_REALK, &
     -1.759343683124099_REALK,      0.000000000000000_REALK,      4.021099293627904_REALK, &
     10.685409318004002_REALK,      0.000000000000000_REALK,      4.600086849371640_REALK, &
      0.000000000000000_REALK,     -8.214416061055735_REALK,      0.000000000000000_REALK, &
     -0.841629928852001_REALK,      0.000000000000000_REALK,      5.770806826770811_REALK, &
      4.708832366668603_REALK,     11.725567243664646_REALK,      0.000000000000000_REALK, &
     -2.476437392488705_REALK,      0.000000000000000_REALK,      1.739072823229350_REALK, &
     10.495576024837222_REALK,      0.000000000000000_REALK,      3.967762619826361_REALK, &
      0.000000000000000_REALK,     -0.551839628371991_REALK,      0.000000000000000_REALK, &
     -1.176307735221730_REALK,      0.000000000000000_REALK,      2.478178717883222_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.739577136339899_REALK, &
      0.000000000000000_REALK,     -2.715670483803584_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.021524636477491_REALK,      0.000000000000000_REALK, &
     -0.582834064897854_REALK,      0.000000000000000_REALK,     -2.838252901442681_REALK, &
      0.000000000000000_REALK,     -3.897344637081698_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.336357645632673_REALK, &
      0.000000000000000_REALK,     -2.397235007410863_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.495373672484880_REALK,      0.000000000000000_REALK, &
     -0.341455709263499_REALK,      0.000000000000000_REALK,     -1.319666144853419_REALK, &
      0.000000000000000_REALK,     -3.416059809444079_REALK,      0.000000000000000_REALK, &
     -0.659776841145460_REALK,      1.571630708818834_REALK,      0.000000000000000_REALK, &
      0.208401105821886_REALK,      0.000000000000000_REALK,     -0.420228864919910_REALK, &
      1.012944805905224_REALK,      0.000000000000000_REALK,      1.238545473528804_REALK, &
      0.000000000000000_REALK,      0.495222846099632_REALK,      0.000000000000000_REALK, &
      0.299083020926469_REALK,      0.000000000000000_REALK,     -1.005139567318847_REALK, &
     -0.134242632136717_REALK,      1.813880423060473_REALK,      0.000000000000000_REALK, &
      0.544167610972415_REALK,      0.000000000000000_REALK,     -0.148736052861172_REALK, &
      1.745815213892259_REALK,      0.000000000000000_REALK,      1.841372819726761_REALK, &
      0.000000000000000_REALK,      2.174144591454064_REALK,      0.000000000000000_REALK, &
      0.775438828357419_REALK,      0.000000000000000_REALK,     -0.353248117674233_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.832181770263585_REALK, &
      0.000000000000000_REALK,     -0.587051462671293_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.143720822447735_REALK,      0.000000000000000_REALK, &
      1.093020727801649_REALK,      0.000000000000000_REALK,     -0.870373992864928_REALK, &
      0.000000000000000_REALK,     -1.404160214686298_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.670783180607918_REALK, &
      0.000000000000000_REALK,     -0.969945312182009_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.146519233858506_REALK,      0.000000000000000_REALK, &
      1.134916705826045_REALK,      0.000000000000000_REALK,     -0.458653883015244_REALK, &
      0.000000000000000_REALK,     -2.303620065103174_REALK,      0.000000000000000_REALK, &
     -1.256845450833596_REALK,      0.152115772336205_REALK,      0.000000000000000_REALK, &
      0.068404937598657_REALK,      0.000000000000000_REALK,     -1.334195403268458_REALK, &
      0.367474271781731_REALK,      0.000000000000000_REALK,      0.199794922371787_REALK, &
      0.000000000000000_REALK,      0.790896933560633_REALK,      0.000000000000000_REALK, &
      0.163616817215760_REALK,      0.000000000000000_REALK,     -4.467740755652034_REALK, &
     -0.722106369527260_REALK,      1.009631161813292_REALK,      0.000000000000000_REALK, &
      1.177742594247931_REALK,      0.000000000000000_REALK,     -1.333446876995238_REALK, &
      2.076676975585313_REALK,      0.000000000000000_REALK,      1.708223022565957_REALK, &
      0.000000000000000_REALK,      4.058820387643606_REALK,      0.000000000000000_REALK, &
      2.797138599013193_REALK,      0.000000000000000_REALK,     -4.433710767217540_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.848482057770214_REALK, &
      0.000000000000000_REALK,      0.627684927139428_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.620021504795026_REALK,      0.000000000000000_REALK, &
      3.399018083346471_REALK,      0.000000000000000_REALK,      0.806095159745948_REALK, &
      0.000000000000000_REALK,      2.101891165131701_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.147473697243626_REALK, &
      0.000000000000000_REALK,      1.513452149229135_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.057524676643206_REALK,      0.000000000000000_REALK, &
      9.824116422230516_REALK,      0.000000000000000_REALK,     -0.105082805027068_REALK, &
      0.000000000000000_REALK,      5.032228284059122_REALK,      0.000000000000000_REALK/
    ! results of test 6, ket-major order, dd/dydy
  data REF_CONTR_INTS(35281:36540)                                                         &
   /-44.650698056086931_REALK,    -17.201198375243852_REALK,      0.000000000000000_REALK, &
     -6.336138284201847_REALK,      0.000000000000000_REALK,     -7.772242761892167_REALK, &
      5.660415904029062_REALK,      0.000000000000000_REALK,     -3.637129482509224_REALK, &
      0.000000000000000_REALK,     31.924805193054258_REALK,      0.000000000000000_REALK, &
     -1.898430617566173_REALK,      0.000000000000000_REALK,     -6.986146591744647_REALK, &
     -6.941741705918485_REALK,      3.484441750385425_REALK,      0.000000000000000_REALK, &
     13.681350492055406_REALK,      0.000000000000000_REALK,     -1.878309720239863_REALK, &
     28.728847405507068_REALK,      0.000000000000000_REALK,      0.856960863286978_REALK, &
      0.000000000000000_REALK,     60.692890840352518_REALK,      0.000000000000000_REALK, &
      4.130631699499381_REALK,      0.000000000000000_REALK,     -1.701280661526635_REALK, &
    -13.625421555265151_REALK,      7.364220949628632_REALK,      0.000000000000000_REALK, &
     12.363032067848581_REALK,      0.000000000000000_REALK,     -2.068419429682283_REALK, &
     18.388991273795476_REALK,      0.000000000000000_REALK,      1.342157608231812_REALK, &
      0.000000000000000_REALK,     29.655013658489530_REALK,      0.000000000000000_REALK, &
      3.049578377058928_REALK,      0.000000000000000_REALK,     -1.530645669969213_REALK, &
      2.325823948188813_REALK,      9.305611038656632_REALK,      0.000000000000000_REALK, &
      7.313954597671305_REALK,      0.000000000000000_REALK,      0.284767114872919_REALK, &
      2.915769742405322_REALK,      0.000000000000000_REALK,      1.529050618401852_REALK, &
      0.000000000000000_REALK,     -9.766134083112608_REALK,      0.000000000000000_REALK, &
      1.641040843696512_REALK,      0.000000000000000_REALK,      0.191680626482231_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.388905633856207_REALK, &
      0.000000000000000_REALK,      2.503569875501656_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.949251890669033_REALK,      0.000000000000000_REALK, &
      3.493207915708023_REALK,      0.000000000000000_REALK,     -0.961090094756436_REALK, &
      0.000000000000000_REALK,      1.852660216980554_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.425306304520572_REALK, &
      0.000000000000000_REALK,     -0.831537155948674_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.902721205829706_REALK,      0.000000000000000_REALK, &
      1.195541944318073_REALK,      0.000000000000000_REALK,     -6.254693086881094_REALK, &
      0.000000000000000_REALK,     -0.559718993770134_REALK,      0.000000000000000_REALK, &
     -6.117860298827023_REALK,      8.906406283004234_REALK,      0.000000000000000_REALK, &
      6.787503077919369_REALK,      0.000000000000000_REALK,     -0.807108689488842_REALK, &
      5.707544514902112_REALK,      0.000000000000000_REALK,      1.388867060032071_REALK, &
      0.000000000000000_REALK,      3.104987816564442_REALK,      0.000000000000000_REALK, &
      1.374977496272525_REALK,      0.000000000000000_REALK,     -0.490499793084448_REALK, &
     -0.054666434507072_REALK,      3.269434561768719_REALK,      0.000000000000000_REALK, &
      0.781731742988022_REALK,      0.000000000000000_REALK,     -0.011233951041405_REALK, &
     -1.278429610493446_REALK,      0.000000000000000_REALK,      0.596697883994877_REALK, &
      0.000000000000000_REALK,     -3.155664875282992_REALK,      0.000000000000000_REALK, &
      0.158958023672224_REALK,      0.000000000000000_REALK,     -0.006852964606810_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.955744993952840_REALK, &
      0.000000000000000_REALK,     -1.064590308157620_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.822874584138400_REALK,      0.000000000000000_REALK, &
      0.914937982934962_REALK,      0.000000000000000_REALK,     -2.954761611446047_REALK, &
      0.000000000000000_REALK,     -0.646977702844122_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.287465640392507_REALK, &
      0.000000000000000_REALK,     -1.513163460461679_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.347504474509103_REALK,      0.000000000000000_REALK, &
     -0.157394316450835_REALK,      0.000000000000000_REALK,     -0.586734891010232_REALK, &
      0.000000000000000_REALK,     -0.923063987072981_REALK,      0.000000000000000_REALK, &
     -7.000832775177361_REALK,     -2.367191189929789_REALK,      0.000000000000000_REALK, &
     -0.752940158896755_REALK,      0.000000000000000_REALK,     -2.770788816927035_REALK, &
      0.574488171866002_REALK,      0.000000000000000_REALK,     -1.107421028422686_REALK, &
      0.000000000000000_REALK,      2.564953749545049_REALK,      0.000000000000000_REALK, &
     -0.457580245329443_REALK,      0.000000000000000_REALK,     -2.806460804851737_REALK, &
     -1.919091878932965_REALK,      0.839417013272841_REALK,      0.000000000000000_REALK, &
      2.872561321193901_REALK,      0.000000000000000_REALK,     -1.183120011737885_REALK, &
      5.135903200476413_REALK,      0.000000000000000_REALK,      0.459600899922800_REALK, &
      0.000000000000000_REALK,      8.582530704479758_REALK,      0.000000000000000_REALK, &
      1.752327475211342_REALK,      0.000000000000000_REALK,     -1.202883345340844_REALK, &
      0.280598113068302_REALK,     12.281388170758236_REALK,      0.000000000000000_REALK, &
      5.907191892772730_REALK,      0.000000000000000_REALK,      0.031469954987438_REALK, &
      4.221882130291875_REALK,      0.000000000000000_REALK,      1.610843004995975_REALK, &
      0.000000000000000_REALK,      2.121567251661205_REALK,      0.000000000000000_REALK, &
      0.973825167774433_REALK,      0.000000000000000_REALK,      0.015563859149213_REALK, &
      6.065139634821247_REALK,      9.182967597643151_REALK,      0.000000000000000_REALK, &
      2.443562176055166_REALK,      0.000000000000000_REALK,      0.534545869195630_REALK, &
     -0.167230236448540_REALK,      0.000000000000000_REALK,      1.015351193201780_REALK, &
      0.000000000000000_REALK,     -3.756494130903193_REALK,      0.000000000000000_REALK, &
      0.342998972875774_REALK,      0.000000000000000_REALK,      0.225100084482094_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.903595458130129_REALK, &
      0.000000000000000_REALK,     -1.302133363800587_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.996684749927671_REALK,      0.000000000000000_REALK, &
      0.355550301685120_REALK,      0.000000000000000_REALK,     -0.882153195578549_REALK, &
      0.000000000000000_REALK,     -0.643986312524847_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.023739673850361_REALK, &
      0.000000000000000_REALK,     -0.923971748308923_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.182655687653759_REALK,      0.000000000000000_REALK, &
      0.007874613270890_REALK,      0.000000000000000_REALK,      0.277875617653487_REALK, &
      0.000000000000000_REALK,     -0.389089375840427_REALK,      0.000000000000000_REALK, &
     -2.549492953947872_REALK,      1.191858023272934_REALK,      0.000000000000000_REALK, &
      1.709037446662404_REALK,      0.000000000000000_REALK,     -0.857800798703164_REALK, &
      2.141828390489006_REALK,      0.000000000000000_REALK,      0.468976991780646_REALK, &
      0.000000000000000_REALK,      2.739742979960734_REALK,      0.000000000000000_REALK, &
      0.845225807002324_REALK,      0.000000000000000_REALK,     -0.707060158089815_REALK, &
      0.921781126521956_REALK,      3.197628946507357_REALK,      0.000000000000000_REALK, &
      2.086576973979955_REALK,      0.000000000000000_REALK,      0.243721162158863_REALK, &
      0.674206073478341_REALK,      0.000000000000000_REALK,      1.060675538184219_REALK, &
      0.000000000000000_REALK,     -1.743039095639344_REALK,      0.000000000000000_REALK, &
      0.878668567447830_REALK,      0.000000000000000_REALK,      0.171053777775231_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.102026062931680_REALK, &
      0.000000000000000_REALK,      1.038263423750751_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.331687793890719_REALK,      0.000000000000000_REALK, &
      2.034329065783530_REALK,      0.000000000000000_REALK,     -0.266377200551206_REALK, &
      0.000000000000000_REALK,      0.855810231986171_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.500178530329371_REALK, &
      0.000000000000000_REALK,     -0.711680497646394_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.013566679963902_REALK,      0.000000000000000_REALK, &
      1.382210721640209_REALK,      0.000000000000000_REALK,     -3.348973449128870_REALK, &
      0.000000000000000_REALK,     -0.499487351090267_REALK,      0.000000000000000_REALK, &
      8.141538783004179_REALK,     16.210778919889609_REALK,      0.000000000000000_REALK, &
      3.493943994194688_REALK,      0.000000000000000_REALK,      0.776924297565761_REALK, &
      1.124646135030787_REALK,      0.000000000000000_REALK,      1.772631437892116_REALK, &
      0.000000000000000_REALK,     -2.387588984523606_REALK,      0.000000000000000_REALK, &
      0.464380943841977_REALK,      0.000000000000000_REALK,      0.309783590575707_REALK, &
      3.108073477269128_REALK,      5.263978242269377_REALK,      0.000000000000000_REALK, &
     -2.949723767869311_REALK,      0.000000000000000_REALK,      0.485639536114348_REALK, &
     -4.941468807694954_REALK,      0.000000000000000_REALK,      0.703417255604694_REALK, &
      0.000000000000000_REALK,     -6.794032028889688_REALK,      0.000000000000000_REALK, &
     -0.402553220184471_REALK,      0.000000000000000_REALK,      0.198827864399930_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.042666297998338_REALK, &
      0.000000000000000_REALK,     -1.836239926884615_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.875758747379199_REALK,      0.000000000000000_REALK, &
     -0.013996542956526_REALK,      0.000000000000000_REALK,     -0.639647586694017_REALK, &
      0.000000000000000_REALK,     -0.732165282371855_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.732694897546124_REALK, &
      0.000000000000000_REALK,     -1.462561915518068_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.447569533188795_REALK,      0.000000000000000_REALK, &
     -0.293726651388246_REALK,      0.000000000000000_REALK,      0.032874165572986_REALK, &
      0.000000000000000_REALK,     -0.598794044945011_REALK,      0.000000000000000_REALK, &
     -1.415740968580323_REALK,      1.765404817250952_REALK,      0.000000000000000_REALK, &
      1.136145686859639_REALK,      0.000000000000000_REALK,     -0.405300614613104_REALK, &
      0.793318352330131_REALK,      0.000000000000000_REALK,      0.579135418809327_REALK, &
      0.000000000000000_REALK,      0.341001889077016_REALK,      0.000000000000000_REALK, &
      0.453016196552524_REALK,      0.000000000000000_REALK,     -0.269343015037577_REALK, &
     -0.024198207599269_REALK,      1.266475759098905_REALK,      0.000000000000000_REALK, &
      0.263106257424826_REALK,      0.000000000000000_REALK,     -0.011342981173952_REALK, &
     -0.362591932666698_REALK,      0.000000000000000_REALK,      0.507711579581583_REALK, &
      0.000000000000000_REALK,     -0.712822756344639_REALK,      0.000000000000000_REALK, &
      0.107719514956704_REALK,      0.000000000000000_REALK,     -0.007739968141770_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.162988142667847_REALK, &
      0.000000000000000_REALK,     -0.534598514210894_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.760109636193324_REALK,      0.000000000000000_REALK, &
      0.635857583949712_REALK,      0.000000000000000_REALK,     -0.973510381490192_REALK, &
      0.000000000000000_REALK,     -0.355268091043047_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.334065348230121_REALK, &
      0.000000000000000_REALK,     -1.527849336521713_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.146549440842564_REALK,      0.000000000000000_REALK, &
     -0.223203174129526_REALK,      0.000000000000000_REALK,     -0.397606842408427_REALK, &
      0.000000000000000_REALK,     -1.042539435510921_REALK,      0.000000000000000_REALK, &
     -4.860211882853279_REALK,     -1.407655544985902_REALK,      0.000000000000000_REALK, &
     -0.378099149646141_REALK,      0.000000000000000_REALK,     -2.318982199648271_REALK, &
      0.239552407562275_REALK,      0.000000000000000_REALK,     -0.769628185387085_REALK, &
      0.000000000000000_REALK,      0.845079715924113_REALK,      0.000000000000000_REALK, &
     -0.251266248500634_REALK,      0.000000000000000_REALK,     -2.157515406916340_REALK, &
     -2.548469683850521_REALK,      0.975490971604092_REALK,      0.000000000000000_REALK, &
      2.900440714689849_REALK,      0.000000000000000_REALK,     -1.991004466461459_REALK, &
      4.369979509621277_REALK,      0.000000000000000_REALK,      0.651766734713066_REALK, &
      0.000000000000000_REALK,      5.816038871330841_REALK,      0.000000000000000_REALK, &
      1.979137440547414_REALK,      0.000000000000000_REALK,     -1.902007529227955_REALK, &
     32.053625482432643_REALK,     28.594860630270510_REALK,      0.000000000000000_REALK, &
      1.326044444288091_REALK,      0.000000000000000_REALK,      2.332272313250845_REALK, &
      0.188490846777937_REALK,      0.000000000000000_REALK,      2.393950921714721_REALK, &
      0.000000000000000_REALK,     -3.166624201665044_REALK,      0.000000000000000_REALK, &
      0.133342748566138_REALK,      0.000000000000000_REALK,      0.703577324258993_REALK, &
     54.239772480292558_REALK,     37.424468347709059_REALK,      0.000000000000000_REALK, &
     -4.895863195595171_REALK,      0.000000000000000_REALK,      3.187617727962020_REALK, &
     -2.575408148826997_REALK,      0.000000000000000_REALK,      2.467386081812969_REALK, &
      0.000000000000000_REALK,     -4.220560242852829_REALK,      0.000000000000000_REALK, &
     -0.371809715881244_REALK,      0.000000000000000_REALK,      0.726237965250680_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.492900984637716_REALK, &
      0.000000000000000_REALK,     -2.758734251097314_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.562076590983474_REALK,      0.000000000000000_REALK, &
     -0.374955318133523_REALK,      0.000000000000000_REALK,     -0.176002419164099_REALK, &
      0.000000000000000_REALK,     -0.832228231540956_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.935393623655359_REALK, &
      0.000000000000000_REALK,     -2.924721065893961_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.175479689709105_REALK,      0.000000000000000_REALK, &
     -0.580589359695724_REALK,      0.000000000000000_REALK,      1.560338965618971_REALK, &
      0.000000000000000_REALK,     -0.666341969800319_REALK,      0.000000000000000_REALK, &
      0.099790419376301_REALK,      3.528431796336110_REALK,      0.000000000000000_REALK, &
      1.362937382497282_REALK,      0.000000000000000_REALK,      0.021782724612533_REALK, &
      0.774215522250463_REALK,      0.000000000000000_REALK,      0.886196928210010_REALK, &
      0.000000000000000_REALK,      0.298581595731446_REALK,      0.000000000000000_REALK, &
      0.411157750002779_REALK,      0.000000000000000_REALK,      0.010952002339008_REALK, &
      6.926999566567689_REALK,      8.840291207267020_REALK,      0.000000000000000_REALK, &
      1.860938200960534_REALK,      0.000000000000000_REALK,      1.221278719117000_REALK, &
     -0.095994546831524_REALK,      0.000000000000000_REALK,      1.748514737576984_REALK, &
      0.000000000000000_REALK,     -1.547794526743526_REALK,      0.000000000000000_REALK, &
      0.423979312408612_REALK,      0.000000000000000_REALK,      0.463741811633179_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.778806491862817_REALK, &
      0.000000000000000_REALK,     -0.901304513583896_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.548320948124843_REALK,      0.000000000000000_REALK, &
      0.326006925359643_REALK,      0.000000000000000_REALK,     -0.372453018318223_REALK, &
      0.000000000000000_REALK,     -0.453161361423541_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.068561375537228_REALK, &
      0.000000000000000_REALK,     -2.111001315889022_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.314547482588506_REALK,      0.000000000000000_REALK, &
      0.022601173940373_REALK,      0.000000000000000_REALK,      0.343480659198688_REALK, &
      0.000000000000000_REALK,     -0.801585714437241_REALK,      0.000000000000000_REALK, &
     -2.720064311438772_REALK,      1.027259220430997_REALK,      0.000000000000000_REALK, &
      1.182953457290123_REALK,      0.000000000000000_REALK,     -0.989580833423544_REALK, &
      1.178315785286034_REALK,      0.000000000000000_REALK,      0.430008767902057_REALK, &
      0.000000000000000_REALK,      1.156744143100116_REALK,      0.000000000000000_REALK, &
      0.594769904207717_REALK,      0.000000000000000_REALK,     -0.696563378232277_REALK, &
      3.158300310464023_REALK,      9.234913689720498_REALK,      0.000000000000000_REALK, &
      4.767209328463926_REALK,      0.000000000000000_REALK,      0.928050911673806_REALK, &
      1.161035968179058_REALK,      0.000000000000000_REALK,      3.044278049998707_REALK, &
      0.000000000000000_REALK,     -2.154561895840285_REALK,      0.000000000000000_REALK, &
      1.810196358792573_REALK,      0.000000000000000_REALK,      0.493357008570527_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.456046515805107_REALK, &
      0.000000000000000_REALK,      1.197767110664571_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.304127200435903_REALK,      0.000000000000000_REALK, &
      2.611409707902491_REALK,      0.000000000000000_REALK,     -0.187444752328209_REALK, &
      0.000000000000000_REALK,      0.843105158022938_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     12.034402845949915_REALK, &
      0.000000000000000_REALK,     -2.709964653092745_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -5.779200731372238_REALK,      0.000000000000000_REALK, &
      5.553976736931101_REALK,      0.000000000000000_REALK,     -6.899415511032293_REALK, &
      0.000000000000000_REALK,     -1.440632230154661_REALK,      0.000000000000000_REALK, &
    -15.033660536843350_REALK,      0.896794872476420_REALK,      0.000000000000000_REALK, &
      1.670101987272728_REALK,      0.000000000000000_REALK,     -6.514858349794101_REALK, &
      4.180714149593612_REALK,      0.000000000000000_REALK,      0.454608947138930_REALK, &
      0.000000000000000_REALK,     50.355645194635258_REALK,      0.000000000000000_REALK, &
      2.083464999288866_REALK,      0.000000000000000_REALK,    -24.382006818552949_REALK, &
     -1.989789774057248_REALK,      1.021257412340258_REALK,      0.000000000000000_REALK, &
      6.024684211165247_REALK,      0.000000000000000_REALK,     -1.364236359540145_REALK, &
      5.264453680571704_REALK,      0.000000000000000_REALK,      0.866081830165236_REALK, &
      0.000000000000000_REALK,     65.030551978822231_REALK,      0.000000000000000_REALK, &
      8.963169082764042_REALK,      0.000000000000000_REALK,     -6.088890669199627_REALK, &
      2.956126948080313_REALK,      6.594025257920351_REALK,      0.000000000000000_REALK, &
      7.090917337564129_REALK,      0.000000000000000_REALK,      1.133573257574496_REALK, &
      8.352795798665193_REALK,      0.000000000000000_REALK,      2.847739861873701_REALK, &
      0.000000000000000_REALK,     30.771482013539625_REALK,      0.000000000000000_REALK, &
      7.595838165534335_REALK,      0.000000000000000_REALK,      3.642873807469019_REALK, &
      3.075120221334543_REALK,      3.406892613860774_REALK,      0.000000000000000_REALK, &
      1.993097684053224_REALK,      0.000000000000000_REALK,      1.102080465897723_REALK, &
      0.916347587995105_REALK,      0.000000000000000_REALK,      1.598620550665300_REALK, &
      0.000000000000000_REALK,    -16.721349920141972_REALK,      0.000000000000000_REALK, &
      2.352163432122069_REALK,      0.000000000000000_REALK,      3.901876047342975_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.796502125962459_REALK, &
      0.000000000000000_REALK,     -0.533300329055835_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.198891150013644_REALK,      0.000000000000000_REALK, &
      2.327548280118798_REALK,      0.000000000000000_REALK,     -5.253607554213763_REALK, &
      0.000000000000000_REALK,     -1.713824657780829_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.590247019915411_REALK, &
      0.000000000000000_REALK,     -1.250853017478184_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.223109720775433_REALK,      0.000000000000000_REALK, &
      0.830887077714291_REALK,      0.000000000000000_REALK,     -8.973039331542452_REALK, &
      0.000000000000000_REALK,     -4.428599887821401_REALK,      0.000000000000000_REALK, &
      8.744533024106582_REALK,      5.821317068245651_REALK,      0.000000000000000_REALK, &
      0.446950985620193_REALK,      0.000000000000000_REALK,      2.822555184245709_REALK, &
      1.642896779501506_REALK,      0.000000000000000_REALK,      2.190155709779041_REALK, &
      0.000000000000000_REALK,    -14.038274947213456_REALK,      0.000000000000000_REALK, &
      0.383694686928774_REALK,      0.000000000000000_REALK,      7.269249622006520_REALK, &
      1.439105464343200_REALK,      1.082641067462852_REALK,      0.000000000000000_REALK, &
     -2.630301630870363_REALK,      0.000000000000000_REALK,      0.803273538060483_REALK, &
     -2.545427769363629_REALK,      0.000000000000000_REALK,      0.549617897758230_REALK, &
      0.000000000000000_REALK,    -16.387047559978420_REALK,      0.000000000000000_REALK, &
     -2.490081913013870_REALK,      0.000000000000000_REALK,      2.281354600002889_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.500062845505657_REALK, &
      0.000000000000000_REALK,     -2.215444289707560_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.176877219264073_REALK,      0.000000000000000_REALK, &
     -0.564416342638400_REALK,      0.000000000000000_REALK,     -5.578510690250020_REALK, &
      0.000000000000000_REALK,     -5.705687405306456_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.586060341941269_REALK, &
      0.000000000000000_REALK,     -1.446903421913706_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.538064059106810_REALK,      0.000000000000000_REALK, &
     -0.892565216980230_REALK,      0.000000000000000_REALK,     -0.785167785439939_REALK, &
      0.000000000000000_REALK,     -4.109309744365325_REALK,      0.000000000000000_REALK, &
     -1.869959253360384_REALK,      0.235259325566119_REALK,      0.000000000000000_REALK, &
      0.154730517513344_REALK,      0.000000000000000_REALK,     -1.810753016890747_REALK, &
      0.813978775582942_REALK,      0.000000000000000_REALK,      0.265535040847387_REALK, &
      0.000000000000000_REALK,      3.210434546765649_REALK,      0.000000000000000_REALK, &
      0.398495222422847_REALK,      0.000000000000000_REALK,     -7.772399371232499_REALK, &
     -0.449101043249107_REALK,      0.665174068342088_REALK,      0.000000000000000_REALK, &
      1.107030457996667_REALK,      0.000000000000000_REALK,     -0.752031716011883_REALK, &
      2.052608207117231_REALK,      0.000000000000000_REALK,      1.013054790011498_REALK, &
      0.000000000000000_REALK,      7.603674209612245_REALK,      0.000000000000000_REALK, &
      3.144046091437211_REALK,      0.000000000000000_REALK,     -3.559706902197231_REALK, &
     15.647445754106514_REALK,      3.676619080955428_REALK,      0.000000000000000_REALK, &
     -2.008522647047143_REALK,      0.000000000000000_REALK,      4.121161564678256_REALK, &
      0.328527800119489_REALK,      0.000000000000000_REALK,      1.174809929869413_REALK, &
      0.000000000000000_REALK,    -11.989171916634472_REALK,      0.000000000000000_REALK, &
     -1.311998559996348_REALK,      0.000000000000000_REALK,      8.076022512844373_REALK, &
      7.191304304957538_REALK,      1.837078476046693_REALK,      0.000000000000000_REALK, &
     -2.321643517605646_REALK,      0.000000000000000_REALK,      1.628458767573881_REALK, &
      0.963529796970529_REALK,      0.000000000000000_REALK,      0.573668541526040_REALK, &
      0.000000000000000_REALK,     -4.469205894709360_REALK,      0.000000000000000_REALK, &
     -1.414046172894106_REALK,      0.000000000000000_REALK,      2.975541943293516_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.736230046451126_REALK, &
      0.000000000000000_REALK,     -1.547814081873527_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.087850390688799_REALK,      0.000000000000000_REALK, &
     -1.664360860504229_REALK,      0.000000000000000_REALK,     -0.758421620371970_REALK, &
      0.000000000000000_REALK,     -3.033169453497039_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.913752337881485_REALK, &
      0.000000000000000_REALK,     -0.558151077855906_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.934337804059617_REALK,      0.000000000000000_REALK, &
     -0.856018364740490_REALK,      0.000000000000000_REALK,      1.574416867225715_REALK, &
      0.000000000000000_REALK,     -1.019861218426205_REALK,      0.000000000000000_REALK, &
      0.504830912804713_REALK,      1.362779712332452_REALK,      0.000000000000000_REALK, &
      0.831715811108638_REALK,      0.000000000000000_REALK,      0.398881028994695_REALK, &
      1.277250794173957_REALK,      0.000000000000000_REALK,      1.306369060558239_REALK, &
      0.000000000000000_REALK,      2.200920182774587_REALK,      0.000000000000000_REALK, &
      1.629869518431846_REALK,      0.000000000000000_REALK,      1.302776785764112_REALK, &
      1.334260117712501_REALK,      1.645904317543721_REALK,      0.000000000000000_REALK, &
      0.546417858244671_REALK,      0.000000000000000_REALK,      0.906422880234065_REALK, &
      0.294613579028160_REALK,      0.000000000000000_REALK,      1.541910498078340_REALK, &
      0.000000000000000_REALK,     -2.365902161376031_REALK,      0.000000000000000_REALK, &
      0.998422120440863_REALK,      0.000000000000000_REALK,      2.760380297618857_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.113843163164904_REALK, &
      0.000000000000000_REALK,     -0.187657376879342_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.091239107994126_REALK,      0.000000000000000_REALK, &
      1.779561574901086_REALK,      0.000000000000000_REALK,     -1.127287684099039_REALK, &
      0.000000000000000_REALK,     -0.612903739473269_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.855462935236318_REALK, &
      0.000000000000000_REALK,     -1.028783133297336_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.179720677292956_REALK,      0.000000000000000_REALK, &
      1.335686473891630_REALK,      0.000000000000000_REALK,     -3.808783366772850_REALK, &
      0.000000000000000_REALK,     -3.133010820449758_REALK,      0.000000000000000_REALK, &
     27.188625582317318_REALK,     -2.137438530464277_REALK,      0.000000000000000_REALK, &
     -4.364842159632134_REALK,      0.000000000000000_REALK,      5.772378656270876_REALK, &
     -1.978756441406430_REALK,      0.000000000000000_REALK,     -0.561479403101888_REALK, &
      0.000000000000000_REALK,    -14.405853318338595_REALK,      0.000000000000000_REALK, &
     -2.088041030015330_REALK,      0.000000000000000_REALK,      8.284123251843427_REALK, &
      5.718907826014892_REALK,     -1.922527049183726_REALK,      0.000000000000000_REALK, &
     -6.570891895247241_REALK,      0.000000000000000_REALK,      2.112115362011166_REALK, &
     -2.640378448329523_REALK,      0.000000000000000_REALK,     -0.650555389162751_REALK, &
      0.000000000000000_REALK,    -16.910652487924217_REALK,      0.000000000000000_REALK, &
     -3.121173580696672_REALK,      0.000000000000000_REALK,      3.009764323802558_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.340628995024221_REALK, &
      0.000000000000000_REALK,     -0.880793353965868_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.427686492289380_REALK,      0.000000000000000_REALK, &
     -2.632629215826342_REALK,      0.000000000000000_REALK,     -0.117828142348579_REALK, &
      0.000000000000000_REALK,     -1.264054411214185_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.598143150151621_REALK, &
      0.000000000000000_REALK,     -0.572706649412678_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.770985600095131_REALK,      0.000000000000000_REALK, &
     -1.622365687015074_REALK,      0.000000000000000_REALK,     -0.456909239327733_REALK, &
      0.000000000000000_REALK,     -0.816106957228630_REALK,      0.000000000000000_REALK, &
      1.959138330824078_REALK,      1.254663890183392_REALK,      0.000000000000000_REALK, &
      0.065864305616313_REALK,      0.000000000000000_REALK,      1.247825667166423_REALK, &
      0.247230974471663_REALK,      0.000000000000000_REALK,      0.988755356628635_REALK, &
      0.000000000000000_REALK,     -1.152785648017409_REALK,      0.000000000000000_REALK, &
      0.094523948984164_REALK,      0.000000000000000_REALK,      2.984656828426225_REALK, &
      0.771309142893924_REALK,      0.547760458899486_REALK,      0.000000000000000_REALK, &
     -0.932771163918344_REALK,      0.000000000000000_REALK,      0.854583045816176_REALK, &
     -0.858425104106424_REALK,      0.000000000000000_REALK,      0.556062686335605_REALK, &
      0.000000000000000_REALK,     -2.915786977723829_REALK,      0.000000000000000_REALK, &
     -1.329198878966525_REALK,      0.000000000000000_REALK,      2.029634688589242_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.323334455616958_REALK, &
      0.000000000000000_REALK,     -0.979427528752871_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.531306358468441_REALK,      0.000000000000000_REALK, &
     -0.424680369878636_REALK,      0.000000000000000_REALK,     -1.374277199701464_REALK, &
      0.000000000000000_REALK,     -2.342679060512547_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.889548784428190_REALK, &
      0.000000000000000_REALK,     -1.539325117426884_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.544373368021553_REALK,      0.000000000000000_REALK, &
     -1.505052310911933_REALK,      0.000000000000000_REALK,     -0.419120405137284_REALK, &
      0.000000000000000_REALK,     -3.655897072428412_REALK,      0.000000000000000_REALK, &
     -1.256845450833596_REALK,      0.152115772336205_REALK,      0.000000000000000_REALK, &
      0.068404937598657_REALK,      0.000000000000000_REALK,     -1.334195403268458_REALK, &
      0.367474271781730_REALK,      0.000000000000000_REALK,      0.199794922371787_REALK, &
      0.000000000000000_REALK,      0.790896933560630_REALK,      0.000000000000000_REALK, &
      0.163616817215760_REALK,      0.000000000000000_REALK,     -4.467740755652036_REALK, &
     -0.722106369527259_REALK,      1.009631161813292_REALK,      0.000000000000000_REALK, &
      1.177742594247931_REALK,      0.000000000000000_REALK,     -1.333446876995238_REALK, &
      2.076676975585312_REALK,      0.000000000000000_REALK,      1.708223022565957_REALK, &
      0.000000000000000_REALK,      4.058820387643602_REALK,      0.000000000000000_REALK, &
      2.797138599013194_REALK,      0.000000000000000_REALK,     -4.433710767217539_REALK, &
     56.921752452083197_REALK,    -18.465995536142056_REALK,      0.000000000000000_REALK, &
     -5.521484611842427_REALK,      0.000000000000000_REALK,      8.933749772023360_REALK, &
     -4.501667840999641_REALK,      0.000000000000000_REALK,     -3.670209204993494_REALK, &
      0.000000000000000_REALK,    -12.409296866473357_REALK,      0.000000000000000_REALK, &
     -1.821478869619545_REALK,      0.000000000000000_REALK,      8.841446230588554_REALK, &
     61.358322501540385_REALK,    -18.742838631353383_REALK,      0.000000000000000_REALK, &
    -12.590508547744188_REALK,      0.000000000000000_REALK,      7.749091424931501_REALK, &
      6.982384802426012_REALK,      0.000000000000000_REALK,     -2.939938693071755_REALK, &
      0.000000000000000_REALK,     -7.172978516430408_REALK,      0.000000000000000_REALK, &
     -2.877667322425324_REALK,      0.000000000000000_REALK,      5.313361351716087_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -6.536262163043411_REALK, &
      0.000000000000000_REALK,      0.513007650973321_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.982338777797146_REALK,      0.000000000000000_REALK, &
     -3.897344637081698_REALK,      0.000000000000000_REALK,      0.596417840114078_REALK, &
      0.000000000000000_REALK,      0.507707253695990_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -7.259409628092707_REALK, &
      0.000000000000000_REALK,      1.442056770518694_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.542508475828424_REALK,      0.000000000000000_REALK, &
     -3.416059809444079_REALK,      0.000000000000000_REALK,      1.337708760458420_REALK, &
      0.000000000000000_REALK,      0.988782850954978_REALK,      0.000000000000000_REALK, &
      5.108612159825119_REALK,      0.997352498130547_REALK,      0.000000000000000_REALK, &
     -0.390764899923818_REALK,      0.000000000000000_REALK,      2.405357921294453_REALK, &
      0.055433371126793_REALK,      0.000000000000000_REALK,      0.594686429783478_REALK, &
      0.000000000000000_REALK,     -1.177984693725829_REALK,      0.000000000000000_REALK, &
     -0.386727515281107_REALK,      0.000000000000000_REALK,      3.967509588012660_REALK, &
      9.491793246719803_REALK,      1.968411498536855_REALK,      0.000000000000000_REALK, &
     -1.709008983878324_REALK,      0.000000000000000_REALK,      3.596224798365338_REALK, &
      0.518588540865941_REALK,      0.000000000000000_REALK,      0.926275241801725_REALK, &
      0.000000000000000_REALK,     -1.234549280949998_REALK,      0.000000000000000_REALK, &
     -1.171825416262260_REALK,      0.000000000000000_REALK,      4.109738120230931_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.412955764001002_REALK, &
      0.000000000000000_REALK,     -0.903397453386725_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.044469691535219_REALK,      0.000000000000000_REALK, &
     -1.404160214686298_REALK,      0.000000000000000_REALK,     -0.223553986814391_REALK, &
      0.000000000000000_REALK,     -1.490105911626317_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.937229898699983_REALK, &
      0.000000000000000_REALK,     -1.232599060773387_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.508630703502730_REALK,      0.000000000000000_REALK, &
     -2.303620065103174_REALK,      0.000000000000000_REALK,      1.304725217728276_REALK, &
      0.000000000000000_REALK,     -1.408604753886304_REALK,      0.000000000000000_REALK, &
      0.494454886823866_REALK,      1.109039354283498_REALK,      0.000000000000000_REALK, &
      0.485439404187055_REALK,      0.000000000000000_REALK,      0.388018291966421_REALK, &
      0.646541789793905_REALK,      0.000000000000000_REALK,      1.102135663042008_REALK, &
      0.000000000000000_REALK,      0.648747963274309_REALK,      0.000000000000000_REALK, &
      0.800706403592035_REALK,      0.000000000000000_REALK,      0.896021665674454_REALK, &
      5.283264608594198_REALK,      5.290710810215006_REALK,      0.000000000000000_REALK, &
      1.206687876424854_REALK,      0.000000000000000_REALK,      3.336181532103781_REALK, &
      0.475698499043448_REALK,      0.000000000000000_REALK,      4.149415606338430_REALK, &
      0.000000000000000_REALK,     -1.960632077109598_REALK,      0.000000000000000_REALK, &
      1.378993651124902_REALK,      0.000000000000000_REALK,      5.337587737735813_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.510755175947495_REALK, &
      0.000000000000000_REALK,     -0.182546898846347_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.076975089062119_REALK,      0.000000000000000_REALK, &
      2.101891165131701_REALK,      0.000000000000000_REALK,     -0.553802900870852_REALK, &
      0.000000000000000_REALK,     -0.421541921487981_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.583100559522471_REALK, &
      0.000000000000000_REALK,     -3.786540879197730_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -3.174731215320404_REALK,      0.000000000000000_REALK, &
      5.032228284059121_REALK,      0.000000000000000_REALK,     -5.260588656600167_REALK, &
      0.000000000000000_REALK,     -6.058121829028958_REALK,      0.000000000000000_REALK/
    ! results of test 6, ket-major order, dd/dxdz
  data REF_CONTR_INTS(36541:37800)                                                         &
     /0.000000000000000_REALK,      0.000000000000000_REALK,     -2.007973229731048_REALK, &
      0.000000000000000_REALK,      0.784646442899580_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      4.868492175230356_REALK,      0.000000000000000_REALK, &
      2.295583909107734_REALK,      0.000000000000000_REALK,     21.263882242809874_REALK, &
      0.000000000000000_REALK,      7.628368538887436_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,    -10.110998805077370_REALK, &
      0.000000000000000_REALK,     -6.444278722264309_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.908676150855705_REALK,      0.000000000000000_REALK, &
     -0.690326245291721_REALK,      0.000000000000000_REALK,     17.578272342011676_REALK, &
      0.000000000000000_REALK,      5.122535896143644_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.063302760179718_REALK, &
      0.000000000000000_REALK,      1.241365116617189_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.592149160127781_REALK,      0.000000000000000_REALK, &
      1.972883013552031_REALK,      0.000000000000000_REALK,      6.096792407908051_REALK, &
      0.000000000000000_REALK,      3.493207915708023_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.038525389244614_REALK, &
      0.000000000000000_REALK,     -0.699091396115598_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.167755182186871_REALK,      0.000000000000000_REALK, &
      0.205033780586002_REALK,      0.000000000000000_REALK,      0.221676494806465_REALK, &
      0.000000000000000_REALK,      1.195541944318073_REALK,      0.000000000000000_REALK, &
     -1.891530617869040_REALK,     -0.063302760179718_REALK,      0.000000000000000_REALK, &
      1.902216917409395_REALK,      0.000000000000000_REALK,     -0.424773219431562_REALK, &
      5.499360953151936_REALK,      0.000000000000000_REALK,     -0.934328779472125_REALK, &
      0.000000000000000_REALK,     17.928611899048871_REALK,      0.000000000000000_REALK, &
     -2.535031329243154_REALK,      0.000000000000000_REALK,     -3.231950370510727_REALK, &
     -2.245118939992585_REALK,     -2.038525389244614_REALK,      0.000000000000000_REALK, &
     -1.325542807260906_REALK,      0.000000000000000_REALK,      0.773483100563791_REALK, &
      0.703585042159742_REALK,      0.000000000000000_REALK,     -0.330796079386869_REALK, &
      0.000000000000000_REALK,      9.107902792496375_REALK,      0.000000000000000_REALK, &
     -3.657291290148381_REALK,      0.000000000000000_REALK,     -2.918814983726261_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.190551008398621_REALK, &
      0.000000000000000_REALK,      1.546295902073605_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.071081388287194_REALK,      0.000000000000000_REALK, &
      2.078740984432865_REALK,      0.000000000000000_REALK,      3.466495079181182_REALK, &
      0.000000000000000_REALK,      2.328809364268813_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.367388583914372_REALK, &
      0.000000000000000_REALK,     -0.843616364405123_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.395144379029249_REALK,      0.000000000000000_REALK, &
      0.297308254498012_REALK,      0.000000000000000_REALK,      2.459837206204790_REALK, &
      0.000000000000000_REALK,      1.071981212438575_REALK,      0.000000000000000_REALK, &
     -0.239196096204769_REALK,      0.724022810769969_REALK,      0.000000000000000_REALK, &
      1.383122906827116_REALK,      0.000000000000000_REALK,     -0.498540576782245_REALK, &
      2.206386506224024_REALK,      0.000000000000000_REALK,     -0.598691391245336_REALK, &
      0.000000000000000_REALK,      4.129718741629424_REALK,      0.000000000000000_REALK, &
     -0.986507748135628_REALK,      0.000000000000000_REALK,     -2.030133053909236_REALK, &
     -2.762699748376050_REALK,     -0.931080059284198_REALK,      0.000000000000000_REALK, &
     -0.207457714974776_REALK,      0.000000000000000_REALK,      0.409085417556688_REALK, &
      0.015242478310692_REALK,      0.000000000000000_REALK,     -0.132628143799372_REALK, &
      0.000000000000000_REALK,     -0.725443988239485_REALK,      0.000000000000000_REALK, &
     -0.425311085460374_REALK,      0.000000000000000_REALK,     -1.147046580138042_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.166659627663694_REALK, &
      0.000000000000000_REALK,     -0.335367581535756_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.617140549879661_REALK,      0.000000000000000_REALK, &
      0.601109383161642_REALK,      0.000000000000000_REALK,     -1.407904850009757_REALK, &
      0.000000000000000_REALK,      1.043357497921092_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.571815390544211_REALK, &
      0.000000000000000_REALK,     -0.227073231873659_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.139587790907156_REALK,      0.000000000000000_REALK, &
      0.370946766256344_REALK,      0.000000000000000_REALK,      0.990146138217552_REALK, &
      0.000000000000000_REALK,      2.120069688527255_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.042600084979177_REALK, &
      0.000000000000000_REALK,      1.966462487880807_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.846338403359447_REALK,      0.000000000000000_REALK, &
      2.538772457870516_REALK,      0.000000000000000_REALK,      2.120852952000573_REALK, &
      0.000000000000000_REALK,      1.841577246329267_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.258278653991340_REALK, &
      0.000000000000000_REALK,      0.301041890904021_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.398302130328830_REALK,      0.000000000000000_REALK, &
      0.842065217443024_REALK,      0.000000000000000_REALK,     -0.024453703915457_REALK, &
      0.000000000000000_REALK,      0.750098924333474_REALK,      0.000000000000000_REALK, &
      1.472292159312946_REALK,      1.374103353403729_REALK,      0.000000000000000_REALK, &
      1.457533376735307_REALK,      0.000000000000000_REALK,     -0.692819518204187_REALK, &
      1.706691218420259_REALK,      0.000000000000000_REALK,     -0.542996083769181_REALK, &
      0.000000000000000_REALK,      2.544346760404039_REALK,      0.000000000000000_REALK, &
     -0.646429512152753_REALK,      0.000000000000000_REALK,     -1.754312851894571_REALK, &
     -0.448007046589204_REALK,     -0.078417122416250_REALK,      0.000000000000000_REALK, &
      0.187631305418268_REALK,      0.000000000000000_REALK,     -0.227767310078620_REALK, &
      0.586661121090821_REALK,      0.000000000000000_REALK,     -0.412480146227534_REALK, &
      0.000000000000000_REALK,      1.670616363607198_REALK,      0.000000000000000_REALK, &
     -0.754278699410477_REALK,      0.000000000000000_REALK,     -1.252298555347053_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.298021690281402_REALK, &
      0.000000000000000_REALK,     -0.283429416898958_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.326727307363027_REALK,      0.000000000000000_REALK, &
      0.513685736947729_REALK,      0.000000000000000_REALK,     -0.463261457957566_REALK, &
      0.000000000000000_REALK,      0.548302121139384_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.021107259380686_REALK, &
      0.000000000000000_REALK,      0.034957239151241_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.056304043710069_REALK,      0.000000000000000_REALK, &
      0.505627956648819_REALK,      0.000000000000000_REALK,      0.016150410422268_REALK, &
      0.000000000000000_REALK,      0.639986410577626_REALK,      0.000000000000000_REALK, &
      0.947762795454340_REALK,      1.370475041294047_REALK,      0.000000000000000_REALK, &
      1.997232769095131_REALK,      0.000000000000000_REALK,      0.181830738706407_REALK, &
      3.187578787088979_REALK,      0.000000000000000_REALK,      0.220795369074609_REALK, &
      0.000000000000000_REALK,      6.264619314191912_REALK,      0.000000000000000_REALK, &
      0.361137744790740_REALK,      0.000000000000000_REALK,     -0.902264624796057_REALK, &
     -0.724342925364422_REALK,     -0.200968790955777_REALK,      0.000000000000000_REALK, &
      0.631093487587518_REALK,      0.000000000000000_REALK,     -0.216088360044353_REALK, &
      2.248417787255832_REALK,      0.000000000000000_REALK,     -0.620299413988378_REALK, &
      0.000000000000000_REALK,      6.317992079462829_REALK,      0.000000000000000_REALK, &
     -1.488678255837162_REALK,      0.000000000000000_REALK,     -2.742626958394148_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.652479334468778_REALK, &
      0.000000000000000_REALK,      2.770587765206690_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.034547655222911_REALK,      0.000000000000000_REALK, &
      3.662706467709802_REALK,      0.000000000000000_REALK,      1.743321941074763_REALK, &
      0.000000000000000_REALK,      1.759371491587673_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.210082009772104_REALK, &
      0.000000000000000_REALK,     -0.110661370713986_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.772329039901908_REALK,      0.000000000000000_REALK, &
      1.095731104373929_REALK,      0.000000000000000_REALK,      1.594577131477581_REALK, &
      0.000000000000000_REALK,      0.930750459800047_REALK,      0.000000000000000_REALK, &
      4.161436440065573_REALK,      2.224668473491938_REALK,      0.000000000000000_REALK, &
      1.680887045721388_REALK,      0.000000000000000_REALK,     -1.094584762479397_REALK, &
      1.410602012777335_REALK,      0.000000000000000_REALK,     -0.580072496428230_REALK, &
      0.000000000000000_REALK,      1.462957426682938_REALK,      0.000000000000000_REALK, &
     -0.505501631208539_REALK,      0.000000000000000_REALK,     -1.879393381952750_REALK, &
     -3.775899967736221_REALK,     -0.661128923174980_REALK,      0.000000000000000_REALK, &
     -0.019814056415620_REALK,      0.000000000000000_REALK,      0.067583616619431_REALK, &
     -0.005609519968640_REALK,      0.000000000000000_REALK,     -0.277609628867568_REALK, &
      0.000000000000000_REALK,     -0.561900982497604_REALK,      0.000000000000000_REALK, &
     -0.268871978703311_REALK,      0.000000000000000_REALK,     -1.254306058459091_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.527254524811554_REALK, &
      0.000000000000000_REALK,     -0.332540458882170_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.289224902889814_REALK,      0.000000000000000_REALK, &
      0.599666275379072_REALK,      0.000000000000000_REALK,     -0.314330685354412_REALK, &
      0.000000000000000_REALK,      0.436215264425194_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.277653120793157_REALK, &
      0.000000000000000_REALK,     -0.011389791081850_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.096042804878278_REALK,      0.000000000000000_REALK, &
      0.530955361790253_REALK,      0.000000000000000_REALK,      0.219822510950273_REALK, &
      0.000000000000000_REALK,      0.703874107008584_REALK,      0.000000000000000_REALK, &
      1.874431281717542_REALK,      1.474510313279929_REALK,      0.000000000000000_REALK, &
      1.367841947161625_REALK,      0.000000000000000_REALK,      0.201009779657673_REALK, &
      1.416913597153980_REALK,      0.000000000000000_REALK,      0.156749556330272_REALK, &
      0.000000000000000_REALK,      1.722026867670873_REALK,      0.000000000000000_REALK, &
      0.167710973904112_REALK,      0.000000000000000_REALK,     -0.676340164779221_REALK, &
     -2.938059493338335_REALK,     -0.730959175933421_REALK,      0.000000000000000_REALK, &
     -0.026668410118688_REALK,      0.000000000000000_REALK,      0.030857599413780_REALK, &
      0.035274542099661_REALK,      0.000000000000000_REALK,     -0.180103475490717_REALK, &
      0.000000000000000_REALK,     -0.617257615698524_REALK,      0.000000000000000_REALK, &
     -0.212348831869497_REALK,      0.000000000000000_REALK,     -1.322035473494754_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.199091123430418_REALK, &
      0.000000000000000_REALK,     -1.171716210498047_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.400141968949348_REALK,      0.000000000000000_REALK, &
     -0.145492954985301_REALK,      0.000000000000000_REALK,     -2.074048792036812_REALK, &
      0.000000000000000_REALK,     -0.163975616386533_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.526920535278414_REALK, &
      0.000000000000000_REALK,      0.034262311853534_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.379172140881652_REALK,      0.000000000000000_REALK, &
      1.007468046247442_REALK,      0.000000000000000_REALK,     -0.988883330634010_REALK, &
      0.000000000000000_REALK,      2.117027988153923_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     21.322965548391078_REALK, &
      0.000000000000000_REALK,      5.246504776415646_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.958331429484087_REALK,      0.000000000000000_REALK, &
      6.994930829719670_REALK,      0.000000000000000_REALK,      1.726398447659577_REALK, &
      0.000000000000000_REALK,      2.091942667648477_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     15.735383059303384_REALK, &
      0.000000000000000_REALK,      4.229296203899287_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.705691259189686_REALK,      0.000000000000000_REALK, &
      6.308084565348791_REALK,      0.000000000000000_REALK,     -0.417193924760103_REALK, &
      0.000000000000000_REALK,      1.731535160551735_REALK,      0.000000000000000_REALK, &
     18.116312936243755_REALK,      5.363172076349015_REALK,      0.000000000000000_REALK, &
      2.880905600870508_REALK,      0.000000000000000_REALK,     -2.456188361856750_REALK, &
      1.743321941074762_REALK,      0.000000000000000_REALK,     -0.833212819554650_REALK, &
      0.000000000000000_REALK,      1.424468527709419_REALK,      0.000000000000000_REALK, &
     -0.544010304478621_REALK,      0.000000000000000_REALK,     -2.648036891660549_REALK, &
      5.026724465672621_REALK,      2.321737266812735_REALK,      0.000000000000000_REALK, &
      1.660838746841487_REALK,      0.000000000000000_REALK,     -3.801579066269349_REALK, &
      1.594577131477581_REALK,      0.000000000000000_REALK,     -1.501648177726673_REALK, &
      0.000000000000000_REALK,      2.323711931845904_REALK,      0.000000000000000_REALK, &
     -1.097047960588345_REALK,      0.000000000000000_REALK,     -3.434409817913686_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.425344304567185_REALK, &
      0.000000000000000_REALK,     -0.552540355328863_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.340050273570480_REALK,      0.000000000000000_REALK, &
      0.965887025398556_REALK,      0.000000000000000_REALK,     -0.253725621903253_REALK, &
      0.000000000000000_REALK,      0.455107965274024_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.787064633841794_REALK, &
      0.000000000000000_REALK,      0.331368766719156_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.149244208041139_REALK,      0.000000000000000_REALK, &
      2.318315838887020_REALK,      0.000000000000000_REALK,     -0.004422836555428_REALK, &
      0.000000000000000_REALK,      0.996820132719230_REALK,      0.000000000000000_REALK, &
      6.602825995591690_REALK,      2.960176238929848_REALK,      0.000000000000000_REALK, &
      1.883302583578810_REALK,      0.000000000000000_REALK,      0.364975102722253_REALK, &
      1.445473175406511_REALK,      0.000000000000000_REALK,      0.187496563321047_REALK, &
      0.000000000000000_REALK,      1.399759179745009_REALK,      0.000000000000000_REALK, &
      0.144990561615213_REALK,      0.000000000000000_REALK,     -0.771090402940709_REALK, &
      3.156413242393998_REALK,      2.275252277875626_REALK,      0.000000000000000_REALK, &
      1.966467218565774_REALK,      0.000000000000000_REALK,     -1.400726698720405_REALK, &
      2.092998596064242_REALK,      0.000000000000000_REALK,     -0.863505845271654_REALK, &
      0.000000000000000_REALK,      2.876932978621070_REALK,      0.000000000000000_REALK, &
     -0.762193884943702_REALK,      0.000000000000000_REALK,     -2.921193841748347_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.268152534442383_REALK, &
      0.000000000000000_REALK,     -1.293816639553684_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.977612468092477_REALK,      0.000000000000000_REALK, &
     -0.163975616386533_REALK,      0.000000000000000_REALK,     -0.900387401961542_REALK, &
      0.000000000000000_REALK,     -0.113690357708270_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.718842408730941_REALK, &
      0.000000000000000_REALK,     -0.430032940569052_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.235778610049536_REALK,      0.000000000000000_REALK, &
      2.117027988153923_REALK,      0.000000000000000_REALK,     -0.032645232368719_REALK, &
      0.000000000000000_REALK,      1.293414299125926_REALK,      0.000000000000000_REALK, &
      7.084093085619700_REALK,      4.920599850605618_REALK,      0.000000000000000_REALK, &
      4.301094911539490_REALK,      0.000000000000000_REALK,      1.743607843686610_REALK, &
      4.499505223423653_REALK,      0.000000000000000_REALK,      1.387793855982019_REALK, &
      0.000000000000000_REALK,      5.744079730740990_REALK,      0.000000000000000_REALK, &
      1.474449232925265_REALK,      0.000000000000000_REALK,      0.099679689600662_REALK, &
      8.505541817779690_REALK,      9.718428095692042_REALK,      0.000000000000000_REALK, &
     11.023610482844763_REALK,      0.000000000000000_REALK,     -1.116519748808467_REALK, &
     13.369260671141360_REALK,      0.000000000000000_REALK,     -1.091029829978262_REALK, &
      0.000000000000000_REALK,     18.133466753179569_REALK,      0.000000000000000_REALK, &
     -1.263884778182963_REALK,      0.000000000000000_REALK,     -8.481191937318728_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -8.627958530041608_REALK, &
      0.000000000000000_REALK,     -1.069780357495832_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -7.589432792294826_REALK,      0.000000000000000_REALK, &
    -10.266151610029418_REALK,      0.000000000000000_REALK,      4.660099866463162_REALK, &
      0.000000000000000_REALK,      3.314593099119844_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -8.620085844139110_REALK, &
      0.000000000000000_REALK,     -2.199291852554054_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,    -11.467043706376549_REALK,      0.000000000000000_REALK, &
    -11.377896453456046_REALK,      0.000000000000000_REALK,      3.574511418685382_REALK, &
      0.000000000000000_REALK,      2.134671598578417_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.968860323045903_REALK, &
      0.000000000000000_REALK,     -0.485208223038026_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.023322778327782_REALK,      0.000000000000000_REALK, &
     -4.753736529732972_REALK,      0.000000000000000_REALK,      2.082819198986841_REALK, &
      0.000000000000000_REALK,      2.327548280118798_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.272919773489437_REALK, &
      0.000000000000000_REALK,     -0.592378076620113_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.036799046812541_REALK,      0.000000000000000_REALK, &
     -4.127820412262259_REALK,      0.000000000000000_REALK,     -0.040484624239909_REALK, &
      0.000000000000000_REALK,      0.830887077714291_REALK,      0.000000000000000_REALK, &
     -5.253368370049524_REALK,     -4.968860323045903_REALK,      0.000000000000000_REALK, &
     -1.439895578714875_REALK,      0.000000000000000_REALK,     -0.038357974112016_REALK, &
     -6.683440864367982_REALK,      0.000000000000000_REALK,     -0.093618443692772_REALK, &
      0.000000000000000_REALK,     12.239565789747807_REALK,      0.000000000000000_REALK, &
      0.136027856126263_REALK,      0.000000000000000_REALK,     -2.746423392632127_REALK, &
     -1.774777765588930_REALK,     -3.272919773489437_REALK,      0.000000000000000_REALK, &
     -2.015793198932588_REALK,      0.000000000000000_REALK,      0.846708253611518_REALK, &
     -6.912042680354247_REALK,      0.000000000000000_REALK,      1.747423221279447_REALK, &
      0.000000000000000_REALK,      5.996017368081704_REALK,      0.000000000000000_REALK, &
     -1.196923272703355_REALK,      0.000000000000000_REALK,     -3.310379765610975_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.244568398917928_REALK, &
      0.000000000000000_REALK,     -0.137021453304330_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.604704645703887_REALK,      0.000000000000000_REALK, &
     -1.944444188793208_REALK,      0.000000000000000_REALK,      1.105707041119855_REALK, &
      0.000000000000000_REALK,      1.452666064574803_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.797821121957492_REALK, &
      0.000000000000000_REALK,     -0.516050932098365_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.863751453536737_REALK,      0.000000000000000_REALK, &
     -2.521931802009070_REALK,      0.000000000000000_REALK,      0.813161127658611_REALK, &
      0.000000000000000_REALK,      0.673057785729938_REALK,      0.000000000000000_REALK, &
     -4.320074100928000_REALK,     -1.684905342162263_REALK,      0.000000000000000_REALK, &
     -0.351174040698063_REALK,      0.000000000000000_REALK,     -0.016248701150207_REALK, &
     -0.903580665392834_REALK,      0.000000000000000_REALK,     -0.019885676260457_REALK, &
      0.000000000000000_REALK,      3.744425719797317_REALK,      0.000000000000000_REALK, &
      0.073320587429267_REALK,      0.000000000000000_REALK,     -2.571207669012065_REALK, &
     -3.659623659608114_REALK,     -1.018932760585597_REALK,      0.000000000000000_REALK, &
     -0.373278637653759_REALK,      0.000000000000000_REALK,      0.629124574766000_REALK, &
      0.032967989752836_REALK,      0.000000000000000_REALK,      0.286432086697009_REALK, &
      0.000000000000000_REALK,     -0.769061709294030_REALK,      0.000000000000000_REALK, &
     -0.206096316762915_REALK,      0.000000000000000_REALK,     -2.287164668549965_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.622328090286026_REALK, &
      0.000000000000000_REALK,      0.197903886243526_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.718751695180461_REALK,      0.000000000000000_REALK, &
      0.374155678131880_REALK,      0.000000000000000_REALK,     -2.949826998084437_REALK, &
      0.000000000000000_REALK,     -0.807433285030285_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.125886595017154_REALK, &
      0.000000000000000_REALK,      0.486352280321393_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.753499505796591_REALK,      0.000000000000000_REALK, &
     -1.214347318252845_REALK,      0.000000000000000_REALK,     -1.062175693359101_REALK, &
      0.000000000000000_REALK,      1.030291647491714_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.688346647537960_REALK, &
      0.000000000000000_REALK,      0.035241696871132_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.082936176407624_REALK,      0.000000000000000_REALK, &
      0.325342126694209_REALK,      0.000000000000000_REALK,      0.271499339088984_REALK, &
      0.000000000000000_REALK,      0.560504959651175_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.256719747323924_REALK, &
      0.000000000000000_REALK,     -0.053021613771683_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.172445460538469_REALK,      0.000000000000000_REALK, &
     -1.022394884454766_REALK,      0.000000000000000_REALK,     -0.333025773986991_REALK, &
      0.000000000000000_REALK,      0.148985863189664_REALK,      0.000000000000000_REALK, &
     -3.065599552428698_REALK,     -0.446998264426821_REALK,      0.000000000000000_REALK, &
      0.181646214485040_REALK,      0.000000000000000_REALK,      0.011502833616730_REALK, &
      0.065562997692427_REALK,      0.000000000000000_REALK,      0.001696331894097_REALK, &
      0.000000000000000_REALK,      2.528737909510181_REALK,      0.000000000000000_REALK, &
      0.056895158214388_REALK,      0.000000000000000_REALK,     -2.730667166757759_REALK, &
     -1.498959543462914_REALK,     -0.399259070655766_REALK,      0.000000000000000_REALK, &
     -0.282632525816314_REALK,      0.000000000000000_REALK,      0.349336524409592_REALK, &
     -0.218534539510121_REALK,      0.000000000000000_REALK,      0.076572555015892_REALK, &
      0.000000000000000_REALK,      1.411492648933640_REALK,      0.000000000000000_REALK, &
     -0.336195245836472_REALK,      0.000000000000000_REALK,     -2.736132425292518_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.645611993894856_REALK, &
      0.000000000000000_REALK,     -0.072754369714285_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.052951752033527_REALK,      0.000000000000000_REALK, &
     -0.047876828702849_REALK,      0.000000000000000_REALK,     -1.035463048214976_REALK, &
      0.000000000000000_REALK,     -0.445304245254318_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.376281772542985_REALK, &
      0.000000000000000_REALK,      0.072455160361309_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.042818161387827_REALK,      0.000000000000000_REALK, &
     -0.276887695546917_REALK,      0.000000000000000_REALK,      0.009919951518860_REALK, &
      0.000000000000000_REALK,      0.330682245961476_REALK,      0.000000000000000_REALK, &
     -1.414424325749041_REALK,     -0.595736389216283_REALK,      0.000000000000000_REALK, &
      0.199225289838993_REALK,      0.000000000000000_REALK,      0.184967314047639_REALK, &
      0.161397874911339_REALK,      0.000000000000000_REALK,      0.078792517867594_REALK, &
      0.000000000000000_REALK,      5.614764984844232_REALK,      0.000000000000000_REALK, &
      2.174799800357737_REALK,      0.000000000000000_REALK,      2.662549342831122_REALK, &
     -1.749219826106720_REALK,     -1.481178904125174_REALK,      0.000000000000000_REALK, &
     -0.970533782644071_REALK,      0.000000000000000_REALK,     -0.234332078575897_REALK, &
     -1.123658065338962_REALK,      0.000000000000000_REALK,     -0.163289829319134_REALK, &
      0.000000000000000_REALK,      5.783312445631703_REALK,      0.000000000000000_REALK, &
      0.663610662254942_REALK,      0.000000000000000_REALK,     -2.315010656725312_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.108813951978477_REALK, &
      0.000000000000000_REALK,     -0.168221204011149_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.813188878372806_REALK,      0.000000000000000_REALK, &
      3.302158615215671_REALK,      0.000000000000000_REALK,     -0.592880568806241_REALK, &
      0.000000000000000_REALK,     -0.582834064897854_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -6.252537144066599_REALK, &
      0.000000000000000_REALK,      0.149645930498532_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.017132938133052_REALK,      0.000000000000000_REALK, &
     -0.071642277975646_REALK,      0.000000000000000_REALK,      0.009370096353675_REALK, &
      0.000000000000000_REALK,     -0.341455709263499_REALK,      0.000000000000000_REALK, &
     -0.213288376588447_REALK,      0.088949856638586_REALK,      0.000000000000000_REALK, &
      0.823437098635292_REALK,      0.000000000000000_REALK,      0.063614047798235_REALK, &
      0.128313933223753_REALK,      0.000000000000000_REALK,      0.005216879556121_REALK, &
      0.000000000000000_REALK,      2.042055284953991_REALK,      0.000000000000000_REALK, &
      0.056185070342429_REALK,      0.000000000000000_REALK,     -3.289716725502260_REALK, &
     -7.429662423319458_REALK,     -0.161505671386505_REALK,      0.000000000000000_REALK, &
     -0.220859332942734_REALK,      0.000000000000000_REALK,      0.554319256583917_REALK, &
      0.004136506092995_REALK,      0.000000000000000_REALK,      0.000783390303876_REALK, &
      0.000000000000000_REALK,     -0.462249469068878_REALK,      0.000000000000000_REALK, &
     -0.213335206298910_REALK,      0.000000000000000_REALK,     -3.525578845440739_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.353613592580646_REALK, &
      0.000000000000000_REALK,     -0.205131766209642_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.327503557467550_REALK,      0.000000000000000_REALK, &
     -0.405268923774496_REALK,      0.000000000000000_REALK,     -0.540967772586140_REALK, &
      0.000000000000000_REALK,     -0.273509372817343_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.822608395050520_REALK, &
      0.000000000000000_REALK,      0.075814353308552_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.003228209389838_REALK,      0.000000000000000_REALK, &
     -0.015309312227038_REALK,      0.000000000000000_REALK,     -0.208999457831603_REALK, &
      0.000000000000000_REALK,      0.280976720658328_REALK,      0.000000000000000_REALK, &
     -0.075259217362676_REALK,      0.169445508991214_REALK,      0.000000000000000_REALK, &
      0.485120127194595_REALK,      0.000000000000000_REALK,      0.782296521462220_REALK, &
      0.451566987868269_REALK,      0.000000000000000_REALK,      0.346355014468018_REALK, &
      0.000000000000000_REALK,      1.690437338047142_REALK,      0.000000000000000_REALK, &
      1.153627638107253_REALK,      0.000000000000000_REALK,      2.453102050373645_REALK, &
     -4.876396043080628_REALK,     -0.868757354997319_REALK,      0.000000000000000_REALK, &
     -0.215867042343484_REALK,      0.000000000000000_REALK,     -0.209133268380305_REALK, &
      0.000485020068320_REALK,      0.000000000000000_REALK,     -0.002422267928165_REALK, &
      0.000000000000000_REALK,     -0.778079683671449_REALK,      0.000000000000000_REALK, &
      0.119857823569238_REALK,      0.000000000000000_REALK,     -1.677728656009297_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.376487390406873_REALK, &
      0.000000000000000_REALK,     -0.630867860580579_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.828879367344814_REALK,      0.000000000000000_REALK, &
     -1.370530832568945_REALK,      0.000000000000000_REALK,     -3.073035624459172_REALK, &
      0.000000000000000_REALK,     -2.671786307374670_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.179460929721904_REALK, &
      0.000000000000000_REALK,      0.931558293988361_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.036716061563797_REALK,      0.000000000000000_REALK, &
      0.012610231455056_REALK,      0.000000000000000_REALK,     -3.559304316898139_REALK, &
      0.000000000000000_REALK,     -0.735759644721394_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     12.359585388935011_REALK, &
      0.000000000000000_REALK,     -1.891764437921224_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.610007566480336_REALK,      0.000000000000000_REALK, &
      9.740143439716144_REALK,      0.000000000000000_REALK,     -2.265511277981753_REALK, &
      0.000000000000000_REALK,     -2.714931001653664_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      9.172910810921440_REALK, &
      0.000000000000000_REALK,     -1.973834539185649_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.123594409209340_REALK,      0.000000000000000_REALK, &
      9.311941641946580_REALK,      0.000000000000000_REALK,     -2.668315265173357_REALK, &
      0.000000000000000_REALK,     -2.812714155666854_REALK,      0.000000000000000_REALK, &
     17.481884110487336_REALK,     -0.739577136339899_REALK,      0.000000000000000_REALK, &
      2.742019569032700_REALK,      0.000000000000000_REALK,      0.219282189622886_REALK, &
     -0.592880568806241_REALK,      0.000000000000000_REALK,     -0.011478132569104_REALK, &
      0.000000000000000_REALK,      2.948239170537001_REALK,      0.000000000000000_REALK, &
      0.077497661678299_REALK,      0.000000000000000_REALK,     -4.697171105762137_REALK, &
      4.578950892977239_REALK,     -0.336357645632673_REALK,      0.000000000000000_REALK, &
      1.213261004937080_REALK,      0.000000000000000_REALK,     -2.147677599715272_REALK, &
      0.009370096353675_REALK,      0.000000000000000_REALK,      0.144547866867706_REALK, &
      0.000000000000000_REALK,      2.371515684356980_REALK,      0.000000000000000_REALK, &
     -0.731890992628083_REALK,      0.000000000000000_REALK,     -8.530705320973750_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.406367040612783_REALK, &
      0.000000000000000_REALK,     -0.214252353449319_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.684315851885238_REALK,      0.000000000000000_REALK, &
     -1.033065829144778_REALK,      0.000000000000000_REALK,     -0.148938390922317_REALK, &
      0.000000000000000_REALK,     -0.118329340747820_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.963187117596924_REALK, &
      0.000000000000000_REALK,     -0.042885935804868_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.164921333894645_REALK,      0.000000000000000_REALK, &
      1.588156063696960_REALK,      0.000000000000000_REALK,      0.136603721388818_REALK, &
      0.000000000000000_REALK,      0.099261122658687_REALK,      0.000000000000000_REALK, &
      5.144474802606103_REALK,      0.832181770263585_REALK,      0.000000000000000_REALK, &
      1.019008203426536_REALK,      0.000000000000000_REALK,      2.248961526485204_REALK, &
      0.499176270841288_REALK,      0.000000000000000_REALK,      0.450123634512626_REALK, &
      0.000000000000000_REALK,      1.280042057043136_REALK,      0.000000000000000_REALK, &
      1.003740824882682_REALK,      0.000000000000000_REALK,      2.921149551917308_REALK, &
      2.371358305799172_REALK,      0.670783180607918_REALK,      0.000000000000000_REALK, &
      0.899867207552006_REALK,      0.000000000000000_REALK,      0.639342465242857_REALK, &
      0.822696209337129_REALK,      0.000000000000000_REALK,      0.165701262630409_REALK, &
      0.000000000000000_REALK,      2.279069881040390_REALK,      0.000000000000000_REALK, &
      0.312035394278330_REALK,      0.000000000000000_REALK,     -3.203151912937042_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.773582845751958_REALK, &
      0.000000000000000_REALK,     -0.941819337186881_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.930320639287793_REALK,      0.000000000000000_REALK, &
     -2.671786307374669_REALK,      0.000000000000000_REALK,     -1.209517667600199_REALK, &
      0.000000000000000_REALK,     -1.652184218173291_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.093854162900803_REALK, &
      0.000000000000000_REALK,     -0.764067071750364_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.533891860008976_REALK,      0.000000000000000_REALK, &
     -0.735759644721393_REALK,      0.000000000000000_REALK,      0.053051106484761_REALK, &
      0.000000000000000_REALK,     -0.376879745241827_REALK,      0.000000000000000_REALK, &
      3.955979996498204_REALK,      1.848482057770214_REALK,      0.000000000000000_REALK, &
      1.862706995679253_REALK,      0.000000000000000_REALK,      3.409175501698476_REALK, &
      2.048055360380415_REALK,      0.000000000000000_REALK,      1.970984227761083_REALK, &
      0.000000000000000_REALK,      4.736971286469370_REALK,      0.000000000000000_REALK, &
      3.616951991603150_REALK,      0.000000000000000_REALK,      8.769782735281350_REALK, &
      4.612117986991533_REALK,      4.147473697243626_REALK,      0.000000000000000_REALK, &
      5.150100366193085_REALK,      0.000000000000000_REALK,      4.650182460406040_REALK, &
      7.050214526101208_REALK,      0.000000000000000_REALK,      3.831426572772513_REALK, &
      0.000000000000000_REALK,     15.563398101344422_REALK,      0.000000000000000_REALK, &
      6.678429398453408_REALK,      0.000000000000000_REALK,      2.605450929602596_REALK/
    ! results of test 6, ket-major order, dd/dydz
  data REF_CONTR_INTS(37801:39060)                                                         &
     /0.000000000000000_REALK,      0.000000000000000_REALK,     12.025699675883445_REALK, &
      0.000000000000000_REALK,      9.407353539870734_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     10.022829009826010_REALK,      0.000000000000000_REALK, &
      7.628368538887436_REALK,      0.000000000000000_REALK,     14.758280997098849_REALK, &
      0.000000000000000_REALK,      8.455879838460540_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.942821120950701_REALK, &
      0.000000000000000_REALK,      5.484777704953808_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      4.191172498796663_REALK,      0.000000000000000_REALK, &
      5.122535896143643_REALK,      0.000000000000000_REALK,      0.921133587074646_REALK, &
      0.000000000000000_REALK,      4.967842173024986_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.388905633856208_REALK, &
      0.000000000000000_REALK,      2.503569875501657_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.949251890669032_REALK,      0.000000000000000_REALK, &
      3.493207915708023_REALK,      0.000000000000000_REALK,     -0.961090094756436_REALK, &
      0.000000000000000_REALK,      1.852660216980553_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.425306304520572_REALK, &
      0.000000000000000_REALK,     -0.831537155948674_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.902721205829705_REALK,      0.000000000000000_REALK, &
      1.195541944318073_REALK,      0.000000000000000_REALK,     -6.254693086881094_REALK, &
      0.000000000000000_REALK,     -0.559718993770134_REALK,      0.000000000000000_REALK, &
      9.525803028744182_REALK,      6.388905633856207_REALK,      0.000000000000000_REALK, &
      5.699938471809623_REALK,      0.000000000000000_REALK,     -2.054517786765621_REALK, &
      6.096792407908051_REALK,      0.000000000000000_REALK,     -1.654332601530995_REALK, &
      0.000000000000000_REALK,      8.362277840289090_REALK,      0.000000000000000_REALK, &
     -1.997582014084849_REALK,      0.000000000000000_REALK,     -4.110821513923573_REALK, &
      4.634251563916110_REALK,      2.425306304520572_REALK,      0.000000000000000_REALK, &
      1.392721828438234_REALK,      0.000000000000000_REALK,     -2.746305148479256_REALK, &
      0.221676494806463_REALK,      0.000000000000000_REALK,     -1.928855756318097_REALK, &
      0.000000000000000_REALK,     -2.579793148127004_REALK,      0.000000000000000_REALK, &
     -1.512473246564303_REALK,      0.000000000000000_REALK,     -4.079078407147477_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.977995602968631_REALK, &
      0.000000000000000_REALK,      0.976906797655766_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.034795378286157_REALK,      0.000000000000000_REALK, &
      2.328809364268813_REALK,      0.000000000000000_REALK,     -0.789389464148348_REALK, &
      0.000000000000000_REALK,      0.593690277844008_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.957870987156322_REALK, &
      0.000000000000000_REALK,      0.032803814805673_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.341650145356655_REALK,      0.000000000000000_REALK, &
      1.071981212438575_REALK,      0.000000000000000_REALK,     -0.411870617943185_REALK, &
      0.000000000000000_REALK,      0.020011070103747_REALK,      0.000000000000000_REALK, &
      5.784004144574479_REALK,      1.955744993952840_REALK,      0.000000000000000_REALK, &
      0.622070136443883_REALK,      0.000000000000000_REALK,     -1.084128372325531_REALK, &
     -0.474635243233301_REALK,      0.000000000000000_REALK,     -0.433301357970137_REALK, &
      0.000000000000000_REALK,     -2.119134050825053_REALK,      0.000000000000000_REALK, &
     -0.179037725122444_REALK,      0.000000000000000_REALK,     -1.781435786716064_REALK, &
      0.657209667217229_REALK,     -0.287465640392507_REALK,      0.000000000000000_REALK, &
     -0.983733551627870_REALK,      0.000000000000000_REALK,     -0.653690102904076_REALK, &
     -1.758834618758193_REALK,      0.000000000000000_REALK,      0.253935827798255_REALK, &
      0.000000000000000_REALK,     -2.939162116255210_REALK,      0.000000000000000_REALK, &
      0.968185066796349_REALK,      0.000000000000000_REALK,     -0.879919108301500_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.079649984213533_REALK, &
      0.000000000000000_REALK,     -0.729291711113649_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.663622447331980_REALK,      0.000000000000000_REALK, &
      1.043357497921092_REALK,      0.000000000000000_REALK,     -0.773544059408003_REALK, &
      0.000000000000000_REALK,      0.915543137212652_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.526993206158055_REALK, &
      0.000000000000000_REALK,      0.362847263529467_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.236079700185838_REALK,      0.000000000000000_REALK, &
      2.120069688527255_REALK,      0.000000000000000_REALK,      0.041041633924932_REALK, &
      0.000000000000000_REALK,      1.626341826189340_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.680184006854288_REALK, &
      0.000000000000000_REALK,     -0.038090548831310_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.592868566972908_REALK,      0.000000000000000_REALK, &
      1.841577246329267_REALK,      0.000000000000000_REALK,     -1.206456429927306_REALK, &
      0.000000000000000_REALK,     -0.018838156494452_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.261330583053541_REALK, &
      0.000000000000000_REALK,     -1.560906188179094_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.984742396064977_REALK,      0.000000000000000_REALK, &
      0.750098924333474_REALK,      0.000000000000000_REALK,     -2.719363361095113_REALK, &
      0.000000000000000_REALK,     -0.657305827386627_REALK,      0.000000000000000_REALK, &
      5.361360235092981_REALK,      0.903595458130129_REALK,      0.000000000000000_REALK, &
      0.026952263429164_REALK,      0.000000000000000_REALK,     -0.854291355644070_REALK, &
     -0.472750982455444_REALK,      0.000000000000000_REALK,     -0.168383465787107_REALK, &
      0.000000000000000_REALK,     -0.852689785526250_REALK,      0.000000000000000_REALK, &
     -0.006312694983628_REALK,      0.000000000000000_REALK,     -1.142378020560860_REALK, &
      2.149978491726147_REALK,      0.023739673850361_REALK,      0.000000000000000_REALK, &
     -0.181173210261457_REALK,      0.000000000000000_REALK,     -0.917137556211742_REALK, &
     -0.162076381579305_REALK,      0.000000000000000_REALK,     -0.012704692803563_REALK, &
      0.000000000000000_REALK,     -0.021197522781608_REALK,      0.000000000000000_REALK, &
      0.123089099353113_REALK,      0.000000000000000_REALK,     -0.852216690226312_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.674562485792478_REALK, &
      0.000000000000000_REALK,     -0.225779391218526_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.072128389064046_REALK,      0.000000000000000_REALK, &
      0.548302121139384_REALK,      0.000000000000000_REALK,      0.057926033797551_REALK, &
      0.000000000000000_REALK,      0.230662075955777_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.262587621126191_REALK, &
      0.000000000000000_REALK,     -0.074746057776222_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.211479971552682_REALK,      0.000000000000000_REALK, &
      0.639986410577626_REALK,      0.000000000000000_REALK,     -0.351734470380270_REALK, &
      0.000000000000000_REALK,     -0.231270899544068_REALK,      0.000000000000000_REALK, &
      5.347203593806017_REALK,      3.102026062931681_REALK,      0.000000000000000_REALK, &
      2.363839607921407_REALK,      0.000000000000000_REALK,      0.347375571951382_REALK, &
      2.130342476498452_REALK,      0.000000000000000_REALK,      0.235674383175797_REALK, &
      0.000000000000000_REALK,      2.317701715458949_REALK,      0.000000000000000_REALK, &
      0.225724708026532_REALK,      0.000000000000000_REALK,     -0.910296342973315_REALK, &
      5.510002978298435_REALK,      2.500178530329371_REALK,      0.000000000000000_REALK, &
      1.191976758771676_REALK,      0.000000000000000_REALK,     -1.379217627485658_REALK, &
      0.153773088086115_REALK,      0.000000000000000_REALK,     -0.785129046409808_REALK, &
      0.000000000000000_REALK,     -1.381308185279813_REALK,      0.000000000000000_REALK, &
     -0.475197344084619_REALK,      0.000000000000000_REALK,     -2.958470457593326_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.363172076349014_REALK, &
      0.000000000000000_REALK,     -0.940372266387817_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.849262370067561_REALK,      0.000000000000000_REALK, &
      1.759371491587673_REALK,      0.000000000000000_REALK,     -1.114605309233373_REALK, &
      0.000000000000000_REALK,     -0.374955318133523_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.321737266812735_REALK, &
      0.000000000000000_REALK,     -1.418096744973421_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.837821506049139_REALK,      0.000000000000000_REALK, &
      0.930750459800047_REALK,      0.000000000000000_REALK,     -0.341817188972833_REALK, &
      0.000000000000000_REALK,     -0.580589359695724_REALK,      0.000000000000000_REALK, &
      6.058311227868542_REALK,     -0.042666297998338_REALK,      0.000000000000000_REALK, &
     -0.558359008759080_REALK,      0.000000000000000_REALK,     -0.821378697904194_REALK, &
     -0.896383850066621_REALK,      0.000000000000000_REALK,      0.006628559730896_REALK, &
      0.000000000000000_REALK,     -1.131754912367273_REALK,      0.000000000000000_REALK, &
      0.105436656540091_REALK,      0.000000000000000_REALK,     -0.885535135599369_REALK, &
      0.789370118057951_REALK,     -0.732694897546124_REALK,      0.000000000000000_REALK, &
     -0.979062235107092_REALK,      0.000000000000000_REALK,     -0.596979790088043_REALK, &
     -1.215186996193372_REALK,      0.000000000000000_REALK,      0.473890811616331_REALK, &
      0.000000000000000_REALK,     -1.538451710424842_REALK,      0.000000000000000_REALK, &
      0.646708315515843_REALK,      0.000000000000000_REALK,     -0.539321481004063_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.643716010635055_REALK, &
      0.000000000000000_REALK,     -0.106678061114171_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.003155133601527_REALK,      0.000000000000000_REALK, &
      0.436215264425194_REALK,      0.000000000000000_REALK,      0.056556979547184_REALK, &
      0.000000000000000_REALK,      0.087866949200755_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.238964168303053_REALK, &
      0.000000000000000_REALK,      0.003478742340930_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.030531448434630_REALK,      0.000000000000000_REALK, &
      0.703874107008584_REALK,      0.000000000000000_REALK,     -0.029314060058093_REALK, &
      0.000000000000000_REALK,      0.010464717107516_REALK,      0.000000000000000_REALK, &
      4.015448815404866_REALK,      1.162988142667847_REALK,      0.000000000000000_REALK, &
      0.312380986497419_REALK,      0.000000000000000_REALK,      0.221956302476666_REALK, &
     -0.197915328458605_REALK,      0.000000000000000_REALK,      0.073663276214993_REALK, &
      0.000000000000000_REALK,     -0.698194734308170_REALK,      0.000000000000000_REALK, &
      0.024049398681388_REALK,      0.000000000000000_REALK,     -0.468931643378991_REALK, &
      0.872745558054182_REALK,     -0.334065348230121_REALK,      0.000000000000000_REALK, &
     -0.993281091859178_REALK,      0.000000000000000_REALK,     -0.387299732473856_REALK, &
     -1.496537404379601_REALK,      0.000000000000000_REALK,      0.126784789407511_REALK, &
      0.000000000000000_REALK,     -1.991752981246049_REALK,      0.000000000000000_REALK, &
      0.384991301709791_REALK,      0.000000000000000_REALK,     -0.807707595241062_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.268152534442383_REALK, &
      0.000000000000000_REALK,     -1.293816639553684_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.977612468092477_REALK,      0.000000000000000_REALK, &
     -0.163975616386533_REALK,      0.000000000000000_REALK,     -0.900387401961542_REALK, &
      0.000000000000000_REALK,     -0.113690357708270_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.718842408730941_REALK, &
      0.000000000000000_REALK,     -0.430032940569052_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.235778610049536_REALK,      0.000000000000000_REALK, &
      2.117027988153923_REALK,      0.000000000000000_REALK,     -0.032645232368719_REALK, &
      0.000000000000000_REALK,      1.293414299125926_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.329161148811684_REALK, &
      0.000000000000000_REALK,     -2.822931665178891_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.356257924736461_REALK,      0.000000000000000_REALK, &
      2.091942667648477_REALK,      0.000000000000000_REALK,     -1.416292738606842_REALK, &
      0.000000000000000_REALK,     -0.851594685692660_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.754444401258725_REALK, &
      0.000000000000000_REALK,     -9.308036080444149_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -4.942342122119540_REALK,      0.000000000000000_REALK, &
      1.731535160551735_REALK,      0.000000000000000_REALK,     -4.456366493987991_REALK, &
      0.000000000000000_REALK,     -2.120658673793840_REALK,      0.000000000000000_REALK, &
     10.363453625388184_REALK,     -1.492900984637715_REALK,      0.000000000000000_REALK, &
     -1.091973734750924_REALK,      0.000000000000000_REALK,     -1.071337370498422_REALK, &
     -1.114605309233373_REALK,      0.000000000000000_REALK,      0.177573400116376_REALK, &
      0.000000000000000_REALK,     -0.904136513214187_REALK,      0.000000000000000_REALK, &
      0.156006668432454_REALK,      0.000000000000000_REALK,     -0.873859251108124_REALK, &
      7.516977341709913_REALK,     -2.935393623655359_REALK,      0.000000000000000_REALK, &
     -1.192974374261568_REALK,      0.000000000000000_REALK,     -2.138197434955117_REALK, &
     -0.341817188972833_REALK,      0.000000000000000_REALK,      0.936707518986214_REALK, &
      0.000000000000000_REALK,      0.494880360981682_REALK,      0.000000000000000_REALK, &
      0.438509255134162_REALK,      0.000000000000000_REALK,     -1.074942902707438_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.877193075558379_REALK, &
      0.000000000000000_REALK,      0.005733371092139_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.070927098326264_REALK,      0.000000000000000_REALK, &
      0.455107965274024_REALK,      0.000000000000000_REALK,      0.110768397217945_REALK, &
      0.000000000000000_REALK,     -0.003572838274770_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.685917775605770_REALK, &
      0.000000000000000_REALK,     -0.374550034520548_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.358971845442042_REALK,      0.000000000000000_REALK, &
      0.996820132719230_REALK,      0.000000000000000_REALK,     -0.353038700496368_REALK, &
      0.000000000000000_REALK,     -0.626995716361963_REALK,      0.000000000000000_REALK, &
      5.720056850387194_REALK,      0.778806491862817_REALK,      0.000000000000000_REALK, &
      0.018655690235219_REALK,      0.000000000000000_REALK,      0.241081354501035_REALK, &
     -0.260081502145720_REALK,      0.000000000000000_REALK,      0.037767479380520_REALK, &
      0.000000000000000_REALK,     -0.360013301431261_REALK,      0.000000000000000_REALK, &
      0.001086635336423_REALK,      0.000000000000000_REALK,     -0.385352830391790_REALK, &
      7.366475123580135_REALK,      0.068561375537228_REALK,      0.000000000000000_REALK, &
     -0.413927033987519_REALK,      0.000000000000000_REALK,     -1.229546315052147_REALK, &
     -0.279108296421973_REALK,      0.000000000000000_REALK,     -0.012838012226160_REALK, &
      0.000000000000000_REALK,     -0.026202151739291_REALK,      0.000000000000000_REALK, &
      0.089279560471491_REALK,      0.000000000000000_REALK,     -1.426925717250625_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.054016482801900_REALK, &
      0.000000000000000_REALK,     -0.552111244605921_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.140187558713326_REALK,      0.000000000000000_REALK, &
     -0.113690357708270_REALK,      0.000000000000000_REALK,      0.086402736042197_REALK, &
      0.000000000000000_REALK,     -0.036705434122899_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.890147979101255_REALK, &
      0.000000000000000_REALK,      0.200447798720497_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.427469806163484_REALK,      0.000000000000000_REALK, &
      1.293414299125926_REALK,      0.000000000000000_REALK,      0.510328667964786_REALK, &
      0.000000000000000_REALK,     -0.335495522311696_REALK,      0.000000000000000_REALK, &
      9.508255121203915_REALK,      4.456046515805108_REALK,      0.000000000000000_REALK, &
      2.726985534197337_REALK,      0.000000000000000_REALK,      1.784412560114390_REALK, &
      1.953328115416345_REALK,      0.000000000000000_REALK,      0.962208792922050_REALK, &
      0.000000000000000_REALK,      1.630924204946561_REALK,      0.000000000000000_REALK, &
      0.707272062719753_REALK,      0.000000000000000_REALK,      0.077180218956323_REALK, &
     31.464888312983430_REALK,     12.034402845949915_REALK,      0.000000000000000_REALK, &
      4.538855419337718_REALK,      0.000000000000000_REALK,     -1.553517806981055_REALK, &
      0.441348951577097_REALK,      0.000000000000000_REALK,     -0.666572946018233_REALK, &
      0.000000000000000_REALK,     -2.845713548882986_REALK,      0.000000000000000_REALK, &
     -0.289587276249476_REALK,      0.000000000000000_REALK,     -6.566836768405381_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.179536291094299_REALK, &
      0.000000000000000_REALK,      3.064977122988472_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.410783217873031_REALK,      0.000000000000000_REALK, &
      3.314593099119844_REALK,      0.000000000000000_REALK,     10.264660320412796_REALK, &
      0.000000000000000_REALK,     11.470747190347668_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.839046657036442_REALK, &
      0.000000000000000_REALK,      1.548397979719395_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.536172909094886_REALK,      0.000000000000000_REALK, &
      2.134671598578416_REALK,      0.000000000000000_REALK,     -0.336728022515945_REALK, &
      0.000000000000000_REALK,      6.910844990305760_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.796502125962458_REALK, &
      0.000000000000000_REALK,     -0.533300329055835_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.198891150013643_REALK,      0.000000000000000_REALK, &
      2.327548280118798_REALK,      0.000000000000000_REALK,     -5.253607554213771_REALK, &
      0.000000000000000_REALK,     -1.713824657780830_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.590247019915411_REALK, &
      0.000000000000000_REALK,     -1.250853017478184_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.223109720775433_REALK,      0.000000000000000_REALK, &
      0.830887077714291_REALK,      0.000000000000000_REALK,     -8.973039331542459_REALK, &
      0.000000000000000_REALK,     -4.428599887821400_REALK,      0.000000000000000_REALK, &
      7.184458968449644_REALK,      1.796502125962459_REALK,      0.000000000000000_REALK, &
      3.517806101442681_REALK,      0.000000000000000_REALK,      0.162767669082529_REALK, &
      2.082819198986840_REALK,      0.000000000000000_REALK,      0.045837931118313_REALK, &
      0.000000000000000_REALK,     11.369779085097626_REALK,      0.000000000000000_REALK, &
      0.222634642490777_REALK,      0.000000000000000_REALK,     -7.807355617714961_REALK, &
      2.526463270198780_REALK,      0.590247019915411_REALK,      0.000000000000000_REALK, &
      0.682274663751221_REALK,      0.000000000000000_REALK,     -1.149907105330384_REALK, &
     -0.040484624239909_REALK,      0.000000000000000_REALK,     -0.351738018821233_REALK, &
      0.000000000000000_REALK,     -3.815818199851167_REALK,      0.000000000000000_REALK, &
     -1.022578639558239_REALK,      0.000000000000000_REALK,    -11.348120004987591_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.287036308029394_REALK, &
      0.000000000000000_REALK,     -1.327897953200935_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.318350720213868_REALK,      0.000000000000000_REALK, &
      1.452666064574803_REALK,      0.000000000000000_REALK,     -3.533050409893534_REALK, &
      0.000000000000000_REALK,     -3.419887677749239_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.441931265690199_REALK, &
      0.000000000000000_REALK,     -0.911709407828829_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.144821070129953_REALK,      0.000000000000000_REALK, &
      0.673057785729938_REALK,      0.000000000000000_REALK,     -0.859228635008953_REALK, &
      0.000000000000000_REALK,     -2.589320266217456_REALK,      0.000000000000000_REALK, &
      3.974750599003235_REALK,     -0.500062845505657_REALK,      0.000000000000000_REALK, &
     -0.328892309319061_REALK,      0.000000000000000_REALK,      0.075798963497752_REALK, &
     -1.730178141587932_REALK,      0.000000000000000_REALK,     -0.011115420314542_REALK, &
      0.000000000000000_REALK,     -6.824039943590261_REALK,      0.000000000000000_REALK, &
     -0.016681195357235_REALK,      0.000000000000000_REALK,     -2.913745996843442_REALK, &
      0.395686367673300_REALK,     -0.586060341941269_REALK,      0.000000000000000_REALK, &
     -0.975363712494073_REALK,      0.000000000000000_REALK,     -0.280492006592250_REALK, &
     -1.808477397101296_REALK,      0.000000000000000_REALK,      0.377848121014255_REALK, &
      0.000000000000000_REALK,     -6.699316944814519_REALK,      0.000000000000000_REALK, &
      1.172663038312350_REALK,      0.000000000000000_REALK,     -2.220500225769276_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.858902244525298_REALK, &
      0.000000000000000_REALK,     -0.923206680384123_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.893020867315613_REALK,      0.000000000000000_REALK, &
     -0.807433285030284_REALK,      0.000000000000000_REALK,     -2.127643952335097_REALK, &
      0.000000000000000_REALK,     -0.915000188560849_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.416498189315893_REALK, &
      0.000000000000000_REALK,     -0.216837701927006_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.159325223721814_REALK,      0.000000000000000_REALK, &
      1.030291647491714_REALK,      0.000000000000000_REALK,      0.030006285572467_REALK, &
      0.000000000000000_REALK,      1.000261532246371_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.584708265632021_REALK, &
      0.000000000000000_REALK,     -1.938839685789551_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.277967229671905_REALK,      0.000000000000000_REALK, &
      0.560504959651175_REALK,      0.000000000000000_REALK,     -3.107374562122532_REALK, &
      0.000000000000000_REALK,     -3.799441663591992_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.159034182452520_REALK, &
      0.000000000000000_REALK,     -1.848288420210174_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.545081570211194_REALK,      0.000000000000000_REALK, &
      0.148985863189664_REALK,      0.000000000000000_REALK,     -3.201957755735063_REALK, &
      0.000000000000000_REALK,     -3.377217665653650_REALK,      0.000000000000000_REALK, &
      2.761785160404540_REALK,     -1.736230046451126_REALK,      0.000000000000000_REALK, &
     -0.478219606929740_REALK,      0.000000000000000_REALK,      0.042974778011134_REALK, &
     -1.719433903830800_REALK,      0.000000000000000_REALK,     -0.032777347362228_REALK, &
      0.000000000000000_REALK,     -2.136450538053331_REALK,      0.000000000000000_REALK, &
     -0.018455744433232_REALK,      0.000000000000000_REALK,     -1.256992840578852_REALK, &
      0.886461590498131_REALK,     -0.913752337881485_REALK,      0.000000000000000_REALK, &
     -0.129577524137941_REALK,      0.000000000000000_REALK,     -0.254933897725558_REALK, &
     -0.284057364658497_REALK,      0.000000000000000_REALK,      0.362376803977623_REALK, &
      0.000000000000000_REALK,      1.068923649981245_REALK,      0.000000000000000_REALK, &
      0.100229668884927_REALK,      0.000000000000000_REALK,     -1.298428064479486_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.207095148918244_REALK, &
      0.000000000000000_REALK,      0.203368227036682_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.098877730988983_REALK,      0.000000000000000_REALK, &
     -0.445304245254318_REALK,      0.000000000000000_REALK,      1.221665257651519_REALK, &
      0.000000000000000_REALK,      0.153368470621683_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.217323585097687_REALK, &
      0.000000000000000_REALK,      0.261354209056931_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.299698696977856_REALK,      0.000000000000000_REALK, &
      0.330682245961476_REALK,      0.000000000000000_REALK,      0.967591256187921_REALK, &
      0.000000000000000_REALK,     -0.775654373222312_REALK,      0.000000000000000_REALK, &
      3.680765788565760_REALK,      1.113843163164904_REALK,      0.000000000000000_REALK, &
      1.237843349048006_REALK,      0.000000000000000_REALK,      1.996125272466717_REALK, &
      0.955470194704806_REALK,      0.000000000000000_REALK,      0.732852272202154_REALK, &
      0.000000000000000_REALK,      2.439659186814830_REALK,      0.000000000000000_REALK, &
      1.664929070203348_REALK,      0.000000000000000_REALK,      3.540345932196543_REALK, &
      3.288612090907591_REALK,      0.855462935236318_REALK,      0.000000000000000_REALK, &
      0.561147198380252_REALK,      0.000000000000000_REALK,      0.543642727327413_REALK, &
     -0.039048457809637_REALK,      0.000000000000000_REALK,      0.195014254408311_REALK, &
      0.000000000000000_REALK,     -1.619699229349520_REALK,      0.000000000000000_REALK, &
      0.249503525847849_REALK,      0.000000000000000_REALK,     -3.492464677105383_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.739577136339899_REALK, &
      0.000000000000000_REALK,     -2.715670483803585_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.021524636477491_REALK,      0.000000000000000_REALK, &
     -0.582834064897854_REALK,      0.000000000000000_REALK,     -2.838252901442682_REALK, &
      0.000000000000000_REALK,     -3.897344637081700_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.336357645632673_REALK, &
      0.000000000000000_REALK,     -2.397235007410863_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.495373672484880_REALK,      0.000000000000000_REALK, &
     -0.341455709263499_REALK,      0.000000000000000_REALK,     -1.319666144853419_REALK, &
      0.000000000000000_REALK,     -3.416059809444079_REALK,      0.000000000000000_REALK, &
      1.402409378620816_REALK,     -3.340628995024220_REALK,      0.000000000000000_REALK, &
     -0.442973513305125_REALK,      0.000000000000000_REALK,      0.017590975740833_REALK, &
     -2.153096633947384_REALK,      0.000000000000000_REALK,     -0.051846089589578_REALK, &
      0.000000000000000_REALK,     -1.052636468221079_REALK,      0.000000000000000_REALK, &
     -0.012519754364364_REALK,      0.000000000000000_REALK,     -0.376810461050694_REALK, &
      0.118276232699858_REALK,     -1.598143150151621_REALK,      0.000000000000000_REALK, &
     -0.479446014717224_REALK,      0.000000000000000_REALK,     -0.055475418165717_REALK, &
     -1.538173404399426_REALK,      0.000000000000000_REALK,      0.686793317479483_REALK, &
      0.000000000000000_REALK,     -1.915558623433947_REALK,      0.000000000000000_REALK, &
      0.289222366988681_REALK,      0.000000000000000_REALK,     -0.220351716194399_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.901852802192630_REALK, &
      0.000000000000000_REALK,      0.636199957220517_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.155753263396848_REALK,      0.000000000000000_REALK, &
     -0.273509372817343_REALK,      0.000000000000000_REALK,      0.943242513197806_REALK, &
      0.000000000000000_REALK,      0.351366602558711_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.170407155738047_REALK, &
      0.000000000000000_REALK,      0.246406926483447_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.037222051214996_REALK,      0.000000000000000_REALK, &
      0.280976720658328_REALK,      0.000000000000000_REALK,      0.116517387335213_REALK, &
      0.000000000000000_REALK,     -0.570318163626208_REALK,      0.000000000000000_REALK, &
      2.671527307120714_REALK,     -0.323334455616958_REALK,      0.000000000000000_REALK, &
     -0.145400262709704_REALK,      0.000000000000000_REALK,      1.167886394861041_REALK, &
     -0.781096475368610_REALK,      0.000000000000000_REALK,     -0.174890252978467_REALK, &
      0.000000000000000_REALK,     -1.681115807614926_REALK,      0.000000000000000_REALK, &
     -0.143221790697702_REALK,      0.000000000000000_REALK,      1.516953837965576_REALK, &
      0.636221293018702_REALK,     -0.889548784428190_REALK,      0.000000000000000_REALK, &
     -1.037665568088211_REALK,      0.000000000000000_REALK,      0.171531771020783_REALK, &
     -1.829683501412708_REALK,      0.000000000000000_REALK,     -0.219742177520777_REALK, &
      0.000000000000000_REALK,     -3.576076966123205_REALK,      0.000000000000000_REALK, &
     -0.359817961972727_REALK,      0.000000000000000_REALK,     -0.859386557822327_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.773582845751958_REALK, &
      0.000000000000000_REALK,     -0.941819337186881_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.930320639287793_REALK,      0.000000000000000_REALK, &
     -2.671786307374670_REALK,      0.000000000000000_REALK,     -1.209517667600199_REALK, &
      0.000000000000000_REALK,     -1.652184218173292_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.093854162900803_REALK, &
      0.000000000000000_REALK,     -0.764067071750363_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.533891860008975_REALK,      0.000000000000000_REALK, &
     -0.735759644721393_REALK,      0.000000000000000_REALK,      0.053051106484761_REALK, &
      0.000000000000000_REALK,     -0.376879745241827_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.553228527069673_REALK, &
      0.000000000000000_REALK,     -4.202967617035060_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.395952811166696_REALK,      0.000000000000000_REALK, &
     -2.714931001653665_REALK,      0.000000000000000_REALK,     -3.220693872586515_REALK, &
      0.000000000000000_REALK,     -4.159542537366607_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -5.977250212736610_REALK, &
      0.000000000000000_REALK,     -8.795160327693745_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.335100408377604_REALK,      0.000000000000000_REALK, &
     -2.812714155666853_REALK,      0.000000000000000_REALK,     -5.317428644884128_REALK, &
      0.000000000000000_REALK,     -6.030625063599328_REALK,      0.000000000000000_REALK, &
     -2.404007971232745_REALK,     -6.536262163043411_REALK,      0.000000000000000_REALK, &
     -0.041802627324294_REALK,      0.000000000000000_REALK,     -0.022291484395886_REALK, &
     -2.838252901442681_REALK,      0.000000000000000_REALK,     -0.076752957841871_REALK, &
      0.000000000000000_REALK,      0.535583867573667_REALK,      0.000000000000000_REALK, &
     -0.000814740703666_REALK,      0.000000000000000_REALK,      0.329283369591645_REALK, &
     -1.760114497466155_REALK,     -7.259409628092707_REALK,      0.000000000000000_REALK, &
      0.967471153240867_REALK,      0.000000000000000_REALK,      0.282303842986881_REALK, &
     -1.319666144853419_REALK,      0.000000000000000_REALK,      1.446114811237764_REALK, &
      0.000000000000000_REALK,      2.754001202726378_REALK,      0.000000000000000_REALK, &
     -0.280823792862268_REALK,      0.000000000000000_REALK,      0.539555788322485_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.515677273640493_REALK, &
      0.000000000000000_REALK,      1.226364104292357_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.152486529268856_REALK,      0.000000000000000_REALK, &
     -0.118329340747820_REALK,      0.000000000000000_REALK,      0.992619452075042_REALK, &
      0.000000000000000_REALK,      0.467072244715713_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.129869025910760_REALK, &
      0.000000000000000_REALK,      1.036920523812228_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.223586811494711_REALK,      0.000000000000000_REALK, &
      0.099261122658687_REALK,      0.000000000000000_REALK,      0.674094189679257_REALK, &
      0.000000000000000_REALK,     -1.154817815684799_REALK,      0.000000000000000_REALK, &
      2.705020897656309_REALK,     -1.412955764001002_REALK,      0.000000000000000_REALK, &
     -0.279117744255817_REALK,      0.000000000000000_REALK,      0.874177390315751_REALK, &
     -0.870373992864928_REALK,      0.000000000000000_REALK,     -0.578255913356589_REALK, &
      0.000000000000000_REALK,     -0.629744752238638_REALK,      0.000000000000000_REALK, &
     -0.189595987234234_REALK,      0.000000000000000_REALK,      0.783013269756688_REALK, &
      3.510118518708548_REALK,     -2.937229898699984_REALK,      0.000000000000000_REALK, &
     -0.286153948073177_REALK,      0.000000000000000_REALK,      0.323616696960016_REALK, &
     -0.458653883015244_REALK,      0.000000000000000_REALK,     -0.336335478585200_REALK, &
      0.000000000000000_REALK,      0.885821075084264_REALK,      0.000000000000000_REALK, &
     -0.047745108922572_REALK,      0.000000000000000_REALK,     -0.780150908570550_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.266835440747264_REALK, &
      0.000000000000000_REALK,      0.273905253803867_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.115498435960184_REALK,      0.000000000000000_REALK, &
     -1.652184218173291_REALK,      0.000000000000000_REALK,      0.830961934050871_REALK, &
      0.000000000000000_REALK,      0.331351556890553_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.313780601412076_REALK, &
      0.000000000000000_REALK,      1.911637049843479_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.602764636146474_REALK,      0.000000000000000_REALK, &
     -0.376879745241827_REALK,      0.000000000000000_REALK,      2.655810804840407_REALK, &
      0.000000000000000_REALK,      0.453712209122340_REALK,      0.000000000000000_REALK, &
      6.008522144900397_REALK,      1.510755175947495_REALK,      0.000000000000000_REALK, &
      1.204133130197048_REALK,      0.000000000000000_REALK,      3.827814663505203_REALK, &
      0.806095159745948_REALK,      0.000000000000000_REALK,      1.218820916323634_REALK, &
      0.000000000000000_REALK,      1.198531975335211_REALK,      0.000000000000000_REALK, &
      1.612391465953496_REALK,      0.000000000000000_REALK,      6.790287514136709_REALK, &
     21.703174216976816_REALK,      4.583100559522471_REALK,      0.000000000000000_REALK, &
      2.065359294046666_REALK,      0.000000000000000_REALK,      7.482825371651259_REALK, &
     -0.105082805027068_REALK,      0.000000000000000_REALK,      1.962579873765785_REALK, &
      0.000000000000000_REALK,     -2.237084804389788_REALK,      0.000000000000000_REALK, &
      1.288718232073658_REALK,      0.000000000000000_REALK,      2.017354528613508_REALK/
    ! results of test 6, ket-major order, dd/dzdz
  data REF_CONTR_INTS(39061:40320)                                                         &
    /13.016292663418731_REALK,     12.025699675883443_REALK,      0.000000000000000_REALK, &
     14.415442170920659_REALK,      0.000000000000000_REALK,     -3.219030240153009_REALK, &
     21.263882242809874_REALK,      0.000000000000000_REALK,     -3.612684694096428_REALK, &
      0.000000000000000_REALK,     43.399130984169759_REALK,      0.000000000000000_REALK, &
     -6.136457040080957_REALK,      0.000000000000000_REALK,     -7.823463314054561_REALK, &
      4.633625798420769_REALK,      6.942821120950701_REALK,      0.000000000000000_REALK, &
     10.399652572786522_REALK,      0.000000000000000_REALK,     -6.068423797951203_REALK, &
     17.578272342011672_REALK,      0.000000000000000_REALK,     -8.264563947071368_REALK, &
      0.000000000000000_REALK,     37.846119758001322_REALK,      0.000000000000000_REALK, &
    -15.197163091253522_REALK,      0.000000000000000_REALK,    -12.128568337000804_REALK, &
      9.525803028744182_REALK,      6.388905633856208_REALK,      0.000000000000000_REALK, &
      5.699938471809623_REALK,      0.000000000000000_REALK,     -2.054517786765622_REALK, &
      6.096792407908051_REALK,      0.000000000000000_REALK,     -1.654332601530996_REALK, &
      0.000000000000000_REALK,      8.362277840289090_REALK,      0.000000000000000_REALK, &
     -1.997582014084851_REALK,      0.000000000000000_REALK,     -4.110821513923569_REALK, &
      4.634251563916111_REALK,      2.425306304520572_REALK,      0.000000000000000_REALK, &
      1.392721828438235_REALK,      0.000000000000000_REALK,     -2.746305148479257_REALK, &
      0.221676494806465_REALK,      0.000000000000000_REALK,     -1.928855756318097_REALK, &
      0.000000000000000_REALK,     -2.579793148127003_REALK,      0.000000000000000_REALK, &
     -1.512473246564304_REALK,      0.000000000000000_REALK,     -4.079078407147477_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -5.587361619169614_REALK, &
      0.000000000000000_REALK,     -5.250886383073587_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -6.478971159623427_REALK,      0.000000000000000_REALK, &
     -0.589854187374252_REALK,      0.000000000000000_REALK,    -10.831274739945462_REALK, &
      0.000000000000000_REALK,     -0.750254492043083_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.856689720441907_REALK, &
      0.000000000000000_REALK,     -4.970564132866164_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -6.619366722711685_REALK,      0.000000000000000_REALK, &
      2.266491617764591_REALK,      0.000000000000000_REALK,    -11.481146139801387_REALK, &
      0.000000000000000_REALK,      3.167448800129687_REALK,      0.000000000000000_REALK, &
      9.510959964896420_REALK,      4.977995602968631_REALK,      0.000000000000000_REALK, &
      3.750376449821699_REALK,      0.000000000000000_REALK,     -1.782692627505893_REALK, &
      3.466495079181182_REALK,      0.000000000000000_REALK,     -1.102890336626212_REALK, &
      0.000000000000000_REALK,      4.248495720455168_REALK,      0.000000000000000_REALK, &
     -1.079394152831895_REALK,      0.000000000000000_REALK,     -2.929314022602022_REALK, &
      2.376895851820571_REALK,      1.957870987156322_REALK,      0.000000000000000_REALK, &
      1.947565293383987_REALK,      0.000000000000000_REALK,     -2.364166827532824_REALK, &
      2.459837206204790_REALK,      0.000000000000000_REALK,     -1.729506139122870_REALK, &
      0.000000000000000_REALK,      4.245392125121027_REALK,      0.000000000000000_REALK, &
     -1.916782883479936_REALK,      0.000000000000000_REALK,     -3.182357446620135_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.101900593229321_REALK, &
      0.000000000000000_REALK,     -2.770788816927034_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.521292409756537_REALK,      0.000000000000000_REALK, &
     -0.370513883412761_REALK,      0.000000000000000_REALK,     -2.938916206705701_REALK, &
      0.000000000000000_REALK,     -0.325124843475479_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.718343421390774_REALK, &
      0.000000000000000_REALK,     -1.183120011737885_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.769774628966610_REALK,      0.000000000000000_REALK, &
      0.890694159637845_REALK,      0.000000000000000_REALK,     -0.133822639142115_REALK, &
      0.000000000000000_REALK,      0.683266769012612_REALK,      0.000000000000000_REALK, &
     -1.331394484815900_REALK,     -1.079649984213533_REALK,      0.000000000000000_REALK, &
     -1.117536663497718_REALK,      0.000000000000000_REALK,      1.864996849558304_REALK, &
     -1.407904850009757_REALK,      0.000000000000000_REALK,      1.787639900598868_REALK, &
      0.000000000000000_REALK,     -2.274732400262176_REALK,      0.000000000000000_REALK, &
      2.403732926077292_REALK,      0.000000000000000_REALK,      0.789174327852425_REALK, &
      0.403620074108518_REALK,      0.526993206158055_REALK,      0.000000000000000_REALK, &
      0.687992418413710_REALK,      0.000000000000000_REALK,      1.178011156720046_REALK, &
      0.990146138217552_REALK,      0.000000000000000_REALK,      1.366003250495541_REALK, &
      0.000000000000000_REALK,      1.686255516444594_REALK,      0.000000000000000_REALK, &
      1.986887271408420_REALK,      0.000000000000000_REALK,     -2.364722774771443_REALK, &
     11.871359651725614_REALK,      4.680184006854287_REALK,      0.000000000000000_REALK, &
      2.904829306750835_REALK,      0.000000000000000_REALK,     -1.891609495632988_REALK, &
      2.120852952000573_REALK,      0.000000000000000_REALK,     -0.872144272644214_REALK, &
      0.000000000000000_REALK,      1.969016280246860_REALK,      0.000000000000000_REALK, &
     -0.680362205616442_REALK,      0.000000000000000_REALK,     -2.529503660570415_REALK, &
      7.081279366587592_REALK,      2.261330583053542_REALK,      0.000000000000000_REALK, &
      0.885613152013883_REALK,      0.000000000000000_REALK,     -3.020731266902372_REALK, &
     -0.024453703915457_REALK,      0.000000000000000_REALK,     -1.210189767816047_REALK, &
      0.000000000000000_REALK,     -1.257430296039953_REALK,      0.000000000000000_REALK, &
     -0.601685674716174_REALK,      0.000000000000000_REALK,     -2.806904574899269_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.214248024780312_REALK, &
      0.000000000000000_REALK,     -2.183376982873821_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.652128759772581_REALK,      0.000000000000000_REALK, &
     -0.320174712797634_REALK,      0.000000000000000_REALK,     -1.607335538201811_REALK, &
      0.000000000000000_REALK,     -0.208492204936195_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.096602118318022_REALK, &
      0.000000000000000_REALK,     -1.659936094259207_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.365176281139311_REALK,      0.000000000000000_REALK, &
      0.972423464473688_REALK,      0.000000000000000_REALK,     -1.603988465357956_REALK, &
      0.000000000000000_REALK,      0.661755539726312_REALK,      0.000000000000000_REALK, &
     -1.162795822826618_REALK,     -0.674562485792478_REALK,      0.000000000000000_REALK, &
     -0.514037435400265_REALK,      0.000000000000000_REALK,      1.384693711940300_REALK, &
     -0.463261457957566_REALK,      0.000000000000000_REALK,      0.939435190032904_REALK, &
      0.000000000000000_REALK,     -0.504004350314162_REALK,      0.000000000000000_REALK, &
      0.899774218659346_REALK,      0.000000000000000_REALK,      0.476829297036242_REALK, &
      0.578702103436991_REALK,      0.262587621126191_REALK,      0.000000000000000_REALK, &
      0.125190396496336_REALK,      0.000000000000000_REALK,      0.724376083204971_REALK, &
      0.016150410422268_REALK,      0.000000000000000_REALK,      0.412356028602676_REALK, &
      0.000000000000000_REALK,     -0.145075412021468_REALK,      0.000000000000000_REALK, &
      0.249577429984668_REALK,      0.000000000000000_REALK,     -1.003782572920369_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.218633802689464_REALK, &
      0.000000000000000_REALK,     -0.978200612219274_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.016954534440413_REALK,      0.000000000000000_REALK, &
     -1.278654709640886_REALK,      0.000000000000000_REALK,     -1.348528075393662_REALK, &
      0.000000000000000_REALK,     -1.290036951603636_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.863581063741684_REALK, &
      0.000000000000000_REALK,     -3.282874883903729_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -3.543417919629400_REALK,      0.000000000000000_REALK, &
     -0.631979330112086_REALK,      0.000000000000000_REALK,     -4.743907255431166_REALK, &
      0.000000000000000_REALK,     -0.681715817101485_REALK,      0.000000000000000_REALK, &
     18.116312936243752_REALK,      5.363172076349014_REALK,      0.000000000000000_REALK, &
      2.880905600870508_REALK,      0.000000000000000_REALK,     -2.456188361856752_REALK, &
      1.743321941074763_REALK,      0.000000000000000_REALK,     -0.833212819554650_REALK, &
      0.000000000000000_REALK,      1.424468527709420_REALK,      0.000000000000000_REALK, &
     -0.544010304478621_REALK,      0.000000000000000_REALK,     -2.648036891660547_REALK, &
      5.026724465672619_REALK,      2.321737266812735_REALK,      0.000000000000000_REALK, &
      1.660838746841487_REALK,      0.000000000000000_REALK,     -3.801579066269350_REALK, &
      1.594577131477581_REALK,      0.000000000000000_REALK,     -1.501648177726673_REALK, &
      0.000000000000000_REALK,      2.323711931845904_REALK,      0.000000000000000_REALK, &
     -1.097047960588345_REALK,      0.000000000000000_REALK,     -3.434409817913686_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -5.415292672577699_REALK, &
      0.000000000000000_REALK,     -2.099259616029728_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.291948723458392_REALK,      0.000000000000000_REALK, &
     -0.343002809134444_REALK,      0.000000000000000_REALK,     -0.963976561126490_REALK, &
      0.000000000000000_REALK,     -0.161616531171477_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.566346814280867_REALK, &
      0.000000000000000_REALK,     -1.080479470499021_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.486633983268567_REALK,      0.000000000000000_REALK, &
      0.973982312499835_REALK,      0.000000000000000_REALK,      0.014421347391389_REALK, &
      0.000000000000000_REALK,      0.418789002657365_REALK,      0.000000000000000_REALK, &
     -1.435841809991788_REALK,     -0.643716010635055_REALK,      0.000000000000000_REALK, &
     -0.409540489507582_REALK,      0.000000000000000_REALK,      1.454848212023959_REALK, &
     -0.314330685354412_REALK,      0.000000000000000_REALK,      0.747390816178078_REALK, &
      0.000000000000000_REALK,     -0.304389780306120_REALK,      0.000000000000000_REALK, &
      0.577955202294355_REALK,      0.000000000000000_REALK,      0.403910767766744_REALK, &
      0.331510343984218_REALK,      0.238964168303053_REALK,      0.000000000000000_REALK, &
      0.206533230600055_REALK,      0.000000000000000_REALK,      0.735672818733799_REALK, &
      0.219822510950273_REALK,      0.000000000000000_REALK,      0.453520147623681_REALK, &
      0.000000000000000_REALK,      0.302157217107240_REALK,      0.000000000000000_REALK, &
      0.400310299125756_REALK,      0.000000000000000_REALK,     -0.991134950475264_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.095710093544188_REALK, &
      0.000000000000000_REALK,     -0.625023198231647_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.472269758139048_REALK,      0.000000000000000_REALK, &
     -0.958483257846576_REALK,      0.000000000000000_REALK,     -0.434963499785888_REALK, &
      0.000000000000000_REALK,     -0.664551881818172_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.540993107039053_REALK, &
      0.000000000000000_REALK,     -0.921867977136391_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.505442094763189_REALK,      0.000000000000000_REALK, &
     -0.304634609663732_REALK,      0.000000000000000_REALK,     -0.069982067622716_REALK, &
      0.000000000000000_REALK,     -0.186118824291646_REALK,      0.000000000000000_REALK, &
     -3.265415635127592_REALK,     -2.268152534442383_REALK,      0.000000000000000_REALK, &
     -1.982591476786075_REALK,      0.000000000000000_REALK,      1.171532642704260_REALK, &
     -2.074048792036812_REALK,      0.000000000000000_REALK,      0.932460707557803_REALK, &
      0.000000000000000_REALK,     -2.647735925471725_REALK,      0.000000000000000_REALK, &
      0.990684581189964_REALK,      0.000000000000000_REALK,      1.308314727847534_REALK, &
     -0.629128919579572_REALK,     -0.718842408730941_REALK,      0.000000000000000_REALK, &
     -0.815382758855047_REALK,      0.000000000000000_REALK,      2.937188116177729_REALK, &
     -0.988883330634010_REALK,      0.000000000000000_REALK,      2.870132708738398_REALK, &
      0.000000000000000_REALK,     -1.341277086288903_REALK,      0.000000000000000_REALK, &
      3.324855968431010_REALK,      0.000000000000000_REALK,     -0.027246951289592_REALK, &
     41.203146472028351_REALK,      8.329161148811684_REALK,      0.000000000000000_REALK, &
      3.803795309366867_REALK,      0.000000000000000_REALK,     -4.259436303112782_REALK, &
      1.726398447659577_REALK,      0.000000000000000_REALK,     -0.990713704747560_REALK, &
      0.000000000000000_REALK,      1.120098901041499_REALK,      0.000000000000000_REALK, &
     -0.543435629199157_REALK,      0.000000000000000_REALK,     -3.474300365578791_REALK, &
     50.945694679005172_REALK,      8.754444401258723_REALK,      0.000000000000000_REALK, &
      2.428734459456448_REALK,      0.000000000000000_REALK,    -14.491456969042330_REALK, &
     -0.417193924760103_REALK,      0.000000000000000_REALK,     -2.793613036807701_REALK, &
      0.000000000000000_REALK,     -2.287236893187705_REALK,      0.000000000000000_REALK, &
     -0.892745528917291_REALK,      0.000000000000000_REALK,     -7.285336968468151_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -9.965878247850164_REALK, &
      0.000000000000000_REALK,     -2.738097886844812_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.390368250126219_REALK,      0.000000000000000_REALK, &
     -0.483285777875557_REALK,      0.000000000000000_REALK,     -0.818467790322184_REALK, &
      0.000000000000000_REALK,     -0.159485598276808_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,    -14.242341809794471_REALK, &
      0.000000000000000_REALK,     -3.869944126587510_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.985557667527924_REALK,      0.000000000000000_REALK, &
      2.666856620809991_REALK,      0.000000000000000_REALK,     -1.510531136848363_REALK, &
      0.000000000000000_REALK,      0.834704868977895_REALK,      0.000000000000000_REALK, &
     -2.754244948755943_REALK,     -0.877193075558379_REALK,      0.000000000000000_REALK, &
     -0.437233510304113_REALK,      0.000000000000000_REALK,      2.127862405395634_REALK, &
     -0.253725621903253_REALK,      0.000000000000000_REALK,      0.779760685503540_REALK, &
      0.000000000000000_REALK,     -0.180781312982954_REALK,      0.000000000000000_REALK, &
      0.466835252397068_REALK,      0.000000000000000_REALK,      0.446955370455357_REALK, &
      2.548241398206049_REALK,      0.685917775605770_REALK,      0.000000000000000_REALK, &
      0.212508886934204_REALK,      0.000000000000000_REALK,      2.126932998192582_REALK, &
     -0.004422836555428_REALK,      0.000000000000000_REALK,      0.642271123832616_REALK, &
      0.000000000000000_REALK,     -0.163244663817173_REALK,      0.000000000000000_REALK, &
      0.229209928066973_REALK,      0.000000000000000_REALK,     -1.594598652567411_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.631635279118173_REALK, &
      0.000000000000000_REALK,     -0.678878849318080_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.408289665681696_REALK,      0.000000000000000_REALK, &
     -1.092759649644788_REALK,      0.000000000000000_REALK,     -0.304846704770540_REALK, &
      0.000000000000000_REALK,     -0.546107203931753_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -6.901371803879397_REALK, &
      0.000000000000000_REALK,     -2.926620596953650_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.814207643291383_REALK,      0.000000000000000_REALK, &
     -0.673126223595721_REALK,      0.000000000000000_REALK,     -1.530024312840739_REALK, &
      0.000000000000000_REALK,     -0.328804307909147_REALK,      0.000000000000000_REALK, &
     -4.382834127149986_REALK,     -2.054016482801900_REALK,      0.000000000000000_REALK, &
     -1.257005108841789_REALK,      0.000000000000000_REALK,      1.198949390939552_REALK, &
     -0.900387401961542_REALK,      0.000000000000000_REALK,      0.646509485539946_REALK, &
      0.000000000000000_REALK,     -0.751775186205739_REALK,      0.000000000000000_REALK, &
      0.475217126230074_REALK,      0.000000000000000_REALK,      1.013004931732698_REALK, &
     -2.327361573563652_REALK,     -0.890147979101255_REALK,      0.000000000000000_REALK, &
     -0.335725256223741_REALK,      0.000000000000000_REALK,      4.086783100616696_REALK, &
     -0.032645232368719_REALK,      0.000000000000000_REALK,      1.753529337658129_REALK, &
      0.000000000000000_REALK,      0.210488729442171_REALK,      0.000000000000000_REALK, &
      0.761806772611013_REALK,      0.000000000000000_REALK,     -0.021096832011092_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.395872584408894_REALK, &
      0.000000000000000_REALK,      0.255194136581624_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.210865361150383_REALK,      0.000000000000000_REALK, &
     -1.437041630408984_REALK,      0.000000000000000_REALK,      0.214592313145280_REALK, &
      0.000000000000000_REALK,     -1.112675893440789_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,    -13.095096251101094_REALK, &
      0.000000000000000_REALK,     -8.802337879411517_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -7.161257378717121_REALK,      0.000000000000000_REALK, &
     -6.689256440824538_REALK,      0.000000000000000_REALK,     -6.881798123312346_REALK, &
      0.000000000000000_REALK,     -5.179372837397003_REALK,      0.000000000000000_REALK, &
      9.463830309200178_REALK,      2.179536291094299_REALK,      0.000000000000000_REALK, &
      9.095573402735734_REALK,      0.000000000000000_REALK,      0.242300743382705_REALK, &
      4.660099866463161_REALK,      0.000000000000000_REALK,      0.065276450529713_REALK, &
      0.000000000000000_REALK,     60.319678905504475_REALK,      0.000000000000000_REALK, &
      0.670379713193199_REALK,      0.000000000000000_REALK,    -13.535069791519900_REALK, &
      2.541771017272492_REALK,      0.839046657036442_REALK,      0.000000000000000_REALK, &
      5.269016933523262_REALK,      0.000000000000000_REALK,     -2.213183439846595_REALK, &
      3.574511418685382_REALK,      0.000000000000000_REALK,     -0.903666911012080_REALK, &
      0.000000000000000_REALK,     49.871453897183493_REALK,      0.000000000000000_REALK, &
     -9.955325368276680_REALK,      0.000000000000000_REALK,    -27.533851509782217_REALK, &
      7.184458968449644_REALK,      1.796502125962458_REALK,      0.000000000000000_REALK, &
      3.517806101442681_REALK,      0.000000000000000_REALK,      0.162767669082531_REALK, &
      2.082819198986841_REALK,      0.000000000000000_REALK,      0.045837931118314_REALK, &
      0.000000000000000_REALK,     11.369779085097617_REALK,      0.000000000000000_REALK, &
      0.222634642490780_REALK,      0.000000000000000_REALK,     -7.807355617714952_REALK, &
      2.526463270198781_REALK,      0.590247019915411_REALK,      0.000000000000000_REALK, &
      0.682274663751221_REALK,      0.000000000000000_REALK,     -1.149907105330385_REALK, &
     -0.040484624239909_REALK,      0.000000000000000_REALK,     -0.351738018821233_REALK, &
      0.000000000000000_REALK,     -3.815818199851172_REALK,      0.000000000000000_REALK, &
     -1.022578639558240_REALK,      0.000000000000000_REALK,    -11.348120004987592_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.392744813259428_REALK, &
      0.000000000000000_REALK,     -3.888338761415987_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -3.249554340794059_REALK,      0.000000000000000_REALK, &
     -3.016993167655975_REALK,      0.000000000000000_REALK,    -17.568052958766316_REALK, &
      0.000000000000000_REALK,     -8.576513956040865_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.261956696852469_REALK, &
      0.000000000000000_REALK,     -3.083034786559791_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -3.209090603477226_REALK,      0.000000000000000_REALK, &
     -0.774824003964609_REALK,      0.000000000000000_REALK,    -18.277811999342184_REALK, &
      0.000000000000000_REALK,     -2.656129025158096_REALK,      0.000000000000000_REALK, &
      7.654050268815653_REALK,      1.287036308029394_REALK,      0.000000000000000_REALK, &
      2.304974936043592_REALK,      0.000000000000000_REALK,      0.145963642871433_REALK, &
      1.105707041119855_REALK,      0.000000000000000_REALK,      0.028608303241080_REALK, &
      0.000000000000000_REALK,      5.195988335348902_REALK,      0.000000000000000_REALK, &
      0.116906768909498_REALK,      0.000000000000000_REALK,     -5.610907596565382_REALK, &
      1.474823563388662_REALK,      0.441931265690199_REALK,      0.000000000000000_REALK, &
      0.845838820619889_REALK,      0.000000000000000_REALK,     -1.045464929956779_REALK, &
      0.813161127658611_REALK,      0.000000000000000_REALK,     -0.284924412058626_REALK, &
      0.000000000000000_REALK,      4.269542187460925_REALK,      0.000000000000000_REALK, &
     -1.016937485580981_REALK,      0.000000000000000_REALK,     -8.276368161812085_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.646001398060350_REALK, &
      0.000000000000000_REALK,     -1.810753016890747_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.751547366365816_REALK,      0.000000000000000_REALK, &
     -2.824515692243490_REALK,      0.000000000000000_REALK,     -4.173104232691589_REALK, &
      0.000000000000000_REALK,     -3.200799916118068_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.444489796947362_REALK, &
      0.000000000000000_REALK,     -0.752031716011883_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.552568212698671_REALK,      0.000000000000000_REALK, &
     -0.535331355218454_REALK,      0.000000000000000_REALK,      0.104067135141475_REALK, &
      0.000000000000000_REALK,     -0.519727945901496_REALK,      0.000000000000000_REALK, &
     -3.827128674403096_REALK,     -1.858902244525298_REALK,      0.000000000000000_REALK, &
     -2.739692268613830_REALK,      0.000000000000000_REALK,      2.206788218548608_REALK, &
     -2.949826998084437_REALK,      0.000000000000000_REALK,      1.249372845738540_REALK, &
      0.000000000000000_REALK,    -12.502975843717969_REALK,      0.000000000000000_REALK, &
      4.201549102985045_REALK,      0.000000000000000_REALK,     10.865263970178463_REALK, &
     -0.437220191976517_REALK,     -0.416498189315893_REALK,      0.000000000000000_REALK, &
     -0.737873297591563_REALK,      0.000000000000000_REALK,      2.231235156597307_REALK, &
     -1.062175693359101_REALK,      0.000000000000000_REALK,      1.933142117129001_REALK, &
      0.000000000000000_REALK,     -4.444112124591996_REALK,      0.000000000000000_REALK, &
      6.386518422543717_REALK,      0.000000000000000_REALK,      5.109194505130885_REALK, &
     10.431473873322961_REALK,      0.584708265632021_REALK,      0.000000000000000_REALK, &
      2.101100487830756_REALK,      0.000000000000000_REALK,      0.162319024832960_REALK, &
      0.271499339088984_REALK,      0.000000000000000_REALK,      0.011038390890286_REALK, &
      0.000000000000000_REALK,      2.947118372146866_REALK,      0.000000000000000_REALK, &
      0.081086958941109_REALK,      0.000000000000000_REALK,     -4.747758139714111_REALK, &
      5.010519543702735_REALK,      0.159034182452520_REALK,      0.000000000000000_REALK, &
      0.574124676798713_REALK,      0.000000000000000_REALK,     -1.440955017789814_REALK, &
     -0.333025773986991_REALK,      0.000000000000000_REALK,     -0.063069933034538_REALK, &
      0.000000000000000_REALK,     -0.962247343723518_REALK,      0.000000000000000_REALK, &
     -0.444091879645289_REALK,      0.000000000000000_REALK,     -7.339064955437903_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.559142958393525_REALK, &
      0.000000000000000_REALK,     -1.026619696932653_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.359162112899272_REALK,      0.000000000000000_REALK, &
     -2.999684683487605_REALK,      0.000000000000000_REALK,     -1.531305197464566_REALK, &
      0.000000000000000_REALK,     -1.380828178929964_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.809294063011861_REALK, &
      0.000000000000000_REALK,     -0.683507451443523_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.901378583700518_REALK,      0.000000000000000_REALK, &
     -0.640416275850232_REALK,      0.000000000000000_REALK,     -1.508887359406084_REALK, &
      0.000000000000000_REALK,     -0.303908706255136_REALK,      0.000000000000000_REALK, &
     -3.988922924352661_REALK,     -1.207095148918244_REALK,      0.000000000000000_REALK, &
     -1.341476745712490_REALK,      0.000000000000000_REALK,      1.876781025644894_REALK, &
     -1.035463048214976_REALK,      0.000000000000000_REALK,      0.689036533949641_REALK, &
      0.000000000000000_REALK,     -2.643909723385371_REALK,      0.000000000000000_REALK, &
      1.565386366829009_REALK,      0.000000000000000_REALK,      7.031111231331795_REALK, &
     -0.835445862297012_REALK,     -0.217323585097687_REALK,      0.000000000000000_REALK, &
     -0.142555002556401_REALK,      0.000000000000000_REALK,      1.729663847391669_REALK, &
      0.009919951518860_REALK,      0.000000000000000_REALK,      0.620460991420472_REALK, &
      0.000000000000000_REALK,      0.411471764355239_REALK,      0.000000000000000_REALK, &
      0.793825074378066_REALK,      0.000000000000000_REALK,      2.548172213853037_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.877283716925099_REALK, &
      0.000000000000000_REALK,      0.570624546539369_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.621701536977929_REALK,      0.000000000000000_REALK, &
     -1.663293241635627_REALK,      0.000000000000000_REALK,      1.572147653410231_REALK, &
      0.000000000000000_REALK,     -2.211652331600825_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.352716480629805_REALK, &
      0.000000000000000_REALK,     -1.046287604350175_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.277176305558838_REALK,      0.000000000000000_REALK, &
     -3.720799880265206_REALK,      0.000000000000000_REALK,     -3.201297287933446_REALK, &
      0.000000000000000_REALK,     -5.613262347045026_REALK,      0.000000000000000_REALK, &
     17.481884110487332_REALK,     -0.739577136339899_REALK,      0.000000000000000_REALK, &
      2.742019569032701_REALK,      0.000000000000000_REALK,      0.219282189622889_REALK, &
     -0.592880568806241_REALK,      0.000000000000000_REALK,     -0.011478132569104_REALK, &
      0.000000000000000_REALK,      2.948239170537002_REALK,      0.000000000000000_REALK, &
      0.077497661678300_REALK,      0.000000000000000_REALK,     -4.697171105762132_REALK, &
      4.578950892977232_REALK,     -0.336357645632673_REALK,      0.000000000000000_REALK, &
      1.213261004937080_REALK,      0.000000000000000_REALK,     -2.147677599715272_REALK, &
      0.009370096353675_REALK,      0.000000000000000_REALK,      0.144547866867706_REALK, &
      0.000000000000000_REALK,      2.371515684356980_REALK,      0.000000000000000_REALK, &
     -0.731890992628083_REALK,      0.000000000000000_REALK,     -8.530705320973750_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -6.681157671931513_REALK, &
      0.000000000000000_REALK,     -0.420228864919910_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.342198902624696_REALK,      0.000000000000000_REALK, &
     -3.613810205298281_REALK,      0.000000000000000_REALK,     -0.292123796787548_REALK, &
      0.000000000000000_REALK,     -0.413932749604830_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.340504231735455_REALK, &
      0.000000000000000_REALK,     -0.148736052861172_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.571976518075759_REALK,      0.000000000000000_REALK, &
     -0.825193274105560_REALK,      0.000000000000000_REALK,      0.473766001468805_REALK, &
      0.000000000000000_REALK,     -0.051575290785620_REALK,      0.000000000000000_REALK, &
     -5.575175018638241_REALK,     -0.901852802192629_REALK,      0.000000000000000_REALK, &
     -1.104320518132014_REALK,      0.000000000000000_REALK,      2.114500717230504_REALK, &
     -0.540967772586140_REALK,      0.000000000000000_REALK,      0.423211663165645_REALK, &
      0.000000000000000_REALK,     -1.387208368795585_REALK,      0.000000000000000_REALK, &
      0.943729214187575_REALK,      0.000000000000000_REALK,      5.801389981724927_REALK, &
     -0.602424801052414_REALK,     -0.170407155738047_REALK,      0.000000000000000_REALK, &
     -0.228604138884197_REALK,      0.000000000000000_REALK,      2.034143919609227_REALK, &
     -0.208999457831603_REALK,      0.000000000000000_REALK,      0.527198229704927_REALK, &
      0.000000000000000_REALK,     -0.578979657486895_REALK,      0.000000000000000_REALK, &
      0.992777634022839_REALK,      0.000000000000000_REALK,      2.337083823582529_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.983188511878272_REALK, &
      0.000000000000000_REALK,      0.333859128817874_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.329783033635336_REALK,      0.000000000000000_REALK, &
     -1.532451622883513_REALK,      0.000000000000000_REALK,      0.428753688579983_REALK, &
      0.000000000000000_REALK,     -0.947640303213492_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.904684220112487_REALK, &
      0.000000000000000_REALK,     -0.330127778317891_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.230676782344515_REALK,      0.000000000000000_REALK, &
     -2.696528659279342_REALK,      0.000000000000000_REALK,      0.022921605404351_REALK, &
      0.000000000000000_REALK,     -1.381248674669170_REALK,      0.000000000000000_REALK, &
     -5.935809985443352_REALK,     -2.773582845751958_REALK,      0.000000000000000_REALK, &
     -2.794926868865708_REALK,      0.000000000000000_REALK,     -0.915125024798179_REALK, &
     -3.073035624459172_REALK,      0.000000000000000_REALK,     -0.529071322203291_REALK, &
      0.000000000000000_REALK,     -7.107660172162880_REALK,      0.000000000000000_REALK, &
     -0.970898470718392_REALK,      0.000000000000000_REALK,      3.152999879474417_REALK, &
     -2.328430064130341_REALK,     -2.093854162900803_REALK,      0.000000000000000_REALK, &
     -2.600030736367778_REALK,      0.000000000000000_REALK,      2.778939683517746_REALK, &
     -3.559304316898139_REALK,      0.000000000000000_REALK,      2.289652812167771_REALK, &
      0.000000000000000_REALK,     -7.857189287309963_REALK,      0.000000000000000_REALK, &
      3.991015973449183_REALK,      0.000000000000000_REALK,     11.980512350061437_REALK, &
     40.175041028412878_REALK,     -4.553228527069673_REALK,      0.000000000000000_REALK, &
      5.068850929457563_REALK,      0.000000000000000_REALK,      0.372528423743011_REALK, &
     -2.265511277981753_REALK,      0.000000000000000_REALK,     -0.053466912505215_REALK, &
      0.000000000000000_REALK,      4.155836216345164_REALK,      0.000000000000000_REALK, &
      0.098792813691050_REALK,      0.000000000000000_REALK,     -5.502882287255771_REALK, &
     48.000613370622638_REALK,     -5.977250212736610_REALK,      0.000000000000000_REALK, &
      4.147407192206654_REALK,      0.000000000000000_REALK,     -7.698793254508042_REALK, &
     -2.668315265173357_REALK,      0.000000000000000_REALK,      1.190701517884108_REALK, &
      0.000000000000000_REALK,      0.754009704107816_REALK,      0.000000000000000_REALK, &
     -1.203850486247784_REALK,      0.000000000000000_REALK,    -14.714388651666171_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,    -12.608159684732673_REALK, &
      0.000000000000000_REALK,      0.532518793901729_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.851333028981595_REALK,      0.000000000000000_REALK, &
     -5.159922964322648_REALK,      0.000000000000000_REALK,      0.536101170756055_REALK, &
      0.000000000000000_REALK,      0.361723425071991_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,    -17.437147726617020_REALK, &
      0.000000000000000_REALK,      0.756889460264708_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.962284935698216_REALK,      0.000000000000000_REALK, &
     -1.996687909376208_REALK,      0.000000000000000_REALK,     -0.014241662955454_REALK, &
      0.000000000000000_REALK,      0.126287859964958_REALK,      0.000000000000000_REALK, &
    -11.072453590309630_REALK,     -0.515677273640492_REALK,      0.000000000000000_REALK, &
     -1.328998078939925_REALK,      0.000000000000000_REALK,      3.104424938255300_REALK, &
     -0.148938390922317_REALK,      0.000000000000000_REALK,      0.183095579443353_REALK, &
      0.000000000000000_REALK,     -0.941427229089017_REALK,      0.000000000000000_REALK, &
      0.783203099760598_REALK,      0.000000000000000_REALK,      5.873583861826185_REALK, &
     -5.040229147359401_REALK,     -0.129869025910760_REALK,      0.000000000000000_REALK, &
     -0.322093486108598_REALK,      0.000000000000000_REALK,      5.819717237122913_REALK, &
      0.136603721388818_REALK,      0.000000000000000_REALK,      0.186244212764579_REALK, &
      0.000000000000000_REALK,      0.202577733037398_REALK,      0.000000000000000_REALK, &
      0.673059642327409_REALK,      0.000000000000000_REALK,      3.217349269231609_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.547380335597499_REALK, &
      0.000000000000000_REALK,      0.249897681184842_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.286935474913328_REALK,      0.000000000000000_REALK, &
     -1.824840662800507_REALK,      0.000000000000000_REALK,      0.188246121207302_REALK, &
      0.000000000000000_REALK,     -0.489147997652684_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.726162071319162_REALK, &
      0.000000000000000_REALK,     -0.622828415740195_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.600539193740215_REALK,      0.000000000000000_REALK, &
     -5.148264531527631_REALK,      0.000000000000000_REALK,     -0.515954308253473_REALK, &
      0.000000000000000_REALK,     -1.253897211559370_REALK,      0.000000000000000_REALK, &
     -9.015577878813339_REALK,     -2.266835440747264_REALK,      0.000000000000000_REALK, &
     -1.806759757216593_REALK,      0.000000000000000_REALK,     -1.027500340512786_REALK, &
     -1.209517667600199_REALK,      0.000000000000000_REALK,     -0.327168114612908_REALK, &
      0.000000000000000_REALK,     -1.798355419735530_REALK,      0.000000000000000_REALK, &
     -0.432814262430884_REALK,      0.000000000000000_REALK,      2.441311986845113_REALK, &
    -10.956858318976073_REALK,     -2.313780601412077_REALK,      0.000000000000000_REALK, &
     -1.042697668848278_REALK,      0.000000000000000_REALK,      4.471721388820390_REALK, &
      0.053051106484761_REALK,      0.000000000000000_REALK,      1.172833784419886_REALK, &
      0.000000000000000_REALK,      1.129393378322501_REALK,      0.000000000000000_REALK, &
      0.770135422959214_REALK,      0.000000000000000_REALK,      9.276298612997842_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.232901748043467_REALK, &
      0.000000000000000_REALK,      2.441134634461809_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.306659949362009_REALK,      0.000000000000000_REALK, &
      1.575389509442804_REALK,      0.000000000000000_REALK,      3.396614509538316_REALK, &
      0.000000000000000_REALK,      1.219796206904348_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.069227765529678_REALK, &
      0.000000000000000_REALK,      1.630925198406863_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.455602429662911_REALK,      0.000000000000000_REALK, &
    -11.542097644460270_REALK,      0.000000000000000_REALK,      1.872570715396900_REALK, &
      0.000000000000000_REALK,     -8.936841868022730_REALK,      0.000000000000000_REALK/
    ! results of test 7, ket-major order, 01ODGXXX
  data REF_CONTR_INTS(40321:41580)                                                         &
    /-3.265472355446656_REALK,     -7.813735596646530_REALK,      0.000000000000000_REALK, &
    -22.875654966078319_REALK,      0.000000000000000_REALK,     -3.595431162965437_REALK, &
    -51.315710678533023_REALK,      0.000000000000000_REALK,     -6.136464144862937_REALK, &
      0.000000000000000_REALK,   -275.490541338179355_REALK,      0.000000000000000_REALK, &
    -27.417238487364969_REALK,      0.000000000000000_REALK,    -12.927733934539257_REALK, &
      2.505596483099850_REALK,     -0.798583393649939_REALK,      0.000000000000000_REALK, &
    -12.530990965858939_REALK,      0.000000000000000_REALK,     -1.510728075297577_REALK, &
    -41.729378764516625_REALK,      0.000000000000000_REALK,     -4.053493549422536_REALK, &
      0.000000000000000_REALK,   -281.405420046075733_REALK,      0.000000000000000_REALK, &
    -23.346266256002114_REALK,      0.000000000000000_REALK,     -8.443831772541049_REALK, &
     -5.212146954771741_REALK,     -6.240757317996759_REALK,      0.000000000000000_REALK, &
    -10.137796461468634_REALK,      0.000000000000000_REALK,     -2.571956730130634_REALK, &
    -16.640018445736381_REALK,      0.000000000000000_REALK,     -3.178012319875950_REALK, &
      0.000000000000000_REALK,    -49.971155053013064_REALK,      0.000000000000000_REALK, &
     -8.401943688908782_REALK,      0.000000000000000_REALK,     -6.394713791798811_REALK, &
     -0.327749373245651_REALK,     -1.103136212470482_REALK,      0.000000000000000_REALK, &
     -1.849749194848120_REALK,      0.000000000000000_REALK,     -0.753600307327906_REALK, &
     -0.574694014856333_REALK,      0.000000000000000_REALK,     -1.033143365830085_REALK, &
      0.000000000000000_REALK,     16.858266864140642_REALK,      0.000000000000000_REALK, &
     -2.042017934703224_REALK,      0.000000000000000_REALK,     -2.495795669133078_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.819266601171182_REALK, &
      0.000000000000000_REALK,      3.113040468604507_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      5.894367201223658_REALK,      0.000000000000000_REALK, &
      2.779302916484855_REALK,      0.000000000000000_REALK,     21.575114651332335_REALK, &
      0.000000000000000_REALK,      7.740022445090653_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.736345521026424_REALK, &
      0.000000000000000_REALK,      2.200558363479375_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      5.720213203784148_REALK,      0.000000000000000_REALK, &
      2.068875488105246_REALK,      0.000000000000000_REALK,     25.008752564973928_REALK, &
      0.000000000000000_REALK,      7.287873929776227_REALK,      0.000000000000000_REALK, &
     -7.222477972356128_REALK,     -5.876801920794403_REALK,      0.000000000000000_REALK, &
     -7.059007622663045_REALK,      0.000000000000000_REALK,     -2.361704781801470_REALK, &
     -9.877953573044023_REALK,      0.000000000000000_REALK,     -2.212020139003652_REALK, &
      0.000000000000000_REALK,    -23.423872662537210_REALK,      0.000000000000000_REALK, &
     -4.188745043942472_REALK,      0.000000000000000_REALK,     -4.204236514038834_REALK, &
     -1.017602805222532_REALK,     -1.841023518789175_REALK,      0.000000000000000_REALK, &
     -3.222854084361211_REALK,      0.000000000000000_REALK,     -0.808296218778887_REALK, &
     -6.774854153281390_REALK,      0.000000000000000_REALK,     -0.984145936027778_REALK, &
      0.000000000000000_REALK,    -24.267655774849754_REALK,      0.000000000000000_REALK, &
     -2.263741069009781_REALK,      0.000000000000000_REALK,     -1.703248082425446_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.614174271991597_REALK, &
      0.000000000000000_REALK,      1.738404987798610_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.394850206405620_REALK,      0.000000000000000_REALK, &
      1.822718910198175_REALK,      0.000000000000000_REALK,      5.401190093417026_REALK, &
      0.000000000000000_REALK,      3.094656784458564_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.538597056511856_REALK, &
      0.000000000000000_REALK,      0.652613663338533_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.706701352565159_REALK,      0.000000000000000_REALK, &
      0.863744703279969_REALK,      0.000000000000000_REALK,      0.254987183426956_REALK, &
      0.000000000000000_REALK,      1.375192590069599_REALK,      0.000000000000000_REALK, &
     -1.549782056930419_REALK,     -1.953761419553443_REALK,      0.000000000000000_REALK, &
     -3.224278672061193_REALK,      0.000000000000000_REALK,     -1.520306898246728_REALK, &
     -6.149668420674549_REALK,      0.000000000000000_REALK,     -2.206179312374909_REALK, &
      0.000000000000000_REALK,    -19.224534351808778_REALK,      0.000000000000000_REALK, &
     -5.739764863488270_REALK,      0.000000000000000_REALK,     -4.510675101736261_REALK, &
     -0.548423957767047_REALK,     -1.572735899557999_REALK,      0.000000000000000_REALK, &
     -3.613331331803738_REALK,      0.000000000000000_REALK,     -1.306862586489971_REALK, &
     -8.655026463419903_REALK,      0.000000000000000_REALK,     -2.522186644871825_REALK, &
      0.000000000000000_REALK,    -30.592073742487106_REALK,      0.000000000000000_REALK, &
     -7.614039901559972_REALK,      0.000000000000000_REALK,     -4.589718353904422_REALK, &
    -10.195961712046925_REALK,     -5.865118977643934_REALK,      0.000000000000000_REALK, &
     -5.433454627565196_REALK,      0.000000000000000_REALK,     -2.490389435012316_REALK, &
     -5.909432478017532_REALK,      0.000000000000000_REALK,     -1.710424474890441_REALK, &
      0.000000000000000_REALK,     -9.746540861706164_REALK,      0.000000000000000_REALK, &
     -2.370400520294366_REALK,      0.000000000000000_REALK,     -3.259374090955149_REALK, &
     -3.545219627198449_REALK,     -1.803104461079762_REALK,      0.000000000000000_REALK, &
     -1.213960384608646_REALK,      0.000000000000000_REALK,     -0.855492800895275_REALK, &
      0.057248798435586_REALK,      0.000000000000000_REALK,     -0.585354571429885_REALK, &
      0.000000000000000_REALK,      5.724459912318524_REALK,      0.000000000000000_REALK, &
     -0.565931778731177_REALK,      0.000000000000000_REALK,     -1.196457236926538_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.760405575965852_REALK, &
      0.000000000000000_REALK,      1.361328385543433_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.534468061015650_REALK,      0.000000000000000_REALK, &
      1.540143070077236_REALK,      0.000000000000000_REALK,      2.652079223301691_REALK, &
      0.000000000000000_REALK,      1.781680570412525_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.823040077314231_REALK, &
      0.000000000000000_REALK,      0.758456313508275_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.065342384916262_REALK,      0.000000000000000_REALK, &
      0.801567988086597_REALK,      0.000000000000000_REALK,      2.434056105980550_REALK, &
      0.000000000000000_REALK,      1.060745974998200_REALK,      0.000000000000000_REALK, &
     -1.530851975073775_REALK,     -1.295800329232165_REALK,      0.000000000000000_REALK, &
     -1.473846240194262_REALK,      0.000000000000000_REALK,     -1.121743399875742_REALK, &
     -1.978624529036003_REALK,      0.000000000000000_REALK,     -1.133669379668809_REALK, &
      0.000000000000000_REALK,     -3.824172625621123_REALK,      0.000000000000000_REALK, &
     -1.928941787900365_REALK,      0.000000000000000_REALK,     -2.446860534375856_REALK, &
     -0.919521727328719_REALK,     -0.664517768921301_REALK,      0.000000000000000_REALK, &
     -0.544636809436312_REALK,      0.000000000000000_REALK,     -0.665666136981877_REALK, &
     -0.119999878888083_REALK,      0.000000000000000_REALK,     -0.647181329031049_REALK, &
      0.000000000000000_REALK,      2.096138279816691_REALK,      0.000000000000000_REALK, &
     -0.761706763008080_REALK,      0.000000000000000_REALK,     -1.551622382903012_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.133230859960155_REALK, &
      0.000000000000000_REALK,      1.357733805663918_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.102655035903772_REALK,      0.000000000000000_REALK, &
      1.652401090212516_REALK,      0.000000000000000_REALK,      4.953275309930273_REALK, &
      0.000000000000000_REALK,      2.961626754955710_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.330700625877872_REALK, &
      0.000000000000000_REALK,      1.943785280839991_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.583254082642802_REALK,      0.000000000000000_REALK, &
      2.159973843378352_REALK,      0.000000000000000_REALK,      9.328682005873196_REALK, &
      0.000000000000000_REALK,      4.530830970286924_REALK,      0.000000000000000_REALK, &
    -15.753115154681366_REALK,     -6.507419077120328_REALK,      0.000000000000000_REALK, &
     -5.013372055411702_REALK,      0.000000000000000_REALK,     -3.008450912950833_REALK, &
     -4.450675218378501_REALK,      0.000000000000000_REALK,     -1.497216494753960_REALK, &
      0.000000000000000_REALK,     -6.089756095131469_REALK,      0.000000000000000_REALK, &
     -1.636946625531155_REALK,      0.000000000000000_REALK,     -2.946922858866041_REALK, &
     -3.747788754541385_REALK,     -2.442271050686154_REALK,      0.000000000000000_REALK, &
     -2.448724623868275_REALK,      0.000000000000000_REALK,     -1.158031356151691_REALK, &
     -3.467712404478784_REALK,      0.000000000000000_REALK,     -0.674698190345548_REALK, &
      0.000000000000000_REALK,     -8.550809532650138_REALK,      0.000000000000000_REALK, &
     -0.834054385865047_REALK,      0.000000000000000_REALK,     -1.183303082126628_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.190219913641819_REALK, &
      0.000000000000000_REALK,      1.217715417087095_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.099442015735217_REALK,      0.000000000000000_REALK, &
      1.511766804771819_REALK,      0.000000000000000_REALK,      1.373701144085328_REALK, &
      0.000000000000000_REALK,      1.192811018707222_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.899859862142954_REALK, &
      0.000000000000000_REALK,      0.531016168793583_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.352759501126094_REALK,      0.000000000000000_REALK, &
      0.745781866081414_REALK,      0.000000000000000_REALK,     -0.017689254429225_REALK, &
      0.000000000000000_REALK,      0.542604538171256_REALK,      0.000000000000000_REALK, &
     -1.913838255810972_REALK,     -1.197245899418277_REALK,      0.000000000000000_REALK, &
     -1.092445438168901_REALK,      0.000000000000000_REALK,     -1.096485690239571_REALK, &
     -1.230090570008060_REALK,      0.000000000000000_REALK,     -0.826381221637329_REALK, &
      0.000000000000000_REALK,     -1.994706992058646_REALK,      0.000000000000000_REALK, &
     -1.070103028753148_REALK,      0.000000000000000_REALK,     -1.790101084402231_REALK, &
     -0.784445227723247_REALK,     -0.797790925885954_REALK,      0.000000000000000_REALK, &
     -0.966446764581926_REALK,      0.000000000000000_REALK,     -0.727158516967883_REALK, &
     -1.517208345471767_REALK,      0.000000000000000_REALK,     -0.661189625719217_REALK, &
      0.000000000000000_REALK,     -3.528851920247394_REALK,      0.000000000000000_REALK, &
     -0.987537538742863_REALK,      0.000000000000000_REALK,     -1.238378836853668_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.986538369406460_REALK, &
      0.000000000000000_REALK,      0.807101805293506_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.894684096366004_REALK,      0.000000000000000_REALK, &
      1.134905791280819_REALK,      0.000000000000000_REALK,      1.379847619562218_REALK, &
      0.000000000000000_REALK,      1.317658615830391_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.700188520149887_REALK, &
      0.000000000000000_REALK,      0.587103555059486_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.474790969196903_REALK,      0.000000000000000_REALK, &
      0.967165227858577_REALK,      0.000000000000000_REALK,      0.111235962000981_REALK, &
      0.000000000000000_REALK,      0.999859866400124_REALK,      0.000000000000000_REALK, &
     -1.232000512874643_REALK,     -1.194084578412571_REALK,      0.000000000000000_REALK, &
     -1.496959083329213_REALK,      0.000000000000000_REALK,     -1.176406390520219_REALK, &
     -2.297434102218698_REALK,      0.000000000000000_REALK,     -1.373665277849119_REALK, &
      0.000000000000000_REALK,     -4.911311674600469_REALK,      0.000000000000000_REALK, &
     -2.443906110428038_REALK,      0.000000000000000_REALK,     -2.688809278369133_REALK, &
     -1.268300030910518_REALK,     -2.044592722488961_REALK,      0.000000000000000_REALK, &
     -3.250620987089814_REALK,      0.000000000000000_REALK,     -1.959463701126168_REALK, &
     -5.814801950040264_REALK,      0.000000000000000_REALK,     -2.824180816190354_REALK, &
      0.000000000000000_REALK,    -13.345528612912824_REALK,      0.000000000000000_REALK, &
     -5.535932184126784_REALK,      0.000000000000000_REALK,     -4.671858544470154_REALK, &
    -27.373311207001766_REALK,     -7.919070407337382_REALK,      0.000000000000000_REALK, &
     -5.272306551486256_REALK,      0.000000000000000_REALK,     -4.155430239398581_REALK, &
     -3.573250187706644_REALK,      0.000000000000000_REALK,     -1.443281057158836_REALK, &
      0.000000000000000_REALK,     -3.808407113619712_REALK,      0.000000000000000_REALK, &
     -1.300515275573218_REALK,      0.000000000000000_REALK,     -3.075049098611286_REALK, &
    -16.329480143042829_REALK,     -3.839565663646379_REALK,      0.000000000000000_REALK, &
     -1.621845678858614_REALK,      0.000000000000000_REALK,     -1.999334021532502_REALK, &
      0.456023246193007_REALK,      0.000000000000000_REALK,     -0.630897877420901_REALK, &
      0.000000000000000_REALK,      4.512490605171417_REALK,      0.000000000000000_REALK, &
     -0.363895477561085_REALK,      0.000000000000000_REALK,     -1.345778981416490_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.158400952415122_REALK, &
      0.000000000000000_REALK,      1.265060310673888_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.959248161489025_REALK,      0.000000000000000_REALK, &
      1.726892184710045_REALK,      0.000000000000000_REALK,      0.927614085992253_REALK, &
      0.000000000000000_REALK,      0.936153982599326_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.082157895134937_REALK, &
      0.000000000000000_REALK,      0.861415998593070_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.723452891098676_REALK,      0.000000000000000_REALK, &
      1.026388746727359_REALK,      0.000000000000000_REALK,      0.993375833252289_REALK, &
      0.000000000000000_REALK,      0.579830850011674_REALK,      0.000000000000000_REALK, &
     -2.804797533464013_REALK,     -1.278409934010220_REALK,      0.000000000000000_REALK, &
     -0.928964156397757_REALK,      0.000000000000000_REALK,     -1.277354471054894_REALK, &
     -0.804986721220461_REALK,      0.000000000000000_REALK,     -0.698985390759142_REALK, &
      0.000000000000000_REALK,     -0.942198774985691_REALK,      0.000000000000000_REALK, &
     -0.687440343646957_REALK,      0.000000000000000_REALK,     -1.575419586955108_REALK, &
     -2.592274306373985_REALK,     -0.954775103821140_REALK,      0.000000000000000_REALK, &
     -0.450383122815401_REALK,      0.000000000000000_REALK,     -0.952171563664790_REALK, &
      0.015343534516553_REALK,      0.000000000000000_REALK,     -0.470651349019790_REALK, &
      0.000000000000000_REALK,      1.022161866817192_REALK,      0.000000000000000_REALK, &
     -0.303159018824226_REALK,      0.000000000000000_REALK,     -1.068199429811747_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.151137761116202_REALK, &
      0.000000000000000_REALK,      0.698243766778285_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.627078700627896_REALK,      0.000000000000000_REALK, &
      1.048996434770847_REALK,      0.000000000000000_REALK,      0.769130042385859_REALK, &
      0.000000000000000_REALK,      0.861175915987812_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.307442012754068_REALK, &
      0.000000000000000_REALK,      0.844169037131397_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.856583095275029_REALK,      0.000000000000000_REALK, &
      1.074161067887679_REALK,      0.000000000000000_REALK,      1.303878114967447_REALK, &
      0.000000000000000_REALK,      0.947036141950933_REALK,      0.000000000000000_REALK, &
     -1.263361897106449_REALK,     -0.847330132448345_REALK,      0.000000000000000_REALK, &
     -0.755955698370634_REALK,      0.000000000000000_REALK,     -0.958928971150055_REALK, &
     -0.808588546233497_REALK,      0.000000000000000_REALK,     -0.772145887343973_REALK, &
      0.000000000000000_REALK,     -1.109049091668189_REALK,      0.000000000000000_REALK, &
     -0.932354676067239_REALK,      0.000000000000000_REALK,     -1.655767232224310_REALK, &
     -2.017070420365329_REALK,     -1.055621072724019_REALK,      0.000000000000000_REALK, &
     -0.606185910539133_REALK,      0.000000000000000_REALK,     -1.234821157788492_REALK, &
     -0.096485288810378_REALK,      0.000000000000000_REALK,     -0.867271395366472_REALK, &
      0.000000000000000_REALK,      1.122861885674354_REALK,      0.000000000000000_REALK, &
     -0.680053331466405_REALK,      0.000000000000000_REALK,     -1.939408222011257_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.235041944095373_REALK, &
      0.000000000000000_REALK,      1.160666763455146_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.432125157116353_REALK,      0.000000000000000_REALK, &
      1.575638030368470_REALK,      0.000000000000000_REALK,      2.394167323260061_REALK, &
      0.000000000000000_REALK,      2.004104633689443_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.523145374135919_REALK, &
      0.000000000000000_REALK,      3.605752279756441_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      4.801828527499344_REALK,      0.000000000000000_REALK, &
      4.052337147409784_REALK,      0.000000000000000_REALK,      8.328666075159266_REALK, &
      0.000000000000000_REALK,      5.663189016310396_REALK,      0.000000000000000_REALK, &
   -190.777317056496543_REALK,    134.678124319619201_REALK,      0.000000000000000_REALK, &
   -121.670183776018277_REALK,      0.000000000000000_REALK,    -54.860689735728286_REALK, &
    233.113087590624360_REALK,      0.000000000000000_REALK,     55.268846418437676_REALK, &
      0.000000000000000_REALK,   -479.464691433399310_REALK,      0.000000000000000_REALK, &
    -90.192600448172925_REALK,      0.000000000000000_REALK,   -122.002649689948129_REALK, &
   -159.708341843177010_REALK,    135.050457657112418_REALK,      0.000000000000000_REALK, &
   -144.298644951622009_REALK,      0.000000000000000_REALK,    -47.725612130253438_REALK, &
    305.956969784880926_REALK,      0.000000000000000_REALK,     60.905074594977876_REALK, &
      0.000000000000000_REALK,   -673.244176365137719_REALK,      0.000000000000000_REALK, &
   -105.822367018756950_REALK,      0.000000000000000_REALK,   -104.999681280494556_REALK, &
    -73.092831054110192_REALK,     35.300207362918698_REALK,      0.000000000000000_REALK, &
    -32.174760570198607_REALK,      0.000000000000000_REALK,    -25.197880156385498_REALK, &
     40.583435767105215_REALK,      0.000000000000000_REALK,     15.117315698355092_REALK, &
      0.000000000000000_REALK,   -103.943999477569449_REALK,      0.000000000000000_REALK, &
    -34.450265659982065_REALK,      0.000000000000000_REALK,    -80.939871819271076_REALK, &
    -35.738049660992822_REALK,     16.587376565292189_REALK,      0.000000000000000_REALK, &
     -9.891635795203642_REALK,      0.000000000000000_REALK,    -13.127229193748816_REALK, &
     -1.161830504015325_REALK,      0.000000000000000_REALK,      7.948284650488787_REALK, &
      0.000000000000000_REALK,     51.159057615066274_REALK,      0.000000000000000_REALK, &
    -10.795257705086550_REALK,      0.000000000000000_REALK,    -42.979288269681952_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,    -22.221811616905637_REALK, &
      0.000000000000000_REALK,     11.854582568102586_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,    -21.105701337476297_REALK,      0.000000000000000_REALK, &
    -28.549476053930011_REALK,      0.000000000000000_REALK,     53.536475185678306_REALK, &
      0.000000000000000_REALK,     38.078933131604551_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,    -21.188827863094438_REALK, &
      0.000000000000000_REALK,     14.899306136193035_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,    -30.698233574426339_REALK,      0.000000000000000_REALK, &
    -30.459578933984858_REALK,      0.000000000000000_REALK,     81.684153365252655_REALK, &
      0.000000000000000_REALK,     48.781168058726486_REALK,      0.000000000000000_REALK, &
    -34.577074804474677_REALK,      9.503178355248286_REALK,      0.000000000000000_REALK, &
    -14.027813335572496_REALK,      0.000000000000000_REALK,    -15.035604745563948_REALK, &
      9.078177766226364_REALK,      0.000000000000000_REALK,      3.975604229916761_REALK, &
      0.000000000000000_REALK,    -51.591085093923255_REALK,      0.000000000000000_REALK, &
    -19.647106003896955_REALK,      0.000000000000000_REALK,    -63.175802215663353_REALK, &
    -15.118300445008051_REALK,      5.179424364818995_REALK,      0.000000000000000_REALK, &
     -6.644971483047777_REALK,      0.000000000000000_REALK,     -6.467201815955732_REALK, &
      9.222800414784997_REALK,      0.000000000000000_REALK,      2.544586968176875_REALK, &
      0.000000000000000_REALK,    -54.846634000253722_REALK,      0.000000000000000_REALK, &
    -10.286422623036890_REALK,      0.000000000000000_REALK,    -30.033704992010119_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -8.973743618858029_REALK, &
      0.000000000000000_REALK,      3.673345122697648_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -4.793571825236873_REALK,      0.000000000000000_REALK, &
    -11.262354053247195_REALK,      0.000000000000000_REALK,     13.811615274417685_REALK, &
      0.000000000000000_REALK,     15.434465647940524_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -5.643129169537978_REALK, &
      0.000000000000000_REALK,      1.969338675180113_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.089059666009123_REALK,      0.000000000000000_REALK, &
     -8.317198167086438_REALK,      0.000000000000000_REALK,     -0.445616245017422_REALK, &
      0.000000000000000_REALK,      9.145614824295507_REALK,      0.000000000000000_REALK, &
     -5.317791281420228_REALK,      4.221783102963842_REALK,      0.000000000000000_REALK, &
     -5.128458425828048_REALK,      0.000000000000000_REALK,     -6.937215621533140_REALK, &
      7.449316693388136_REALK,      0.000000000000000_REALK,      5.298481666188505_REALK, &
      0.000000000000000_REALK,    -38.183978000259856_REALK,      0.000000000000000_REALK, &
    -21.548483128153205_REALK,      0.000000000000000_REALK,    -48.580704429008932_REALK, &
     -5.880797114855647_REALK,      6.404909049890389_REALK,      0.000000000000000_REALK, &
     -7.606071158273465_REALK,      0.000000000000000_REALK,     -7.546939932594007_REALK, &
     15.807225247346201_REALK,      0.000000000000000_REALK,      9.439957195675028_REALK, &
      0.000000000000000_REALK,    -74.907751321342957_REALK,      0.000000000000000_REALK, &
    -35.322617697227834_REALK,      0.000000000000000_REALK,    -58.413353507522750_REALK, &
    -22.448030066956179_REALK,      1.285938487144900_REALK,      0.000000000000000_REALK, &
     -9.073630368389024_REALK,      0.000000000000000_REALK,    -11.864682493438773_REALK, &
      0.650868975521506_REALK,      0.000000000000000_REALK,      0.447901997462217_REALK, &
      0.000000000000000_REALK,    -30.306700871237783_REALK,      0.000000000000000_REALK, &
    -14.113818612235560_REALK,      0.000000000000000_REALK,    -55.365703628687434_REALK, &
     -6.486127099341057_REALK,      0.388453211726382_REALK,      0.000000000000000_REALK, &
     -2.096255881795924_REALK,      0.000000000000000_REALK,     -4.142761588435214_REALK, &
     -1.049015714703462_REALK,      0.000000000000000_REALK,      0.156432848908888_REALK, &
      0.000000000000000_REALK,     11.160048669020842_REALK,      0.000000000000000_REALK, &
     -4.055586200037202_REALK,      0.000000000000000_REALK,    -24.044765060419820_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.342280668381246_REALK, &
      0.000000000000000_REALK,      1.477823599716187_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.086112468338218_REALK,      0.000000000000000_REALK, &
     -3.492424099004270_REALK,      0.000000000000000_REALK,      5.249060573964798_REALK, &
      0.000000000000000_REALK,      6.896159545998276_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.287305543650700_REALK, &
      0.000000000000000_REALK,      0.831878842837806_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.946433552653423_REALK,      0.000000000000000_REALK, &
     -2.763342238269908_REALK,      0.000000000000000_REALK,      5.833308340411016_REALK, &
      0.000000000000000_REALK,      4.828260306025513_REALK,      0.000000000000000_REALK, &
     -2.640276982733066_REALK,      0.816551818144006_REALK,      0.000000000000000_REALK, &
     -1.781880982257122_REALK,      0.000000000000000_REALK,     -4.186476229953211_REALK, &
      0.763520467312602_REALK,      0.000000000000000_REALK,      0.853233325001713_REALK, &
      0.000000000000000_REALK,     -8.362747591155525_REALK,      0.000000000000000_REALK, &
     -8.315021865928482_REALK,      0.000000000000000_REALK,    -32.559826516542351_REALK, &
     -1.419038206584422_REALK,      0.696511319308430_REALK,      0.000000000000000_REALK, &
     -0.682957414823169_REALK,      0.000000000000000_REALK,     -2.719066502115188_REALK, &
     -0.041000275931440_REALK,      0.000000000000000_REALK,      0.841470066568425_REALK, &
      0.000000000000000_REALK,      6.261703343608626_REALK,      0.000000000000000_REALK, &
     -3.963913982290602_REALK,      0.000000000000000_REALK,    -26.302630033682437_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.542081083973915_REALK, &
      0.000000000000000_REALK,      1.969567591772298_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.191222574694756_REALK,      0.000000000000000_REALK, &
     -2.685591902977195_REALK,      0.000000000000000_REALK,     12.921727982804892_REALK, &
      0.000000000000000_REALK,     15.318080308657780_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.669184917475795_REALK, &
      0.000000000000000_REALK,      3.086119974120179_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -3.249964713809923_REALK,      0.000000000000000_REALK, &
     -5.374497987153796_REALK,      0.000000000000000_REALK,     29.993629286268064_REALK, &
      0.000000000000000_REALK,     29.853286727520405_REALK,      0.000000000000000_REALK, &
    -25.480736788417875_REALK,      0.156512144620696_REALK,      0.000000000000000_REALK, &
     -9.481628058801819_REALK,      0.000000000000000_REALK,    -12.834181009826461_REALK, &
      0.526394300419586_REALK,      0.000000000000000_REALK,      0.172491474109392_REALK, &
      0.000000000000000_REALK,    -29.965094727728690_REALK,      0.000000000000000_REALK, &
    -13.331959255602957_REALK,      0.000000000000000_REALK,    -54.137784325932060_REALK, &
     -5.802418570779700_REALK,     -0.061229514989451_REALK,      0.000000000000000_REALK, &
     -3.245564851267218_REALK,      0.000000000000000_REALK,     -4.523833126903571_REALK, &
     -0.005060396693305_REALK,      0.000000000000000_REALK,      0.061468643681174_REALK, &
      0.000000000000000_REALK,    -23.686888168085819_REALK,      0.000000000000000_REALK, &
     -5.756120110709978_REALK,      0.000000000000000_REALK,    -24.069517664173500_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.471297387115925_REALK, &
      0.000000000000000_REALK,      0.484369725358871_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.397227755214200_REALK,      0.000000000000000_REALK, &
      1.558245487809528_REALK,      0.000000000000000_REALK,      0.989688730190803_REALK, &
      0.000000000000000_REALK,      2.043192604608906_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.202698384279472_REALK, &
      0.000000000000000_REALK,      0.132626726186170_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.102966855816915_REALK,      0.000000000000000_REALK, &
      0.610470036885209_REALK,      0.000000000000000_REALK,     -1.577337560764162_REALK, &
      0.000000000000000_REALK,      0.705654085623737_REALK,      0.000000000000000_REALK, &
     -2.499444711477381_REALK,     -0.058703163911015_REALK,      0.000000000000000_REALK, &
     -1.174542647674184_REALK,      0.000000000000000_REALK,     -3.776773739023341_REALK, &
     -0.147732701267098_REALK,      0.000000000000000_REALK,     -0.194089640182925_REALK, &
      0.000000000000000_REALK,     -4.336665523169195_REALK,      0.000000000000000_REALK, &
     -4.954514549289032_REALK,      0.000000000000000_REALK,    -26.552293178990876_REALK, &
     -1.001656914661755_REALK,      0.040702438158695_REALK,      0.000000000000000_REALK, &
     -0.802404255350983_REALK,      0.000000000000000_REALK,     -2.342813782079482_REALK, &
     -0.148101258165146_REALK,      0.000000000000000_REALK,     -0.122584198252895_REALK, &
      0.000000000000000_REALK,     -7.587844032341394_REALK,      0.000000000000000_REALK, &
     -4.269274055030847_REALK,      0.000000000000000_REALK,    -20.775301287556832_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.166298197148638_REALK, &
      0.000000000000000_REALK,      0.922702719880097_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.234022950209687_REALK,      0.000000000000000_REALK, &
      0.916383237780699_REALK,      0.000000000000000_REALK,      3.482948013448502_REALK, &
      0.000000000000000_REALK,      6.486984613921883_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.133039368778970_REALK, &
      0.000000000000000_REALK,      0.713414227836693_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.100639399424287_REALK,      0.000000000000000_REALK, &
      0.667794735631314_REALK,      0.000000000000000_REALK,     -0.184948445448130_REALK, &
      0.000000000000000_REALK,      6.326322492853675_REALK,      0.000000000000000_REALK, &
     -1.153208480206623_REALK,     -0.078236569774523_REALK,      0.000000000000000_REALK, &
     -1.288210712645590_REALK,      0.000000000000000_REALK,     -2.904250081137008_REALK, &
     -0.363676843320653_REALK,      0.000000000000000_REALK,     -0.431121216899016_REALK, &
      0.000000000000000_REALK,     -9.629055521688322_REALK,      0.000000000000000_REALK, &
     -9.056658111409064_REALK,      0.000000000000000_REALK,    -28.585323592924354_REALK, &
     -1.168889541898819_REALK,      0.150998680250641_REALK,      0.000000000000000_REALK, &
     -2.755381514941468_REALK,      0.000000000000000_REALK,     -4.556600981840630_REALK, &
     -0.761505131395518_REALK,      0.000000000000000_REALK,     -0.757941988782148_REALK, &
      0.000000000000000_REALK,    -31.089692787918541_REALK,      0.000000000000000_REALK, &
    -24.433816111609225_REALK,      0.000000000000000_REALK,    -56.569012252117055_REALK, &
    -47.884222211318566_REALK,      5.397129002043533_REALK,      0.000000000000000_REALK, &
    -14.761028450421822_REALK,      0.000000000000000_REALK,    -18.361956273141281_REALK, &
      5.835004472157563_REALK,      0.000000000000000_REALK,      2.330840237582188_REALK, &
      0.000000000000000_REALK,    -39.298007466002709_REALK,      0.000000000000000_REALK, &
    -15.812112584119980_REALK,      0.000000000000000_REALK,    -59.008351788787664_REALK, &
    -22.327720389350173_REALK,      3.075981495163008_REALK,      0.000000000000000_REALK, &
     -5.474546801222181_REALK,      0.000000000000000_REALK,     -8.001945523433976_REALK, &
      4.107744870463028_REALK,      0.000000000000000_REALK,      1.443346705918403_REALK, &
      0.000000000000000_REALK,     -5.139135021545857_REALK,      0.000000000000000_REALK, &
     -6.460811678376242_REALK,      0.000000000000000_REALK,    -28.330598841163081_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.981656707419164_REALK, &
      0.000000000000000_REALK,     -0.516916961823070_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.589418484111326_REALK,      0.000000000000000_REALK, &
      6.454234778755872_REALK,      0.000000000000000_REALK,     -1.689808958948191_REALK, &
      0.000000000000000_REALK,     -1.661174739505509_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.991138167023512_REALK, &
      0.000000000000000_REALK,     -0.333029495420431_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.006948214878891_REALK,      0.000000000000000_REALK, &
      4.210606689710995_REALK,      0.000000000000000_REALK,      0.032355829755103_REALK, &
      0.000000000000000_REALK,     -1.179078888927783_REALK,      0.000000000000000_REALK, &
     -4.059207584745020_REALK,     -0.188010726150529_REALK,      0.000000000000000_REALK, &
     -1.190399499090038_REALK,      0.000000000000000_REALK,     -4.669700502542989_REALK, &
     -0.117989376589254_REALK,      0.000000000000000_REALK,     -0.243586709957890_REALK, &
      0.000000000000000_REALK,     -2.738168354157962_REALK,      0.000000000000000_REALK, &
     -3.825491759516351_REALK,      0.000000000000000_REALK,    -25.011072341040482_REALK, &
     -3.076245287282364_REALK,     -0.087692196315464_REALK,      0.000000000000000_REALK, &
     -0.557861667089914_REALK,      0.000000000000000_REALK,     -3.307451021819752_REALK, &
      0.275931914297214_REALK,      0.000000000000000_REALK,     -0.123443762147829_REALK, &
      0.000000000000000_REALK,      1.811664948036477_REALK,      0.000000000000000_REALK, &
     -1.975089064640923_REALK,      0.000000000000000_REALK,    -19.516517954198459_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.465975134292156_REALK, &
      0.000000000000000_REALK,      0.581641658770123_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.590670647386578_REALK,      0.000000000000000_REALK, &
      3.165529144299991_REALK,      0.000000000000000_REALK,      1.422736009480562_REALK, &
      0.000000000000000_REALK,      3.115292211168613_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.549057961517513_REALK, &
      0.000000000000000_REALK,      0.664145997794042_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.746846453141825_REALK,      0.000000000000000_REALK, &
      3.634332179092798_REALK,      0.000000000000000_REALK,      2.840847893633429_REALK, &
      0.000000000000000_REALK,      3.918974825218999_REALK,      0.000000000000000_REALK, &
     -1.432299269312807_REALK,     -0.358152046470688_REALK,      0.000000000000000_REALK, &
     -0.701312531786615_REALK,      0.000000000000000_REALK,     -2.746188132398796_REALK, &
     -0.415232438506542_REALK,      0.000000000000000_REALK,     -0.773369694119044_REALK, &
      0.000000000000000_REALK,     -2.266687908908400_REALK,      0.000000000000000_REALK, &
     -3.756253416389590_REALK,      0.000000000000000_REALK,    -20.592145900102331_REALK, &
     -2.019067555393309_REALK,     -0.471706286664147_REALK,      0.000000000000000_REALK, &
     -0.545251796729502_REALK,      0.000000000000000_REALK,     -3.618029137022101_REALK, &
      0.032353999466083_REALK,      0.000000000000000_REALK,     -1.106696701667932_REALK, &
      0.000000000000000_REALK,      3.049478223363482_REALK,      0.000000000000000_REALK, &
     -3.217407124165185_REALK,      0.000000000000000_REALK,    -29.888836510031432_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.127300361872834_REALK, &
      0.000000000000000_REALK,      1.291970346752169_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.079722757215951_REALK,      0.000000000000000_REALK, &
      3.407904331375991_REALK,      0.000000000000000_REALK,      5.837300931216253_REALK, &
      0.000000000000000_REALK,      9.687771047094094_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.012804125692685_REALK, &
      0.000000000000000_REALK,      4.106435785232474_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      4.274335323629878_REALK,      0.000000000000000_REALK, &
      9.895913359894340_REALK,      0.000000000000000_REALK,     24.345058186515836_REALK, &
      0.000000000000000_REALK,     33.923604032878806_REALK,      0.000000000000000_REALK/
    ! results of test 7, ket-major order, 01ODGXXY
  data REF_CONTR_INTS(41581:42840)                                                         &
     /0.218884656985987_REALK,     -0.854032447146465_REALK,      0.000000000000000_REALK, &
     -1.651400185012393_REALK,      0.000000000000000_REALK,     -0.816086574938233_REALK, &
     -0.989680616784998_REALK,      0.000000000000000_REALK,     -0.920134387761684_REALK, &
      0.000000000000000_REALK,      8.328973072684899_REALK,      0.000000000000000_REALK, &
     -1.951460554441513_REALK,      0.000000000000000_REALK,     -2.893109933839487_REALK, &
      0.719261624345730_REALK,     -0.324935059031339_REALK,      0.000000000000000_REALK, &
      0.643745182485891_REALK,      0.000000000000000_REALK,     -0.034343176060455_REALK, &
      6.904585569435595_REALK,      0.000000000000000_REALK,      0.164471037095362_REALK, &
      0.000000000000000_REALK,     61.803165652309907_REALK,      0.000000000000000_REALK, &
      2.536395466132255_REALK,      0.000000000000000_REALK,     -0.405942654433284_REALK, &
     -1.517863296970444_REALK,     -1.725016719871126_REALK,      0.000000000000000_REALK, &
     -2.445490225440290_REALK,      0.000000000000000_REALK,     -0.985213729793337_REALK, &
     -3.642913348344206_REALK,      0.000000000000000_REALK,     -0.930358863951708_REALK, &
      0.000000000000000_REALK,     -9.826454752134239_REALK,      0.000000000000000_REALK, &
     -1.856903872126778_REALK,      0.000000000000000_REALK,     -2.244270499257059_REALK, &
      0.419488951857468_REALK,     -0.169410665559575_REALK,      0.000000000000000_REALK, &
     -1.101062854807932_REALK,      0.000000000000000_REALK,     -0.226794471157706_REALK, &
     -3.981192673485336_REALK,      0.000000000000000_REALK,     -0.390444182335838_REALK, &
      0.000000000000000_REALK,    -21.576973787124249_REALK,      0.000000000000000_REALK, &
     -1.335917845681453_REALK,      0.000000000000000_REALK,     -0.825508135158149_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.453064349516843_REALK, &
      0.000000000000000_REALK,      0.476647553171250_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.494462290385379_REALK,      0.000000000000000_REALK, &
      0.733057996466841_REALK,      0.000000000000000_REALK,      0.389282303415769_REALK, &
      0.000000000000000_REALK,      1.085780688774695_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.016308611604772_REALK, &
      0.000000000000000_REALK,     -0.088138410017770_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.704544993570987_REALK,      0.000000000000000_REALK, &
      0.112760359603550_REALK,      0.000000000000000_REALK,     -4.489324896088761_REALK, &
      0.000000000000000_REALK,     -0.320814586520405_REALK,      0.000000000000000_REALK, &
     -3.504389325089737_REALK,     -2.190939197881040_REALK,      0.000000000000000_REALK, &
     -2.153379442765976_REALK,      0.000000000000000_REALK,     -1.183003380596675_REALK, &
     -2.262244518583762_REALK,      0.000000000000000_REALK,     -0.797395628465542_REALK, &
      0.000000000000000_REALK,     -3.400321345207874_REALK,      0.000000000000000_REALK, &
     -1.124770470563161_REALK,      0.000000000000000_REALK,     -1.853747522585790_REALK, &
     -0.040598142807251_REALK,     -0.227312608515163_REALK,      0.000000000000000_REALK, &
      0.036679028128639_REALK,      0.000000000000000_REALK,     -0.267386771346084_REALK, &
      1.491621795957514_REALK,      0.000000000000000_REALK,     -0.163388903238819_REALK, &
      0.000000000000000_REALK,      9.242488942037934_REALK,      0.000000000000000_REALK, &
      0.025900119051515_REALK,      0.000000000000000_REALK,     -0.566428520382994_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.691738087441118_REALK, &
      0.000000000000000_REALK,      0.546294571314490_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.624914626480019_REALK,      0.000000000000000_REALK, &
      0.755277363473341_REALK,      0.000000000000000_REALK,      1.117296837302734_REALK, &
      0.000000000000000_REALK,      0.856034923303032_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.151953808780741_REALK, &
      0.000000000000000_REALK,      0.249886378283624_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.530261713328266_REALK,      0.000000000000000_REALK, &
      0.327666375241879_REALK,      0.000000000000000_REALK,      1.799205471771527_REALK, &
      0.000000000000000_REALK,      0.529355924388110_REALK,      0.000000000000000_REALK, &
     -0.425030238751424_REALK,     -0.334663694631348_REALK,      0.000000000000000_REALK, &
     -0.290341797583263_REALK,      0.000000000000000_REALK,     -0.430442079336494_REALK, &
     -0.131007430640835_REALK,      0.000000000000000_REALK,     -0.365404070587522_REALK, &
      0.000000000000000_REALK,      0.647268668844245_REALK,      0.000000000000000_REALK, &
     -0.454960988954753_REALK,      0.000000000000000_REALK,     -1.124159845009977_REALK, &
     -0.003652456679704_REALK,      0.059053322745093_REALK,      0.000000000000000_REALK, &
      0.450912588140138_REALK,      0.000000000000000_REALK,     -0.072167237085514_REALK, &
      1.781933760958900_REALK,      0.000000000000000_REALK,      0.127339935504966_REALK, &
      0.000000000000000_REALK,      7.758362237337845_REALK,      0.000000000000000_REALK, &
      0.955207128746483_REALK,      0.000000000000000_REALK,     -0.254796831799680_REALK, &
     -6.782654140788305_REALK,     -2.823521172591122_REALK,      0.000000000000000_REALK, &
     -2.290883375062810_REALK,      0.000000000000000_REALK,     -1.563666882664958_REALK, &
     -2.052044478758253_REALK,      0.000000000000000_REALK,     -0.755404267576124_REALK, &
      0.000000000000000_REALK,     -2.992514226125708_REALK,      0.000000000000000_REALK, &
     -0.856878258196611_REALK,      0.000000000000000_REALK,     -1.754614184295964_REALK, &
     -1.087932568797374_REALK,     -0.886603986703474_REALK,      0.000000000000000_REALK, &
     -1.196397957535395_REALK,      0.000000000000000_REALK,     -0.498287964230639_REALK, &
     -2.386435235939626_REALK,      0.000000000000000_REALK,     -0.321041305638246_REALK, &
      0.000000000000000_REALK,     -7.811744579477506_REALK,      0.000000000000000_REALK, &
     -0.513605203352427_REALK,      0.000000000000000_REALK,     -0.641734523830059_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.004938971945125_REALK, &
      0.000000000000000_REALK,      0.546240335382483_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.489398519280537_REALK,      0.000000000000000_REALK, &
      0.806583490958127_REALK,      0.000000000000000_REALK,      0.579649683668467_REALK, &
      0.000000000000000_REALK,      0.612944515946528_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.292499287137137_REALK, &
      0.000000000000000_REALK,      0.140651413396212_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.014528940582679_REALK,      0.000000000000000_REALK, &
      0.317743957107321_REALK,      0.000000000000000_REALK,     -0.551231485598499_REALK, &
      0.000000000000000_REALK,      0.181141978697412_REALK,      0.000000000000000_REALK, &
     -0.748084339961549_REALK,     -0.464066894381222_REALK,      0.000000000000000_REALK, &
     -0.428085586336539_REALK,      0.000000000000000_REALK,     -0.517388038763625_REALK, &
     -0.486146669105747_REALK,      0.000000000000000_REALK,     -0.372469081364815_REALK, &
      0.000000000000000_REALK,     -0.847333125845759_REALK,      0.000000000000000_REALK, &
     -0.480361290634104_REALK,      0.000000000000000_REALK,     -0.967614864845270_REALK, &
     -0.205283359421001_REALK,     -0.273355286595825_REALK,      0.000000000000000_REALK, &
     -0.456469551916289_REALK,      0.000000000000000_REALK,     -0.282067740749938_REALK, &
     -1.009282982190374_REALK,      0.000000000000000_REALK,     -0.296947699631284_REALK, &
      0.000000000000000_REALK,     -3.165019196956283_REALK,      0.000000000000000_REALK, &
     -0.587877475616354_REALK,      0.000000000000000_REALK,     -0.605448456487963_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.365652396083740_REALK, &
      0.000000000000000_REALK,      0.250312937446054_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.197957930219650_REALK,      0.000000000000000_REALK, &
      0.489132830191621_REALK,      0.000000000000000_REALK,      0.100703193362208_REALK, &
      0.000000000000000_REALK,      0.468133201754479_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.078945062599406_REALK, &
      0.000000000000000_REALK,     -0.109619084010723_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.535833352352754_REALK,      0.000000000000000_REALK, &
      0.142930927171000_REALK,      0.000000000000000_REALK,     -1.975550364616969_REALK, &
      0.000000000000000_REALK,     -0.235293497368614_REALK,      0.000000000000000_REALK, &
    -13.318632223511841_REALK,     -3.721286622568673_REALK,      0.000000000000000_REALK, &
     -2.590814841445884_REALK,      0.000000000000000_REALK,     -2.295979818950293_REALK, &
     -1.688660528130259_REALK,      0.000000000000000_REALK,     -0.757990487229062_REALK, &
      0.000000000000000_REALK,     -1.787752264153038_REALK,      0.000000000000000_REALK, &
     -0.710655391177086_REALK,      0.000000000000000_REALK,     -1.889348181431858_REALK, &
     -5.454650910939197_REALK,     -1.180334867042123_REALK,      0.000000000000000_REALK, &
     -0.254210084814534_REALK,      0.000000000000000_REALK,     -0.880592115440514_REALK, &
      1.274495242717142_REALK,      0.000000000000000_REALK,     -0.248270224262725_REALK, &
      0.000000000000000_REALK,      5.547480007691254_REALK,      0.000000000000000_REALK, &
     -0.070292268711712_REALK,      0.000000000000000_REALK,     -0.730484209339532_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.599814031315025_REALK, &
      0.000000000000000_REALK,      0.617668656969615_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.477418097046237_REALK,      0.000000000000000_REALK, &
      0.977600443124685_REALK,      0.000000000000000_REALK,      0.460241290576040_REALK, &
      0.000000000000000_REALK,      0.508275876007718_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.794458123196833_REALK, &
      0.000000000000000_REALK,      0.369625869816954_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.401222866030700_REALK,      0.000000000000000_REALK, &
      0.501316114403275_REALK,      0.000000000000000_REALK,      0.759741560408520_REALK, &
      0.000000000000000_REALK,      0.306618531474818_REALK,      0.000000000000000_REALK, &
     -1.275251268471379_REALK,     -0.558867724771252_REALK,      0.000000000000000_REALK, &
     -0.400164705313192_REALK,      0.000000000000000_REALK,     -0.659516186203919_REALK, &
     -0.322957486998061_REALK,      0.000000000000000_REALK,     -0.341508028239613_REALK, &
      0.000000000000000_REALK,     -0.331831427682763_REALK,      0.000000000000000_REALK, &
     -0.329293163649128_REALK,      0.000000000000000_REALK,     -0.904519932873319_REALK, &
     -0.755352482283025_REALK,     -0.224251167864885_REALK,      0.000000000000000_REALK, &
      0.016727667767595_REALK,      0.000000000000000_REALK,     -0.365829519324266_REALK, &
      0.430616113416650_REALK,      0.000000000000000_REALK,     -0.141506167338373_REALK, &
      0.000000000000000_REALK,      1.650582964927937_REALK,      0.000000000000000_REALK, &
      0.013876228220818_REALK,      0.000000000000000_REALK,     -0.505782193766605_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.529348452170272_REALK, &
      0.000000000000000_REALK,      0.304555437563937_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.267637988332046_REALK,      0.000000000000000_REALK, &
      0.539116079827159_REALK,      0.000000000000000_REALK,      0.327105147156264_REALK, &
      0.000000000000000_REALK,      0.417694773387049_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.449721895804898_REALK, &
      0.000000000000000_REALK,      0.341886074591396_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.459243567047425_REALK,      0.000000000000000_REALK, &
      0.472969828499336_REALK,      0.000000000000000_REALK,      0.963940964626050_REALK, &
      0.000000000000000_REALK,      0.472678883717462_REALK,      0.000000000000000_REALK, &
     -0.464006964545157_REALK,     -0.256099399421559_REALK,      0.000000000000000_REALK, &
     -0.161863540018900_REALK,      0.000000000000000_REALK,     -0.399947460283258_REALK, &
     -0.056107768497533_REALK,      0.000000000000000_REALK,     -0.260824989090229_REALK, &
      0.000000000000000_REALK,      0.189497460391153_REALK,      0.000000000000000_REALK, &
     -0.221994245805007_REALK,      0.000000000000000_REALK,     -0.767933586004480_REALK, &
     -0.203868356679079_REALK,      0.174773982117306_REALK,      0.000000000000000_REALK, &
      0.616923322519425_REALK,      0.000000000000000_REALK,     -0.164561280282280_REALK, &
      1.543278717010430_REALK,      0.000000000000000_REALK,      0.183808751851455_REALK, &
      0.000000000000000_REALK,      4.156614292426649_REALK,      0.000000000000000_REALK, &
      0.852935083057307_REALK,      0.000000000000000_REALK,     -0.318522769036064_REALK, &
    -29.281018630054263_REALK,     -5.295273450406336_REALK,      0.000000000000000_REALK, &
     -3.519426855591932_REALK,      0.000000000000000_REALK,     -3.862946098643767_REALK, &
     -1.692526133318657_REALK,      0.000000000000000_REALK,     -0.825746169155332_REALK, &
      0.000000000000000_REALK,     -1.759618934878115_REALK,      0.000000000000000_REALK, &
     -0.712947408003160_REALK,      0.000000000000000_REALK,     -2.347607313311348_REALK, &
     -9.071879507864205_REALK,     -2.623028461848746_REALK,      0.000000000000000_REALK, &
     -2.470031015311172_REALK,      0.000000000000000_REALK,     -1.864271031462505_REALK, &
     -3.143321938457972_REALK,      0.000000000000000_REALK,     -0.478723615130793_REALK, &
      0.000000000000000_REALK,     -7.478931378162228_REALK,      0.000000000000000_REALK, &
     -0.502258290167675_REALK,      0.000000000000000_REALK,     -1.137247558675119_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.904024818248153_REALK, &
      0.000000000000000_REALK,      0.763666572886251_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.511006952299542_REALK,      0.000000000000000_REALK, &
      1.358562909692460_REALK,      0.000000000000000_REALK,      0.344641783150657_REALK, &
      0.000000000000000_REALK,      0.464098950815960_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.440708082016940_REALK, &
      0.000000000000000_REALK,      0.356286823497894_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.075905950663691_REALK,      0.000000000000000_REALK, &
      0.788822147456062_REALK,      0.000000000000000_REALK,     -0.371910166767901_REALK, &
      0.000000000000000_REALK,      0.217343032945820_REALK,      0.000000000000000_REALK, &
     -2.488557578070401_REALK,     -0.781246025983733_REALK,      0.000000000000000_REALK, &
     -0.480993163038203_REALK,      0.000000000000000_REALK,     -0.984921041400221_REALK, &
     -0.330943101451917_REALK,      0.000000000000000_REALK,     -0.365483059089833_REALK, &
      0.000000000000000_REALK,     -0.340284019536475_REALK,      0.000000000000000_REALK, &
     -0.292311370225354_REALK,      0.000000000000000_REALK,     -0.997601217991442_REALK, &
     -1.166954053595418_REALK,     -0.604732848080786_REALK,      0.000000000000000_REALK, &
     -0.575785601665731_REALK,      0.000000000000000_REALK,     -0.719427094003985_REALK, &
     -0.820416049424159_REALK,      0.000000000000000_REALK,     -0.331105704073296_REALK, &
      0.000000000000000_REALK,     -1.780754816159147_REALK,      0.000000000000000_REALK, &
     -0.351242259716359_REALK,      0.000000000000000_REALK,     -0.731444706351631_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.834176048484690_REALK, &
      0.000000000000000_REALK,      0.344065354292598_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.236782972532863_REALK,      0.000000000000000_REALK, &
      0.650408031699013_REALK,      0.000000000000000_REALK,      0.197738933930268_REALK, &
      0.000000000000000_REALK,      0.348494957548052_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.598521762674636_REALK, &
      0.000000000000000_REALK,      0.203072208985473_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.014984411714571_REALK,      0.000000000000000_REALK, &
      0.546174976996071_REALK,      0.000000000000000_REALK,     -0.376973970210279_REALK, &
      0.000000000000000_REALK,      0.206464412457524_REALK,      0.000000000000000_REALK, &
     -0.823417019917842_REALK,     -0.385210942151250_REALK,      0.000000000000000_REALK, &
     -0.269642150880898_REALK,      0.000000000000000_REALK,     -0.543153160898523_REALK, &
     -0.235209647889891_REALK,      0.000000000000000_REALK,     -0.300349418001918_REALK, &
      0.000000000000000_REALK,     -0.289055189210408_REALK,      0.000000000000000_REALK, &
     -0.273113606912283_REALK,      0.000000000000000_REALK,     -0.770204234582216_REALK, &
     -0.660582067168464_REALK,     -0.559348672508236_REALK,      0.000000000000000_REALK, &
     -0.659049759998687_REALK,      0.000000000000000_REALK,     -0.678747998503631_REALK, &
     -1.040923228750812_REALK,      0.000000000000000_REALK,     -0.510427970028626_REALK, &
      0.000000000000000_REALK,     -2.164480592346645_REALK,      0.000000000000000_REALK, &
     -0.670058803999787_REALK,      0.000000000000000_REALK,     -0.966120526215954_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.505865661828382_REALK, &
      0.000000000000000_REALK,      0.262778133627733_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.159628146616823_REALK,      0.000000000000000_REALK, &
      0.552193659859004_REALK,      0.000000000000000_REALK,      0.057255680053719_REALK, &
      0.000000000000000_REALK,      0.372625708264090_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.269233351437781_REALK, &
      0.000000000000000_REALK,     -0.263779663963916_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.921052194223617_REALK,      0.000000000000000_REALK, &
      0.343960637988129_REALK,      0.000000000000000_REALK,     -2.251719056200842_REALK, &
      0.000000000000000_REALK,     -0.375460330366665_REALK,      0.000000000000000_REALK, &
    -39.186429254566768_REALK,     18.269070198417669_REALK,      0.000000000000000_REALK, &
    -10.780793710910700_REALK,      0.000000000000000_REALK,    -12.183307356177139_REALK, &
     10.105656725589924_REALK,      0.000000000000000_REALK,      7.934376842941083_REALK, &
      0.000000000000000_REALK,     -6.305442561874799_REALK,      0.000000000000000_REALK, &
    -10.221441638650639_REALK,      0.000000000000000_REALK,    -34.653561262620975_REALK, &
    -16.219320407608251_REALK,      0.451546018526934_REALK,      0.000000000000000_REALK, &
      5.222137590937062_REALK,      0.000000000000000_REALK,     -5.566925349742216_REALK, &
    -39.962402228147688_REALK,      0.000000000000000_REALK,      0.218825687774073_REALK, &
      0.000000000000000_REALK,    106.220137689564865_REALK,      0.000000000000000_REALK, &
      4.844878596836374_REALK,      0.000000000000000_REALK,    -15.494274331622242_REALK, &
    -16.371674109106912_REALK,      5.880339804319960_REALK,      0.000000000000000_REALK, &
     -5.842500492970720_REALK,      0.000000000000000_REALK,     -7.133431993813867_REALK, &
      4.937692469809917_REALK,      0.000000000000000_REALK,      2.510454828078649_REALK, &
      0.000000000000000_REALK,    -21.097578738191093_REALK,      0.000000000000000_REALK, &
     -8.704500908932124_REALK,      0.000000000000000_REALK,    -31.883419786783477_REALK, &
     -8.753845196285452_REALK,      3.509266905140854_REALK,      0.000000000000000_REALK, &
     -3.508242089013376_REALK,      0.000000000000000_REALK,     -3.120659968032609_REALK, &
     10.418680080273734_REALK,      0.000000000000000_REALK,      1.801181961907751_REALK, &
      0.000000000000000_REALK,    -42.764483967621608_REALK,      0.000000000000000_REALK, &
     -5.543165990303865_REALK,      0.000000000000000_REALK,    -14.792311160287619_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -7.013901835561430_REALK, &
      0.000000000000000_REALK,      1.208284393112207_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.649690854979329_REALK,      0.000000000000000_REALK, &
     -8.983197049506835_REALK,      0.000000000000000_REALK,      2.292799094634923_REALK, &
      0.000000000000000_REALK,      5.400519491995403_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.445780569862941_REALK, &
      0.000000000000000_REALK,      0.035422069753141_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.659058571774197_REALK,      0.000000000000000_REALK, &
     -5.305790048090025_REALK,      0.000000000000000_REALK,    -10.221050821782937_REALK, &
      0.000000000000000_REALK,      0.167904956995430_REALK,      0.000000000000000_REALK, &
     -7.565365536655131_REALK,      0.590219187422014_REALK,      0.000000000000000_REALK, &
     -3.884189490703039_REALK,      0.000000000000000_REALK,     -5.425237293845515_REALK, &
     -0.077871142754874_REALK,      0.000000000000000_REALK,      0.221046271084554_REALK, &
      0.000000000000000_REALK,    -14.451010407708401_REALK,      0.000000000000000_REALK, &
     -7.349196942461152_REALK,      0.000000000000000_REALK,    -30.794947641577849_REALK, &
     -0.531519380747858_REALK,     -0.226908065307680_REALK,      0.000000000000000_REALK, &
     -0.536351517408677_REALK,      0.000000000000000_REALK,     -1.572046846282631_REALK, &
     -2.763093273883990_REALK,      0.000000000000000_REALK,     -0.095876818218131_REALK, &
      0.000000000000000_REALK,     15.077435615837237_REALK,      0.000000000000000_REALK, &
     -1.443322952773950_REALK,      0.000000000000000_REALK,    -12.691143153866168_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.657757891319052_REALK, &
      0.000000000000000_REALK,      0.487224888489277_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.121979850457066_REALK,      0.000000000000000_REALK, &
     -4.109661764493260_REALK,      0.000000000000000_REALK,      1.813178530582985_REALK, &
      0.000000000000000_REALK,      2.765605284716629_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.408421333679474_REALK, &
      0.000000000000000_REALK,      0.264141572262871_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.144034839704739_REALK,      0.000000000000000_REALK, &
     -3.052933893144085_REALK,      0.000000000000000_REALK,      4.111552846502166_REALK, &
      0.000000000000000_REALK,      2.132416419015986_REALK,      0.000000000000000_REALK, &
     -0.810397146738488_REALK,      0.619563174878029_REALK,      0.000000000000000_REALK, &
     -0.514247584505000_REALK,      0.000000000000000_REALK,     -1.743443909752776_REALK, &
      0.295533817761664_REALK,      0.000000000000000_REALK,      0.696108153174152_REALK, &
      0.000000000000000_REALK,     -0.600226489312407_REALK,      0.000000000000000_REALK, &
     -2.918992586297426_REALK,      0.000000000000000_REALK,    -16.493676070098832_REALK, &
     -0.087692327425171_REALK,      0.027337572612992_REALK,      0.000000000000000_REALK, &
      0.243299316167077_REALK,      0.000000000000000_REALK,     -0.778088918853481_REALK, &
     -2.109487296423435_REALK,      0.000000000000000_REALK,      0.034653322829932_REALK, &
      0.000000000000000_REALK,     14.354195399946768_REALK,      0.000000000000000_REALK, &
      1.964156766711892_REALK,      0.000000000000000_REALK,    -10.469193797624627_REALK, &
     -7.348800337603907_REALK,     -0.701158545600768_REALK,      0.000000000000000_REALK, &
     -4.410051630641959_REALK,      0.000000000000000_REALK,     -6.024866805685903_REALK, &
     -0.328149426608538_REALK,      0.000000000000000_REALK,     -0.120586888096753_REALK, &
      0.000000000000000_REALK,    -17.887933694476924_REALK,      0.000000000000000_REALK, &
     -7.862615838803629_REALK,      0.000000000000000_REALK,    -32.224937806117595_REALK, &
     -1.208175732703176_REALK,     -0.447608079823065_REALK,      0.000000000000000_REALK, &
     -1.308873456842339_REALK,      0.000000000000000_REALK,     -1.694890916206910_REALK, &
      0.106332953756004_REALK,      0.000000000000000_REALK,     -0.122185157922945_REALK, &
      0.000000000000000_REALK,    -18.659568402107645_REALK,      0.000000000000000_REALK, &
     -3.533032307858515_REALK,      0.000000000000000_REALK,    -13.725019024454630_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.298210879373210_REALK, &
      0.000000000000000_REALK,      0.090390797055937_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.159849311839108_REALK,      0.000000000000000_REALK, &
     -0.669808038506462_REALK,      0.000000000000000_REALK,     -0.056772883656934_REALK, &
      0.000000000000000_REALK,      0.483469246261846_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.991984022723139_REALK, &
      0.000000000000000_REALK,     -0.025655222668803_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.092386655259466_REALK,      0.000000000000000_REALK, &
     -0.812356143267406_REALK,      0.000000000000000_REALK,     -1.995757037142305_REALK, &
      0.000000000000000_REALK,     -0.207752850545663_REALK,      0.000000000000000_REALK, &
     -0.683273922321538_REALK,      0.116588568698317_REALK,      0.000000000000000_REALK, &
     -0.458802821987990_REALK,      0.000000000000000_REALK,     -1.680533223655963_REALK, &
      0.039437688583438_REALK,      0.000000000000000_REALK,      0.060153524941802_REALK, &
      0.000000000000000_REALK,     -1.982614165389496_REALK,      0.000000000000000_REALK, &
     -2.453978300380205_REALK,      0.000000000000000_REALK,    -14.980989168180850_REALK, &
     -0.194109449172436_REALK,      0.166677106373349_REALK,      0.000000000000000_REALK, &
     -0.306126852131421_REALK,      0.000000000000000_REALK,     -0.816920088478012_REALK, &
      0.263179224497765_REALK,      0.000000000000000_REALK,      0.136495314645017_REALK, &
      0.000000000000000_REALK,     -6.374949166681255_REALK,      0.000000000000000_REALK, &
     -2.478977749673206_REALK,      0.000000000000000_REALK,    -11.025531346989149_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.417190572251211_REALK, &
      0.000000000000000_REALK,      0.284654296558929_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.063489788045719_REALK,      0.000000000000000_REALK, &
     -0.358747056330693_REALK,      0.000000000000000_REALK,      0.646387344229222_REALK, &
      0.000000000000000_REALK,      2.537529680102571_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.490985225781119_REALK, &
      0.000000000000000_REALK,      0.009272718160016_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.125725066405273_REALK,      0.000000000000000_REALK, &
     -0.670129853035859_REALK,      0.000000000000000_REALK,     -4.570990226487872_REALK, &
      0.000000000000000_REALK,      0.125148893003139_REALK,      0.000000000000000_REALK, &
    -17.985766532757111_REALK,      1.789235651917116_REALK,      0.000000000000000_REALK, &
     -7.679431438467632_REALK,      0.000000000000000_REALK,     -9.369716418180888_REALK, &
      2.809968760834719_REALK,      0.000000000000000_REALK,      1.139420881247937_REALK, &
      0.000000000000000_REALK,    -25.583596555742680_REALK,      0.000000000000000_REALK, &
    -10.084180820675195_REALK,      0.000000000000000_REALK,    -36.911292986908585_REALK, &
     -3.317729263979382_REALK,      0.263679529037896_REALK,      0.000000000000000_REALK, &
     -2.118389385820358_REALK,      0.000000000000000_REALK,     -3.132511137688426_REALK, &
      1.626311478778614_REALK,      0.000000000000000_REALK,      0.535947678732389_REALK, &
      0.000000000000000_REALK,      0.150326649252868_REALK,      0.000000000000000_REALK, &
     -3.788256552706084_REALK,      0.000000000000000_REALK,    -16.805346443676832_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.397650330441123_REALK, &
      0.000000000000000_REALK,     -0.412726026146496_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.651495448867067_REALK,      0.000000000000000_REALK, &
      2.670154659865003_REALK,      0.000000000000000_REALK,     -1.474840228079252_REALK, &
      0.000000000000000_REALK,     -1.625903132442242_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.216727398696725_REALK, &
      0.000000000000000_REALK,     -0.183062300579602_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.340185428233469_REALK,      0.000000000000000_REALK, &
      1.321542252518112_REALK,      0.000000000000000_REALK,      0.284893099959921_REALK, &
      0.000000000000000_REALK,     -0.982095592575260_REALK,      0.000000000000000_REALK, &
     -1.466875900813178_REALK,     -0.020968883039014_REALK,      0.000000000000000_REALK, &
     -0.547107337280924_REALK,      0.000000000000000_REALK,     -2.292514670350757_REALK, &
      0.004704194644613_REALK,      0.000000000000000_REALK,     -0.040060206433119_REALK, &
      0.000000000000000_REALK,     -1.412675536092882_REALK,      0.000000000000000_REALK, &
     -2.155288198741910_REALK,      0.000000000000000_REALK,    -15.051981813435303_REALK, &
     -0.429688762095046_REALK,      0.003280559013460_REALK,      0.000000000000000_REALK, &
     -0.138417087166334_REALK,      0.000000000000000_REALK,     -1.217101872309959_REALK, &
      0.192165653515276_REALK,      0.000000000000000_REALK,      0.020003919090238_REALK, &
      0.000000000000000_REALK,      2.585754335947079_REALK,      0.000000000000000_REALK, &
     -0.742582229179682_REALK,      0.000000000000000_REALK,    -10.882546367422268_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.389850579459017_REALK, &
      0.000000000000000_REALK,      0.205884119739572_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.203336361217860_REALK,      0.000000000000000_REALK, &
      1.241323048549416_REALK,      0.000000000000000_REALK,      0.531748205929693_REALK, &
      0.000000000000000_REALK,      1.351775003263567_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.104460389766656_REALK, &
      0.000000000000000_REALK,      0.204502304060625_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.238693573641555_REALK,      0.000000000000000_REALK, &
      1.061616417838668_REALK,      0.000000000000000_REALK,      2.115372773832569_REALK, &
      0.000000000000000_REALK,      1.828528783675774_REALK,      0.000000000000000_REALK, &
     -0.471392441863701_REALK,     -0.066034185398358_REALK,      0.000000000000000_REALK, &
     -0.217302961661703_REALK,      0.000000000000000_REALK,     -1.227863570310568_REALK, &
     -0.053559581391768_REALK,      0.000000000000000_REALK,     -0.210259418982815_REALK, &
      0.000000000000000_REALK,     -0.176027541392038_REALK,      0.000000000000000_REALK, &
     -1.426747784535286_REALK,      0.000000000000000_REALK,    -11.286511059758391_REALK, &
     -0.212675636945946_REALK,     -0.001185711756699_REALK,      0.000000000000000_REALK, &
      0.188365921752846_REALK,      0.000000000000000_REALK,     -1.004013209699164_REALK, &
      0.440127384114215_REALK,      0.000000000000000_REALK,     -0.012050223731190_REALK, &
      0.000000000000000_REALK,      7.385159639903975_REALK,      0.000000000000000_REALK, &
      1.684247575453184_REALK,      0.000000000000000_REALK,    -12.568141401545919_REALK, &
    -56.399615657074911_REALK,     13.334596680063655_REALK,      0.000000000000000_REALK, &
    -17.716284283188010_REALK,      0.000000000000000_REALK,    -18.204634498319194_REALK, &
     12.514914193459186_REALK,      0.000000000000000_REALK,      5.016878949224358_REALK, &
      0.000000000000000_REALK,    -44.387552419623233_REALK,      0.000000000000000_REALK, &
    -15.208925296688863_REALK,      0.000000000000000_REALK,    -46.884480127901647_REALK, &
    -15.942627877274084_REALK,      6.266293786666584_REALK,      0.000000000000000_REALK, &
     -8.912268222027883_REALK,      0.000000000000000_REALK,     -8.898785681982270_REALK, &
      6.022997246750021_REALK,      0.000000000000000_REALK,      3.181171785617031_REALK, &
      0.000000000000000_REALK,    -33.143459872910249_REALK,      0.000000000000000_REALK, &
     -8.437160834765761_REALK,      0.000000000000000_REALK,    -25.273191121231125_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.525738780901341_REALK, &
      0.000000000000000_REALK,     -1.697953831460659_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.012269032171494_REALK,      0.000000000000000_REALK, &
      7.365541449106207_REALK,      0.000000000000000_REALK,     -3.594753217409486_REALK, &
      0.000000000000000_REALK,     -4.372934962059346_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.439615418103965_REALK, &
      0.000000000000000_REALK,     -1.227369389657900_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.180862753947938_REALK,      0.000000000000000_REALK, &
      5.238506792353748_REALK,      0.000000000000000_REALK,     -3.525857049016413_REALK, &
      0.000000000000000_REALK,     -3.485817309206515_REALK,      0.000000000000000_REALK, &
     -4.109141022509694_REALK,      0.287451841070169_REALK,      0.000000000000000_REALK, &
     -0.970852133560564_REALK,      0.000000000000000_REALK,     -3.979038307903156_REALK, &
      0.294300089530318_REALK,      0.000000000000000_REALK,      0.324444253916610_REALK, &
      0.000000000000000_REALK,     -1.896147400738977_REALK,      0.000000000000000_REALK, &
     -2.500346687391817_REALK,      0.000000000000000_REALK,    -17.079455096289653_REALK, &
     -1.807348294902181_REALK,      0.201009312934743_REALK,      0.000000000000000_REALK, &
     -0.779055863081567_REALK,      0.000000000000000_REALK,     -3.026453089071390_REALK, &
     -0.088805931150339_REALK,      0.000000000000000_REALK,      0.306135577132474_REALK, &
      0.000000000000000_REALK,     -3.895208105604048_REALK,      0.000000000000000_REALK, &
     -2.212574661916139_REALK,      0.000000000000000_REALK,    -14.325573936529743_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.596670723253085_REALK, &
      0.000000000000000_REALK,      0.059697327055934_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.430081508340371_REALK,      0.000000000000000_REALK, &
      3.003579310466627_REALK,      0.000000000000000_REALK,     -0.018054028645878_REALK, &
      0.000000000000000_REALK,      0.256242272107616_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.336423776769005_REALK, &
      0.000000000000000_REALK,     -0.045810811276620_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.231475266783483_REALK,      0.000000000000000_REALK, &
      3.392271218859404_REALK,      0.000000000000000_REALK,     -1.249850289197731_REALK, &
      0.000000000000000_REALK,     -0.216843329376366_REALK,      0.000000000000000_REALK, &
     -1.146174385547933_REALK,     -0.143392385061863_REALK,      0.000000000000000_REALK, &
     -0.303009852888598_REALK,      0.000000000000000_REALK,     -1.849807442581238_REALK, &
     -0.106108812082311_REALK,      0.000000000000000_REALK,     -0.269742780886456_REALK, &
      0.000000000000000_REALK,     -0.630480092432191_REALK,      0.000000000000000_REALK, &
     -1.300626627762062_REALK,      0.000000000000000_REALK,    -11.116048901925939_REALK, &
     -0.871123394941736_REALK,     -0.224551245683288_REALK,      0.000000000000000_REALK, &
     -0.546630198098092_REALK,      0.000000000000000_REALK,     -2.431199063862475_REALK, &
     -0.659396977100200_REALK,      0.000000000000000_REALK,     -0.569982920935496_REALK, &
      0.000000000000000_REALK,     -3.992335695835139_REALK,      0.000000000000000_REALK, &
     -2.587448438263039_REALK,      0.000000000000000_REALK,    -16.111153646283103_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.855171764097777_REALK, &
      0.000000000000000_REALK,      0.313326525727307_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.284703381920061_REALK,      0.000000000000000_REALK, &
      2.252190543851455_REALK,      0.000000000000000_REALK,      0.342590067574221_REALK, &
      0.000000000000000_REALK,      1.882873266741298_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.102444385436304_REALK, &
      0.000000000000000_REALK,      0.027596118675563_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.525008061784799_REALK,      0.000000000000000_REALK, &
      3.917699305986812_REALK,      0.000000000000000_REALK,     -4.770999467179887_REALK, &
      0.000000000000000_REALK,      0.182874909188520_REALK,      0.000000000000000_REALK/
    ! results of test 7, ket-major order, 01ODGXYY
  data REF_CONTR_INTS(42841:44100)                                                         &
     /1.180731843468121_REALK,     -0.014637573057903_REALK,      0.000000000000000_REALK, &
     -0.806761043153024_REALK,      0.000000000000000_REALK,     -0.301510503258220_REALK, &
     -2.044366705660536_REALK,      0.000000000000000_REALK,     -0.395461818693976_REALK, &
      0.000000000000000_REALK,     -9.126452789613182_REALK,      0.000000000000000_REALK, &
     -1.093936003591134_REALK,      0.000000000000000_REALK,     -1.226508881809583_REALK, &
      1.306703570353245_REALK,      1.009507239784321_REALK,      0.000000000000000_REALK, &
      0.446859083766123_REALK,      0.000000000000000_REALK,      0.054879907173821_REALK, &
     -2.286894306368873_REALK,      0.000000000000000_REALK,     -0.156618622566641_REALK, &
      0.000000000000000_REALK,    -25.216740577780591_REALK,      0.000000000000000_REALK, &
     -1.342316972685338_REALK,      0.000000000000000_REALK,     -0.494560143465974_REALK, &
      0.023564378993789_REALK,     -0.477386894897365_REALK,      0.000000000000000_REALK, &
     -0.707054690102998_REALK,      0.000000000000000_REALK,     -0.457109735513920_REALK, &
     -0.768121087436984_REALK,      0.000000000000000_REALK,     -0.343080385214539_REALK, &
      0.000000000000000_REALK,     -0.807128458635064_REALK,      0.000000000000000_REALK, &
     -0.531356229220907_REALK,      0.000000000000000_REALK,     -1.030562877819793_REALK, &
      1.303649492942670_REALK,      0.050034563887609_REALK,      0.000000000000000_REALK, &
      0.004173727414026_REALK,      0.000000000000000_REALK,     -0.001269542643413_REALK, &
      1.272885645904451_REALK,      0.000000000000000_REALK,     -0.010800281471031_REALK, &
      0.000000000000000_REALK,     10.250674883359297_REALK,      0.000000000000000_REALK, &
      0.260575118716143_REALK,      0.000000000000000_REALK,     -0.237781142997553_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.164777544679262_REALK, &
      0.000000000000000_REALK,      0.206929371832832_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.316858890254348_REALK,      0.000000000000000_REALK, &
      0.355258664036565_REALK,      0.000000000000000_REALK,      0.803913179096936_REALK, &
      0.000000000000000_REALK,      0.466526333554740_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.194522129376039_REALK, &
      0.000000000000000_REALK,      0.002246562653325_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.341893774505058_REALK,      0.000000000000000_REALK, &
      0.125966547104804_REALK,      0.000000000000000_REALK,      2.048000651525196_REALK, &
      0.000000000000000_REALK,      0.420773763130428_REALK,      0.000000000000000_REALK, &
     -1.634096766198136_REALK,     -0.936465508048077_REALK,      0.000000000000000_REALK, &
     -0.938897508865942_REALK,      0.000000000000000_REALK,     -0.703933574363717_REALK, &
     -0.949389990383901_REALK,      0.000000000000000_REALK,     -0.357286760595035_REALK, &
      0.000000000000000_REALK,     -1.682895121243910_REALK,      0.000000000000000_REALK, &
     -0.451295646426911_REALK,      0.000000000000000_REALK,     -1.015069763688463_REALK, &
      0.355902031652439_REALK,     -0.060496894181031_REALK,      0.000000000000000_REALK, &
     -0.429633601738757_REALK,      0.000000000000000_REALK,     -0.131127496894839_REALK, &
     -1.586422481438013_REALK,      0.000000000000000_REALK,     -0.139865558756482_REALK, &
      0.000000000000000_REALK,     -7.284753874753414_REALK,      0.000000000000000_REALK, &
     -0.361651472079656_REALK,      0.000000000000000_REALK,     -0.331136475989428_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.351805617596584_REALK, &
      0.000000000000000_REALK,      0.216648767060220_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.207615820423211_REALK,      0.000000000000000_REALK, &
      0.402669895655461_REALK,      0.000000000000000_REALK,      0.233148689173733_REALK, &
      0.000000000000000_REALK,      0.312406767899930_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.015124337063226_REALK, &
      0.000000000000000_REALK,      0.007512723683762_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.114955787705338_REALK,      0.000000000000000_REALK, &
      0.104899956409637_REALK,      0.000000000000000_REALK,     -0.745321634790414_REALK, &
      0.000000000000000_REALK,      0.018971893040241_REALK,      0.000000000000000_REALK, &
     -0.173592056185053_REALK,     -0.159259166455242_REALK,      0.000000000000000_REALK, &
     -0.200090389495006_REALK,      0.000000000000000_REALK,     -0.224339119541483_REALK, &
     -0.314111485005012_REALK,      0.000000000000000_REALK,     -0.182284957178383_REALK, &
      0.000000000000000_REALK,     -0.802378498593267_REALK,      0.000000000000000_REALK, &
     -0.288529645094162_REALK,      0.000000000000000_REALK,     -0.539160382343572_REALK, &
      0.079274408148733_REALK,     -0.026763788501985_REALK,      0.000000000000000_REALK, &
     -0.237822825631396_REALK,      0.000000000000000_REALK,     -0.087622888749182_REALK, &
     -0.903499648305215_REALK,      0.000000000000000_REALK,     -0.185629309600699_REALK, &
      0.000000000000000_REALK,     -3.760792747588303_REALK,      0.000000000000000_REALK, &
     -0.600574358958331_REALK,      0.000000000000000_REALK,     -0.368790366672513_REALK, &
     -4.779606403877841_REALK,     -1.455884748097376_REALK,      0.000000000000000_REALK, &
     -1.150464511811770_REALK,      0.000000000000000_REALK,     -1.134685827672357_REALK, &
     -0.742579908557253_REALK,      0.000000000000000_REALK,     -0.372877674903372_REALK, &
      0.000000000000000_REALK,     -0.773063693618496_REALK,      0.000000000000000_REALK, &
     -0.379770938155917_REALK,      0.000000000000000_REALK,     -1.123687076471572_REALK, &
      0.535006996221579_REALK,     -0.080856468623811_REALK,      0.000000000000000_REALK, &
      0.131291209756074_REALK,      0.000000000000000_REALK,     -0.239161215526149_REALK, &
      1.231725117482152_REALK,      0.000000000000000_REALK,     -0.065087296876508_REALK, &
      0.000000000000000_REALK,      5.528807606714535_REALK,      0.000000000000000_REALK, &
      0.065555305336562_REALK,      0.000000000000000_REALK,     -0.358248351986595_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.677994268570551_REALK, &
      0.000000000000000_REALK,      0.274259788644555_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.231607124846581_REALK,      0.000000000000000_REALK, &
      0.520938749017289_REALK,      0.000000000000000_REALK,      0.240568279839486_REALK, &
      0.000000000000000_REALK,      0.271601330147837_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.084872251734459_REALK, &
      0.000000000000000_REALK,      0.113425475562667_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.223847196414208_REALK,      0.000000000000000_REALK, &
      0.204959684954325_REALK,      0.000000000000000_REALK,      0.642378318631284_REALK, &
      0.000000000000000_REALK,      0.169904177833460_REALK,      0.000000000000000_REALK, &
     -0.433999895268206_REALK,     -0.208665458942594_REALK,      0.000000000000000_REALK, &
     -0.159369664114353_REALK,      0.000000000000000_REALK,     -0.309096705100599_REALK, &
     -0.119653043384771_REALK,      0.000000000000000_REALK,     -0.160328675600540_REALK, &
      0.000000000000000_REALK,     -0.079911823755111_REALK,      0.000000000000000_REALK, &
     -0.157824860044540_REALK,      0.000000000000000_REALK,     -0.510167608265013_REALK, &
      0.063434071358715_REALK,     -0.004862609222313_REALK,      0.000000000000000_REALK, &
      0.093224629459071_REALK,      0.000000000000000_REALK,     -0.085069745175666_REALK, &
      0.461323045127661_REALK,      0.000000000000000_REALK,     -0.011742811506634_REALK, &
      0.000000000000000_REALK,      1.831143481901136_REALK,      0.000000000000000_REALK, &
      0.139644589925667_REALK,      0.000000000000000_REALK,     -0.212381816355237_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.216072428996973_REALK, &
      0.000000000000000_REALK,      0.139925234692617_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.148074819826754_REALK,      0.000000000000000_REALK, &
      0.276699735471527_REALK,      0.000000000000000_REALK,      0.238780460266680_REALK, &
      0.000000000000000_REALK,      0.230948182691950_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.056713900956908_REALK, &
      0.000000000000000_REALK,      0.150538080332467_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.371730510919839_REALK,      0.000000000000000_REALK, &
      0.228265874792366_REALK,      0.000000000000000_REALK,      1.097542284769250_REALK, &
      0.000000000000000_REALK,      0.375827515006891_REALK,      0.000000000000000_REALK, &
    -12.857016763378462_REALK,     -2.284632835372703_REALK,      0.000000000000000_REALK, &
     -1.718632002814951_REALK,      0.000000000000000_REALK,     -2.039645403723275_REALK, &
     -0.818487447737099_REALK,      0.000000000000000_REALK,     -0.416657663122270_REALK, &
      0.000000000000000_REALK,     -0.981326644604187_REALK,      0.000000000000000_REALK, &
     -0.400863220300150_REALK,      0.000000000000000_REALK,     -1.427214476632109_REALK, &
     -2.804092323185774_REALK,     -0.967263276185771_REALK,      0.000000000000000_REALK, &
     -1.283719626925579_REALK,      0.000000000000000_REALK,     -0.778489732208717_REALK, &
     -2.299119306156129_REALK,      0.000000000000000_REALK,     -0.227757940468723_REALK, &
      0.000000000000000_REALK,     -6.644514855241652_REALK,      0.000000000000000_REALK, &
     -0.331787503460817_REALK,      0.000000000000000_REALK,     -0.603620508641762_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.382565465796372_REALK, &
      0.000000000000000_REALK,      0.357389570313067_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.255650272647912_REALK,      0.000000000000000_REALK, &
      0.756432045237100_REALK,      0.000000000000000_REALK,      0.166009141472378_REALK, &
      0.000000000000000_REALK,      0.250078551701696_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.495150503303482_REALK, &
      0.000000000000000_REALK,      0.093118992747468_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.064004565031097_REALK,      0.000000000000000_REALK, &
      0.349773825692500_REALK,      0.000000000000000_REALK,     -0.455455211037518_REALK, &
      0.000000000000000_REALK,      0.072202023277766_REALK,      0.000000000000000_REALK, &
     -1.049123075955871_REALK,     -0.334173656874177_REALK,      0.000000000000000_REALK, &
     -0.221986931375859_REALK,      0.000000000000000_REALK,     -0.499300677411062_REALK, &
     -0.161943266722937_REALK,      0.000000000000000_REALK,     -0.182833774593155_REALK, &
      0.000000000000000_REALK,     -0.193079707248785_REALK,      0.000000000000000_REALK, &
     -0.155332373707910_REALK,      0.000000000000000_REALK,     -0.582298238125487_REALK, &
     -0.352069694953410_REALK,     -0.234831894413710_REALK,      0.000000000000000_REALK, &
     -0.320253359099923_REALK,      0.000000000000000_REALK,     -0.293231403556316_REALK, &
     -0.627182569867028_REALK,      0.000000000000000_REALK,     -0.165885017900017_REALK, &
      0.000000000000000_REALK,     -1.667278627224088_REALK,      0.000000000000000_REALK, &
     -0.248316050316642_REALK,      0.000000000000000_REALK,     -0.378939891864338_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.376620928579123_REALK, &
      0.000000000000000_REALK,      0.153669153018048_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.106242907097963_REALK,      0.000000000000000_REALK, &
      0.343429354500889_REALK,      0.000000000000000_REALK,      0.080247925285734_REALK, &
      0.000000000000000_REALK,      0.179213209804995_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.176125242744572_REALK, &
      0.000000000000000_REALK,      0.016800187317593_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.136341234187697_REALK,      0.000000000000000_REALK, &
      0.207357828730146_REALK,      0.000000000000000_REALK,     -0.511750508030378_REALK, &
      0.000000000000000_REALK,      0.021710707271525_REALK,      0.000000000000000_REALK, &
     -0.334348801821725_REALK,     -0.170492829434832_REALK,      0.000000000000000_REALK, &
     -0.141924281859412_REALK,      0.000000000000000_REALK,     -0.265206544187808_REALK, &
     -0.160739760832116_REALK,      0.000000000000000_REALK,     -0.155467309213895_REALK, &
      0.000000000000000_REALK,     -0.276172300321240_REALK,      0.000000000000000_REALK, &
     -0.165516016726578_REALK,      0.000000000000000_REALK,     -0.433007673670510_REALK, &
     -0.235262354909448_REALK,     -0.311668453762359_REALK,      0.000000000000000_REALK, &
     -0.531826829681272_REALK,      0.000000000000000_REALK,     -0.326575067015214_REALK, &
     -1.071579427160611_REALK,      0.000000000000000_REALK,     -0.366937145685418_REALK, &
      0.000000000000000_REALK,     -2.582224249691172_REALK,      0.000000000000000_REALK, &
     -0.687274278558881_REALK,      0.000000000000000_REALK,     -0.590841385715341_REALK, &
    -38.318048110149846_REALK,     -3.615686149629592_REALK,      0.000000000000000_REALK, &
     -3.033831660420315_REALK,      0.000000000000000_REALK,     -4.297488803637732_REALK, &
     -0.755816002129626_REALK,      0.000000000000000_REALK,     -0.474238144858837_REALK, &
      0.000000000000000_REALK,     -0.892078446484956_REALK,      0.000000000000000_REALK, &
     -0.500139775266628_REALK,      0.000000000000000_REALK,     -2.125376743050190_REALK, &
    -32.379856888030041_REALK,     -1.615039323332737_REALK,      0.000000000000000_REALK, &
      0.104144745865239_REALK,      0.000000000000000_REALK,     -2.853770858838974_REALK, &
      3.631880079627916_REALK,      0.000000000000000_REALK,     -0.178573221192086_REALK, &
      0.000000000000000_REALK,      9.362981549105880_REALK,      0.000000000000000_REALK, &
      0.014618633899406_REALK,      0.000000000000000_REALK,     -1.201737958210831_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.288804741794417_REALK, &
      0.000000000000000_REALK,      0.523524038414251_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.363472929176180_REALK,      0.000000000000000_REALK, &
      1.294091850072203_REALK,      0.000000000000000_REALK,      0.169538834371112_REALK, &
      0.000000000000000_REALK,      0.258915349524936_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.001091683594105_REALK, &
      0.000000000000000_REALK,      0.569525454500130_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.547179461068480_REALK,      0.000000000000000_REALK, &
      0.995482774858298_REALK,      0.000000000000000_REALK,      0.806994446600131_REALK, &
      0.000000000000000_REALK,      0.239830172321029_REALK,      0.000000000000000_REALK, &
     -2.824844477842666_REALK,     -0.576269047241189_REALK,      0.000000000000000_REALK, &
     -0.321220692679456_REALK,      0.000000000000000_REALK,     -0.950445399565990_REALK, &
     -0.150524732291000_REALK,      0.000000000000000_REALK,     -0.226752615625581_REALK, &
      0.000000000000000_REALK,     -0.107794593637414_REALK,      0.000000000000000_REALK, &
     -0.158863704084461_REALK,      0.000000000000000_REALK,     -0.783424398168944_REALK, &
     -3.307969455991393_REALK,     -0.358975363652147_REALK,      0.000000000000000_REALK, &
      0.160048114741467_REALK,      0.000000000000000_REALK,     -0.874635135178201_REALK, &
      0.751130570973332_REALK,      0.000000000000000_REALK,     -0.119074599775719_REALK, &
      0.000000000000000_REALK,      1.894713812851828_REALK,      0.000000000000000_REALK, &
      0.067397105142195_REALK,      0.000000000000000_REALK,     -0.613855779785187_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.805092116724352_REALK, &
      0.000000000000000_REALK,      0.229727866556580_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.140843834027050_REALK,      0.000000000000000_REALK, &
      0.527984697890530_REALK,      0.000000000000000_REALK,      0.100633208549616_REALK, &
      0.000000000000000_REALK,      0.189357974358030_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.130412245881169_REALK, &
      0.000000000000000_REALK,      0.414807668263243_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.409519470051287_REALK,      0.000000000000000_REALK, &
      0.624942541972994_REALK,      0.000000000000000_REALK,      0.660426167791989_REALK, &
      0.000000000000000_REALK,      0.291129494369934_REALK,      0.000000000000000_REALK, &
     -0.769508263193814_REALK,     -0.247782206745705_REALK,      0.000000000000000_REALK, &
     -0.133492602440084_REALK,      0.000000000000000_REALK,     -0.431513778556243_REALK, &
     -0.072762845247007_REALK,      0.000000000000000_REALK,     -0.162497198585875_REALK, &
      0.000000000000000_REALK,     -0.033428277538892_REALK,      0.000000000000000_REALK, &
     -0.110034055374864_REALK,      0.000000000000000_REALK,     -0.497957895729689_REALK, &
     -1.176646129896033_REALK,     -0.064765019184781_REALK,      0.000000000000000_REALK, &
      0.340931267678546_REALK,      0.000000000000000_REALK,     -0.518513477109325_REALK, &
      0.843972013004559_REALK,      0.000000000000000_REALK,     -0.035805004650066_REALK, &
      0.000000000000000_REALK,      1.882590114507567_REALK,      0.000000000000000_REALK, &
      0.239279924572578_REALK,      0.000000000000000_REALK,     -0.509480439128841_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.427629497993912_REALK, &
      0.000000000000000_REALK,      0.195342317602282_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.150077603478157_REALK,      0.000000000000000_REALK, &
      0.392619126760842_REALK,      0.000000000000000_REALK,      0.166475562721896_REALK, &
      0.000000000000000_REALK,      0.225420958157225_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.258952658126751_REALK, &
      0.000000000000000_REALK,      0.917553277130049_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.133443440230377_REALK,      0.000000000000000_REALK, &
      0.974407618250921_REALK,      0.000000000000000_REALK,      1.880630214565381_REALK, &
      0.000000000000000_REALK,      0.901568555483777_REALK,      0.000000000000000_REALK, &
     -5.187570603457241_REALK,      3.798348601678498_REALK,      0.000000000000000_REALK, &
     -1.819737276100534_REALK,      0.000000000000000_REALK,     -2.277723487790466_REALK, &
      4.039893416586631_REALK,      0.000000000000000_REALK,      1.648434871396054_REALK, &
      0.000000000000000_REALK,    -10.100330552197958_REALK,      0.000000000000000_REALK, &
     -3.328292834455572_REALK,      0.000000000000000_REALK,    -12.497843830834416_REALK, &
     -5.052654148098362_REALK,      3.666646304347569_REALK,      0.000000000000000_REALK, &
     -1.920229564936004_REALK,      0.000000000000000_REALK,     -1.165823829890549_REALK, &
     17.198411646807859_REALK,      0.000000000000000_REALK,      1.953188988415021_REALK, &
      0.000000000000000_REALK,    -31.598057481355294_REALK,      0.000000000000000_REALK, &
     -3.235267706706221_REALK,      0.000000000000000_REALK,     -5.892658238515084_REALK, &
      1.774039166317852_REALK,     -0.166817760146315_REALK,      0.000000000000000_REALK, &
     -0.889069413040800_REALK,      0.000000000000000_REALK,     -1.293722067726851_REALK, &
     -0.825418650916523_REALK,      0.000000000000000_REALK,     -0.064760112478007_REALK, &
      0.000000000000000_REALK,     -6.070600647649476_REALK,      0.000000000000000_REALK, &
     -3.345789997495316_REALK,      0.000000000000000_REALK,    -14.605796657434272_REALK, &
      2.962404710465961_REALK,     -0.938551169917110_REALK,      0.000000000000000_REALK, &
      0.000293767192521_REALK,      0.000000000000000_REALK,      0.002865783851232_REALK, &
     -5.291670862338975_REALK,      0.000000000000000_REALK,     -0.406635191038059_REALK, &
      0.000000000000000_REALK,     13.252589460580033_REALK,      0.000000000000000_REALK, &
     -0.186247717329499_REALK,      0.000000000000000_REALK,     -5.450700904398362_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.681223616785849_REALK, &
      0.000000000000000_REALK,      0.087492440807801_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.141734697309538_REALK,      0.000000000000000_REALK, &
     -4.287249545923355_REALK,      0.000000000000000_REALK,      0.806922184886757_REALK, &
      0.000000000000000_REALK,      0.987767644519417_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.493943098654024_REALK, &
      0.000000000000000_REALK,     -0.000618377502945_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.779728559103855_REALK,      0.000000000000000_REALK, &
     -3.241565492211127_REALK,      0.000000000000000_REALK,      3.452116309080846_REALK, &
      0.000000000000000_REALK,      1.176149699186220_REALK,      0.000000000000000_REALK, &
      4.379235738239919_REALK,     -1.703777732660707_REALK,      0.000000000000000_REALK, &
     -1.102445769647944_REALK,      0.000000000000000_REALK,     -1.497772186325484_REALK, &
     -1.237487565830717_REALK,      0.000000000000000_REALK,     -0.488476885131316_REALK, &
      0.000000000000000_REALK,     -9.908653432874118_REALK,      0.000000000000000_REALK, &
     -4.213674870893666_REALK,      0.000000000000000_REALK,    -17.173974079083891_REALK, &
      1.759882818540984_REALK,     -0.785443999831023_REALK,      0.000000000000000_REALK, &
      0.142953747940453_REALK,      0.000000000000000_REALK,      0.162820883796986_REALK, &
      0.714962570749339_REALK,      0.000000000000000_REALK,     -0.298816180746428_REALK, &
      0.000000000000000_REALK,    -13.283032871496340_REALK,      0.000000000000000_REALK, &
     -1.958975978658187_REALK,      0.000000000000000_REALK,     -6.693679699430917_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.316178171893794_REALK, &
      0.000000000000000_REALK,     -0.006066174872882_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.456349655642139_REALK,      0.000000000000000_REALK, &
     -1.992160380654186_REALK,      0.000000000000000_REALK,     -0.295518991595735_REALK, &
      0.000000000000000_REALK,     -0.069556859833044_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.402464570450541_REALK, &
      0.000000000000000_REALK,      0.009779656079595_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.054694120700390_REALK,      0.000000000000000_REALK, &
     -1.600670856220315_REALK,      0.000000000000000_REALK,     -1.743994093314241_REALK, &
      0.000000000000000_REALK,     -0.402048458654866_REALK,      0.000000000000000_REALK, &
      0.391396918896424_REALK,      0.156639580215867_REALK,      0.000000000000000_REALK, &
     -0.106947966383927_REALK,      0.000000000000000_REALK,     -0.401592963231639_REALK, &
      0.110060303090971_REALK,      0.000000000000000_REALK,      0.134726753552474_REALK, &
      0.000000000000000_REALK,     -1.240481737379780_REALK,      0.000000000000000_REALK, &
     -1.226302383805350_REALK,      0.000000000000000_REALK,     -7.674673095427020_REALK, &
      0.280883230191539_REALK,      0.302623150964620_REALK,      0.000000000000000_REALK, &
      0.042802820824821_REALK,      0.000000000000000_REALK,      0.077960285710591_REALK, &
      1.013759893478960_REALK,      0.000000000000000_REALK,      0.345392010873411_REALK, &
      0.000000000000000_REALK,     -5.728700500425921_REALK,      0.000000000000000_REALK, &
     -1.759653713652097_REALK,      0.000000000000000_REALK,     -5.341669218074412_REALK, &
      2.107307292038042_REALK,     -1.348949354637831_REALK,      0.000000000000000_REALK, &
     -2.682248105716032_REALK,      0.000000000000000_REALK,     -3.191956311812608_REALK, &
      0.215013836052696_REALK,      0.000000000000000_REALK,      0.088039588524483_REALK, &
      0.000000000000000_REALK,    -15.428026079790383_REALK,      0.000000000000000_REALK, &
     -5.954608253795562_REALK,      0.000000000000000_REALK,    -21.258491367263286_REALK, &
      9.263439882697638_REALK,     -2.190020904927275_REALK,      0.000000000000000_REALK, &
      0.107833581923523_REALK,      0.000000000000000_REALK,      0.164885660662902_REALK, &
     -0.880373406977992_REALK,      0.000000000000000_REALK,     -0.263412078906366_REALK, &
      0.000000000000000_REALK,      2.837840250338939_REALK,      0.000000000000000_REALK, &
     -1.895154534192923_REALK,      0.000000000000000_REALK,     -8.693501649151685_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.918479561269928_REALK, &
      0.000000000000000_REALK,     -0.185158692008343_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.044122826932171_REALK,      0.000000000000000_REALK, &
      0.179834540928474_REALK,      0.000000000000000_REALK,     -1.041346300013656_REALK, &
      0.000000000000000_REALK,     -1.233160504442456_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.559412273741702_REALK, &
      0.000000000000000_REALK,      0.011292314399178_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.164677328096133_REALK,      0.000000000000000_REALK, &
     -0.562690558762560_REALK,      0.000000000000000_REALK,      0.474845967804518_REALK, &
      0.000000000000000_REALK,     -0.595380783612799_REALK,      0.000000000000000_REALK, &
      0.166178204427120_REALK,     -0.003719963347364_REALK,      0.000000000000000_REALK, &
     -0.172980765127588_REALK,      0.000000000000000_REALK,     -0.755134626797356_REALK, &
      0.003094480167755_REALK,      0.000000000000000_REALK,      0.000728353606387_REALK, &
      0.000000000000000_REALK,     -0.696762946405411_REALK,      0.000000000000000_REALK, &
     -1.152055273613444_REALK,      0.000000000000000_REALK,     -8.382018933804050_REALK, &
      1.132789023870738_REALK,     -0.093664371349982_REALK,      0.000000000000000_REALK, &
      0.002066900143067_REALK,      0.000000000000000_REALK,      0.060489624467088_REALK, &
     -0.146605313506266_REALK,      0.000000000000000_REALK,     -0.033797385296068_REALK, &
      0.000000000000000_REALK,      2.584757943073567_REALK,      0.000000000000000_REALK, &
     -0.108976121575037_REALK,      0.000000000000000_REALK,     -5.315467780794485_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.246269046818799_REALK, &
      0.000000000000000_REALK,      0.051068597564448_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.012841030574264_REALK,      0.000000000000000_REALK, &
      0.080364119948984_REALK,      0.000000000000000_REALK,      0.277847372127477_REALK, &
      0.000000000000000_REALK,      0.566863095026492_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.746662366438747_REALK, &
      0.000000000000000_REALK,     -0.013052422957834_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.147921707614377_REALK,      0.000000000000000_REALK, &
     -0.449036549702042_REALK,      0.000000000000000_REALK,      2.019881113087765_REALK, &
      0.000000000000000_REALK,      1.146969158841699_REALK,      0.000000000000000_REALK, &
    -13.839528467671787_REALK,      3.830444949347913_REALK,      0.000000000000000_REALK, &
     -8.096711861994836_REALK,      0.000000000000000_REALK,     -8.038884104933219_REALK, &
      5.843578636790013_REALK,      0.000000000000000_REALK,      2.338900602228772_REALK, &
      0.000000000000000_REALK,    -28.614341023272175_REALK,      0.000000000000000_REALK, &
     -9.578689256925834_REALK,      0.000000000000000_REALK,    -28.530831080343361_REALK, &
      0.107961124752143_REALK,      0.264485593839303_REALK,      0.000000000000000_REALK, &
     -2.621703711783625_REALK,      0.000000000000000_REALK,     -2.451846369761906_REALK, &
      1.758307313385343_REALK,      0.000000000000000_REALK,      1.016847560092656_REALK, &
      0.000000000000000_REALK,    -22.076206218890260_REALK,      0.000000000000000_REALK, &
     -4.959728976178945_REALK,      0.000000000000000_REALK,    -13.915180533853075_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.722480013392735_REALK, &
      0.000000000000000_REALK,     -0.837441304352699_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.883809653008534_REALK,      0.000000000000000_REALK, &
      3.155280595799031_REALK,      0.000000000000000_REALK,     -2.419581086245785_REALK, &
      0.000000000000000_REALK,     -2.972165798425545_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.134790462774438_REALK, &
      0.000000000000000_REALK,     -0.378774019916579_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.338909807195176_REALK,      0.000000000000000_REALK, &
      1.554655789069819_REALK,      0.000000000000000_REALK,     -2.394890983979327_REALK, &
      0.000000000000000_REALK,     -2.149689692500711_REALK,      0.000000000000000_REALK, &
     -0.981643408991887_REALK,      0.099917453478303_REALK,      0.000000000000000_REALK, &
     -0.419700709159155_REALK,      0.000000000000000_REALK,     -1.710604002663298_REALK, &
      0.154561286460808_REALK,      0.000000000000000_REALK,      0.183031210632607_REALK, &
      0.000000000000000_REALK,     -1.167590948996504_REALK,      0.000000000000000_REALK, &
     -1.489561222803529_REALK,      0.000000000000000_REALK,    -10.118517530601805_REALK, &
      0.011875913262753_REALK,      0.009231222882210_REALK,      0.000000000000000_REALK, &
     -0.236798152199641_REALK,      0.000000000000000_REALK,     -0.809122215642062_REALK, &
     -0.084916534505494_REALK,      0.000000000000000_REALK,      0.106471732484790_REALK, &
      0.000000000000000_REALK,     -3.037531442419035_REALK,      0.000000000000000_REALK, &
     -1.343921494665590_REALK,      0.000000000000000_REALK,     -7.653471443307874_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.407494393725145_REALK, &
      0.000000000000000_REALK,     -0.006928171796183_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.170993208658174_REALK,      0.000000000000000_REALK, &
      1.244096828817291_REALK,      0.000000000000000_REALK,     -0.104467868065399_REALK, &
      0.000000000000000_REALK,     -0.040981330375445_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.049448960220016_REALK, &
      0.000000000000000_REALK,     -0.048599029871411_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.019488160825683_REALK,      0.000000000000000_REALK, &
      0.950563201173675_REALK,      0.000000000000000_REALK,     -1.196436900762934_REALK, &
      0.000000000000000_REALK,     -0.459697286890284_REALK,      0.000000000000000_REALK, &
     -0.263204971392219_REALK,     -0.027558221361372_REALK,      0.000000000000000_REALK, &
     -0.122145157349910_REALK,      0.000000000000000_REALK,     -0.764431485439280_REALK, &
     -0.041239352629586_REALK,      0.000000000000000_REALK,     -0.084136361951160_REALK, &
      0.000000000000000_REALK,     -0.438518288717654_REALK,      0.000000000000000_REALK, &
     -0.722509659745283_REALK,      0.000000000000000_REALK,     -6.330441600771431_REALK, &
      0.005686307367013_REALK,     -0.010670073575476_REALK,      0.000000000000000_REALK, &
     -0.212704368222760_REALK,      0.000000000000000_REALK,     -0.645693165348623_REALK, &
     -0.361214616667279_REALK,      0.000000000000000_REALK,     -0.205112084248789_REALK, &
      0.000000000000000_REALK,     -3.930075622620623_REALK,      0.000000000000000_REALK, &
     -2.011966519505250_REALK,      0.000000000000000_REALK,     -8.550638888957732_REALK, &
    -82.613261069266187_REALK,     27.496107618468411_REALK,      0.000000000000000_REALK, &
    -26.568746848273165_REALK,      0.000000000000000_REALK,    -21.758349675827400_REALK, &
     23.393485149686832_REALK,      0.000000000000000_REALK,      8.785979605627334_REALK, &
      0.000000000000000_REALK,    -57.980240695423305_REALK,      0.000000000000000_REALK, &
    -17.355123008988272_REALK,      0.000000000000000_REALK,    -42.638687920025994_REALK, &
    -66.297473616782398_REALK,     22.856391439481616_REALK,      0.000000000000000_REALK, &
    -17.916749580144099_REALK,      0.000000000000000_REALK,    -15.012951420345285_REALK, &
     19.955734777368622_REALK,      0.000000000000000_REALK,      7.137415691599667_REALK, &
      0.000000000000000_REALK,    -24.955512898389294_REALK,      0.000000000000000_REALK, &
    -10.912575932688162_REALK,      0.000000000000000_REALK,    -27.431868422691693_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      9.167420938768897_REALK, &
      0.000000000000000_REALK,     -3.120819160484921_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.950387516689999_REALK,      0.000000000000000_REALK, &
      8.787946409199174_REALK,      0.000000000000000_REALK,     -5.093219065225643_REALK, &
      0.000000000000000_REALK,     -6.115704371944465_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.377383636906744_REALK, &
      0.000000000000000_REALK,     -2.824288337995394_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.797255168503976_REALK,      0.000000000000000_REALK, &
      7.848072113604552_REALK,      0.000000000000000_REALK,     -2.974514013777315_REALK, &
      0.000000000000000_REALK,     -5.160577950757824_REALK,      0.000000000000000_REALK, &
     -5.328406921289461_REALK,      0.955005302763553_REALK,      0.000000000000000_REALK, &
     -1.179276321833525_REALK,      0.000000000000000_REALK,     -4.210123393312434_REALK, &
      0.745269174205352_REALK,      0.000000000000000_REALK,      0.915473989603251_REALK, &
      0.000000000000000_REALK,     -1.995856778184247_REALK,      0.000000000000000_REALK, &
     -2.310965482552101_REALK,      0.000000000000000_REALK,    -13.750593844569188_REALK, &
     -6.356192995568024_REALK,      1.294181933936862_REALK,      0.000000000000000_REALK, &
     -0.941320069653690_REALK,      0.000000000000000_REALK,     -4.318047647443658_REALK, &
      1.350703075735573_REALK,      0.000000000000000_REALK,      1.212411128089508_REALK, &
      0.000000000000000_REALK,      0.858516583494420_REALK,      0.000000000000000_REALK, &
     -1.719992796312206_REALK,      0.000000000000000_REALK,    -13.149992029222583_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.950746738883068_REALK, &
      0.000000000000000_REALK,     -0.244220429275481_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.458808373382339_REALK,      0.000000000000000_REALK, &
      3.116663147633794_REALK,      0.000000000000000_REALK,     -0.404143354549135_REALK, &
      0.000000000000000_REALK,     -0.797643113464979_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.764580722990313_REALK, &
      0.000000000000000_REALK,     -0.295724633843404_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.757963059084960_REALK,      0.000000000000000_REALK, &
      4.316508554119454_REALK,      0.000000000000000_REALK,      0.430957808055207_REALK, &
      0.000000000000000_REALK,     -0.900586768695740_REALK,      0.000000000000000_REALK, &
     -1.260563798145300_REALK,      0.007900781546626_REALK,      0.000000000000000_REALK, &
     -0.228157999268850_REALK,      0.000000000000000_REALK,     -1.660011210896155_REALK, &
      0.032177752672425_REALK,      0.000000000000000_REALK,      0.012622896756948_REALK, &
      0.000000000000000_REALK,     -0.270411595529872_REALK,      0.000000000000000_REALK, &
     -0.745181954837459_REALK,      0.000000000000000_REALK,     -7.590417887659003_REALK, &
     -2.331820279559062_REALK,      0.166051479666663_REALK,      0.000000000000000_REALK, &
     -0.054128256298259_REALK,      0.000000000000000_REALK,     -2.640183906580599_REALK, &
      0.674782698918032_REALK,      0.000000000000000_REALK,      0.259266306259293_REALK, &
      0.000000000000000_REALK,      2.345858853241527_REALK,      0.000000000000000_REALK, &
     -0.164839806549892_REALK,      0.000000000000000_REALK,    -11.256419619843365_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.871746017779974_REALK, &
      0.000000000000000_REALK,      0.112264014221239_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.222544381973673_REALK,      0.000000000000000_REALK, &
      1.949875956206280_REALK,      0.000000000000000_REALK,      0.179719543541516_REALK, &
      0.000000000000000_REALK,      0.513328329406445_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.206182012284627_REALK, &
      0.000000000000000_REALK,      0.569697652097427_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.134736146384939_REALK,      0.000000000000000_REALK, &
      4.822505209664736_REALK,      0.000000000000000_REALK,      3.055318973761651_REALK, &
      0.000000000000000_REALK,      2.428904976075542_REALK,      0.000000000000000_REALK/
    ! results of test 7, ket-major order, 01ODGYYY
  data REF_CONTR_INTS(44101:45360)                                                         &
     /1.792798351343109_REALK,      0.279691501344849_REALK,      0.000000000000000_REALK, &
     -0.059301532718398_REALK,      0.000000000000000_REALK,     -0.054682367750756_REALK, &
     -0.043322219842544_REALK,      0.000000000000000_REALK,     -0.106584307747871_REALK, &
      0.000000000000000_REALK,      1.033110959678044_REALK,      0.000000000000000_REALK, &
     -0.192177402782467_REALK,      0.000000000000000_REALK,     -0.531624475655876_REALK, &
      1.174174554202171_REALK,     -0.743256849041189_REALK,      0.000000000000000_REALK, &
     -1.258518117093243_REALK,      0.000000000000000_REALK,      0.071994654255372_REALK, &
     -0.652067885764186_REALK,      0.000000000000000_REALK,     -0.016915233261568_REALK, &
      0.000000000000000_REALK,      9.153924917402659_REALK,      0.000000000000000_REALK, &
      0.333463966442266_REALK,      0.000000000000000_REALK,     -0.057228313151547_REALK, &
      1.243578670824656_REALK,      0.013699182897255_REALK,      0.000000000000000_REALK, &
     -0.247340781865980_REALK,      0.000000000000000_REALK,     -0.196561007599318_REALK, &
     -0.405695584888529_REALK,      0.000000000000000_REALK,     -0.142315464922370_REALK, &
      0.000000000000000_REALK,     -1.088399111996465_REALK,      0.000000000000000_REALK, &
     -0.232006083605268_REALK,      0.000000000000000_REALK,     -0.553123701056297_REALK, &
      1.199159873828736_REALK,      0.575073611440272_REALK,      0.000000000000000_REALK, &
      0.429910865108379_REALK,      0.000000000000000_REALK,      0.085355669845394_REALK, &
     -0.310690416178276_REALK,      0.000000000000000_REALK,     -0.019280197553739_REALK, &
      0.000000000000000_REALK,     -5.759848498320898_REALK,      0.000000000000000_REALK, &
     -0.245068801404687_REALK,      0.000000000000000_REALK,     -0.145969874686685_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.005339702443010_REALK, &
      0.000000000000000_REALK,      0.050405733719964_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.060157959294369_REALK,      0.000000000000000_REALK, &
      0.166416254478148_REALK,      0.000000000000000_REALK,      0.019217682657391_REALK, &
      0.000000000000000_REALK,      0.141841997709324_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.066501874029140_REALK, &
      0.000000000000000_REALK,      0.034302938614875_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.038974553226376_REALK,      0.000000000000000_REALK, &
      0.006688722505095_REALK,      0.000000000000000_REALK,     -0.753799339233347_REALK, &
      0.000000000000000_REALK,     -0.058662718716495_REALK,      0.000000000000000_REALK, &
      0.284946874426763_REALK,     -0.272680555874028_REALK,      0.000000000000000_REALK, &
     -0.379648498898701_REALK,      0.000000000000000_REALK,     -0.418013852876596_REALK, &
     -0.265362917820539_REALK,      0.000000000000000_REALK,     -0.158703055183305_REALK, &
      0.000000000000000_REALK,     -0.231367627916583_REALK,      0.000000000000000_REALK, &
     -0.190590726777081_REALK,      0.000000000000000_REALK,     -0.629552580245256_REALK, &
      3.508684628757381_REALK,      0.044983212692725_REALK,      0.000000000000000_REALK, &
     -0.230628128377636_REALK,      0.000000000000000_REALK,      0.107341696813267_REALK, &
      0.342223391218727_REALK,      0.000000000000000_REALK,     -0.001323862701924_REALK, &
      0.000000000000000_REALK,      4.239944864156709_REALK,      0.000000000000000_REALK, &
      0.097686196045218_REALK,      0.000000000000000_REALK,     -0.136398826706308_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.138762204308823_REALK, &
      0.000000000000000_REALK,      0.091912375338657_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.101625025256091_REALK,      0.000000000000000_REALK, &
      0.242283345402381_REALK,      0.000000000000000_REALK,      0.131535280271804_REALK, &
      0.000000000000000_REALK,      0.138425252303789_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.331953512068339_REALK, &
      0.000000000000000_REALK,     -0.069623675957487_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.049205742698639_REALK,      0.000000000000000_REALK, &
      0.029308325067967_REALK,      0.000000000000000_REALK,      0.475219496887037_REALK, &
      0.000000000000000_REALK,      0.088470631576672_REALK,      0.000000000000000_REALK, &
      0.024421346499657_REALK,     -0.035583917717005_REALK,      0.000000000000000_REALK, &
     -0.038852143983704_REALK,      0.000000000000000_REALK,     -0.107477520116260_REALK, &
     -0.008417871872462_REALK,      0.000000000000000_REALK,     -0.062130683711335_REALK, &
      0.000000000000000_REALK,      0.104852724008798_REALK,      0.000000000000000_REALK, &
     -0.058513533282883_REALK,      0.000000000000000_REALK,     -0.269778739157113_REALK, &
      0.263174175983488_REALK,     -0.133406263088295_REALK,      0.000000000000000_REALK, &
     -0.140742938803283_REALK,      0.000000000000000_REALK,      0.024153976999784_REALK, &
      0.151350380465077_REALK,      0.000000000000000_REALK,      0.011778499044437_REALK, &
      0.000000000000000_REALK,      1.636462180908691_REALK,      0.000000000000000_REALK, &
      0.178841701686169_REALK,      0.000000000000000_REALK,     -0.051153997326144_REALK, &
     -2.636753176759758_REALK,     -0.669452928588829_REALK,      0.000000000000000_REALK, &
     -0.689910089492933_REALK,      0.000000000000000_REALK,     -0.873325106221219_REALK, &
     -0.363370090050531_REALK,      0.000000000000000_REALK,     -0.186199150887719_REALK, &
      0.000000000000000_REALK,     -0.562249520051835_REALK,      0.000000000000000_REALK, &
     -0.215365193531249_REALK,      0.000000000000000_REALK,     -0.817862356478661_REALK, &
      1.010891892983961_REALK,      0.069108450405972_REALK,      0.000000000000000_REALK, &
     -0.242433577100870_REALK,      0.000000000000000_REALK,     -0.106183019924119_REALK, &
     -1.124179276639026_REALK,      0.000000000000000_REALK,     -0.075104699799938_REALK, &
      0.000000000000000_REALK,     -4.930793373068170_REALK,      0.000000000000000_REALK, &
     -0.201355327281961_REALK,      0.000000000000000_REALK,     -0.264573706962779_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.449612707736549_REALK, &
      0.000000000000000_REALK,      0.135184761358021_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.113576175535814_REALK,      0.000000000000000_REALK, &
      0.375160825356366_REALK,      0.000000000000000_REALK,      0.070561158820683_REALK, &
      0.000000000000000_REALK,      0.126599506525890_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.029135748967881_REALK, &
      0.000000000000000_REALK,      0.001835626264013_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.068030860543916_REALK,      0.000000000000000_REALK, &
      0.094991205857942_REALK,      0.000000000000000_REALK,     -0.394113545442658_REALK, &
      0.000000000000000_REALK,      0.004573786332458_REALK,      0.000000000000000_REALK, &
     -0.207700858111754_REALK,     -0.098860292945151_REALK,      0.000000000000000_REALK, &
     -0.086565156363119_REALK,      0.000000000000000_REALK,     -0.206379241983801_REALK, &
     -0.078384055373146_REALK,      0.000000000000000_REALK,     -0.082489903995345_REALK, &
      0.000000000000000_REALK,     -0.126769548342708_REALK,      0.000000000000000_REALK, &
     -0.081067614188285_REALK,      0.000000000000000_REALK,     -0.322120998573460_REALK, &
      0.128961685951422_REALK,      0.018897949307130_REALK,      0.000000000000000_REALK, &
     -0.068227130733875_REALK,      0.000000000000000_REALK,     -0.040637999069536_REALK, &
     -0.330953529048329_REALK,      0.000000000000000_REALK,     -0.061612934505493_REALK, &
      0.000000000000000_REALK,     -1.331835221213167_REALK,      0.000000000000000_REALK, &
     -0.169999920011649_REALK,      0.000000000000000_REALK,     -0.168761227313942_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.115602051242419_REALK, &
      0.000000000000000_REALK,      0.052923503210612_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.034869185084385_REALK,      0.000000000000000_REALK, &
      0.160765625654896_REALK,      0.000000000000000_REALK,      0.006715046687797_REALK, &
      0.000000000000000_REALK,      0.082604100772625_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.006556112222317_REALK, &
      0.000000000000000_REALK,     -0.016331695246943_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.124549377081041_REALK,      0.000000000000000_REALK, &
      0.035624792439945_REALK,      0.000000000000000_REALK,     -0.522897352253718_REALK, &
      0.000000000000000_REALK,     -0.067822161452271_REALK,      0.000000000000000_REALK, &
    -10.418470655147727_REALK,     -1.111487305196884_REALK,      0.000000000000000_REALK, &
     -1.285408192260743_REALK,      0.000000000000000_REALK,     -1.928814479757852_REALK, &
     -0.283798645149219_REALK,      0.000000000000000_REALK,     -0.203986691118726_REALK, &
      0.000000000000000_REALK,     -0.419193743001482_REALK,      0.000000000000000_REALK, &
     -0.272085530841393_REALK,      0.000000000000000_REALK,     -1.224830792535573_REALK, &
     13.123401155224371_REALK,      0.088374962458382_REALK,      0.000000000000000_REALK, &
     -0.027589359472465_REALK,      0.000000000000000_REALK,      0.048530097526435_REALK, &
      1.169244571594817_REALK,      0.000000000000000_REALK,     -0.007666928655923_REALK, &
      0.000000000000000_REALK,      5.602194255522814_REALK,      0.000000000000000_REALK, &
      0.077349511845331_REALK,      0.000000000000000_REALK,     -0.408176857881284_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.195849945294375_REALK, &
      0.000000000000000_REALK,      0.205175751074655_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.173376633308513_REALK,      0.000000000000000_REALK, &
      0.658408257857427_REALK,      0.000000000000000_REALK,      0.084754330179408_REALK, &
      0.000000000000000_REALK,      0.130290175874976_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.680935727365530_REALK, &
      0.000000000000000_REALK,     -0.010909873251157_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.134876409962726_REALK,      0.000000000000000_REALK, &
      0.177222784454568_REALK,      0.000000000000000_REALK,      0.457829871381959_REALK, &
      0.000000000000000_REALK,      0.091760742518901_REALK,      0.000000000000000_REALK, &
     -0.744317240857654_REALK,     -0.185109403500502_REALK,      0.000000000000000_REALK, &
     -0.125151360834076_REALK,      0.000000000000000_REALK,     -0.413395570008245_REALK, &
     -0.056804240082101_REALK,      0.000000000000000_REALK,     -0.101917101180944_REALK, &
      0.000000000000000_REALK,     -0.032158870575968_REALK,      0.000000000000000_REALK, &
     -0.079473294132752_REALK,      0.000000000000000_REALK,     -0.437522313107982_REALK, &
      1.243798352041995_REALK,      0.011771594989010_REALK,      0.000000000000000_REALK, &
     -0.009882311861686_REALK,      0.000000000000000_REALK,      0.013798630693489_REALK, &
      0.263994108546984_REALK,      0.000000000000000_REALK,     -0.003063717701368_REALK, &
      0.000000000000000_REALK,      1.202545521533587_REALK,      0.000000000000000_REALK, &
      0.083118131013616_REALK,      0.000000000000000_REALK,     -0.193429164120427_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.282596484949452_REALK, &
      0.000000000000000_REALK,      0.090896912943105_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.065262309976189_REALK,      0.000000000000000_REALK, &
      0.259318849693971_REALK,      0.000000000000000_REALK,      0.054848114568038_REALK, &
      0.000000000000000_REALK,      0.096201871743446_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.260605372449089_REALK, &
      0.000000000000000_REALK,     -0.008950029863342_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.113873217136262_REALK,      0.000000000000000_REALK, &
      0.113043487789793_REALK,      0.000000000000000_REALK,      0.404349416822390_REALK, &
      0.000000000000000_REALK,      0.125461492069349_REALK,      0.000000000000000_REALK, &
     -0.191374928549974_REALK,     -0.072468509113449_REALK,      0.000000000000000_REALK, &
     -0.038422899379192_REALK,      0.000000000000000_REALK,     -0.177150152583782_REALK, &
     -0.005405851187698_REALK,      0.000000000000000_REALK,     -0.066499236272164_REALK, &
      0.000000000000000_REALK,      0.043721914054706_REALK,      0.000000000000000_REALK, &
     -0.040665350652800_REALK,      0.000000000000000_REALK,     -0.262484676200277_REALK, &
      0.279878907074245_REALK,     -0.104732703873333_REALK,      0.000000000000000_REALK, &
     -0.018092315408814_REALK,      0.000000000000000_REALK,      0.005174935405559_REALK, &
      0.350259010292969_REALK,      0.000000000000000_REALK,      0.045430184421121_REALK, &
      0.000000000000000_REALK,      1.392414521788058_REALK,      0.000000000000000_REALK, &
      0.253618023720367_REALK,      0.000000000000000_REALK,     -0.101559120825339_REALK, &
    -60.050265706634235_REALK,     -1.635496010334175_REALK,      0.000000000000000_REALK, &
     -3.565484973672014_REALK,      0.000000000000000_REALK,     -5.730429068293263_REALK, &
     -0.199608562792580_REALK,      0.000000000000000_REALK,     -0.178839749699407_REALK, &
      0.000000000000000_REALK,     -0.933635972935663_REALK,      0.000000000000000_REALK, &
     -0.473889472778978_REALK,      0.000000000000000_REALK,     -2.284898152725151_REALK, &
    -25.173826949141635_REALK,     -2.162866479208211_REALK,      0.000000000000000_REALK, &
     -5.078606267910479_REALK,      0.000000000000000_REALK,     -3.933435207119274_REALK, &
     -6.727256227542052_REALK,      0.000000000000000_REALK,     -0.289020496100708_REALK, &
      0.000000000000000_REALK,    -16.084629405786291_REALK,      0.000000000000000_REALK, &
     -0.693085003235117_REALK,      0.000000000000000_REALK,     -1.610405380592565_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.519198167175681_REALK, &
      0.000000000000000_REALK,      0.349610206544180_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.329326406820218_REALK,      0.000000000000000_REALK, &
      1.482508542887697_REALK,      0.000000000000000_REALK,      0.064647396294924_REALK, &
      0.000000000000000_REALK,      0.139400332084483_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.973171873815267_REALK, &
      0.000000000000000_REALK,      0.048143576487240_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.225865241225581_REALK,      0.000000000000000_REALK, &
      1.191901051068122_REALK,      0.000000000000000_REALK,     -1.001991985454090_REALK, &
      0.000000000000000_REALK,      0.019710677952873_REALK,      0.000000000000000_REALK, &
     -3.941704620092249_REALK,     -0.480725278629121_REALK,      0.000000000000000_REALK, &
     -0.297148016120546_REALK,      0.000000000000000_REALK,     -1.128437574811948_REALK, &
     -0.102584797266230_REALK,      0.000000000000000_REALK,     -0.157700394181903_REALK, &
      0.000000000000000_REALK,     -0.103106219540978_REALK,      0.000000000000000_REALK, &
     -0.118482044717464_REALK,      0.000000000000000_REALK,     -0.749904559043605_REALK, &
     -2.374064263747361_REALK,     -0.668387865479993_REALK,      0.000000000000000_REALK, &
     -0.846940548266103_REALK,      0.000000000000000_REALK,     -1.112849624872707_REALK, &
     -1.336890846147017_REALK,      0.000000000000000_REALK,     -0.267946904248254_REALK, &
      0.000000000000000_REALK,     -2.830404868279982_REALK,      0.000000000000000_REALK, &
     -0.346749735066474_REALK,      0.000000000000000_REALK,     -0.759361274695193_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.968582785906060_REALK, &
      0.000000000000000_REALK,      0.174674428997505_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.096192746133796_REALK,      0.000000000000000_REALK, &
      0.529567488700877_REALK,      0.000000000000000_REALK,      0.038818855719577_REALK, &
      0.000000000000000_REALK,      0.116080103656063_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.845366128776046_REALK, &
      0.000000000000000_REALK,      0.019238254861962_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.242709957228297_REALK,      0.000000000000000_REALK, &
      0.564824829166135_REALK,      0.000000000000000_REALK,     -0.678694571000772_REALK, &
      0.000000000000000_REALK,      0.013127367263624_REALK,      0.000000000000000_REALK, &
     -0.931481307274618_REALK,     -0.212970799776440_REALK,      0.000000000000000_REALK, &
     -0.111852246561742_REALK,      0.000000000000000_REALK,     -0.444443292379019_REALK, &
     -0.066386964553749_REALK,      0.000000000000000_REALK,     -0.116440652513480_REALK, &
      0.000000000000000_REALK,     -0.069741609817624_REALK,      0.000000000000000_REALK, &
     -0.074331546120217_REALK,      0.000000000000000_REALK,     -0.413497460633288_REALK, &
     -0.908593684848372_REALK,     -0.548319051800791_REALK,      0.000000000000000_REALK, &
     -0.715053469920083_REALK,      0.000000000000000_REALK,     -0.709843282105878_REALK, &
     -1.180724692259648_REALK,      0.000000000000000_REALK,     -0.366355126163288_REALK, &
      0.000000000000000_REALK,     -2.293525164403423_REALK,      0.000000000000000_REALK, &
     -0.487922089613719_REALK,      0.000000000000000_REALK,     -0.678113630521782_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.415061507093220_REALK, &
      0.000000000000000_REALK,      0.113972198875515_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.049220455682288_REALK,      0.000000000000000_REALK, &
      0.317705741246475_REALK,      0.000000000000000_REALK,      0.006157080204853_REALK, &
      0.000000000000000_REALK,      0.106036508202328_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.317039799646769_REALK, &
      0.000000000000000_REALK,     -0.285273498249901_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.740579930501704_REALK,      0.000000000000000_REALK, &
      0.296558760057097_REALK,      0.000000000000000_REALK,     -1.500784051825623_REALK, &
      0.000000000000000_REALK,     -0.272521910774434_REALK,      0.000000000000000_REALK, &
      7.443573404943722_REALK,     -0.893965159796495_REALK,      0.000000000000000_REALK, &
      0.855171886007517_REALK,      0.000000000000000_REALK,      1.301850834489785_REALK, &
     -1.712747980239688_REALK,      0.000000000000000_REALK,     -0.354567531148867_REALK, &
      0.000000000000000_REALK,     -1.246623437272161_REALK,      0.000000000000000_REALK, &
     -0.883217697309069_REALK,      0.000000000000000_REALK,     -4.033637149764244_REALK, &
      4.792459579075794_REALK,     -1.933459351287913_REALK,      0.000000000000000_REALK, &
     -0.360733865121063_REALK,      0.000000000000000_REALK,      0.916190310273030_REALK, &
     -9.627125030149402_REALK,      0.000000000000000_REALK,     -0.850675994558197_REALK, &
      0.000000000000000_REALK,      4.388784786629137_REALK,      0.000000000000000_REALK, &
      0.116711558105258_REALK,      0.000000000000000_REALK,     -0.889270531312769_REALK, &
     11.704205623982022_REALK,     -2.625738745123939_REALK,      0.000000000000000_REALK, &
      1.082262953089944_REALK,      0.000000000000000_REALK,      1.446479175862973_REALK, &
     -2.007331173018328_REALK,      0.000000000000000_REALK,     -0.837352993021908_REALK, &
      0.000000000000000_REALK,     -4.281817087059316_REALK,      0.000000000000000_REALK, &
     -1.730541758840840_REALK,      0.000000000000000_REALK,     -6.938773825652308_REALK, &
      3.645907457804698_REALK,     -0.958009229238167_REALK,      0.000000000000000_REALK, &
      1.448375877645039_REALK,      0.000000000000000_REALK,      1.369609916791493_REALK, &
      2.175445447392077_REALK,      0.000000000000000_REALK,     -0.402748445350052_REALK, &
      0.000000000000000_REALK,     -5.776036635611058_REALK,      0.000000000000000_REALK, &
     -0.677178335877834_REALK,      0.000000000000000_REALK,     -1.921055532413270_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.844760145187061_REALK, &
      0.000000000000000_REALK,      0.031647754570778_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.595929532596596_REALK,      0.000000000000000_REALK, &
     -2.721597980483072_REALK,      0.000000000000000_REALK,     -0.244448115609935_REALK, &
      0.000000000000000_REALK,     -0.151814567897511_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.547501806768587_REALK, &
      0.000000000000000_REALK,      0.169727283815926_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.256151300531801_REALK,      0.000000000000000_REALK, &
     -1.951715895309503_REALK,      0.000000000000000_REALK,     -0.898061065659940_REALK, &
      0.000000000000000_REALK,     -0.238064527409303_REALK,      0.000000000000000_REALK, &
     15.227004773550332_REALK,     -3.901520716482385_REALK,      0.000000000000000_REALK, &
      0.838045457671909_REALK,      0.000000000000000_REALK,      0.969380713098030_REALK, &
     -1.895571611036996_REALK,      0.000000000000000_REALK,     -0.779383506205892_REALK, &
      0.000000000000000_REALK,     -7.813396117056610_REALK,      0.000000000000000_REALK, &
     -2.961580510625470_REALK,      0.000000000000000_REALK,    -10.277123994906095_REALK, &
     17.266521329264268_REALK,     -4.277781454856459_REALK,      0.000000000000000_REALK, &
      1.408677189594755_REALK,      0.000000000000000_REALK,      2.337257217462855_REALK, &
     -3.604735202001320_REALK,      0.000000000000000_REALK,     -0.946882677076218_REALK, &
      0.000000000000000_REALK,      2.607934958361084_REALK,      0.000000000000000_REALK, &
     -0.612420913688804_REALK,      0.000000000000000_REALK,     -3.048360286978450_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.363098368848092_REALK, &
      0.000000000000000_REALK,      0.068373540780558_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.353199191282231_REALK,      0.000000000000000_REALK, &
     -1.416186168978836_REALK,      0.000000000000000_REALK,     -0.579234591597570_REALK, &
      0.000000000000000_REALK,     -0.724878623102446_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.673846158953410_REALK, &
      0.000000000000000_REALK,      0.164575580524039_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.625890537157365_REALK,      0.000000000000000_REALK, &
     -1.775559576241645_REALK,      0.000000000000000_REALK,      0.386472192589456_REALK, &
      0.000000000000000_REALK,     -0.214647177096107_REALK,      0.000000000000000_REALK, &
      1.163596274943699_REALK,     -0.051702615877130_REALK,      0.000000000000000_REALK, &
      0.048660257428932_REALK,      0.000000000000000_REALK,      0.222230399912091_REALK, &
     -0.049891241458239_REALK,      0.000000000000000_REALK,     -0.030984968916427_REALK, &
      0.000000000000000_REALK,     -0.242715713817082_REALK,      0.000000000000000_REALK, &
     -0.515883483613944_REALK,      0.000000000000000_REALK,     -3.926715521354306_REALK, &
      1.963926396352022_REALK,     -0.331353212573079_REALK,      0.000000000000000_REALK, &
     -0.104671413319469_REALK,      0.000000000000000_REALK,      0.797532008371573_REALK, &
     -0.830044159722526_REALK,      0.000000000000000_REALK,     -0.220034113680216_REALK, &
      0.000000000000000_REALK,      1.711185285104061_REALK,      0.000000000000000_REALK, &
      0.136517357679331_REALK,      0.000000000000000_REALK,     -1.733630972627218_REALK, &
     15.179460462105020_REALK,     -3.569269344381261_REALK,      0.000000000000000_REALK, &
     -1.006097209557022_REALK,      0.000000000000000_REALK,     -0.964046950459341_REALK, &
      0.574631794533765_REALK,      0.000000000000000_REALK,      0.229264466302743_REALK, &
      0.000000000000000_REALK,    -16.305340912221222_REALK,      0.000000000000000_REALK, &
     -5.333856633048532_REALK,      0.000000000000000_REALK,    -15.332777506286273_REALK, &
     11.142163774364825_REALK,     -4.289335367311450_REALK,      0.000000000000000_REALK, &
      2.359142086948723_REALK,      0.000000000000000_REALK,      2.044678630967903_REALK, &
     -0.959324193572434_REALK,      0.000000000000000_REALK,     -0.647753528463964_REALK, &
      0.000000000000000_REALK,    -11.351667586222296_REALK,      0.000000000000000_REALK, &
     -2.209657503853863_REALK,      0.000000000000000_REALK,     -5.745359092463268_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.487763507450994_REALK, &
      0.000000000000000_REALK,     -0.110142902540466_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.082616069700228_REALK,      0.000000000000000_REALK, &
      0.286690025557243_REALK,      0.000000000000000_REALK,     -1.420191457274682_REALK, &
      0.000000000000000_REALK,     -1.751778393930791_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.052398601902492_REALK, &
      0.000000000000000_REALK,      0.351659614512722_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.186804127000752_REALK,      0.000000000000000_REALK, &
     -0.929828275724317_REALK,      0.000000000000000_REALK,     -1.253922100580737_REALK, &
      0.000000000000000_REALK,     -0.988131207072076_REALK,      0.000000000000000_REALK, &
      1.050418955484549_REALK,     -0.104936747218159_REALK,      0.000000000000000_REALK, &
     -0.049914302513471_REALK,      0.000000000000000_REALK,     -0.200136202456132_REALK, &
      0.016158292918433_REALK,      0.000000000000000_REALK,      0.020221169958263_REALK, &
      0.000000000000000_REALK,     -0.654745357934895_REALK,      0.000000000000000_REALK, &
     -0.793866828224345_REALK,      0.000000000000000_REALK,     -5.305142489430985_REALK, &
      1.197801349741762_REALK,     -0.144517551962676_REALK,      0.000000000000000_REALK, &
      0.232447409116771_REALK,      0.000000000000000_REALK,      0.659419177519972_REALK, &
      0.117883956822913_REALK,      0.000000000000000_REALK,     -0.065472908639088_REALK, &
      0.000000000000000_REALK,     -1.857045130154515_REALK,      0.000000000000000_REALK, &
     -0.653155862863584_REALK,      0.000000000000000_REALK,     -3.088178838089243_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.341069586766179_REALK, &
      0.000000000000000_REALK,     -0.004378812721089_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.014391054265293_REALK,      0.000000000000000_REALK, &
      0.109539417227142_REALK,      0.000000000000000_REALK,     -0.112137860420463_REALK, &
      0.000000000000000_REALK,     -0.116072080587232_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.700330954900695_REALK, &
      0.000000000000000_REALK,      0.081717739134650_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.041641304618633_REALK,      0.000000000000000_REALK, &
     -0.528802026750597_REALK,      0.000000000000000_REALK,     -0.866202917559264_REALK, &
      0.000000000000000_REALK,     -0.382698898204973_REALK,      0.000000000000000_REALK, &
      1.399784975883166_REALK,      3.627246535105352_REALK,      0.000000000000000_REALK, &
     -8.941144908457487_REALK,      0.000000000000000_REALK,     -7.066422592463386_REALK, &
      9.677928474186853_REALK,      0.000000000000000_REALK,      3.600767400770055_REALK, &
      0.000000000000000_REALK,    -35.098284347353484_REALK,      0.000000000000000_REALK, &
    -10.326093872390485_REALK,      0.000000000000000_REALK,    -24.482952836186485_REALK, &
     82.344145735100639_REALK,    -20.388664650606493_REALK,      0.000000000000000_REALK, &
      5.889637867606082_REALK,      0.000000000000000_REALK,      4.837545353842065_REALK, &
     -0.229226117142198_REALK,      0.000000000000000_REALK,     -0.077871875410721_REALK, &
      0.000000000000000_REALK,     -8.593565238533573_REALK,      0.000000000000000_REALK, &
     -4.479574928831388_REALK,      0.000000000000000_REALK,    -11.038104907949350_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.144745344955181_REALK, &
      0.000000000000000_REALK,     -1.070891394713381_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.185956170452967_REALK,      0.000000000000000_REALK, &
      3.409165889666912_REALK,      0.000000000000000_REALK,     -3.099854198911363_REALK, &
      0.000000000000000_REALK,     -3.710305061207182_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -7.068916793263823_REALK, &
      0.000000000000000_REALK,      0.941600657082177_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.031151126851648_REALK,      0.000000000000000_REALK, &
     -0.080996448357016_REALK,      0.000000000000000_REALK,     -1.060646286333125_REALK, &
      0.000000000000000_REALK,     -2.148504266944478_REALK,      0.000000000000000_REALK, &
      0.088422284376167_REALK,      0.130787795037342_REALK,      0.000000000000000_REALK, &
     -0.385898606678050_REALK,      0.000000000000000_REALK,     -1.339125448747038_REALK, &
      0.315772420942791_REALK,      0.000000000000000_REALK,      0.389499107020619_REALK, &
      0.000000000000000_REALK,     -1.175797262527438_REALK,      0.000000000000000_REALK, &
     -1.337018450739892_REALK,      0.000000000000000_REALK,     -7.732754156343563_REALK, &
      7.669130682944563_REALK,     -1.215766877440743_REALK,      0.000000000000000_REALK, &
      0.271546014032027_REALK,      0.000000000000000_REALK,      1.351635887606458_REALK, &
     -0.017677439308648_REALK,      0.000000000000000_REALK,     -0.013930394427140_REALK, &
      0.000000000000000_REALK,      0.879505152367213_REALK,      0.000000000000000_REALK, &
     -0.619602126901085_REALK,      0.000000000000000_REALK,     -5.140175313946493_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.237649199563883_REALK, &
      0.000000000000000_REALK,     -0.094452826678975_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.176512292740888_REALK,      0.000000000000000_REALK, &
      1.179571725173447_REALK,      0.000000000000000_REALK,     -0.261497985111057_REALK, &
      0.000000000000000_REALK,     -0.545416031607513_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.279761341059527_REALK, &
      0.000000000000000_REALK,      0.095174060945431_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.009208006717093_REALK,      0.000000000000000_REALK, &
     -0.043536272276636_REALK,      0.000000000000000_REALK,      0.391003943797764_REALK, &
      0.000000000000000_REALK,     -0.361940196383850_REALK,      0.000000000000000_REALK, &
      0.020270796966093_REALK,      0.005199565722923_REALK,      0.000000000000000_REALK, &
     -0.067220430719540_REALK,      0.000000000000000_REALK,     -0.511657219202753_REALK, &
      0.024933288735778_REALK,      0.000000000000000_REALK,      0.025808042784057_REALK, &
      0.000000000000000_REALK,     -0.109575068614092_REALK,      0.000000000000000_REALK, &
     -0.388163084738686_REALK,      0.000000000000000_REALK,     -4.136376684470688_REALK, &
      2.616903758103396_REALK,     -0.282516719120320_REALK,      0.000000000000000_REALK, &
     -0.060531480057920_REALK,      0.000000000000000_REALK,      0.768687956104974_REALK, &
     -0.012211483868923_REALK,      0.000000000000000_REALK,     -0.005395180883543_REALK, &
      0.000000000000000_REALK,      1.731250547578578_REALK,      0.000000000000000_REALK, &
      0.230196920904010_REALK,      0.000000000000000_REALK,     -4.092572007934788_REALK, &
   -145.966200502425039_REALK,     57.786971038066063_REALK,      0.000000000000000_REALK, &
    -47.336628248866177_REALK,      0.000000000000000_REALK,    -30.989877651819874_REALK, &
     44.255000561534501_REALK,      0.000000000000000_REALK,     15.179942507386043_REALK, &
      0.000000000000000_REALK,    -85.232739531317392_REALK,      0.000000000000000_REALK, &
    -22.644764321682953_REALK,      0.000000000000000_REALK,    -44.474553960234331_REALK, &
    -69.184029970767952_REALK,     43.691844417173272_REALK,      0.000000000000000_REALK, &
    -41.911862897954059_REALK,      0.000000000000000_REALK,    -25.551146644187835_REALK, &
     38.308052127888665_REALK,      0.000000000000000_REALK,     14.784689172576739_REALK, &
      0.000000000000000_REALK,    -87.181514011081873_REALK,      0.000000000000000_REALK, &
    -19.908134432936549_REALK,      0.000000000000000_REALK,    -36.410383156674115_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     14.615867775301636_REALK, &
      0.000000000000000_REALK,     -5.712108491361608_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      4.858009152218718_REALK,      0.000000000000000_REALK, &
     11.518238205208082_REALK,      0.000000000000000_REALK,     -7.344365338688053_REALK, &
      0.000000000000000_REALK,     -8.197627631190596_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     12.341115545320966_REALK, &
      0.000000000000000_REALK,     -6.258871029538124_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      5.084283761607267_REALK,      0.000000000000000_REALK, &
     12.528165826895751_REALK,      0.000000000000000_REALK,     -8.751309962980690_REALK, &
      0.000000000000000_REALK,     -8.918891018361736_REALK,      0.000000000000000_REALK, &
     -8.491036367593907_REALK,      2.214983157606878_REALK,      0.000000000000000_REALK, &
     -1.881351822441611_REALK,      0.000000000000000_REALK,     -5.408159778013469_REALK, &
      1.458355914148672_REALK,      0.000000000000000_REALK,      1.745548332953050_REALK, &
      0.000000000000000_REALK,     -2.751243620196831_REALK,      0.000000000000000_REALK, &
     -2.699987527716198_REALK,      0.000000000000000_REALK,    -12.935702025846501_REALK, &
     -5.875645037951672_REALK,      2.402127867880796_REALK,      0.000000000000000_REALK, &
     -2.503739435590963_REALK,      0.000000000000000_REALK,     -6.510005331750609_REALK, &
      1.203825536147325_REALK,      0.000000000000000_REALK,      2.438536140084041_REALK, &
      0.000000000000000_REALK,     -6.109665470069812_REALK,      0.000000000000000_REALK, &
     -3.567828616219020_REALK,      0.000000000000000_REALK,    -15.461262318400955_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.769786300964080_REALK, &
      0.000000000000000_REALK,     -0.617885275265055_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.629013056693822_REALK,      0.000000000000000_REALK, &
      3.637947797842157_REALK,      0.000000000000000_REALK,     -0.718898066710719_REALK, &
      0.000000000000000_REALK,     -1.477911181448639_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.448173287079501_REALK, &
      0.000000000000000_REALK,     -1.119640969865019_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.703243741316842_REALK,      0.000000000000000_REALK, &
      5.834060216809555_REALK,      0.000000000000000_REALK,     -2.024648229491992_REALK, &
      0.000000000000000_REALK,     -2.659147244178492_REALK,      0.000000000000000_REALK, &
     -1.762739639098959_REALK,      0.195361939889605_REALK,      0.000000000000000_REALK, &
     -0.280011801367482_REALK,      0.000000000000000_REALK,     -1.871223802485093_REALK, &
      0.123024216190104_REALK,      0.000000000000000_REALK,      0.256596163666554_REALK, &
      0.000000000000000_REALK,     -0.331430786740872_REALK,      0.000000000000000_REALK, &
     -0.669756326530123_REALK,      0.000000000000000_REALK,     -6.266055800243715_REALK, &
     -1.894925177797398_REALK,      0.242799601271361_REALK,      0.000000000000000_REALK, &
     -0.740083967124686_REALK,      0.000000000000000_REALK,     -3.499182623368621_REALK, &
     -0.443786527462771_REALK,      0.000000000000000_REALK,      0.410799393331595_REALK, &
      0.000000000000000_REALK,     -2.998482228770619_REALK,      0.000000000000000_REALK, &
     -1.757699382756197_REALK,      0.000000000000000_REALK,    -11.634781963455284_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.058288570247961_REALK, &
      0.000000000000000_REALK,     -0.040940811756046_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.182615017984283_REALK,      0.000000000000000_REALK, &
      1.945997783722533_REALK,      0.000000000000000_REALK,     -0.094606599986229_REALK, &
      0.000000000000000_REALK,     -0.137096060145217_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.961008360790617_REALK, &
      0.000000000000000_REALK,     -0.433632054615634_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.261271769201006_REALK,      0.000000000000000_REALK, &
      4.645038364963690_REALK,      0.000000000000000_REALK,     -2.331027584840843_REALK, &
      0.000000000000000_REALK,     -1.441826549470307_REALK,      0.000000000000000_REALK/
    ! results of test 7, ket-major order, 01ODGXXZ
  data REF_CONTR_INTS(45361:46620)                                                         &
     /0.000000000000000_REALK,      0.000000000000000_REALK,      0.580259891490002_REALK, &
      0.000000000000000_REALK,      1.770444022701706_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.977608199375717_REALK,      0.000000000000000_REALK, &
      1.875515673143678_REALK,      0.000000000000000_REALK,     17.495316159756662_REALK, &
      0.000000000000000_REALK,      6.276404179020735_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.705710818383488_REALK, &
      0.000000000000000_REALK,      0.464305248711001_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.962911983267625_REALK,      0.000000000000000_REALK, &
      1.071620192677525_REALK,      0.000000000000000_REALK,     18.832978146027980_REALK, &
      0.000000000000000_REALK,      5.488173394250455_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.812053696912720_REALK, &
      0.000000000000000_REALK,      1.110929494916976_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.726322171783106_REALK,      0.000000000000000_REALK, &
      1.313902664637266_REALK,      0.000000000000000_REALK,      4.416804888429023_REALK, &
      0.000000000000000_REALK,      2.530645094359074_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.075507188953042_REALK, &
      0.000000000000000_REALK,      0.286776068400083_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.427147914046196_REALK,      0.000000000000000_REALK, &
      0.522068829973651_REALK,      0.000000000000000_REALK,      0.193547082434702_REALK, &
      0.000000000000000_REALK,      1.043834870508455_REALK,      0.000000000000000_REALK, &
     -0.498939345928663_REALK,     -0.982892127054096_REALK,      0.000000000000000_REALK, &
     -2.060478600651300_REALK,      0.000000000000000_REALK,     -0.971553686535840_REALK, &
     -4.432974102233586_REALK,      0.000000000000000_REALK,     -1.590319198960767_REALK, &
      0.000000000000000_REALK,    -15.720797793495603_REALK,      0.000000000000000_REALK, &
     -4.693673258859462_REALK,      0.000000000000000_REALK,     -3.688589272898520_REALK, &
      0.354065391924784_REALK,     -0.220485547229396_REALK,      0.000000000000000_REALK, &
     -1.587795370174451_REALK,      0.000000000000000_REALK,     -0.574270714124395_REALK, &
     -5.231313745821034_REALK,      0.000000000000000_REALK,     -1.524472480888368_REALK, &
      0.000000000000000_REALK,    -23.220800900300070_REALK,      0.000000000000000_REALK, &
     -5.779408943942042_REALK,      0.000000000000000_REALK,     -3.483808812099279_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.059674247724404_REALK, &
      0.000000000000000_REALK,      0.936286919041259_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.152746858179920_REALK,      0.000000000000000_REALK, &
      1.157010126365219_REALK,      0.000000000000000_REALK,      2.183887201115879_REALK, &
      0.000000000000000_REALK,      1.467146742832473_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.237977785449935_REALK, &
      0.000000000000000_REALK,      0.380702297064662_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.682033248445912_REALK,      0.000000000000000_REALK, &
      0.513164618722954_REALK,      0.000000000000000_REALK,      1.850588609286267_REALK, &
      0.000000000000000_REALK,      0.806474597629349_REALK,      0.000000000000000_REALK, &
     -0.761806522728751_REALK,     -0.780005617925153_REALK,      0.000000000000000_REALK, &
     -1.013673827730526_REALK,      0.000000000000000_REALK,     -0.771506480712413_REALK, &
     -1.486412957891284_REALK,      0.000000000000000_REALK,     -0.851652666372878_REALK, &
      0.000000000000000_REALK,     -3.149061905305546_REALK,      0.000000000000000_REALK, &
     -1.588410800582625_REALK,      0.000000000000000_REALK,     -2.014897351854529_REALK, &
     -0.016910497554341_REALK,     -0.192141879112463_REALK,      0.000000000000000_REALK, &
     -0.273376964138239_REALK,      0.000000000000000_REALK,     -0.334126861249202_REALK, &
     -0.076824041143908_REALK,      0.000000000000000_REALK,     -0.414326126907346_REALK, &
      0.000000000000000_REALK,      1.593673052394576_REALK,      0.000000000000000_REALK, &
     -0.579118063784817_REALK,      0.000000000000000_REALK,     -1.179683040443799_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.682147100316643_REALK, &
      0.000000000000000_REALK,      0.933814658742877_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.579589075884675_REALK,      0.000000000000000_REALK, &
      1.241342334577354_REALK,      0.000000000000000_REALK,      4.078835374869744_REALK, &
      0.000000000000000_REALK,      2.438787916968033_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.384765209826293_REALK, &
      0.000000000000000_REALK,      0.975670593331002_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.294002807542520_REALK,      0.000000000000000_REALK, &
      1.382817390742727_REALK,      0.000000000000000_REALK,      7.092503996643967_REALK, &
      0.000000000000000_REALK,      3.444745650526689_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.455013503440466_REALK, &
      0.000000000000000_REALK,      0.880217324103182_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.849305993129656_REALK,      0.000000000000000_REALK, &
      1.167822030749455_REALK,      0.000000000000000_REALK,      1.137490890235970_REALK, &
      0.000000000000000_REALK,      0.987705130329478_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.469738525719465_REALK, &
      0.000000000000000_REALK,      0.322594455119471_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.241365708587946_REALK,      0.000000000000000_REALK, &
      0.510280142658548_REALK,      0.000000000000000_REALK,     -0.013544345133339_REALK, &
      0.000000000000000_REALK,      0.415462571659646_REALK,      0.000000000000000_REALK, &
     -1.145991126664164_REALK,     -0.795358009368004_REALK,      0.000000000000000_REALK, &
     -0.789666770101328_REALK,      0.000000000000000_REALK,     -0.792587238887750_REALK, &
     -0.950230460768315_REALK,      0.000000000000000_REALK,     -0.638369749474281_REALK, &
      0.000000000000000_REALK,     -1.651713723851834_REALK,      0.000000000000000_REALK, &
     -0.886096988461864_REALK,      0.000000000000000_REALK,     -1.482290150864567_REALK, &
     -0.321498221444546_REALK,     -0.416457216422106_REALK,      0.000000000000000_REALK, &
     -0.587120290763639_REALK,      0.000000000000000_REALK,     -0.441751719349099_REALK, &
     -1.038106886451910_REALK,      0.000000000000000_REALK,     -0.452400295423008_REALK, &
      0.000000000000000_REALK,     -2.701978679966982_REALK,      0.000000000000000_REALK, &
     -0.756139797207252_REALK,      0.000000000000000_REALK,     -0.948204484212627_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.655380147083844_REALK, &
      0.000000000000000_REALK,      0.583408061822613_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.691132914811615_REALK,      0.000000000000000_REALK, &
      0.876701341568966_REALK,      0.000000000000000_REALK,      1.142580468775032_REALK, &
      0.000000000000000_REALK,      1.091084970265488_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.365507494019831_REALK, &
      0.000000000000000_REALK,      0.356667767524686_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.324862288175209_REALK,      0.000000000000000_REALK, &
      0.661755444710941_REALK,      0.000000000000000_REALK,      0.085171382808037_REALK, &
      0.000000000000000_REALK,      0.765574782684101_REALK,      0.000000000000000_REALK, &
     -0.737712108906390_REALK,     -0.793257871056156_REALK,      0.000000000000000_REALK, &
     -1.082066712904029_REALK,      0.000000000000000_REALK,     -0.850357374630766_REALK, &
     -1.774740753863195_REALK,      0.000000000000000_REALK,     -1.061140229620206_REALK, &
      0.000000000000000_REALK,     -4.066803258497241_REALK,      0.000000000000000_REALK, &
     -2.023672287945069_REALK,      0.000000000000000_REALK,     -2.226463938605310_REALK, &
     -0.519802007565595_REALK,     -1.067303934272086_REALK,      0.000000000000000_REALK, &
     -1.974765304251554_REALK,      0.000000000000000_REALK,     -1.190382067701017_REALK, &
     -3.978613725469468_REALK,      0.000000000000000_REALK,     -1.932365823469655_REALK, &
      0.000000000000000_REALK,    -10.218432113312311_REALK,      0.000000000000000_REALK, &
     -4.238764072085228_REALK,      0.000000000000000_REALK,     -3.577158369993311_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.224909244072971_REALK, &
      0.000000000000000_REALK,      0.945698264529739_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.755213839889800_REALK,      0.000000000000000_REALK, &
      1.359578188678634_REALK,      0.000000000000000_REALK,      0.771110418981206_REALK, &
      0.000000000000000_REALK,      0.778209495364563_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.121657036130949_REALK, &
      0.000000000000000_REALK,      0.531505595531693_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.498883470412966_REALK,      0.000000000000000_REALK, &
      0.707783998461234_REALK,      0.000000000000000_REALK,      0.755363773618577_REALK, &
      0.000000000000000_REALK,      0.440903839477691_REALK,      0.000000000000000_REALK, &
     -1.846388554634302_REALK,     -0.900565229920881_REALK,      0.000000000000000_REALK, &
     -0.694448938997787_REALK,      0.000000000000000_REALK,     -0.954888787730941_REALK, &
     -0.633764167814003_REALK,      0.000000000000000_REALK,     -0.550309567612472_REALK, &
      0.000000000000000_REALK,     -0.783234432415533_REALK,      0.000000000000000_REALK, &
     -0.571457914901280_REALK,      0.000000000000000_REALK,     -1.309620537368919_REALK, &
     -1.213056499723403_REALK,     -0.514336696379232_REALK,      0.000000000000000_REALK, &
     -0.277892621335567_REALK,      0.000000000000000_REALK,     -0.587503035491067_REALK, &
      0.010580696880476_REALK,      0.000000000000000_REALK,     -0.324554896721688_REALK, &
      0.000000000000000_REALK,      0.777252696434332_REALK,      0.000000000000000_REALK, &
     -0.230522359010736_REALK,      0.000000000000000_REALK,     -0.812259695948219_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.810909407797150_REALK, &
      0.000000000000000_REALK,      0.521973468687181_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.493697598209801_REALK,      0.000000000000000_REALK, &
      0.825872446087628_REALK,      0.000000000000000_REALK,      0.639365225465265_REALK, &
      0.000000000000000_REALK,      0.715881454822401_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.704318119372869_REALK, &
      0.000000000000000_REALK,      0.520863981563795_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.590688284649623_REALK,      0.000000000000000_REALK, &
      0.740727154350692_REALK,      0.000000000000000_REALK,      0.991469955571538_REALK, &
      0.000000000000000_REALK,      0.720127035499921_REALK,      0.000000000000000_REALK, &
     -0.831666784980918_REALK,     -0.596894654247215_REALK,      0.000000000000000_REALK, &
     -0.565116133972815_REALK,      0.000000000000000_REALK,     -0.716849193807068_REALK, &
     -0.636599876244743_REALK,      0.000000000000000_REALK,     -0.607908655911279_REALK, &
      0.000000000000000_REALK,     -0.921934371913069_REALK,      0.000000000000000_REALK, &
     -0.775051193980360_REALK,      0.000000000000000_REALK,     -1.376412220832213_REALK, &
     -0.943889455605698_REALK,     -0.568662350955983_REALK,      0.000000000000000_REALK, &
     -0.374025098106200_REALK,      0.000000000000000_REALK,     -0.761901747724037_REALK, &
     -0.066534969059863_REALK,      0.000000000000000_REALK,     -0.598058793922641_REALK, &
      0.000000000000000_REALK,      0.853825070858191_REALK,      0.000000000000000_REALK, &
     -0.517113094080966_REALK,      0.000000000000000_REALK,     -1.474727554393060_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.870015010644692_REALK, &
      0.000000000000000_REALK,      0.867658667840253_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.127508795460953_REALK,      0.000000000000000_REALK, &
      1.240496145798021_REALK,      0.000000000000000_REALK,      1.990232140314435_REALK, &
      0.000000000000000_REALK,      1.665979405771281_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.897916006968174_REALK, &
      0.000000000000000_REALK,      2.224799070277129_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.311276946435085_REALK,      0.000000000000000_REALK, &
      2.794437681094885_REALK,      0.000000000000000_REALK,      6.333124307186105_REALK, &
      0.000000000000000_REALK,      4.306293431832526_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.929068626894682_REALK, &
      0.000000000000000_REALK,      1.144800741712444_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.777378361533536_REALK,      0.000000000000000_REALK, &
      1.838099616984495_REALK,      0.000000000000000_REALK,      0.574153433732571_REALK, &
      0.000000000000000_REALK,      0.695723555260569_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.018280218609009_REALK, &
      0.000000000000000_REALK,      0.624342715608674_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.298804740997582_REALK,      0.000000000000000_REALK, &
      1.105056712101189_REALK,      0.000000000000000_REALK,     -0.091764704791971_REALK, &
      0.000000000000000_REALK,      0.380863199137705_REALK,      0.000000000000000_REALK, &
     -3.460911488134340_REALK,     -1.196147809358435_REALK,      0.000000000000000_REALK, &
     -0.760869133085338_REALK,      0.000000000000000_REALK,     -1.369759163752341_REALK, &
     -0.554478007177769_REALK,      0.000000000000000_REALK,     -0.559582699876705_REALK, &
      0.000000000000000_REALK,     -0.573404235463241_REALK,      0.000000000000000_REALK, &
     -0.462398877874875_REALK,      0.000000000000000_REALK,     -1.387393864762617_REALK, &
     -1.647566041353873_REALK,     -0.869578995420229_REALK,      0.000000000000000_REALK, &
     -0.715936063202437_REALK,      0.000000000000000_REALK,     -1.015724351493456_REALK, &
     -0.815688643776513_REALK,      0.000000000000000_REALK,     -0.476115306849514_REALK, &
      0.000000000000000_REALK,     -1.492491302181597_REALK,      0.000000000000000_REALK, &
     -0.436737215943176_REALK,      0.000000000000000_REALK,     -1.032691437679184_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.207772261476302_REALK, &
      0.000000000000000_REALK,      0.554430469254863_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.410915010406762_REALK,      0.000000000000000_REALK, &
      0.941701431915285_REALK,      0.000000000000000_REALK,      0.388038227791563_REALK, &
      0.000000000000000_REALK,      0.561568377739091_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.961194583281098_REALK, &
      0.000000000000000_REALK,      0.465761182385247_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.248932338230689_REALK,      0.000000000000000_REALK, &
      0.877128388893167_REALK,      0.000000000000000_REALK,     -0.009262652247213_REALK, &
      0.000000000000000_REALK,      0.473541452801996_REALK,      0.000000000000000_REALK, &
     -1.261393332225881_REALK,     -0.660207853319754_REALK,      0.000000000000000_REALK, &
     -0.497394570537820_REALK,      0.000000000000000_REALK,     -0.832056854500249_REALK, &
     -0.459744736095163_REALK,      0.000000000000000_REALK,     -0.514764828323661_REALK, &
      0.000000000000000_REALK,     -0.563457757529389_REALK,      0.000000000000000_REALK, &
     -0.503798181309469_REALK,      0.000000000000000_REALK,     -1.179876614708646_REALK, &
     -1.034550293369255_REALK,     -0.852168597370520_REALK,      0.000000000000000_REALK, &
     -0.847683016520444_REALK,      0.000000000000000_REALK,     -1.063000308176165_REALK, &
     -1.070650740279847_REALK,      0.000000000000000_REALK,     -0.777637828883148_REALK, &
      0.000000000000000_REALK,     -1.847818306867515_REALK,      0.000000000000000_REALK, &
     -0.861843069667080_REALK,      0.000000000000000_REALK,     -1.513059956518434_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.906692573068289_REALK, &
      0.000000000000000_REALK,      0.612460878743670_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.557311677965351_REALK,      0.000000000000000_REALK, &
      0.989728949934956_REALK,      0.000000000000000_REALK,      0.649624103979624_REALK, &
      0.000000000000000_REALK,      0.868484244009491_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.246522636759859_REALK, &
      0.000000000000000_REALK,      0.858260262923003_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.558410785798380_REALK,      0.000000000000000_REALK, &
      1.592502262876783_REALK,      0.000000000000000_REALK,      0.097077770907155_REALK, &
      0.000000000000000_REALK,      1.221635803970594_REALK,      0.000000000000000_REALK, &
     -1.353333828429534_REALK,     -1.097440963713791_REALK,      0.000000000000000_REALK, &
     -1.135951957492796_REALK,      0.000000000000000_REALK,     -1.249785394805225_REALK, &
     -1.431104967354345_REALK,      0.000000000000000_REALK,     -1.197946387667443_REALK, &
      0.000000000000000_REALK,     -2.312216509087607_REALK,      0.000000000000000_REALK, &
     -1.610807173607460_REALK,      0.000000000000000_REALK,     -2.278575929867013_REALK, &
     -2.787787943816408_REALK,     -3.639921304324416_REALK,      0.000000000000000_REALK, &
     -4.751936517843196_REALK,      0.000000000000000_REALK,     -4.010232511034143_REALK, &
     -6.838900351614185_REALK,      0.000000000000000_REALK,     -4.650202686168100_REALK, &
      0.000000000000000_REALK,    -11.646900390970844_REALK,      0.000000000000000_REALK, &
     -6.763840805843521_REALK,      0.000000000000000_REALK,     -7.338998014653585_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,    -22.083563537827498_REALK, &
      0.000000000000000_REALK,      8.119688892340157_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,    -21.271025808692766_REALK,      0.000000000000000_REALK, &
    -28.773108851374289_REALK,      0.000000000000000_REALK,     32.470356992459678_REALK, &
      0.000000000000000_REALK,     23.095217762972243_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,    -20.936592959726735_REALK, &
      0.000000000000000_REALK,     11.026883162838597_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,    -30.677010860410203_REALK,      0.000000000000000_REALK, &
    -30.438521209891359_REALK,      0.000000000000000_REALK,     51.391847814477003_REALK, &
      0.000000000000000_REALK,     30.690828781398903_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -9.936000676106527_REALK, &
      0.000000000000000_REALK,      2.320169275637030_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -5.416427298299214_REALK,      0.000000000000000_REALK, &
    -12.725734412898788_REALK,      0.000000000000000_REALK,      9.279806433273412_REALK, &
      0.000000000000000_REALK,     10.370173999791975_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -6.013565106022804_REALK, &
      0.000000000000000_REALK,      1.285726803470360_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.325777984391873_REALK,      0.000000000000000_REALK, &
     -9.259647631696508_REALK,      0.000000000000000_REALK,     -0.296952092296837_REALK, &
      0.000000000000000_REALK,      6.094502809944335_REALK,      0.000000000000000_REALK, &
     -3.352095957362327_REALK,      4.674486094886002_REALK,      0.000000000000000_REALK, &
     -3.239252309145873_REALK,      0.000000000000000_REALK,     -4.381704959900456_REALK, &
      8.417247881698263_REALK,      0.000000000000000_REALK,      5.986942885718248_REALK, &
      0.000000000000000_REALK,    -25.655212489961375_REALK,      0.000000000000000_REALK, &
    -14.478085899938341_REALK,      0.000000000000000_REALK,    -32.640608975569542_REALK, &
     -4.607128640603287_REALK,      6.825351044166152_REALK,      0.000000000000000_REALK, &
     -4.965793685233259_REALK,      0.000000000000000_REALK,     -4.927188541924844_REALK, &
     17.598394661859608_REALK,      0.000000000000000_REALK,     10.509630230545431_REALK, &
      0.000000000000000_REALK,    -49.917420499906370_REALK,      0.000000000000000_REALK, &
    -23.538471381767074_REALK,      0.000000000000000_REALK,    -38.925797109249253_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.869622203643763_REALK, &
      0.000000000000000_REALK,      0.871834150578941_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.701508863754932_REALK,      0.000000000000000_REALK, &
     -5.471247898975983_REALK,      0.000000000000000_REALK,      3.766768173389701_REALK, &
      0.000000000000000_REALK,      4.948739670737526_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.258597479211311_REALK, &
      0.000000000000000_REALK,      0.415445327941920_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.414721993150545_REALK,      0.000000000000000_REALK, &
     -4.130623885979106_REALK,      0.000000000000000_REALK,      4.052036936894686_REALK, &
      0.000000000000000_REALK,      3.353892501348439_REALK,      0.000000000000000_REALK, &
     -1.148020999821120_REALK,      1.189696275862302_REALK,      0.000000000000000_REALK, &
     -1.051211181698043_REALK,      0.000000000000000_REALK,     -2.469789323002519_REALK, &
      1.196134728826393_REALK,      0.000000000000000_REALK,      1.336679310534733_REALK, &
      0.000000000000000_REALK,     -6.001175072106776_REALK,      0.000000000000000_REALK, &
     -5.966926707031922_REALK,      0.000000000000000_REALK,    -23.365193928589690_REALK, &
     -0.153040366203850_REALK,      0.992281086206818_REALK,      0.000000000000000_REALK, &
     -0.341073065644605_REALK,      0.000000000000000_REALK,     -1.357918264652127_REALK, &
     -0.061286914356352_REALK,      0.000000000000000_REALK,      1.257823337322168_REALK, &
      0.000000000000000_REALK,      4.349616333566099_REALK,      0.000000000000000_REALK, &
     -2.753484803750851_REALK,      0.000000000000000_REALK,    -18.270803155666407_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.246774891581860_REALK, &
      0.000000000000000_REALK,      1.161935895942104_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.866174847112540_REALK,      0.000000000000000_REALK, &
     -4.207260813731124_REALK,      0.000000000000000_REALK,      9.272736144872502_REALK, &
      0.000000000000000_REALK,     10.992377887629724_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.802639864962327_REALK, &
      0.000000000000000_REALK,      1.541226989669269_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -4.858023624267888_REALK,      0.000000000000000_REALK, &
     -8.033760514145811_REALK,      0.000000000000000_REALK,     20.834711050251290_REALK, &
      0.000000000000000_REALK,     20.737223792818956_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.674919372124917_REALK, &
      0.000000000000000_REALK,      0.286934942161196_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.220294028380480_REALK,      0.000000000000000_REALK, &
     -0.864169663900150_REALK,      0.000000000000000_REALK,      0.743391161369511_REALK, &
      0.000000000000000_REALK,      1.534716196019512_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.305518212296026_REALK, &
      0.000000000000000_REALK,      0.062570713408861_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.180325782376376_REALK,      0.000000000000000_REALK, &
     -1.069115747444003_REALK,      0.000000000000000_REALK,     -1.132596185217770_REALK, &
      0.000000000000000_REALK,      0.506689972610292_REALK,      0.000000000000000_REALK, &
     -0.909651749013888_REALK,      0.208622133556194_REALK,      0.000000000000000_REALK, &
     -0.695785283497133_REALK,      0.000000000000000_REALK,     -2.237316449866224_REALK, &
      0.081929400598177_REALK,      0.000000000000000_REALK,      0.107637968751097_REALK, &
      0.000000000000000_REALK,     -3.257427028716733_REALK,      0.000000000000000_REALK, &
     -3.721515879147208_REALK,      0.000000000000000_REALK,    -19.944392071180108_REALK, &
     -0.262630359945389_REALK,      0.262151938161305_REALK,      0.000000000000000_REALK, &
     -0.378558742595671_REALK,      0.000000000000000_REALK,     -1.105294037968277_REALK, &
      0.259369629553826_REALK,      0.000000000000000_REALK,      0.214681620425887_REALK, &
      0.000000000000000_REALK,     -5.448398249575587_REALK,      0.000000000000000_REALK, &
     -3.065522326137078_REALK,      0.000000000000000_REALK,    -14.917559544855617_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.590998549043921_REALK, &
      0.000000000000000_REALK,      0.546598265126120_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.129784129528856_REALK,      0.000000000000000_REALK, &
     -0.508206570012206_REALK,      0.000000000000000_REALK,      2.616168790977279_REALK, &
      0.000000000000000_REALK,      4.872609820463274_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.856865828066210_REALK, &
      0.000000000000000_REALK,      0.336574976065634_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.176249709628328_REALK,      0.000000000000000_REALK, &
     -1.169508452153390_REALK,      0.000000000000000_REALK,     -0.132800935568305_REALK, &
      0.000000000000000_REALK,      4.542571545936044_REALK,      0.000000000000000_REALK, &
     -0.419700466339799_REALK,      0.278040892876243_REALK,      0.000000000000000_REALK, &
     -0.763120911511416_REALK,      0.000000000000000_REALK,     -1.720443672311021_REALK, &
      0.201687409281362_REALK,      0.000000000000000_REALK,      0.239090618277077_REALK, &
      0.000000000000000_REALK,     -7.232733433045511_REALK,      0.000000000000000_REALK, &
     -6.802784942563700_REALK,      0.000000000000000_REALK,    -21.471475076583406_REALK, &
     -0.306478073112442_REALK,      0.972536252820246_REALK,      0.000000000000000_REALK, &
     -1.299935481039220_REALK,      0.000000000000000_REALK,     -2.149715840479029_REALK, &
      1.333623402531467_REALK,      0.000000000000000_REALK,      1.327383273371683_REALK, &
      0.000000000000000_REALK,    -22.323736102581631_REALK,      0.000000000000000_REALK, &
    -17.544530483959463_REALK,      0.000000000000000_REALK,    -40.618982944427955_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.763703958351070_REALK, &
      0.000000000000000_REALK,     -0.327410452864831_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.829768751079361_REALK,      0.000000000000000_REALK, &
      3.369485371585827_REALK,      0.000000000000000_REALK,     -1.312041711951015_REALK, &
      0.000000000000000_REALK,     -1.289808849414091_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.272909529037981_REALK, &
      0.000000000000000_REALK,     -0.161285180883176_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.397968222047669_REALK,      0.000000000000000_REALK, &
      1.664124960237251_REALK,      0.000000000000000_REALK,      0.023744279173582_REALK, &
      0.000000000000000_REALK,     -0.865265348417237_REALK,      0.000000000000000_REALK, &
     -1.892526785757177_REALK,     -0.066563250219611_REALK,      0.000000000000000_REALK, &
     -0.753988102291255_REALK,      0.000000000000000_REALK,     -2.957745381170226_REALK, &
     -0.061597306582122_REALK,      0.000000000000000_REALK,     -0.127166408420309_REALK, &
      0.000000000000000_REALK,     -2.126033878549021_REALK,      0.000000000000000_REALK, &
     -2.970279409770972_REALK,      0.000000000000000_REALK,    -19.419692384928080_REALK, &
     -0.565499535964382_REALK,     -0.008000979781076_REALK,      0.000000000000000_REALK, &
     -0.270170723979865_REALK,      0.000000000000000_REALK,     -1.601788561229395_REALK, &
      0.109054399934836_REALK,      0.000000000000000_REALK,     -0.048787707072658_REALK, &
      0.000000000000000_REALK,      1.329487718929119_REALK,      0.000000000000000_REALK, &
     -1.449416272074629_REALK,      0.000000000000000_REALK,    -14.322168657338322_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.519013312046306_REALK, &
      0.000000000000000_REALK,      0.368406481055191_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.308364379979659_REALK,      0.000000000000000_REALK, &
      1.652590045245217_REALK,      0.000000000000000_REALK,      1.104674572618634_REALK, &
      0.000000000000000_REALK,      2.418849364198837_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.141335055461835_REALK, &
      0.000000000000000_REALK,      0.321643904999526_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.295170248785045_REALK,      0.000000000000000_REALK, &
      1.436368518532156_REALK,      0.000000000000000_REALK,      2.084752144719010_REALK, &
      0.000000000000000_REALK,      2.875934044298870_REALK,      0.000000000000000_REALK, &
     -0.667781747004494_REALK,     -0.126800022392378_REALK,      0.000000000000000_REALK, &
     -0.444204912182066_REALK,      0.000000000000000_REALK,     -1.739410324067620_REALK, &
     -0.216775446713049_REALK,      0.000000000000000_REALK,     -0.403743892264209_REALK, &
      0.000000000000000_REALK,     -1.759955803710486_REALK,      0.000000000000000_REALK, &
     -2.916519726602271_REALK,      0.000000000000000_REALK,    -15.988644288128485_REALK, &
     -0.371160833752739_REALK,     -0.043038179231242_REALK,      0.000000000000000_REALK, &
     -0.264063801770392_REALK,      0.000000000000000_REALK,     -1.752200606341281_REALK, &
      0.012787016703929_REALK,      0.000000000000000_REALK,     -0.437391031833527_REALK, &
      0.000000000000000_REALK,      2.237855212409787_REALK,      0.000000000000000_REALK, &
     -2.361089594965515_REALK,      0.000000000000000_REALK,    -21.933879725516970_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.399109016790470_REALK, &
      0.000000000000000_REALK,      0.818322143707961_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.563677982056418_REALK,      0.000000000000000_REALK, &
      1.779123968364355_REALK,      0.000000000000000_REALK,      4.532336194816589_REALK, &
      0.000000000000000_REALK,      7.522009894852570_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.274886317219064_REALK, &
      0.000000000000000_REALK,      1.988734474014802_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.689311926914853_REALK,      0.000000000000000_REALK, &
      3.911083993379532_REALK,      0.000000000000000_REALK,     17.865585968678747_REALK, &
      0.000000000000000_REALK,     24.894788074587506_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.100166479442597_REALK, &
      0.000000000000000_REALK,     -1.813314047293088_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.449883038994490_REALK,      0.000000000000000_REALK, &
      9.142583537607457_REALK,      0.000000000000000_REALK,     -3.896974810612431_REALK, &
      0.000000000000000_REALK,     -4.670035337639276_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.255245487759491_REALK, &
      0.000000000000000_REALK,     -1.306365845811305_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.477929003281689_REALK,      0.000000000000000_REALK, &
      6.480704869920711_REALK,      0.000000000000000_REALK,     -3.519700368448997_REALK, &
      0.000000000000000_REALK,     -3.710172924187484_REALK,      0.000000000000000_REALK, &
     -5.185351535341269_REALK,      0.228031990956170_REALK,      0.000000000000000_REALK, &
     -1.236513261524956_REALK,      0.000000000000000_REALK,     -5.021174081405887_REALK, &
      0.261814117857074_REALK,      0.000000000000000_REALK,      0.257377614627396_REALK, &
      0.000000000000000_REALK,     -2.385867613233646_REALK,      0.000000000000000_REALK, &
     -3.184534215350834_REALK,      0.000000000000000_REALK,    -21.552674444900703_REALK, &
     -2.275866249193374_REALK,      0.177097213862368_REALK,      0.000000000000000_REALK, &
     -0.911383765954853_REALK,      0.000000000000000_REALK,     -3.810998942269392_REALK, &
     -0.007401487862641_REALK,      0.000000000000000_REALK,      0.269717641350827_REALK, &
      0.000000000000000_REALK,     -3.550483755627925_REALK,      0.000000000000000_REALK, &
     -2.588395419883118_REALK,      0.000000000000000_REALK,    -18.039184984118883_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.059984835878491_REALK, &
      0.000000000000000_REALK,      0.189502135658482_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.592710640503822_REALK,      0.000000000000000_REALK, &
      3.875143285845095_REALK,      0.000000000000000_REALK,      0.236401684359723_REALK, &
      0.000000000000000_REALK,      0.813410921478570_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.758824275342511_REALK, &
      0.000000000000000_REALK,      0.111728328396168_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.451807227637836_REALK,      0.000000000000000_REALK, &
      4.464458858028023_REALK,      0.000000000000000_REALK,     -0.709292585867876_REALK, &
      0.000000000000000_REALK,      0.528860809051986_REALK,      0.000000000000000_REALK, &
     -1.525917352364510_REALK,     -0.256584548908259_REALK,      0.000000000000000_REALK, &
     -0.459521577223509_REALK,      0.000000000000000_REALK,     -2.462673490839134_REALK, &
     -0.220434606701045_REALK,      0.000000000000000_REALK,     -0.482674374410824_REALK, &
      0.000000000000000_REALK,     -1.035876233514639_REALK,      0.000000000000000_REALK, &
     -1.972430908336994_REALK,      0.000000000000000_REALK,    -14.798945189367862_REALK, &
     -1.178631188465017_REALK,     -0.353177143239763_REALK,      0.000000000000000_REALK, &
     -0.675966969300687_REALK,      0.000000000000000_REALK,     -3.289415780443964_REALK, &
     -0.649852016266746_REALK,      0.000000000000000_REALK,     -0.896476610935301_REALK, &
      0.000000000000000_REALK,     -3.412079727724343_REALK,      0.000000000000000_REALK, &
     -3.199657986550904_REALK,      0.000000000000000_REALK,    -21.798413726371351_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.211449407971730_REALK, &
      0.000000000000000_REALK,      0.601655191756733_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.581983051665080_REALK,      0.000000000000000_REALK, &
      3.190487590369526_REALK,      0.000000000000000_REALK,      1.386588785947268_REALK, &
      0.000000000000000_REALK,      3.615526881183341_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.923982375887102_REALK, &
      0.000000000000000_REALK,      1.001665619772955_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.735991008696902_REALK,      0.000000000000000_REALK, &
      6.837156158004901_REALK,      0.000000000000000_REALK,     -0.138611802135529_REALK, &
      0.000000000000000_REALK,      6.637872209741166_REALK,      0.000000000000000_REALK, &
     -1.173394516230406_REALK,     -0.569937905282105_REALK,      0.000000000000000_REALK, &
     -0.839987405088150_REALK,      0.000000000000000_REALK,     -2.651233103099862_REALK, &
     -0.904414540992806_REALK,      0.000000000000000_REALK,     -1.500995255863125_REALK, &
      0.000000000000000_REALK,     -3.833402150730684_REALK,      0.000000000000000_REALK, &
     -5.047736784393265_REALK,      0.000000000000000_REALK,    -20.484072736785315_REALK, &
     -2.292351219575286_REALK,     -2.183705486960850_REALK,      0.000000000000000_REALK, &
     -3.868679408376714_REALK,      0.000000000000000_REALK,     -8.956741421492261_REALK, &
     -5.569001136630370_REALK,      0.000000000000000_REALK,     -7.760120677071925_REALK, &
      0.000000000000000_REALK,    -23.300538345870805_REALK,      0.000000000000000_REALK, &
    -25.637097876118055_REALK,      0.000000000000000_REALK,    -76.313368764623405_REALK/
    ! results of test 7, ket-major order, 01ODGXYZ
  data REF_CONTR_INTS(46621:47880)                                                         &
     /0.000000000000000_REALK,      0.000000000000000_REALK,      0.005541928322510_REALK, &
      0.000000000000000_REALK,      0.207427355377053_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.302978969027785_REALK,      0.000000000000000_REALK, &
      0.449177137115944_REALK,      0.000000000000000_REALK,      0.302521907671317_REALK, &
      0.000000000000000_REALK,      0.843789821419073_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.083713027299292_REALK, &
      0.000000000000000_REALK,      0.024298949635324_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.243444824127602_REALK,      0.000000000000000_REALK, &
      0.038962630013332_REALK,      0.000000000000000_REALK,     -3.064221652304192_REALK, &
      0.000000000000000_REALK,     -0.218974350296479_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.234312090868370_REALK, &
      0.000000000000000_REALK,      0.298295970659624_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.417980067346861_REALK,      0.000000000000000_REALK, &
      0.505174418829579_REALK,      0.000000000000000_REALK,      0.877765479927090_REALK, &
      0.000000000000000_REALK,      0.672514125343257_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.221620739174165_REALK, &
      0.000000000000000_REALK,      0.001935200213495_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.232249615087772_REALK,      0.000000000000000_REALK, &
      0.143514773204116_REALK,      0.000000000000000_REALK,      1.231938437172158_REALK, &
      0.000000000000000_REALK,      0.362456606780108_REALK,      0.000000000000000_REALK, &
      0.004038773482914_REALK,     -0.113360463230933_REALK,      0.000000000000000_REALK, &
     -0.158536791102948_REALK,      0.000000000000000_REALK,     -0.235036452146090_REALK, &
     -0.087625560935637_REALK,      0.000000000000000_REALK,     -0.244403973856856_REALK, &
      0.000000000000000_REALK,      0.508504163603836_REALK,      0.000000000000000_REALK, &
     -0.357424309713470_REALK,      0.000000000000000_REALK,     -0.883157163723882_REALK, &
      0.191300317759439_REALK,     -0.086127759103047_REALK,      0.000000000000000_REALK, &
      0.003492011620761_REALK,      0.000000000000000_REALK,     -0.000558886216906_REALK, &
      0.780470133317752_REALK,      0.000000000000000_REALK,      0.055773687337712_REALK, &
      0.000000000000000_REALK,      5.312247433457771_REALK,      0.000000000000000_REALK, &
      0.654042240214506_REALK,      0.000000000000000_REALK,     -0.174462570111378_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.497151537472393_REALK, &
      0.000000000000000_REALK,      0.336797659745175_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.345261776961332_REALK,      0.000000000000000_REALK, &
      0.569030020289546_REALK,      0.000000000000000_REALK,      0.459280193153581_REALK, &
      0.000000000000000_REALK,      0.485661052887527_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.024669042441651_REALK, &
      0.000000000000000_REALK,      0.049779397013078_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.007823622737264_REALK,      0.000000000000000_REALK, &
      0.171100489626661_REALK,      0.000000000000000_REALK,     -0.382540826408328_REALK, &
      0.000000000000000_REALK,      0.125707990270025_REALK,      0.000000000000000_REALK, &
     -0.246846241834907_REALK,     -0.229577692250412_REALK,      0.000000000000000_REALK, &
     -0.263946498106612_REALK,      0.000000000000000_REALK,     -0.319008080049087_REALK, &
     -0.342967655656245_REALK,      0.000000000000000_REALK,     -0.262770179779507_REALK, &
      0.000000000000000_REALK,     -0.671376751628577_REALK,      0.000000000000000_REALK, &
     -0.380609931415264_REALK,      0.000000000000000_REALK,     -0.766680901491859_REALK, &
      0.090318016710343_REALK,     -0.023054460175557_REALK,      0.000000000000000_REALK, &
     -0.161553862137261_REALK,      0.000000000000000_REALK,     -0.099829512639303_REALK, &
     -0.543484175109906_REALK,      0.000000000000000_REALK,     -0.159902008091573_REALK, &
      0.000000000000000_REALK,     -2.196443945663424_REALK,      0.000000000000000_REALK, &
     -0.407972224418477_REALK,      0.000000000000000_REALK,     -0.420166044472374_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.180891234162846_REALK, &
      0.000000000000000_REALK,      0.154336481718694_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.139655728529177_REALK,      0.000000000000000_REALK, &
      0.345074338129084_REALK,      0.000000000000000_REALK,      0.079791266003745_REALK, &
      0.000000000000000_REALK,      0.370921115599839_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.006658132807382_REALK, &
      0.000000000000000_REALK,     -0.038796424233634_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.288538450205318_REALK,      0.000000000000000_REALK, &
      0.076966220992491_REALK,      0.000000000000000_REALK,     -1.370982407275442_REALK, &
      0.000000000000000_REALK,     -0.163287786136105_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.928589738863381_REALK, &
      0.000000000000000_REALK,      0.409082119881048_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.348435188623591_REALK,      0.000000000000000_REALK, &
      0.713484463421306_REALK,      0.000000000000000_REALK,      0.366831257574265_REALK, &
      0.000000000000000_REALK,      0.405116799836035_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.114145260001671_REALK, &
      0.000000000000000_REALK,      0.140195698773809_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.220614784316170_REALK,      0.000000000000000_REALK, &
      0.275651653524743_REALK,      0.000000000000000_REALK,      0.520350077923325_REALK, &
      0.000000000000000_REALK,      0.210004276533018_REALK,      0.000000000000000_REALK, &
     -0.613303780279207_REALK,     -0.324386975264826_REALK,      0.000000000000000_REALK, &
     -0.265029193409677_REALK,      0.000000000000000_REALK,     -0.436797749900130_REALK, &
     -0.235704833134283_REALK,      0.000000000000000_REALK,     -0.249243618899968_REALK, &
      0.000000000000000_REALK,     -0.264483309976771_REALK,      0.000000000000000_REALK, &
     -0.262460209036939_REALK,      0.000000000000000_REALK,     -0.720939627258604_REALK, &
      0.103466207613139_REALK,     -0.032219706884756_REALK,      0.000000000000000_REALK, &
      0.006344650802433_REALK,      0.000000000000000_REALK,     -0.138755777887383_REALK, &
      0.236776836585412_REALK,      0.000000000000000_REALK,     -0.077808009537458_REALK, &
      0.000000000000000_REALK,      1.130490971110408_REALK,      0.000000000000000_REALK, &
      0.009503885021246_REALK,      0.000000000000000_REALK,     -0.346412277086917_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.307252925244369_REALK, &
      0.000000000000000_REALK,      0.201707149317250_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.195330871461044_REALK,      0.000000000000000_REALK, &
      0.393464374573958_REALK,      0.000000000000000_REALK,      0.260716269807440_REALK, &
      0.000000000000000_REALK,      0.332919931655835_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.064614636349280_REALK, &
      0.000000000000000_REALK,      0.129674249132269_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.252517812593971_REALK,      0.000000000000000_REALK, &
      0.260065279266643_REALK,      0.000000000000000_REALK,      0.660207078558322_REALK, &
      0.000000000000000_REALK,      0.323739685693695_REALK,      0.000000000000000_REALK, &
     -0.223153846200477_REALK,     -0.148649324094537_REALK,      0.000000000000000_REALK, &
     -0.107202266676840_REALK,      0.000000000000000_REALK,     -0.264885311967133_REALK, &
     -0.040949266524753_REALK,      0.000000000000000_REALK,     -0.190358523972329_REALK, &
      0.000000000000000_REALK,      0.151037277892674_REALK,      0.000000000000000_REALK, &
     -0.176938553820274_REALK,      0.000000000000000_REALK,     -0.612074685291619_REALK, &
      0.027925354338087_REALK,      0.025110979481249_REALK,      0.000000000000000_REALK, &
      0.233993352070573_REALK,      0.000000000000000_REALK,     -0.062416582723801_REALK, &
      0.848581001031332_REALK,      0.000000000000000_REALK,      0.101068337770237_REALK, &
      0.000000000000000_REALK,      2.846881997344471_REALK,      0.000000000000000_REALK, &
      0.584178699785435_REALK,      0.000000000000000_REALK,     -0.218157537148747_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.852819336187525_REALK, &
      0.000000000000000_REALK,      0.530227658790960_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.381297838772569_REALK,      0.000000000000000_REALK, &
      1.013718304557737_REALK,      0.000000000000000_REALK,      0.275520737139172_REALK, &
      0.000000000000000_REALK,      0.371019682713378_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.691502246693437_REALK, &
      0.000000000000000_REALK,      0.195306010102731_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.047004604846493_REALK,      0.000000000000000_REALK, &
      0.488476502976871_REALK,      0.000000000000000_REALK,     -0.259130798616218_REALK, &
      0.000000000000000_REALK,      0.151435154866496_REALK,      0.000000000000000_REALK, &
     -1.436892564285792_REALK,     -0.498448819778176_REALK,      0.000000000000000_REALK, &
     -0.333962344021823_REALK,      0.000000000000000_REALK,     -0.683848680061816_REALK, &
     -0.246939672293026_REALK,      0.000000000000000_REALK,     -0.272712337692916_REALK, &
      0.000000000000000_REALK,     -0.272036962675491_REALK,      0.000000000000000_REALK, &
     -0.233685664757150_REALK,      0.000000000000000_REALK,     -0.797523215087897_REALK, &
     -0.473500891609424_REALK,     -0.290255970877706_REALK,      0.000000000000000_REALK, &
     -0.315628816782777_REALK,      0.000000000000000_REALK,     -0.394368879292982_REALK, &
     -0.508040962213393_REALK,      0.000000000000000_REALK,     -0.205036530684411_REALK, &
      0.000000000000000_REALK,     -1.240752361413594_REALK,      0.000000000000000_REALK, &
     -0.244730301564643_REALK,      0.000000000000000_REALK,     -0.509638799465222_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.532219112834340_REALK, &
      0.000000000000000_REALK,      0.238890863833607_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.176680249219001_REALK,      0.000000000000000_REALK, &
      0.485314682493365_REALK,      0.000000000000000_REALK,      0.158080591214227_REALK, &
      0.000000000000000_REALK,      0.278601122345489_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.287274812122252_REALK, &
      0.000000000000000_REALK,      0.111318242168827_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.009279066335935_REALK,      0.000000000000000_REALK, &
      0.338217738481252_REALK,      0.000000000000000_REALK,     -0.262659036205050_REALK, &
      0.000000000000000_REALK,      0.143855406134501_REALK,      0.000000000000000_REALK, &
     -0.475440794961925_REALK,     -0.245771412711068_REALK,      0.000000000000000_REALK, &
     -0.187217473501008_REALK,      0.000000000000000_REALK,     -0.377121166610275_REALK, &
     -0.175506282243888_REALK,      0.000000000000000_REALK,     -0.224111596614051_REALK, &
      0.000000000000000_REALK,     -0.231082540477514_REALK,      0.000000000000000_REALK, &
     -0.218338187585096_REALK,      0.000000000000000_REALK,     -0.615732766119769_REALK, &
     -0.268036429387911_REALK,     -0.268472752081007_REALK,      0.000000000000000_REALK, &
     -0.361271791700899_REALK,      0.000000000000000_REALK,     -0.372069789591145_REALK, &
     -0.644589582439319_REALK,      0.000000000000000_REALK,     -0.316081477460106_REALK, &
      0.000000000000000_REALK,     -1.508115761820848_REALK,      0.000000000000000_REALK, &
     -0.466867777531483_REALK,      0.000000000000000_REALK,     -0.673150684998883_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.322751263645996_REALK, &
      0.000000000000000_REALK,      0.182451660871170_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.119109665804678_REALK,      0.000000000000000_REALK, &
      0.412030106715130_REALK,      0.000000000000000_REALK,      0.045772532365611_REALK, &
      0.000000000000000_REALK,      0.297892231404364_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.129224976057183_REALK, &
      0.000000000000000_REALK,     -0.144596292417578_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.570359689246157_REALK,      0.000000000000000_REALK, &
      0.212996922244115_REALK,      0.000000000000000_REALK,     -1.568899722111715_REALK, &
      0.000000000000000_REALK,     -0.261604397917256_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.324746586419036_REALK, &
      0.000000000000000_REALK,      0.774178946156914_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.516796682842852_REALK,      0.000000000000000_REALK, &
      1.701718329455722_REALK,      0.000000000000000_REALK,      0.261595390663872_REALK, &
      0.000000000000000_REALK,      0.382879863637619_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.939592231840449_REALK, &
      0.000000000000000_REALK,      0.741291543834205_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.577135593731017_REALK,      0.000000000000000_REALK, &
      1.306789868567422_REALK,      0.000000000000000_REALK,      0.683223008887936_REALK, &
      0.000000000000000_REALK,      0.312161778359704_REALK,      0.000000000000000_REALK, &
     -3.785662668244539_REALK,     -0.854960002007707_REALK,      0.000000000000000_REALK, &
     -0.479094955069294_REALK,      0.000000000000000_REALK,     -1.273721684703002_REALK, &
     -0.249821695544359_REALK,      0.000000000000000_REALK,     -0.336413030751173_REALK, &
      0.000000000000000_REALK,     -0.198687156673778_REALK,      0.000000000000000_REALK, &
     -0.236942391648588_REALK,      0.000000000000000_REALK,     -1.049891603167154_REALK, &
     -4.619743483143154_REALK,     -0.752908122516006_REALK,      0.000000000000000_REALK, &
     -0.117538465985884_REALK,      0.000000000000000_REALK,     -1.221471364721706_REALK, &
      0.427355006605341_REALK,      0.000000000000000_REALK,     -0.249744808235241_REALK, &
      0.000000000000000_REALK,      1.302079882662757_REALK,      0.000000000000000_REALK, &
     -0.049496067873710_REALK,      0.000000000000000_REALK,     -0.857280055327015_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.102664599224762_REALK, &
      0.000000000000000_REALK,      0.342658918798019_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.211888765978994_REALK,      0.000000000000000_REALK, &
      0.723134686332545_REALK,      0.000000000000000_REALK,      0.153450847595619_REALK, &
      0.000000000000000_REALK,      0.282443744121590_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.520299003246433_REALK, &
      0.000000000000000_REALK,      0.512708900892108_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.403605901730662_REALK,      0.000000000000000_REALK, &
      0.840489411813848_REALK,      0.000000000000000_REALK,      0.534969499913051_REALK, &
      0.000000000000000_REALK,      0.359840703284584_REALK,      0.000000000000000_REALK, &
     -1.087424978481155_REALK,     -0.385197056465371_REALK,      0.000000000000000_REALK, &
     -0.221996055193216_REALK,      0.000000000000000_REALK,     -0.609790542616510_REALK, &
     -0.143335713093148_REALK,      0.000000000000000_REALK,     -0.252614759555301_REALK, &
      0.000000000000000_REALK,     -0.110637213304032_REALK,      0.000000000000000_REALK, &
     -0.182984867952480_REALK,      0.000000000000000_REALK,     -0.703685561219236_REALK, &
     -1.919206983807972_REALK,     -0.429133791986372_REALK,      0.000000000000000_REALK, &
      0.023202986738615_REALK,      0.000000000000000_REALK,     -0.845738290538295_REALK, &
      0.433173728293894_REALK,      0.000000000000000_REALK,     -0.237244389193095_REALK, &
      0.000000000000000_REALK,      1.162252520235560_REALK,      0.000000000000000_REALK, &
      0.016284833463586_REALK,      0.000000000000000_REALK,     -0.831004659808826_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.608085051801086_REALK, &
      0.000000000000000_REALK,      0.281592824276036_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.197972816097101_REALK,      0.000000000000000_REALK, &
      0.558300639115084_REALK,      0.000000000000000_REALK,      0.181769009400824_REALK, &
      0.000000000000000_REALK,      0.324952243004215_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.434335618134041_REALK, &
      0.000000000000000_REALK,      0.790384944380283_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.769952021204091_REALK,      0.000000000000000_REALK, &
      1.110151000847039_REALK,      0.000000000000000_REALK,      1.131259721868263_REALK, &
      0.000000000000000_REALK,      0.776615625863062_REALK,      0.000000000000000_REALK, &
     -0.659442281311413_REALK,     -0.294192258284706_REALK,      0.000000000000000_REALK, &
     -0.149659489733033_REALK,      0.000000000000000_REALK,     -0.517709583928759_REALK, &
     -0.041503125186399_REALK,      0.000000000000000_REALK,     -0.270106501280662_REALK, &
      0.000000000000000_REALK,      0.105301814901791_REALK,      0.000000000000000_REALK, &
     -0.172703928094214_REALK,      0.000000000000000_REALK,     -0.768119215392699_REALK, &
     -0.863317861733807_REALK,      0.557421264146606_REALK,      0.000000000000000_REALK, &
      1.426226284703686_REALK,      0.000000000000000_REALK,     -0.532614444521933_REALK, &
      2.587408191872899_REALK,      0.000000000000000_REALK,      0.431434433100682_REALK, &
      0.000000000000000_REALK,      4.878110279490394_REALK,      0.000000000000000_REALK, &
      1.401379956175611_REALK,      0.000000000000000_REALK,     -0.672860254099504_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -7.693166739029803_REALK, &
      0.000000000000000_REALK,      0.503585268652498_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.954388833934078_REALK,      0.000000000000000_REALK, &
    -10.016208874412106_REALK,      0.000000000000000_REALK,      1.173106859376854_REALK, &
      0.000000000000000_REALK,      2.763166853599521_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.658040839738441_REALK, &
      0.000000000000000_REALK,      0.016588405137595_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.827918006270719_REALK,      0.000000000000000_REALK, &
     -5.845814808107779_REALK,      0.000000000000000_REALK,     -5.104050808139378_REALK, &
      0.000000000000000_REALK,      0.083846117819581_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.805002034646137_REALK, &
      0.000000000000000_REALK,      0.148567425271635_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.527774007871992_REALK,      0.000000000000000_REALK, &
     -5.596031356873651_REALK,      0.000000000000000_REALK,      1.099659504974764_REALK, &
      0.000000000000000_REALK,      1.677288853276486_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.126300799848195_REALK, &
      0.000000000000000_REALK,     -0.000628292673320_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.522722874211528_REALK,      0.000000000000000_REALK, &
     -4.063488375708856_REALK,      0.000000000000000_REALK,      2.304118308372527_REALK, &
      0.000000000000000_REALK,      1.195008284110675_REALK,      0.000000000000000_REALK, &
      0.242998210091841_REALK,      0.813887196565432_REALK,      0.000000000000000_REALK, &
     -0.156807341716384_REALK,      0.000000000000000_REALK,     -0.531620980160955_REALK, &
      0.402421563131919_REALK,      0.000000000000000_REALK,      0.947874369271431_REALK, &
      0.000000000000000_REALK,     -0.364026350950560_REALK,      0.000000000000000_REALK, &
     -1.770315436859252_REALK,      0.000000000000000_REALK,    -10.003111859386138_REALK, &
      0.637726069642297_REALK,      0.035486097856198_REALK,      0.000000000000000_REALK, &
     -0.000578716846659_REALK,      0.000000000000000_REALK,      0.001850778590886_REALK, &
     -2.807750645034217_REALK,      0.000000000000000_REALK,      0.046123951394865_REALK, &
      0.000000000000000_REALK,      8.044105392226928_REALK,      0.000000000000000_REALK, &
      1.100715407451172_REALK,      0.000000000000000_REALK,     -5.866946626632468_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.961718981739212_REALK, &
      0.000000000000000_REALK,      0.028194512123243_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.607934232156518_REALK,      0.000000000000000_REALK, &
     -2.547394360956297_REALK,      0.000000000000000_REALK,     -0.037963104974717_REALK, &
      0.000000000000000_REALK,      0.323288030581550_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.829949850415956_REALK, &
      0.000000000000000_REALK,      0.003069119905751_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.237526517997903_REALK,      0.000000000000000_REALK, &
     -2.088571401817701_REALK,      0.000000000000000_REALK,     -1.212074607747228_REALK, &
      0.000000000000000_REALK,     -0.126173652477292_REALK,      0.000000000000000_REALK, &
      0.510879856109798_REALK,      0.265983425693002_REALK,      0.000000000000000_REALK, &
     -0.143108835722659_REALK,      0.000000000000000_REALK,     -0.524188478154016_REALK, &
      0.149988264892450_REALK,      0.000000000000000_REALK,      0.228774128435476_REALK, &
      0.000000000000000_REALK,     -1.325741883041540_REALK,      0.000000000000000_REALK, &
     -1.640935422374525_REALK,      0.000000000000000_REALK,    -10.017544077088340_REALK, &
      0.352103248741190_REALK,      0.307475462193812_REALK,      0.000000000000000_REALK, &
      0.036621783708158_REALK,      0.000000000000000_REALK,      0.097727692225598_REALK, &
      0.676635003494591_REALK,      0.000000000000000_REALK,      0.350930085298624_REALK, &
      0.000000000000000_REALK,     -3.871670682758937_REALK,      0.000000000000000_REALK, &
     -1.505546981736640_REALK,      0.000000000000000_REALK,     -6.696088919592147_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.951772363389541_REALK, &
      0.000000000000000_REALK,      0.088788784662417_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.241462506790166_REALK,      0.000000000000000_REALK, &
     -1.364376322422505_REALK,      0.000000000000000_REALK,      0.432228715940964_REALK, &
      0.000000000000000_REALK,      1.696804872627388_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.905738721484799_REALK, &
      0.000000000000000_REALK,     -0.001109290075269_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.323239727257468_REALK,      0.000000000000000_REALK, &
     -1.722906951778020_REALK,      0.000000000000000_REALK,     -2.776079995047839_REALK, &
      0.000000000000000_REALK,      0.076006143319922_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.152422033905003_REALK, &
      0.000000000000000_REALK,     -0.173838514502146_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.055054159460071_REALK,      0.000000000000000_REALK, &
      0.225639520096255_REALK,      0.000000000000000_REALK,     -1.050199511517196_REALK, &
      0.000000000000000_REALK,     -1.157767901197611_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.941916983748251_REALK, &
      0.000000000000000_REALK,      0.011871351467637_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.180374023928239_REALK,      0.000000000000000_REALK, &
     -0.700711653393592_REALK,      0.000000000000000_REALK,      0.181568365496688_REALK, &
      0.000000000000000_REALK,     -0.625910180100806_REALK,      0.000000000000000_REALK, &
      0.212493645081164_REALK,      0.017289734287767_REALK,      0.000000000000000_REALK, &
     -0.230439373242680_REALK,      0.000000000000000_REALK,     -0.965597804648008_REALK, &
      0.000397524622077_REALK,      0.000000000000000_REALK,     -0.003385259247486_REALK, &
      0.000000000000000_REALK,     -1.005933476515746_REALK,      0.000000000000000_REALK, &
     -1.534730725676884_REALK,      0.000000000000000_REALK,    -10.718167057608925_REALK, &
      1.478074490052295_REALK,     -0.029394406534367_REALK,      0.000000000000000_REALK, &
      0.008976167598000_REALK,      0.000000000000000_REALK,      0.078927469240600_REALK, &
     -0.101890584688894_REALK,      0.000000000000000_REALK,     -0.010606531265545_REALK, &
      0.000000000000000_REALK,      1.647955631147028_REALK,      0.000000000000000_REALK, &
     -0.473263275305754_REALK,      0.000000000000000_REALK,     -6.935675720657171_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.321448353650376_REALK, &
      0.000000000000000_REALK,      0.086717549337209_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.017182794559786_REALK,      0.000000000000000_REALK, &
      0.104897121192699_REALK,      0.000000000000000_REALK,      0.378645561387210_REALK, &
      0.000000000000000_REALK,      0.962567619922738_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.935984126772504_REALK, &
      0.000000000000000_REALK,     -0.013261707734245_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.126560742437183_REALK,      0.000000000000000_REALK, &
     -0.562893084951380_REALK,      0.000000000000000_REALK,      1.348171566861423_REALK, &
      0.000000000000000_REALK,      1.165359858004155_REALK,      0.000000000000000_REALK, &
      0.068286552515996_REALK,      0.054447989305034_REALK,      0.000000000000000_REALK, &
     -0.091527118861118_REALK,      0.000000000000000_REALK,     -0.517171114860412_REALK, &
     -0.004526014325479_REALK,      0.000000000000000_REALK,     -0.017767822631442_REALK, &
      0.000000000000000_REALK,     -0.125345128552838_REALK,      0.000000000000000_REALK, &
     -1.015953998168731_REALK,      0.000000000000000_REALK,     -8.036862689274811_REALK, &
      0.731577042165914_REALK,      0.010624193396908_REALK,      0.000000000000000_REALK, &
     -0.012215284384460_REALK,      0.000000000000000_REALK,      0.065108947351537_REALK, &
     -0.233365513996112_REALK,      0.000000000000000_REALK,      0.006389301725583_REALK, &
      0.000000000000000_REALK,      4.706717589643674_REALK,      0.000000000000000_REALK, &
      1.073406408964679_REALK,      0.000000000000000_REALK,     -8.009940893377117_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.129648093208494_REALK, &
      0.000000000000000_REALK,     -0.915881523028273_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.065793352018990_REALK,      0.000000000000000_REALK, &
      3.901140943368993_REALK,      0.000000000000000_REALK,     -2.672108050493735_REALK, &
      0.000000000000000_REALK,     -3.250558246895432_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.166061955059402_REALK, &
      0.000000000000000_REALK,     -0.408625230630788_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.431754769484311_REALK,      0.000000000000000_REALK, &
      1.915337142282673_REALK,      0.000000000000000_REALK,     -2.345745263091267_REALK, &
      0.000000000000000_REALK,     -2.319106908589436_REALK,      0.000000000000000_REALK, &
     -1.231674107582464_REALK,      0.093808729674559_REALK,      0.000000000000000_REALK, &
     -0.523680629146306_REALK,      0.000000000000000_REALK,     -2.146305510848412_REALK, &
      0.155875319803299_REALK,      0.000000000000000_REALK,      0.171841102455337_REALK, &
      0.000000000000000_REALK,     -1.409473871502270_REALK,      0.000000000000000_REALK, &
     -1.858596712577598_REALK,      0.000000000000000_REALK,    -12.695767052885591_REALK, &
      0.014788929169529_REALK,      0.009704573166930_REALK,      0.000000000000000_REALK, &
     -0.259369252979906_REALK,      0.000000000000000_REALK,     -1.007589974082501_REALK, &
     -0.032469805830073_REALK,      0.000000000000000_REALK,      0.111931293534223_REALK, &
      0.000000000000000_REALK,     -2.591473742539943_REALK,      0.000000000000000_REALK, &
     -1.472021259022230_REALK,      0.000000000000000_REALK,     -9.530774145268511_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.521066943594102_REALK, &
      0.000000000000000_REALK,      0.032200921963627_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.227791614882041_REALK,      0.000000000000000_REALK, &
      1.590838406881716_REALK,      0.000000000000000_REALK,     -0.013420202270035_REALK, &
      0.000000000000000_REALK,      0.190474003850810_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.064521499697331_REALK, &
      0.000000000000000_REALK,     -0.015251686640572_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.084633502172284_REALK,      0.000000000000000_REALK, &
      1.240304407290568_REALK,      0.000000000000000_REALK,     -0.831522763033374_REALK, &
      0.000000000000000_REALK,     -0.144265409982928_REALK,      0.000000000000000_REALK, &
     -0.343554359833436_REALK,     -0.046795516903212_REALK,      0.000000000000000_REALK, &
     -0.163444447318951_REALK,      0.000000000000000_REALK,     -0.997791828275393_REALK, &
     -0.056200271782705_REALK,      0.000000000000000_REALK,     -0.142868601577425_REALK, &
      0.000000000000000_REALK,     -0.468658299686607_REALK,      0.000000000000000_REALK, &
     -0.966802078623366_REALK,      0.000000000000000_REALK,     -8.262954913473488_REALK, &
      0.007128112617834_REALK,     -0.010841159355468_REALK,      0.000000000000000_REALK, &
     -0.181988317982938_REALK,      0.000000000000000_REALK,     -0.809413438652776_REALK, &
     -0.241093038877489_REALK,      0.000000000000000_REALK,     -0.208400886399157_REALK, &
      0.000000000000000_REALK,     -2.656092523600170_REALK,      0.000000000000000_REALK, &
     -1.721423992286241_REALK,      0.000000000000000_REALK,    -10.718716562614746_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.279081798693301_REALK, &
      0.000000000000000_REALK,      0.169009292403091_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.150792447181021_REALK,      0.000000000000000_REALK, &
      1.192867191583528_REALK,      0.000000000000000_REALK,      0.254659394461567_REALK, &
      0.000000000000000_REALK,      1.399606735102823_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.053225156808586_REALK, &
      0.000000000000000_REALK,      0.009187511480517_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.191956884011683_REALK,      0.000000000000000_REALK, &
      1.432414863717309_REALK,      0.000000000000000_REALK,     -3.174135889448557_REALK, &
      0.000000000000000_REALK,      0.121666291628836_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     11.198163131428442_REALK, &
      0.000000000000000_REALK,     -3.545499459236042_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.482221867510234_REALK,      0.000000000000000_REALK, &
     10.734628434513512_REALK,      0.000000000000000_REALK,     -5.777345004169679_REALK, &
      0.000000000000000_REALK,     -6.947927908840255_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     10.122686526996414_REALK, &
      0.000000000000000_REALK,     -3.230561574193854_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.165822893477212_REALK,      0.000000000000000_REALK, &
      9.483100845148202_REALK,      0.000000000000000_REALK,     -3.725388938814008_REALK, &
      0.000000000000000_REALK,     -5.902925917324481_REALK,      0.000000000000000_REALK, &
     -6.587961283458864_REALK,      1.044457332888828_REALK,      0.000000000000000_REALK, &
     -1.422099045563877_REALK,      0.000000000000000_REALK,     -5.205332536242315_REALK, &
      0.823051466015901_REALK,      0.000000000000000_REALK,      1.001223258910890_REALK, &
      0.000000000000000_REALK,     -2.356717049377399_REALK,      0.000000000000000_REALK, &
     -2.786812340943738_REALK,      0.000000000000000_REALK,    -17.001025111398103_REALK, &
     -7.830834718219199_REALK,      1.396176515352400_REALK,      0.000000000000000_REALK, &
     -1.199196426470569_REALK,      0.000000000000000_REALK,     -5.319838062831623_REALK, &
      1.322985205984172_REALK,      0.000000000000000_REALK,      1.307961345775565_REALK, &
      0.000000000000000_REALK,      0.028983776679800_REALK,      0.000000000000000_REALK, &
     -2.191187972494360_REALK,      0.000000000000000_REALK,    -16.200800415994841_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.447614099707220_REALK, &
      0.000000000000000_REALK,     -0.229289352694354_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.572477130457608_REALK,      0.000000000000000_REALK, &
      3.910496689362208_REALK,      0.000000000000000_REALK,     -0.407579259200188_REALK, &
      0.000000000000000_REALK,     -0.748877044029730_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.442698476417883_REALK, &
      0.000000000000000_REALK,     -0.310888533731290_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.830210500356804_REALK,      0.000000000000000_REALK, &
      5.375295175551247_REALK,      0.000000000000000_REALK,      0.164786710032319_REALK, &
      0.000000000000000_REALK,     -0.946766241211679_REALK,      0.000000000000000_REALK, &
     -1.611894876639657_REALK,     -0.036721440737759_REALK,      0.000000000000000_REALK, &
     -0.303944697625993_REALK,      0.000000000000000_REALK,     -2.122672069390557_REALK, &
      0.004133634173417_REALK,      0.000000000000000_REALK,     -0.058669000334160_REALK, &
      0.000000000000000_REALK,     -0.390399744683412_REALK,      0.000000000000000_REALK, &
     -0.992707267179916_REALK,      0.000000000000000_REALK,     -9.705939296902825_REALK, &
     -3.042582509164700_REALK,      0.052111433927389_REALK,      0.000000000000000_REALK, &
     -0.235069072857990_REALK,      0.000000000000000_REALK,     -3.444938465265971_REALK, &
      0.468973477743493_REALK,      0.000000000000000_REALK,      0.081364761189429_REALK, &
      0.000000000000000_REALK,      1.495641523197538_REALK,      0.000000000000000_REALK, &
     -0.715868996079585_REALK,      0.000000000000000_REALK,    -14.687489319558564_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.137866596863985_REALK, &
      0.000000000000000_REALK,      0.190631046402588_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.297790303805698_REALK,      0.000000000000000_REALK, &
      2.545120566475981_REALK,      0.000000000000000_REALK,      0.244918665004717_REALK, &
      0.000000000000000_REALK,      0.871662368940398_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.765575763672606_REALK, &
      0.000000000000000_REALK,      0.578832281439913_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.970872034084248_REALK,      0.000000000000000_REALK, &
      6.045287040583949_REALK,      0.000000000000000_REALK,      2.039275550144075_REALK, &
      0.000000000000000_REALK,      2.467850452826032_REALK,      0.000000000000000_REALK, &
     -0.863325772259187_REALK,     -0.192735621735336_REALK,      0.000000000000000_REALK, &
     -0.201203915194388_REALK,      0.000000000000000_REALK,     -1.591654978351912_REALK, &
     -0.078439113982530_REALK,      0.000000000000000_REALK,     -0.431100970995262_REALK, &
      0.000000000000000_REALK,     -0.081076776491279_REALK,      0.000000000000000_REALK, &
     -0.920006917383431_REALK,      0.000000000000000_REALK,     -9.357246423937097_REALK, &
     -2.509890996226340_REALK,     -0.031391570569019_REALK,      0.000000000000000_REALK, &
      0.533159157959459_REALK,      0.000000000000000_REALK,     -3.978524169738306_REALK, &
      1.790192178834410_REALK,      0.000000000000000_REALK,     -0.068619004128260_REALK, &
      0.000000000000000_REALK,      7.119490084142977_REALK,      0.000000000000000_REALK, &
      2.273123168123063_REALK,      0.000000000000000_REALK,    -21.808839944594290_REALK/
    ! results of test 7, ket-major order, 01ODGYYZ
  data REF_CONTR_INTS(47881:49140)                                                         &
     /0.000000000000000_REALK,      0.000000000000000_REALK,     -0.156902537250718_REALK, &
      0.000000000000000_REALK,      0.034891531242990_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.159987642353925_REALK,      0.000000000000000_REALK, &
      0.179376365420554_REALK,      0.000000000000000_REALK,      0.584535202399502_REALK, &
      0.000000000000000_REALK,      0.339217059627573_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.522417960874782_REALK, &
      0.000000000000000_REALK,     -0.285598515398973_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.096808701178737_REALK,      0.000000000000000_REALK, &
     -0.035667972705381_REALK,      0.000000000000000_REALK,      1.104963871931702_REALK, &
      0.000000000000000_REALK,      0.227021317678595_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.007526414042530_REALK, &
      0.000000000000000_REALK,      0.081922482201389_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.120942258486808_REALK,      0.000000000000000_REALK, &
      0.234566934764160_REALK,      0.000000000000000_REALK,      0.172044401750932_REALK, &
      0.000000000000000_REALK,      0.230530292393088_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.149079640698863_REALK, &
      0.000000000000000_REALK,     -0.006201712220181_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.016431725308648_REALK,      0.000000000000000_REALK, &
      0.014994349593172_REALK,      0.000000000000000_REALK,     -0.416653975806253_REALK, &
      0.000000000000000_REALK,      0.010605776479319_REALK,      0.000000000000000_REALK, &
      0.178898431194062_REALK,      0.003407138393637_REALK,      0.000000000000000_REALK, &
     -0.075661180049630_REALK,      0.000000000000000_REALK,     -0.084830473660641_REALK, &
     -0.182979082883532_REALK,      0.000000000000000_REALK,     -0.106186293339234_REALK, &
      0.000000000000000_REALK,     -0.592088805034732_REALK,      0.000000000000000_REALK, &
     -0.212910955466038_REALK,      0.000000000000000_REALK,     -0.397855659222613_REALK, &
      0.338731214158065_REALK,      0.263808982630881_REALK,      0.000000000000000_REALK, &
      0.196321438940188_REALK,      0.000000000000000_REALK,      0.072332214360271_REALK, &
     -0.129145807564432_REALK,      0.000000000000000_REALK,     -0.026533764723627_REALK, &
      0.000000000000000_REALK,     -2.102379935484656_REALK,      0.000000000000000_REALK, &
     -0.335736523330154_REALK,      0.000000000000000_REALK,     -0.206163306337347_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.187911076649245_REALK, &
      0.000000000000000_REALK,      0.134417696321760_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.145871350879186_REALK,      0.000000000000000_REALK, &
      0.328098883377622_REALK,      0.000000000000000_REALK,      0.179309893333431_REALK, &
      0.000000000000000_REALK,      0.202440677426472_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.420971657880754_REALK, &
      0.000000000000000_REALK,     -0.072195242380889_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.040592874330307_REALK,      0.000000000000000_REALK, &
      0.037167777248972_REALK,      0.000000000000000_REALK,      0.346846705323539_REALK, &
      0.000000000000000_REALK,      0.091738314624011_REALK,      0.000000000000000_REALK, &
      0.034422361019970_REALK,     -0.057833160053227_REALK,      0.000000000000000_REALK, &
     -0.078108800490572_REALK,      0.000000000000000_REALK,     -0.151491646827294_REALK, &
     -0.075360164705227_REALK,      0.000000000000000_REALK,     -0.100978588245131_REALK, &
      0.000000000000000_REALK,     -0.059563050470202_REALK,      0.000000000000000_REALK, &
     -0.117636285377409_REALK,      0.000000000000000_REALK,     -0.380258359419653_REALK, &
      0.589967007240221_REALK,      0.024118844782722_REALK,      0.000000000000000_REALK, &
     -0.059337416804108_REALK,      0.000000000000000_REALK,      0.054146838192840_REALK, &
      0.083657194266978_REALK,      0.000000000000000_REALK,     -0.002129463667221_REALK, &
      0.000000000000000_REALK,      0.988710336652313_REALK,      0.000000000000000_REALK, &
      0.075399907697967_REALK,      0.000000000000000_REALK,     -0.114673753980986_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.059886056046820_REALK, &
      0.000000000000000_REALK,      0.068578874787362_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.093260835622516_REALK,      0.000000000000000_REALK, &
      0.174271686278570_REALK,      0.000000000000000_REALK,      0.177977324729153_REALK, &
      0.000000000000000_REALK,      0.172139460911780_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.281304483182702_REALK, &
      0.000000000000000_REALK,     -0.095817391492016_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.067410314519142_REALK,      0.000000000000000_REALK, &
      0.041394165831759_REALK,      0.000000000000000_REALK,      0.592608614556913_REALK, &
      0.000000000000000_REALK,      0.202924867744322_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.598160657099063_REALK, &
      0.000000000000000_REALK,      0.200044641545862_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.168683689399408_REALK,      0.000000000000000_REALK, &
      0.499110549927965_REALK,      0.000000000000000_REALK,      0.124361730010049_REALK, &
      0.000000000000000_REALK,      0.187340293746444_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.041318681304675_REALK, &
      0.000000000000000_REALK,      0.016365741850884_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.024650589524141_REALK,      0.000000000000000_REALK, &
      0.134711188166739_REALK,      0.000000000000000_REALK,     -0.257231182105020_REALK, &
      0.000000000000000_REALK,      0.040778129985176_REALK,      0.000000000000000_REALK, &
     -0.281267453649626_REALK,     -0.144578711913592_REALK,      0.000000000000000_REALK, &
     -0.124254594436121_REALK,      0.000000000000000_REALK,     -0.279477727760233_REALK, &
     -0.106853739764398_REALK,      0.000000000000000_REALK,     -0.120637757690438_REALK, &
      0.000000000000000_REALK,     -0.144640989106542_REALK,      0.000000000000000_REALK, &
     -0.116363487875137_REALK,      0.000000000000000_REALK,     -0.436214630307801_REALK, &
      0.163544631294309_REALK,      0.019595949394615_REALK,      0.000000000000000_REALK, &
     -0.056284799129234_REALK,      0.000000000000000_REALK,     -0.051535667553766_REALK, &
     -0.241551834294580_REALK,      0.000000000000000_REALK,     -0.063888622357974_REALK, &
      0.000000000000000_REALK,     -0.941642650662216_REALK,      0.000000000000000_REALK, &
     -0.140243496200415_REALK,      0.000000000000000_REALK,     -0.214016996553768_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.162943330850799_REALK, &
      0.000000000000000_REALK,      0.086014515211575_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.070101413764126_REALK,      0.000000000000000_REALK, &
      0.226602263964924_REALK,      0.000000000000000_REALK,      0.060115790791626_REALK, &
      0.000000000000000_REALK,      0.134253238191171_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.014697072357031_REALK, &
      0.000000000000000_REALK,      0.002952647151499_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.052510188883290_REALK,      0.000000000000000_REALK, &
      0.079861377358952_REALK,      0.000000000000000_REALK,     -0.289025539577491_REALK, &
      0.000000000000000_REALK,      0.012261734547001_REALK,      0.000000000000000_REALK, &
     -0.089638135195451_REALK,     -0.073762946788690_REALK,      0.000000000000000_REALK, &
     -0.079440460633336_REALK,      0.000000000000000_REALK,     -0.148446268370936_REALK, &
     -0.106059640028947_REALK,      0.000000000000000_REALK,     -0.102580760143822_REALK, &
      0.000000000000000_REALK,     -0.206887793914161_REALK,      0.000000000000000_REALK, &
     -0.123992317543033_REALK,      0.000000000000000_REALK,     -0.324377217589859_REALK, &
      0.109284882063445_REALK,      0.026007707611750_REALK,      0.000000000000000_REALK, &
     -0.093469015795109_REALK,      0.000000000000000_REALK,     -0.057395844650086_REALK, &
     -0.412705946655787_REALK,      0.000000000000000_REALK,     -0.141321434729798_REALK, &
      0.000000000000000_REALK,     -1.458384008155729_REALK,      0.000000000000000_REALK, &
     -0.388157541773109_REALK,      0.000000000000000_REALK,     -0.333694344473327_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.563293283731060_REALK, &
      0.000000000000000_REALK,      0.302938548660733_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.241749738001569_REALK,      0.000000000000000_REALK, &
      0.860714349247397_REALK,      0.000000000000000_REALK,      0.125965488118408_REALK, &
      0.000000000000000_REALK,      0.192371255265713_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.877407544033105_REALK, &
      0.000000000000000_REALK,     -0.012742143067700_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.125519394685765_REALK,      0.000000000000000_REALK, &
      0.228357246955732_REALK,      0.000000000000000_REALK,      0.360617183984500_REALK, &
      0.000000000000000_REALK,      0.107171594230042_REALK,      0.000000000000000_REALK, &
     -0.990232887595459_REALK,     -0.273922473938881_REALK,      0.000000000000000_REALK, &
     -0.185875190630904_REALK,      0.000000000000000_REALK,     -0.549977706463906_REALK, &
     -0.100115611571356_REALK,      0.000000000000000_REALK,     -0.150815593180212_REALK, &
      0.000000000000000_REALK,     -0.080090196764829_REALK,      0.000000000000000_REALK, &
     -0.118033983798034_REALK,      0.000000000000000_REALK,     -0.582075706048594_REALK, &
      1.763884902082236_REALK,      0.104951039620761_REALK,      0.000000000000000_REALK, &
     -0.003580798644972_REALK,      0.000000000000000_REALK,      0.019568442352167_REALK, &
      0.172304447273006_REALK,      0.000000000000000_REALK,     -0.027314935500526_REALK, &
      0.000000000000000_REALK,      0.846680373732142_REALK,      0.000000000000000_REALK, &
      0.030117374868539_REALK,      0.000000000000000_REALK,     -0.274310366832589_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.382690733464856_REALK, &
      0.000000000000000_REALK,      0.132932628446966_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.093676742453279_REALK,      0.000000000000000_REALK, &
      0.351168277299696_REALK,      0.000000000000000_REALK,      0.074769366457517_REALK, &
      0.000000000000000_REALK,      0.140690891013855_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.330490480456007_REALK, &
      0.000000000000000_REALK,     -0.009280601266941_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.093941091817479_REALK,      0.000000000000000_REALK, &
      0.143357737566864_REALK,      0.000000000000000_REALK,      0.295121020797844_REALK, &
      0.000000000000000_REALK,      0.130095441024191_REALK,      0.000000000000000_REALK, &
     -0.269746669407057_REALK,     -0.117780254543866_REALK,      0.000000000000000_REALK, &
     -0.077245842163496_REALK,      0.000000000000000_REALK,     -0.249696572097994_REALK, &
     -0.048395347666143_REALK,      0.000000000000000_REALK,     -0.108078627129568_REALK, &
      0.000000000000000_REALK,     -0.024836842324437_REALK,      0.000000000000000_REALK, &
     -0.081754092189891_REALK,      0.000000000000000_REALK,     -0.369977236369942_REALK, &
      0.627414603196538_REALK,      0.018934881840771_REALK,      0.000000000000000_REALK, &
     -0.007627745089682_REALK,      0.000000000000000_REALK,      0.011600838655502_REALK, &
      0.193601667718301_REALK,      0.000000000000000_REALK,     -0.008213434220688_REALK, &
      0.000000000000000_REALK,      0.841262723121528_REALK,      0.000000000000000_REALK, &
      0.106925708035440_REALK,      0.000000000000000_REALK,     -0.227668730593963_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.203268474301220_REALK, &
      0.000000000000000_REALK,      0.113035340966778_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.099818221409171_REALK,      0.000000000000000_REALK, &
      0.261135186171820_REALK,      0.000000000000000_REALK,      0.123689510995148_REALK, &
      0.000000000000000_REALK,      0.167485291094064_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.368070914280785_REALK, &
      0.000000000000000_REALK,     -0.020528661251304_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.260004522557294_REALK,      0.000000000000000_REALK, &
      0.223522743673938_REALK,      0.000000000000000_REALK,      0.840386913379565_REALK, &
      0.000000000000000_REALK,      0.402878997516364_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.826444239075616_REALK, &
      0.000000000000000_REALK,      0.540595833200805_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.449774556661972_REALK,      0.000000000000000_REALK, &
      1.911346446771697_REALK,      0.000000000000000_REALK,      0.114511932552108_REALK, &
      0.000000000000000_REALK,      0.215552169991230_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.911625676171685_REALK, &
      0.000000000000000_REALK,      0.257225671467770_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.019075436568682_REALK,      0.000000000000000_REALK, &
      1.568113433291468_REALK,      0.000000000000000_REALK,     -0.713955978383472_REALK, &
      0.000000000000000_REALK,      0.105311917839269_REALK,      0.000000000000000_REALK, &
     -5.152854154728446_REALK,     -0.709782795723473_REALK,      0.000000000000000_REALK, &
     -0.414331814351252_REALK,      0.000000000000000_REALK,     -1.475167422764762_REALK, &
     -0.152465886212715_REALK,      0.000000000000000_REALK,     -0.232841981990885_REALK, &
      0.000000000000000_REALK,     -0.134810621914037_REALK,      0.000000000000000_REALK, &
     -0.165206825866602_REALK,      0.000000000000000_REALK,     -0.980324300055545_REALK, &
     -3.059058015784150_REALK,     -0.780640948854037_REALK,      0.000000000000000_REALK, &
     -0.788184271679307_REALK,      0.000000000000000_REALK,     -1.433942466222771_REALK, &
     -1.053023933927590_REALK,      0.000000000000000_REALK,     -0.312947521009596_REALK, &
      0.000000000000000_REALK,     -2.154135281178598_REALK,      0.000000000000000_REALK, &
     -0.322694063884271_REALK,      0.000000000000000_REALK,     -0.978461379375531_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.288593729009748_REALK, &
      0.000000000000000_REALK,      0.258480935166150_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.142865765947480_REALK,      0.000000000000000_REALK, &
      0.704531770497080_REALK,      0.000000000000000_REALK,      0.068416961044607_REALK, &
      0.000000000000000_REALK,      0.171773818980862_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.198850721125115_REALK, &
      0.000000000000000_REALK,      0.171520923896637_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.087944551652326_REALK,      0.000000000000000_REALK, &
      0.801002820796217_REALK,      0.000000000000000_REALK,     -0.442972358614832_REALK, &
      0.000000000000000_REALK,      0.117038586791945_REALK,      0.000000000000000_REALK, &
     -1.261407284501391_REALK,     -0.311460172629353_REALK,      0.000000000000000_REALK, &
     -0.160551382533163_REALK,      0.000000000000000_REALK,     -0.601862863136762_REALK, &
     -0.090499214418101_REALK,      0.000000000000000_REALK,     -0.170289193499733_REALK, &
      0.000000000000000_REALK,     -0.079573490304100_REALK,      0.000000000000000_REALK, &
     -0.106694615998087_REALK,      0.000000000000000_REALK,     -0.559956173991028_REALK, &
     -1.152246251191520_REALK,     -0.568571341607831_REALK,      0.000000000000000_REALK, &
     -0.589892033978362_REALK,      0.000000000000000_REALK,     -0.900198047135313_REALK, &
     -0.861771185919497_REALK,      0.000000000000000_REALK,     -0.379886536686024_REALK, &
      0.000000000000000_REALK,     -1.621582821035536_REALK,      0.000000000000000_REALK, &
     -0.402517246573711_REALK,      0.000000000000000_REALK,     -0.859959629568622_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.585037235471693_REALK, &
      0.000000000000000_REALK,      0.185234590288970_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.098953374479293_REALK,      0.000000000000000_REALK, &
      0.447812397381812_REALK,      0.000000000000000_REALK,      0.055120651082721_REALK, &
      0.000000000000000_REALK,      0.172337020311283_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.710719511421130_REALK, &
      0.000000000000000_REALK,      0.051575293885263_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.312229518486593_REALK,      0.000000000000000_REALK, &
      0.664806429004392_REALK,      0.000000000000000_REALK,     -0.829541244564813_REALK, &
      0.000000000000000_REALK,      0.049269903179202_REALK,      0.000000000000000_REALK, &
     -0.670004031379529_REALK,     -0.264840974123789_REALK,      0.000000000000000_REALK, &
     -0.171077185537666_REALK,      0.000000000000000_REALK,     -0.447556288465636_REALK, &
     -0.149711093020698_REALK,      0.000000000000000_REALK,     -0.202720552396442_REALK, &
      0.000000000000000_REALK,     -0.189697078778256_REALK,      0.000000000000000_REALK, &
     -0.159165371612332_REALK,      0.000000000000000_REALK,     -0.535363333828106_REALK, &
     -1.283269432049872_REALK,     -1.257678046210610_REALK,      0.000000000000000_REALK, &
     -1.632667810087745_REALK,      0.000000000000000_REALK,     -1.403584771639945_REALK, &
     -2.453980489144552_REALK,      0.000000000000000_REALK,     -1.176430979172972_REALK, &
      0.000000000000000_REALK,     -4.185753573706465_REALK,      0.000000000000000_REALK, &
     -1.559688348180368_REALK,      0.000000000000000_REALK,     -1.723943842478206_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.560153990630309_REALK, &
      0.000000000000000_REALK,     -0.111945410393533_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.444992422011534_REALK,      0.000000000000000_REALK, &
     -5.425991799785067_REALK,      0.000000000000000_REALK,      0.283347088688895_REALK, &
      0.000000000000000_REALK,      0.346850156827628_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.066616892680447_REALK, &
      0.000000000000000_REALK,     -0.261209873929288_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.222331688942316_REALK,      0.000000000000000_REALK, &
     -4.047714848577820_REALK,      0.000000000000000_REALK,      0.744150218971315_REALK, &
      0.000000000000000_REALK,      0.253534926934576_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.617105497958341_REALK, &
      0.000000000000000_REALK,      0.007315632877368_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.792707419803442_REALK,      0.000000000000000_REALK, &
     -3.460505109751639_REALK,      0.000000000000000_REALK,     -0.149096647269321_REALK, &
      0.000000000000000_REALK,     -0.035093157768608_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.044677461869560_REALK, &
      0.000000000000000_REALK,      0.101308889253313_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.088114798265007_REALK,      0.000000000000000_REALK, &
     -2.578755957283781_REALK,      0.000000000000000_REALK,     -0.616392278076646_REALK, &
      0.000000000000000_REALK,     -0.142098855883466_REALK,      0.000000000000000_REALK, &
      1.306265853298286_REALK,      0.244619301602968_REALK,      0.000000000000000_REALK, &
      0.128976179460874_REALK,      0.000000000000000_REALK,      0.484309593228251_REALK, &
      0.191181515768350_REALK,      0.000000000000000_REALK,      0.234028657339067_REALK, &
      0.000000000000000_REALK,     -0.625853746466346_REALK,      0.000000000000000_REALK, &
     -0.618699911557198_REALK,      0.000000000000000_REALK,     -3.872062574514902_REALK, &
      0.716613339215294_REALK,      0.441199549175441_REALK,      0.000000000000000_REALK, &
      0.443400688058835_REALK,      0.000000000000000_REALK,      0.807602014521764_REALK, &
      1.633214820151893_REALK,      0.000000000000000_REALK,      0.556442757845428_REALK, &
      0.000000000000000_REALK,     -2.024735499628840_REALK,      0.000000000000000_REALK, &
     -0.621926969444507_REALK,      0.000000000000000_REALK,     -1.887944271533444_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.950885465966705_REALK, &
      0.000000000000000_REALK,      0.069284918027507_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.433891478359196_REALK,      0.000000000000000_REALK, &
     -1.768442329034232_REALK,      0.000000000000000_REALK,     -0.620285316669441_REALK, &
      0.000000000000000_REALK,     -0.734540809327604_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.292862556529207_REALK, &
      0.000000000000000_REALK,      0.196717882153480_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.639936114423823_REALK,      0.000000000000000_REALK, &
     -2.186615570950225_REALK,      0.000000000000000_REALK,      0.204626354381641_REALK, &
      0.000000000000000_REALK,     -0.256568671695505_REALK,      0.000000000000000_REALK, &
      1.479509789471527_REALK,     -0.011951475284314_REALK,      0.000000000000000_REALK, &
      0.064728034110656_REALK,      0.000000000000000_REALK,      0.282565404572148_REALK, &
     -0.030430248197934_REALK,      0.000000000000000_REALK,     -0.007162424645398_REALK, &
      0.000000000000000_REALK,     -0.415031795713823_REALK,      0.000000000000000_REALK, &
     -0.686229902775516_REALK,      0.000000000000000_REALK,     -4.992809086291194_REALK, &
      2.594889402925378_REALK,     -0.197782142985934_REALK,      0.000000000000000_REALK, &
      0.036006455753337_REALK,      0.000000000000000_REALK,      1.053760141348109_REALK, &
     -0.569708263813453_REALK,      0.000000000000000_REALK,     -0.131336642840262_REALK, &
      0.000000000000000_REALK,      1.113855082934750_REALK,      0.000000000000000_REALK, &
     -0.046961305316865_REALK,      0.000000000000000_REALK,     -2.290605517502928_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.791211673747304_REALK, &
      0.000000000000000_REALK,     -0.019109465278968_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.126275085413000_REALK,      0.000000000000000_REALK, &
     -0.790278167473355_REALK,      0.000000000000000_REALK,      0.165501759792688_REALK, &
      0.000000000000000_REALK,      0.337656027012451_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.576655891591941_REALK, &
      0.000000000000000_REALK,     -0.227379871873158_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.574823771457004_REALK,      0.000000000000000_REALK, &
     -1.744956079703074_REALK,      0.000000000000000_REALK,      0.870431543025409_REALK, &
      0.000000000000000_REALK,      0.494265790330085_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.833120731519408_REALK, &
      0.000000000000000_REALK,     -0.122349190793896_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.098944237145351_REALK,      0.000000000000000_REALK, &
      0.353239897831089_REALK,      0.000000000000000_REALK,     -1.584130291217887_REALK, &
      0.000000000000000_REALK,     -1.945914480226444_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.522312942053012_REALK, &
      0.000000000000000_REALK,      0.380158598901874_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.249109273372641_REALK,      0.000000000000000_REALK, &
     -1.142720469392381_REALK,      0.000000000000000_REALK,     -1.190054670050080_REALK, &
      0.000000000000000_REALK,     -1.068210734781853_REALK,      0.000000000000000_REALK, &
      1.311695725314318_REALK,     -0.106335489519518_REALK,      0.000000000000000_REALK, &
     -0.061317780570828_REALK,      0.000000000000000_REALK,     -0.249917235281852_REALK, &
      0.017303441446935_REALK,      0.000000000000000_REALK,      0.020490705717217_REALK, &
      0.000000000000000_REALK,     -0.764436538445198_REALK,      0.000000000000000_REALK, &
     -0.975234542491761_REALK,      0.000000000000000_REALK,     -6.624721202179739_REALK, &
      1.475101774841309_REALK,     -0.172742436426957_REALK,      0.000000000000000_REALK, &
      0.237663749437182_REALK,      0.000000000000000_REALK,      0.812079899003133_REALK, &
      0.062416300026998_REALK,      0.000000000000000_REALK,     -0.078260042497790_REALK, &
      0.000000000000000_REALK,     -1.509391660270216_REALK,      0.000000000000000_REALK, &
     -0.667813299898111_REALK,      0.000000000000000_REALK,     -3.803116506818869_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.433669137120593_REALK, &
      0.000000000000000_REALK,     -0.001012197760653_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.019143027607954_REALK,      0.000000000000000_REALK, &
      0.139279098438506_REALK,      0.000000000000000_REALK,     -0.068396432424643_REALK, &
      0.000000000000000_REALK,     -0.026830994501978_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.925330693038197_REALK, &
      0.000000000000000_REALK,      0.048776679847195_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.014324405725619_REALK,      0.000000000000000_REALK, &
     -0.698693585467055_REALK,      0.000000000000000_REALK,     -0.594526152003529_REALK, &
      0.000000000000000_REALK,     -0.228429981461677_REALK,      0.000000000000000_REALK, &
      0.351700864788778_REALK,      0.029328379144341_REALK,      0.000000000000000_REALK, &
     -0.017845264000569_REALK,      0.000000000000000_REALK,     -0.111682542017872_REALK, &
     -0.004616827019724_REALK,      0.000000000000000_REALK,     -0.009419231981801_REALK, &
      0.000000000000000_REALK,     -0.287103461156788_REALK,      0.000000000000000_REALK, &
     -0.473036197962645_REALK,      0.000000000000000_REALK,     -4.144620055750093_REALK, &
      0.706293646963716_REALK,      0.199667425410637_REALK,      0.000000000000000_REALK, &
      0.213481892505937_REALK,      0.000000000000000_REALK,      0.648053446520725_REALK, &
      0.265504003658835_REALK,      0.000000000000000_REALK,      0.150763776032419_REALK, &
      0.000000000000000_REALK,     -1.952909288830502_REALK,      0.000000000000000_REALK, &
     -0.999774172828193_REALK,      0.000000000000000_REALK,     -4.248931500342486_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.394611340695933_REALK, &
      0.000000000000000_REALK,     -1.223072523070172_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.394389496751870_REALK,      0.000000000000000_REALK, &
      4.153291763094577_REALK,      0.000000000000000_REALK,     -3.529086245014304_REALK, &
      0.000000000000000_REALK,     -4.237565261027483_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -8.507573327167504_REALK, &
      0.000000000000000_REALK,      1.086472091472735_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.034744647267545_REALK,      0.000000000000000_REALK, &
     -0.097480737684464_REALK,      0.000000000000000_REALK,     -1.428912776507045_REALK, &
      0.000000000000000_REALK,     -2.479065734383341_REALK,      0.000000000000000_REALK, &
      0.108947908593326_REALK,      0.145281997472853_REALK,      0.000000000000000_REALK, &
     -0.462167268326348_REALK,      0.000000000000000_REALK,     -1.649979052389335_REALK, &
      0.352223395362905_REALK,      0.000000000000000_REALK,      0.432664288481136_REALK, &
      0.000000000000000_REALK,     -1.382927106159441_REALK,      0.000000000000000_REALK, &
     -1.601265602899441_REALK,      0.000000000000000_REALK,     -9.527772313774923_REALK, &
      9.425044217997348_REALK,     -1.314294316564061_REALK,      0.000000000000000_REALK, &
      0.362115287969430_REALK,      0.000000000000000_REALK,      1.661104567647259_REALK, &
     -0.016777054327410_REALK,      0.000000000000000_REALK,     -0.015059332971488_REALK, &
      0.000000000000000_REALK,      0.412418737755590_REALK,      0.000000000000000_REALK, &
     -0.826259237901370_REALK,      0.000000000000000_REALK,     -6.317062731757115_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.296761056685729_REALK, &
      0.000000000000000_REALK,     -0.095711824767453_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.216838490959953_REALK,      0.000000000000000_REALK, &
      1.472973408879430_REALK,      0.000000000000000_REALK,     -0.280030514157769_REALK, &
      0.000000000000000_REALK,     -0.552686091862599_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.807544006471964_REALK, &
      0.000000000000000_REALK,      0.113761954510601_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.009414643120964_REALK,      0.000000000000000_REALK, &
     -0.053615261428020_REALK,      0.000000000000000_REALK,      0.207025791511923_REALK, &
      0.000000000000000_REALK,     -0.432628635865246_REALK,      0.000000000000000_REALK, &
      0.025774268272881_REALK,      0.001201921414854_REALK,      0.000000000000000_REALK, &
     -0.089416837527053_REALK,      0.000000000000000_REALK,     -0.650570890406881_REALK, &
      0.015207602425679_REALK,      0.000000000000000_REALK,      0.005965736553895_REALK, &
      0.000000000000000_REALK,     -0.187367916057733_REALK,      0.000000000000000_REALK, &
     -0.516335809077012_REALK,      0.000000000000000_REALK,     -5.259392737324007_REALK, &
      3.457652915603936_REALK,     -0.168632021712023_REALK,      0.000000000000000_REALK, &
      0.020822533959080_REALK,      0.000000000000000_REALK,      1.015649178685225_REALK, &
     -0.008381461627145_REALK,      0.000000000000000_REALK,     -0.003220341304850_REALK, &
      0.000000000000000_REALK,      1.126916085032078_REALK,      0.000000000000000_REALK, &
     -0.079186618239185_REALK,      0.000000000000000_REALK,     -5.407418401130084_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.132616020440503_REALK, &
      0.000000000000000_REALK,      0.043997112316569_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.105177217240047_REALK,      0.000000000000000_REALK, &
      0.921535404390990_REALK,      0.000000000000000_REALK,      0.124527486634725_REALK, &
      0.000000000000000_REALK,      0.355684670791634_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.240467436623179_REALK, &
      0.000000000000000_REALK,     -0.219156306123022_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.014094533667075_REALK,      0.000000000000000_REALK, &
     -0.059900235181373_REALK,      0.000000000000000_REALK,      1.467730290625975_REALK, &
      0.000000000000000_REALK,      1.166810220816028_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     17.637399716120957_REALK, &
      0.000000000000000_REALK,     -6.587135712733047_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      5.657438894586567_REALK,      0.000000000000000_REALK, &
     13.899398542318711_REALK,      0.000000000000000_REALK,     -8.390190715197113_REALK, &
      0.000000000000000_REALK,     -9.453406883073916_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     14.733468205479349_REALK, &
      0.000000000000000_REALK,     -7.125448112123778_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      5.949903946083746_REALK,      0.000000000000000_REALK, &
     14.956778599607611_REALK,      0.000000000000000_REALK,     -9.463080047987729_REALK, &
      0.000000000000000_REALK,    -10.153763333530957_REALK,      0.000000000000000_REALK, &
    -10.344392894623812_REALK,      2.529747696644115_REALK,      0.000000000000000_REALK, &
     -2.212001831320299_REALK,      0.000000000000000_REALK,     -6.588610289573596_REALK, &
      1.660292215925766_REALK,      0.000000000000000_REALK,      1.993602912737218_REALK, &
      0.000000000000000_REALK,     -3.161066492484813_REALK,      0.000000000000000_REALK, &
     -3.174513817463057_REALK,      0.000000000000000_REALK,    -15.759205158257441_REALK, &
     -7.071448492987819_REALK,      2.771710989124363_REALK,      0.000000000000000_REALK, &
     -2.792564903148854_REALK,      0.000000000000000_REALK,     -7.834912949165999_REALK, &
      1.621805225221042_REALK,      0.000000000000000_REALK,      2.813720912705073_REALK, &
      0.000000000000000_REALK,     -5.904231433187307_REALK,      0.000000000000000_REALK, &
     -3.979404898318303_REALK,      0.000000000000000_REALK,    -18.607917839648955_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.412741786411208_REALK, &
      0.000000000000000_REALK,     -0.686360733996172_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.753330644690109_REALK,      0.000000000000000_REALK, &
      4.482431176064789_REALK,      0.000000000000000_REALK,     -0.801883575584812_REALK, &
      0.000000000000000_REALK,     -1.641696677178620_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.237662265205200_REALK, &
      0.000000000000000_REALK,     -1.210378231707987_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.937798003802083_REALK,      0.000000000000000_REALK, &
      7.169818560553888_REALK,      0.000000000000000_REALK,     -1.921524534578082_REALK, &
      0.000000000000000_REALK,     -2.874648236253764_REALK,      0.000000000000000_REALK, &
     -2.201196044088544_REALK,      0.197965994395230_REALK,      0.000000000000000_REALK, &
     -0.343983614493260_REALK,      0.000000000000000_REALK,     -2.336664099605736_REALK, &
      0.131743020883852_REALK,      0.000000000000000_REALK,      0.260016432714352_REALK, &
      0.000000000000000_REALK,     -0.386956242270226_REALK,      0.000000000000000_REALK, &
     -0.822769615082069_REALK,      0.000000000000000_REALK,     -7.824648027195252_REALK, &
     -2.333615247272057_REALK,      0.290219382472937_REALK,      0.000000000000000_REALK, &
     -0.756692153263955_REALK,      0.000000000000000_REALK,     -4.309270898164992_REALK, &
     -0.234972712085553_REALK,      0.000000000000000_REALK,      0.491030239047658_REALK, &
      0.000000000000000_REALK,     -2.437142746874573_REALK,      0.000000000000000_REALK, &
     -1.797143823958064_REALK,      0.000000000000000_REALK,    -14.328325417135874_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.345611303064238_REALK, &
      0.000000000000000_REALK,     -0.009463797750291_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.242915096174087_REALK,      0.000000000000000_REALK, &
      2.474331375327487_REALK,      0.000000000000000_REALK,     -0.057703561478889_REALK, &
      0.000000000000000_REALK,     -0.031690856383286_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.591033871694822_REALK, &
      0.000000000000000_REALK,     -0.258831584469272_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.089876214517325_REALK,      0.000000000000000_REALK, &
      6.137379105355032_REALK,      0.000000000000000_REALK,     -1.599921718267229_REALK, &
      0.000000000000000_REALK,     -0.860614999184168_REALK,      0.000000000000000_REALK, &
     -0.983666330200254_REALK,     -0.091001630273275_REALK,      0.000000000000000_REALK, &
     -0.166848787724020_REALK,      0.000000000000000_REALK,     -1.461885654537528_REALK, &
     -0.058585141414586_REALK,      0.000000000000000_REALK,     -0.167335238993876_REALK, &
      0.000000000000000_REALK,     -0.242218660160611_REALK,      0.000000000000000_REALK, &
     -0.558716607117368_REALK,      0.000000000000000_REALK,     -6.293995073833764_REALK, &
     -1.862264298998657_REALK,     -0.559092080491168_REALK,      0.000000000000000_REALK, &
     -1.132833490633502_REALK,      0.000000000000000_REALK,     -4.814419129651563_REALK, &
     -1.665862811004594_REALK,      0.000000000000000_REALK,     -1.324320801152430_REALK, &
      0.000000000000000_REALK,     -5.255449191724006_REALK,      0.000000000000000_REALK, &
     -3.766671272427693_REALK,      0.000000000000000_REALK,    -20.581641320661777_REALK/
    ! results of test 7, ket-major order, 01ODGXZZ
  data REF_CONTR_INTS(49141:50400)                                                         &
     /0.551903365073073_REALK,     -0.012022834554742_REALK,      0.000000000000000_REALK, &
     -0.896678529241405_REALK,      0.000000000000000_REALK,     -0.422800474824952_REALK, &
     -2.716279783792623_REALK,      0.000000000000000_REALK,     -0.974459085546625_REALK, &
      0.000000000000000_REALK,    -12.217061235182427_REALK,      0.000000000000000_REALK, &
     -3.647581654230655_REALK,      0.000000000000000_REALK,     -2.866503444060780_REALK, &
      1.256554741616577_REALK,      1.131764805099192_REALK,      0.000000000000000_REALK, &
      0.437740591454868_REALK,      0.000000000000000_REALK,      0.158321158241193_REALK, &
     -1.807601028222185_REALK,      0.000000000000000_REALK,     -0.526758316904916_REALK, &
      0.000000000000000_REALK,    -15.849528058113025_REALK,      0.000000000000000_REALK, &
     -3.944777986324108_REALK,      0.000000000000000_REALK,     -2.377899270294135_REALK, &
      0.007238929616269_REALK,     -0.264210906618142_REALK,      0.000000000000000_REALK, &
     -0.553501415266789_REALK,      0.000000000000000_REALK,     -0.421269561549084_REALK, &
     -0.994201386746565_REALK,      0.000000000000000_REALK,     -0.569635953076947_REALK, &
      0.000000000000000_REALK,     -2.473951184989966_REALK,      0.000000000000000_REALK, &
     -1.247879813264885_REALK,      0.000000000000000_REALK,     -1.582934169333200_REALK, &
      0.885700732220030_REALK,      0.280234010696374_REALK,      0.000000000000000_REALK, &
     -0.002117118840165_REALK,      0.000000000000000_REALK,     -0.002587585516526_REALK, &
     -0.033648203399732_REALK,      0.000000000000000_REALK,     -0.181470924783641_REALK, &
      0.000000000000000_REALK,      1.091207824972460_REALK,      0.000000000000000_REALK, &
     -0.396529364561553_REALK,      0.000000000000000_REALK,     -0.807743697984585_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.231063340673133_REALK, &
      0.000000000000000_REALK,      0.509895511821837_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.056523115865578_REALK,      0.000000000000000_REALK, &
      0.830283578942191_REALK,      0.000000000000000_REALK,      3.204395439809211_REALK, &
      0.000000000000000_REALK,      1.915949078980353_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.561170206225283_REALK, &
      0.000000000000000_REALK,      0.007555905822013_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.004751532442234_REALK,      0.000000000000000_REALK, &
      0.605660938107101_REALK,      0.000000000000000_REALK,      4.856325987414734_REALK, &
      0.000000000000000_REALK,      2.358660330766450_REALK,      0.000000000000000_REALK, &
     -0.378143997517365_REALK,     -0.393470119317730_REALK,      0.000000000000000_REALK, &
     -0.486888102033755_REALK,      0.000000000000000_REALK,     -0.488688787535929_REALK, &
     -0.670370351528568_REALK,      0.000000000000000_REALK,     -0.450358277311234_REALK, &
      0.000000000000000_REALK,     -1.308720455645024_REALK,      0.000000000000000_REALK, &
     -0.702090948170581_REALK,      0.000000000000000_REALK,     -1.174479217326904_REALK, &
      0.141448784834157_REALK,     -0.035123506958265_REALK,      0.000000000000000_REALK, &
     -0.207793816945346_REALK,      0.000000000000000_REALK,     -0.156344921730311_REALK, &
     -0.559005427432055_REALK,      0.000000000000000_REALK,     -0.243610965126799_REALK, &
      0.000000000000000_REALK,     -1.875105439686565_REALK,      0.000000000000000_REALK, &
     -0.524742055671638_REALK,      0.000000000000000_REALK,     -0.658030131571585_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.324221924761226_REALK, &
      0.000000000000000_REALK,      0.359714318351720_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.487581733257224_REALK,      0.000000000000000_REALK, &
      0.618496891857113_REALK,      0.000000000000000_REALK,      0.905313317987846_REALK, &
      0.000000000000000_REALK,      0.864511324700586_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.030826467889781_REALK, &
      0.000000000000000_REALK,      0.126231979989883_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.174933607153516_REALK,      0.000000000000000_REALK, &
      0.356345661563305_REALK,      0.000000000000000_REALK,      0.059106803615093_REALK, &
      0.000000000000000_REALK,      0.531289698968076_REALK,      0.000000000000000_REALK, &
     -0.243423704938143_REALK,     -0.392431163699740_REALK,      0.000000000000000_REALK, &
     -0.667174342478845_REALK,      0.000000000000000_REALK,     -0.524308358741312_REALK, &
     -1.252047405507691_REALK,      0.000000000000000_REALK,     -0.748615181391292_REALK, &
      0.000000000000000_REALK,     -3.222294842394016_REALK,      0.000000000000000_REALK, &
     -1.603438465462103_REALK,      0.000000000000000_REALK,     -1.764118598841490_REALK, &
      0.228696015779331_REALK,     -0.090015146055227_REALK,      0.000000000000000_REALK, &
     -0.698909621413279_REALK,      0.000000000000000_REALK,     -0.421300434275857_REALK, &
     -2.142425500898678_REALK,      0.000000000000000_REALK,     -1.040550830748958_REALK, &
      0.000000000000000_REALK,     -7.091335613711774_REALK,      0.000000000000000_REALK, &
     -2.941595960043663_REALK,      0.000000000000000_REALK,     -2.482458195516460_REALK, &
     -0.887979575804589_REALK,     -0.522720525831544_REALK,      0.000000000000000_REALK, &
     -0.459933721597815_REALK,      0.000000000000000_REALK,     -0.632423104406986_REALK, &
     -0.462541614407546_REALK,      0.000000000000000_REALK,     -0.401633744465803_REALK, &
      0.000000000000000_REALK,     -0.624270089845375_REALK,      0.000000000000000_REALK, &
     -0.455475486155602_REALK,      0.000000000000000_REALK,     -1.043821487782729_REALK, &
      0.166161306927196_REALK,     -0.073898288937329_REALK,      0.000000000000000_REALK, &
     -0.105402119855730_REALK,      0.000000000000000_REALK,     -0.222834507317339_REALK, &
      0.005817859244399_REALK,      0.000000000000000_REALK,     -0.178458444423587_REALK, &
      0.000000000000000_REALK,      0.532343526051472_REALK,      0.000000000000000_REALK, &
     -0.157885699197245_REALK,      0.000000000000000_REALK,     -0.556319962084691_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.470681054478099_REALK, &
      0.000000000000000_REALK,      0.345703170596076_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.360316495791708_REALK,      0.000000000000000_REALK, &
      0.602748457404412_REALK,      0.000000000000000_REALK,      0.509600408544671_REALK, &
      0.000000000000000_REALK,      0.570586993656990_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.101194225991677_REALK, &
      0.000000000000000_REALK,      0.197558925996189_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.324793474024219_REALK,      0.000000000000000_REALK, &
      0.407293240813709_REALK,      0.000000000000000_REALK,      0.679061796175630_REALK, &
      0.000000000000000_REALK,      0.493217929048909_REALK,      0.000000000000000_REALK, &
     -0.399971672855387_REALK,     -0.346459176046085_REALK,      0.000000000000000_REALK, &
     -0.374276569574995_REALK,      0.000000000000000_REALK,     -0.474769416464079_REALK, &
     -0.464611206255990_REALK,      0.000000000000000_REALK,     -0.443671424478586_REALK, &
      0.000000000000000_REALK,     -0.734819652157949_REALK,      0.000000000000000_REALK, &
     -0.617747711893480_REALK,      0.000000000000000_REALK,     -1.097057209440115_REALK, &
      0.129291509153946_REALK,     -0.081703629187955_REALK,      0.000000000000000_REALK, &
     -0.141864285673264_REALK,      0.000000000000000_REALK,     -0.288982337659576_REALK, &
     -0.036584649309348_REALK,      0.000000000000000_REALK,     -0.328846192478812_REALK, &
      0.000000000000000_REALK,      0.584788256042029_REALK,      0.000000000000000_REALK, &
     -0.354172856695526_REALK,      0.000000000000000_REALK,     -1.010046886774864_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.504988077194013_REALK, &
      0.000000000000000_REALK,      0.574650572225357_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.822892433805555_REALK,      0.000000000000000_REALK, &
      0.905354261227576_REALK,      0.000000000000000_REALK,      1.586296957368807_REALK, &
      0.000000000000000_REALK,      1.327854177853119_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.272686639800449_REALK, &
      0.000000000000000_REALK,      0.843845860797796_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.820725365370840_REALK,      0.000000000000000_REALK, &
      1.536538214779998_REALK,      0.000000000000000_REALK,      4.337582539212942_REALK, &
      0.000000000000000_REALK,      2.949397847354656_REALK,      0.000000000000000_REALK, &
     -1.998329484828510_REALK,     -0.763163515749361_REALK,      0.000000000000000_REALK, &
     -0.528285345209470_REALK,      0.000000000000000_REALK,     -0.951048821947124_REALK, &
     -0.413734617175764_REALK,      0.000000000000000_REALK,     -0.417543583540983_REALK, &
      0.000000000000000_REALK,     -0.458402797795686_REALK,      0.000000000000000_REALK, &
     -0.369660574872083_REALK,      0.000000000000000_REALK,     -1.109139399254620_REALK, &
     -0.668513029422953_REALK,     -0.417375203565659_REALK,      0.000000000000000_REALK, &
     -0.392455198370678_REALK,      0.000000000000000_REALK,     -0.556790364871699_REALK, &
     -0.505113525925806_REALK,      0.000000000000000_REALK,     -0.294833430899029_REALK, &
      0.000000000000000_REALK,     -1.039902905648280_REALK,      0.000000000000000_REALK, &
     -0.304299461712232_REALK,      0.000000000000000_REALK,     -0.719534395350210_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.770580122357276_REALK, &
      0.000000000000000_REALK,      0.384951207913047_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.306612277352076_REALK,      0.000000000000000_REALK, &
      0.702668954194293_REALK,      0.000000000000000_REALK,      0.310213629879501_REALK, &
      0.000000000000000_REALK,      0.448940729049929_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.461348292651992_REALK, &
      0.000000000000000_REALK,      0.255316649937605_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.154150841794862_REALK,      0.000000000000000_REALK, &
      0.543159962546737_REALK,      0.000000000000000_REALK,     -0.006453812475695_REALK, &
      0.000000000000000_REALK,      0.329943050250210_REALK,      0.000000000000000_REALK, &
     -0.728328215383478_REALK,     -0.421224319037197_REALK,      0.000000000000000_REALK, &
     -0.345350141010934_REALK,      0.000000000000000_REALK,     -0.577712281258056_REALK, &
     -0.343047532858993_REALK,      0.000000000000000_REALK,     -0.384101851516279_REALK, &
      0.000000000000000_REALK,     -0.450451176529047_REALK,      0.000000000000000_REALK, &
     -0.402756871249941_REALK,      0.000000000000000_REALK,     -0.943241622202526_REALK, &
     -0.419777012484647_REALK,     -0.409018667278068_REALK,      0.000000000000000_REALK, &
     -0.464675022677156_REALK,      0.000000000000000_REALK,     -0.582705660820173_REALK, &
     -0.662998283210130_REALK,      0.000000000000000_REALK,     -0.481550636554008_REALK, &
      0.000000000000000_REALK,     -1.287479279519320_REALK,      0.000000000000000_REALK, &
     -0.600494697054243_REALK,      0.000000000000000_REALK,     -1.054234247733080_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.578485941580887_REALK, &
      0.000000000000000_REALK,      0.425242781820281_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.415849016093891_REALK,      0.000000000000000_REALK, &
      0.738505626748557_REALK,      0.000000000000000_REALK,      0.519336078044833_REALK, &
      0.000000000000000_REALK,      0.694301825262580_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.598298305279816_REALK, &
      0.000000000000000_REALK,      0.470473159617714_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.345794738080110_REALK,      0.000000000000000_REALK, &
      0.986153772255911_REALK,      0.000000000000000_REALK,      0.067639560708090_REALK, &
      0.000000000000000_REALK,      0.851182596733432_REALK,      0.000000000000000_REALK, &
     -0.781414636415461_REALK,     -0.700186797687151_REALK,      0.000000000000000_REALK, &
     -0.788712205438025_REALK,      0.000000000000000_REALK,     -0.867748841453370_REALK, &
     -1.067846980659150_REALK,      0.000000000000000_REALK,     -0.893871143097972_REALK, &
      0.000000000000000_REALK,     -1.848480445943763_REALK,      0.000000000000000_REALK, &
     -1.287745135845544_REALK,      0.000000000000000_REALK,     -1.821586791030786_REALK, &
     -1.131167138027460_REALK,     -1.747067147845738_REALK,      0.000000000000000_REALK, &
     -2.604872536261243_REALK,      0.000000000000000_REALK,     -2.198292105290180_REALK, &
     -4.234975068508538_REALK,      0.000000000000000_REALK,     -2.879628511444108_REALK, &
      0.000000000000000_REALK,     -8.115052691203561_REALK,      0.000000000000000_REALK, &
     -4.712749546384467_REALK,      0.000000000000000_REALK,     -5.113494027623238_REALK, &
     -5.121901275891580_REALK,     -1.281657308547250_REALK,      0.000000000000000_REALK, &
     -0.728831671496390_REALK,      0.000000000000000_REALK,     -1.723311687735845_REALK, &
     -0.416188608956288_REALK,      0.000000000000000_REALK,     -0.504311568424559_REALK, &
      0.000000000000000_REALK,     -0.351847980059355_REALK,      0.000000000000000_REALK, &
     -0.360452802782311_REALK,      0.000000000000000_REALK,     -1.420475518571043_REALK, &
     -6.471773847497634_REALK,     -1.319365945673963_REALK,      0.000000000000000_REALK, &
     -0.462691667505395_REALK,      0.000000000000000_REALK,     -1.711152678177439_REALK, &
      0.105445103486465_REALK,      0.000000000000000_REALK,     -0.437642768407570_REALK, &
      0.000000000000000_REALK,      0.805379843915906_REALK,      0.000000000000000_REALK, &
     -0.194841901222341_REALK,      0.000000000000000_REALK,     -1.200959027766603_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.533508652821721_REALK, &
      0.000000000000000_REALK,      0.524637183992427_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.335180692928381_REALK,      0.000000000000000_REALK, &
      1.005685046410418_REALK,      0.000000000000000_REALK,      0.257098938764011_REALK, &
      0.000000000000000_REALK,      0.432443115947535_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.146436702229730_REALK, &
      0.000000000000000_REALK,      0.737252643701618_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.501846554575832_REALK,      0.000000000000000_REALK, &
      1.186646388309374_REALK,      0.000000000000000_REALK,      0.531886895864797_REALK, &
      0.000000000000000_REALK,      0.517434960357430_REALK,      0.000000000000000_REALK, &
     -1.574441903279015_REALK,     -0.620710519403442_REALK,      0.000000000000000_REALK, &
     -0.385253679156848_REALK,      0.000000000000000_REALK,     -0.882892890560285_REALK, &
     -0.281278628251931_REALK,      0.000000000000000_REALK,     -0.407066035372581_REALK, &
      0.000000000000000_REALK,     -0.261141253471215_REALK,      0.000000000000000_REALK, &
     -0.317553361690894_REALK,      0.000000000000000_REALK,     -1.018839971713209_REALK, &
     -3.082145833407727_REALK,     -0.984250200239538_REALK,      0.000000000000000_REALK, &
     -0.385465499266983_REALK,      0.000000000000000_REALK,     -1.358211370804804_REALK, &
      0.010643540204054_REALK,      0.000000000000000_REALK,     -0.544137613792079_REALK, &
      0.000000000000000_REALK,      0.547299908266124_REALK,      0.000000000000000_REALK, &
     -0.270535924199536_REALK,      0.000000000000000_REALK,     -1.334549932019448_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.931526081212957_REALK, &
      0.000000000000000_REALK,      0.482618154581218_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.365189950900055_REALK,      0.000000000000000_REALK, &
      0.855261291086115_REALK,      0.000000000000000_REALK,      0.355288764755013_REALK, &
      0.000000000000000_REALK,      0.556931279228865_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.246340626367799_REALK, &
      0.000000000000000_REALK,      1.204152727162152_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.990327728685612_REALK,      0.000000000000000_REALK, &
      1.738628855811158_REALK,      0.000000000000000_REALK,      1.163567134648867_REALK, &
      0.000000000000000_REALK,      1.183175148374039_REALK,      0.000000000000000_REALK, &
     -1.181956918505199_REALK,     -0.685678243243370_REALK,      0.000000000000000_REALK, &
     -0.522507985679791_REALK,      0.000000000000000_REALK,     -0.927921126446664_REALK, &
     -0.470895297833724_REALK,      0.000000000000000_REALK,     -0.629541213513182_REALK, &
      0.000000000000000_REALK,     -0.512309570705576_REALK,      0.000000000000000_REALK, &
     -0.602963311905358_REALK,      0.000000000000000_REALK,     -1.376744935227242_REALK, &
     -3.997072619805064_REALK,     -1.813682349640054_REALK,      0.000000000000000_REALK, &
     -0.864685134417400_REALK,      0.000000000000000_REALK,     -2.465949921197992_REALK, &
     -0.111550248243549_REALK,      0.000000000000000_REALK,     -1.403758820610530_REALK, &
      0.000000000000000_REALK,      1.002030152912836_REALK,      0.000000000000000_REALK, &
     -0.849621430183719_REALK,      0.000000000000000_REALK,     -3.115273548510765_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.399192476912348_REALK, &
      0.000000000000000_REALK,      1.123135542857607_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.167631433504161_REALK,      0.000000000000000_REALK, &
      1.651679308939461_REALK,      0.000000000000000_REALK,      1.548332512877712_REALK, &
      0.000000000000000_REALK,      1.666382116036224_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.474454937998043_REALK, &
      0.000000000000000_REALK,      7.200722545157332_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      7.772202780524291_REALK,      0.000000000000000_REALK, &
      8.433105156241085_REALK,      0.000000000000000_REALK,     10.405379776672715_REALK, &
      0.000000000000000_REALK,      9.096786711790106_REALK,      0.000000000000000_REALK, &
     -1.386400633304416_REALK,      5.127189086808163_REALK,      0.000000000000000_REALK, &
     -1.350046192463699_REALK,      0.000000000000000_REALK,     -1.826194298267775_REALK, &
      9.385179070008387_REALK,      0.000000000000000_REALK,      6.675404105247988_REALK, &
      0.000000000000000_REALK,    -13.126446979662907_REALK,      0.000000000000000_REALK, &
     -7.407688671723484_REALK,      0.000000000000000_REALK,    -16.700513522130169_REALK, &
     -3.333460166350851_REALK,      7.245793038441882_REALK,      0.000000000000000_REALK, &
     -2.325516212193040_REALK,      0.000000000000000_REALK,     -2.307437151255666_REALK, &
     19.389564076373013_REALK,      0.000000000000000_REALK,     11.579303265415831_REALK, &
      0.000000000000000_REALK,    -24.927089678469759_REALK,      0.000000000000000_REALK, &
    -11.754325066306308_REALK,      0.000000000000000_REALK,    -19.438240710975741_REALK, &
      0.344234983090827_REALK,      1.562840733580600_REALK,      0.000000000000000_REALK, &
     -0.320541381138964_REALK,      0.000000000000000_REALK,     -0.753102416051829_REALK, &
      1.628748990340185_REALK,      0.000000000000000_REALK,      1.820125296067753_REALK, &
      0.000000000000000_REALK,     -3.639602553058025_REALK,      0.000000000000000_REALK, &
     -3.618831548135360_REALK,      0.000000000000000_REALK,    -14.170561340637027_REALK, &
      1.112957474176751_REALK,      1.288050853105201_REALK,      0.000000000000000_REALK, &
      0.000811283533961_REALK,      0.000000000000000_REALK,      0.003229972810942_REALK, &
     -0.081573552781265_REALK,      0.000000000000000_REALK,      1.674176608075910_REALK, &
      0.000000000000000_REALK,      2.437529323523570_REALK,      0.000000000000000_REALK, &
     -1.543055625211098_REALK,      0.000000000000000_REALK,    -10.238976277650364_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.951468699189806_REALK, &
      0.000000000000000_REALK,      0.354304200111911_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.541127119530324_REALK,      0.000000000000000_REALK, &
     -5.728929724485052_REALK,      0.000000000000000_REALK,      5.623744306940109_REALK, &
      0.000000000000000_REALK,      6.666675466601664_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.936094812448832_REALK, &
      0.000000000000000_REALK,     -0.003665994781650_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -6.466082534725851_REALK,      0.000000000000000_REALK, &
    -10.693023041137826_REALK,      0.000000000000000_REALK,     11.675792814234498_REALK, &
      0.000000000000000_REALK,     11.621160858117491_REALK,      0.000000000000000_REALK, &
      0.680141213449604_REALK,      0.475947431023403_REALK,      0.000000000000000_REALK, &
     -0.217027919320081_REALK,      0.000000000000000_REALK,     -0.697859160709108_REALK, &
      0.311591502463452_REALK,      0.000000000000000_REALK,      0.409365577685119_REALK, &
      0.000000000000000_REALK,     -2.178188534264272_REALK,      0.000000000000000_REALK, &
     -2.488517209005385_REALK,      0.000000000000000_REALK,    -13.336490963369345_REALK, &
      0.476396194770982_REALK,      0.483601438163913_REALK,      0.000000000000000_REALK, &
      0.045286770159643_REALK,      0.000000000000000_REALK,      0.132225706142933_REALK, &
      0.666840517272797_REALK,      0.000000000000000_REALK,      0.551947439104669_REALK, &
      0.000000000000000_REALK,     -3.308952466809783_REALK,      0.000000000000000_REALK, &
     -1.861770597243310_REALK,      0.000000000000000_REALK,     -9.059817802154408_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.348295295236480_REALK, &
      0.000000000000000_REALK,      0.170493810372143_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.493591209267399_REALK,      0.000000000000000_REALK, &
     -1.932796377805110_REALK,      0.000000000000000_REALK,      1.749389568506057_REALK, &
      0.000000000000000_REALK,      3.258235027004666_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.580692287353440_REALK, &
      0.000000000000000_REALK,     -0.040264275705427_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.453138818680943_REALK,      0.000000000000000_REALK, &
     -3.006811639938096_REALK,      0.000000000000000_REALK,     -0.080653425688480_REALK, &
      0.000000000000000_REALK,      2.758820599018414_REALK,      0.000000000000000_REALK, &
      0.313807547527023_REALK,      0.634318355527009_REALK,      0.000000000000000_REALK, &
     -0.238031110377242_REALK,      0.000000000000000_REALK,     -0.536637263485036_REALK, &
      0.767051661883376_REALK,      0.000000000000000_REALK,      0.909302453453170_REALK, &
      0.000000000000000_REALK,     -4.836411344402703_REALK,      0.000000000000000_REALK, &
     -4.548911773718336_REALK,      0.000000000000000_REALK,    -14.357626560242464_REALK, &
      0.555933395673942_REALK,      1.794073825389840_REALK,      0.000000000000000_REALK, &
      0.155510552863036_REALK,      0.000000000000000_REALK,      0.257169300882582_REALK, &
      3.428751936458454_REALK,      0.000000000000000_REALK,      3.412708535525515_REALK, &
      0.000000000000000_REALK,    -13.557779417244726_REALK,      0.000000000000000_REALK, &
    -10.655244856309711_REALK,      0.000000000000000_REALK,    -24.668953636738873_REALK, &
      0.274154013230667_REALK,      0.054884225711306_REALK,      0.000000000000000_REALK, &
     -0.317576705492472_REALK,      0.000000000000000_REALK,     -1.245790259797459_REALK, &
     -0.005205236574991_REALK,      0.000000000000000_REALK,     -0.010746106882728_REALK, &
      0.000000000000000_REALK,     -1.513899402940080_REALK,      0.000000000000000_REALK, &
     -2.115067060025594_REALK,      0.000000000000000_REALK,    -13.828312428815686_REALK, &
      1.945246215353607_REALK,      0.071690236753312_REALK,      0.000000000000000_REALK, &
      0.017520219130187_REALK,      0.000000000000000_REALK,      0.103873899360974_REALK, &
     -0.057823114427541_REALK,      0.000000000000000_REALK,      0.025868348002514_REALK, &
      0.000000000000000_REALK,      0.847310489821760_REALK,      0.000000000000000_REALK, &
     -0.923743479508334_REALK,      0.000000000000000_REALK,     -9.127819360478185_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.427948510199542_REALK, &
      0.000000000000000_REALK,      0.155171303340259_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.026058112572740_REALK,      0.000000000000000_REALK, &
      0.139650946190447_REALK,      0.000000000000000_REALK,      0.786613135756706_REALK, &
      0.000000000000000_REALK,      1.722406517229061_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.266387850593833_REALK, &
      0.000000000000000_REALK,     -0.020858187794991_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.156505955571733_REALK,      0.000000000000000_REALK, &
     -0.761595142028482_REALK,      0.000000000000000_REALK,      1.328656395804589_REALK, &
      0.000000000000000_REALK,      1.832893263378740_REALK,      0.000000000000000_REALK, &
      0.096735775303820_REALK,      0.104552001685932_REALK,      0.000000000000000_REALK, &
     -0.187097292577517_REALK,      0.000000000000000_REALK,     -0.732632515736442_REALK, &
     -0.018318454919558_REALK,      0.000000000000000_REALK,     -0.034118090409376_REALK, &
      0.000000000000000_REALK,     -1.253223698512573_REALK,      0.000000000000000_REALK, &
     -2.076786036814953_REALK,      0.000000000000000_REALK,    -11.385142676154645_REALK, &
      1.276745887887836_REALK,      0.385629928201659_REALK,      0.000000000000000_REALK, &
      0.017124193188720_REALK,      0.000000000000000_REALK,      0.113627924339551_REALK, &
     -0.006779966058224_REALK,      0.000000000000000_REALK,      0.231914638000876_REALK, &
      0.000000000000000_REALK,      1.426232201456092_REALK,      0.000000000000000_REALK, &
     -1.504772065765845_REALK,      0.000000000000000_REALK,    -13.978922941002505_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.329082328291893_REALK, &
      0.000000000000000_REALK,      0.344673940663753_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.047633206896887_REALK,      0.000000000000000_REALK, &
      0.150343605352723_REALK,      0.000000000000000_REALK,      3.227371458416927_REALK, &
      0.000000000000000_REALK,      5.356248742611047_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.463031491254536_REALK, &
      0.000000000000000_REALK,     -0.128966837202884_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.895711469800167_REALK,      0.000000000000000_REALK, &
     -2.073745373135261_REALK,      0.000000000000000_REALK,     11.386113750841657_REALK, &
      0.000000000000000_REALK,     15.865972116296204_REALK,      0.000000000000000_REALK, &
     -1.554257493185792_REALK,      0.074417305233181_REALK,      0.000000000000000_REALK, &
     -0.666979059280962_REALK,      0.000000000000000_REALK,     -2.708436754792098_REALK, &
      0.138669204671736_REALK,      0.000000000000000_REALK,      0.136319421629407_REALK, &
      0.000000000000000_REALK,     -1.773500340957529_REALK,      0.000000000000000_REALK, &
     -2.367177661237040_REALK,      0.000000000000000_REALK,    -16.020870254729765_REALK, &
      0.018622655552103_REALK,      0.008550115636407_REALK,      0.000000000000000_REALK, &
     -0.303424873305876_REALK,      0.000000000000000_REALK,     -1.268786996677970_REALK, &
     -0.002706180439083_REALK,      0.000000000000000_REALK,      0.098615929478637_REALK, &
      0.000000000000000_REALK,     -2.362129359093005_REALK,      0.000000000000000_REALK, &
     -1.722054017162081_REALK,      0.000000000000000_REALK,    -12.001431747872035_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.672267604490460_REALK, &
      0.000000000000000_REALK,      0.102218035265833_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.313927735417266_REALK,      0.000000000000000_REALK, &
      2.052460126426446_REALK,      0.000000000000000_REALK,      0.175725788593386_REALK, &
      0.000000000000000_REALK,      0.604637297802806_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.084914666980506_REALK, &
      0.000000000000000_REALK,      0.037197452000658_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.165192715891791_REALK,      0.000000000000000_REALK, &
      1.632324669971818_REALK,      0.000000000000000_REALK,     -0.471890862367625_REALK, &
      0.000000000000000_REALK,      0.351849981556792_REALK,      0.000000000000000_REALK, &
     -0.457378533110133_REALK,     -0.083735315444815_REALK,      0.000000000000000_REALK, &
     -0.247867353171654_REALK,      0.000000000000000_REALK,     -1.328373661120574_REALK, &
     -0.116752648190072_REALK,      0.000000000000000_REALK,     -0.255647297261164_REALK, &
      0.000000000000000_REALK,     -0.770003684671378_REALK,      0.000000000000000_REALK, &
     -1.466178118621479_REALK,      0.000000000000000_REALK,    -11.000582846079920_REALK, &
      0.009644346478414_REALK,     -0.017051117569713_REALK,      0.000000000000000_REALK, &
     -0.225048107812333_REALK,      0.000000000000000_REALK,     -1.095137530111547_REALK, &
     -0.237603147820626_REALK,      0.000000000000000_REALK,     -0.327775646414801_REALK, &
      0.000000000000000_REALK,     -2.270049451049613_REALK,      0.000000000000000_REALK, &
     -2.128725714378497_REALK,      0.000000000000000_REALK,    -14.502438706584449_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.395351546901669_REALK, &
      0.000000000000000_REALK,      0.324534662341196_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.308245894329056_REALK,      0.000000000000000_REALK, &
      1.689833918402781_REALK,      0.000000000000000_REALK,      1.030700811313015_REALK, &
      0.000000000000000_REALK,      2.687549854381561_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.092888371519094_REALK, &
      0.000000000000000_REALK,      0.333482200504234_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.269097850059268_REALK,      0.000000000000000_REALK, &
      2.499845787377414_REALK,      0.000000000000000_REALK,     -0.092218139801971_REALK, &
      0.000000000000000_REALK,      4.416162390176647_REALK,      0.000000000000000_REALK, &
     -0.351713322979981_REALK,     -0.185996898432951_REALK,      0.000000000000000_REALK, &
     -0.453091791803838_REALK,      0.000000000000000_REALK,     -1.430083296364551_REALK, &
     -0.479020940961978_REALK,      0.000000000000000_REALK,     -0.794998451764984_REALK, &
      0.000000000000000_REALK,     -2.849504299248987_REALK,      0.000000000000000_REALK, &
     -3.752162466404475_REALK,      0.000000000000000_REALK,    -15.226540559662627_REALK, &
      0.018757546574507_REALK,     -0.105427601158549_REALK,      0.000000000000000_REALK, &
     -1.287990419840223_REALK,      0.000000000000000_REALK,     -2.981947048620573_REALK, &
     -2.036174647701456_REALK,      0.000000000000000_REALK,     -2.837306116141032_REALK, &
      0.000000000000000_REALK,    -15.501799049836757_REALK,      0.000000000000000_REALK, &
    -17.056307180430775_REALK,      0.000000000000000_REALK,    -50.771123389727386_REALK, &
     -8.177401049566454_REALK,      1.115418522243528_REALK,      0.000000000000000_REALK, &
     -1.731367066628035_REALK,      0.000000000000000_REALK,     -6.461193366768227_REALK, &
      0.892247850385952_REALK,      0.000000000000000_REALK,      1.069247093896467_REALK, &
      0.000000000000000_REALK,     -2.810777125934166_REALK,      0.000000000000000_REALK, &
     -3.392868536853145_REALK,      0.000000000000000_REALK,    -21.102765272576235_REALK, &
     -9.687747044249766_REALK,      1.486037805528613_REALK,      0.000000000000000_REALK, &
     -1.500874825111766_REALK,      0.000000000000000_REALK,     -6.581322084244484_REALK, &
      1.320675073385082_REALK,      0.000000000000000_REALK,      1.392144894732011_REALK, &
      0.000000000000000_REALK,     -0.727135710522549_REALK,      0.000000000000000_REALK, &
     -2.742418833488069_REALK,      0.000000000000000_REALK,    -20.042468267064386_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.088660004685890_REALK, &
      0.000000000000000_REALK,     -0.181892408151881_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.729128091972643_REALK,      0.000000000000000_REALK, &
      4.934680971291352_REALK,      0.000000000000000_REALK,     -0.362589098680325_REALK, &
      0.000000000000000_REALK,     -0.594074898583741_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.335147403922479_REALK, &
      0.000000000000000_REALK,     -0.273905185494776_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.971227364052618_REALK,      0.000000000000000_REALK, &
      6.768730135743516_REALK,      0.000000000000000_REALK,      0.013734069542765_REALK, &
      0.000000000000000_REALK,     -0.834138782176567_REALK,      0.000000000000000_REALK, &
     -2.079626659742793_REALK,     -0.116567889844407_REALK,      0.000000000000000_REALK, &
     -0.418877010320260_REALK,      0.000000000000000_REALK,     -2.738618683743635_REALK, &
     -0.054126317194345_REALK,      0.000000000000000_REALK,     -0.186237833560862_REALK, &
      0.000000000000000_REALK,     -0.587539786856796_REALK,      0.000000000000000_REALK, &
     -1.368085232107562_REALK,      0.000000000000000_REALK,    -12.522361360043387_REALK, &
     -4.004244813564375_REALK,     -0.127094963847672_REALK,      0.000000000000000_REALK, &
     -0.458821832618115_REALK,      0.000000000000000_REALK,     -4.533772524176096_REALK, &
      0.266143404219758_REALK,      0.000000000000000_REALK,     -0.198441121314258_REALK, &
      0.000000000000000_REALK,      0.768996887820461_REALK,      0.000000000000000_REALK, &
     -1.397275790908289_REALK,      0.000000000000000_REALK,    -19.329731487962398_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.514857081717689_REALK, &
      0.000000000000000_REALK,      0.341112821493381_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.451606008128627_REALK,      0.000000000000000_REALK, &
      3.388353190591412_REALK,      0.000000000000000_REALK,      0.508803637837161_REALK, &
      0.000000000000000_REALK,      1.559741792692727_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.741827929377910_REALK, &
      0.000000000000000_REALK,      0.910395001158158_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.200587579577802_REALK,      0.000000000000000_REALK, &
      8.179281937126927_REALK,      0.000000000000000_REALK,      2.009756450222893_REALK, &
      0.000000000000000_REALK,      3.881467547507440_REALK,      0.000000000000000_REALK, &
     -1.223000500716423_REALK,     -0.370094383756225_REALK,      0.000000000000000_REALK, &
     -0.411295671242397_REALK,      0.000000000000000_REALK,     -2.254762799908367_REALK, &
     -0.317472122288696_REALK,      0.000000000000000_REALK,     -0.827807785404054_REALK, &
      0.000000000000000_REALK,     -0.810620555190114_REALK,      0.000000000000000_REALK, &
     -1.880653576086182_REALK,      0.000000000000000_REALK,    -13.255618480906822_REALK, &
     -4.380253649009310_REALK,     -1.139430416260181_REALK,      0.000000000000000_REALK, &
     -0.747417754174255_REALK,      0.000000000000000_REALK,     -6.943307513501439_REALK, &
      0.052010436342354_REALK,      0.000000000000000_REALK,     -2.490687118228696_REALK, &
      0.000000000000000_REALK,      2.157351874753287_REALK,      0.000000000000000_REALK, &
     -3.186614330667087_REALK,      0.000000000000000_REALK,    -38.060716936152744_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.630845199924043_REALK, &
      0.000000000000000_REALK,      1.060774621401091_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.155725277701034_REALK,      0.000000000000000_REALK, &
      4.690014884564744_REALK,      0.000000000000000_REALK,      2.922577274228411_REALK, &
      0.000000000000000_REALK,      6.236231889266885_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     10.188613250536655_REALK, &
      0.000000000000000_REALK,      7.880601665022370_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      9.619647292261657_REALK,      0.000000000000000_REALK, &
     28.634586283801820_REALK,      0.000000000000000_REALK,     24.112059277609937_REALK, &
      0.000000000000000_REALK,     43.198626688468984_REALK,      0.000000000000000_REALK/
    ! results of test 7, ket-major order, 01ODGYZZ
  data REF_CONTR_INTS(50401:51660)                                                         &
     /0.433107785717250_REALK,      0.107942768169482_REALK,      0.000000000000000_REALK, &
     -0.026731784622632_REALK,      0.000000000000000_REALK,     -0.039630824955685_REALK, &
     -0.044243691230438_REALK,      0.000000000000000_REALK,     -0.123403877126191_REALK, &
      0.000000000000000_REALK,      0.369739658363427_REALK,      0.000000000000000_REALK, &
     -0.259887630472186_REALK,      0.000000000000000_REALK,     -0.642154482437787_REALK, &
      0.386253092198582_REALK,     -0.231308840951186_REALK,      0.000000000000000_REALK, &
     -0.443928564898617_REALK,      0.000000000000000_REALK,      0.071049464651703_REALK, &
     -0.220993494323394_REALK,      0.000000000000000_REALK,     -0.015792560829542_REALK, &
      0.000000000000000_REALK,      2.866132629577696_REALK,      0.000000000000000_REALK, &
      0.352877351682529_REALK,      0.000000000000000_REALK,     -0.094128308423076_REALK, &
      0.254391856291735_REALK,      0.004911509880398_REALK,      0.000000000000000_REALK, &
     -0.099807409876685_REALK,      0.000000000000000_REALK,     -0.120628121334548_REALK, &
     -0.199788642206742_REALK,      0.000000000000000_REALK,     -0.153071278194199_REALK, &
      0.000000000000000_REALK,     -0.495420377411394_REALK,      0.000000000000000_REALK, &
     -0.280858572196423_REALK,      0.000000000000000_REALK,     -0.565746938138448_REALK, &
      0.385919392841686_REALK,      0.227246366244709_REALK,      0.000000000000000_REALK, &
      0.133361827641766_REALK,      0.000000000000000_REALK,      0.082408715471331_REALK, &
     -0.077685368029438_REALK,      0.000000000000000_REALK,     -0.022856316551863_REALK, &
      0.000000000000000_REALK,     -1.227868694370563_REALK,      0.000000000000000_REALK, &
     -0.228066973220600_REALK,      0.000000000000000_REALK,     -0.234883632456785_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.003869927758047_REALK, &
      0.000000000000000_REALK,      0.058360025991333_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.081353526838704_REALK,      0.000000000000000_REALK, &
      0.201015846066546_REALK,      0.000000000000000_REALK,      0.058879338645282_REALK, &
      0.000000000000000_REALK,      0.273709029445198_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.065628796984642_REALK, &
      0.000000000000000_REALK,      0.032026235543455_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.041243548057882_REALK,      0.000000000000000_REALK, &
      0.011001514813983_REALK,      0.000000000000000_REALK,     -0.766414449933914_REALK, &
      0.000000000000000_REALK,     -0.091282074903596_REALK,      0.000000000000000_REALK, &
      0.048643707912963_REALK,     -0.089906225758400_REALK,      0.000000000000000_REALK, &
     -0.129893681506162_REALK,      0.000000000000000_REALK,     -0.214079313596341_REALK, &
     -0.148452179270505_REALK,      0.000000000000000_REALK,     -0.156979209560322_REALK, &
      0.000000000000000_REALK,     -0.197135192270778_REALK,      0.000000000000000_REALK, &
     -0.195627254424750_REALK,      0.000000000000000_REALK,     -0.537359321643890_REALK, &
      0.962284897509302_REALK,      0.159811754095371_REALK,      0.000000000000000_REALK, &
     -0.004038366162729_REALK,      0.000000000000000_REALK,      0.088317963549500_REALK, &
      0.042937559754173_REALK,      0.000000000000000_REALK,     -0.014109851736543_REALK, &
      0.000000000000000_REALK,      0.610398977292877_REALK,      0.000000000000000_REALK, &
      0.005131541821674_REALK,      0.000000000000000_REALK,     -0.187042360407229_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.085157398318466_REALK, &
      0.000000000000000_REALK,      0.098858861070563_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.123023754590042_REALK,      0.000000000000000_REALK, &
      0.247812669320757_REALK,      0.000000000000000_REALK,      0.194327392458616_REALK, &
      0.000000000000000_REALK,      0.248145089924622_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.320492623106337_REALK, &
      0.000000000000000_REALK,     -0.082537576326859_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.045792058140517_REALK,      0.000000000000000_REALK, &
      0.047160730033950_REALK,      0.000000000000000_REALK,      0.356473192490593_REALK, &
      0.000000000000000_REALK,      0.174800487669927_REALK,      0.000000000000000_REALK, &
      0.017699272144203_REALK,     -0.041199248767514_REALK,      0.000000000000000_REALK, &
     -0.052540993334781_REALK,      0.000000000000000_REALK,     -0.129823163651008_REALK, &
     -0.025790764551973_REALK,      0.000000000000000_REALK,     -0.119892058854429_REALK, &
      0.000000000000000_REALK,      0.112577095394195_REALK,      0.000000000000000_REALK, &
     -0.131882861835542_REALK,      0.000000000000000_REALK,     -0.456215784578759_REALK, &
      0.259719065355252_REALK,     -0.124552023154807_REALK,      0.000000000000000_REALK, &
     -0.148936618378278_REALK,      0.000000000000000_REALK,      0.039728114834678_REALK, &
      0.153883285052234_REALK,      0.000000000000000_REALK,      0.018327923689018_REALK, &
      0.000000000000000_REALK,      1.537149702262287_REALK,      0.000000000000000_REALK, &
      0.315422316513563_REALK,      0.000000000000000_REALK,     -0.117792305261431_REALK, &
     -0.385227550501183_REALK,     -0.215651613572618_REALK,      0.000000000000000_REALK, &
     -0.186931525005443_REALK,      0.000000000000000_REALK,     -0.382776318723410_REALK, &
     -0.162936243134136_REALK,      0.000000000000000_REALK,     -0.179941616296000_REALK, &
      0.000000000000000_REALK,     -0.203789905814507_REALK,      0.000000000000000_REALK, &
     -0.175059959288946_REALK,      0.000000000000000_REALK,     -0.597445212184352_REALK, &
      0.219952270376572_REALK,      0.024220906325373_REALK,      0.000000000000000_REALK, &
     -0.055472031899823_REALK,      0.000000000000000_REALK,     -0.069310664581978_REALK, &
     -0.195665875002628_REALK,      0.000000000000000_REALK,     -0.078967357295527_REALK, &
      0.000000000000000_REALK,     -0.700749906668042_REALK,      0.000000000000000_REALK, &
     -0.138218343412928_REALK,      0.000000000000000_REALK,     -0.287832892578813_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.230262177183990_REALK, &
      0.000000000000000_REALK,      0.133716373374615_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.116577525905140_REALK,      0.000000000000000_REALK, &
      0.320221333287718_REALK,      0.000000000000000_REALK,      0.118422248498187_REALK, &
      0.000000000000000_REALK,      0.208707287142926_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.023972138430130_REALK, &
      0.000000000000000_REALK,      0.019564275352181_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.003573720957298_REALK,      0.000000000000000_REALK, &
      0.130260499966432_REALK,      0.000000000000000_REALK,     -0.148344102199820_REALK, &
      0.000000000000000_REALK,      0.081246399811478_REALK,      0.000000000000000_REALK, &
     -0.127464570006007_REALK,     -0.106331883270886_REALK,      0.000000000000000_REALK, &
     -0.104792796121118_REALK,      0.000000000000000_REALK,     -0.211089172322026_REALK, &
     -0.115802916597885_REALK,      0.000000000000000_REALK,     -0.147873775226184_REALK, &
      0.000000000000000_REALK,     -0.173109891744620_REALK,      0.000000000000000_REALK, &
     -0.163562768257909_REALK,      0.000000000000000_REALK,     -0.461261297657323_REALK, &
      0.124509208392644_REALK,      0.022403168346221_REALK,      0.000000000000000_REALK, &
     -0.063493823403111_REALK,      0.000000000000000_REALK,     -0.065391580678658_REALK, &
     -0.248255936127827_REALK,      0.000000000000000_REALK,     -0.121734984891588_REALK, &
      0.000000000000000_REALK,     -0.851750931295050_REALK,      0.000000000000000_REALK, &
     -0.263676751063178_REALK,      0.000000000000000_REALK,     -0.380180843781812_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.139636865463611_REALK, &
      0.000000000000000_REALK,      0.102125188114607_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.078591184992533_REALK,      0.000000000000000_REALK, &
      0.271866553571256_REALK,      0.000000000000000_REALK,      0.034289384677502_REALK, &
      0.000000000000000_REALK,      0.223158754544638_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.010783399323414_REALK, &
      0.000000000000000_REALK,     -0.025412920871241_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.219667184268698_REALK,      0.000000000000000_REALK, &
      0.082033206500101_REALK,      0.000000000000000_REALK,     -0.886080388022589_REALK, &
      0.000000000000000_REALK,     -0.147748465467847_REALK,      0.000000000000000_REALK, &
     -1.327042145095716_REALK,     -0.406394825455068_REALK,      0.000000000000000_REALK, &
     -0.277229543840981_REALK,      0.000000000000000_REALK,     -0.737042371025398_REALK, &
     -0.166159085304762_REALK,      0.000000000000000_REALK,     -0.223751909746734_REALK, &
      0.000000000000000_REALK,     -0.147622370804358_REALK,      0.000000000000000_REALK, &
     -0.176045589381750_REALK,      0.000000000000000_REALK,     -0.780057906820800_REALK, &
      2.463352787810691_REALK,      0.220122320910970_REALK,      0.000000000000000_REALK, &
      0.002629719071757_REALK,      0.000000000000000_REALK,      0.027328300709655_REALK, &
      0.098032447417320_REALK,      0.000000000000000_REALK,     -0.057289827901045_REALK, &
      0.000000000000000_REALK,      0.581853298479236_REALK,      0.000000000000000_REALK, &
     -0.022118036487266_REALK,      0.000000000000000_REALK,     -0.383088038264147_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.524138189254601_REALK, &
      0.000000000000000_REALK,      0.198280476023128_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.140929487587970_REALK,      0.000000000000000_REALK, &
      0.480964624674988_REALK,      0.000000000000000_REALK,      0.114012290996729_REALK, &
      0.000000000000000_REALK,      0.209852593514875_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.444478861451153_REALK, &
      0.000000000000000_REALK,     -0.011470971342246_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.092584557866829_REALK,      0.000000000000000_REALK, &
      0.192802781750365_REALK,      0.000000000000000_REALK,      0.239058887442175_REALK, &
      0.000000000000000_REALK,      0.160800042240920_REALK,      0.000000000000000_REALK, &
     -0.381190534534198_REALK,     -0.183098729952795_REALK,      0.000000000000000_REALK, &
     -0.128458595659416_REALK,      0.000000000000000_REALK,     -0.352856886050216_REALK, &
     -0.095334117908243_REALK,      0.000000000000000_REALK,     -0.168016782092243_REALK, &
      0.000000000000000_REALK,     -0.082202231893352_REALK,      0.000000000000000_REALK, &
     -0.135955743092239_REALK,      0.000000000000000_REALK,     -0.522830627741771_REALK, &
      1.023365018252599_REALK,      0.125462753619526_REALK,      0.000000000000000_REALK, &
     -0.000519126536462_REALK,      0.000000000000000_REALK,      0.018921925632506_REALK, &
      0.099367224170026_REALK,      0.000000000000000_REALK,     -0.054422313414254_REALK, &
      0.000000000000000_REALK,      0.519369411638486_REALK,      0.000000000000000_REALK, &
      0.007277114247856_REALK,      0.000000000000000_REALK,     -0.371346496324462_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.289045824258701_REALK, &
      0.000000000000000_REALK,      0.162944421344717_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.131673840281263_REALK,      0.000000000000000_REALK, &
      0.371331734492830_REALK,      0.000000000000000_REALK,      0.135052373569200_REALK, &
      0.000000000000000_REALK,      0.241435940367489_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.419346366159337_REALK, &
      0.000000000000000_REALK,     -0.017683490632897_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.176621965031183_REALK,      0.000000000000000_REALK, &
      0.254661389087989_REALK,      0.000000000000000_REALK,      0.505519829750903_REALK, &
      0.000000000000000_REALK,      0.347041966914388_REALK,      0.000000000000000_REALK, &
     -0.231163676282892_REALK,     -0.139840707372376_REALK,      0.000000000000000_REALK, &
     -0.086600853611914_REALK,      0.000000000000000_REALK,     -0.299573999425469_REALK, &
     -0.027604173061248_REALK,      0.000000000000000_REALK,     -0.179650726850884_REALK, &
      0.000000000000000_REALK,      0.078238089597945_REALK,      0.000000000000000_REALK, &
     -0.128317117921986_REALK,      0.000000000000000_REALK,     -0.570704123683394_REALK, &
      0.460340810962477_REALK,     -0.162969237174712_REALK,      0.000000000000000_REALK, &
     -0.031909336488847_REALK,      0.000000000000000_REALK,      0.011916323315134_REALK, &
      0.593534540596052_REALK,      0.000000000000000_REALK,      0.098968241212212_REALK, &
      0.000000000000000_REALK,      2.179854396231460_REALK,      0.000000000000000_REALK, &
      0.626226977914732_REALK,      0.000000000000000_REALK,     -0.300677372775887_REALK, &
     -6.775953626185209_REALK,     -1.049615407265602_REALK,      0.000000000000000_REALK, &
     -0.589109367067054_REALK,      0.000000000000000_REALK,     -1.939830965008158_REALK, &
     -0.235252136861008_REALK,      0.000000000000000_REALK,     -0.344322986170417_REALK, &
      0.000000000000000_REALK,     -0.193248223921548_REALK,      0.000000000000000_REALK, &
     -0.234896006655484_REALK,      0.000000000000000_REALK,     -1.289117020652201_REALK, &
     -4.015685779149440_REALK,     -1.016078437906020_REALK,      0.000000000000000_REALK, &
     -0.831334562004249_REALK,      0.000000000000000_REALK,     -1.882364551446142_REALK, &
     -0.891518130762937_REALK,      0.000000000000000_REALK,     -0.407330961514097_REALK, &
      0.000000000000000_REALK,     -1.689391202865268_REALK,      0.000000000000000_REALK, &
     -0.340360418115210_REALK,      0.000000000000000_REALK,     -1.284445547070826_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.726884864887036_REALK, &
      0.000000000000000_REALK,      0.383485564436559_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.213081751199167_REALK,      0.000000000000000_REALK, &
      0.944165118852810_REALK,      0.000000000000000_REALK,      0.113549720049415_REALK, &
      0.000000000000000_REALK,      0.254845796982886_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.674254517721772_REALK, &
      0.000000000000000_REALK,      0.359744734205120_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.064586000964325_REALK,      0.000000000000000_REALK, &
      1.118640184131807_REALK,      0.000000000000000_REALK,     -0.252028691891101_REALK, &
      0.000000000000000_REALK,      0.245474513200407_REALK,      0.000000000000000_REALK, &
     -1.727639768084007_REALK,     -0.464569699799710_REALK,      0.000000000000000_REALK, &
     -0.241537263992968_REALK,      0.000000000000000_REALK,     -0.824319179113498_REALK, &
     -0.137997996479942_REALK,      0.000000000000000_REALK,     -0.254001013469708_REALK, &
      0.000000000000000_REALK,     -0.112113960189109_REALK,      0.000000000000000_REALK, &
     -0.160513881751439_REALK,      0.000000000000000_REALK,     -0.766923234436103_REALK, &
     -1.549663703276136_REALK,     -0.702763256173713_REALK,      0.000000000000000_REALK, &
     -0.581373838630319_REALK,      0.000000000000000_REALK,     -1.210682384918244_REALK, &
     -0.698066374190121_REALK,      0.000000000000000_REALK,     -0.469545824703501_REALK, &
      0.000000000000000_REALK,     -1.206746539885406_REALK,      0.000000000000000_REALK, &
     -0.396704792192615_REALK,      0.000000000000000_REALK,     -1.156565467535445_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.826741093790238_REALK, &
      0.000000000000000_REALK,      0.287961835000153_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.164557873477071_REALK,      0.000000000000000_REALK, &
      0.632822816697761_REALK,      0.000000000000000_REALK,      0.108582310137540_REALK, &
      0.000000000000000_REALK,      0.267911541412850_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.159242201364778_REALK, &
      0.000000000000000_REALK,      0.341738514345953_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.021249612645324_REALK,      0.000000000000000_REALK, &
      1.084354173279273_REALK,      0.000000000000000_REALK,     -0.425767049315361_REALK, &
      0.000000000000000_REALK,      0.326462967945211_REALK,      0.000000000000000_REALK, &
     -0.952739317656139_REALK,     -0.381777583080459_REALK,      0.000000000000000_REALK, &
     -0.225674127291002_REALK,      0.000000000000000_REALK,     -0.636420757062466_REALK, &
     -0.163464454660814_REALK,      0.000000000000000_REALK,     -0.292228809347583_REALK, &
      0.000000000000000_REALK,     -0.158725849168268_REALK,      0.000000000000000_REALK, &
     -0.209960821021647_REALK,      0.000000000000000_REALK,     -0.761281534857776_REALK, &
     -1.462039928324657_REALK,     -1.083370107631999_REALK,      0.000000000000000_REALK, &
     -1.109076849989454_REALK,      0.000000000000000_REALK,     -1.599116232082348_REALK, &
     -1.476148401806558_REALK,      0.000000000000000_REALK,     -1.013383481065243_REALK, &
      0.000000000000000_REALK,     -2.444636998649374_REALK,      0.000000000000000_REALK, &
     -1.059501650903604_REALK,      0.000000000000000_REALK,     -1.964104083634572_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.701899681563481_REALK, &
      0.000000000000000_REALK,      0.307901105585334_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.155312247763029_REALK,      0.000000000000000_REALK, &
      0.690767854611473_REALK,      0.000000000000000_REALK,      0.044016296837574_REALK, &
      0.000000000000000_REALK,      0.368308895715987_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.730047519491287_REALK, &
      0.000000000000000_REALK,     -0.621459427162743_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.828620556927482_REALK,      0.000000000000000_REALK, &
      0.877996068920238_REALK,      0.000000000000000_REALK,     -3.560433865169622_REALK, &
      0.000000000000000_REALK,     -0.763303488648903_REALK,      0.000000000000000_REALK, &
      1.296393566922173_REALK,      1.008211218252836_REALK,      0.000000000000000_REALK, &
      0.200632901072232_REALK,      0.000000000000000_REALK,      0.680201949430865_REALK, &
      0.509309308502173_REALK,      0.000000000000000_REALK,      1.199640585368709_REALK, &
      0.000000000000000_REALK,     -0.127826212588713_REALK,      0.000000000000000_REALK, &
     -0.621638287421078_REALK,      0.000000000000000_REALK,     -3.512547648673447_REALK, &
      1.363144466709778_REALK,      0.043634623099404_REALK,      0.000000000000000_REALK, &
     -0.244456749860396_REALK,      0.000000000000000_REALK,      0.781790476035255_REALK, &
     -3.506013993645000_REALK,      0.000000000000000_REALK,      0.057594579959798_REALK, &
      0.000000000000000_REALK,      1.734015384507086_REALK,      0.000000000000000_REALK, &
      0.237274048190451_REALK,      0.000000000000000_REALK,     -1.264699455640306_REALK, &
      1.705033634541135_REALK,      0.415378282687688_REALK,      0.000000000000000_REALK, &
      0.172585150542671_REALK,      0.000000000000000_REALK,      0.632156267347930_REALK, &
      0.260538841201463_REALK,      0.000000000000000_REALK,      0.397394731929149_REALK, &
      0.000000000000000_REALK,     -0.668869600693583_REALK,      0.000000000000000_REALK, &
     -0.827892544368846_REALK,      0.000000000000000_REALK,     -5.054098985995830_REALK, &
      0.898315946654826_REALK,      0.448273818014275_REALK,      0.000000000000000_REALK, &
      0.379370419547737_REALK,      0.000000000000000_REALK,      1.012375472929209_REALK, &
      1.090090782491417_REALK,      0.000000000000000_REALK,      0.565364855952231_REALK, &
      0.000000000000000_REALK,     -1.368392198836616_REALK,      0.000000000000000_REALK, &
     -0.532116213800074_REALK,      0.000000000000000_REALK,     -2.366646492195139_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.486354154527872_REALK, &
      0.000000000000000_REALK,     -0.107076727234095_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.419435225534613_REALK,      0.000000000000000_REALK, &
     -2.370005588514316_REALK,      0.000000000000000_REALK,      0.218070087652707_REALK, &
      0.000000000000000_REALK,      0.856080065152204_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.320492217188477_REALK, &
      0.000000000000000_REALK,     -0.011491298310554_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.520754388109662_REALK,      0.000000000000000_REALK, &
     -2.775684050520181_REALK,      0.000000000000000_REALK,     -0.981169763607805_REALK, &
      0.000000000000000_REALK,      0.026863393636704_REALK,      0.000000000000000_REALK, &
      1.891863190975506_REALK,      0.055548351614549_REALK,      0.000000000000000_REALK, &
      0.086228590795564_REALK,      0.000000000000000_REALK,      0.361319061054740_REALK, &
     -0.003909145400459_REALK,      0.000000000000000_REALK,      0.033289687938147_REALK, &
      0.000000000000000_REALK,     -0.599191416938610_REALK,      0.000000000000000_REALK, &
     -0.914173252611858_REALK,      0.000000000000000_REALK,     -6.384352301782549_REALK, &
      3.385837742199640_REALK,     -0.062069372082193_REALK,      0.000000000000000_REALK, &
      0.156369422362335_REALK,      0.000000000000000_REALK,      1.374956810791160_REALK, &
     -0.395946822893065_REALK,      0.000000000000000_REALK,     -0.041216981621329_REALK, &
      0.000000000000000_REALK,      0.710156926346978_REALK,      0.000000000000000_REALK, &
     -0.203944321431826_REALK,      0.000000000000000_REALK,     -2.988805073892077_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.032747286759769_REALK, &
      0.000000000000000_REALK,     -0.032449021065153_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.168970772098287_REALK,      0.000000000000000_REALK, &
     -1.031528806164017_REALK,      0.000000000000000_REALK,      0.225542916844727_REALK, &
      0.000000000000000_REALK,      0.573360236581909_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.976428643311661_REALK, &
      0.000000000000000_REALK,     -0.231025719529114_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.491815058515921_REALK,      0.000000000000000_REALK, &
     -2.187402587741429_REALK,      0.000000000000000_REALK,      0.580970359890277_REALK, &
      0.000000000000000_REALK,      0.502190932332538_REALK,      0.000000000000000_REALK, &
      0.607965546895693_REALK,      0.174930164008425_REALK,      0.000000000000000_REALK, &
      0.034248723939467_REALK,      0.000000000000000_REALK,      0.193521340589745_REALK, &
      0.044507552740809_REALK,      0.000000000000000_REALK,      0.174723773719931_REALK, &
      0.000000000000000_REALK,     -0.074662715713639_REALK,      0.000000000000000_REALK, &
     -0.605160211802176_REALK,      0.000000000000000_REALK,     -4.787214318791231_REALK, &
      1.675829721277776_REALK,      0.022434098550515_REALK,      0.000000000000000_REALK, &
     -0.212796490521766_REALK,      0.000000000000000_REALK,      1.134231104402240_REALK, &
     -0.906858412106439_REALK,      0.000000000000000_REALK,      0.024828827182356_REALK, &
      0.000000000000000_REALK,      2.028275539383374_REALK,      0.000000000000000_REALK, &
      0.462565242476175_REALK,      0.000000000000000_REALK,     -3.451740385208318_REALK, &
      1.645792807344768_REALK,     -0.099834381721052_REALK,      0.000000000000000_REALK, &
     -0.076509124732047_REALK,      0.000000000000000_REALK,     -0.313572713793666_REALK, &
      0.017450550076280_REALK,      0.000000000000000_REALK,      0.019237950994065_REALK, &
      0.000000000000000_REALK,     -0.922800342265564_REALK,      0.000000000000000_REALK, &
     -1.216846737763380_REALK,      0.000000000000000_REALK,     -8.312079009481529_REALK, &
      1.836926153241244_REALK,     -0.181600166600883_REALK,      0.000000000000000_REALK, &
      0.260317357121755_REALK,      0.000000000000000_REALK,      1.011273140906391_REALK, &
      0.023866319490194_REALK,      0.000000000000000_REALK,     -0.082272990064027_REALK, &
      0.000000000000000_REALK,     -1.287739379475838_REALK,      0.000000000000000_REALK, &
     -0.731467856128321_REALK,      0.000000000000000_REALK,     -4.735974354007280_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.554536836064881_REALK, &
      0.000000000000000_REALK,      0.004704516871320_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.025501721423712_REALK,      0.000000000000000_REALK, &
      0.178097503296807_REALK,      0.000000000000000_REALK,     -0.008786375894192_REALK, &
      0.000000000000000_REALK,      0.124705735594005_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.207380777374339_REALK, &
      0.000000000000000_REALK,      0.015307437995476_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.062208262438915_REALK,      0.000000000000000_REALK, &
     -0.911662404278267_REALK,      0.000000000000000_REALK,     -0.413195236869018_REALK, &
      0.000000000000000_REALK,     -0.071687490589490_REALK,      0.000000000000000_REALK, &
      0.459065665881061_REALK,      0.049801351255439_REALK,      0.000000000000000_REALK, &
     -0.023879041749303_REALK,      0.000000000000000_REALK,     -0.145776213969548_REALK, &
     -0.006291731483100_REALK,      0.000000000000000_REALK,     -0.015994422268394_REALK, &
      0.000000000000000_REALK,     -0.306836506941024_REALK,      0.000000000000000_REALK, &
     -0.632977529484670_REALK,      0.000000000000000_REALK,     -5.409860925021038_REALK, &
      0.885379620177406_REALK,      0.202868926972351_REALK,      0.000000000000000_REALK, &
      0.182653562132217_REALK,      0.000000000000000_REALK,      0.812372186556924_REALK, &
      0.177210899345223_REALK,      0.000000000000000_REALK,      0.153181148137183_REALK, &
      0.000000000000000_REALK,     -1.319849351365202_REALK,      0.000000000000000_REALK, &
     -0.855399546309444_REALK,      0.000000000000000_REALK,     -5.326279478946392_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.297008166711175_REALK, &
      0.000000000000000_REALK,      0.024692059078875_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.016881512441981_REALK,      0.000000000000000_REALK, &
      0.133543839315602_REALK,      0.000000000000000_REALK,      0.166728721348913_REALK, &
      0.000000000000000_REALK,      0.916340203464348_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.995994071819129_REALK, &
      0.000000000000000_REALK,     -0.009221095714530_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.141094293761433_REALK,      0.000000000000000_REALK, &
     -1.052869578552192_REALK,      0.000000000000000_REALK,     -1.577272311717228_REALK, &
      0.000000000000000_REALK,      0.060457674069151_REALK,      0.000000000000000_REALK, &
      0.134701537312948_REALK,      0.158890057634399_REALK,      0.000000000000000_REALK, &
     -0.557331321768491_REALK,      0.000000000000000_REALK,     -2.040009007613213_REALK, &
      0.388984264950503_REALK,      0.000000000000000_REALK,      0.473190449807517_REALK, &
      0.000000000000000_REALK,     -1.632966816435179_REALK,      0.000000000000000_REALK, &
     -1.930979401025420_REALK,      0.000000000000000_REALK,    -11.779992791085602_REALK, &
     11.611661813054978_REALK,     -1.417873956458271_REALK,      0.000000000000000_REALK, &
      0.461317434210301_REALK,      0.000000000000000_REALK,      2.046482120350123_REALK, &
     -0.016432771253644_REALK,      0.000000000000000_REALK,     -0.016246160203847_REALK, &
      0.000000000000000_REALK,      0.013923379959673_REALK,      0.000000000000000_REALK, &
     -1.052614469161536_REALK,      0.000000000000000_REALK,     -7.782626202745047_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.372347948664977_REALK, &
      0.000000000000000_REALK,     -0.089860223451536_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.270559746245229_REALK,      0.000000000000000_REALK, &
      1.848148922771676_REALK,      0.000000000000000_REALK,     -0.282411248951998_REALK, &
      0.000000000000000_REALK,     -0.518896132572928_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.496200126543044_REALK, &
      0.000000000000000_REALK,      0.119595336961122_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.010312027060490_REALK,      0.000000000000000_REALK, &
     -0.066766427652486_REALK,      0.000000000000000_REALK,      0.079161111453204_REALK, &
      0.000000000000000_REALK,     -0.454812575152385_REALK,      0.000000000000000_REALK, &
      0.032957801135745_REALK,     -0.005586318992182_REALK,      0.000000000000000_REALK, &
     -0.119118215148827_REALK,      0.000000000000000_REALK,     -0.831891163843242_REALK, &
      0.001953606447364_REALK,      0.000000000000000_REALK,     -0.027727692510936_REALK, &
      0.000000000000000_REALK,     -0.270507581035745_REALK,      0.000000000000000_REALK, &
     -0.687845843083754_REALK,      0.000000000000000_REALK,     -6.725235343107329_REALK, &
      4.511580234548861_REALK,     -0.052921277637084_REALK,      0.000000000000000_REALK, &
      0.090428439544473_REALK,      0.000000000000000_REALK,      1.325229244124896_REALK, &
     -0.005825109645162_REALK,      0.000000000000000_REALK,     -0.001010629977331_REALK, &
      0.000000000000000_REALK,      0.718484186550353_REALK,      0.000000000000000_REALK, &
     -0.343892935136789_REALK,      0.000000000000000_REALK,     -7.055653813133853_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.173100119519406_REALK, &
      0.000000000000000_REALK,      0.074709742189257_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.140739367121191_REALK,      0.000000000000000_REALK, &
      1.202855342149335_REALK,      0.000000000000000_REALK,      0.169703890750892_REALK, &
      0.000000000000000_REALK,      0.603973957752367_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.808554510697989_REALK, &
      0.000000000000000_REALK,     -0.222670295722824_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.012059180994997_REALK,      0.000000000000000_REALK, &
     -0.075088382433300_REALK,      0.000000000000000_REALK,      0.979637976127368_REALK, &
      0.000000000000000_REALK,      1.185519054951008_REALK,      0.000000000000000_REALK, &
      0.017652093526595_REALK,     -0.029320272912468_REALK,      0.000000000000000_REALK, &
     -0.078853329063181_REALK,      0.000000000000000_REALK,     -0.623781568275038_REALK, &
     -0.037071291839815_REALK,      0.000000000000000_REALK,     -0.203743631165345_REALK, &
      0.000000000000000_REALK,     -0.056178014933429_REALK,      0.000000000000000_REALK, &
     -0.637471845580637_REALK,      0.000000000000000_REALK,     -6.483626410532708_REALK, &
      3.721698450358751_REALK,      0.031879414868183_REALK,      0.000000000000000_REALK, &
     -0.205100356660893_REALK,      0.000000000000000_REALK,      1.530493688451953_REALK, &
     -0.022235939178900_REALK,      0.000000000000000_REALK,      0.000852315198531_REALK, &
      0.000000000000000_REALK,      3.420098307262075_REALK,      0.000000000000000_REALK, &
      1.091974931858023_REALK,      0.000000000000000_REALK,    -10.476645896871865_REALK, &
    -12.635854718932844_REALK,      2.873995136924778_REALK,      0.000000000000000_REALK, &
     -2.610735404899545_REALK,      0.000000000000000_REALK,     -8.048101349861344_REALK, &
      1.883304216115742_REALK,      0.000000000000000_REALK,      2.264891903554870_REALK, &
      0.000000000000000_REALK,     -3.644987263204941_REALK,      0.000000000000000_REALK, &
     -3.746748985124839_REALK,      0.000000000000000_REALK,    -19.250141491540834_REALK, &
     -8.544679280409293_REALK,      3.170420985624809_REALK,      0.000000000000000_REALK, &
     -3.160514636438342_REALK,      0.000000000000000_REALK,     -9.467200165133761_REALK, &
      2.031207524645924_REALK,      0.000000000000000_REALK,      3.218474027174733_REALK, &
      0.000000000000000_REALK,     -5.897295918647548_REALK,      0.000000000000000_REALK, &
     -4.503733256572774_REALK,      0.000000000000000_REALK,    -22.484599891192438_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.219462043990898_REALK, &
      0.000000000000000_REALK,     -0.750649760325727_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.908447639432090_REALK,      0.000000000000000_REALK, &
      5.542009737600447_REALK,      0.000000000000000_REALK,     -0.885574602173600_REALK, &
      0.000000000000000_REALK,     -1.795468703573224_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.220803209341624_REALK, &
      0.000000000000000_REALK,     -1.305768236668107_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.194709484229344_REALK,      0.000000000000000_REALK, &
      8.833222047610326_REALK,      0.000000000000000_REALK,     -1.882092798817391_REALK, &
      0.000000000000000_REALK,     -3.101199492986050_REALK,      0.000000000000000_REALK, &
     -2.761854404952475_REALK,      0.185862807812751_REALK,      0.000000000000000_REALK, &
     -0.429204792183329_REALK,      0.000000000000000_REALK,     -2.931827019097993_REALK, &
      0.132863060229058_REALK,      0.000000000000000_REALK,      0.244119624733434_REALK, &
      0.000000000000000_REALK,     -0.467119682079875_REALK,      0.000000000000000_REALK, &
     -1.026608962686435_REALK,      0.000000000000000_REALK,     -9.817634680540344_REALK, &
     -2.906022453791524_REALK,      0.305100989068059_REALK,      0.000000000000000_REALK, &
     -0.828818454471564_REALK,      0.000000000000000_REALK,     -5.366282211335714_REALK, &
     -0.089847264507596_REALK,      0.000000000000000_REALK,      0.516208842838869_REALK, &
      0.000000000000000_REALK,     -2.079251377334664_REALK,      0.000000000000000_REALK, &
     -1.968443785509242_REALK,      0.000000000000000_REALK,    -17.842887955117298_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.720645927281855_REALK, &
      0.000000000000000_REALK,      0.043986064693795_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.323603624207893_REALK,      0.000000000000000_REALK, &
      3.163950981987036_REALK,      0.000000000000000_REALK,     -0.007412743086356_REALK, &
      0.000000000000000_REALK,      0.147293517450138_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.380807006345569_REALK, &
      0.000000000000000_REALK,     -0.081228333764133_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.390315887919206_REALK,      0.000000000000000_REALK, &
      8.008113867847998_REALK,      0.000000000000000_REALK,     -1.111944413418150_REALK, &
      0.000000000000000_REALK,     -0.270084203747746_REALK,      0.000000000000000_REALK, &
     -1.283953166135541_REALK,     -0.154526239985938_REALK,      0.000000000000000_REALK, &
     -0.223263111588350_REALK,      0.000000000000000_REALK,     -1.908159969539133_REALK, &
     -0.079838810747137_REALK,      0.000000000000000_REALK,     -0.284145297410851_REALK, &
      0.000000000000000_REALK,     -0.258866707145092_REALK,      0.000000000000000_REALK, &
     -0.747627896508538_REALK,      0.000000000000000_REALK,     -8.215382243534957_REALK, &
     -2.334455172866758_REALK,     -0.568056658289240_REALK,      0.000000000000000_REALK, &
     -0.969244135593973_REALK,      0.000000000000000_REALK,     -6.035150675232847_REALK, &
     -1.111881714986190_REALK,      0.000000000000000_REALK,     -1.345555186803369_REALK, &
      0.000000000000000_REALK,     -3.551829696597717_REALK,      0.000000000000000_REALK, &
     -3.222736679041172_REALK,      0.000000000000000_REALK,    -25.800268561740687_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.290201485020440_REALK, &
      0.000000000000000_REALK,      0.323210470465692_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.299904697592641_REALK,      0.000000000000000_REALK, &
      3.050283759878626_REALK,      0.000000000000000_REALK,      0.196928069991882_REALK, &
      0.000000000000000_REALK,      1.391548718334001_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.904459404306946_REALK, &
      0.000000000000000_REALK,      0.068503948004174_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.239383312553788_REALK,      0.000000000000000_REALK, &
     11.890914083553659_REALK,      0.000000000000000_REALK,     -5.942408262592565_REALK, &
      0.000000000000000_REALK,      0.292854371192486_REALK,      0.000000000000000_REALK/
    ! results of test 7, ket-major order, 01ODGZZZ
  data REF_CONTR_INTS(51661:52920)                                                         &
     /0.000000000000000_REALK,      0.000000000000000_REALK,     -0.220020418970379_REALK, &
      0.000000000000000_REALK,      0.085976364900795_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.533457155846480_REALK,      0.000000000000000_REALK, &
      0.419224823307028_REALK,      0.000000000000000_REALK,      2.329955504748678_REALK, &
      0.000000000000000_REALK,      1.393110240992673_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.507105622276851_REALK, &
      0.000000000000000_REALK,     -0.960558781686979_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.284499742658050_REALK,      0.000000000000000_REALK, &
     -0.171495514528524_REALK,      0.000000000000000_REALK,      2.620147978185500_REALK, &
      0.000000000000000_REALK,      1.272575011006212_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.006936297561391_REALK, &
      0.000000000000000_REALK,      0.136020574880827_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.284030551702834_REALK,      0.000000000000000_REALK, &
      0.360292442145260_REALK,      0.000000000000000_REALK,      0.668046167200660_REALK, &
      0.000000000000000_REALK,      0.637937679135684_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.303854558240268_REALK, &
      0.000000000000000_REALK,     -0.104203807544919_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.025004926131823_REALK,      0.000000000000000_REALK, &
      0.050935878415670_REALK,      0.000000000000000_REALK,      0.033042224422149_REALK, &
      0.000000000000000_REALK,      0.297004615252050_REALK,      0.000000000000000_REALK, &
      0.250864699030103_REALK,      0.008395543656676_REALK,      0.000000000000000_REALK, &
     -0.252281972053660_REALK,      0.000000000000000_REALK,     -0.198259342851858_REALK, &
     -0.729354057152186_REALK,      0.000000000000000_REALK,     -0.436090133162378_REALK, &
      0.000000000000000_REALK,     -2.377786426290789_REALK,      0.000000000000000_REALK, &
     -1.183204642979135_REALK,      0.000000000000000_REALK,     -1.301773259077668_REALK, &
      0.977194039124253_REALK,      0.887273642161628_REALK,      0.000000000000000_REALK, &
      0.576946061424994_REALK,      0.000000000000000_REALK,      0.347781199149302_REALK, &
     -0.306237276327888_REALK,      0.000000000000000_REALK,     -0.148735838028261_REALK, &
      0.000000000000000_REALK,     -3.964239114111232_REALK,      0.000000000000000_REALK, &
     -1.644427848002095_REALK,      0.000000000000000_REALK,     -1.387758021039607_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.130452701159048_REALK, &
      0.000000000000000_REALK,      0.169432872504971_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.226935393373615_REALK,      0.000000000000000_REALK, &
      0.379624468721194_REALK,      0.000000000000000_REALK,      0.379835591624077_REALK, &
      0.000000000000000_REALK,      0.425292532491579_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.501929667389512_REALK, &
      0.000000000000000_REALK,     -0.125746129571418_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.058898663398815_REALK,      0.000000000000000_REALK, &
      0.073859327276725_REALK,      0.000000000000000_REALK,      0.366653636779720_REALK, &
      0.000000000000000_REALK,      0.266308822597896_REALK,      0.000000000000000_REALK, &
      0.031723439270143_REALK,     -0.096023697844955_REALK,      0.000000000000000_REALK, &
     -0.183437005177174_REALK,      0.000000000000000_REALK,     -0.232689639121091_REALK, &
     -0.292622536267237_REALK,      0.000000000000000_REALK,     -0.279434193045893_REALK, &
      0.000000000000000_REALK,     -0.547704932402829_REALK,      0.000000000000000_REALK, &
     -0.460444229806600_REALK,      0.000000000000000_REALK,     -0.817702198048018_REALK, &
      1.202472473913590_REALK,      0.405255092580072_REALK,      0.000000000000000_REALK, &
      0.090296526759672_REALK,      0.000000000000000_REALK,      0.183937072404886_REALK, &
     -0.006634329558833_REALK,      0.000000000000000_REALK,     -0.059633591034983_REALK, &
      0.000000000000000_REALK,      0.315751441225865_REALK,      0.000000000000000_REALK, &
     -0.191232619310086_REALK,      0.000000000000000_REALK,     -0.545366219156666_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.139961143743333_REALK, &
      0.000000000000000_REALK,      0.281642476610460_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.518276072150156_REALK,      0.000000000000000_REALK, &
      0.570212376657129_REALK,      0.000000000000000_REALK,      1.182361774423179_REALK, &
      0.000000000000000_REALK,      0.989728949934956_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.352542727367269_REALK, &
      0.000000000000000_REALK,     -0.537107348681537_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.330173784306596_REALK,      0.000000000000000_REALK, &
      0.278638748465111_REALK,      0.000000000000000_REALK,      2.342040771239774_REALK, &
      0.000000000000000_REALK,      1.592502262876782_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.333387983238251_REALK, &
      0.000000000000000_REALK,      0.215471946571231_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.202309544297390_REALK,      0.000000000000000_REALK, &
      0.463636476473301_REALK,      0.000000000000000_REALK,      0.232389031967440_REALK, &
      0.000000000000000_REALK,      0.336313080360766_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.038497997977112_REALK, &
      0.000000000000000_REALK,      0.044872117489963_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.059369345359035_REALK,      0.000000000000000_REALK, &
      0.209191536200307_REALK,      0.000000000000000_REALK,     -0.003644972704178_REALK, &
      0.000000000000000_REALK,      0.186344647698424_REALK,      0.000000000000000_REALK, &
     -0.195263098541075_REALK,     -0.182240784754640_REALK,      0.000000000000000_REALK, &
     -0.193305711484047_REALK,      0.000000000000000_REALK,     -0.323367708015862_REALK, &
     -0.226350329622823_REALK,      0.000000000000000_REALK,     -0.253438874708896_REALK, &
      0.000000000000000_REALK,     -0.337444595528705_REALK,      0.000000000000000_REALK, &
     -0.301715561190412_REALK,      0.000000000000000_REALK,     -0.706606629696406_REALK, &
      0.194996268399962_REALK,      0.034131262814383_REALK,      0.000000000000000_REALK, &
     -0.081667028833866_REALK,      0.000000000000000_REALK,     -0.102411013464179_REALK, &
     -0.255345826140415_REALK,      0.000000000000000_REALK,     -0.185463444224869_REALK, &
      0.000000000000000_REALK,     -0.727140252171126_REALK,      0.000000000000000_REALK, &
     -0.339146324441405_REALK,      0.000000000000000_REALK,     -0.595408538947726_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.250279310093485_REALK, &
      0.000000000000000_REALK,      0.238024684896892_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.274386354222431_REALK,      0.000000000000000_REALK, &
      0.487282303562159_REALK,      0.000000000000000_REALK,      0.389048052110042_REALK, &
      0.000000000000000_REALK,      0.520119406515669_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.049926026200224_REALK, &
      0.000000000000000_REALK,      0.082686056312423_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.133178690361841_REALK,      0.000000000000000_REALK, &
      0.379805281635041_REALK,      0.000000000000000_REALK,      0.038201350509025_REALK, &
      0.000000000000000_REALK,      0.480729389496271_REALK,      0.000000000000000_REALK, &
     -0.209495444401387_REALK,     -0.302932631660511_REALK,      0.000000000000000_REALK, &
     -0.441472453383252_REALK,      0.000000000000000_REALK,     -0.485712288101514_REALK, &
     -0.704588993963956_REALK,      0.000000000000000_REALK,     -0.589795898528502_REALK, &
      0.000000000000000_REALK,     -1.384744382799920_REALK,      0.000000000000000_REALK, &
     -0.964683098083629_REALK,      0.000000000000000_REALK,     -1.364597652194560_REALK, &
      0.525453667761492_REALK,      0.145787008632931_REALK,      0.000000000000000_REALK, &
     -0.457808554679285_REALK,      0.000000000000000_REALK,     -0.386351699546210_REALK, &
     -1.631049785402897_REALK,      0.000000000000000_REALK,     -1.109054336720118_REALK, &
      0.000000000000000_REALK,     -4.583204991436280_REALK,      0.000000000000000_REALK, &
     -2.661658286925416_REALK,      0.000000000000000_REALK,     -2.887990040592893_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.728934663415637_REALK, &
      0.000000000000000_REALK,      0.303582673249400_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.222932268662419_REALK,      0.000000000000000_REALK, &
      0.668891895286015_REALK,      0.000000000000000_REALK,      0.191021682060423_REALK, &
      0.000000000000000_REALK,      0.321300475999133_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.627538227379467_REALK, &
      0.000000000000000_REALK,     -0.016494747669059_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.115120322010061_REALK,      0.000000000000000_REALK, &
      0.272208931372884_REALK,      0.000000000000000_REALK,      0.237681381071587_REALK, &
      0.000000000000000_REALK,      0.231223323884516_REALK,      0.000000000000000_REALK, &
     -0.551911499717651_REALK,     -0.295047186533543_REALK,      0.000000000000000_REALK, &
     -0.222928045068362_REALK,      0.000000000000000_REALK,     -0.510888271146732_REALK, &
     -0.187081428153306_REALK,      0.000000000000000_REALK,     -0.270743979816332_REALK, &
      0.000000000000000_REALK,     -0.194025077401142_REALK,      0.000000000000000_REALK, &
     -0.235938652978320_REALK,      0.000000000000000_REALK,     -0.756986886381866_REALK, &
      1.643470586379473_REALK,      0.287758136689790_REALK,      0.000000000000000_REALK, &
      0.008624121188109_REALK,      0.000000000000000_REALK,      0.030387620897755_REALK, &
      0.002441558608793_REALK,      0.000000000000000_REALK,     -0.124821614787165_REALK, &
      0.000000000000000_REALK,      0.244568909421133_REALK,      0.000000000000000_REALK, &
     -0.120892905226921_REALK,      0.000000000000000_REALK,     -0.596363011417384_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.442789578801805_REALK, &
      0.000000000000000_REALK,      0.279268252416842_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.242891747539475_REALK,      0.000000000000000_REALK, &
      0.568843444576675_REALK,      0.000000000000000_REALK,      0.263975642166955_REALK, &
      0.000000000000000_REALK,      0.413793811292280_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.656746417584531_REALK, &
      0.000000000000000_REALK,     -0.026940826267946_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.227174713031836_REALK,      0.000000000000000_REALK, &
      0.398830104365538_REALK,      0.000000000000000_REALK,      0.519956866173954_REALK, &
      0.000000000000000_REALK,      0.528718991765885_REALK,      0.000000000000000_REALK, &
     -0.414328159162475_REALK,     -0.325928802899384_REALK,      0.000000000000000_REALK, &
     -0.302350607099019_REALK,      0.000000000000000_REALK,     -0.536943977145430_REALK, &
     -0.313197505892645_REALK,      0.000000000000000_REALK,     -0.418714603513794_REALK, &
      0.000000000000000_REALK,     -0.380640372933079_REALK,      0.000000000000000_REALK, &
     -0.447995104976325_REALK,      0.000000000000000_REALK,     -1.022906335434819_REALK, &
      2.131330455252786_REALK,      0.530253235765222_REALK,      0.000000000000000_REALK, &
      0.019345828363247_REALK,      0.000000000000000_REALK,      0.055171347383000_REALK, &
     -0.025588898401332_REALK,      0.000000000000000_REALK,     -0.322013105359935_REALK, &
      0.000000000000000_REALK,      0.447771720776209_REALK,      0.000000000000000_REALK, &
     -0.379665670434970_REALK,      0.000000000000000_REALK,     -1.392105211056073_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.665089104867519_REALK, &
      0.000000000000000_REALK,      0.649905307754644_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.776604171792957_REALK,      0.000000000000000_REALK, &
      1.098549597912931_REALK,      0.000000000000000_REALK,      1.150394017262833_REALK, &
      0.000000000000000_REALK,      1.238103573242769_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.477615307394832_REALK, &
      0.000000000000000_REALK,     -0.161103662946438_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.782892556824853_REALK,      0.000000000000000_REALK, &
      1.934499245395304_REALK,      0.000000000000000_REALK,      4.649795013040892_REALK, &
      0.000000000000000_REALK,      4.065031204531759_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.336429462396944_REALK, &
      0.000000000000000_REALK,      0.574877275227260_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.324154381607723_REALK,      0.000000000000000_REALK, &
      1.277430386883101_REALK,      0.000000000000000_REALK,      0.189167317641356_REALK, &
      0.000000000000000_REALK,      0.382035390531311_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.345454166748324_REALK, &
      0.000000000000000_REALK,      0.630402219409815_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.254243614913926_REALK,      0.000000000000000_REALK, &
      1.567097029270236_REALK,      0.000000000000000_REALK,     -0.062185281761675_REALK, &
      0.000000000000000_REALK,      0.430159674948421_REALK,      0.000000000000000_REALK, &
     -2.402680321086200_REALK,     -0.711291974906379_REALK,      0.000000000000000_REALK, &
     -0.382080791962395_REALK,      0.000000000000000_REALK,     -1.146405348232077_REALK, &
     -0.231208487945594_REALK,      0.000000000000000_REALK,     -0.388895105679476_REALK, &
      0.000000000000000_REALK,     -0.188920478001176_REALK,      0.000000000000000_REALK, &
     -0.253912253731306_REALK,      0.000000000000000_REALK,     -1.066583090528744_REALK, &
     -2.187895303306971_REALK,     -1.010542371331792_REALK,      0.000000000000000_REALK, &
     -0.722884518254274_REALK,      0.000000000000000_REALK,     -1.709303959406932_REALK, &
     -0.694043972480532_REALK,      0.000000000000000_REALK,     -0.675186055867908_REALK, &
      0.000000000000000_REALK,     -1.011401849582725_REALK,      0.000000000000000_REALK, &
     -0.493265664084467_REALK,      0.000000000000000_REALK,     -1.632898898669584_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.197007469006410_REALK, &
      0.000000000000000_REALK,      0.464024678203588_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.285575012295109_REALK,      0.000000000000000_REALK, &
      0.916240457665078_REALK,      0.000000000000000_REALK,      0.213079368629262_REALK, &
      0.000000000000000_REALK,      0.431715427813756_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.861682221350412_REALK, &
      0.000000000000000_REALK,      0.783802644899260_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.353014576952215_REALK,      0.000000000000000_REALK, &
      1.741415973007625_REALK,      0.000000000000000_REALK,     -0.010461550207114_REALK, &
      0.000000000000000_REALK,      0.748767045548984_REALK,      0.000000000000000_REALK, &
     -1.459502285683625_REALK,     -0.654323465381176_REALK,      0.000000000000000_REALK, &
     -0.416289090035430_REALK,      0.000000000000000_REALK,     -0.974933575612562_REALK, &
     -0.319510374013895_REALK,      0.000000000000000_REALK,     -0.500847026359397_REALK, &
      0.000000000000000_REALK,     -0.309405658063446_REALK,      0.000000000000000_REALK, &
     -0.387303587590647_REALK,      0.000000000000000_REALK,     -1.166207922338181_REALK, &
     -2.289728879939608_REALK,     -1.650516092071920_REALK,      0.000000000000000_REALK, &
     -1.426516883571775_REALK,      0.000000000000000_REALK,     -2.504406718341065_REALK, &
     -1.518305419174623_REALK,      0.000000000000000_REALK,     -1.543891354538089_REALK, &
      0.000000000000000_REALK,     -2.086987989507704_REALK,      0.000000000000000_REALK, &
     -1.362752268429849_REALK,      0.000000000000000_REALK,     -3.076021219652180_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.258055796893585_REALK, &
      0.000000000000000_REALK,      0.717629656203017_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.542243528123892_REALK,      0.000000000000000_REALK, &
      1.238103573242769_REALK,      0.000000000000000_REALK,      0.499409794220983_REALK, &
      0.000000000000000_REALK,      0.858422985220246_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.380044686501539_REALK, &
      0.000000000000000_REALK,      2.022043410539936_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.108646663592915_REALK,      0.000000000000000_REALK, &
      4.065031204531759_REALK,      0.000000000000000_REALK,      0.153500047948338_REALK, &
      0.000000000000000_REALK,      2.483561632512620_REALK,      0.000000000000000_REALK, &
     -2.192235579175428_REALK,     -1.522723365292891_REALK,      0.000000000000000_REALK, &
     -1.331012054828531_REALK,      0.000000000000000_REALK,     -1.882790243417549_REALK, &
     -1.392411889603529_REALK,      0.000000000000000_REALK,     -1.498573627882464_REALK, &
      0.000000000000000_REALK,     -1.777556534500176_REALK,      0.000000000000000_REALK, &
     -1.592146215800770_REALK,      0.000000000000000_REALK,     -2.752663187853567_REALK, &
     -8.638139730685637_REALK,     -9.869934408849138_REALK,      0.000000000000000_REALK, &
    -11.195464054789804_REALK,      0.000000000000000_REALK,    -12.147460419270070_REALK, &
    -13.577681968698592_REALK,      0.000000000000000_REALK,    -11.870136367984140_REALK, &
      0.000000000000000_REALK,    -18.416160072045493_REALK,      0.000000000000000_REALK, &
    -13.750755715588515_REALK,      0.000000000000000_REALK,    -18.235603273489144_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.656162506797754_REALK, &
      0.000000000000000_REALK,     -0.453327495718283_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -3.216079391948108_REALK,      0.000000000000000_REALK, &
     -7.250598635238980_REALK,      0.000000000000000_REALK,      1.974752469007719_REALK, &
      0.000000000000000_REALK,      2.340973045573607_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -6.069549759935332_REALK, &
      0.000000000000000_REALK,     -1.548558979232571_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -8.074141445183816_REALK,      0.000000000000000_REALK, &
    -13.352285568129840_REALK,      0.000000000000000_REALK,      2.516874578217704_REALK, &
      0.000000000000000_REALK,      2.505097923416022_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.105592041429039_REALK, &
      0.000000000000000_REALK,     -0.205610644381833_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.857398289005942_REALK,      0.000000000000000_REALK, &
     -3.357386185598013_REALK,      0.000000000000000_REALK,      0.882610346034834_REALK, &
      0.000000000000000_REALK,      1.643860233546059_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.304518746640667_REALK, &
      0.000000000000000_REALK,     -0.417103527476488_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.730027927733558_REALK,      0.000000000000000_REALK, &
     -4.844114827722802_REALK,      0.000000000000000_REALK,     -0.028505915808655_REALK, &
      0.000000000000000_REALK,      0.975069652100783_REALK,      0.000000000000000_REALK, &
      1.047315561393846_REALK,      0.990595818177776_REALK,      0.000000000000000_REALK, &
      0.287058690756932_REALK,      0.000000000000000_REALK,      0.647169145340950_REALK, &
      1.332415914485390_REALK,      0.000000000000000_REALK,      1.579514288629262_REALK, &
      0.000000000000000_REALK,     -2.440089255759895_REALK,      0.000000000000000_REALK, &
     -2.295038604872973_REALK,      0.000000000000000_REALK,     -7.243778043901519_REALK, &
      1.418344864460342_REALK,      2.615611397959430_REALK,      0.000000000000000_REALK, &
      1.610956586765294_REALK,      0.000000000000000_REALK,      2.664054442244198_REALK, &
      5.523880470385442_REALK,      0.000000000000000_REALK,      5.498033797679347_REALK, &
      0.000000000000000_REALK,     -4.791822731907814_REALK,      0.000000000000000_REALK, &
     -3.765959228659949_REALK,      0.000000000000000_REALK,     -8.718924329049774_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.374910332445390_REALK, &
      0.000000000000000_REALK,     -0.058063874374674_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.256248154834178_REALK,      0.000000000000000_REALK, &
     -1.373288152864323_REALK,      0.000000000000000_REALK,      0.468551698894779_REALK, &
      0.000000000000000_REALK,      1.025963670259285_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.674110756649497_REALK, &
      0.000000000000000_REALK,     -0.363360280589509_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.608182159928511_REALK,      0.000000000000000_REALK, &
     -2.959558802589121_REALK,      0.000000000000000_REALK,      0.572560646890170_REALK, &
      0.000000000000000_REALK,      0.789852482458611_REALK,      0.000000000000000_REALK, &
      0.861253297612134_REALK,      0.335904025764242_REALK,      0.000000000000000_REALK, &
      0.070010327027033_REALK,      0.000000000000000_REALK,      0.274145292594736_REALK, &
      0.180138536873934_REALK,      0.000000000000000_REALK,      0.335507711445458_REALK, &
      0.000000000000000_REALK,     -0.746491593314660_REALK,      0.000000000000000_REALK, &
     -1.237052347027635_REALK,      0.000000000000000_REALK,     -6.781641064180805_REALK, &
      2.924652609528414_REALK,      0.814298035634560_REALK,      0.000000000000000_REALK, &
      0.298312188147832_REALK,      0.000000000000000_REALK,      1.979456455020384_REALK, &
     -0.026346948820378_REALK,      0.000000000000000_REALK,      0.901220307835280_REALK, &
      0.000000000000000_REALK,      0.614609190502397_REALK,      0.000000000000000_REALK, &
     -0.648454536566175_REALK,      0.000000000000000_REALK,     -6.023966156488045_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.057273673374256_REALK, &
      0.000000000000000_REALK,     -0.128974262380456_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.468411568262645_REALK,      0.000000000000000_REALK, &
     -1.478436757658909_REALK,      0.000000000000000_REALK,      1.922406722017265_REALK, &
      0.000000000000000_REALK,      3.190487590369525_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -5.200949299728129_REALK, &
      0.000000000000000_REALK,     -2.246668148420571_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -3.480734866515189_REALK,      0.000000000000000_REALK, &
     -8.058574739650062_REALK,      0.000000000000000_REALK,      4.906641533004571_REALK, &
      0.000000000000000_REALK,      6.837156158004907_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.715449626897570_REALK, &
      0.000000000000000_REALK,      0.014933934873183_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.035144830330710_REALK,      0.000000000000000_REALK, &
      0.229776967007799_REALK,      0.000000000000000_REALK,      0.115049892827049_REALK, &
      0.000000000000000_REALK,      0.395863674127042_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.588994941381493_REALK, &
      0.000000000000000_REALK,     -0.037333424394852_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.121421795854254_REALK,      0.000000000000000_REALK, &
     -1.199809518084385_REALK,      0.000000000000000_REALK,     -0.234489138867375_REALK, &
      0.000000000000000_REALK,      0.174839154061599_REALK,      0.000000000000000_REALK, &
      0.611160286144245_REALK,      0.089113918018629_REALK,      0.000000000000000_REALK, &
     -0.036213129119798_REALK,      0.000000000000000_REALK,     -0.194073831402013_REALK, &
     -0.013070689679098_REALK,      0.000000000000000_REALK,     -0.028620220111505_REALK, &
      0.000000000000000_REALK,     -0.504131135828117_REALK,      0.000000000000000_REALK, &
     -0.959925328905965_REALK,      0.000000000000000_REALK,     -7.202220502791978_REALK, &
      1.197919881421847_REALK,      0.319074908100335_REALK,      0.000000000000000_REALK, &
      0.225870753676022_REALK,      0.000000000000000_REALK,      1.099140720220874_REALK, &
      0.174645720625493_REALK,      0.000000000000000_REALK,      0.240925318105699_REALK, &
      0.000000000000000_REALK,     -1.128019174374883_REALK,      0.000000000000000_REALK, &
     -1.057793442206090_REALK,      0.000000000000000_REALK,     -7.206463686797547_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.420746314168392_REALK, &
      0.000000000000000_REALK,      0.047414132925658_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.034508736993033_REALK,      0.000000000000000_REALK, &
      0.189180246436037_REALK,      0.000000000000000_REALK,      0.674812836678762_REALK, &
      0.000000000000000_REALK,      1.759572827579780_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.738205632848908_REALK, &
      0.000000000000000_REALK,     -0.334701218764488_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.197795308578366_REALK,      0.000000000000000_REALK, &
     -1.837464583250070_REALK,      0.000000000000000_REALK,     -0.045824477468413_REALK, &
      0.000000000000000_REALK,      2.194452570612128_REALK,      0.000000000000000_REALK, &
      0.469967870270444_REALK,      0.197944108416202_REALK,      0.000000000000000_REALK, &
     -0.066196178519526_REALK,      0.000000000000000_REALK,     -0.208933489629238_REALK, &
     -0.053627340931151_REALK,      0.000000000000000_REALK,     -0.089001647666845_REALK, &
      0.000000000000000_REALK,     -1.865606447767290_REALK,      0.000000000000000_REALK, &
     -2.456588148415686_REALK,      0.000000000000000_REALK,     -9.969008382539943_REALK, &
      2.329866312724303_REALK,      1.972850284643745_REALK,      0.000000000000000_REALK, &
      1.292698568696273_REALK,      0.000000000000000_REALK,      2.992847324251123_REALK, &
      1.496651841227459_REALK,      0.000000000000000_REALK,      2.085508444789860_REALK, &
      0.000000000000000_REALK,     -7.703059753802711_REALK,      0.000000000000000_REALK, &
     -8.475516484743496_REALK,      0.000000000000000_REALK,    -25.228878014831380_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.469868275806189_REALK, &
      0.000000000000000_REALK,     -0.071285004072797_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.344594921000071_REALK,      0.000000000000000_REALK, &
      2.332191034996491_REALK,      0.000000000000000_REALK,     -0.251237613061157_REALK, &
      0.000000000000000_REALK,     -0.411633885417270_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.402518258859211_REALK, &
      0.000000000000000_REALK,      0.105368257109669_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.012063594541017_REALK,      0.000000000000000_REALK, &
     -0.084074253812672_REALK,      0.000000000000000_REALK,      0.006597644977363_REALK, &
      0.000000000000000_REALK,     -0.400708000604954_REALK,      0.000000000000000_REALK, &
      0.042521334909435_REALK,     -0.017733111877792_REALK,      0.000000000000000_REALK, &
     -0.164161053724396_REALK,      0.000000000000000_REALK,     -1.073285278962778_REALK, &
     -0.025580764481517_REALK,      0.000000000000000_REALK,     -0.088018295070076_REALK, &
      0.000000000000000_REALK,     -0.407105713231892_REALK,      0.000000000000000_REALK, &
     -0.947944848396993_REALK,      0.000000000000000_REALK,     -8.676731290149187_REALK, &
      5.937545391375913_REALK,      0.129070097695445_REALK,      0.000000000000000_REALK, &
      0.176503620183404_REALK,      0.000000000000000_REALK,      1.744091511598084_REALK, &
     -0.003305761593121_REALK,      0.000000000000000_REALK,      0.002464832969503_REALK, &
      0.000000000000000_REALK,      0.369414792806915_REALK,      0.000000000000000_REALK, &
     -0.671230735738706_REALK,      0.000000000000000_REALK,     -9.285718662500068_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.230450513814929_REALK, &
      0.000000000000000_REALK,      0.133684682700637_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.213434564389381_REALK,      0.000000000000000_REALK, &
      1.601377471101462_REALK,      0.000000000000000_REALK,      0.352549516663056_REALK, &
      0.000000000000000_REALK,      1.080743481847858_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.799978235040006_REALK, &
      0.000000000000000_REALK,     -0.350218760481332_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.014912472925570_REALK,      0.000000000000000_REALK, &
     -0.101594687895157_REALK,      0.000000000000000_REALK,      0.965457434757249_REALK, &
      0.000000000000000_REALK,      1.864599912638389_REALK,      0.000000000000000_REALK, &
      0.025006225825073_REALK,     -0.056301311804235_REALK,      0.000000000000000_REALK, &
     -0.161189869866126_REALK,      0.000000000000000_REALK,     -0.883658515535449_REALK, &
     -0.150041237066892_REALK,      0.000000000000000_REALK,     -0.391232160103435_REALK, &
      0.000000000000000_REALK,     -0.561678147869053_REALK,      0.000000000000000_REALK, &
     -1.303102926068362_REALK,      0.000000000000000_REALK,     -9.184804394046456_REALK, &
      6.495096098677791_REALK,      1.157137865196037_REALK,      0.000000000000000_REALK, &
      0.287523238918987_REALK,      0.000000000000000_REALK,      2.671012635093269_REALK, &
     -0.000646020529444_REALK,      0.000000000000000_REALK,      0.030936772001017_REALK, &
      0.000000000000000_REALK,      1.036360105542666_REALK,      0.000000000000000_REALK, &
     -1.530802648701702_REALK,      0.000000000000000_REALK,    -18.283808535170763_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.248095426829940_REALK, &
      0.000000000000000_REALK,      0.415725559825211_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.546210007750072_REALK,      0.000000000000000_REALK, &
      2.216558827493896_REALK,      0.000000000000000_REALK,      2.025050783480083_REALK, &
      0.000000000000000_REALK,      4.321078653654240_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,    -10.346950562132404_REALK, &
      0.000000000000000_REALK,     -3.031579197447487_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.119485435498035_REALK,      0.000000000000000_REALK, &
     -0.355669590420264_REALK,      0.000000000000000_REALK,     11.583078583623523_REALK, &
      0.000000000000000_REALK,     20.751984800476617_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.237467535483344_REALK, &
      0.000000000000000_REALK,     -0.801649449929328_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.106010393281043_REALK,      0.000000000000000_REALK, &
      6.879098752257319_REALK,      0.000000000000000_REALK,     -0.960027492534135_REALK, &
      0.000000000000000_REALK,     -1.917454150601781_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.458803266813280_REALK, &
      0.000000000000000_REALK,     -1.389810631829366_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.495259115705923_REALK,      0.000000000000000_REALK, &
     10.927828751619863_REALK,      0.000000000000000_REALK,     -1.878806379657605_REALK, &
      0.000000000000000_REALK,     -3.300800177046551_REALK,      0.000000000000000_REALK, &
     -3.485201870818873_REALK,      0.147442667100190_REALK,      0.000000000000000_REALK, &
     -0.546651131618120_REALK,      0.000000000000000_REALK,     -3.699691407901524_REALK, &
      0.118197126494855_REALK,      0.000000000000000_REALK,      0.193657079572676_REALK, &
      0.000000000000000_REALK,     -0.587763230086451_REALK,      0.000000000000000_REALK, &
     -1.307527225702869_REALK,      0.000000000000000_REALK,    -12.388936467570325_REALK, &
     -3.659349136321393_REALK,      0.268806128043169_REALK,      0.000000000000000_REALK, &
     -0.969598869766915_REALK,      0.000000000000000_REALK,     -6.757380745522950_REALK, &
     -0.007488277293312_REALK,      0.000000000000000_REALK,      0.454800558755999_REALK, &
      0.000000000000000_REALK,     -1.895238467098254_REALK,      0.000000000000000_REALK, &
     -2.302797264385660_REALK,      0.000000000000000_REALK,    -22.468290478226969_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.219934559140077_REALK, &
      0.000000000000000_REALK,      0.139628583217408_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.445969677035784_REALK,      0.000000000000000_REALK, &
      4.082050825781345_REALK,      0.000000000000000_REALK,      0.097063374923827_REALK, &
      0.000000000000000_REALK,      0.467565928023847_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.449371177295668_REALK, &
      0.000000000000000_REALK,      0.198108387451859_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.761841822991518_REALK,      0.000000000000000_REALK, &
     10.539220653893363_REALK,      0.000000000000000_REALK,     -0.631030720360080_REALK, &
      0.000000000000000_REALK,      0.658710373600093_REALK,      0.000000000000000_REALK, &
     -1.709344093301273_REALK,     -0.276507330317266_REALK,      0.000000000000000_REALK, &
     -0.338583766154381_REALK,      0.000000000000000_REALK,     -2.540358993640528_REALK, &
     -0.165860275891810_REALK,      0.000000000000000_REALK,     -0.508446058199758_REALK, &
      0.000000000000000_REALK,     -0.425316949414443_REALK,      0.000000000000000_REALK, &
     -1.133795310300370_REALK,      0.000000000000000_REALK,    -10.937248711699652_REALK, &
     -3.158521158759928_REALK,     -0.893446959790573_REALK,      0.000000000000000_REALK, &
     -1.198574508194938_REALK,      0.000000000000000_REALK,     -8.165567420435195_REALK, &
     -1.095786907473348_REALK,      0.000000000000000_REALK,     -2.116306839005109_REALK, &
      0.000000000000000_REALK,     -3.035597962549396_REALK,      0.000000000000000_REALK, &
     -3.985260150948888_REALK,      0.000000000000000_REALK,    -34.907799944547364_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.827719168021490_REALK, &
      0.000000000000000_REALK,      0.620634519003548_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.613057175283803_REALK,      0.000000000000000_REALK, &
      4.321078653654240_REALK,      0.000000000000000_REALK,      0.797040776524629_REALK, &
      0.000000000000000_REALK,      2.672076706639054_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.814049924414298_REALK, &
      0.000000000000000_REALK,      2.486510887317548_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.737449461761735_REALK,      0.000000000000000_REALK, &
     20.751984800476617_REALK,      0.000000000000000_REALK,     -0.172644730725550_REALK, &
      0.000000000000000_REALK,     10.629833806429323_REALK,      0.000000000000000_REALK, &
     -1.840223505717098_REALK,     -0.859867879922583_REALK,      0.000000000000000_REALK, &
     -0.866484967251324_REALK,      0.000000000000000_REALK,     -3.516257256001235_REALK, &
     -0.952704416735706_REALK,      0.000000000000000_REALK,     -2.032892583229019_REALK, &
      0.000000000000000_REALK,     -2.203521229880884_REALK,      0.000000000000000_REALK, &
     -3.730559978137361_REALK,      0.000000000000000_REALK,    -18.503070831689211_REALK, &
     -8.600328806565932_REALK,     -7.733895276201746_REALK,      0.000000000000000_REALK, &
     -9.603517659566219_REALK,      0.000000000000000_REALK,    -28.586573571369517_REALK, &
    -13.146706838878881_REALK,      0.000000000000000_REALK,    -23.553346247901430_REALK, &
      0.000000000000000_REALK,    -29.021447715902042_REALK,      0.000000000000000_REALK, &
    -41.055037079860192_REALK,      0.000000000000000_REALK,   -149.364843582268975_REALK/
    ! results of test 7, ket-major order, 02ODGXXX
  data REF_CONTR_INTS(52921:54180)                                                         &
   /-27.630013796517481_REALK,    -23.241762416451706_REALK,      0.000000000000000_REALK, &
    -27.626768591092382_REALK,      0.000000000000000_REALK,     -7.008905108687512_REALK, &
    -38.284347044850200_REALK,      0.000000000000000_REALK,     -7.311778347103636_REALK, &
      0.000000000000000_REALK,    -87.768820799366267_REALK,      0.000000000000000_REALK, &
    -14.757087147893275_REALK,      0.000000000000000_REALK,    -11.231609280598054_REALK, &
    -14.959175285837519_REALK,     -9.744647693158067_REALK,      0.000000000000000_REALK, &
     -7.687599904733163_REALK,      0.000000000000000_REALK,     -3.131980090574699_REALK, &
     -1.682767754162850_REALK,      0.000000000000000_REALK,     -3.025158252049584_REALK, &
      0.000000000000000_REALK,     33.510493395925216_REALK,      0.000000000000000_REALK, &
     -4.059078496425346_REALK,      0.000000000000000_REALK,     -4.961087931640481_REALK, &
    -13.326960595825787_REALK,     -5.750853515976517_REALK,      0.000000000000000_REALK, &
     -2.438739947206311_REALK,      0.000000000000000_REALK,     -2.991487567446487_REALK, &
      2.485155471582547_REALK,      0.000000000000000_REALK,     -1.596849487310319_REALK, &
      0.000000000000000_REALK,     18.071946137082133_REALK,      0.000000000000000_REALK, &
     -1.074660774221663_REALK,      0.000000000000000_REALK,     -3.954707449216875_REALK, &
     -1.670419914070547_REALK,      0.967551800547019_REALK,      0.000000000000000_REALK, &
      4.365554017072273_REALK,      0.000000000000000_REALK,     -0.599345989217994_REALK, &
     10.592849509903221_REALK,      0.000000000000000_REALK,      0.315977085072184_REALK, &
      0.000000000000000_REALK,     28.945683548818039_REALK,      0.000000000000000_REALK, &
      1.969982915213714_REALK,      0.000000000000000_REALK,     -0.811375615404576_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.020535997228247_REALK, &
      0.000000000000000_REALK,      3.620831466443514_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      4.400434310273160_REALK,      0.000000000000000_REALK, &
      3.349167646880901_REALK,      0.000000000000000_REALK,      8.354345708381032_REALK, &
      0.000000000000000_REALK,      4.786691854757032_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.927866659188283_REALK, &
      0.000000000000000_REALK,      1.750126448153901_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.545361668122045_REALK,      0.000000000000000_REALK, &
      1.888772323198920_REALK,      0.000000000000000_REALK,      0.439307486403718_REALK, &
      0.000000000000000_REALK,      2.369265748753030_REALK,      0.000000000000000_REALK, &
     -9.231203579977802_REALK,     -2.033850231818449_REALK,      0.000000000000000_REALK, &
     -0.081894983150301_REALK,      0.000000000000000_REALK,     -1.827041531000609_REALK, &
      1.972617614023954_REALK,      0.000000000000000_REALK,     -0.494527290832019_REALK, &
      0.000000000000000_REALK,      5.711027787336221_REALK,      0.000000000000000_REALK, &
     -0.029759002566521_REALK,      0.000000000000000_REALK,     -1.991731294836478_REALK, &
     -3.189548945970673_REALK,     -0.045840967462353_REALK,      0.000000000000000_REALK, &
      0.495723507320209_REALK,      0.000000000000000_REALK,     -0.518470228130278_REALK, &
      0.652481790205087_REALK,      0.000000000000000_REALK,     -0.010567120090946_REALK, &
      0.000000000000000_REALK,      0.142766782643057_REALK,      0.000000000000000_REALK, &
      0.171279531770324_REALK,      0.000000000000000_REALK,     -0.537416543292822_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.922861522767549_REALK, &
      0.000000000000000_REALK,      0.868814872644983_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.381151464839174_REALK,      0.000000000000000_REALK, &
      1.402621714160095_REALK,      0.000000000000000_REALK,     -0.491335223902354_REALK, &
      0.000000000000000_REALK,      0.947129959502714_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.551108321632924_REALK, &
      0.000000000000000_REALK,     -0.222288768372896_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.925340562659555_REALK,      0.000000000000000_REALK, &
      0.381119431386166_REALK,      0.000000000000000_REALK,     -2.574783319576815_REALK, &
      0.000000000000000_REALK,     -0.230411805789865_REALK,      0.000000000000000_REALK, &
     -3.068942879763809_REALK,     -2.327389751846186_REALK,      0.000000000000000_REALK, &
     -2.394191065121736_REALK,      0.000000000000000_REALK,     -1.822217238202401_REALK, &
     -2.963047671325440_REALK,      0.000000000000000_REALK,     -1.697702806260671_REALK, &
      0.000000000000000_REALK,     -5.174394066252281_REALK,      0.000000000000000_REALK, &
     -2.610003762535845_REALK,      0.000000000000000_REALK,     -3.310786899418515_REALK, &
     -2.724744186877439_REALK,     -1.609269548538975_REALK,      0.000000000000000_REALK, &
     -1.087156500032458_REALK,      0.000000000000000_REALK,     -1.328744688447226_REALK, &
     -0.206351554376435_REALK,      0.000000000000000_REALK,     -1.112891733278458_REALK, &
      0.000000000000000_REALK,      3.101068734660922_REALK,      0.000000000000000_REALK, &
     -1.126884161454607_REALK,      0.000000000000000_REALK,     -2.295501067821438_REALK, &
     -7.381605098247669_REALK,      0.069147016893840_REALK,      0.000000000000000_REALK, &
      1.240962481145086_REALK,      0.000000000000000_REALK,     -1.284898765164554_REALK, &
      2.809105197460790_REALK,      0.000000000000000_REALK,      0.014620879794870_REALK, &
      0.000000000000000_REALK,      5.670340566038607_REALK,      0.000000000000000_REALK, &
      0.371816564567527_REALK,      0.000000000000000_REALK,     -1.154942196736778_REALK, &
     -0.935860496775635_REALK,      1.139133377374372_REALK,      0.000000000000000_REALK, &
      2.010095681680979_REALK,      0.000000000000000_REALK,     -0.253226919460787_REALK, &
      3.477149558561523_REALK,      0.000000000000000_REALK,      0.280157566808445_REALK, &
      0.000000000000000_REALK,      6.987725685462143_REALK,      0.000000000000000_REALK, &
      0.606881970211911_REALK,      0.000000000000000_REALK,     -0.229360502378481_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.321185173685406_REALK, &
      0.000000000000000_REALK,      0.300262524307739_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.012521969095754_REALK,      0.000000000000000_REALK, &
      0.838079087672368_REALK,      0.000000000000000_REALK,     -0.358859012041319_REALK, &
      0.000000000000000_REALK,      0.269893526885987_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.403801463448821_REALK, &
      0.000000000000000_REALK,      0.007762692590785_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.094953583373682_REALK,      0.000000000000000_REALK, &
      0.297931842891647_REALK,      0.000000000000000_REALK,     -0.144714365709619_REALK, &
      0.000000000000000_REALK,      0.007031065560579_REALK,      0.000000000000000_REALK, &
     -1.630842673956041_REALK,     -0.628264496969195_REALK,      0.000000000000000_REALK, &
     -0.231424034826579_REALK,      0.000000000000000_REALK,     -0.851630929880504_REALK, &
      0.206743639193152_REALK,      0.000000000000000_REALK,     -0.398532580386236_REALK, &
      0.000000000000000_REALK,      1.166036298047718_REALK,      0.000000000000000_REALK, &
     -0.208017464415625_REALK,      0.000000000000000_REALK,     -1.275826189102154_REALK, &
     -0.344902884310159_REALK,      0.173125716978791_REALK,      0.000000000000000_REALK, &
      0.679762723229102_REALK,      0.000000000000000_REALK,     -0.279973442221081_REALK, &
      1.427402913107232_REALK,      0.000000000000000_REALK,      0.127735207968027_REALK, &
      0.000000000000000_REALK,      3.015547681659210_REALK,      0.000000000000000_REALK, &
      0.615695677339450_REALK,      0.000000000000000_REALK,     -0.422643647689570_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.317696591729078_REALK, &
      0.000000000000000_REALK,      1.030795548764399_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.098235277920395_REALK,      0.000000000000000_REALK, &
      1.393110240992673_REALK,      0.000000000000000_REALK,      1.617114770349404_REALK, &
      0.000000000000000_REALK,      1.544232261395292_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.034869546279941_REALK, &
      0.000000000000000_REALK,      0.817539342594287_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.624719650218597_REALK,      0.000000000000000_REALK, &
      1.272575011006215_REALK,      0.000000000000000_REALK,      0.137300541193925_REALK, &
      0.000000000000000_REALK,      1.234144950116148_REALK,      0.000000000000000_REALK, &
     -6.884960629394300_REALK,      1.419397199466604_REALK,      0.000000000000000_REALK, &
      1.513546289307689_REALK,      0.000000000000000_REALK,     -1.045177668865127_REALK, &
      2.306978227324219_REALK,      0.000000000000000_REALK,      0.258690601952010_REALK, &
      0.000000000000000_REALK,      3.074121334648700_REALK,      0.000000000000000_REALK, &
      0.373345147955580_REALK,      0.000000000000000_REALK,     -0.773439202049392_REALK, &
     -2.409395592906487_REALK,      1.287418829806393_REALK,      0.000000000000000_REALK, &
      0.796637247168716_REALK,      0.000000000000000_REALK,     -0.294999383815706_REALK, &
      0.373631001960522_REALK,      0.000000000000000_REALK,      0.211542106120719_REALK, &
      0.000000000000000_REALK,     -0.976349667262225_REALK,      0.000000000000000_REALK, &
      0.178742463158037_REALK,      0.000000000000000_REALK,     -0.198568106176519_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.056206967690776_REALK, &
      0.000000000000000_REALK,     -0.010064088832634_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.185915447018167_REALK,      0.000000000000000_REALK, &
      0.577493353573992_REALK,      0.000000000000000_REALK,     -0.476961980565188_REALK, &
      0.000000000000000_REALK,     -0.007447500140832_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.326971019542053_REALK, &
      0.000000000000000_REALK,     -0.271846050737768_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.426474518312377_REALK,      0.000000000000000_REALK, &
      0.161178638636426_REALK,      0.000000000000000_REALK,     -0.757026656830559_REALK, &
      0.000000000000000_REALK,     -0.182983282094878_REALK,      0.000000000000000_REALK, &
     -1.266706628773984_REALK,     -0.246820511396195_REALK,      0.000000000000000_REALK, &
     -0.008619331470285_REALK,      0.000000000000000_REALK,     -0.576880632728238_REALK, &
      0.179436421068978_REALK,      0.000000000000000_REALK,     -0.134951964167280_REALK, &
      0.000000000000000_REALK,      0.408022665645467_REALK,      0.000000000000000_REALK, &
     -0.006378369011476_REALK,      0.000000000000000_REALK,     -0.711493221912451_REALK, &
     -0.787051846825260_REALK,     -0.010023324203466_REALK,      0.000000000000000_REALK, &
      0.092136567780745_REALK,      0.000000000000000_REALK,     -0.289093012199441_REALK, &
      0.101695210004905_REALK,      0.000000000000000_REALK,     -0.004940944772380_REALK, &
      0.000000000000000_REALK,      0.017231411972962_REALK,      0.000000000000000_REALK, &
      0.062018379622300_REALK,      0.000000000000000_REALK,     -0.324320744893321_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.700054001472689_REALK, &
      0.000000000000000_REALK,      0.274324619857245_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.104012740608798_REALK,      0.000000000000000_REALK, &
      0.637937679135684_REALK,      0.000000000000000_REALK,     -0.105309892674673_REALK, &
      0.000000000000000_REALK,      0.338337078000133_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.361506596702492_REALK, &
      0.000000000000000_REALK,     -0.123945650377589_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.432668179825259_REALK,      0.000000000000000_REALK, &
      0.297004615252051_REALK,      0.000000000000000_REALK,     -0.932299894261781_REALK, &
      0.000000000000000_REALK,     -0.139049177809302_REALK,      0.000000000000000_REALK, &
     -1.263361897106450_REALK,     -0.847330132448344_REALK,      0.000000000000000_REALK, &
     -0.755955698370635_REALK,      0.000000000000000_REALK,     -0.958928971150056_REALK, &
     -0.808588546233497_REALK,      0.000000000000000_REALK,     -0.772145887343973_REALK, &
      0.000000000000000_REALK,     -1.109049091668189_REALK,      0.000000000000000_REALK, &
     -0.932354676067240_REALK,      0.000000000000000_REALK,     -1.655767232224311_REALK, &
     -2.017070420365323_REALK,     -1.055621072724018_REALK,      0.000000000000000_REALK, &
     -0.606185910539135_REALK,      0.000000000000000_REALK,     -1.234821157788495_REALK, &
     -0.096485288810378_REALK,      0.000000000000000_REALK,     -0.867271395366471_REALK, &
      0.000000000000000_REALK,      1.122861885674353_REALK,      0.000000000000000_REALK, &
     -0.680053331466405_REALK,      0.000000000000000_REALK,     -1.939408222011255_REALK, &
     -7.169292940326340_REALK,      3.056584388446049_REALK,      0.000000000000000_REALK, &
      1.839596434494833_REALK,      0.000000000000000_REALK,     -0.945820654116248_REALK, &
      2.378131725277496_REALK,      0.000000000000000_REALK,      0.476644477966599_REALK, &
      0.000000000000000_REALK,      2.533819055490822_REALK,      0.000000000000000_REALK, &
      0.372655993023716_REALK,      0.000000000000000_REALK,     -0.574798464173183_REALK, &
     -1.040445764462916_REALK,      2.148779412049962_REALK,      0.000000000000000_REALK, &
      1.830855080699322_REALK,      0.000000000000000_REALK,     -0.213811580810201_REALK, &
      2.472322176734363_REALK,      0.000000000000000_REALK,      0.392169381010125_REALK, &
      0.000000000000000_REALK,      3.811691692782859_REALK,      0.000000000000000_REALK, &
      0.372287690590395_REALK,      0.000000000000000_REALK,     -0.130429907555939_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.988242986089264_REALK, &
      0.000000000000000_REALK,     -0.205191630223210_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.223165728888714_REALK,      0.000000000000000_REALK, &
      0.462320520895036_REALK,      0.000000000000000_REALK,     -0.370687581664860_REALK, &
      0.000000000000000_REALK,     -0.124699998250405_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.297794872915094_REALK, &
      0.000000000000000_REALK,     -0.209344139087782_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.146770429155009_REALK,      0.000000000000000_REALK, &
      0.163049818409726_REALK,      0.000000000000000_REALK,     -0.075185067608427_REALK, &
      0.000000000000000_REALK,     -0.127704666908737_REALK,      0.000000000000000_REALK, &
     -1.157370100693947_REALK,      0.009515860792385_REALK,      0.000000000000000_REALK, &
      0.147466871117380_REALK,      0.000000000000000_REALK,     -0.458063809696877_REALK, &
      0.285102320541471_REALK,      0.000000000000000_REALK,      0.004451716612439_REALK, &
      0.000000000000000_REALK,      0.455575569157190_REALK,      0.000000000000000_REALK, &
      0.089619242998976_REALK,      0.000000000000000_REALK,     -0.463961064149626_REALK, &
     -0.258725022517764_REALK,      0.274422132971295_REALK,      0.000000000000000_REALK, &
      0.422043358252434_REALK,      0.000000000000000_REALK,     -0.159503958637096_REALK, &
      0.621615733283056_REALK,      0.000000000000000_REALK,      0.150252684039113_REALK, &
      0.000000000000000_REALK,      0.988128418659658_REALK,      0.000000000000000_REALK, &
      0.257456008663666_REALK,      0.000000000000000_REALK,     -0.162168379756056_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.545455816831066_REALK, &
      0.000000000000000_REALK,      0.107042982313077_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.003812647297981_REALK,      0.000000000000000_REALK, &
      0.425292532491579_REALK,      0.000000000000000_REALK,     -0.086496073782809_REALK, &
      0.000000000000000_REALK,      0.108421086609287_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.291832531021004_REALK, &
      0.000000000000000_REALK,      0.004889607315642_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.050925023812697_REALK,      0.000000000000000_REALK, &
      0.266308822597897_REALK,      0.000000000000000_REALK,     -0.061391810633100_REALK, &
      0.000000000000000_REALK,      0.004971285369946_REALK,      0.000000000000000_REALK, &
     -0.767104928257635_REALK,     -0.259381145963337_REALK,      0.000000000000000_REALK, &
     -0.082502200112637_REALK,      0.000000000000000_REALK,     -0.506007838610796_REALK, &
      0.062948612260341_REALK,      0.000000000000000_REALK,     -0.202239780094747_REALK, &
      0.000000000000000_REALK,      0.281050658573837_REALK,      0.000000000000000_REALK, &
     -0.083564358826502_REALK,      0.000000000000000_REALK,     -0.717531274944825_REALK, &
     -0.286052270024326_REALK,      0.125120190846337_REALK,      0.000000000000000_REALK, &
      0.428172666317825_REALK,      0.000000000000000_REALK,     -0.293918674751006_REALK, &
      0.765537484290947_REALK,      0.000000000000000_REALK,      0.114177163837550_REALK, &
      0.000000000000000_REALK,      1.279278192733024_REALK,      0.000000000000000_REALK, &
      0.435325042374486_REALK,      0.000000000000000_REALK,     -0.418359782041582_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.906692573068288_REALK, &
      0.000000000000000_REALK,      0.612460878743670_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.557311677965351_REALK,      0.000000000000000_REALK, &
      0.989728949934956_REALK,      0.000000000000000_REALK,      0.649624103979624_REALK, &
      0.000000000000000_REALK,      0.868484244009491_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.246522636759880_REALK, &
      0.000000000000000_REALK,      0.858260262922999_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.558410785798382_REALK,      0.000000000000000_REALK, &
      1.592502262876787_REALK,      0.000000000000000_REALK,      0.097077770907155_REALK, &
      0.000000000000000_REALK,      1.221635803970593_REALK,      0.000000000000000_REALK, &
   -143.415773815603785_REALK,     36.178657048860643_REALK,      0.000000000000000_REALK, &
    -72.722560235839325_REALK,      0.000000000000000_REALK,    -56.953162199612073_REALK, &
     39.311848540305817_REALK,      0.000000000000000_REALK,     14.643649898942821_REALK, &
      0.000000000000000_REALK,   -267.548089651672512_REALK,      0.000000000000000_REALK, &
    -88.673735969817258_REALK,      0.000000000000000_REALK,   -208.336298302340310_REALK, &
    -65.466626232622133_REALK,     17.377210783985930_REALK,      0.000000000000000_REALK, &
    -20.175228157764241_REALK,      0.000000000000000_REALK,    -26.774625506487666_REALK, &
     -1.165043352919112_REALK,      0.000000000000000_REALK,      7.970264308914057_REALK, &
      0.000000000000000_REALK,    127.047745499762158_REALK,      0.000000000000000_REALK, &
    -26.808804099555456_REALK,      0.000000000000000_REALK,   -106.734211543399852_REALK, &
    -37.867798694007938_REALK,     -2.504553698775545_REALK,      0.000000000000000_REALK, &
      4.213632103942007_REALK,      0.000000000000000_REALK,    -16.436850266943868_REALK, &
     -8.667959282324674_REALK,      0.000000000000000_REALK,     -0.942549933380108_REALK, &
      0.000000000000000_REALK,    134.451528791709762_REALK,      0.000000000000000_REALK, &
      5.562932482657332_REALK,      0.000000000000000_REALK,    -65.100905352188278_REALK, &
     -6.691603914407421_REALK,     -5.515969960161870_REALK,      0.000000000000000_REALK, &
     15.642154594743555_REALK,      0.000000000000000_REALK,     -3.542027314917106_REALK, &
    -13.538878703333665_REALK,      0.000000000000000_REALK,     -2.227349228855780_REALK, &
      0.000000000000000_REALK,    172.191805373485408_REALK,      0.000000000000000_REALK, &
     23.733217991622787_REALK,      0.000000000000000_REALK,    -16.122530797411837_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -6.086972447112517_REALK, &
      0.000000000000000_REALK,      7.732872663879500_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.925005406049845_REALK,      0.000000000000000_REALK, &
     -6.872212974292420_REALK,      0.000000000000000_REALK,     27.407041797850503_REALK, &
      0.000000000000000_REALK,     30.627340592386172_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.531821360083569_REALK, &
      0.000000000000000_REALK,      4.020174290309383_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.378904710860877_REALK,      0.000000000000000_REALK, &
     -5.489849773256239_REALK,      0.000000000000000_REALK,     -0.891608703179176_REALK, &
      0.000000000000000_REALK,     18.298950867349021_REALK,      0.000000000000000_REALK, &
    -12.661326099685258_REALK,     -0.328572011390304_REALK,      0.000000000000000_REALK, &
      3.758888409654532_REALK,      0.000000000000000_REALK,     -5.717394146891812_REALK, &
      0.549091788288846_REALK,      0.000000000000000_REALK,      0.177168171302610_REALK, &
      0.000000000000000_REALK,     34.378608085635570_REALK,      0.000000000000000_REALK, &
      5.026659294945628_REALK,      0.000000000000000_REALK,    -22.937147341904840_REALK, &
     -3.195061947475081_REALK,     -0.336373010934878_REALK,      0.000000000000000_REALK, &
      0.946794280173346_REALK,      0.000000000000000_REALK,     -1.466746197413174_REALK, &
     -0.009318593407166_REALK,      0.000000000000000_REALK,     -0.009360652791234_REALK, &
      0.000000000000000_REALK,    -19.968583023637702_REALK,      0.000000000000000_REALK, &
      1.474342194540126_REALK,      0.000000000000000_REALK,     -6.852024308168400_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.149349518778076_REALK, &
      0.000000000000000_REALK,     -1.045091177771749_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.020644148721267_REALK,      0.000000000000000_REALK, &
      0.241590703494874_REALK,      0.000000000000000_REALK,    -12.852472818103653_REALK, &
      0.000000000000000_REALK,     -4.192716072112541_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.092486769161771_REALK, &
      0.000000000000000_REALK,     -2.207677100724862_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.011366042356967_REALK,      0.000000000000000_REALK, &
     -0.007721218758011_REALK,      0.000000000000000_REALK,    -20.896454403331948_REALK, &
      0.000000000000000_REALK,    -10.313343361947908_REALK,      0.000000000000000_REALK, &
     -5.624788948556963_REALK,      0.070262902707410_REALK,      0.000000000000000_REALK, &
     -3.243220583375280_REALK,      0.000000000000000_REALK,     -7.619850043854592_REALK, &
     -0.101708055714982_REALK,      0.000000000000000_REALK,     -0.113658646064328_REALK, &
      0.000000000000000_REALK,    -13.085892629253031_REALK,      0.000000000000000_REALK, &
    -13.011212183721611_REALK,      0.000000000000000_REALK,    -50.949091692447695_REALK, &
     -3.951033887345645_REALK,      0.104971785511664_REALK,      0.000000000000000_REALK, &
     -1.366726113180298_REALK,      0.000000000000000_REALK,     -5.441362977041320_REALK, &
     -0.000426999081614_REALK,      0.000000000000000_REALK,      0.008763525060940_REALK, &
      0.000000000000000_REALK,     10.085877363693685_REALK,      0.000000000000000_REALK, &
     -6.384772339370108_REALK,      0.000000000000000_REALK,    -42.366283789714522_REALK, &
     -3.344239491136653_REALK,      3.926330172811612_REALK,      0.000000000000000_REALK, &
      2.156120369790368_REALK,      0.000000000000000_REALK,     -1.449230978652752_REALK, &
      4.883450162348959_REALK,      0.000000000000000_REALK,      1.990360204728577_REALK, &
      0.000000000000000_REALK,     13.361228358002705_REALK,      0.000000000000000_REALK, &
      2.689776647740986_REALK,      0.000000000000000_REALK,     -5.423780181542442_REALK, &
     -0.260460196054068_REALK,      1.291891421013687_REALK,      0.000000000000000_REALK, &
      1.960024410598961_REALK,      0.000000000000000_REALK,     -0.178576286953869_REALK, &
      3.116215764671927_REALK,      0.000000000000000_REALK,      1.095594188856130_REALK, &
      0.000000000000000_REALK,     24.527366242228332_REALK,      0.000000000000000_REALK, &
      2.916008471611760_REALK,      0.000000000000000_REALK,     -0.797025735144788_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.693000031859761_REALK, &
      0.000000000000000_REALK,     -2.024547185564689_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.230961407315805_REALK,      0.000000000000000_REALK, &
      1.053899920216022_REALK,      0.000000000000000_REALK,     -7.827631383276452_REALK, &
      0.000000000000000_REALK,     -7.576914283098801_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.159249570767461_REALK, &
      0.000000000000000_REALK,     -1.164541004456034_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.087177142755290_REALK,      0.000000000000000_REALK, &
      0.405156891994289_REALK,      0.000000000000000_REALK,     -1.724750630869383_REALK, &
      0.000000000000000_REALK,     -5.197605830065160_REALK,      0.000000000000000_REALK, &
     -2.123542349882958_REALK,      0.126674530543938_REALK,      0.000000000000000_REALK, &
      0.235906104830938_REALK,      0.000000000000000_REALK,     -2.760720366547777_REALK, &
      0.590536385177755_REALK,      0.000000000000000_REALK,      0.192643970412795_REALK, &
      0.000000000000000_REALK,      7.112861492676827_REALK,      0.000000000000000_REALK, &
      0.882884008784009_REALK,      0.000000000000000_REALK,    -17.220098833362258_REALK, &
     -0.467014995125678_REALK,      0.239694932431825_REALK,      0.000000000000000_REALK, &
      1.414027704933919_REALK,      0.000000000000000_REALK,     -0.960582135521516_REALK, &
      1.235597268629285_REALK,      0.000000000000000_REALK,      0.609823017938723_REALK, &
      0.000000000000000_REALK,     15.263041006329384_REALK,      0.000000000000000_REALK, &
      6.311120531536140_REALK,      0.000000000000000_REALK,     -7.145486631984555_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.923594943341197_REALK, &
      0.000000000000000_REALK,      1.298807174634074_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.597830029948230_REALK,      0.000000000000000_REALK, &
      2.340973045573600_REALK,      0.000000000000000_REALK,      4.349727235919727_REALK, &
      0.000000000000000_REALK,      8.101359407380494_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.590787090508261_REALK, &
      0.000000000000000_REALK,      1.090253479607753_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.377528508476903_REALK,      0.000000000000000_REALK, &
      2.505097923416021_REALK,      0.000000000000000_REALK,     -0.237095955327955_REALK, &
      0.000000000000000_REALK,      8.110073439771305_REALK,      0.000000000000000_REALK, &
      2.865312615633128_REALK,      7.747700313171994_REALK,      0.000000000000000_REALK, &
      0.121733659131762_REALK,      0.000000000000000_REALK,      1.098749076991362_REALK, &
      7.310146073422279_REALK,      0.000000000000000_REALK,      3.345973689313669_REALK, &
      0.000000000000000_REALK,     -5.064535205646425_REALK,      0.000000000000000_REALK, &
      0.130401911352816_REALK,      0.000000000000000_REALK,      3.530962120716359_REALK, &
      0.818725878547166_REALK,      3.735799721791784_REALK,      0.000000000000000_REALK, &
     -1.277054762600128_REALK,      0.000000000000000_REALK,      0.293420007260791_REALK, &
      2.031563476774219_REALK,      0.000000000000000_REALK,      1.752954050893377_REALK, &
      0.000000000000000_REALK,    -18.770559520924639_REALK,      0.000000000000000_REALK, &
     -1.507122073061997_REALK,      0.000000000000000_REALK,      1.038842928051985_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.399632101631589_REALK, &
      0.000000000000000_REALK,     -2.334885309234804_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.256770702138816_REALK,      0.000000000000000_REALK, &
      0.517763378840724_REALK,      0.000000000000000_REALK,     -6.136686160673483_REALK, &
      0.000000000000000_REALK,     -7.503434365287767_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.077262360341731_REALK, &
      0.000000000000000_REALK,     -1.582330040108094_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.397917106612474_REALK,      0.000000000000000_REALK, &
      0.108761746583403_REALK,      0.000000000000000_REALK,     -5.311458380793892_REALK, &
      0.000000000000000_REALK,     -5.602182302959007_REALK,      0.000000000000000_REALK, &
     -1.074695618921125_REALK,      0.558278189286068_REALK,      0.000000000000000_REALK, &
      0.270940102028119_REALK,      0.000000000000000_REALK,     -1.236326688641611_REALK, &
      0.747239146438330_REALK,      0.000000000000000_REALK,      0.723305261108152_REALK, &
      0.000000000000000_REALK,      1.984976683939542_REALK,      0.000000000000000_REALK, &
      0.870698558276774_REALK,      0.000000000000000_REALK,     -6.621807165135147_REALK, &
     -0.544249606521143_REALK,      0.503847337481301_REALK,      0.000000000000000_REALK, &
      0.125907031267215_REALK,      0.000000000000000_REALK,     -0.585154546893622_REALK, &
      0.235358637447388_REALK,      0.000000000000000_REALK,      0.709262779359655_REALK, &
      0.000000000000000_REALK,     -2.012509072048581_REALK,      0.000000000000000_REALK, &
      0.445769292438582_REALK,      0.000000000000000_REALK,     -3.452864198166377_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.761281326684206_REALK, &
      0.000000000000000_REALK,     -0.225990037060070_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.084281625031207_REALK,      0.000000000000000_REALK, &
      1.643860233546059_REALK,      0.000000000000000_REALK,     -2.226255828451832_REALK, &
      0.000000000000000_REALK,     -1.210410209859448_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.415603014031002_REALK, &
      0.000000000000000_REALK,     -0.880746986656874_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.861212457316139_REALK,      0.000000000000000_REALK, &
      0.975069652100781_REALK,      0.000000000000000_REALK,     -6.318070342383359_REALK, &
      0.000000000000000_REALK,     -5.197088109482463_REALK,      0.000000000000000_REALK, &
     -1.432299269312808_REALK,     -0.358152046470688_REALK,      0.000000000000000_REALK, &
     -0.701312531786616_REALK,      0.000000000000000_REALK,     -2.746188132398796_REALK, &
     -0.415232438506541_REALK,      0.000000000000000_REALK,     -0.773369694119043_REALK, &
      0.000000000000000_REALK,     -2.266687908908401_REALK,      0.000000000000000_REALK, &
     -3.756253416389591_REALK,      0.000000000000000_REALK,    -20.592145900102334_REALK, &
     -2.019067555393310_REALK,     -0.471706286664146_REALK,      0.000000000000000_REALK, &
     -0.545251796729502_REALK,      0.000000000000000_REALK,     -3.618029137022104_REALK, &
      0.032353999466083_REALK,      0.000000000000000_REALK,     -1.106696701667930_REALK, &
      0.000000000000000_REALK,      3.049478223363483_REALK,      0.000000000000000_REALK, &
     -3.217407124165185_REALK,      0.000000000000000_REALK,    -29.888836510031432_REALK, &
     11.941116809019887_REALK,     11.476669577945389_REALK,      0.000000000000000_REALK, &
     -1.686384705556105_REALK,      0.000000000000000_REALK,      3.854346602850893_REALK, &
     10.029857150258522_REALK,      0.000000000000000_REALK,      4.317870528388784_REALK, &
      0.000000000000000_REALK,    -14.129866747934228_REALK,      0.000000000000000_REALK, &
     -1.447713222383791_REALK,      0.000000000000000_REALK,      9.926540229307671_REALK, &
      2.062058602220013_REALK,      5.439403928970804_REALK,      0.000000000000000_REALK, &
     -1.639009331639306_REALK,      0.000000000000000_REALK,      1.150990771791220_REALK, &
      7.304462728845737_REALK,      0.000000000000000_REALK,      2.761389570695675_REALK, &
      0.000000000000000_REALK,     -0.727916288100025_REALK,      0.000000000000000_REALK, &
     -1.551634779858124_REALK,      0.000000000000000_REALK,      3.268896543171162_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.484700557520788_REALK, &
      0.000000000000000_REALK,     -2.603053180083789_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.020204095384229_REALK,      0.000000000000000_REALK, &
     -0.547077069231256_REALK,      0.000000000000000_REALK,     -4.882165085897602_REALK, &
      0.000000000000000_REALK,     -6.703940971996856_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.156033824306646_REALK, &
      0.000000000000000_REALK,     -1.586589896920539_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.344758450508521_REALK,      0.000000000000000_REALK, &
     -0.237638267396144_REALK,      0.000000000000000_REALK,     -1.740734866263431_REALK, &
      0.000000000000000_REALK,     -4.506029376241263_REALK,      0.000000000000000_REALK, &
     -0.415972647950801_REALK,      1.030007883357799_REALK,      0.000000000000000_REALK, &
      0.199758831006197_REALK,      0.000000000000000_REALK,     -0.402802213934542_REALK, &
      0.950800423452897_REALK,      0.000000000000000_REALK,      1.162560441429461_REALK, &
      0.000000000000000_REALK,      0.851847870123739_REALK,      0.000000000000000_REALK, &
      0.514461795074635_REALK,      0.000000000000000_REALK,     -1.728971121468404_REALK, &
     -0.058786585044227_REALK,      0.841445713870194_REALK,      0.000000000000000_REALK, &
      0.360152772311090_REALK,      0.000000000000000_REALK,     -0.098439709935760_REALK, &
      1.215011175294274_REALK,      0.000000000000000_REALK,      1.281515097387173_REALK, &
      0.000000000000000_REALK,      2.867853592669494_REALK,      0.000000000000000_REALK, &
      1.022859766798187_REALK,      0.000000000000000_REALK,     -0.465959756015239_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.545391343493370_REALK, &
      0.000000000000000_REALK,     -0.562706773849472_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.134903518973264_REALK,      0.000000000000000_REALK, &
      1.025963670259285_REALK,      0.000000000000000_REALK,     -1.497156760582723_REALK, &
      0.000000000000000_REALK,     -2.415338665438647_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.311171356768059_REALK, &
      0.000000000000000_REALK,     -0.641950175145953_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.101970990467395_REALK,      0.000000000000000_REALK, &
      0.789852482458611_REALK,      0.000000000000000_REALK,     -0.604997566108226_REALK, &
      0.000000000000000_REALK,     -3.038641084783276_REALK,      0.000000000000000_REALK, &
     -0.792409338497689_REALK,      0.099692913742507_REALK,      0.000000000000000_REALK, &
      0.065568223910665_REALK,      0.000000000000000_REALK,     -1.278867082013151_REALK, &
      0.344929645900969_REALK,      0.000000000000000_REALK,      0.187537460765269_REALK, &
      0.000000000000000_REALK,      1.360445855128170_REALK,      0.000000000000000_REALK, &
      0.281442260508371_REALK,      0.000000000000000_REALK,     -7.685096673026917_REALK, &
     -0.316219719678619_REALK,      0.468360429329831_REALK,      0.000000000000000_REALK, &
      0.779479064601568_REALK,      0.000000000000000_REALK,     -0.882530639082350_REALK, &
      1.445276517660241_REALK,      0.000000000000000_REALK,      1.188848651218531_REALK, &
      0.000000000000000_REALK,      5.353876957612568_REALK,      0.000000000000000_REALK, &
      3.689627641098856_REALK,      0.000000000000000_REALK,     -5.848384418682253_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.211449407971729_REALK, &
      0.000000000000000_REALK,      0.601655191756734_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.581983051665080_REALK,      0.000000000000000_REALK, &
      3.190487590369524_REALK,      0.000000000000000_REALK,      1.386588785947269_REALK, &
      0.000000000000000_REALK,      3.615526881183342_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.923982375887115_REALK, &
      0.000000000000000_REALK,      1.001665619772953_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.735991008696902_REALK,      0.000000000000000_REALK, &
      6.837156158004898_REALK,      0.000000000000000_REALK,     -0.138611802135529_REALK, &
      0.000000000000000_REALK,      6.637872209741166_REALK,      0.000000000000000_REALK/
    ! results of test 7, ket-major order, 02ODGXXY
  data REF_CONTR_INTS(54181:55440)                                                         &
   /-14.305273990746340_REALK,     -8.540681292911962_REALK,      0.000000000000000_REALK, &
     -7.970539984462286_REALK,      0.000000000000000_REALK,     -3.211088453704699_REALK, &
     -9.285868622568998_REALK,      0.000000000000000_REALK,     -2.371505813176925_REALK, &
      0.000000000000000_REALK,    -18.586648530062710_REALK,      0.000000000000000_REALK, &
     -3.512316547108387_REALK,      0.000000000000000_REALK,     -4.245016949477070_REALK, &
     -3.857509817286957_REALK,     -4.325431503565961_REALK,      0.000000000000000_REALK, &
     -6.719525914522427_REALK,      0.000000000000000_REALK,     -1.384072961466359_REALK, &
    -14.403400669181732_REALK,      0.000000000000000_REALK,     -1.412572678179586_REALK, &
      0.000000000000000_REALK,    -48.974781739830156_REALK,      0.000000000000000_REALK, &
     -3.032227112109461_REALK,      0.000000000000000_REALK,     -1.873714133533871_REALK, &
    -10.990589596361842_REALK,     -4.713766871542480_REALK,      0.000000000000000_REALK, &
     -3.833735087042788_REALK,      0.000000000000000_REALK,     -2.175259538885034_REALK, &
     -4.032692497402067_REALK,      0.000000000000000_REALK,     -1.146144550925669_REALK, &
      0.000000000000000_REALK,     -7.529516568191893_REALK,      0.000000000000000_REALK, &
     -1.393102823957869_REALK,      0.000000000000000_REALK,     -2.371337719737606_REALK, &
     -5.751421031375730_REALK,     -2.567814745957826_REALK,      0.000000000000000_REALK, &
     -2.261398473336500_REALK,      0.000000000000000_REALK,     -0.934909802208151_REALK, &
     -2.418904584046321_REALK,      0.000000000000000_REALK,     -0.591924828247172_REALK, &
      0.000000000000000_REALK,     -2.282091598951508_REALK,      0.000000000000000_REALK, &
     -0.781345378904950_REALK,      0.000000000000000_REALK,     -0.969073954362199_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.064016077159365_REALK, &
      0.000000000000000_REALK,      1.290290373279086_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.245718303879490_REALK,      0.000000000000000_REALK, &
      1.505586197404626_REALK,      0.000000000000000_REALK,      1.835890909429663_REALK, &
      0.000000000000000_REALK,      1.406597317182354_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.272677452645452_REALK, &
      0.000000000000000_REALK,      0.993739912494012_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.424298008049745_REALK,      0.000000000000000_REALK, &
      0.880121181355167_REALK,      0.000000000000000_REALK,      3.501006575569632_REALK, &
      0.000000000000000_REALK,      1.030053877212114_REALK,      0.000000000000000_REALK, &
     -9.478096848929187_REALK,     -2.269093147295379_REALK,      0.000000000000000_REALK, &
     -1.285126396297237_REALK,      0.000000000000000_REALK,     -1.649830189397460_REALK, &
     -0.439295493694670_REALK,      0.000000000000000_REALK,     -0.479791314799639_REALK, &
      0.000000000000000_REALK,      0.144737465450913_REALK,      0.000000000000000_REALK, &
     -0.385048934972934_REALK,      0.000000000000000_REALK,     -1.482963915014213_REALK, &
     -2.082608375645090_REALK,     -0.432251286875862_REALK,      0.000000000000000_REALK, &
      0.066896817436278_REALK,      0.000000000000000_REALK,     -0.563516149281669_REALK, &
      0.621919472183995_REALK,      0.000000000000000_REALK,     -0.106307541492714_REALK, &
      0.000000000000000_REALK,      1.105979885307665_REALK,      0.000000000000000_REALK, &
      0.020197283510745_REALK,      0.000000000000000_REALK,     -0.510405241957878_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.572991419696251_REALK, &
      0.000000000000000_REALK,      0.695905488862901_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.586188682561351_REALK,      0.000000000000000_REALK, &
      0.997809572944391_REALK,      0.000000000000000_REALK,      0.733628268953788_REALK, &
      0.000000000000000_REALK,      0.625520574708909_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.728138137624045_REALK, &
      0.000000000000000_REALK,      0.434832805815576_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.433160593169877_REALK,      0.000000000000000_REALK, &
      0.537233162478423_REALK,      0.000000000000000_REALK,      0.536490439805725_REALK, &
      0.000000000000000_REALK,      0.393850191776112_REALK,      0.000000000000000_REALK, &
     -1.750560536214831_REALK,     -0.933045298642841_REALK,      0.000000000000000_REALK, &
     -0.756363762796393_REALK,      0.000000000000000_REALK,     -0.914147956192702_REALK, &
     -0.772504696004752_REALK,      0.000000000000000_REALK,     -0.591866884535431_REALK, &
      0.000000000000000_REALK,     -1.199245874280124_REALK,      0.000000000000000_REALK, &
     -0.679864009071785_REALK,      0.000000000000000_REALK,     -1.369482791552092_REALK, &
     -0.796486111683686_REALK,     -0.773956939436357_REALK,      0.000000000000000_REALK, &
     -1.046300931474342_REALK,      0.000000000000000_REALK,     -0.646544196971206_REALK, &
     -1.940880596351310_REALK,      0.000000000000000_REALK,     -0.571039082710705_REALK, &
      0.000000000000000_REALK,     -5.102169699542003_REALK,      0.000000000000000_REALK, &
     -0.947687978012107_REALK,      0.000000000000000_REALK,     -0.976013280519142_REALK, &
     -9.618896557719811_REALK,     -0.936193902874490_REALK,      0.000000000000000_REALK, &
     -0.533055781393449_REALK,      0.000000000000000_REALK,     -1.460205282559017_REALK, &
      0.102480615699294_REALK,      0.000000000000000_REALK,     -0.170624941608602_REALK, &
      0.000000000000000_REALK,      0.036338337988333_REALK,      0.000000000000000_REALK, &
     -0.131488406386266_REALK,      0.000000000000000_REALK,     -1.080562704518030_REALK, &
     -5.155591346480471_REALK,     -0.514556227225255_REALK,      0.000000000000000_REALK, &
     -0.521185540371670_REALK,      0.000000000000000_REALK,     -0.631235599041931_REALK, &
     -0.666714992611114_REALK,      0.000000000000000_REALK,     -0.084549258954937_REALK, &
      0.000000000000000_REALK,     -1.446655859198163_REALK,      0.000000000000000_REALK, &
     -0.116939030379852_REALK,      0.000000000000000_REALK,     -0.424893285645850_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.356186330621171_REALK, &
      0.000000000000000_REALK,      0.330257992748451_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.192531887202570_REALK,      0.000000000000000_REALK, &
      0.741510533540542_REALK,      0.000000000000000_REALK,      0.074588608826529_REALK, &
      0.000000000000000_REALK,      0.244393356259851_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.727621890482185_REALK, &
      0.000000000000000_REALK,      0.103153684719840_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.014193248735756_REALK,      0.000000000000000_REALK, &
      0.358677371206282_REALK,      0.000000000000000_REALK,     -0.135401026305020_REALK, &
      0.000000000000000_REALK,      0.069434151200616_REALK,      0.000000000000000_REALK, &
     -1.508129744429213_REALK,     -0.572045242877262_REALK,      0.000000000000000_REALK, &
     -0.403495210736391_REALK,      0.000000000000000_REALK,     -0.686828995317302_REALK, &
     -0.366828271156641_REALK,      0.000000000000000_REALK,     -0.312772340848593_REALK, &
      0.000000000000000_REALK,     -0.537944050629165_REALK,      0.000000000000000_REALK, &
     -0.298589439020034_REALK,      0.000000000000000_REALK,     -0.847097557201938_REALK, &
     -1.419218397740044_REALK,     -0.561463710693151_REALK,      0.000000000000000_REALK, &
     -0.420309891786622_REALK,      0.000000000000000_REALK,     -0.521294909892541_REALK, &
     -0.377008237393259_REALK,      0.000000000000000_REALK,     -0.276770573306542_REALK, &
      0.000000000000000_REALK,     -0.275439845134603_REALK,      0.000000000000000_REALK, &
     -0.282916317111586_REALK,      0.000000000000000_REALK,     -0.584817848757992_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.751443979096175_REALK, &
      0.000000000000000_REALK,      0.407403725810623_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.339945105203048_REALK,      0.000000000000000_REALK, &
      0.684767785080360_REALK,      0.000000000000000_REALK,      0.393494024505087_REALK, &
      0.000000000000000_REALK,      0.502469615118262_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.834829155260516_REALK, &
      0.000000000000000_REALK,      0.554097900050524_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.665969321500879_REALK,      0.000000000000000_REALK, &
      0.685874377732030_REALK,      0.000000000000000_REALK,      1.267674850693779_REALK, &
      0.000000000000000_REALK,      0.621618081741229_REALK,      0.000000000000000_REALK, &
    -11.102722519996615_REALK,      0.411535072043020_REALK,      0.000000000000000_REALK, &
     -0.005891054101088_REALK,      0.000000000000000_REALK,     -1.464744761267403_REALK, &
      0.724931170778971_REALK,      0.000000000000000_REALK,      0.064174874516917_REALK, &
      0.000000000000000_REALK,      0.726071459897110_REALK,      0.000000000000000_REALK, &
     -0.001193379468905_REALK,      0.000000000000000_REALK,     -0.890161401654842_REALK, &
     -2.805529125024345_REALK,      0.624286976502419_REALK,      0.000000000000000_REALK, &
      0.621842494459975_REALK,      0.000000000000000_REALK,     -0.576536171051792_REALK, &
      1.262176640991181_REALK,      0.000000000000000_REALK,      0.113937352421891_REALK, &
      0.000000000000000_REALK,      2.083427644973353_REALK,      0.000000000000000_REALK, &
      0.126446002533989_REALK,      0.000000000000000_REALK,     -0.351700124043759_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.380662514829959_REALK, &
      0.000000000000000_REALK,      0.135338545974330_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.078596725341929_REALK,      0.000000000000000_REALK, &
      0.645902497686718_REALK,      0.000000000000000_REALK,     -0.016466688394003_REALK, &
      0.000000000000000_REALK,      0.082248561638954_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.637217347930484_REALK, &
      0.000000000000000_REALK,      0.083670774348491_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.096021904199935_REALK,      0.000000000000000_REALK, &
      0.348891745014082_REALK,      0.000000000000000_REALK,      0.134161810802614_REALK, &
      0.000000000000000_REALK,      0.051041067663660_REALK,      0.000000000000000_REALK, &
     -1.486081381817120_REALK,     -0.312267621722113_REALK,      0.000000000000000_REALK, &
     -0.152714986578350_REALK,      0.000000000000000_REALK,     -0.588161123971145_REALK, &
     -0.044585074552912_REALK,      0.000000000000000_REALK,     -0.146085255919217_REALK, &
      0.000000000000000_REALK,      0.011628728897890_REALK,      0.000000000000000_REALK, &
     -0.092808651787673_REALK,      0.000000000000000_REALK,     -0.595733291284620_REALK, &
     -0.575751301332732_REALK,     -0.104131195240254_REALK,      0.000000000000000_REALK, &
      0.014045777892322_REALK,      0.000000000000000_REALK,     -0.354950637782717_REALK, &
      0.111181564736777_REALK,      0.000000000000000_REALK,     -0.057014320993875_REALK, &
      0.000000000000000_REALK,      0.156395686426574_REALK,      0.000000000000000_REALK, &
      0.008568242679395_REALK,      0.000000000000000_REALK,     -0.360879882320453_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.649414886563796_REALK, &
      0.000000000000000_REALK,      0.248088898565237_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.178480770842390_REALK,      0.000000000000000_REALK, &
      0.506349539636475_REALK,      0.000000000000000_REALK,      0.176827006571805_REALK, &
      0.000000000000000_REALK,      0.251282871393411_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.526234832882611_REALK, &
      0.000000000000000_REALK,      0.273894868762562_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.232310490432865_REALK,      0.000000000000000_REALK, &
      0.480210270817563_REALK,      0.000000000000000_REALK,      0.227593987131248_REALK, &
      0.000000000000000_REALK,      0.278470123690032_REALK,      0.000000000000000_REALK, &
     -0.823417019917842_REALK,     -0.385210942151249_REALK,      0.000000000000000_REALK, &
     -0.269642150880898_REALK,      0.000000000000000_REALK,     -0.543153160898524_REALK, &
     -0.235209647889891_REALK,      0.000000000000000_REALK,     -0.300349418001918_REALK, &
      0.000000000000000_REALK,     -0.289055189210408_REALK,      0.000000000000000_REALK, &
     -0.273113606912283_REALK,      0.000000000000000_REALK,     -0.770204234582216_REALK, &
     -0.660582067168464_REALK,     -0.559348672508236_REALK,      0.000000000000000_REALK, &
     -0.659049759998687_REALK,      0.000000000000000_REALK,     -0.678747998503632_REALK, &
     -1.040923228750812_REALK,      0.000000000000000_REALK,     -0.510427970028625_REALK, &
      0.000000000000000_REALK,     -2.164480592346644_REALK,      0.000000000000000_REALK, &
     -0.670058803999787_REALK,      0.000000000000000_REALK,     -0.966120526215954_REALK, &
    -15.056626967220865_REALK,      2.301939431631734_REALK,      0.000000000000000_REALK, &
      0.185589729156608_REALK,      0.000000000000000_REALK,     -1.688647752259648_REALK, &
      1.017461323880678_REALK,      0.000000000000000_REALK,      0.301925399621944_REALK, &
      0.000000000000000_REALK,      0.452113889673492_REALK,      0.000000000000000_REALK, &
      0.030595239229365_REALK,      0.000000000000000_REALK,     -0.835141829065061_REALK, &
    -11.568490588236187_REALK,      1.730017721688297_REALK,      0.000000000000000_REALK, &
     -0.297706006324875_REALK,      0.000000000000000_REALK,     -1.019578975769525_REALK, &
     -0.477157865364838_REALK,      0.000000000000000_REALK,      0.191286263323772_REALK, &
      0.000000000000000_REALK,     -1.865943656281299_REALK,      0.000000000000000_REALK, &
     -0.041788523078725_REALK,      0.000000000000000_REALK,     -0.429350083515271_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.639849416612461_REALK, &
      0.000000000000000_REALK,     -0.060167202197353_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000865049152266_REALK,      0.000000000000000_REALK, &
      0.645254410642204_REALK,      0.000000000000000_REALK,     -0.112044741343228_REALK, &
      0.000000000000000_REALK,     -0.029756441049109_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.218340779059817_REALK, &
      0.000000000000000_REALK,     -0.176429140338376_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.145296733127103_REALK,      0.000000000000000_REALK, &
      0.404132025053294_REALK,      0.000000000000000_REALK,     -0.274342921052849_REALK, &
      0.000000000000000_REALK,     -0.074295241407501_REALK,      0.000000000000000_REALK, &
     -1.799820203668029_REALK,     -0.151517753488430_REALK,      0.000000000000000_REALK, &
     -0.073688419358749_REALK,      0.000000000000000_REALK,     -0.605566375791637_REALK, &
      0.011936266046976_REALK,      0.000000000000000_REALK,     -0.059619802732236_REALK, &
      0.000000000000000_REALK,      0.003357196444200_REALK,      0.000000000000000_REALK, &
     -0.036443527812020_REALK,      0.000000000000000_REALK,     -0.499150686323010_REALK, &
     -2.043287413454656_REALK,     -0.176813739575624_REALK,      0.000000000000000_REALK, &
     -0.148687516881370_REALK,      0.000000000000000_REALK,     -0.540250140411056_REALK, &
     -0.154162823888374_REALK,      0.000000000000000_REALK,     -0.058650334832496_REALK, &
      0.000000000000000_REALK,     -0.258196098789836_REALK,      0.000000000000000_REALK, &
     -0.062613097472427_REALK,      0.000000000000000_REALK,     -0.379170305287950_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.658473545372956_REALK, &
      0.000000000000000_REALK,      0.136962342304646_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.067274532236989_REALK,      0.000000000000000_REALK, &
      0.431831275826143_REALK,      0.000000000000000_REALK,      0.020673092897971_REALK, &
      0.000000000000000_REALK,      0.112894060659164_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.750084484335201_REALK, &
      0.000000000000000_REALK,      0.088285249973853_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.009845607176246_REALK,      0.000000000000000_REALK, &
      0.414680313348462_REALK,      0.000000000000000_REALK,     -0.072498272222407_REALK, &
      0.000000000000000_REALK,      0.061962307237049_REALK,      0.000000000000000_REALK, &
     -0.846571860136475_REALK,     -0.277746981138349_REALK,      0.000000000000000_REALK, &
     -0.167334781851156_REALK,      0.000000000000000_REALK,     -0.474728394300385_REALK, &
     -0.128177211120368_REALK,      0.000000000000000_REALK,     -0.182148294437401_REALK, &
      0.000000000000000_REALK,     -0.149097395802511_REALK,      0.000000000000000_REALK, &
     -0.137929175967748_REALK,      0.000000000000000_REALK,     -0.547826660506376_REALK, &
     -1.687413272790801_REALK,     -0.578796794622429_REALK,      0.000000000000000_REALK, &
     -0.359726983710236_REALK,      0.000000000000000_REALK,     -0.743593592979816_REALK, &
     -0.261523987685204_REALK,      0.000000000000000_REALK,     -0.319984803274314_REALK, &
      0.000000000000000_REALK,     -0.147479774846623_REALK,      0.000000000000000_REALK, &
     -0.252471549808287_REALK,      0.000000000000000_REALK,     -0.730639427921509_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.608085051801086_REALK, &
      0.000000000000000_REALK,      0.281592824276036_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.197972816097101_REALK,      0.000000000000000_REALK, &
      0.558300639115085_REALK,      0.000000000000000_REALK,      0.181769009400824_REALK, &
      0.000000000000000_REALK,      0.324952243004215_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.434335618134043_REALK, &
      0.000000000000000_REALK,      0.790384944380282_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.769952021204092_REALK,      0.000000000000000_REALK, &
      1.110151000847040_REALK,      0.000000000000000_REALK,      1.131259721868264_REALK, &
      0.000000000000000_REALK,      0.776615625863063_REALK,      0.000000000000000_REALK, &
    -54.773585811651792_REALK,      3.602401764588083_REALK,      0.000000000000000_REALK, &
    -19.472420751882954_REALK,      0.000000000000000_REALK,    -23.774955493047493_REALK, &
      2.666476696205398_REALK,      0.000000000000000_REALK,      1.355708022902800_REALK, &
      0.000000000000000_REALK,    -62.309728814793800_REALK,      0.000000000000000_REALK, &
    -25.707930650917433_REALK,      0.000000000000000_REALK,    -94.164703222861107_REALK, &
    -18.434058209426080_REALK,      2.644582778861762_REALK,      0.000000000000000_REALK, &
    -10.969472373419354_REALK,      0.000000000000000_REALK,     -9.757591533769125_REALK, &
      6.177015665318653_REALK,      0.000000000000000_REALK,      1.067882794084339_REALK, &
      0.000000000000000_REALK,   -128.401809859562633_REALK,      0.000000000000000_REALK, &
    -16.643543414340794_REALK,      0.000000000000000_REALK,    -44.414414691050752_REALK, &
    -24.656523204488380_REALK,     -0.079510424362517_REALK,      0.000000000000000_REALK, &
     -7.024641124238996_REALK,      0.000000000000000_REALK,    -11.133988678764728_REALK, &
      0.085165472591955_REALK,      0.000000000000000_REALK,      0.042872539338320_REALK, &
      0.000000000000000_REALK,    -27.420378747779729_REALK,      0.000000000000000_REALK, &
     -9.393861629443409_REALK,      0.000000000000000_REALK,    -44.667541237604219_REALK, &
     -9.463575548007579_REALK,     -0.029444260043771_REALK,      0.000000000000000_REALK, &
     -3.983144695130818_REALK,      0.000000000000000_REALK,     -4.344411368906808_REALK, &
      0.008395392426060_REALK,      0.000000000000000_REALK,     -0.000819380526989_REALK, &
      0.000000000000000_REALK,    -27.648667797949148_REALK,      0.000000000000000_REALK, &
     -6.202528272472059_REALK,      0.000000000000000_REALK,    -20.295271504322187_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.216025461337790_REALK, &
      0.000000000000000_REALK,      1.503197278142206_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.095402621787713_REALK,      0.000000000000000_REALK, &
      0.349447012647916_REALK,      0.000000000000000_REALK,      3.953735607407650_REALK, &
      0.000000000000000_REALK,      6.030554579037060_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.254782935173325_REALK, &
      0.000000000000000_REALK,      1.058451167071445_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.007970736184373_REALK,      0.000000000000000_REALK, &
     -0.021270445449775_REALK,      0.000000000000000_REALK,      9.533856460891082_REALK, &
      0.000000000000000_REALK,      4.944640823731918_REALK,      0.000000000000000_REALK, &
    -13.834753947973468_REALK,      2.234718727280556_REALK,      0.000000000000000_REALK, &
     -3.664046233769089_REALK,      0.000000000000000_REALK,     -5.995310460444039_REALK, &
      2.647176229164637_REALK,      0.000000000000000_REALK,      1.132837797070898_REALK, &
      0.000000000000000_REALK,     -9.134984733353178_REALK,      0.000000000000000_REALK, &
     -4.570925693166944_REALK,      0.000000000000000_REALK,    -22.437586924742305_REALK, &
     -3.167541681771505_REALK,      0.740956395167987_REALK,      0.000000000000000_REALK, &
     -0.509164824119636_REALK,      0.000000000000000_REALK,     -2.171724666078898_REALK, &
      1.893066036865959_REALK,      0.000000000000000_REALK,      0.628371322494645_REALK, &
      0.000000000000000_REALK,      9.504829896733220_REALK,      0.000000000000000_REALK, &
     -0.757505331337098_REALK,      0.000000000000000_REALK,     -9.692890797761624_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.349540421890421_REALK, &
      0.000000000000000_REALK,     -0.489915757538383_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.431622549840960_REALK,      0.000000000000000_REALK, &
      2.052352781487934_REALK,      0.000000000000000_REALK,     -1.214084676279439_REALK, &
      0.000000000000000_REALK,     -1.833520960773446_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.471687362786989_REALK, &
      0.000000000000000_REALK,     -0.101937572433456_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.366752504713929_REALK,      0.000000000000000_REALK, &
      1.200049613815430_REALK,      0.000000000000000_REALK,      1.553878117711092_REALK, &
      0.000000000000000_REALK,     -0.454970085858254_REALK,      0.000000000000000_REALK, &
     -3.071581479184208_REALK,     -0.182201145291054_REALK,      0.000000000000000_REALK, &
     -1.090190794518650_REALK,      0.000000000000000_REALK,     -3.993222714659855_REALK, &
     -0.181663464034588_REALK,      0.000000000000000_REALK,     -0.277087682045544_REALK, &
      0.000000000000000_REALK,     -3.296358730085410_REALK,      0.000000000000000_REALK, &
     -4.080064056391564_REALK,      0.000000000000000_REALK,    -24.907879350365867_REALK, &
     -1.286534844999703_REALK,     -0.114919605267576_REALK,      0.000000000000000_REALK, &
     -0.991624123810579_REALK,      0.000000000000000_REALK,     -2.646215649885232_REALK, &
     -0.563732333495885_REALK,      0.000000000000000_REALK,     -0.292374226662196_REALK, &
      0.000000000000000_REALK,    -11.381506134525894_REALK,      0.000000000000000_REALK, &
     -4.425839285546338_REALK,      0.000000000000000_REALK,    -19.684416201783161_REALK, &
     -9.075437053324555_REALK,      5.609133179539145_REALK,      0.000000000000000_REALK, &
     -4.024917722930350_REALK,      0.000000000000000_REALK,     -3.480118724647508_REALK, &
      5.297990537549655_REALK,      0.000000000000000_REALK,      2.422397779982078_REALK, &
      0.000000000000000_REALK,    -15.889494157188523_REALK,      0.000000000000000_REALK, &
     -4.311518834243271_REALK,      0.000000000000000_REALK,    -11.183779490376471_REALK, &
     -4.857339317346772_REALK,      2.687071851206424_REALK,      0.000000000000000_REALK, &
     -2.761271677728011_REALK,      0.000000000000000_REALK,     -1.740803088199819_REALK, &
      1.371087951714121_REALK,      0.000000000000000_REALK,      1.260858139460088_REALK, &
      0.000000000000000_REALK,    -19.679230097115806_REALK,      0.000000000000000_REALK, &
     -3.258727516705469_REALK,      0.000000000000000_REALK,     -6.163250400645349_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.653234408133076_REALK, &
      0.000000000000000_REALK,     -1.328928464226132_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.436348423444210_REALK,      0.000000000000000_REALK, &
      2.141930614872967_REALK,      0.000000000000000_REALK,     -3.326518995857751_REALK, &
      0.000000000000000_REALK,     -4.270671226567161_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.939612848804262_REALK, &
      0.000000000000000_REALK,     -0.907535682499224_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.103368811381599_REALK,      0.000000000000000_REALK, &
      1.322687193300276_REALK,      0.000000000000000_REALK,     -3.226651241836124_REALK, &
      0.000000000000000_REALK,     -3.213097274860334_REALK,      0.000000000000000_REALK, &
     -2.092850089877189_REALK,      0.135096521321608_REALK,      0.000000000000000_REALK, &
     -0.506335058530551_REALK,      0.000000000000000_REALK,     -2.407608606461685_REALK, &
      0.115898610037404_REALK,      0.000000000000000_REALK,      0.175031062478527_REALK, &
      0.000000000000000_REALK,     -1.583217457308171_REALK,      0.000000000000000_REALK, &
     -1.627168522368763_REALK,      0.000000000000000_REALK,    -12.895232358548990_REALK, &
     -1.612033617174913_REALK,      0.044104049804493_REALK,      0.000000000000000_REALK, &
     -0.529688374944404_REALK,      0.000000000000000_REALK,     -1.733191516416150_REALK, &
     -0.212041456891336_REALK,      0.000000000000000_REALK,      0.062084998010956_REALK, &
      0.000000000000000_REALK,     -2.786536966972708_REALK,      0.000000000000000_REALK, &
     -1.875342542314329_REALK,      0.000000000000000_REALK,    -10.227169843195204_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.101149512568409_REALK, &
      0.000000000000000_REALK,      0.325050690141934_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.389489927875934_REALK,      0.000000000000000_REALK, &
      2.377748975906132_REALK,      0.000000000000000_REALK,      0.684850850472177_REALK, &
      0.000000000000000_REALK,      1.740982386604396_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.144904906305813_REALK, &
      0.000000000000000_REALK,      0.422266315855494_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.603947889720294_REALK,      0.000000000000000_REALK, &
      2.686125920628716_REALK,      0.000000000000000_REALK,      2.882573980803715_REALK, &
      0.000000000000000_REALK,      2.491697709347390_REALK,      0.000000000000000_REALK, &
     -5.025796733790924_REALK,      9.740780174032881_REALK,      0.000000000000000_REALK, &
     -5.578374818021519_REALK,      0.000000000000000_REALK,     -1.622223689569293_REALK, &
      8.835478655517353_REALK,      0.000000000000000_REALK,      3.664776384064903_REALK, &
      0.000000000000000_REALK,    -20.681300265268032_REALK,      0.000000000000000_REALK, &
     -4.788875845976921_REALK,      0.000000000000000_REALK,     -4.177898454574579_REALK, &
     -2.343682965996808_REALK,      4.753848962963569_REALK,      0.000000000000000_REALK, &
     -3.050455203067314_REALK,      0.000000000000000_REALK,     -1.308186616501779_REALK, &
      6.691195495485191_REALK,      0.000000000000000_REALK,      2.413357992605262_REALK, &
      0.000000000000000_REALK,     -3.834930578650948_REALK,      0.000000000000000_REALK, &
     -2.887837363771662_REALK,      0.000000000000000_REALK,     -3.715344043854006_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.535214473803324_REALK, &
      0.000000000000000_REALK,     -1.884542686258743_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.668014271219265_REALK,      0.000000000000000_REALK, &
      1.732782481756699_REALK,      0.000000000000000_REALK,     -3.538323881362836_REALK, &
      0.000000000000000_REALK,     -4.853478609100236_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.925717935025524_REALK, &
      0.000000000000000_REALK,     -1.141196361934238_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.745443165732629_REALK,      0.000000000000000_REALK, &
      1.409861016702861_REALK,      0.000000000000000_REALK,     -1.174809760831180_REALK, &
      0.000000000000000_REALK,     -3.241079715001401_REALK,      0.000000000000000_REALK, &
     -1.720833465647026_REALK,      0.586241555059541_REALK,      0.000000000000000_REALK, &
     -0.339464161029904_REALK,      0.000000000000000_REALK,     -1.666348816899265_REALK, &
      0.515401242148343_REALK,      0.000000000000000_REALK,      0.661685460903956_REALK, &
      0.000000000000000_REALK,     -0.582402836043064_REALK,      0.000000000000000_REALK, &
     -0.874260931380457_REALK,      0.000000000000000_REALK,     -7.152564914104632_REALK, &
     -0.714922899074915_REALK,      0.482606024575668_REALK,      0.000000000000000_REALK, &
     -0.093558591402409_REALK,      0.000000000000000_REALK,     -1.197157527664170_REALK, &
      0.738105626843311_REALK,      0.000000000000000_REALK,      0.735005118439687_REALK, &
      0.000000000000000_REALK,      1.111348862240593_REALK,      0.000000000000000_REALK, &
     -0.265713126043006_REALK,      0.000000000000000_REALK,     -5.666689081735728_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.062088932114754_REALK, &
      0.000000000000000_REALK,     -0.136168184840578_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.252108789595923_REALK,      0.000000000000000_REALK, &
      1.997950044374814_REALK,      0.000000000000000_REALK,     -0.232212656934136_REALK, &
      0.000000000000000_REALK,     -0.584482535367568_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.921670281065326_REALK, &
      0.000000000000000_REALK,     -0.056192819511905_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.428989927635677_REALK,      0.000000000000000_REALK, &
      2.339494120117242_REALK,      0.000000000000000_REALK,      0.545059942242303_REALK, &
      0.000000000000000_REALK,     -0.265986079059584_REALK,      0.000000000000000_REALK, &
     -1.146174385547933_REALK,     -0.143392385061863_REALK,      0.000000000000000_REALK, &
     -0.303009852888598_REALK,      0.000000000000000_REALK,     -1.849807442581238_REALK, &
     -0.106108812082311_REALK,      0.000000000000000_REALK,     -0.269742780886456_REALK, &
      0.000000000000000_REALK,     -0.630480092432191_REALK,      0.000000000000000_REALK, &
     -1.300626627762062_REALK,      0.000000000000000_REALK,    -11.116048901925938_REALK, &
     -0.871123394941737_REALK,     -0.224551245683288_REALK,      0.000000000000000_REALK, &
     -0.546630198098092_REALK,      0.000000000000000_REALK,     -2.431199063862476_REALK, &
     -0.659396977100200_REALK,      0.000000000000000_REALK,     -0.569982920935496_REALK, &
      0.000000000000000_REALK,     -3.992335695835138_REALK,      0.000000000000000_REALK, &
     -2.587448438263038_REALK,      0.000000000000000_REALK,    -16.111153646283103_REALK, &
      3.054894077665048_REALK,     15.323013695969193_REALK,      0.000000000000000_REALK, &
     -8.775387972330657_REALK,      0.000000000000000_REALK,      0.804585761464128_REALK, &
     13.838553264597365_REALK,      0.000000000000000_REALK,      4.896245232147249_REALK, &
      0.000000000000000_REALK,    -29.597185368848574_REALK,      0.000000000000000_REALK, &
     -5.732221341906958_REALK,      0.000000000000000_REALK,      1.576704193980229_REALK, &
     -5.653823192237355_REALK,     12.904504690945075_REALK,      0.000000000000000_REALK, &
     -9.587990913874396_REALK,      0.000000000000000_REALK,     -1.280298754895459_REALK, &
      9.392523155951876_REALK,      0.000000000000000_REALK,      4.029718099523486_REALK, &
      0.000000000000000_REALK,    -32.286424715318333_REALK,      0.000000000000000_REALK, &
     -5.839769006178017_REALK,      0.000000000000000_REALK,     -2.339379246803722_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.997873674043931_REALK, &
      0.000000000000000_REALK,     -2.589949412658644_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.096456709882250_REALK,      0.000000000000000_REALK, &
      0.956567875438518_REALK,      0.000000000000000_REALK,     -4.078782137921455_REALK, &
      0.000000000000000_REALK,     -5.075386983861731_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.488108997216547_REALK, &
      0.000000000000000_REALK,     -2.450826966004899_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.083585084830379_REALK,      0.000000000000000_REALK, &
      1.394085221501382_REALK,      0.000000000000000_REALK,     -4.138687876666938_REALK, &
      0.000000000000000_REALK,     -4.478184267426666_REALK,      0.000000000000000_REALK, &
     -1.549852645775845_REALK,      1.159233184869172_REALK,      0.000000000000000_REALK, &
     -0.472095153449146_REALK,      0.000000000000000_REALK,     -1.224581939134072_REALK, &
      0.810131455948291_REALK,      0.000000000000000_REALK,      1.111248100467788_REALK, &
      0.000000000000000_REALK,     -1.136490870645991_REALK,      0.000000000000000_REALK, &
     -0.925139921748659_REALK,      0.000000000000000_REALK,     -3.999580843918972_REALK, &
     -2.107544961777160_REALK,      1.298151618708921_REALK,      0.000000000000000_REALK, &
     -0.757016662177566_REALK,      0.000000000000000_REALK,     -1.431750038179944_REALK, &
      0.440816491371661_REALK,      0.000000000000000_REALK,      1.216129994708214_REALK, &
      0.000000000000000_REALK,     -2.784412337720352_REALK,      0.000000000000000_REALK, &
     -1.383231110872577_REALK,      0.000000000000000_REALK,     -4.360188475699551_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.025016233488434_REALK, &
      0.000000000000000_REALK,     -0.467622493499078_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.200169997141460_REALK,      0.000000000000000_REALK, &
      1.637644834648775_REALK,      0.000000000000000_REALK,     -0.713784548285154_REALK, &
      0.000000000000000_REALK,     -1.527291810711387_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.361809443339574_REALK, &
      0.000000000000000_REALK,     -0.746416557321030_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.099701868199327_REALK,      0.000000000000000_REALK, &
      2.126276169971149_REALK,      0.000000000000000_REALK,     -1.369615703909973_REALK, &
      0.000000000000000_REALK,     -2.273104092554915_REALK,      0.000000000000000_REALK, &
     -1.072215882259961_REALK,      0.083760733965632_REALK,      0.000000000000000_REALK, &
     -0.178168854825408_REALK,      0.000000000000000_REALK,     -1.411979613940401_REALK, &
      0.053167201239705_REALK,      0.000000000000000_REALK,      0.133822596017213_REALK, &
      0.000000000000000_REALK,     -0.339717331844212_REALK,      0.000000000000000_REALK, &
     -0.581913480813360_REALK,      0.000000000000000_REALK,     -6.456290926419245_REALK, &
     -2.098329830052835_REALK,      0.063921339080996_REALK,      0.000000000000000_REALK, &
     -0.435650278995296_REALK,      0.000000000000000_REALK,     -2.375816308215268_REALK, &
     -0.204519420366834_REALK,      0.000000000000000_REALK,      0.099804286646202_REALK, &
      0.000000000000000_REALK,     -1.182800527062764_REALK,      0.000000000000000_REALK, &
     -1.326710162568090_REALK,      0.000000000000000_REALK,    -10.129288811389760_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.137866596863984_REALK, &
      0.000000000000000_REALK,      0.190631046402589_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.297790303805698_REALK,      0.000000000000000_REALK, &
      2.545120566475979_REALK,      0.000000000000000_REALK,      0.244918665004717_REALK, &
      0.000000000000000_REALK,      0.871662368940398_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.765575763672610_REALK, &
      0.000000000000000_REALK,      0.578832281439913_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.970872034084248_REALK,      0.000000000000000_REALK, &
      6.045287040583948_REALK,      0.000000000000000_REALK,      2.039275550144076_REALK, &
      0.000000000000000_REALK,      2.467850452826031_REALK,      0.000000000000000_REALK/
    ! results of test 7, ket-major order, 02ODGXYY
  data REF_CONTR_INTS(55441:56700)                                                         &
    /-9.990114141531915_REALK,     -4.205221431133410_REALK,      0.000000000000000_REALK, &
     -3.058391496218793_REALK,      0.000000000000000_REALK,     -1.977245250619782_REALK, &
     -2.289253897416152_REALK,      0.000000000000000_REALK,     -1.022492575487134_REALK, &
      0.000000000000000_REALK,     -1.688150005709021_REALK,      0.000000000000000_REALK, &
     -1.111358435941815_REALK,      0.000000000000000_REALK,     -2.155474397491899_REALK, &
     -4.010509699724212_REALK,     -0.287328079267282_REALK,      0.000000000000000_REALK, &
      2.143240521711811_REALK,      0.000000000000000_REALK,     -0.651919727258460_REALK, &
      7.806120536525577_REALK,      0.000000000000000_REALK,     -0.066233993024071_REALK, &
      0.000000000000000_REALK,     29.131066202500694_REALK,      0.000000000000000_REALK, &
      0.740520123837623_REALK,      0.000000000000000_REALK,     -0.675742650819298_REALK, &
     -9.340377496615645_REALK,     -2.623950389235196_REALK,      0.000000000000000_REALK, &
     -1.643403933115630_REALK,      0.000000000000000_REALK,     -1.625857703282085_REALK, &
     -0.846374157659673_REALK,      0.000000000000000_REALK,     -0.554824560076245_REALK, &
      0.000000000000000_REALK,     -0.388689729924095_REALK,      0.000000000000000_REALK, &
     -0.492395873277313_REALK,      0.000000000000000_REALK,     -1.461416041729592_REALK, &
     -2.200080294602209_REALK,     -0.824754743394669_REALK,      0.000000000000000_REALK, &
     -0.714785434545019_REALK,      0.000000000000000_REALK,     -0.595301925327508_REALK, &
     -1.333877471267794_REALK,      0.000000000000000_REALK,     -0.202839532852384_REALK, &
      0.000000000000000_REALK,     -5.194159927834518_REALK,      0.000000000000000_REALK, &
     -0.215805842850571_REALK,      0.000000000000000_REALK,     -0.539195236236082_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.429801712513928_REALK, &
      0.000000000000000_REALK,      0.620827621636712_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.467636506232421_REALK,      0.000000000000000_REALK, &
      0.906978778329366_REALK,      0.000000000000000_REALK,      0.416461551442135_REALK, &
      0.000000000000000_REALK,      0.558036194420457_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.507736270349492_REALK, &
      0.000000000000000_REALK,      0.048656031395594_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.410527974895409_REALK,      0.000000000000000_REALK, &
      0.374616776859032_REALK,      0.000000000000000_REALK,     -1.731324611742897_REALK, &
      0.000000000000000_REALK,      0.044070242723008_REALK,      0.000000000000000_REALK, &
    -10.090161411603367_REALK,     -1.696718736716154_REALK,      0.000000000000000_REALK, &
     -1.148014868018560_REALK,      0.000000000000000_REALK,     -1.531746069487732_REALK, &
     -0.531786428169764_REALK,      0.000000000000000_REALK,     -0.309233519348424_REALK, &
      0.000000000000000_REALK,     -0.726259310376022_REALK,      0.000000000000000_REALK, &
     -0.283179829902423_REALK,      0.000000000000000_REALK,     -1.133503415752525_REALK, &
     -5.689538010876416_REALK,     -0.875994331066953_REALK,      0.000000000000000_REALK, &
     -0.508526226428902_REALK,      0.000000000000000_REALK,     -0.696610474571292_REALK, &
     -0.018168821671708_REALK,      0.000000000000000_REALK,     -0.143938927607252_REALK, &
      0.000000000000000_REALK,      1.175761946732580_REALK,      0.000000000000000_REALK, &
     -0.114098644791477_REALK,      0.000000000000000_REALK,     -0.468898005443843_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.336480570483183_REALK, &
      0.000000000000000_REALK,      0.381906132700301_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.246207424880950_REALK,      0.000000000000000_REALK, &
      0.730736181680611_REALK,      0.000000000000000_REALK,      0.143707076154162_REALK, &
      0.000000000000000_REALK,      0.282613361663400_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.768664239466144_REALK, &
      0.000000000000000_REALK,      0.196821833397479_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.151653364898213_REALK,      0.000000000000000_REALK, &
      0.378908980554844_REALK,      0.000000000000000_REALK,      0.290404765653279_REALK, &
      0.000000000000000_REALK,      0.132483458800523_REALK,      0.000000000000000_REALK, &
     -1.370844407844560_REALK,     -0.510330056721325_REALK,      0.000000000000000_REALK, &
     -0.321891391361914_REALK,      0.000000000000000_REALK,     -0.624306821647210_REALK, &
     -0.208238800743860_REALK,      0.000000000000000_REALK,     -0.279028850311358_REALK, &
      0.000000000000000_REALK,     -0.120609370324931_REALK,      0.000000000000000_REALK, &
     -0.238202009378803_REALK,      0.000000000000000_REALK,     -0.769986105955733_REALK, &
     -0.989631800404298_REALK,     -0.062825517232384_REALK,      0.000000000000000_REALK, &
      0.398348721985428_REALK,      0.000000000000000_REALK,     -0.363502911912678_REALK, &
      1.216654746849029_REALK,      0.000000000000000_REALK,     -0.030969507185461_REALK, &
      0.000000000000000_REALK,      3.516009772398784_REALK,      0.000000000000000_REALK, &
      0.268133954381066_REALK,      0.000000000000000_REALK,     -0.407797941103741_REALK, &
    -12.312663096501026_REALK,     -0.711329838947053_REALK,      0.000000000000000_REALK, &
     -0.723677307695879_REALK,      0.000000000000000_REALK,     -1.624368143522322_REALK, &
      0.092109238976501_REALK,      0.000000000000000_REALK,     -0.110924939952126_REALK, &
      0.000000000000000_REALK,      0.095657975815676_REALK,      0.000000000000000_REALK, &
     -0.146598830412603_REALK,      0.000000000000000_REALK,     -0.987168455335633_REALK, &
     -3.416261470767274_REALK,     -0.044808548476283_REALK,      0.000000000000000_REALK, &
      0.011056912795001_REALK,      0.000000000000000_REALK,     -0.702041654139245_REALK, &
      0.366219608220823_REALK,      0.000000000000000_REALK,     -0.008177917482531_REALK, &
      0.000000000000000_REALK,      0.100814468072377_REALK,      0.000000000000000_REALK, &
      0.002248322422077_REALK,      0.000000000000000_REALK,     -0.428261311678358_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.448306211215451_REALK, &
      0.000000000000000_REALK,      0.245281929362609_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.169269732023610_REALK,      0.000000000000000_REALK, &
      0.677547618763632_REALK,      0.000000000000000_REALK,      0.085447978089106_REALK, &
      0.000000000000000_REALK,      0.149063858643263_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.703211732387462_REALK, &
      0.000000000000000_REALK,      0.142443371836165_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.093689584255329_REALK,      0.000000000000000_REALK, &
      0.385025249585332_REALK,      0.000000000000000_REALK,      0.003656077998306_REALK, &
      0.000000000000000_REALK,      0.086893683448510_REALK,      0.000000000000000_REALK, &
     -1.464488210883001_REALK,     -0.361102296985883_REALK,      0.000000000000000_REALK, &
     -0.195290058870220_REALK,      0.000000000000000_REALK,     -0.579614981181049_REALK, &
     -0.085900391559997_REALK,      0.000000000000000_REALK,     -0.168931127656724_REALK, &
      0.000000000000000_REALK,     -0.031228731832493_REALK,      0.000000000000000_REALK, &
     -0.118682569912558_REALK,      0.000000000000000_REALK,     -0.587077122822215_REALK, &
     -0.608227215191797_REALK,     -0.198686967089170_REALK,      0.000000000000000_REALK, &
     -0.150077654499028_REALK,      0.000000000000000_REALK,     -0.374972036449412_REALK, &
     -0.238459464698693_REALK,      0.000000000000000_REALK,     -0.108785868564989_REALK, &
      0.000000000000000_REALK,     -0.734501791682315_REALK,      0.000000000000000_REALK, &
     -0.091550768804691_REALK,      0.000000000000000_REALK,     -0.381235726839743_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.590298526307446_REALK, &
      0.000000000000000_REALK,      0.221323790824520_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.142384400431800_REALK,      0.000000000000000_REALK, &
      0.460256445036854_REALK,      0.000000000000000_REALK,      0.100380059779841_REALK, &
      0.000000000000000_REALK,      0.224173181418819_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.366947557846175_REALK, &
      0.000000000000000_REALK,      0.030647727483688_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.220172279492104_REALK,      0.000000000000000_REALK, &
      0.334854280101340_REALK,      0.000000000000000_REALK,     -0.734475476483265_REALK, &
      0.000000000000000_REALK,      0.031159679996048_REALK,      0.000000000000000_REALK, &
    -17.683259574173093_REALK,      0.593816363844014_REALK,      0.000000000000000_REALK, &
     -0.687394141890940_REALK,      0.000000000000000_REALK,     -1.983232804901121_REALK, &
      0.343729847074568_REALK,      0.000000000000000_REALK,      0.077885734303862_REALK, &
      0.000000000000000_REALK,     -0.104665665895958_REALK,      0.000000000000000_REALK, &
     -0.113319785052708_REALK,      0.000000000000000_REALK,     -0.980832544816180_REALK, &
    -14.616607681167178_REALK,      0.312599044708441_REALK,      0.000000000000000_REALK, &
     -0.755287176062596_REALK,      0.000000000000000_REALK,     -1.288222156133642_REALK, &
     -0.401566932685491_REALK,      0.000000000000000_REALK,      0.034563751822441_REALK, &
      0.000000000000000_REALK,     -0.811318450071603_REALK,      0.000000000000000_REALK, &
     -0.106018470965997_REALK,      0.000000000000000_REALK,     -0.542477143474591_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.818555166030498_REALK, &
      0.000000000000000_REALK,      0.103997761445868_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.106265607273993_REALK,      0.000000000000000_REALK, &
      0.715572253153203_REALK,      0.000000000000000_REALK,     -0.014236325147054_REALK, &
      0.000000000000000_REALK,      0.051433391360841_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.483559954748464_REALK, &
      0.000000000000000_REALK,      0.012663300669464_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.002583505183222_REALK,      0.000000000000000_REALK, &
      0.492107051742241_REALK,      0.000000000000000_REALK,     -0.079600393323103_REALK, &
      0.000000000000000_REALK,      0.005332582692684_REALK,      0.000000000000000_REALK, &
     -1.887999965266314_REALK,     -0.274604449462457_REALK,      0.000000000000000_REALK, &
     -0.158698965431895_REALK,      0.000000000000000_REALK,     -0.635235283019379_REALK, &
     -0.061938974931911_REALK,      0.000000000000000_REALK,     -0.108052440914762_REALK, &
      0.000000000000000_REALK,     -0.067097047067594_REALK,      0.000000000000000_REALK, &
     -0.078486554750198_REALK,      0.000000000000000_REALK,     -0.523605900478225_REALK, &
     -2.254903584228380_REALK,     -0.301012455642076_REALK,      0.000000000000000_REALK, &
     -0.145075977784891_REALK,      0.000000000000000_REALK,     -0.596201968441189_REALK, &
     -0.004201130748035_REALK,      0.000000000000000_REALK,     -0.099847904096892_REALK, &
      0.000000000000000_REALK,      0.209847522354182_REALK,      0.000000000000000_REALK, &
     -0.061092259313204_REALK,      0.000000000000000_REALK,     -0.418439655036684_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.648905743774199_REALK, &
      0.000000000000000_REALK,      0.158381506651325_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.086029849822812_REALK,      0.000000000000000_REALK, &
      0.425556648697573_REALK,      0.000000000000000_REALK,      0.039830073012089_REALK, &
      0.000000000000000_REALK,      0.130549252577860_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.792393861741559_REALK, &
      0.000000000000000_REALK,      0.168452196438760_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.105199273650590_REALK,      0.000000000000000_REALK, &
      0.438070833012387_REALK,      0.000000000000000_REALK,      0.155492497579652_REALK, &
      0.000000000000000_REALK,      0.118226847107365_REALK,      0.000000000000000_REALK, &
     -0.769508263193814_REALK,     -0.247782206745704_REALK,      0.000000000000000_REALK, &
     -0.133492602440084_REALK,      0.000000000000000_REALK,     -0.431513778556243_REALK, &
     -0.072762845247007_REALK,      0.000000000000000_REALK,     -0.162497198585875_REALK, &
      0.000000000000000_REALK,     -0.033428277538893_REALK,      0.000000000000000_REALK, &
     -0.110034055374864_REALK,      0.000000000000000_REALK,     -0.497957895729690_REALK, &
     -1.176646129896033_REALK,     -0.064765019184781_REALK,      0.000000000000000_REALK, &
      0.340931267678546_REALK,      0.000000000000000_REALK,     -0.518513477109325_REALK, &
      0.843972013004560_REALK,      0.000000000000000_REALK,     -0.035805004650066_REALK, &
      0.000000000000000_REALK,      1.882590114507567_REALK,      0.000000000000000_REALK, &
      0.239279924572578_REALK,      0.000000000000000_REALK,     -0.509480439128841_REALK, &
    -29.428691902782209_REALK,      3.408312086181109_REALK,      0.000000000000000_REALK, &
     -0.889011305177811_REALK,      0.000000000000000_REALK,     -2.808297840769068_REALK, &
      0.942084981969218_REALK,      0.000000000000000_REALK,      0.372695302549561_REALK, &
      0.000000000000000_REALK,      0.034934813214586_REALK,      0.000000000000000_REALK, &
     -0.118158708230758_REALK,      0.000000000000000_REALK,     -1.119754641790968_REALK, &
    -11.345551540556741_REALK,      2.571995113345222_REALK,      0.000000000000000_REALK, &
      0.250151044689457_REALK,      0.000000000000000_REALK,     -1.772753581089265_REALK, &
      1.713507774092145_REALK,      0.000000000000000_REALK,      0.343691721506435_REALK, &
      0.000000000000000_REALK,      1.716435153082639_REALK,      0.000000000000000_REALK, &
      0.034138487701507_REALK,      0.000000000000000_REALK,     -0.725791008399931_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.688825004286384_REALK, &
      0.000000000000000_REALK,     -0.088783881868014_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.101908223667954_REALK,      0.000000000000000_REALK, &
      0.882060465535158_REALK,      0.000000000000000_REALK,     -0.052077713297209_REALK, &
      0.000000000000000_REALK,     -0.035400861829778_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.765748937739059_REALK, &
      0.000000000000000_REALK,     -0.049787332118567_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.138340465459139_REALK,      0.000000000000000_REALK, &
      0.707862883188425_REALK,      0.000000000000000_REALK,      0.078940137346521_REALK, &
      0.000000000000000_REALK,     -0.020383655331089_REALK,      0.000000000000000_REALK, &
     -2.849287287809712_REALK,     -0.140997960841719_REALK,      0.000000000000000_REALK, &
     -0.121134803532038_REALK,      0.000000000000000_REALK,     -0.815698573812275_REALK, &
      0.012802694662903_REALK,      0.000000000000000_REALK,     -0.046253931282732_REALK, &
      0.000000000000000_REALK,      0.010505532512692_REALK,      0.000000000000000_REALK, &
     -0.048300168368285_REALK,      0.000000000000000_REALK,     -0.542073476602487_REALK, &
     -1.512215037040986_REALK,     -0.017357417429061_REALK,      0.000000000000000_REALK, &
      0.003721408232760_REALK,      0.000000000000000_REALK,     -0.708855258215122_REALK, &
      0.103868272789752_REALK,      0.000000000000000_REALK,     -0.006958334383467_REALK, &
      0.000000000000000_REALK,      0.022772648507021_REALK,      0.000000000000000_REALK, &
      0.001523598464409_REALK,      0.000000000000000_REALK,     -0.483692693443821_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.861238533553101_REALK, &
      0.000000000000000_REALK,      0.123171659553205_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.070582779279806_REALK,      0.000000000000000_REALK, &
      0.470877589425150_REALK,      0.000000000000000_REALK,      0.028152692056393_REALK, &
      0.000000000000000_REALK,      0.081853875753214_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.817206090921909_REALK, &
      0.000000000000000_REALK,      0.143825843564448_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.079717538956487_REALK,      0.000000000000000_REALK, &
      0.546009918053830_REALK,      0.000000000000000_REALK,      0.002477578290942_REALK, &
      0.000000000000000_REALK,      0.098140641342897_REALK,      0.000000000000000_REALK, &
     -1.016696617875118_REALK,     -0.214730289983210_REALK,      0.000000000000000_REALK, &
     -0.098067561307087_REALK,      0.000000000000000_REALK,     -0.485102587319890_REALK, &
     -0.035819093614932_REALK,      0.000000000000000_REALK,     -0.117402644429661_REALK, &
      0.000000000000000_REALK,     -0.010288983897021_REALK,      0.000000000000000_REALK, &
     -0.065170916814542_REALK,      0.000000000000000_REALK,     -0.451325717910377_REALK, &
     -0.807699014218625_REALK,     -0.230895180233722_REALK,      0.000000000000000_REALK, &
     -0.151534220092200_REALK,      0.000000000000000_REALK,     -0.631018824770185_REALK, &
     -0.202897705414674_REALK,      0.000000000000000_REALK,     -0.154270825730404_REALK, &
      0.000000000000000_REALK,     -0.497742579500092_REALK,      0.000000000000000_REALK, &
     -0.103400509787939_REALK,      0.000000000000000_REALK,     -0.602812588326607_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.585037235471693_REALK, &
      0.000000000000000_REALK,      0.185234590288970_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.098953374479293_REALK,      0.000000000000000_REALK, &
      0.447812397381812_REALK,      0.000000000000000_REALK,      0.055120651082721_REALK, &
      0.000000000000000_REALK,      0.172337020311283_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.710719511421130_REALK, &
      0.000000000000000_REALK,      0.051575293885263_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.312229518486593_REALK,      0.000000000000000_REALK, &
      0.664806429004392_REALK,      0.000000000000000_REALK,     -0.829541244564813_REALK, &
      0.000000000000000_REALK,      0.049269903179202_REALK,      0.000000000000000_REALK, &
    -28.987744962512977_REALK,     -0.007499868540138_REALK,      0.000000000000000_REALK, &
     -8.995556861262926_REALK,      0.000000000000000_REALK,    -13.089810820399318_REALK, &
      0.051543685757293_REALK,      0.000000000000000_REALK,      0.004043978026747_REALK, &
      0.000000000000000_REALK,    -21.826347001397011_REALK,      0.000000000000000_REALK, &
    -12.029513670514905_REALK,      0.000000000000000_REALK,    -52.513944596312776_REALK, &
    -10.516629494528912_REALK,     -0.076488744107242_REALK,      0.000000000000000_REALK, &
     -0.494893925991084_REALK,      0.000000000000000_REALK,     -4.827833254655090_REALK, &
     -0.027699401599963_REALK,      0.000000000000000_REALK,     -0.002128543470344_REALK, &
      0.000000000000000_REALK,     54.835849875057782_REALK,      0.000000000000000_REALK, &
     -0.770645759263229_REALK,      0.000000000000000_REALK,    -22.553616211872647_REALK, &
    -18.974288750286583_REALK,      1.502477335744872_REALK,      0.000000000000000_REALK, &
     -5.851862059256348_REALK,      0.000000000000000_REALK,     -8.222535236395881_REALK, &
      1.915476202231711_REALK,      0.000000000000000_REALK,      0.761645344622597_REALK, &
      0.000000000000000_REALK,    -14.996694770770331_REALK,      0.000000000000000_REALK, &
     -7.300242664244005_REALK,      0.000000000000000_REALK,    -30.773026739089786_REALK, &
     -4.499811347425546_REALK,      0.506320966331780_REALK,      0.000000000000000_REALK, &
     -1.690686608584251_REALK,      0.000000000000000_REALK,     -3.085153181138356_REALK, &
      0.993090506001616_REALK,      0.000000000000000_REALK,      0.429387717408852_REALK, &
      0.000000000000000_REALK,     -7.369757018858060_REALK,      0.000000000000000_REALK, &
     -2.515303608879874_REALK,      0.000000000000000_REALK,    -13.769725668370954_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.586603806299847_REALK, &
      0.000000000000000_REALK,     -0.046211598123635_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.552723636841771_REALK,      0.000000000000000_REALK, &
      2.412873806638175_REALK,      0.000000000000000_REALK,     -0.734786024574976_REALK, &
      0.000000000000000_REALK,     -0.172947966026353_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.524174103806511_REALK, &
      0.000000000000000_REALK,     -0.264808043441560_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.045567911993460_REALK,      0.000000000000000_REALK, &
      1.333584446970084_REALK,      0.000000000000000_REALK,     -5.126799539027024_REALK, &
      0.000000000000000_REALK,     -1.181897266969065_REALK,      0.000000000000000_REALK, &
    -15.820539723607181_REALK,      4.541285313113572_REALK,      0.000000000000000_REALK, &
     -6.000852644601519_REALK,      0.000000000000000_REALK,     -6.066634168983216_REALK, &
      4.435331598562267_REALK,      0.000000000000000_REALK,      1.961229856491903_REALK, &
      0.000000000000000_REALK,    -20.026578530263716_REALK,      0.000000000000000_REALK, &
     -6.428153562324564_REALK,      0.000000000000000_REALK,    -19.495857516057512_REALK, &
     -7.909843507101379_REALK,      2.247823702732914_REALK,      0.000000000000000_REALK, &
     -3.185937511271512_REALK,      0.000000000000000_REALK,     -2.834778281839418_REALK, &
      1.569156354223806_REALK,      0.000000000000000_REALK,      1.054749172557349_REALK, &
      0.000000000000000_REALK,    -14.723942185640533_REALK,      0.000000000000000_REALK, &
     -3.759898860450798_REALK,      0.000000000000000_REALK,    -10.036430024578433_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.267401874279167_REALK, &
      0.000000000000000_REALK,     -0.893483763281377_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.696893712812908_REALK,      0.000000000000000_REALK, &
      2.937646026992176_REALK,      0.000000000000000_REALK,     -2.407043362899948_REALK, &
      0.000000000000000_REALK,     -2.871317382363949_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.334814497806883_REALK, &
      0.000000000000000_REALK,     -0.620150317535771_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.343237114720788_REALK,      0.000000000000000_REALK, &
      1.879010109246075_REALK,      0.000000000000000_REALK,     -1.692680895459258_REALK, &
      0.000000000000000_REALK,     -2.195619779699030_REALK,      0.000000000000000_REALK, &
     -2.460484965661692_REALK,      0.012743060526536_REALK,      0.000000000000000_REALK, &
     -0.648398363604076_REALK,      0.000000000000000_REALK,     -2.830534689536362_REALK, &
      0.070143936899133_REALK,      0.000000000000000_REALK,      0.016509910109958_REALK, &
      0.000000000000000_REALK,     -1.260225247788586_REALK,      0.000000000000000_REALK, &
     -2.083706015289299_REALK,      0.000000000000000_REALK,    -15.160438628829759_REALK, &
     -1.791411734238545_REALK,      0.114571171921923_REALK,      0.000000000000000_REALK, &
     -0.065812211077475_REALK,      0.000000000000000_REALK,     -1.926051409294953_REALK, &
      0.699600587108108_REALK,      0.000000000000000_REALK,      0.161281129792320_REALK, &
      0.000000000000000_REALK,      5.526563663351203_REALK,      0.000000000000000_REALK, &
     -0.233005754091381_REALK,      0.000000000000000_REALK,    -11.365192307377603_REALK, &
    -15.463096923012490_REALK,      8.866495799808279_REALK,      0.000000000000000_REALK, &
     -7.714612405940495_REALK,      0.000000000000000_REALK,     -4.991169255604929_REALK, &
      8.296643753297712_REALK,      0.000000000000000_REALK,      3.335844135274738_REALK, &
      0.000000000000000_REALK,    -23.766034223743866_REALK,      0.000000000000000_REALK, &
     -6.622774950964187_REALK,      0.000000000000000_REALK,    -12.854329802721853_REALK, &
     -5.003637262359064_REALK,      4.399243564443770_REALK,      0.000000000000000_REALK, &
     -3.860919395226359_REALK,      0.000000000000000_REALK,     -2.792908168645465_REALK, &
      6.119652485372309_REALK,      0.000000000000000_REALK,      2.233337596625918_REALK, &
      0.000000000000000_REALK,     -7.417490921281286_REALK,      0.000000000000000_REALK, &
     -3.655096221978293_REALK,      0.000000000000000_REALK,     -7.932059997033315_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.676226106175783_REALK, &
      0.000000000000000_REALK,     -1.525769802411000_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.995959540549111_REALK,      0.000000000000000_REALK, &
      3.020631835572067_REALK,      0.000000000000000_REALK,     -2.962187192620855_REALK, &
      0.000000000000000_REALK,     -3.929489712495772_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.507468084763851_REALK, &
      0.000000000000000_REALK,     -0.954648172387594_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.860087532633760_REALK,      0.000000000000000_REALK, &
      2.295861845405087_REALK,      0.000000000000000_REALK,     -1.344523667433384_REALK, &
      0.000000000000000_REALK,     -2.711269444676768_REALK,      0.000000000000000_REALK, &
     -2.360113608896231_REALK,      0.394150117863225_REALK,      0.000000000000000_REALK, &
     -0.542159491902681_REALK,      0.000000000000000_REALK,     -2.285388213584855_REALK, &
      0.372940344152061_REALK,      0.000000000000000_REALK,      0.444873619334591_REALK, &
      0.000000000000000_REALK,     -0.956117368634374_REALK,      0.000000000000000_REALK, &
     -1.396285430867145_REALK,      0.000000000000000_REALK,     -9.809703338111754_REALK, &
     -1.015619839292050_REALK,      0.329781280402197_REALK,      0.000000000000000_REALK, &
     -0.310662186602450_REALK,      0.000000000000000_REALK,     -1.700682601476085_REALK, &
      0.387205557634948_REALK,      0.000000000000000_REALK,      0.502254254439388_REALK, &
      0.000000000000000_REALK,     -0.861706223770773_REALK,      0.000000000000000_REALK, &
     -0.882302945225480_REALK,      0.000000000000000_REALK,     -8.050101433255911_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.248657924570882_REALK, &
      0.000000000000000_REALK,     -0.012844145831714_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.322843389708394_REALK,      0.000000000000000_REALK, &
      2.348914559196075_REALK,      0.000000000000000_REALK,     -0.140539303706156_REALK, &
      0.000000000000000_REALK,     -0.055131666248912_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.024228613478228_REALK, &
      0.000000000000000_REALK,     -0.145974739590017_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.053300727376985_REALK,      0.000000000000000_REALK, &
      2.599819987814406_REALK,      0.000000000000000_REALK,     -1.798347649522338_REALK, &
      0.000000000000000_REALK,     -0.690964592318892_REALK,      0.000000000000000_REALK, &
    -15.995782909144925_REALK,     15.556320391359423_REALK,      0.000000000000000_REALK, &
    -11.825050322280063_REALK,      0.000000000000000_REALK,     -4.212905208813716_REALK, &
     14.075887287993874_REALK,      0.000000000000000_REALK,      4.970794979187739_REALK, &
      0.000000000000000_REALK,    -33.027389440729102_REALK,      0.000000000000000_REALK, &
     -7.724308718910675_REALK,      0.000000000000000_REALK,     -8.255807683559031_REALK, &
    -18.471872632189502_REALK,     13.118639798351371_REALK,      0.000000000000000_REALK, &
    -10.834019700570426_REALK,      0.000000000000000_REALK,     -4.182924496834327_REALK, &
      9.792703794226009_REALK,      0.000000000000000_REALK,      4.096586541104521_REALK, &
      0.000000000000000_REALK,    -31.415208440908099_REALK,      0.000000000000000_REALK, &
     -6.598689238238677_REALK,      0.000000000000000_REALK,     -7.643096364363912_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.070203224678564_REALK, &
      0.000000000000000_REALK,     -2.357488330377372_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.516344600815899_REALK,      0.000000000000000_REALK, &
      2.943115799311053_REALK,      0.000000000000000_REALK,     -3.830036115192999_REALK, &
      0.000000000000000_REALK,     -4.619845286599910_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.177032788544237_REALK, &
      0.000000000000000_REALK,     -2.268011634732487_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.371478809520904_REALK,      0.000000000000000_REALK, &
      2.976297077041559_REALK,      0.000000000000000_REALK,     -3.785172854045946_REALK, &
      0.000000000000000_REALK,     -4.144141615005942_REALK,      0.000000000000000_REALK, &
     -2.701743751200651_REALK,      0.938542278889654_REALK,      0.000000000000000_REALK, &
     -0.703858723357037_REALK,      0.000000000000000_REALK,     -2.134723330573429_REALK, &
      0.678219717473974_REALK,      0.000000000000000_REALK,      0.899692433099680_REALK, &
      0.000000000000000_REALK,     -1.432394476801071_REALK,      0.000000000000000_REALK, &
     -1.379314740876246_REALK,      0.000000000000000_REALK,     -6.972174149543478_REALK, &
     -3.431992237458743_REALK,      1.085946390664957_REALK,      0.000000000000000_REALK, &
     -0.873440958433148_REALK,      0.000000000000000_REALK,     -2.331506613681617_REALK, &
      0.504497175121199_REALK,      0.000000000000000_REALK,      1.017332613001120_REALK, &
      0.000000000000000_REALK,     -2.083289136783216_REALK,      0.000000000000000_REALK, &
     -1.595963163795862_REALK,      0.000000000000000_REALK,     -7.100267502639465_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.405804111954563_REALK, &
      0.000000000000000_REALK,     -0.314398492118897_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.319692257395075_REALK,      0.000000000000000_REALK, &
      2.246020860211456_REALK,      0.000000000000000_REALK,     -0.516488966883924_REALK, &
      0.000000000000000_REALK,     -1.026850181479020_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.934587197837119_REALK, &
      0.000000000000000_REALK,     -0.510052082758728_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.331060995242334_REALK,      0.000000000000000_REALK, &
      3.020589024118422_REALK,      0.000000000000000_REALK,     -0.718491762007150_REALK, &
      0.000000000000000_REALK,     -1.553290137207354_REALK,      0.000000000000000_REALK, &
     -1.260563798145300_REALK,      0.007900781546626_REALK,      0.000000000000000_REALK, &
     -0.228157999268850_REALK,      0.000000000000000_REALK,     -1.660011210896154_REALK, &
      0.032177752672425_REALK,      0.000000000000000_REALK,      0.012622896756948_REALK, &
      0.000000000000000_REALK,     -0.270411595529872_REALK,      0.000000000000000_REALK, &
     -0.745181954837459_REALK,      0.000000000000000_REALK,     -7.590417887659001_REALK, &
     -2.331820279559063_REALK,      0.166051479666664_REALK,      0.000000000000000_REALK, &
     -0.054128256298259_REALK,      0.000000000000000_REALK,     -2.640183906580601_REALK, &
      0.674782698918031_REALK,      0.000000000000000_REALK,      0.259266306259294_REALK, &
      0.000000000000000_REALK,      2.345858853241527_REALK,      0.000000000000000_REALK, &
     -0.164839806549892_REALK,      0.000000000000000_REALK,    -11.256419619843365_REALK, &
    -13.040000699672166_REALK,     27.314876463100887_REALK,      0.000000000000000_REALK, &
    -20.217116331669477_REALK,      0.000000000000000_REALK,     -2.768504111715728_REALK, &
     24.646749435495714_REALK,      0.000000000000000_REALK,      7.175289634632149_REALK, &
      0.000000000000000_REALK,    -47.737364346230315_REALK,      0.000000000000000_REALK, &
     -9.671407777246328_REALK,      0.000000000000000_REALK,     -3.973167848192555_REALK, &
    -15.147502958562260_REALK,     24.150190813761821_REALK,      0.000000000000000_REALK, &
    -21.144309272102120_REALK,      0.000000000000000_REALK,     -5.594297839415058_REALK, &
     29.229832537309722_REALK,      0.000000000000000_REALK,      8.172075805056771_REALK, &
      0.000000000000000_REALK,    -37.621947079562958_REALK,      0.000000000000000_REALK, &
    -10.043546680458917_REALK,      0.000000000000000_REALK,     -7.971874243537726_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.414996736472384_REALK, &
      0.000000000000000_REALK,     -3.726767258497837_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.517977231133834_REALK,      0.000000000000000_REALK, &
      2.691235750446939_REALK,      0.000000000000000_REALK,     -5.048387535085523_REALK, &
      0.000000000000000_REALK,     -5.348401610277515_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.105054586169564_REALK, &
      0.000000000000000_REALK,     -4.089717636849971_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.597827623812475_REALK,      0.000000000000000_REALK, &
      4.167273565758810_REALK,      0.000000000000000_REALK,     -4.643734792270742_REALK, &
      0.000000000000000_REALK,     -5.827847502655526_REALK,      0.000000000000000_REALK, &
     -3.464375491705201_REALK,      1.910988867650651_REALK,      0.000000000000000_REALK, &
     -1.136853045555318_REALK,      0.000000000000000_REALK,     -2.206549987429258_REALK, &
      1.248518680884145_REALK,      0.000000000000000_REALK,      1.505981397991047_REALK, &
      0.000000000000000_REALK,     -1.951603260830898_REALK,      0.000000000000000_REALK, &
     -1.631533776527754_REALK,      0.000000000000000_REALK,     -5.277816172991243_REALK, &
     -2.681770908252139_REALK,      2.225790011196866_REALK,      0.000000000000000_REALK, &
     -1.369179198238385_REALK,      0.000000000000000_REALK,     -2.971306605230415_REALK, &
      2.063803728818518_REALK,      0.000000000000000_REALK,      2.259525587757330_REALK, &
      0.000000000000000_REALK,     -1.319812086740852_REALK,      0.000000000000000_REALK, &
     -1.951080314015866_REALK,      0.000000000000000_REALK,     -7.056853030181941_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.730414724719733_REALK, &
      0.000000000000000_REALK,     -0.674528785925111_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.449630282589669_REALK,      0.000000000000000_REALK, &
      2.272795715307220_REALK,      0.000000000000000_REALK,     -0.729740704303299_REALK, &
      0.000000000000000_REALK,     -1.613396005431685_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.288102958688778_REALK, &
      0.000000000000000_REALK,     -1.015626812270775_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.870172870699479_REALK,      0.000000000000000_REALK, &
      3.871304987272426_REALK,      0.000000000000000_REALK,     -0.717703037059271_REALK, &
      0.000000000000000_REALK,     -2.412113625396548_REALK,      0.000000000000000_REALK, &
     -1.586290207907548_REALK,      0.254852594900942_REALK,      0.000000000000000_REALK, &
     -0.239683721143919_REALK,      0.000000000000000_REALK,     -1.683915156184329_REALK, &
      0.168365546493714_REALK,      0.000000000000000_REALK,      0.334733562683710_REALK, &
      0.000000000000000_REALK,     -0.235541414709360_REALK,      0.000000000000000_REALK, &
     -0.573296153299431_REALK,      0.000000000000000_REALK,     -5.638826482173915_REALK, &
     -1.633007907675351_REALK,      0.500556881459050_REALK,      0.000000000000000_REALK, &
     -0.330505892535259_REALK,      0.000000000000000_REALK,     -3.015524286295645_REALK, &
      0.391745908240560_REALK,      0.000000000000000_REALK,      0.846906099328867_REALK, &
      0.000000000000000_REALK,     -0.459976413084451_REALK,      0.000000000000000_REALK, &
     -0.784951477281007_REALK,      0.000000000000000_REALK,    -10.026618028520630_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.345611303064237_REALK, &
      0.000000000000000_REALK,     -0.009463797750291_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.242915096174087_REALK,      0.000000000000000_REALK, &
      2.474331375327485_REALK,      0.000000000000000_REALK,     -0.057703561478889_REALK, &
      0.000000000000000_REALK,     -0.031690856383286_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.591033871694823_REALK, &
      0.000000000000000_REALK,     -0.258831584469272_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.089876214517325_REALK,      0.000000000000000_REALK, &
      6.137379105355033_REALK,      0.000000000000000_REALK,     -1.599921718267228_REALK, &
      0.000000000000000_REALK,     -0.860614999184169_REALK,      0.000000000000000_REALK/
    ! results of test 7, ket-major order, 02ODGYYY
  data REF_CONTR_INTS(56701:57960)                                                         &
    /-8.557505639361384_REALK,     -2.602449859369222_REALK,      0.000000000000000_REALK, &
     -1.874405965411763_REALK,      0.000000000000000_REALK,     -1.489585026908911_REALK, &
     -1.568666471793085_REALK,      0.000000000000000_REALK,     -0.550278352924908_REALK, &
      0.000000000000000_REALK,     -2.634647673258785_REALK,      0.000000000000000_REALK, &
     -0.561608587893157_REALK,      0.000000000000000_REALK,     -1.338926186129585_REALK, &
     -2.474905907578396_REALK,     -1.958588907783191_REALK,      0.000000000000000_REALK, &
     -3.372900226158615_REALK,      0.000000000000000_REALK,     -0.669664764236353_REALK, &
     -7.762246810805175_REALK,      0.000000000000000_REALK,     -0.481693815387365_REALK, &
      0.000000000000000_REALK,    -23.933930897350805_REALK,      0.000000000000000_REALK, &
     -1.018335770398520_REALK,      0.000000000000000_REALK,     -0.606549442205736_REALK, &
     -9.571712728481494_REALK,     -1.832760722368165_REALK,      0.000000000000000_REALK, &
     -1.272160932936231_REALK,      0.000000000000000_REALK,     -1.453042498731193_REALK, &
     -0.690785121006765_REALK,      0.000000000000000_REALK,     -0.334027694771829_REALK, &
      0.000000000000000_REALK,     -0.856226818376150_REALK,      0.000000000000000_REALK, &
     -0.313802831856325_REALK,      0.000000000000000_REALK,     -1.075262191530359_REALK, &
     -5.292954489390258_REALK,     -0.583679115365450_REALK,      0.000000000000000_REALK, &
      0.279853494742565_REALK,      0.000000000000000_REALK,     -0.648053942462444_REALK, &
      2.022131130508231_REALK,      0.000000000000000_REALK,     -0.095907179935884_REALK, &
      0.000000000000000_REALK,      7.265450478141606_REALK,      0.000000000000000_REALK, &
      0.062791067266124_REALK,      0.000000000000000_REALK,     -0.436213941841267_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.224462289982474_REALK, &
      0.000000000000000_REALK,      0.378776811259695_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.280815115886089_REALK,      0.000000000000000_REALK, &
      0.669488893557356_REALK,      0.000000000000000_REALK,      0.266346119009336_REALK, &
      0.000000000000000_REALK,      0.280297640662007_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.864682835379409_REALK, &
      0.000000000000000_REALK,      0.467403264775629_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.715615685549734_REALK,      0.000000000000000_REALK, &
      0.426240840714062_REALK,      0.000000000000000_REALK,      1.689955422886239_REALK, &
      0.000000000000000_REALK,      0.314615508367300_REALK,      0.000000000000000_REALK, &
    -12.132798505485075_REALK,     -1.117167893605648_REALK,      0.000000000000000_REALK, &
     -0.961673790069412_REALK,      0.000000000000000_REALK,     -1.600639214248118_REALK, &
     -0.156562901489525_REALK,      0.000000000000000_REALK,     -0.174211420257703_REALK, &
      0.000000000000000_REALK,     -0.165707924531350_REALK,      0.000000000000000_REALK, &
     -0.194810934878556_REALK,      0.000000000000000_REALK,     -0.972747801648353_REALK, &
     -3.526241560815978_REALK,     -0.458626470129508_REALK,      0.000000000000000_REALK, &
     -0.614993408475227_REALK,      0.000000000000000_REALK,     -0.724642560129859_REALK, &
     -0.987842514383533_REALK,      0.000000000000000_REALK,     -0.083702988727895_REALK, &
      0.000000000000000_REALK,     -3.443155327127258_REALK,      0.000000000000000_REALK, &
     -0.125053303335240_REALK,      0.000000000000000_REALK,     -0.442048376288544_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.373889914257267_REALK, &
      0.000000000000000_REALK,      0.264948501077157_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.187574522079744_REALK,      0.000000000000000_REALK, &
      0.642734134977693_REALK,      0.000000000000000_REALK,      0.110996047957100_REALK, &
      0.000000000000000_REALK,      0.161015717769914_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.654195066245592_REALK, &
      0.000000000000000_REALK,      0.094910684138491_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.051559499219845_REALK,      0.000000000000000_REALK, &
      0.358187452026067_REALK,      0.000000000000000_REALK,     -0.406909664783199_REALK, &
      0.000000000000000_REALK,      0.057897667242090_REALK,      0.000000000000000_REALK, &
     -1.341740858755493_REALK,     -0.358143441226694_REALK,      0.000000000000000_REALK, &
     -0.222740644558382_REALK,      0.000000000000000_REALK,     -0.531034047811492_REALK, &
     -0.159207441454336_REALK,      0.000000000000000_REALK,     -0.167546913698115_REALK, &
      0.000000000000000_REALK,     -0.211677076410963_REALK,      0.000000000000000_REALK, &
     -0.135364965698208_REALK,      0.000000000000000_REALK,     -0.537870743565933_REALK, &
     -0.684204631858812_REALK,     -0.471832496846539_REALK,      0.000000000000000_REALK, &
     -0.708180287869652_REALK,      0.000000000000000_REALK,     -0.421812108613581_REALK, &
     -1.387669601769688_REALK,      0.000000000000000_REALK,     -0.258339581798547_REALK, &
      0.000000000000000_REALK,     -3.384477060842815_REALK,      0.000000000000000_REALK, &
     -0.432006017306289_REALK,      0.000000000000000_REALK,     -0.428858235242825_REALK, &
    -18.088106212740502_REALK,     -0.204809248042133_REALK,      0.000000000000000_REALK, &
     -1.036474113747325_REALK,      0.000000000000000_REALK,     -2.028637620183792_REALK, &
      0.041206707417753_REALK,      0.000000000000000_REALK,     -0.026863050005428_REALK, &
      0.000000000000000_REALK,     -0.327069865785067_REALK,      0.000000000000000_REALK, &
     -0.170867071196510_REALK,      0.000000000000000_REALK,     -1.003288063104579_REALK, &
    -15.217197607799180_REALK,     -0.140121534040910_REALK,      0.000000000000000_REALK, &
     -0.545759739809773_REALK,      0.000000000000000_REALK,     -1.341154633156671_REALK, &
      0.462266979405936_REALK,      0.000000000000000_REALK,     -0.015493092539956_REALK, &
      0.000000000000000_REALK,      1.698705566795996_REALK,      0.000000000000000_REALK, &
     -0.076607434844938_REALK,      0.000000000000000_REALK,     -0.564767288691988_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.791989533671811_REALK, &
      0.000000000000000_REALK,      0.163332048977677_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.141213284172998_REALK,      0.000000000000000_REALK, &
      0.705119103444889_REALK,      0.000000000000000_REALK,      0.024198228064175_REALK, &
      0.000000000000000_REALK,      0.080777904062959_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.531320367355063_REALK, &
      0.000000000000000_REALK,      0.129611984402913_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.143696408563638_REALK,      0.000000000000000_REALK, &
      0.507949509448516_REALK,      0.000000000000000_REALK,      0.214714479839643_REALK, &
      0.000000000000000_REALK,      0.054580290149637_REALK,      0.000000000000000_REALK, &
     -1.790991497730717_REALK,     -0.296622084893332_REALK,      0.000000000000000_REALK, &
     -0.175860635209640_REALK,      0.000000000000000_REALK,     -0.602595874934667_REALK, &
     -0.080458093751343_REALK,      0.000000000000000_REALK,     -0.116716026869521_REALK, &
      0.000000000000000_REALK,     -0.079104378164015_REALK,      0.000000000000000_REALK, &
     -0.086974072806476_REALK,      0.000000000000000_REALK,     -0.496702189179255_REALK, &
     -2.097727799070507_REALK,     -0.200566005500463_REALK,      0.000000000000000_REALK, &
      0.079838594896880_REALK,      0.000000000000000_REALK,     -0.554644310207886_REALK, &
      0.467572274219984_REALK,      0.000000000000000_REALK,     -0.066529124981191_REALK, &
      0.000000000000000_REALK,      1.296722338958119_REALK,      0.000000000000000_REALK, &
      0.033620453345309_REALK,      0.000000000000000_REALK,     -0.389272739971406_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.594517144919867_REALK, &
      0.000000000000000_REALK,      0.157083735806288_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.098122476441713_REALK,      0.000000000000000_REALK, &
      0.389888248351497_REALK,      0.000000000000000_REALK,      0.073820897693640_REALK, &
      0.000000000000000_REALK,      0.129479537953854_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.891376671280816_REALK, &
      0.000000000000000_REALK,      0.400032380630747_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.496410022839447_REALK,      0.000000000000000_REALK, &
      0.492792965429550_REALK,      0.000000000000000_REALK,      0.904859081467663_REALK, &
      0.000000000000000_REALK,      0.280759575135728_REALK,      0.000000000000000_REALK, &
    -31.257090738997565_REALK,      1.876082961965944_REALK,      0.000000000000000_REALK, &
     -1.394892388973276_REALK,      0.000000000000000_REALK,     -2.982776832929873_REALK, &
      0.549747946989972_REALK,      0.000000000000000_REALK,      0.205147677043099_REALK, &
      0.000000000000000_REALK,     -0.180470602714329_REALK,      0.000000000000000_REALK, &
     -0.185395485796475_REALK,      0.000000000000000_REALK,     -1.189324777312479_REALK, &
    -12.425494260134625_REALK,      1.426265881086214_REALK,      0.000000000000000_REALK, &
     -0.530675513894772_REALK,      0.000000000000000_REALK,     -1.941495692626048_REALK, &
      0.451626642573854_REALK,      0.000000000000000_REALK,      0.190589699588833_REALK, &
      0.000000000000000_REALK,     -0.885823098638214_REALK,      0.000000000000000_REALK, &
     -0.072422082134728_REALK,      0.000000000000000_REALK,     -0.794876474421984_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.750383890537832_REALK, &
      0.000000000000000_REALK,      0.030621857514903_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.153660366553670_REALK,      0.000000000000000_REALK, &
      0.902254661802381_REALK,      0.000000000000000_REALK,     -0.006243132835532_REALK, &
      0.000000000000000_REALK,      0.012209875532000_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.838302778418084_REALK, &
      0.000000000000000_REALK,      0.022317014304265_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.099962847016332_REALK,      0.000000000000000_REALK, &
      0.736948655096185_REALK,      0.000000000000000_REALK,     -0.090872569115759_REALK, &
      0.000000000000000_REALK,      0.009136909093939_REALK,      0.000000000000000_REALK, &
     -2.807664619448512_REALK,     -0.221442130347578_REALK,      0.000000000000000_REALK, &
     -0.160972527925284_REALK,      0.000000000000000_REALK,     -0.803782768984258_REALK, &
     -0.021761411185038_REALK,      0.000000000000000_REALK,     -0.072643384479133_REALK, &
      0.000000000000000_REALK,     -0.018198691472724_REALK,      0.000000000000000_REALK, &
     -0.064184693207541_REALK,      0.000000000000000_REALK,     -0.534154814051133_REALK, &
     -1.560897945937128_REALK,     -0.177657419326323_REALK,      0.000000000000000_REALK, &
     -0.206987391130327_REALK,      0.000000000000000_REALK,     -0.731675515328662_REALK, &
     -0.280174773425660_REALK,      0.000000000000000_REALK,     -0.071220256955199_REALK, &
      0.000000000000000_REALK,     -0.777763028650334_REALK,      0.000000000000000_REALK, &
     -0.084743637771834_REALK,      0.000000000000000_REALK,     -0.499264266766310_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.816986715830845_REALK, &
      0.000000000000000_REALK,      0.133047496236722_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.078215584866779_REALK,      0.000000000000000_REALK, &
      0.446683143351341_REALK,      0.000000000000000_REALK,      0.036570058502194_REALK, &
      0.000000000000000_REALK,      0.088416874999826_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.760243562734522_REALK, &
      0.000000000000000_REALK,      0.095831831509844_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.043870366383883_REALK,      0.000000000000000_REALK, &
      0.507950846182930_REALK,      0.000000000000000_REALK,     -0.275746456259575_REALK, &
      0.000000000000000_REALK,      0.065391567832009_REALK,      0.000000000000000_REALK, &
     -0.931481307274619_REALK,     -0.212970799776439_REALK,      0.000000000000000_REALK, &
     -0.111852246561743_REALK,      0.000000000000000_REALK,     -0.444443292379019_REALK, &
     -0.066386964553749_REALK,      0.000000000000000_REALK,     -0.116440652513480_REALK, &
      0.000000000000000_REALK,     -0.069741609817624_REALK,      0.000000000000000_REALK, &
     -0.074331546120217_REALK,      0.000000000000000_REALK,     -0.413497460633288_REALK, &
     -0.908593684848372_REALK,     -0.548319051800791_REALK,      0.000000000000000_REALK, &
     -0.715053469920083_REALK,      0.000000000000000_REALK,     -0.709843282105878_REALK, &
     -1.180724692259648_REALK,      0.000000000000000_REALK,     -0.366355126163288_REALK, &
      0.000000000000000_REALK,     -2.293525164403423_REALK,      0.000000000000000_REALK, &
     -0.487922089613719_REALK,      0.000000000000000_REALK,     -0.678113630521782_REALK, &
    -77.817962920896591_REALK,      8.757267072497896_REALK,      0.000000000000000_REALK, &
     -3.074990873076120_REALK,      0.000000000000000_REALK,     -5.662157639342767_REALK, &
      1.449444915101999_REALK,      0.000000000000000_REALK,      0.733155088635590_REALK, &
      0.000000000000000_REALK,     -0.646579387850445_REALK,      0.000000000000000_REALK, &
     -0.309211155476684_REALK,      0.000000000000000_REALK,     -1.708104880715501_REALK, &
   -155.939218428070092_REALK,     15.143106792168469_REALK,      0.000000000000000_REALK, &
     -6.033023370912581_REALK,      0.000000000000000_REALK,     -9.164393477617640_REALK, &
      0.462427206099451_REALK,      0.000000000000000_REALK,      0.998381342047606_REALK, &
      0.000000000000000_REALK,     -1.228464411966648_REALK,      0.000000000000000_REALK, &
     -0.458169809046559_REALK,      0.000000000000000_REALK,     -2.087932443579676_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.731562888157273_REALK, &
      0.000000000000000_REALK,     -0.319269934569609_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.224398662395733_REALK,      0.000000000000000_REALK, &
      1.439532834558900_REALK,      0.000000000000000_REALK,     -0.086033255783236_REALK, &
      0.000000000000000_REALK,     -0.096314261848663_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     11.735152623873178_REALK, &
      0.000000000000000_REALK,     -0.792448159166459_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.211476849189793_REALK,      0.000000000000000_REALK, &
      2.321087261660575_REALK,      0.000000000000000_REALK,     -0.142607527385845_REALK, &
      0.000000000000000_REALK,     -0.180544214455615_REALK,      0.000000000000000_REALK, &
     -6.432757814921886_REALK,     -0.058841513103232_REALK,      0.000000000000000_REALK, &
     -0.239140583420915_REALK,      0.000000000000000_REALK,     -1.404172793914952_REALK, &
      0.007556552153542_REALK,      0.000000000000000_REALK,     -0.014778567696125_REALK, &
      0.000000000000000_REALK,     -0.046030613625521_REALK,      0.000000000000000_REALK, &
     -0.072141615217522_REALK,      0.000000000000000_REALK,     -0.705995415949026_REALK, &
    -17.379570394129342_REALK,     -0.134892686068994_REALK,      0.000000000000000_REALK, &
     -0.415633028825929_REALK,      0.000000000000000_REALK,     -3.064140435663849_REALK, &
      0.265353384325958_REALK,      0.000000000000000_REALK,     -0.026680325800704_REALK, &
      0.000000000000000_REALK,      0.699920480962774_REALK,      0.000000000000000_REALK, &
     -0.094694066511703_REALK,      0.000000000000000_REALK,     -1.163510028047169_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.544510953011944_REALK, &
      0.000000000000000_REALK,      0.113054405216078_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.077687756204939_REALK,      0.000000000000000_REALK, &
      0.646529365428568_REALK,      0.000000000000000_REALK,      0.010216709666334_REALK, &
      0.000000000000000_REALK,      0.056841930125182_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.422530462542070_REALK, &
      0.000000000000000_REALK,      0.296124930367521_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.247456535032084_REALK,      0.000000000000000_REALK, &
      1.457881780482015_REALK,      0.000000000000000_REALK,      0.265407493099273_REALK, &
      0.000000000000000_REALK,      0.112444038800309_REALK,      0.000000000000000_REALK, &
     -1.910816049726257_REALK,     -0.255657776127890_REALK,      0.000000000000000_REALK, &
     -0.121726382782749_REALK,      0.000000000000000_REALK,     -0.695169938098634_REALK, &
     -0.044263603163644_REALK,      0.000000000000000_REALK,     -0.107017861831612_REALK, &
      0.000000000000000_REALK,     -0.033398580379285_REALK,      0.000000000000000_REALK, &
     -0.061202060470830_REALK,      0.000000000000000_REALK,     -0.489328313738929_REALK, &
     -7.187448482560774_REALK,     -0.579244740673202_REALK,      0.000000000000000_REALK, &
      0.182407502387936_REALK,      0.000000000000000_REALK,     -2.111996156524150_REALK, &
      0.805196288564912_REALK,      0.000000000000000_REALK,     -0.190947323262097_REALK, &
      0.000000000000000_REALK,      1.602871988352772_REALK,      0.000000000000000_REALK, &
      0.069263456644872_REALK,      0.000000000000000_REALK,     -1.122748863007893_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.854021210158001_REALK, &
      0.000000000000000_REALK,      0.181215795592027_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.089969286207402_REALK,      0.000000000000000_REALK, &
      0.500488329969394_REALK,      0.000000000000000_REALK,      0.051946412291281_REALK, &
      0.000000000000000_REALK,      0.127557327813165_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.290567981264131_REALK, &
      0.000000000000000_REALK,      1.523258843240778_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.424761938902202_REALK,      0.000000000000000_REALK, &
      1.980132712956516_REALK,      0.000000000000000_REALK,      1.864152964127066_REALK, &
      0.000000000000000_REALK,      0.809772844061398_REALK,      0.000000000000000_REALK, &
    -21.084875098585297_REALK,      1.151751611810634_REALK,      0.000000000000000_REALK, &
     -6.836469447094798_REALK,      0.000000000000000_REALK,     -9.137160856714871_REALK, &
      1.399632901848776_REALK,      0.000000000000000_REALK,      0.583853235205206_REALK, &
      0.000000000000000_REALK,    -21.101878633624462_REALK,      0.000000000000000_REALK, &
     -8.528547909214446_REALK,      0.000000000000000_REALK,    -34.196034103746555_REALK, &
     -5.221533697110728_REALK,      0.245595522295786_REALK,      0.000000000000000_REALK, &
     -3.785863068423591_REALK,      0.000000000000000_REALK,     -3.579979259636895_REALK, &
     -1.125015419035518_REALK,      0.000000000000000_REALK,      0.208278360440877_REALK, &
      0.000000000000000_REALK,    -48.041779584350600_REALK,      0.000000000000000_REALK, &
     -5.632383311242370_REALK,      0.000000000000000_REALK,    -15.978244647634932_REALK, &
    -19.274790991300677_REALK,      3.987627097401321_REALK,      0.000000000000000_REALK, &
     -6.871386841460575_REALK,      0.000000000000000_REALK,     -7.391221012096619_REALK, &
      4.009979470310667_REALK,      0.000000000000000_REALK,      1.722123315484369_REALK, &
      0.000000000000000_REALK,    -21.421484676021539_REALK,      0.000000000000000_REALK, &
     -7.360675627117989_REALK,      0.000000000000000_REALK,    -23.752576421742162_REALK, &
     -9.369760084257845_REALK,      2.116968901388067_REALK,      0.000000000000000_REALK, &
     -2.934644836789423_REALK,      0.000000000000000_REALK,     -3.357992148523997_REALK, &
      2.509253880463922_REALK,      0.000000000000000_REALK,      0.993348007832632_REALK, &
      0.000000000000000_REALK,     -3.031136910394841_REALK,      0.000000000000000_REALK, &
     -3.463334650675149_REALK,      0.000000000000000_REALK,    -11.888849804463836_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.519614091819512_REALK, &
      0.000000000000000_REALK,     -0.684916397741056_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.814149842780701_REALK,      0.000000000000000_REALK, &
      3.264412193687625_REALK,      0.000000000000000_REALK,     -1.758819599515940_REALK, &
      0.000000000000000_REALK,     -2.201061103872200_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.548904685454893_REALK, &
      0.000000000000000_REALK,     -0.300809469219756_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.768592304295730_REALK,      0.000000000000000_REALK, &
      2.180383541690775_REALK,      0.000000000000000_REALK,      1.917541347329538_REALK, &
      0.000000000000000_REALK,     -1.065005050975512_REALK,      0.000000000000000_REALK, &
    -21.504849772175096_REALK,      8.388205774005613_REALK,      0.000000000000000_REALK, &
     -8.807367518122906_REALK,      0.000000000000000_REALK,     -6.941322657658952_REALK, &
      7.987569983220281_REALK,      0.000000000000000_REALK,      3.155896948296008_REALK, &
      0.000000000000000_REALK,    -25.093781885657446_REALK,      0.000000000000000_REALK, &
     -7.560874080730830_REALK,      0.000000000000000_REALK,    -17.876783202343987_REALK, &
     -6.529034056737181_REALK,      4.145970554556835_REALK,      0.000000000000000_REALK, &
     -4.443122283416320_REALK,      0.000000000000000_REALK,     -3.644347420545911_REALK, &
      5.219849884602263_REALK,      0.000000000000000_REALK,      2.104760006659584_REALK, &
      0.000000000000000_REALK,    -13.204128930148380_REALK,      0.000000000000000_REALK, &
     -4.206262242092323_REALK,      0.000000000000000_REALK,    -10.350208687249278_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.260552404860642_REALK, &
      0.000000000000000_REALK,     -1.339753085084043_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.140441814999896_REALK,      0.000000000000000_REALK, &
      3.680155564189915_REALK,      0.000000000000000_REALK,     -2.678110884308454_REALK, &
      0.000000000000000_REALK,     -3.450419556608905_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.785700851885624_REALK, &
      0.000000000000000_REALK,     -0.899074286944481_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.792247628178767_REALK,      0.000000000000000_REALK, &
      2.719608126094293_REALK,      0.000000000000000_REALK,     -2.150041467060592_REALK, &
      0.000000000000000_REALK,     -2.553435614495082_REALK,      0.000000000000000_REALK, &
     -2.622638525056538_REALK,      0.302143015900645_REALK,      0.000000000000000_REALK, &
     -0.633380753735015_REALK,      0.000000000000000_REALK,     -2.539601123888657_REALK, &
      0.272506427119207_REALK,      0.000000000000000_REALK,      0.341026048067890_REALK, &
      0.000000000000000_REALK,     -1.345354625190293_REALK,      0.000000000000000_REALK, &
     -1.631217993672238_REALK,      0.000000000000000_REALK,    -10.900876041276533_REALK, &
     -1.178514565360978_REALK,      0.159963365512063_REALK,      0.000000000000000_REALK, &
     -0.695649029833388_REALK,      0.000000000000000_REALK,     -1.973454179757522_REALK, &
     -0.438643024017444_REALK,      0.000000000000000_REALK,      0.243622927247090_REALK, &
      0.000000000000000_REALK,     -5.617268027009273_REALK,      0.000000000000000_REALK, &
     -1.975693258898877_REALK,      0.000000000000000_REALK,     -9.341252922292741_REALK, &
    -27.910327002607058_REALK,     15.782105710642625_REALK,      0.000000000000000_REALK, &
    -13.581449727840688_REALK,      0.000000000000000_REALK,     -7.350910091543808_REALK, &
     14.212518254783378_REALK,      0.000000000000000_REALK,      5.042941380343801_REALK, &
      0.000000000000000_REALK,    -34.742632388334478_REALK,      0.000000000000000_REALK, &
     -8.871616415073230_REALK,      0.000000000000000_REALK,    -14.405190007113315_REALK, &
    -26.345732566158404_REALK,     13.320847771874154_REALK,      0.000000000000000_REALK, &
    -11.326693910996633_REALK,      0.000000000000000_REALK,     -5.965946838870519_REALK, &
     10.423411971067553_REALK,      0.000000000000000_REALK,      4.159730470320534_REALK, &
      0.000000000000000_REALK,    -28.220638000682392_REALK,      0.000000000000000_REALK, &
     -6.898762904352279_REALK,      0.000000000000000_REALK,    -10.901058966918676_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.269795335661478_REALK, &
      0.000000000000000_REALK,     -2.230317102890853_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.731130934487807_REALK,      0.000000000000000_REALK, &
      4.093052215957330_REALK,      0.000000000000000_REALK,     -3.687356287439167_REALK, &
      0.000000000000000_REALK,     -4.370634553157733_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.145575346122566_REALK, &
      0.000000000000000_REALK,     -2.137437792940688_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.578289375154997_REALK,      0.000000000000000_REALK, &
      3.883643829490918_REALK,      0.000000000000000_REALK,     -3.228620274209788_REALK, &
      0.000000000000000_REALK,     -3.905555320599906_REALK,      0.000000000000000_REALK, &
     -3.291641563829763_REALK,      0.824118364144626_REALK,      0.000000000000000_REALK, &
     -0.805966394504584_REALK,      0.000000000000000_REALK,     -2.600818097226996_REALK, &
      0.613177861225105_REALK,      0.000000000000000_REALK,      0.790004960753164_REALK, &
      0.000000000000000_REALK,     -1.532164682471498_REALK,      0.000000000000000_REALK, &
     -1.579409747582463_REALK,      0.000000000000000_REALK,     -8.494476284324833_REALK, &
     -4.065433639382810_REALK,      1.022729111191996_REALK,      0.000000000000000_REALK, &
     -0.804547794750454_REALK,      0.000000000000000_REALK,     -2.761831834655683_REALK, &
      0.806746562220148_REALK,      0.000000000000000_REALK,      0.958109615746469_REALK, &
      0.000000000000000_REALK,     -0.428875264376318_REALK,      0.000000000000000_REALK, &
     -1.470080640869323_REALK,      0.000000000000000_REALK,     -8.410760968160272_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.562177349767165_REALK, &
      0.000000000000000_REALK,     -0.241007941640100_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.373482205838587_REALK,      0.000000000000000_REALK, &
      2.495854781679784_REALK,      0.000000000000000_REALK,     -0.377396989140550_REALK, &
      0.000000000000000_REALK,     -0.787150876402523_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.244874609973330_REALK, &
      0.000000000000000_REALK,     -0.247405333756415_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.741326978589512_REALK,      0.000000000000000_REALK, &
      3.505059691798123_REALK,      0.000000000000000_REALK,      0.813938211898207_REALK, &
      0.000000000000000_REALK,     -0.753437301417935_REALK,      0.000000000000000_REALK, &
    -39.808499311297481_REALK,     30.094530444357748_REALK,      0.000000000000000_REALK, &
    -23.815355231549660_REALK,      0.000000000000000_REALK,     -8.451686204842806_REALK, &
     26.022160109294362_REALK,      0.000000000000000_REALK,      7.905471315172400_REALK, &
      0.000000000000000_REALK,    -50.835796037879796_REALK,      0.000000000000000_REALK, &
    -11.392723275944743_REALK,      0.000000000000000_REALK,    -12.129282290024648_REALK, &
    -24.974193153648535_REALK,     25.617627821902747_REALK,      0.000000000000000_REALK, &
    -23.073095211155344_REALK,      0.000000000000000_REALK,     -9.223505364731823_REALK, &
     29.250164837966864_REALK,      0.000000000000000_REALK,      8.668635296538712_REALK, &
      0.000000000000000_REALK,    -41.210848374490148_REALK,      0.000000000000000_REALK, &
    -10.959719981095089_REALK,      0.000000000000000_REALK,    -13.143494851880433_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.958675243916229_REALK, &
      0.000000000000000_REALK,     -3.780857770533157_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.891977644785005_REALK,      0.000000000000000_REALK, &
      4.695817032696648_REALK,      0.000000000000000_REALK,     -5.097390916224782_REALK, &
      0.000000000000000_REALK,     -5.426028615562264_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.854883933545507_REALK, &
      0.000000000000000_REALK,     -4.152755690210638_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.761437893389341_REALK,      0.000000000000000_REALK, &
      5.943624508442124_REALK,      0.000000000000000_REALK,     -4.942818841590769_REALK, &
      0.000000000000000_REALK,     -5.917676726692908_REALK,      0.000000000000000_REALK, &
     -4.817978887052822_REALK,      1.807903394488074_REALK,      0.000000000000000_REALK, &
     -1.297885371220067_REALK,      0.000000000000000_REALK,     -3.068694856580945_REALK, &
      1.202007779947898_REALK,      0.000000000000000_REALK,      1.424743454843423_REALK, &
      0.000000000000000_REALK,     -2.060634352941433_REALK,      0.000000000000000_REALK, &
     -1.862636362268305_REALK,      0.000000000000000_REALK,     -7.339968474000954_REALK, &
     -3.499329122848934_REALK,      2.097646950406057_REALK,      0.000000000000000_REALK, &
     -1.575642996640803_REALK,      0.000000000000000_REALK,     -3.877131974473117_REALK, &
      1.760352516987681_REALK,      0.000000000000000_REALK,      2.129440304197862_REALK, &
      0.000000000000000_REALK,     -2.349442573215051_REALK,      0.000000000000000_REALK, &
     -2.245291220183726_REALK,      0.000000000000000_REALK,     -9.208188234197461_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.108232887748611_REALK, &
      0.000000000000000_REALK,     -0.592292507358020_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.514857436149228_REALK,      0.000000000000000_REALK, &
      2.769037159528840_REALK,      0.000000000000000_REALK,     -0.659757940951885_REALK, &
      0.000000000000000_REALK,     -1.416696196453565_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.710417184833889_REALK, &
      0.000000000000000_REALK,     -0.956503116494008_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.801537479337845_REALK,      0.000000000000000_REALK, &
      4.585830163538343_REALK,      0.000000000000000_REALK,     -1.147686223819643_REALK, &
      0.000000000000000_REALK,     -2.271694851055527_REALK,      0.000000000000000_REALK, &
     -1.762739639098958_REALK,      0.195361939889605_REALK,      0.000000000000000_REALK, &
     -0.280011801367482_REALK,      0.000000000000000_REALK,     -1.871223802485092_REALK, &
      0.123024216190104_REALK,      0.000000000000000_REALK,      0.256596163666554_REALK, &
      0.000000000000000_REALK,     -0.331430786740872_REALK,      0.000000000000000_REALK, &
     -0.669756326530123_REALK,      0.000000000000000_REALK,     -6.266055800243713_REALK, &
     -1.894925177797399_REALK,      0.242799601271361_REALK,      0.000000000000000_REALK, &
     -0.740083967124685_REALK,      0.000000000000000_REALK,     -3.499182623368622_REALK, &
     -0.443786527462771_REALK,      0.000000000000000_REALK,      0.410799393331595_REALK, &
      0.000000000000000_REALK,     -2.998482228770617_REALK,      0.000000000000000_REALK, &
     -1.757699382756196_REALK,      0.000000000000000_REALK,    -11.634781963455286_REALK, &
    -65.069743706691597_REALK,     65.686048730607808_REALK,      0.000000000000000_REALK, &
    -49.222256742598162_REALK,      0.000000000000000_REALK,    -10.212559925919845_REALK, &
     51.674195598551826_REALK,      0.000000000000000_REALK,     13.055431548159849_REALK, &
      0.000000000000000_REALK,    -83.545311756986422_REALK,      0.000000000000000_REALK, &
    -16.237897390737015_REALK,      0.000000000000000_REALK,    -10.107043712422398_REALK, &
   -265.179076308338836_REALK,    176.479862002443497_REALK,      0.000000000000000_REALK, &
   -122.905731604976438_REALK,      0.000000000000000_REALK,    -33.490108961838338_REALK, &
    100.940450232123865_REALK,      0.000000000000000_REALK,     27.682038193564864_REALK, &
      0.000000000000000_REALK,   -144.047652316701601_REALK,      0.000000000000000_REALK, &
    -28.091145503553662_REALK,      0.000000000000000_REALK,    -22.963343812163806_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      9.570133916044623_REALK, &
      0.000000000000000_REALK,     -7.223002743873803_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      5.359815107938992_REALK,      0.000000000000000_REALK, &
      5.706336307123192_REALK,      0.000000000000000_REALK,     -7.843350602794211_REALK, &
      0.000000000000000_REALK,     -7.148374648161886_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     31.701489820964117_REALK, &
      0.000000000000000_REALK,    -19.215372632019886_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     12.439199526054379_REALK,      0.000000000000000_REALK, &
     14.917767535505316_REALK,      0.000000000000000_REALK,    -14.819164189647204_REALK, &
      0.000000000000000_REALK,    -13.175508289050804_REALK,      0.000000000000000_REALK, &
     -9.112224330465843_REALK,      4.281194817761600_REALK,      0.000000000000000_REALK, &
     -2.642317153616571_REALK,      0.000000000000000_REALK,     -4.290433544019198_REALK, &
      2.398116076560893_REALK,      0.000000000000000_REALK,      2.552726810384872_REALK, &
      0.000000000000000_REALK,     -3.413604330455696_REALK,      0.000000000000000_REALK, &
     -2.615016721312488_REALK,      0.000000000000000_REALK,     -7.076841276688945_REALK, &
    -34.773698323259161_REALK,     14.273157225619620_REALK,      0.000000000000000_REALK, &
     -8.337809618376220_REALK,      0.000000000000000_REALK,    -13.174964202280348_REALK, &
      5.610062109045329_REALK,      0.000000000000000_REALK,      6.716518456766836_REALK, &
      0.000000000000000_REALK,     -7.795516512885631_REALK,      0.000000000000000_REALK, &
     -5.717030933679878_REALK,      0.000000000000000_REALK,    -15.056248051957519_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.474788345564612_REALK, &
      0.000000000000000_REALK,     -1.301747292903291_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.876295006318787_REALK,      0.000000000000000_REALK, &
      3.453158034814452_REALK,      0.000000000000000_REALK,     -1.086893064121569_REALK, &
      0.000000000000000_REALK,     -2.147162723701398_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     13.325829493553693_REALK, &
      0.000000000000000_REALK,     -4.720234217160086_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.548388602093896_REALK,      0.000000000000000_REALK, &
     10.451224202463933_REALK,      0.000000000000000_REALK,     -2.675569842981346_REALK, &
      0.000000000000000_REALK,     -5.394247464034780_REALK,      0.000000000000000_REALK, &
     -3.223986914481563_REALK,      0.670673103035718_REALK,      0.000000000000000_REALK, &
     -0.470410494928044_REALK,      0.000000000000000_REALK,     -2.529989953006257_REALK, &
      0.310389403292462_REALK,      0.000000000000000_REALK,      0.666498210585375_REALK, &
      0.000000000000000_REALK,     -0.451624154721114_REALK,      0.000000000000000_REALK, &
     -0.775917019419883_REALK,      0.000000000000000_REALK,     -5.842316866928741_REALK, &
    -16.097881800112109_REALK,      3.287532517431013_REALK,      0.000000000000000_REALK, &
     -1.776731955738917_REALK,      0.000000000000000_REALK,    -10.165202757431802_REALK, &
      1.302615208784738_REALK,      0.000000000000000_REALK,      2.578356524010986_REALK, &
      0.000000000000000_REALK,     -0.355410555069620_REALK,      0.000000000000000_REALK, &
     -2.030435653313930_REALK,      0.000000000000000_REALK,    -16.263402056377796_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.118850835518643_REALK, &
      0.000000000000000_REALK,     -0.234444566344062_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.315093238958373_REALK,      0.000000000000000_REALK, &
      2.947925595300652_REALK,      0.000000000000000_REALK,     -0.185403912695989_REALK, &
      0.000000000000000_REALK,     -0.541385329488824_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     12.026805203646152_REALK, &
      0.000000000000000_REALK,     -0.910600475143550_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.994975543776828_REALK,      0.000000000000000_REALK, &
     13.205389785068025_REALK,      0.000000000000000_REALK,      1.124189462188568_REALK, &
      0.000000000000000_REALK,     -1.456878135476539_REALK,      0.000000000000000_REALK/
    ! results of test 7, ket-major order, 02ODGXXZ
  data REF_CONTR_INTS(57961:59220)                                                         &
     /0.000000000000000_REALK,      0.000000000000000_REALK,      4.020535997228255_REALK, &
      0.000000000000000_REALK,      3.620831466443515_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      4.400434310273158_REALK,      0.000000000000000_REALK, &
      3.349167646880900_REALK,      0.000000000000000_REALK,      8.354345708381032_REALK, &
      0.000000000000000_REALK,      4.786691854757032_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.927866659188259_REALK, &
      0.000000000000000_REALK,      1.750126448153912_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.545361668122043_REALK,      0.000000000000000_REALK, &
      1.888772323198917_REALK,      0.000000000000000_REALK,      0.439307486403718_REALK, &
      0.000000000000000_REALK,      2.369265748753031_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.922861522767549_REALK, &
      0.000000000000000_REALK,      0.868814872644983_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.381151464839174_REALK,      0.000000000000000_REALK, &
      1.402621714160095_REALK,      0.000000000000000_REALK,     -0.491335223902354_REALK, &
      0.000000000000000_REALK,      0.947129959502714_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.551108321632920_REALK, &
      0.000000000000000_REALK,     -0.222288768372897_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.925340562659554_REALK,      0.000000000000000_REALK, &
      0.381119431386166_REALK,      0.000000000000000_REALK,     -2.574783319576816_REALK, &
      0.000000000000000_REALK,     -0.230411805789865_REALK,      0.000000000000000_REALK, &
     -3.068942879763796_REALK,     -2.327389751846186_REALK,      0.000000000000000_REALK, &
     -2.394191065121736_REALK,      0.000000000000000_REALK,     -1.822217238202401_REALK, &
     -2.963047671325440_REALK,      0.000000000000000_REALK,     -1.697702806260671_REALK, &
      0.000000000000000_REALK,     -5.174394066252283_REALK,      0.000000000000000_REALK, &
     -2.610003762535846_REALK,      0.000000000000000_REALK,     -3.310786899418516_REALK, &
     -2.724744186877440_REALK,     -1.609269548538962_REALK,      0.000000000000000_REALK, &
     -1.087156500032461_REALK,      0.000000000000000_REALK,     -1.328744688447230_REALK, &
     -0.206351554376435_REALK,      0.000000000000000_REALK,     -1.112891733278457_REALK, &
      0.000000000000000_REALK,      3.101068734660923_REALK,      0.000000000000000_REALK, &
     -1.126884161454607_REALK,      0.000000000000000_REALK,     -2.295501067821439_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.321185173685406_REALK, &
      0.000000000000000_REALK,      0.300262524307740_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.012521969095754_REALK,      0.000000000000000_REALK, &
      0.838079087672367_REALK,      0.000000000000000_REALK,     -0.358859012041319_REALK, &
      0.000000000000000_REALK,      0.269893526885987_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.403801463448817_REALK, &
      0.000000000000000_REALK,      0.007762692590785_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.094953583373682_REALK,      0.000000000000000_REALK, &
      0.297931842891646_REALK,      0.000000000000000_REALK,     -0.144714365709619_REALK, &
      0.000000000000000_REALK,      0.007031065560579_REALK,      0.000000000000000_REALK, &
     -1.630842673956036_REALK,     -0.628264496969196_REALK,      0.000000000000000_REALK, &
     -0.231424034826579_REALK,      0.000000000000000_REALK,     -0.851630929880505_REALK, &
      0.206743639193152_REALK,      0.000000000000000_REALK,     -0.398532580386236_REALK, &
      0.000000000000000_REALK,      1.166036298047718_REALK,      0.000000000000000_REALK, &
     -0.208017464415625_REALK,      0.000000000000000_REALK,     -1.275826189102154_REALK, &
     -0.344902884310163_REALK,      0.173125716978789_REALK,      0.000000000000000_REALK, &
      0.679762723229105_REALK,      0.000000000000000_REALK,     -0.279973442221082_REALK, &
      1.427402913107229_REALK,      0.000000000000000_REALK,      0.127735207968027_REALK, &
      0.000000000000000_REALK,      3.015547681659215_REALK,      0.000000000000000_REALK, &
      0.615695677339451_REALK,      0.000000000000000_REALK,     -0.422643647689570_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.317696591729079_REALK, &
      0.000000000000000_REALK,      1.030795548764400_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.098235277920395_REALK,      0.000000000000000_REALK, &
      1.393110240992673_REALK,      0.000000000000000_REALK,      1.617114770349404_REALK, &
      0.000000000000000_REALK,      1.544232261395292_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.034869546279929_REALK, &
      0.000000000000000_REALK,      0.817539342594290_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.624719650218596_REALK,      0.000000000000000_REALK, &
      1.272575011006212_REALK,      0.000000000000000_REALK,      0.137300541193925_REALK, &
      0.000000000000000_REALK,      1.234144950116151_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.056206967690777_REALK, &
      0.000000000000000_REALK,     -0.010064088832635_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.185915447018167_REALK,      0.000000000000000_REALK, &
      0.577493353573991_REALK,      0.000000000000000_REALK,     -0.476961980565188_REALK, &
      0.000000000000000_REALK,     -0.007447500140832_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.326971019542051_REALK, &
      0.000000000000000_REALK,     -0.271846050737769_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.426474518312377_REALK,      0.000000000000000_REALK, &
      0.161178638636426_REALK,      0.000000000000000_REALK,     -0.757026656830560_REALK, &
      0.000000000000000_REALK,     -0.182983282094878_REALK,      0.000000000000000_REALK, &
     -1.266706628773982_REALK,     -0.246820511396196_REALK,      0.000000000000000_REALK, &
     -0.008619331470285_REALK,      0.000000000000000_REALK,     -0.576880632728238_REALK, &
      0.179436421068978_REALK,      0.000000000000000_REALK,     -0.134951964167279_REALK, &
      0.000000000000000_REALK,      0.408022665645467_REALK,      0.000000000000000_REALK, &
     -0.006378369011476_REALK,      0.000000000000000_REALK,     -0.711493221912451_REALK, &
     -0.787051846825266_REALK,     -0.010023324203466_REALK,      0.000000000000000_REALK, &
      0.092136567780745_REALK,      0.000000000000000_REALK,     -0.289093012199442_REALK, &
      0.101695210004905_REALK,      0.000000000000000_REALK,     -0.004940944772380_REALK, &
      0.000000000000000_REALK,      0.017231411972962_REALK,      0.000000000000000_REALK, &
      0.062018379622300_REALK,      0.000000000000000_REALK,     -0.324320744893321_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.700054001472689_REALK, &
      0.000000000000000_REALK,      0.274324619857245_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.104012740608798_REALK,      0.000000000000000_REALK, &
      0.637937679135683_REALK,      0.000000000000000_REALK,     -0.105309892674673_REALK, &
      0.000000000000000_REALK,      0.338337078000133_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.361506596702489_REALK, &
      0.000000000000000_REALK,     -0.123945650377590_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.432668179825259_REALK,      0.000000000000000_REALK, &
      0.297004615252051_REALK,      0.000000000000000_REALK,     -0.932299894261782_REALK, &
      0.000000000000000_REALK,     -0.139049177809303_REALK,      0.000000000000000_REALK, &
     -1.263361897106448_REALK,     -0.847330132448344_REALK,      0.000000000000000_REALK, &
     -0.755955698370636_REALK,      0.000000000000000_REALK,     -0.958928971150057_REALK, &
     -0.808588546233497_REALK,      0.000000000000000_REALK,     -0.772145887343972_REALK, &
      0.000000000000000_REALK,     -1.109049091668189_REALK,      0.000000000000000_REALK, &
     -0.932354676067240_REALK,      0.000000000000000_REALK,     -1.655767232224311_REALK, &
     -2.017070420365340_REALK,     -1.055621072724011_REALK,      0.000000000000000_REALK, &
     -0.606185910539136_REALK,      0.000000000000000_REALK,     -1.234821157788498_REALK, &
     -0.096485288810378_REALK,      0.000000000000000_REALK,     -0.867271395366470_REALK, &
      0.000000000000000_REALK,      1.122861885674355_REALK,      0.000000000000000_REALK, &
     -0.680053331466406_REALK,      0.000000000000000_REALK,     -1.939408222011259_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.988242986089264_REALK, &
      0.000000000000000_REALK,     -0.205191630223210_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.223165728888714_REALK,      0.000000000000000_REALK, &
      0.462320520895036_REALK,      0.000000000000000_REALK,     -0.370687581664860_REALK, &
      0.000000000000000_REALK,     -0.124699998250405_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.297794872915089_REALK, &
      0.000000000000000_REALK,     -0.209344139087784_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.146770429155008_REALK,      0.000000000000000_REALK, &
      0.163049818409725_REALK,      0.000000000000000_REALK,     -0.075185067608427_REALK, &
      0.000000000000000_REALK,     -0.127704666908737_REALK,      0.000000000000000_REALK, &
     -1.157370100693947_REALK,      0.009515860792385_REALK,      0.000000000000000_REALK, &
      0.147466871117380_REALK,      0.000000000000000_REALK,     -0.458063809696877_REALK, &
      0.285102320541471_REALK,      0.000000000000000_REALK,      0.004451716612439_REALK, &
      0.000000000000000_REALK,      0.455575569157190_REALK,      0.000000000000000_REALK, &
      0.089619242998976_REALK,      0.000000000000000_REALK,     -0.463961064149626_REALK, &
     -0.258725022517771_REALK,      0.274422132971291_REALK,      0.000000000000000_REALK, &
      0.422043358252437_REALK,      0.000000000000000_REALK,     -0.159503958637096_REALK, &
      0.621615733283054_REALK,      0.000000000000000_REALK,      0.150252684039112_REALK, &
      0.000000000000000_REALK,      0.988128418659658_REALK,      0.000000000000000_REALK, &
      0.257456008663666_REALK,      0.000000000000000_REALK,     -0.162168379756056_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.545455816831067_REALK, &
      0.000000000000000_REALK,      0.107042982313077_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.003812647297981_REALK,      0.000000000000000_REALK, &
      0.425292532491579_REALK,      0.000000000000000_REALK,     -0.086496073782809_REALK, &
      0.000000000000000_REALK,      0.108421086609287_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.291832531020999_REALK, &
      0.000000000000000_REALK,      0.004889607315642_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.050925023812697_REALK,      0.000000000000000_REALK, &
      0.266308822597896_REALK,      0.000000000000000_REALK,     -0.061391810633100_REALK, &
      0.000000000000000_REALK,      0.004971285369946_REALK,      0.000000000000000_REALK, &
     -0.767104928257635_REALK,     -0.259381145963337_REALK,      0.000000000000000_REALK, &
     -0.082502200112636_REALK,      0.000000000000000_REALK,     -0.506007838610795_REALK, &
      0.062948612260341_REALK,      0.000000000000000_REALK,     -0.202239780094747_REALK, &
      0.000000000000000_REALK,      0.281050658573837_REALK,      0.000000000000000_REALK, &
     -0.083564358826502_REALK,      0.000000000000000_REALK,     -0.717531274944825_REALK, &
     -0.286052270024333_REALK,      0.125120190846335_REALK,      0.000000000000000_REALK, &
      0.428172666317827_REALK,      0.000000000000000_REALK,     -0.293918674751008_REALK, &
      0.765537484290945_REALK,      0.000000000000000_REALK,      0.114177163837550_REALK, &
      0.000000000000000_REALK,      1.279278192733024_REALK,      0.000000000000000_REALK, &
      0.435325042374486_REALK,      0.000000000000000_REALK,     -0.418359782041582_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.906692573068289_REALK, &
      0.000000000000000_REALK,      0.612460878743670_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.557311677965351_REALK,      0.000000000000000_REALK, &
      0.989728949934956_REALK,      0.000000000000000_REALK,      0.649624103979624_REALK, &
      0.000000000000000_REALK,      0.868484244009491_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.246522636759859_REALK, &
      0.000000000000000_REALK,      0.858260262923003_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.558410785798380_REALK,      0.000000000000000_REALK, &
      1.592502262876782_REALK,      0.000000000000000_REALK,      0.097077770907155_REALK, &
      0.000000000000000_REALK,      1.221635803970593_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.058889909618454_REALK, &
      0.000000000000000_REALK,     -0.446878391238749_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.270128453900364_REALK,      0.000000000000000_REALK, &
      0.416656174429278_REALK,      0.000000000000000_REALK,     -0.367562004200374_REALK, &
      0.000000000000000_REALK,     -0.221009287774420_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.451828317139380_REALK, &
      0.000000000000000_REALK,     -0.607264477258081_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.427788812158596_REALK,      0.000000000000000_REALK, &
      0.149874563767675_REALK,      0.000000000000000_REALK,     -0.537376517455119_REALK, &
      0.000000000000000_REALK,     -0.255722273823692_REALK,      0.000000000000000_REALK, &
     -1.288265360572739_REALK,      0.229721507810099_REALK,      0.000000000000000_REALK, &
      0.209229198103497_REALK,      0.000000000000000_REALK,     -0.433448954440025_REALK, &
      0.268701604669540_REALK,      0.000000000000000_REALK,      0.090391724162118_REALK, &
      0.000000000000000_REALK,      0.284009390221279_REALK,      0.000000000000000_REALK, &
      0.103476912200397_REALK,      0.000000000000000_REALK,     -0.357279320226283_REALK, &
     -0.954902620895233_REALK,      0.442387684093640_REALK,      0.000000000000000_REALK, &
      0.227270338413950_REALK,      0.000000000000000_REALK,     -0.252478565482527_REALK, &
      0.086393752942157_REALK,      0.000000000000000_REALK,      0.146743040784833_REALK, &
      0.000000000000000_REALK,     -0.174256837615538_REALK,      0.000000000000000_REALK, &
      0.095704738031624_REALK,      0.000000000000000_REALK,     -0.177200092312488_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.512823592864569_REALK, &
      0.000000000000000_REALK,     -0.004173710280888_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.064962614325899_REALK,      0.000000000000000_REALK, &
      0.336313080360766_REALK,      0.000000000000000_REALK,     -0.132195511997771_REALK, &
      0.000000000000000_REALK,     -0.003440267548698_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.337065022086165_REALK, &
      0.000000000000000_REALK,     -0.232662523001202_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.295837877300379_REALK,      0.000000000000000_REALK, &
      0.186344647698424_REALK,      0.000000000000000_REALK,     -0.405337582322932_REALK, &
      0.000000000000000_REALK,     -0.163292358995609_REALK,      0.000000000000000_REALK, &
     -0.711051679027956_REALK,     -0.119839563001183_REALK,      0.000000000000000_REALK, &
     -0.003574550361207_REALK,      0.000000000000000_REALK,     -0.398733335874307_REALK, &
      0.062698711725576_REALK,      0.000000000000000_REALK,     -0.078591572507195_REALK, &
      0.000000000000000_REALK,      0.113088186039025_REALK,      0.000000000000000_REALK, &
     -0.002946397517134_REALK,      0.000000000000000_REALK,     -0.460129948929013_REALK, &
     -0.935783903888434_REALK,     -0.010332756703484_REALK,      0.000000000000000_REALK, &
      0.078856125598889_REALK,      0.000000000000000_REALK,     -0.412372550675882_REALK, &
      0.070544179705084_REALK,      0.000000000000000_REALK,     -0.005712410904422_REALK, &
      0.000000000000000_REALK,      0.009226278633797_REALK,      0.000000000000000_REALK, &
      0.055344550571344_REALK,      0.000000000000000_REALK,     -0.405188596783052_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.566499147762278_REALK, &
      0.000000000000000_REALK,      0.189610058966323_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.060573589244656_REALK,      0.000000000000000_REALK, &
      0.520119406515668_REALK,      0.000000000000000_REALK,     -0.048646418190615_REALK, &
      0.000000000000000_REALK,      0.218806051310702_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.621111259200082_REALK, &
      0.000000000000000_REALK,     -0.176800482317180_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.500223852378632_REALK,      0.000000000000000_REALK, &
      0.480729389496272_REALK,      0.000000000000000_REALK,     -0.831974633324302_REALK, &
      0.000000000000000_REALK,     -0.173720436103835_REALK,      0.000000000000000_REALK, &
     -1.181956918505199_REALK,     -0.685678243243370_REALK,      0.000000000000000_REALK, &
     -0.522507985679792_REALK,      0.000000000000000_REALK,     -0.927921126446665_REALK, &
     -0.470895297833724_REALK,      0.000000000000000_REALK,     -0.629541213513182_REALK, &
      0.000000000000000_REALK,     -0.512309570705576_REALK,      0.000000000000000_REALK, &
     -0.602963311905358_REALK,      0.000000000000000_REALK,     -1.376744935227242_REALK, &
     -3.997072619805052_REALK,     -1.813682349640057_REALK,      0.000000000000000_REALK, &
     -0.864685134417400_REALK,      0.000000000000000_REALK,     -2.465949921197991_REALK, &
     -0.111550248243550_REALK,      0.000000000000000_REALK,     -1.403758820610531_REALK, &
      0.000000000000000_REALK,      1.002030152912837_REALK,      0.000000000000000_REALK, &
     -0.849621430183720_REALK,      0.000000000000000_REALK,     -3.115273548510766_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -6.086972447112503_REALK, &
      0.000000000000000_REALK,      7.732872663879496_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.925005406049845_REALK,      0.000000000000000_REALK, &
     -6.872212974292419_REALK,      0.000000000000000_REALK,     27.407041797850503_REALK, &
      0.000000000000000_REALK,     30.627340592386172_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.531821360083636_REALK, &
      0.000000000000000_REALK,      4.020174290309392_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.378904710860877_REALK,      0.000000000000000_REALK, &
     -5.489849773256241_REALK,      0.000000000000000_REALK,     -0.891608703179176_REALK, &
      0.000000000000000_REALK,     18.298950867349021_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.149349518778072_REALK, &
      0.000000000000000_REALK,     -1.045091177771749_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.020644148721266_REALK,      0.000000000000000_REALK, &
      0.241590703494873_REALK,      0.000000000000000_REALK,    -12.852472818103653_REALK, &
      0.000000000000000_REALK,     -4.192716072112541_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.092486769161783_REALK, &
      0.000000000000000_REALK,     -2.207677100724869_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.011366042356968_REALK,      0.000000000000000_REALK, &
     -0.007721218758012_REALK,      0.000000000000000_REALK,    -20.896454403331948_REALK, &
      0.000000000000000_REALK,    -10.313343361947908_REALK,      0.000000000000000_REALK, &
     -5.624788948556962_REALK,      0.070262902707408_REALK,      0.000000000000000_REALK, &
     -3.243220583375279_REALK,      0.000000000000000_REALK,     -7.619850043854590_REALK, &
     -0.101708055714981_REALK,      0.000000000000000_REALK,     -0.113658646064327_REALK, &
      0.000000000000000_REALK,    -13.085892629253031_REALK,      0.000000000000000_REALK, &
    -13.011212183721611_REALK,      0.000000000000000_REALK,    -50.949091692447695_REALK, &
     -3.951033887345697_REALK,      0.104971785511677_REALK,      0.000000000000000_REALK, &
     -1.366726113180303_REALK,      0.000000000000000_REALK,     -5.441362977041337_REALK, &
     -0.000426999081614_REALK,      0.000000000000000_REALK,      0.008763525060941_REALK, &
      0.000000000000000_REALK,     10.085877363693685_REALK,      0.000000000000000_REALK, &
     -6.384772339370108_REALK,      0.000000000000000_REALK,    -42.366283789714522_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.693000031859763_REALK, &
      0.000000000000000_REALK,     -2.024547185564688_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.230961407315805_REALK,      0.000000000000000_REALK, &
      1.053899920216022_REALK,      0.000000000000000_REALK,     -7.827631383276448_REALK, &
      0.000000000000000_REALK,     -7.576914283098797_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.159249570767456_REALK, &
      0.000000000000000_REALK,     -1.164541004456037_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.087177142755290_REALK,      0.000000000000000_REALK, &
      0.405156891994289_REALK,      0.000000000000000_REALK,     -1.724750630869383_REALK, &
      0.000000000000000_REALK,     -5.197605830065160_REALK,      0.000000000000000_REALK, &
     -2.123542349882955_REALK,      0.126674530543938_REALK,      0.000000000000000_REALK, &
      0.235906104830938_REALK,      0.000000000000000_REALK,     -2.760720366547775_REALK, &
      0.590536385177755_REALK,      0.000000000000000_REALK,      0.192643970412795_REALK, &
      0.000000000000000_REALK,      7.112861492676824_REALK,      0.000000000000000_REALK, &
      0.882884008784008_REALK,      0.000000000000000_REALK,    -17.220098833362250_REALK, &
     -0.467014995125684_REALK,      0.239694932431818_REALK,      0.000000000000000_REALK, &
      1.414027704933922_REALK,      0.000000000000000_REALK,     -0.960582135521518_REALK, &
      1.235597268629285_REALK,      0.000000000000000_REALK,      0.609823017938723_REALK, &
      0.000000000000000_REALK,     15.263041006329384_REALK,      0.000000000000000_REALK, &
      6.311120531536140_REALK,      0.000000000000000_REALK,     -7.145486631984555_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.923594943341200_REALK, &
      0.000000000000000_REALK,      1.298807174634074_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.597830029948230_REALK,      0.000000000000000_REALK, &
      2.340973045573602_REALK,      0.000000000000000_REALK,      4.349727235919725_REALK, &
      0.000000000000000_REALK,      8.101359407380491_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.590787090508244_REALK, &
      0.000000000000000_REALK,      1.090253479607756_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.377528508476903_REALK,      0.000000000000000_REALK, &
      2.505097923416020_REALK,      0.000000000000000_REALK,     -0.237095955327955_REALK, &
      0.000000000000000_REALK,      8.110073439771305_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.399632101631589_REALK, &
      0.000000000000000_REALK,     -2.334885309234805_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.256770702138816_REALK,      0.000000000000000_REALK, &
      0.517763378840723_REALK,      0.000000000000000_REALK,     -6.136686160673483_REALK, &
      0.000000000000000_REALK,     -7.503434365287765_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.077262360341731_REALK, &
      0.000000000000000_REALK,     -1.582330040108098_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.397917106612475_REALK,      0.000000000000000_REALK, &
      0.108761746583403_REALK,      0.000000000000000_REALK,     -5.311458380793891_REALK, &
      0.000000000000000_REALK,     -5.602182302959005_REALK,      0.000000000000000_REALK, &
     -1.074695618921123_REALK,      0.558278189286068_REALK,      0.000000000000000_REALK, &
      0.270940102028119_REALK,      0.000000000000000_REALK,     -1.236326688641612_REALK, &
      0.747239146438329_REALK,      0.000000000000000_REALK,      0.723305261108151_REALK, &
      0.000000000000000_REALK,      1.984976683939542_REALK,      0.000000000000000_REALK, &
      0.870698558276774_REALK,      0.000000000000000_REALK,     -6.621807165135146_REALK, &
     -0.544249606521144_REALK,      0.503847337481298_REALK,      0.000000000000000_REALK, &
      0.125907031267215_REALK,      0.000000000000000_REALK,     -0.585154546893623_REALK, &
      0.235358637447388_REALK,      0.000000000000000_REALK,      0.709262779359656_REALK, &
      0.000000000000000_REALK,     -2.012509072048581_REALK,      0.000000000000000_REALK, &
      0.445769292438582_REALK,      0.000000000000000_REALK,     -3.452864198166377_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.761281326684206_REALK, &
      0.000000000000000_REALK,     -0.225990037060070_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.084281625031207_REALK,      0.000000000000000_REALK, &
      1.643860233546058_REALK,      0.000000000000000_REALK,     -2.226255828451832_REALK, &
      0.000000000000000_REALK,     -1.210410209859448_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.415603014030999_REALK, &
      0.000000000000000_REALK,     -0.880746986656876_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.861212457316140_REALK,      0.000000000000000_REALK, &
      0.975069652100782_REALK,      0.000000000000000_REALK,     -6.318070342383358_REALK, &
      0.000000000000000_REALK,     -5.197088109482462_REALK,      0.000000000000000_REALK, &
     -1.432299269312806_REALK,     -0.358152046470688_REALK,      0.000000000000000_REALK, &
     -0.701312531786616_REALK,      0.000000000000000_REALK,     -2.746188132398798_REALK, &
     -0.415232438506541_REALK,      0.000000000000000_REALK,     -0.773369694119043_REALK, &
      0.000000000000000_REALK,     -2.266687908908400_REALK,      0.000000000000000_REALK, &
     -3.756253416389590_REALK,      0.000000000000000_REALK,    -20.592145900102331_REALK, &
     -2.019067555393316_REALK,     -0.471706286664143_REALK,      0.000000000000000_REALK, &
     -0.545251796729504_REALK,      0.000000000000000_REALK,     -3.618029137022113_REALK, &
      0.032353999466083_REALK,      0.000000000000000_REALK,     -1.106696701667931_REALK, &
      0.000000000000000_REALK,      3.049478223363482_REALK,      0.000000000000000_REALK, &
     -3.217407124165184_REALK,      0.000000000000000_REALK,    -29.888836510031425_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.484700557520788_REALK, &
      0.000000000000000_REALK,     -2.603053180083787_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.020204095384229_REALK,      0.000000000000000_REALK, &
     -0.547077069231256_REALK,      0.000000000000000_REALK,     -4.882165085897602_REALK, &
      0.000000000000000_REALK,     -6.703940971996856_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.156033824306644_REALK, &
      0.000000000000000_REALK,     -1.586589896920543_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.344758450508521_REALK,      0.000000000000000_REALK, &
     -0.237638267396144_REALK,      0.000000000000000_REALK,     -1.740734866263431_REALK, &
      0.000000000000000_REALK,     -4.506029376241263_REALK,      0.000000000000000_REALK, &
     -0.415972647950801_REALK,      1.030007883357799_REALK,      0.000000000000000_REALK, &
      0.199758831006197_REALK,      0.000000000000000_REALK,     -0.402802213934542_REALK, &
      0.950800423452898_REALK,      0.000000000000000_REALK,      1.162560441429462_REALK, &
      0.000000000000000_REALK,      0.851847870123739_REALK,      0.000000000000000_REALK, &
      0.514461795074635_REALK,      0.000000000000000_REALK,     -1.728971121468404_REALK, &
     -0.058786585044228_REALK,      0.841445713870187_REALK,      0.000000000000000_REALK, &
      0.360152772311091_REALK,      0.000000000000000_REALK,     -0.098439709935760_REALK, &
      1.215011175294273_REALK,      0.000000000000000_REALK,      1.281515097387173_REALK, &
      0.000000000000000_REALK,      2.867853592669494_REALK,      0.000000000000000_REALK, &
      1.022859766798187_REALK,      0.000000000000000_REALK,     -0.465959756015239_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.545391343493370_REALK, &
      0.000000000000000_REALK,     -0.562706773849471_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.134903518973264_REALK,      0.000000000000000_REALK, &
      1.025963670259286_REALK,      0.000000000000000_REALK,     -1.497156760582723_REALK, &
      0.000000000000000_REALK,     -2.415338665438647_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.311171356768057_REALK, &
      0.000000000000000_REALK,     -0.641950175145954_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.101970990467395_REALK,      0.000000000000000_REALK, &
      0.789852482458611_REALK,      0.000000000000000_REALK,     -0.604997566108226_REALK, &
      0.000000000000000_REALK,     -3.038641084783276_REALK,      0.000000000000000_REALK, &
     -0.792409338497689_REALK,      0.099692913742507_REALK,      0.000000000000000_REALK, &
      0.065568223910665_REALK,      0.000000000000000_REALK,     -1.278867082013150_REALK, &
      0.344929645900969_REALK,      0.000000000000000_REALK,      0.187537460765269_REALK, &
      0.000000000000000_REALK,      1.360445855128170_REALK,      0.000000000000000_REALK, &
      0.281442260508371_REALK,      0.000000000000000_REALK,     -7.685096673026917_REALK, &
     -0.316219719678621_REALK,      0.468360429329827_REALK,      0.000000000000000_REALK, &
      0.779479064601569_REALK,      0.000000000000000_REALK,     -0.882530639082351_REALK, &
      1.445276517660241_REALK,      0.000000000000000_REALK,      1.188848651218531_REALK, &
      0.000000000000000_REALK,      5.353876957612568_REALK,      0.000000000000000_REALK, &
      3.689627641098856_REALK,      0.000000000000000_REALK,     -5.848384418682253_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.211449407971729_REALK, &
      0.000000000000000_REALK,      0.601655191756734_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.581983051665080_REALK,      0.000000000000000_REALK, &
      3.190487590369525_REALK,      0.000000000000000_REALK,      1.386588785947269_REALK, &
      0.000000000000000_REALK,      3.615526881183342_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.923982375887100_REALK, &
      0.000000000000000_REALK,      1.001665619772955_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.735991008696902_REALK,      0.000000000000000_REALK, &
      6.837156158004897_REALK,      0.000000000000000_REALK,     -0.138611802135529_REALK, &
      0.000000000000000_REALK,      6.637872209741166_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.370912858908336_REALK, &
      0.000000000000000_REALK,     -3.051500300963125_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.331467118322034_REALK,      0.000000000000000_REALK, &
     -2.272771729817140_REALK,      0.000000000000000_REALK,     -4.630151210294883_REALK, &
      0.000000000000000_REALK,     -5.979863866476092_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.309293109721556_REALK, &
      0.000000000000000_REALK,     -2.804261963721270_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.582210177640486_REALK,      0.000000000000000_REALK, &
     -1.226567528514714_REALK,      0.000000000000000_REALK,     -4.518010475383256_REALK, &
      0.000000000000000_REALK,     -5.123985488110749_REALK,      0.000000000000000_REALK, &
      0.489322146384909_REALK,      1.601208425967197_REALK,      0.000000000000000_REALK, &
      0.014278520567097_REALK,      0.000000000000000_REALK,      0.386627118722835_REALK, &
      1.117816130414477_REALK,      0.000000000000000_REALK,      1.534928300046790_REALK, &
      0.000000000000000_REALK,     -0.362239223498403_REALK,      0.000000000000000_REALK, &
      0.027980862128367_REALK,      0.000000000000000_REALK,      1.262754551873346_REALK, &
      0.355235961022214_REALK,      1.804802671666166_REALK,      0.000000000000000_REALK, &
     -0.350111052671559_REALK,      0.000000000000000_REALK,      0.241327758116992_REALK, &
      0.653165015935572_REALK,      0.000000000000000_REALK,      1.690769115032696_REALK, &
      0.000000000000000_REALK,     -2.655844626951984_REALK,      0.000000000000000_REALK, &
     -0.639727663222892_REALK,      0.000000000000000_REALK,      0.734928920376163_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.247774537948345_REALK, &
      0.000000000000000_REALK,     -0.821597941296678_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.117790710248112_REALK,      0.000000000000000_REALK, &
      0.395863674127042_REALK,      0.000000000000000_REALK,     -1.316773409266108_REALK, &
      0.000000000000000_REALK,     -2.683403439493068_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.111978685755491_REALK, &
      0.000000000000000_REALK,     -1.301411463878329_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.383801249017717_REALK,      0.000000000000000_REALK, &
      0.174839154061599_REALK,      0.000000000000000_REALK,     -2.254553177200494_REALK, &
      0.000000000000000_REALK,     -3.963261124936955_REALK,      0.000000000000000_REALK, &
     -0.550591615126168_REALK,      0.346136158312213_REALK,      0.000000000000000_REALK, &
      0.095338228888839_REALK,      0.000000000000000_REALK,     -0.725063067081281_REALK, &
      0.342787666392638_REALK,      0.000000000000000_REALK,      0.553013770148805_REALK, &
      0.000000000000000_REALK,      0.425924423539031_REALK,      0.000000000000000_REALK, &
      0.311382147467075_REALK,      0.000000000000000_REALK,     -3.315358136095704_REALK, &
     -0.708431370283217_REALK,      0.730241251018129_REALK,      0.000000000000000_REALK, &
      0.103554157300109_REALK,      0.000000000000000_REALK,     -0.802115462814431_REALK, &
      0.227009438695451_REALK,      0.000000000000000_REALK,      1.140170218354549_REALK, &
      0.000000000000000_REALK,     -0.854249134086929_REALK,      0.000000000000000_REALK, &
      0.315359267491051_REALK,      0.000000000000000_REALK,     -3.419817918933469_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.786665736635325_REALK, &
      0.000000000000000_REALK,     -0.132535381550827_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.064438767030904_REALK,      0.000000000000000_REALK, &
      1.759572827579780_REALK,      0.000000000000000_REALK,     -0.796161098562502_REALK, &
      0.000000000000000_REALK,     -0.606019359548796_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.003910120904321_REALK, &
      0.000000000000000_REALK,     -1.207306310059528_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.384435817137219_REALK,      0.000000000000000_REALK, &
      2.194452570612128_REALK,      0.000000000000000_REALK,     -4.469715767614196_REALK, &
      0.000000000000000_REALK,     -5.147348410783861_REALK,      0.000000000000000_REALK, &
     -1.223000500716423_REALK,     -0.370094383756225_REALK,      0.000000000000000_REALK, &
     -0.411295671242397_REALK,      0.000000000000000_REALK,     -2.254762799908368_REALK, &
     -0.317472122288696_REALK,      0.000000000000000_REALK,     -0.827807785404054_REALK, &
      0.000000000000000_REALK,     -0.810620555190114_REALK,      0.000000000000000_REALK, &
     -1.880653576086182_REALK,      0.000000000000000_REALK,    -13.255618480906822_REALK, &
     -4.380253649009305_REALK,     -1.139430416260183_REALK,      0.000000000000000_REALK, &
     -0.747417754174255_REALK,      0.000000000000000_REALK,     -6.943307513501437_REALK, &
      0.052010436342354_REALK,      0.000000000000000_REALK,     -2.490687118228696_REALK, &
      0.000000000000000_REALK,      2.157351874753287_REALK,      0.000000000000000_REALK, &
     -3.186614330667087_REALK,      0.000000000000000_REALK,    -38.060716936152744_REALK/
    ! results of test 7, ket-major order, 02ODGXYZ
  data REF_CONTR_INTS(59221:60480)                                                         &
     /0.000000000000000_REALK,      0.000000000000000_REALK,      2.064016077159365_REALK, &
      0.000000000000000_REALK,      1.290290373279086_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.245718303879490_REALK,      0.000000000000000_REALK, &
      1.505586197404626_REALK,      0.000000000000000_REALK,      1.835890909429663_REALK, &
      0.000000000000000_REALK,      1.406597317182354_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.272677452645445_REALK, &
      0.000000000000000_REALK,      0.993739912494013_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.424298008049744_REALK,      0.000000000000000_REALK, &
      0.880121181355167_REALK,      0.000000000000000_REALK,      3.501006575569633_REALK, &
      0.000000000000000_REALK,      1.030053877212114_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.572991419696250_REALK, &
      0.000000000000000_REALK,      0.695905488862901_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.586188682561351_REALK,      0.000000000000000_REALK, &
      0.997809572944391_REALK,      0.000000000000000_REALK,      0.733628268953788_REALK, &
      0.000000000000000_REALK,      0.625520574708909_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.728138137624042_REALK, &
      0.000000000000000_REALK,      0.434832805815576_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.433160593169877_REALK,      0.000000000000000_REALK, &
      0.537233162478422_REALK,      0.000000000000000_REALK,      0.536490439805725_REALK, &
      0.000000000000000_REALK,      0.393850191776112_REALK,      0.000000000000000_REALK, &
     -1.750560536214830_REALK,     -0.933045298642841_REALK,      0.000000000000000_REALK, &
     -0.756363762796393_REALK,      0.000000000000000_REALK,     -0.914147956192702_REALK, &
     -0.772504696004752_REALK,      0.000000000000000_REALK,     -0.591866884535431_REALK, &
      0.000000000000000_REALK,     -1.199245874280125_REALK,      0.000000000000000_REALK, &
     -0.679864009071785_REALK,      0.000000000000000_REALK,     -1.369482791552092_REALK, &
     -0.796486111683688_REALK,     -0.773956939436354_REALK,      0.000000000000000_REALK, &
     -1.046300931474342_REALK,      0.000000000000000_REALK,     -0.646544196971206_REALK, &
     -1.940880596351310_REALK,      0.000000000000000_REALK,     -0.571039082710704_REALK, &
      0.000000000000000_REALK,     -5.102169699542004_REALK,      0.000000000000000_REALK, &
     -0.947687978012108_REALK,      0.000000000000000_REALK,     -0.976013280519142_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.356186330621170_REALK, &
      0.000000000000000_REALK,      0.330257992748451_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.192531887202570_REALK,      0.000000000000000_REALK, &
      0.741510533540542_REALK,      0.000000000000000_REALK,      0.074588608826529_REALK, &
      0.000000000000000_REALK,      0.244393356259851_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.727621890482183_REALK, &
      0.000000000000000_REALK,      0.103153684719840_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.014193248735756_REALK,      0.000000000000000_REALK, &
      0.358677371206282_REALK,      0.000000000000000_REALK,     -0.135401026305020_REALK, &
      0.000000000000000_REALK,      0.069434151200616_REALK,      0.000000000000000_REALK, &
     -1.508129744429212_REALK,     -0.572045242877262_REALK,      0.000000000000000_REALK, &
     -0.403495210736392_REALK,      0.000000000000000_REALK,     -0.686828995317302_REALK, &
     -0.366828271156641_REALK,      0.000000000000000_REALK,     -0.312772340848593_REALK, &
      0.000000000000000_REALK,     -0.537944050629165_REALK,      0.000000000000000_REALK, &
     -0.298589439020034_REALK,      0.000000000000000_REALK,     -0.847097557201938_REALK, &
     -1.419218397740047_REALK,     -0.561463710693150_REALK,      0.000000000000000_REALK, &
     -0.420309891786622_REALK,      0.000000000000000_REALK,     -0.521294909892541_REALK, &
     -0.377008237393259_REALK,      0.000000000000000_REALK,     -0.276770573306541_REALK, &
      0.000000000000000_REALK,     -0.275439845134603_REALK,      0.000000000000000_REALK, &
     -0.282916317111587_REALK,      0.000000000000000_REALK,     -0.584817848757992_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.751443979096175_REALK, &
      0.000000000000000_REALK,      0.407403725810623_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.339945105203048_REALK,      0.000000000000000_REALK, &
      0.684767785080360_REALK,      0.000000000000000_REALK,      0.393494024505087_REALK, &
      0.000000000000000_REALK,      0.502469615118262_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.834829155260513_REALK, &
      0.000000000000000_REALK,      0.554097900050524_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.665969321500878_REALK,      0.000000000000000_REALK, &
      0.685874377732029_REALK,      0.000000000000000_REALK,      1.267674850693780_REALK, &
      0.000000000000000_REALK,      0.621618081741230_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.380662514829959_REALK, &
      0.000000000000000_REALK,      0.135338545974330_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.078596725341929_REALK,      0.000000000000000_REALK, &
      0.645902497686718_REALK,      0.000000000000000_REALK,     -0.016466688394003_REALK, &
      0.000000000000000_REALK,      0.082248561638954_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.637217347930483_REALK, &
      0.000000000000000_REALK,      0.083670774348491_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.096021904199935_REALK,      0.000000000000000_REALK, &
      0.348891745014082_REALK,      0.000000000000000_REALK,      0.134161810802614_REALK, &
      0.000000000000000_REALK,      0.051041067663660_REALK,      0.000000000000000_REALK, &
     -1.486081381817119_REALK,     -0.312267621722113_REALK,      0.000000000000000_REALK, &
     -0.152714986578350_REALK,      0.000000000000000_REALK,     -0.588161123971145_REALK, &
     -0.044585074552912_REALK,      0.000000000000000_REALK,     -0.146085255919217_REALK, &
      0.000000000000000_REALK,      0.011628728897890_REALK,      0.000000000000000_REALK, &
     -0.092808651787673_REALK,      0.000000000000000_REALK,     -0.595733291284620_REALK, &
     -0.575751301332734_REALK,     -0.104131195240254_REALK,      0.000000000000000_REALK, &
      0.014045777892322_REALK,      0.000000000000000_REALK,     -0.354950637782717_REALK, &
      0.111181564736777_REALK,      0.000000000000000_REALK,     -0.057014320993875_REALK, &
      0.000000000000000_REALK,      0.156395686426574_REALK,      0.000000000000000_REALK, &
      0.008568242679395_REALK,      0.000000000000000_REALK,     -0.360879882320453_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.649414886563797_REALK, &
      0.000000000000000_REALK,      0.248088898565237_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.178480770842390_REALK,      0.000000000000000_REALK, &
      0.506349539636475_REALK,      0.000000000000000_REALK,      0.176827006571805_REALK, &
      0.000000000000000_REALK,      0.251282871393411_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.526234832882610_REALK, &
      0.000000000000000_REALK,      0.273894868762562_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.232310490432865_REALK,      0.000000000000000_REALK, &
      0.480210270817562_REALK,      0.000000000000000_REALK,      0.227593987131248_REALK, &
      0.000000000000000_REALK,      0.278470123690033_REALK,      0.000000000000000_REALK, &
     -0.823417019917842_REALK,     -0.385210942151249_REALK,      0.000000000000000_REALK, &
     -0.269642150880898_REALK,      0.000000000000000_REALK,     -0.543153160898524_REALK, &
     -0.235209647889891_REALK,      0.000000000000000_REALK,     -0.300349418001918_REALK, &
      0.000000000000000_REALK,     -0.289055189210408_REALK,      0.000000000000000_REALK, &
     -0.273113606912283_REALK,      0.000000000000000_REALK,     -0.770204234582216_REALK, &
     -0.660582067168466_REALK,     -0.559348672508235_REALK,      0.000000000000000_REALK, &
     -0.659049759998687_REALK,      0.000000000000000_REALK,     -0.678747998503632_REALK, &
     -1.040923228750811_REALK,      0.000000000000000_REALK,     -0.510427970028625_REALK, &
      0.000000000000000_REALK,     -2.164480592346646_REALK,      0.000000000000000_REALK, &
     -0.670058803999787_REALK,      0.000000000000000_REALK,     -0.966120526215954_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.639849416612461_REALK, &
      0.000000000000000_REALK,     -0.060167202197353_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000865049152266_REALK,      0.000000000000000_REALK, &
      0.645254410642204_REALK,      0.000000000000000_REALK,     -0.112044741343228_REALK, &
      0.000000000000000_REALK,     -0.029756441049109_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.218340779059815_REALK, &
      0.000000000000000_REALK,     -0.176429140338376_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.145296733127103_REALK,      0.000000000000000_REALK, &
      0.404132025053294_REALK,      0.000000000000000_REALK,     -0.274342921052849_REALK, &
      0.000000000000000_REALK,     -0.074295241407501_REALK,      0.000000000000000_REALK, &
     -1.799820203668029_REALK,     -0.151517753488430_REALK,      0.000000000000000_REALK, &
     -0.073688419358749_REALK,      0.000000000000000_REALK,     -0.605566375791637_REALK, &
      0.011936266046976_REALK,      0.000000000000000_REALK,     -0.059619802732236_REALK, &
      0.000000000000000_REALK,      0.003357196444200_REALK,      0.000000000000000_REALK, &
     -0.036443527812020_REALK,      0.000000000000000_REALK,     -0.499150686323010_REALK, &
     -2.043287413454662_REALK,     -0.176813739575624_REALK,      0.000000000000000_REALK, &
     -0.148687516881370_REALK,      0.000000000000000_REALK,     -0.540250140411056_REALK, &
     -0.154162823888374_REALK,      0.000000000000000_REALK,     -0.058650334832496_REALK, &
      0.000000000000000_REALK,     -0.258196098789836_REALK,      0.000000000000000_REALK, &
     -0.062613097472427_REALK,      0.000000000000000_REALK,     -0.379170305287950_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.658473545372956_REALK, &
      0.000000000000000_REALK,      0.136962342304646_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.067274532236989_REALK,      0.000000000000000_REALK, &
      0.431831275826143_REALK,      0.000000000000000_REALK,      0.020673092897971_REALK, &
      0.000000000000000_REALK,      0.112894060659164_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.750084484335200_REALK, &
      0.000000000000000_REALK,      0.088285249973853_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.009845607176246_REALK,      0.000000000000000_REALK, &
      0.414680313348462_REALK,      0.000000000000000_REALK,     -0.072498272222407_REALK, &
      0.000000000000000_REALK,      0.061962307237049_REALK,      0.000000000000000_REALK, &
     -0.846571860136475_REALK,     -0.277746981138349_REALK,      0.000000000000000_REALK, &
     -0.167334781851156_REALK,      0.000000000000000_REALK,     -0.474728394300385_REALK, &
     -0.128177211120368_REALK,      0.000000000000000_REALK,     -0.182148294437401_REALK, &
      0.000000000000000_REALK,     -0.149097395802511_REALK,      0.000000000000000_REALK, &
     -0.137929175967748_REALK,      0.000000000000000_REALK,     -0.547826660506376_REALK, &
     -1.687413272790807_REALK,     -0.578796794622428_REALK,      0.000000000000000_REALK, &
     -0.359726983710236_REALK,      0.000000000000000_REALK,     -0.743593592979817_REALK, &
     -0.261523987685203_REALK,      0.000000000000000_REALK,     -0.319984803274314_REALK, &
      0.000000000000000_REALK,     -0.147479774846623_REALK,      0.000000000000000_REALK, &
     -0.252471549808287_REALK,      0.000000000000000_REALK,     -0.730639427921509_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.608085051801086_REALK, &
      0.000000000000000_REALK,      0.281592824276036_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.197972816097101_REALK,      0.000000000000000_REALK, &
      0.558300639115084_REALK,      0.000000000000000_REALK,      0.181769009400824_REALK, &
      0.000000000000000_REALK,      0.324952243004215_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.434335618134041_REALK, &
      0.000000000000000_REALK,      0.790384944380283_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.769952021204091_REALK,      0.000000000000000_REALK, &
      1.110151000847039_REALK,      0.000000000000000_REALK,      1.131259721868263_REALK, &
      0.000000000000000_REALK,      0.776615625863062_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.289432833345108_REALK, &
      0.000000000000000_REALK,     -0.344172257635865_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.027514228703403_REALK,      0.000000000000000_REALK, &
      0.751041137884619_REALK,      0.000000000000000_REALK,     -0.154153209466741_REALK, &
      0.000000000000000_REALK,     -0.137232054758799_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.397523311359155_REALK, &
      0.000000000000000_REALK,     -0.275538164107433_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.054528646573435_REALK,      0.000000000000000_REALK, &
      0.560246623604605_REALK,      0.000000000000000_REALK,      0.093799823546163_REALK, &
      0.000000000000000_REALK,     -0.112809317726675_REALK,      0.000000000000000_REALK, &
     -2.569293571046774_REALK,      0.081573417556626_REALK,      0.000000000000000_REALK, &
     -0.000986091001532_REALK,      0.000000000000000_REALK,     -0.735541519654534_REALK, &
      0.100761579774554_REALK,      0.000000000000000_REALK,      0.026759899417250_REALK, &
      0.000000000000000_REALK,      0.079740003522388_REALK,      0.000000000000000_REALK, &
     -0.000393184782669_REALK,      0.000000000000000_REALK,     -0.488805009038021_REALK, &
     -1.241873131205444_REALK,      0.241829070906295_REALK,      0.000000000000000_REALK, &
      0.209292577527569_REALK,      0.000000000000000_REALK,     -0.582131692602127_REALK, &
      0.357982218080124_REALK,      0.000000000000000_REALK,      0.096945732041440_REALK, &
      0.000000000000000_REALK,      0.470618616116943_REALK,      0.000000000000000_REALK, &
      0.085687414491651_REALK,      0.000000000000000_REALK,     -0.397221919525187_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.821014057935986_REALK, &
      0.000000000000000_REALK,      0.067962093059584_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.032773581257582_REALK,      0.000000000000000_REALK, &
      0.448885071235867_REALK,      0.000000000000000_REALK,     -0.005425308098707_REALK, &
      0.000000000000000_REALK,      0.045164291375197_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.740513666064626_REALK, &
      0.000000000000000_REALK,      0.084482833755182_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.081702037100234_REALK,      0.000000000000000_REALK, &
      0.494768468587350_REALK,      0.000000000000000_REALK,      0.090916110124588_REALK, &
      0.000000000000000_REALK,      0.057647494231339_REALK,      0.000000000000000_REALK, &
     -1.031687318172173_REALK,     -0.185690640919346_REALK,      0.000000000000000_REALK, &
     -0.076687909233187_REALK,      0.000000000000000_REALK,     -0.492255190537000_REALK, &
     -0.018591265187936_REALK,      0.000000000000000_REALK,     -0.101525370693974_REALK, &
      0.000000000000000_REALK,      0.003831337276678_REALK,      0.000000000000000_REALK, &
     -0.050963043097066_REALK,      0.000000000000000_REALK,     -0.457980297511210_REALK, &
     -0.764572427715023_REALK,     -0.121011415319258_REALK,      0.000000000000000_REALK, &
      0.014182097965258_REALK,      0.000000000000000_REALK,     -0.597325967093270_REALK, &
      0.094600918432863_REALK,      0.000000000000000_REALK,     -0.080852839566463_REALK, &
      0.000000000000000_REALK,      0.105983121166190_REALK,      0.000000000000000_REALK, &
      0.009677260743995_REALK,      0.000000000000000_REALK,     -0.570625785101302_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.643626695607853_REALK, &
      0.000000000000000_REALK,      0.207635362243589_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.124039392664925_REALK,      0.000000000000000_REALK, &
      0.492659263553887_REALK,      0.000000000000000_REALK,      0.097099162449431_REALK, &
      0.000000000000000_REALK,      0.193178064553124_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.019233825984180_REALK, &
      0.000000000000000_REALK,      0.460921885892291_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.329442892332135_REALK,      0.000000000000000_REALK, &
      0.953390457535259_REALK,      0.000000000000000_REALK,      0.257052284773766_REALK, &
      0.000000000000000_REALK,      0.440318900394620_REALK,      0.000000000000000_REALK, &
     -0.952739317656139_REALK,     -0.381777583080458_REALK,      0.000000000000000_REALK, &
     -0.225674127291002_REALK,      0.000000000000000_REALK,     -0.636420757062466_REALK, &
     -0.163464454660814_REALK,      0.000000000000000_REALK,     -0.292228809347582_REALK, &
      0.000000000000000_REALK,     -0.158725849168268_REALK,      0.000000000000000_REALK, &
     -0.209960821021647_REALK,      0.000000000000000_REALK,     -0.761281534857777_REALK, &
     -1.462039928324655_REALK,     -1.083370107631999_REALK,      0.000000000000000_REALK, &
     -1.109076849989454_REALK,      0.000000000000000_REALK,     -1.599116232082348_REALK, &
     -1.476148401806558_REALK,      0.000000000000000_REALK,     -1.013383481065243_REALK, &
      0.000000000000000_REALK,     -2.444636998649375_REALK,      0.000000000000000_REALK, &
     -1.059501650903604_REALK,      0.000000000000000_REALK,     -1.964104083634572_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.216025461337785_REALK, &
      0.000000000000000_REALK,      1.503197278142206_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.095402621787713_REALK,      0.000000000000000_REALK, &
      0.349447012647916_REALK,      0.000000000000000_REALK,      3.953735607407649_REALK, &
      0.000000000000000_REALK,      6.030554579037060_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.254782935173341_REALK, &
      0.000000000000000_REALK,      1.058451167071446_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.007970736184372_REALK,      0.000000000000000_REALK, &
     -0.021270445449774_REALK,      0.000000000000000_REALK,      9.533856460891082_REALK, &
      0.000000000000000_REALK,      4.944640823731918_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.349540421890423_REALK, &
      0.000000000000000_REALK,     -0.489915757538383_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.431622549840960_REALK,      0.000000000000000_REALK, &
      2.052352781487933_REALK,      0.000000000000000_REALK,     -1.214084676279439_REALK, &
      0.000000000000000_REALK,     -1.833520960773447_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.471687362786980_REALK, &
      0.000000000000000_REALK,     -0.101937572433456_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.366752504713929_REALK,      0.000000000000000_REALK, &
      1.200049613815431_REALK,      0.000000000000000_REALK,      1.553878117711092_REALK, &
      0.000000000000000_REALK,     -0.454970085858254_REALK,      0.000000000000000_REALK, &
     -3.071581479184206_REALK,     -0.182201145291055_REALK,      0.000000000000000_REALK, &
     -1.090190794518650_REALK,      0.000000000000000_REALK,     -3.993222714659855_REALK, &
     -0.181663464034588_REALK,      0.000000000000000_REALK,     -0.277087682045544_REALK, &
      0.000000000000000_REALK,     -3.296358730085410_REALK,      0.000000000000000_REALK, &
     -4.080064056391564_REALK,      0.000000000000000_REALK,    -24.907879350365867_REALK, &
     -1.286534844999716_REALK,     -0.114919605267574_REALK,      0.000000000000000_REALK, &
     -0.991624123810580_REALK,      0.000000000000000_REALK,     -2.646215649885234_REALK, &
     -0.563732333495885_REALK,      0.000000000000000_REALK,     -0.292374226662196_REALK, &
      0.000000000000000_REALK,    -11.381506134525896_REALK,      0.000000000000000_REALK, &
     -4.425839285546339_REALK,      0.000000000000000_REALK,    -19.684416201783165_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.653234408133077_REALK, &
      0.000000000000000_REALK,     -1.328928464226131_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.436348423444210_REALK,      0.000000000000000_REALK, &
      2.141930614872967_REALK,      0.000000000000000_REALK,     -3.326518995857750_REALK, &
      0.000000000000000_REALK,     -4.270671226567160_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.939612848804258_REALK, &
      0.000000000000000_REALK,     -0.907535682499224_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.103368811381599_REALK,      0.000000000000000_REALK, &
      1.322687193300276_REALK,      0.000000000000000_REALK,     -3.226651241836124_REALK, &
      0.000000000000000_REALK,     -3.213097274860335_REALK,      0.000000000000000_REALK, &
     -2.092850089877187_REALK,      0.135096521321608_REALK,      0.000000000000000_REALK, &
     -0.506335058530551_REALK,      0.000000000000000_REALK,     -2.407608606461685_REALK, &
      0.115898610037404_REALK,      0.000000000000000_REALK,      0.175031062478527_REALK, &
      0.000000000000000_REALK,     -1.583217457308171_REALK,      0.000000000000000_REALK, &
     -1.627168522368762_REALK,      0.000000000000000_REALK,    -12.895232358548986_REALK, &
     -1.612033617174918_REALK,      0.044104049804493_REALK,      0.000000000000000_REALK, &
     -0.529688374944404_REALK,      0.000000000000000_REALK,     -1.733191516416151_REALK, &
     -0.212041456891336_REALK,      0.000000000000000_REALK,      0.062084998010956_REALK, &
      0.000000000000000_REALK,     -2.786536966972708_REALK,      0.000000000000000_REALK, &
     -1.875342542314330_REALK,      0.000000000000000_REALK,    -10.227169843195206_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.101149512568410_REALK, &
      0.000000000000000_REALK,      0.325050690141934_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.389489927875934_REALK,      0.000000000000000_REALK, &
      2.377748975906132_REALK,      0.000000000000000_REALK,      0.684850850472177_REALK, &
      0.000000000000000_REALK,      1.740982386604396_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.144904906305808_REALK, &
      0.000000000000000_REALK,      0.422266315855495_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.603947889720294_REALK,      0.000000000000000_REALK, &
      2.686125920628717_REALK,      0.000000000000000_REALK,      2.882573980803716_REALK, &
      0.000000000000000_REALK,      2.491697709347391_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.535214473803324_REALK, &
      0.000000000000000_REALK,     -1.884542686258743_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.668014271219265_REALK,      0.000000000000000_REALK, &
      1.732782481756698_REALK,      0.000000000000000_REALK,     -3.538323881362835_REALK, &
      0.000000000000000_REALK,     -4.853478609100235_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.925717935025521_REALK, &
      0.000000000000000_REALK,     -1.141196361934239_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.745443165732629_REALK,      0.000000000000000_REALK, &
      1.409861016702862_REALK,      0.000000000000000_REALK,     -1.174809760831180_REALK, &
      0.000000000000000_REALK,     -3.241079715001401_REALK,      0.000000000000000_REALK, &
     -1.720833465647025_REALK,      0.586241555059541_REALK,      0.000000000000000_REALK, &
     -0.339464161029904_REALK,      0.000000000000000_REALK,     -1.666348816899265_REALK, &
      0.515401242148343_REALK,      0.000000000000000_REALK,      0.661685460903956_REALK, &
      0.000000000000000_REALK,     -0.582402836043064_REALK,      0.000000000000000_REALK, &
     -0.874260931380457_REALK,      0.000000000000000_REALK,     -7.152564914104631_REALK, &
     -0.714922899074916_REALK,      0.482606024575667_REALK,      0.000000000000000_REALK, &
     -0.093558591402409_REALK,      0.000000000000000_REALK,     -1.197157527664171_REALK, &
      0.738105626843312_REALK,      0.000000000000000_REALK,      0.735005118439687_REALK, &
      0.000000000000000_REALK,      1.111348862240593_REALK,      0.000000000000000_REALK, &
     -0.265713126043006_REALK,      0.000000000000000_REALK,     -5.666689081735728_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.062088932114754_REALK, &
      0.000000000000000_REALK,     -0.136168184840578_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.252108789595923_REALK,      0.000000000000000_REALK, &
      1.997950044374813_REALK,      0.000000000000000_REALK,     -0.232212656934136_REALK, &
      0.000000000000000_REALK,     -0.584482535367568_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.921670281065324_REALK, &
      0.000000000000000_REALK,     -0.056192819511905_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.428989927635678_REALK,      0.000000000000000_REALK, &
      2.339494120117243_REALK,      0.000000000000000_REALK,      0.545059942242303_REALK, &
      0.000000000000000_REALK,     -0.265986079059584_REALK,      0.000000000000000_REALK, &
     -1.146174385547932_REALK,     -0.143392385061863_REALK,      0.000000000000000_REALK, &
     -0.303009852888598_REALK,      0.000000000000000_REALK,     -1.849807442581238_REALK, &
     -0.106108812082311_REALK,      0.000000000000000_REALK,     -0.269742780886456_REALK, &
      0.000000000000000_REALK,     -0.630480092432191_REALK,      0.000000000000000_REALK, &
     -1.300626627762062_REALK,      0.000000000000000_REALK,    -11.116048901925936_REALK, &
     -0.871123394941739_REALK,     -0.224551245683287_REALK,      0.000000000000000_REALK, &
     -0.546630198098092_REALK,      0.000000000000000_REALK,     -2.431199063862477_REALK, &
     -0.659396977100200_REALK,      0.000000000000000_REALK,     -0.569982920935496_REALK, &
      0.000000000000000_REALK,     -3.992335695835138_REALK,      0.000000000000000_REALK, &
     -2.587448438263038_REALK,      0.000000000000000_REALK,    -16.111153646283103_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.997873674043931_REALK, &
      0.000000000000000_REALK,     -2.589949412658643_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.096456709882250_REALK,      0.000000000000000_REALK, &
      0.956567875438519_REALK,      0.000000000000000_REALK,     -4.078782137921455_REALK, &
      0.000000000000000_REALK,     -5.075386983861731_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.488108997216544_REALK, &
      0.000000000000000_REALK,     -2.450826966004900_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.083585084830379_REALK,      0.000000000000000_REALK, &
      1.394085221501382_REALK,      0.000000000000000_REALK,     -4.138687876666938_REALK, &
      0.000000000000000_REALK,     -4.478184267426666_REALK,      0.000000000000000_REALK, &
     -1.549852645775845_REALK,      1.159233184869172_REALK,      0.000000000000000_REALK, &
     -0.472095153449146_REALK,      0.000000000000000_REALK,     -1.224581939134071_REALK, &
      0.810131455948292_REALK,      0.000000000000000_REALK,      1.111248100467788_REALK, &
      0.000000000000000_REALK,     -1.136490870645991_REALK,      0.000000000000000_REALK, &
     -0.925139921748659_REALK,      0.000000000000000_REALK,     -3.999580843918972_REALK, &
     -2.107544961777164_REALK,      1.298151618708919_REALK,      0.000000000000000_REALK, &
     -0.757016662177566_REALK,      0.000000000000000_REALK,     -1.431750038179944_REALK, &
      0.440816491371661_REALK,      0.000000000000000_REALK,      1.216129994708214_REALK, &
      0.000000000000000_REALK,     -2.784412337720352_REALK,      0.000000000000000_REALK, &
     -1.383231110872577_REALK,      0.000000000000000_REALK,     -4.360188475699551_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.025016233488434_REALK, &
      0.000000000000000_REALK,     -0.467622493499078_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.200169997141460_REALK,      0.000000000000000_REALK, &
      1.637644834648775_REALK,      0.000000000000000_REALK,     -0.713784548285154_REALK, &
      0.000000000000000_REALK,     -1.527291810711387_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.361809443339572_REALK, &
      0.000000000000000_REALK,     -0.746416557321030_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.099701868199327_REALK,      0.000000000000000_REALK, &
      2.126276169971149_REALK,      0.000000000000000_REALK,     -1.369615703909973_REALK, &
      0.000000000000000_REALK,     -2.273104092554915_REALK,      0.000000000000000_REALK, &
     -1.072215882259961_REALK,      0.083760733965632_REALK,      0.000000000000000_REALK, &
     -0.178168854825408_REALK,      0.000000000000000_REALK,     -1.411979613940400_REALK, &
      0.053167201239705_REALK,      0.000000000000000_REALK,      0.133822596017213_REALK, &
      0.000000000000000_REALK,     -0.339717331844212_REALK,      0.000000000000000_REALK, &
     -0.581913480813360_REALK,      0.000000000000000_REALK,     -6.456290926419245_REALK, &
     -2.098329830052837_REALK,      0.063921339080996_REALK,      0.000000000000000_REALK, &
     -0.435650278995296_REALK,      0.000000000000000_REALK,     -2.375816308215268_REALK, &
     -0.204519420366834_REALK,      0.000000000000000_REALK,      0.099804286646202_REALK, &
      0.000000000000000_REALK,     -1.182800527062764_REALK,      0.000000000000000_REALK, &
     -1.326710162568090_REALK,      0.000000000000000_REALK,    -10.129288811389760_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.137866596863984_REALK, &
      0.000000000000000_REALK,      0.190631046402588_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.297790303805698_REALK,      0.000000000000000_REALK, &
      2.545120566475980_REALK,      0.000000000000000_REALK,      0.244918665004717_REALK, &
      0.000000000000000_REALK,      0.871662368940398_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.765575763672606_REALK, &
      0.000000000000000_REALK,      0.578832281439913_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.970872034084248_REALK,      0.000000000000000_REALK, &
      6.045287040583948_REALK,      0.000000000000000_REALK,      2.039275550144075_REALK, &
      0.000000000000000_REALK,      2.467850452826031_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.652200230820251_REALK, &
      0.000000000000000_REALK,     -3.670874879600088_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.868594763361123_REALK,      0.000000000000000_REALK, &
     -0.513975477307868_REALK,      0.000000000000000_REALK,     -4.963266497892465_REALK, &
      0.000000000000000_REALK,     -5.268188688846125_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.256464533229883_REALK, &
      0.000000000000000_REALK,     -4.022961316157454_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.184038752023320_REALK,      0.000000000000000_REALK, &
      1.275508358228222_REALK,      0.000000000000000_REALK,     -4.453967717497949_REALK, &
      0.000000000000000_REALK,     -5.732719747788319_REALK,      0.000000000000000_REALK, &
     -1.125987059223923_REALK,      2.099422691342335_REALK,      0.000000000000000_REALK, &
     -0.822049387242511_REALK,      0.000000000000000_REALK,     -0.717170161642361_REALK, &
      1.329605137207667_REALK,      0.000000000000000_REALK,      1.654479297709780_REALK, &
      0.000000000000000_REALK,     -1.698293146258114_REALK,      0.000000000000000_REALK, &
     -1.179749085867967_REALK,      0.000000000000000_REALK,     -1.715389317924595_REALK, &
     -1.256130384122419_REALK,      2.405202026553559_REALK,      0.000000000000000_REALK, &
     -1.081768196031698_REALK,      0.000000000000000_REALK,     -1.391747705178197_REALK, &
      2.256552025926989_REALK,      0.000000000000000_REALK,      2.441656892781730_REALK, &
      0.000000000000000_REALK,     -0.682358466391128_REALK,      0.000000000000000_REALK, &
     -1.541519644997140_REALK,      0.000000000000000_REALK,     -3.305400726147514_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.992650705013950_REALK, &
      0.000000000000000_REALK,     -0.833138975602650_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.301577959057102_REALK,      0.000000000000000_REALK, &
      1.303787026845720_REALK,      0.000000000000000_REALK,     -0.871673123046072_REALK, &
      0.000000000000000_REALK,     -1.992773508343642_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.405096378126620_REALK, &
      0.000000000000000_REALK,     -1.214090862759964_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.754184190395748_REALK,      0.000000000000000_REALK, &
      2.377321612903820_REALK,      0.000000000000000_REALK,     -0.627110220324322_REALK, &
      0.000000000000000_REALK,     -2.883465734805736_REALK,      0.000000000000000_REALK, &
     -1.156614353523482_REALK,      0.379056544130054_REALK,      0.000000000000000_REALK, &
     -0.150073981044034_REALK,      0.000000000000000_REALK,     -1.227795790486303_REALK, &
      0.232680140828270_REALK,      0.000000000000000_REALK,      0.497867983351496_REALK, &
      0.000000000000000_REALK,     -0.143476096588708_REALK,      0.000000000000000_REALK, &
     -0.358959864409043_REALK,      0.000000000000000_REALK,     -4.111446703635444_REALK, &
     -1.149519438672375_REALK,      0.732521161723696_REALK,      0.000000000000000_REALK, &
     -0.099534694241255_REALK,      0.000000000000000_REALK,     -2.122710960916314_REALK, &
      0.746760611937827_REALK,      0.000000000000000_REALK,      1.239372911911548_REALK, &
      0.000000000000000_REALK,      0.593234967135272_REALK,      0.000000000000000_REALK, &
     -0.236394893555647_REALK,      0.000000000000000_REALK,     -7.058013787780585_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.144555961877379_REALK, &
      0.000000000000000_REALK,     -0.100331168630421_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.189692689468853_REALK,      0.000000000000000_REALK, &
      2.104627629719110_REALK,      0.000000000000000_REALK,     -0.095343416199010_REALK, &
      0.000000000000000_REALK,     -0.335973014188336_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.331587777717856_REALK, &
      0.000000000000000_REALK,     -0.099636940959180_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.723367065692322_REALK,      0.000000000000000_REALK, &
      5.522829425578494_REALK,      0.000000000000000_REALK,      0.484919164313179_REALK, &
      0.000000000000000_REALK,     -0.331292821307430_REALK,      0.000000000000000_REALK, &
     -1.283953166135541_REALK,     -0.154526239985938_REALK,      0.000000000000000_REALK, &
     -0.223263111588350_REALK,      0.000000000000000_REALK,     -1.908159969539132_REALK, &
     -0.079838810747137_REALK,      0.000000000000000_REALK,     -0.284145297410851_REALK, &
      0.000000000000000_REALK,     -0.258866707145092_REALK,      0.000000000000000_REALK, &
     -0.747627896508537_REALK,      0.000000000000000_REALK,     -8.215382243534954_REALK, &
     -2.334455172866755_REALK,     -0.568056658289240_REALK,      0.000000000000000_REALK, &
     -0.969244135593973_REALK,      0.000000000000000_REALK,     -6.035150675232847_REALK, &
     -1.111881714986190_REALK,      0.000000000000000_REALK,     -1.345555186803368_REALK, &
      0.000000000000000_REALK,     -3.551829696597716_REALK,      0.000000000000000_REALK, &
     -3.222736679041172_REALK,      0.000000000000000_REALK,    -25.800268561740683_REALK/
    ! results of test 7, ket-major order, 02ODGYYZ
  data REF_CONTR_INTS(60481:61740)                                                         &
     /0.000000000000000_REALK,      0.000000000000000_REALK,      1.429801712513927_REALK, &
      0.000000000000000_REALK,      0.620827621636712_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.467636506232420_REALK,      0.000000000000000_REALK, &
      0.906978778329366_REALK,      0.000000000000000_REALK,      0.416461551442135_REALK, &
      0.000000000000000_REALK,      0.558036194420457_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.507736270349491_REALK, &
      0.000000000000000_REALK,      0.048656031395594_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.410527974895409_REALK,      0.000000000000000_REALK, &
      0.374616776859032_REALK,      0.000000000000000_REALK,     -1.731324611742897_REALK, &
      0.000000000000000_REALK,      0.044070242723008_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.336480570483182_REALK, &
      0.000000000000000_REALK,      0.381906132700301_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.246207424880950_REALK,      0.000000000000000_REALK, &
      0.730736181680611_REALK,      0.000000000000000_REALK,      0.143707076154162_REALK, &
      0.000000000000000_REALK,      0.282613361663400_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.768664239466143_REALK, &
      0.000000000000000_REALK,      0.196821833397479_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.151653364898213_REALK,      0.000000000000000_REALK, &
      0.378908980554844_REALK,      0.000000000000000_REALK,      0.290404765653279_REALK, &
      0.000000000000000_REALK,      0.132483458800523_REALK,      0.000000000000000_REALK, &
     -1.370844407844559_REALK,     -0.510330056721325_REALK,      0.000000000000000_REALK, &
     -0.321891391361913_REALK,      0.000000000000000_REALK,     -0.624306821647210_REALK, &
     -0.208238800743860_REALK,      0.000000000000000_REALK,     -0.279028850311358_REALK, &
      0.000000000000000_REALK,     -0.120609370324931_REALK,      0.000000000000000_REALK, &
     -0.238202009378803_REALK,      0.000000000000000_REALK,     -0.769986105955733_REALK, &
     -0.989631800404300_REALK,     -0.062825517232384_REALK,      0.000000000000000_REALK, &
      0.398348721985428_REALK,      0.000000000000000_REALK,     -0.363502911912678_REALK, &
      1.216654746849028_REALK,      0.000000000000000_REALK,     -0.030969507185461_REALK, &
      0.000000000000000_REALK,      3.516009772398784_REALK,      0.000000000000000_REALK, &
      0.268133954381066_REALK,      0.000000000000000_REALK,     -0.407797941103741_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.448306211215451_REALK, &
      0.000000000000000_REALK,      0.245281929362609_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.169269732023610_REALK,      0.000000000000000_REALK, &
      0.677547618763632_REALK,      0.000000000000000_REALK,      0.085447978089106_REALK, &
      0.000000000000000_REALK,      0.149063858643263_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.703211732387462_REALK, &
      0.000000000000000_REALK,      0.142443371836165_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.093689584255329_REALK,      0.000000000000000_REALK, &
      0.385025249585331_REALK,      0.000000000000000_REALK,      0.003656077998306_REALK, &
      0.000000000000000_REALK,      0.086893683448510_REALK,      0.000000000000000_REALK, &
     -1.464488210883001_REALK,     -0.361102296985883_REALK,      0.000000000000000_REALK, &
     -0.195290058870220_REALK,      0.000000000000000_REALK,     -0.579614981181049_REALK, &
     -0.085900391559997_REALK,      0.000000000000000_REALK,     -0.168931127656724_REALK, &
      0.000000000000000_REALK,     -0.031228731832493_REALK,      0.000000000000000_REALK, &
     -0.118682569912558_REALK,      0.000000000000000_REALK,     -0.587077122822215_REALK, &
     -0.608227215191799_REALK,     -0.198686967089170_REALK,      0.000000000000000_REALK, &
     -0.150077654499028_REALK,      0.000000000000000_REALK,     -0.374972036449412_REALK, &
     -0.238459464698693_REALK,      0.000000000000000_REALK,     -0.108785868564989_REALK, &
      0.000000000000000_REALK,     -0.734501791682315_REALK,      0.000000000000000_REALK, &
     -0.091550768804691_REALK,      0.000000000000000_REALK,     -0.381235726839743_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.590298526307446_REALK, &
      0.000000000000000_REALK,      0.221323790824520_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.142384400431800_REALK,      0.000000000000000_REALK, &
      0.460256445036854_REALK,      0.000000000000000_REALK,      0.100380059779841_REALK, &
      0.000000000000000_REALK,      0.224173181418819_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.366947557846175_REALK, &
      0.000000000000000_REALK,      0.030647727483688_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.220172279492103_REALK,      0.000000000000000_REALK, &
      0.334854280101339_REALK,      0.000000000000000_REALK,     -0.734475476483265_REALK, &
      0.000000000000000_REALK,      0.031159679996048_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.818555166030498_REALK, &
      0.000000000000000_REALK,      0.103997761445868_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.106265607273993_REALK,      0.000000000000000_REALK, &
      0.715572253153203_REALK,      0.000000000000000_REALK,     -0.014236325147054_REALK, &
      0.000000000000000_REALK,      0.051433391360841_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.483559954748464_REALK, &
      0.000000000000000_REALK,      0.012663300669464_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.002583505183222_REALK,      0.000000000000000_REALK, &
      0.492107051742241_REALK,      0.000000000000000_REALK,     -0.079600393323103_REALK, &
      0.000000000000000_REALK,      0.005332582692685_REALK,      0.000000000000000_REALK, &
     -1.887999965266314_REALK,     -0.274604449462457_REALK,      0.000000000000000_REALK, &
     -0.158698965431895_REALK,      0.000000000000000_REALK,     -0.635235283019380_REALK, &
     -0.061938974931911_REALK,      0.000000000000000_REALK,     -0.108052440914762_REALK, &
      0.000000000000000_REALK,     -0.067097047067594_REALK,      0.000000000000000_REALK, &
     -0.078486554750198_REALK,      0.000000000000000_REALK,     -0.523605900478225_REALK, &
     -2.254903584228381_REALK,     -0.301012455642076_REALK,      0.000000000000000_REALK, &
     -0.145075977784891_REALK,      0.000000000000000_REALK,     -0.596201968441190_REALK, &
     -0.004201130748035_REALK,      0.000000000000000_REALK,     -0.099847904096892_REALK, &
      0.000000000000000_REALK,      0.209847522354182_REALK,      0.000000000000000_REALK, &
     -0.061092259313204_REALK,      0.000000000000000_REALK,     -0.418439655036684_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.648905743774199_REALK, &
      0.000000000000000_REALK,      0.158381506651325_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.086029849822812_REALK,      0.000000000000000_REALK, &
      0.425556648697573_REALK,      0.000000000000000_REALK,      0.039830073012089_REALK, &
      0.000000000000000_REALK,      0.130549252577860_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.792393861741559_REALK, &
      0.000000000000000_REALK,      0.168452196438760_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.105199273650590_REALK,      0.000000000000000_REALK, &
      0.438070833012387_REALK,      0.000000000000000_REALK,      0.155492497579652_REALK, &
      0.000000000000000_REALK,      0.118226847107365_REALK,      0.000000000000000_REALK, &
     -0.769508263193814_REALK,     -0.247782206745704_REALK,      0.000000000000000_REALK, &
     -0.133492602440084_REALK,      0.000000000000000_REALK,     -0.431513778556243_REALK, &
     -0.072762845247007_REALK,      0.000000000000000_REALK,     -0.162497198585875_REALK, &
      0.000000000000000_REALK,     -0.033428277538893_REALK,      0.000000000000000_REALK, &
     -0.110034055374864_REALK,      0.000000000000000_REALK,     -0.497957895729690_REALK, &
     -1.176646129896034_REALK,     -0.064765019184781_REALK,      0.000000000000000_REALK, &
      0.340931267678547_REALK,      0.000000000000000_REALK,     -0.518513477109325_REALK, &
      0.843972013004559_REALK,      0.000000000000000_REALK,     -0.035805004650066_REALK, &
      0.000000000000000_REALK,      1.882590114507567_REALK,      0.000000000000000_REALK, &
      0.239279924572578_REALK,      0.000000000000000_REALK,     -0.509480439128841_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.688825004286384_REALK, &
      0.000000000000000_REALK,     -0.088783881868014_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.101908223667954_REALK,      0.000000000000000_REALK, &
      0.882060465535158_REALK,      0.000000000000000_REALK,     -0.052077713297209_REALK, &
      0.000000000000000_REALK,     -0.035400861829778_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.765748937739059_REALK, &
      0.000000000000000_REALK,     -0.049787332118567_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.138340465459139_REALK,      0.000000000000000_REALK, &
      0.707862883188424_REALK,      0.000000000000000_REALK,      0.078940137346521_REALK, &
      0.000000000000000_REALK,     -0.020383655331089_REALK,      0.000000000000000_REALK, &
     -2.849287287809712_REALK,     -0.140997960841719_REALK,      0.000000000000000_REALK, &
     -0.121134803532038_REALK,      0.000000000000000_REALK,     -0.815698573812275_REALK, &
      0.012802694662903_REALK,      0.000000000000000_REALK,     -0.046253931282732_REALK, &
      0.000000000000000_REALK,      0.010505532512692_REALK,      0.000000000000000_REALK, &
     -0.048300168368285_REALK,      0.000000000000000_REALK,     -0.542073476602487_REALK, &
     -1.512215037040988_REALK,     -0.017357417429061_REALK,      0.000000000000000_REALK, &
      0.003721408232760_REALK,      0.000000000000000_REALK,     -0.708855258215123_REALK, &
      0.103868272789752_REALK,      0.000000000000000_REALK,     -0.006958334383467_REALK, &
      0.000000000000000_REALK,      0.022772648507021_REALK,      0.000000000000000_REALK, &
      0.001523598464409_REALK,      0.000000000000000_REALK,     -0.483692693443821_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.861238533553101_REALK, &
      0.000000000000000_REALK,      0.123171659553205_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.070582779279806_REALK,      0.000000000000000_REALK, &
      0.470877589425150_REALK,      0.000000000000000_REALK,      0.028152692056393_REALK, &
      0.000000000000000_REALK,      0.081853875753214_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.817206090921909_REALK, &
      0.000000000000000_REALK,      0.143825843564448_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.079717538956487_REALK,      0.000000000000000_REALK, &
      0.546009918053830_REALK,      0.000000000000000_REALK,      0.002477578290942_REALK, &
      0.000000000000000_REALK,      0.098140641342897_REALK,      0.000000000000000_REALK, &
     -1.016696617875118_REALK,     -0.214730289983210_REALK,      0.000000000000000_REALK, &
     -0.098067561307087_REALK,      0.000000000000000_REALK,     -0.485102587319890_REALK, &
     -0.035819093614932_REALK,      0.000000000000000_REALK,     -0.117402644429661_REALK, &
      0.000000000000000_REALK,     -0.010288983897021_REALK,      0.000000000000000_REALK, &
     -0.065170916814542_REALK,      0.000000000000000_REALK,     -0.451325717910377_REALK, &
     -0.807699014218626_REALK,     -0.230895180233722_REALK,      0.000000000000000_REALK, &
     -0.151534220092200_REALK,      0.000000000000000_REALK,     -0.631018824770185_REALK, &
     -0.202897705414674_REALK,      0.000000000000000_REALK,     -0.154270825730404_REALK, &
      0.000000000000000_REALK,     -0.497742579500092_REALK,      0.000000000000000_REALK, &
     -0.103400509787939_REALK,      0.000000000000000_REALK,     -0.602812588326607_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.585037235471693_REALK, &
      0.000000000000000_REALK,      0.185234590288970_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.098953374479293_REALK,      0.000000000000000_REALK, &
      0.447812397381812_REALK,      0.000000000000000_REALK,      0.055120651082721_REALK, &
      0.000000000000000_REALK,      0.172337020311283_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.710719511421130_REALK, &
      0.000000000000000_REALK,      0.051575293885263_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.312229518486593_REALK,      0.000000000000000_REALK, &
      0.664806429004392_REALK,      0.000000000000000_REALK,     -0.829541244564812_REALK, &
      0.000000000000000_REALK,      0.049269903179202_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.396292309013861_REALK, &
      0.000000000000000_REALK,     -0.580023164651288_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.143016729687245_REALK,      0.000000000000000_REALK, &
      1.355326656147118_REALK,      0.000000000000000_REALK,     -0.147432361807041_REALK, &
      0.000000000000000_REALK,     -0.174975771000243_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     10.715209885663773_REALK, &
      0.000000000000000_REALK,     -1.429027238177583_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.099686443725669_REALK,      0.000000000000000_REALK, &
      2.119353532823931_REALK,      0.000000000000000_REALK,     -0.541064418669108_REALK, &
      0.000000000000000_REALK,     -0.325576628790242_REALK,      0.000000000000000_REALK, &
     -6.288780311281675_REALK,      0.170602908257606_REALK,      0.000000000000000_REALK, &
     -0.158599075415011_REALK,      0.000000000000000_REALK,     -1.372744703605317_REALK, &
      0.063033731130601_REALK,      0.000000000000000_REALK,      0.042848432949328_REALK, &
      0.000000000000000_REALK,     -0.014730262034842_REALK,      0.000000000000000_REALK, &
     -0.047844633097285_REALK,      0.000000000000000_REALK,     -0.690193879423901_REALK, &
    -16.693636283465235_REALK,      0.300933936328530_REALK,      0.000000000000000_REALK, &
     -0.575202371522859_REALK,      0.000000000000000_REALK,     -2.943205429963307_REALK, &
     -0.230509963654395_REALK,      0.000000000000000_REALK,      0.059521503349906_REALK, &
      0.000000000000000_REALK,     -0.334288890840072_REALK,      0.000000000000000_REALK, &
     -0.131048900951245_REALK,      0.000000000000000_REALK,     -1.117588799947831_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.567407799997209_REALK, &
      0.000000000000000_REALK,      0.071984678681605_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.058461472935917_REALK,      0.000000000000000_REALK, &
      0.656113942295977_REALK,      0.000000000000000_REALK,     -0.006010704600239_REALK, &
      0.000000000000000_REALK,      0.036192734532396_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.284595981842195_REALK, &
      0.000000000000000_REALK,      0.028931885012354_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.004448999437549_REALK,      0.000000000000000_REALK, &
      1.412411846918910_REALK,      0.000000000000000_REALK,     -0.098393647495869_REALK, &
      0.000000000000000_REALK,      0.010985964595611_REALK,      0.000000000000000_REALK, &
     -2.014314774852108_REALK,     -0.236680835446361_REALK,      0.000000000000000_REALK, &
     -0.109847499358573_REALK,      0.000000000000000_REALK,     -0.732823589976497_REALK, &
     -0.034075405952595_REALK,      0.000000000000000_REALK,     -0.099074150333368_REALK, &
      0.000000000000000_REALK,     -0.028328977127579_REALK,      0.000000000000000_REALK, &
     -0.055229549622875_REALK,      0.000000000000000_REALK,     -0.515832621491220_REALK, &
     -7.725980154319534_REALK,     -0.869339155320595_REALK,      0.000000000000000_REALK, &
     -0.331455567303122_REALK,      0.000000000000000_REALK,     -2.270241022373372_REALK, &
     -0.007234678086371_REALK,      0.000000000000000_REALK,     -0.286576593725263_REALK, &
      0.000000000000000_REALK,      0.259391471328400_REALK,      0.000000000000000_REALK, &
     -0.125859726245117_REALK,      0.000000000000000_REALK,     -1.206872710800047_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.932150188286353_REALK, &
      0.000000000000000_REALK,      0.182712937068657_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.078881459801783_REALK,      0.000000000000000_REALK, &
      0.546274829555792_REALK,      0.000000000000000_REALK,      0.028027692143008_REALK, &
      0.000000000000000_REALK,      0.128611161809773_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.814122403330775_REALK, &
      0.000000000000000_REALK,      0.641438819237802_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.301935726922248_REALK,      0.000000000000000_REALK, &
      1.760249126697302_REALK,      0.000000000000000_REALK,      0.320339162416847_REALK, &
      0.000000000000000_REALK,      0.340992431621469_REALK,      0.000000000000000_REALK, &
     -1.368319114087344_REALK,     -0.355938027807606_REALK,      0.000000000000000_REALK, &
     -0.154000463718674_REALK,      0.000000000000000_REALK,     -0.696927388466182_REALK, &
     -0.066716836821599_REALK,      0.000000000000000_REALK,     -0.208592979882866_REALK, &
      0.000000000000000_REALK,     -0.023522866037598_REALK,      0.000000000000000_REALK, &
     -0.108400526398741_REALK,      0.000000000000000_REALK,     -0.630726915198482_REALK, &
     -6.719241206747248_REALK,     -0.311741070383743_REALK,      0.000000000000000_REALK, &
      1.298211328817412_REALK,      0.000000000000000_REALK,     -2.764182072814521_REALK, &
      2.422310481866481_REALK,      0.000000000000000_REALK,     -0.143871089826447_REALK, &
      0.000000000000000_REALK,      3.878433685500908_REALK,      0.000000000000000_REALK, &
      0.690136338018969_REALK,      0.000000000000000_REALK,     -1.889298656987965_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.586603806299847_REALK, &
      0.000000000000000_REALK,     -0.046211598123635_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.552723636841771_REALK,      0.000000000000000_REALK, &
      2.412873806638174_REALK,      0.000000000000000_REALK,     -0.734786024574976_REALK, &
      0.000000000000000_REALK,     -0.172947966026353_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.524174103806505_REALK, &
      0.000000000000000_REALK,     -0.264808043441560_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.045567911993460_REALK,      0.000000000000000_REALK, &
      1.333584446970084_REALK,      0.000000000000000_REALK,     -5.126799539027024_REALK, &
      0.000000000000000_REALK,     -1.181897266969065_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.267401874279167_REALK, &
      0.000000000000000_REALK,     -0.893483763281377_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.696893712812908_REALK,      0.000000000000000_REALK, &
      2.937646026992176_REALK,      0.000000000000000_REALK,     -2.407043362899948_REALK, &
      0.000000000000000_REALK,     -2.871317382363949_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.334814497806880_REALK, &
      0.000000000000000_REALK,     -0.620150317535771_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.343237114720788_REALK,      0.000000000000000_REALK, &
      1.879010109246075_REALK,      0.000000000000000_REALK,     -1.692680895459258_REALK, &
      0.000000000000000_REALK,     -2.195619779699030_REALK,      0.000000000000000_REALK, &
     -2.460484965661690_REALK,      0.012743060526536_REALK,      0.000000000000000_REALK, &
     -0.648398363604076_REALK,      0.000000000000000_REALK,     -2.830534689536362_REALK, &
      0.070143936899133_REALK,      0.000000000000000_REALK,      0.016509910109958_REALK, &
      0.000000000000000_REALK,     -1.260225247788586_REALK,      0.000000000000000_REALK, &
     -2.083706015289299_REALK,      0.000000000000000_REALK,    -15.160438628829759_REALK, &
     -1.791411734238549_REALK,      0.114571171921922_REALK,      0.000000000000000_REALK, &
     -0.065812211077475_REALK,      0.000000000000000_REALK,     -1.926051409294952_REALK, &
      0.699600587108108_REALK,      0.000000000000000_REALK,      0.161281129792320_REALK, &
      0.000000000000000_REALK,      5.526563663351204_REALK,      0.000000000000000_REALK, &
     -0.233005754091381_REALK,      0.000000000000000_REALK,    -11.365192307377605_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.676226106175783_REALK, &
      0.000000000000000_REALK,     -1.525769802410999_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.995959540549111_REALK,      0.000000000000000_REALK, &
      3.020631835572067_REALK,      0.000000000000000_REALK,     -2.962187192620855_REALK, &
      0.000000000000000_REALK,     -3.929489712495772_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.507468084763850_REALK, &
      0.000000000000000_REALK,     -0.954648172387594_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.860087532633760_REALK,      0.000000000000000_REALK, &
      2.295861845405087_REALK,      0.000000000000000_REALK,     -1.344523667433384_REALK, &
      0.000000000000000_REALK,     -2.711269444676768_REALK,      0.000000000000000_REALK, &
     -2.360113608896230_REALK,      0.394150117863225_REALK,      0.000000000000000_REALK, &
     -0.542159491902681_REALK,      0.000000000000000_REALK,     -2.285388213584854_REALK, &
      0.372940344152061_REALK,      0.000000000000000_REALK,      0.444873619334591_REALK, &
      0.000000000000000_REALK,     -0.956117368634374_REALK,      0.000000000000000_REALK, &
     -1.396285430867145_REALK,      0.000000000000000_REALK,     -9.809703338111753_REALK, &
     -1.015619839292053_REALK,      0.329781280402196_REALK,      0.000000000000000_REALK, &
     -0.310662186602450_REALK,      0.000000000000000_REALK,     -1.700682601476084_REALK, &
      0.387205557634948_REALK,      0.000000000000000_REALK,      0.502254254439388_REALK, &
      0.000000000000000_REALK,     -0.861706223770773_REALK,      0.000000000000000_REALK, &
     -0.882302945225480_REALK,      0.000000000000000_REALK,     -8.050101433255911_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.248657924570882_REALK, &
      0.000000000000000_REALK,     -0.012844145831714_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.322843389708394_REALK,      0.000000000000000_REALK, &
      2.348914559196075_REALK,      0.000000000000000_REALK,     -0.140539303706156_REALK, &
      0.000000000000000_REALK,     -0.055131666248912_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.024228613478226_REALK, &
      0.000000000000000_REALK,     -0.145974739590017_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.053300727376985_REALK,      0.000000000000000_REALK, &
      2.599819987814406_REALK,      0.000000000000000_REALK,     -1.798347649522338_REALK, &
      0.000000000000000_REALK,     -0.690964592318892_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.070203224678564_REALK, &
      0.000000000000000_REALK,     -2.357488330377372_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.516344600815899_REALK,      0.000000000000000_REALK, &
      2.943115799311053_REALK,      0.000000000000000_REALK,     -3.830036115192999_REALK, &
      0.000000000000000_REALK,     -4.619845286599909_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.177032788544236_REALK, &
      0.000000000000000_REALK,     -2.268011634732487_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.371478809520905_REALK,      0.000000000000000_REALK, &
      2.976297077041560_REALK,      0.000000000000000_REALK,     -3.785172854045946_REALK, &
      0.000000000000000_REALK,     -4.144141615005942_REALK,      0.000000000000000_REALK, &
     -2.701743751200650_REALK,      0.938542278889654_REALK,      0.000000000000000_REALK, &
     -0.703858723357037_REALK,      0.000000000000000_REALK,     -2.134723330573429_REALK, &
      0.678219717473973_REALK,      0.000000000000000_REALK,      0.899692433099680_REALK, &
      0.000000000000000_REALK,     -1.432394476801071_REALK,      0.000000000000000_REALK, &
     -1.379314740876246_REALK,      0.000000000000000_REALK,     -6.972174149543476_REALK, &
     -3.431992237458746_REALK,      1.085946390664956_REALK,      0.000000000000000_REALK, &
     -0.873440958433148_REALK,      0.000000000000000_REALK,     -2.331506613681617_REALK, &
      0.504497175121200_REALK,      0.000000000000000_REALK,      1.017332613001120_REALK, &
      0.000000000000000_REALK,     -2.083289136783216_REALK,      0.000000000000000_REALK, &
     -1.595963163795862_REALK,      0.000000000000000_REALK,     -7.100267502639465_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.405804111954563_REALK, &
      0.000000000000000_REALK,     -0.314398492118897_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.319692257395075_REALK,      0.000000000000000_REALK, &
      2.246020860211455_REALK,      0.000000000000000_REALK,     -0.516488966883924_REALK, &
      0.000000000000000_REALK,     -1.026850181479020_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.934587197837119_REALK, &
      0.000000000000000_REALK,     -0.510052082758728_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.331060995242334_REALK,      0.000000000000000_REALK, &
      3.020589024118422_REALK,      0.000000000000000_REALK,     -0.718491762007150_REALK, &
      0.000000000000000_REALK,     -1.553290137207354_REALK,      0.000000000000000_REALK, &
     -1.260563798145300_REALK,      0.007900781546626_REALK,      0.000000000000000_REALK, &
     -0.228157999268850_REALK,      0.000000000000000_REALK,     -1.660011210896154_REALK, &
      0.032177752672425_REALK,      0.000000000000000_REALK,      0.012622896756948_REALK, &
      0.000000000000000_REALK,     -0.270411595529872_REALK,      0.000000000000000_REALK, &
     -0.745181954837458_REALK,      0.000000000000000_REALK,     -7.590417887659000_REALK, &
     -2.331820279559064_REALK,      0.166051479666663_REALK,      0.000000000000000_REALK, &
     -0.054128256298259_REALK,      0.000000000000000_REALK,     -2.640183906580601_REALK, &
      0.674782698918032_REALK,      0.000000000000000_REALK,      0.259266306259294_REALK, &
      0.000000000000000_REALK,      2.345858853241527_REALK,      0.000000000000000_REALK, &
     -0.164839806549892_REALK,      0.000000000000000_REALK,    -11.256419619843365_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.414996736472384_REALK, &
      0.000000000000000_REALK,     -3.726767258497836_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.517977231133834_REALK,      0.000000000000000_REALK, &
      2.691235750446939_REALK,      0.000000000000000_REALK,     -5.048387535085523_REALK, &
      0.000000000000000_REALK,     -5.348401610277515_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.105054586169563_REALK, &
      0.000000000000000_REALK,     -4.089717636849971_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.597827623812475_REALK,      0.000000000000000_REALK, &
      4.167273565758810_REALK,      0.000000000000000_REALK,     -4.643734792270742_REALK, &
      0.000000000000000_REALK,     -5.827847502655526_REALK,      0.000000000000000_REALK, &
     -3.464375491705201_REALK,      1.910988867650651_REALK,      0.000000000000000_REALK, &
     -1.136853045555318_REALK,      0.000000000000000_REALK,     -2.206549987429258_REALK, &
      1.248518680884145_REALK,      0.000000000000000_REALK,      1.505981397991047_REALK, &
      0.000000000000000_REALK,     -1.951603260830898_REALK,      0.000000000000000_REALK, &
     -1.631533776527754_REALK,      0.000000000000000_REALK,     -5.277816172991243_REALK, &
     -2.681770908252142_REALK,      2.225790011196866_REALK,      0.000000000000000_REALK, &
     -1.369179198238385_REALK,      0.000000000000000_REALK,     -2.971306605230415_REALK, &
      2.063803728818518_REALK,      0.000000000000000_REALK,      2.259525587757330_REALK, &
      0.000000000000000_REALK,     -1.319812086740852_REALK,      0.000000000000000_REALK, &
     -1.951080314015866_REALK,      0.000000000000000_REALK,     -7.056853030181941_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.730414724719733_REALK, &
      0.000000000000000_REALK,     -0.674528785925111_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.449630282589669_REALK,      0.000000000000000_REALK, &
      2.272795715307220_REALK,      0.000000000000000_REALK,     -0.729740704303299_REALK, &
      0.000000000000000_REALK,     -1.613396005431685_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.288102958688777_REALK, &
      0.000000000000000_REALK,     -1.015626812270775_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.870172870699479_REALK,      0.000000000000000_REALK, &
      3.871304987272426_REALK,      0.000000000000000_REALK,     -0.717703037059271_REALK, &
      0.000000000000000_REALK,     -2.412113625396548_REALK,      0.000000000000000_REALK, &
     -1.586290207907548_REALK,      0.254852594900942_REALK,      0.000000000000000_REALK, &
     -0.239683721143919_REALK,      0.000000000000000_REALK,     -1.683915156184329_REALK, &
      0.168365546493714_REALK,      0.000000000000000_REALK,      0.334733562683710_REALK, &
      0.000000000000000_REALK,     -0.235541414709360_REALK,      0.000000000000000_REALK, &
     -0.573296153299431_REALK,      0.000000000000000_REALK,     -5.638826482173915_REALK, &
     -1.633007907675353_REALK,      0.500556881459050_REALK,      0.000000000000000_REALK, &
     -0.330505892535259_REALK,      0.000000000000000_REALK,     -3.015524286295645_REALK, &
      0.391745908240560_REALK,      0.000000000000000_REALK,      0.846906099328867_REALK, &
      0.000000000000000_REALK,     -0.459976413084451_REALK,      0.000000000000000_REALK, &
     -0.784951477281007_REALK,      0.000000000000000_REALK,    -10.026618028520630_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.345611303064237_REALK, &
      0.000000000000000_REALK,     -0.009463797750291_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.242915096174087_REALK,      0.000000000000000_REALK, &
      2.474331375327485_REALK,      0.000000000000000_REALK,     -0.057703561478889_REALK, &
      0.000000000000000_REALK,     -0.031690856383286_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.591033871694823_REALK, &
      0.000000000000000_REALK,     -0.258831584469272_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.089876214517325_REALK,      0.000000000000000_REALK, &
      6.137379105355033_REALK,      0.000000000000000_REALK,     -1.599921718267228_REALK, &
      0.000000000000000_REALK,     -0.860614999184169_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.134872078078112_REALK, &
      0.000000000000000_REALK,     -6.555856653298987_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      4.550005847063370_REALK,      0.000000000000000_REALK, &
      1.869214633175928_REALK,      0.000000000000000_REALK,     -7.428787473057141_REALK, &
      0.000000000000000_REALK,     -6.488121513891631_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     19.227784773648743_REALK, &
      0.000000000000000_REALK,    -18.114671617801228_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     11.399349739133232_REALK,      0.000000000000000_REALK, &
      9.048017146700056_REALK,      0.000000000000000_REALK,    -14.808863129688719_REALK, &
      0.000000000000000_REALK,    -12.420784682367351_REALK,      0.000000000000000_REALK, &
     -5.222338032655264_REALK,      4.219946277385263_REALK,      0.000000000000000_REALK, &
     -2.300603686283165_REALK,      0.000000000000000_REALK,     -2.458905033604008_REALK, &
      2.375061969460365_REALK,      0.000000000000000_REALK,      2.516206446848283_REALK, &
      0.000000000000000_REALK,     -3.245074764581600_REALK,      0.000000000000000_REALK, &
     -2.276833839007287_REALK,      0.000000000000000_REALK,     -4.055832693533779_REALK, &
    -24.381000785019634_REALK,     14.056493373003683_REALK,      0.000000000000000_REALK, &
     -7.975142117806665_REALK,      0.000000000000000_REALK,     -9.237407237283945_REALK, &
      5.270603968602914_REALK,      0.000000000000000_REALK,      6.614562964929537_REALK, &
      0.000000000000000_REALK,     -8.677967385107360_REALK,      0.000000000000000_REALK, &
     -5.468358750661108_REALK,      0.000000000000000_REALK,    -10.556438149366837_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.498552165844086_REALK, &
      0.000000000000000_REALK,     -1.375972075065967_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.767570595084173_REALK,      0.000000000000000_REALK, &
      2.482998856002444_REALK,      0.000000000000000_REALK,     -1.128949676796609_REALK, &
      0.000000000000000_REALK,     -2.269592542686544_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     10.212478052091880_REALK, &
      0.000000000000000_REALK,     -5.008588394262822_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.214461442378489_REALK,      0.000000000000000_REALK, &
      8.009474970153709_REALK,      0.000000000000000_REALK,     -3.136787072687170_REALK, &
      0.000000000000000_REALK,     -5.723776406248182_REALK,      0.000000000000000_REALK, &
     -2.646213547631492_REALK,      0.763792059368155_REALK,      0.000000000000000_REALK, &
     -0.410814312695170_REALK,      0.000000000000000_REALK,     -2.076588356777899_REALK, &
      0.343313460449035_REALK,      0.000000000000000_REALK,      0.759037508025847_REALK, &
      0.000000000000000_REALK,     -0.422215674472388_REALK,      0.000000000000000_REALK, &
     -0.677616295721086_REALK,      0.000000000000000_REALK,     -4.795310419337999_REALK, &
    -13.589646339892184_REALK,      3.490742594915415_REALK,      0.000000000000000_REALK, &
     -1.928872930141763_REALK,      0.000000000000000_REALK,     -8.581347046903586_REALK, &
      0.814587534520515_REALK,      0.000000000000000_REALK,      2.737730773922928_REALK, &
      0.000000000000000_REALK,     -1.726429593815290_REALK,      0.000000000000000_REALK, &
     -2.204301192096897_REALK,      0.000000000000000_REALK,    -13.729376633148739_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.906754836532760_REALK, &
      0.000000000000000_REALK,     -0.305836470128077_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.269712632296231_REALK,      0.000000000000000_REALK, &
      2.652839592270003_REALK,      0.000000000000000_REALK,     -0.253735663187621_REALK, &
      0.000000000000000_REALK,     -0.706245321578474_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     10.364455669143632_REALK, &
      0.000000000000000_REALK,     -1.877298528112319_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.890914007019544_REALK,      0.000000000000000_REALK, &
     11.380135846850335_REALK,      0.000000000000000_REALK,     -0.992361404969582_REALK, &
      0.000000000000000_REALK,     -3.003507305372283_REALK,      0.000000000000000_REALK, &
     -2.057758067558845_REALK,      0.010716182502463_REALK,      0.000000000000000_REALK, &
     -0.221944566774452_REALK,      0.000000000000000_REALK,     -2.260725717762436_REALK, &
      0.027147189754838_REALK,      0.000000000000000_REALK,      0.014909265038089_REALK, &
      0.000000000000000_REALK,     -0.132845171774627_REALK,      0.000000000000000_REALK, &
     -0.512520013942667_REALK,      0.000000000000000_REALK,     -6.712103669491391_REALK, &
    -15.388832848322707_REALK,      0.889612627295872_REALK,      0.000000000000000_REALK, &
     -0.199224548458664_REALK,      0.000000000000000_REALK,    -13.604451272792467_REALK, &
      1.815899084458656_REALK,      0.000000000000000_REALK,      0.976791533764837_REALK, &
      0.000000000000000_REALK,      3.240036852976371_REALK,      0.000000000000000_REALK, &
     -0.318741200583997_REALK,      0.000000000000000_REALK,    -27.984712648347369_REALK/
    ! results of test 7, ket-major order, 02ODGXZZ
  data REF_CONTR_INTS(61741:63000)                                                         &
    /-3.068942879763788_REALK,     -2.327389751846186_REALK,      0.000000000000000_REALK, &
     -2.394191065121737_REALK,      0.000000000000000_REALK,     -1.822217238202401_REALK, &
     -2.963047671325440_REALK,      0.000000000000000_REALK,     -1.697702806260671_REALK, &
      0.000000000000000_REALK,     -5.174394066252283_REALK,      0.000000000000000_REALK, &
     -2.610003762535846_REALK,      0.000000000000000_REALK,     -3.310786899418516_REALK, &
     -2.724744186877442_REALK,     -1.609269548538955_REALK,      0.000000000000000_REALK, &
     -1.087156500032463_REALK,      0.000000000000000_REALK,     -1.328744688447232_REALK, &
     -0.206351554376435_REALK,      0.000000000000000_REALK,     -1.112891733278457_REALK, &
      0.000000000000000_REALK,      3.101068734660924_REALK,      0.000000000000000_REALK, &
     -1.126884161454607_REALK,      0.000000000000000_REALK,     -2.295501067821440_REALK, &
     -1.630842673956035_REALK,     -0.628264496969195_REALK,      0.000000000000000_REALK, &
     -0.231424034826579_REALK,      0.000000000000000_REALK,     -0.851630929880505_REALK, &
      0.206743639193152_REALK,      0.000000000000000_REALK,     -0.398532580386236_REALK, &
      0.000000000000000_REALK,      1.166036298047718_REALK,      0.000000000000000_REALK, &
     -0.208017464415625_REALK,      0.000000000000000_REALK,     -1.275826189102154_REALK, &
     -0.344902884310163_REALK,      0.173125716978788_REALK,      0.000000000000000_REALK, &
      0.679762723229105_REALK,      0.000000000000000_REALK,     -0.279973442221082_REALK, &
      1.427402913107229_REALK,      0.000000000000000_REALK,      0.127735207968027_REALK, &
      0.000000000000000_REALK,      3.015547681659216_REALK,      0.000000000000000_REALK, &
      0.615695677339452_REALK,      0.000000000000000_REALK,     -0.422643647689570_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.317696591729078_REALK, &
      0.000000000000000_REALK,      1.030795548764400_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.098235277920395_REALK,      0.000000000000000_REALK, &
      1.393110240992673_REALK,      0.000000000000000_REALK,      1.617114770349404_REALK, &
      0.000000000000000_REALK,      1.544232261395293_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.034869546279925_REALK, &
      0.000000000000000_REALK,      0.817539342594290_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.624719650218595_REALK,      0.000000000000000_REALK, &
      1.272575011006212_REALK,      0.000000000000000_REALK,      0.137300541193925_REALK, &
      0.000000000000000_REALK,      1.234144950116151_REALK,      0.000000000000000_REALK, &
     -1.266706628773981_REALK,     -0.246820511396196_REALK,      0.000000000000000_REALK, &
     -0.008619331470285_REALK,      0.000000000000000_REALK,     -0.576880632728238_REALK, &
      0.179436421068978_REALK,      0.000000000000000_REALK,     -0.134951964167279_REALK, &
      0.000000000000000_REALK,      0.408022665645467_REALK,      0.000000000000000_REALK, &
     -0.006378369011476_REALK,      0.000000000000000_REALK,     -0.711493221912451_REALK, &
     -0.787051846825268_REALK,     -0.010023324203466_REALK,      0.000000000000000_REALK, &
      0.092136567780745_REALK,      0.000000000000000_REALK,     -0.289093012199442_REALK, &
      0.101695210004905_REALK,      0.000000000000000_REALK,     -0.004940944772380_REALK, &
      0.000000000000000_REALK,      0.017231411972962_REALK,      0.000000000000000_REALK, &
      0.062018379622300_REALK,      0.000000000000000_REALK,     -0.324320744893321_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.700054001472689_REALK, &
      0.000000000000000_REALK,      0.274324619857245_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.104012740608798_REALK,      0.000000000000000_REALK, &
      0.637937679135683_REALK,      0.000000000000000_REALK,     -0.105309892674673_REALK, &
      0.000000000000000_REALK,      0.338337078000133_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.361506596702488_REALK, &
      0.000000000000000_REALK,     -0.123945650377590_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.432668179825258_REALK,      0.000000000000000_REALK, &
      0.297004615252050_REALK,      0.000000000000000_REALK,     -0.932299894261783_REALK, &
      0.000000000000000_REALK,     -0.139049177809303_REALK,      0.000000000000000_REALK, &
     -1.263361897106447_REALK,     -0.847330132448344_REALK,      0.000000000000000_REALK, &
     -0.755955698370636_REALK,      0.000000000000000_REALK,     -0.958928971150057_REALK, &
     -0.808588546233497_REALK,      0.000000000000000_REALK,     -0.772145887343972_REALK, &
      0.000000000000000_REALK,     -1.109049091668189_REALK,      0.000000000000000_REALK, &
     -0.932354676067240_REALK,      0.000000000000000_REALK,     -1.655767232224311_REALK, &
     -2.017070420365343_REALK,     -1.055621072724008_REALK,      0.000000000000000_REALK, &
     -0.606185910539137_REALK,      0.000000000000000_REALK,     -1.234821157788499_REALK, &
     -0.096485288810378_REALK,      0.000000000000000_REALK,     -0.867271395366469_REALK, &
      0.000000000000000_REALK,      1.122861885674356_REALK,      0.000000000000000_REALK, &
     -0.680053331466407_REALK,      0.000000000000000_REALK,     -1.939408222011260_REALK, &
     -1.157370100693947_REALK,      0.009515860792385_REALK,      0.000000000000000_REALK, &
      0.147466871117380_REALK,      0.000000000000000_REALK,     -0.458063809696877_REALK, &
      0.285102320541471_REALK,      0.000000000000000_REALK,      0.004451716612439_REALK, &
      0.000000000000000_REALK,      0.455575569157190_REALK,      0.000000000000000_REALK, &
      0.089619242998976_REALK,      0.000000000000000_REALK,     -0.463961064149626_REALK, &
     -0.258725022517772_REALK,      0.274422132971290_REALK,      0.000000000000000_REALK, &
      0.422043358252437_REALK,      0.000000000000000_REALK,     -0.159503958637096_REALK, &
      0.621615733283054_REALK,      0.000000000000000_REALK,      0.150252684039112_REALK, &
      0.000000000000000_REALK,      0.988128418659659_REALK,      0.000000000000000_REALK, &
      0.257456008663666_REALK,      0.000000000000000_REALK,     -0.162168379756056_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.545455816831067_REALK, &
      0.000000000000000_REALK,      0.107042982313077_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.003812647297981_REALK,      0.000000000000000_REALK, &
      0.425292532491578_REALK,      0.000000000000000_REALK,     -0.086496073782809_REALK, &
      0.000000000000000_REALK,      0.108421086609287_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.291832531020999_REALK, &
      0.000000000000000_REALK,      0.004889607315642_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.050925023812697_REALK,      0.000000000000000_REALK, &
      0.266308822597896_REALK,      0.000000000000000_REALK,     -0.061391810633100_REALK, &
      0.000000000000000_REALK,      0.004971285369946_REALK,      0.000000000000000_REALK, &
     -0.767104928257635_REALK,     -0.259381145963338_REALK,      0.000000000000000_REALK, &
     -0.082502200112636_REALK,      0.000000000000000_REALK,     -0.506007838610796_REALK, &
      0.062948612260341_REALK,      0.000000000000000_REALK,     -0.202239780094747_REALK, &
      0.000000000000000_REALK,      0.281050658573837_REALK,      0.000000000000000_REALK, &
     -0.083564358826502_REALK,      0.000000000000000_REALK,     -0.717531274944825_REALK, &
     -0.286052270024334_REALK,      0.125120190846334_REALK,      0.000000000000000_REALK, &
      0.428172666317827_REALK,      0.000000000000000_REALK,     -0.293918674751008_REALK, &
      0.765537484290944_REALK,      0.000000000000000_REALK,      0.114177163837550_REALK, &
      0.000000000000000_REALK,      1.279278192733025_REALK,      0.000000000000000_REALK, &
      0.435325042374486_REALK,      0.000000000000000_REALK,     -0.418359782041583_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.906692573068289_REALK, &
      0.000000000000000_REALK,      0.612460878743670_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.557311677965351_REALK,      0.000000000000000_REALK, &
      0.989728949934956_REALK,      0.000000000000000_REALK,      0.649624103979624_REALK, &
      0.000000000000000_REALK,      0.868484244009491_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.246522636759856_REALK, &
      0.000000000000000_REALK,      0.858260262923004_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.558410785798380_REALK,      0.000000000000000_REALK, &
      1.592502262876782_REALK,      0.000000000000000_REALK,      0.097077770907156_REALK, &
      0.000000000000000_REALK,      1.221635803970594_REALK,      0.000000000000000_REALK, &
     -1.288265360572739_REALK,      0.229721507810099_REALK,      0.000000000000000_REALK, &
      0.209229198103496_REALK,      0.000000000000000_REALK,     -0.433448954440025_REALK, &
      0.268701604669540_REALK,      0.000000000000000_REALK,      0.090391724162118_REALK, &
      0.000000000000000_REALK,      0.284009390221279_REALK,      0.000000000000000_REALK, &
      0.103476912200397_REALK,      0.000000000000000_REALK,     -0.357279320226283_REALK, &
     -0.954902620895236_REALK,      0.442387684093639_REALK,      0.000000000000000_REALK, &
      0.227270338413950_REALK,      0.000000000000000_REALK,     -0.252478565482527_REALK, &
      0.086393752942157_REALK,      0.000000000000000_REALK,      0.146743040784833_REALK, &
      0.000000000000000_REALK,     -0.174256837615538_REALK,      0.000000000000000_REALK, &
      0.095704738031623_REALK,      0.000000000000000_REALK,     -0.177200092312488_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.512823592864569_REALK, &
      0.000000000000000_REALK,     -0.004173710280888_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.064962614325899_REALK,      0.000000000000000_REALK, &
      0.336313080360766_REALK,      0.000000000000000_REALK,     -0.132195511997771_REALK, &
      0.000000000000000_REALK,     -0.003440267548698_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.337065022086164_REALK, &
      0.000000000000000_REALK,     -0.232662523001202_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.295837877300379_REALK,      0.000000000000000_REALK, &
      0.186344647698424_REALK,      0.000000000000000_REALK,     -0.405337582322932_REALK, &
      0.000000000000000_REALK,     -0.163292358995609_REALK,      0.000000000000000_REALK, &
     -0.711051679027955_REALK,     -0.119839563001183_REALK,      0.000000000000000_REALK, &
     -0.003574550361207_REALK,      0.000000000000000_REALK,     -0.398733335874307_REALK, &
      0.062698711725576_REALK,      0.000000000000000_REALK,     -0.078591572507195_REALK, &
      0.000000000000000_REALK,      0.113088186039025_REALK,      0.000000000000000_REALK, &
     -0.002946397517134_REALK,      0.000000000000000_REALK,     -0.460129948929013_REALK, &
     -0.935783903888437_REALK,     -0.010332756703484_REALK,      0.000000000000000_REALK, &
      0.078856125598889_REALK,      0.000000000000000_REALK,     -0.412372550675882_REALK, &
      0.070544179705084_REALK,      0.000000000000000_REALK,     -0.005712410904422_REALK, &
      0.000000000000000_REALK,      0.009226278633797_REALK,      0.000000000000000_REALK, &
      0.055344550571344_REALK,      0.000000000000000_REALK,     -0.405188596783052_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.566499147762278_REALK, &
      0.000000000000000_REALK,      0.189610058966322_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.060573589244656_REALK,      0.000000000000000_REALK, &
      0.520119406515668_REALK,      0.000000000000000_REALK,     -0.048646418190615_REALK, &
      0.000000000000000_REALK,      0.218806051310702_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.621111259200081_REALK, &
      0.000000000000000_REALK,     -0.176800482317180_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.500223852378632_REALK,      0.000000000000000_REALK, &
      0.480729389496272_REALK,      0.000000000000000_REALK,     -0.831974633324301_REALK, &
      0.000000000000000_REALK,     -0.173720436103835_REALK,      0.000000000000000_REALK, &
     -1.181956918505199_REALK,     -0.685678243243370_REALK,      0.000000000000000_REALK, &
     -0.522507985679791_REALK,      0.000000000000000_REALK,     -0.927921126446665_REALK, &
     -0.470895297833724_REALK,      0.000000000000000_REALK,     -0.629541213513182_REALK, &
      0.000000000000000_REALK,     -0.512309570705576_REALK,      0.000000000000000_REALK, &
     -0.602963311905358_REALK,      0.000000000000000_REALK,     -1.376744935227242_REALK, &
     -3.997072619805065_REALK,     -1.813682349640054_REALK,      0.000000000000000_REALK, &
     -0.864685134417400_REALK,      0.000000000000000_REALK,     -2.465949921197992_REALK, &
     -0.111550248243549_REALK,      0.000000000000000_REALK,     -1.403758820610530_REALK, &
      0.000000000000000_REALK,      1.002030152912836_REALK,      0.000000000000000_REALK, &
     -0.849621430183719_REALK,      0.000000000000000_REALK,     -3.115273548510765_REALK, &
     -1.659054184895284_REALK,      0.605868251709324_REALK,      0.000000000000000_REALK, &
      0.307926129921455_REALK,      0.000000000000000_REALK,     -0.474956715767564_REALK, &
      0.330547670192549_REALK,      0.000000000000000_REALK,      0.198753147305520_REALK, &
      0.000000000000000_REALK,      0.278273904938454_REALK,      0.000000000000000_REALK, &
      0.122779609877082_REALK,      0.000000000000000_REALK,     -0.315633061546917_REALK, &
     -0.460555418169762_REALK,      0.832369324296796_REALK,      0.000000000000000_REALK, &
      0.616208095028590_REALK,      0.000000000000000_REALK,     -0.215886710469374_REALK, &
      0.701207222422547_REALK,      0.000000000000000_REALK,      0.333684668970421_REALK, &
      0.000000000000000_REALK,      0.861010495780793_REALK,      0.000000000000000_REALK, &
      0.252284524733661_REALK,      0.000000000000000_REALK,     -0.147311913476655_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.587660905920843_REALK, &
      0.000000000000000_REALK,     -0.103039770140006_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.093056550611021_REALK,      0.000000000000000_REALK, &
      0.321300475999133_REALK,      0.000000000000000_REALK,     -0.122131074006890_REALK, &
      0.000000000000000_REALK,     -0.068475204225340_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.346069004231910_REALK, &
      0.000000000000000_REALK,     -0.211375910380754_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.124882370829382_REALK,      0.000000000000000_REALK, &
      0.231223323884516_REALK,      0.000000000000000_REALK,     -0.050949922675605_REALK, &
      0.000000000000000_REALK,     -0.144233935258725_REALK,      0.000000000000000_REALK, &
     -0.803484970558993_REALK,      0.005658627941291_REALK,      0.000000000000000_REALK, &
      0.074052496618266_REALK,      0.000000000000000_REALK,     -0.383371628505495_REALK, &
      0.118883121762916_REALK,      0.000000000000000_REALK,      0.003093824742672_REALK, &
      0.000000000000000_REALK,      0.150099264999851_REALK,      0.000000000000000_REALK, &
      0.049211676447280_REALK,      0.000000000000000_REALK,     -0.356678113010383_REALK, &
     -0.343575460653136_REALK,      0.318907418945558_REALK,      0.000000000000000_REALK, &
      0.426139463275594_REALK,      0.000000000000000_REALK,     -0.268420017338951_REALK, &
      0.528913398728615_REALK,      0.000000000000000_REALK,      0.213075521119509_REALK, &
      0.000000000000000_REALK,      0.669615232461859_REALK,      0.000000000000000_REALK, &
      0.290779453754046_REALK,      0.000000000000000_REALK,     -0.256421772313521_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.540594206031607_REALK, &
      0.000000000000000_REALK,      0.089588484356810_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.002649688552190_REALK,      0.000000000000000_REALK, &
      0.413793811292280_REALK,      0.000000000000000_REALK,     -0.047496683240320_REALK, &
      0.000000000000000_REALK,      0.083350590319933_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.565233558390332_REALK, &
      0.000000000000000_REALK,      0.008228438288679_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.072217518484324_REALK,      0.000000000000000_REALK, &
      0.528718991765885_REALK,      0.000000000000000_REALK,     -0.069337970605244_REALK, &
      0.000000000000000_REALK,      0.007860631074661_REALK,      0.000000000000000_REALK, &
     -0.887583093669551_REALK,     -0.257069299354537_REALK,      0.000000000000000_REALK, &
     -0.069049337980658_REALK,      0.000000000000000_REALK,     -0.592897022260706_REALK, &
      0.043747612681299_REALK,      0.000000000000000_REALK,     -0.196771781789926_REALK, &
      0.000000000000000_REALK,      0.154330405080398_REALK,      0.000000000000000_REALK, &
     -0.064241549828731_REALK,      0.000000000000000_REALK,     -0.709218783501954_REALK, &
     -0.633108074150648_REALK,      0.242338064406748_REALK,      0.000000000000000_REALK, &
      0.720547098010183_REALK,      0.000000000000000_REALK,     -0.692466312597096_REALK, &
      1.085619863931017_REALK,      0.000000000000000_REALK,      0.226682820185900_REALK, &
      0.000000000000000_REALK,      1.444859710259580_REALK,      0.000000000000000_REALK, &
      0.688338991029205_REALK,      0.000000000000000_REALK,     -0.850517232621833_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.258055796893584_REALK, &
      0.000000000000000_REALK,      0.717629656203017_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.542243528123892_REALK,      0.000000000000000_REALK, &
      1.238103573242769_REALK,      0.000000000000000_REALK,      0.499409794220983_REALK, &
      0.000000000000000_REALK,      0.858422985220246_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.380044686501539_REALK, &
      0.000000000000000_REALK,      2.022043410539935_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.108646663592915_REALK,      0.000000000000000_REALK, &
      4.065031204531760_REALK,      0.000000000000000_REALK,      0.153500047948338_REALK, &
      0.000000000000000_REALK,      2.483561632512620_REALK,      0.000000000000000_REALK, &
     -5.624788948556959_REALK,      0.070262902707407_REALK,      0.000000000000000_REALK, &
     -3.243220583375279_REALK,      0.000000000000000_REALK,     -7.619850043854588_REALK, &
     -0.101708055714981_REALK,      0.000000000000000_REALK,     -0.113658646064327_REALK, &
      0.000000000000000_REALK,    -13.085892629253031_REALK,      0.000000000000000_REALK, &
    -13.011212183721609_REALK,      0.000000000000000_REALK,    -50.949091692447688_REALK, &
     -3.951033887345727_REALK,      0.104971785511684_REALK,      0.000000000000000_REALK, &
     -1.366726113180304_REALK,      0.000000000000000_REALK,     -5.441362977041340_REALK, &
     -0.000426999081614_REALK,      0.000000000000000_REALK,      0.008763525060941_REALK, &
      0.000000000000000_REALK,     10.085877363693687_REALK,      0.000000000000000_REALK, &
     -6.384772339370107_REALK,      0.000000000000000_REALK,    -42.366283789714522_REALK, &
     -2.123542349882954_REALK,      0.126674530543938_REALK,      0.000000000000000_REALK, &
      0.235906104830938_REALK,      0.000000000000000_REALK,     -2.760720366547775_REALK, &
      0.590536385177755_REALK,      0.000000000000000_REALK,      0.192643970412795_REALK, &
      0.000000000000000_REALK,      7.112861492676824_REALK,      0.000000000000000_REALK, &
      0.882884008784008_REALK,      0.000000000000000_REALK,    -17.220098833362250_REALK, &
     -0.467014995125689_REALK,      0.239694932431814_REALK,      0.000000000000000_REALK, &
      1.414027704933924_REALK,      0.000000000000000_REALK,     -0.960582135521519_REALK, &
      1.235597268629285_REALK,      0.000000000000000_REALK,      0.609823017938723_REALK, &
      0.000000000000000_REALK,     15.263041006329390_REALK,      0.000000000000000_REALK, &
      6.311120531536140_REALK,      0.000000000000000_REALK,     -7.145486631984557_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.923594943341201_REALK, &
      0.000000000000000_REALK,      1.298807174634074_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.597830029948230_REALK,      0.000000000000000_REALK, &
      2.340973045573601_REALK,      0.000000000000000_REALK,      4.349727235919725_REALK, &
      0.000000000000000_REALK,      8.101359407380491_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.590787090508232_REALK, &
      0.000000000000000_REALK,      1.090253479607757_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.377528508476903_REALK,      0.000000000000000_REALK, &
      2.505097923416021_REALK,      0.000000000000000_REALK,     -0.237095955327955_REALK, &
      0.000000000000000_REALK,      8.110073439771307_REALK,      0.000000000000000_REALK, &
     -1.074695618921123_REALK,      0.558278189286068_REALK,      0.000000000000000_REALK, &
      0.270940102028119_REALK,      0.000000000000000_REALK,     -1.236326688641611_REALK, &
      0.747239146438329_REALK,      0.000000000000000_REALK,      0.723305261108151_REALK, &
      0.000000000000000_REALK,      1.984976683939541_REALK,      0.000000000000000_REALK, &
      0.870698558276774_REALK,      0.000000000000000_REALK,     -6.621807165135144_REALK, &
     -0.544249606521146_REALK,      0.503847337481295_REALK,      0.000000000000000_REALK, &
      0.125907031267215_REALK,      0.000000000000000_REALK,     -0.585154546893624_REALK, &
      0.235358637447388_REALK,      0.000000000000000_REALK,      0.709262779359656_REALK, &
      0.000000000000000_REALK,     -2.012509072048581_REALK,      0.000000000000000_REALK, &
      0.445769292438582_REALK,      0.000000000000000_REALK,     -3.452864198166377_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.761281326684207_REALK, &
      0.000000000000000_REALK,     -0.225990037060070_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.084281625031207_REALK,      0.000000000000000_REALK, &
      1.643860233546058_REALK,      0.000000000000000_REALK,     -2.226255828451831_REALK, &
      0.000000000000000_REALK,     -1.210410209859447_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.415603014030997_REALK, &
      0.000000000000000_REALK,     -0.880746986656877_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.861212457316140_REALK,      0.000000000000000_REALK, &
      0.975069652100782_REALK,      0.000000000000000_REALK,     -6.318070342383357_REALK, &
      0.000000000000000_REALK,     -5.197088109482463_REALK,      0.000000000000000_REALK, &
     -1.432299269312805_REALK,     -0.358152046470688_REALK,      0.000000000000000_REALK, &
     -0.701312531786616_REALK,      0.000000000000000_REALK,     -2.746188132398796_REALK, &
     -0.415232438506541_REALK,      0.000000000000000_REALK,     -0.773369694119043_REALK, &
      0.000000000000000_REALK,     -2.266687908908400_REALK,      0.000000000000000_REALK, &
     -3.756253416389590_REALK,      0.000000000000000_REALK,    -20.592145900102327_REALK, &
     -2.019067555393322_REALK,     -0.471706286664141_REALK,      0.000000000000000_REALK, &
     -0.545251796729504_REALK,      0.000000000000000_REALK,     -3.618029137022114_REALK, &
      0.032353999466083_REALK,      0.000000000000000_REALK,     -1.106696701667931_REALK, &
      0.000000000000000_REALK,      3.049478223363482_REALK,      0.000000000000000_REALK, &
     -3.217407124165184_REALK,      0.000000000000000_REALK,    -29.888836510031428_REALK, &
     -0.415972647950801_REALK,      1.030007883357799_REALK,      0.000000000000000_REALK, &
      0.199758831006197_REALK,      0.000000000000000_REALK,     -0.402802213934542_REALK, &
      0.950800423452898_REALK,      0.000000000000000_REALK,      1.162560441429461_REALK, &
      0.000000000000000_REALK,      0.851847870123739_REALK,      0.000000000000000_REALK, &
      0.514461795074635_REALK,      0.000000000000000_REALK,     -1.728971121468404_REALK, &
     -0.058786585044228_REALK,      0.841445713870185_REALK,      0.000000000000000_REALK, &
      0.360152772311091_REALK,      0.000000000000000_REALK,     -0.098439709935760_REALK, &
      1.215011175294274_REALK,      0.000000000000000_REALK,      1.281515097387174_REALK, &
      0.000000000000000_REALK,      2.867853592669494_REALK,      0.000000000000000_REALK, &
      1.022859766798187_REALK,      0.000000000000000_REALK,     -0.465959756015239_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.545391343493370_REALK, &
      0.000000000000000_REALK,     -0.562706773849471_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.134903518973264_REALK,      0.000000000000000_REALK, &
      1.025963670259285_REALK,      0.000000000000000_REALK,     -1.497156760582723_REALK, &
      0.000000000000000_REALK,     -2.415338665438646_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.311171356768056_REALK, &
      0.000000000000000_REALK,     -0.641950175145955_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.101970990467395_REALK,      0.000000000000000_REALK, &
      0.789852482458611_REALK,      0.000000000000000_REALK,     -0.604997566108226_REALK, &
      0.000000000000000_REALK,     -3.038641084783276_REALK,      0.000000000000000_REALK, &
     -0.792409338497688_REALK,      0.099692913742507_REALK,      0.000000000000000_REALK, &
      0.065568223910665_REALK,      0.000000000000000_REALK,     -1.278867082013150_REALK, &
      0.344929645900969_REALK,      0.000000000000000_REALK,      0.187537460765269_REALK, &
      0.000000000000000_REALK,      1.360445855128170_REALK,      0.000000000000000_REALK, &
      0.281442260508371_REALK,      0.000000000000000_REALK,     -7.685096673026916_REALK, &
     -0.316219719678622_REALK,      0.468360429329826_REALK,      0.000000000000000_REALK, &
      0.779479064601569_REALK,      0.000000000000000_REALK,     -0.882530639082352_REALK, &
      1.445276517660241_REALK,      0.000000000000000_REALK,      1.188848651218531_REALK, &
      0.000000000000000_REALK,      5.353876957612567_REALK,      0.000000000000000_REALK, &
      3.689627641098856_REALK,      0.000000000000000_REALK,     -5.848384418682253_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.211449407971729_REALK, &
      0.000000000000000_REALK,      0.601655191756734_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.581983051665080_REALK,      0.000000000000000_REALK, &
      3.190487590369524_REALK,      0.000000000000000_REALK,      1.386588785947269_REALK, &
      0.000000000000000_REALK,      3.615526881183341_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.923982375887094_REALK, &
      0.000000000000000_REALK,      1.001665619772955_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.735991008696902_REALK,      0.000000000000000_REALK, &
      6.837156158004900_REALK,      0.000000000000000_REALK,     -0.138611802135529_REALK, &
      0.000000000000000_REALK,      6.637872209741166_REALK,      0.000000000000000_REALK, &
      0.489322146384909_REALK,      1.601208425967197_REALK,      0.000000000000000_REALK, &
      0.014278520567097_REALK,      0.000000000000000_REALK,      0.386627118722835_REALK, &
      1.117816130414478_REALK,      0.000000000000000_REALK,      1.534928300046790_REALK, &
      0.000000000000000_REALK,     -0.362239223498403_REALK,      0.000000000000000_REALK, &
      0.027980862128367_REALK,      0.000000000000000_REALK,      1.262754551873346_REALK, &
      0.355235961022214_REALK,      1.804802671666163_REALK,      0.000000000000000_REALK, &
     -0.350111052671559_REALK,      0.000000000000000_REALK,      0.241327758116992_REALK, &
      0.653165015935572_REALK,      0.000000000000000_REALK,      1.690769115032696_REALK, &
      0.000000000000000_REALK,     -2.655844626951984_REALK,      0.000000000000000_REALK, &
     -0.639727663222891_REALK,      0.000000000000000_REALK,      0.734928920376163_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.247774537948345_REALK, &
      0.000000000000000_REALK,     -0.821597941296678_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.117790710248112_REALK,      0.000000000000000_REALK, &
      0.395863674127042_REALK,      0.000000000000000_REALK,     -1.316773409266107_REALK, &
      0.000000000000000_REALK,     -2.683403439493068_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.111978685755491_REALK, &
      0.000000000000000_REALK,     -1.301411463878329_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.383801249017717_REALK,      0.000000000000000_REALK, &
      0.174839154061599_REALK,      0.000000000000000_REALK,     -2.254553177200494_REALK, &
      0.000000000000000_REALK,     -3.963261124936955_REALK,      0.000000000000000_REALK, &
     -0.550591615126168_REALK,      0.346136158312213_REALK,      0.000000000000000_REALK, &
      0.095338228888839_REALK,      0.000000000000000_REALK,     -0.725063067081280_REALK, &
      0.342787666392638_REALK,      0.000000000000000_REALK,      0.553013770148805_REALK, &
      0.000000000000000_REALK,      0.425924423539031_REALK,      0.000000000000000_REALK, &
      0.311382147467075_REALK,      0.000000000000000_REALK,     -3.315358136095704_REALK, &
     -0.708431370283218_REALK,      0.730241251018128_REALK,      0.000000000000000_REALK, &
      0.103554157300109_REALK,      0.000000000000000_REALK,     -0.802115462814431_REALK, &
      0.227009438695451_REALK,      0.000000000000000_REALK,      1.140170218354549_REALK, &
      0.000000000000000_REALK,     -0.854249134086929_REALK,      0.000000000000000_REALK, &
      0.315359267491051_REALK,      0.000000000000000_REALK,     -3.419817918933469_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.786665736635325_REALK, &
      0.000000000000000_REALK,     -0.132535381550827_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.064438767030904_REALK,      0.000000000000000_REALK, &
      1.759572827579780_REALK,      0.000000000000000_REALK,     -0.796161098562502_REALK, &
      0.000000000000000_REALK,     -0.606019359548796_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.003910120904320_REALK, &
      0.000000000000000_REALK,     -1.207306310059529_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.384435817137219_REALK,      0.000000000000000_REALK, &
      2.194452570612128_REALK,      0.000000000000000_REALK,     -4.469715767614196_REALK, &
      0.000000000000000_REALK,     -5.147348410783861_REALK,      0.000000000000000_REALK, &
     -1.223000500716423_REALK,     -0.370094383756225_REALK,      0.000000000000000_REALK, &
     -0.411295671242397_REALK,      0.000000000000000_REALK,     -2.254762799908367_REALK, &
     -0.317472122288696_REALK,      0.000000000000000_REALK,     -0.827807785404054_REALK, &
      0.000000000000000_REALK,     -0.810620555190114_REALK,      0.000000000000000_REALK, &
     -1.880653576086182_REALK,      0.000000000000000_REALK,    -13.255618480906822_REALK, &
     -4.380253649009311_REALK,     -1.139430416260181_REALK,      0.000000000000000_REALK, &
     -0.747417754174255_REALK,      0.000000000000000_REALK,     -6.943307513501439_REALK, &
      0.052010436342354_REALK,      0.000000000000000_REALK,     -2.490687118228696_REALK, &
      0.000000000000000_REALK,      2.157351874753287_REALK,      0.000000000000000_REALK, &
     -3.186614330667087_REALK,      0.000000000000000_REALK,    -38.060716936152744_REALK, &
      2.675305769777078_REALK,      2.473557569567987_REALK,      0.000000000000000_REALK, &
     -0.248511718749873_REALK,      0.000000000000000_REALK,      1.703971156361408_REALK, &
      1.509340932436663_REALK,      0.000000000000000_REALK,      1.949321500343940_REALK, &
      0.000000000000000_REALK,     -1.160306922087335_REALK,      0.000000000000000_REALK, &
     -0.356647030668182_REALK,      0.000000000000000_REALK,      4.075704868953553_REALK, &
      1.105189781070889_REALK,      2.752057428649975_REALK,      0.000000000000000_REALK, &
     -0.581233963437244_REALK,      0.000000000000000_REALK,      1.224510895551985_REALK, &
      2.463371482750232_REALK,      0.000000000000000_REALK,      2.793769469595424_REALK, &
      0.000000000000000_REALK,     -0.129519904421265_REALK,      0.000000000000000_REALK, &
     -0.828258379442878_REALK,      0.000000000000000_REALK,      2.908213312135364_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.313401390068775_REALK, &
      0.000000000000000_REALK,     -1.150785851499927_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.009121227065179_REALK,      0.000000000000000_REALK, &
     -0.411633885417270_REALK,      0.000000000000000_REALK,     -1.202731075599482_REALK, &
      0.000000000000000_REALK,     -2.752548645304838_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.236835166634712_REALK, &
      0.000000000000000_REALK,     -1.687934137411406_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.348801068721744_REALK,      0.000000000000000_REALK, &
     -0.400708000604953_REALK,      0.000000000000000_REALK,     -0.929199485656602_REALK, &
      0.000000000000000_REALK,     -4.008843487027326_REALK,      0.000000000000000_REALK, &
     -0.279585413055741_REALK,      0.665990367490523_REALK,      0.000000000000000_REALK, &
      0.088311540537446_REALK,      0.000000000000000_REALK,     -0.296791918745840_REALK, &
      0.429243002027775_REALK,      0.000000000000000_REALK,      0.874738311021654_REALK, &
      0.000000000000000_REALK,      0.209854416443332_REALK,      0.000000000000000_REALK, &
      0.211231143443673_REALK,      0.000000000000000_REALK,     -0.993849437706503_REALK, &
     -0.094522531491085_REALK,      1.277184205053313_REALK,      0.000000000000000_REALK, &
      0.383157714698149_REALK,      0.000000000000000_REALK,     -0.174545994525691_REALK, &
      1.229258328045046_REALK,      0.000000000000000_REALK,      2.160903452317498_REALK, &
      0.000000000000000_REALK,      1.530852362925934_REALK,      0.000000000000000_REALK, &
      0.909999552131560_REALK,      0.000000000000000_REALK,     -0.580365418866263_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.587738836999956_REALK, &
      0.000000000000000_REALK,     -0.414612475613667_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.101504637636263_REALK,      0.000000000000000_REALK, &
      1.080743481847858_REALK,      0.000000000000000_REALK,     -0.614712574344679_REALK, &
      0.000000000000000_REALK,     -1.388388125579714_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.787183168559668_REALK, &
      0.000000000000000_REALK,     -1.138258451085584_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.171944494283750_REALK,      0.000000000000000_REALK, &
      1.864599912638391_REALK,      0.000000000000000_REALK,     -0.538243395692964_REALK, &
      0.000000000000000_REALK,     -3.784709265528944_REALK,      0.000000000000000_REALK, &
     -0.887662900050848_REALK,      0.107433676531887_REALK,      0.000000000000000_REALK, &
      0.048311847129931_REALK,      0.000000000000000_REALK,     -1.319209186905216_REALK, &
      0.259533324139017_REALK,      0.000000000000000_REALK,      0.197550745898382_REALK, &
      0.000000000000000_REALK,      0.558580902067254_REALK,      0.000000000000000_REALK, &
      0.161779007688419_REALK,      0.000000000000000_REALK,     -5.679716534576967_REALK, &
     -0.847412392610126_REALK,      1.184830926011720_REALK,      0.000000000000000_REALK, &
      1.382114480341556_REALK,      0.000000000000000_REALK,     -2.190773047563502_REALK, &
      2.437039581455566_REALK,      0.000000000000000_REALK,      2.806507721925784_REALK, &
      0.000000000000000_REALK,      4.763141333484651_REALK,      0.000000000000000_REALK, &
      4.595530544738391_REALK,      0.000000000000000_REALK,     -9.365554569651353_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.827719168021490_REALK, &
      0.000000000000000_REALK,      0.620634519003548_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.613057175283803_REALK,      0.000000000000000_REALK, &
      4.321078653654239_REALK,      0.000000000000000_REALK,      0.797040776524629_REALK, &
      0.000000000000000_REALK,      2.672076706639054_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.814049924414300_REALK, &
      0.000000000000000_REALK,      2.486510887317548_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.737449461761735_REALK,      0.000000000000000_REALK, &
     20.751984800476613_REALK,      0.000000000000000_REALK,     -0.172644730725550_REALK, &
      0.000000000000000_REALK,     10.629833806429321_REALK,      0.000000000000000_REALK/
    ! results of test 7, ket-major order, 02ODGYZZ
  data REF_CONTR_INTS(63001:64260)                                                         &
    /-1.750560536214828_REALK,     -0.933045298642840_REALK,      0.000000000000000_REALK, &
     -0.756363762796393_REALK,      0.000000000000000_REALK,     -0.914147956192702_REALK, &
     -0.772504696004752_REALK,      0.000000000000000_REALK,     -0.591866884535431_REALK, &
      0.000000000000000_REALK,     -1.199245874280125_REALK,      0.000000000000000_REALK, &
     -0.679864009071785_REALK,      0.000000000000000_REALK,     -1.369482791552092_REALK, &
     -0.796486111683692_REALK,     -0.773956939436353_REALK,      0.000000000000000_REALK, &
     -1.046300931474342_REALK,      0.000000000000000_REALK,     -0.646544196971206_REALK, &
     -1.940880596351309_REALK,      0.000000000000000_REALK,     -0.571039082710704_REALK, &
      0.000000000000000_REALK,     -5.102169699542004_REALK,      0.000000000000000_REALK, &
     -0.947687978012108_REALK,      0.000000000000000_REALK,     -0.976013280519142_REALK, &
     -1.508129744429212_REALK,     -0.572045242877262_REALK,      0.000000000000000_REALK, &
     -0.403495210736391_REALK,      0.000000000000000_REALK,     -0.686828995317302_REALK, &
     -0.366828271156641_REALK,      0.000000000000000_REALK,     -0.312772340848593_REALK, &
      0.000000000000000_REALK,     -0.537944050629165_REALK,      0.000000000000000_REALK, &
     -0.298589439020034_REALK,      0.000000000000000_REALK,     -0.847097557201938_REALK, &
     -1.419218397740049_REALK,     -0.561463710693149_REALK,      0.000000000000000_REALK, &
     -0.420309891786622_REALK,      0.000000000000000_REALK,     -0.521294909892541_REALK, &
     -0.377008237393259_REALK,      0.000000000000000_REALK,     -0.276770573306541_REALK, &
      0.000000000000000_REALK,     -0.275439845134603_REALK,      0.000000000000000_REALK, &
     -0.282916317111587_REALK,      0.000000000000000_REALK,     -0.584817848757992_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.751443979096174_REALK, &
      0.000000000000000_REALK,      0.407403725810623_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.339945105203048_REALK,      0.000000000000000_REALK, &
      0.684767785080360_REALK,      0.000000000000000_REALK,      0.393494024505087_REALK, &
      0.000000000000000_REALK,      0.502469615118262_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.834829155260513_REALK, &
      0.000000000000000_REALK,      0.554097900050524_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.665969321500878_REALK,      0.000000000000000_REALK, &
      0.685874377732029_REALK,      0.000000000000000_REALK,      1.267674850693780_REALK, &
      0.000000000000000_REALK,      0.621618081741230_REALK,      0.000000000000000_REALK, &
     -1.486081381817119_REALK,     -0.312267621722113_REALK,      0.000000000000000_REALK, &
     -0.152714986578350_REALK,      0.000000000000000_REALK,     -0.588161123971145_REALK, &
     -0.044585074552912_REALK,      0.000000000000000_REALK,     -0.146085255919217_REALK, &
      0.000000000000000_REALK,      0.011628728897890_REALK,      0.000000000000000_REALK, &
     -0.092808651787673_REALK,      0.000000000000000_REALK,     -0.595733291284620_REALK, &
     -0.575751301332736_REALK,     -0.104131195240254_REALK,      0.000000000000000_REALK, &
      0.014045777892322_REALK,      0.000000000000000_REALK,     -0.354950637782717_REALK, &
      0.111181564736777_REALK,      0.000000000000000_REALK,     -0.057014320993875_REALK, &
      0.000000000000000_REALK,      0.156395686426574_REALK,      0.000000000000000_REALK, &
      0.008568242679395_REALK,      0.000000000000000_REALK,     -0.360879882320453_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.649414886563796_REALK, &
      0.000000000000000_REALK,      0.248088898565237_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.178480770842390_REALK,      0.000000000000000_REALK, &
      0.506349539636475_REALK,      0.000000000000000_REALK,      0.176827006571805_REALK, &
      0.000000000000000_REALK,      0.251282871393411_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.526234832882610_REALK, &
      0.000000000000000_REALK,      0.273894868762562_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.232310490432865_REALK,      0.000000000000000_REALK, &
      0.480210270817562_REALK,      0.000000000000000_REALK,      0.227593987131248_REALK, &
      0.000000000000000_REALK,      0.278470123690033_REALK,      0.000000000000000_REALK, &
     -0.823417019917842_REALK,     -0.385210942151249_REALK,      0.000000000000000_REALK, &
     -0.269642150880898_REALK,      0.000000000000000_REALK,     -0.543153160898524_REALK, &
     -0.235209647889891_REALK,      0.000000000000000_REALK,     -0.300349418001918_REALK, &
      0.000000000000000_REALK,     -0.289055189210408_REALK,      0.000000000000000_REALK, &
     -0.273113606912283_REALK,      0.000000000000000_REALK,     -0.770204234582216_REALK, &
     -0.660582067168468_REALK,     -0.559348672508235_REALK,      0.000000000000000_REALK, &
     -0.659049759998687_REALK,      0.000000000000000_REALK,     -0.678747998503632_REALK, &
     -1.040923228750811_REALK,      0.000000000000000_REALK,     -0.510427970028625_REALK, &
      0.000000000000000_REALK,     -2.164480592346646_REALK,      0.000000000000000_REALK, &
     -0.670058803999787_REALK,      0.000000000000000_REALK,     -0.966120526215954_REALK, &
     -1.799820203668029_REALK,     -0.151517753488430_REALK,      0.000000000000000_REALK, &
     -0.073688419358749_REALK,      0.000000000000000_REALK,     -0.605566375791637_REALK, &
      0.011936266046976_REALK,      0.000000000000000_REALK,     -0.059619802732236_REALK, &
      0.000000000000000_REALK,      0.003357196444200_REALK,      0.000000000000000_REALK, &
     -0.036443527812020_REALK,      0.000000000000000_REALK,     -0.499150686323010_REALK, &
     -2.043287413454664_REALK,     -0.176813739575624_REALK,      0.000000000000000_REALK, &
     -0.148687516881370_REALK,      0.000000000000000_REALK,     -0.540250140411056_REALK, &
     -0.154162823888374_REALK,      0.000000000000000_REALK,     -0.058650334832496_REALK, &
      0.000000000000000_REALK,     -0.258196098789836_REALK,      0.000000000000000_REALK, &
     -0.062613097472427_REALK,      0.000000000000000_REALK,     -0.379170305287950_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.658473545372956_REALK, &
      0.000000000000000_REALK,      0.136962342304646_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.067274532236989_REALK,      0.000000000000000_REALK, &
      0.431831275826143_REALK,      0.000000000000000_REALK,      0.020673092897971_REALK, &
      0.000000000000000_REALK,      0.112894060659164_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.750084484335199_REALK, &
      0.000000000000000_REALK,      0.088285249973853_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.009845607176246_REALK,      0.000000000000000_REALK, &
      0.414680313348462_REALK,      0.000000000000000_REALK,     -0.072498272222407_REALK, &
      0.000000000000000_REALK,      0.061962307237049_REALK,      0.000000000000000_REALK, &
     -0.846571860136475_REALK,     -0.277746981138349_REALK,      0.000000000000000_REALK, &
     -0.167334781851156_REALK,      0.000000000000000_REALK,     -0.474728394300385_REALK, &
     -0.128177211120368_REALK,      0.000000000000000_REALK,     -0.182148294437401_REALK, &
      0.000000000000000_REALK,     -0.149097395802511_REALK,      0.000000000000000_REALK, &
     -0.137929175967748_REALK,      0.000000000000000_REALK,     -0.547826660506376_REALK, &
     -1.687413272790808_REALK,     -0.578796794622428_REALK,      0.000000000000000_REALK, &
     -0.359726983710236_REALK,      0.000000000000000_REALK,     -0.743593592979817_REALK, &
     -0.261523987685203_REALK,      0.000000000000000_REALK,     -0.319984803274314_REALK, &
      0.000000000000000_REALK,     -0.147479774846623_REALK,      0.000000000000000_REALK, &
     -0.252471549808287_REALK,      0.000000000000000_REALK,     -0.730639427921509_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.608085051801086_REALK, &
      0.000000000000000_REALK,      0.281592824276036_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.197972816097101_REALK,      0.000000000000000_REALK, &
      0.558300639115084_REALK,      0.000000000000000_REALK,      0.181769009400824_REALK, &
      0.000000000000000_REALK,      0.324952243004215_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.434335618134040_REALK, &
      0.000000000000000_REALK,      0.790384944380283_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.769952021204091_REALK,      0.000000000000000_REALK, &
      1.110151000847039_REALK,      0.000000000000000_REALK,      1.131259721868264_REALK, &
      0.000000000000000_REALK,      0.776615625863062_REALK,      0.000000000000000_REALK, &
     -2.569293571046773_REALK,      0.081573417556626_REALK,      0.000000000000000_REALK, &
     -0.000986091001532_REALK,      0.000000000000000_REALK,     -0.735541519654534_REALK, &
      0.100761579774554_REALK,      0.000000000000000_REALK,      0.026759899417250_REALK, &
      0.000000000000000_REALK,      0.079740003522388_REALK,      0.000000000000000_REALK, &
     -0.000393184782669_REALK,      0.000000000000000_REALK,     -0.488805009038021_REALK, &
     -1.241873131205446_REALK,      0.241829070906295_REALK,      0.000000000000000_REALK, &
      0.209292577527569_REALK,      0.000000000000000_REALK,     -0.582131692602127_REALK, &
      0.357982218080124_REALK,      0.000000000000000_REALK,      0.096945732041440_REALK, &
      0.000000000000000_REALK,      0.470618616116943_REALK,      0.000000000000000_REALK, &
      0.085687414491651_REALK,      0.000000000000000_REALK,     -0.397221919525187_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.821014057935986_REALK, &
      0.000000000000000_REALK,      0.067962093059584_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.032773581257582_REALK,      0.000000000000000_REALK, &
      0.448885071235867_REALK,      0.000000000000000_REALK,     -0.005425308098707_REALK, &
      0.000000000000000_REALK,      0.045164291375197_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.740513666064626_REALK, &
      0.000000000000000_REALK,      0.084482833755182_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.081702037100234_REALK,      0.000000000000000_REALK, &
      0.494768468587350_REALK,      0.000000000000000_REALK,      0.090916110124588_REALK, &
      0.000000000000000_REALK,      0.057647494231339_REALK,      0.000000000000000_REALK, &
     -1.031687318172173_REALK,     -0.185690640919346_REALK,      0.000000000000000_REALK, &
     -0.076687909233187_REALK,      0.000000000000000_REALK,     -0.492255190537000_REALK, &
     -0.018591265187936_REALK,      0.000000000000000_REALK,     -0.101525370693974_REALK, &
      0.000000000000000_REALK,      0.003831337276678_REALK,      0.000000000000000_REALK, &
     -0.050963043097066_REALK,      0.000000000000000_REALK,     -0.457980297511210_REALK, &
     -0.764572427715024_REALK,     -0.121011415319258_REALK,      0.000000000000000_REALK, &
      0.014182097965258_REALK,      0.000000000000000_REALK,     -0.597325967093270_REALK, &
      0.094600918432863_REALK,      0.000000000000000_REALK,     -0.080852839566463_REALK, &
      0.000000000000000_REALK,      0.105983121166190_REALK,      0.000000000000000_REALK, &
      0.009677260743995_REALK,      0.000000000000000_REALK,     -0.570625785101302_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.643626695607853_REALK, &
      0.000000000000000_REALK,      0.207635362243589_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.124039392664925_REALK,      0.000000000000000_REALK, &
      0.492659263553887_REALK,      0.000000000000000_REALK,      0.097099162449431_REALK, &
      0.000000000000000_REALK,      0.193178064553124_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.019233825984180_REALK, &
      0.000000000000000_REALK,      0.460921885892291_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.329442892332135_REALK,      0.000000000000000_REALK, &
      0.953390457535259_REALK,      0.000000000000000_REALK,      0.257052284773766_REALK, &
      0.000000000000000_REALK,      0.440318900394620_REALK,      0.000000000000000_REALK, &
     -0.952739317656139_REALK,     -0.381777583080459_REALK,      0.000000000000000_REALK, &
     -0.225674127291002_REALK,      0.000000000000000_REALK,     -0.636420757062466_REALK, &
     -0.163464454660814_REALK,      0.000000000000000_REALK,     -0.292228809347582_REALK, &
      0.000000000000000_REALK,     -0.158725849168268_REALK,      0.000000000000000_REALK, &
     -0.209960821021647_REALK,      0.000000000000000_REALK,     -0.761281534857776_REALK, &
     -1.462039928324657_REALK,     -1.083370107631999_REALK,      0.000000000000000_REALK, &
     -1.109076849989454_REALK,      0.000000000000000_REALK,     -1.599116232082348_REALK, &
     -1.476148401806558_REALK,      0.000000000000000_REALK,     -1.013383481065243_REALK, &
      0.000000000000000_REALK,     -2.444636998649374_REALK,      0.000000000000000_REALK, &
     -1.059501650903604_REALK,      0.000000000000000_REALK,     -1.964104083634572_REALK, &
     -5.354658671869837_REALK,      0.661345132234171_REALK,      0.000000000000000_REALK, &
      0.042820207006405_REALK,      0.000000000000000_REALK,     -1.168840215047285_REALK, &
      0.186583690858150_REALK,      0.000000000000000_REALK,      0.166102693349818_REALK, &
      0.000000000000000_REALK,      0.063628851041777_REALK,      0.000000000000000_REALK, &
      0.012917585351682_REALK,      0.000000000000000_REALK,     -0.587673993810648_REALK, &
    -13.212379947608001_REALK,      1.665459481462440_REALK,      0.000000000000000_REALK, &
     -0.226723299801499_REALK,      0.000000000000000_REALK,     -2.329435465360824_REALK, &
     -0.273901143869337_REALK,      0.000000000000000_REALK,      0.329410013753910_REALK, &
      0.000000000000000_REALK,     -0.768827869221134_REALK,      0.000000000000000_REALK, &
     -0.051654584073364_REALK,      0.000000000000000_REALK,     -0.884529146278783_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.413381795851520_REALK, &
      0.000000000000000_REALK,     -0.041646249468572_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000475902306501_REALK,      0.000000000000000_REALK, &
      0.591638948107289_REALK,      0.000000000000000_REALK,     -0.047306298168087_REALK, &
      0.000000000000000_REALK,     -0.020939062018361_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.518629624482709_REALK, &
      0.000000000000000_REALK,     -0.403088241709916_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.250212419993721_REALK,      0.000000000000000_REALK, &
      1.159911970136897_REALK,      0.000000000000000_REALK,     -0.339113910624694_REALK, &
      0.000000000000000_REALK,     -0.153059959641106_REALK,      0.000000000000000_REALK, &
     -1.920235431685749_REALK,     -0.130592743674753_REALK,      0.000000000000000_REALK, &
     -0.051005301617535_REALK,      0.000000000000000_REALK,     -0.698596783489976_REALK, &
      0.006566674885337_REALK,      0.000000000000000_REALK,     -0.054665875650129_REALK, &
      0.000000000000000_REALK,      0.001417438552619_REALK,      0.000000000000000_REALK, &
     -0.025644642373877_REALK,      0.000000000000000_REALK,     -0.491740461308740_REALK, &
     -7.000919292663975_REALK,     -0.510646998589725_REALK,      0.000000000000000_REALK, &
     -0.339706862647385_REALK,      0.000000000000000_REALK,     -2.057185477449724_REALK, &
     -0.265480526698645_REALK,      0.000000000000000_REALK,     -0.168334161134046_REALK, &
      0.000000000000000_REALK,     -0.319154904499227_REALK,      0.000000000000000_REALK, &
     -0.128992893630557_REALK,      0.000000000000000_REALK,     -1.093611202211777_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.945894292337421_REALK, &
      0.000000000000000_REALK,      0.158003243935394_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.061684558572003_REALK,      0.000000000000000_REALK, &
      0.554329387922290_REALK,      0.000000000000000_REALK,      0.014547276456467_REALK, &
      0.000000000000000_REALK,      0.111218072996156_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.610469709855967_REALK, &
      0.000000000000000_REALK,      0.336176005398242_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.028258185219267_REALK,      0.000000000000000_REALK, &
      1.666261719390832_REALK,      0.000000000000000_REALK,     -0.149357918625609_REALK, &
      0.000000000000000_REALK,      0.178713027798588_REALK,      0.000000000000000_REALK, &
     -1.505351551217142_REALK,     -0.398982291724279_REALK,      0.000000000000000_REALK, &
     -0.193041663210570_REALK,      0.000000000000000_REALK,     -0.766722261285543_REALK, &
     -0.117526713661831_REALK,      0.000000000000000_REALK,     -0.233818526398780_REALK, &
      0.000000000000000_REALK,     -0.104917103908111_REALK,      0.000000000000000_REALK, &
     -0.135881525312425_REALK,      0.000000000000000_REALK,     -0.693892039081631_REALK, &
     -9.635978487729394_REALK,     -2.785990563447168_REALK,      0.000000000000000_REALK, &
     -1.369782386678205_REALK,      0.000000000000000_REALK,     -3.964078408594911_REALK, &
     -0.750608179972866_REALK,      0.000000000000000_REALK,     -1.285757754395148_REALK, &
      0.000000000000000_REALK,     -0.303831685021277_REALK,      0.000000000000000_REALK, &
     -0.728183909075976_REALK,      0.000000000000000_REALK,     -2.709419212001341_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.222916026489719_REALK, &
      0.000000000000000_REALK,      0.454793708534931_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.254132009689221_REALK,      0.000000000000000_REALK, &
      0.921438606742517_REALK,      0.000000000000000_REALK,      0.179070527164521_REALK, &
      0.000000000000000_REALK,      0.411593284441330_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      9.665678434453195_REALK, &
      0.000000000000000_REALK,      4.213521905078345_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.093808742306753_REALK,      0.000000000000000_REALK, &
      5.735302422196880_REALK,      0.000000000000000_REALK,      3.262803777596950_REALK, &
      0.000000000000000_REALK,      2.879912055991419_REALK,      0.000000000000000_REALK, &
     -3.071581479184202_REALK,     -0.182201145291055_REALK,      0.000000000000000_REALK, &
     -1.090190794518650_REALK,      0.000000000000000_REALK,     -3.993222714659855_REALK, &
     -0.181663464034588_REALK,      0.000000000000000_REALK,     -0.277087682045544_REALK, &
      0.000000000000000_REALK,     -3.296358730085410_REALK,      0.000000000000000_REALK, &
     -4.080064056391564_REALK,      0.000000000000000_REALK,    -24.907879350365867_REALK, &
     -1.286534844999721_REALK,     -0.114919605267573_REALK,      0.000000000000000_REALK, &
     -0.991624123810580_REALK,      0.000000000000000_REALK,     -2.646215649885233_REALK, &
     -0.563732333495885_REALK,      0.000000000000000_REALK,     -0.292374226662196_REALK, &
      0.000000000000000_REALK,    -11.381506134525898_REALK,      0.000000000000000_REALK, &
     -4.425839285546338_REALK,      0.000000000000000_REALK,    -19.684416201783165_REALK, &
     -2.092850089877186_REALK,      0.135096521321608_REALK,      0.000000000000000_REALK, &
     -0.506335058530551_REALK,      0.000000000000000_REALK,     -2.407608606461684_REALK, &
      0.115898610037404_REALK,      0.000000000000000_REALK,      0.175031062478527_REALK, &
      0.000000000000000_REALK,     -1.583217457308171_REALK,      0.000000000000000_REALK, &
     -1.627168522368762_REALK,      0.000000000000000_REALK,    -12.895232358548986_REALK, &
     -1.612033617174922_REALK,      0.044104049804493_REALK,      0.000000000000000_REALK, &
     -0.529688374944404_REALK,      0.000000000000000_REALK,     -1.733191516416151_REALK, &
     -0.212041456891336_REALK,      0.000000000000000_REALK,      0.062084998010956_REALK, &
      0.000000000000000_REALK,     -2.786536966972709_REALK,      0.000000000000000_REALK, &
     -1.875342542314330_REALK,      0.000000000000000_REALK,    -10.227169843195208_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.101149512568410_REALK, &
      0.000000000000000_REALK,      0.325050690141934_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.389489927875934_REALK,      0.000000000000000_REALK, &
      2.377748975906131_REALK,      0.000000000000000_REALK,      0.684850850472177_REALK, &
      0.000000000000000_REALK,      1.740982386604396_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.144904906305805_REALK, &
      0.000000000000000_REALK,      0.422266315855494_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.603947889720294_REALK,      0.000000000000000_REALK, &
      2.686125920628717_REALK,      0.000000000000000_REALK,      2.882573980803716_REALK, &
      0.000000000000000_REALK,      2.491697709347391_REALK,      0.000000000000000_REALK, &
     -1.720833465647024_REALK,      0.586241555059541_REALK,      0.000000000000000_REALK, &
     -0.339464161029904_REALK,      0.000000000000000_REALK,     -1.666348816899265_REALK, &
      0.515401242148343_REALK,      0.000000000000000_REALK,      0.661685460903956_REALK, &
      0.000000000000000_REALK,     -0.582402836043064_REALK,      0.000000000000000_REALK, &
     -0.874260931380456_REALK,      0.000000000000000_REALK,     -7.152564914104629_REALK, &
     -0.714922899074919_REALK,      0.482606024575666_REALK,      0.000000000000000_REALK, &
     -0.093558591402409_REALK,      0.000000000000000_REALK,     -1.197157527664170_REALK, &
      0.738105626843312_REALK,      0.000000000000000_REALK,      0.735005118439687_REALK, &
      0.000000000000000_REALK,      1.111348862240593_REALK,      0.000000000000000_REALK, &
     -0.265713126043006_REALK,      0.000000000000000_REALK,     -5.666689081735728_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.062088932114754_REALK, &
      0.000000000000000_REALK,     -0.136168184840578_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.252108789595923_REALK,      0.000000000000000_REALK, &
      1.997950044374813_REALK,      0.000000000000000_REALK,     -0.232212656934136_REALK, &
      0.000000000000000_REALK,     -0.584482535367567_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.921670281065322_REALK, &
      0.000000000000000_REALK,     -0.056192819511905_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.428989927635678_REALK,      0.000000000000000_REALK, &
      2.339494120117243_REALK,      0.000000000000000_REALK,      0.545059942242303_REALK, &
      0.000000000000000_REALK,     -0.265986079059584_REALK,      0.000000000000000_REALK, &
     -1.146174385547932_REALK,     -0.143392385061863_REALK,      0.000000000000000_REALK, &
     -0.303009852888598_REALK,      0.000000000000000_REALK,     -1.849807442581238_REALK, &
     -0.106108812082311_REALK,      0.000000000000000_REALK,     -0.269742780886456_REALK, &
      0.000000000000000_REALK,     -0.630480092432190_REALK,      0.000000000000000_REALK, &
     -1.300626627762062_REALK,      0.000000000000000_REALK,    -11.116048901925934_REALK, &
     -0.871123394941741_REALK,     -0.224551245683287_REALK,      0.000000000000000_REALK, &
     -0.546630198098092_REALK,      0.000000000000000_REALK,     -2.431199063862477_REALK, &
     -0.659396977100200_REALK,      0.000000000000000_REALK,     -0.569982920935496_REALK, &
      0.000000000000000_REALK,     -3.992335695835138_REALK,      0.000000000000000_REALK, &
     -2.587448438263038_REALK,      0.000000000000000_REALK,    -16.111153646283103_REALK, &
     -1.549852645775844_REALK,      1.159233184869172_REALK,      0.000000000000000_REALK, &
     -0.472095153449146_REALK,      0.000000000000000_REALK,     -1.224581939134071_REALK, &
      0.810131455948292_REALK,      0.000000000000000_REALK,      1.111248100467788_REALK, &
      0.000000000000000_REALK,     -1.136490870645991_REALK,      0.000000000000000_REALK, &
     -0.925139921748659_REALK,      0.000000000000000_REALK,     -3.999580843918972_REALK, &
     -2.107544961777165_REALK,      1.298151618708919_REALK,      0.000000000000000_REALK, &
     -0.757016662177566_REALK,      0.000000000000000_REALK,     -1.431750038179944_REALK, &
      0.440816491371661_REALK,      0.000000000000000_REALK,      1.216129994708214_REALK, &
      0.000000000000000_REALK,     -2.784412337720352_REALK,      0.000000000000000_REALK, &
     -1.383231110872577_REALK,      0.000000000000000_REALK,     -4.360188475699551_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.025016233488434_REALK, &
      0.000000000000000_REALK,     -0.467622493499078_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.200169997141460_REALK,      0.000000000000000_REALK, &
      1.637644834648774_REALK,      0.000000000000000_REALK,     -0.713784548285154_REALK, &
      0.000000000000000_REALK,     -1.527291810711387_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.361809443339571_REALK, &
      0.000000000000000_REALK,     -0.746416557321030_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.099701868199327_REALK,      0.000000000000000_REALK, &
      2.126276169971150_REALK,      0.000000000000000_REALK,     -1.369615703909973_REALK, &
      0.000000000000000_REALK,     -2.273104092554915_REALK,      0.000000000000000_REALK, &
     -1.072215882259960_REALK,      0.083760733965632_REALK,      0.000000000000000_REALK, &
     -0.178168854825408_REALK,      0.000000000000000_REALK,     -1.411979613940400_REALK, &
      0.053167201239705_REALK,      0.000000000000000_REALK,      0.133822596017213_REALK, &
      0.000000000000000_REALK,     -0.339717331844212_REALK,      0.000000000000000_REALK, &
     -0.581913480813360_REALK,      0.000000000000000_REALK,     -6.456290926419245_REALK, &
     -2.098329830052839_REALK,      0.063921339080996_REALK,      0.000000000000000_REALK, &
     -0.435650278995296_REALK,      0.000000000000000_REALK,     -2.375816308215268_REALK, &
     -0.204519420366834_REALK,      0.000000000000000_REALK,      0.099804286646202_REALK, &
      0.000000000000000_REALK,     -1.182800527062763_REALK,      0.000000000000000_REALK, &
     -1.326710162568090_REALK,      0.000000000000000_REALK,    -10.129288811389760_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.137866596863984_REALK, &
      0.000000000000000_REALK,      0.190631046402588_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.297790303805698_REALK,      0.000000000000000_REALK, &
      2.545120566475979_REALK,      0.000000000000000_REALK,      0.244918665004717_REALK, &
      0.000000000000000_REALK,      0.871662368940398_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.765575763672605_REALK, &
      0.000000000000000_REALK,      0.578832281439913_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.970872034084248_REALK,      0.000000000000000_REALK, &
      6.045287040583950_REALK,      0.000000000000000_REALK,      2.039275550144076_REALK, &
      0.000000000000000_REALK,      2.467850452826031_REALK,      0.000000000000000_REALK, &
     -1.125987059223923_REALK,      2.099422691342335_REALK,      0.000000000000000_REALK, &
     -0.822049387242511_REALK,      0.000000000000000_REALK,     -0.717170161642361_REALK, &
      1.329605137207667_REALK,      0.000000000000000_REALK,      1.654479297709780_REALK, &
      0.000000000000000_REALK,     -1.698293146258114_REALK,      0.000000000000000_REALK, &
     -1.179749085867967_REALK,      0.000000000000000_REALK,     -1.715389317924595_REALK, &
     -1.256130384122421_REALK,      2.405202026553559_REALK,      0.000000000000000_REALK, &
     -1.081768196031699_REALK,      0.000000000000000_REALK,     -1.391747705178196_REALK, &
      2.256552025926989_REALK,      0.000000000000000_REALK,      2.441656892781730_REALK, &
      0.000000000000000_REALK,     -0.682358466391128_REALK,      0.000000000000000_REALK, &
     -1.541519644997140_REALK,      0.000000000000000_REALK,     -3.305400726147514_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.992650705013949_REALK, &
      0.000000000000000_REALK,     -0.833138975602650_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.301577959057102_REALK,      0.000000000000000_REALK, &
      1.303787026845719_REALK,      0.000000000000000_REALK,     -0.871673123046072_REALK, &
      0.000000000000000_REALK,     -1.992773508343642_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.405096378126620_REALK, &
      0.000000000000000_REALK,     -1.214090862759964_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.754184190395748_REALK,      0.000000000000000_REALK, &
      2.377321612903820_REALK,      0.000000000000000_REALK,     -0.627110220324322_REALK, &
      0.000000000000000_REALK,     -2.883465734805736_REALK,      0.000000000000000_REALK, &
     -1.156614353523482_REALK,      0.379056544130054_REALK,      0.000000000000000_REALK, &
     -0.150073981044034_REALK,      0.000000000000000_REALK,     -1.227795790486303_REALK, &
      0.232680140828270_REALK,      0.000000000000000_REALK,      0.497867983351496_REALK, &
      0.000000000000000_REALK,     -0.143476096588708_REALK,      0.000000000000000_REALK, &
     -0.358959864409043_REALK,      0.000000000000000_REALK,     -4.111446703635444_REALK, &
     -1.149519438672377_REALK,      0.732521161723696_REALK,      0.000000000000000_REALK, &
     -0.099534694241255_REALK,      0.000000000000000_REALK,     -2.122710960916314_REALK, &
      0.746760611937827_REALK,      0.000000000000000_REALK,      1.239372911911548_REALK, &
      0.000000000000000_REALK,      0.593234967135272_REALK,      0.000000000000000_REALK, &
     -0.236394893555647_REALK,      0.000000000000000_REALK,     -7.058013787780586_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.144555961877379_REALK, &
      0.000000000000000_REALK,     -0.100331168630421_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.189692689468853_REALK,      0.000000000000000_REALK, &
      2.104627629719110_REALK,      0.000000000000000_REALK,     -0.095343416199010_REALK, &
      0.000000000000000_REALK,     -0.335973014188336_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.331587777717855_REALK, &
      0.000000000000000_REALK,     -0.099636940959180_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.723367065692322_REALK,      0.000000000000000_REALK, &
      5.522829425578494_REALK,      0.000000000000000_REALK,      0.484919164313179_REALK, &
      0.000000000000000_REALK,     -0.331292821307430_REALK,      0.000000000000000_REALK, &
     -1.283953166135541_REALK,     -0.154526239985938_REALK,      0.000000000000000_REALK, &
     -0.223263111588349_REALK,      0.000000000000000_REALK,     -1.908159969539132_REALK, &
     -0.079838810747137_REALK,      0.000000000000000_REALK,     -0.284145297410851_REALK, &
      0.000000000000000_REALK,     -0.258866707145092_REALK,      0.000000000000000_REALK, &
     -0.747627896508537_REALK,      0.000000000000000_REALK,     -8.215382243534954_REALK, &
     -2.334455172866758_REALK,     -0.568056658289239_REALK,      0.000000000000000_REALK, &
     -0.969244135593973_REALK,      0.000000000000000_REALK,     -6.035150675232848_REALK, &
     -1.111881714986190_REALK,      0.000000000000000_REALK,     -1.345555186803368_REALK, &
      0.000000000000000_REALK,     -3.551829696597716_REALK,      0.000000000000000_REALK, &
     -3.222736679041172_REALK,      0.000000000000000_REALK,    -25.800268561740683_REALK, &
      0.997368470061109_REALK,      4.156657421413390_REALK,      0.000000000000000_REALK, &
     -1.707281522487098_REALK,      0.000000000000000_REALK,      0.469604674392221_REALK, &
      2.335015967279824_REALK,      0.000000000000000_REALK,      2.478469514446207_REALK, &
      0.000000000000000_REALK,     -2.908043323116912_REALK,      0.000000000000000_REALK, &
     -1.689641882383760_REALK,      0.000000000000000_REALK,      0.774587861428969_REALK, &
     -7.462473915508059_REALK,     13.827049713870473_REALK,      0.000000000000000_REALK, &
     -7.057915000686339_REALK,      0.000000000000000_REALK,     -2.827361811887218_REALK, &
      5.055219769860038_REALK,      0.000000000000000_REALK,      6.506593680559138_REALK, &
      0.000000000000000_REALK,     -8.918627459953841_REALK,      0.000000000000000_REALK, &
     -4.839438681506524_REALK,      0.000000000000000_REALK,     -3.231087395671102_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.812076350347229_REALK, &
      0.000000000000000_REALK,     -1.511650353357779_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.555024187005717_REALK,      0.000000000000000_REALK, &
      0.807021232721636_REALK,      0.000000000000000_REALK,     -1.202270589058968_REALK, &
      0.000000000000000_REALK,     -2.493386625572190_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.783482414154760_REALK, &
      0.000000000000000_REALK,     -5.412310638224026_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.749613171735064_REALK,      0.000000000000000_REALK, &
      3.751604896570141_REALK,      0.000000000000000_REALK,     -3.429746310142585_REALK, &
      0.000000000000000_REALK,     -6.185147090513171_REALK,      0.000000000000000_REALK, &
     -1.517997799111025_REALK,      0.943391812467544_REALK,      0.000000000000000_REALK, &
     -0.275543144604251_REALK,      0.000000000000000_REALK,     -1.191232868590623_REALK, &
      0.410086917844432_REALK,      0.000000000000000_REALK,      0.937519265413311_REALK, &
      0.000000000000000_REALK,     -0.334994491568504_REALK,      0.000000000000000_REALK, &
     -0.454493719396324_REALK,      0.000000000000000_REALK,     -2.750825105980052_REALK, &
     -8.345237603795001_REALK,      4.172870032111658_REALK,      0.000000000000000_REALK, &
     -1.671766057273051_REALK,      0.000000000000000_REALK,     -5.269701526876022_REALK, &
      0.711765370730093_REALK,      0.000000000000000_REALK,      3.272711863410733_REALK, &
      0.000000000000000_REALK,     -2.307453044490698_REALK,      0.000000000000000_REALK, &
     -1.910481429527491_REALK,      0.000000000000000_REALK,     -8.431044288421582_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.390275248243002_REALK, &
      0.000000000000000_REALK,     -0.454887718450516_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.168876085006443_REALK,      0.000000000000000_REALK, &
      1.934269236940088_REALK,      0.000000000000000_REALK,     -0.350661112520750_REALK, &
      0.000000000000000_REALK,     -1.050438238659524_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      7.295827048320264_REALK, &
      0.000000000000000_REALK,     -2.747261998889376_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.268306421418740_REALK,      0.000000000000000_REALK, &
      8.010792421274342_REALK,      0.000000000000000_REALK,     -1.891676197377165_REALK, &
      0.000000000000000_REALK,     -4.395369921124351_REALK,      0.000000000000000_REALK, &
     -1.750296879167428_REALK,      0.113608420435226_REALK,      0.000000000000000_REALK, &
     -0.173316777950569_REALK,      0.000000000000000_REALK,     -1.922937992971800_REALK, &
      0.044855217686624_REALK,      0.000000000000000_REALK,      0.158061702517489_REALK, &
      0.000000000000000_REALK,     -0.166893018086856_REALK,      0.000000000000000_REALK, &
     -0.400227492579236_REALK,      0.000000000000000_REALK,     -5.709210567837108_REALK, &
    -13.847914137464558_REALK,      0.342455427161914_REALK,      0.000000000000000_REALK, &
     -1.603455127770663_REALK,      0.000000000000000_REALK,    -12.242206733273102_REALK, &
     -0.550379594488186_REALK,      0.000000000000000_REALK,      0.376014853746367_REALK, &
      0.000000000000000_REALK,     -1.633652123659402_REALK,      0.000000000000000_REALK, &
     -2.565382712433308_REALK,      0.000000000000000_REALK,    -25.182539945397568_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.160674923219629_REALK, &
      0.000000000000000_REALK,      0.259615420894441_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.351728660283010_REALK,      0.000000000000000_REALK, &
      3.865004775404846_REALK,      0.000000000000000_REALK,      0.168449754839295_REALK, &
      0.000000000000000_REALK,      0.770799219715536_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     20.743010399326810_REALK, &
      0.000000000000000_REALK,      2.982631455460768_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.657781826513546_REALK,      0.000000000000000_REALK, &
     29.283110245414569_REALK,      0.000000000000000_REALK,      3.943229191898980_REALK, &
      0.000000000000000_REALK,      6.135351036459622_REALK,      0.000000000000000_REALK/
    ! results of test 7, ket-major order, 02ODGZZZ
  data REF_CONTR_INTS(64261:65520)                                                         &
     /0.000000000000000_REALK,      0.000000000000000_REALK,      1.317696591729077_REALK, &
      0.000000000000000_REALK,      1.030795548764400_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.098235277920395_REALK,      0.000000000000000_REALK, &
      1.393110240992673_REALK,      0.000000000000000_REALK,      1.617114770349404_REALK, &
      0.000000000000000_REALK,      1.544232261395293_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.034869546279924_REALK, &
      0.000000000000000_REALK,      0.817539342594290_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.624719650218595_REALK,      0.000000000000000_REALK, &
      1.272575011006211_REALK,      0.000000000000000_REALK,      0.137300541193925_REALK, &
      0.000000000000000_REALK,      1.234144950116151_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.700054001472689_REALK, &
      0.000000000000000_REALK,      0.274324619857245_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.104012740608798_REALK,      0.000000000000000_REALK, &
      0.637937679135683_REALK,      0.000000000000000_REALK,     -0.105309892674673_REALK, &
      0.000000000000000_REALK,      0.338337078000133_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.361506596702488_REALK, &
      0.000000000000000_REALK,     -0.123945650377590_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.432668179825258_REALK,      0.000000000000000_REALK, &
      0.297004615252050_REALK,      0.000000000000000_REALK,     -0.932299894261783_REALK, &
      0.000000000000000_REALK,     -0.139049177809303_REALK,      0.000000000000000_REALK, &
     -1.263361897106447_REALK,     -0.847330132448344_REALK,      0.000000000000000_REALK, &
     -0.755955698370636_REALK,      0.000000000000000_REALK,     -0.958928971150057_REALK, &
     -0.808588546233497_REALK,      0.000000000000000_REALK,     -0.772145887343972_REALK, &
      0.000000000000000_REALK,     -1.109049091668190_REALK,      0.000000000000000_REALK, &
     -0.932354676067240_REALK,      0.000000000000000_REALK,     -1.655767232224311_REALK, &
     -2.017070420365347_REALK,     -1.055621072724008_REALK,      0.000000000000000_REALK, &
     -0.606185910539136_REALK,      0.000000000000000_REALK,     -1.234821157788498_REALK, &
     -0.096485288810378_REALK,      0.000000000000000_REALK,     -0.867271395366469_REALK, &
      0.000000000000000_REALK,      1.122861885674356_REALK,      0.000000000000000_REALK, &
     -0.680053331466407_REALK,      0.000000000000000_REALK,     -1.939408222011260_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.545455816831067_REALK, &
      0.000000000000000_REALK,      0.107042982313077_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.003812647297981_REALK,      0.000000000000000_REALK, &
      0.425292532491578_REALK,      0.000000000000000_REALK,     -0.086496073782809_REALK, &
      0.000000000000000_REALK,      0.108421086609287_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.291832531020999_REALK, &
      0.000000000000000_REALK,      0.004889607315642_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.050925023812697_REALK,      0.000000000000000_REALK, &
      0.266308822597896_REALK,      0.000000000000000_REALK,     -0.061391810633100_REALK, &
      0.000000000000000_REALK,      0.004971285369946_REALK,      0.000000000000000_REALK, &
     -0.767104928257634_REALK,     -0.259381145963337_REALK,      0.000000000000000_REALK, &
     -0.082502200112636_REALK,      0.000000000000000_REALK,     -0.506007838610796_REALK, &
      0.062948612260341_REALK,      0.000000000000000_REALK,     -0.202239780094747_REALK, &
      0.000000000000000_REALK,      0.281050658573837_REALK,      0.000000000000000_REALK, &
     -0.083564358826502_REALK,      0.000000000000000_REALK,     -0.717531274944825_REALK, &
     -0.286052270024335_REALK,      0.125120190846334_REALK,      0.000000000000000_REALK, &
      0.428172666317827_REALK,      0.000000000000000_REALK,     -0.293918674751008_REALK, &
      0.765537484290944_REALK,      0.000000000000000_REALK,      0.114177163837550_REALK, &
      0.000000000000000_REALK,      1.279278192733025_REALK,      0.000000000000000_REALK, &
      0.435325042374486_REALK,      0.000000000000000_REALK,     -0.418359782041583_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.906692573068289_REALK, &
      0.000000000000000_REALK,      0.612460878743670_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.557311677965351_REALK,      0.000000000000000_REALK, &
      0.989728949934956_REALK,      0.000000000000000_REALK,      0.649624103979624_REALK, &
      0.000000000000000_REALK,      0.868484244009491_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.246522636759856_REALK, &
      0.000000000000000_REALK,      0.858260262923004_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.558410785798380_REALK,      0.000000000000000_REALK, &
      1.592502262876781_REALK,      0.000000000000000_REALK,      0.097077770907156_REALK, &
      0.000000000000000_REALK,      1.221635803970594_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.512823592864569_REALK, &
      0.000000000000000_REALK,     -0.004173710280888_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.064962614325899_REALK,      0.000000000000000_REALK, &
      0.336313080360766_REALK,      0.000000000000000_REALK,     -0.132195511997771_REALK, &
      0.000000000000000_REALK,     -0.003440267548698_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.337065022086164_REALK, &
      0.000000000000000_REALK,     -0.232662523001202_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.295837877300379_REALK,      0.000000000000000_REALK, &
      0.186344647698424_REALK,      0.000000000000000_REALK,     -0.405337582322932_REALK, &
      0.000000000000000_REALK,     -0.163292358995609_REALK,      0.000000000000000_REALK, &
     -0.711051679027955_REALK,     -0.119839563001183_REALK,      0.000000000000000_REALK, &
     -0.003574550361207_REALK,      0.000000000000000_REALK,     -0.398733335874307_REALK, &
      0.062698711725576_REALK,      0.000000000000000_REALK,     -0.078591572507195_REALK, &
      0.000000000000000_REALK,      0.113088186039025_REALK,      0.000000000000000_REALK, &
     -0.002946397517134_REALK,      0.000000000000000_REALK,     -0.460129948929013_REALK, &
     -0.935783903888438_REALK,     -0.010332756703484_REALK,      0.000000000000000_REALK, &
      0.078856125598889_REALK,      0.000000000000000_REALK,     -0.412372550675882_REALK, &
      0.070544179705084_REALK,      0.000000000000000_REALK,     -0.005712410904422_REALK, &
      0.000000000000000_REALK,      0.009226278633797_REALK,      0.000000000000000_REALK, &
      0.055344550571344_REALK,      0.000000000000000_REALK,     -0.405188596783052_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.566499147762278_REALK, &
      0.000000000000000_REALK,      0.189610058966323_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.060573589244656_REALK,      0.000000000000000_REALK, &
      0.520119406515668_REALK,      0.000000000000000_REALK,     -0.048646418190615_REALK, &
      0.000000000000000_REALK,      0.218806051310702_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.621111259200081_REALK, &
      0.000000000000000_REALK,     -0.176800482317180_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.500223852378632_REALK,      0.000000000000000_REALK, &
      0.480729389496271_REALK,      0.000000000000000_REALK,     -0.831974633324301_REALK, &
      0.000000000000000_REALK,     -0.173720436103835_REALK,      0.000000000000000_REALK, &
     -1.181956918505199_REALK,     -0.685678243243370_REALK,      0.000000000000000_REALK, &
     -0.522507985679792_REALK,      0.000000000000000_REALK,     -0.927921126446665_REALK, &
     -0.470895297833724_REALK,      0.000000000000000_REALK,     -0.629541213513182_REALK, &
      0.000000000000000_REALK,     -0.512309570705576_REALK,      0.000000000000000_REALK, &
     -0.602963311905358_REALK,      0.000000000000000_REALK,     -1.376744935227242_REALK, &
     -3.997072619805067_REALK,     -1.813682349640054_REALK,      0.000000000000000_REALK, &
     -0.864685134417400_REALK,      0.000000000000000_REALK,     -2.465949921197993_REALK, &
     -0.111550248243549_REALK,      0.000000000000000_REALK,     -1.403758820610530_REALK, &
      0.000000000000000_REALK,      1.002030152912836_REALK,      0.000000000000000_REALK, &
     -0.849621430183719_REALK,      0.000000000000000_REALK,     -3.115273548510765_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.587660905920843_REALK, &
      0.000000000000000_REALK,     -0.103039770140006_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.093056550611021_REALK,      0.000000000000000_REALK, &
      0.321300475999133_REALK,      0.000000000000000_REALK,     -0.122131074006890_REALK, &
      0.000000000000000_REALK,     -0.068475204225340_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.346069004231910_REALK, &
      0.000000000000000_REALK,     -0.211375910380754_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.124882370829382_REALK,      0.000000000000000_REALK, &
      0.231223323884516_REALK,      0.000000000000000_REALK,     -0.050949922675605_REALK, &
      0.000000000000000_REALK,     -0.144233935258725_REALK,      0.000000000000000_REALK, &
     -0.803484970558993_REALK,      0.005658627941291_REALK,      0.000000000000000_REALK, &
      0.074052496618266_REALK,      0.000000000000000_REALK,     -0.383371628505495_REALK, &
      0.118883121762916_REALK,      0.000000000000000_REALK,      0.003093824742672_REALK, &
      0.000000000000000_REALK,      0.150099264999851_REALK,      0.000000000000000_REALK, &
      0.049211676447280_REALK,      0.000000000000000_REALK,     -0.356678113010383_REALK, &
     -0.343575460653136_REALK,      0.318907418945558_REALK,      0.000000000000000_REALK, &
      0.426139463275595_REALK,      0.000000000000000_REALK,     -0.268420017338951_REALK, &
      0.528913398728614_REALK,      0.000000000000000_REALK,      0.213075521119509_REALK, &
      0.000000000000000_REALK,      0.669615232461859_REALK,      0.000000000000000_REALK, &
      0.290779453754046_REALK,      0.000000000000000_REALK,     -0.256421772313521_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.540594206031607_REALK, &
      0.000000000000000_REALK,      0.089588484356810_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.002649688552190_REALK,      0.000000000000000_REALK, &
      0.413793811292280_REALK,      0.000000000000000_REALK,     -0.047496683240320_REALK, &
      0.000000000000000_REALK,      0.083350590319933_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.565233558390332_REALK, &
      0.000000000000000_REALK,      0.008228438288679_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.072217518484324_REALK,      0.000000000000000_REALK, &
      0.528718991765885_REALK,      0.000000000000000_REALK,     -0.069337970605244_REALK, &
      0.000000000000000_REALK,      0.007860631074661_REALK,      0.000000000000000_REALK, &
     -0.887583093669551_REALK,     -0.257069299354537_REALK,      0.000000000000000_REALK, &
     -0.069049337980658_REALK,      0.000000000000000_REALK,     -0.592897022260706_REALK, &
      0.043747612681299_REALK,      0.000000000000000_REALK,     -0.196771781789926_REALK, &
      0.000000000000000_REALK,      0.154330405080398_REALK,      0.000000000000000_REALK, &
     -0.064241549828731_REALK,      0.000000000000000_REALK,     -0.709218783501954_REALK, &
     -0.633108074150649_REALK,      0.242338064406748_REALK,      0.000000000000000_REALK, &
      0.720547098010183_REALK,      0.000000000000000_REALK,     -0.692466312597096_REALK, &
      1.085619863931017_REALK,      0.000000000000000_REALK,      0.226682820185900_REALK, &
      0.000000000000000_REALK,      1.444859710259579_REALK,      0.000000000000000_REALK, &
      0.688338991029205_REALK,      0.000000000000000_REALK,     -0.850517232621833_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.258055796893585_REALK, &
      0.000000000000000_REALK,      0.717629656203017_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.542243528123892_REALK,      0.000000000000000_REALK, &
      1.238103573242769_REALK,      0.000000000000000_REALK,      0.499409794220983_REALK, &
      0.000000000000000_REALK,      0.858422985220246_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.380044686501539_REALK, &
      0.000000000000000_REALK,      2.022043410539936_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.108646663592915_REALK,      0.000000000000000_REALK, &
      4.065031204531759_REALK,      0.000000000000000_REALK,      0.153500047948338_REALK, &
      0.000000000000000_REALK,      2.483561632512620_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.912654361372544_REALK, &
      0.000000000000000_REALK,     -0.309318171428312_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.148609768503927_REALK,      0.000000000000000_REALK, &
      0.382035390531311_REALK,      0.000000000000000_REALK,     -0.155187986134019_REALK, &
      0.000000000000000_REALK,     -0.155520183872292_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.304902970656238_REALK, &
      0.000000000000000_REALK,     -1.387419163984939_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.736686033008097_REALK,      0.000000000000000_REALK, &
      0.430159674948421_REALK,      0.000000000000000_REALK,     -0.664248421693300_REALK, &
      0.000000000000000_REALK,     -0.526828369748517_REALK,      0.000000000000000_REALK, &
     -1.374455507135462_REALK,      0.197996348911766_REALK,      0.000000000000000_REALK, &
      0.144823276836873_REALK,      0.000000000000000_REALK,     -0.500037745627878_REALK, &
      0.147824794796711_REALK,      0.000000000000000_REALK,      0.082880897393097_REALK, &
      0.000000000000000_REALK,      0.119911320560664_REALK,      0.000000000000000_REALK, &
      0.072814805992988_REALK,      0.000000000000000_REALK,     -0.351975270310364_REALK, &
     -3.271784545443825_REALK,      1.277637946223382_REALK,      0.000000000000000_REALK, &
      0.519245295467612_REALK,      0.000000000000000_REALK,     -0.961397692340822_REALK, &
      0.148776848114587_REALK,      0.000000000000000_REALK,      0.421171792852023_REALK, &
      0.000000000000000_REALK,     -0.215398004184383_REALK,      0.000000000000000_REALK, &
      0.197166912214972_REALK,      0.000000000000000_REALK,     -0.511084342004922_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.736668789316084_REALK, &
      0.000000000000000_REALK,     -0.004814898405870_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.059564742483235_REALK,      0.000000000000000_REALK, &
      0.431715427813756_REALK,      0.000000000000000_REALK,     -0.093023558150051_REALK, &
      0.000000000000000_REALK,     -0.003389194481298_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.622434642909089_REALK, &
      0.000000000000000_REALK,     -0.885941395777729_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.849093548216942_REALK,      0.000000000000000_REALK, &
      0.748767045548984_REALK,      0.000000000000000_REALK,     -0.835059592189545_REALK, &
      0.000000000000000_REALK,     -0.470971356518990_REALK,      0.000000000000000_REALK, &
     -1.264373171874305_REALK,     -0.172148994345438_REALK,      0.000000000000000_REALK, &
     -0.004123692273200_REALK,      0.000000000000000_REALK,     -0.643984494295981_REALK, &
      0.057488952018293_REALK,      0.000000000000000_REALK,     -0.100885741081207_REALK, &
      0.000000000000000_REALK,      0.079578083182298_REALK,      0.000000000000000_REALK, &
     -0.002902656279905_REALK,      0.000000000000000_REALK,     -0.582813016456259_REALK, &
     -5.343796752362217_REALK,     -0.049735870926999_REALK,      0.000000000000000_REALK, &
      0.300271419210659_REALK,      0.000000000000000_REALK,     -2.198347511146244_REALK, &
      0.202471057453624_REALK,      0.000000000000000_REALK,     -0.022953516984228_REALK, &
      0.000000000000000_REALK,      0.019007594680001_REALK,      0.000000000000000_REALK, &
      0.159625950772264_REALK,      0.000000000000000_REALK,     -1.502554785102294_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.139282876201792_REALK, &
      0.000000000000000_REALK,      0.306234585751691_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.077756574222209_REALK,      0.000000000000000_REALK, &
      0.858422985220246_REALK,      0.000000000000000_REALK,     -0.047924229651546_REALK, &
      0.000000000000000_REALK,      0.277145652179548_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.185534841041127_REALK, &
      0.000000000000000_REALK,     -0.942518845239329_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.009991382552851_REALK,      0.000000000000000_REALK, &
      2.483561632512621_REALK,      0.000000000000000_REALK,     -2.399599246751475_REALK, &
      0.000000000000000_REALK,     -0.644204882887249_REALK,      0.000000000000000_REALK, &
     -2.942414070601782_REALK,     -1.378963206206108_REALK,      0.000000000000000_REALK, &
     -0.843889915012481_REALK,      0.000000000000000_REALK,     -1.926852170675919_REALK, &
     -0.604474749366567_REALK,      0.000000000000000_REALK,     -1.039016504774240_REALK, &
      0.000000000000000_REALK,     -0.504703993271919_REALK,      0.000000000000000_REALK, &
     -0.763729610389331_REALK,      0.000000000000000_REALK,     -2.131338373972405_REALK, &
    -31.955413033160461_REALK,    -12.222014256795804_REALK,      0.000000000000000_REALK, &
     -4.609614316122868_REALK,      0.000000000000000_REALK,    -16.901891875242487_REALK, &
     -0.448229400947182_REALK,      0.000000000000000_REALK,     -7.252149804742732_REALK, &
      0.000000000000000_REALK,      2.890077057451163_REALK,      0.000000000000000_REALK, &
     -3.150638383171299_REALK,      0.000000000000000_REALK,    -14.119504776619905_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.923594943341201_REALK, &
      0.000000000000000_REALK,      1.298807174634073_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.597830029948230_REALK,      0.000000000000000_REALK, &
      2.340973045573600_REALK,      0.000000000000000_REALK,      4.349727235919725_REALK, &
      0.000000000000000_REALK,      8.101359407380491_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.590787090508226_REALK, &
      0.000000000000000_REALK,      1.090253479607757_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.377528508476903_REALK,      0.000000000000000_REALK, &
      2.505097923416021_REALK,      0.000000000000000_REALK,     -0.237095955327955_REALK, &
      0.000000000000000_REALK,      8.110073439771307_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.761281326684207_REALK, &
      0.000000000000000_REALK,     -0.225990037060070_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.084281625031207_REALK,      0.000000000000000_REALK, &
      1.643860233546058_REALK,      0.000000000000000_REALK,     -2.226255828451831_REALK, &
      0.000000000000000_REALK,     -1.210410209859447_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.415603014030996_REALK, &
      0.000000000000000_REALK,     -0.880746986656876_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.861212457316140_REALK,      0.000000000000000_REALK, &
      0.975069652100782_REALK,      0.000000000000000_REALK,     -6.318070342383359_REALK, &
      0.000000000000000_REALK,     -5.197088109482464_REALK,      0.000000000000000_REALK, &
     -1.432299269312804_REALK,     -0.358152046470688_REALK,      0.000000000000000_REALK, &
     -0.701312531786616_REALK,      0.000000000000000_REALK,     -2.746188132398796_REALK, &
     -0.415232438506541_REALK,      0.000000000000000_REALK,     -0.773369694119043_REALK, &
      0.000000000000000_REALK,     -2.266687908908400_REALK,      0.000000000000000_REALK, &
     -3.756253416389590_REALK,      0.000000000000000_REALK,    -20.592145900102327_REALK, &
     -2.019067555393327_REALK,     -0.471706286664139_REALK,      0.000000000000000_REALK, &
     -0.545251796729504_REALK,      0.000000000000000_REALK,     -3.618029137022114_REALK, &
      0.032353999466083_REALK,      0.000000000000000_REALK,     -1.106696701667931_REALK, &
      0.000000000000000_REALK,      3.049478223363483_REALK,      0.000000000000000_REALK, &
     -3.217407124165185_REALK,      0.000000000000000_REALK,    -29.888836510031435_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.545391343493370_REALK, &
      0.000000000000000_REALK,     -0.562706773849471_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.134903518973264_REALK,      0.000000000000000_REALK, &
      1.025963670259285_REALK,      0.000000000000000_REALK,     -1.497156760582723_REALK, &
      0.000000000000000_REALK,     -2.415338665438646_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.311171356768056_REALK, &
      0.000000000000000_REALK,     -0.641950175145955_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.101970990467395_REALK,      0.000000000000000_REALK, &
      0.789852482458611_REALK,      0.000000000000000_REALK,     -0.604997566108226_REALK, &
      0.000000000000000_REALK,     -3.038641084783276_REALK,      0.000000000000000_REALK, &
     -0.792409338497688_REALK,      0.099692913742507_REALK,      0.000000000000000_REALK, &
      0.065568223910665_REALK,      0.000000000000000_REALK,     -1.278867082013150_REALK, &
      0.344929645900969_REALK,      0.000000000000000_REALK,      0.187537460765269_REALK, &
      0.000000000000000_REALK,      1.360445855128170_REALK,      0.000000000000000_REALK, &
      0.281442260508371_REALK,      0.000000000000000_REALK,     -7.685096673026915_REALK, &
     -0.316219719678623_REALK,      0.468360429329825_REALK,      0.000000000000000_REALK, &
      0.779479064601569_REALK,      0.000000000000000_REALK,     -0.882530639082352_REALK, &
      1.445276517660241_REALK,      0.000000000000000_REALK,      1.188848651218531_REALK, &
      0.000000000000000_REALK,      5.353876957612567_REALK,      0.000000000000000_REALK, &
      3.689627641098856_REALK,      0.000000000000000_REALK,     -5.848384418682253_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.211449407971729_REALK, &
      0.000000000000000_REALK,      0.601655191756734_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.581983051665080_REALK,      0.000000000000000_REALK, &
      3.190487590369524_REALK,      0.000000000000000_REALK,      1.386588785947268_REALK, &
      0.000000000000000_REALK,      3.615526881183341_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.923982375887092_REALK, &
      0.000000000000000_REALK,      1.001665619772955_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.735991008696902_REALK,      0.000000000000000_REALK, &
      6.837156158004900_REALK,      0.000000000000000_REALK,     -0.138611802135529_REALK, &
      0.000000000000000_REALK,      6.637872209741166_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.247774537948345_REALK, &
      0.000000000000000_REALK,     -0.821597941296678_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.117790710248112_REALK,      0.000000000000000_REALK, &
      0.395863674127042_REALK,      0.000000000000000_REALK,     -1.316773409266107_REALK, &
      0.000000000000000_REALK,     -2.683403439493068_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.111978685755491_REALK, &
      0.000000000000000_REALK,     -1.301411463878329_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.383801249017717_REALK,      0.000000000000000_REALK, &
      0.174839154061599_REALK,      0.000000000000000_REALK,     -2.254553177200494_REALK, &
      0.000000000000000_REALK,     -3.963261124936955_REALK,      0.000000000000000_REALK, &
     -0.550591615126168_REALK,      0.346136158312213_REALK,      0.000000000000000_REALK, &
      0.095338228888839_REALK,      0.000000000000000_REALK,     -0.725063067081280_REALK, &
      0.342787666392638_REALK,      0.000000000000000_REALK,      0.553013770148805_REALK, &
      0.000000000000000_REALK,      0.425924423539031_REALK,      0.000000000000000_REALK, &
      0.311382147467075_REALK,      0.000000000000000_REALK,     -3.315358136095704_REALK, &
     -0.708431370283218_REALK,      0.730241251018128_REALK,      0.000000000000000_REALK, &
      0.103554157300109_REALK,      0.000000000000000_REALK,     -0.802115462814431_REALK, &
      0.227009438695451_REALK,      0.000000000000000_REALK,      1.140170218354549_REALK, &
      0.000000000000000_REALK,     -0.854249134086929_REALK,      0.000000000000000_REALK, &
      0.315359267491051_REALK,      0.000000000000000_REALK,     -3.419817918933469_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.786665736635325_REALK, &
      0.000000000000000_REALK,     -0.132535381550827_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.064438767030904_REALK,      0.000000000000000_REALK, &
      1.759572827579780_REALK,      0.000000000000000_REALK,     -0.796161098562502_REALK, &
      0.000000000000000_REALK,     -0.606019359548796_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.003910120904319_REALK, &
      0.000000000000000_REALK,     -1.207306310059529_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.384435817137220_REALK,      0.000000000000000_REALK, &
      2.194452570612128_REALK,      0.000000000000000_REALK,     -4.469715767614196_REALK, &
      0.000000000000000_REALK,     -5.147348410783861_REALK,      0.000000000000000_REALK, &
     -1.223000500716423_REALK,     -0.370094383756225_REALK,      0.000000000000000_REALK, &
     -0.411295671242397_REALK,      0.000000000000000_REALK,     -2.254762799908367_REALK, &
     -0.317472122288696_REALK,      0.000000000000000_REALK,     -0.827807785404054_REALK, &
      0.000000000000000_REALK,     -0.810620555190114_REALK,      0.000000000000000_REALK, &
     -1.880653576086181_REALK,      0.000000000000000_REALK,    -13.255618480906818_REALK, &
     -4.380253649009314_REALK,     -1.139430416260181_REALK,      0.000000000000000_REALK, &
     -0.747417754174255_REALK,      0.000000000000000_REALK,     -6.943307513501439_REALK, &
      0.052010436342354_REALK,      0.000000000000000_REALK,     -2.490687118228696_REALK, &
      0.000000000000000_REALK,      2.157351874753287_REALK,      0.000000000000000_REALK, &
     -3.186614330667087_REALK,      0.000000000000000_REALK,    -38.060716936152744_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.313401390068775_REALK, &
      0.000000000000000_REALK,     -1.150785851499926_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.009121227065179_REALK,      0.000000000000000_REALK, &
     -0.411633885417270_REALK,      0.000000000000000_REALK,     -1.202731075599482_REALK, &
      0.000000000000000_REALK,     -2.752548645304838_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.236835166634712_REALK, &
      0.000000000000000_REALK,     -1.687934137411406_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.348801068721744_REALK,      0.000000000000000_REALK, &
     -0.400708000604953_REALK,      0.000000000000000_REALK,     -0.929199485656602_REALK, &
      0.000000000000000_REALK,     -4.008843487027326_REALK,      0.000000000000000_REALK, &
     -0.279585413055741_REALK,      0.665990367490523_REALK,      0.000000000000000_REALK, &
      0.088311540537446_REALK,      0.000000000000000_REALK,     -0.296791918745840_REALK, &
      0.429243002027775_REALK,      0.000000000000000_REALK,      0.874738311021654_REALK, &
      0.000000000000000_REALK,      0.209854416443332_REALK,      0.000000000000000_REALK, &
      0.211231143443673_REALK,      0.000000000000000_REALK,     -0.993849437706503_REALK, &
     -0.094522531491085_REALK,      1.277184205053313_REALK,      0.000000000000000_REALK, &
      0.383157714698149_REALK,      0.000000000000000_REALK,     -0.174545994525691_REALK, &
      1.229258328045046_REALK,      0.000000000000000_REALK,      2.160903452317498_REALK, &
      0.000000000000000_REALK,      1.530852362925934_REALK,      0.000000000000000_REALK, &
      0.909999552131560_REALK,      0.000000000000000_REALK,     -0.580365418866263_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.587738836999956_REALK, &
      0.000000000000000_REALK,     -0.414612475613667_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.101504637636263_REALK,      0.000000000000000_REALK, &
      1.080743481847858_REALK,      0.000000000000000_REALK,     -0.614712574344679_REALK, &
      0.000000000000000_REALK,     -1.388388125579714_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.787183168559668_REALK, &
      0.000000000000000_REALK,     -1.138258451085584_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.171944494283750_REALK,      0.000000000000000_REALK, &
      1.864599912638391_REALK,      0.000000000000000_REALK,     -0.538243395692964_REALK, &
      0.000000000000000_REALK,     -3.784709265528944_REALK,      0.000000000000000_REALK, &
     -0.887662900050848_REALK,      0.107433676531887_REALK,      0.000000000000000_REALK, &
      0.048311847129931_REALK,      0.000000000000000_REALK,     -1.319209186905215_REALK, &
      0.259533324139017_REALK,      0.000000000000000_REALK,      0.197550745898382_REALK, &
      0.000000000000000_REALK,      0.558580902067254_REALK,      0.000000000000000_REALK, &
      0.161779007688419_REALK,      0.000000000000000_REALK,     -5.679716534576967_REALK, &
     -0.847412392610127_REALK,      1.184830926011719_REALK,      0.000000000000000_REALK, &
      1.382114480341556_REALK,      0.000000000000000_REALK,     -2.190773047563502_REALK, &
      2.437039581455566_REALK,      0.000000000000000_REALK,      2.806507721925784_REALK, &
      0.000000000000000_REALK,      4.763141333484651_REALK,      0.000000000000000_REALK, &
      4.595530544738391_REALK,      0.000000000000000_REALK,     -9.365554569651353_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.827719168021490_REALK, &
      0.000000000000000_REALK,      0.620634519003548_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.613057175283803_REALK,      0.000000000000000_REALK, &
      4.321078653654239_REALK,      0.000000000000000_REALK,      0.797040776524629_REALK, &
      0.000000000000000_REALK,      2.672076706639054_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.814049924414298_REALK, &
      0.000000000000000_REALK,      2.486510887317548_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.737449461761735_REALK,      0.000000000000000_REALK, &
     20.751984800476613_REALK,      0.000000000000000_REALK,     -0.172644730725550_REALK, &
      0.000000000000000_REALK,     10.629833806429321_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.929464932821578_REALK, &
      0.000000000000000_REALK,     -1.781039230216905_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.167787990358116_REALK,      0.000000000000000_REALK, &
     -1.917454150601780_REALK,      0.000000000000000_REALK,     -1.364793321829664_REALK, &
      0.000000000000000_REALK,     -2.937729208595079_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.208684025862177_REALK, &
      0.000000000000000_REALK,     -6.192822695825230_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.940067014375212_REALK,      0.000000000000000_REALK, &
     -3.300800177046547_REALK,      0.000000000000000_REALK,     -3.744092383601191_REALK, &
      0.000000000000000_REALK,     -7.077110284216079_REALK,      0.000000000000000_REALK, &
      0.479264879337441_REALK,      1.303074255316436_REALK,      0.000000000000000_REALK, &
      0.008333803955855_REALK,      0.000000000000000_REALK,      0.376098092739147_REALK, &
      0.565836282831266_REALK,      0.000000000000000_REALK,      1.294962710591991_REALK, &
      0.000000000000000_REALK,     -0.106774412039968_REALK,      0.000000000000000_REALK, &
      0.013746165095330_REALK,      0.000000000000000_REALK,      0.868495239761220_REALK, &
      1.406626455856501_REALK,      5.801484875827506_REALK,      0.000000000000000_REALK, &
     -0.773171587067604_REALK,      0.000000000000000_REALK,      0.888231340327611_REALK, &
      1.054634408682644_REALK,      0.000000000000000_REALK,      4.550007125170531_REALK, &
      0.000000000000000_REALK,     -2.200908495891780_REALK,      0.000000000000000_REALK, &
     -0.883574560270962_REALK,      0.000000000000000_REALK,      1.421089549469342_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.336067660198981_REALK, &
      0.000000000000000_REALK,     -0.799223344034506_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.099375702057745_REALK,      0.000000000000000_REALK, &
      0.467565928023847_REALK,      0.000000000000000_REALK,     -0.646891600189881_REALK, &
      0.000000000000000_REALK,     -1.845586784938682_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.599920296019381_REALK, &
      0.000000000000000_REALK,     -4.789977157613082_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.032842628927600_REALK,      0.000000000000000_REALK, &
      0.658710373600095_REALK,      0.000000000000000_REALK,     -3.113927920697653_REALK, &
      0.000000000000000_REALK,     -7.663528826139100_REALK,      0.000000000000000_REALK, &
     -0.898791746695499_REALK,      0.469479914269886_REALK,      0.000000000000000_REALK, &
      0.092741880519574_REALK,      0.000000000000000_REALK,     -0.987444369044627_REALK, &
      0.289197381803295_REALK,      0.000000000000000_REALK,      0.653180409189581_REALK, &
      0.000000000000000_REALK,      0.209243997459425_REALK,      0.000000000000000_REALK, &
      0.214161899017177_REALK,      0.000000000000000_REALK,     -2.931726268608550_REALK, &
     -4.675288244709046_REALK,      3.912231551216232_REALK,      0.000000000000000_REALK, &
      0.381141600339988_REALK,      0.000000000000000_REALK,     -4.133174473874163_REALK, &
      0.610902194960717_REALK,      0.000000000000000_REALK,      4.295616474073197_REALK, &
      0.000000000000000_REALK,     -1.179865818542423_REALK,      0.000000000000000_REALK, &
      0.609791977066923_REALK,      0.000000000000000_REALK,     -8.502048164792397_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.493785769604785_REALK, &
      0.000000000000000_REALK,     -0.180496459071297_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.076110474076609_REALK,      0.000000000000000_REALK, &
      2.672076706639054_REALK,      0.000000000000000_REALK,     -0.547582365202157_REALK, &
      0.000000000000000_REALK,     -0.535894706617375_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      7.529758667776978_REALK, &
      0.000000000000000_REALK,     -6.221059004867589_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -5.215892511184975_REALK,      0.000000000000000_REALK, &
     10.629833806429325_REALK,      0.000000000000000_REALK,     -8.642830878398085_REALK, &
      0.000000000000000_REALK,    -12.796881338963292_REALK,      0.000000000000000_REALK, &
     -2.795015064650225_REALK,     -0.702765734059144_REALK,      0.000000000000000_REALK, &
     -0.560132784332273_REALK,      0.000000000000000_REALK,     -3.948045818841662_REALK, &
     -0.374975420027998_REALK,      0.000000000000000_REALK,     -1.257103921066513_REALK, &
      0.000000000000000_REALK,     -0.557527266396126_REALK,      0.000000000000000_REALK, &
     -1.663036469917381_REALK,      0.000000000000000_REALK,    -14.326600171763040_REALK, &
    -40.470437863611323_REALK,     -8.546219302416551_REALK,      0.000000000000000_REALK, &
     -3.851325807925577_REALK,      0.000000000000000_REALK,    -45.999988135893794_REALK, &
      0.195950467377038_REALK,      0.000000000000000_REALK,    -12.064781205638104_REALK, &
      0.000000000000000_REALK,      4.171546551972409_REALK,      0.000000000000000_REALK, &
     -7.922278075669776_REALK,      0.000000000000000_REALK,   -115.650554072150001_REALK/
    ! results of test 7, ket-major order, 03ODGXXX
  data REF_CONTR_INTS(65521:66780)                                                         &
     /0.000000000000000_REALK,      0.000000000000000_REALK,      6.775293439895970_REALK, &
      0.000000000000000_REALK,      8.483426252215706_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     13.561403208615404_REALK,      0.000000000000000_REALK, &
      6.394451889849557_REALK,      0.000000000000000_REALK,     37.894308617635026_REALK, &
      0.000000000000000_REALK,     13.594495509370322_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.504570878666005_REALK, &
      0.000000000000000_REALK,      9.145570822552967_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     16.749418085850220_REALK,      0.000000000000000_REALK, &
      6.057896669816125_REALK,      0.000000000000000_REALK,     49.711850240757641_REALK, &
      0.000000000000000_REALK,     14.486676071879291_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.020535997228246_REALK, &
      0.000000000000000_REALK,      3.620831466443514_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      4.400434310273159_REALK,      0.000000000000000_REALK, &
      3.349167646880901_REALK,      0.000000000000000_REALK,      8.354345708381032_REALK, &
      0.000000000000000_REALK,      4.786691854757032_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.927866659188283_REALK, &
      0.000000000000000_REALK,      1.750126448153901_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.545361668122045_REALK,      0.000000000000000_REALK, &
      1.888772323198920_REALK,      0.000000000000000_REALK,      0.439307486403718_REALK, &
      0.000000000000000_REALK,      2.369265748753030_REALK,      0.000000000000000_REALK, &
      3.884992328926648_REALK,      4.020535997228247_REALK,      0.000000000000000_REALK, &
      5.548413418709843_REALK,      0.000000000000000_REALK,     -1.238984581113063_REALK, &
      9.335719176605314_REALK,      0.000000000000000_REALK,     -1.586117219451256_REALK, &
      0.000000000000000_REALK,     24.567315377471022_REALK,      0.000000000000000_REALK, &
     -3.473716454344696_REALK,      0.000000000000000_REALK,     -4.428694451291213_REALK, &
      1.115008471351495_REALK,      1.927866659188283_REALK,      0.000000000000000_REALK, &
      3.318403771005471_REALK,      0.000000000000000_REALK,     -1.936360880735163_REALK, &
      6.481429308136115_REALK,      0.000000000000000_REALK,     -3.047295316815151_REALK, &
      0.000000000000000_REALK,     18.049590172716393_REALK,      0.000000000000000_REALK, &
     -7.247838545642861_REALK,      0.000000000000000_REALK,     -5.784362816173948_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.161868232448746_REALK, &
      0.000000000000000_REALK,      2.211411318547784_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.297910466687112_REALK,      0.000000000000000_REALK, &
      2.306408957501271_REALK,      0.000000000000000_REALK,      3.588463267673318_REALK, &
      0.000000000000000_REALK,      2.410748225572630_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.993164661042822_REALK, &
      0.000000000000000_REALK,      1.513964346395500_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.831960657856964_REALK,      0.000000000000000_REALK, &
      1.378374726813886_REALK,      0.000000000000000_REALK,      3.600991099369117_REALK, &
      0.000000000000000_REALK,      1.569288729735902_REALK,      0.000000000000000_REALK, &
      2.535523830672630_REALK,      1.922861522767549_REALK,      0.000000000000000_REALK, &
      1.978051967284203_REALK,      0.000000000000000_REALK,     -0.712980143563181_REALK, &
      2.448034478453017_REALK,      0.000000000000000_REALK,     -0.664261299453749_REALK, &
      0.000000000000000_REALK,      4.275022370336014_REALK,      0.000000000000000_REALK, &
     -1.021217897789723_REALK,      0.000000000000000_REALK,     -2.101563027218705_REALK, &
      0.933112291270528_REALK,      0.551108321632924_REALK,      0.000000000000000_REALK, &
      0.372306177438802_REALK,      0.000000000000000_REALK,     -0.734149742635528_REALK, &
      0.070666880450194_REALK,      0.000000000000000_REALK,     -0.614888011723583_REALK, &
      0.000000000000000_REALK,     -1.061987898285223_REALK,      0.000000000000000_REALK, &
     -0.622619021024076_REALK,      0.000000000000000_REALK,     -1.679178002194588_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.442615040115217_REALK, &
      0.000000000000000_REALK,     -0.479620792299600_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.684731047753909_REALK,      0.000000000000000_REALK, &
      0.666944114800489_REALK,      0.000000000000000_REALK,     -1.457441803100006_REALK, &
      0.000000000000000_REALK,      1.080067898791235_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.338458779161230_REALK, &
      0.000000000000000_REALK,      0.407508426321171_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.647154191810341_REALK,      0.000000000000000_REALK, &
      1.719776157794167_REALK,      0.000000000000000_REALK,      1.449489186439792_REALK, &
      0.000000000000000_REALK,      3.103600538755864_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.925426323843173_REALK, &
      0.000000000000000_REALK,      1.555213510071008_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.349578038340781_REALK,      0.000000000000000_REALK, &
      1.855711578794185_REALK,      0.000000000000000_REALK,      1.609911397934686_REALK, &
      0.000000000000000_REALK,      1.397916907084966_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.329981198566440_REALK, &
      0.000000000000000_REALK,      0.739437882467696_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.464153293664243_REALK,      0.000000000000000_REALK, &
      0.981283589504282_REALK,      0.000000000000000_REALK,     -0.021834163725111_REALK, &
      0.000000000000000_REALK,      0.669746504682866_REALK,      0.000000000000000_REALK, &
      2.215576329152866_REALK,      1.321185173685406_REALK,      0.000000000000000_REALK, &
      1.152717436944855_REALK,      0.000000000000000_REALK,     -0.547929228954277_REALK, &
      1.247503156744251_REALK,      0.000000000000000_REALK,     -0.396902099976129_REALK, &
      0.000000000000000_REALK,      1.931379941267870_REALK,      0.000000000000000_REALK, &
     -0.490696084608036_REALK,      0.000000000000000_REALK,     -1.331675660561124_REALK, &
      0.427180295012026_REALK,      0.403801463448821_REALK,      0.000000000000000_REALK, &
      0.460871723687677_REALK,      0.000000000000000_REALK,     -0.559456283489776_REALK, &
      0.683653615897700_REALK,      0.000000000000000_REALK,     -0.480675356379736_REALK, &
      0.000000000000000_REALK,      1.491655878837778_REALK,      0.000000000000000_REALK, &
     -0.673478532096011_REALK,      0.000000000000000_REALK,     -1.118149290786368_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.286544558428689_REALK, &
      0.000000000000000_REALK,     -0.224155436998870_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.238820791324631_REALK,      0.000000000000000_REALK, &
      0.375477749870856_REALK,      0.000000000000000_REALK,     -0.351655639626601_REALK, &
      0.000000000000000_REALK,      0.416208881196314_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.108689811162322_REALK, &
      0.000000000000000_REALK,      0.085864152717375_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.065612773180672_REALK,      0.000000000000000_REALK, &
      0.589223264393580_REALK,      0.000000000000000_REALK,      0.014420339209417_REALK, &
      0.000000000000000_REALK,      0.571429510993861_REALK,      0.000000000000000_REALK, &
      1.426239216162292_REALK,      1.317696591729078_REALK,      0.000000000000000_REALK, &
      1.579548760475287_REALK,      0.000000000000000_REALK,      0.143804228722992_REALK, &
      2.329955504748678_REALK,      0.000000000000000_REALK,      0.161390014164390_REALK, &
      0.000000000000000_REALK,      4.755389584235825_REALK,      0.000000000000000_REALK, &
      0.274134880975418_REALK,      0.000000000000000_REALK,     -0.684897131619733_REALK, &
      0.690669994819908_REALK,      1.034869546279940_REALK,      0.000000000000000_REALK, &
      1.550131214959873_REALK,      0.000000000000000_REALK,     -0.530769717454560_REALK, &
      2.620147978185504_REALK,      0.000000000000000_REALK,     -0.722853316960694_REALK, &
      0.000000000000000_REALK,      5.641193414047703_REALK,      0.000000000000000_REALK, &
     -1.329207423314566_REALK,      0.000000000000000_REALK,     -2.448830093531583_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.158400952415116_REALK, &
      0.000000000000000_REALK,      1.265060310673889_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.959248161489025_REALK,      0.000000000000000_REALK, &
      1.726892184710044_REALK,      0.000000000000000_REALK,      0.927614085992253_REALK, &
      0.000000000000000_REALK,      0.936153982599326_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.082157895134936_REALK, &
      0.000000000000000_REALK,      0.861415998593071_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.723452891098675_REALK,      0.000000000000000_REALK, &
      1.026388746727358_REALK,      0.000000000000000_REALK,      0.993375833252288_REALK, &
      0.000000000000000_REALK,      0.579830850011674_REALK,      0.000000000000000_REALK, &
      2.317290110937858_REALK,      1.056206967690776_REALK,      0.000000000000000_REALK, &
      0.767499053800730_REALK,      0.000000000000000_REALK,     -0.499791328421531_REALK, &
      0.665070382537255_REALK,      0.000000000000000_REALK,     -0.273492475981431_REALK, &
      0.000000000000000_REALK,      0.778433337081412_REALK,      0.000000000000000_REALK, &
     -0.268975237764757_REALK,      0.000000000000000_REALK,     -1.000017112814635_REALK, &
      0.887746831160096_REALK,      0.326971019542053_REALK,      0.000000000000000_REALK, &
      0.154237608691431_REALK,      0.000000000000000_REALK,     -0.526087904235592_REALK, &
     -0.005254526541568_REALK,      0.000000000000000_REALK,     -0.260041353134384_REALK, &
      0.000000000000000_REALK,     -0.350048201291218_REALK,      0.000000000000000_REALK, &
     -0.167499533644446_REALK,      0.000000000000000_REALK,     -0.781396711001754_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.250324895366694_REALK, &
      0.000000000000000_REALK,     -0.151839166226063_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.136363705043566_REALK,      0.000000000000000_REALK, &
      0.282730547346812_REALK,      0.000000000000000_REALK,     -0.167254001985768_REALK, &
      0.000000000000000_REALK,      0.232108260827707_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.137317429025479_REALK, &
      0.000000000000000_REALK,      0.088661004244172_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.089964822334326_REALK,      0.000000000000000_REALK, &
      0.497354329160390_REALK,      0.000000000000000_REALK,      0.136943121578881_REALK, &
      0.000000000000000_REALK,      0.438493387213232_REALK,      0.000000000000000_REALK, &
      1.043774459928598_REALK,      0.700054001472689_REALK,      0.000000000000000_REALK, &
      0.624561539020574_REALK,      0.000000000000000_REALK,      0.091781786339931_REALK, &
      0.668046167200660_REALK,      0.000000000000000_REALK,      0.073904252543821_REALK, &
      0.000000000000000_REALK,      0.916283069278548_REALK,      0.000000000000000_REALK, &
      0.089238285885981_REALK,      0.000000000000000_REALK,     -0.359877684660324_REALK, &
      0.690763268957752_REALK,      0.361506596702492_REALK,      0.000000000000000_REALK, &
      0.207593625355086_REALK,      0.000000000000000_REALK,     -0.240203330590469_REALK, &
      0.033042224422149_REALK,      0.000000000000000_REALK,     -0.168705788995358_REALK, &
      0.000000000000000_REALK,     -0.384533796591992_REALK,      0.000000000000000_REALK, &
     -0.132287233796616_REALK,      0.000000000000000_REALK,     -0.823590194633617_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.569293094478672_REALK, &
      0.000000000000000_REALK,     -0.535009824229015_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.660138682960038_REALK,      0.000000000000000_REALK, &
     -0.068596992172181_REALK,      0.000000000000000_REALK,     -1.103592416982066_REALK, &
      0.000000000000000_REALK,     -0.087250718261273_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.260596290070384_REALK, &
      0.000000000000000_REALK,     -0.266706470279506_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.355176572901810_REALK,      0.000000000000000_REALK, &
      0.943711336867272_REALK,      0.000000000000000_REALK,     -0.616045961757647_REALK, &
      0.000000000000000_REALK,      1.318847737269451_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.929068626894676_REALK, &
      0.000000000000000_REALK,      1.144800741712445_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.777378361533535_REALK,      0.000000000000000_REALK, &
      1.838099616984495_REALK,      0.000000000000000_REALK,      0.574153433732571_REALK, &
      0.000000000000000_REALK,      0.695723555260569_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.018280218609042_REALK, &
      0.000000000000000_REALK,      0.624342715608671_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.298804740997583_REALK,      0.000000000000000_REALK, &
      1.105056712101192_REALK,      0.000000000000000_REALK,     -0.091764704791971_REALK, &
      0.000000000000000_REALK,      0.380863199137705_REALK,      0.000000000000000_REALK, &
      2.859363597763882_REALK,      0.988242986089264_REALK,      0.000000000000000_REALK, &
      0.628620959901860_REALK,      0.000000000000000_REALK,     -0.535946573627272_REALK, &
      0.458103084959113_REALK,      0.000000000000000_REALK,     -0.218948292952791_REALK, &
      0.000000000000000_REALK,      0.473739707966660_REALK,      0.000000000000000_REALK, &
     -0.180923114664369_REALK,      0.000000000000000_REALK,     -0.880665454755568_REALK, &
      0.564223287922309_REALK,      0.297794872915093_REALK,      0.000000000000000_REALK, &
      0.245178517511990_REALK,      0.000000000000000_REALK,     -0.561201694893679_REALK, &
      0.279339654351152_REALK,      0.000000000000000_REALK,     -0.263060265096435_REALK, &
      0.000000000000000_REALK,      0.511116597802892_REALK,      0.000000000000000_REALK, &
     -0.241303327472736_REALK,      0.000000000000000_REALK,     -0.755422321302304_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.262640558926406_REALK, &
      0.000000000000000_REALK,     -0.120565716712964_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.089357034804363_REALK,      0.000000000000000_REALK, &
      0.253811883870556_REALK,      0.000000000000000_REALK,     -0.084382279907153_REALK, &
      0.000000000000000_REALK,      0.151356600983604_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.100951910434139_REALK, &
      0.000000000000000_REALK,      0.048917755037018_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.026144753154394_REALK,      0.000000000000000_REALK, &
      0.406124942047437_REALK,      0.000000000000000_REALK,     -0.000972833655441_REALK, &
      0.000000000000000_REALK,      0.219257519778776_REALK,      0.000000000000000_REALK, &
      1.042148055214512_REALK,      0.545455816831066_REALK,      0.000000000000000_REALK, &
      0.410941433664899_REALK,      0.000000000000000_REALK,      0.079638499555215_REALK, &
      0.379835591624077_REALK,      0.000000000000000_REALK,      0.049269588165483_REALK, &
      0.000000000000000_REALK,      0.465522047091042_REALK,      0.000000000000000_REALK, &
      0.048219939564383_REALK,      0.000000000000000_REALK,     -0.256443814095655_REALK, &
      0.354290725466838_REALK,      0.291832531021004_REALK,      0.000000000000000_REALK, &
      0.290296404934427_REALK,      0.000000000000000_REALK,     -0.206779915319805_REALK, &
      0.366653636779721_REALK,      0.000000000000000_REALK,     -0.151269837994522_REALK, &
      0.000000000000000_REALK,      0.632801413973741_REALK,      0.000000000000000_REALK, &
     -0.167649845060239_REALK,      0.000000000000000_REALK,     -0.642536898595306_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.417940316222180_REALK, &
      0.000000000000000_REALK,     -0.282314095139903_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.256893048252210_REALK,      0.000000000000000_REALK, &
     -0.043088848912457_REALK,      0.000000000000000_REALK,     -0.299444499169120_REALK, &
      0.000000000000000_REALK,     -0.037810338250118_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.092201467760338_REALK, &
      0.000000000000000_REALK,     -0.063482887216205_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.041303938288393_REALK,      0.000000000000000_REALK, &
      0.370863130286241_REALK,      0.000000000000000_REALK,     -0.007180545864620_REALK, &
      0.000000000000000_REALK,      0.284495469106493_REALK,      0.000000000000000_REALK, &
      1.118108191411694_REALK,      0.906692573068288_REALK,      0.000000000000000_REALK, &
      0.938509894633124_REALK,      0.000000000000000_REALK,      0.380459684642043_REALK, &
      1.182361774423179_REALK,      0.000000000000000_REALK,      0.364678853477128_REALK, &
      0.000000000000000_REALK,      1.910325571428527_REALK,      0.000000000000000_REALK, &
      0.490361938807377_REALK,      0.000000000000000_REALK,      0.033150768952094_REALK, &
      0.954702172908178_REALK,      1.246522636759879_REALK,      0.000000000000000_REALK, &
      1.627341896348152_REALK,      0.000000000000000_REALK,     -0.164824343908354_REALK, &
      2.342040771239780_REALK,      0.000000000000000_REALK,     -0.191127722564614_REALK, &
      0.000000000000000_REALK,      3.988582107031851_REALK,      0.000000000000000_REALK, &
     -0.278000245635688_REALK,      0.000000000000000_REALK,     -1.865497142269325_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,    -22.774803933218131_REALK, &
      0.000000000000000_REALK,     26.794157271152290_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,    -20.444403452610391_REALK,      0.000000000000000_REALK, &
    -27.654944864152871_REALK,      0.000000000000000_REALK,    137.800947958552911_REALK, &
      0.000000000000000_REALK,     98.013794606133857_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,    -22.197767476565410_REALK, &
      0.000000000000000_REALK,     30.388998029610807_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,    -30.783124430490926_REALK,      0.000000000000000_REALK, &
    -30.543809830358875_REALK,      0.000000000000000_REALK,    202.853375568355148_REALK, &
      0.000000000000000_REALK,    121.142525168036769_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -6.086972447112518_REALK, &
      0.000000000000000_REALK,      7.732872663879500_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.925005406049845_REALK,      0.000000000000000_REALK, &
     -6.872212974292422_REALK,      0.000000000000000_REALK,     27.407041797850500_REALK, &
      0.000000000000000_REALK,     30.627340592386172_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.531821360083569_REALK, &
      0.000000000000000_REALK,      4.020174290309383_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.378904710860877_REALK,      0.000000000000000_REALK, &
     -5.489849773256239_REALK,      0.000000000000000_REALK,     -0.891608703179176_REALK, &
      0.000000000000000_REALK,     18.298950867349021_REALK,      0.000000000000000_REALK, &
     23.838134441360214_REALK,     -6.086972447112517_REALK,      0.000000000000000_REALK, &
     22.947939937556644_REALK,      0.000000000000000_REALK,      0.611319667245958_REALK, &
     -9.661879393977646_REALK,      0.000000000000000_REALK,     -0.135338986364621_REALK, &
      0.000000000000000_REALK,    161.055885863897544_REALK,      0.000000000000000_REALK, &
      1.789939875884562_REALK,      0.000000000000000_REALK,    -36.139162128464015_REALK, &
      8.547900441777312_REALK,     -4.531821360083569_REALK,      0.000000000000000_REALK, &
     13.680182155232291_REALK,      0.000000000000000_REALK,     -5.746186239678622_REALK, &
     -9.192763287074253_REALK,      0.000000000000000_REALK,      2.324008802957140_REALK, &
      0.000000000000000_REALK,    132.052634059651496_REALK,      0.000000000000000_REALK, &
    -26.360309055999867_REALK,      0.000000000000000_REALK,    -72.905787450471635_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.287597597856199_REALK, &
      0.000000000000000_REALK,      2.689802497990677_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.144680322495209_REALK,      0.000000000000000_REALK, &
      0.465223500939159_REALK,      0.000000000000000_REALK,      8.213645375114993_REALK, &
      0.000000000000000_REALK,     10.790999296519782_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.344721672529514_REALK, &
      0.000000000000000_REALK,      1.664745872629581_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.009856671659180_REALK,      0.000000000000000_REALK, &
     -0.028778942851515_REALK,      0.000000000000000_REALK,      9.395851147443679_REALK, &
      0.000000000000000_REALK,      7.776995915379662_REALK,      0.000000000000000_REALK, &
     11.955946741816431_REALK,     -0.149349518778076_REALK,      0.000000000000000_REALK, &
      6.893729333034897_REALK,      0.000000000000000_REALK,      0.318970466952053_REALK, &
      0.216188750984868_REALK,      0.000000000000000_REALK,      0.004757803788739_REALK, &
      0.000000000000000_REALK,     27.815129914272724_REALK,      0.000000000000000_REALK, &
      0.544655393737185_REALK,      0.000000000000000_REALK,    -19.099985071680390_REALK, &
      3.481110255561678_REALK,     -0.092486769161771_REALK,      0.000000000000000_REALK, &
      1.204171977459851_REALK,      0.000000000000000_REALK,     -2.029513898856607_REALK, &
      0.000376213144333_REALK,      0.000000000000000_REALK,      0.003268610454623_REALK, &
      0.000000000000000_REALK,     -8.886294607480284_REALK,      0.000000000000000_REALK, &
     -2.381385740752882_REALK,      0.000000000000000_REALK,    -26.427552971285046_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.143802689398227_REALK, &
      0.000000000000000_REALK,     -3.884956368092166_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.171966972292137_REALK,      0.000000000000000_REALK, &
     -0.089519676357906_REALK,      0.000000000000000_REALK,    -21.912524727767611_REALK, &
      0.000000000000000_REALK,     -5.997945586550739_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.102194784232710_REALK, &
      0.000000000000000_REALK,     -1.568940003686876_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.008598535138298_REALK,      0.000000000000000_REALK, &
     -0.013857484982762_REALK,      0.000000000000000_REALK,    -12.273145343249611_REALK, &
      0.000000000000000_REALK,     11.904734042268197_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.617514146356768_REALK, &
      0.000000000000000_REALK,      0.681804508556546_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.014749538808879_REALK,      0.000000000000000_REALK, &
      3.980660639519203_REALK,      0.000000000000000_REALK,      1.235986299012096_REALK, &
      0.000000000000000_REALK,      2.551669013198302_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.900121443737068_REALK, &
      0.000000000000000_REALK,      0.202682738963479_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.386259494010208_REALK,      0.000000000000000_REALK, &
      2.290055821214423_REALK,      0.000000000000000_REALK,     -2.022078936310553_REALK, &
      0.000000000000000_REALK,      0.904618198637182_REALK,      0.000000000000000_REALK, &
      8.692007520888275_REALK,      0.693000031859761_REALK,      0.000000000000000_REALK, &
      3.514223746121000_REALK,      0.000000000000000_REALK,      0.222539903505229_REALK, &
      0.802183372239507_REALK,      0.000000000000000_REALK,      0.020755140660709_REALK, &
      0.000000000000000_REALK,     11.511944818851619_REALK,      0.000000000000000_REALK, &
      0.259012181278502_REALK,      0.000000000000000_REALK,    -12.431217021005642_REALK, &
      1.533652013551763_REALK,      0.159249570767461_REALK,      0.000000000000000_REALK, &
      1.080403450172060_REALK,      0.000000000000000_REALK,     -1.335389071562596_REALK, &
      0.489494129862020_REALK,      0.000000000000000_REALK,     -0.171514380623022_REALK, &
      0.000000000000000_REALK,      8.570356342081160_REALK,      0.000000000000000_REALK, &
     -2.041323459607763_REALK,      0.000000000000000_REALK,    -16.613356011166946_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.000919171155809_REALK, &
      0.000000000000000_REALK,     -1.407544519487160_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.647880916176454_REALK,      0.000000000000000_REALK, &
     -0.585787673729580_REALK,      0.000000000000000_REALK,     -4.713890446368820_REALK, &
      0.000000000000000_REALK,     -2.027223888916609_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.150084782461346_REALK, &
      0.000000000000000_REALK,     -0.276970263811759_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.095908128288595_REALK,      0.000000000000000_REALK, &
      0.620198994195887_REALK,      0.000000000000000_REALK,      0.060232350113215_REALK, &
      0.000000000000000_REALK,      2.007849411068963_REALK,      0.000000000000000_REALK, &
      4.010369478100301_REALK,      0.923594943341198_REALK,      0.000000000000000_REALK, &
      3.854317836266756_REALK,      0.000000000000000_REALK,      3.578475494935050_REALK, &
      1.974752469007713_REALK,      0.000000000000000_REALK,      0.964050606514118_REALK, &
      0.000000000000000_REALK,     25.560918920564326_REALK,      0.000000000000000_REALK, &
      9.900660404390164_REALK,      0.000000000000000_REALK,     12.121114251052873_REALK, &
      1.789704412072151_REALK,      0.590787090508261_REALK,      0.000000000000000_REALK, &
      3.710004870276927_REALK,      0.000000000000000_REALK,      0.895768048805284_REALK, &
      2.516874578217703_REALK,      0.000000000000000_REALK,      0.365751853675220_REALK, &
      0.000000000000000_REALK,     35.115342991054305_REALK,      0.000000000000000_REALK, &
      4.029337207123281_REALK,      0.000000000000000_REALK,    -14.056372364985673_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.981656707419159_REALK, &
      0.000000000000000_REALK,     -0.516916961823070_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.589418484111325_REALK,      0.000000000000000_REALK, &
      6.454234778755866_REALK,      0.000000000000000_REALK,     -1.689808958948191_REALK, &
      0.000000000000000_REALK,     -1.661174739505510_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.991138167023507_REALK, &
      0.000000000000000_REALK,     -0.333029495420431_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.006948214878889_REALK,      0.000000000000000_REALK, &
      4.210606689710990_REALK,      0.000000000000000_REALK,      0.032355829755103_REALK, &
      0.000000000000000_REALK,     -1.179078888927783_REALK,      0.000000000000000_REALK, &
      8.628176121992912_REALK,      0.399632101631588_REALK,      0.000000000000000_REALK, &
      2.530291028298360_REALK,      0.000000000000000_REALK,      0.195475834990172_REALK, &
      0.250796023726926_REALK,      0.000000000000000_REALK,      0.010196652974981_REALK, &
      0.000000000000000_REALK,      5.820199710931111_REALK,      0.000000000000000_REALK, &
      0.160136864351848_REALK,      0.000000000000000_REALK,     -9.376243863664479_REALK, &
      2.710366279691972_REALK,      0.077262360341731_REALK,      0.000000000000000_REALK, &
      0.491511342565600_REALK,      0.000000000000000_REALK,     -1.233609639146062_REALK, &
     -0.243113434124987_REALK,      0.000000000000000_REALK,     -0.046041925904085_REALK, &
      0.000000000000000_REALK,     -1.596191176808219_REALK,      0.000000000000000_REALK, &
     -0.736666663312362_REALK,      0.000000000000000_REALK,    -12.174157511894693_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.588707936232893_REALK, &
      0.000000000000000_REALK,     -0.630337239504366_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.640122143446849_REALK,      0.000000000000000_REALK, &
     -0.792118455643440_REALK,      0.000000000000000_REALK,     -1.541848791669632_REALK, &
      0.000000000000000_REALK,     -0.779547539352891_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.393525909603673_REALK, &
      0.000000000000000_REALK,     -0.168721031997733_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.189730427852419_REALK,      0.000000000000000_REALK, &
      0.899768883674402_REALK,      0.000000000000000_REALK,     -0.721694913399235_REALK, &
      0.000000000000000_REALK,      0.970239215864850_REALK,      0.000000000000000_REALK, &
      3.044468679423040_REALK,      0.761281326684206_REALK,      0.000000000000000_REALK, &
      1.490696869890620_REALK,      0.000000000000000_REALK,      2.403872588453273_REALK, &
      0.882610346034834_REALK,      0.000000000000000_REALK,      0.676968262480019_REALK, &
      0.000000000000000_REALK,      4.818029648237856_REALK,      0.000000000000000_REALK, &
      3.288032060300099_REALK,      0.000000000000000_REALK,      6.991751863755676_REALK, &
      1.778925965748525_REALK,      0.415603014031002_REALK,      0.000000000000000_REALK, &
      0.480401250806193_REALK,      0.000000000000000_REALK,      0.465415575367096_REALK, &
     -0.028505915808655_REALK,      0.000000000000000_REALK,      0.142363110593296_REALK, &
      0.000000000000000_REALK,     -2.686782806764104_REALK,      0.000000000000000_REALK, &
      0.413880411454073_REALK,      0.000000000000000_REALK,     -5.793355875983308_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.691474868558958_REALK, &
      0.000000000000000_REALK,     -1.938556436568604_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.620086332455188_REALK,      0.000000000000000_REALK, &
     -2.678771311639730_REALK,      0.000000000000000_REALK,     -8.758666420513320_REALK, &
      0.000000000000000_REALK,     -7.615038637018149_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.521015664253354_REALK, &
      0.000000000000000_REALK,     -2.073136152571187_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.157900318201978_REALK,      0.000000000000000_REALK, &
     -0.741136748073720_REALK,      0.000000000000000_REALK,    -12.290614757551316_REALK, &
      0.000000000000000_REALK,     -2.540647705927045_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.100166479442596_REALK, &
      0.000000000000000_REALK,     -1.813314047293090_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.449883038994487_REALK,      0.000000000000000_REALK, &
      9.142583537607450_REALK,      0.000000000000000_REALK,     -3.896974810612432_REALK, &
      0.000000000000000_REALK,     -4.670035337639278_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.255245487759520_REALK, &
      0.000000000000000_REALK,     -1.306365845811303_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.477929003281688_REALK,      0.000000000000000_REALK, &
      6.480704869920708_REALK,      0.000000000000000_REALK,     -3.519700368448996_REALK, &
      0.000000000000000_REALK,     -3.710172924187483_REALK,      0.000000000000000_REALK, &
     11.021886751864940_REALK,     -0.484700557520789_REALK,      0.000000000000000_REALK, &
      2.628309583799560_REALK,      0.000000000000000_REALK,      0.210188682477456_REALK, &
     -0.556507217956663_REALK,      0.000000000000000_REALK,     -0.010773946658821_REALK, &
      0.000000000000000_REALK,      5.071355810454774_REALK,      0.000000000000000_REALK, &
      0.133306083433291_REALK,      0.000000000000000_REALK,     -8.079746791902309_REALK, &
      2.005181824870693_REALK,     -0.156033824306646_REALK,      0.000000000000000_REALK, &
      0.802986627014042_REALK,      0.000000000000000_REALK,     -1.421422418334805_REALK, &
      0.006521178010540_REALK,      0.000000000000000_REALK,      0.100599005101837_REALK, &
      0.000000000000000_REALK,      3.128200305623008_REALK,      0.000000000000000_REALK, &
     -0.965417029254302_REALK,      0.000000000000000_REALK,    -11.252615855874291_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.232448682603202_REALK, &
      0.000000000000000_REALK,     -0.205367430736867_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.642332926685537_REALK,      0.000000000000000_REALK, &
     -0.969687017574261_REALK,      0.000000000000000_REALK,     -0.256193453282862_REALK, &
      0.000000000000000_REALK,     -0.203541895700219_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.446815380690559_REALK, &
      0.000000000000000_REALK,     -0.028383697158451_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.114778048748748_REALK,      0.000000000000000_REALK, &
      1.105287289369595_REALK,      0.000000000000000_REALK,      0.180190165224907_REALK, &
      0.000000000000000_REALK,      0.130932583025096_REALK,      0.000000000000000_REALK, &
      3.243461535025961_REALK,      0.545391343493370_REALK,      0.000000000000000_REALK, &
      0.976750515307645_REALK,      0.000000000000000_REALK,      2.155698376632213_REALK, &
      0.468551698894779_REALK,      0.000000000000000_REALK,      0.422508452391242_REALK, &
      0.000000000000000_REALK,      2.201839249842746_REALK,      0.000000000000000_REALK, &
      1.726565102088476_REALK,      0.000000000000000_REALK,      5.024758134064437_REALK, &
      1.038448475684121_REALK,      0.311171356768059_REALK,      0.000000000000000_REALK, &
      0.595569568965256_REALK,      0.000000000000000_REALK,      0.423143451889668_REALK, &
      0.572560646890169_REALK,      0.000000000000000_REALK,      0.115320845101046_REALK, &
      0.000000000000000_REALK,      3.006257620573075_REALK,      0.000000000000000_REALK, &
      0.411597200130402_REALK,      0.000000000000000_REALK,     -4.225188498267705_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.817737576798512_REALK, &
      0.000000000000000_REALK,     -0.902762627259174_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.873245267289092_REALK,      0.000000000000000_REALK, &
     -2.507871640802090_REALK,      0.000000000000000_REALK,     -2.080528103937623_REALK, &
      0.000000000000000_REALK,     -2.841972292651092_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.971323461261814_REALK, &
      0.000000000000000_REALK,     -0.505691387311289_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.371565427513559_REALK,      0.000000000000000_REALK, &
     -0.512056593133922_REALK,      0.000000000000000_REALK,      0.069978237383771_REALK, &
      0.000000000000000_REALK,     -0.497131577929358_REALK,      0.000000000000000_REALK, &
      2.494145553103703_REALK,      1.211449407971730_REALK,      0.000000000000000_REALK, &
      1.785461600582721_REALK,      0.000000000000000_REALK,      3.267798941030067_REALK, &
      1.922406722017265_REALK,      0.000000000000000_REALK,      1.850063920017338_REALK, &
      0.000000000000000_REALK,      8.148208292483364_REALK,      0.000000000000000_REALK, &
      6.221629059833560_REALK,      0.000000000000000_REALK,     15.085169844919418_REALK, &
      2.019706124356683_REALK,      1.923982375887115_REALK,      0.000000000000000_REALK, &
      3.408550761134561_REALK,      0.000000000000000_REALK,      3.077684285315799_REALK, &
      4.906641533004564_REALK,      0.000000000000000_REALK,      2.666505633697235_REALK, &
      0.000000000000000_REALK,     20.529245080813745_REALK,      0.000000000000000_REALK, &
      8.809330262130745_REALK,      0.000000000000000_REALK,      3.436777773822087_REALK/
    ! results of test 7, ket-major order, 03ODGXXY
  data REF_CONTR_INTS(66781:68040)                                                         &
     /0.000000000000000_REALK,      0.000000000000000_REALK,      2.243154034294182_REALK, &
      0.000000000000000_REALK,      1.553528344348035_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.260395575815755_REALK,      0.000000000000000_REALK, &
      1.868581433870428_REALK,      0.000000000000000_REALK,      0.736323886393578_REALK, &
      0.000000000000000_REALK,      2.053744158197185_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.416395167221024_REALK, &
      0.000000000000000_REALK,     -0.537887848630149_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.548945671344526_REALK,      0.000000000000000_REALK, &
      0.407951277964424_REALK,      0.000000000000000_REALK,    -10.189737871227027_REALK, &
      0.000000000000000_REALK,     -0.728175531416112_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.064016077159364_REALK, &
      0.000000000000000_REALK,      1.290290373279086_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.245718303879490_REALK,      0.000000000000000_REALK, &
      1.505586197404626_REALK,      0.000000000000000_REALK,      1.835890909429663_REALK, &
      0.000000000000000_REALK,      1.406597317182354_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.272677452645452_REALK, &
      0.000000000000000_REALK,      0.993739912494012_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.424298008049745_REALK,      0.000000000000000_REALK, &
      0.880121181355167_REALK,      0.000000000000000_REALK,      3.501006575569632_REALK, &
      0.000000000000000_REALK,      1.030053877212114_REALK,      0.000000000000000_REALK, &
      1.414629918434587_REALK,      0.825009367478168_REALK,      0.000000000000000_REALK, &
      0.566564064478422_REALK,      0.000000000000000_REALK,     -0.397788823805573_REALK, &
      0.215761511926864_REALK,      0.000000000000000_REALK,     -0.285003255831862_REALK, &
      0.000000000000000_REALK,     -0.878702331721319_REALK,      0.000000000000000_REALK, &
     -0.292502609870373_REALK,      0.000000000000000_REALK,     -1.172512716234611_REALK, &
      0.201540623521745_REALK,     -0.169378886764434_REALK,      0.000000000000000_REALK, &
     -0.614088105699357_REALK,      0.000000000000000_REALK,     -0.158567193116307_REALK, &
     -1.639118408519625_REALK,      0.000000000000000_REALK,      0.188981081980301_REALK, &
      0.000000000000000_REALK,     -5.169998196421722_REALK,      0.000000000000000_REALK, &
      1.026958343327274_REALK,      0.000000000000000_REALK,     -0.362681517253939_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.020513840890586_REALK, &
      0.000000000000000_REALK,      0.965125686657097_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.777672003918945_REALK,      0.000000000000000_REALK, &
      1.281690432295288_REALK,      0.000000000000000_REALK,      0.820388664698240_REALK, &
      0.000000000000000_REALK,      0.867511442064532_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.828159776528108_REALK, &
      0.000000000000000_REALK,      0.322395446162481_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.027939576273508_REALK,      0.000000000000000_REALK, &
      0.611030892068641_REALK,      0.000000000000000_REALK,     -0.888612803978842_REALK, &
      0.000000000000000_REALK,      0.292009955552185_REALK,      0.000000000000000_REALK, &
      1.446292137229144_REALK,      0.770870844617368_REALK,      0.000000000000000_REALK, &
      0.624898676959106_REALK,      0.000000000000000_REALK,     -0.357679275214861_REALK, &
      0.638234122551447_REALK,      0.000000000000000_REALK,     -0.231580147229127_REALK, &
      0.000000000000000_REALK,      0.990802570201993_REALK,      0.000000000000000_REALK, &
     -0.266010840326383_REALK,      0.000000000000000_REALK,     -0.869296178997090_REALK, &
      0.272763580602419_REALK,      0.265048270065240_REALK,      0.000000000000000_REALK, &
      0.358314833454281_REALK,      0.000000000000000_REALK,     -0.357224574394043_REALK, &
      0.664671402572789_REALK,      0.000000000000000_REALK,     -0.315506958749768_REALK, &
      0.000000000000000_REALK,      1.747282288634477_REALK,      0.000000000000000_REALK, &
     -0.523610661405106_REALK,      0.000000000000000_REALK,     -0.713961780925211_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.159870122463144_REALK, &
      0.000000000000000_REALK,     -0.096174546687617_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.068404309114592_REALK,      0.000000000000000_REALK, &
      0.209488095614903_REALK,      0.000000000000000_REALK,     -0.030993743409770_REALK, &
      0.000000000000000_REALK,      0.178575639352516_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.023475644375328_REALK, &
      0.000000000000000_REALK,     -0.026389684258710_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.108222817760856_REALK,      0.000000000000000_REALK, &
      0.127264880347580_REALK,      0.000000000000000_REALK,     -0.334479791730891_REALK, &
      0.000000000000000_REALK,     -0.175624447385779_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.271038323766668_REALK, &
      0.000000000000000_REALK,      0.826255194058182_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.606401005468884_REALK,      0.000000000000000_REALK, &
      1.241716422828065_REALK,      0.000000000000000_REALK,      0.553651323577815_REALK, &
      0.000000000000000_REALK,      0.611434952179400_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.474770986391992_REALK, &
      0.000000000000000_REALK,      0.599056040860099_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.581830947745230_REALK,      0.000000000000000_REALK, &
      0.726980575281808_REALK,      0.000000000000000_REALK,      0.999133042893717_REALK, &
      0.000000000000000_REALK,      0.403232786416619_REALK,      0.000000000000000_REALK, &
      1.600490398390158_REALK,      0.655455002379724_REALK,      0.000000000000000_REALK, &
      0.442258624709774_REALK,      0.000000000000000_REALK,     -0.345192524044209_REALK, &
      0.338910702638694_REALK,      0.000000000000000_REALK,     -0.169722428443331_REALK, &
      0.000000000000000_REALK,      0.329797356843654_REALK,      0.000000000000000_REALK, &
     -0.154992528193672_REALK,      0.000000000000000_REALK,     -0.690685115226211_REALK, &
      0.552786925183265_REALK,      0.142559598617894_REALK,      0.000000000000000_REALK, &
     -0.009284289244740_REALK,      0.000000000000000_REALK,     -0.327587218282116_REALK, &
     -0.213850167218156_REALK,      0.000000000000000_REALK,     -0.113378216145312_REALK, &
      0.000000000000000_REALK,     -0.743366476057978_REALK,      0.000000000000000_REALK, &
      0.010082587067499_REALK,      0.000000000000000_REALK,     -0.486564265916344_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.163408014049323_REALK, &
      0.000000000000000_REALK,     -0.088593475499108_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.073924013063266_REALK,      0.000000000000000_REALK, &
      0.184561895792837_REALK,      0.000000000000000_REALK,     -0.085568690246199_REALK, &
      0.000000000000000_REALK,      0.135428019198713_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.087680059350708_REALK, &
      0.000000000000000_REALK,      0.058195543910265_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.069945125019893_REALK,      0.000000000000000_REALK, &
      0.317571173656504_REALK,      0.000000000000000_REALK,      0.133140781495042_REALK, &
      0.000000000000000_REALK,      0.287819446525226_REALK,      0.000000000000000_REALK, &
      0.582346953813168_REALK,      0.300360219452664_REALK,      0.000000000000000_REALK, &
      0.178890206079987_REALK,      0.000000000000000_REALK,      0.051207272971831_REALK, &
      0.058879338645282_REALK,      0.000000000000000_REALK,      0.031708835983867_REALK, &
      0.000000000000000_REALK,     -0.188335872831595_REALK,      0.000000000000000_REALK, &
      0.025560099934111_REALK,      0.000000000000000_REALK,     -0.200784442859056_REALK, &
      0.149196255621183_REALK,     -0.111106260791054_REALK,      0.000000000000000_REALK, &
     -0.342408436589859_REALK,      0.000000000000000_REALK,     -0.051880925234933_REALK, &
     -0.766414449933914_REALK,      0.000000000000000_REALK,      0.051850421430912_REALK, &
      0.000000000000000_REALK,     -1.871997824131382_REALK,      0.000000000000000_REALK, &
      0.218196800733248_REALK,      0.000000000000000_REALK,     -0.177885215858475_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.904024818248150_REALK, &
      0.000000000000000_REALK,      0.763666572886251_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.511006952299542_REALK,      0.000000000000000_REALK, &
      1.358562909692460_REALK,      0.000000000000000_REALK,      0.344641783150657_REALK, &
      0.000000000000000_REALK,      0.464098950815960_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.440708082016940_REALK, &
      0.000000000000000_REALK,      0.356286823497894_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.075905950663691_REALK,      0.000000000000000_REALK, &
      0.788822147456062_REALK,      0.000000000000000_REALK,     -0.371910166767901_REALK, &
      0.000000000000000_REALK,      0.217343032945820_REALK,      0.000000000000000_REALK, &
      2.056016449444012_REALK,      0.645456104628605_REALK,      0.000000000000000_REALK, &
      0.397390787334508_REALK,      0.000000000000000_REALK,     -0.385370707056130_REALK, &
      0.273421224572490_REALK,      0.000000000000000_REALK,     -0.143002798171771_REALK, &
      0.000000000000000_REALK,      0.281138579157331_REALK,      0.000000000000000_REALK, &
     -0.114372863091790_REALK,      0.000000000000000_REALK,     -0.633239740077316_REALK, &
      0.399633542114546_REALK,      0.207096011507005_REALK,      0.000000000000000_REALK, &
      0.197182775777056_REALK,      0.000000000000000_REALK,     -0.397493378901307_REALK, &
      0.280958595438129_REALK,      0.000000000000000_REALK,     -0.182940462185125_REALK, &
      0.000000000000000_REALK,      0.609834939624749_REALK,      0.000000000000000_REALK, &
     -0.194066186540943_REALK,      0.000000000000000_REALK,     -0.535057847693791_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.181398820460772_REALK, &
      0.000000000000000_REALK,     -0.074819996982016_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.051490512105545_REALK,      0.000000000000000_REALK, &
      0.175301090361852_REALK,      0.000000000000000_REALK,     -0.043000047099506_REALK, &
      0.000000000000000_REALK,      0.093928031430048_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.062861273283665_REALK, &
      0.000000000000000_REALK,      0.021328176219204_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.001573776023741_REALK,      0.000000000000000_REALK, &
      0.252888042034751_REALK,      0.000000000000000_REALK,     -0.039592651829936_REALK, &
      0.000000000000000_REALK,      0.095596435602750_REALK,      0.000000000000000_REALK, &
      0.680297274462081_REALK,      0.318256664241179_REALK,      0.000000000000000_REALK, &
      0.222775113808882_REALK,      0.000000000000000_REALK,      0.051986715245091_REALK, &
      0.194327392458616_REALK,      0.000000000000000_REALK,      0.028747286754006_REALK, &
      0.000000000000000_REALK,      0.238813933441140_REALK,      0.000000000000000_REALK, &
      0.026140470744239_REALK,      0.000000000000000_REALK,     -0.167402344521983_REALK, &
      0.226222061225564_REALK,      0.191553806752562_REALK,      0.000000000000000_REALK, &
      0.225697309338393_REALK,      0.000000000000000_REALK,     -0.132033314171729_REALK, &
      0.356473192490593_REALK,      0.000000000000000_REALK,     -0.099290895409494_REALK, &
      0.000000000000000_REALK,      0.741245161531934_REALK,      0.000000000000000_REALK, &
     -0.130343050406157_REALK,      0.000000000000000_REALK,     -0.410273290169186_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.233178985855190_REALK, &
      0.000000000000000_REALK,     -0.121127689281709_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.073580660145069_REALK,      0.000000000000000_REALK, &
     -0.024040308391146_REALK,      0.000000000000000_REALK,     -0.026392029380134_REALK, &
      0.000000000000000_REALK,     -0.016222636354473_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.019914367730315_REALK, &
      0.000000000000000_REALK,      0.019510975144438_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.068127414366127_REALK,      0.000000000000000_REALK, &
      0.080101813274095_REALK,      0.000000000000000_REALK,      0.166552773165269_REALK, &
      0.000000000000000_REALK,     -0.087437485436629_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.324746586419033_REALK, &
      0.000000000000000_REALK,      0.774178946156914_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.516796682842852_REALK,      0.000000000000000_REALK, &
      1.701718329455722_REALK,      0.000000000000000_REALK,      0.261595390663872_REALK, &
      0.000000000000000_REALK,      0.382879863637619_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.939592231840455_REALK, &
      0.000000000000000_REALK,      0.741291543834205_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.577135593731017_REALK,      0.000000000000000_REALK, &
      1.306789868567423_REALK,      0.000000000000000_REALK,      0.683223008887936_REALK, &
      0.000000000000000_REALK,      0.312161778359704_REALK,      0.000000000000000_REALK, &
      3.127669131124556_REALK,      0.706357708270313_REALK,      0.000000000000000_REALK, &
      0.395822510657715_REALK,      0.000000000000000_REALK,     -0.498369925703783_REALK, &
      0.206399691127687_REALK,      0.000000000000000_REALK,     -0.131628548963850_REALK, &
      0.000000000000000_REALK,      0.164152947882080_REALK,      0.000000000000000_REALK, &
     -0.092708606236470_REALK,      0.000000000000000_REALK,     -0.666431710295514_REALK, &
      1.582071244485486_REALK,      0.257839920055843_REALK,      0.000000000000000_REALK, &
      0.040252067638761_REALK,      0.000000000000000_REALK,     -0.674879753683187_REALK, &
     -0.146351430464536_REALK,      0.000000000000000_REALK,     -0.137987446561103_REALK, &
      0.000000000000000_REALK,     -0.445908554858165_REALK,      0.000000000000000_REALK, &
     -0.027347259264245_REALK,      0.000000000000000_REALK,     -0.627107445430847_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.239783985678525_REALK, &
      0.000000000000000_REALK,     -0.074514155379115_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.046077050866300_REALK,      0.000000000000000_REALK, &
      0.194902726925786_REALK,      0.000000000000000_REALK,     -0.033369218407932_REALK, &
      0.000000000000000_REALK,      0.076125591778226_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.159673276856117_REALK, &
      0.000000000000000_REALK,      0.053848558805817_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.042389738301602_REALK,      0.000000000000000_REALK, &
      0.389160490056784_REALK,      0.000000000000000_REALK,      0.056186534942659_REALK, &
      0.000000000000000_REALK,      0.166612193400982_REALK,      0.000000000000000_REALK, &
      0.898417486095355_REALK,      0.318245192053905_REALK,      0.000000000000000_REALK, &
      0.183410480517329_REALK,      0.000000000000000_REALK,      0.058364766294855_REALK, &
      0.118422248498187_REALK,      0.000000000000000_REALK,      0.024178468463635_REALK, &
      0.000000000000000_REALK,      0.091407139813946_REALK,      0.000000000000000_REALK, &
      0.017513995884088_REALK,      0.000000000000000_REALK,     -0.152944644375093_REALK, &
      0.657249085880517_REALK,      0.146960590954011_REALK,      0.000000000000000_REALK, &
     -0.007946064156871_REALK,      0.000000000000000_REALK,     -0.164517066227646_REALK, &
     -0.148344102199820_REALK,      0.000000000000000_REALK,     -0.046149915790351_REALK, &
      0.000000000000000_REALK,     -0.398023461217033_REALK,      0.000000000000000_REALK, &
      0.003167803864869_REALK,      0.000000000000000_REALK,     -0.352894909769761_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.280297055902525_REALK, &
      0.000000000000000_REALK,     -0.129800328710710_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.091255651386907_REALK,      0.000000000000000_REALK, &
     -0.024306181897720_REALK,      0.000000000000000_REALK,     -0.083786499994471_REALK, &
      0.000000000000000_REALK,     -0.014147123920638_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.106093419688427_REALK, &
      0.000000000000000_REALK,     -0.058462357456227_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.056950996609724_REALK,      0.000000000000000_REALK, &
      0.258532803916268_REALK,      0.000000000000000_REALK,     -0.083675822402653_REALK, &
      0.000000000000000_REALK,      0.180858833767992_REALK,      0.000000000000000_REALK, &
      0.544823310411986_REALK,      0.243058118350407_REALK,      0.000000000000000_REALK, &
      0.123646876977266_REALK,      0.000000000000000_REALK,      0.157601157651866_REALK, &
      0.034289384677502_REALK,      0.000000000000000_REALK,      0.082225824308838_REALK, &
      0.000000000000000_REALK,     -0.086999097590606_REALK,      0.000000000000000_REALK, &
      0.052574531829448_REALK,      0.000000000000000_REALK,      0.011175288171605_REALK, &
      0.295650693352021_REALK,     -0.190893749033678_REALK,      0.000000000000000_REALK, &
     -0.488423567540570_REALK,      0.000000000000000_REALK,     -0.021890956729539_REALK, &
     -0.886080388022589_REALK,      0.000000000000000_REALK,      0.017732362694590_REALK, &
      0.000000000000000_REALK,     -1.670551195920522_REALK,      0.000000000000000_REALK, &
      0.057598039816250_REALK,      0.000000000000000_REALK,     -0.171034094662919_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.296842221687920_REALK, &
      0.000000000000000_REALK,      4.027080890951046_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.430898939160325_REALK,      0.000000000000000_REALK, &
     -4.851149749885736_REALK,      0.000000000000000_REALK,      6.771568035667203_REALK, &
      0.000000000000000_REALK,     15.949930045578942_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.596739490360948_REALK, &
      0.000000000000000_REALK,      0.110756728215324_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.983620833788108_REALK,      0.000000000000000_REALK, &
     -3.145691008019012_REALK,      0.000000000000000_REALK,    -30.689050876357143_REALK, &
      0.000000000000000_REALK,      0.504140313698829_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.216025461337790_REALK, &
      0.000000000000000_REALK,      1.503197278142206_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.095402621787713_REALK,      0.000000000000000_REALK, &
      0.349447012647916_REALK,      0.000000000000000_REALK,      3.953735607407649_REALK, &
      0.000000000000000_REALK,      6.030554579037060_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.254782935173325_REALK, &
      0.000000000000000_REALK,      1.058451167071446_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.007970736184373_REALK,      0.000000000000000_REALK, &
     -0.021270445449775_REALK,      0.000000000000000_REALK,      9.533856460891080_REALK, &
      0.000000000000000_REALK,      4.944640823731919_REALK,      0.000000000000000_REALK, &
      8.439797815227310_REALK,     -0.077777382259670_REALK,      0.000000000000000_REALK, &
      3.372380088288272_REALK,      0.000000000000000_REALK,      0.225163787380252_REALK, &
      0.053414624118782_REALK,      0.000000000000000_REALK,      0.002477741656089_REALK, &
      0.000000000000000_REALK,      2.782018117720292_REALK,      0.000000000000000_REALK, &
      0.266442866565152_REALK,      0.000000000000000_REALK,    -13.482831243722302_REALK, &
      1.994680670897142_REALK,     -0.002548031805551_REALK,      0.000000000000000_REALK, &
     -0.858977879445972_REALK,      0.000000000000000_REALK,     -1.162914084349548_REALK, &
      0.012949205504176_REALK,      0.000000000000000_REALK,      0.000090050971332_REALK, &
      0.000000000000000_REALK,    -29.325715050524202_REALK,      0.000000000000000_REALK, &
      1.698725524280838_REALK,      0.000000000000000_REALK,    -15.143021973151036_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.028805325358799_REALK, &
      0.000000000000000_REALK,      0.214783366921326_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.736320528795711_REALK,      0.000000000000000_REALK, &
      3.085364606393209_REALK,      0.000000000000000_REALK,     -0.094392441021369_REALK, &
      0.000000000000000_REALK,      0.803831677622438_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.683947632662488_REALK, &
      0.000000000000000_REALK,     -0.083103907817910_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.197893070217406_REALK,      0.000000000000000_REALK, &
      1.740074373833184_REALK,      0.000000000000000_REALK,     -3.563121895932460_REALK, &
      0.000000000000000_REALK,     -0.370911246682405_REALK,      0.000000000000000_REALK, &
      6.528896446452015_REALK,      0.387283364641915_REALK,      0.000000000000000_REALK, &
      2.317289270209409_REALK,      0.000000000000000_REALK,      0.167158160148552_REALK, &
      0.386140479366542_REALK,      0.000000000000000_REALK,      0.011599019248418_REALK, &
      0.000000000000000_REALK,      7.006678789065267_REALK,      0.000000000000000_REALK, &
      0.170793379104763_REALK,      0.000000000000000_REALK,     -9.337558491346460_REALK, &
      1.133518408285453_REALK,      0.101251426302197_REALK,      0.000000000000000_REALK, &
      0.873683447290915_REALK,      0.000000000000000_REALK,     -0.986982758451103_REALK, &
      0.496683770242886_REALK,      0.000000000000000_REALK,     -0.109049434706343_REALK, &
      0.000000000000000_REALK,     10.027825338459362_REALK,      0.000000000000000_REALK, &
     -1.650744929537106_REALK,      0.000000000000000_REALK,    -12.278890319092381_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.706556796911304_REALK, &
      0.000000000000000_REALK,     -0.733012928567466_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.316940308466326_REALK,      0.000000000000000_REALK, &
     -0.413512173957618_REALK,      0.000000000000000_REALK,     -1.164679869710403_REALK, &
      0.000000000000000_REALK,     -1.055725981738829_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.085998774124760_REALK, &
      0.000000000000000_REALK,     -0.007630594600505_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.068414613693928_REALK,      0.000000000000000_REALK, &
      0.355374824412955_REALK,      0.000000000000000_REALK,      2.073189337919165_REALK, &
      0.000000000000000_REALK,      0.055316714017876_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.947722694787250_REALK, &
      0.000000000000000_REALK,     -0.651613537790846_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.247936738274062_REALK,      0.000000000000000_REALK, &
      5.114669799633750_REALK,      0.000000000000000_REALK,     -1.899480944641308_REALK, &
      0.000000000000000_REALK,     -2.094038363686874_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.375371781141695_REALK, &
      0.000000000000000_REALK,     -0.377995952626841_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.860744880395177_REALK,      0.000000000000000_REALK, &
      3.343796158429817_REALK,      0.000000000000000_REALK,      0.388217834423153_REALK, &
      0.000000000000000_REALK,     -1.338281005049713_REALK,      0.000000000000000_REALK, &
      6.687600786722494_REALK,      0.125892872870552_REALK,      0.000000000000000_REALK, &
      1.836024710245858_REALK,      0.000000000000000_REALK,      0.151511087555728_REALK, &
     -0.019153326292500_REALK,      0.000000000000000_REALK,      0.003212169221250_REALK, &
      0.000000000000000_REALK,      3.867320191726506_REALK,      0.000000000000000_REALK, &
      0.116198190912849_REALK,      0.000000000000000_REALK,     -7.267419551081356_REALK, &
      2.059442771352431_REALK,     -0.031679086756324_REALK,      0.000000000000000_REALK, &
      0.251816952425293_REALK,      0.000000000000000_REALK,     -0.937345064040114_REALK, &
     -0.428392178352150_REALK,      0.000000000000000_REALK,      0.018878094827708_REALK, &
      0.000000000000000_REALK,     -3.104472645867570_REALK,      0.000000000000000_REALK, &
     -0.377417849891977_REALK,      0.000000000000000_REALK,     -9.250403118218669_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.193338774085765_REALK, &
      0.000000000000000_REALK,     -0.352264236293352_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.422098386953919_REALK,      0.000000000000000_REALK, &
     -0.594990208854651_REALK,      0.000000000000000_REALK,     -0.742187200744266_REALK, &
      0.000000000000000_REALK,     -0.435650476275891_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.290854026031621_REALK, &
      0.000000000000000_REALK,     -0.107273414016889_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.153428179293284_REALK,      0.000000000000000_REALK, &
      0.665016955499176_REALK,      0.000000000000000_REALK,     -0.732295095455562_REALK, &
      0.000000000000000_REALK,      0.616881439536769_REALK,      0.000000000000000_REALK, &
      2.149114634247593_REALK,      0.396455704960462_REALK,      0.000000000000000_REALK, &
      0.729241923903561_REALK,      0.000000000000000_REALK,      1.696912763014738_REALK, &
      0.218070087652706_REALK,      0.000000000000000_REALK,      0.352547632957647_REALK, &
      0.000000000000000_REALK,      0.481890460854305_REALK,      0.000000000000000_REALK, &
      1.608489877412683_REALK,      0.000000000000000_REALK,      4.935533201896112_REALK, &
      1.019326875144621_REALK,      0.011449958819312_REALK,      0.000000000000000_REALK, &
     -0.342686971151057_REALK,      0.000000000000000_REALK,      0.266683725583239_REALK, &
     -0.981169763607803_REALK,      0.000000000000000_REALK,      0.003922136506837_REALK, &
      0.000000000000000_REALK,     -8.866668332995234_REALK,      0.000000000000000_REALK, &
     -0.295235335840472_REALK,      0.000000000000000_REALK,     -3.319600396738247_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.525738780901339_REALK, &
      0.000000000000000_REALK,     -1.697953831460659_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.012269032171494_REALK,      0.000000000000000_REALK, &
      7.365541449106206_REALK,      0.000000000000000_REALK,     -3.594753217409488_REALK, &
      0.000000000000000_REALK,     -4.372934962059348_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.439615418103963_REALK, &
      0.000000000000000_REALK,     -1.227369389657900_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.180862753947937_REALK,      0.000000000000000_REALK, &
      5.238506792353745_REALK,      0.000000000000000_REALK,     -3.525857049016413_REALK, &
      0.000000000000000_REALK,     -3.485817309206514_REALK,      0.000000000000000_REALK, &
      8.734313708311307_REALK,     -0.611002285437523_REALK,      0.000000000000000_REALK, &
      2.063625232731060_REALK,      0.000000000000000_REALK,      0.166564394284319_REALK, &
     -0.625558794955140_REALK,      0.000000000000000_REALK,     -0.013581387373253_REALK, &
      0.000000000000000_REALK,      4.030415637849827_REALK,      0.000000000000000_REALK, &
      0.104665675286169_REALK,      0.000000000000000_REALK,     -6.402809677957888_REALK, &
      1.592387932917139_REALK,     -0.177101892991010_REALK,      0.000000000000000_REALK, &
      0.686397391658576_REALK,      0.000000000000000_REALK,     -1.128803322701267_REALK, &
      0.078243631033455_REALK,      0.000000000000000_REALK,      0.114182128879532_REALK, &
      0.000000000000000_REALK,      3.431924217960776_REALK,      0.000000000000000_REALK, &
     -0.825243794167614_REALK,      0.000000000000000_REALK,     -8.936112167185463_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.730345481478925_REALK, &
      0.000000000000000_REALK,     -0.064695242809455_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.466088332294448_REALK,      0.000000000000000_REALK, &
     -0.751593334433045_REALK,      0.000000000000000_REALK,      0.019565528718556_REALK, &
      0.000000000000000_REALK,     -0.064120159252976_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.339507878616622_REALK, &
      0.000000000000000_REALK,      0.011637873872488_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.058804458693390_REALK,      0.000000000000000_REALK, &
      0.839840701758813_REALK,      0.000000000000000_REALK,      0.317514569592425_REALK, &
      0.000000000000000_REALK,     -0.053684933239624_REALK,      0.000000000000000_REALK, &
      2.436286949746073_REALK,      0.304792185922193_REALK,      0.000000000000000_REALK, &
      0.644072105907392_REALK,      0.000000000000000_REALK,      1.619226793924601_REALK, &
      0.225542916844727_REALK,      0.000000000000000_REALK,      0.236119029594563_REALK, &
      0.000000000000000_REALK,      1.340136754611680_REALK,      0.000000000000000_REALK, &
      1.138502006254978_REALK,      0.000000000000000_REALK,      3.774286371351598_REALK, &
      0.767514698799165_REALK,      0.197843821778100_REALK,      0.000000000000000_REALK, &
      0.481615709420645_REALK,      0.000000000000000_REALK,      0.312744278248356_REALK, &
      0.580970359890276_REALK,      0.000000000000000_REALK,      0.073321391025324_REALK, &
      0.000000000000000_REALK,      3.517499755931823_REALK,      0.000000000000000_REALK, &
      0.332843865546661_REALK,      0.000000000000000_REALK,     -3.122826364092081_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.283155400455548_REALK, &
      0.000000000000000_REALK,     -0.470135521858741_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.427187493057729_REALK,      0.000000000000000_REALK, &
     -1.770326520515794_REALK,      0.000000000000000_REALK,     -0.514044445578809_REALK, &
      0.000000000000000_REALK,     -1.480025963159439_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.556569597378407_REALK, &
      0.000000000000000_REALK,     -0.013931914265577_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.265050581623980_REALK,      0.000000000000000_REALK, &
     -0.293409088981832_REALK,      0.000000000000000_REALK,      2.408641458580250_REALK, &
      0.000000000000000_REALK,     -0.013696089544351_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     11.198163131428441_REALK, &
      0.000000000000000_REALK,     -3.545499459236044_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.482221867510233_REALK,      0.000000000000000_REALK, &
     10.734628434513510_REALK,      0.000000000000000_REALK,     -5.777345004169680_REALK, &
      0.000000000000000_REALK,     -6.947927908840257_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     10.122686526996429_REALK, &
      0.000000000000000_REALK,     -3.230561574193854_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.165822893477211_REALK,      0.000000000000000_REALK, &
      9.483100845148201_REALK,      0.000000000000000_REALK,     -3.725388938814007_REALK, &
      0.000000000000000_REALK,     -5.902925917324480_REALK,      0.000000000000000_REALK, &
     14.003247937398614_REALK,     -2.220079075024159_REALK,      0.000000000000000_REALK, &
      3.022787273593917_REALK,      0.000000000000000_REALK,      0.217897641052004_REALK, &
     -1.749462883577984_REALK,      0.000000000000000_REALK,     -0.041911671303247_REALK, &
      0.000000000000000_REALK,      5.009393914258007_REALK,      0.000000000000000_REALK, &
      0.116657260783692_REALK,      0.000000000000000_REALK,     -6.373407553389242_REALK, &
      6.899459691932656_REALK,     -1.230119640768960_REALK,      0.000000000000000_REALK, &
      1.056567748504966_REALK,      0.000000000000000_REALK,     -1.984187662859015_REALK, &
     -1.165633477166121_REALK,      0.000000000000000_REALK,      0.487842061192924_REALK, &
      0.000000000000000_REALK,     -0.025536536795624_REALK,      0.000000000000000_REALK, &
     -0.817267009010078_REALK,      0.000000000000000_REALK,    -10.105854771120237_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.652530628985034_REALK, &
      0.000000000000000_REALK,      0.248485670594346_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.620405448356384_REALK,      0.000000000000000_REALK, &
     -0.978533590175288_REALK,      0.000000000000000_REALK,      0.441702173923924_REALK, &
      0.000000000000000_REALK,      0.187393418459533_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.874590288472053_REALK, &
      0.000000000000000_REALK,      0.078978770363187_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.210908403966612_REALK,      0.000000000000000_REALK, &
      1.330787363727837_REALK,      0.000000000000000_REALK,     -0.041862758894146_REALK, &
      0.000000000000000_REALK,     -0.234395416262772_REALK,      0.000000000000000_REALK, &
      3.426213761043365_REALK,      0.078054411242585_REALK,      0.000000000000000_REALK, &
      0.646059194488739_REALK,      0.000000000000000_REALK,      1.858078527717689_REALK, &
     -0.008786375894192_REALK,      0.000000000000000_REALK,      0.051355841222739_REALK, &
      0.000000000000000_REALK,      0.829826434047997_REALK,      0.000000000000000_REALK, &
      0.868965152015164_REALK,      0.000000000000000_REALK,      3.295504970576308_REALK, &
      2.680707247277334_REALK,     -0.045913462716092_REALK,      0.000000000000000_REALK, &
      0.207110691435013_REALK,      0.000000000000000_REALK,      0.443149559385709_REALK, &
     -0.413195236869018_REALK,      0.000000000000000_REALK,     -0.010466589877923_REALK, &
      0.000000000000000_REALK,     -1.317754591202615_REALK,      0.000000000000000_REALK, &
      0.092087865542198_REALK,      0.000000000000000_REALK,     -2.846877379263272_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.707329135573588_REALK, &
      0.000000000000000_REALK,     -0.286035235206861_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.446823962826596_REALK,      0.000000000000000_REALK, &
     -2.000583142950886_REALK,      0.000000000000000_REALK,     -0.367491913165217_REALK, &
      0.000000000000000_REALK,     -0.685167164422917_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.396202302484019_REALK, &
      0.000000000000000_REALK,     -0.292223765739565_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.490145230230705_REALK,      0.000000000000000_REALK, &
     -0.452750970576245_REALK,      0.000000000000000_REALK,     -1.029529277740510_REALK, &
      0.000000000000000_REALK,     -0.184825249860441_REALK,      0.000000000000000_REALK, &
      1.835069199639295_REALK,      0.409675251781621_REALK,      0.000000000000000_REALK, &
      0.427675298808537_REALK,      0.000000000000000_REALK,      1.961807298898870_REALK, &
      0.166728721348913_REALK,      0.000000000000000_REALK,      0.531357010761602_REALK, &
      0.000000000000000_REALK,      0.172335287704719_REALK,      0.000000000000000_REALK, &
      1.133962014449345_REALK,      0.000000000000000_REALK,      6.890995428480807_REALK, &
      2.211372399332972_REALK,      0.027657955199016_REALK,      0.000000000000000_REALK, &
     -0.469746872727071_REALK,      0.000000000000000_REALK,      1.367086615515204_REALK, &
     -1.577272311717227_REALK,      0.000000000000000_REALK,      0.023578623155605_REALK, &
      0.000000000000000_REALK,     -6.272720167158529_REALK,      0.000000000000000_REALK, &
     -0.781082664319458_REALK,      0.000000000000000_REALK,      0.982162596249722_REALK/
    ! results of test 7, ket-major order, 03ODGXYY
  data REF_CONTR_INTS(68041:69300)                                                         &
     /0.000000000000000_REALK,      0.000000000000000_REALK,      1.451497872399183_REALK, &
      0.000000000000000_REALK,      0.895080734192202_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.944343881856039_REALK,      0.000000000000000_REALK, &
      1.058787858500609_REALK,      0.000000000000000_REALK,      1.681425085886675_REALK, &
      0.000000000000000_REALK,      0.975763429263407_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.117061196618931_REALK, &
      0.000000000000000_REALK,      1.153626874862517_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.096703677240242_REALK,      0.000000000000000_REALK, &
      0.772504626345545_REALK,      0.000000000000000_REALK,      5.820147769899170_REALK, &
      0.000000000000000_REALK,      1.195783544937761_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.429801712513927_REALK, &
      0.000000000000000_REALK,      0.620827621636713_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.467636506232420_REALK,      0.000000000000000_REALK, &
      0.906978778329366_REALK,      0.000000000000000_REALK,      0.416461551442136_REALK, &
      0.000000000000000_REALK,      0.558036194420458_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.507736270349492_REALK, &
      0.000000000000000_REALK,      0.048656031395594_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.410527974895409_REALK,      0.000000000000000_REALK, &
      0.374616776859032_REALK,      0.000000000000000_REALK,     -1.731324611742897_REALK, &
      0.000000000000000_REALK,      0.044070242723008_REALK,      0.000000000000000_REALK, &
      1.017089926423901_REALK,      0.534756870125259_REALK,      0.000000000000000_REALK, &
      0.473718047273192_REALK,      0.000000000000000_REALK,     -0.251534235959136_REALK, &
      0.584535202399502_REALK,      0.000000000000000_REALK,     -0.160648279254696_REALK, &
      0.000000000000000_REALK,      1.184131974711033_REALK,      0.000000000000000_REALK, &
     -0.201655309059266_REALK,      0.000000000000000_REALK,     -0.611323510636391_REALK, &
      0.239411495118778_REALK,      0.307692992541366_REALK,      0.000000000000000_REALK, &
      0.527473902699636_REALK,      0.000000000000000_REALK,     -0.313545046079689_REALK, &
      1.104963871931701_REALK,      0.000000000000000_REALK,     -0.366270190261745_REALK, &
      0.000000000000000_REALK,      2.991729687461362_REALK,      0.000000000000000_REALK, &
     -0.770805261964487_REALK,      0.000000000000000_REALK,     -0.626662317056610_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.658160652413162_REALK, &
      0.000000000000000_REALK,      0.553943973290143_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.403078672781373_REALK,      0.000000000000000_REALK, &
      0.906618480296622_REALK,      0.000000000000000_REALK,      0.363085052851597_REALK, &
      0.000000000000000_REALK,      0.409922635590567_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.096560070964886_REALK, &
      0.000000000000000_REALK,      0.484666911449777_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.590355840582009_REALK,      0.000000000000000_REALK, &
      0.540543500365030_REALK,      0.000000000000000_REALK,      1.233441545246773_REALK, &
      0.000000000000000_REALK,      0.326235904252356_REALK,      0.000000000000000_REALK, &
      1.132575222286866_REALK,      0.421628577337686_REALK,      0.000000000000000_REALK, &
      0.265942810167035_REALK,      0.000000000000000_REALK,     -0.244272942870745_REALK, &
      0.172044401750932_REALK,      0.000000000000000_REALK,     -0.109175802743210_REALK, &
      0.000000000000000_REALK,      0.099646016443557_REALK,      0.000000000000000_REALK, &
     -0.093201457698576_REALK,      0.000000000000000_REALK,     -0.488758226037706_REALK, &
      0.338907997762422_REALK,      0.021515143556338_REALK,      0.000000000000000_REALK, &
     -0.136417976589018_REALK,      0.000000000000000_REALK,     -0.200840365758916_REALK, &
     -0.416653975806253_REALK,      0.000000000000000_REALK,     -0.017111079297201_REALK, &
      0.000000000000000_REALK,     -1.204088057386567_REALK,      0.000000000000000_REALK, &
      0.148147703100696_REALK,      0.000000000000000_REALK,     -0.298307564148304_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.114914988962683_REALK, &
      0.000000000000000_REALK,     -0.061457726676558_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.056039707565616_REALK,      0.000000000000000_REALK, &
      0.129791236625420_REALK,      0.000000000000000_REALK,     -0.078369222053135_REALK, &
      0.000000000000000_REALK,      0.093947078397957_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.076959006238643_REALK, &
      0.000000000000000_REALK,      0.067558867876838_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.102965952353642_REALK,      0.000000000000000_REALK, &
      0.278740253093209_REALK,      0.000000000000000_REALK,      0.221336066006938_REALK, &
      0.000000000000000_REALK,      0.334127918628363_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.166970274493679_REALK, &
      0.000000000000000_REALK,      0.514734499080271_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.342616855896416_REALK,      0.000000000000000_REALK, &
      1.013753540546235_REALK,      0.000000000000000_REALK,      0.207656552934707_REALK, &
      0.000000000000000_REALK,      0.312816809656948_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.031619687911639_REALK, &
      0.000000000000000_REALK,      0.169872243644052_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.103358540538052_REALK,      0.000000000000000_REALK, &
      0.564836463218262_REALK,      0.000000000000000_REALK,     -0.653679239970016_REALK, &
      0.000000000000000_REALK,      0.103625916570355_REALK,      0.000000000000000_REALK, &
      1.501166026792486_REALK,      0.432731342269990_REALK,      0.000000000000000_REALK, &
      0.264148228135742_REALK,      0.000000000000000_REALK,     -0.281371977014144_REALK, &
      0.179309893333431_REALK,      0.000000000000000_REALK,     -0.095872968521758_REALK, &
      0.000000000000000_REALK,      0.199539628829002_REALK,      0.000000000000000_REALK, &
     -0.076024382284125_REALK,      0.000000000000000_REALK,     -0.462349406239445_REALK, &
      0.297145922549767_REALK,      0.167551242996493_REALK,      0.000000000000000_REALK, &
      0.200071865880070_REALK,      0.000000000000000_REALK,     -0.295554612748691_REALK, &
      0.346846705323539_REALK,      0.000000000000000_REALK,     -0.148008170753370_REALK, &
      0.000000000000000_REALK,      0.819474371027940_REALK,      0.000000000000000_REALK, &
     -0.196909612883105_REALK,      0.000000000000000_REALK,     -0.397840123552224_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.128365536970782_REALK, &
      0.000000000000000_REALK,     -0.048128778893142_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.030962723441006_REALK,      0.000000000000000_REALK, &
      0.124050523254251_REALK,      0.000000000000000_REALK,     -0.021828515065761_REALK, &
      0.000000000000000_REALK,      0.060420230405134_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.038539602321998_REALK, &
      0.000000000000000_REALK,      0.003218855675801_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.023124154698723_REALK,      0.000000000000000_REALK, &
      0.155043066468409_REALK,      0.000000000000000_REALK,     -0.077140158514944_REALK, &
      0.000000000000000_REALK,      0.014427446874203_REALK,      0.000000000000000_REALK, &
      0.478411993689345_REALK,      0.220776202465660_REALK,      0.000000000000000_REALK, &
      0.168879525250640_REALK,      0.000000000000000_REALK,      0.036559117637845_REALK, &
      0.177977324729152_REALK,      0.000000000000000_REALK,      0.019942133233481_REALK, &
      0.000000000000000_REALK,      0.285412273947286_REALK,      0.000000000000000_REALK, &
      0.019816352974249_REALK,      0.000000000000000_REALK,     -0.117723960388286_REALK, &
      0.198560826145657_REALK,      0.222373698262127_REALK,      0.000000000000000_REALK, &
      0.332248150147318_REALK,      0.000000000000000_REALK,     -0.115888980051982_REALK, &
      0.592608614556913_REALK,      0.000000000000000_REALK,     -0.115266222009822_REALK, &
      0.000000000000000_REALK,      1.269173945084321_REALK,      0.000000000000000_REALK, &
     -0.191877508460122_REALK,      0.000000000000000_REALK,     -0.360107245951858_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.288804741794416_REALK, &
      0.000000000000000_REALK,      0.523524038414251_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.363472929176180_REALK,      0.000000000000000_REALK, &
      1.294091850072203_REALK,      0.000000000000000_REALK,      0.169538834371112_REALK, &
      0.000000000000000_REALK,      0.258915349524936_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.001091683594104_REALK, &
      0.000000000000000_REALK,      0.569525454500130_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.547179461068480_REALK,      0.000000000000000_REALK, &
      0.995482774858298_REALK,      0.000000000000000_REALK,      0.806994446600131_REALK, &
      0.000000000000000_REALK,      0.239830172321029_REALK,      0.000000000000000_REALK, &
      2.333852656151521_REALK,      0.476106581127212_REALK,      0.000000000000000_REALK, &
      0.265388686952887_REALK,      0.000000000000000_REALK,     -0.371881399881838_REALK, &
      0.124361730010049_REALK,      0.000000000000000_REALK,     -0.088721645834906_REALK, &
      0.000000000000000_REALK,      0.089058601509836_REALK,      0.000000000000000_REALK, &
     -0.062158706530981_REALK,      0.000000000000000_REALK,     -0.497288348610442_REALK, &
      1.132842845724325_REALK,      0.122934228358147_REALK,      0.000000000000000_REALK, &
     -0.054809865740492_REALK,      0.000000000000000_REALK,     -0.483247959501868_REALK, &
     -0.257231182105020_REALK,      0.000000000000000_REALK,     -0.065790356522087_REALK, &
      0.000000000000000_REALK,     -0.648861186942542_REALK,      0.000000000000000_REALK, &
      0.037237828925844_REALK,      0.000000000000000_REALK,     -0.449040576101127_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.175074267118260_REALK, &
      0.000000000000000_REALK,     -0.049956318089008_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.030627713907742_REALK,      0.000000000000000_REALK, &
      0.142304966611198_REALK,      0.000000000000000_REALK,     -0.021883564462494_REALK, &
      0.000000000000000_REALK,      0.051036668915300_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.118724426650743_REALK, &
      0.000000000000000_REALK,      0.043566232376133_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.043010825883486_REALK,      0.000000000000000_REALK, &
      0.289358726562289_REALK,      0.000000000000000_REALK,      0.069362941176500_REALK, &
      0.000000000000000_REALK,      0.134797767951038_REALK,      0.000000000000000_REALK, &
      0.635758505670715_REALK,      0.204714689922394_REALK,      0.000000000000000_REALK, &
      0.110289988431257_REALK,      0.000000000000000_REALK,      0.041301396263673_REALK, &
      0.060115790791626_REALK,      0.000000000000000_REALK,      0.015553063480353_REALK, &
      0.000000000000000_REALK,      0.027618042315836_REALK,      0.000000000000000_REALK, &
      0.010531668626530_REALK,      0.000000000000000_REALK,     -0.108230149193610_REALK, &
      0.402952677748486_REALK,      0.022179342830325_REALK,      0.000000000000000_REALK, &
     -0.116754871110990_REALK,      0.000000000000000_REALK,     -0.100863727003808_REALK, &
     -0.289025539577491_REALK,      0.000000000000000_REALK,     -0.006964961131826_REALK, &
      0.000000000000000_REALK,     -0.644709321238903_REALK,      0.000000000000000_REALK, &
      0.046545877889480_REALK,      0.000000000000000_REALK,     -0.216356252006086_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.197115993806698_REALK, &
      0.000000000000000_REALK,     -0.090043122018738_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.069178333338795_REALK,      0.000000000000000_REALK, &
     -0.017093070010987_REALK,      0.000000000000000_REALK,     -0.076736979428213_REALK, &
      0.000000000000000_REALK,     -0.009813928963457_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.093120878431689_REALK, &
      0.000000000000000_REALK,     -0.067868610167884_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.083837345372412_REALK,      0.000000000000000_REALK, &
      0.226920782408494_REALK,      0.000000000000000_REALK,     -0.139104466283968_REALK, &
      0.000000000000000_REALK,      0.209957966433501_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.826444239075615_REALK, &
      0.000000000000000_REALK,      0.540595833200805_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.449774556661972_REALK,      0.000000000000000_REALK, &
      1.911346446771698_REALK,      0.000000000000000_REALK,      0.114511932552108_REALK, &
      0.000000000000000_REALK,      0.215552169991230_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.911625676171685_REALK, &
      0.000000000000000_REALK,      0.257225671467770_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.019075436568682_REALK,      0.000000000000000_REALK, &
      1.568113433291469_REALK,      0.000000000000000_REALK,     -0.713955978383472_REALK, &
      0.000000000000000_REALK,      0.105311917839269_REALK,      0.000000000000000_REALK, &
      4.257226353557927_REALK,      0.586414040165132_REALK,      0.000000000000000_REALK, &
      0.342315979883692_REALK,      0.000000000000000_REALK,     -0.577189732822473_REALK, &
      0.125965488118408_REALK,      0.000000000000000_REALK,     -0.091104236238686_REALK, &
      0.000000000000000_REALK,      0.111378920326189_REALK,      0.000000000000000_REALK, &
     -0.064640583984479_REALK,      0.000000000000000_REALK,     -0.622273002240836_REALK, &
      1.047600963050045_REALK,      0.267337267092059_REALK,      0.000000000000000_REALK, &
      0.269920543452159_REALK,      0.000000000000000_REALK,     -0.792272963861720_REALK, &
      0.360617183984500_REALK,      0.000000000000000_REALK,     -0.172907815929717_REALK, &
      0.000000000000000_REALK,      0.737702319949076_REALK,      0.000000000000000_REALK, &
     -0.178292915117876_REALK,      0.000000000000000_REALK,     -0.715752585470882_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.280215888384867_REALK, &
      0.000000000000000_REALK,     -0.056208922368259_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.031067400549529_REALK,      0.000000000000000_REALK, &
      0.189888779878810_REALK,      0.000000000000000_REALK,     -0.014877861880051_REALK, &
      0.000000000000000_REALK,      0.046297303070358_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.125912351908802_REALK, &
      0.000000000000000_REALK,      0.018014422103469_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.009236600638416_REALK,      0.000000000000000_REALK, &
      0.370877545744695_REALK,      0.000000000000000_REALK,     -0.046524300749836_REALK, &
      0.000000000000000_REALK,      0.054190800206766_REALK,      0.000000000000000_REALK, &
      1.042159582417342_REALK,      0.257324662252402_REALK,      0.000000000000000_REALK, &
      0.132645628286051_REALK,      0.000000000000000_REALK,      0.057605985815724_REALK, &
      0.074769366457517_REALK,      0.000000000000000_REALK,      0.016298857208420_REALK, &
      0.000000000000000_REALK,      0.065742664122628_REALK,      0.000000000000000_REALK, &
      0.010212041500230_REALK,      0.000000000000000_REALK,     -0.121705350537970_REALK, &
      0.394596727551641_REALK,      0.194712189817145_REALK,      0.000000000000000_REALK, &
      0.202013645933705_REALK,      0.000000000000000_REALK,     -0.175110839127665_REALK, &
      0.295121020797844_REALK,      0.000000000000000_REALK,     -0.073897350059895_REALK, &
      0.000000000000000_REALK,      0.555325108650083_REALK,      0.000000000000000_REALK, &
     -0.078299584225031_REALK,      0.000000000000000_REALK,     -0.365190943636911_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.269673155441601_REALK, &
      0.000000000000000_REALK,     -0.085383960936920_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.045612598856054_REALK,      0.000000000000000_REALK, &
     -0.019495964762048_REALK,      0.000000000000000_REALK,     -0.025407886893709_REALK, &
      0.000000000000000_REALK,     -0.007502866144012_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.052569748985282_REALK, &
      0.000000000000000_REALK,     -0.003814866779117_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.023094662731033_REALK,      0.000000000000000_REALK, &
      0.154820623519618_REALK,      0.000000000000000_REALK,      0.061358629246736_REALK, &
      0.000000000000000_REALK,      0.011474012281107_REALK,      0.000000000000000_REALK, &
      0.553549301751837_REALK,      0.218808439106922_REALK,      0.000000000000000_REALK, &
      0.141341920592716_REALK,      0.000000000000000_REALK,      0.136245090618726_REALK, &
      0.123689510995148_REALK,      0.000000000000000_REALK,      0.061712192953920_REALK, &
      0.000000000000000_REALK,      0.156725453257139_REALK,      0.000000000000000_REALK, &
      0.048453124305392_REALK,      0.000000000000000_REALK,      0.007788946575151_REALK, &
      0.439466752814599_REALK,      0.430702760659935_REALK,      0.000000000000000_REALK, &
      0.559121259343065_REALK,      0.000000000000000_REALK,     -0.057688659814304_REALK, &
      0.840386913379565_REALK,      0.000000000000000_REALK,     -0.048352424394875_REALK, &
      0.000000000000000_REALK,      1.433447633970757_REALK,      0.000000000000000_REALK, &
     -0.064104664251510_REALK,      0.000000000000000_REALK,     -0.438208636268135_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.165502121408005_REALK, &
      0.000000000000000_REALK,      0.885243845613137_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.071296201498447_REALK,      0.000000000000000_REALK, &
      0.267719469523494_REALK,      0.000000000000000_REALK,      2.901222569678208_REALK, &
      0.000000000000000_REALK,      3.551437595286573_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.203247922548344_REALK, &
      0.000000000000000_REALK,      1.041747608202429_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.009316039750014_REALK,      0.000000000000000_REALK, &
     -0.016968066744357_REALK,      0.000000000000000_REALK,     14.283980669518961_REALK, &
      0.000000000000000_REALK,      4.866608788192790_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.586603806299848_REALK, &
      0.000000000000000_REALK,     -0.046211598123635_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.552723636841771_REALK,      0.000000000000000_REALK, &
      2.412873806638176_REALK,      0.000000000000000_REALK,     -0.734786024574977_REALK, &
      0.000000000000000_REALK,     -0.172947966026354_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.524174103806510_REALK, &
      0.000000000000000_REALK,     -0.264808043441560_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.045567911993460_REALK,      0.000000000000000_REALK, &
      1.333584446970083_REALK,      0.000000000000000_REALK,     -5.126799539027026_REALK, &
      0.000000000000000_REALK,     -1.181897266969065_REALK,      0.000000000000000_REALK, &
      5.001939149438540_REALK,      0.228073999363090_REALK,      0.000000000000000_REALK, &
      1.731754532979893_REALK,      0.000000000000000_REALK,      0.128063747411637_REALK, &
      0.283347088688894_REALK,      0.000000000000000_REALK,      0.006830747071004_REALK, &
      0.000000000000000_REALK,      6.556070369883154_REALK,      0.000000000000000_REALK, &
      0.127637154441620_REALK,      0.000000000000000_REALK,     -7.153720350920782_REALK, &
      0.904241335855493_REALK,      0.099653564055522_REALK,      0.000000000000000_REALK, &
      1.021144036839333_REALK,      0.000000000000000_REALK,     -0.787345491210944_REALK, &
      0.744150218971315_REALK,      0.000000000000000_REALK,     -0.107328511050233_REALK, &
      0.000000000000000_REALK,     14.837627665605023_REALK,      0.000000000000000_REALK, &
     -1.929358220493217_REALK,      0.000000000000000_REALK,     -9.795235881306471_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.146332248123628_REALK, &
      0.000000000000000_REALK,     -0.694045912080043_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.000151437514905_REALK,      0.000000000000000_REALK, &
      4.076388280853888_REALK,      0.000000000000000_REALK,     -1.883468266702085_REALK, &
      0.000000000000000_REALK,     -2.230399894672160_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.907488291833303_REALK, &
      0.000000000000000_REALK,     -0.359558821109427_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.785840244559248_REALK,      0.000000000000000_REALK, &
      2.685159465612768_REALK,      0.000000000000000_REALK,      1.015285194650272_REALK, &
      0.000000000000000_REALK,     -1.273005007447388_REALK,      0.000000000000000_REALK, &
      5.229961066546016_REALK,     -0.027086412375009_REALK,      0.000000000000000_REALK, &
      1.378223498451456_REALK,      0.000000000000000_REALK,      0.118487498631755_REALK, &
     -0.149096647269321_REALK,      0.000000000000000_REALK,     -0.000691112516231_REALK, &
      0.000000000000000_REALK,      2.678711340648299_REALK,      0.000000000000000_REALK, &
      0.087224902965599_REALK,      0.000000000000000_REALK,     -5.683401644110133_REALK, &
      1.578346817010173_REALK,     -0.100944434530544_REALK,      0.000000000000000_REALK, &
      0.057984712218426_REALK,      0.000000000000000_REALK,     -0.718376649668372_REALK, &
     -0.616392278076645_REALK,      0.000000000000000_REALK,      0.060154467900391_REALK, &
      0.000000000000000_REALK,     -4.869251440268237_REALK,      0.000000000000000_REALK, &
     -0.086906243607948_REALK,      0.000000000000000_REALK,     -7.089463480509030_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.914244540650712_REALK, &
      0.000000000000000_REALK,     -0.207450979151388_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.315442186855201_REALK,      0.000000000000000_REALK, &
     -0.455835812929763_REALK,      0.000000000000000_REALK,     -0.544611595598670_REALK, &
      0.000000000000000_REALK,     -0.256557744329005_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.232022904185201_REALK, &
      0.000000000000000_REALK,     -0.105580517979871_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.179323839606045_REALK,      0.000000000000000_REALK, &
      0.530503797566636_REALK,      0.000000000000000_REALK,     -1.097151927006581_REALK, &
      0.000000000000000_REALK,      0.607146351361643_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.278080758304878_REALK, &
      0.000000000000000_REALK,     -1.552533417911501_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.668675068871718_REALK,      0.000000000000000_REALK, &
      5.957321293766974_REALK,      0.000000000000000_REALK,     -3.255031881273683_REALK, &
      0.000000000000000_REALK,     -3.998417116624645_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.791893867601885_REALK, &
      0.000000000000000_REALK,     -1.137706638735031_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.926928887762994_REALK,      0.000000000000000_REALK, &
      4.252032047532020_REALK,      0.000000000000000_REALK,     -3.599727297908573_REALK, &
      0.000000000000000_REALK,     -3.231168650219568_REALK,      0.000000000000000_REALK, &
      6.961241964126641_REALK,     -0.650790098556227_REALK,      0.000000000000000_REALK, &
      1.653880104421393_REALK,      0.000000000000000_REALK,      0.132751706653036_REALK, &
     -0.620285316669441_REALK,      0.000000000000000_REALK,     -0.014465792743870_REALK, &
      0.000000000000000_REALK,      3.338747113085343_REALK,      0.000000000000000_REALK, &
      0.083883679665292_REALK,      0.000000000000000_REALK,     -5.103034869941042_REALK, &
      1.278730917918111_REALK,     -0.168463570621770_REALK,      0.000000000000000_REALK, &
      0.626665004243955_REALK,      0.000000000000000_REALK,     -0.906459838804815_REALK, &
      0.204626354381641_REALK,      0.000000000000000_REALK,      0.108612781079746_REALK, &
      0.000000000000000_REALK,      4.022644547360116_REALK,      0.000000000000000_REALK, &
     -0.753428570765291_REALK,      0.000000000000000_REALK,     -7.175941664686584_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.353196727558212_REALK, &
      0.000000000000000_REALK,      0.013919469668788_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.349872138614213_REALK,      0.000000000000000_REALK, &
     -0.587774898998832_REALK,      0.000000000000000_REALK,      0.152305384946672_REALK, &
      0.000000000000000_REALK,      0.013795737879960_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.260197169359807_REALK, &
      0.000000000000000_REALK,      0.037083726757420_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.013540627752248_REALK,      0.000000000000000_REALK, &
      0.643649785687474_REALK,      0.000000000000000_REALK,      0.456855980952851_REALK, &
      0.000000000000000_REALK,     -0.171065386776092_REALK,      0.000000000000000_REALK, &
      1.866495995632369_REALK,      0.179494342294220_REALK,      0.000000000000000_REALK, &
      0.481327386835152_REALK,      0.000000000000000_REALK,      1.240527240518984_REALK, &
      0.165501759792688_REALK,      0.000000000000000_REALK,      0.139052219439263_REALK, &
      0.000000000000000_REALK,      1.253950856461784_REALK,      0.000000000000000_REALK, &
      0.850824295216535_REALK,      0.000000000000000_REALK,      2.891568416943592_REALK, &
      0.612269294841574_REALK,      0.194721622070875_REALK,      0.000000000000000_REALK, &
      0.562902972750586_REALK,      0.000000000000000_REALK,      0.249485409215548_REALK, &
      0.870431543025408_REALK,      0.000000000000000_REALK,      0.072164296386051_REALK, &
      0.000000000000000_REALK,      5.204653045980497_REALK,      0.000000000000000_REALK, &
      0.389021366440462_REALK,      0.000000000000000_REALK,     -2.491171437950071_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      9.167420938768897_REALK, &
      0.000000000000000_REALK,     -3.120819160484922_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.950387516689999_REALK,      0.000000000000000_REALK, &
      8.787946409199174_REALK,      0.000000000000000_REALK,     -5.093219065225644_REALK, &
      0.000000000000000_REALK,     -6.115704371944466_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.377383636906744_REALK, &
      0.000000000000000_REALK,     -2.824288337995394_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.797255168503975_REALK,      0.000000000000000_REALK, &
      7.848072113604551_REALK,      0.000000000000000_REALK,     -2.974514013777315_REALK, &
      0.000000000000000_REALK,     -5.160577950757824_REALK,      0.000000000000000_REALK, &
     11.325962618740856_REALK,     -2.029941504013693_REALK,      0.000000000000000_REALK, &
      2.506647809664750_REALK,      0.000000000000000_REALK,      0.176237723440986_REALK, &
     -1.584130291217887_REALK,      0.000000000000000_REALK,     -0.038322167006648_REALK, &
      0.000000000000000_REALK,      4.242356035489306_REALK,      0.000000000000000_REALK, &
      0.096738089967297_REALK,      0.000000000000000_REALK,     -5.154873785452449_REALK, &
      5.600207250580201_REALK,     -1.140255976345700_REALK,      0.000000000000000_REALK, &
      0.829362400239730_REALK,      0.000000000000000_REALK,     -1.610540916565918_REALK, &
     -1.190054670050080_REALK,      0.000000000000000_REALK,      0.452203840465721_REALK, &
      0.000000000000000_REALK,     -0.756407302135283_REALK,      0.000000000000000_REALK, &
     -0.641521122699835_REALK,      0.000000000000000_REALK,     -8.202799014640638_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.114065070510488_REALK, &
      0.000000000000000_REALK,      0.264666790796219_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.497220237200395_REALK,      0.000000000000000_REALK, &
     -0.779890592291620_REALK,      0.000000000000000_REALK,      0.437978612139295_REALK, &
      0.000000000000000_REALK,      0.199596276764725_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.702319842584693_REALK, &
      0.000000000000000_REALK,      0.075126501665201_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.192554513570421_REALK,      0.000000000000000_REALK, &
      1.068658529744125_REALK,      0.000000000000000_REALK,     -0.109481418790548_REALK, &
      0.000000000000000_REALK,     -0.222962544861151_REALK,      0.000000000000000_REALK, &
      2.679430956987918_REALK,     -0.016793754264223_REALK,      0.000000000000000_REALK, &
      0.484968398445882_REALK,      0.000000000000000_REALK,      1.453088883212356_REALK, &
     -0.068396432424643_REALK,      0.000000000000000_REALK,     -0.011049437998408_REALK, &
      0.000000000000000_REALK,      0.574781856544892_REALK,      0.000000000000000_REALK, &
      0.652294157676325_REALK,      0.000000000000000_REALK,      2.577211654879568_REALK, &
      2.054480857604861_REALK,     -0.146301835241193_REALK,      0.000000000000000_REALK, &
      0.047690410532553_REALK,      0.000000000000000_REALK,      0.339627644062461_REALK, &
     -0.594526152003528_REALK,      0.000000000000000_REALK,     -0.033351466373288_REALK, &
      0.000000000000000_REALK,     -2.066849727174927_REALK,      0.000000000000000_REALK, &
      0.021204642224624_REALK,      0.000000000000000_REALK,     -2.181832829968689_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.308024489934045_REALK, &
      0.000000000000000_REALK,     -0.168448237152426_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.333920081975381_REALK,      0.000000000000000_REALK, &
     -1.532693193483076_REALK,      0.000000000000000_REALK,     -0.269662905797642_REALK, &
      0.000000000000000_REALK,     -0.403499942649718_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.113792088328146_REALK, &
      0.000000000000000_REALK,     -0.287612143563871_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.572872108985566_REALK,      0.000000000000000_REALK, &
     -0.361172910339391_REALK,      0.000000000000000_REALK,     -1.542479306487775_REALK, &
      0.000000000000000_REALK,     -0.181908497970916_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     17.637399716120957_REALK, &
      0.000000000000000_REALK,     -6.587135712733049_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      5.657438894586567_REALK,      0.000000000000000_REALK, &
     13.899398542318711_REALK,      0.000000000000000_REALK,     -8.390190715197114_REALK, &
      0.000000000000000_REALK,     -9.453406883073917_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     14.733468205479351_REALK, &
      0.000000000000000_REALK,     -7.125448112123779_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      5.949903946083744_REALK,      0.000000000000000_REALK, &
     14.956778599607611_REALK,      0.000000000000000_REALK,     -9.463080047987727_REALK, &
      0.000000000000000_REALK,    -10.153763333530955_REALK,      0.000000000000000_REALK, &
     21.987849082991083_REALK,     -5.377184638913305_REALK,      0.000000000000000_REALK, &
      4.701789939131985_REALK,      0.000000000000000_REALK,      0.275802291191453_REALK, &
     -3.529086245014303_REALK,      0.000000000000000_REALK,     -0.083453145184349_REALK, &
      0.000000000000000_REALK,      6.719104125886323_REALK,      0.000000000000000_REALK, &
      0.132886624917058_REALK,      0.000000000000000_REALK,     -5.907869468630462_REALK, &
      6.230392492825142_REALK,     -2.442052339919540_REALK,      0.000000000000000_REALK, &
      2.460425954535137_REALK,      0.000000000000000_REALK,     -2.922257675835115_REALK, &
     -1.428912776507044_REALK,      0.000000000000000_REALK,      1.049458697008935_REALK, &
      0.000000000000000_REALK,      5.202000584987620_REALK,      0.000000000000000_REALK, &
     -1.484234296515619_REALK,      0.000000000000000_REALK,    -11.607384231137832_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.698459703413077_REALK, &
      0.000000000000000_REALK,      0.743823493121433_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.816400187036257_REALK,      0.000000000000000_REALK, &
     -1.121650219871096_REALK,      0.000000000000000_REALK,      0.869018014470983_REALK, &
      0.000000000000000_REALK,      0.410805959219580_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.076544544449694_REALK, &
      0.000000000000000_REALK,      0.307487005928917_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.238240157333552_REALK,      0.000000000000000_REALK, &
      1.775066043629487_REALK,      0.000000000000000_REALK,      0.488148093280412_REALK, &
      0.000000000000000_REALK,     -0.711690320816048_REALK,      0.000000000000000_REALK, &
      4.678821358830069_REALK,     -0.420792834598234_REALK,      0.000000000000000_REALK, &
      0.731165171271721_REALK,      0.000000000000000_REALK,      2.045396202538604_REALK, &
     -0.280030514157769_REALK,      0.000000000000000_REALK,     -0.227605082031819_REALK, &
      0.000000000000000_REALK,      0.822506989383690_REALK,      0.000000000000000_REALK, &
      0.720210425853235_REALK,      0.000000000000000_REALK,      2.656740958070946_REALK, &
      2.056062337463617_REALK,     -0.255701595454561_REALK,      0.000000000000000_REALK, &
      0.666693551646515_REALK,      0.000000000000000_REALK,      0.554335445770593_REALK, &
      0.207025791511923_REALK,      0.000000000000000_REALK,     -0.063165085900084_REALK, &
      0.000000000000000_REALK,      2.147276599571883_REALK,      0.000000000000000_REALK, &
      0.231180760344373_REALK,      0.000000000000000_REALK,     -2.777260607668860_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.019042820318713_REALK, &
      0.000000000000000_REALK,      0.014200098391831_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.364485628026792_REALK,      0.000000000000000_REALK, &
     -1.944939546187652_REALK,      0.000000000000000_REALK,      0.086582181084138_REALK, &
      0.000000000000000_REALK,      0.024910487110583_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.308084741338024_REALK, &
      0.000000000000000_REALK,      0.130671254405151_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.045374051687883_REALK,      0.000000000000000_REALK, &
     -0.459648041207891_REALK,      0.000000000000000_REALK,      0.807721276770392_REALK, &
      0.000000000000000_REALK,      0.064454222530262_REALK,      0.000000000000000_REALK, &
      2.090862850704727_REALK,      0.193431372255286_REALK,      0.000000000000000_REALK, &
      0.354650679022685_REALK,      0.000000000000000_REALK,      1.801859062569511_REALK, &
      0.124527486634725_REALK,      0.000000000000000_REALK,      0.206250410852917_REALK, &
      0.000000000000000_REALK,      0.514855477643717_REALK,      0.000000000000000_REALK, &
      0.688650701795825_REALK,      0.000000000000000_REALK,      4.635112651272926_REALK, &
      1.640772398984861_REALK,      0.492595414439395_REALK,      0.000000000000000_REALK, &
      0.998097813009982_REALK,      0.000000000000000_REALK,      1.654313929695175_REALK, &
      1.467730290625975_REALK,      0.000000000000000_REALK,      0.455058500253611_REALK, &
      0.000000000000000_REALK,      4.630382477226600_REALK,      0.000000000000000_REALK, &
      1.294290460957594_REALK,      0.000000000000000_REALK,      0.926895622414445_REALK/
    ! results of test 7, ket-major order, 03ODGYYY
  data REF_CONTR_INTS(69301:70560)                                                         &
     /0.000000000000000_REALK,      0.000000000000000_REALK,      1.014389542508378_REALK, &
      0.000000000000000_REALK,      0.381986372254824_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.232607347162773_REALK,      0.000000000000000_REALK, &
      0.643466698887012_REALK,      0.000000000000000_REALK,      0.046519537126272_REALK, &
      0.000000000000000_REALK,      0.343351703539849_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.226492452842789_REALK, &
      0.000000000000000_REALK,     -0.269126460395106_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.973734900501095_REALK,      0.000000000000000_REALK, &
      0.167110127091095_REALK,      0.000000000000000_REALK,     -3.132266638773400_REALK, &
      0.000000000000000_REALK,     -0.243761525397866_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.224462289982473_REALK, &
      0.000000000000000_REALK,      0.378776811259695_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.280815115886089_REALK,      0.000000000000000_REALK, &
      0.669488893557356_REALK,      0.000000000000000_REALK,      0.266346119009337_REALK, &
      0.000000000000000_REALK,      0.280297640662007_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.864682835379409_REALK, &
      0.000000000000000_REALK,      0.467403264775629_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.715615685549735_REALK,      0.000000000000000_REALK, &
      0.426240840714062_REALK,      0.000000000000000_REALK,      1.689955422886239_REALK, &
      0.000000000000000_REALK,      0.314615508367300_REALK,      0.000000000000000_REALK, &
      0.803518733777365_REALK,      0.259422044192534_REALK,      0.000000000000000_REALK, &
      0.132282768230293_REALK,      0.000000000000000_REALK,     -0.173302295414209_REALK, &
      0.019217682657391_REALK,      0.000000000000000_REALK,     -0.067174312763246_REALK, &
      0.000000000000000_REALK,     -0.175413384275197_REALK,      0.000000000000000_REALK, &
     -0.046359391403447_REALK,      0.000000000000000_REALK,     -0.346755238134299_REALK, &
      0.151181052416076_REALK,     -0.119004659116819_REALK,      0.000000000000000_REALK, &
     -0.323570993899528_REALK,      0.000000000000000_REALK,     -0.089591446833744_REALK, &
     -0.753799339233346_REALK,      0.000000000000000_REALK,      0.094644879015199_REALK, &
      0.000000000000000_REALK,     -1.992944237913689_REALK,      0.000000000000000_REALK, &
      0.351392834982741_REALK,      0.000000000000000_REALK,     -0.133069894453276_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.628822225495115_REALK, &
      0.000000000000000_REALK,      0.347843660710872_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.230686869046846_REALK,      0.000000000000000_REALK, &
      0.761996746079909_REALK,      0.000000000000000_REALK,      0.117821511574320_REALK, &
      0.000000000000000_REALK,      0.211393144227545_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.727443647963574_REALK, &
      0.000000000000000_REALK,      0.019053334385996_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.285249586038525_REALK,      0.000000000000000_REALK, &
      0.398292803172567_REALK,      0.000000000000000_REALK,     -1.001526489668212_REALK, &
      0.000000000000000_REALK,      0.011622965571747_REALK,      0.000000000000000_REALK, &
      1.108530218791016_REALK,      0.295893819339926_REALK,      0.000000000000000_REALK, &
      0.184025651328063_REALK,      0.000000000000000_REALK,     -0.207778042984093_REALK, &
      0.131535280271804_REALK,      0.000000000000000_REALK,     -0.065556191697481_REALK, &
      0.000000000000000_REALK,      0.174885063904614_REALK,      0.000000000000000_REALK, &
     -0.052964339626236_REALK,      0.000000000000000_REALK,     -0.341420122297611_REALK, &
      0.234311813492971_REALK,      0.161583132959326_REALK,      0.000000000000000_REALK, &
      0.242522484947097_REALK,      0.000000000000000_REALK,     -0.233057000093144_REALK, &
      0.475219496887037_REALK,      0.000000000000000_REALK,     -0.142736177340141_REALK, &
      0.000000000000000_REALK,      1.159043538914662_REALK,      0.000000000000000_REALK, &
     -0.238689275057831_REALK,      0.000000000000000_REALK,     -0.313713343363062_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.091070431082846_REALK, &
      0.000000000000000_REALK,     -0.029612950535252_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.015401186315782_REALK,      0.000000000000000_REALK, &
      0.088009094149535_REALK,      0.000000000000000_REALK,     -0.002438286111879_REALK, &
      0.000000000000000_REALK,      0.037175705169837_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.017191856424767_REALK, &
      0.000000000000000_REALK,     -0.017804149037715_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.054848385132510_REALK,      0.000000000000000_REALK, &
      0.069162056113356_REALK,      0.000000000000000_REALK,     -0.139559931966086_REALK, &
      0.000000000000000_REALK,     -0.079801159248356_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.515789590787578_REALK, &
      0.000000000000000_REALK,      0.354575006258369_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.260673344592997_REALK,      0.000000000000000_REALK, &
      0.989922802214872_REALK,      0.000000000000000_REALK,      0.114072120555864_REALK, &
      0.000000000000000_REALK,      0.175359496301771_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.329077932320228_REALK, &
      0.000000000000000_REALK,      0.487629944891657_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.587969703797702_REALK,      0.000000000000000_REALK, &
      0.772571186545912_REALK,      0.000000000000000_REALK,      1.024538430505777_REALK, &
      0.000000000000000_REALK,      0.205343541343389_REALK,      0.000000000000000_REALK, &
      1.754260832331272_REALK,      0.321739957907894_REALK,      0.000000000000000_REALK, &
      0.178688480207536_REALK,      0.000000000000000_REALK,     -0.279527918082450_REALK, &
      0.070561158820683_REALK,      0.000000000000000_REALK,     -0.059955690023983_REALK, &
      0.000000000000000_REALK,      0.035759982561177_REALK,      0.000000000000000_REALK, &
     -0.041851990486915_REALK,      0.000000000000000_REALK,     -0.373791151743283_REALK, &
      0.798820865789569_REALK,      0.013788638509421_REALK,      0.000000000000000_REALK, &
     -0.151264631175268_REALK,      0.000000000000000_REALK,     -0.340760905060492_REALK, &
     -0.394113545442658_REALK,      0.000000000000000_REALK,     -0.007379225912950_REALK, &
      0.000000000000000_REALK,     -0.921581671977642_REALK,      0.000000000000000_REALK, &
      0.102769207370531_REALK,      0.000000000000000_REALK,     -0.316639667302131_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.129282912195901_REALK, &
      0.000000000000000_REALK,     -0.034159221474405_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.021337583978286_REALK,      0.000000000000000_REALK, &
      0.105084549581514_REALK,      0.000000000000000_REALK,     -0.016052994798049_REALK, &
      0.000000000000000_REALK,      0.034897945715042_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.093619106315650_REALK, &
      0.000000000000000_REALK,      0.042014420142003_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.052136727605383_REALK,      0.000000000000000_REALK, &
      0.228171288332153_REALK,      0.000000000000000_REALK,      0.095035130801528_REALK, &
      0.000000000000000_REALK,      0.129996323941977_REALK,      0.000000000000000_REALK, &
      0.451046305280492_REALK,      0.125958026069409_REALK,      0.000000000000000_REALK, &
      0.054859407436547_REALK,      0.000000000000000_REALK,      0.029301758484540_REALK, &
      0.006715046687797_REALK,      0.000000000000000_REALK,      0.009569577913828_REALK, &
      0.000000000000000_REALK,     -0.048617841862455_REALK,      0.000000000000000_REALK, &
      0.005238563430711_REALK,      0.000000000000000_REALK,     -0.076785144796817_REALK, &
      0.179750287092950_REALK,     -0.122678481138015_REALK,      0.000000000000000_REALK, &
     -0.276931901737616_REALK,      0.000000000000000_REALK,     -0.044993580852975_REALK, &
     -0.522897352253717_REALK,      0.000000000000000_REALK,      0.038524624438801_REALK, &
      0.000000000000000_REALK,     -1.067089503139069_REALK,      0.000000000000000_REALK, &
      0.110402575578426_REALK,      0.000000000000000_REALK,     -0.096512817906431_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.519198167175680_REALK, &
      0.000000000000000_REALK,      0.349610206544180_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.329326406820217_REALK,      0.000000000000000_REALK, &
      1.482508542887697_REALK,      0.000000000000000_REALK,      0.064647396294924_REALK, &
      0.000000000000000_REALK,      0.139400332084483_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.973171873815267_REALK, &
      0.000000000000000_REALK,      0.048143576487240_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.225865241225581_REALK,      0.000000000000000_REALK, &
      1.191901051068122_REALK,      0.000000000000000_REALK,     -1.001991985454090_REALK, &
      0.000000000000000_REALK,      0.019710677952873_REALK,      0.000000000000000_REALK, &
      3.256589121816917_REALK,      0.397169464445909_REALK,      0.000000000000000_REALK, &
      0.245500130054139_REALK,      0.000000000000000_REALK,     -0.441524515971101_REALK, &
      0.084754330179408_REALK,      0.000000000000000_REALK,     -0.061703537496277_REALK, &
      0.000000000000000_REALK,      0.085185123014356_REALK,      0.000000000000000_REALK, &
     -0.046358547971838_REALK,      0.000000000000000_REALK,     -0.476011215190437_REALK, &
      0.813018908504391_REALK,      0.228895224593613_REALK,      0.000000000000000_REALK, &
      0.290042140237824_REALK,      0.000000000000000_REALK,     -0.614864746249400_REALK, &
      0.457829871381959_REALK,      0.000000000000000_REALK,     -0.148044355325869_REALK, &
      0.000000000000000_REALK,      0.969296708507039_REALK,      0.000000000000000_REALK, &
     -0.191584004791377_REALK,      0.000000000000000_REALK,     -0.555479048152547_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.210626731852506_REALK, &
      0.000000000000000_REALK,     -0.037984470355346_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.020917947377236_REALK,      0.000000000000000_REALK, &
      0.142731567977333_REALK,      0.000000000000000_REALK,     -0.008441497034061_REALK, &
      0.000000000000000_REALK,      0.031286465954408_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.088786731844592_REALK, &
      0.000000000000000_REALK,      0.002020546739979_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.025491231733688_REALK,      0.000000000000000_REALK, &
      0.261523231851510_REALK,      0.000000000000000_REALK,     -0.071281626775219_REALK, &
      0.000000000000000_REALK,      0.006078188024335_REALK,      0.000000000000000_REALK, &
      0.769578693690987_REALK,      0.175953922645875_REALK,      0.000000000000000_REALK, &
      0.092410985731150_REALK,      0.000000000000000_REALK,      0.042538916362517_REALK, &
      0.054848114568038_REALK,      0.000000000000000_REALK,      0.011144862040676_REALK, &
      0.000000000000000_REALK,      0.057619682284757_REALK,      0.000000000000000_REALK, &
      0.007114481144667_REALK,      0.000000000000000_REALK,     -0.089872843144580_REALK, &
      0.311155791866979_REALK,      0.187776617429713_REALK,      0.000000000000000_REALK, &
      0.244876265783582_REALK,      0.000000000000000_REALK,     -0.138082117789811_REALK, &
      0.404349416822390_REALK,      0.000000000000000_REALK,     -0.071265155223706_REALK, &
      0.000000000000000_REALK,      0.785437595041048_REALK,      0.000000000000000_REALK, &
     -0.094912943671760_REALK,      0.000000000000000_REALK,     -0.287968118628457_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.191322773207639_REALK, &
      0.000000000000000_REALK,     -0.052535532167619_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.022688189385782_REALK,      0.000000000000000_REALK, &
     -0.013831640151669_REALK,      0.000000000000000_REALK,     -0.002838108664675_REALK, &
      0.000000000000000_REALK,     -0.004616406422622_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.023450464519327_REALK, &
      0.000000000000000_REALK,      0.021100808341625_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.054778432875952_REALK,      0.000000000000000_REALK, &
      0.069062828124277_REALK,      0.000000000000000_REALK,      0.111008407139168_REALK, &
      0.000000000000000_REALK,     -0.063465108500894_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     11.011321470130087_REALK, &
      0.000000000000000_REALK,      0.278327086165248_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.573585507533667_REALK,      0.000000000000000_REALK, &
      2.765591011988680_REALK,      0.000000000000000_REALK,      0.031237905722586_REALK, &
      0.000000000000000_REALK,      0.083963019858516_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     23.775207262616210_REALK, &
      0.000000000000000_REALK,      1.201711113404797_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.023850024529694_REALK,      0.000000000000000_REALK, &
      4.702480870025951_REALK,      0.000000000000000_REALK,      2.124226709109430_REALK, &
      0.000000000000000_REALK,      0.273786980842336_REALK,      0.000000000000000_REALK, &
      8.732611962237669_REALK,      0.555028513967204_REALK,      0.000000000000000_REALK, &
      0.423444861190502_REALK,      0.000000000000000_REALK,     -0.902746697711627_REALK, &
      0.064647396294924_REALK,      0.000000000000000_REALK,     -0.066017975338541_REALK, &
      0.000000000000000_REALK,      0.065602068569501_REALK,      0.000000000000000_REALK, &
     -0.060496163924896_REALK,      0.000000000000000_REALK,     -0.736344661285925_REALK, &
      9.626095910136931_REALK,      0.099654940991531_REALK,      0.000000000000000_REALK, &
     -0.321609606429370_REALK,      0.000000000000000_REALK,     -2.738134312242686_REALK, &
     -1.001991985454089_REALK,      0.000000000000000_REALK,     -0.031800686551418_REALK, &
      0.000000000000000_REALK,     -1.768972410844089_REALK,      0.000000000000000_REALK, &
      0.118216109249311_REALK,      0.000000000000000_REALK,     -1.376551106781574_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.471527018033634_REALK, &
      0.000000000000000_REALK,     -0.053370459424984_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.031185333432981_REALK,      0.000000000000000_REALK, &
      0.244639074028730_REALK,      0.000000000000000_REALK,     -0.010473304835374_REALK, &
      0.000000000000000_REALK,      0.033258621692408_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.706467230630363_REALK, &
      0.000000000000000_REALK,      0.117010115070072_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.106343558768501_REALK,      0.000000000000000_REALK, &
      1.026683931578840_REALK,      0.000000000000000_REALK,      0.133009704142181_REALK, &
      0.000000000000000_REALK,      0.195874607284092_REALK,      0.000000000000000_REALK, &
      1.871627954723397_REALK,      0.277306803233457_REALK,      0.000000000000000_REALK, &
      0.123683747159683_REALK,      0.000000000000000_REALK,      0.078882887748952_REALK, &
      0.038818855719577_REALK,      0.000000000000000_REALK,      0.013447729420112_REALK, &
      0.000000000000000_REALK,      0.015098186467694_REALK,      0.000000000000000_REALK, &
      0.007204189633852_REALK,      0.000000000000000_REALK,     -0.126089154121648_REALK, &
      2.737001350795438_REALK,      0.039822283530535_REALK,      0.000000000000000_REALK, &
     -0.345594804216565_REALK,      0.000000000000000_REALK,     -0.456835850078558_REALK, &
     -0.678694571000772_REALK,      0.000000000000000_REALK,     -0.007456661404949_REALK, &
      0.000000000000000_REALK,     -1.139162488847957_REALK,      0.000000000000000_REALK, &
      0.074541041507852_REALK,      0.000000000000000_REALK,     -0.530171832536051_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.393661429723657_REALK, &
      0.000000000000000_REALK,     -0.083531495860705_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.041471379654693_REALK,      0.000000000000000_REALK, &
     -0.021789264660710_REALK,      0.000000000000000_REALK,     -0.023944720211126_REALK, &
      0.000000000000000_REALK,     -0.005553337028466_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.317360193655487_REALK, &
      0.000000000000000_REALK,     -0.112670798735578_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.105385283910535_REALK,      0.000000000000000_REALK, &
      0.461134802397488_REALK,      0.000000000000000_REALK,     -0.137885694454027_REALK, &
      0.000000000000000_REALK,      0.188580511795880_REALK,      0.000000000000000_REALK, &
      0.802038536002474_REALK,      0.180938139079923_REALK,      0.000000000000000_REALK, &
      0.063287208655265_REALK,      0.000000000000000_REALK,      0.150518430468593_REALK, &
      0.006157080204853_REALK,      0.000000000000000_REALK,      0.039070567997919_REALK, &
      0.000000000000000_REALK,     -0.034211483970033_REALK,      0.000000000000000_REALK, &
      0.016414195839348_REALK,      0.000000000000000_REALK,      0.006510291218631_REALK, &
      1.026464546368171_REALK,     -0.590502735958478_REALK,      0.000000000000000_REALK, &
     -1.054512056329488_REALK,      0.000000000000000_REALK,     -0.050679695257640_REALK, &
     -1.500784051825622_REALK,      0.000000000000000_REALK,      0.032707326934143_REALK, &
      0.000000000000000_REALK,     -2.198373316913725_REALK,      0.000000000000000_REALK, &
      0.067279797647586_REALK,      0.000000000000000_REALK,     -0.214226888635535_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.247822955927475_REALK, &
      0.000000000000000_REALK,     -0.199913437464120_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.415518172694637_REALK,      0.000000000000000_REALK, &
      1.897662991683392_REALK,      0.000000000000000_REALK,     -1.204702200710235_REALK, &
      0.000000000000000_REALK,     -0.748180625527274_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.396718009480177_REALK, &
      0.000000000000000_REALK,     -0.443644681895234_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.132466738271805_REALK,      0.000000000000000_REALK, &
      1.009315346625729_REALK,      0.000000000000000_REALK,     -7.469559923446975_REALK, &
      0.000000000000000_REALK,     -1.980085008834158_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.519614091819512_REALK, &
      0.000000000000000_REALK,     -0.684916397741056_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.814149842780701_REALK,      0.000000000000000_REALK, &
      3.264412193687626_REALK,      0.000000000000000_REALK,     -1.758819599515942_REALK, &
      0.000000000000000_REALK,     -2.201061103872201_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.548904685454893_REALK, &
      0.000000000000000_REALK,     -0.300809469219756_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.768592304295731_REALK,      0.000000000000000_REALK, &
      2.180383541690774_REALK,      0.000000000000000_REALK,      1.917541347329537_REALK, &
      0.000000000000000_REALK,     -1.065005050975512_REALK,      0.000000000000000_REALK, &
      4.113229434803028_REALK,     -0.117177029713871_REALK,      0.000000000000000_REALK, &
      1.036099908651636_REALK,      0.000000000000000_REALK,      0.093187360446296_REALK, &
     -0.244448115609934_REALK,      0.000000000000000_REALK,     -0.002989783612861_REALK, &
      0.000000000000000_REALK,      1.566543435635167_REALK,      0.000000000000000_REALK, &
      0.065572611478724_REALK,      0.000000000000000_REALK,     -4.469848749333143_REALK, &
      1.194562270372654_REALK,     -0.169116696624364_REALK,      0.000000000000000_REALK, &
     -0.168562599451706_REALK,      0.000000000000000_REALK,     -0.543699035194378_REALK, &
     -0.898061065659939_REALK,      0.000000000000000_REALK,      0.100779453030987_REALK, &
      0.000000000000000_REALK,     -7.480498622949561_REALK,      0.000000000000000_REALK, &
      0.252638010445858_REALK,      0.000000000000000_REALK,     -5.365617682838007_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.283698180139276_REALK, &
      0.000000000000000_REALK,     -1.397643383092767_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.393303741322704_REALK,      0.000000000000000_REALK, &
      4.834970807231532_REALK,      0.000000000000000_REALK,     -2.918174405583529_REALK, &
      0.000000000000000_REALK,     -3.599511071016347_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.271755805947815_REALK, &
      0.000000000000000_REALK,     -1.052417278372270_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.695093118477865_REALK,      0.000000000000000_REALK, &
      3.459865936578101_REALK,      0.000000000000000_REALK,     -3.792916181507350_REALK, &
      0.000000000000000_REALK,     -2.988940734851295_REALK,      0.000000000000000_REALK, &
      5.574631655585293_REALK,     -0.642229573332999_REALK,      0.000000000000000_REALK, &
      1.346302346311171_REALK,      0.000000000000000_REALK,      0.106308884255804_REALK, &
     -0.579234591597570_REALK,      0.000000000000000_REALK,     -0.014275508988888_REALK, &
      0.000000000000000_REALK,      2.859660761450996_REALK,      0.000000000000000_REALK, &
      0.068283543921164_REALK,      0.000000000000000_REALK,     -4.086560971752970_REALK, &
      1.038345723367878_REALK,     -0.140937822371425_REALK,      0.000000000000000_REALK, &
      0.612910706683770_REALK,      0.000000000000000_REALK,     -0.736056885650424_REALK, &
      0.386472192589455_REALK,      0.000000000000000_REALK,      0.090866225799357_REALK, &
      0.000000000000000_REALK,      4.949167710175615_REALK,      0.000000000000000_REALK, &
     -0.736892015057743_REALK,      0.000000000000000_REALK,     -5.826955643487325_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.064254310892508_REALK, &
      0.000000000000000_REALK,      0.060216247482289_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.263021557291135_REALK,      0.000000000000000_REALK, &
     -0.462269792229457_REALK,      0.000000000000000_REALK,      0.249708930612020_REALK, &
      0.000000000000000_REALK,      0.059680978237502_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.196928658533851_REALK, &
      0.000000000000000_REALK,      0.062128015248207_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.039362847978430_REALK,      0.000000000000000_REALK, &
      0.487142458824209_REALK,      0.000000000000000_REALK,      0.665622499989556_REALK, &
      0.000000000000000_REALK,     -0.286593443738476_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      7.524936976106547_REALK, &
      0.000000000000000_REALK,     -2.732510395238596_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.509363623863095_REALK,      0.000000000000000_REALK, &
      7.213451124401638_REALK,      0.000000000000000_REALK,     -4.473746292718081_REALK, &
      0.000000000000000_REALK,     -5.354756207004236_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.960742575728101_REALK, &
      0.000000000000000_REALK,     -2.447694492769884_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.507944602790394_REALK,      0.000000000000000_REALK, &
      6.520939241445864_REALK,      0.000000000000000_REALK,     -2.207907504383066_REALK, &
      0.000000000000000_REALK,     -4.472460569852844_REALK,      0.000000000000000_REALK, &
      9.192168077740350_REALK,     -1.827422378428857_REALK,      0.000000000000000_REALK, &
      2.092990922280479_REALK,      0.000000000000000_REALK,      0.143034798015956_REALK, &
     -1.420191457274682_REALK,      0.000000000000000_REALK,     -0.034498918042401_REALK, &
      0.000000000000000_REALK,      3.606951220334230_REALK,      0.000000000000000_REALK, &
      0.080773989612600_REALK,      0.000000000000000_REALK,     -4.183703218039089_REALK, &
      4.556872123131439_REALK,     -1.054775502239941_REALK,      0.000000000000000_REALK, &
      0.621929152000193_REALK,      0.000000000000000_REALK,     -1.310492393848716_REALK, &
     -1.253922100580737_REALK,      0.000000000000000_REALK,      0.418303909680587_REALK, &
      0.000000000000000_REALK,     -1.613079277475548_REALK,      0.000000000000000_REALK, &
     -0.481069177618365_REALK,      0.000000000000000_REALK,     -6.674593365735406_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.692964290677905_REALK, &
      0.000000000000000_REALK,      0.261185350707643_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.404750483536701_REALK,      0.000000000000000_REALK, &
     -0.624544126764523_REALK,      0.000000000000000_REALK,      0.408993016138364_REALK, &
      0.000000000000000_REALK,      0.196970777443980_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.570292619632206_REALK, &
      0.000000000000000_REALK,      0.062851366072781_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.188328249045885_REALK,      0.000000000000000_REALK, &
      0.867764279843176_REALK,      0.000000000000000_REALK,     -0.206774557928515_REALK, &
      0.000000000000000_REALK,     -0.186532052164998_REALK,      0.000000000000000_REALK, &
      2.107303312696312_REALK,     -0.072650531018349_REALK,      0.000000000000000_REALK, &
      0.364582169650482_REALK,      0.000000000000000_REALK,      1.142816913886014_REALK, &
     -0.112137860420463_REALK,      0.000000000000000_REALK,     -0.047800362289972_REALK, &
      0.000000000000000_REALK,      0.336139520010646_REALK,      0.000000000000000_REALK, &
      0.490371785085509_REALK,      0.000000000000000_REALK,      2.026910469061863_REALK, &
      1.554921447712337_REALK,     -0.245105965486249_REALK,      0.000000000000000_REALK, &
     -0.138636879631378_REALK,      0.000000000000000_REALK,      0.257045134314072_REALK, &
     -0.866202917559264_REALK,      0.000000000000000_REALK,     -0.055875193584075_REALK, &
      0.000000000000000_REALK,     -3.175245051038892_REALK,      0.000000000000000_REALK, &
     -0.061642275646065_REALK,      0.000000000000000_REALK,     -1.651307020011043_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     14.615867775301636_REALK, &
      0.000000000000000_REALK,     -5.712108491361608_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      4.858009152218718_REALK,      0.000000000000000_REALK, &
     11.518238205208082_REALK,      0.000000000000000_REALK,     -7.344365338688053_REALK, &
      0.000000000000000_REALK,     -8.197627631190596_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     12.341115545320966_REALK, &
      0.000000000000000_REALK,     -6.258871029538125_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      5.084283761607266_REALK,      0.000000000000000_REALK, &
     12.528165826895750_REALK,      0.000000000000000_REALK,     -8.751309962980688_REALK, &
      0.000000000000000_REALK,     -8.918891018361736_REALK,      0.000000000000000_REALK, &
     18.048388930187979_REALK,     -4.708126990820202_REALK,      0.000000000000000_REALK, &
      3.998966431887517_REALK,      0.000000000000000_REALK,      0.226388083730797_REALK, &
     -3.099854198911363_REALK,      0.000000000000000_REALK,     -0.073069465100360_REALK, &
      0.000000000000000_REALK,      5.847992253162566_REALK,      0.000000000000000_REALK, &
      0.113022733718353_REALK,      0.000000000000000_REALK,     -4.849384108294083_REALK, &
      5.176814166328185_REALK,     -2.116426280936835_REALK,      0.000000000000000_REALK, &
      2.205952486108716_REALK,      0.000000000000000_REALK,     -2.428095011886606_REALK, &
     -1.060646286333125_REALK,      0.000000000000000_REALK,      0.909522671074535_REALK, &
      0.000000000000000_REALK,      5.383000939078121_REALK,      0.000000000000000_REALK, &
     -1.330725003258656_REALK,      0.000000000000000_REALK,     -9.644540242202536_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.001675386626190_REALK, &
      0.000000000000000_REALK,      0.669615205287246_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.681674614928654_REALK,      0.000000000000000_REALK, &
     -0.910332983832131_REALK,      0.000000000000000_REALK,      0.779084881598128_REALK, &
      0.000000000000000_REALK,      0.369821495636916_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.875981120770806_REALK, &
      0.000000000000000_REALK,      0.284435923019973_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.178653504161776_REALK,      0.000000000000000_REALK, &
      1.444366004507136_REALK,      0.000000000000000_REALK,      0.514345851434621_REALK, &
      0.000000000000000_REALK,     -0.658337716399273_REALK,      0.000000000000000_REALK, &
      3.746846581712671_REALK,     -0.415257704788602_REALK,      0.000000000000000_REALK, &
      0.595187875464834_REALK,      0.000000000000000_REALK,      1.637973579663696_REALK, &
     -0.261497985111057_REALK,      0.000000000000000_REALK,     -0.224611153497886_REALK, &
      0.000000000000000_REALK,      0.704483114142226_REALK,      0.000000000000000_REALK, &
      0.586270421641717_REALK,      0.000000000000000_REALK,      2.127544527524610_REALK, &
      1.669548694856711_REALK,     -0.213921774940747_REALK,      0.000000000000000_REALK, &
      0.652060691300554_REALK,      0.000000000000000_REALK,      0.450127412547618_REALK, &
      0.391003943797764_REALK,      0.000000000000000_REALK,     -0.052844360497672_REALK, &
      0.000000000000000_REALK,      2.641852116511522_REALK,      0.000000000000000_REALK, &
      0.226106711296744_REALK,      0.000000000000000_REALK,     -2.255170837150041_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.587925082613918_REALK, &
      0.000000000000000_REALK,      0.061430259872095_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.274007464194092_REALK,      0.000000000000000_REALK, &
     -1.529644769530735_REALK,      0.000000000000000_REALK,      0.141953903049105_REALK, &
      0.000000000000000_REALK,      0.107763879835078_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.990016048191835_REALK, &
      0.000000000000000_REALK,      0.218919358868411_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.131903182883006_REALK,      0.000000000000000_REALK, &
     -0.347881848121154_REALK,      0.000000000000000_REALK,      1.176820437848553_REALK, &
      0.000000000000000_REALK,      0.107983023021554_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     35.090900440650088_REALK, &
      0.000000000000000_REALK,    -13.869478745974662_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     10.653444921579505_REALK,      0.000000000000000_REALK, &
     20.923477246062099_REALK,      0.000000000000000_REALK,    -13.338918978021086_REALK, &
      0.000000000000000_REALK,    -13.726179231350100_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     87.820127296931801_REALK, &
      0.000000000000000_REALK,    -32.772553231428134_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     22.595582444622544_REALK,      0.000000000000000_REALK, &
     41.325510294716835_REALK,      0.000000000000000_REALK,    -19.408209061846964_REALK, &
      0.000000000000000_REALK,    -22.471333500684267_REALK,      0.000000000000000_REALK, &
     47.509125028116941_REALK,    -13.748294878174267_REALK,      0.000000000000000_REALK, &
      9.434656252642212_REALK,      0.000000000000000_REALK,      0.440534695350206_REALK, &
     -7.344365338688051_REALK,      0.000000000000000_REALK,     -0.161441244377933_REALK, &
      0.000000000000000_REALK,     10.578989159110298_REALK,      0.000000000000000_REALK, &
      0.183883142427730_REALK,      0.000000000000000_REALK,     -6.507451290848692_REALK, &
     64.579404298560505_REALK,    -18.953381071258619_REALK,      0.000000000000000_REALK, &
      9.929671574130994_REALK,      0.000000000000000_REALK,    -10.357856853933287_REALK, &
     -8.751309962980688_REALK,      0.000000000000000_REALK,      3.775619023358763_REALK, &
      0.000000000000000_REALK,      4.353802959734896_REALK,      0.000000000000000_REALK, &
     -2.882244110310828_REALK,      0.000000000000000_REALK,    -19.796548148354930_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -6.636538616331555_REALK, &
      0.000000000000000_REALK,      1.728380478224889_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.376580074306070_REALK,      0.000000000000000_REALK, &
     -1.522846321642324_REALK,      0.000000000000000_REALK,      1.429093115432881_REALK, &
      0.000000000000000_REALK,      0.658269878302690_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -5.684217342364443_REALK, &
      0.000000000000000_REALK,      1.373197293140344_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.028732886576977_REALK,      0.000000000000000_REALK, &
      4.344544751007688_REALK,      0.000000000000000_REALK,      0.464821129319422_REALK, &
      0.000000000000000_REALK,     -1.529329068286219_REALK,      0.000000000000000_REALK, &
      9.003237145866445_REALK,     -1.487168701027406_REALK,      0.000000000000000_REALK, &
      1.221595468921582_REALK,      0.000000000000000_REALK,      2.909562125522384_REALK, &
     -0.718898066710719_REALK,      0.000000000000000_REALK,     -0.608627755686289_REALK, &
      0.000000000000000_REALK,      1.063192693735805_REALK,      0.000000000000000_REALK, &
      0.829791740932026_REALK,      0.000000000000000_REALK,      2.606136670547621_REALK, &
     18.043828856478953_REALK,     -3.390544694833136_REALK,      0.000000000000000_REALK, &
      1.373444071035067_REALK,      0.000000000000000_REALK,      1.663557587563720_REALK, &
     -2.024648229491992_REALK,      0.000000000000000_REALK,     -0.388243519210374_REALK, &
      0.000000000000000_REALK,     -1.336764903456491_REALK,      0.000000000000000_REALK, &
      0.229160692040707_REALK,      0.000000000000000_REALK,     -4.010380105812714_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.179261765294486_REALK, &
      0.000000000000000_REALK,      0.351775893500439_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.472786413432424_REALK,      0.000000000000000_REALK, &
     -2.317206630724698_REALK,      0.000000000000000_REALK,      0.278192103421982_REALK, &
      0.000000000000000_REALK,      0.425554049691215_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -6.071738600485277_REALK, &
      0.000000000000000_REALK,      0.459717103663833_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.007164397449591_REALK,      0.000000000000000_REALK, &
     -0.988994071231010_REALK,      0.000000000000000_REALK,     -0.567547610213205_REALK, &
      0.000000000000000_REALK,      0.109110284659800_REALK,      0.000000000000000_REALK, &
      3.439984869369132_REALK,     -0.098539156499770_REALK,      0.000000000000000_REALK, &
      0.354653494315653_REALK,      0.000000000000000_REALK,      2.191491386344133_REALK, &
     -0.094606599986229_REALK,      0.000000000000000_REALK,     -0.079497715401494_REALK, &
      0.000000000000000_REALK,      0.165135345577746_REALK,      0.000000000000000_REALK, &
      0.474897877373051_REALK,      0.000000000000000_REALK,      3.887559327233471_REALK, &
     10.261694034002419_REALK,     -1.313143143077266_REALK,      0.000000000000000_REALK, &
     -0.510267125400965_REALK,      0.000000000000000_REALK,      3.538029216652153_REALK, &
     -2.331027584840842_REALK,      0.000000000000000_REALK,     -0.562315461008674_REALK, &
      0.000000000000000_REALK,     -4.385562655818328_REALK,      0.000000000000000_REALK, &
     -0.318390388358831_REALK,      0.000000000000000_REALK,      0.953845493925382_REALK/
    ! results of test 7, ket-major order, 03ODGXXZ
  data REF_CONTR_INTS(70561:71820)                                                         &
    /-4.702310189935555_REALK,     -4.866369297051516_REALK,      0.000000000000000_REALK, &
     -6.715678886290879_REALK,      0.000000000000000_REALK,     -3.166566533379394_REALK, &
    -11.299751375997426_REALK,      0.000000000000000_REALK,     -4.053759652617332_REALK, &
      0.000000000000000_REALK,    -29.735744026748296_REALK,      0.000000000000000_REALK, &
     -8.878039677374693_REALK,      0.000000000000000_REALK,     -6.976932588249482_REALK, &
     -3.255892006842355_REALK,     -5.629486956543693_REALK,      0.000000000000000_REALK, &
     -9.689939216691755_REALK,      0.000000000000000_REALK,     -3.504638203586757_REALK, &
    -18.926164616216436_REALK,      0.000000000000000_REALK,     -5.515329136822177_REALK, &
      0.000000000000000_REALK,    -52.705892269048199_REALK,      0.000000000000000_REALK, &
    -13.117932774413763_REALK,      0.000000000000000_REALK,     -7.907446979319847_REALK, &
     -3.068942879763796_REALK,     -2.327389751846186_REALK,      0.000000000000000_REALK, &
     -2.394191065121736_REALK,      0.000000000000000_REALK,     -1.822217238202401_REALK, &
     -2.963047671325440_REALK,      0.000000000000000_REALK,     -1.697702806260671_REALK, &
      0.000000000000000_REALK,     -5.174394066252283_REALK,      0.000000000000000_REALK, &
     -2.610003762535846_REALK,      0.000000000000000_REALK,     -3.310786899418515_REALK, &
     -2.724744186877440_REALK,     -1.609269548538963_REALK,      0.000000000000000_REALK, &
     -1.087156500032461_REALK,      0.000000000000000_REALK,     -1.328744688447230_REALK, &
     -0.206351554376435_REALK,      0.000000000000000_REALK,     -1.112891733278458_REALK, &
      0.000000000000000_REALK,      3.101068734660924_REALK,      0.000000000000000_REALK, &
     -1.126884161454607_REALK,      0.000000000000000_REALK,     -2.295501067821439_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.796391669565980_REALK, &
      0.000000000000000_REALK,      0.862975653603200_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.232027954094029_REALK,      0.000000000000000_REALK, &
      1.570731358141665_REALK,      0.000000000000000_REALK,      2.622356688475667_REALK, &
      0.000000000000000_REALK,      2.543686164861153_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.780515118571113_REALK, &
      0.000000000000000_REALK,      2.143761541089574_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.404455412326858_REALK,      0.000000000000000_REALK, &
      2.717031453221886_REALK,      0.000000000000000_REALK,      7.625263605385726_REALK, &
      0.000000000000000_REALK,      4.903301074281632_REALK,      0.000000000000000_REALK, &
     -2.681685384957760_REALK,     -1.599133789468551_REALK,      0.000000000000000_REALK, &
     -1.395224106236474_REALK,      0.000000000000000_REALK,     -1.400384141591393_REALK, &
     -1.509950679247808_REALK,      0.000000000000000_REALK,     -1.014392693800378_REALK, &
      0.000000000000000_REALK,     -2.337700260265456_REALK,      0.000000000000000_REALK, &
     -1.254109069044432_REALK,      0.000000000000000_REALK,     -2.097912017939894_REALK, &
     -1.247392234001947_REALK,     -1.179124635349786_REALK,      0.000000000000000_REALK, &
     -1.345773238400221_REALK,      0.000000000000000_REALK,     -1.012565314586672_REALK, &
     -1.996309804491622_REALK,      0.000000000000000_REALK,     -0.869978956015426_REALK, &
      0.000000000000000_REALK,     -4.355725160527820_REALK,      0.000000000000000_REALK, &
     -1.218935280278479_REALK,      0.000000000000000_REALK,     -1.528553189494713_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.515576016650195_REALK, &
      0.000000000000000_REALK,      0.403320055882765_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.429707243297882_REALK,      0.000000000000000_REALK, &
      0.884293995431764_REALK,      0.000000000000000_REALK,      0.632729565361402_REALK, &
      0.000000000000000_REALK,      0.980220571295803_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.571779678721125_REALK, &
      0.000000000000000_REALK,      0.451701747655833_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.345166211699634_REALK,      0.000000000000000_REALK, &
      0.930899137699896_REALK,      0.000000000000000_REALK,      0.075860440201671_REALK, &
      0.000000000000000_REALK,      0.902787230555007_REALK,      0.000000000000000_REALK, &
      0.375396505160565_REALK,      0.346827299229723_REALK,      0.000000000000000_REALK, &
      0.415748689065393_REALK,      0.000000000000000_REALK,     -0.404948982987896_REALK, &
      0.613261186307717_REALK,      0.000000000000000_REALK,     -0.454470099249751_REALK, &
      0.000000000000000_REALK,      1.251653025922652_REALK,      0.000000000000000_REALK, &
     -0.771956723653389_REALK,      0.000000000000000_REALK,     -1.506982960457473_REALK, &
     -0.211819354871869_REALK,     -0.317380806048646_REALK,      0.000000000000000_REALK, &
     -0.475404746669446_REALK,      0.000000000000000_REALK,     -1.263361589820152_REALK, &
     -0.803564739413351_REALK,      0.000000000000000_REALK,     -1.720567480944146_REALK, &
      0.000000000000000_REALK,     -1.730079428139321_REALK,      0.000000000000000_REALK, &
     -3.163838380932500_REALK,      0.000000000000000_REALK,     -3.554739635336730_REALK, &
     -2.804797533464011_REALK,     -1.278409934010218_REALK,      0.000000000000000_REALK, &
     -0.928964156397758_REALK,      0.000000000000000_REALK,     -1.277354471054897_REALK, &
     -0.804986721220460_REALK,      0.000000000000000_REALK,     -0.698985390759142_REALK, &
      0.000000000000000_REALK,     -0.942198774985691_REALK,      0.000000000000000_REALK, &
     -0.687440343646957_REALK,      0.000000000000000_REALK,     -1.575419586955109_REALK, &
     -2.592274306373999_REALK,     -0.954775103821133_REALK,      0.000000000000000_REALK, &
     -0.450383122815403_REALK,      0.000000000000000_REALK,     -0.952171563664795_REALK, &
      0.015343534516553_REALK,      0.000000000000000_REALK,     -0.470651349019789_REALK, &
      0.000000000000000_REALK,      1.022161866817193_REALK,      0.000000000000000_REALK, &
     -0.303159018824227_REALK,      0.000000000000000_REALK,     -1.068199429811748_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.450406432874753_REALK, &
      0.000000000000000_REALK,      0.273202300276112_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.245357497792165_REALK,      0.000000000000000_REALK, &
      0.665863491058829_REALK,      0.000000000000000_REALK,      0.300938020200046_REALK, &
      0.000000000000000_REALK,      0.546642088407759_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.722379720889768_REALK, &
      0.000000000000000_REALK,      0.466415020687787_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.473273958804676_REALK,      0.000000000000000_REALK, &
      0.785757698524033_REALK,      0.000000000000000_REALK,      0.720410618273165_REALK, &
      0.000000000000000_REALK,      0.692764764582083_REALK,      0.000000000000000_REALK, &
      0.274729007583582_REALK,      0.184259290165678_REALK,      0.000000000000000_REALK, &
      0.164389126556838_REALK,      0.000000000000000_REALK,     -0.258455132823399_REALK, &
      0.175834596055941_REALK,      0.000000000000000_REALK,     -0.208112460752110_REALK, &
      0.000000000000000_REALK,      0.241172348962969_REALK,      0.000000000000000_REALK, &
     -0.251292701431759_REALK,      0.000000000000000_REALK,     -0.791840867181653_REALK, &
     -0.211847960816608_REALK,     -0.110869293106344_REALK,      0.000000000000000_REALK, &
     -0.063666219942988_REALK,      0.000000000000000_REALK,     -0.571742606323146_REALK, &
     -0.010133613322027_REALK,      0.000000000000000_REALK,     -0.401560991119062_REALK, &
      0.000000000000000_REALK,      0.117931430830123_REALK,      0.000000000000000_REALK, &
     -0.314875933019879_REALK,      0.000000000000000_REALK,     -1.195529537092832_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.118209334835161_REALK, &
      0.000000000000000_REALK,     -0.111090677307975_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.137072722940940_REALK,      0.000000000000000_REALK, &
      0.342461763462982_REALK,      0.000000000000000_REALK,     -0.229152481921534_REALK, &
      0.000000000000000_REALK,      0.435588119726406_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.685339125981187_REALK, &
      0.000000000000000_REALK,      0.701408217229485_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.934074702198476_REALK,      0.000000000000000_REALK, &
      1.720867789502897_REALK,      0.000000000000000_REALK,      1.620132047471582_REALK, &
      0.000000000000000_REALK,      2.404933057029690_REALK,      0.000000000000000_REALK, &
     -3.460911488134340_REALK,     -1.196147809358434_REALK,      0.000000000000000_REALK, &
     -0.760869133085339_REALK,      0.000000000000000_REALK,     -1.369759163752341_REALK, &
     -0.554478007177769_REALK,      0.000000000000000_REALK,     -0.559582699876705_REALK, &
      0.000000000000000_REALK,     -0.573404235463241_REALK,      0.000000000000000_REALK, &
     -0.462398877874875_REALK,      0.000000000000000_REALK,     -1.387393864762617_REALK, &
     -1.647566041353872_REALK,     -0.869578995420228_REALK,      0.000000000000000_REALK, &
     -0.715936063202437_REALK,      0.000000000000000_REALK,     -1.015724351493457_REALK, &
     -0.815688643776513_REALK,      0.000000000000000_REALK,     -0.476115306849514_REALK, &
      0.000000000000000_REALK,     -1.492491302181596_REALK,      0.000000000000000_REALK, &
     -0.436737215943176_REALK,      0.000000000000000_REALK,     -1.032691437679183_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.472565851274947_REALK, &
      0.000000000000000_REALK,      0.216932376270950_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.160778987801199_REALK,      0.000000000000000_REALK, &
      0.597756657892920_REALK,      0.000000000000000_REALK,      0.151827973942205_REALK, &
      0.000000000000000_REALK,      0.356462489361348_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.531073246857617_REALK, &
      0.000000000000000_REALK,      0.257339468711132_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.137538545692542_REALK,      0.000000000000000_REALK, &
      0.641626665470302_REALK,      0.000000000000000_REALK,     -0.005117742951327_REALK, &
      0.000000000000000_REALK,      0.346399486290386_REALK,      0.000000000000000_REALK, &
      0.274300926067715_REALK,      0.143567926780793_REALK,      0.000000000000000_REALK, &
      0.108162765597326_REALK,      0.000000000000000_REALK,     -0.224259951796606_REALK, &
      0.099975482384330_REALK,      0.000000000000000_REALK,     -0.138741883997565_REALK, &
      0.000000000000000_REALK,      0.122528778884232_REALK,      0.000000000000000_REALK, &
     -0.135786100726901_REALK,      0.000000000000000_REALK,     -0.564254747633319_REALK, &
     -0.108656280811854_REALK,     -0.089501178442840_REALK,      0.000000000000000_REALK, &
     -0.089030068883862_REALK,      0.000000000000000_REALK,     -0.492186712938593_REALK, &
     -0.112447822240135_REALK,      0.000000000000000_REALK,     -0.360059168290730_REALK, &
      0.000000000000000_REALK,     -0.194071826306678_REALK,      0.000000000000000_REALK, &
     -0.399047586595853_REALK,      0.000000000000000_REALK,     -0.932711251236349_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.086782093899563_REALK, &
      0.000000000000000_REALK,     -0.058620351669009_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.053341866697820_REALK,      0.000000000000000_REALK, &
      0.215115600799396_REALK,      0.000000000000000_REALK,     -0.062177348381934_REALK, &
      0.000000000000000_REALK,      0.188763307314784_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.242479558369712_REALK, &
      0.000000000000000_REALK,      0.166952900318597_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.108624742733301_REALK,      0.000000000000000_REALK, &
      0.676272913433876_REALK,      0.000000000000000_REALK,      0.018884033328324_REALK, &
      0.000000000000000_REALK,      0.518780552822518_REALK,      0.000000000000000_REALK, &
      0.623819787443449_REALK,      0.505865865711873_REALK,      0.000000000000000_REALK, &
      0.523617524207940_REALK,      0.000000000000000_REALK,      0.054410668752589_REALK, &
      0.659668426067674_REALK,      0.000000000000000_REALK,      0.052153805248214_REALK, &
      0.000000000000000_REALK,      1.065817155325300_REALK,      0.000000000000000_REALK, &
      0.070128116324410_REALK,      0.000000000000000_REALK,     -0.429194570811728_REALK, &
      0.206204149563280_REALK,      0.269233848543004_REALK,      0.000000000000000_REALK, &
      0.351486213509889_REALK,      0.000000000000000_REALK,     -0.933905977333513_REALK, &
      0.505852546668983_REALK,      0.000000000000000_REALK,     -1.082942715285310_REALK, &
      0.000000000000000_REALK,      0.861485607431313_REALK,      0.000000000000000_REALK, &
     -1.575168357677254_REALK,      0.000000000000000_REALK,     -2.960197316746176_REALK, &
     -5.121901275891581_REALK,     -1.281657308547249_REALK,      0.000000000000000_REALK, &
     -0.728831671496390_REALK,      0.000000000000000_REALK,     -1.723311687735846_REALK, &
     -0.416188608956288_REALK,      0.000000000000000_REALK,     -0.504311568424559_REALK, &
      0.000000000000000_REALK,     -0.351847980059355_REALK,      0.000000000000000_REALK, &
     -0.360452802782311_REALK,      0.000000000000000_REALK,     -1.420475518571043_REALK, &
     -6.471773847497614_REALK,     -1.319365945673965_REALK,      0.000000000000000_REALK, &
     -0.462691667505395_REALK,      0.000000000000000_REALK,     -1.711152678177438_REALK, &
      0.105445103486465_REALK,      0.000000000000000_REALK,     -0.437642768407570_REALK, &
      0.000000000000000_REALK,      0.805379843915906_REALK,      0.000000000000000_REALK, &
     -0.194841901222341_REALK,      0.000000000000000_REALK,     -1.200959027766604_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.600016944479573_REALK, &
      0.000000000000000_REALK,      0.205275137848277_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.131146371329158_REALK,      0.000000000000000_REALK, &
      0.638371050379009_REALK,      0.000000000000000_REALK,      0.100595271752964_REALK, &
      0.000000000000000_REALK,      0.274498628712772_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.185935843225760_REALK, &
      0.000000000000000_REALK,      0.407342240640236_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.277277133890125_REALK,      0.000000000000000_REALK, &
      0.868041640043253_REALK,      0.000000000000000_REALK,      0.293874836231084_REALK, &
      0.000000000000000_REALK,      0.378507949823446_REALK,      0.000000000000000_REALK, &
      0.342376054380406_REALK,      0.134978888775232_REALK,      0.000000000000000_REALK, &
      0.083776755643095_REALK,      0.000000000000000_REALK,     -0.237961523912374_REALK, &
      0.061166478560983_REALK,      0.000000000000000_REALK,     -0.109714389079242_REALK, &
      0.000000000000000_REALK,      0.056787431669102_REALK,      0.000000000000000_REALK, &
     -0.085588504199539_REALK,      0.000000000000000_REALK,     -0.487241872540828_REALK, &
     -0.323710220106527_REALK,     -0.103373385355737_REALK,      0.000000000000000_REALK, &
     -0.040484496307311_REALK,      0.000000000000000_REALK,     -0.628874314457348_REALK, &
      0.001117864931900_REALK,      0.000000000000000_REALK,     -0.251944709195878_REALK, &
      0.000000000000000_REALK,      0.057481567500402_REALK,      0.000000000000000_REALK, &
     -0.125262604572554_REALK,      0.000000000000000_REALK,     -0.822670464292390_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.089158978744195_REALK, &
      0.000000000000000_REALK,     -0.046192739692097_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.034953356354225_REALK,      0.000000000000000_REALK, &
      0.185889325036463_REALK,      0.000000000000000_REALK,     -0.034005686006769_REALK, &
      0.000000000000000_REALK,      0.121047895732632_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.436968946224233_REALK, &
      0.000000000000000_REALK,      0.234237560459332_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.192643296809402_REALK,      0.000000000000000_REALK, &
      0.738327115200208_REALK,      0.000000000000000_REALK,      0.226342656461138_REALK, &
      0.000000000000000_REALK,      0.502447829021000_REALK,      0.000000000000000_REALK, &
      0.544823529996921_REALK,      0.316063669561148_REALK,      0.000000000000000_REALK, &
      0.240850271911491_REALK,      0.000000000000000_REALK,      0.040397982925290_REALK, &
      0.217059382121289_REALK,      0.000000000000000_REALK,      0.027407712217590_REALK, &
      0.000000000000000_REALK,      0.236149308314905_REALK,      0.000000000000000_REALK, &
      0.026250616442161_REALK,      0.000000000000000_REALK,     -0.259324889658850_REALK, &
      0.295651239233514_REALK,      0.134152537432054_REALK,      0.000000000000000_REALK, &
      0.063958115314345_REALK,      0.000000000000000_REALK,     -0.574272280940146_REALK, &
      0.008251030758510_REALK,      0.000000000000000_REALK,     -0.326908414835215_REALK, &
      0.000000000000000_REALK,     -0.074117106351817_REALK,      0.000000000000000_REALK, &
     -0.197860480641958_REALK,      0.000000000000000_REALK,     -1.256550878037974_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.425942190341048_REALK, &
      0.000000000000000_REALK,     -0.341904935216873_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.355450374772832_REALK,      0.000000000000000_REALK, &
     -0.024030113912773_REALK,      0.000000000000000_REALK,     -0.471343401850428_REALK, &
      0.000000000000000_REALK,     -0.024244023554590_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.348308102159454_REALK, &
      0.000000000000000_REALK,      0.295956497760673_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.319444875203073_REALK,      0.000000000000000_REALK, &
      2.143607824666655_REALK,      0.000000000000000_REALK,      0.427670936806871_REALK, &
      0.000000000000000_REALK,      2.312308789400735_REALK,      0.000000000000000_REALK, &
    -11.214877253593979_REALK,      2.863674127197349_REALK,      0.000000000000000_REALK, &
    -10.796076775874564_REALK,      0.000000000000000_REALK,    -14.603747606431179_REALK, &
      4.545523128457754_REALK,      0.000000000000000_REALK,      3.233098007599279_REALK, &
      0.000000000000000_REALK,    -75.770274531155309_REALK,      0.000000000000000_REALK, &
    -42.759674812797797_REALK,      0.000000000000000_REALK,    -96.400990789327096_REALK, &
     -9.701802537613167_REALK,      5.143583067063250_REALK,      0.000000000000000_REALK, &
    -15.526903577394149_REALK,      0.000000000000000_REALK,    -15.406194104601569_REALK, &
     10.433717003805999_REALK,      0.000000000000000_REALK,      6.230938091063832_REALK, &
      0.000000000000000_REALK,   -149.878743785652688_REALK,      0.000000000000000_REALK, &
    -70.675056643610091_REALK,      0.000000000000000_REALK,   -116.876022702343207_REALK, &
     -5.624788948556963_REALK,      0.070262902707408_REALK,      0.000000000000000_REALK, &
     -3.243220583375279_REALK,      0.000000000000000_REALK,     -7.619850043854592_REALK, &
     -0.101708055714981_REALK,      0.000000000000000_REALK,     -0.113658646064328_REALK, &
      0.000000000000000_REALK,    -13.085892629253031_REALK,      0.000000000000000_REALK, &
    -13.011212183721611_REALK,      0.000000000000000_REALK,    -50.949091692447695_REALK, &
     -3.951033887345697_REALK,      0.104971785511677_REALK,      0.000000000000000_REALK, &
     -1.366726113180302_REALK,      0.000000000000000_REALK,     -5.441362977041337_REALK, &
     -0.000426999081614_REALK,      0.000000000000000_REALK,      0.008763525060941_REALK, &
      0.000000000000000_REALK,     10.085877363693683_REALK,      0.000000000000000_REALK, &
     -6.384772339370107_REALK,      0.000000000000000_REALK,    -42.366283789714522_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.005554610320103_REALK, &
      0.000000000000000_REALK,     -0.150062692329741_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.006642501075662_REALK,      0.000000000000000_REALK, &
      0.134113121086378_REALK,      0.000000000000000_REALK,     -0.846406534548965_REALK, &
      0.000000000000000_REALK,      8.985769782081583_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.150040119135052_REALK, &
      0.000000000000000_REALK,      2.303482969667574_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.012624178877850_REALK,      0.000000000000000_REALK, &
     -0.034915209076269_REALK,      0.000000000000000_REALK,     18.019160207526017_REALK, &
      0.000000000000000_REALK,     29.995073319595765_REALK,      0.000000000000000_REALK, &
     -4.089237673940868_REALK,     -0.326028461378226_REALK,      0.000000000000000_REALK, &
     -1.653300011851235_REALK,      0.000000000000000_REALK,     -5.316231028180456_REALK, &
     -0.377394803132372_REALK,      0.000000000000000_REALK,     -0.495817249116947_REALK, &
      0.000000000000000_REALK,     -5.415904017621656_REALK,      0.000000000000000_REALK, &
     -6.187513219430855_REALK,      0.000000000000000_REALK,    -33.160194286801641_REALK, &
     -1.740683469378153_REALK,     -0.180747061843908_REALK,      0.000000000000000_REALK, &
     -1.226249768106300_REALK,      0.000000000000000_REALK,     -3.580333526190699_REALK, &
     -0.555572145884117_REALK,      0.000000000000000_REALK,     -0.459850016931677_REALK, &
      0.000000000000000_REALK,     -9.727289815107197_REALK,      0.000000000000000_REALK, &
     -5.473025783924614_REALK,      0.000000000000000_REALK,    -26.633043030258044_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.038662113907306_REALK, &
      0.000000000000000_REALK,     -0.054368672426543_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.025025443114112_REALK,      0.000000000000000_REALK, &
      0.877592685922011_REALK,      0.000000000000000_REALK,     -0.182081605224547_REALK, &
      0.000000000000000_REALK,      3.037067759231941_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.220351154023451_REALK, &
      0.000000000000000_REALK,      0.406641607897998_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.140810190094154_REALK,      0.000000000000000_REALK, &
      1.562648458805953_REALK,      0.000000000000000_REALK,     -0.088431802607370_REALK, &
      0.000000000000000_REALK,      5.058961425420134_REALK,      0.000000000000000_REALK, &
      2.044674154042382_REALK,      0.470891951419036_REALK,      0.000000000000000_REALK, &
      1.965111719584582_REALK,      0.000000000000000_REALK,      1.022964833302368_REALK, &
      1.006821280697588_REALK,      0.000000000000000_REALK,      0.275589386984376_REALK, &
      0.000000000000000_REALK,     13.032153410265831_REALK,      0.000000000000000_REALK, &
      2.830263176175296_REALK,      0.000000000000000_REALK,     -3.818981202386522_REALK, &
      0.516035937819704_REALK,      0.170345096232518_REALK,      0.000000000000000_REALK, &
      1.069727397236713_REALK,      0.000000000000000_REALK,     -1.723983341863894_REALK, &
      0.725705163704300_REALK,      0.000000000000000_REALK,     -0.703921181195180_REALK, &
      0.000000000000000_REALK,     10.125012169617721_REALK,      0.000000000000000_REALK, &
     -7.754809108337473_REALK,      0.000000000000000_REALK,    -33.543928763259167_REALK, &
     -4.059207584745018_REALK,     -0.188010726150528_REALK,      0.000000000000000_REALK, &
     -1.190399499090038_REALK,      0.000000000000000_REALK,     -4.669700502542993_REALK, &
     -0.117989376589254_REALK,      0.000000000000000_REALK,     -0.243586709957889_REALK, &
      0.000000000000000_REALK,     -2.738168354157962_REALK,      0.000000000000000_REALK, &
     -3.825491759516352_REALK,      0.000000000000000_REALK,    -25.011072341040482_REALK, &
     -3.076245287282374_REALK,     -0.087692196315463_REALK,      0.000000000000000_REALK, &
     -0.557861667089916_REALK,      0.000000000000000_REALK,     -3.307451021819763_REALK, &
      0.275931914297214_REALK,      0.000000000000000_REALK,     -0.123443762147829_REALK, &
      0.000000000000000_REALK,      1.811664948036477_REALK,      0.000000000000000_REALK, &
     -1.975089064640923_REALK,      0.000000000000000_REALK,    -19.516517954198456_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.061366400970369_REALK, &
      0.000000000000000_REALK,     -0.024347790367121_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.024725748030136_REALK,      0.000000000000000_REALK, &
      1.186705344328274_REALK,      0.000000000000000_REALK,     -0.059556391094535_REALK, &
      0.000000000000000_REALK,      1.167872335907861_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.577766025956915_REALK, &
      0.000000000000000_REALK,      0.247712482898155_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.278558012644702_REALK,      0.000000000000000_REALK, &
      2.267050531383598_REALK,      0.000000000000000_REALK,      1.059576490117097_REALK, &
      0.000000000000000_REALK,      2.444607020541924_REALK,      0.000000000000000_REALK, &
      1.552212696511088_REALK,      0.388136868965908_REALK,      0.000000000000000_REALK, &
      0.760027069331542_REALK,      0.000000000000000_REALK,      0.687185681502583_REALK, &
      0.449996084521042_REALK,      0.000000000000000_REALK,      0.193522276946998_REALK, &
      0.000000000000000_REALK,      2.456457129189104_REALK,      0.000000000000000_REALK, &
      0.939936901403535_REALK,      0.000000000000000_REALK,     -2.202880724196995_REALK, &
      0.512928125367915_REALK,      0.119833247132618_REALK,      0.000000000000000_REALK, &
      0.138516901627628_REALK,      0.000000000000000_REALK,     -0.895732662095973_REALK, &
     -0.008219277383742_REALK,      0.000000000000000_REALK,     -0.273990160160446_REALK, &
      0.000000000000000_REALK,     -0.774695796721576_REALK,      0.000000000000000_REALK, &
     -0.796548767085679_REALK,      0.000000000000000_REALK,    -13.825182753999348_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.986781060951010_REALK, &
      0.000000000000000_REALK,     -1.130924740738411_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.945134060037403_REALK,      0.000000000000000_REALK, &
     -1.157102400885800_REALK,      0.000000000000000_REALK,     -5.109674582580927_REALK, &
      0.000000000000000_REALK,     -3.289336215990088_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.387560716766843_REALK, &
      0.000000000000000_REALK,     -0.528243168120272_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.549841407744016_REALK,      0.000000000000000_REALK, &
      1.918125778918293_REALK,      0.000000000000000_REALK,     -3.131696521534527_REALK, &
      0.000000000000000_REALK,      6.575415228774416_REALK,      0.000000000000000_REALK, &
     -5.185351535341272_REALK,      0.228031990956170_REALK,      0.000000000000000_REALK, &
     -1.236513261524956_REALK,      0.000000000000000_REALK,     -5.021174081405889_REALK, &
      0.261814117857074_REALK,      0.000000000000000_REALK,      0.257377614627396_REALK, &
      0.000000000000000_REALK,     -2.385867613233646_REALK,      0.000000000000000_REALK, &
     -3.184534215350835_REALK,      0.000000000000000_REALK,    -21.552674444900706_REALK, &
     -2.275866249193375_REALK,      0.177097213862368_REALK,      0.000000000000000_REALK, &
     -0.911383765954853_REALK,      0.000000000000000_REALK,     -3.810998942269394_REALK, &
     -0.007401487862641_REALK,      0.000000000000000_REALK,      0.269717641350827_REALK, &
      0.000000000000000_REALK,     -3.550483755627924_REALK,      0.000000000000000_REALK, &
     -2.588395419883118_REALK,      0.000000000000000_REALK,    -18.039184984118883_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.086231923362356_REALK, &
      0.000000000000000_REALK,     -0.007932647539192_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.024811143090858_REALK,      0.000000000000000_REALK, &
      1.452728134135417_REALK,      0.000000000000000_REALK,     -0.009895884461570_REALK, &
      0.000000000000000_REALK,      0.304934512889176_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.656004447325977_REALK, &
      0.000000000000000_REALK,      0.041672315618859_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.168514589444544_REALK,      0.000000000000000_REALK, &
      2.784873073698808_REALK,      0.000000000000000_REALK,     -0.264551210321485_REALK, &
      0.000000000000000_REALK,      0.329896696038541_REALK,      0.000000000000000_REALK, &
      1.653668572562470_REALK,      0.278066046026160_REALK,      0.000000000000000_REALK, &
      0.497993151130593_REALK,      0.000000000000000_REALK,      0.616241087475096_REALK, &
      0.238889597029505_REALK,      0.000000000000000_REALK,      0.120780843457220_REALK, &
      0.000000000000000_REALK,      1.122600755390284_REALK,      0.000000000000000_REALK, &
      0.493566431946653_REALK,      0.000000000000000_REALK,     -1.583142973746331_REALK, &
      0.299421920967747_REALK,      0.089721856765450_REALK,      0.000000000000000_REALK, &
      0.171724056209942_REALK,      0.000000000000000_REALK,     -0.814376292221542_REALK, &
      0.165089759171198_REALK,      0.000000000000000_REALK,     -0.221944973577736_REALK, &
      0.000000000000000_REALK,      0.866811837807269_REALK,      0.000000000000000_REALK, &
     -0.792154528763367_REALK,      0.000000000000000_REALK,    -10.082930240968921_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.060440830605951_REALK, &
      0.000000000000000_REALK,     -0.526658172505197_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.509438187550549_REALK,      0.000000000000000_REALK, &
     -1.083281833009188_REALK,      0.000000000000000_REALK,     -1.213748881466400_REALK, &
      0.000000000000000_REALK,     -1.227597499192483_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.247497001974580_REALK, &
      0.000000000000000_REALK,     -0.128852135540229_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.094676318460944_REALK,      0.000000000000000_REALK, &
      1.325246594650782_REALK,      0.000000000000000_REALK,      0.017830727503946_REALK, &
      0.000000000000000_REALK,      1.286619368988273_REALK,      0.000000000000000_REALK, &
      1.760637539236880_REALK,      0.855171945320963_REALK,      0.000000000000000_REALK, &
      1.260371799448545_REALK,      0.000000000000000_REALK,      2.083992532204078_REALK, &
      1.357042469415252_REALK,      0.000000000000000_REALK,      1.179852084841247_REALK, &
      0.000000000000000_REALK,      5.751886203840554_REALK,      0.000000000000000_REALK, &
      3.967755890988194_REALK,      0.000000000000000_REALK,      7.971321328578470_REALK, &
      1.157294655570301_REALK,      1.102444803317510_REALK,      0.000000000000000_REALK, &
      1.953104727232311_REALK,      0.000000000000000_REALK,      0.670799143954191_REALK, &
      2.811512999077576_REALK,      0.000000000000000_REALK,      0.581180371543404_REALK, &
      0.000000000000000_REALK,     11.763288395476835_REALK,      0.000000000000000_REALK, &
      1.920044634480985_REALK,      0.000000000000000_REALK,    -12.513251533867010_REALK, &
     -8.177401049566456_REALK,      1.115418522243528_REALK,      0.000000000000000_REALK, &
     -1.731367066628036_REALK,      0.000000000000000_REALK,     -6.461193366768232_REALK, &
      0.892247850385952_REALK,      0.000000000000000_REALK,      1.069247093896467_REALK, &
      0.000000000000000_REALK,     -2.810777125934166_REALK,      0.000000000000000_REALK, &
     -3.392868536853146_REALK,      0.000000000000000_REALK,    -21.102765272576239_REALK, &
     -9.687747044249754_REALK,      1.486037805528615_REALK,      0.000000000000000_REALK, &
     -1.500874825111766_REALK,      0.000000000000000_REALK,     -6.581322084244484_REALK, &
      1.320675073385082_REALK,      0.000000000000000_REALK,      1.392144894732011_REALK, &
      0.000000000000000_REALK,     -0.727135710522549_REALK,      0.000000000000000_REALK, &
     -2.742418833488069_REALK,      0.000000000000000_REALK,    -20.042468267064386_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.129292744382200_REALK, &
      0.000000000000000_REALK,      0.007614100806358_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.030521641059320_REALK,      0.000000000000000_REALK, &
      1.849931564121315_REALK,      0.000000000000000_REALK,      0.015178148316851_REALK, &
      0.000000000000000_REALK,     -0.222709008492323_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.616918765936980_REALK, &
      0.000000000000000_REALK,     -0.102160870957520_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.362247371221397_REALK,      0.000000000000000_REALK, &
      4.222248406269775_REALK,      0.000000000000000_REALK,      0.005122518961244_REALK, &
      0.000000000000000_REALK,     -0.520325241666021_REALK,      0.000000000000000_REALK, &
      2.253734938232888_REALK,      0.126327062017427_REALK,      0.000000000000000_REALK, &
      0.453945783277306_REALK,      0.000000000000000_REALK,      0.685291559001897_REALK, &
      0.058657822819918_REALK,      0.000000000000000_REALK,      0.046602769514299_REALK, &
      0.000000000000000_REALK,      0.636729164361086_REALK,      0.000000000000000_REALK, &
      0.342339467383195_REALK,      0.000000000000000_REALK,     -1.339601447818596_REALK, &
      1.017246689071613_REALK,      0.032287469221103_REALK,      0.000000000000000_REALK, &
      0.116560053601988_REALK,      0.000000000000000_REALK,     -1.122447602995358_REALK, &
     -0.067611624504997_REALK,      0.000000000000000_REALK,     -0.049129011163915_REALK, &
      0.000000000000000_REALK,     -0.195357570394257_REALK,      0.000000000000000_REALK, &
     -0.345930205775700_REALK,      0.000000000000000_REALK,     -8.941032894242120_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.326028385019856_REALK, &
      0.000000000000000_REALK,     -0.298592711651416_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.395312794092128_REALK,      0.000000000000000_REALK, &
     -1.150464106572898_REALK,      0.000000000000000_REALK,     -0.445380672748622_REALK, &
      0.000000000000000_REALK,     -0.529586748216600_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.481340788789079_REALK, &
      0.000000000000000_REALK,     -0.117111277225395_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.154441033492533_REALK,      0.000000000000000_REALK, &
      1.585390955445009_REALK,      0.000000000000000_REALK,     -0.258530796520367_REALK, &
      0.000000000000000_REALK,      0.752345204747052_REALK,      0.000000000000000_REALK, &
      1.835069588516829_REALK,      0.555313712557015_REALK,      0.000000000000000_REALK, &
      0.617134807175802_REALK,      0.000000000000000_REALK,      1.772348433416345_REALK, &
      0.476355844885271_REALK,      0.000000000000000_REALK,      0.650695422015280_REALK, &
      0.000000000000000_REALK,      1.216307865601539_REALK,      0.000000000000000_REALK, &
      1.478281183063092_REALK,      0.000000000000000_REALK,      5.158387966988545_REALK, &
      2.211373237553003_REALK,      0.575242013471420_REALK,      0.000000000000000_REALK, &
      0.377334225662192_REALK,      0.000000000000000_REALK,      0.520006609221893_REALK, &
     -0.026257494706260_REALK,      0.000000000000000_REALK,      0.186535561108917_REALK, &
      0.000000000000000_REALK,     -1.089140169061493_REALK,      0.000000000000000_REALK, &
      0.238655786131593_REALK,      0.000000000000000_REALK,     -6.240889798094890_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.010111525487774_REALK, &
      0.000000000000000_REALK,     -1.307466393819951_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.424498598096623_REALK,      0.000000000000000_REALK, &
     -3.453886930493415_REALK,      0.000000000000000_REALK,     -3.602246407769902_REALK, &
      0.000000000000000_REALK,     -4.592573871940729_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.500975791831301_REALK, &
      0.000000000000000_REALK,     -2.707904891066064_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -3.305469691313450_REALK,      0.000000000000000_REALK, &
     -1.289560548772172_REALK,      0.000000000000000_REALK,     -8.285301811575509_REALK, &
      0.000000000000000_REALK,     -1.945453102987524_REALK,      0.000000000000000_REALK/
    ! results of test 7, ket-major order, 03ODGXYZ
  data REF_CONTR_INTS(71821:73080)                                                         &
    /-1.712237275454425_REALK,     -0.998573388832594_REALK,      0.000000000000000_REALK, &
     -0.685756817024210_REALK,      0.000000000000000_REALK,     -1.016658960907709_REALK, &
     -0.261153039756430_REALK,      0.000000000000000_REALK,     -0.728404360779518_REALK, &
      0.000000000000000_REALK,      1.063562184565472_REALK,      0.000000000000000_REALK, &
     -0.747571026678603_REALK,      0.000000000000000_REALK,     -1.847167888868262_REALK, &
     -0.588510779997131_REALK,      0.494596568289507_REALK,      0.000000000000000_REALK, &
      1.793174317698274_REALK,      0.000000000000000_REALK,     -0.286992289691340_REALK, &
      4.786324643882340_REALK,      0.000000000000000_REALK,      0.342038680006728_REALK, &
      0.000000000000000_REALK,     15.096706648978063_REALK,      0.000000000000000_REALK, &
      1.858701794342414_REALK,      0.000000000000000_REALK,     -0.495799616864586_REALK, &
     -1.750560536214829_REALK,     -0.933045298642841_REALK,      0.000000000000000_REALK, &
     -0.756363762796392_REALK,      0.000000000000000_REALK,     -0.914147956192702_REALK, &
     -0.772504696004752_REALK,      0.000000000000000_REALK,     -0.591866884535431_REALK, &
      0.000000000000000_REALK,     -1.199245874280124_REALK,      0.000000000000000_REALK, &
     -0.679864009071785_REALK,      0.000000000000000_REALK,     -1.369482791552092_REALK, &
     -0.796486111683688_REALK,     -0.773956939436354_REALK,      0.000000000000000_REALK, &
     -1.046300931474342_REALK,      0.000000000000000_REALK,     -0.646544196971206_REALK, &
     -1.940880596351310_REALK,      0.000000000000000_REALK,     -0.571039082710704_REALK, &
      0.000000000000000_REALK,     -5.102169699542005_REALK,      0.000000000000000_REALK, &
     -0.947687978012108_REALK,      0.000000000000000_REALK,     -0.976013280519142_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.287652298731191_REALK, &
      0.000000000000000_REALK,      0.173045651106579_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.123079012243002_REALK,      0.000000000000000_REALK, &
      0.493368954965800_REALK,      0.000000000000000_REALK,      0.055766652334682_REALK, &
      0.000000000000000_REALK,      0.420566506708138_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.123497283279391_REALK, &
      0.000000000000000_REALK,     -0.138827043911805_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.569322987204241_REALK,      0.000000000000000_REALK, &
      0.201062609937798_REALK,      0.000000000000000_REALK,     -1.759583035515458_REALK, &
      0.000000000000000_REALK,     -0.277464683609706_REALK,      0.000000000000000_REALK, &
     -1.937198756663547_REALK,     -0.793348474277677_REALK,      0.000000000000000_REALK, &
     -0.535300217216707_REALK,      0.000000000000000_REALK,     -0.882234622507707_REALK, &
     -0.410210140861839_REALK,      0.000000000000000_REALK,     -0.433772437579258_REALK, &
      0.000000000000000_REALK,     -0.399179545388755_REALK,      0.000000000000000_REALK, &
     -0.396126118261318_REALK,      0.000000000000000_REALK,     -1.088100238488033_REALK, &
     -1.614171172179189_REALK,     -0.416282628845011_REALK,      0.000000000000000_REALK, &
      0.027110684732757_REALK,      0.000000000000000_REALK,     -0.592903260761150_REALK, &
      0.624455390247888_REALK,      0.000000000000000_REALK,     -0.205204325139288_REALK, &
      0.000000000000000_REALK,      2.170674958745470_REALK,      0.000000000000000_REALK, &
      0.018248571420391_REALK,      0.000000000000000_REALK,     -0.665152110446294_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.294017982523426_REALK, &
      0.000000000000000_REALK,      0.159405125155758_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.133010546069891_REALK,      0.000000000000000_REALK, &
      0.434664840436598_REALK,      0.000000000000000_REALK,      0.153962667129444_REALK, &
      0.000000000000000_REALK,      0.318948817158488_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.461254607305611_REALK, &
      0.000000000000000_REALK,      0.306146721980395_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.367957223260385_REALK,      0.000000000000000_REALK, &
      0.501722775694266_REALK,      0.000000000000000_REALK,      0.700407816094411_REALK, &
      0.000000000000000_REALK,      0.454718764133228_REALK,      0.000000000000000_REALK, &
      0.153277941578833_REALK,      0.079056988052248_REALK,      0.000000000000000_REALK, &
      0.047085199599671_REALK,      0.000000000000000_REALK,     -0.144198354218573_REALK, &
      0.015497468940084_REALK,      0.000000000000000_REALK,     -0.089291260746798_REALK, &
      0.000000000000000_REALK,     -0.049571367591186_REALK,      0.000000000000000_REALK, &
     -0.071976579307172_REALK,      0.000000000000000_REALK,     -0.441787124145151_REALK, &
     -0.045756518817960_REALK,      0.034074821057085_REALK,      0.000000000000000_REALK, &
      0.105012139929519_REALK,      0.000000000000000_REALK,     -0.123489276103541_REALK, &
      0.235049177707234_REALK,      0.000000000000000_REALK,      0.123416669598166_REALK, &
      0.000000000000000_REALK,      0.574116979748690_REALK,      0.000000000000000_REALK, &
      0.519361689265226_REALK,      0.000000000000000_REALK,     -0.258219477546777_REALK, &
     -2.488557578070401_REALK,     -0.781246025983733_REALK,      0.000000000000000_REALK, &
     -0.480993163038204_REALK,      0.000000000000000_REALK,     -0.984921041400222_REALK, &
     -0.330943101451917_REALK,      0.000000000000000_REALK,     -0.365483059089833_REALK, &
      0.000000000000000_REALK,     -0.340284019536476_REALK,      0.000000000000000_REALK, &
     -0.292311370225354_REALK,      0.000000000000000_REALK,     -0.997601217991442_REALK, &
     -1.166954053595421_REALK,     -0.604732848080785_REALK,      0.000000000000000_REALK, &
     -0.575785601665732_REALK,      0.000000000000000_REALK,     -0.719427094003986_REALK, &
     -0.820416049424159_REALK,      0.000000000000000_REALK,     -0.331105704073296_REALK, &
      0.000000000000000_REALK,     -1.780754816159147_REALK,      0.000000000000000_REALK, &
     -0.351242259716359_REALK,      0.000000000000000_REALK,     -0.731444706351631_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.326388614011959_REALK, &
      0.000000000000000_REALK,      0.134622678655291_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.092646230213659_REALK,      0.000000000000000_REALK, &
      0.412854561030432_REALK,      0.000000000000000_REALK,      0.077369443415381_REALK, &
      0.000000000000000_REALK,      0.221211494489050_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.330691517979149_REALK, &
      0.000000000000000_REALK,      0.112200192602339_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.008279093869156_REALK,      0.000000000000000_REALK, &
      0.399531509515411_REALK,      0.000000000000000_REALK,     -0.208283311020108_REALK, &
      0.000000000000000_REALK,      0.151030424030137_REALK,      0.000000000000000_REALK, &
      0.179059176335440_REALK,      0.083767462110370_REALK,      0.000000000000000_REALK, &
      0.058636025578956_REALK,      0.000000000000000_REALK,     -0.146393243469447_REALK, &
      0.051148379009114_REALK,      0.000000000000000_REALK,     -0.080951614831302_REALK, &
      0.000000000000000_REALK,      0.062857559223957_REALK,      0.000000000000000_REALK, &
     -0.073610888474602_REALK,      0.000000000000000_REALK,     -0.368336307875394_REALK, &
     -0.069379314905779_REALK,     -0.058747019667704_REALK,      0.000000000000000_REALK, &
     -0.069218380440634_REALK,      0.000000000000000_REALK,     -0.314271542282363_REALK, &
     -0.109325614589875_REALK,      0.000000000000000_REALK,     -0.236336586949204_REALK, &
      0.000000000000000_REALK,     -0.227330089760925_REALK,      0.000000000000000_REALK, &
     -0.310248301604034_REALK,      0.000000000000000_REALK,     -0.595555702184776_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.048417823934297_REALK, &
      0.000000000000000_REALK,     -0.025151233554349_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.015278458454596_REALK,      0.000000000000000_REALK, &
      0.120018183671391_REALK,      0.000000000000000_REALK,     -0.005480102021671_REALK, &
      0.000000000000000_REALK,      0.080989449800168_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.052372562061709_REALK, &
      0.000000000000000_REALK,     -0.051311684632650_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.179167487781309_REALK,      0.000000000000000_REALK, &
      0.146066519452604_REALK,      0.000000000000000_REALK,     -0.438015184176259_REALK, &
      0.000000000000000_REALK,     -0.159443196669138_REALK,      0.000000000000000_REALK, &
     -3.785662668244539_REALK,     -0.854960002007707_REALK,      0.000000000000000_REALK, &
     -0.479094955069294_REALK,      0.000000000000000_REALK,     -1.273721684703002_REALK, &
     -0.249821695544359_REALK,      0.000000000000000_REALK,     -0.336413030751173_REALK, &
      0.000000000000000_REALK,     -0.198687156673778_REALK,      0.000000000000000_REALK, &
     -0.236942391648588_REALK,      0.000000000000000_REALK,     -1.049891603167154_REALK, &
     -4.619743483143155_REALK,     -0.752908122516006_REALK,      0.000000000000000_REALK, &
     -0.117538465985884_REALK,      0.000000000000000_REALK,     -1.221471364721706_REALK, &
      0.427355006605341_REALK,      0.000000000000000_REALK,     -0.249744808235241_REALK, &
      0.000000000000000_REALK,      1.302079882662757_REALK,      0.000000000000000_REALK, &
     -0.049496067873710_REALK,      0.000000000000000_REALK,     -0.857280055327015_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.431440306773118_REALK, &
      0.000000000000000_REALK,      0.134072381709452_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.082905857556347_REALK,      0.000000000000000_REALK, &
      0.459018706629166_REALK,      0.000000000000000_REALK,      0.060040814593844_REALK, &
      0.000000000000000_REALK,      0.179284667949908_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.839986140051275_REALK, &
      0.000000000000000_REALK,      0.283278729848962_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.222997820016132_REALK,      0.000000000000000_REALK, &
      0.614824950935316_REALK,      0.000000000000000_REALK,      0.295578017427855_REALK, &
      0.000000000000000_REALK,      0.263226448342783_REALK,      0.000000000000000_REALK, &
      0.236469997903185_REALK,      0.083764442547480_REALK,      0.000000000000000_REALK, &
      0.048274968613814_REALK,      0.000000000000000_REALK,     -0.164353670008933_REALK, &
      0.031169594634409_REALK,      0.000000000000000_REALK,     -0.068085940876010_REALK, &
      0.000000000000000_REALK,      0.024059022107953_REALK,      0.000000000000000_REALK, &
     -0.049318958728101_REALK,      0.000000000000000_REALK,     -0.336524949989808_REALK, &
     -0.201569604015645_REALK,     -0.045070870026117_REALK,      0.000000000000000_REALK, &
      0.002436952808291_REALK,      0.000000000000000_REALK,     -0.391590807664529_REALK, &
      0.045495174631418_REALK,      0.000000000000000_REALK,     -0.109848073591266_REALK, &
      0.000000000000000_REALK,      0.122068532600498_REALK,      0.000000000000000_REALK, &
      0.007540147064441_REALK,      0.000000000000000_REALK,     -0.512264826449449_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.058201528976623_REALK, &
      0.000000000000000_REALK,     -0.026952040464024_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.018948534515905_REALK,      0.000000000000000_REALK, &
      0.121345523355481_REALK,      0.000000000000000_REALK,     -0.017397622645647_REALK, &
      0.000000000000000_REALK,      0.070627717810575_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.279013839767190_REALK, &
      0.000000000000000_REALK,      0.153749468002900_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.149774757843730_REALK,      0.000000000000000_REALK, &
      0.471437353148961_REALK,      0.000000000000000_REALK,      0.220058063665076_REALK, &
      0.000000000000000_REALK,      0.329798031791759_REALK,      0.000000000000000_REALK, &
      0.303970192067306_REALK,      0.135608043023384_REALK,      0.000000000000000_REALK, &
      0.068985603635206_REALK,      0.000000000000000_REALK,      0.022539009335741_REALK, &
      0.019130882704722_REALK,      0.000000000000000_REALK,      0.011759359190938_REALK, &
      0.000000000000000_REALK,     -0.048538915092127_REALK,      0.000000000000000_REALK, &
      0.007518839844716_REALK,      0.000000000000000_REALK,     -0.144683612541256_REALK, &
      0.063856982334856_REALK,     -0.041230746397621_REALK,      0.000000000000000_REALK, &
     -0.105493597091719_REALK,      0.000000000000000_REALK,     -0.124035654288018_REALK, &
     -0.191382672043491_REALK,      0.000000000000000_REALK,      0.100472776775808_REALK, &
      0.000000000000000_REALK,     -0.360818900838339_REALK,      0.000000000000000_REALK, &
      0.326354423088122_REALK,      0.000000000000000_REALK,     -0.271399326550236_REALK, &
     -6.775953626185209_REALK,     -1.049615407265602_REALK,      0.000000000000000_REALK, &
     -0.589109367067054_REALK,      0.000000000000000_REALK,     -1.939830965008158_REALK, &
     -0.235252136861008_REALK,      0.000000000000000_REALK,     -0.344322986170417_REALK, &
      0.000000000000000_REALK,     -0.193248223921548_REALK,      0.000000000000000_REALK, &
     -0.234896006655484_REALK,      0.000000000000000_REALK,     -1.289117020652201_REALK, &
     -4.015685779149433_REALK,     -1.016078437906020_REALK,      0.000000000000000_REALK, &
     -0.831334562004249_REALK,      0.000000000000000_REALK,     -1.882364551446142_REALK, &
     -0.891518130762937_REALK,      0.000000000000000_REALK,     -0.407330961514097_REALK, &
      0.000000000000000_REALK,     -1.689391202865269_REALK,      0.000000000000000_REALK, &
     -0.340360418115211_REALK,      0.000000000000000_REALK,     -1.284445547070826_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.675679382826410_REALK, &
      0.000000000000000_REALK,      0.150046650341267_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.083372637672195_REALK,      0.000000000000000_REALK, &
      0.599320513718088_REALK,      0.000000000000000_REALK,      0.044428674037930_REALK, &
      0.000000000000000_REALK,      0.161766528880304_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.925048682398272_REALK, &
      0.000000000000000_REALK,      0.198763920809957_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.035684655147128_REALK,      0.000000000000000_REALK, &
      0.818294539652617_REALK,      0.000000000000000_REALK,     -0.139249323739419_REALK, &
      0.000000000000000_REALK,      0.179566635121083_REALK,      0.000000000000000_REALK, &
      0.375690259485210_REALK,      0.101024712611404_REALK,      0.000000000000000_REALK, &
      0.052524374039793_REALK,      0.000000000000000_REALK,     -0.222174456436685_REALK, &
      0.030008861837839_REALK,      0.000000000000000_REALK,     -0.068459570675875_REALK, &
      0.000000000000000_REALK,      0.024380153532859_REALK,      0.000000000000000_REALK, &
     -0.043262470815031_REALK,      0.000000000000000_REALK,     -0.366767228629013_REALK, &
     -0.162757379304139_REALK,     -0.073809501767556_REALK,      0.000000000000000_REALK, &
     -0.061060268864410_REALK,      0.000000000000000_REALK,     -0.560565955496237_REALK, &
     -0.073316199768591_REALK,      0.000000000000000_REALK,     -0.217407477925733_REALK, &
      0.000000000000000_REALK,     -0.126741630394301_REALK,      0.000000000000000_REALK, &
     -0.183680875889184_REALK,      0.000000000000000_REALK,     -0.712953653762626_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.079129713160812_REALK, &
      0.000000000000000_REALK,     -0.027561636376822_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.015750296464515_REALK,      0.000000000000000_REALK, &
      0.137542769080819_REALK,      0.000000000000000_REALK,     -0.010392718010582_REALK, &
      0.000000000000000_REALK,      0.058230035805162_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.225501349707632_REALK, &
      0.000000000000000_REALK,      0.066476613896016_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.004133576509416_REALK,      0.000000000000000_REALK, &
      0.460482457734815_REALK,      0.000000000000000_REALK,     -0.082822247299672_REALK, &
      0.000000000000000_REALK,      0.138635948976143_REALK,      0.000000000000000_REALK, &
      0.439165582167530_REALK,      0.175980534680269_REALK,      0.000000000000000_REALK, &
      0.104024582228559_REALK,      0.000000000000000_REALK,      0.027707220090529_REALK, &
      0.075349007923198_REALK,      0.000000000000000_REALK,      0.012722476203887_REALK, &
      0.000000000000000_REALK,      0.073164745763307_REALK,      0.000000000000000_REALK, &
      0.009140856287099_REALK,      0.000000000000000_REALK,     -0.143395661007990_REALK, &
      0.108142622797567_REALK,      0.080133574076912_REALK,      0.000000000000000_REALK, &
      0.082035023201699_REALK,      0.000000000000000_REALK,     -0.372403396432400_REALK, &
      0.109186183439411_REALK,      0.000000000000000_REALK,     -0.235997510791168_REALK, &
      0.000000000000000_REALK,      0.180822323453817_REALK,      0.000000000000000_REALK, &
     -0.246737545030385_REALK,      0.000000000000000_REALK,     -0.792224718766286_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.213672309348446_REALK, &
      0.000000000000000_REALK,     -0.093731258197483_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.047280156297696_REALK,      0.000000000000000_REALK, &
     -0.010049911107898_REALK,      0.000000000000000_REALK,     -0.013399441602967_REALK, &
      0.000000000000000_REALK,     -0.005358488582645_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.030005642588300_REALK, &
      0.000000000000000_REALK,     -0.025542569431054_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.075158032040187_REALK,      0.000000000000000_REALK, &
      0.223177490200168_REALK,      0.000000000000000_REALK,     -0.146337194723988_REALK, &
      0.000000000000000_REALK,     -0.194023826401859_REALK,      0.000000000000000_REALK, &
     -3.970583217229476_REALK,      0.036591109815818_REALK,      0.000000000000000_REALK, &
     -1.586568312870850_REALK,      0.000000000000000_REALK,     -5.378912698528238_REALK, &
     -0.025129418349099_REALK,      0.000000000000000_REALK,     -0.059190495117683_REALK, &
      0.000000000000000_REALK,     -1.308826904397949_REALK,      0.000000000000000_REALK, &
     -6.365024034611950_REALK,      0.000000000000000_REALK,    -35.965368702236916_REALK, &
     -2.263947518627617_REALK,      0.002891996883374_REALK,      0.000000000000000_REALK, &
      0.974933415208287_REALK,      0.000000000000000_REALK,     -3.117908011186588_REALK, &
     -0.014697250591089_REALK,      0.000000000000000_REALK,      0.000241437135132_REALK, &
      0.000000000000000_REALK,     33.284465423106269_REALK,      0.000000000000000_REALK, &
      4.554480844494051_REALK,      0.000000000000000_REALK,    -24.275935310601096_REALK, &
     -3.071581479184207_REALK,     -0.182201145291054_REALK,      0.000000000000000_REALK, &
     -1.090190794518650_REALK,      0.000000000000000_REALK,     -3.993222714659857_REALK, &
     -0.181663464034588_REALK,      0.000000000000000_REALK,     -0.277087682045544_REALK, &
      0.000000000000000_REALK,     -3.296358730085410_REALK,      0.000000000000000_REALK, &
     -4.080064056391565_REALK,      0.000000000000000_REALK,    -24.907879350365874_REALK, &
     -1.286534844999716_REALK,     -0.114919605267574_REALK,      0.000000000000000_REALK, &
     -0.991624123810580_REALK,      0.000000000000000_REALK,     -2.646215649885234_REALK, &
     -0.563732333495885_REALK,      0.000000000000000_REALK,     -0.292374226662196_REALK, &
      0.000000000000000_REALK,    -11.381506134525896_REALK,      0.000000000000000_REALK, &
     -4.425839285546339_REALK,      0.000000000000000_REALK,    -19.684416201783165_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.027291893442926_REALK, &
      0.000000000000000_REALK,     -0.028313804107756_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.012242329511575_REALK,      0.000000000000000_REALK, &
      0.619499650947657_REALK,      0.000000000000000_REALK,     -0.044987634452333_REALK, &
      0.000000000000000_REALK,      1.581626656657055_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.126261495750736_REALK, &
      0.000000000000000_REALK,      0.011203070015040_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.100444820802594_REALK,      0.000000000000000_REALK, &
      0.895399584430708_REALK,      0.000000000000000_REALK,     -3.043810675724389_REALK, &
      0.000000000000000_REALK,      0.139375553193726_REALK,      0.000000000000000_REALK, &
     -3.146245446707517_REALK,     -0.059227500365796_REALK,      0.000000000000000_REALK, &
     -0.863775301319167_REALK,      0.000000000000000_REALK,     -3.619431536053505_REALK, &
      0.009010864667150_REALK,      0.000000000000000_REALK,     -0.076735153618752_REALK, &
      0.000000000000000_REALK,     -1.819417595670019_REALK,      0.000000000000000_REALK, &
     -2.775845671806937_REALK,      0.000000000000000_REALK,    -19.385796569261679_REALK, &
     -2.337452014242396_REALK,      0.035955524561287_REALK,      0.000000000000000_REALK, &
     -0.285810341930668_REALK,      0.000000000000000_REALK,     -2.513131213860520_REALK, &
      0.486221891719446_REALK,      0.000000000000000_REALK,      0.050614369446022_REALK, &
      0.000000000000000_REALK,      3.523553040747128_REALK,      0.000000000000000_REALK, &
     -1.011901183053609_REALK,      0.000000000000000_REALK,    -14.829417014187364_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.046094630758678_REALK, &
      0.000000000000000_REALK,     -0.013606773075709_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.016304229538993_REALK,      0.000000000000000_REALK, &
      0.891379383525741_REALK,      0.000000000000000_REALK,     -0.028668175136045_REALK, &
      0.000000000000000_REALK,      0.652665955164252_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.427025440137094_REALK, &
      0.000000000000000_REALK,      0.157496450919303_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.225259855213505_REALK,      0.000000000000000_REALK, &
      1.675571438063946_REALK,      0.000000000000000_REALK,      1.075139442674077_REALK, &
      0.000000000000000_REALK,      1.554289574442080_REALK,      0.000000000000000_REALK, &
      1.095719277417262_REALK,      0.202131683273058_REALK,      0.000000000000000_REALK, &
      0.371801681114945_REALK,      0.000000000000000_REALK,      0.485089833422916_REALK, &
      0.111182342282452_REALK,      0.000000000000000_REALK,      0.100781416860369_REALK, &
      0.000000000000000_REALK,      0.245690322492457_REALK,      0.000000000000000_REALK, &
      0.459812727974508_REALK,      0.000000000000000_REALK,     -1.555031008816584_REALK, &
      0.293908478077145_REALK,      0.003301433576106_REALK,      0.000000000000000_REALK, &
     -0.098808938137321_REALK,      0.000000000000000_REALK,     -0.513255971861130_REALK, &
     -0.282906414997021_REALK,      0.000000000000000_REALK,     -0.007548492058096_REALK, &
      0.000000000000000_REALK,     -2.556578325275399_REALK,      0.000000000000000_REALK, &
      0.568206023420248_REALK,      0.000000000000000_REALK,     -7.921847567730405_REALK, &
     -4.109141022509695_REALK,      0.287451841070169_REALK,      0.000000000000000_REALK, &
     -0.970852133560565_REALK,      0.000000000000000_REALK,     -3.979038307903159_REALK, &
      0.294300089530317_REALK,      0.000000000000000_REALK,      0.324444253916610_REALK, &
      0.000000000000000_REALK,     -1.896147400738977_REALK,      0.000000000000000_REALK, &
     -2.500346687391817_REALK,      0.000000000000000_REALK,    -17.079455096289653_REALK, &
     -1.807348294902186_REALK,      0.201009312934743_REALK,      0.000000000000000_REALK, &
     -0.779055863081567_REALK,      0.000000000000000_REALK,     -3.026453089071392_REALK, &
     -0.088805931150339_REALK,      0.000000000000000_REALK,      0.306135577132474_REALK, &
      0.000000000000000_REALK,     -3.895208105604048_REALK,      0.000000000000000_REALK, &
     -2.212574661916138_REALK,      0.000000000000000_REALK,    -14.325573936529741_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.066837379112920_REALK, &
      0.000000000000000_REALK,     -0.002498957876760_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.018003411977039_REALK,      0.000000000000000_REALK, &
      1.125992988016790_REALK,      0.000000000000000_REALK,      0.000755750036339_REALK, &
      0.000000000000000_REALK,      0.096061056427320_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.498457949076190_REALK, &
      0.000000000000000_REALK,     -0.017086468702066_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.086335404045047_REALK,      0.000000000000000_REALK, &
      2.116055960309108_REALK,      0.000000000000000_REALK,     -0.466167859802653_REALK, &
      0.000000000000000_REALK,     -0.135264131307995_REALK,      0.000000000000000_REALK, &
      1.242133171314737_REALK,      0.155397328927508_REALK,      0.000000000000000_REALK, &
      0.328378119642062_REALK,      0.000000000000000_REALK,      0.462882048422655_REALK, &
      0.114992340535714_REALK,      0.000000000000000_REALK,      0.067498426100890_REALK, &
      0.000000000000000_REALK,      0.683264472263723_REALK,      0.000000000000000_REALK, &
      0.325459128249298_REALK,      0.000000000000000_REALK,     -1.189158719740915_REALK, &
      0.221302000885531_REALK,      0.057045465957637_REALK,      0.000000000000000_REALK, &
      0.138867073581066_REALK,      0.000000000000000_REALK,     -0.601903502455255_REALK, &
      0.167514580893451_REALK,      0.000000000000000_REALK,     -0.141113379628283_REALK, &
      0.000000000000000_REALK,      1.014221272009503_REALK,      0.000000000000000_REALK, &
     -0.640586902389906_REALK,      0.000000000000000_REALK,     -7.452268791489089_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.748573609317217_REALK, &
      0.000000000000000_REALK,     -0.274270009962229_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.249214774313281_REALK,      0.000000000000000_REALK, &
     -0.764697254423982_REALK,      0.000000000000000_REALK,     -0.299885817290551_REALK, &
      0.000000000000000_REALK,     -0.639301155684254_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.141816101674729_REALK, &
      0.000000000000000_REALK,     -0.003549906030292_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.067535920771785_REALK,      0.000000000000000_REALK, &
      0.759368009760329_REALK,      0.000000000000000_REALK,      0.613731227140216_REALK, &
      0.000000000000000_REALK,      0.035446660138866_REALK,      0.000000000000000_REALK, &
     -6.587961283458866_REALK,      1.044457332888828_REALK,      0.000000000000000_REALK, &
     -1.422099045563877_REALK,      0.000000000000000_REALK,     -5.205332536242316_REALK, &
      0.823051466015901_REALK,      0.000000000000000_REALK,      1.001223258910890_REALK, &
      0.000000000000000_REALK,     -2.356717049377400_REALK,      0.000000000000000_REALK, &
     -2.786812340943739_REALK,      0.000000000000000_REALK,    -17.001025111398107_REALK, &
     -7.830834718219200_REALK,      1.396176515352400_REALK,      0.000000000000000_REALK, &
     -1.199196426470569_REALK,      0.000000000000000_REALK,     -5.319838062831623_REALK, &
      1.322985205984171_REALK,      0.000000000000000_REALK,      1.307961345775565_REALK, &
      0.000000000000000_REALK,      0.028983776679800_REALK,      0.000000000000000_REALK, &
     -2.191187972494360_REALK,      0.000000000000000_REALK,    -16.200800415994838_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.102458264638907_REALK, &
      0.000000000000000_REALK,      0.009598158949996_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.023964158949388_REALK,      0.000000000000000_REALK, &
      1.465981549593460_REALK,      0.000000000000000_REALK,      0.017061457361868_REALK, &
      0.000000000000000_REALK,     -0.280741812785099_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.284054093972916_REALK, &
      0.000000000000000_REALK,     -0.115954881684052_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.309651048195096_REALK,      0.000000000000000_REALK, &
      3.353041269639541_REALK,      0.000000000000000_REALK,      0.061461975569087_REALK, &
      0.000000000000000_REALK,     -0.590580828737225_REALK,      0.000000000000000_REALK, &
      1.746844215149024_REALK,      0.039795793915804_REALK,      0.000000000000000_REALK, &
      0.329391230450495_REALK,      0.000000000000000_REALK,      0.531161662014940_REALK, &
     -0.004479705871656_REALK,      0.000000000000000_REALK,      0.014680894037106_REALK, &
      0.000000000000000_REALK,      0.423084374470860_REALK,      0.000000000000000_REALK, &
      0.248407678950137_REALK,      0.000000000000000_REALK,     -1.038309785250070_REALK, &
      0.772943995129992_REALK,     -0.013238497168265_REALK,      0.000000000000000_REALK, &
      0.059717436670679_REALK,      0.000000000000000_REALK,     -0.852879782164851_REALK, &
     -0.119138998664847_REALK,      0.000000000000000_REALK,      0.020143860477861_REALK, &
      0.000000000000000_REALK,     -0.379955886402564_REALK,      0.000000000000000_REALK, &
     -0.177231088331730_REALK,      0.000000000000000_REALK,     -6.793748026028369_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.996030202464195_REALK, &
      0.000000000000000_REALK,     -0.166868664804498_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.260670396168523_REALK,      0.000000000000000_REALK, &
     -0.864157215594170_REALK,      0.000000000000000_REALK,     -0.214389268622733_REALK, &
      0.000000000000000_REALK,     -0.295959781082088_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.355757785944861_REALK, &
      0.000000000000000_REALK,     -0.074459753944696_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.124890914151967_REALK,      0.000000000000000_REALK, &
      1.171758532213803_REALK,      0.000000000000000_REALK,     -0.262328070769364_REALK, &
      0.000000000000000_REALK,      0.478343675811177_REALK,      0.000000000000000_REALK, &
      1.295390205259598_REALK,      0.289193077078230_REALK,      0.000000000000000_REALK, &
      0.301899456007952_REALK,      0.000000000000000_REALK,      1.251114843448713_REALK, &
      0.117695154282624_REALK,      0.000000000000000_REALK,      0.338865414410229_REALK, &
      0.000000000000000_REALK,      0.121652874865519_REALK,      0.000000000000000_REALK, &
      0.723168228082790_REALK,      0.000000000000000_REALK,      3.641347057997225_REALK, &
      1.267119720221112_REALK,      0.015848050045409_REALK,      0.000000000000000_REALK, &
     -0.269165666589765_REALK,      0.000000000000000_REALK,      0.297964458464502_REALK, &
     -0.903779413606900_REALK,      0.000000000000000_REALK,      0.005139097698832_REALK, &
      0.000000000000000_REALK,     -3.594278116898227_REALK,      0.000000000000000_REALK, &
     -0.170241497830954_REALK,      0.000000000000000_REALK,     -3.576037911919079_REALK, &
    -12.635854718932844_REALK,      2.873995136924778_REALK,      0.000000000000000_REALK, &
     -2.610735404899546_REALK,      0.000000000000000_REALK,     -8.048101349861348_REALK, &
      1.883304216115742_REALK,      0.000000000000000_REALK,      2.264891903554870_REALK, &
      0.000000000000000_REALK,     -3.644987263204941_REALK,      0.000000000000000_REALK, &
     -3.746748985124840_REALK,      0.000000000000000_REALK,    -19.250141491540834_REALK, &
     -8.544679280409280_REALK,      3.170420985624809_REALK,      0.000000000000000_REALK, &
     -3.160514636438342_REALK,      0.000000000000000_REALK,     -9.467200165133763_REALK, &
      2.031207524645923_REALK,      0.000000000000000_REALK,      3.218474027174733_REALK, &
      0.000000000000000_REALK,     -5.897295918647546_REALK,      0.000000000000000_REALK, &
     -4.503733256572775_REALK,      0.000000000000000_REALK,    -22.484599891192438_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.176628643701945_REALK, &
      0.000000000000000_REALK,      0.031422548106658_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.038028040720413_REALK,      0.000000000000000_REALK, &
      2.077609231863237_REALK,      0.000000000000000_REALK,      0.037070564742151_REALK, &
      0.000000000000000_REALK,     -0.673091988409311_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.947249746297076_REALK, &
      0.000000000000000_REALK,     -0.487024077640995_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.445601499765718_REALK,      0.000000000000000_REALK, &
      5.510052397539251_REALK,      0.000000000000000_REALK,     -0.701981012892245_REALK, &
      0.000000000000000_REALK,     -1.934489092368973_REALK,      0.000000000000000_REALK, &
      2.993079424901985_REALK,     -0.201423414978470_REALK,      0.000000000000000_REALK, &
      0.465138216645189_REALK,      0.000000000000000_REALK,      0.733638575011499_REALK, &
     -0.143986479224979_REALK,      0.000000000000000_REALK,     -0.061086678189111_REALK, &
      0.000000000000000_REALK,      0.506227376393539_REALK,      0.000000000000000_REALK, &
      0.256890986942001_REALK,      0.000000000000000_REALK,     -1.050258593732223_REALK, &
      0.738251994351910_REALK,     -0.077508490467567_REALK,      0.000000000000000_REALK, &
      0.210554765731757_REALK,      0.000000000000000_REALK,     -1.328555981357932_REALK, &
      0.022824986132937_REALK,      0.000000000000000_REALK,      0.127800275642367_REALK, &
      0.000000000000000_REALK,      0.528217348793546_REALK,      0.000000000000000_REALK, &
     -0.487336979721424_REALK,      0.000000000000000_REALK,     -8.253288372594833_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.506165411695094_REALK, &
      0.000000000000000_REALK,     -0.038503150583127_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.283266056167095_REALK,      0.000000000000000_REALK, &
     -1.074271728767691_REALK,      0.000000000000000_REALK,      0.006488736041173_REALK, &
      0.000000000000000_REALK,     -0.050011287320279_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.434899824869437_REALK, &
      0.000000000000000_REALK,      0.010449040144011_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.050209405914391_REALK,      0.000000000000000_REALK, &
      1.552213433141490_REALK,      0.000000000000000_REALK,      0.143038165074919_REALK, &
      0.000000000000000_REALK,     -0.052350445567432_REALK,      0.000000000000000_REALK, &
      1.926526936722445_REALK,      0.231861232648667_REALK,      0.000000000000000_REALK, &
      0.334998510690240_REALK,      0.000000000000000_REALK,      1.499902487684249_REALK, &
      0.119795350451286_REALK,      0.000000000000000_REALK,      0.223351419825273_REALK, &
      0.000000000000000_REALK,      0.388420463837241_REALK,      0.000000000000000_REALK, &
      0.587670300046246_REALK,      0.000000000000000_REALK,      3.196993710274842_REALK, &
      1.178550857371535_REALK,      0.286783687022036_REALK,      0.000000000000000_REALK, &
      0.489323384866645_REALK,      0.000000000000000_REALK,      0.451991825605954_REALK, &
      0.561334037904656_REALK,      0.000000000000000_REALK,      0.100772951341990_REALK, &
      0.000000000000000_REALK,      1.793142992342156_REALK,      0.000000000000000_REALK, &
      0.241361104866017_REALK,      0.000000000000000_REALK,     -4.230520227067263_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.590248342001938_REALK, &
      0.000000000000000_REALK,     -0.398375696155388_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.369649976102557_REALK,      0.000000000000000_REALK, &
     -2.246333001461003_REALK,      0.000000000000000_REALK,     -0.242725295571390_REALK, &
      0.000000000000000_REALK,     -1.024783939858372_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.341636738831623_REALK, &
      0.000000000000000_REALK,     -0.023539087971059_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.425872576311791_REALK,      0.000000000000000_REALK, &
     -0.535508127793851_REALK,      0.000000000000000_REALK,      2.041909626064081_REALK, &
      0.000000000000000_REALK,     -0.013188716605937_REALK,      0.000000000000000_REALK/
    ! results of test 7, ket-major order, 03ODGYYZ
  data REF_CONTR_INTS(73081:74340)                                                         &
    /-1.231063518322395_REALK,     -0.647258081001876_REALK,      0.000000000000000_REALK, &
     -0.573378017831135_REALK,      0.000000000000000_REALK,     -0.642865057184009_REALK, &
     -0.707508691369450_REALK,      0.000000000000000_REALK,     -0.410580948695831_REALK, &
      0.000000000000000_REALK,     -1.433247579268871_REALK,      0.000000000000000_REALK, &
     -0.515385713978533_REALK,      0.000000000000000_REALK,     -0.963074551706448_REALK, &
     -0.699096009879270_REALK,     -0.898482101900580_REALK,      0.000000000000000_REALK, &
     -1.540255619346148_REALK,      0.000000000000000_REALK,     -0.567488198077543_REALK, &
     -3.226561170527561_REALK,      0.000000000000000_REALK,     -0.662915944231914_REALK, &
      0.000000000000000_REALK,     -8.736031183899241_REALK,      0.000000000000000_REALK, &
     -1.395087865842861_REALK,      0.000000000000000_REALK,     -0.856671547678010_REALK, &
     -1.370844407844559_REALK,     -0.510330056721326_REALK,      0.000000000000000_REALK, &
     -0.321891391361913_REALK,      0.000000000000000_REALK,     -0.624306821647210_REALK, &
     -0.208238800743860_REALK,      0.000000000000000_REALK,     -0.279028850311359_REALK, &
      0.000000000000000_REALK,     -0.120609370324930_REALK,      0.000000000000000_REALK, &
     -0.238202009378803_REALK,      0.000000000000000_REALK,     -0.769986105955733_REALK, &
     -0.989631800404300_REALK,     -0.062825517232385_REALK,      0.000000000000000_REALK, &
      0.398348721985428_REALK,      0.000000000000000_REALK,     -0.363502911912677_REALK, &
      1.216654746849028_REALK,      0.000000000000000_REALK,     -0.030969507185461_REALK, &
      0.000000000000000_REALK,      3.516009772398784_REALK,      0.000000000000000_REALK, &
      0.268133954381066_REALK,      0.000000000000000_REALK,     -0.407797941103740_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.206765092967297_REALK, &
      0.000000000000000_REALK,      0.110580113913284_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.100831540334807_REALK,      0.000000000000000_REALK, &
      0.305673535241431_REALK,      0.000000000000000_REALK,      0.141008754644299_REALK, &
      0.000000000000000_REALK,      0.221256352325124_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.404854837737385_REALK, &
      0.000000000000000_REALK,      0.355403945929136_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.541668428037438_REALK,      0.000000000000000_REALK, &
      0.440374772903394_REALK,      0.000000000000000_REALK,      1.164372845600431_REALK, &
      0.000000000000000_REALK,      0.527880364080197_REALK,      0.000000000000000_REALK, &
     -1.816978698262115_REALK,     -0.523768601834761_REALK,      0.000000000000000_REALK, &
     -0.319719268315597_REALK,      0.000000000000000_REALK,     -0.719123627061891_REALK, &
     -0.217032793681477_REALK,      0.000000000000000_REALK,     -0.245029791495873_REALK, &
      0.000000000000000_REALK,     -0.241518425391027_REALK,      0.000000000000000_REALK, &
     -0.194301259540682_REALK,      0.000000000000000_REALK,     -0.728381845943173_REALK, &
     -0.867684021201133_REALK,     -0.489259738222036_REALK,      0.000000000000000_REALK, &
     -0.584221919070612_REALK,      0.000000000000000_REALK,     -0.534927139558865_REALK, &
     -1.012813305439475_REALK,      0.000000000000000_REALK,     -0.267881413442060_REALK, &
      0.000000000000000_REALK,     -2.392914603785961_REALK,      0.000000000000000_REALK, &
     -0.356388604432868_REALK,      0.000000000000000_REALK,     -0.543862787174908_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.230966494668332_REALK, &
      0.000000000000000_REALK,      0.086597505965689_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.055710838495397_REALK,      0.000000000000000_REALK, &
      0.292153484145553_REALK,      0.000000000000000_REALK,      0.039275772357040_REALK, &
      0.000000000000000_REALK,      0.142296705911977_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.202743580084087_REALK, &
      0.000000000000000_REALK,      0.016933291579744_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.121648217095413_REALK,      0.000000000000000_REALK, &
      0.244948673284874_REALK,      0.000000000000000_REALK,     -0.405807817499105_REALK, &
      0.000000000000000_REALK,      0.022793563435126_REALK,      0.000000000000000_REALK, &
      0.125921506310231_REALK,      0.058109897616782_REALK,      0.000000000000000_REALK, &
      0.044450315805264_REALK,      0.000000000000000_REALK,     -0.102949528242997_REALK, &
      0.046844922607673_REALK,      0.000000000000000_REALK,     -0.056156530605668_REALK, &
      0.000000000000000_REALK,      0.075122580388751_REALK,      0.000000000000000_REALK, &
     -0.055802336653875_REALK,      0.000000000000000_REALK,     -0.259028683509244_REALK, &
     -0.060895979863676_REALK,     -0.068199072870738_REALK,      0.000000000000000_REALK, &
     -0.101896114424266_REALK,      0.000000000000000_REALK,     -0.275844083161435_REALK, &
     -0.181745226183870_REALK,      0.000000000000000_REALK,     -0.274361766886893_REALK, &
      0.000000000000000_REALK,     -0.389238867019325_REALK,      0.000000000000000_REALK, &
     -0.456715344088299_REALK,      0.000000000000000_REALK,     -0.522734306287024_REALK, &
     -2.824844477842666_REALK,     -0.576269047241189_REALK,      0.000000000000000_REALK, &
     -0.321220692679456_REALK,      0.000000000000000_REALK,     -0.950445399565990_REALK, &
     -0.150524732291000_REALK,      0.000000000000000_REALK,     -0.226752615625581_REALK, &
      0.000000000000000_REALK,     -0.107794593637414_REALK,      0.000000000000000_REALK, &
     -0.158863704084461_REALK,      0.000000000000000_REALK,     -0.783424398168944_REALK, &
     -3.307969455991395_REALK,     -0.358975363652147_REALK,      0.000000000000000_REALK, &
      0.160048114741467_REALK,      0.000000000000000_REALK,     -0.874635135178201_REALK, &
      0.751130570973332_REALK,      0.000000000000000_REALK,     -0.119074599775719_REALK, &
      0.000000000000000_REALK,      1.894713812851829_REALK,      0.000000000000000_REALK, &
      0.067397105142195_REALK,      0.000000000000000_REALK,     -0.613855779785187_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.315008924803046_REALK, &
      0.000000000000000_REALK,      0.089885774233786_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.055108060059654_REALK,      0.000000000000000_REALK, &
      0.335144832250864_REALK,      0.000000000000000_REALK,      0.039374822043561_REALK, &
      0.000000000000000_REALK,      0.120197321636665_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.624568336265956_REALK, &
      0.000000000000000_REALK,      0.229186950319688_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.226265147967386_REALK,      0.000000000000000_REALK, &
      0.457150634267642_REALK,      0.000000000000000_REALK,      0.364894554484245_REALK, &
      0.000000000000000_REALK,      0.212963631160486_REALK,      0.000000000000000_REALK, &
      0.167336249382539_REALK,      0.053882391033028_REALK,      0.000000000000000_REALK, &
      0.029029124807477_REALK,      0.000000000000000_REALK,     -0.116303662009632_REALK, &
      0.015822912112082_REALK,      0.000000000000000_REALK,     -0.043797023875057_REALK, &
      0.000000000000000_REALK,      0.007269269030927_REALK,      0.000000000000000_REALK, &
     -0.029656906040601_REALK,      0.000000000000000_REALK,     -0.238139398038970_REALK, &
     -0.123580258133020_REALK,     -0.006802111174710_REALK,      0.000000000000000_REALK, &
      0.035807175152189_REALK,      0.000000000000000_REALK,     -0.240080310372314_REALK, &
      0.088640311283192_REALK,      0.000000000000000_REALK,     -0.016578308971239_REALK, &
      0.000000000000000_REALK,      0.197723824009920_REALK,      0.000000000000000_REALK, &
      0.110790560117179_REALK,      0.000000000000000_REALK,     -0.314064314380338_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.040929620856545_REALK, &
      0.000000000000000_REALK,     -0.018696762113483_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.014364349134557_REALK,      0.000000000000000_REALK, &
      0.085334979181970_REALK,      0.000000000000000_REALK,     -0.015933843890686_REALK, &
      0.000000000000000_REALK,      0.048994792816714_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.244897505707921_REALK, &
      0.000000000000000_REALK,      0.178486861656600_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.220482851028285_REALK,      0.000000000000000_REALK, &
      0.413792491369101_REALK,      0.000000000000000_REALK,      0.365829203928369_REALK, &
      0.000000000000000_REALK,      0.382860613696070_REALK,      0.000000000000000_REALK, &
     -5.152854154728445_REALK,     -0.709782795723473_REALK,      0.000000000000000_REALK, &
     -0.414331814351252_REALK,      0.000000000000000_REALK,     -1.475167422764762_REALK, &
     -0.152465886212715_REALK,      0.000000000000000_REALK,     -0.232841981990885_REALK, &
      0.000000000000000_REALK,     -0.134810621914037_REALK,      0.000000000000000_REALK, &
     -0.165206825866602_REALK,      0.000000000000000_REALK,     -0.980324300055545_REALK, &
     -3.059058015784150_REALK,     -0.780640948854037_REALK,      0.000000000000000_REALK, &
     -0.788184271679308_REALK,      0.000000000000000_REALK,     -1.433942466222771_REALK, &
     -1.053023933927591_REALK,      0.000000000000000_REALK,     -0.312947521009596_REALK, &
      0.000000000000000_REALK,     -2.154135281178598_REALK,      0.000000000000000_REALK, &
     -0.322694063884271_REALK,      0.000000000000000_REALK,     -0.978461379375531_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.504188920312440_REALK, &
      0.000000000000000_REALK,      0.101136006398946_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.055899182698975_REALK,      0.000000000000000_REALK, &
      0.447210275187945_REALK,      0.000000000000000_REALK,      0.026769549582278_REALK, &
      0.000000000000000_REALK,      0.109035561025610_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.662381536516958_REALK, &
      0.000000000000000_REALK,      0.094767673000053_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.048590576145371_REALK,      0.000000000000000_REALK, &
      0.585940183270456_REALK,      0.000000000000000_REALK,     -0.244748329682334_REALK, &
      0.000000000000000_REALK,      0.085614693499356_REALK,      0.000000000000000_REALK, &
      0.274303960111098_REALK,      0.067729717291817_REALK,      0.000000000000000_REALK, &
      0.034913291346313_REALK,      0.000000000000000_REALK,     -0.162216963835105_REALK, &
      0.019679839498978_REALK,      0.000000000000000_REALK,     -0.045897159694298_REALK, &
      0.000000000000000_REALK,      0.017303945980385_REALK,      0.000000000000000_REALK, &
     -0.028756844332542_REALK,      0.000000000000000_REALK,     -0.267788958355656_REALK, &
     -0.121017598696079_REALK,     -0.059715653991181_REALK,      0.000000000000000_REALK, &
     -0.061954914036984_REALK,      0.000000000000000_REALK,     -0.416806575130214_REALK, &
     -0.090509714774603_REALK,      0.000000000000000_REALK,     -0.175893745601938_REALK, &
      0.000000000000000_REALK,     -0.170310867911790_REALK,      0.000000000000000_REALK, &
     -0.186372138341257_REALK,      0.000000000000000_REALK,     -0.530113838947481_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.055995557713277_REALK, &
      0.000000000000000_REALK,     -0.017729323130447_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.009471105522217_REALK,      0.000000000000000_REALK, &
      0.097331125773917_REALK,      0.000000000000000_REALK,     -0.005275752399601_REALK, &
      0.000000000000000_REALK,      0.037457105469811_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.138252566116321_REALK, &
      0.000000000000000_REALK,      0.010032673386978_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.060736382573373_REALK,      0.000000000000000_REALK, &
      0.282317074890811_REALK,      0.000000000000000_REALK,     -0.161366339206151_REALK, &
      0.000000000000000_REALK,      0.020922985005631_REALK,      0.000000000000000_REALK, &
      0.308838635125564_REALK,      0.122078556460780_REALK,      0.000000000000000_REALK, &
      0.078858099366639_REALK,      0.000000000000000_REALK,      0.019484814801854_REALK, &
      0.069009390191979_REALK,      0.000000000000000_REALK,      0.008825643883847_REALK, &
      0.000000000000000_REALK,      0.087440946850060_REALK,      0.000000000000000_REALK, &
      0.006929425121847_REALK,      0.000000000000000_REALK,     -0.100841509505501_REALK, &
      0.094919515841705_REALK,      0.093026599285826_REALK,      0.000000000000000_REALK, &
      0.120763445456903_REALK,      0.000000000000000_REALK,     -0.326867882179432_REALK, &
      0.181513432874742_REALK,      0.000000000000000_REALK,     -0.273968135350494_REALK, &
      0.000000000000000_REALK,      0.309607392435313_REALK,      0.000000000000000_REALK, &
     -0.363221401037282_REALK,      0.000000000000000_REALK,     -0.695355677510149_REALK, &
    -13.627226672270504_REALK,     -1.038783384951629_REALK,      0.000000000000000_REALK, &
     -0.699981083609219_REALK,      0.000000000000000_REALK,     -2.974615476013657_REALK, &
     -0.138602751747972_REALK,      0.000000000000000_REALK,     -0.260899656832148_REALK, &
      0.000000000000000_REALK,     -0.125547849525179_REALK,      0.000000000000000_REALK, &
     -0.211163514242994_REALK,      0.000000000000000_REALK,     -1.495588647905300_REALK, &
    -36.981053715759757_REALK,     -1.554771676763102_REALK,      0.000000000000000_REALK, &
      0.079313282022898_REALK,      0.000000000000000_REALK,     -6.520019740084779_REALK, &
      2.084794531146910_REALK,      0.000000000000000_REALK,     -0.307517153750866_REALK, &
      0.000000000000000_REALK,      3.857844865638675_REALK,      0.000000000000000_REALK, &
      0.018070020143378_REALK,      0.000000000000000_REALK,     -2.475770451758226_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.109100491712340_REALK, &
      0.000000000000000_REALK,      0.141784903256928_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.078239556482620_REALK,      0.000000000000000_REALK, &
      0.753185703243676_REALK,      0.000000000000000_REALK,      0.028007475423355_REALK, &
      0.000000000000000_REALK,      0.115649890305698_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.788804933226515_REALK, &
      0.000000000000000_REALK,      0.718929096035077_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.520626068881159_REALK,      0.000000000000000_REALK, &
      2.090040732234733_REALK,      0.000000000000000_REALK,      0.551144530870935_REALK, &
      0.000000000000000_REALK,      0.361429546541853_REALK,      0.000000000000000_REALK, &
      0.655385218068794_REALK,      0.108008406754579_REALK,      0.000000000000000_REALK, &
      0.048349984185355_REALK,      0.000000000000000_REALK,     -0.295522616688824_REALK, &
      0.018007840324964_REALK,      0.000000000000000_REALK,     -0.056037248355245_REALK, &
      0.000000000000000_REALK,      0.009896946188679_REALK,      0.000000000000000_REALK, &
     -0.030130035419966_REALK,      0.000000000000000_REALK,     -0.369096555970015_REALK, &
     -1.190392904357413_REALK,     -0.108886150825885_REALK,      0.000000000000000_REALK, &
      0.038404631460457_REALK,      0.000000000000000_REALK,     -1.542062498842290_REALK, &
      0.135853765085494_REALK,      0.000000000000000_REALK,     -0.158240406033634_REALK, &
      0.000000000000000_REALK,      0.245979375861104_REALK,      0.000000000000000_REALK, &
      0.064289246281849_REALK,      0.000000000000000_REALK,     -1.091405301964606_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.110692937799441_REALK, &
      0.000000000000000_REALK,     -0.025365800624680_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.012360432850544_REALK,      0.000000000000000_REALK, &
      0.147309508372310_REALK,      0.000000000000000_REALK,     -0.006777782406542_REALK, &
      0.000000000000000_REALK,      0.040545578840409_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.058437796726781_REALK, &
      0.000000000000000_REALK,      0.307255949028602_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.228639509893906_REALK,      0.000000000000000_REALK, &
      1.066379588055897_REALK,      0.000000000000000_REALK,      0.264667022620229_REALK, &
      0.000000000000000_REALK,      0.356579829551655_REALK,      0.000000000000000_REALK, &
      0.630727261059683_REALK,      0.164069780999746_REALK,      0.000000000000000_REALK, &
      0.070986577387678_REALK,      0.000000000000000_REALK,      0.030341437366813_REALK, &
      0.030753153501857_REALK,      0.000000000000000_REALK,      0.009081305942362_REALK, &
      0.000000000000000_REALK,      0.010842874820223_REALK,      0.000000000000000_REALK, &
      0.004719326341149_REALK,      0.000000000000000_REALK,     -0.118804277759494_REALK, &
      0.497001725623040_REALK,      0.023058533718467_REALK,      0.000000000000000_REALK, &
     -0.096024722255503_REALK,      0.000000000000000_REALK,     -0.643724809755212_REALK, &
     -0.179170899278554_REALK,      0.000000000000000_REALK,     -0.033504808108934_REALK, &
      0.000000000000000_REALK,     -0.286875880043249_REALK,      0.000000000000000_REALK, &
      0.160719471870415_REALK,      0.000000000000000_REALK,     -0.762051822848451_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.261802122258295_REALK, &
      0.000000000000000_REALK,     -0.096042266188594_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.058646607474360_REALK,      0.000000000000000_REALK, &
     -0.009427571472017_REALK,      0.000000000000000_REALK,     -0.049926136727111_REALK, &
      0.000000000000000_REALK,     -0.004154063527227_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.348692624021162_REALK, &
      0.000000000000000_REALK,      0.201043339622322_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.187189487165798_REALK,      0.000000000000000_REALK, &
      1.279595655829726_REALK,      0.000000000000000_REALK,      0.222937867934013_REALK, &
      0.000000000000000_REALK,      0.849825337528925_REALK,      0.000000000000000_REALK, &
     -2.353209884309157_REALK,     -0.107299583945436_REALK,      0.000000000000000_REALK, &
     -0.814720403918330_REALK,      0.000000000000000_REALK,     -3.059300632611311_REALK, &
     -0.133303334941165_REALK,      0.000000000000000_REALK,     -0.163178957807308_REALK, &
      0.000000000000000_REALK,     -3.084365710120084_REALK,      0.000000000000000_REALK, &
     -3.049109800549807_REALK,      0.000000000000000_REALK,    -19.082504658163380_REALK, &
     -1.026307096879730_REALK,     -0.113106043667842_REALK,      0.000000000000000_REALK, &
     -1.158990780877221_REALK,      0.000000000000000_REALK,     -2.110964900722927_REALK, &
     -0.844604886539841_REALK,      0.000000000000000_REALK,     -0.287760230042638_REALK, &
      0.000000000000000_REALK,    -16.840595502817159_REALK,      0.000000000000000_REALK, &
     -5.172833946274865_REALK,      0.000000000000000_REALK,    -15.702844057697314_REALK, &
     -2.460484965661691_REALK,      0.012743060526536_REALK,      0.000000000000000_REALK, &
     -0.648398363604077_REALK,      0.000000000000000_REALK,     -2.830534689536363_REALK, &
      0.070143936899133_REALK,      0.000000000000000_REALK,      0.016509910109958_REALK, &
      0.000000000000000_REALK,     -1.260225247788587_REALK,      0.000000000000000_REALK, &
     -2.083706015289300_REALK,      0.000000000000000_REALK,    -15.160438628829763_REALK, &
     -1.791411734238548_REALK,      0.114571171921922_REALK,      0.000000000000000_REALK, &
     -0.065812211077475_REALK,      0.000000000000000_REALK,     -1.926051409294952_REALK, &
      0.699600587108108_REALK,      0.000000000000000_REALK,      0.161281129792320_REALK, &
      0.000000000000000_REALK,      5.526563663351204_REALK,      0.000000000000000_REALK, &
     -0.233005754091381_REALK,      0.000000000000000_REALK,    -11.365192307377601_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.035314166806251_REALK, &
      0.000000000000000_REALK,     -0.008013127950054_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.012184462153205_REALK,      0.000000000000000_REALK, &
      0.682906440931949_REALK,      0.000000000000000_REALK,     -0.021036499400807_REALK, &
      0.000000000000000_REALK,      0.384359743362784_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.340650889841218_REALK, &
      0.000000000000000_REALK,      0.155010978446472_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.263279290232415_REALK,      0.000000000000000_REALK, &
      1.336653153933329_REALK,      0.000000000000000_REALK,      1.610814163102948_REALK, &
      0.000000000000000_REALK,      1.529761123613286_REALK,      0.000000000000000_REALK, &
     -3.274982543298090_REALK,      0.306170396476124_REALK,      0.000000000000000_REALK, &
     -0.778083637747483_REALK,      0.000000000000000_REALK,     -3.171290770044745_REALK, &
      0.291819131474682_REALK,      0.000000000000000_REALK,      0.345571715547997_REALK, &
      0.000000000000000_REALK,     -1.570745359547809_REALK,      0.000000000000000_REALK, &
     -2.003887903115297_REALK,      0.000000000000000_REALK,    -13.612313859023871_REALK, &
     -1.451349948315809_REALK,      0.191204882191375_REALK,      0.000000000000000_REALK, &
     -0.711260053836464_REALK,      0.000000000000000_REALK,     -2.430324330287257_REALK, &
     -0.232249369037986_REALK,      0.000000000000000_REALK,      0.291203507467371_REALK, &
      0.000000000000000_REALK,     -4.565671224567853_REALK,      0.000000000000000_REALK, &
     -2.020029689433069_REALK,      0.000000000000000_REALK,    -11.503826379796878_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.052269401493665_REALK, &
      0.000000000000000_REALK,      0.000537661918537_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.013514374452910_REALK,      0.000000000000000_REALK, &
      0.880569830098621_REALK,      0.000000000000000_REALK,      0.005883040620258_REALK, &
      0.000000000000000_REALK,     -0.020667964184476_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.382015722059210_REALK, &
      0.000000000000000_REALK,     -0.054445506416299_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.019880049812368_REALK,      0.000000000000000_REALK, &
      1.621734886750940_REALK,      0.000000000000000_REALK,     -0.670745834284744_REALK, &
      0.000000000000000_REALK,     -0.431014989547492_REALK,      0.000000000000000_REALK, &
      0.951627061230507_REALK,      0.091514620907119_REALK,      0.000000000000000_REALK, &
      0.245403240990351_REALK,      0.000000000000000_REALK,      0.354624684059093_REALK, &
      0.084380547115309_REALK,      0.000000000000000_REALK,      0.039750315652669_REALK, &
      0.000000000000000_REALK,      0.639322865548349_REALK,      0.000000000000000_REALK, &
      0.243221822968382_REALK,      0.000000000000000_REALK,     -0.911042103968529_REALK, &
      0.176539185817820_REALK,      0.056145223860054_REALK,      0.000000000000000_REALK, &
      0.162305105516572_REALK,      0.000000000000000_REALK,     -0.480156319595625_REALK, &
      0.250976616352474_REALK,      0.000000000000000_REALK,     -0.138886450585965_REALK, &
      0.000000000000000_REALK,      1.500688045183416_REALK,      0.000000000000000_REALK, &
     -0.748705377767128_REALK,      0.000000000000000_REALK,     -5.944896384491040_REALK, &
     -5.328406921289462_REALK,      0.955005302763553_REALK,      0.000000000000000_REALK, &
     -1.179276321833526_REALK,      0.000000000000000_REALK,     -4.210123393312435_REALK, &
      0.745269174205352_REALK,      0.000000000000000_REALK,      0.915473989603251_REALK, &
      0.000000000000000_REALK,     -1.995856778184246_REALK,      0.000000000000000_REALK, &
     -2.310965482552101_REALK,      0.000000000000000_REALK,    -13.750593844569186_REALK, &
     -6.356192995568030_REALK,      1.294181933936861_REALK,      0.000000000000000_REALK, &
     -0.941320069653690_REALK,      0.000000000000000_REALK,     -4.318047647443658_REALK, &
      1.350703075735573_REALK,      0.000000000000000_REALK,      1.212411128089508_REALK, &
      0.000000000000000_REALK,      0.858516583494420_REALK,      0.000000000000000_REALK, &
     -1.719992796312206_REALK,      0.000000000000000_REALK,    -13.149992029222581_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.081659165813710_REALK, &
      0.000000000000000_REALK,      0.010223180760369_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.019205931909028_REALK,      0.000000000000000_REALK, &
      1.168386277671087_REALK,      0.000000000000000_REALK,      0.016917628795080_REALK, &
      0.000000000000000_REALK,     -0.299023418350127_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.031130440202809_REALK, &
      0.000000000000000_REALK,     -0.110299066089101_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.282704272757270_REALK,      0.000000000000000_REALK, &
      2.692583541931790_REALK,      0.000000000000000_REALK,      0.160738194632330_REALK, &
      0.000000000000000_REALK,     -0.561774656778446_REALK,      0.000000000000000_REALK, &
      1.366099371943512_REALK,     -0.008562242327274_REALK,      0.000000000000000_REALK, &
      0.247259599207638_REALK,      0.000000000000000_REALK,      0.415388851842852_REALK, &
     -0.034871704058953_REALK,      0.000000000000000_REALK,     -0.003158659746622_REALK, &
      0.000000000000000_REALK,      0.293050705853304_REALK,      0.000000000000000_REALK, &
      0.186468786838397_REALK,      0.000000000000000_REALK,     -0.811998192633289_REALK, &
      0.592380478550221_REALK,     -0.042184063605241_REALK,      0.000000000000000_REALK, &
      0.013750854922282_REALK,      0.000000000000000_REALK,     -0.653642872818559_REALK, &
     -0.171423201696342_REALK,      0.000000000000000_REALK,      0.064187791170905_REALK, &
      0.000000000000000_REALK,     -0.595946867036109_REALK,      0.000000000000000_REALK, &
     -0.040810174033548_REALK,      0.000000000000000_REALK,     -5.206695093260247_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.763081863005540_REALK, &
      0.000000000000000_REALK,     -0.098270174309010_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.194803965988118_REALK,      0.000000000000000_REALK, &
     -0.662050906060737_REALK,      0.000000000000000_REALK,     -0.157317293462852_REALK, &
      0.000000000000000_REALK,     -0.174292874635677_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.283798563174953_REALK, &
      0.000000000000000_REALK,     -0.073284694648546_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.145970045142940_REALK,      0.000000000000000_REALK, &
      0.934746619661641_REALK,      0.000000000000000_REALK,     -0.393029736425419_REALK, &
      0.000000000000000_REALK,      0.470794870540698_REALK,      0.000000000000000_REALK, &
    -10.344392894623814_REALK,      2.529747696644115_REALK,      0.000000000000000_REALK, &
     -2.212001831320299_REALK,      0.000000000000000_REALK,     -6.588610289573597_REALK, &
      1.660292215925766_REALK,      0.000000000000000_REALK,      1.993602912737218_REALK, &
      0.000000000000000_REALK,     -3.161066492484813_REALK,      0.000000000000000_REALK, &
     -3.174513817463057_REALK,      0.000000000000000_REALK,    -15.759205158257439_REALK, &
     -7.071448492987819_REALK,      2.771710989124363_REALK,      0.000000000000000_REALK, &
     -2.792564903148854_REALK,      0.000000000000000_REALK,     -7.834912949166000_REALK, &
      1.621805225221042_REALK,      0.000000000000000_REALK,      2.813720912705073_REALK, &
      0.000000000000000_REALK,     -5.904231433187306_REALK,      0.000000000000000_REALK, &
     -3.979404898318302_REALK,      0.000000000000000_REALK,    -18.607917839648952_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.142858958500935_REALK, &
      0.000000000000000_REALK,      0.028731379562631_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.031534771173074_REALK,      0.000000000000000_REALK, &
      1.680390478096846_REALK,      0.000000000000000_REALK,      0.033567219443085_REALK, &
      0.000000000000000_REALK,     -0.615445358979520_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.580558860377754_REALK, &
      0.000000000000000_REALK,     -0.451445612889535_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.349778923234265_REALK,      0.000000000000000_REALK, &
      4.472442302091688_REALK,      0.000000000000000_REALK,     -0.716688220648835_REALK, &
      0.000000000000000_REALK,     -1.793169278534906_REALK,      0.000000000000000_REALK, &
      2.385482224523864_REALK,     -0.214539891600412_REALK,      0.000000000000000_REALK, &
      0.372782242683394_REALK,      0.000000000000000_REALK,      0.584709435157157_REALK, &
     -0.142772669143895_REALK,      0.000000000000000_REALK,     -0.065064577116429_REALK, &
      0.000000000000000_REALK,      0.419352578832384_REALK,      0.000000000000000_REALK, &
      0.205883745541467_REALK,      0.000000000000000_REALK,     -0.837055370351120_REALK, &
      0.592836475885061_REALK,     -0.073727936145395_REALK,      0.000000000000000_REALK, &
      0.192231650009691_REALK,      0.000000000000000_REALK,     -1.066866668874602_REALK, &
      0.059692956979431_REALK,      0.000000000000000_REALK,      0.121566689082497_REALK, &
      0.000000000000000_REALK,      0.619136817423064_REALK,      0.000000000000000_REALK, &
     -0.444927434423106_REALK,      0.000000000000000_REALK,     -6.627615544157865_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.177879289472975_REALK, &
      0.000000000000000_REALK,      0.008284124356301_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.212635446976573_REALK,      0.000000000000000_REALK, &
     -0.840121815808867_REALK,      0.000000000000000_REALK,      0.050510745443381_REALK, &
      0.000000000000000_REALK,      0.010760151237116_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.333305088079812_REALK, &
      0.000000000000000_REALK,      0.033295544686546_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.011561485136581_REALK,      0.000000000000000_REALK, &
      1.189608745432840_REALK,      0.000000000000000_REALK,      0.205810528010987_REALK, &
      0.000000000000000_REALK,     -0.166813082898345_REALK,      0.000000000000000_REALK, &
      1.475957014523730_REALK,      0.136544771749574_REALK,      0.000000000000000_REALK, &
      0.250350785673344_REALK,      0.000000000000000_REALK,      1.149110119148103_REALK, &
      0.087904961024863_REALK,      0.000000000000000_REALK,      0.131533280883558_REALK, &
      0.000000000000000_REALK,      0.363440650082851_REALK,      0.000000000000000_REALK, &
      0.439177240013187_REALK,      0.000000000000000_REALK,      2.449291106251588_REALK, &
      0.940165059388159_REALK,      0.282257915453282_REALK,      0.000000000000000_REALK, &
      0.571911552281285_REALK,      0.000000000000000_REALK,      0.360567317825827_REALK, &
      0.841011670299861_REALK,      0.000000000000000_REALK,      0.099182639972403_REALK, &
      0.000000000000000_REALK,      2.653216143436478_REALK,      0.000000000000000_REALK, &
      0.282098114280537_REALK,      0.000000000000000_REALK,     -3.374811766200799_REALK, &
    -26.971757352186415_REALK,      7.458839498548065_REALK,      0.000000000000000_REALK, &
     -5.169039900311878_REALK,      0.000000000000000_REALK,    -12.699482397296409_REALK, &
      3.947245084830151_REALK,      0.000000000000000_REALK,      4.447445251336743_REALK, &
      0.000000000000000_REALK,     -5.696793452680824_REALK,      0.000000000000000_REALK, &
     -5.115633357617932_REALK,      0.000000000000000_REALK,    -20.947118816710837_REALK, &
    -87.505949639281141_REALK,     24.490398375007366_REALK,      0.000000000000000_REALK, &
    -13.188883548299144_REALK,      0.000000000000000_REALK,    -33.154016097647613_REALK, &
     10.740524488854847_REALK,      0.000000000000000_REALK,     11.524444809173518_REALK, &
      0.000000000000000_REALK,     -6.893576002152039_REALK,      0.000000000000000_REALK, &
     -9.043292984304450_REALK,      0.000000000000000_REALK,    -37.888155339228696_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.312300385636861_REALK, &
      0.000000000000000_REALK,      0.076248748824700_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.062517777586800_REALK,      0.000000000000000_REALK, &
      2.779413426160939_REALK,      0.000000000000000_REALK,      0.062844622240634_REALK, &
      0.000000000000000_REALK,     -1.126324496576702_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     10.043895276404461_REALK, &
      0.000000000000000_REALK,     -2.326287729856705_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.684594733224741_REALK,      0.000000000000000_REALK, &
     13.174293565507114_REALK,      0.000000000000000_REALK,     -0.919389785787049_REALK, &
      0.000000000000000_REALK,     -4.446138588365179_REALK,      0.000000000000000_REALK, &
      5.655819979297720_REALK,     -0.842256830949701_REALK,      0.000000000000000_REALK, &
      0.745921470835591_REALK,      0.000000000000000_REALK,      1.024819684089753_REALK, &
     -0.408837796742366_REALK,      0.000000000000000_REALK,     -0.193267573812275_REALK, &
      0.000000000000000_REALK,      0.637556310632945_REALK,      0.000000000000000_REALK, &
      0.284091172063342_REALK,      0.000000000000000_REALK,     -1.011717658419460_REALK, &
      6.393881696912572_REALK,     -1.056842903329056_REALK,      0.000000000000000_REALK, &
      0.528096204589798_REALK,      0.000000000000000_REALK,     -3.934708787253402_REALK, &
     -0.554044404515098_REALK,      0.000000000000000_REALK,      0.807763146929225_REALK, &
      0.000000000000000_REALK,     -0.180739748874051_REALK,      0.000000000000000_REALK, &
     -0.588140451896640_REALK,      0.000000000000000_REALK,    -11.761520475644367_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.316072212719786_REALK, &
      0.000000000000000_REALK,      0.207956245300676_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.338829850237299_REALK,      0.000000000000000_REALK, &
     -1.249889072177797_REALK,      0.000000000000000_REALK,      0.173794914893266_REALK, &
      0.000000000000000_REALK,      0.186269401843476_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.905269070335387_REALK, &
      0.000000000000000_REALK,      0.140015195170143_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.262388419546215_REALK,      0.000000000000000_REALK, &
      3.152169845054022_REALK,      0.000000000000000_REALK,     -0.076568771463758_REALK, &
      0.000000000000000_REALK,     -0.337538151621288_REALK,      0.000000000000000_REALK, &
      3.087594198113878_REALK,     -0.016079258024626_REALK,      0.000000000000000_REALK, &
      0.333020080192736_REALK,      0.000000000000000_REALK,      1.777035564194659_REALK, &
     -0.040733411232144_REALK,      0.000000000000000_REALK,     -0.011719375774125_REALK, &
      0.000000000000000_REALK,      0.199329546113930_REALK,      0.000000000000000_REALK, &
      0.402864569099119_REALK,      0.000000000000000_REALK,      2.611996931848588_REALK, &
      7.769059932329294_REALK,     -0.449121378218873_REALK,      0.000000000000000_REALK, &
      0.100578612570693_REALK,      0.000000000000000_REALK,      1.018881068270837_REALK, &
     -0.916757557722051_REALK,      0.000000000000000_REALK,     -0.073155056491738_REALK, &
      0.000000000000000_REALK,     -1.635734219861426_REALK,      0.000000000000000_REALK, &
      0.023871552658830_REALK,      0.000000000000000_REALK,     -4.588707773494243_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.040306763489165_REALK, &
      0.000000000000000_REALK,     -0.188445093799348_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.323982277650115_REALK,      0.000000000000000_REALK, &
     -2.180632866572601_REALK,      0.000000000000000_REALK,     -0.152353073753120_REALK, &
      0.000000000000000_REALK,     -0.334289008223372_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -5.685931121528173_REALK, &
      0.000000000000000_REALK,     -1.008707639971045_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.469009912323664_REALK,      0.000000000000000_REALK, &
     -1.052019541277329_REALK,      0.000000000000000_REALK,     -2.030049817361760_REALK, &
      0.000000000000000_REALK,     -0.271945531864465_REALK,      0.000000000000000_REALK/
    ! results of test 7, ket-major order, 03ODGXZZ
  data REF_CONTR_INTS(74341:75600)                                                         &
     /0.000000000000000_REALK,      0.000000000000000_REALK,      2.035398379247176_REALK, &
      0.000000000000000_REALK,      2.205572099506001_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.148786955941967_REALK,      0.000000000000000_REALK, &
      2.474518601482841_REALK,      0.000000000000000_REALK,      6.702155180051340_REALK, &
      0.000000000000000_REALK,      4.007304430931070_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.222571457980984_REALK, &
      0.000000000000000_REALK,      3.880014655857980_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      6.161756632843372_REALK,      0.000000000000000_REALK, &
      3.714286748649602_REALK,      0.000000000000000_REALK,     13.801038024331664_REALK, &
      0.000000000000000_REALK,      6.703001609807401_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.317696591729078_REALK, &
      0.000000000000000_REALK,      1.030795548764400_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.098235277920395_REALK,      0.000000000000000_REALK, &
      1.393110240992673_REALK,      0.000000000000000_REALK,      1.617114770349404_REALK, &
      0.000000000000000_REALK,      1.544232261395293_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.034869546279925_REALK, &
      0.000000000000000_REALK,      0.817539342594290_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.624719650218596_REALK,      0.000000000000000_REALK, &
      1.272575011006212_REALK,      0.000000000000000_REALK,      0.137300541193925_REALK, &
      0.000000000000000_REALK,      1.234144950116151_REALK,      0.000000000000000_REALK, &
     -0.675446205841158_REALK,     -0.624041993269632_REALK,      0.000000000000000_REALK, &
     -0.748051382344502_REALK,      0.000000000000000_REALK,     -0.953702194698785_REALK, &
     -1.103433132133244_REALK,      0.000000000000000_REALK,     -1.070330212663893_REALK, &
      0.000000000000000_REALK,     -2.252083532390522_REALK,      0.000000000000000_REALK, &
     -1.818048328282197_REALK,      0.000000000000000_REALK,     -2.329068789295214_REALK, &
     -1.114308704563656_REALK,     -1.669631158377214_REALK,      0.000000000000000_REALK, &
     -2.500940708298771_REALK,      0.000000000000000_REALK,     -1.995953462185742_REALK, &
     -4.227277457012200_REALK,      0.000000000000000_REALK,     -2.718281644927597_REALK, &
      0.000000000000000_REALK,     -9.101352270326357_REALK,      0.000000000000000_REALK, &
     -4.998469338550432_REALK,      0.000000000000000_REALK,     -4.660649177141873_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.151137761116200_REALK, &
      0.000000000000000_REALK,      0.698243766778287_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.627078700627895_REALK,      0.000000000000000_REALK, &
      1.048996434770846_REALK,      0.000000000000000_REALK,      0.769130042385859_REALK, &
      0.000000000000000_REALK,      0.861175915987812_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.307442012754055_REALK, &
      0.000000000000000_REALK,      0.844169037131402_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.856583095275026_REALK,      0.000000000000000_REALK, &
      1.074161067887675_REALK,      0.000000000000000_REALK,      1.303878114967449_REALK, &
      0.000000000000000_REALK,      0.947036141950935_REALK,      0.000000000000000_REALK, &
     -0.494316444761433_REALK,     -0.331535421141333_REALK,      0.000000000000000_REALK, &
     -0.295783285906899_REALK,      0.000000000000000_REALK,     -0.608692051986728_REALK, &
     -0.316376975088778_REALK,      0.000000000000000_REALK,     -0.490129174048041_REALK, &
      0.000000000000000_REALK,     -0.433938371352610_REALK,      0.000000000000000_REALK, &
     -0.591823688749499_REALK,      0.000000000000000_REALK,     -1.223804049702982_REALK, &
     -1.114459190590976_REALK,     -0.583245182915176_REALK,      0.000000000000000_REALK, &
     -0.334926065241062_REALK,      0.000000000000000_REALK,     -0.903281882055822_REALK, &
     -0.053309451066202_REALK,      0.000000000000000_REALK,     -0.634416193242765_REALK, &
      0.000000000000000_REALK,      0.620396658252240_REALK,      0.000000000000000_REALK, &
     -0.497464632243143_REALK,      0.000000000000000_REALK,     -1.567468879552046_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.332874424808350_REALK, &
      0.000000000000000_REALK,      0.312828469613066_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.385993237078157_REALK,      0.000000000000000_REALK, &
      0.753520519098144_REALK,      0.000000000000000_REALK,      0.645287453138998_REALK, &
      0.000000000000000_REALK,      0.958426957714086_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.631274542032752_REALK, &
      0.000000000000000_REALK,      1.669522904738477_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.223325977298760_REALK,      0.000000000000000_REALK, &
      2.498024242138520_REALK,      0.000000000000000_REALK,      3.856310056700817_REALK, &
      0.000000000000000_REALK,      3.491018376789930_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.207772261476301_REALK, &
      0.000000000000000_REALK,      0.554430469254864_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.410915010406762_REALK,      0.000000000000000_REALK, &
      0.941701431915285_REALK,      0.000000000000000_REALK,      0.388038227791563_REALK, &
      0.000000000000000_REALK,      0.561568377739091_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.961194583281095_REALK, &
      0.000000000000000_REALK,      0.465761182385247_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.248932338230689_REALK,      0.000000000000000_REALK, &
      0.877128388893167_REALK,      0.000000000000000_REALK,     -0.009262652247213_REALK, &
      0.000000000000000_REALK,      0.473541452801996_REALK,      0.000000000000000_REALK, &
     -0.493546203079083_REALK,     -0.258319963269480_REALK,      0.000000000000000_REALK, &
     -0.194615902470248_REALK,      0.000000000000000_REALK,     -0.528158403148428_REALK, &
     -0.179884626855416_REALK,      0.000000000000000_REALK,     -0.326753356160613_REALK, &
      0.000000000000000_REALK,     -0.220464489322579_REALK,      0.000000000000000_REALK, &
     -0.319792141018185_REALK,      0.000000000000000_REALK,     -0.872065681170982_REALK, &
     -0.571603287090556_REALK,     -0.470834887906679_REALK,      0.000000000000000_REALK, &
     -0.468356542702154_REALK,      0.000000000000000_REALK,     -0.777593510557380_REALK, &
     -0.591549281259991_REALK,      0.000000000000000_REALK,     -0.568848498586939_REALK, &
      0.000000000000000_REALK,     -1.020945066587096_REALK,      0.000000000000000_REALK, &
     -0.630445328131467_REALK,      0.000000000000000_REALK,     -1.222885603877392_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.244376128423054_REALK, &
      0.000000000000000_REALK,      0.165073391801884_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.150209314856570_REALK,      0.000000000000000_REALK, &
      0.473320050511249_REALK,      0.000000000000000_REALK,      0.175089802405252_REALK, &
      0.000000000000000_REALK,      0.415336952879686_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.577160584499760_REALK, &
      0.000000000000000_REALK,      0.397388687853399_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.258553423754994_REALK,      0.000000000000000_REALK, &
      0.981682696581511_REALK,      0.000000000000000_REALK,      0.044948612521268_REALK, &
      0.000000000000000_REALK,      0.753065636538544_REALK,      0.000000000000000_REALK, &
      0.129531383475203_REALK,      0.105039158355457_REALK,      0.000000000000000_REALK, &
      0.108725153782756_REALK,      0.000000000000000_REALK,     -0.271638347136865_REALK, &
      0.136975077712170_REALK,      0.000000000000000_REALK,     -0.260371242980700_REALK, &
      0.000000000000000_REALK,      0.221308739222073_REALK,      0.000000000000000_REALK, &
     -0.350105706158558_REALK,      0.000000000000000_REALK,     -0.891539910575549_REALK, &
     -0.542293873781644_REALK,     -0.708054939673849_REALK,      0.000000000000000_REALK, &
     -0.924369469328383_REALK,      0.000000000000000_REALK,     -1.702987610758672_REALK, &
     -1.330335677901808_REALK,      0.000000000000000_REALK,     -1.974757708006007_REALK, &
      0.000000000000000_REALK,     -2.265610892169226_REALK,      0.000000000000000_REALK, &
     -2.872336469718821_REALK,      0.000000000000000_REALK,     -4.054897491223031_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.533508652821721_REALK, &
      0.000000000000000_REALK,      0.524637183992428_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.335180692928381_REALK,      0.000000000000000_REALK, &
      1.005685046410418_REALK,      0.000000000000000_REALK,      0.257098938764011_REALK, &
      0.000000000000000_REALK,      0.432443115947536_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.146436702229730_REALK, &
      0.000000000000000_REALK,      0.737252643701618_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.501846554575832_REALK,      0.000000000000000_REALK, &
      1.186646388309374_REALK,      0.000000000000000_REALK,      0.531886895864797_REALK, &
      0.000000000000000_REALK,      0.517434960357430_REALK,      0.000000000000000_REALK, &
     -0.616032924449305_REALK,     -0.242865815314105_REALK,      0.000000000000000_REALK, &
     -0.150738461756876_REALK,      0.000000000000000_REALK,     -0.560427207236329_REALK, &
     -0.110056074845474_REALK,      0.000000000000000_REALK,     -0.258390212225911_REALK, &
      0.000000000000000_REALK,     -0.102176910901057_REALK,      0.000000000000000_REALK, &
     -0.201570932945217_REALK,      0.000000000000000_REALK,     -0.753040922127019_REALK, &
     -1.702928026757127_REALK,     -0.543811792797637_REALK,      0.000000000000000_REALK, &
     -0.212974997787147_REALK,      0.000000000000000_REALK,     -0.993542842631077_REALK, &
      0.005880702567977_REALK,      0.000000000000000_REALK,     -0.398041161493979_REALK, &
      0.000000000000000_REALK,      0.302390737883263_REALK,      0.000000000000000_REALK, &
     -0.197899264386045_REALK,      0.000000000000000_REALK,     -1.078610198155918_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.251069374574856_REALK, &
      0.000000000000000_REALK,      0.130077558399008_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.098427746063868_REALK,      0.000000000000000_REALK, &
      0.409013313719681_REALK,      0.000000000000000_REALK,      0.095759130913825_REALK, &
      0.000000000000000_REALK,      0.266342356898043_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.040092839605421_REALK, &
      0.000000000000000_REALK,      0.557542616026939_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.458538107434805_REALK,      0.000000000000000_REALK, &
      1.071761028737191_REALK,      0.000000000000000_REALK,      0.538750815857048_REALK, &
      0.000000000000000_REALK,      0.729356935472013_REALK,      0.000000000000000_REALK, &
      0.113128417871391_REALK,      0.065628191360019_REALK,      0.000000000000000_REALK, &
      0.050010707513670_REALK,      0.000000000000000_REALK,     -0.201681794417699_REALK, &
      0.045070712132536_REALK,      0.000000000000000_REALK,     -0.136829519215103_REALK, &
      0.000000000000000_REALK,      0.049034588559785_REALK,      0.000000000000000_REALK, &
     -0.131052865644719_REALK,      0.000000000000000_REALK,     -0.538679901050948_REALK, &
     -0.777529725526130_REALK,     -0.352806184335973_REALK,      0.000000000000000_REALK, &
     -0.168202697118591_REALK,      0.000000000000000_REALK,     -1.047191691004608_REALK, &
     -0.021699288992005_REALK,      0.000000000000000_REALK,     -0.596121016279044_REALK, &
      0.000000000000000_REALK,      0.194919708464346_REALK,      0.000000000000000_REALK, &
     -0.360800718027399_REALK,      0.000000000000000_REALK,     -1.721231545656172_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.060915256890369_REALK, &
      0.000000000000000_REALK,     -0.048896839601977_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.050834013117433_REALK,      0.000000000000000_REALK, &
      0.311111770657674_REALK,      0.000000000000000_REALK,     -0.067408218904800_REALK, &
      0.000000000000000_REALK,      0.313881204363573_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.973537469327171_REALK, &
      0.000000000000000_REALK,      1.676909707240005_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.809996456267317_REALK,      0.000000000000000_REALK, &
      3.401507290981540_REALK,      0.000000000000000_REALK,      2.423212704780039_REALK, &
      0.000000000000000_REALK,      3.669204373878608_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.336429462396944_REALK, &
      0.000000000000000_REALK,      0.574877275227260_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.324154381607723_REALK,      0.000000000000000_REALK, &
      1.277430386883101_REALK,      0.000000000000000_REALK,      0.189167317641356_REALK, &
      0.000000000000000_REALK,      0.382035390531311_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.345454166748324_REALK, &
      0.000000000000000_REALK,      0.630402219409815_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.254243614913926_REALK,      0.000000000000000_REALK, &
      1.567097029270236_REALK,      0.000000000000000_REALK,     -0.062185281761675_REALK, &
      0.000000000000000_REALK,      0.430159674948421_REALK,      0.000000000000000_REALK, &
     -0.940098317780370_REALK,     -0.278307681297305_REALK,      0.000000000000000_REALK, &
     -0.149497004086526_REALK,      0.000000000000000_REALK,     -0.727695006426859_REALK, &
     -0.090465097943589_REALK,      0.000000000000000_REALK,     -0.246855989343754_REALK, &
      0.000000000000000_REALK,     -0.073919040333621_REALK,      0.000000000000000_REALK, &
     -0.161173950728513_REALK,      0.000000000000000_REALK,     -0.788328625020747_REALK, &
     -1.208842291376043_REALK,     -0.558338579477225_REALK,      0.000000000000000_REALK, &
     -0.399403653422515_REALK,      0.000000000000000_REALK,     -1.250369972785174_REALK, &
     -0.383468854629825_REALK,      0.000000000000000_REALK,     -0.493904179917423_REALK, &
      0.000000000000000_REALK,     -0.558813453049409_REALK,      0.000000000000000_REALK, &
     -0.360827909853524_REALK,      0.000000000000000_REALK,     -1.319741856340611_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.322623190768360_REALK, &
      0.000000000000000_REALK,      0.125066155519955_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.076969546185738_REALK,      0.000000000000000_REALK, &
      0.438175502223094_REALK,      0.000000000000000_REALK,      0.057430172805139_REALK, &
      0.000000000000000_REALK,      0.206460130435430_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.861989640092205_REALK, &
      0.000000000000000_REALK,      0.362913580003975_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.163451584080561_REALK,      0.000000000000000_REALK, &
      1.073479120314766_REALK,      0.000000000000000_REALK,     -0.004843870664079_REALK, &
      0.000000000000000_REALK,      0.461570240445411_REALK,      0.000000000000000_REALK, &
      0.139693064843583_REALK,      0.062627137466494_REALK,      0.000000000000000_REALK, &
      0.039844198545230_REALK,      0.000000000000000_REALK,     -0.211899855885980_REALK, &
      0.030581235694615_REALK,      0.000000000000000_REALK,     -0.108858095937249_REALK, &
      0.000000000000000_REALK,      0.029614084937581_REALK,      0.000000000000000_REALK, &
     -0.084179657412061_REALK,      0.000000000000000_REALK,     -0.456302944819821_REALK, &
     -0.445409037285772_REALK,     -0.321066301794569_REALK,      0.000000000000000_REALK, &
     -0.277492902041906_REALK,      0.000000000000000_REALK,     -1.063522776273083_REALK, &
     -0.295348047965477_REALK,      0.000000000000000_REALK,     -0.655629777550672_REALK, &
      0.000000000000000_REALK,     -0.405970907463121_REALK,      0.000000000000000_REALK, &
     -0.578707150591336_REALK,      0.000000000000000_REALK,     -1.699544093296117_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.054770729056022_REALK, &
      0.000000000000000_REALK,     -0.031242731490539_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.023607119361946_REALK,      0.000000000000000_REALK, &
      0.233210280497175_REALK,      0.000000000000000_REALK,     -0.021742309518180_REALK, &
      0.000000000000000_REALK,      0.161693310232602_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.787147360581380_REALK, &
      0.000000000000000_REALK,      0.470894997318775_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.258182472719838_REALK,      0.000000000000000_REALK, &
      1.639637242048279_REALK,      0.000000000000000_REALK,      0.035747207152077_REALK, &
      0.000000000000000_REALK,      1.001748803563975_REALK,      0.000000000000000_REALK, &
      0.667360380894940_REALK,      0.463547464840306_REALK,      0.000000000000000_REALK, &
      0.405186705445329_REALK,      0.000000000000000_REALK,      0.027392523341732_REALK, &
      0.423878043872444_REALK,      0.000000000000000_REALK,      0.021802594964888_REALK, &
      0.000000000000000_REALK,      0.541123781219043_REALK,      0.000000000000000_REALK, &
      0.023163973008809_REALK,      0.000000000000000_REALK,     -0.467717493672433_REALK, &
     -0.355035701740843_REALK,     -0.405663626455798_REALK,      0.000000000000000_REALK, &
     -0.460144146880013_REALK,      0.000000000000000_REALK,     -3.087758390550226_REALK, &
     -0.558055553170390_REALK,      0.000000000000000_REALK,     -3.017265494364197_REALK, &
      0.000000000000000_REALK,     -0.756921573209073_REALK,      0.000000000000000_REALK, &
     -3.495299418293248_REALK,      0.000000000000000_REALK,     -7.108083338337405_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.132693468758014_REALK, &
      0.000000000000000_REALK,      3.584830983432684_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.158681970140813_REALK,      0.000000000000000_REALK, &
      0.357745918530662_REALK,      0.000000000000000_REALK,     20.219711658669681_REALK, &
      0.000000000000000_REALK,     23.969485150713901_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.402275022502852_REALK, &
      0.000000000000000_REALK,      6.175905943022033_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.033846892893998_REALK,      0.000000000000000_REALK, &
     -0.055972933169773_REALK,      0.000000000000000_REALK,     48.311465758301644_REALK, &
      0.000000000000000_REALK,     48.085412596923334_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.923594943341201_REALK, &
      0.000000000000000_REALK,      1.298807174634074_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.597830029948230_REALK,      0.000000000000000_REALK, &
      2.340973045573601_REALK,      0.000000000000000_REALK,      4.349727235919725_REALK, &
      0.000000000000000_REALK,      8.101359407380491_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.590787090508233_REALK, &
      0.000000000000000_REALK,      1.090253479607757_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.377528508476903_REALK,      0.000000000000000_REALK, &
      2.505097923416021_REALK,      0.000000000000000_REALK,     -0.237095955327955_REALK, &
      0.000000000000000_REALK,      8.110073439771305_REALK,      0.000000000000000_REALK, &
      0.078978829984470_REALK,      0.018188959496873_REALK,      0.000000000000000_REALK, &
      0.075905602902409_REALK,      0.000000000000000_REALK,     -1.532545828330312_REALK, &
      0.038890092387461_REALK,      0.000000000000000_REALK,     -0.412871832545366_REALK, &
      0.000000000000000_REALK,      0.503387899967351_REALK,      0.000000000000000_REALK, &
     -4.240134052039567_REALK,      0.000000000000000_REALK,    -19.759076655825908_REALK, &
     -0.757632536432773_REALK,     -0.250096898043203_REALK,      0.000000000000000_REALK, &
     -1.570550075803511_REALK,      0.000000000000000_REALK,     -4.343734732533078_REALK, &
     -1.065464250809103_REALK,      0.000000000000000_REALK,     -1.773594216065581_REALK, &
      0.000000000000000_REALK,    -14.865318651818868_REALK,      0.000000000000000_REALK, &
    -19.538955423798228_REALK,      0.000000000000000_REALK,    -53.031485161532672_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.465975134292155_REALK, &
      0.000000000000000_REALK,      0.581641658770123_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.590670647386577_REALK,      0.000000000000000_REALK, &
      3.165529144299986_REALK,      0.000000000000000_REALK,      1.422736009480562_REALK, &
      0.000000000000000_REALK,      3.115292211168612_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.549057961517493_REALK, &
      0.000000000000000_REALK,      0.664145997794044_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.746846453141824_REALK,      0.000000000000000_REALK, &
      3.634332179092795_REALK,      0.000000000000000_REALK,      2.840847893633429_REALK, &
      0.000000000000000_REALK,      3.918974825218998_REALK,      0.000000000000000_REALK, &
      0.059956713599141_REALK,      0.014992411247610_REALK,      0.000000000000000_REALK, &
      0.029357268772463_REALK,      0.000000000000000_REALK,     -1.029501225448107_REALK, &
      0.017381823007251_REALK,      0.000000000000000_REALK,     -0.289923708586022_REALK, &
      0.000000000000000_REALK,      0.094884610140352_REALK,      0.000000000000000_REALK, &
     -1.408158257493027_REALK,      0.000000000000000_REALK,    -11.397513312149661_REALK, &
     -0.753069715012703_REALK,     -0.175936519765761_REALK,      0.000000000000000_REALK, &
     -0.203367447550938_REALK,      0.000000000000000_REALK,     -2.256880899559044_REALK, &
      0.012067361041170_REALK,      0.000000000000000_REALK,     -0.690343430914188_REALK, &
      0.000000000000000_REALK,      1.137391213320953_REALK,      0.000000000000000_REALK, &
     -2.006977945625432_REALK,      0.000000000000000_REALK,    -21.857009632015391_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.282087253343063_REALK, &
      0.000000000000000_REALK,     -0.323293044908217_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.270181787619619_REALK,      0.000000000000000_REALK, &
      0.364566509868129_REALK,      0.000000000000000_REALK,     -1.460682744648533_REALK, &
      0.000000000000000_REALK,      1.036366205037973_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.745894230719654_REALK, &
      0.000000000000000_REALK,      1.016649816330648_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.058217502713948_REALK,      0.000000000000000_REALK, &
      4.577388305910307_REALK,      0.000000000000000_REALK,      6.027221714482259_REALK, &
      0.000000000000000_REALK,     15.691478163475878_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.059984835878490_REALK, &
      0.000000000000000_REALK,      0.189502135658482_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.592710640503822_REALK,      0.000000000000000_REALK, &
      3.875143285845092_REALK,      0.000000000000000_REALK,      0.236401684359723_REALK, &
      0.000000000000000_REALK,      0.813410921478570_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.758824275342505_REALK, &
      0.000000000000000_REALK,      0.111728328396168_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.451807227637836_REALK,      0.000000000000000_REALK, &
      4.464458858028022_REALK,      0.000000000000000_REALK,     -0.709292585867876_REALK, &
      0.000000000000000_REALK,      0.528860809051986_REALK,      0.000000000000000_REALK, &
      0.063875610098980_REALK,      0.010740748558950_REALK,      0.000000000000000_REALK, &
      0.019235786953542_REALK,      0.000000000000000_REALK,     -0.923216201682020_REALK, &
      0.009227495164230_REALK,      0.000000000000000_REALK,     -0.180946765476802_REALK, &
      0.000000000000000_REALK,      0.043362260937822_REALK,      0.000000000000000_REALK, &
     -0.739432238195170_REALK,      0.000000000000000_REALK,     -8.191044081557095_REALK, &
     -0.439604633748637_REALK,     -0.131727643237156_REALK,      0.000000000000000_REALK, &
     -0.252121456545373_REALK,      0.000000000000000_REALK,     -2.051896036332755_REALK, &
     -0.242381128547774_REALK,      0.000000000000000_REALK,     -0.559210792256518_REALK, &
      0.000000000000000_REALK,     -1.272633944958537_REALK,      0.000000000000000_REALK, &
     -1.995906257657135_REALK,      0.000000000000000_REALK,    -15.940671983670136_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.303144084413391_REALK, &
      0.000000000000000_REALK,     -0.150553717751220_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.145631107812006_REALK,      0.000000000000000_REALK, &
      0.341307974783717_REALK,      0.000000000000000_REALK,     -0.346969658995177_REALK, &
      0.000000000000000_REALK,      0.386777294266125_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.476329457312645_REALK, &
      0.000000000000000_REALK,      0.247987116230833_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.182212790591672_REALK,      0.000000000000000_REALK, &
      3.162549782435489_REALK,      0.000000000000000_REALK,     -0.034316782375879_REALK, &
      0.000000000000000_REALK,      3.070370315905904_REALK,      0.000000000000000_REALK, &
      1.027129525370058_REALK,      0.498894482670196_REALK,      0.000000000000000_REALK, &
      0.735281998314372_REALK,      0.000000000000000_REALK,      0.900186123378093_REALK, &
      0.791678216813237_REALK,      0.000000000000000_REALK,      0.509640249665154_REALK, &
      0.000000000000000_REALK,      3.355564115197744_REALK,      0.000000000000000_REALK, &
      1.713882722142829_REALK,      0.000000000000000_REALK,      0.857472812237523_REALK, &
      0.294883186783905_REALK,      0.280907230747920_REALK,      0.000000000000000_REALK, &
      0.497658693330055_REALK,      0.000000000000000_REALK,     -1.736085997407423_REALK, &
      0.716384465150591_REALK,      0.000000000000000_REALK,     -1.504144890610428_REALK, &
      0.000000000000000_REALK,      2.997331710139925_REALK,      0.000000000000000_REALK, &
     -4.969240993168774_REALK,      0.000000000000000_REALK,    -28.463280841556106_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.088660004685890_REALK, &
      0.000000000000000_REALK,     -0.181892408151881_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.729128091972643_REALK,      0.000000000000000_REALK, &
      4.934680971291352_REALK,      0.000000000000000_REALK,     -0.362589098680325_REALK, &
      0.000000000000000_REALK,     -0.594074898583741_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.335147403922479_REALK, &
      0.000000000000000_REALK,     -0.273905185494776_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.971227364052618_REALK,      0.000000000000000_REALK, &
      6.768730135743514_REALK,      0.000000000000000_REALK,      0.013734069542765_REALK, &
      0.000000000000000_REALK,     -0.834138782176567_REALK,      0.000000000000000_REALK, &
      0.087054139245047_REALK,      0.004879586086510_REALK,      0.000000000000000_REALK, &
      0.017534386478523_REALK,      0.000000000000000_REALK,     -1.026663562370870_REALK, &
      0.002265752812787_REALK,      0.000000000000000_REALK,     -0.069817532023281_REALK, &
      0.000000000000000_REALK,      0.024594688752145_REALK,      0.000000000000000_REALK, &
     -0.512872882362184_REALK,      0.000000000000000_REALK,     -6.930981403930991_REALK, &
     -1.493499062246381_REALK,     -0.047403747313285_REALK,      0.000000000000000_REALK, &
     -0.171130889508063_REALK,      0.000000000000000_REALK,     -2.828110063585727_REALK, &
      0.099265889857380_REALK,      0.000000000000000_REALK,     -0.123785066239086_REALK, &
      0.000000000000000_REALK,      0.286819658713102_REALK,      0.000000000000000_REALK, &
     -0.871602998341994_REALK,      0.000000000000000_REALK,    -14.135382191102257_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.379066562774008_REALK, &
      0.000000000000000_REALK,     -0.085357533936483_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.113006526685210_REALK,      0.000000000000000_REALK, &
      0.362474992481872_REALK,      0.000000000000000_REALK,     -0.127319235886694_REALK, &
      0.000000000000000_REALK,      0.166856098753176_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.926382117266584_REALK, &
      0.000000000000000_REALK,      0.225390815569123_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.297235170864245_REALK,      0.000000000000000_REALK, &
      3.783354616005648_REALK,      0.000000000000000_REALK,      0.497564952394053_REALK, &
      0.000000000000000_REALK,      1.795385985667181_REALK,      0.000000000000000_REALK, &
      1.070552066208516_REALK,      0.323961688478705_REALK,      0.000000000000000_REALK, &
      0.360027187571252_REALK,      0.000000000000000_REALK,      0.765570625085166_REALK, &
      0.277898853091779_REALK,      0.000000000000000_REALK,      0.281069620160446_REALK, &
      0.000000000000000_REALK,      0.709575760403626_REALK,      0.000000000000000_REALK, &
      0.638547493275773_REALK,      0.000000000000000_REALK,      0.554886355014703_REALK, &
      0.563466515912427_REALK,      0.146573906038519_REALK,      0.000000000000000_REALK, &
      0.096146230703080_REALK,      0.000000000000000_REALK,     -1.345821921458940_REALK, &
     -0.006690511944106_REALK,      0.000000000000000_REALK,     -0.482770108725486_REALK, &
      0.000000000000000_REALK,     -0.277517158107798_REALK,      0.000000000000000_REALK, &
     -0.617661743068077_REALK,      0.000000000000000_REALK,    -14.195846582609352_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.281920180405411_REALK, &
      0.000000000000000_REALK,     -0.833818190775742_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.908453822937092_REALK,      0.000000000000000_REALK, &
     -1.825106567481783_REALK,      0.000000000000000_REALK,     -2.297281671370239_REALK, &
      0.000000000000000_REALK,     -2.426812719699206_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.763057983357706_REALK, &
      0.000000000000000_REALK,     -0.590203579848378_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.720446294598430_REALK,      0.000000000000000_REALK, &
      4.695268817742625_REALK,      0.000000000000000_REALK,     -1.805829593738421_REALK, &
      0.000000000000000_REALK,      7.083362855303776_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.237467535483344_REALK, &
      0.000000000000000_REALK,     -0.801649449929328_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.106010393281043_REALK,      0.000000000000000_REALK, &
      6.879098752257319_REALK,      0.000000000000000_REALK,     -0.960027492534135_REALK, &
      0.000000000000000_REALK,     -1.917454150601781_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.458803266813282_REALK, &
      0.000000000000000_REALK,     -1.389810631829366_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.495259115705923_REALK,      0.000000000000000_REALK, &
     10.927828751619861_REALK,      0.000000000000000_REALK,     -1.878806379657605_REALK, &
      0.000000000000000_REALK,     -3.300800177046551_REALK,      0.000000000000000_REALK, &
      0.145892171336604_REALK,     -0.006172018622799_REALK,      0.000000000000000_REALK, &
      0.022883070625875_REALK,      0.000000000000000_REALK,     -1.386954081287734_REALK, &
     -0.004947786690482_REALK,      0.000000000000000_REALK,      0.072598886574687_REALK, &
      0.000000000000000_REALK,      0.024604042189665_REALK,      0.000000000000000_REALK, &
     -0.490170671589076_REALK,      0.000000000000000_REALK,     -6.857132277399389_REALK, &
     -1.364860231575907_REALK,      0.100259029817209_REALK,      0.000000000000000_REALK, &
     -0.361639977117937_REALK,      0.000000000000000_REALK,     -4.215168799931526_REALK, &
     -0.002792969869753_REALK,      0.000000000000000_REALK,      0.283698846883809_REALK, &
      0.000000000000000_REALK,     -0.706884070563336_REALK,      0.000000000000000_REALK, &
     -1.436455861664623_REALK,      0.000000000000000_REALK,    -16.430537241980119_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.555499903635982_REALK, &
      0.000000000000000_REALK,     -0.034939617567891_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.111596133137327_REALK,      0.000000000000000_REALK, &
      0.436684506944051_REALK,      0.000000000000000_REALK,     -0.024288416608846_REALK, &
      0.000000000000000_REALK,      0.050018680672318_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.101551960571672_REALK, &
      0.000000000000000_REALK,      0.049046634660839_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.188612799499428_REALK,      0.000000000000000_REALK, &
      4.874952277780953_REALK,      0.000000000000000_REALK,     -0.156227273359579_REALK, &
      0.000000000000000_REALK,      0.304688718609706_REALK,      0.000000000000000_REALK, &
      1.496272364461859_REALK,      0.242040370073067_REALK,      0.000000000000000_REALK, &
      0.296378906001184_REALK,      0.000000000000000_REALK,      0.862540495515156_REALK, &
      0.145185599641110_REALK,      0.000000000000000_REALK,      0.172635173249220_REALK, &
      0.000000000000000_REALK,      0.372300697115341_REALK,      0.000000000000000_REALK, &
      0.384963058846172_REALK,      0.000000000000000_REALK,      0.457838318164170_REALK, &
      0.406305446070380_REALK,      0.114931117219571_REALK,      0.000000000000000_REALK, &
      0.154182076270126_REALK,      0.000000000000000_REALK,     -1.582732669437936_REALK, &
      0.140959697865010_REALK,      0.000000000000000_REALK,     -0.410203945443610_REALK, &
      0.000000000000000_REALK,      0.390492867474793_REALK,      0.000000000000000_REALK, &
     -0.772463334431668_REALK,      0.000000000000000_REALK,    -13.019874885186658_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.436672276258753_REALK, &
      0.000000000000000_REALK,     -0.487847598658603_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.481891454060291_REALK,      0.000000000000000_REALK, &
     -1.681536034212734_REALK,      0.000000000000000_REALK,     -0.626511122012382_REALK, &
      0.000000000000000_REALK,     -1.039831400568066_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.510326093057702_REALK, &
      0.000000000000000_REALK,     -0.186222789757337_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.130123172788800_REALK,      0.000000000000000_REALK, &
      3.402743317966672_REALK,      0.000000000000000_REALK,      0.012929918608681_REALK, &
      0.000000000000000_REALK,      1.742994528171246_REALK,      0.000000000000000_REALK, &
      2.268182460535027_REALK,      1.059837154323183_REALK,      0.000000000000000_REALK, &
      1.067993099170236_REALK,      0.000000000000000_REALK,      2.589491777675328_REALK, &
      1.174263583418428_REALK,      0.000000000000000_REALK,      1.497091437261680_REALK, &
      0.000000000000000_REALK,      2.715968027527601_REALK,      0.000000000000000_REALK, &
      2.747311611806583_REALK,      0.000000000000000_REALK,      7.784590053924211_REALK, &
      2.955215024183071_REALK,      2.657494152809714_REALK,      0.000000000000000_REALK, &
      3.299927283116253_REALK,      0.000000000000000_REALK,      1.287398292988953_REALK, &
      4.517425605765691_REALK,      0.000000000000000_REALK,      1.060726556753034_REALK, &
      0.000000000000000_REALK,      9.972248764268192_REALK,      0.000000000000000_REALK, &
      1.848916398576202_REALK,      0.000000000000000_REALK,    -21.653616707788935_REALK/
    ! results of test 7, ket-major order, 03ODGYZZ
  data REF_CONTR_INTS(75601:76860)                                                         &
     /0.000000000000000_REALK,      0.000000000000000_REALK,      0.735174719925525_REALK, &
      0.000000000000000_REALK,      0.442265848900776_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.314562333600596_REALK,      0.000000000000000_REALK, &
      0.777249814316696_REALK,      0.000000000000000_REALK,      0.142527048079134_REALK, &
      0.000000000000000_REALK,      0.662557374063761_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.223518922183453_REALK, &
      0.000000000000000_REALK,     -0.251264403564900_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.030423156647625_REALK,      0.000000000000000_REALK, &
      0.274860339528017_REALK,      0.000000000000000_REALK,     -3.184686279300026_REALK, &
      0.000000000000000_REALK,     -0.379304919833632_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.751443979096174_REALK, &
      0.000000000000000_REALK,      0.407403725810624_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.339945105203048_REALK,      0.000000000000000_REALK, &
      0.684767785080360_REALK,      0.000000000000000_REALK,      0.393494024505087_REALK, &
      0.000000000000000_REALK,      0.502469615118262_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.834829155260513_REALK, &
      0.000000000000000_REALK,      0.554097900050524_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.665969321500878_REALK,      0.000000000000000_REALK, &
      0.685874377732029_REALK,      0.000000000000000_REALK,      1.267674850693780_REALK, &
      0.000000000000000_REALK,      0.621618081741230_REALK,      0.000000000000000_REALK, &
     -0.275791070655502_REALK,     -0.142246243348167_REALK,      0.000000000000000_REALK, &
     -0.084719806880644_REALK,      0.000000000000000_REALK,     -0.339603981408978_REALK, &
     -0.027884400765115_REALK,      0.000000000000000_REALK,     -0.210291357477464_REALK, &
      0.000000000000000_REALK,      0.089193137649224_REALK,      0.000000000000000_REALK, &
     -0.169513258548456_REALK,      0.000000000000000_REALK,     -0.682789805431246_REALK, &
     -0.240709293257103_REALK,      0.179255902905224_REALK,      0.000000000000000_REALK, &
      0.552432716448897_REALK,      0.000000000000000_REALK,     -0.195097626972150_REALK, &
      1.236512805348380_REALK,      0.000000000000000_REALK,      0.194982917765419_REALK, &
      0.000000000000000_REALK,      3.020231783628764_REALK,      0.000000000000000_REALK, &
      0.820526577797203_REALK,      0.000000000000000_REALK,     -0.338553739235079_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.834176048484690_REALK, &
      0.000000000000000_REALK,      0.344065354292598_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.236782972532863_REALK,      0.000000000000000_REALK, &
      0.650408031699013_REALK,      0.000000000000000_REALK,      0.197738933930268_REALK, &
      0.000000000000000_REALK,      0.348494957548052_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.598521762674634_REALK, &
      0.000000000000000_REALK,      0.203072208985473_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.014984411714571_REALK,      0.000000000000000_REALK, &
      0.546174976996071_REALK,      0.000000000000000_REALK,     -0.376973970210280_REALK, &
      0.000000000000000_REALK,      0.206464412457524_REALK,      0.000000000000000_REALK, &
     -0.322178921791201_REALK,     -0.150721740020440_REALK,      0.000000000000000_REALK, &
     -0.105503062650971_REALK,      0.000000000000000_REALK,     -0.344773202183985_REALK, &
     -0.092030634440389_REALK,      0.000000000000000_REALK,     -0.190650516416610_REALK, &
      0.000000000000000_REALK,     -0.113098814993225_REALK,      0.000000000000000_REALK, &
     -0.173362247693442_REALK,      0.000000000000000_REALK,     -0.569270271228805_REALK, &
     -0.364980691037124_REALK,     -0.309047846087969_REALK,      0.000000000000000_REALK, &
     -0.364134070219660_REALK,      0.000000000000000_REALK,     -0.496509770392998_REALK, &
     -0.575124421670343_REALK,      0.000000000000000_REALK,     -0.373382278488915_REALK, &
      0.000000000000000_REALK,     -1.195905341053786_REALK,      0.000000000000000_REALK, &
     -0.490153552801911_REALK,      0.000000000000000_REALK,     -0.780838114200365_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.136343337986596_REALK, &
      0.000000000000000_REALK,      0.070825222173012_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.043023743235877_REALK,      0.000000000000000_REALK, &
      0.264076675733929_REALK,      0.000000000000000_REALK,      0.015431825336793_REALK, &
      0.000000000000000_REALK,      0.178201535954809_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.124659491853733_REALK, &
      0.000000000000000_REALK,     -0.122134344409739_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.426462389928745_REALK,      0.000000000000000_REALK, &
      0.212031225631112_REALK,      0.000000000000000_REALK,     -1.042583141517787_REALK, &
      0.000000000000000_REALK,     -0.231448907901647_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.102664599224762_REALK, &
      0.000000000000000_REALK,      0.342658918798019_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.211888765978994_REALK,      0.000000000000000_REALK, &
      0.723134686332545_REALK,      0.000000000000000_REALK,      0.153450847595619_REALK, &
      0.000000000000000_REALK,      0.282443744121590_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.520299003246433_REALK, &
      0.000000000000000_REALK,      0.512708900892108_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.403605901730662_REALK,      0.000000000000000_REALK, &
      0.840489411813848_REALK,      0.000000000000000_REALK,      0.534969499913051_REALK, &
      0.000000000000000_REALK,      0.359840703284584_REALK,      0.000000000000000_REALK, &
     -0.425477490288985_REALK,     -0.150716306958946_REALK,      0.000000000000000_REALK, &
     -0.086860543289701_REALK,      0.000000000000000_REALK,     -0.387072106312722_REALK, &
     -0.056083059229370_REALK,      0.000000000000000_REALK,     -0.160350350215656_REALK, &
      0.000000000000000_REALK,     -0.043289095598039_REALK,      0.000000000000000_REALK, &
     -0.116151913340291_REALK,      0.000000000000000_REALK,     -0.520105255604522_REALK, &
     -1.060388293911809_REALK,     -0.237102331006244_REALK,      0.000000000000000_REALK, &
      0.012819969773453_REALK,      0.000000000000000_REALK,     -0.618664549101412_REALK, &
      0.239334451462656_REALK,      0.000000000000000_REALK,     -0.173546231392181_REALK, &
      0.000000000000000_REALK,      0.642160526418029_REALK,      0.000000000000000_REALK, &
      0.011912490264014_REALK,      0.000000000000000_REALK,     -0.671634743129137_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.163893997949280_REALK, &
      0.000000000000000_REALK,      0.075896247782663_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.053358582355097_REALK,      0.000000000000000_REALK, &
      0.266997228608682_REALK,      0.000000000000000_REALK,      0.048991254703177_REALK, &
      0.000000000000000_REALK,      0.155402559541789_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.664121099222807_REALK, &
      0.000000000000000_REALK,      0.365961293462028_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.356500512297184_REALK,      0.000000000000000_REALK, &
      0.684341902381653_REALK,      0.000000000000000_REALK,      0.523791949732806_REALK, &
      0.000000000000000_REALK,      0.478737229815527_REALK,      0.000000000000000_REALK, &
      0.063117073722626_REALK,      0.028157967696362_REALK,      0.000000000000000_REALK, &
      0.014324330293146_REALK,      0.000000000000000_REALK,     -0.112523138980384_REALK, &
      0.003972380731942_REALK,      0.000000000000000_REALK,     -0.058707105926962_REALK, &
      0.000000000000000_REALK,     -0.010078732593648_REALK,      0.000000000000000_REALK, &
     -0.037536852140017_REALK,      0.000000000000000_REALK,     -0.300542513254117_REALK, &
     -0.167936728682310_REALK,      0.108432256238436_REALK,      0.000000000000000_REALK, &
      0.277436373357132_REALK,      0.000000000000000_REALK,     -0.226180351846497_REALK, &
      0.503315043935606_REALK,      0.000000000000000_REALK,      0.183213190857027_REALK, &
      0.000000000000000_REALK,      0.948913394243844_REALK,      0.000000000000000_REALK, &
      0.595110806359994_REALK,      0.000000000000000_REALK,     -0.371764558437553_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.726884864887036_REALK, &
      0.000000000000000_REALK,      0.383485564436559_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.213081751199167_REALK,      0.000000000000000_REALK, &
      0.944165118852810_REALK,      0.000000000000000_REALK,      0.113549720049415_REALK, &
      0.000000000000000_REALK,      0.254845796982886_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.674254517721772_REALK, &
      0.000000000000000_REALK,      0.359744734205120_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.064586000964325_REALK,      0.000000000000000_REALK, &
      1.118640184131807_REALK,      0.000000000000000_REALK,     -0.252028691891101_REALK, &
      0.000000000000000_REALK,      0.245474513200407_REALK,      0.000000000000000_REALK, &
     -0.675974754299399_REALK,     -0.181772493594153_REALK,      0.000000000000000_REALK, &
     -0.094506444976587_REALK,      0.000000000000000_REALK,     -0.523246817775091_REALK, &
     -0.053994567321052_REALK,      0.000000000000000_REALK,     -0.161230292072792_REALK, &
      0.000000000000000_REALK,     -0.043866903328125_REALK,      0.000000000000000_REALK, &
     -0.101888176283235_REALK,      0.000000000000000_REALK,     -0.566845231532558_REALK, &
     -0.856210541290138_REALK,     -0.388286378970635_REALK,      0.000000000000000_REALK, &
     -0.321217053747365_REALK,      0.000000000000000_REALK,     -0.885624170207240_REALK, &
     -0.385691286979356_REALK,      0.000000000000000_REALK,     -0.343476651314617_REALK, &
      0.000000000000000_REALK,     -0.666744085139853_REALK,      0.000000000000000_REALK, &
     -0.290192834040899_REALK,      0.000000000000000_REALK,     -0.934759560649036_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.222827222489538_REALK, &
      0.000000000000000_REALK,      0.077612854082169_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.044352426849347_REALK,      0.000000000000000_REALK, &
      0.302636118286466_REALK,      0.000000000000000_REALK,      0.029265624705459_REALK, &
      0.000000000000000_REALK,      0.128123871007725_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.536748300260014_REALK, &
      0.000000000000000_REALK,      0.158230580712662_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.009838921888052_REALK,      0.000000000000000_REALK, &
      0.668439696249634_REALK,      0.000000000000000_REALK,     -0.197137181304902_REALK, &
      0.000000000000000_REALK,      0.201244955299166_REALK,      0.000000000000000_REALK, &
      0.091189357211613_REALK,      0.036541005240087_REALK,      0.000000000000000_REALK, &
      0.021599904848669_REALK,      0.000000000000000_REALK,     -0.138324774197719_REALK, &
      0.015645642277195_REALK,      0.000000000000000_REALK,     -0.063515345183981_REALK, &
      0.000000000000000_REALK,      0.015192097030413_REALK,      0.000000000000000_REALK, &
     -0.045634563040087_REALK,      0.000000000000000_REALK,     -0.297867129470437_REALK, &
     -0.284403014982989_REALK,     -0.210742346350316_REALK,      0.000000000000000_REALK, &
     -0.215742945096089_REALK,      0.000000000000000_REALK,     -0.679081605344887_REALK, &
     -0.287147462872081_REALK,      0.000000000000000_REALK,     -0.430344003359687_REALK, &
      0.000000000000000_REALK,     -0.475542507071981_REALK,      0.000000000000000_REALK, &
     -0.449928571498690_REALK,      0.000000000000000_REALK,     -1.085194559983358_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.030557911166061_REALK, &
      0.000000000000000_REALK,     -0.013404785440920_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.006761675485551_REALK,      0.000000000000000_REALK, &
      0.130113642035977_REALK,      0.000000000000000_REALK,     -0.001916293914859_REALK, &
      0.000000000000000_REALK,      0.069374988277082_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.170014017968898_REALK, &
      0.000000000000000_REALK,     -0.144725940977392_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.425850537017646_REALK,      0.000000000000000_REALK, &
      0.354141205944182_REALK,      0.000000000000000_REALK,     -0.829156528813115_REALK, &
      0.000000000000000_REALK,     -0.307879758851268_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.727487435732162_REALK, &
      0.000000000000000_REALK,      0.535867521630995_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.284313015870595_REALK,      0.000000000000000_REALK, &
      1.560319194737519_REALK,      0.000000000000000_REALK,      0.110447928227471_REALK, &
      0.000000000000000_REALK,      0.269425540408499_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     11.377741083273055_REALK, &
      0.000000000000000_REALK,      1.693631247227498_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.993872955461610_REALK,      0.000000000000000_REALK, &
      3.750658490390826_REALK,      0.000000000000000_REALK,      0.844528539258812_REALK, &
      0.000000000000000_REALK,      0.643102684533551_REALK,      0.000000000000000_REALK, &
     -1.580318240377797_REALK,     -0.288322546659842_REALK,      0.000000000000000_REALK, &
     -0.129752268990622_REALK,      0.000000000000000_REALK,     -0.932718439511255_REALK, &
     -0.053775500429779_REALK,      0.000000000000000_REALK,     -0.195798687034866_REALK, &
      0.000000000000000_REALK,     -0.032822719810000_REALK,      0.000000000000000_REALK, &
     -0.105835214687763_REALK,      0.000000000000000_REALK,     -0.764471565394782_REALK, &
     -8.745539027891844_REALK,     -1.201406191980441_REALK,      0.000000000000000_REALK, &
     -0.148372337764514_REALK,      0.000000000000000_REALK,     -3.402366460530769_REALK, &
      0.406616426484939_REALK,      0.000000000000000_REALK,     -0.524345408136375_REALK, &
      0.000000000000000_REALK,      0.889267837108472_REALK,      0.000000000000000_REALK, &
     -0.074591704596925_REALK,      0.000000000000000_REALK,     -1.998393675602001_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.426919927481869_REALK, &
      0.000000000000000_REALK,      0.106543164248251_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.052363953421632_REALK,      0.000000000000000_REALK, &
      0.443927073851684_REALK,      0.000000000000000_REALK,      0.029103434921935_REALK, &
      0.000000000000000_REALK,      0.133068377056179_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.388277949047550_REALK, &
      0.000000000000000_REALK,      0.903953130955896_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.536359239398883_REALK,      0.000000000000000_REALK, &
      2.081867682781967_REALK,      0.000000000000000_REALK,      0.510300640667360_REALK, &
      0.000000000000000_REALK,      0.639779023608608_REALK,      0.000000000000000_REALK, &
      0.185073175595207_REALK,      0.052961136901118_REALK,      0.000000000000000_REALK, &
      0.024512079269712_REALK,      0.000000000000000_REALK,     -0.214056876089950_REALK, &
      0.012579119767731_REALK,      0.000000000000000_REALK,     -0.070480368439383_REALK, &
      0.000000000000000_REALK,      0.007451565627774_REALK,      0.000000000000000_REALK, &
     -0.039180960903929_REALK,      0.000000000000000_REALK,     -0.348742330358540_REALK, &
     -2.131921154243963_REALK,     -0.401810425308159_REALK,      0.000000000000000_REALK, &
      0.017186894689099_REALK,      0.000000000000000_REALK,     -1.914628527919571_REALK, &
      0.241845958932376_REALK,      0.000000000000000_REALK,     -0.404825335170155_REALK, &
      0.000000000000000_REALK,      0.465774872446437_REALK,      0.000000000000000_REALK, &
      0.019945911537715_REALK,      0.000000000000000_REALK,     -1.702627602871865_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.053240883679821_REALK, &
      0.000000000000000_REALK,     -0.019799903190349_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.011063893574132_REALK,      0.000000000000000_REALK, &
      0.173562988253498_REALK,      0.000000000000000_REALK,     -0.007796016161974_REALK, &
      0.000000000000000_REALK,      0.077528073894424_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.250950497279685_REALK, &
      0.000000000000000_REALK,      0.981248165025624_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.720488517615120_REALK,      0.000000000000000_REALK, &
      2.313343975160679_REALK,      0.000000000000000_REALK,      0.759844209127507_REALK, &
      0.000000000000000_REALK,      1.161617420196722_REALK,      0.000000000000000_REALK, &
      0.499749225016309_REALK,      0.180109552620229_REALK,      0.000000000000000_REALK, &
      0.073581785693021_REALK,      0.000000000000000_REALK,      0.015640608307618_REALK, &
      0.016218392587274_REALK,      0.000000000000000_REALK,      0.006485797996874_REALK, &
      0.000000000000000_REALK,     -0.031580087325983_REALK,      0.000000000000000_REALK, &
      0.003182592668267_REALK,      0.000000000000000_REALK,     -0.202049642016722_REALK, &
     -0.283677522390086_REALK,      0.154389191702953_REALK,      0.000000000000000_REALK, &
      0.312497707196708_REALK,      0.000000000000000_REALK,     -0.927944121104412_REALK, &
      0.427313437384073_REALK,      0.000000000000000_REALK,      0.566561278904976_REALK, &
      0.000000000000000_REALK,      0.578271845700358_REALK,      0.000000000000000_REALK, &
      1.320951343100206_REALK,      0.000000000000000_REALK,     -1.188722623265617_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.651973010025453_REALK, &
      0.000000000000000_REALK,      0.676385320351953_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.292455649443176_REALK,      0.000000000000000_REALK, &
      1.652511475852930_REALK,      0.000000000000000_REALK,      1.074704600805737_REALK, &
      0.000000000000000_REALK,      4.218979295052939_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.338521765626227_REALK, &
      0.000000000000000_REALK,      0.030036734630586_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.269304255299116_REALK,      0.000000000000000_REALK, &
      1.435424344448462_REALK,      0.000000000000000_REALK,     -8.160810689367942_REALK, &
      0.000000000000000_REALK,      0.223434392369575_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.101149512568410_REALK, &
      0.000000000000000_REALK,      0.325050690141934_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.389489927875934_REALK,      0.000000000000000_REALK, &
      2.377748975906132_REALK,      0.000000000000000_REALK,      0.684850850472177_REALK, &
      0.000000000000000_REALK,      1.740982386604395_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.144904906305805_REALK, &
      0.000000000000000_REALK,      0.422266315855495_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.603947889720294_REALK,      0.000000000000000_REALK, &
      2.686125920628717_REALK,      0.000000000000000_REALK,      2.882573980803716_REALK, &
      0.000000000000000_REALK,      2.491697709347392_REALK,      0.000000000000000_REALK, &
      0.042323920586933_REALK,      0.007807661585655_REALK,      0.000000000000000_REALK, &
      0.014361438326328_REALK,      0.000000000000000_REALK,     -0.726733096168904_REALK, &
      0.004294596912198_REALK,      0.000000000000000_REALK,     -0.150984799236909_REALK, &
      0.000000000000000_REALK,      0.009490184130610_REALK,      0.000000000000000_REALK, &
     -0.688864421463667_REALK,      0.000000000000000_REALK,     -8.045595219529277_REALK, &
     -0.431509918990334_REALK,     -0.004847091667100_REALK,      0.000000000000000_REALK, &
      0.145069094876415_REALK,      0.000000000000000_REALK,     -1.293195669305498_REALK, &
      0.415356933613761_REALK,      0.000000000000000_REALK,     -0.019019120623030_REALK, &
      0.000000000000000_REALK,      3.753511682444439_REALK,      0.000000000000000_REALK, &
      1.431647382680968_REALK,      0.000000000000000_REALK,    -12.524094738722566_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.596670723253085_REALK, &
      0.000000000000000_REALK,      0.059697327055934_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.430081508340371_REALK,      0.000000000000000_REALK, &
      3.003579310466625_REALK,      0.000000000000000_REALK,     -0.018054028645878_REALK, &
      0.000000000000000_REALK,      0.256242272107616_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.336423776768998_REALK, &
      0.000000000000000_REALK,     -0.045810811276620_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.231475266783483_REALK,      0.000000000000000_REALK, &
      3.392271218859404_REALK,      0.000000000000000_REALK,     -1.249850289197731_REALK, &
      0.000000000000000_REALK,     -0.216843329376366_REALK,      0.000000000000000_REALK, &
      0.047979392883402_REALK,      0.006002471932822_REALK,      0.000000000000000_REALK, &
      0.012684133376732_REALK,      0.000000000000000_REALK,     -0.693462697079292_REALK, &
      0.004441764226701_REALK,      0.000000000000000_REALK,     -0.101122177392783_REALK, &
      0.000000000000000_REALK,      0.026392189915766_REALK,      0.000000000000000_REALK, &
     -0.487583749756382_REALK,      0.000000000000000_REALK,     -6.152603810833425_REALK, &
     -0.324910697028105_REALK,     -0.083752889862825_REALK,      0.000000000000000_REALK, &
     -0.203881562258513_REALK,      0.000000000000000_REALK,     -1.516551283158866_REALK, &
     -0.245941198103375_REALK,      0.000000000000000_REALK,     -0.355548150281890_REALK, &
      0.000000000000000_REALK,     -1.489057211912818_REALK,      0.000000000000000_REALK, &
     -1.614017670326472_REALK,      0.000000000000000_REALK,    -11.781711218886096_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.213991818178886_REALK, &
      0.000000000000000_REALK,     -0.078404498065717_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.071242055568834_REALK,      0.000000000000000_REALK, &
      0.240932011667830_REALK,      0.000000000000000_REALK,     -0.085727189002294_REALK, &
      0.000000000000000_REALK,      0.201423651790930_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.272937394028947_REALK, &
      0.000000000000000_REALK,      0.006832102204993_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.129978740080409_REALK,      0.000000000000000_REALK, &
      1.812145108502490_REALK,      0.000000000000000_REALK,     -1.181179004299818_REALK, &
      0.000000000000000_REALK,      0.084589409822084_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.447614099707220_REALK, &
      0.000000000000000_REALK,     -0.229289352694354_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.572477130457608_REALK,      0.000000000000000_REALK, &
      3.910496689362207_REALK,      0.000000000000000_REALK,     -0.407579259200188_REALK, &
      0.000000000000000_REALK,     -0.748877044029730_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.442698476417882_REALK, &
      0.000000000000000_REALK,     -0.310888533731290_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.830210500356804_REALK,      0.000000000000000_REALK, &
      5.375295175551247_REALK,      0.000000000000000_REALK,      0.164786710032319_REALK, &
      0.000000000000000_REALK,     -0.946766241211679_REALK,      0.000000000000000_REALK, &
      0.067474669254683_REALK,      0.001537176589022_REALK,      0.000000000000000_REALK, &
      0.012723266412251_REALK,      0.000000000000000_REALK,     -0.795755203687809_REALK, &
     -0.000173035849120_REALK,      0.000000000000000_REALK,     -0.021994053148527_REALK, &
      0.000000000000000_REALK,      0.016342314893724_REALK,      0.000000000000000_REALK, &
     -0.372149794114889_REALK,      0.000000000000000_REALK,     -5.372124541076447_REALK, &
     -1.134819257017355_REALK,      0.019436468379562_REALK,      0.000000000000000_REALK, &
     -0.087675818093656_REALK,      0.000000000000000_REALK,     -2.148909123715411_REALK, &
      0.174917239539323_REALK,      0.000000000000000_REALK,      0.050754310833645_REALK, &
      0.000000000000000_REALK,      0.557842818397487_REALK,      0.000000000000000_REALK, &
     -0.446550042205658_REALK,      0.000000000000000_REALK,    -10.740618672793467_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.284731269354802_REALK, &
      0.000000000000000_REALK,     -0.047702094402136_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.074516829510449_REALK,      0.000000000000000_REALK, &
      0.272268711762547_REALK,      0.000000000000000_REALK,     -0.061286624080250_REALK, &
      0.000000000000000_REALK,      0.093247602258740_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.684686730594294_REALK, &
      0.000000000000000_REALK,      0.143304257850174_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.240363401926771_REALK,      0.000000000000000_REALK, &
      2.796268035003852_REALK,      0.000000000000000_REALK,      0.504873136201782_REALK, &
      0.000000000000000_REALK,      1.141512601482796_REALK,      0.000000000000000_REALK, &
      0.755711210879902_REALK,      0.168710902374838_REALK,      0.000000000000000_REALK, &
      0.176123613207367_REALK,      0.000000000000000_REALK,      0.540422387998556_REALK, &
      0.068661587216336_REALK,      0.000000000000000_REALK,      0.146373818058856_REALK, &
      0.000000000000000_REALK,      0.070970462026320_REALK,      0.000000000000000_REALK, &
      0.312374441716235_REALK,      0.000000000000000_REALK,      0.391698687513645_REALK, &
      0.322867041109249_REALK,      0.004038144891802_REALK,      0.000000000000000_REALK, &
     -0.068584460452459_REALK,      0.000000000000000_REALK,     -0.771157698586200_REALK, &
     -0.230286515496573_REALK,      0.000000000000000_REALK,     -0.013300427757941_REALK, &
      0.000000000000000_REALK,     -0.915836066637927_REALK,      0.000000000000000_REALK, &
      0.440599668657550_REALK,      0.000000000000000_REALK,     -8.134238420087881_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.219462043990899_REALK, &
      0.000000000000000_REALK,     -0.750649760325727_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.908447639432090_REALK,      0.000000000000000_REALK, &
      5.542009737600446_REALK,      0.000000000000000_REALK,     -0.885574602173600_REALK, &
      0.000000000000000_REALK,     -1.795468703573224_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.220803209341625_REALK, &
      0.000000000000000_REALK,     -1.305768236668108_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.194709484229345_REALK,      0.000000000000000_REALK, &
      8.833222047610324_REALK,      0.000000000000000_REALK,     -1.882092798817391_REALK, &
      0.000000000000000_REALK,     -3.101199492986050_REALK,      0.000000000000000_REALK, &
      0.115612509974755_REALK,     -0.007780303582859_REALK,      0.000000000000000_REALK, &
      0.017966712230930_REALK,      0.000000000000000_REALK,     -1.099094222043248_REALK, &
     -0.005561709497961_REALK,      0.000000000000000_REALK,      0.091516473272162_REALK, &
      0.000000000000000_REALK,      0.019553847156832_REALK,      0.000000000000000_REALK, &
     -0.384858987872217_REALK,      0.000000000000000_REALK,     -5.433946637136283_REALK, &
     -1.083885229719807_REALK,      0.113796249300246_REALK,      0.000000000000000_REALK, &
     -0.309131844369904_REALK,      0.000000000000000_REALK,     -3.347419096346823_REALK, &
     -0.033511139187329_REALK,      0.000000000000000_REALK,      0.322004559240618_REALK, &
      0.000000000000000_REALK,     -0.775517014270559_REALK,      0.000000000000000_REALK, &
     -1.227890382615333_REALK,      0.000000000000000_REALK,    -13.048088163856065_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.430561632036111_REALK, &
      0.000000000000000_REALK,     -0.011006745490819_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.080976162708766_REALK,      0.000000000000000_REALK, &
      0.338469174817218_REALK,      0.000000000000000_REALK,      0.001854909665330_REALK, &
      0.000000000000000_REALK,      0.015756980936526_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.837002452202232_REALK, &
      0.000000000000000_REALK,     -0.020110084492037_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.096632358696808_REALK,      0.000000000000000_REALK, &
      3.704180244710326_REALK,      0.000000000000000_REALK,     -0.275289361089437_REALK, &
      0.000000000000000_REALK,     -0.124928364960870_REALK,      0.000000000000000_REALK, &
      1.123906911007949_REALK,      0.135264364490016_REALK,      0.000000000000000_REALK, &
      0.195433105120593_REALK,      0.000000000000000_REALK,      0.647886873378403_REALK, &
      0.069886810151680_REALK,      0.000000000000000_REALK,      0.096477240516242_REALK, &
      0.000000000000000_REALK,      0.226598671091658_REALK,      0.000000000000000_REALK, &
      0.253845750907550_REALK,      0.000000000000000_REALK,      0.343899721822393_REALK, &
      0.300299349811963_REALK,      0.073073600694217_REALK,      0.000000000000000_REALK, &
      0.124681504751490_REALK,      0.000000000000000_REALK,     -1.169793799603746_REALK, &
      0.143030099681944_REALK,      0.000000000000000_REALK,     -0.260809083194350_REALK, &
      0.000000000000000_REALK,      0.456899820107188_REALK,      0.000000000000000_REALK, &
     -0.624663341110780_REALK,      0.000000000000000_REALK,     -9.622957310735618_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.014158376597462_REALK, &
      0.000000000000000_REALK,     -0.254058462831172_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.235739041363518_REALK,      0.000000000000000_REALK, &
     -1.187009649193077_REALK,      0.000000000000000_REALK,     -0.154794622458735_REALK, &
      0.000000000000000_REALK,     -0.541517408219898_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.292417510203909_REALK, &
      0.000000000000000_REALK,     -0.005130480776013_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.092821398538675_REALK,      0.000000000000000_REALK, &
      1.949776314475650_REALK,      0.000000000000000_REALK,      0.445046048332752_REALK, &
      0.000000000000000_REALK,      0.048019900953748_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      9.113140954516203_REALK, &
      0.000000000000000_REALK,     -2.069366870329050_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.762693723855230_REALK,      0.000000000000000_REALK, &
      9.056412299083760_REALK,      0.000000000000000_REALK,     -1.702942630051726_REALK, &
      0.000000000000000_REALK,     -3.413310271399396_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     32.539076825998464_REALK, &
      0.000000000000000_REALK,     -7.134246120993677_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      5.111703281404242_REALK,      0.000000000000000_REALK, &
     25.519851309385075_REALK,      0.000000000000000_REALK,     -3.087243915826124_REALK, &
      0.000000000000000_REALK,     -8.152961754750343_REALK,      0.000000000000000_REALK, &
      0.270106988334582_REALK,     -0.035580828023616_REALK,      0.000000000000000_REALK, &
      0.034745131759636_REALK,      0.000000000000000_REALK,     -1.898252056603464_REALK, &
     -0.017440200042806_REALK,      0.000000000000000_REALK,      0.316662532840267_REALK, &
      0.000000000000000_REALK,      0.029079250430714_REALK,      0.000000000000000_REALK, &
     -0.513245051766491_REALK,      0.000000000000000_REALK,     -6.471904647054038_REALK, &
    -11.565229303661507_REALK,      1.673917694994408_REALK,      0.000000000000000_REALK, &
     -0.987744733799570_REALK,      0.000000000000000_REALK,    -12.213884471866875_REALK, &
      0.796743155658242_REALK,      0.000000000000000_REALK,      2.195630530931601_REALK, &
      0.000000000000000_REALK,      0.008958568730729_REALK,      0.000000000000000_REALK, &
     -1.887836109023057_REALK,      0.000000000000000_REALK,    -22.908376594445919_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.830724099152327_REALK, &
      0.000000000000000_REALK,      0.055813148461783_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.120856810049300_REALK,      0.000000000000000_REALK, &
      0.494104152412315_REALK,      0.000000000000000_REALK,      0.050104456483278_REALK, &
      0.000000000000000_REALK,     -0.055099593369859_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.566290391139599_REALK, &
      0.000000000000000_REALK,     -0.283289103179076_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.553123796742642_REALK,      0.000000000000000_REALK, &
      9.367420060901372_REALK,      0.000000000000000_REALK,      0.056347753498019_REALK, &
      0.000000000000000_REALK,     -0.846799793255718_REALK,      0.000000000000000_REALK, &
      2.303283288372997_REALK,      0.043598436849089_REALK,      0.000000000000000_REALK, &
      0.258812083349722_REALK,      0.000000000000000_REALK,      0.981531313593271_REALK, &
     -0.003052687634250_REALK,      0.000000000000000_REALK,      0.023528286157243_REALK, &
      0.000000000000000_REALK,      0.167884711298296_REALK,      0.000000000000000_REALK, &
      0.231821707906456_REALK,      0.000000000000000_REALK,      0.359281280144992_REALK, &
      2.582984647091038_REALK,     -0.035913692968707_REALK,      0.000000000000000_REALK, &
      0.111296924057077_REALK,      0.000000000000000_REALK,     -3.440721463290761_REALK, &
     -0.162347238640840_REALK,      0.000000000000000_REALK,      0.059417360919295_REALK, &
      0.000000000000000_REALK,     -0.265732356720055_REALK,      0.000000000000000_REALK, &
     -0.268306293339876_REALK,      0.000000000000000_REALK,    -13.619227473845864_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.698390986158685_REALK, &
      0.000000000000000_REALK,     -0.204069795958886_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.276475086455017_REALK,      0.000000000000000_REALK, &
     -1.504056121901731_REALK,      0.000000000000000_REALK,     -0.132409342176004_REALK, &
      0.000000000000000_REALK,     -0.299954425036588_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.553510698155565_REALK, &
      0.000000000000000_REALK,     -0.223378853190180_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.273943033803435_REALK,      0.000000000000000_REALK, &
      4.801608553345573_REALK,      0.000000000000000_REALK,     -0.295321104167850_REALK, &
      0.000000000000000_REALK,      1.006025444959530_REALK,      0.000000000000000_REALK, &
      2.431865983679500_REALK,      0.451094452479791_REALK,      0.000000000000000_REALK, &
      0.337738597133020_REALK,      0.000000000000000_REALK,      2.052410132975515_REALK, &
      0.114192425706452_REALK,      0.000000000000000_REALK,      0.482119359014333_REALK, &
      0.000000000000000_REALK,      0.068730956383648_REALK,      0.000000000000000_REALK, &
      0.599125710296103_REALK,      0.000000000000000_REALK,      4.254839156752032_REALK, &
      7.968334085707539_REALK,      0.080904615783353_REALK,      0.000000000000000_REALK, &
     -0.944012519578126_REALK,      0.000000000000000_REALK,      1.187036698515030_REALK, &
     -2.317552026565943_REALK,      0.000000000000000_REALK,      0.014969093885321_REALK, &
      0.000000000000000_REALK,     -4.730412657120758_REALK,      0.000000000000000_REALK, &
     -0.254503858750149_REALK,      0.000000000000000_REALK,     -9.606946561121100_REALK/
    ! results of test 7, ket-major order, 03ODGZZZ
  data REF_CONTR_INTS(76861:78120)                                                         &
    /-1.726288916842879_REALK,     -1.594911285768987_REALK,      0.000000000000000_REALK, &
     -1.911851453754397_REALK,      0.000000000000000_REALK,     -1.502455406409673_REALK, &
     -2.820127450574205_REALK,      0.000000000000000_REALK,     -1.686190326078034_REALK, &
      0.000000000000000_REALK,     -5.755820090703696_REALK,      0.000000000000000_REALK, &
     -2.864139932911005_REALK,      0.000000000000000_REALK,     -3.151154618132954_REALK, &
     -2.016798054255452_REALK,     -3.021881510705781_REALK,      0.000000000000000_REALK, &
     -4.526476669928097_REALK,      0.000000000000000_REALK,     -2.728545334551332_REALK, &
     -7.650990174611048_REALK,      0.000000000000000_REALK,     -3.715995808911047_REALK, &
      0.000000000000000_REALK,    -16.472625112513395_REALK,      0.000000000000000_REALK, &
     -6.833100296168363_REALK,      0.000000000000000_REALK,     -5.766558718947016_REALK, &
     -1.263361897106447_REALK,     -0.847330132448344_REALK,      0.000000000000000_REALK, &
     -0.755955698370636_REALK,      0.000000000000000_REALK,     -0.958928971150057_REALK, &
     -0.808588546233497_REALK,      0.000000000000000_REALK,     -0.772145887343972_REALK, &
      0.000000000000000_REALK,     -1.109049091668190_REALK,      0.000000000000000_REALK, &
     -0.932354676067240_REALK,      0.000000000000000_REALK,     -1.655767232224311_REALK, &
     -2.017070420365347_REALK,     -1.055621072724008_REALK,      0.000000000000000_REALK, &
     -0.606185910539136_REALK,      0.000000000000000_REALK,     -1.234821157788498_REALK, &
     -0.096485288810378_REALK,      0.000000000000000_REALK,     -0.867271395366469_REALK, &
      0.000000000000000_REALK,      1.122861885674356_REALK,      0.000000000000000_REALK, &
     -0.680053331466407_REALK,      0.000000000000000_REALK,     -1.939408222011260_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.783958184451860_REALK, &
      0.000000000000000_REALK,      0.736747616534107_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.909059197097254_REALK,      0.000000000000000_REALK, &
      1.164579274733306_REALK,      0.000000000000000_REALK,      1.519727388199531_REALK, &
      0.000000000000000_REALK,      1.481265795701765_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.577209958084318_REALK, &
      0.000000000000000_REALK,      2.637637592247468_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.512577252399043_REALK,      0.000000000000000_REALK, &
      3.275180694774144_REALK,      0.000000000000000_REALK,      6.092488065930048_REALK, &
      0.000000000000000_REALK,      4.577103696550167_REALK,      0.000000000000000_REALK, &
     -1.261393332225880_REALK,     -0.660207853319753_REALK,      0.000000000000000_REALK, &
     -0.497394570537821_REALK,      0.000000000000000_REALK,     -0.832056854500249_REALK, &
     -0.459744736095163_REALK,      0.000000000000000_REALK,     -0.514764828323661_REALK, &
      0.000000000000000_REALK,     -0.563457757529389_REALK,      0.000000000000000_REALK, &
     -0.503798181309469_REALK,      0.000000000000000_REALK,     -1.179876614708646_REALK, &
     -1.034550293369261_REALK,     -0.852168597370518_REALK,      0.000000000000000_REALK, &
     -0.847683016520445_REALK,      0.000000000000000_REALK,     -1.063000308176167_REALK, &
     -1.070650740279846_REALK,      0.000000000000000_REALK,     -0.777637828883147_REALK, &
      0.000000000000000_REALK,     -1.847818306867516_REALK,      0.000000000000000_REALK, &
     -0.861843069667081_REALK,      0.000000000000000_REALK,     -1.513059956518435_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.575534350745671_REALK, &
      0.000000000000000_REALK,      0.388767135272777_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.353760496410960_REALK,      0.000000000000000_REALK, &
      0.731524500223102_REALK,      0.000000000000000_REALK,      0.412356953192438_REALK, &
      0.000000000000000_REALK,      0.641910598444589_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.911841610629808_REALK, &
      0.000000000000000_REALK,      0.627824475388202_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.408482104776687_REALK,      0.000000000000000_REALK, &
      1.287092479729146_REALK,      0.000000000000000_REALK,      0.071013191714212_REALK, &
      0.000000000000000_REALK,      0.987350720254569_REALK,      0.000000000000000_REALK, &
     -0.364757020493043_REALK,     -0.295787549000958_REALK,      0.000000000000000_REALK, &
     -0.306167216642428_REALK,      0.000000000000000_REALK,     -0.597687363026319_REALK, &
     -0.385718270643335_REALK,      0.000000000000000_REALK,     -0.572896291209614_REALK, &
      0.000000000000000_REALK,     -0.623199676881154_REALK,      0.000000000000000_REALK, &
     -0.770339528641525_REALK,      0.000000000000000_REALK,     -1.353885250339370_REALK, &
     -1.290791897126572_REALK,     -1.685343727890701_REALK,      0.000000000000000_REALK, &
     -2.200225152166656_REALK,      0.000000000000000_REALK,     -2.472069244183831_REALK, &
     -3.166523902472598_REALK,      0.000000000000000_REALK,     -2.866572700726703_REALK, &
      0.000000000000000_REALK,     -5.392707391769767_REALK,      0.000000000000000_REALK, &
     -4.169504581760389_REALK,      0.000000000000000_REALK,     -5.149597665699884_REALK, &
     -1.574441903279015_REALK,     -0.620710519403442_REALK,      0.000000000000000_REALK, &
     -0.385253679156848_REALK,      0.000000000000000_REALK,     -0.882892890560285_REALK, &
     -0.281278628251931_REALK,      0.000000000000000_REALK,     -0.407066035372581_REALK, &
      0.000000000000000_REALK,     -0.261141253471215_REALK,      0.000000000000000_REALK, &
     -0.317553361690894_REALK,      0.000000000000000_REALK,     -1.018839971713209_REALK, &
     -3.082145833407729_REALK,     -0.984250200239538_REALK,      0.000000000000000_REALK, &
     -0.385465499266984_REALK,      0.000000000000000_REALK,     -1.358211370804805_REALK, &
      0.010643540204054_REALK,      0.000000000000000_REALK,     -0.544137613792079_REALK, &
      0.000000000000000_REALK,      0.547299908266124_REALK,      0.000000000000000_REALK, &
     -0.270535924199536_REALK,      0.000000000000000_REALK,     -1.334549932019448_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.591297727893907_REALK, &
      0.000000000000000_REALK,      0.306347856490113_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.231808848481961_REALK,      0.000000000000000_REALK, &
      0.632137302402898_REALK,      0.000000000000000_REALK,      0.225523947834419_REALK, &
      0.000000000000000_REALK,      0.411636818063454_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.643216732986610_REALK, &
      0.000000000000000_REALK,      0.880847671594545_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.724432918060208_REALK,      0.000000000000000_REALK, &
      1.405194942274174_REALK,      0.000000000000000_REALK,      0.851158975252958_REALK, &
      0.000000000000000_REALK,      0.956266041923026_REALK,      0.000000000000000_REALK, &
     -0.318566694254139_REALK,     -0.184807286841111_REALK,      0.000000000000000_REALK, &
     -0.140828856884150_REALK,      0.000000000000000_REALK,     -0.443761571760687_REALK, &
     -0.126917957856218_REALK,      0.000000000000000_REALK,     -0.301066750647796_REALK, &
      0.000000000000000_REALK,     -0.138080131195335_REALK,      0.000000000000000_REALK, &
     -0.288356347731599_REALK,      0.000000000000000_REALK,     -0.818034912443046_REALK, &
     -1.850710690285776_REALK,     -0.839764906104000_REALK,      0.000000000000000_REALK, &
     -0.400363509551528_REALK,      0.000000000000000_REALK,     -1.520111101069070_REALK, &
     -0.051649608742519_REALK,      0.000000000000000_REALK,     -0.865333617722872_REALK, &
      0.000000000000000_REALK,      0.463956523280510_REALK,      0.000000000000000_REALK, &
     -0.523740955412839_REALK,      0.000000000000000_REALK,     -2.185912213274370_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.304111676560310_REALK, &
      0.000000000000000_REALK,      0.244111256012919_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.253782348537965_REALK,      0.000000000000000_REALK, &
      0.646253655228121_REALK,      0.000000000000000_REALK,      0.336526964040828_REALK, &
      0.000000000000000_REALK,      0.652006432281735_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.598766836494889_REALK, &
      0.000000000000000_REALK,      3.057862916719338_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.300548037331560_REALK,      0.000000000000000_REALK, &
      4.659406757296426_REALK,      0.000000000000000_REALK,      4.418754472753209_REALK, &
      0.000000000000000_REALK,      5.026099958356483_REALK,      0.000000000000000_REALK, &
     -2.402680321086200_REALK,     -0.711291974906379_REALK,      0.000000000000000_REALK, &
     -0.382080791962395_REALK,      0.000000000000000_REALK,     -1.146405348232077_REALK, &
     -0.231208487945594_REALK,      0.000000000000000_REALK,     -0.388895105679476_REALK, &
      0.000000000000000_REALK,     -0.188920478001176_REALK,      0.000000000000000_REALK, &
     -0.253912253731306_REALK,      0.000000000000000_REALK,     -1.066583090528744_REALK, &
     -2.187895303306972_REALK,     -1.010542371331792_REALK,      0.000000000000000_REALK, &
     -0.722884518254274_REALK,      0.000000000000000_REALK,     -1.709303959406932_REALK, &
     -0.694043972480532_REALK,      0.000000000000000_REALK,     -0.675186055867908_REALK, &
      0.000000000000000_REALK,     -1.011401849582725_REALK,      0.000000000000000_REALK, &
     -0.493265664084467_REALK,      0.000000000000000_REALK,     -1.632898898669584_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.759815329887385_REALK, &
      0.000000000000000_REALK,      0.294545416861771_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.181272279240424_REALK,      0.000000000000000_REALK, &
      0.677207979944086_REALK,      0.000000000000000_REALK,      0.135254770717200_REALK, &
      0.000000000000000_REALK,      0.319087779124593_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.361835930721309_REALK, &
      0.000000000000000_REALK,      0.573358112451618_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.258233080516388_REALK,      0.000000000000000_REALK, &
      1.407447546661196_REALK,      0.000000000000000_REALK,     -0.007652710435597_REALK, &
      0.000000000000000_REALK,      0.605168642997197_REALK,      0.000000000000000_REALK, &
     -0.393372051998820_REALK,     -0.176356396816063_REALK,      0.000000000000000_REALK, &
     -0.112200230981657_REALK,      0.000000000000000_REALK,     -0.466244429128174_REALK, &
     -0.086115967541555_REALK,      0.000000000000000_REALK,     -0.239521072744632_REALK, &
      0.000000000000000_REALK,     -0.083392496062761_REALK,      0.000000000000000_REALK, &
     -0.185220967471590_REALK,      0.000000000000000_REALK,     -0.692937937325941_REALK, &
     -1.060182318170385_REALK,     -0.764216231887019_REALK,      0.000000000000000_REALK, &
     -0.660500895885196_REALK,      0.000000000000000_REALK,     -1.543817423629078_REALK, &
     -0.703000505035192_REALK,      0.000000000000000_REALK,     -0.951716969879811_REALK, &
      0.000000000000000_REALK,     -0.966309934811315_REALK,      0.000000000000000_REALK, &
     -0.840055523204173_REALK,      0.000000000000000_REALK,     -2.158369802081471_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.273435902431379_REALK, &
      0.000000000000000_REALK,      0.155975365432850_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.117855542509513_REALK,      0.000000000000000_REALK, &
      0.484433603683573_REALK,      0.000000000000000_REALK,      0.108545716416611_REALK, &
      0.000000000000000_REALK,      0.335875728979513_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.435371692061419_REALK, &
      0.000000000000000_REALK,      0.858682100624065_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.470798520438107_REALK,      0.000000000000000_REALK, &
      2.245985732669149_REALK,      0.000000000000000_REALK,      0.065185417351142_REALK, &
      0.000000000000000_REALK,      1.372202010801136_REALK,      0.000000000000000_REALK, &
      0.095441188880866_REALK,      0.066293298813666_REALK,      0.000000000000000_REALK, &
      0.057946953390557_REALK,      0.000000000000000_REALK,     -0.354644030010124_REALK, &
      0.060620057177249_REALK,      0.000000000000000_REALK,     -0.282272649604583_REALK, &
      0.000000000000000_REALK,      0.077387718075199_REALK,      0.000000000000000_REALK, &
     -0.299898064753107_REALK,      0.000000000000000_REALK,     -0.924706632508660_REALK, &
     -2.011656507529802_REALK,     -2.298517782934467_REALK,      0.000000000000000_REALK, &
     -2.607208128461971_REALK,      0.000000000000000_REALK,     -4.899698796294196_REALK, &
     -3.161980836276031_REALK,      0.000000000000000_REALK,     -4.787839669088186_REALK, &
      0.000000000000000_REALK,     -4.288769272976357_REALK,      0.000000000000000_REALK, &
     -5.546390677752301_REALK,      0.000000000000000_REALK,     -9.333587325367752_REALK, &
     -5.464577121380922_REALK,     -1.104656982567830_REALK,      0.000000000000000_REALK, &
     -0.504479259517070_REALK,      0.000000000000000_REALK,     -1.988056223282090_REALK, &
     -0.228964005597790_REALK,      0.000000000000000_REALK,     -0.462407324831896_REALK, &
      0.000000000000000_REALK,     -0.148553383719629_REALK,      0.000000000000000_REALK, &
     -0.253644028857308_REALK,      0.000000000000000_REALK,     -1.399387611635736_REALK, &
    -22.174250224592637_REALK,     -3.810395401493929_REALK,      0.000000000000000_REALK, &
     -1.057113186352760_REALK,      0.000000000000000_REALK,     -6.515793659151059_REALK, &
      0.181584774495631_REALK,      0.000000000000000_REALK,     -1.256092203167635_REALK, &
      0.000000000000000_REALK,      0.995525991195580_REALK,      0.000000000000000_REALK, &
     -0.401405163675489_REALK,      0.000000000000000_REALK,     -3.463832024413176_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.398304307143455_REALK, &
      0.000000000000000_REALK,      0.384180297344232_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.195081443332543_REALK,      0.000000000000000_REALK, &
      0.954175816217672_REALK,      0.000000000000000_REALK,      0.114838552910535_REALK, &
      0.000000000000000_REALK,      0.314880569380052_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      7.557720845156879_REALK, &
      0.000000000000000_REALK,      2.053591873141888_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.053639266178616_REALK,      0.000000000000000_REALK, &
      3.853725842949354_REALK,      0.000000000000000_REALK,      0.801565698441985_REALK, &
      0.000000000000000_REALK,      1.206185476832560_REALK,      0.000000000000000_REALK, &
     -0.754569883437025_REALK,     -0.240321209293612_REALK,      0.000000000000000_REALK, &
     -0.119787181257774_REALK,      0.000000000000000_REALK,     -0.681929554071344_REALK, &
     -0.069512231666614_REALK,      0.000000000000000_REALK,     -0.249894849967485_REALK, &
      0.000000000000000_REALK,     -0.049527960222549_REALK,      0.000000000000000_REALK, &
     -0.149609652712825_REALK,      0.000000000000000_REALK,     -0.766784045378418_REALK, &
     -8.149370062903518_REALK,     -2.193590367878895_REALK,      0.000000000000000_REALK, &
     -0.679611265440449_REALK,      0.000000000000000_REALK,     -4.463392064903110_REALK, &
      0.014144394578668_REALK,      0.000000000000000_REALK,     -1.347812949475589_REALK, &
      0.000000000000000_REALK,      0.522062461263274_REALK,      0.000000000000000_REALK, &
     -0.480999530780004_REALK,      0.000000000000000_REALK,     -3.472517618807552_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.407176741013166_REALK, &
      0.000000000000000_REALK,      0.169415114361525_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.101889225851672_REALK,      0.000000000000000_REALK, &
      0.552299156718457_REALK,      0.000000000000000_REALK,      0.076074898199159_REALK, &
      0.000000000000000_REALK,      0.276011791163249_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.428343954577014_REALK, &
      0.000000000000000_REALK,      2.726026702574150_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.689859794185257_REALK,      0.000000000000000_REALK, &
      4.962771289021541_REALK,      0.000000000000000_REALK,      1.425154711455609_REALK, &
      0.000000000000000_REALK,      2.424182154546635_REALK,      0.000000000000000_REALK, &
      0.128100966769115_REALK,      0.060034555169835_REALK,      0.000000000000000_REALK, &
      0.036739599310608_REALK,      0.000000000000000_REALK,     -0.362943573470981_REALK, &
      0.026316418397748_REALK,      0.000000000000000_REALK,     -0.195710064776691_REALK, &
      0.000000000000000_REALK,      0.021972797818066_REALK,      0.000000000000000_REALK, &
     -0.143856782673197_REALK,      0.000000000000000_REALK,     -0.715983974802714_REALK, &
     -7.441800732929046_REALK,     -2.846271915174703_REALK,      0.000000000000000_REALK, &
     -1.073490465000278_REALK,      0.000000000000000_REALK,     -6.817406800918514_REALK, &
     -0.104384001578314_REALK,      0.000000000000000_REALK,     -2.925166943740354_REALK, &
      0.000000000000000_REALK,      0.673043328904654_REALK,      0.000000000000000_REALK, &
     -1.270815344176302_REALK,      0.000000000000000_REALK,     -7.226831426801134_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.052636177291292_REALK, &
      0.000000000000000_REALK,     -0.033931230264064_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.028037168955958_REALK,      0.000000000000000_REALK, &
      0.566115078305615_REALK,      0.000000000000000_REALK,     -0.028532713516722_REALK, &
      0.000000000000000_REALK,      0.438332882788323_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     18.663608740609870_REALK, &
      0.000000000000000_REALK,     12.545412957172612_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     10.206485179209240_REALK,      0.000000000000000_REALK, &
     20.756032191585536_REALK,      0.000000000000000_REALK,      9.808189656839305_REALK, &
      0.000000000000000_REALK,     16.071028266930178_REALK,      0.000000000000000_REALK, &
     -1.886716494073439_REALK,     -0.434514032425292_REALK,      0.000000000000000_REALK, &
     -1.813300513779764_REALK,      0.000000000000000_REALK,     -4.088056489962992_REALK, &
     -0.929041095922666_REALK,      0.000000000000000_REALK,     -1.101333052075107_REALK, &
      0.000000000000000_REALK,    -12.025377610331130_REALK,      0.000000000000000_REALK, &
    -11.310531280254429_REALK,      0.000000000000000_REALK,    -35.699172109265298_REALK, &
     -2.031301010685264_REALK,     -0.670538892318915_REALK,      0.000000000000000_REALK, &
     -4.210827548843735_REALK,      0.000000000000000_REALK,     -6.963486123202260_REALK, &
     -2.856633665322506_REALK,      0.000000000000000_REALK,     -2.843267250935980_REALK, &
      0.000000000000000_REALK,    -39.855649473255454_REALK,      0.000000000000000_REALK, &
    -31.323101739258988_REALK,      0.000000000000000_REALK,    -72.519041559806155_REALK, &
     -1.432299269312805_REALK,     -0.358152046470688_REALK,      0.000000000000000_REALK, &
     -0.701312531786616_REALK,      0.000000000000000_REALK,     -2.746188132398797_REALK, &
     -0.415232438506541_REALK,      0.000000000000000_REALK,     -0.773369694119043_REALK, &
      0.000000000000000_REALK,     -2.266687908908400_REALK,      0.000000000000000_REALK, &
     -3.756253416389589_REALK,      0.000000000000000_REALK,    -20.592145900102327_REALK, &
     -2.019067555393327_REALK,     -0.471706286664140_REALK,      0.000000000000000_REALK, &
     -0.545251796729504_REALK,      0.000000000000000_REALK,     -3.618029137022114_REALK, &
      0.032353999466083_REALK,      0.000000000000000_REALK,     -1.106696701667931_REALK, &
      0.000000000000000_REALK,      3.049478223363482_REALK,      0.000000000000000_REALK, &
     -3.217407124165185_REALK,      0.000000000000000_REALK,    -29.888836510031432_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.422606554264885_REALK, &
      0.000000000000000_REALK,      0.484338650921976_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.404770484798165_REALK,      0.000000000000000_REALK, &
      1.886235420622057_REALK,      0.000000000000000_REALK,      2.188309093283860_REALK, &
      0.000000000000000_REALK,      5.362068626066033_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.879349178206145_REALK, &
      0.000000000000000_REALK,      2.561542800781569_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.666276413171912_REALK,      0.000000000000000_REALK, &
      7.236650832902320_REALK,      0.000000000000000_REALK,     15.186139950499049_REALK, &
      0.000000000000000_REALK,     24.807541098177342_REALK,      0.000000000000000_REALK, &
     -1.525917352364509_REALK,     -0.256584548908259_REALK,      0.000000000000000_REALK, &
     -0.459521577223509_REALK,      0.000000000000000_REALK,     -2.462673490839135_REALK, &
     -0.220434606701045_REALK,      0.000000000000000_REALK,     -0.482674374410823_REALK, &
      0.000000000000000_REALK,     -1.035876233514639_REALK,      0.000000000000000_REALK, &
     -1.972430908336993_REALK,      0.000000000000000_REALK,    -14.798945189367862_REALK, &
     -1.178631188465024_REALK,     -0.353177143239761_REALK,      0.000000000000000_REALK, &
     -0.675966969300688_REALK,      0.000000000000000_REALK,     -3.289415780443966_REALK, &
     -0.649852016266746_REALK,      0.000000000000000_REALK,     -0.896476610935301_REALK, &
      0.000000000000000_REALK,     -3.412079727724343_REALK,      0.000000000000000_REALK, &
     -3.199657986550904_REALK,      0.000000000000000_REALK,    -21.798413726371351_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.454152661779169_REALK, &
      0.000000000000000_REALK,      0.225550737002757_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.218175971926537_REALK,      0.000000000000000_REALK, &
      1.765897782576620_REALK,      0.000000000000000_REALK,      0.519809563476046_REALK, &
      0.000000000000000_REALK,      2.001152087724733_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.200155916599869_REALK, &
      0.000000000000000_REALK,      0.624826368001894_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.459101899644287_REALK,      0.000000000000000_REALK, &
      4.999852970220195_REALK,      0.000000000000000_REALK,     -0.086464292255704_REALK, &
      0.000000000000000_REALK,      4.854121262823536_REALK,      0.000000000000000_REALK, &
      0.293621511503237_REALK,      0.142617020019429_REALK,      0.000000000000000_REALK, &
      0.210192197180198_REALK,      0.000000000000000_REALK,     -0.283620285447893_REALK, &
      0.226313964211223_REALK,      0.000000000000000_REALK,     -0.160571585510939_REALK, &
      0.000000000000000_REALK,      0.959242026554935_REALK,      0.000000000000000_REALK, &
     -0.539990446702535_REALK,      0.000000000000000_REALK,     -6.256375704103423_REALK, &
     -0.567528282002496_REALK,     -0.540630341821667_REALK,      0.000000000000000_REALK, &
     -0.957787340572202_REALK,      0.000000000000000_REALK,     -4.142971138769037_REALK, &
     -1.378744068776396_REALK,      0.000000000000000_REALK,     -3.589470152764260_REALK, &
      0.000000000000000_REALK,     -5.768624975196985_REALK,      0.000000000000000_REALK, &
    -11.858526620818534_REALK,      0.000000000000000_REALK,    -44.413310149245206_REALK, &
     -2.079626659742793_REALK,     -0.116567889844407_REALK,      0.000000000000000_REALK, &
     -0.418877010320260_REALK,      0.000000000000000_REALK,     -2.738618683743636_REALK, &
     -0.054126317194345_REALK,      0.000000000000000_REALK,     -0.186237833560862_REALK, &
      0.000000000000000_REALK,     -0.587539786856796_REALK,      0.000000000000000_REALK, &
     -1.368085232107561_REALK,      0.000000000000000_REALK,    -12.522361360043385_REALK, &
     -4.004244813564379_REALK,     -0.127094963847672_REALK,      0.000000000000000_REALK, &
     -0.458821832618115_REALK,      0.000000000000000_REALK,     -4.533772524176097_REALK, &
      0.266143404219758_REALK,      0.000000000000000_REALK,     -0.198441121314258_REALK, &
      0.000000000000000_REALK,      0.768996887820461_REALK,      0.000000000000000_REALK, &
     -1.397275790908288_REALK,      0.000000000000000_REALK,    -19.329731487962391_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.567895259471840_REALK, &
      0.000000000000000_REALK,      0.127877643778449_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.169299740721709_REALK,      0.000000000000000_REALK, &
      1.875414091536642_REALK,      0.000000000000000_REALK,      0.190742200975233_REALK, &
      0.000000000000000_REALK,      0.863298945722951_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.334105023322246_REALK, &
      0.000000000000000_REALK,      0.567892908363640_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.748911375221024_REALK,      0.000000000000000_REALK, &
      5.981318276566287_REALK,      0.000000000000000_REALK,      1.253660701308473_REALK, &
      0.000000000000000_REALK,      2.838426766587310_REALK,      0.000000000000000_REALK, &
      0.306034543900203_REALK,      0.092609664400395_REALK,      0.000000000000000_REALK, &
      0.102919567966702_REALK,      0.000000000000000_REALK,     -0.241207183246011_REALK, &
      0.079441861298288_REALK,      0.000000000000000_REALK,     -0.088556181694387_REALK, &
      0.000000000000000_REALK,      0.202843655205712_REALK,      0.000000000000000_REALK, &
     -0.201186196511545_REALK,      0.000000000000000_REALK,     -4.048615256959138_REALK, &
     -1.084440205728153_REALK,     -0.282094201394381_REALK,      0.000000000000000_REALK, &
     -0.185041764256032_REALK,      0.000000000000000_REALK,     -3.211650452139772_REALK, &
      0.012876470818047_REALK,      0.000000000000000_REALK,     -1.152075778559889_REALK, &
      0.000000000000000_REALK,      0.534105852845897_REALK,      0.000000000000000_REALK, &
     -1.473979272267746_REALK,      0.000000000000000_REALK,    -22.150803367123814_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.553728835323047_REALK, &
      0.000000000000000_REALK,     -0.360169987731533_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.392409047777560_REALK,      0.000000000000000_REALK, &
     -0.196326204470152_REALK,      0.000000000000000_REALK,     -0.992316934970576_REALK, &
      0.000000000000000_REALK,     -0.261051567457683_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.974859825115883_REALK, &
      0.000000000000000_REALK,      1.527497731369309_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.864577102116592_REALK,      0.000000000000000_REALK, &
     10.680098184257423_REALK,      0.000000000000000_REALK,      4.673642624098667_REALK, &
      0.000000000000000_REALK,     16.112178813595072_REALK,      0.000000000000000_REALK, &
     -3.485201870818874_REALK,      0.147442667100190_REALK,      0.000000000000000_REALK, &
     -0.546651131618120_REALK,      0.000000000000000_REALK,     -3.699691407901524_REALK, &
      0.118197126494855_REALK,      0.000000000000000_REALK,      0.193657079572676_REALK, &
      0.000000000000000_REALK,     -0.587763230086451_REALK,      0.000000000000000_REALK, &
     -1.307527225702869_REALK,      0.000000000000000_REALK,    -12.388936467570327_REALK, &
     -3.659349136321394_REALK,      0.268806128043169_REALK,      0.000000000000000_REALK, &
     -0.969598869766915_REALK,      0.000000000000000_REALK,     -6.757380745522950_REALK, &
     -0.007488277293312_REALK,      0.000000000000000_REALK,      0.454800558755999_REALK, &
      0.000000000000000_REALK,     -1.895238467098254_REALK,      0.000000000000000_REALK, &
     -2.302797264385659_REALK,      0.000000000000000_REALK,    -22.468290478226962_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.832217327752047_REALK, &
      0.000000000000000_REALK,      0.052344482824759_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.167186771949229_REALK,      0.000000000000000_REALK, &
      2.259367666362698_REALK,      0.000000000000000_REALK,      0.036387479157491_REALK, &
      0.000000000000000_REALK,      0.258792304348082_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.775461568933670_REALK, &
      0.000000000000000_REALK,      0.123577511056349_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.475227311245473_REALK,      0.000000000000000_REALK, &
      7.707086465837158_REALK,      0.000000000000000_REALK,     -0.393628996859829_REALK, &
      0.000000000000000_REALK,      0.481699546104900_REALK,      0.000000000000000_REALK, &
      0.427733545207482_REALK,      0.069191136609623_REALK,      0.000000000000000_REALK, &
      0.084724681949329_REALK,      0.000000000000000_REALK,     -0.271759334203405_REALK, &
      0.041503641130137_REALK,      0.000000000000000_REALK,     -0.054391903900439_REALK, &
      0.000000000000000_REALK,      0.106428148272079_REALK,      0.000000000000000_REALK, &
     -0.121289730869342_REALK,      0.000000000000000_REALK,     -3.340524025123770_REALK, &
     -0.781970088873056_REALK,     -0.221194908450477_REALK,      0.000000000000000_REALK, &
     -0.296736785218229_REALK,      0.000000000000000_REALK,     -3.777010919770357_REALK, &
     -0.271289170581109_REALK,      0.000000000000000_REALK,     -0.978904909964110_REALK, &
      0.000000000000000_REALK,     -0.751537409199937_REALK,      0.000000000000000_REALK, &
     -1.843395606604074_REALK,      0.000000000000000_REALK,    -20.315849904973557_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.620574415188692_REALK, &
      0.000000000000000_REALK,     -0.210727069243065_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.208154296724268_REALK,      0.000000000000000_REALK, &
     -0.180882362245991_REALK,      0.000000000000000_REALK,     -0.270623147378130_REALK, &
      0.000000000000000_REALK,     -0.111854373766286_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.320767911310298_REALK, &
      0.000000000000000_REALK,      0.481960629511384_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.336769985848834_REALK,      0.000000000000000_REALK, &
      7.740053688594157_REALK,      0.000000000000000_REALK,     -0.033463743724876_REALK, &
      0.000000000000000_REALK,      3.964704347735765_REALK,      0.000000000000000_REALK, &
      1.446501267284602_REALK,      0.675896147474030_REALK,      0.000000000000000_REALK, &
      0.681097485885924_REALK,      0.000000000000000_REALK,      1.368341970940015_REALK, &
      0.748869983387601_REALK,      0.000000000000000_REALK,      0.791094633163540_REALK, &
      0.000000000000000_REALK,      1.732070176045904_REALK,      0.000000000000000_REALK, &
      1.451737293817794_REALK,      0.000000000000000_REALK,      2.527057876801528_REALK, &
      0.644106258033273_REALK,      0.579216267007422_REALK,      0.000000000000000_REALK, &
      0.719238294579759_REALK,      0.000000000000000_REALK,     -4.687396079882741_REALK, &
      0.984599116836778_REALK,      0.000000000000000_REALK,     -3.862088004177859_REALK, &
      0.000000000000000_REALK,      2.173509468234147_REALK,      0.000000000000000_REALK, &
     -6.731874297111075_REALK,      0.000000000000000_REALK,    -47.195862082684940_REALK, &
     -8.009327099271472_REALK,      0.907735143449977_REALK,      0.000000000000000_REALK, &
     -1.010530022427601_REALK,      0.000000000000000_REALK,     -6.285235526384285_REALK, &
      0.451654071979954_REALK,      0.000000000000000_REALK,      0.902084556628847_REALK, &
      0.000000000000000_REALK,     -0.828510706539585_REALK,      0.000000000000000_REALK, &
     -1.666815369746944_REALK,      0.000000000000000_REALK,    -14.514025039815579_REALK, &
    -38.360534363904669_REALK,      4.776824629655041_REALK,      0.000000000000000_REALK, &
     -3.314473398273682_REALK,      0.000000000000000_REALK,    -24.223224802769110_REALK, &
      2.132431071934159_REALK,      0.000000000000000_REALK,      3.746383308035489_REALK, &
      0.000000000000000_REALK,     -0.602580115837596_REALK,      0.000000000000000_REALK, &
     -3.787754780949291_REALK,      0.000000000000000_REALK,    -38.754961752379963_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.570495635027558_REALK, &
      0.000000000000000_REALK,     -0.066331523577189_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.230605458187421_REALK,      0.000000000000000_REALK, &
      3.226003150198837_REALK,      0.000000000000000_REALK,     -0.066777751048400_REALK, &
      0.000000000000000_REALK,     -0.226150839237604_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     14.487673126491433_REALK, &
      0.000000000000000_REALK,     -0.628862430090168_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.630366569988881_REALK,      0.000000000000000_REALK, &
     18.648535859110158_REALK,      0.000000000000000_REALK,      0.011832701133874_REALK, &
      0.000000000000000_REALK,     -1.179495139960335_REALK,      0.000000000000000_REALK, &
      0.849490789525967_REALK,      0.039563326299136_REALK,      0.000000000000000_REALK, &
      0.101962190958761_REALK,      0.000000000000000_REALK,     -0.398986128228747_REALK, &
      0.011426716785343_REALK,      0.000000000000000_REALK,     -0.023531764430084_REALK, &
      0.000000000000000_REALK,      0.072227330067112_REALK,      0.000000000000000_REALK, &
     -0.100658633597324_REALK,      0.000000000000000_REALK,     -3.382094302540882_REALK, &
     -6.542407330202672_REALK,     -0.168574888609970_REALK,      0.000000000000000_REALK, &
     -0.418089480243458_REALK,      0.000000000000000_REALK,    -10.806086699515214_REALK, &
      0.177316777078556_REALK,      0.000000000000000_REALK,     -0.345819397818708_REALK, &
      0.000000000000000_REALK,      0.262953529851726_REALK,      0.000000000000000_REALK, &
     -1.249741276524681_REALK,      0.000000000000000_REALK,    -27.967839315831696_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.976684161009390_REALK, &
      0.000000000000000_REALK,     -0.157731813873649_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.181109535343385_REALK,      0.000000000000000_REALK, &
     -0.215394394759949_REALK,      0.000000000000000_REALK,     -0.118818237976142_REALK, &
      0.000000000000000_REALK,     -0.057736403539337_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.439903987192289_REALK, &
      0.000000000000000_REALK,      0.909280572683800_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.876740059064601_REALK,      0.000000000000000_REALK, &
     14.777459805585154_REALK,      0.000000000000000_REALK,      0.753252769191396_REALK, &
      0.000000000000000_REALK,      3.599157644421916_REALK,      0.000000000000000_REALK, &
      2.197011841515757_REALK,      0.552406553748815_REALK,      0.000000000000000_REALK, &
      0.440290421172810_REALK,      0.000000000000000_REALK,      1.536371318650011_REALK, &
      0.294748120859217_REALK,      0.000000000000000_REALK,      0.489198580135961_REALK, &
      0.000000000000000_REALK,      0.438242362888117_REALK,      0.000000000000000_REALK, &
      0.647166130153895_REALK,      0.000000000000000_REALK,      1.956656175678419_REALK, &
      3.030961127137103_REALK,      0.640053823408322_REALK,      0.000000000000000_REALK, &
      0.288438164447393_REALK,      0.000000000000000_REALK,     -7.542707541514961_REALK, &
     -0.014675360110155_REALK,      0.000000000000000_REALK,     -1.978285644719250_REALK, &
      0.000000000000000_REALK,     -0.312420524870075_REALK,      0.000000000000000_REALK, &
     -1.299031347808238_REALK,      0.000000000000000_REALK,    -36.542920468222100_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.932170277766514_REALK, &
      0.000000000000000_REALK,     -1.367849572538139_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.292498898333513_REALK,      0.000000000000000_REALK, &
     -3.662334489264126_REALK,      0.000000000000000_REALK,     -1.903236978149356_REALK, &
      0.000000000000000_REALK,     -2.835680758087174_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.424830069137441_REALK, &
      0.000000000000000_REALK,     -2.351264686014340_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.098506168821405_REALK,      0.000000000000000_REALK, &
     24.576691663063603_REALK,      0.000000000000000_REALK,     -2.699639075708828_REALK, &
      0.000000000000000_REALK,     19.029297255804206_REALK,      0.000000000000000_REALK/
    ! results of test 8, ket-major order, SQHDR001
  data REF_CONTR_INTS(78121:79380)                                                         &
    /21.578818408653966_REALK,      9.032095652812330_REALK,      0.000000000000000_REALK, &
     -4.187608634636813_REALK,      0.000000000000000_REALK,     -0.658178251315770_REALK, &
    -28.782908284490574_REALK,      0.000000000000000_REALK,     -3.441933909463378_REALK, &
      0.000000000000000_REALK,   -136.359522158011004_REALK,      0.000000000000000_REALK, &
    -13.570707440151212_REALK,      0.000000000000000_REALK,     -6.398839006729168_REALK, &
     64.808457510703334_REALK,     45.480441173591913_REALK,      0.000000000000000_REALK, &
     32.960848851312427_REALK,      0.000000000000000_REALK,      3.973738380387092_REALK, &
     10.655557405207025_REALK,      0.000000000000000_REALK,      1.035055744568991_REALK, &
      0.000000000000000_REALK,   -105.269570561925448_REALK,      0.000000000000000_REALK, &
     -8.733490003821931_REALK,      0.000000000000000_REALK,     -3.158711528893076_REALK, &
      8.508323327151494_REALK,      0.220472395407806_REALK,      0.000000000000000_REALK, &
     -5.300880331640146_REALK,      0.000000000000000_REALK,     -1.344832172987217_REALK, &
    -11.992504208685887_REALK,      0.000000000000000_REALK,     -2.290401675073463_REALK, &
      0.000000000000000_REALK,    -29.572719588095829_REALK,      0.000000000000000_REALK, &
     -4.972234971224448_REALK,      0.000000000000000_REALK,     -3.784364752233053_REALK, &
     10.098804464972838_REALK,      5.498957920893444_REALK,      0.000000000000000_REALK, &
      1.764399924760266_REALK,      0.000000000000000_REALK,      0.718828438607779_REALK, &
     -0.102552090883603_REALK,      0.000000000000000_REALK,     -0.184360737382806_REALK, &
      0.000000000000000_REALK,      8.303477408882673_REALK,      0.000000000000000_REALK, &
     -1.005788431633408_REALK,      0.000000000000000_REALK,     -1.229294987607264_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.064270735907157_REALK, &
      0.000000000000000_REALK,      1.627755602940452_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      4.248085643578538_REALK,      0.000000000000000_REALK, &
      2.003050779772292_REALK,      0.000000000000000_REALK,     12.768062194840102_REALK, &
      0.000000000000000_REALK,      4.580512760439632_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.670564876385117_REALK, &
      0.000000000000000_REALK,     -2.099022408966304_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.020751581160471_REALK,      0.000000000000000_REALK, &
      0.369183429091511_REALK,      0.000000000000000_REALK,     12.317969197018233_REALK, &
      0.000000000000000_REALK,      3.589615529423323_REALK,      0.000000000000000_REALK, &
      1.369876512200389_REALK,     -3.456468018839270_REALK,      0.000000000000000_REALK, &
     -6.006565788410716_REALK,      0.000000000000000_REALK,     -2.009593402215801_REALK, &
     -8.983417083846373_REALK,      0.000000000000000_REALK,     -2.011702055450537_REALK, &
      0.000000000000000_REALK,    -16.862466066519492_REALK,      0.000000000000000_REALK, &
     -3.015409628560152_REALK,      0.000000000000000_REALK,     -3.026561686658478_REALK, &
     26.952817417941308_REALK,      9.555765959400826_REALK,      0.000000000000000_REALK, &
      3.287746977763453_REALK,      0.000000000000000_REALK,      0.824571445329534_REALK, &
     -1.935969132495212_REALK,      0.000000000000000_REALK,     -0.281227626589949_REALK, &
      0.000000000000000_REALK,    -14.928644872839639_REALK,      0.000000000000000_REALK, &
     -1.392577297817659_REALK,      0.000000000000000_REALK,     -1.047780881218306_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.949384005649440_REALK, &
      0.000000000000000_REALK,      1.479222644921078_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.177975235294354_REALK,      0.000000000000000_REALK, &
      1.657655512940236_REALK,      0.000000000000000_REALK,      3.888229157543609_REALK, &
      0.000000000000000_REALK,      2.227793233307497_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.795568533439717_REALK, &
      0.000000000000000_REALK,     -0.665754186545394_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.201945602592212_REALK,      0.000000000000000_REALK, &
      0.246822004735901_REALK,      0.000000000000000_REALK,      0.156859531214041_REALK, &
      0.000000000000000_REALK,      0.845972186163362_REALK,      0.000000000000000_REALK, &
      0.293944827100112_REALK,     -1.149113744881098_REALK,      0.000000000000000_REALK, &
     -2.743564393063917_REALK,      0.000000000000000_REALK,     -1.293641244071725_REALK, &
     -5.592761288232476_REALK,      0.000000000000000_REALK,     -2.006390167585056_REALK, &
      0.000000000000000_REALK,    -13.839430516990364_REALK,      0.000000000000000_REALK, &
     -4.131963643875452_REALK,      0.000000000000000_REALK,     -3.247161856449544_REALK, &
     14.525874659010494_REALK,      8.163228779395611_REALK,      0.000000000000000_REALK, &
      3.686086572594665_REALK,      0.000000000000000_REALK,      1.333176559228604_REALK, &
     -2.473243511226652_REALK,      0.000000000000000_REALK,     -0.720735145050835_REALK, &
      0.000000000000000_REALK,    -18.819213897809615_REALK,      0.000000000000000_REALK, &
     -4.683901024169833_REALK,      0.000000000000000_REALK,     -2.823440220493132_REALK, &
     -9.464638014202675_REALK,     -7.201453989309063_REALK,      0.000000000000000_REALK, &
     -6.839419708690413_REALK,      0.000000000000000_REALK,     -3.134804604371980_REALK, &
     -6.920217000664947_REALK,      0.000000000000000_REALK,     -2.002985662924623_REALK, &
      0.000000000000000_REALK,     -8.778717002774494_REALK,      0.000000000000000_REALK, &
     -2.135021608810140_REALK,      0.000000000000000_REALK,     -2.935720801529766_REALK, &
      4.187306267328489_REALK,      0.490327132926319_REALK,      0.000000000000000_REALK, &
     -0.624127389316745_REALK,      0.000000000000000_REALK,     -0.439830240897167_REALK, &
      0.052115780614889_REALK,      0.000000000000000_REALK,     -0.532870754674209_REALK, &
      0.000000000000000_REALK,      5.243412599072213_REALK,      0.000000000000000_REALK, &
     -0.518374460519636_REALK,      0.000000000000000_REALK,     -1.095914557258352_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.161504277434769_REALK, &
      0.000000000000000_REALK,      1.713586811390695_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.796932616172348_REALK,      0.000000000000000_REALK, &
      1.803578312579406_REALK,      0.000000000000000_REALK,      2.388729837657292_REALK, &
      0.000000000000000_REALK,      1.604761087951301_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.223813367502445_REALK, &
      0.000000000000000_REALK,      0.389941356293375_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.969822101585396_REALK,      0.000000000000000_REALK, &
      0.729698134399135_REALK,      0.000000000000000_REALK,      2.229513464751976_REALK, &
      0.000000000000000_REALK,      0.971607609261431_REALK,      0.000000000000000_REALK, &
     -1.421048862931805_REALK,     -1.591041287630548_REALK,      0.000000000000000_REALK, &
     -1.855219876434487_REALK,      0.000000000000000_REALK,     -1.412006622505192_REALK, &
     -2.317060251505085_REALK,      0.000000000000000_REALK,     -1.327578941548252_REALK, &
      0.000000000000000_REALK,     -3.444435284931249_REALK,      0.000000000000000_REALK, &
     -1.737399382106410_REALK,      0.000000000000000_REALK,     -2.203889203495630_REALK, &
      1.086059397349922_REALK,      0.180705610488400_REALK,      0.000000000000000_REALK, &
     -0.280011402603447_REALK,      0.000000000000000_REALK,     -0.342235606283806_REALK, &
     -0.109240499937850_REALK,      0.000000000000000_REALK,     -0.589154027394730_REALK, &
      0.000000000000000_REALK,      1.919992110021930_REALK,      0.000000000000000_REALK, &
     -0.697697756492359_REALK,      0.000000000000000_REALK,     -1.421233876406157_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.391431261390456_REALK, &
      0.000000000000000_REALK,      1.709062095136012_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.462305674888851_REALK,      0.000000000000000_REALK, &
      1.935037612992931_REALK,      0.000000000000000_REALK,      4.461418958756212_REALK, &
      0.000000000000000_REALK,      2.667539542336693_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.361864016618997_REALK, &
      0.000000000000000_REALK,      0.999348618047432_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.261973853801232_REALK,      0.000000000000000_REALK, &
      1.966307172054676_REALK,      0.000000000000000_REALK,      8.544758721617551_REALK, &
      0.000000000000000_REALK,      4.150088664739545_REALK,      0.000000000000000_REALK, &
    -29.453493680452233_REALK,    -12.753584720675677_REALK,      0.000000000000000_REALK, &
     -9.086786158663664_REALK,      0.000000000000000_REALK,     -5.452846868867733_REALK, &
     -6.957783297081264_REALK,      0.000000000000000_REALK,     -2.340612920101810_REALK, &
      0.000000000000000_REALK,     -7.155501404700518_REALK,      0.000000000000000_REALK, &
     -1.923422497622227_REALK,      0.000000000000000_REALK,     -3.462652744502863_REALK, &
     45.648056370814082_REALK,      7.655174867030911_REALK,      0.000000000000000_REALK, &
      0.356949419183346_REALK,      0.000000000000000_REALK,      0.168805677839537_REALK, &
     -3.413349996667941_REALK,      0.000000000000000_REALK,     -0.664121125729281_REALK, &
      0.000000000000000_REALK,    -10.259719829601947_REALK,      0.000000000000000_REALK, &
     -1.000743179806741_REALK,      0.000000000000000_REALK,     -1.419790494662208_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.292509041526632_REALK, &
      0.000000000000000_REALK,      2.207121170118241_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.718768258264154_REALK,      0.000000000000000_REALK, &
      2.363359559441288_REALK,      0.000000000000000_REALK,      1.614107414580956_REALK, &
      0.000000000000000_REALK,      1.401560388719890_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.820565145130513_REALK, &
      0.000000000000000_REALK,     -0.077405973370908_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.347229383970301_REALK,      0.000000000000000_REALK, &
      0.734090441530322_REALK,      0.000000000000000_REALK,     -0.021224516081830_REALK, &
      0.000000000000000_REALK,      0.651046023028685_REALK,      0.000000000000000_REALK, &
     -3.578290542501678_REALK,     -2.346425953016919_REALK,      0.000000000000000_REALK, &
     -1.980068101255898_REALK,      0.000000000000000_REALK,     -1.987391097871251_REALK, &
     -1.923012397435151_REALK,      0.000000000000000_REALK,     -1.291889697362508_REALK, &
      0.000000000000000_REALK,     -2.343793160296257_REALK,      0.000000000000000_REALK, &
     -1.257377734970209_REALK,      0.000000000000000_REALK,     -2.103379942299570_REALK, &
      9.554540642541831_REALK,      2.500635235909485_REALK,      0.000000000000000_REALK, &
      0.140878483405858_REALK,      0.000000000000000_REALK,      0.105997549808554_REALK, &
     -1.493423472567075_REALK,      0.000000000000000_REALK,     -0.650824331288450_REALK, &
      0.000000000000000_REALK,     -4.234105774856399_REALK,      0.000000000000000_REALK, &
     -1.184900497435862_REALK,      0.000000000000000_REALK,     -1.485873338718749_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.933470170787017_REALK, &
      0.000000000000000_REALK,      1.462879960216960_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.398668237159656_REALK,      0.000000000000000_REALK, &
      1.774209119040448_REALK,      0.000000000000000_REALK,      1.621329561613085_REALK, &
      0.000000000000000_REALK,      1.548257094241892_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.194705440302818_REALK, &
      0.000000000000000_REALK,     -0.085581804885805_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.467347797075982_REALK,      0.000000000000000_REALK, &
      0.952003235050463_REALK,      0.000000000000000_REALK,      0.133466872434545_REALK, &
      0.000000000000000_REALK,      1.199685486965720_REALK,      0.000000000000000_REALK, &
     -2.303463090567446_REALK,     -2.340230228598728_REALK,      0.000000000000000_REALK, &
     -2.713253061639105_REALK,      0.000000000000000_REALK,     -2.132248153177364_REALK, &
     -3.591600788247569_REALK,      0.000000000000000_REALK,     -2.147464116575372_REALK, &
      0.000000000000000_REALK,     -5.770821858468377_REALK,      0.000000000000000_REALK, &
     -2.871604926854870_REALK,      0.000000000000000_REALK,     -3.159367677093602_REALK, &
     15.447890769177892_REALK,      6.408672296268862_REALK,      0.000000000000000_REALK, &
      0.473841469153831_REALK,      0.000000000000000_REALK,      0.285630088091710_REALK, &
     -5.723644841815516_REALK,      0.000000000000000_REALK,     -2.779906882439964_REALK, &
      0.000000000000000_REALK,    -16.012680907416499_REALK,      0.000000000000000_REALK, &
     -6.642308308698128_REALK,      0.000000000000000_REALK,     -5.605546418356514_REALK, &
   -138.084338924072085_REALK,    -32.033262444902739_REALK,      0.000000000000000_REALK, &
    -16.718653264862144_REALK,      0.000000000000000_REALK,    -13.177002638293779_REALK, &
     -8.672179326534662_REALK,      0.000000000000000_REALK,     -3.502803187230817_REALK, &
      0.000000000000000_REALK,     -6.507102555710486_REALK,      0.000000000000000_REALK, &
     -2.222080261104156_REALK,      0.000000000000000_REALK,     -5.254075851541640_REALK, &
    -61.946088390955715_REALK,    -19.070599296124005_REALK,      0.000000000000000_REALK, &
     -7.851647939885066_REALK,      0.000000000000000_REALK,     -9.679137205184293_REALK, &
      1.842006629130886_REALK,      0.000000000000000_REALK,     -2.548374632687146_REALK, &
      0.000000000000000_REALK,     13.287474007284651_REALK,      0.000000000000000_REALK, &
     -1.071526153189115_REALK,      0.000000000000000_REALK,     -3.962779050360447_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     12.775980185906937_REALK, &
      0.000000000000000_REALK,      4.011546841359845_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.328068743605272_REALK,      0.000000000000000_REALK, &
      4.191119545706497_REALK,      0.000000000000000_REALK,      1.584935593699231_REALK, &
      0.000000000000000_REALK,      1.599526991462002_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     10.341794454862704_REALK, &
      0.000000000000000_REALK,      4.170270475731821_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.922230461698117_REALK,      0.000000000000000_REALK, &
      4.145873902965362_REALK,      0.000000000000000_REALK,      2.925093195468961_REALK, &
      0.000000000000000_REALK,      1.707369171987277_REALK,      0.000000000000000_REALK, &
    -14.148767399582256_REALK,     -5.171268699717150_REALK,      0.000000000000000_REALK, &
     -2.945775150711046_REALK,      0.000000000000000_REALK,     -4.050532018451778_REALK, &
     -1.953680496798206_REALK,      0.000000000000000_REALK,     -1.696418201038892_REALK, &
      0.000000000000000_REALK,     -1.609855216048441_REALK,      0.000000000000000_REALK, &
     -1.174571069633361_REALK,      0.000000000000000_REALK,     -2.691785965825606_REALK, &
     -9.833825198940081_REALK,     -4.742237799260907_REALK,      0.000000000000000_REALK, &
     -2.180386065400012_REALK,      0.000000000000000_REALK,     -4.609634562474008_REALK, &
      0.061976867472734_REALK,      0.000000000000000_REALK,     -1.901093666038512_REALK, &
      0.000000000000000_REALK,      3.009856512721772_REALK,      0.000000000000000_REALK, &
     -0.892681655244755_REALK,      0.000000000000000_REALK,     -3.145418661249644_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.656442753420520_REALK, &
      0.000000000000000_REALK,      2.214153391332418_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.521902653893295_REALK,      0.000000000000000_REALK, &
      2.545885319344775_REALK,      0.000000000000000_REALK,      1.314147336450567_REALK, &
      0.000000000000000_REALK,      1.471418321796615_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.493886265372918_REALK, &
      0.000000000000000_REALK,      4.086774819397171_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.459980939722215_REALK,      0.000000000000000_REALK, &
      4.338839794509047_REALK,      0.000000000000000_REALK,      3.839397813137192_REALK, &
      0.000000000000000_REALK,      2.788641400319136_REALK,      0.000000000000000_REALK, &
     -6.373013884384699_REALK,     -3.427517008188618_REALK,      0.000000000000000_REALK, &
     -2.397159778407148_REALK,      0.000000000000000_REALK,     -3.040794539871617_REALK, &
     -1.962422026435094_REALK,      0.000000000000000_REALK,     -1.873976701751987_REALK, &
      0.000000000000000_REALK,     -1.894938215243311_REALK,      0.000000000000000_REALK, &
     -1.593035438298881_REALK,      0.000000000000000_REALK,     -2.829069179588857_REALK, &
     -7.651782019770399_REALK,     -5.243125980907410_REALK,      0.000000000000000_REALK, &
     -2.934655508668070_REALK,      0.000000000000000_REALK,     -5.977992312129044_REALK, &
     -0.389731319808868_REALK,      0.000000000000000_REALK,     -3.503154001154802_REALK, &
      0.000000000000000_REALK,      3.306377658176163_REALK,      0.000000000000000_REALK, &
     -2.002484161423298_REALK,      0.000000000000000_REALK,     -5.710778945435564_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.995841770646915_REALK, &
      0.000000000000000_REALK,      3.680511553105002_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.475728126533935_REALK,      0.000000000000000_REALK, &
      3.824029898626580_REALK,      0.000000000000000_REALK,      4.090710851859765_REALK, &
      0.000000000000000_REALK,      3.424243783484856_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     17.498982848057629_REALK, &
      0.000000000000000_REALK,     17.456098214603056_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     19.395941003981264_REALK,      0.000000000000000_REALK, &
     16.368533734446775_REALK,      0.000000000000000_REALK,     24.524579366925529_REALK, &
      0.000000000000000_REALK,     16.675819062388008_REALK,      0.000000000000000_REALK, &
     22.592722061534975_REALK,     38.809554618550393_REALK,      0.000000000000000_REALK, &
      8.763371249755915_REALK,      0.000000000000000_REALK,      3.951375565084183_REALK, &
     64.923703440059569_REALK,      0.000000000000000_REALK,     15.392778807195391_REALK, &
      0.000000000000000_REALK,    -48.113979618687182_REALK,      0.000000000000000_REALK, &
     -9.050770614091354_REALK,      0.000000000000000_REALK,    -12.242889008279313_REALK, &
     25.573011644088382_REALK,     38.774142367498804_REALK,      0.000000000000000_REALK, &
     14.781545942541786_REALK,      0.000000000000000_REALK,      4.888877013195688_REALK, &
     85.699483336386422_REALK,      0.000000000000000_REALK,     17.059697737964736_REALK, &
      0.000000000000000_REALK,    -30.425795593312785_REALK,      0.000000000000000_REALK, &
     -4.782410039544085_REALK,      0.000000000000000_REALK,     -4.745230559960545_REALK, &
     23.630258070771891_REALK,     13.716096563614355_REALK,      0.000000000000000_REALK, &
      3.728979751139395_REALK,      0.000000000000000_REALK,      2.920375574195568_REALK, &
     11.742531315092288_REALK,      0.000000000000000_REALK,      4.374088827933972_REALK, &
      0.000000000000000_REALK,    -17.990621398365398_REALK,      0.000000000000000_REALK, &
     -5.962649981498851_REALK,      0.000000000000000_REALK,    -14.009068318051026_REALK, &
      7.983155504235045_REALK,      6.464357313669890_REALK,      0.000000000000000_REALK, &
      2.259752572980418_REALK,      0.000000000000000_REALK,      2.998926624559051_REALK, &
     -0.397245417677865_REALK,      0.000000000000000_REALK,      2.717625027827930_REALK, &
      0.000000000000000_REALK,      5.006937656168580_REALK,      0.000000000000000_REALK, &
     -1.056532016643791_REALK,      0.000000000000000_REALK,     -4.206383520431005_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -8.634411430571372_REALK, &
      0.000000000000000_REALK,     -1.373918486765967_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -6.106786037154153_REALK,      0.000000000000000_REALK, &
     -8.260589825775195_REALK,      0.000000000000000_REALK,      9.266090018754431_REALK, &
      0.000000000000000_REALK,      6.590699536938666_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -8.257614085369630_REALK, &
      0.000000000000000_REALK,     -3.403759102534970_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,    -10.496137410835971_REALK,      0.000000000000000_REALK, &
    -10.414538191332531_REALK,      0.000000000000000_REALK,      7.994429187379845_REALK, &
      0.000000000000000_REALK,      4.774213573339865_REALK,      0.000000000000000_REALK, &
     22.963938133244806_REALK,      5.052467687275590_REALK,      0.000000000000000_REALK, &
      1.363940221900320_REALK,      0.000000000000000_REALK,      1.461928925234949_REALK, &
      2.304710481094862_REALK,      0.000000000000000_REALK,      1.009301312809934_REALK, &
      0.000000000000000_REALK,    -12.656900838845143_REALK,      0.000000000000000_REALK, &
     -4.820047339746553_REALK,      0.000000000000000_REALK,    -15.498992948150411_REALK, &
     26.941104735571514_REALK,      5.373618970688032_REALK,      0.000000000000000_REALK, &
      3.747086925768967_REALK,      0.000000000000000_REALK,      3.646842944728828_REALK, &
      4.311118477504800_REALK,      0.000000000000000_REALK,      1.189445223008328_REALK, &
      0.000000000000000_REALK,     -8.685961798304925_REALK,      0.000000000000000_REALK, &
     -1.629042065635325_REALK,      0.000000000000000_REALK,     -4.756383303685564_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.770987976158125_REALK, &
      0.000000000000000_REALK,     -0.357163518070453_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.216961763913202_REALK,      0.000000000000000_REALK, &
     -2.859215373032913_REALK,      0.000000000000000_REALK,      3.388419620062888_REALK, &
      0.000000000000000_REALK,      3.786555387445318_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -5.854709678829726_REALK, &
      0.000000000000000_REALK,     -1.110506376288316_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.976512916001543_REALK,      0.000000000000000_REALK, &
     -3.887802520557016_REALK,      0.000000000000000_REALK,     -0.070571435266338_REALK, &
      0.000000000000000_REALK,      1.448374406813634_REALK,      0.000000000000000_REALK, &
      3.531745547666725_REALK,      2.244556706507651_REALK,      0.000000000000000_REALK, &
      0.498645837095108_REALK,      0.000000000000000_REALK,      0.674513353425523_REALK, &
      1.891185511272842_REALK,      0.000000000000000_REALK,      1.345145087969532_REALK, &
      0.000000000000000_REALK,     -9.367719680679070_REALK,      0.000000000000000_REALK, &
     -5.286514398447640_REALK,      0.000000000000000_REALK,    -11.918360653198123_REALK, &
     10.479694564628582_REALK,      6.645051332306740_REALK,      0.000000000000000_REALK, &
      4.289049225620281_REALK,      0.000000000000000_REALK,      4.255705238635018_REALK, &
      7.388951053594196_REALK,      0.000000000000000_REALK,      4.412626541054530_REALK, &
      0.000000000000000_REALK,    -11.863004507643995_REALK,      0.000000000000000_REALK, &
     -5.593978801558380_REALK,      0.000000000000000_REALK,     -9.250816687763855_REALK, &
     18.030917141007290_REALK,      0.863262874057076_REALK,      0.000000000000000_REALK, &
     -0.875759042581794_REALK,      0.000000000000000_REALK,     -1.145142854528216_REALK, &
     -0.080576994101268_REALK,      0.000000000000000_REALK,     -0.055449864665222_REALK, &
      0.000000000000000_REALK,     -9.969655575544655_REALK,      0.000000000000000_REALK, &
     -4.642864659453556_REALK,      0.000000000000000_REALK,    -18.213034741750590_REALK, &
     11.987955223356446_REALK,      0.543859594964661_REALK,      0.000000000000000_REALK, &
      1.113153320074507_REALK,      0.000000000000000_REALK,      2.199888313488220_REALK, &
     -0.550757751676060_REALK,      0.000000000000000_REALK,      0.082130899419076_REALK, &
      0.000000000000000_REALK,      2.869051228409992_REALK,      0.000000000000000_REALK, &
     -1.042619518446978_REALK,      0.000000000000000_REALK,     -6.181484040022541_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.243705157389139_REALK, &
      0.000000000000000_REALK,      0.142635012475388_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.134459747270149_REALK,      0.000000000000000_REALK, &
      0.432358964105052_REALK,      0.000000000000000_REALK,      1.726724602586625_REALK, &
      0.000000000000000_REALK,      2.268552283526704_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.202375547370993_REALK, &
      0.000000000000000_REALK,     -0.441744113324230_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.496899720627669_REALK,      0.000000000000000_REALK, &
     -1.450819217413964_REALK,      0.000000000000000_REALK,      1.499640454634223_REALK, &
      0.000000000000000_REALK,      1.241260371967633_REALK,      0.000000000000000_REALK, &
      2.120748028355782_REALK,      0.548159088785479_REALK,      0.000000000000000_REALK, &
     -0.171981700781279_REALK,      0.000000000000000_REALK,     -0.404065877281951_REALK, &
     -0.094523147522204_REALK,      0.000000000000000_REALK,     -0.105629518660929_REALK, &
      0.000000000000000_REALK,     -2.750999308808342_REALK,      0.000000000000000_REALK, &
     -2.735299512099085_REALK,      0.000000000000000_REALK,    -10.710841056192979_REALK, &
      2.622730979553935_REALK,      0.975160849678353_REALK,      0.000000000000000_REALK, &
      0.362663890597457_REALK,      0.000000000000000_REALK,      1.443878073577451_REALK, &
     -0.021526102491688_REALK,      0.000000000000000_REALK,      0.441791438841256_REALK, &
      0.000000000000000_REALK,      1.609773236902515_REALK,      0.000000000000000_REALK, &
     -1.019052211821600_REALK,      0.000000000000000_REALK,     -6.761941210707207_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.035213862784380_REALK, &
      0.000000000000000_REALK,      0.190096638108577_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.147472283953263_REALK,      0.000000000000000_REALK, &
      0.332473863501054_REALK,      0.000000000000000_REALK,      4.250715971255789_REALK, &
      0.000000000000000_REALK,      5.039017127092977_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.737031344528273_REALK, &
      0.000000000000000_REALK,     -1.638790724535492_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.706307382926545_REALK,      0.000000000000000_REALK, &
     -2.821736973338944_REALK,      0.000000000000000_REALK,      7.710831870036228_REALK, &
      0.000000000000000_REALK,      7.674752279120923_REALK,      0.000000000000000_REALK, &
      1.359446316058158_REALK,      0.451568229273068_REALK,      0.000000000000000_REALK, &
     -5.070083304173502_REALK,      0.000000000000000_REALK,     -6.862784160812634_REALK, &
      1.367996282162826_REALK,      0.000000000000000_REALK,      0.448271751989611_REALK, &
      0.000000000000000_REALK,    -13.160721763372877_REALK,      0.000000000000000_REALK, &
     -5.855419711430152_REALK,      0.000000000000000_REALK,    -23.777409111267204_REALK, &
     69.318115933765000_REALK,     -2.297412483287416_REALK,      0.000000000000000_REALK, &
      2.921613659487305_REALK,      0.000000000000000_REALK,      4.072293502821906_REALK, &
      0.000722373425234_REALK,      0.000000000000000_REALK,     -0.008774670716862_REALK, &
      0.000000000000000_REALK,     -9.144272535269412_REALK,      0.000000000000000_REALK, &
     -2.222137862287664_REALK,      0.000000000000000_REALK,     -9.291985834181032_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.359785383279579_REALK, &
      0.000000000000000_REALK,      0.259005609833998_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.032317583742386_REALK,      0.000000000000000_REALK, &
      4.049576586071101_REALK,      0.000000000000000_REALK,      0.434673013008501_REALK, &
      0.000000000000000_REALK,      0.897373748441915_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -7.605511793880445_REALK, &
      0.000000000000000_REALK,     -0.119388788268182_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.014698555237859_REALK,      0.000000000000000_REALK, &
     -0.087144814581597_REALK,      0.000000000000000_REALK,     -0.608927793021711_REALK, &
      0.000000000000000_REALK,      0.272416251082898_REALK,      0.000000000000000_REALK, &
      0.133350182666360_REALK,     -0.169370139577773_REALK,      0.000000000000000_REALK, &
     -0.628059762635864_REALK,      0.000000000000000_REALK,     -2.019543200715147_REALK, &
     -0.383928522642000_REALK,      0.000000000000000_REALK,     -0.504401179809360_REALK, &
      0.000000000000000_REALK,     -1.904671046423478_REALK,      0.000000000000000_REALK, &
     -2.176031414158595_REALK,      0.000000000000000_REALK,    -11.661813382650033_REALK, &
     11.966211897576155_REALK,      1.527209378387692_REALK,      0.000000000000000_REALK, &
      0.722313477097475_REALK,      0.000000000000000_REALK,      2.108969335395040_REALK, &
      0.021141507203129_REALK,      0.000000000000000_REALK,      0.017498937837945_REALK, &
      0.000000000000000_REALK,     -2.929270966050011_REALK,      0.000000000000000_REALK, &
     -1.648144121335280_REALK,      0.000000000000000_REALK,     -8.020260644946738_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.479802909861757_REALK, &
      0.000000000000000_REALK,      0.493394132923912_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.608180076365653_REALK,      0.000000000000000_REALK, &
      2.381501587918188_REALK,      0.000000000000000_REALK,      1.529716830124718_REALK, &
      0.000000000000000_REALK,      2.849094934050218_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.991813288969262_REALK, &
      0.000000000000000_REALK,     -0.642205855817811_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.014366310011186_REALK,      0.000000000000000_REALK, &
     -0.095327935687203_REALK,      0.000000000000000_REALK,     -0.071398951949744_REALK, &
      0.000000000000000_REALK,      2.442263272834708_REALK,      0.000000000000000_REALK, &
      0.061525890443502_REALK,     -0.225727845996231_REALK,      0.000000000000000_REALK, &
     -0.688841155330787_REALK,      0.000000000000000_REALK,     -1.552981171186969_REALK, &
     -0.945125297091559_REALK,      0.000000000000000_REALK,     -1.120400090596084_REALK, &
      0.000000000000000_REALK,     -4.229097946009225_REALK,      0.000000000000000_REALK, &
     -3.977700007066967_REALK,      0.000000000000000_REALK,    -12.554723879258409_REALK, &
     13.964042716108299_REALK,      5.665670437329365_REALK,      0.000000000000000_REALK, &
      2.480357238281238_REALK,      0.000000000000000_REALK,      4.101790683424793_REALK, &
      0.108705127964988_REALK,      0.000000000000000_REALK,      0.108196488091433_REALK, &
      0.000000000000000_REALK,    -12.002109431730444_REALK,      0.000000000000000_REALK, &
     -9.432622470951923_REALK,      0.000000000000000_REALK,    -21.838346236687428_REALK, &
   -118.979834224311460_REALK,     15.378512926367296_REALK,      0.000000000000000_REALK, &
    -20.306664148908688_REALK,      0.000000000000000_REALK,    -25.260440382456657_REALK, &
     10.113074909004219_REALK,      0.000000000000000_REALK,      4.039750446819080_REALK, &
      0.000000000000000_REALK,    -24.142914915235600_REALK,      0.000000000000000_REALK, &
     -9.714245412538862_REALK,      0.000000000000000_REALK,    -36.252057251438579_REALK, &
    -45.883289804433439_REALK,     10.683552392224046_REALK,      0.000000000000000_REALK, &
    -11.593422678170354_REALK,      0.000000000000000_REALK,    -16.945683372393951_REALK, &
     10.288695181613647_REALK,      0.000000000000000_REALK,      3.615159842414137_REALK, &
      0.000000000000000_REALK,     -4.380343975043947_REALK,      0.000000000000000_REALK, &
     -5.506875649427108_REALK,      0.000000000000000_REALK,    -24.147598267606320_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     14.194671285559911_REALK, &
      0.000000000000000_REALK,     -0.711119768644262_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.754737938637817_REALK,      0.000000000000000_REALK, &
     11.186308444031615_REALK,      0.000000000000000_REALK,     -1.038142047130075_REALK, &
      0.000000000000000_REALK,     -1.020550480324381_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     10.388873070279386_REALK, &
      0.000000000000000_REALK,     -0.705255036607761_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.522109715492408_REALK,      0.000000000000000_REALK, &
     10.546333846487515_REALK,      0.000000000000000_REALK,      0.027578505591138_REALK, &
      0.000000000000000_REALK,     -1.004988404772980_REALK,      0.000000000000000_REALK, &
    -10.086074769757257_REALK,     -0.535715448214570_REALK,      0.000000000000000_REALK, &
     -1.637625922356361_REALK,      0.000000000000000_REALK,     -6.424080821985054_REALK, &
     -0.204496056448200_REALK,      0.000000000000000_REALK,     -0.422178021695868_REALK, &
      0.000000000000000_REALK,     -1.682206550935613_REALK,      0.000000000000000_REALK, &
     -2.350208776840376_REALK,      0.000000000000000_REALK,    -15.365669416978301_REALK, &
     -6.321659872327311_REALK,     -0.304574060409232_REALK,      0.000000000000000_REALK, &
     -1.181381096436745_REALK,      0.000000000000000_REALK,     -7.004173875131080_REALK, &
      0.691128452864008_REALK,      0.000000000000000_REALK,     -0.309190390557889_REALK, &
      0.000000000000000_REALK,      1.544173407909959_REALK,      0.000000000000000_REALK, &
     -1.683468024911447_REALK,      0.000000000000000_REALK,    -16.634912582778384_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.177131497859111_REALK, &
      0.000000000000000_REALK,      0.800161171650713_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.023734691562577_REALK,      0.000000000000000_REALK, &
      5.486411109999468_REALK,      0.000000000000000_REALK,      0.874064529949689_REALK, &
      0.000000000000000_REALK,      1.913894358522050_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.380215035912340_REALK, &
      0.000000000000000_REALK,      1.406458936605049_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.870631148272696_REALK,      0.000000000000000_REALK, &
      9.102935347394295_REALK,      0.000000000000000_REALK,      2.421397940066253_REALK, &
      0.000000000000000_REALK,      3.340339900007776_REALK,      0.000000000000000_REALK, &
     -3.558891044953816_REALK,     -1.020514031472830_REALK,      0.000000000000000_REALK, &
     -0.964791721270930_REALK,      0.000000000000000_REALK,     -3.777915629770872_REALK, &
     -0.719669843494123_REALK,      0.000000000000000_REALK,     -1.340383831117717_REALK, &
      0.000000000000000_REALK,     -1.392550331502475_REALK,      0.000000000000000_REALK, &
     -2.307671876504464_REALK,      0.000000000000000_REALK,    -12.650881264613323_REALK, &
     -4.149167947437577_REALK,     -1.638338473505936_REALK,      0.000000000000000_REALK, &
     -1.154677231749250_REALK,      0.000000000000000_REALK,     -7.661883726716690_REALK, &
      0.081037272009324_REALK,      0.000000000000000_REALK,     -2.771950396392333_REALK, &
      0.000000000000000_REALK,      2.599224092524410_REALK,      0.000000000000000_REALK, &
     -2.742358364299435_REALK,      0.000000000000000_REALK,    -25.475762823683866_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.212115771254651_REALK, &
      0.000000000000000_REALK,      1.777356368491767_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.871346830458201_REALK,      0.000000000000000_REALK, &
      5.906489352386341_REALK,      0.000000000000000_REALK,      3.586173162568095_REALK, &
      0.000000000000000_REALK,      5.951727509610206_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     10.464123654502293_REALK, &
      0.000000000000000_REALK,      8.696180247894883_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     10.705955368614356_REALK,      0.000000000000000_REALK, &
     24.786358285229685_REALK,      0.000000000000000_REALK,     20.750520953878656_REALK, &
      0.000000000000000_REALK,     28.914798679973007_REALK,      0.000000000000000_REALK/
    ! results of test 8, ket-major order, SQHDR002
  data REF_CONTR_INTS(79381:80640)                                                         &
   /-58.548788719033148_REALK,    -41.883399814949165_REALK,      0.000000000000000_REALK, &
    -40.171303901448383_REALK,      0.000000000000000_REALK,    -10.191450954864177_REALK, &
    -46.370332746342470_REALK,      0.000000000000000_REALK,     -8.856089266077861_REALK, &
      0.000000000000000_REALK,    -71.585593920407220_REALK,      0.000000000000000_REALK, &
    -12.036106198031272_REALK,      0.000000000000000_REALK,     -9.160672476978005_REALK, &
    -20.842584358697390_REALK,    -18.728381504507681_REALK,      0.000000000000000_REALK, &
    -13.842741340714612_REALK,      0.000000000000000_REALK,     -5.639626257266616_REALK, &
     -2.562147394806938_REALK,      0.000000000000000_REALK,     -4.606043415791206_REALK, &
      0.000000000000000_REALK,     34.503486431951508_REALK,      0.000000000000000_REALK, &
     -4.179358333311440_REALK,      0.000000000000000_REALK,     -5.108096383859573_REALK, &
    -33.176698866965218_REALK,    -11.982970382632487_REALK,      0.000000000000000_REALK, &
     -4.105822040336166_REALK,      0.000000000000000_REALK,     -5.036418746444696_REALK, &
      3.398840413337189_REALK,      0.000000000000000_REALK,     -2.183942467000221_REALK, &
      0.000000000000000_REALK,     17.031325608052938_REALK,      0.000000000000000_REALK, &
     -1.012779554849125_REALK,      0.000000000000000_REALK,     -3.726987107049885_REALK, &
    -12.500974714007555_REALK,      3.654659718027619_REALK,      0.000000000000000_REALK, &
     11.148556440642349_REALK,      0.000000000000000_REALK,     -1.530582959720324_REALK, &
     20.131731408046583_REALK,      0.000000000000000_REALK,      0.600515074043454_REALK, &
      0.000000000000000_REALK,     36.754212096926096_REALK,      0.000000000000000_REALK, &
      2.501415099455899_REALK,      0.000000000000000_REALK,     -1.030256252493006_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.377532768527326_REALK, &
      0.000000000000000_REALK,      6.095971674346316_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      6.018285029253223_REALK,      0.000000000000000_REALK, &
      4.580512760439631_REALK,      0.000000000000000_REALK,      7.873284975640716_REALK, &
      0.000000000000000_REALK,      4.511064107063818_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      7.281983886630690_REALK, &
      0.000000000000000_REALK,      4.469394585246675_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.936962901421232_REALK,      0.000000000000000_REALK, &
      3.589615529423321_REALK,      0.000000000000000_REALK,      0.557817213188908_REALK, &
      0.000000000000000_REALK,      3.008410414519546_REALK,      0.000000000000000_REALK, &
    -27.612700938654843_REALK,     -5.036935743479733_REALK,      0.000000000000000_REALK, &
     -0.163286483020700_REALK,      0.000000000000000_REALK,     -3.642850568542405_REALK, &
      3.133121445405020_REALK,      0.000000000000000_REALK,     -0.785460927261612_REALK, &
      0.000000000000000_REALK,      6.347923555592708_REALK,      0.000000000000000_REALK, &
     -0.033077736690732_REALK,      0.000000000000000_REALK,     -2.213849848697873_REALK, &
     -6.745007267164157_REALK,     -0.128519724909376_REALK,      0.000000000000000_REALK, &
      1.325286855017149_REALK,      0.000000000000000_REALK,     -1.386098839196177_REALK, &
      1.448316199685684_REALK,      0.000000000000000_REALK,     -0.023455874848139_REALK, &
      0.000000000000000_REALK,      0.224624075723628_REALK,      0.000000000000000_REALK, &
      0.269485000656460_REALK,      0.000000000000000_REALK,     -0.845551689832161_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.762066440423276_REALK, &
      0.000000000000000_REALK,      1.732288346526820_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.605385362041409_REALK,      0.000000000000000_REALK, &
      2.227793233307496_REALK,      0.000000000000000_REALK,     -0.546129095785215_REALK, &
      0.000000000000000_REALK,      1.052754215881542_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.545087152658807_REALK, &
      0.000000000000000_REALK,     -0.594275595956878_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.053981807990159_REALK,      0.000000000000000_REALK, &
      0.845972186163362_REALK,      0.000000000000000_REALK,     -4.051070652720109_REALK, &
      0.000000000000000_REALK,     -0.362521575069464_REALK,      0.000000000000000_REALK, &
     -9.179929919489004_REALK,     -5.763901612165967_REALK,      0.000000000000000_REALK, &
     -4.773662850456000_REALK,      0.000000000000000_REALK,     -3.633231642281247_REALK, &
     -4.706227976870538_REALK,      0.000000000000000_REALK,     -2.696472459945803_REALK, &
      0.000000000000000_REALK,     -5.751444258757945_REALK,      0.000000000000000_REALK, &
     -2.901072273037338_REALK,      0.000000000000000_REALK,     -3.680006984551770_REALK, &
     -5.762074717451478_REALK,     -4.511747703691475_REALK,      0.000000000000000_REALK, &
     -2.906447238356999_REALK,      0.000000000000000_REALK,     -3.552318668106819_REALK, &
     -0.458039294766793_REALK,      0.000000000000000_REALK,     -2.470289822642938_REALK, &
      0.000000000000000_REALK,      4.879109029305623_REALK,      0.000000000000000_REALK, &
     -1.772998652264911_REALK,      0.000000000000000_REALK,     -3.611658091162212_REALK, &
    -28.098024036907592_REALK,      0.213448511339733_REALK,      0.000000000000000_REALK, &
      3.043525149786451_REALK,      0.000000000000000_REALK,     -3.151281175801051_REALK, &
      5.378898935859300_REALK,      0.000000000000000_REALK,      0.027996187127858_REALK, &
      0.000000000000000_REALK,      7.651687418293939_REALK,      0.000000000000000_REALK, &
      0.501737787330507_REALK,      0.000000000000000_REALK,     -1.558505450017691_REALK, &
    -13.443400589293722_REALK,      8.263101921921043_REALK,      0.000000000000000_REALK, &
      9.405029730660580_REALK,      0.000000000000000_REALK,     -1.184822557372308_REALK, &
     11.339590078214901_REALK,      0.000000000000000_REALK,      0.913642600473051_REALK, &
      0.000000000000000_REALK,     15.200616795168704_REALK,      0.000000000000000_REALK, &
      1.320169205880631_REALK,      0.000000000000000_REALK,     -0.498935027151412_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.078339474286108_REALK, &
      0.000000000000000_REALK,      0.736409487114968_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.023977174761878_REALK,      0.000000000000000_REALK, &
      1.604761087951301_REALK,      0.000000000000000_REALK,     -0.484252569206133_REALK, &
      0.000000000000000_REALK,      0.364200506107382_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.929114987736772_REALK, &
      0.000000000000000_REALK,      0.036320835506326_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.309660166691419_REALK,      0.000000000000000_REALK, &
      0.971607609261431_REALK,      0.000000000000000_REALK,     -0.314801656064485_REALK, &
      0.000000000000000_REALK,      0.015294895372098_REALK,      0.000000000000000_REALK, &
     -6.207790317055784_REALK,     -1.939376818114439_REALK,      0.000000000000000_REALK, &
     -0.567579504587295_REALK,      0.000000000000000_REALK,     -2.088669232800358_REALK, &
      0.395874509027620_REALK,      0.000000000000000_REALK,     -0.763113632939945_REALK, &
      0.000000000000000_REALK,      1.573476084396624_REALK,      0.000000000000000_REALK, &
     -0.280703530364212_REALK,      0.000000000000000_REALK,     -1.721629077722734_REALK, &
     -4.954443161303671_REALK,      1.255827871534008_REALK,      0.000000000000000_REALK, &
      3.180539453931907_REALK,      0.000000000000000_REALK,     -1.309966770180124_REALK, &
      4.655009408850949_REALK,      0.000000000000000_REALK,      0.416566751736781_REALK, &
      0.000000000000000_REALK,      6.559814566251029_REALK,      0.000000000000000_REALK, &
      1.339341936840764_REALK,      0.000000000000000_REALK,     -0.919389858535431_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.067570642039764_REALK, &
      0.000000000000000_REALK,      2.528079796624879_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.102910411852460_REALK,      0.000000000000000_REALK, &
      2.667539542336693_REALK,      0.000000000000000_REALK,      2.182171705228680_REALK, &
      0.000000000000000_REALK,      2.083822378537802_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      7.506787797328322_REALK, &
      0.000000000000000_REALK,      3.825182001611945_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.037319542336661_REALK,      0.000000000000000_REALK, &
      4.150088664739545_REALK,      0.000000000000000_REALK,      0.298674133244842_REALK, &
      0.000000000000000_REALK,      2.684673855391543_REALK,      0.000000000000000_REALK, &
    -34.731101028983119_REALK,      5.741573273795579_REALK,      0.000000000000000_REALK, &
      4.799503853606663_REALK,      0.000000000000000_REALK,     -3.314291928075968_REALK, &
      5.598972318981986_REALK,      0.000000000000000_REALK,      0.627834932447559_REALK, &
      0.000000000000000_REALK,      5.252490659866500_REALK,      0.000000000000000_REALK, &
      0.637903221463851_REALK,      0.000000000000000_REALK,     -1.321510032460471_REALK, &
     -9.140072498300194_REALK,      6.394433844948512_REALK,      0.000000000000000_REALK, &
      3.856664836922022_REALK,      0.000000000000000_REALK,     -1.428145312711879_REALK, &
      1.509201094912630_REALK,      0.000000000000000_REALK,      0.854478286069115_REALK, &
      0.000000000000000_REALK,     -2.874957969087014_REALK,      0.000000000000000_REALK, &
      0.526324826136724_REALK,      0.000000000000000_REALK,     -0.584703388960519_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.272440229957429_REALK, &
      0.000000000000000_REALK,     -0.031913548648296_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.451211645258231_REALK,      0.000000000000000_REALK, &
      1.401560388719890_REALK,      0.000000000000000_REALK,     -0.814944524080200_REALK, &
      0.000000000000000_REALK,     -0.012724912477647_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.624020486007222_REALK, &
      0.000000000000000_REALK,     -1.316055844316343_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.722650975459959_REALK,      0.000000000000000_REALK, &
      0.651046023028685_REALK,      0.000000000000000_REALK,     -2.229139715865523_REALK, &
      0.000000000000000_REALK,     -0.538812336100357_REALK,      0.000000000000000_REALK, &
     -6.389886343025059_REALK,     -0.998408375181732_REALK,      0.000000000000000_REALK, &
     -0.027332176689534_REALK,      0.000000000000000_REALK,     -1.829306998675724_REALK, &
      0.435487228567246_REALK,      0.000000000000000_REALK,     -0.327524682641340_REALK, &
      0.000000000000000_REALK,      0.697153757778255_REALK,      0.000000000000000_REALK, &
     -0.010898178702432_REALK,      0.000000000000000_REALK,     -1.215668184769466_REALK, &
     -2.985691084138681_REALK,     -0.049784485081032_REALK,      0.000000000000000_REALK, &
      0.446049770353540_REALK,      0.000000000000000_REALK,     -1.399551500650995_REALK, &
      0.410775662301677_REALK,      0.000000000000000_REALK,     -0.019957870790303_REALK, &
      0.000000000000000_REALK,      0.050739593438078_REALK,      0.000000000000000_REALK, &
      0.182619240527797_REALK,      0.000000000000000_REALK,     -0.954994446493589_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.831773478614511_REALK, &
      0.000000000000000_REALK,      0.869892172737094_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.252436043215534_REALK,      0.000000000000000_REALK, &
      1.548257094241892_REALK,      0.000000000000000_REALK,     -0.179934090899660_REALK, &
      0.000000000000000_REALK,      0.578087898500370_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.795553990362404_REALK, &
      0.000000000000000_REALK,     -0.600043285949249_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.747668922813663_REALK,      0.000000000000000_REALK, &
      1.199685486965721_REALK,      0.000000000000000_REALK,     -2.745249064408206_REALK, &
      0.000000000000000_REALK,     -0.409444029369946_REALK,      0.000000000000000_REALK, &
     -6.373013884384699_REALK,     -3.427517008188617_REALK,      0.000000000000000_REALK, &
     -2.397159778407148_REALK,      0.000000000000000_REALK,     -3.040794539871617_REALK, &
     -1.962422026435094_REALK,      0.000000000000000_REALK,     -1.873976701751987_REALK, &
      0.000000000000000_REALK,     -1.894938215243311_REALK,      0.000000000000000_REALK, &
     -1.593035438298881_REALK,      0.000000000000000_REALK,     -2.829069179588857_REALK, &
     -7.651782019770399_REALK,     -5.243125980907410_REALK,      0.000000000000000_REALK, &
     -2.934655508668071_REALK,      0.000000000000000_REALK,     -5.977992312129044_REALK, &
     -0.389731319808868_REALK,      0.000000000000000_REALK,     -3.503154001154802_REALK, &
      0.000000000000000_REALK,      3.306377658176163_REALK,      0.000000000000000_REALK, &
     -2.002484161423298_REALK,      0.000000000000000_REALK,     -5.710778945435564_REALK, &
    -61.899045022555235_REALK,     19.697708660398863_REALK,      0.000000000000000_REALK, &
      8.759913400686871_REALK,      0.000000000000000_REALK,     -4.503872081549534_REALK, &
      8.227811035662597_REALK,      0.000000000000000_REALK,      1.649084722354313_REALK, &
      0.000000000000000_REALK,      5.989335253113605_REALK,      0.000000000000000_REALK, &
      0.880868612722880_REALK,      0.000000000000000_REALK,     -1.358684511211527_REALK, &
    -61.743964250781801_REALK,     62.287274472090886_REALK,      0.000000000000000_REALK, &
     31.071743938471794_REALK,      0.000000000000000_REALK,     -3.628631648703105_REALK, &
     25.888815510173849_REALK,      0.000000000000000_REALK,      4.106584833179313_REALK, &
      0.000000000000000_REALK,     24.159958192936880_REALK,      0.000000000000000_REALK, &
      2.359701614230572_REALK,      0.000000000000000_REALK,     -0.826714584400053_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.368586615586753_REALK, &
      0.000000000000000_REALK,     -0.977095235452922_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.772104180527675_REALK,      0.000000000000000_REALK, &
      1.599526991462002_REALK,      0.000000000000000_REALK,     -0.876215764478378_REALK, &
      0.000000000000000_REALK,     -0.294760627822210_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.632263917657347_REALK, &
      0.000000000000000_REALK,     -3.552813957438312_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.536900246456559_REALK,      0.000000000000000_REALK, &
      1.707369171987278_REALK,      0.000000000000000_REALK,     -0.476551682706152_REALK, &
      0.000000000000000_REALK,     -0.809440968008996_REALK,      0.000000000000000_REALK, &
     -9.992631709557806_REALK,      0.061323565693081_REALK,      0.000000000000000_REALK, &
      0.702217614817916_REALK,      0.000000000000000_REALK,     -2.181238900930599_REALK, &
      0.986391121362468_REALK,      0.000000000000000_REALK,      0.015401957209581_REALK, &
      0.000000000000000_REALK,      1.076870430387502_REALK,      0.000000000000000_REALK, &
      0.211838209318048_REALK,      0.000000000000000_REALK,     -1.096691711889103_REALK, &
    -15.353715769476747_REALK,      7.954751717065622_REALK,      0.000000000000000_REALK, &
      7.162567532949366_REALK,      0.000000000000000_REALK,     -2.706968023952713_REALK, &
      6.509222458394650_REALK,      0.000000000000000_REALK,      1.573364528944633_REALK, &
      0.000000000000000_REALK,      6.263135428626641_REALK,      0.000000000000000_REALK, &
      1.631854543118449_REALK,      0.000000000000000_REALK,     -1.027885146781678_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.515109809391044_REALK, &
      0.000000000000000_REALK,      0.509724436094219_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.013190918391941_REALK,      0.000000000000000_REALK, &
      1.471418321796615_REALK,      0.000000000000000_REALK,     -0.204455792863609_REALK, &
      0.000000000000000_REALK,      0.256281218977610_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.459431832627603_REALK, &
      0.000000000000000_REALK,      0.082982333267627_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.533259200093234_REALK,      0.000000000000000_REALK, &
      2.788641400319137_REALK,      0.000000000000000_REALK,     -0.389124750328777_REALK, &
      0.000000000000000_REALK,      0.031509905937689_REALK,      0.000000000000000_REALK, &
     -6.623116517412377_REALK,     -1.671543656540007_REALK,      0.000000000000000_REALK, &
     -0.392864497234850_REALK,      0.000000000000000_REALK,     -2.409541986047896_REALK, &
      0.217788308835099_REALK,      0.000000000000000_REALK,     -0.699705015002636_REALK, &
      0.000000000000000_REALK,      0.664335763699989_REALK,      0.000000000000000_REALK, &
     -0.197525927961913_REALK,      0.000000000000000_REALK,     -1.696070345246544_REALK, &
    -16.975417400400666_REALK,      3.626894238441710_REALK,      0.000000000000000_REALK, &
      7.266589032376336_REALK,      0.000000000000000_REALK,     -4.988142369580626_REALK, &
      8.016292893958200_REALK,      0.000000000000000_REALK,      1.195601268265784_REALK, &
      0.000000000000000_REALK,      8.108553929502294_REALK,      0.000000000000000_REALK, &
      2.759256433047825_REALK,      0.000000000000000_REALK,     -2.651724131536841_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.843046969799631_REALK, &
      0.000000000000000_REALK,      2.916457195991702_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.928175435165135_REALK,      0.000000000000000_REALK, &
      3.424243783484856_REALK,      0.000000000000000_REALK,      1.535554221524243_REALK, &
      0.000000000000000_REALK,      2.052886644824826_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     36.133303016648497_REALK, &
      0.000000000000000_REALK,     14.565676662908128_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      5.847374564880098_REALK,      0.000000000000000_REALK, &
     16.675819062388012_REALK,      0.000000000000000_REALK,      0.615316000247660_REALK, &
      0.000000000000000_REALK,      7.743194447443924_REALK,      0.000000000000000_REALK, &
    -42.569402484578895_REALK,     -6.016415895994814_REALK,      0.000000000000000_REALK, &
    -23.555325500808287_REALK,      0.000000000000000_REALK,    -18.447511605223255_REALK, &
     -8.187604218231654_REALK,      0.000000000000000_REALK,     -3.049879721630588_REALK, &
      0.000000000000000_REALK,    -88.662336940815450_REALK,      0.000000000000000_REALK, &
    -29.385448674264893_REALK,      0.000000000000000_REALK,    -69.040235350336260_REALK, &
    -11.433179793251677_REALK,     -1.657204505242454_REALK,      0.000000000000000_REALK, &
     -5.906694485779332_REALK,      0.000000000000000_REALK,     -7.838797737566851_REALK, &
      0.205432510644914_REALK,      0.000000000000000_REALK,     -1.405399553056327_REALK, &
      0.000000000000000_REALK,     41.644852767591324_REALK,      0.000000000000000_REALK, &
     -8.787630943071521_REALK,      0.000000000000000_REALK,    -34.986299894618398_REALK, &
    -19.832059378190362_REALK,      2.093097996306803_REALK,      0.000000000000000_REALK, &
      1.949540854743890_REALK,      0.000000000000000_REALK,     -7.604914318157121_REALK, &
      8.312884865752057_REALK,      0.000000000000000_REALK,      0.903939303497714_REALK, &
      0.000000000000000_REALK,     50.473983007852190_REALK,      0.000000000000000_REALK, &
      2.088361226732203_REALK,      0.000000000000000_REALK,    -24.439305525730489_REALK, &
     -4.990028002127130_REALK,      4.128029115926410_REALK,      0.000000000000000_REALK, &
      7.897667692154026_REALK,      0.000000000000000_REALK,     -1.788356873748601_REALK, &
     11.774001319332745_REALK,      0.000000000000000_REALK,      1.937000347946497_REALK, &
      0.000000000000000_REALK,     67.622872789381219_REALK,      0.000000000000000_REALK, &
      9.320468983115092_REALK,      0.000000000000000_REALK,     -6.331612859226934_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.086986092114821_REALK, &
      0.000000000000000_REALK,      3.577804329111118_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.805185439873636_REALK,      0.000000000000000_REALK, &
      6.590699536938661_REALK,      0.000000000000000_REALK,     10.288782689434894_REALK, &
      0.000000000000000_REALK,     11.497703912542791_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.391514213767258_REALK, &
      0.000000000000000_REALK,      2.029771564850410_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.199155871077604_REALK,      0.000000000000000_REALK, &
      4.774213573339859_REALK,      0.000000000000000_REALK,     -0.350151052671840_REALK, &
      0.000000000000000_REALK,      7.186332845502662_REALK,      0.000000000000000_REALK, &
    -11.918947886218486_REALK,      7.380674627580816_REALK,      0.000000000000000_REALK, &
      2.529327352476005_REALK,      0.000000000000000_REALK,     -3.847190931094640_REALK, &
      8.606152633647300_REALK,      0.000000000000000_REALK,      2.776833230025203_REALK, &
      0.000000000000000_REALK,     14.850455198203793_REALK,      0.000000000000000_REALK, &
      2.171355468210914_REALK,      0.000000000000000_REALK,     -9.908111408323172_REALK, &
     -2.086759650901683_REALK,      3.458794437951016_REALK,      0.000000000000000_REALK, &
      0.751872020201989_REALK,      0.000000000000000_REALK,     -1.164778294151416_REALK, &
      1.748015775933987_REALK,      0.000000000000000_REALK,      1.755905428767346_REALK, &
      0.000000000000000_REALK,     -9.640531021264042_REALK,      0.000000000000000_REALK, &
      0.711790197912266_REALK,      0.000000000000000_REALK,     -3.308054097937644_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.354820756711827_REALK, &
      0.000000000000000_REALK,     -0.703233885576399_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.323564654719393_REALK,      0.000000000000000_REALK, &
      3.786555387445317_REALK,      0.000000000000000_REALK,     -5.551855714924351_REALK, &
      0.000000000000000_REALK,     -1.811118764104704_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.951005914153813_REALK, &
      0.000000000000000_REALK,     -1.753169274926086_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.132083725708465_REALK,      0.000000000000000_REALK, &
      1.448374406813633_REALK,      0.000000000000000_REALK,    -10.088493343332498_REALK, &
      0.000000000000000_REALK,     -4.979126786117537_REALK,      0.000000000000000_REALK, &
     -5.294987730431703_REALK,     -1.578307358190466_REALK,      0.000000000000000_REALK, &
     -2.182338403708613_REALK,      0.000000000000000_REALK,     -5.127338999525722_REALK, &
     -1.594114263268098_REALK,      0.000000000000000_REALK,     -1.781421024728103_REALK, &
      0.000000000000000_REALK,     -5.652685580962337_REALK,      0.000000000000000_REALK, &
     -5.620426025607922_REALK,      0.000000000000000_REALK,    -22.008372232033715_REALK, &
     -2.580500231606986_REALK,     -1.079384540574274_REALK,      0.000000000000000_REALK, &
     -1.085349949084548_REALK,      0.000000000000000_REALK,     -4.321116698604596_REALK, &
      0.080098046814357_REALK,      0.000000000000000_REALK,     -1.643894028849560_REALK, &
      0.000000000000000_REALK,      4.869309629343979_REALK,      0.000000000000000_REALK, &
     -3.082471887391487_REALK,      0.000000000000000_REALK,    -20.453803489558471_REALK, &
     -5.333681995736967_REALK,     13.407942204040650_REALK,      0.000000000000000_REALK, &
      2.089963485580470_REALK,      0.000000000000000_REALK,     -1.404763792408670_REALK, &
     10.511778020644325_REALK,      0.000000000000000_REALK,      4.284312106743672_REALK, &
      0.000000000000000_REALK,      6.781495715790767_REALK,      0.000000000000000_REALK, &
      1.365196995691214_REALK,      0.000000000000000_REALK,     -2.752841361512302_REALK, &
     -1.207513309010609_REALK,     10.748702764432293_REALK,      0.000000000000000_REALK, &
      3.001226122313749_REALK,      0.000000000000000_REALK,     -0.273439358374098_REALK, &
      9.547005655385975_REALK,      0.000000000000000_REALK,      3.356521084193497_REALK, &
      0.000000000000000_REALK,     15.375487958318327_REALK,      0.000000000000000_REALK, &
      1.827960356559977_REALK,      0.000000000000000_REALK,     -0.499632103674053_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.366511211643798_REALK, &
      0.000000000000000_REALK,     -1.962427400598370_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.497151596581785_REALK,      0.000000000000000_REALK, &
      2.268552283526704_REALK,      0.000000000000000_REALK,     -3.972916805862728_REALK, &
      0.000000000000000_REALK,     -3.845665261680275_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.324976908817735_REALK, &
      0.000000000000000_REALK,     -1.783167017808158_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.267080567507741_REALK,      0.000000000000000_REALK, &
      1.241260371967634_REALK,      0.000000000000000_REALK,     -1.081195685428999_REALK, &
      0.000000000000000_REALK,     -3.258226956087219_REALK,      0.000000000000000_REALK, &
     -3.386808758396092_REALK,      0.432578186118478_REALK,      0.000000000000000_REALK, &
      0.228667727474841_REALK,      0.000000000000000_REALK,     -2.676012360360086_REALK, &
      1.271147894978496_REALK,      0.000000000000000_REALK,      0.414672124558107_REALK, &
      0.000000000000000_REALK,      3.610135119852972_REALK,      0.000000000000000_REALK, &
      0.448108060328365_REALK,      0.000000000000000_REALK,     -8.740066656670496_REALK, &
     -2.165117091460372_REALK,      1.994292663410354_REALK,      0.000000000000000_REALK, &
      2.165185730735963_REALK,      0.000000000000000_REALK,     -1.470861374055087_REALK, &
      3.785442023981659_REALK,      0.000000000000000_REALK,      1.868286486144025_REALK, &
      0.000000000000000_REALK,      9.567953643391911_REALK,      0.000000000000000_REALK, &
      3.956256728823308_REALK,      0.000000000000000_REALK,     -4.479296414518813_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.153964917676612_REALK, &
      0.000000000000000_REALK,      1.258955486821485_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.286847691687753_REALK,      0.000000000000000_REALK, &
      5.039017127092976_REALK,      0.000000000000000_REALK,      2.207705446302056_REALK, &
      0.000000000000000_REALK,      4.111847551825289_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.915424570243187_REALK, &
      0.000000000000000_REALK,      1.669416567083639_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.156616575257547_REALK,      0.000000000000000_REALK, &
      7.674752279120921_REALK,      0.000000000000000_REALK,     -0.148628514374879_REALK, &
      0.000000000000000_REALK,      5.083967649962903_REALK,      0.000000000000000_REALK, &
      7.119556385490884_REALK,     22.076201878928988_REALK,      0.000000000000000_REALK, &
      0.167468312923398_REALK,      0.000000000000000_REALK,      1.511542950095011_REALK, &
     12.669751186831022_REALK,      0.000000000000000_REALK,      5.799152807002790_REALK, &
      0.000000000000000_REALK,     -3.111420920282452_REALK,      0.000000000000000_REALK, &
      0.080113024898241_REALK,      0.000000000000000_REALK,      2.169263113991822_REALK, &
      1.682475241569535_REALK,     12.975244525163680_REALK,      0.000000000000000_REALK, &
     -2.704413019665570_REALK,      0.000000000000000_REALK,      0.621374205011223_REALK, &
      5.088470198070773_REALK,      0.000000000000000_REALK,      4.390635364601853_REALK, &
      0.000000000000000_REALK,    -15.999094587118615_REALK,      0.000000000000000_REALK, &
     -1.284596155717866_REALK,      0.000000000000000_REALK,      0.885458222411275_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.138706789925854_REALK, &
      0.000000000000000_REALK,     -3.212088640036259_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.445028167083355_REALK,      0.000000000000000_REALK, &
      0.897373748441915_REALK,      0.000000000000000_REALK,     -3.770101880275150_REALK, &
      0.000000000000000_REALK,     -4.609770040120152_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.268348972825677_REALK, &
      0.000000000000000_REALK,     -3.350893076161843_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.996665554115568_REALK,      0.000000000000000_REALK, &
      0.272416251082898_REALK,      0.000000000000000_REALK,     -4.527223865390631_REALK, &
      0.000000000000000_REALK,     -4.775022527133915_REALK,      0.000000000000000_REALK, &
     -2.670339010969770_REALK,      1.590750998761375_REALK,      0.000000000000000_REALK, &
      0.372730780570973_REALK,      0.000000000000000_REALK,     -1.700807699741284_REALK, &
      1.295095059297693_REALK,      0.000000000000000_REALK,      1.253613484371306_REALK, &
      0.000000000000000_REALK,      1.219479721218381_REALK,      0.000000000000000_REALK, &
      0.534917736668461_REALK,      0.000000000000000_REALK,     -4.068138241137567_REALK, &
     -1.118428661166391_REALK,      1.749971329843395_REALK,      0.000000000000000_REALK, &
      0.266632743245260_REALK,      0.000000000000000_REALK,     -1.239179102949034_REALK, &
      0.589504303557963_REALK,      0.000000000000000_REALK,      1.776495077132926_REALK, &
      0.000000000000000_REALK,     -1.715362984531505_REALK,      0.000000000000000_REALK, &
      0.379951650658440_REALK,      0.000000000000000_REALK,     -2.943050303927120_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.169185638991086_REALK, &
      0.000000000000000_REALK,     -0.310893228001815_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.146074675942457_REALK,      0.000000000000000_REALK, &
      2.849094934050218_REALK,      0.000000000000000_REALK,     -1.367710693534739_REALK, &
      0.000000000000000_REALK,     -0.743621180652740_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.443479611873005_REALK, &
      0.000000000000000_REALK,     -1.865153858317266_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.157084419640559_REALK,      0.000000000000000_REALK, &
      2.442263272834708_REALK,      0.000000000000000_REALK,     -5.385210009492615_REALK, &
      0.000000000000000_REALK,     -4.429740314800348_REALK,      0.000000000000000_REALK, &
     -3.558891044953816_REALK,     -1.020514031472830_REALK,      0.000000000000000_REALK, &
     -0.964791721270930_REALK,      0.000000000000000_REALK,     -3.777915629770872_REALK, &
     -0.719669843494123_REALK,      0.000000000000000_REALK,     -1.340383831117717_REALK, &
      0.000000000000000_REALK,     -1.392550331502475_REALK,      0.000000000000000_REALK, &
     -2.307671876504464_REALK,      0.000000000000000_REALK,    -12.650881264613322_REALK, &
     -4.149167947437577_REALK,     -1.638338473505936_REALK,      0.000000000000000_REALK, &
     -1.154677231749250_REALK,      0.000000000000000_REALK,     -7.661883726716691_REALK, &
      0.081037272009324_REALK,      0.000000000000000_REALK,     -2.771950396392333_REALK, &
      0.000000000000000_REALK,      2.599224092524411_REALK,      0.000000000000000_REALK, &
     -2.742358364299435_REALK,      0.000000000000000_REALK,    -25.475762823683866_REALK, &
     49.988115970775333_REALK,     40.526351018788525_REALK,      0.000000000000000_REALK, &
     -3.432639369353387_REALK,      0.000000000000000_REALK,      7.845530055205593_REALK, &
     18.710298983404090_REALK,      0.000000000000000_REALK,      8.054815472192523_REALK, &
      0.000000000000000_REALK,    -11.052282466911757_REALK,      0.000000000000000_REALK, &
     -1.132391108161579_REALK,      0.000000000000000_REALK,      7.764470004609988_REALK, &
     55.905598383597770_REALK,     74.450813237353373_REALK,      0.000000000000000_REALK, &
    -10.054076650868410_REALK,      0.000000000000000_REALK,      7.060453665908582_REALK, &
     30.891069969589751_REALK,      0.000000000000000_REALK,     11.678104414824650_REALK, &
      0.000000000000000_REALK,     -1.078031463854097_REALK,      0.000000000000000_REALK, &
     -2.297944338439546_REALK,      0.000000000000000_REALK,      4.841179381794744_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.711571880647154_REALK, &
      0.000000000000000_REALK,     -5.298519843685139_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.037689935127181_REALK,      0.000000000000000_REALK, &
     -1.020550480324380_REALK,      0.000000000000000_REALK,     -3.818795218810083_REALK, &
      0.000000000000000_REALK,     -5.243775513654059_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.135683480002582_REALK, &
      0.000000000000000_REALK,     -9.732523256092705_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.458006948985963_REALK,      0.000000000000000_REALK, &
     -1.004988404772978_REALK,      0.000000000000000_REALK,     -2.577998303840630_REALK, &
      0.000000000000000_REALK,     -6.673351763178883_REALK,      0.000000000000000_REALK, &
     -1.741352111280609_REALK,      3.637158040455714_REALK,      0.000000000000000_REALK, &
      0.406609491552383_REALK,      0.000000000000000_REALK,     -0.819904694971994_REALK, &
      1.773680315665551_REALK,      0.000000000000000_REALK,      2.168710193929611_REALK, &
      0.000000000000000_REALK,      0.666309417307221_REALK,      0.000000000000000_REALK, &
      0.402408400520169_REALK,      0.000000000000000_REALK,     -1.352389060172541_REALK, &
     -1.593795254066759_REALK,     11.517129176426996_REALK,      0.000000000000000_REALK, &
      2.209263552646645_REALK,      0.000000000000000_REALK,     -0.603852809180459_REALK, &
      5.138364945258597_REALK,      0.000000000000000_REALK,      5.419614557569036_REALK, &
      0.000000000000000_REALK,      4.247241691341153_REALK,      0.000000000000000_REALK, &
      1.514837667112881_REALK,      0.000000000000000_REALK,     -0.690078359402202_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      1.925882842483814_REALK, &
      0.000000000000000_REALK,     -1.145390739701100_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.251657140883412_REALK,      0.000000000000000_REALK, &
      1.913894358522050_REALK,      0.000000000000000_REALK,     -1.171065496256431_REALK, &
      0.000000000000000_REALK,     -1.889260929342053_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.259099134771572_REALK, &
      0.000000000000000_REALK,     -3.937876461325834_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.431242258100265_REALK,      0.000000000000000_REALK, &
      3.340339900007778_REALK,      0.000000000000000_REALK,     -0.895990957314854_REALK, &
      0.000000000000000_REALK,     -4.500175020545749_REALK,      0.000000000000000_REALK, &
     -3.317198093165548_REALK,      0.352035055899724_REALK,      0.000000000000000_REALK, &
      0.133464248123685_REALK,      0.000000000000000_REALK,     -2.603136448892787_REALK, &
      0.643452514463827_REALK,      0.000000000000000_REALK,      0.349843662670326_REALK, &
      0.000000000000000_REALK,      1.064131186800760_REALK,      0.000000000000000_REALK, &
      0.220142158220950_REALK,      0.000000000000000_REALK,     -6.011228607533408_REALK, &
     -8.573205742210289_REALK,      6.410594856925734_REALK,      0.000000000000000_REALK, &
      4.781511680237358_REALK,      0.000000000000000_REALK,     -5.413654773520530_REALK, &
      6.112172748330605_REALK,      0.000000000000000_REALK,      5.027721850508690_REALK, &
      0.000000000000000_REALK,      7.928999403179580_REALK,      0.000000000000000_REALK, &
      5.464274878904445_REALK,      0.000000000000000_REALK,     -8.661356421230632_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      4.277863330953822_REALK, &
      0.000000000000000_REALK,      1.224670320595075_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.085666200106039_REALK,      0.000000000000000_REALK, &
      5.951727509610205_REALK,      0.000000000000000_REALK,      1.084580003557497_REALK, &
      0.000000000000000_REALK,      2.828039716892085_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     26.334145139729312_REALK, &
      0.000000000000000_REALK,      6.144457340986722_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.112556062044230_REALK,      0.000000000000000_REALK, &
     28.914798679973007_REALK,      0.000000000000000_REALK,     -0.205281687477620_REALK, &
      0.000000000000000_REALK,      9.830574218666738_REALK,      0.000000000000000_REALK/
    ! results of test 8, ket-major order, SQHDR003
  data REF_CONTR_INTS(80641:81900)                                                         &
     /0.000000000000000_REALK,      0.000000000000000_REALK,     12.209587161337501_REALK, &
      0.000000000000000_REALK,     12.335510502417661_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     16.425689030404968_REALK,      0.000000000000000_REALK, &
      7.745015515490884_REALK,      0.000000000000000_REALK,     30.907178242688616_REALK, &
      0.000000000000000_REALK,     11.087878659224394_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     12.501230293251162_REALK, &
      0.000000000000000_REALK,     16.468048920163149_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     25.502317718550895_REALK,      0.000000000000000_REALK, &
      9.223628235199079_REALK,      0.000000000000000_REALK,     51.184926763798529_REALK, &
      0.000000000000000_REALK,     14.915949621647259_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.377532768527326_REALK, &
      0.000000000000000_REALK,      6.095971674346316_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      6.018285029253223_REALK,      0.000000000000000_REALK, &
      4.580512760439631_REALK,      0.000000000000000_REALK,      7.873284975640716_REALK, &
      0.000000000000000_REALK,      4.511064107063819_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      7.281983886630690_REALK, &
      0.000000000000000_REALK,      4.469394585246675_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.936962901421232_REALK,      0.000000000000000_REALK, &
      3.589615529423321_REALK,      0.000000000000000_REALK,      0.557817213188908_REALK, &
      0.000000000000000_REALK,      3.008410414519546_REALK,      0.000000000000000_REALK, &
      9.671464072433743_REALK,      8.377532768527326_REALK,      0.000000000000000_REALK, &
      9.341216610459950_REALK,      0.000000000000000_REALK,     -2.085933847353482_REALK, &
     12.768062194840098_REALK,      0.000000000000000_REALK,     -2.169264405147247_REALK, &
      0.000000000000000_REALK,     23.152677876284958_REALK,      0.000000000000000_REALK, &
     -3.273692581597516_REALK,      0.000000000000000_REALK,     -4.173680944286846_REALK, &
      8.344424410208855_REALK,      7.281983886630688_REALK,      0.000000000000000_REALK, &
      8.474391014111331_REALK,      0.000000000000000_REALK,     -4.944991743065289_REALK, &
     12.317969197018222_REALK,      0.000000000000000_REALK,     -5.791390766173673_REALK, &
      0.000000000000000_REALK,     22.918735512041494_REALK,      0.000000000000000_REALK, &
     -9.203050765809667_REALK,      0.000000000000000_REALK,     -7.344780697013848_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      7.830530914734441_REALK, &
      0.000000000000000_REALK,      4.409227071396122_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.649786208748017_REALK,      0.000000000000000_REALK, &
      3.663284417237144_REALK,      0.000000000000000_REALK,      3.988649916176913_REALK, &
      0.000000000000000_REALK,      2.679595690577733_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.588035945067877_REALK, &
      0.000000000000000_REALK,      4.047492236325485_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      4.066409726357447_REALK,      0.000000000000000_REALK, &
      3.059583387690254_REALK,      0.000000000000000_REALK,      5.665668738974966_REALK, &
      0.000000000000000_REALK,      2.469061947986520_REALK,      0.000000000000000_REALK, &
      7.584348092057158_REALK,      4.762066440423276_REALK,      0.000000000000000_REALK, &
      3.943943041996059_REALK,      0.000000000000000_REALK,     -1.421576946812007_REALK, &
      3.888229157543608_REALK,      0.000000000000000_REALK,     -1.055050562194704_REALK, &
      0.000000000000000_REALK,      4.751774324319903_REALK,      0.000000000000000_REALK, &
     -1.135104466335632_REALK,      0.000000000000000_REALK,     -2.335930053365532_REALK, &
      1.973272488466079_REALK,      1.545087152658806_REALK,      0.000000000000000_REALK, &
      0.995338078011720_REALK,      0.000000000000000_REALK,     -1.962704994138220_REALK, &
      0.156859531214041_REALK,      0.000000000000000_REALK,     -1.364869153040839_REALK, &
      0.000000000000000_REALK,     -1.670893226461585_REALK,      0.000000000000000_REALK, &
     -0.979606176845403_REALK,      0.000000000000000_REALK,     -2.641957742099135_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.096159137619855_REALK, &
      0.000000000000000_REALK,     -0.956292917411944_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.087562797168843_REALK,      0.000000000000000_REALK, &
      1.059311695339401_REALK,      0.000000000000000_REALK,     -1.619976210467590_REALK, &
      0.000000000000000_REALK,      1.200517439536801_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.948902948583891_REALK, &
      0.000000000000000_REALK,      1.089449164175546_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.436490510177777_REALK,      0.000000000000000_REALK, &
      3.817393384087546_REALK,      0.000000000000000_REALK,      2.280573693318199_REALK, &
      0.000000000000000_REALK,      4.883092478005741_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      9.030438649538032_REALK, &
      0.000000000000000_REALK,      3.814242173398460_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.584183704067790_REALK,      0.000000000000000_REALK, &
      3.553332586284230_REALK,      0.000000000000000_REALK,      2.172451309525271_REALK, &
      0.000000000000000_REALK,      1.886381088611597_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      9.647483267783709_REALK, &
      0.000000000000000_REALK,      3.459753350034372_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.513684699194594_REALK,      0.000000000000000_REALK, &
      3.200136625719711_REALK,      0.000000000000000_REALK,     -0.047496534747906_REALK, &
      0.000000000000000_REALK,      1.456920380942887_REALK,      0.000000000000000_REALK, &
      8.433574557777296_REALK,      4.078339474286109_REALK,      0.000000000000000_REALK, &
      2.827099580562477_REALK,      0.000000000000000_REALK,     -1.343824985817980_REALK, &
      2.388729837657292_REALK,      0.000000000000000_REALK,     -0.759991574944114_REALK, &
      0.000000000000000_REALK,      2.606248323964255_REALK,      0.000000000000000_REALK, &
     -0.662156534175242_REALK,      0.000000000000000_REALK,     -1.796993633538033_REALK, &
      6.136337466412070_REALK,      2.929114987736770_REALK,      0.000000000000000_REALK, &
      2.156371113477830_REALK,      0.000000000000000_REALK,     -2.617638069261470_REALK, &
      2.229513464751975_REALK,      0.000000000000000_REALK,     -1.567566022181966_REALK, &
      0.000000000000000_REALK,      3.244845379612820_REALK,      0.000000000000000_REALK, &
     -1.465038776130367_REALK,      0.000000000000000_REALK,     -2.432344893617436_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -0.884528533212159_REALK, &
      0.000000000000000_REALK,     -0.549752889658612_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.457296117453453_REALK,      0.000000000000000_REALK, &
      0.718968044003764_REALK,      0.000000000000000_REALK,     -0.474532173502724_REALK, &
      0.000000000000000_REALK,      0.561641796033587_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.788419517281384_REALK, &
      0.000000000000000_REALK,      0.401749487083899_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.213974676450648_REALK,      0.000000000000000_REALK, &
      1.921559648281265_REALK,      0.000000000000000_REALK,      0.031369011928263_REALK, &
      0.000000000000000_REALK,      1.243048369820754_REALK,      0.000000000000000_REALK, &
      5.428968800785845_REALK,      4.067570642039763_REALK,      0.000000000000000_REALK, &
      3.873925643090009_REALK,      0.000000000000000_REALK,      0.352687364375603_REALK, &
      4.461418958756211_REALK,      0.000000000000000_REALK,      0.309030995432941_REALK, &
      0.000000000000000_REALK,      6.417031609832157_REALK,      0.000000000000000_REALK, &
      0.369923886448416_REALK,      0.000000000000000_REALK,     -0.924215874479916_REALK, &
      9.921300714539553_REALK,      7.506787797328318_REALK,      0.000000000000000_REALK, &
      7.252903578664793_REALK,      0.000000000000000_REALK,     -2.483416594686618_REALK, &
      8.544758721617548_REALK,      0.000000000000000_REALK,     -2.357350514541346_REALK, &
      0.000000000000000_REALK,     12.271463307835534_REALK,      0.000000000000000_REALK, &
     -2.891466206971180_REALK,      0.000000000000000_REALK,     -5.327016188642625_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     12.775980185906935_REALK, &
      0.000000000000000_REALK,      4.011546841359845_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.328068743605272_REALK,      0.000000000000000_REALK, &
      4.191119545706497_REALK,      0.000000000000000_REALK,      1.584935593699231_REALK, &
      0.000000000000000_REALK,      1.599526991462002_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     10.341794454862704_REALK, &
      0.000000000000000_REALK,      4.170270475731821_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.922230461698117_REALK,      0.000000000000000_REALK, &
      4.145873902965363_REALK,      0.000000000000000_REALK,      2.925093195468961_REALK, &
      0.000000000000000_REALK,      1.707369171987277_REALK,      0.000000000000000_REALK, &
     11.689542074189989_REALK,      4.272440229957429_REALK,      0.000000000000000_REALK, &
      2.433764128906156_REALK,      0.000000000000000_REALK,     -1.584854340897326_REALK, &
      1.614107414580956_REALK,      0.000000000000000_REALK,     -0.663758671119298_REALK, &
      0.000000000000000_REALK,      1.330043087845806_REALK,      0.000000000000000_REALK, &
     -0.459575198991359_REALK,      0.000000000000000_REALK,     -1.708644511055313_REALK, &
      3.367678774223799_REALK,      1.624020486007222_REALK,      0.000000000000000_REALK, &
      0.746692128801760_REALK,      0.000000000000000_REALK,     -2.546886589355904_REALK, &
     -0.021224516081830_REALK,      0.000000000000000_REALK,     -1.050380436349446_REALK, &
      0.000000000000000_REALK,     -1.030751481371144_REALK,      0.000000000000000_REALK, &
     -0.493218910413295_REALK,      0.000000000000000_REALK,     -2.300899745899662_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.012583883879152_REALK, &
      0.000000000000000_REALK,     -0.481486868673010_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.330950938682374_REALK,      0.000000000000000_REALK, &
      0.686179214687037_REALK,      0.000000000000000_REALK,     -0.285772742069054_REALK, &
      0.000000000000000_REALK,      0.396583719170183_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      0.682036952802597_REALK, &
      0.000000000000000_REALK,      0.429223939365061_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.363393314950164_REALK,      0.000000000000000_REALK, &
      2.008954541217929_REALK,      0.000000000000000_REALK,      0.403242538914203_REALK, &
      0.000000000000000_REALK,      1.291187061594046_REALK,      0.000000000000000_REALK, &
      5.265307700451096_REALK,      2.831773478614510_REALK,      0.000000000000000_REALK, &
      1.980504682625120_REALK,      0.000000000000000_REALK,      0.291042989792464_REALK, &
      1.621329561613085_REALK,      0.000000000000000_REALK,      0.179363575844341_REALK, &
      0.000000000000000_REALK,      1.565575245496733_REALK,      0.000000000000000_REALK, &
      0.152473898097512_REALK,      0.000000000000000_REALK,     -0.614892508004647_REALK, &
      2.620419152431701_REALK,      1.795553990362403_REALK,      0.000000000000000_REALK, &
      1.004998244962257_REALK,      0.000000000000000_REALK,     -1.162867719394524_REALK, &
      0.133466872434545_REALK,      0.000000000000000_REALK,     -0.681450308282489_REALK, &
      0.000000000000000_REALK,     -1.132297720749378_REALK,      0.000000000000000_REALK, &
     -0.389532817764470_REALK,      0.000000000000000_REALK,     -2.425142623301481_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.302835328577121_REALK, &
      0.000000000000000_REALK,     -1.696533321276294_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.602138316177109_REALK,      0.000000000000000_REALK, &
     -0.166483001784953_REALK,      0.000000000000000_REALK,     -1.885614857541144_REALK, &
      0.000000000000000_REALK,     -0.149077909700123_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.294346251984427_REALK, &
      0.000000000000000_REALK,     -1.291174206782622_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.434658446162249_REALK,      0.000000000000000_REALK, &
      3.811916504273468_REALK,      0.000000000000000_REALK,     -1.814008143256060_REALK, &
      0.000000000000000_REALK,      3.883477343631684_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     25.320305047632353_REALK, &
      0.000000000000000_REALK,      5.451388777667954_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.689557602686869_REALK,      0.000000000000000_REALK, &
      6.359419098833770_REALK,      0.000000000000000_REALK,      1.357159815298884_REALK, &
      0.000000000000000_REALK,      1.644522171744617_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     58.504457569314233_REALK, &
      0.000000000000000_REALK,     10.595823336182809_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      3.128921014440612_REALK,      0.000000000000000_REALK, &
     11.571553908744834_REALK,      0.000000000000000_REALK,     -0.581639757370457_REALK, &
      0.000000000000000_REALK,      2.414056463647814_REALK,      0.000000000000000_REALK, &
     24.687493947734477_REALK,      6.368586615586751_REALK,      0.000000000000000_REALK, &
      2.993409351822925_REALK,      0.000000000000000_REALK,     -2.552106257837468_REALK, &
      1.584935593699231_REALK,      0.000000000000000_REALK,     -0.757512782764906_REALK, &
      0.000000000000000_REALK,      1.119806060174584_REALK,      0.000000000000000_REALK, &
     -0.427658473249786_REALK,      0.000000000000000_REALK,     -2.081680080089664_REALK, &
     33.483131662241782_REALK,      8.632263917657344_REALK,      0.000000000000000_REALK, &
      4.160965111688048_REALK,      0.000000000000000_REALK,     -9.524246645950939_REALK, &
      2.925093195468960_REALK,      0.000000000000000_REALK,     -2.754624269938247_REALK, &
      0.000000000000000_REALK,      3.239652267263647_REALK,      0.000000000000000_REALK, &
     -1.529472678652441_REALK,      0.000000000000000_REALK,     -4.788155278988532_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.692548464126261_REALK, &
      0.000000000000000_REALK,     -0.574117897650379_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.309155623829725_REALK,      0.000000000000000_REALK, &
      0.878133114703220_REALK,      0.000000000000000_REALK,     -0.199459295521049_REALK, &
      0.000000000000000_REALK,      0.357770387786017_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.926321482061439_REALK, &
      0.000000000000000_REALK,      0.830191299452567_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.273773659979538_REALK,      0.000000000000000_REALK, &
      4.252719891318524_REALK,      0.000000000000000_REALK,     -0.006166191376032_REALK, &
      0.000000000000000_REALK,      1.389737926960930_REALK,      0.000000000000000_REALK, &
      8.997814697603234_REALK,      3.515109809391043_REALK,      0.000000000000000_REALK, &
      1.956848417488457_REALK,      0.000000000000000_REALK,      0.379227936292395_REALK, &
      1.314147336450567_REALK,      0.000000000000000_REALK,      0.170461903737989_REALK, &
      0.000000000000000_REALK,      1.100381497921879_REALK,      0.000000000000000_REALK, &
      0.113980271523382_REALK,      0.000000000000000_REALK,     -0.606171136363365_REALK, &
     21.024943956497498_REALK,      8.459431832627596_REALK,      0.000000000000000_REALK, &
      4.926668230309153_REALK,      0.000000000000000_REALK,     -3.509296092392921_REALK, &
      3.839397813137191_REALK,      0.000000000000000_REALK,     -1.584015612911292_REALK, &
      0.000000000000000_REALK,      4.010937121432044_REALK,      0.000000000000000_REALK, &
     -1.062628768055102_REALK,      0.000000000000000_REALK,     -4.072644342372906_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.693354915211359_REALK, &
      0.000000000000000_REALK,     -1.344342149639977_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.888793263606078_REALK,      0.000000000000000_REALK, &
     -0.149077909700123_REALK,      0.000000000000000_REALK,     -0.707814352938138_REALK, &
      0.000000000000000_REALK,     -0.089374492358814_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -2.672669933876064_REALK, &
      0.000000000000000_REALK,     -1.077378563082873_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.432512416162618_REALK,      0.000000000000000_REALK, &
      3.883477343631684_REALK,      0.000000000000000_REALK,     -0.045513042993525_REALK, &
      0.000000000000000_REALK,      1.803240973740631_REALK,      0.000000000000000_REALK, &
      9.653647836174191_REALK,      5.843046969799632_REALK,      0.000000000000000_REALK, &
      4.469059217834127_REALK,      0.000000000000000_REALK,      1.811698385266843_REALK, &
      4.090710851859765_REALK,      0.000000000000000_REALK,      1.261708366790227_REALK, &
      0.000000000000000_REALK,      4.515547495424822_REALK,      0.000000000000000_REALK, &
      1.159096992549553_REALK,      0.000000000000000_REALK,      0.078360397804388_REALK, &
     56.655617089868251_REALK,     36.133303016648483_REALK,      0.000000000000000_REALK, &
     27.617888076844999_REALK,      0.000000000000000_REALK,     -2.797261161047656_REALK, &
     24.524579366925522_REALK,      0.000000000000000_REALK,     -2.001385739657431_REALK, &
      0.000000000000000_REALK,     25.281157218838896_REALK,      0.000000000000000_REALK, &
     -1.762071765904239_REALK,      0.000000000000000_REALK,    -11.824233594654910_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.787390234715580_REALK, &
      0.000000000000000_REALK,      8.678807429153174_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      4.258021186060472_REALK,      0.000000000000000_REALK, &
      5.759783669102943_REALK,      0.000000000000000_REALK,     45.665637510518543_REALK, &
      0.000000000000000_REALK,     32.480635886919686_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      2.116924328407710_REALK, &
      0.000000000000000_REALK,      8.896976316016673_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      5.427999328441814_REALK,      0.000000000000000_REALK, &
      5.385800899502728_REALK,      0.000000000000000_REALK,     66.493104035198101_REALK, &
      0.000000000000000_REALK,     39.709186531976371_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      5.086986092114822_REALK, &
      0.000000000000000_REALK,      3.577804329111118_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.805185439873637_REALK,      0.000000000000000_REALK, &
      6.590699536938662_REALK,      0.000000000000000_REALK,     10.288782689434894_REALK, &
      0.000000000000000_REALK,     11.497703912542791_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.391514213767257_REALK, &
      0.000000000000000_REALK,      2.029771564850410_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.199155871077604_REALK,      0.000000000000000_REALK, &
      4.774213573339859_REALK,      0.000000000000000_REALK,     -0.350151052671840_REALK, &
      0.000000000000000_REALK,      7.186332845502663_REALK,      0.000000000000000_REALK, &
     12.484467384188038_REALK,      5.086986092114821_REALK,      0.000000000000000_REALK, &
     10.617430600697588_REALK,      0.000000000000000_REALK,      0.282842126983386_REALK, &
      9.266090018754426_REALK,      0.000000000000000_REALK,      0.129794958057873_REALK, &
      0.000000000000000_REALK,     60.461432602990122_REALK,      0.000000000000000_REALK, &
      0.671955132770830_REALK,      0.000000000000000_REALK,    -13.566877755744644_REALK, &
      6.374295775640051_REALK,      3.391514213767257_REALK,      0.000000000000000_REALK, &
      6.907074851853642_REALK,      0.000000000000000_REALK,     -2.901228800887829_REALK, &
      7.994429187379834_REALK,      0.000000000000000_REALK,     -2.021059742962373_REALK, &
      0.000000000000000_REALK,     51.859485735397001_REALK,      0.000000000000000_REALK, &
    -10.352175715425401_REALK,      0.000000000000000_REALK,    -28.631436784575698_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      6.460271173033566_REALK, &
      0.000000000000000_REALK,      1.809947593403386_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.267637151084264_REALK,      0.000000000000000_REALK, &
      7.291648761164852_REALK,      0.000000000000000_REALK,      3.548031158016675_REALK, &
      0.000000000000000_REALK,      4.661365323390552_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      3.544640517598148_REALK, &
      0.000000000000000_REALK,      1.322014579711824_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.848950459110981_REALK,      0.000000000000000_REALK, &
      5.398459179522448_REALK,      0.000000000000000_REALK,      4.536175368622069_REALK, &
      0.000000000000000_REALK,      3.754616453541590_REALK,      0.000000000000000_REALK, &
     11.254927408405994_REALK,      3.354820756711827_REALK,      0.000000000000000_REALK, &
      4.638737909278308_REALK,      0.000000000000000_REALK,      0.214632795328984_REALK, &
      3.388419620062888_REALK,      0.000000000000000_REALK,      0.074571112663037_REALK, &
      0.000000000000000_REALK,     12.015243304650177_REALK,      0.000000000000000_REALK, &
      0.235273647583588_REALK,      0.000000000000000_REALK,     -8.250580473962405_REALK, &
      2.273583592764694_REALK,      0.951005914153812_REALK,      0.000000000000000_REALK, &
      0.956261815605389_REALK,      0.000000000000000_REALK,     -1.611685608073121_REALK, &
     -0.070571435266337_REALK,      0.000000000000000_REALK,     -0.613137883628496_REALK, &
      0.000000000000000_REALK,     -4.290169148511706_REALK,      0.000000000000000_REALK, &
     -1.149697155784555_REALK,      0.000000000000000_REALK,    -12.758824396011622_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.230222977691808_REALK, &
      0.000000000000000_REALK,     -2.614157520545937_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.695312592643982_REALK,      0.000000000000000_REALK, &
     -1.403080532039517_REALK,      0.000000000000000_REALK,     -9.465507327657408_REALK, &
      0.000000000000000_REALK,     -2.590919969547953_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.050829703338274_REALK, &
      0.000000000000000_REALK,     -1.245932843966685_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.612944616738928_REALK,      0.000000000000000_REALK, &
      2.599437630362601_REALK,      0.000000000000000_REALK,     -5.925289654755171_REALK, &
      0.000000000000000_REALK,      5.747426229418918_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      8.938493923825762_REALK, &
      0.000000000000000_REALK,      0.660884497522678_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.184279872609441_REALK,      0.000000000000000_REALK, &
      8.568495556841087_REALK,      0.000000000000000_REALK,      0.627325240385276_REALK, &
      0.000000000000000_REALK,      1.295100421718040_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,      7.489126170549058_REALK, &
      0.000000000000000_REALK,      0.310351609617659_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      1.183365290545023_REALK,      0.000000000000000_REALK, &
      7.015937767898883_REALK,      0.000000000000000_REALK,     -1.267582097032667_REALK, &
      0.000000000000000_REALK,      0.567078669705466_REALK,      0.000000000000000_REALK, &
     13.862764357589402_REALK,      2.366511211643798_REALK,      0.000000000000000_REALK, &
      3.406395771061145_REALK,      0.000000000000000_REALK,      0.215711645289892_REALK, &
      1.726724602586625_REALK,      0.000000000000000_REALK,      0.044676084358294_REALK, &
      0.000000000000000_REALK,      5.842891265510258_REALK,      0.000000000000000_REALK, &
      0.131461715241603_REALK,      0.000000000000000_REALK,     -6.309468164992644_REALK, &
      7.110127558109665_REALK,      1.324976908817734_REALK,      0.000000000000000_REALK, &
      1.654334017352063_REALK,      0.000000000000000_REALK,     -2.044772781070226_REALK, &
      1.499640454634223_REALK,      0.000000000000000_REALK,     -0.525460650174332_REALK, &
      0.000000000000000_REALK,      5.372505528510194_REALK,      0.000000000000000_REALK, &
     -1.279645925382504_REALK,      0.000000000000000_REALK,    -10.414426594942304_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -3.418017794505352_REALK, &
      0.000000000000000_REALK,     -1.364356411299563_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.394583777503472_REALK,      0.000000000000000_REALK, &
     -1.260926146221406_REALK,      0.000000000000000_REALK,     -2.392536599945948_REALK, &
      0.000000000000000_REALK,     -1.028918131573026_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.248724691488136_REALK, &
      0.000000000000000_REALK,     -0.424102060342178_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.293829282795217_REALK,      0.000000000000000_REALK, &
      1.900074883189671_REALK,      0.000000000000000_REALK,      0.037757897228790_REALK, &
      0.000000000000000_REALK,      1.258662024170218_REALK,      0.000000000000000_REALK, &
      6.396083635244229_REALK,      3.153964917676612_REALK,      0.000000000000000_REALK, &
      3.736054652831021_REALK,      0.000000000000000_REALK,      3.468676064307997_REALK, &
      4.250715971255789_REALK,      0.000000000000000_REALK,      2.075148847524942_REALK, &
      0.000000000000000_REALK,     12.973452552935330_REALK,      0.000000000000000_REALK, &
      5.025083346895790_REALK,      0.000000000000000_REALK,      6.152075405169781_REALK, &
      8.297205981997802_REALK,      4.915424570243186_REALK,      0.000000000000000_REALK, &
      5.680829009258997_REALK,      0.000000000000000_REALK,      1.371616829398004_REALK, &
      7.710831870036225_REALK,      0.000000000000000_REALK,      1.120536984342240_REALK, &
      0.000000000000000_REALK,     22.012780662181754_REALK,      0.000000000000000_REALK, &
      2.525873552679480_REALK,      0.000000000000000_REALK,     -8.811528392452493_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     14.194671285559911_REALK, &
      0.000000000000000_REALK,     -0.711119768644262_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.754737938637817_REALK,      0.000000000000000_REALK, &
     11.186308444031615_REALK,      0.000000000000000_REALK,     -1.038142047130075_REALK, &
      0.000000000000000_REALK,     -1.020550480324381_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     10.388873070279386_REALK, &
      0.000000000000000_REALK,     -0.705255036607761_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      2.522109715492408_REALK,      0.000000000000000_REALK, &
     10.546333846487515_REALK,      0.000000000000000_REALK,      0.027578505591138_REALK, &
      0.000000000000000_REALK,     -1.004988404772980_REALK,      0.000000000000000_REALK, &
     21.438772882693332_REALK,      1.138706789925853_REALK,      0.000000000000000_REALK, &
      3.480907193101661_REALK,      0.000000000000000_REALK,      0.268915011152863_REALK, &
      0.434673013008501_REALK,      0.000000000000000_REALK,      0.017672568350060_REALK, &
      0.000000000000000_REALK,      3.575666947802675_REALK,      0.000000000000000_REALK, &
      0.098380832518900_REALK,      0.000000000000000_REALK,     -5.760339325620701_REALK, &
      5.569781389173433_REALK,      0.268348972825676_REALK,      0.000000000000000_REALK, &
      1.040871318189451_REALK,      0.000000000000000_REALK,     -2.612409480779788_REALK, &
     -0.608927793021711_REALK,      0.000000000000000_REALK,     -0.115321510010960_REALK, &
      0.000000000000000_REALK,     -1.360514245108708_REALK,      0.000000000000000_REALK, &
     -0.627898151484137_REALK,      0.000000000000000_REALK,    -10.376648460273984_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.526844832563595_REALK, &
      0.000000000000000_REALK,     -0.867151409277285_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.109442712251537_REALK,      0.000000000000000_REALK, &
     -1.372878687060333_REALK,      0.000000000000000_REALK,     -0.947242025480361_REALK, &
      0.000000000000000_REALK,     -0.478918681341797_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -1.366801029056801_REALK, &
      0.000000000000000_REALK,     -0.357299756431006_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.475219031465954_REALK,      0.000000000000000_REALK, &
      2.253656950457883_REALK,      0.000000000000000_REALK,     -0.615136973921593_REALK, &
      0.000000000000000_REALK,      0.826983818433819_REALK,      0.000000000000000_REALK, &
      7.564712593227415_REALK,      2.169185638991086_REALK,      0.000000000000000_REALK, &
      2.050743333120071_REALK,      0.000000000000000_REALK,      3.306994053594784_REALK, &
      1.529716830124718_REALK,      0.000000000000000_REALK,      1.173303427983044_REALK, &
      0.000000000000000_REALK,      2.959979076728517_REALK,      0.000000000000000_REALK, &
      2.020017893758792_REALK,      0.000000000000000_REALK,      4.295415499147779_REALK, &
      3.655678869303805_REALK,      1.443479611873004_REALK,      0.000000000000000_REALK, &
      1.017343527773757_REALK,      0.000000000000000_REALK,      0.985608431556379_REALK, &
     -0.071398951949743_REALK,      0.000000000000000_REALK,      0.356577805143891_REALK, &
      0.000000000000000_REALK,     -2.290080496137786_REALK,      0.000000000000000_REALK, &
      0.352771149055396_REALK,      0.000000000000000_REALK,     -4.937969405406970_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -4.819667664217445_REALK, &
      0.000000000000000_REALK,     -2.666861230118345_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -2.807890639561934_REALK,      0.000000000000000_REALK, &
     -4.642775351410657_REALK,      0.000000000000000_REALK,     -5.380927731369616_REALK, &
      0.000000000000000_REALK,     -4.678334647088952_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -5.282818041655045_REALK, &
      0.000000000000000_REALK,     -4.390270931794373_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -5.404906903038662_REALK,      0.000000000000000_REALK, &
     -1.856330013008662_REALK,      0.000000000000000_REALK,    -10.475910844356811_REALK, &
      0.000000000000000_REALK,     -2.165522179259491_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     28.603262281537582_REALK, &
      0.000000000000000_REALK,     -3.691004292930423_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      4.570159220341039_REALK,      0.000000000000000_REALK, &
     17.055125402755564_REALK,      0.000000000000000_REALK,     -3.048186309302981_REALK, &
      0.000000000000000_REALK,     -3.652868820549558_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     58.242868377715425_REALK, &
      0.000000000000000_REALK,     -8.013561664549341_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      6.250262332117493_REALK,      0.000000000000000_REALK, &
     27.407341925148945_REALK,      0.000000000000000_REALK,     -5.212615519884456_REALK, &
      0.000000000000000_REALK,     -5.494702088688610_REALK,      0.000000000000000_REALK, &
     46.140018725283639_REALK,     -1.711571880647155_REALK,      0.000000000000000_REALK, &
      5.349929302889438_REALK,      0.000000000000000_REALK,      0.427839474639158_REALK, &
     -1.038142047130074_REALK,      0.000000000000000_REALK,     -0.020098368321487_REALK, &
      0.000000000000000_REALK,      3.966778873944783_REALK,      0.000000000000000_REALK, &
      0.104271081599396_REALK,      0.000000000000000_REALK,     -6.319921156955280_REALK, &
     54.363580970309378_REALK,     -2.135683480002585_REALK,      0.000000000000000_REALK, &
      4.925712710583966_REALK,      0.000000000000000_REALK,     -8.719346297380255_REALK, &
      0.027578505591138_REALK,      0.000000000000000_REALK,      0.425440038621845_REALK, &
      0.000000000000000_REALK,      4.632810681434027_REALK,      0.000000000000000_REALK, &
     -1.429765963876433_REALK,      0.000000000000000_REALK,    -16.664929939895877_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -7.883210222978843_REALK, &
      0.000000000000000_REALK,     -0.418025807283314_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.198246487973321_REALK,      0.000000000000000_REALK, &
     -1.808912504668343_REALK,      0.000000000000000_REALK,     -0.200392718655307_REALK, &
      0.000000000000000_REALK,     -0.159209040344163_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -6.115701075662537_REALK, &
      0.000000000000000_REALK,     -0.174112411294617_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -0.485404179128565_REALK,      0.000000000000000_REALK, &
      4.674335164663065_REALK,      0.000000000000000_REALK,      0.266858525856788_REALK, &
      0.000000000000000_REALK,      0.193908896465505_REALK,      0.000000000000000_REALK, &
     13.577836474822536_REALK,      1.925882842483814_REALK,      0.000000000000000_REALK, &
      1.988177585953376_REALK,      0.000000000000000_REALK,      4.387928265536996_REALK, &
      0.874064529949689_REALK,      0.000000000000000_REALK,      0.788172687688949_REALK, &
      0.000000000000000_REALK,      1.722263186915965_REALK,      0.000000000000000_REALK, &
      1.350507088722830_REALK,      0.000000000000000_REALK,      3.930330498956176_REALK, &
     28.153944490788795_REALK,      4.259099134771567_REALK,      0.000000000000000_REALK, &
      3.653366690299653_REALK,      0.000000000000000_REALK,      2.595663500803063_REALK, &
      2.421397940066253_REALK,      0.000000000000000_REALK,      0.487699701841256_REALK, &
      0.000000000000000_REALK,      4.452215668766011_REALK,      0.000000000000000_REALK, &
      0.609568352060083_REALK,      0.000000000000000_REALK,     -6.257431268279474_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,     -6.418784700305597_REALK, &
      0.000000000000000_REALK,     -1.837575094995215_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.629004261182363_REALK,      0.000000000000000_REALK, &
     -4.678334647088951_REALK,      0.000000000000000_REALK,     -1.627374461151853_REALK, &
      0.000000000000000_REALK,     -2.222970754208197_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,      0.000000000000000_REALK,    -13.294806297120484_REALK, &
      0.000000000000000_REALK,     -3.102032350619077_REALK,      0.000000000000000_REALK, &
      0.000000000000000_REALK,     -1.571375479030701_REALK,      0.000000000000000_REALK, &
     -2.165522179259491_REALK,      0.000000000000000_REALK,      0.103636562222921_REALK, &
      0.000000000000000_REALK,     -0.736243289846043_REALK,      0.000000000000000_REALK, &
     10.441036558855577_REALK,      4.277863330953823_REALK,      0.000000000000000_REALK, &
      3.634310583128717_REALK,      0.000000000000000_REALK,      6.651611141368907_REALK, &
      3.586173162568095_REALK,      0.000000000000000_REALK,      3.451220547148149_REALK, &
      0.000000000000000_REALK,      6.373471261569047_REALK,      0.000000000000000_REALK, &
      4.866514525600905_REALK,      0.000000000000000_REALK,     11.799513835596784_REALK, &
     54.757357196160889_REALK,     26.334145139729305_REALK,      0.000000000000000_REALK, &
     20.908868521539585_REALK,      0.000000000000000_REALK,     18.879254141152028_REALK, &
     20.750520953878649_REALK,      0.000000000000000_REALK,     11.276833788138578_REALK, &
      0.000000000000000_REALK,     30.403457771298072_REALK,      0.000000000000000_REALK, &
     13.046466129844349_REALK,      0.000000000000000_REALK,      5.089808587914905_REALK/
